<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/marketingplatform/admin/v1alpha/resources.proto

namespace Google\Ads\MarketingPlatform\Admin\V1alpha;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A resource message representing the link between a Google Analytics account
 * and a Google Marketing Platform organization.
 *
 * Generated from protobuf message <code>google.marketingplatform.admin.v1alpha.AnalyticsAccountLink</code>
 */
class AnalyticsAccountLink extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. Resource name of this AnalyticsAccountLink. Note the resource
     * ID is the same as the ID of the Analtyics account.
     * Format:
     * organizations/{org_id}/analyticsAccountLinks/{analytics_account_link_id}
     * Example: "organizations/xyz/analyticsAccountLinks/1234"
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Required. Immutable. The resource name of the AnalyticsAdmin API account.
     * The account ID will be used as the ID of this AnalyticsAccountLink
     * resource, which will become the final component of the resource name.
     * Format: analyticsadmin.googleapis.com/accounts/{account_id}
     *
     * Generated from protobuf field <code>string analytics_account = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.field_behavior) = IMMUTABLE, (.google.api.resource_reference) = {</code>
     */
    protected $analytics_account = '';
    /**
     * Output only. The human-readable name for the Analytics account.
     *
     * Generated from protobuf field <code>string display_name = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $display_name = '';
    /**
     * Output only. The verification state of the link between the Analytics
     * account and the parent organization.
     *
     * Generated from protobuf field <code>.google.marketingplatform.admin.v1alpha.LinkVerificationState link_verification_state = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $link_verification_state = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. Resource name of this AnalyticsAccountLink. Note the resource
     *           ID is the same as the ID of the Analtyics account.
     *           Format:
     *           organizations/{org_id}/analyticsAccountLinks/{analytics_account_link_id}
     *           Example: "organizations/xyz/analyticsAccountLinks/1234"
     *     @type string $analytics_account
     *           Required. Immutable. The resource name of the AnalyticsAdmin API account.
     *           The account ID will be used as the ID of this AnalyticsAccountLink
     *           resource, which will become the final component of the resource name.
     *           Format: analyticsadmin.googleapis.com/accounts/{account_id}
     *     @type string $display_name
     *           Output only. The human-readable name for the Analytics account.
     *     @type int $link_verification_state
     *           Output only. The verification state of the link between the Analytics
     *           account and the parent organization.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Marketingplatform\Admin\V1Alpha\Resources::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. Resource name of this AnalyticsAccountLink. Note the resource
     * ID is the same as the ID of the Analtyics account.
     * Format:
     * organizations/{org_id}/analyticsAccountLinks/{analytics_account_link_id}
     * Example: "organizations/xyz/analyticsAccountLinks/1234"
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. Resource name of this AnalyticsAccountLink. Note the resource
     * ID is the same as the ID of the Analtyics account.
     * Format:
     * organizations/{org_id}/analyticsAccountLinks/{analytics_account_link_id}
     * Example: "organizations/xyz/analyticsAccountLinks/1234"
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Required. Immutable. The resource name of the AnalyticsAdmin API account.
     * The account ID will be used as the ID of this AnalyticsAccountLink
     * resource, which will become the final component of the resource name.
     * Format: analyticsadmin.googleapis.com/accounts/{account_id}
     *
     * Generated from protobuf field <code>string analytics_account = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.field_behavior) = IMMUTABLE, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getAnalyticsAccount()
    {
        return $this->analytics_account;
    }

    /**
     * Required. Immutable. The resource name of the AnalyticsAdmin API account.
     * The account ID will be used as the ID of this AnalyticsAccountLink
     * resource, which will become the final component of the resource name.
     * Format: analyticsadmin.googleapis.com/accounts/{account_id}
     *
     * Generated from protobuf field <code>string analytics_account = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.field_behavior) = IMMUTABLE, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setAnalyticsAccount($var)
    {
        GPBUtil::checkString($var, True);
        $this->analytics_account = $var;

        return $this;
    }

    /**
     * Output only. The human-readable name for the Analytics account.
     *
     * Generated from protobuf field <code>string display_name = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * Output only. The human-readable name for the Analytics account.
     *
     * Generated from protobuf field <code>string display_name = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * Output only. The verification state of the link between the Analytics
     * account and the parent organization.
     *
     * Generated from protobuf field <code>.google.marketingplatform.admin.v1alpha.LinkVerificationState link_verification_state = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getLinkVerificationState()
    {
        return $this->link_verification_state;
    }

    /**
     * Output only. The verification state of the link between the Analytics
     * account and the parent organization.
     *
     * Generated from protobuf field <code>.google.marketingplatform.admin.v1alpha.LinkVerificationState link_verification_state = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setLinkVerificationState($var)
    {
        GPBUtil::checkEnum($var, \Google\Ads\MarketingPlatform\Admin\V1alpha\LinkVerificationState::class);
        $this->link_verification_state = $var;

        return $this;
    }

}

