<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/advisorynotifications/v1/service.proto

namespace Google\Cloud\AdvisoryNotifications\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Settings for Advisory Notifications.
 *
 * Generated from protobuf message <code>google.cloud.advisorynotifications.v1.Settings</code>
 */
class Settings extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. The resource name of the settings to retrieve.
     * Format:
     * organizations/{organization}/locations/{location}/settings or
     * projects/{projects}/locations/{location}/settings.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Required. Map of each notification type and its settings to get/set all
     * settings at once. The server will validate the value for each notification
     * type.
     *
     * Generated from protobuf field <code>map<string, .google.cloud.advisorynotifications.v1.NotificationSettings> notification_settings = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $notification_settings;
    /**
     * Required. Fingerprint for optimistic concurrency returned in Get requests.
     * Must be provided for Update requests. If the value provided does not match
     * the value known to the server, ABORTED will be thrown, and the client
     * should retry the read-modify-write cycle.
     *
     * Generated from protobuf field <code>string etag = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $etag = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. The resource name of the settings to retrieve.
     *           Format:
     *           organizations/{organization}/locations/{location}/settings or
     *           projects/{projects}/locations/{location}/settings.
     *     @type array|\Google\Protobuf\Internal\MapField $notification_settings
     *           Required. Map of each notification type and its settings to get/set all
     *           settings at once. The server will validate the value for each notification
     *           type.
     *     @type string $etag
     *           Required. Fingerprint for optimistic concurrency returned in Get requests.
     *           Must be provided for Update requests. If the value provided does not match
     *           the value known to the server, ABORTED will be thrown, and the client
     *           should retry the read-modify-write cycle.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Advisorynotifications\V1\Service::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. The resource name of the settings to retrieve.
     * Format:
     * organizations/{organization}/locations/{location}/settings or
     * projects/{projects}/locations/{location}/settings.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. The resource name of the settings to retrieve.
     * Format:
     * organizations/{organization}/locations/{location}/settings or
     * projects/{projects}/locations/{location}/settings.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Required. Map of each notification type and its settings to get/set all
     * settings at once. The server will validate the value for each notification
     * type.
     *
     * Generated from protobuf field <code>map<string, .google.cloud.advisorynotifications.v1.NotificationSettings> notification_settings = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getNotificationSettings()
    {
        return $this->notification_settings;
    }

    /**
     * Required. Map of each notification type and its settings to get/set all
     * settings at once. The server will validate the value for each notification
     * type.
     *
     * Generated from protobuf field <code>map<string, .google.cloud.advisorynotifications.v1.NotificationSettings> notification_settings = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setNotificationSettings($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\AdvisoryNotifications\V1\NotificationSettings::class);
        $this->notification_settings = $arr;

        return $this;
    }

    /**
     * Required. Fingerprint for optimistic concurrency returned in Get requests.
     * Must be provided for Update requests. If the value provided does not match
     * the value known to the server, ABORTED will be thrown, and the client
     * should retry the read-modify-write cycle.
     *
     * Generated from protobuf field <code>string etag = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getEtag()
    {
        return $this->etag;
    }

    /**
     * Required. Fingerprint for optimistic concurrency returned in Get requests.
     * Must be provided for Update requests. If the value provided does not match
     * the value known to the server, ABORTED will be thrown, and the client
     * should retry the read-modify-write cycle.
     *
     * Generated from protobuf field <code>string etag = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setEtag($var)
    {
        GPBUtil::checkString($var, True);
        $this->etag = $var;

        return $this;
    }

}

