<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/notebook_service.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [NotebookService.AssignNotebookRuntime][google.cloud.aiplatform.v1.NotebookService.AssignNotebookRuntime].
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.AssignNotebookRuntimeRequest</code>
 */
class AssignNotebookRuntimeRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the Location to get the NotebookRuntime
     * assignment. Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The resource name of the NotebookRuntimeTemplate based on which a
     * NotebookRuntime will be assigned (reuse or create a new one).
     *
     * Generated from protobuf field <code>string notebook_runtime_template = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $notebook_runtime_template = '';
    /**
     * Required. Provide runtime specific information (e.g. runtime owner,
     * notebook id) used for NotebookRuntime assignment.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookRuntime notebook_runtime = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $notebook_runtime = null;
    /**
     * Optional. User specified ID for the notebook runtime.
     *
     * Generated from protobuf field <code>string notebook_runtime_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $notebook_runtime_id = '';

    /**
     * @param string                                      $parent                  Required. The resource name of the Location to get the NotebookRuntime
     *                                                                             assignment. Format: `projects/{project}/locations/{location}`
     *                                                                             Please see {@see NotebookServiceClient::locationName()} for help formatting this field.
     * @param string                                      $notebookRuntimeTemplate Required. The resource name of the NotebookRuntimeTemplate based on which a
     *                                                                             NotebookRuntime will be assigned (reuse or create a new one). Please see
     *                                                                             {@see NotebookServiceClient::notebookRuntimeTemplateName()} for help formatting this field.
     * @param \Google\Cloud\AIPlatform\V1\NotebookRuntime $notebookRuntime         Required. Provide runtime specific information (e.g. runtime owner,
     *                                                                             notebook id) used for NotebookRuntime assignment.
     * @param string                                      $notebookRuntimeId       Optional. User specified ID for the notebook runtime.
     *
     * @return \Google\Cloud\AIPlatform\V1\AssignNotebookRuntimeRequest
     *
     * @experimental
     */
    public static function build(string $parent, string $notebookRuntimeTemplate, \Google\Cloud\AIPlatform\V1\NotebookRuntime $notebookRuntime, string $notebookRuntimeId): self
    {
        return (new self())
            ->setParent($parent)
            ->setNotebookRuntimeTemplate($notebookRuntimeTemplate)
            ->setNotebookRuntime($notebookRuntime)
            ->setNotebookRuntimeId($notebookRuntimeId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The resource name of the Location to get the NotebookRuntime
     *           assignment. Format: `projects/{project}/locations/{location}`
     *     @type string $notebook_runtime_template
     *           Required. The resource name of the NotebookRuntimeTemplate based on which a
     *           NotebookRuntime will be assigned (reuse or create a new one).
     *     @type \Google\Cloud\AIPlatform\V1\NotebookRuntime $notebook_runtime
     *           Required. Provide runtime specific information (e.g. runtime owner,
     *           notebook id) used for NotebookRuntime assignment.
     *     @type string $notebook_runtime_id
     *           Optional. User specified ID for the notebook runtime.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\NotebookService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the Location to get the NotebookRuntime
     * assignment. Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The resource name of the Location to get the NotebookRuntime
     * assignment. Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The resource name of the NotebookRuntimeTemplate based on which a
     * NotebookRuntime will be assigned (reuse or create a new one).
     *
     * Generated from protobuf field <code>string notebook_runtime_template = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getNotebookRuntimeTemplate()
    {
        return $this->notebook_runtime_template;
    }

    /**
     * Required. The resource name of the NotebookRuntimeTemplate based on which a
     * NotebookRuntime will be assigned (reuse or create a new one).
     *
     * Generated from protobuf field <code>string notebook_runtime_template = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setNotebookRuntimeTemplate($var)
    {
        GPBUtil::checkString($var, True);
        $this->notebook_runtime_template = $var;

        return $this;
    }

    /**
     * Required. Provide runtime specific information (e.g. runtime owner,
     * notebook id) used for NotebookRuntime assignment.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookRuntime notebook_runtime = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\AIPlatform\V1\NotebookRuntime|null
     */
    public function getNotebookRuntime()
    {
        return $this->notebook_runtime;
    }

    public function hasNotebookRuntime()
    {
        return isset($this->notebook_runtime);
    }

    public function clearNotebookRuntime()
    {
        unset($this->notebook_runtime);
    }

    /**
     * Required. Provide runtime specific information (e.g. runtime owner,
     * notebook id) used for NotebookRuntime assignment.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookRuntime notebook_runtime = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\AIPlatform\V1\NotebookRuntime $var
     * @return $this
     */
    public function setNotebookRuntime($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\NotebookRuntime::class);
        $this->notebook_runtime = $var;

        return $this;
    }

    /**
     * Optional. User specified ID for the notebook runtime.
     *
     * Generated from protobuf field <code>string notebook_runtime_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getNotebookRuntimeId()
    {
        return $this->notebook_runtime_id;
    }

    /**
     * Optional. User specified ID for the notebook runtime.
     *
     * Generated from protobuf field <code>string notebook_runtime_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setNotebookRuntimeId($var)
    {
        GPBUtil::checkString($var, True);
        $this->notebook_runtime_id = $var;

        return $this;
    }

}

