<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/deployment_resource_pool_service.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for CreateDeploymentResourcePool method.
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.CreateDeploymentResourcePoolRequest</code>
 */
class CreateDeploymentResourcePoolRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent location resource where this DeploymentResourcePool
     * will be created. Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The DeploymentResourcePool to create.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.DeploymentResourcePool deployment_resource_pool = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $deployment_resource_pool = null;
    /**
     * Required. The ID to use for the DeploymentResourcePool, which
     * will become the final component of the DeploymentResourcePool's resource
     * name.
     * The maximum length is 63 characters, and valid characters
     * are `/^[a-z]([a-z0-9-]{0,61}[a-z0-9])?$/`.
     *
     * Generated from protobuf field <code>string deployment_resource_pool_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $deployment_resource_pool_id = '';

    /**
     * @param string                                             $parent                   Required. The parent location resource where this DeploymentResourcePool
     *                                                                                     will be created. Format: `projects/{project}/locations/{location}`
     *                                                                                     Please see {@see DeploymentResourcePoolServiceClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\AIPlatform\V1\DeploymentResourcePool $deploymentResourcePool   Required. The DeploymentResourcePool to create.
     * @param string                                             $deploymentResourcePoolId Required. The ID to use for the DeploymentResourcePool, which
     *                                                                                     will become the final component of the DeploymentResourcePool's resource
     *                                                                                     name.
     *
     *                                                                                     The maximum length is 63 characters, and valid characters
     *                                                                                     are `/^[a-z]([a-z0-9-]{0,61}[a-z0-9])?$/`.
     *
     * @return \Google\Cloud\AIPlatform\V1\CreateDeploymentResourcePoolRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\AIPlatform\V1\DeploymentResourcePool $deploymentResourcePool, string $deploymentResourcePoolId): self
    {
        return (new self())
            ->setParent($parent)
            ->setDeploymentResourcePool($deploymentResourcePool)
            ->setDeploymentResourcePoolId($deploymentResourcePoolId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent location resource where this DeploymentResourcePool
     *           will be created. Format: `projects/{project}/locations/{location}`
     *     @type \Google\Cloud\AIPlatform\V1\DeploymentResourcePool $deployment_resource_pool
     *           Required. The DeploymentResourcePool to create.
     *     @type string $deployment_resource_pool_id
     *           Required. The ID to use for the DeploymentResourcePool, which
     *           will become the final component of the DeploymentResourcePool's resource
     *           name.
     *           The maximum length is 63 characters, and valid characters
     *           are `/^[a-z]([a-z0-9-]{0,61}[a-z0-9])?$/`.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\DeploymentResourcePoolService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent location resource where this DeploymentResourcePool
     * will be created. Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent location resource where this DeploymentResourcePool
     * will be created. Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The DeploymentResourcePool to create.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.DeploymentResourcePool deployment_resource_pool = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\AIPlatform\V1\DeploymentResourcePool|null
     */
    public function getDeploymentResourcePool()
    {
        return $this->deployment_resource_pool;
    }

    public function hasDeploymentResourcePool()
    {
        return isset($this->deployment_resource_pool);
    }

    public function clearDeploymentResourcePool()
    {
        unset($this->deployment_resource_pool);
    }

    /**
     * Required. The DeploymentResourcePool to create.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.DeploymentResourcePool deployment_resource_pool = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\AIPlatform\V1\DeploymentResourcePool $var
     * @return $this
     */
    public function setDeploymentResourcePool($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\DeploymentResourcePool::class);
        $this->deployment_resource_pool = $var;

        return $this;
    }

    /**
     * Required. The ID to use for the DeploymentResourcePool, which
     * will become the final component of the DeploymentResourcePool's resource
     * name.
     * The maximum length is 63 characters, and valid characters
     * are `/^[a-z]([a-z0-9-]{0,61}[a-z0-9])?$/`.
     *
     * Generated from protobuf field <code>string deployment_resource_pool_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getDeploymentResourcePoolId()
    {
        return $this->deployment_resource_pool_id;
    }

    /**
     * Required. The ID to use for the DeploymentResourcePool, which
     * will become the final component of the DeploymentResourcePool's resource
     * name.
     * The maximum length is 63 characters, and valid characters
     * are `/^[a-z]([a-z0-9-]{0,61}[a-z0-9])?$/`.
     *
     * Generated from protobuf field <code>string deployment_resource_pool_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setDeploymentResourcePoolId($var)
    {
        GPBUtil::checkString($var, True);
        $this->deployment_resource_pool_id = $var;

        return $this;
    }

}

