<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/metadata_service.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [MetadataService.CreateExecution][google.cloud.aiplatform.v1.MetadataService.CreateExecution].
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.CreateExecutionRequest</code>
 */
class CreateExecutionRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the MetadataStore where the Execution should
     * be created.
     * Format:
     * `projects/{project}/locations/{location}/metadataStores/{metadatastore}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The Execution to create.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.Execution execution = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $execution = null;
    /**
     * The {execution} portion of the resource name with the format:
     * `projects/{project}/locations/{location}/metadataStores/{metadatastore}/executions/{execution}`
     * If not provided, the Execution's ID will be a UUID generated by the
     * service.
     * Must be 4-128 characters in length. Valid characters are `/[a-z][0-9]-/`.
     * Must be unique across all Executions in the parent MetadataStore.
     * (Otherwise the request will fail with ALREADY_EXISTS, or PERMISSION_DENIED
     * if the caller can't view the preexisting Execution.)
     *
     * Generated from protobuf field <code>string execution_id = 3;</code>
     */
    protected $execution_id = '';

    /**
     * @param string                                $parent      Required. The resource name of the MetadataStore where the Execution should
     *                                                           be created.
     *                                                           Format:
     *                                                           `projects/{project}/locations/{location}/metadataStores/{metadatastore}`
     *                                                           Please see {@see MetadataServiceClient::metadataStoreName()} for help formatting this field.
     * @param \Google\Cloud\AIPlatform\V1\Execution $execution   Required. The Execution to create.
     * @param string                                $executionId The {execution} portion of the resource name with the format:
     *                                                           `projects/{project}/locations/{location}/metadataStores/{metadatastore}/executions/{execution}`
     *                                                           If not provided, the Execution's ID will be a UUID generated by the
     *                                                           service.
     *                                                           Must be 4-128 characters in length. Valid characters are `/[a-z][0-9]-/`.
     *                                                           Must be unique across all Executions in the parent MetadataStore.
     *                                                           (Otherwise the request will fail with ALREADY_EXISTS, or PERMISSION_DENIED
     *                                                           if the caller can't view the preexisting Execution.)
     *
     * @return \Google\Cloud\AIPlatform\V1\CreateExecutionRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\AIPlatform\V1\Execution $execution, string $executionId): self
    {
        return (new self())
            ->setParent($parent)
            ->setExecution($execution)
            ->setExecutionId($executionId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The resource name of the MetadataStore where the Execution should
     *           be created.
     *           Format:
     *           `projects/{project}/locations/{location}/metadataStores/{metadatastore}`
     *     @type \Google\Cloud\AIPlatform\V1\Execution $execution
     *           Required. The Execution to create.
     *     @type string $execution_id
     *           The {execution} portion of the resource name with the format:
     *           `projects/{project}/locations/{location}/metadataStores/{metadatastore}/executions/{execution}`
     *           If not provided, the Execution's ID will be a UUID generated by the
     *           service.
     *           Must be 4-128 characters in length. Valid characters are `/[a-z][0-9]-/`.
     *           Must be unique across all Executions in the parent MetadataStore.
     *           (Otherwise the request will fail with ALREADY_EXISTS, or PERMISSION_DENIED
     *           if the caller can't view the preexisting Execution.)
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\MetadataService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the MetadataStore where the Execution should
     * be created.
     * Format:
     * `projects/{project}/locations/{location}/metadataStores/{metadatastore}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The resource name of the MetadataStore where the Execution should
     * be created.
     * Format:
     * `projects/{project}/locations/{location}/metadataStores/{metadatastore}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The Execution to create.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.Execution execution = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\AIPlatform\V1\Execution|null
     */
    public function getExecution()
    {
        return $this->execution;
    }

    public function hasExecution()
    {
        return isset($this->execution);
    }

    public function clearExecution()
    {
        unset($this->execution);
    }

    /**
     * Required. The Execution to create.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.Execution execution = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\AIPlatform\V1\Execution $var
     * @return $this
     */
    public function setExecution($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\Execution::class);
        $this->execution = $var;

        return $this;
    }

    /**
     * The {execution} portion of the resource name with the format:
     * `projects/{project}/locations/{location}/metadataStores/{metadatastore}/executions/{execution}`
     * If not provided, the Execution's ID will be a UUID generated by the
     * service.
     * Must be 4-128 characters in length. Valid characters are `/[a-z][0-9]-/`.
     * Must be unique across all Executions in the parent MetadataStore.
     * (Otherwise the request will fail with ALREADY_EXISTS, or PERMISSION_DENIED
     * if the caller can't view the preexisting Execution.)
     *
     * Generated from protobuf field <code>string execution_id = 3;</code>
     * @return string
     */
    public function getExecutionId()
    {
        return $this->execution_id;
    }

    /**
     * The {execution} portion of the resource name with the format:
     * `projects/{project}/locations/{location}/metadataStores/{metadatastore}/executions/{execution}`
     * If not provided, the Execution's ID will be a UUID generated by the
     * service.
     * Must be 4-128 characters in length. Valid characters are `/[a-z][0-9]-/`.
     * Must be unique across all Executions in the parent MetadataStore.
     * (Otherwise the request will fail with ALREADY_EXISTS, or PERMISSION_DENIED
     * if the caller can't view the preexisting Execution.)
     *
     * Generated from protobuf field <code>string execution_id = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setExecutionId($var)
    {
        GPBUtil::checkString($var, True);
        $this->execution_id = $var;

        return $this;
    }

}

