<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/feature_registry_service.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [FeatureRegistryService.CreateFeatureGroup][google.cloud.aiplatform.v1.FeatureRegistryService.CreateFeatureGroup].
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.CreateFeatureGroupRequest</code>
 */
class CreateFeatureGroupRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the Location to create FeatureGroups.
     * Format:
     * `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The FeatureGroup to create.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.FeatureGroup feature_group = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $feature_group = null;
    /**
     * Required. The ID to use for this FeatureGroup, which will become the final
     * component of the FeatureGroup's resource name.
     * This value may be up to 60 characters, and valid characters are
     * `[a-z0-9_]`. The first character cannot be a number.
     * The value must be unique within the project and location.
     *
     * Generated from protobuf field <code>string feature_group_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $feature_group_id = '';

    /**
     * @param string                                   $parent         Required. The resource name of the Location to create FeatureGroups.
     *                                                                 Format:
     *                                                                 `projects/{project}/locations/{location}`
     *                                                                 Please see {@see FeatureRegistryServiceClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\AIPlatform\V1\FeatureGroup $featureGroup   Required. The FeatureGroup to create.
     * @param string                                   $featureGroupId Required. The ID to use for this FeatureGroup, which will become the final
     *                                                                 component of the FeatureGroup's resource name.
     *
     *                                                                 This value may be up to 60 characters, and valid characters are
     *                                                                 `[a-z0-9_]`. The first character cannot be a number.
     *
     *                                                                 The value must be unique within the project and location.
     *
     * @return \Google\Cloud\AIPlatform\V1\CreateFeatureGroupRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\AIPlatform\V1\FeatureGroup $featureGroup, string $featureGroupId): self
    {
        return (new self())
            ->setParent($parent)
            ->setFeatureGroup($featureGroup)
            ->setFeatureGroupId($featureGroupId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The resource name of the Location to create FeatureGroups.
     *           Format:
     *           `projects/{project}/locations/{location}`
     *     @type \Google\Cloud\AIPlatform\V1\FeatureGroup $feature_group
     *           Required. The FeatureGroup to create.
     *     @type string $feature_group_id
     *           Required. The ID to use for this FeatureGroup, which will become the final
     *           component of the FeatureGroup's resource name.
     *           This value may be up to 60 characters, and valid characters are
     *           `[a-z0-9_]`. The first character cannot be a number.
     *           The value must be unique within the project and location.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\FeatureRegistryService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the Location to create FeatureGroups.
     * Format:
     * `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The resource name of the Location to create FeatureGroups.
     * Format:
     * `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The FeatureGroup to create.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.FeatureGroup feature_group = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\AIPlatform\V1\FeatureGroup|null
     */
    public function getFeatureGroup()
    {
        return $this->feature_group;
    }

    public function hasFeatureGroup()
    {
        return isset($this->feature_group);
    }

    public function clearFeatureGroup()
    {
        unset($this->feature_group);
    }

    /**
     * Required. The FeatureGroup to create.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.FeatureGroup feature_group = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\AIPlatform\V1\FeatureGroup $var
     * @return $this
     */
    public function setFeatureGroup($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\FeatureGroup::class);
        $this->feature_group = $var;

        return $this;
    }

    /**
     * Required. The ID to use for this FeatureGroup, which will become the final
     * component of the FeatureGroup's resource name.
     * This value may be up to 60 characters, and valid characters are
     * `[a-z0-9_]`. The first character cannot be a number.
     * The value must be unique within the project and location.
     *
     * Generated from protobuf field <code>string feature_group_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getFeatureGroupId()
    {
        return $this->feature_group_id;
    }

    /**
     * Required. The ID to use for this FeatureGroup, which will become the final
     * component of the FeatureGroup's resource name.
     * This value may be up to 60 characters, and valid characters are
     * `[a-z0-9_]`. The first character cannot be a number.
     * The value must be unique within the project and location.
     *
     * Generated from protobuf field <code>string feature_group_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setFeatureGroupId($var)
    {
        GPBUtil::checkString($var, True);
        $this->feature_group_id = $var;

        return $this;
    }

}

