<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/tensorboard_service.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [TensorboardService.CreateTensorboardTimeSeries][google.cloud.aiplatform.v1.TensorboardService.CreateTensorboardTimeSeries].
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.CreateTensorboardTimeSeriesRequest</code>
 */
class CreateTensorboardTimeSeriesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the TensorboardRun to create the
     * TensorboardTimeSeries in.
     * Format:
     * `projects/{project}/locations/{location}/tensorboards/{tensorboard}/experiments/{experiment}/runs/{run}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. The user specified unique ID to use for the
     * TensorboardTimeSeries, which becomes the final component of the
     * TensorboardTimeSeries's resource name. This value should match
     * "[a-z0-9][a-z0-9-]{0, 127}"
     *
     * Generated from protobuf field <code>string tensorboard_time_series_id = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $tensorboard_time_series_id = '';
    /**
     * Required. The TensorboardTimeSeries to create.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.TensorboardTimeSeries tensorboard_time_series = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $tensorboard_time_series = null;

    /**
     * @param string                                            $parent                Required. The resource name of the TensorboardRun to create the
     *                                                                                 TensorboardTimeSeries in.
     *                                                                                 Format:
     *                                                                                 `projects/{project}/locations/{location}/tensorboards/{tensorboard}/experiments/{experiment}/runs/{run}`
     *                                                                                 Please see {@see TensorboardServiceClient::tensorboardTimeSeriesName()} for help formatting this field.
     * @param \Google\Cloud\AIPlatform\V1\TensorboardTimeSeries $tensorboardTimeSeries Required. The TensorboardTimeSeries to create.
     *
     * @return \Google\Cloud\AIPlatform\V1\CreateTensorboardTimeSeriesRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\AIPlatform\V1\TensorboardTimeSeries $tensorboardTimeSeries): self
    {
        return (new self())
            ->setParent($parent)
            ->setTensorboardTimeSeries($tensorboardTimeSeries);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The resource name of the TensorboardRun to create the
     *           TensorboardTimeSeries in.
     *           Format:
     *           `projects/{project}/locations/{location}/tensorboards/{tensorboard}/experiments/{experiment}/runs/{run}`
     *     @type string $tensorboard_time_series_id
     *           Optional. The user specified unique ID to use for the
     *           TensorboardTimeSeries, which becomes the final component of the
     *           TensorboardTimeSeries's resource name. This value should match
     *           "[a-z0-9][a-z0-9-]{0, 127}"
     *     @type \Google\Cloud\AIPlatform\V1\TensorboardTimeSeries $tensorboard_time_series
     *           Required. The TensorboardTimeSeries to create.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\TensorboardService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the TensorboardRun to create the
     * TensorboardTimeSeries in.
     * Format:
     * `projects/{project}/locations/{location}/tensorboards/{tensorboard}/experiments/{experiment}/runs/{run}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The resource name of the TensorboardRun to create the
     * TensorboardTimeSeries in.
     * Format:
     * `projects/{project}/locations/{location}/tensorboards/{tensorboard}/experiments/{experiment}/runs/{run}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. The user specified unique ID to use for the
     * TensorboardTimeSeries, which becomes the final component of the
     * TensorboardTimeSeries's resource name. This value should match
     * "[a-z0-9][a-z0-9-]{0, 127}"
     *
     * Generated from protobuf field <code>string tensorboard_time_series_id = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getTensorboardTimeSeriesId()
    {
        return $this->tensorboard_time_series_id;
    }

    /**
     * Optional. The user specified unique ID to use for the
     * TensorboardTimeSeries, which becomes the final component of the
     * TensorboardTimeSeries's resource name. This value should match
     * "[a-z0-9][a-z0-9-]{0, 127}"
     *
     * Generated from protobuf field <code>string tensorboard_time_series_id = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setTensorboardTimeSeriesId($var)
    {
        GPBUtil::checkString($var, True);
        $this->tensorboard_time_series_id = $var;

        return $this;
    }

    /**
     * Required. The TensorboardTimeSeries to create.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.TensorboardTimeSeries tensorboard_time_series = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\AIPlatform\V1\TensorboardTimeSeries|null
     */
    public function getTensorboardTimeSeries()
    {
        return $this->tensorboard_time_series;
    }

    public function hasTensorboardTimeSeries()
    {
        return isset($this->tensorboard_time_series);
    }

    public function clearTensorboardTimeSeries()
    {
        unset($this->tensorboard_time_series);
    }

    /**
     * Required. The TensorboardTimeSeries to create.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.TensorboardTimeSeries tensorboard_time_series = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\AIPlatform\V1\TensorboardTimeSeries $var
     * @return $this
     */
    public function setTensorboardTimeSeries($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\TensorboardTimeSeries::class);
        $this->tensorboard_time_series = $var;

        return $this;
    }

}

