<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/evaluation_service.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Response message for EvaluationService.EvaluateInstances.
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.EvaluateInstancesResponse</code>
 */
class EvaluateInstancesResponse extends \Google\Protobuf\Internal\Message
{
    protected $evaluation_results;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\AIPlatform\V1\ExactMatchResults $exact_match_results
     *           Auto metric evaluation results.
     *           Results for exact match metric.
     *     @type \Google\Cloud\AIPlatform\V1\BleuResults $bleu_results
     *           Results for bleu metric.
     *     @type \Google\Cloud\AIPlatform\V1\RougeResults $rouge_results
     *           Results for rouge metric.
     *     @type \Google\Cloud\AIPlatform\V1\FluencyResult $fluency_result
     *           LLM-based metric evaluation result.
     *           General text generation metrics, applicable to other categories.
     *           Result for fluency metric.
     *     @type \Google\Cloud\AIPlatform\V1\CoherenceResult $coherence_result
     *           Result for coherence metric.
     *     @type \Google\Cloud\AIPlatform\V1\SafetyResult $safety_result
     *           Result for safety metric.
     *     @type \Google\Cloud\AIPlatform\V1\GroundednessResult $groundedness_result
     *           Result for groundedness metric.
     *     @type \Google\Cloud\AIPlatform\V1\FulfillmentResult $fulfillment_result
     *           Result for fulfillment metric.
     *     @type \Google\Cloud\AIPlatform\V1\SummarizationQualityResult $summarization_quality_result
     *           Summarization only metrics.
     *           Result for summarization quality metric.
     *     @type \Google\Cloud\AIPlatform\V1\PairwiseSummarizationQualityResult $pairwise_summarization_quality_result
     *           Result for pairwise summarization quality metric.
     *     @type \Google\Cloud\AIPlatform\V1\SummarizationHelpfulnessResult $summarization_helpfulness_result
     *           Result for summarization helpfulness metric.
     *     @type \Google\Cloud\AIPlatform\V1\SummarizationVerbosityResult $summarization_verbosity_result
     *           Result for summarization verbosity metric.
     *     @type \Google\Cloud\AIPlatform\V1\QuestionAnsweringQualityResult $question_answering_quality_result
     *           Question answering only metrics.
     *           Result for question answering quality metric.
     *     @type \Google\Cloud\AIPlatform\V1\PairwiseQuestionAnsweringQualityResult $pairwise_question_answering_quality_result
     *           Result for pairwise question answering quality metric.
     *     @type \Google\Cloud\AIPlatform\V1\QuestionAnsweringRelevanceResult $question_answering_relevance_result
     *           Result for question answering relevance metric.
     *     @type \Google\Cloud\AIPlatform\V1\QuestionAnsweringHelpfulnessResult $question_answering_helpfulness_result
     *           Result for question answering helpfulness metric.
     *     @type \Google\Cloud\AIPlatform\V1\QuestionAnsweringCorrectnessResult $question_answering_correctness_result
     *           Result for question answering correctness metric.
     *     @type \Google\Cloud\AIPlatform\V1\PointwiseMetricResult $pointwise_metric_result
     *           Generic metrics.
     *           Result for pointwise metric.
     *     @type \Google\Cloud\AIPlatform\V1\PairwiseMetricResult $pairwise_metric_result
     *           Result for pairwise metric.
     *     @type \Google\Cloud\AIPlatform\V1\ToolCallValidResults $tool_call_valid_results
     *           Tool call metrics.
     *            Results for tool call valid metric.
     *     @type \Google\Cloud\AIPlatform\V1\ToolNameMatchResults $tool_name_match_results
     *           Results for tool name match metric.
     *     @type \Google\Cloud\AIPlatform\V1\ToolParameterKeyMatchResults $tool_parameter_key_match_results
     *           Results for tool parameter key match  metric.
     *     @type \Google\Cloud\AIPlatform\V1\ToolParameterKVMatchResults $tool_parameter_kv_match_results
     *           Results for tool parameter key value match metric.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\EvaluationService::initOnce();
        parent::__construct($data);
    }

    /**
     * Auto metric evaluation results.
     * Results for exact match metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.ExactMatchResults exact_match_results = 1;</code>
     * @return \Google\Cloud\AIPlatform\V1\ExactMatchResults|null
     */
    public function getExactMatchResults()
    {
        return $this->readOneof(1);
    }

    public function hasExactMatchResults()
    {
        return $this->hasOneof(1);
    }

    /**
     * Auto metric evaluation results.
     * Results for exact match metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.ExactMatchResults exact_match_results = 1;</code>
     * @param \Google\Cloud\AIPlatform\V1\ExactMatchResults $var
     * @return $this
     */
    public function setExactMatchResults($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\ExactMatchResults::class);
        $this->writeOneof(1, $var);

        return $this;
    }

    /**
     * Results for bleu metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.BleuResults bleu_results = 2;</code>
     * @return \Google\Cloud\AIPlatform\V1\BleuResults|null
     */
    public function getBleuResults()
    {
        return $this->readOneof(2);
    }

    public function hasBleuResults()
    {
        return $this->hasOneof(2);
    }

    /**
     * Results for bleu metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.BleuResults bleu_results = 2;</code>
     * @param \Google\Cloud\AIPlatform\V1\BleuResults $var
     * @return $this
     */
    public function setBleuResults($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\BleuResults::class);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     * Results for rouge metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.RougeResults rouge_results = 3;</code>
     * @return \Google\Cloud\AIPlatform\V1\RougeResults|null
     */
    public function getRougeResults()
    {
        return $this->readOneof(3);
    }

    public function hasRougeResults()
    {
        return $this->hasOneof(3);
    }

    /**
     * Results for rouge metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.RougeResults rouge_results = 3;</code>
     * @param \Google\Cloud\AIPlatform\V1\RougeResults $var
     * @return $this
     */
    public function setRougeResults($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\RougeResults::class);
        $this->writeOneof(3, $var);

        return $this;
    }

    /**
     * LLM-based metric evaluation result.
     * General text generation metrics, applicable to other categories.
     * Result for fluency metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.FluencyResult fluency_result = 4;</code>
     * @return \Google\Cloud\AIPlatform\V1\FluencyResult|null
     */
    public function getFluencyResult()
    {
        return $this->readOneof(4);
    }

    public function hasFluencyResult()
    {
        return $this->hasOneof(4);
    }

    /**
     * LLM-based metric evaluation result.
     * General text generation metrics, applicable to other categories.
     * Result for fluency metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.FluencyResult fluency_result = 4;</code>
     * @param \Google\Cloud\AIPlatform\V1\FluencyResult $var
     * @return $this
     */
    public function setFluencyResult($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\FluencyResult::class);
        $this->writeOneof(4, $var);

        return $this;
    }

    /**
     * Result for coherence metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.CoherenceResult coherence_result = 5;</code>
     * @return \Google\Cloud\AIPlatform\V1\CoherenceResult|null
     */
    public function getCoherenceResult()
    {
        return $this->readOneof(5);
    }

    public function hasCoherenceResult()
    {
        return $this->hasOneof(5);
    }

    /**
     * Result for coherence metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.CoherenceResult coherence_result = 5;</code>
     * @param \Google\Cloud\AIPlatform\V1\CoherenceResult $var
     * @return $this
     */
    public function setCoherenceResult($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\CoherenceResult::class);
        $this->writeOneof(5, $var);

        return $this;
    }

    /**
     * Result for safety metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.SafetyResult safety_result = 7;</code>
     * @return \Google\Cloud\AIPlatform\V1\SafetyResult|null
     */
    public function getSafetyResult()
    {
        return $this->readOneof(7);
    }

    public function hasSafetyResult()
    {
        return $this->hasOneof(7);
    }

    /**
     * Result for safety metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.SafetyResult safety_result = 7;</code>
     * @param \Google\Cloud\AIPlatform\V1\SafetyResult $var
     * @return $this
     */
    public function setSafetyResult($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\SafetyResult::class);
        $this->writeOneof(7, $var);

        return $this;
    }

    /**
     * Result for groundedness metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.GroundednessResult groundedness_result = 8;</code>
     * @return \Google\Cloud\AIPlatform\V1\GroundednessResult|null
     */
    public function getGroundednessResult()
    {
        return $this->readOneof(8);
    }

    public function hasGroundednessResult()
    {
        return $this->hasOneof(8);
    }

    /**
     * Result for groundedness metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.GroundednessResult groundedness_result = 8;</code>
     * @param \Google\Cloud\AIPlatform\V1\GroundednessResult $var
     * @return $this
     */
    public function setGroundednessResult($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\GroundednessResult::class);
        $this->writeOneof(8, $var);

        return $this;
    }

    /**
     * Result for fulfillment metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.FulfillmentResult fulfillment_result = 11;</code>
     * @return \Google\Cloud\AIPlatform\V1\FulfillmentResult|null
     */
    public function getFulfillmentResult()
    {
        return $this->readOneof(11);
    }

    public function hasFulfillmentResult()
    {
        return $this->hasOneof(11);
    }

    /**
     * Result for fulfillment metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.FulfillmentResult fulfillment_result = 11;</code>
     * @param \Google\Cloud\AIPlatform\V1\FulfillmentResult $var
     * @return $this
     */
    public function setFulfillmentResult($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\FulfillmentResult::class);
        $this->writeOneof(11, $var);

        return $this;
    }

    /**
     * Summarization only metrics.
     * Result for summarization quality metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.SummarizationQualityResult summarization_quality_result = 6;</code>
     * @return \Google\Cloud\AIPlatform\V1\SummarizationQualityResult|null
     */
    public function getSummarizationQualityResult()
    {
        return $this->readOneof(6);
    }

    public function hasSummarizationQualityResult()
    {
        return $this->hasOneof(6);
    }

    /**
     * Summarization only metrics.
     * Result for summarization quality metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.SummarizationQualityResult summarization_quality_result = 6;</code>
     * @param \Google\Cloud\AIPlatform\V1\SummarizationQualityResult $var
     * @return $this
     */
    public function setSummarizationQualityResult($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\SummarizationQualityResult::class);
        $this->writeOneof(6, $var);

        return $this;
    }

    /**
     * Result for pairwise summarization quality metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PairwiseSummarizationQualityResult pairwise_summarization_quality_result = 22;</code>
     * @return \Google\Cloud\AIPlatform\V1\PairwiseSummarizationQualityResult|null
     */
    public function getPairwiseSummarizationQualityResult()
    {
        return $this->readOneof(22);
    }

    public function hasPairwiseSummarizationQualityResult()
    {
        return $this->hasOneof(22);
    }

    /**
     * Result for pairwise summarization quality metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PairwiseSummarizationQualityResult pairwise_summarization_quality_result = 22;</code>
     * @param \Google\Cloud\AIPlatform\V1\PairwiseSummarizationQualityResult $var
     * @return $this
     */
    public function setPairwiseSummarizationQualityResult($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\PairwiseSummarizationQualityResult::class);
        $this->writeOneof(22, $var);

        return $this;
    }

    /**
     * Result for summarization helpfulness metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.SummarizationHelpfulnessResult summarization_helpfulness_result = 13;</code>
     * @return \Google\Cloud\AIPlatform\V1\SummarizationHelpfulnessResult|null
     */
    public function getSummarizationHelpfulnessResult()
    {
        return $this->readOneof(13);
    }

    public function hasSummarizationHelpfulnessResult()
    {
        return $this->hasOneof(13);
    }

    /**
     * Result for summarization helpfulness metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.SummarizationHelpfulnessResult summarization_helpfulness_result = 13;</code>
     * @param \Google\Cloud\AIPlatform\V1\SummarizationHelpfulnessResult $var
     * @return $this
     */
    public function setSummarizationHelpfulnessResult($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\SummarizationHelpfulnessResult::class);
        $this->writeOneof(13, $var);

        return $this;
    }

    /**
     * Result for summarization verbosity metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.SummarizationVerbosityResult summarization_verbosity_result = 14;</code>
     * @return \Google\Cloud\AIPlatform\V1\SummarizationVerbosityResult|null
     */
    public function getSummarizationVerbosityResult()
    {
        return $this->readOneof(14);
    }

    public function hasSummarizationVerbosityResult()
    {
        return $this->hasOneof(14);
    }

    /**
     * Result for summarization verbosity metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.SummarizationVerbosityResult summarization_verbosity_result = 14;</code>
     * @param \Google\Cloud\AIPlatform\V1\SummarizationVerbosityResult $var
     * @return $this
     */
    public function setSummarizationVerbosityResult($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\SummarizationVerbosityResult::class);
        $this->writeOneof(14, $var);

        return $this;
    }

    /**
     * Question answering only metrics.
     * Result for question answering quality metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.QuestionAnsweringQualityResult question_answering_quality_result = 9;</code>
     * @return \Google\Cloud\AIPlatform\V1\QuestionAnsweringQualityResult|null
     */
    public function getQuestionAnsweringQualityResult()
    {
        return $this->readOneof(9);
    }

    public function hasQuestionAnsweringQualityResult()
    {
        return $this->hasOneof(9);
    }

    /**
     * Question answering only metrics.
     * Result for question answering quality metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.QuestionAnsweringQualityResult question_answering_quality_result = 9;</code>
     * @param \Google\Cloud\AIPlatform\V1\QuestionAnsweringQualityResult $var
     * @return $this
     */
    public function setQuestionAnsweringQualityResult($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\QuestionAnsweringQualityResult::class);
        $this->writeOneof(9, $var);

        return $this;
    }

    /**
     * Result for pairwise question answering quality metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PairwiseQuestionAnsweringQualityResult pairwise_question_answering_quality_result = 23;</code>
     * @return \Google\Cloud\AIPlatform\V1\PairwiseQuestionAnsweringQualityResult|null
     */
    public function getPairwiseQuestionAnsweringQualityResult()
    {
        return $this->readOneof(23);
    }

    public function hasPairwiseQuestionAnsweringQualityResult()
    {
        return $this->hasOneof(23);
    }

    /**
     * Result for pairwise question answering quality metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PairwiseQuestionAnsweringQualityResult pairwise_question_answering_quality_result = 23;</code>
     * @param \Google\Cloud\AIPlatform\V1\PairwiseQuestionAnsweringQualityResult $var
     * @return $this
     */
    public function setPairwiseQuestionAnsweringQualityResult($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\PairwiseQuestionAnsweringQualityResult::class);
        $this->writeOneof(23, $var);

        return $this;
    }

    /**
     * Result for question answering relevance metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.QuestionAnsweringRelevanceResult question_answering_relevance_result = 15;</code>
     * @return \Google\Cloud\AIPlatform\V1\QuestionAnsweringRelevanceResult|null
     */
    public function getQuestionAnsweringRelevanceResult()
    {
        return $this->readOneof(15);
    }

    public function hasQuestionAnsweringRelevanceResult()
    {
        return $this->hasOneof(15);
    }

    /**
     * Result for question answering relevance metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.QuestionAnsweringRelevanceResult question_answering_relevance_result = 15;</code>
     * @param \Google\Cloud\AIPlatform\V1\QuestionAnsweringRelevanceResult $var
     * @return $this
     */
    public function setQuestionAnsweringRelevanceResult($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\QuestionAnsweringRelevanceResult::class);
        $this->writeOneof(15, $var);

        return $this;
    }

    /**
     * Result for question answering helpfulness metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.QuestionAnsweringHelpfulnessResult question_answering_helpfulness_result = 16;</code>
     * @return \Google\Cloud\AIPlatform\V1\QuestionAnsweringHelpfulnessResult|null
     */
    public function getQuestionAnsweringHelpfulnessResult()
    {
        return $this->readOneof(16);
    }

    public function hasQuestionAnsweringHelpfulnessResult()
    {
        return $this->hasOneof(16);
    }

    /**
     * Result for question answering helpfulness metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.QuestionAnsweringHelpfulnessResult question_answering_helpfulness_result = 16;</code>
     * @param \Google\Cloud\AIPlatform\V1\QuestionAnsweringHelpfulnessResult $var
     * @return $this
     */
    public function setQuestionAnsweringHelpfulnessResult($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\QuestionAnsweringHelpfulnessResult::class);
        $this->writeOneof(16, $var);

        return $this;
    }

    /**
     * Result for question answering correctness metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.QuestionAnsweringCorrectnessResult question_answering_correctness_result = 17;</code>
     * @return \Google\Cloud\AIPlatform\V1\QuestionAnsweringCorrectnessResult|null
     */
    public function getQuestionAnsweringCorrectnessResult()
    {
        return $this->readOneof(17);
    }

    public function hasQuestionAnsweringCorrectnessResult()
    {
        return $this->hasOneof(17);
    }

    /**
     * Result for question answering correctness metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.QuestionAnsweringCorrectnessResult question_answering_correctness_result = 17;</code>
     * @param \Google\Cloud\AIPlatform\V1\QuestionAnsweringCorrectnessResult $var
     * @return $this
     */
    public function setQuestionAnsweringCorrectnessResult($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\QuestionAnsweringCorrectnessResult::class);
        $this->writeOneof(17, $var);

        return $this;
    }

    /**
     * Generic metrics.
     * Result for pointwise metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PointwiseMetricResult pointwise_metric_result = 27;</code>
     * @return \Google\Cloud\AIPlatform\V1\PointwiseMetricResult|null
     */
    public function getPointwiseMetricResult()
    {
        return $this->readOneof(27);
    }

    public function hasPointwiseMetricResult()
    {
        return $this->hasOneof(27);
    }

    /**
     * Generic metrics.
     * Result for pointwise metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PointwiseMetricResult pointwise_metric_result = 27;</code>
     * @param \Google\Cloud\AIPlatform\V1\PointwiseMetricResult $var
     * @return $this
     */
    public function setPointwiseMetricResult($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\PointwiseMetricResult::class);
        $this->writeOneof(27, $var);

        return $this;
    }

    /**
     * Result for pairwise metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PairwiseMetricResult pairwise_metric_result = 28;</code>
     * @return \Google\Cloud\AIPlatform\V1\PairwiseMetricResult|null
     */
    public function getPairwiseMetricResult()
    {
        return $this->readOneof(28);
    }

    public function hasPairwiseMetricResult()
    {
        return $this->hasOneof(28);
    }

    /**
     * Result for pairwise metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PairwiseMetricResult pairwise_metric_result = 28;</code>
     * @param \Google\Cloud\AIPlatform\V1\PairwiseMetricResult $var
     * @return $this
     */
    public function setPairwiseMetricResult($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\PairwiseMetricResult::class);
        $this->writeOneof(28, $var);

        return $this;
    }

    /**
     * Tool call metrics.
     *  Results for tool call valid metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.ToolCallValidResults tool_call_valid_results = 18;</code>
     * @return \Google\Cloud\AIPlatform\V1\ToolCallValidResults|null
     */
    public function getToolCallValidResults()
    {
        return $this->readOneof(18);
    }

    public function hasToolCallValidResults()
    {
        return $this->hasOneof(18);
    }

    /**
     * Tool call metrics.
     *  Results for tool call valid metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.ToolCallValidResults tool_call_valid_results = 18;</code>
     * @param \Google\Cloud\AIPlatform\V1\ToolCallValidResults $var
     * @return $this
     */
    public function setToolCallValidResults($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\ToolCallValidResults::class);
        $this->writeOneof(18, $var);

        return $this;
    }

    /**
     * Results for tool name match metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.ToolNameMatchResults tool_name_match_results = 19;</code>
     * @return \Google\Cloud\AIPlatform\V1\ToolNameMatchResults|null
     */
    public function getToolNameMatchResults()
    {
        return $this->readOneof(19);
    }

    public function hasToolNameMatchResults()
    {
        return $this->hasOneof(19);
    }

    /**
     * Results for tool name match metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.ToolNameMatchResults tool_name_match_results = 19;</code>
     * @param \Google\Cloud\AIPlatform\V1\ToolNameMatchResults $var
     * @return $this
     */
    public function setToolNameMatchResults($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\ToolNameMatchResults::class);
        $this->writeOneof(19, $var);

        return $this;
    }

    /**
     * Results for tool parameter key match  metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.ToolParameterKeyMatchResults tool_parameter_key_match_results = 20;</code>
     * @return \Google\Cloud\AIPlatform\V1\ToolParameterKeyMatchResults|null
     */
    public function getToolParameterKeyMatchResults()
    {
        return $this->readOneof(20);
    }

    public function hasToolParameterKeyMatchResults()
    {
        return $this->hasOneof(20);
    }

    /**
     * Results for tool parameter key match  metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.ToolParameterKeyMatchResults tool_parameter_key_match_results = 20;</code>
     * @param \Google\Cloud\AIPlatform\V1\ToolParameterKeyMatchResults $var
     * @return $this
     */
    public function setToolParameterKeyMatchResults($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\ToolParameterKeyMatchResults::class);
        $this->writeOneof(20, $var);

        return $this;
    }

    /**
     * Results for tool parameter key value match metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.ToolParameterKVMatchResults tool_parameter_kv_match_results = 21;</code>
     * @return \Google\Cloud\AIPlatform\V1\ToolParameterKVMatchResults|null
     */
    public function getToolParameterKvMatchResults()
    {
        return $this->readOneof(21);
    }

    public function hasToolParameterKvMatchResults()
    {
        return $this->hasOneof(21);
    }

    /**
     * Results for tool parameter key value match metric.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.ToolParameterKVMatchResults tool_parameter_kv_match_results = 21;</code>
     * @param \Google\Cloud\AIPlatform\V1\ToolParameterKVMatchResults $var
     * @return $this
     */
    public function setToolParameterKvMatchResults($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\ToolParameterKVMatchResults::class);
        $this->writeOneof(21, $var);

        return $this;
    }

    /**
     * @return string
     */
    public function getEvaluationResults()
    {
        return $this->whichOneof("evaluation_results");
    }

}

