<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/tensorboard_service.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [TensorboardService.ExportTensorboardTimeSeriesData][google.cloud.aiplatform.v1.TensorboardService.ExportTensorboardTimeSeriesData].
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.ExportTensorboardTimeSeriesDataRequest</code>
 */
class ExportTensorboardTimeSeriesDataRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the TensorboardTimeSeries to export data
     * from. Format:
     * `projects/{project}/locations/{location}/tensorboards/{tensorboard}/experiments/{experiment}/runs/{run}/timeSeries/{time_series}`
     *
     * Generated from protobuf field <code>string tensorboard_time_series = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $tensorboard_time_series = '';
    /**
     * Exports the TensorboardTimeSeries' data that match the filter expression.
     *
     * Generated from protobuf field <code>string filter = 2;</code>
     */
    protected $filter = '';
    /**
     * The maximum number of data points to return per page.
     * The default page_size is 1000. Values must be between 1 and 10000.
     * Values above 10000 are coerced to 10000.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     */
    protected $page_size = 0;
    /**
     * A page token, received from a previous
     * [ExportTensorboardTimeSeriesData][google.cloud.aiplatform.v1.TensorboardService.ExportTensorboardTimeSeriesData]
     * call. Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * [ExportTensorboardTimeSeriesData][google.cloud.aiplatform.v1.TensorboardService.ExportTensorboardTimeSeriesData]
     * must match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     */
    protected $page_token = '';
    /**
     * Field to use to sort the TensorboardTimeSeries' data.
     * By default, TensorboardTimeSeries' data is returned in a pseudo random
     * order.
     *
     * Generated from protobuf field <code>string order_by = 5;</code>
     */
    protected $order_by = '';

    /**
     * @param string $tensorboardTimeSeries Required. The resource name of the TensorboardTimeSeries to export data
     *                                      from. Format:
     *                                      `projects/{project}/locations/{location}/tensorboards/{tensorboard}/experiments/{experiment}/runs/{run}/timeSeries/{time_series}`
     *                                      Please see {@see TensorboardServiceClient::tensorboardTimeSeriesName()} for help formatting this field.
     *
     * @return \Google\Cloud\AIPlatform\V1\ExportTensorboardTimeSeriesDataRequest
     *
     * @experimental
     */
    public static function build(string $tensorboardTimeSeries): self
    {
        return (new self())
            ->setTensorboardTimeSeries($tensorboardTimeSeries);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $tensorboard_time_series
     *           Required. The resource name of the TensorboardTimeSeries to export data
     *           from. Format:
     *           `projects/{project}/locations/{location}/tensorboards/{tensorboard}/experiments/{experiment}/runs/{run}/timeSeries/{time_series}`
     *     @type string $filter
     *           Exports the TensorboardTimeSeries' data that match the filter expression.
     *     @type int $page_size
     *           The maximum number of data points to return per page.
     *           The default page_size is 1000. Values must be between 1 and 10000.
     *           Values above 10000 are coerced to 10000.
     *     @type string $page_token
     *           A page token, received from a previous
     *           [ExportTensorboardTimeSeriesData][google.cloud.aiplatform.v1.TensorboardService.ExportTensorboardTimeSeriesData]
     *           call. Provide this to retrieve the subsequent page.
     *           When paginating, all other parameters provided to
     *           [ExportTensorboardTimeSeriesData][google.cloud.aiplatform.v1.TensorboardService.ExportTensorboardTimeSeriesData]
     *           must match the call that provided the page token.
     *     @type string $order_by
     *           Field to use to sort the TensorboardTimeSeries' data.
     *           By default, TensorboardTimeSeries' data is returned in a pseudo random
     *           order.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\TensorboardService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the TensorboardTimeSeries to export data
     * from. Format:
     * `projects/{project}/locations/{location}/tensorboards/{tensorboard}/experiments/{experiment}/runs/{run}/timeSeries/{time_series}`
     *
     * Generated from protobuf field <code>string tensorboard_time_series = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getTensorboardTimeSeries()
    {
        return $this->tensorboard_time_series;
    }

    /**
     * Required. The resource name of the TensorboardTimeSeries to export data
     * from. Format:
     * `projects/{project}/locations/{location}/tensorboards/{tensorboard}/experiments/{experiment}/runs/{run}/timeSeries/{time_series}`
     *
     * Generated from protobuf field <code>string tensorboard_time_series = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setTensorboardTimeSeries($var)
    {
        GPBUtil::checkString($var, True);
        $this->tensorboard_time_series = $var;

        return $this;
    }

    /**
     * Exports the TensorboardTimeSeries' data that match the filter expression.
     *
     * Generated from protobuf field <code>string filter = 2;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Exports the TensorboardTimeSeries' data that match the filter expression.
     *
     * Generated from protobuf field <code>string filter = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * The maximum number of data points to return per page.
     * The default page_size is 1000. Values must be between 1 and 10000.
     * Values above 10000 are coerced to 10000.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The maximum number of data points to return per page.
     * The default page_size is 1000. Values must be between 1 and 10000.
     * Values above 10000 are coerced to 10000.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * A page token, received from a previous
     * [ExportTensorboardTimeSeriesData][google.cloud.aiplatform.v1.TensorboardService.ExportTensorboardTimeSeriesData]
     * call. Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * [ExportTensorboardTimeSeriesData][google.cloud.aiplatform.v1.TensorboardService.ExportTensorboardTimeSeriesData]
     * must match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * A page token, received from a previous
     * [ExportTensorboardTimeSeriesData][google.cloud.aiplatform.v1.TensorboardService.ExportTensorboardTimeSeriesData]
     * call. Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * [ExportTensorboardTimeSeriesData][google.cloud.aiplatform.v1.TensorboardService.ExportTensorboardTimeSeriesData]
     * must match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Field to use to sort the TensorboardTimeSeries' data.
     * By default, TensorboardTimeSeries' data is returned in a pseudo random
     * order.
     *
     * Generated from protobuf field <code>string order_by = 5;</code>
     * @return string
     */
    public function getOrderBy()
    {
        return $this->order_by;
    }

    /**
     * Field to use to sort the TensorboardTimeSeries' data.
     * By default, TensorboardTimeSeries' data is returned in a pseudo random
     * order.
     *
     * Generated from protobuf field <code>string order_by = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setOrderBy($var)
    {
        GPBUtil::checkString($var, True);
        $this->order_by = $var;

        return $this;
    }

}

