<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/match_service.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for
 * [MatchService.FindNeighbors][google.cloud.aiplatform.v1.MatchService.FindNeighbors].
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.FindNeighborsRequest</code>
 */
class FindNeighborsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the index endpoint.
     * Format:
     * `projects/{project}/locations/{location}/indexEndpoints/{index_endpoint}`
     *
     * Generated from protobuf field <code>string index_endpoint = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $index_endpoint = '';
    /**
     * The ID of the DeployedIndex that will serve the request. This request is
     * sent to a specific IndexEndpoint, as per the IndexEndpoint.network. That
     * IndexEndpoint also has IndexEndpoint.deployed_indexes, and each such index
     * has a DeployedIndex.id field.
     * The value of the field below must equal one of the DeployedIndex.id
     * fields of the IndexEndpoint that is being called for this request.
     *
     * Generated from protobuf field <code>string deployed_index_id = 2;</code>
     */
    protected $deployed_index_id = '';
    /**
     * The list of queries.
     *
     * Generated from protobuf field <code>repeated .google.cloud.aiplatform.v1.FindNeighborsRequest.Query queries = 3;</code>
     */
    private $queries;
    /**
     * If set to true, the full datapoints (including all vector values and
     * restricts) of the nearest neighbors are returned.
     * Note that returning full datapoint will significantly increase the
     * latency and cost of the query.
     *
     * Generated from protobuf field <code>bool return_full_datapoint = 4;</code>
     */
    protected $return_full_datapoint = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $index_endpoint
     *           Required. The name of the index endpoint.
     *           Format:
     *           `projects/{project}/locations/{location}/indexEndpoints/{index_endpoint}`
     *     @type string $deployed_index_id
     *           The ID of the DeployedIndex that will serve the request. This request is
     *           sent to a specific IndexEndpoint, as per the IndexEndpoint.network. That
     *           IndexEndpoint also has IndexEndpoint.deployed_indexes, and each such index
     *           has a DeployedIndex.id field.
     *           The value of the field below must equal one of the DeployedIndex.id
     *           fields of the IndexEndpoint that is being called for this request.
     *     @type array<\Google\Cloud\AIPlatform\V1\FindNeighborsRequest\Query>|\Google\Protobuf\Internal\RepeatedField $queries
     *           The list of queries.
     *     @type bool $return_full_datapoint
     *           If set to true, the full datapoints (including all vector values and
     *           restricts) of the nearest neighbors are returned.
     *           Note that returning full datapoint will significantly increase the
     *           latency and cost of the query.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\MatchService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the index endpoint.
     * Format:
     * `projects/{project}/locations/{location}/indexEndpoints/{index_endpoint}`
     *
     * Generated from protobuf field <code>string index_endpoint = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getIndexEndpoint()
    {
        return $this->index_endpoint;
    }

    /**
     * Required. The name of the index endpoint.
     * Format:
     * `projects/{project}/locations/{location}/indexEndpoints/{index_endpoint}`
     *
     * Generated from protobuf field <code>string index_endpoint = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setIndexEndpoint($var)
    {
        GPBUtil::checkString($var, True);
        $this->index_endpoint = $var;

        return $this;
    }

    /**
     * The ID of the DeployedIndex that will serve the request. This request is
     * sent to a specific IndexEndpoint, as per the IndexEndpoint.network. That
     * IndexEndpoint also has IndexEndpoint.deployed_indexes, and each such index
     * has a DeployedIndex.id field.
     * The value of the field below must equal one of the DeployedIndex.id
     * fields of the IndexEndpoint that is being called for this request.
     *
     * Generated from protobuf field <code>string deployed_index_id = 2;</code>
     * @return string
     */
    public function getDeployedIndexId()
    {
        return $this->deployed_index_id;
    }

    /**
     * The ID of the DeployedIndex that will serve the request. This request is
     * sent to a specific IndexEndpoint, as per the IndexEndpoint.network. That
     * IndexEndpoint also has IndexEndpoint.deployed_indexes, and each such index
     * has a DeployedIndex.id field.
     * The value of the field below must equal one of the DeployedIndex.id
     * fields of the IndexEndpoint that is being called for this request.
     *
     * Generated from protobuf field <code>string deployed_index_id = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setDeployedIndexId($var)
    {
        GPBUtil::checkString($var, True);
        $this->deployed_index_id = $var;

        return $this;
    }

    /**
     * The list of queries.
     *
     * Generated from protobuf field <code>repeated .google.cloud.aiplatform.v1.FindNeighborsRequest.Query queries = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getQueries()
    {
        return $this->queries;
    }

    /**
     * The list of queries.
     *
     * Generated from protobuf field <code>repeated .google.cloud.aiplatform.v1.FindNeighborsRequest.Query queries = 3;</code>
     * @param array<\Google\Cloud\AIPlatform\V1\FindNeighborsRequest\Query>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setQueries($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\AIPlatform\V1\FindNeighborsRequest\Query::class);
        $this->queries = $arr;

        return $this;
    }

    /**
     * If set to true, the full datapoints (including all vector values and
     * restricts) of the nearest neighbors are returned.
     * Note that returning full datapoint will significantly increase the
     * latency and cost of the query.
     *
     * Generated from protobuf field <code>bool return_full_datapoint = 4;</code>
     * @return bool
     */
    public function getReturnFullDatapoint()
    {
        return $this->return_full_datapoint;
    }

    /**
     * If set to true, the full datapoints (including all vector values and
     * restricts) of the nearest neighbors are returned.
     * Note that returning full datapoint will significantly increase the
     * latency and cost of the query.
     *
     * Generated from protobuf field <code>bool return_full_datapoint = 4;</code>
     * @param bool $var
     * @return $this
     */
    public function setReturnFullDatapoint($var)
    {
        GPBUtil::checkBool($var);
        $this->return_full_datapoint = $var;

        return $this;
    }

}

