<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/notebook_service.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for [NotebookService.ListNotebookExecutionJobs]
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.ListNotebookExecutionJobsRequest</code>
 */
class ListNotebookExecutionJobsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the Location from which to list the
     * NotebookExecutionJobs.
     * Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. An expression for filtering the results of the request. For field
     * names both snake_case and camelCase are supported.
     *   * `notebookExecutionJob` supports = and !=. `notebookExecutionJob`
     *   represents the NotebookExecutionJob ID.
     *   * `displayName` supports = and != and regex.
     *   * `schedule` supports = and != and regex.
     * Some examples:
     *   * `notebookExecutionJob="123"`
     *   * `notebookExecutionJob="my-execution-job"`
     *   * `displayName="myDisplayName"` and `displayName=~"myDisplayNameRegex"`
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $filter = '';
    /**
     * Optional. The standard list page size.
     *
     * Generated from protobuf field <code>int32 page_size = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. The standard list page token.
     * Typically obtained via
     * [ListNotebookExecutionJobs.next_page_token][] of the previous
     * [NotebookService.ListNotebookExecutionJobs][google.cloud.aiplatform.v1.NotebookService.ListNotebookExecutionJobs]
     * call.
     *
     * Generated from protobuf field <code>string page_token = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';
    /**
     * Optional. A comma-separated list of fields to order by, sorted in ascending
     * order. Use "desc" after a field name for descending. Supported fields:
     *   * `display_name`
     *   * `create_time`
     *   * `update_time`
     * Example: `display_name, create_time desc`.
     *
     * Generated from protobuf field <code>string order_by = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $order_by = '';
    /**
     * Optional. The NotebookExecutionJob view. Defaults to BASIC.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookExecutionJobView view = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $view = 0;

    /**
     * @param string $parent Required. The resource name of the Location from which to list the
     *                       NotebookExecutionJobs.
     *                       Format: `projects/{project}/locations/{location}`
     *                       Please see {@see NotebookServiceClient::locationName()} for help formatting this field.
     *
     * @return \Google\Cloud\AIPlatform\V1\ListNotebookExecutionJobsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The resource name of the Location from which to list the
     *           NotebookExecutionJobs.
     *           Format: `projects/{project}/locations/{location}`
     *     @type string $filter
     *           Optional. An expression for filtering the results of the request. For field
     *           names both snake_case and camelCase are supported.
     *             * `notebookExecutionJob` supports = and !=. `notebookExecutionJob`
     *             represents the NotebookExecutionJob ID.
     *             * `displayName` supports = and != and regex.
     *             * `schedule` supports = and != and regex.
     *           Some examples:
     *             * `notebookExecutionJob="123"`
     *             * `notebookExecutionJob="my-execution-job"`
     *             * `displayName="myDisplayName"` and `displayName=~"myDisplayNameRegex"`
     *     @type int $page_size
     *           Optional. The standard list page size.
     *     @type string $page_token
     *           Optional. The standard list page token.
     *           Typically obtained via
     *           [ListNotebookExecutionJobs.next_page_token][] of the previous
     *           [NotebookService.ListNotebookExecutionJobs][google.cloud.aiplatform.v1.NotebookService.ListNotebookExecutionJobs]
     *           call.
     *     @type string $order_by
     *           Optional. A comma-separated list of fields to order by, sorted in ascending
     *           order. Use "desc" after a field name for descending. Supported fields:
     *             * `display_name`
     *             * `create_time`
     *             * `update_time`
     *           Example: `display_name, create_time desc`.
     *     @type int $view
     *           Optional. The NotebookExecutionJob view. Defaults to BASIC.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\NotebookService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the Location from which to list the
     * NotebookExecutionJobs.
     * Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The resource name of the Location from which to list the
     * NotebookExecutionJobs.
     * Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. An expression for filtering the results of the request. For field
     * names both snake_case and camelCase are supported.
     *   * `notebookExecutionJob` supports = and !=. `notebookExecutionJob`
     *   represents the NotebookExecutionJob ID.
     *   * `displayName` supports = and != and regex.
     *   * `schedule` supports = and != and regex.
     * Some examples:
     *   * `notebookExecutionJob="123"`
     *   * `notebookExecutionJob="my-execution-job"`
     *   * `displayName="myDisplayName"` and `displayName=~"myDisplayNameRegex"`
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Optional. An expression for filtering the results of the request. For field
     * names both snake_case and camelCase are supported.
     *   * `notebookExecutionJob` supports = and !=. `notebookExecutionJob`
     *   represents the NotebookExecutionJob ID.
     *   * `displayName` supports = and != and regex.
     *   * `schedule` supports = and != and regex.
     * Some examples:
     *   * `notebookExecutionJob="123"`
     *   * `notebookExecutionJob="my-execution-job"`
     *   * `displayName="myDisplayName"` and `displayName=~"myDisplayNameRegex"`
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * Optional. The standard list page size.
     *
     * Generated from protobuf field <code>int32 page_size = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. The standard list page size.
     *
     * Generated from protobuf field <code>int32 page_size = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. The standard list page token.
     * Typically obtained via
     * [ListNotebookExecutionJobs.next_page_token][] of the previous
     * [NotebookService.ListNotebookExecutionJobs][google.cloud.aiplatform.v1.NotebookService.ListNotebookExecutionJobs]
     * call.
     *
     * Generated from protobuf field <code>string page_token = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. The standard list page token.
     * Typically obtained via
     * [ListNotebookExecutionJobs.next_page_token][] of the previous
     * [NotebookService.ListNotebookExecutionJobs][google.cloud.aiplatform.v1.NotebookService.ListNotebookExecutionJobs]
     * call.
     *
     * Generated from protobuf field <code>string page_token = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. A comma-separated list of fields to order by, sorted in ascending
     * order. Use "desc" after a field name for descending. Supported fields:
     *   * `display_name`
     *   * `create_time`
     *   * `update_time`
     * Example: `display_name, create_time desc`.
     *
     * Generated from protobuf field <code>string order_by = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getOrderBy()
    {
        return $this->order_by;
    }

    /**
     * Optional. A comma-separated list of fields to order by, sorted in ascending
     * order. Use "desc" after a field name for descending. Supported fields:
     *   * `display_name`
     *   * `create_time`
     *   * `update_time`
     * Example: `display_name, create_time desc`.
     *
     * Generated from protobuf field <code>string order_by = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setOrderBy($var)
    {
        GPBUtil::checkString($var, True);
        $this->order_by = $var;

        return $this;
    }

    /**
     * Optional. The NotebookExecutionJob view. Defaults to BASIC.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookExecutionJobView view = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getView()
    {
        return $this->view;
    }

    /**
     * Optional. The NotebookExecutionJob view. Defaults to BASIC.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookExecutionJobView view = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setView($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\AIPlatform\V1\NotebookExecutionJobView::class);
        $this->view = $var;

        return $this;
    }

}

