<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/model.proto

namespace Google\Cloud\AIPlatform\V1\Model;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Stats of data used for train or evaluate the Model.
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.Model.DataStats</code>
 */
class DataStats extends \Google\Protobuf\Internal\Message
{
    /**
     * Number of DataItems that were used for training this Model.
     *
     * Generated from protobuf field <code>int64 training_data_items_count = 1;</code>
     */
    protected $training_data_items_count = 0;
    /**
     * Number of DataItems that were used for validating this Model during
     * training.
     *
     * Generated from protobuf field <code>int64 validation_data_items_count = 2;</code>
     */
    protected $validation_data_items_count = 0;
    /**
     * Number of DataItems that were used for evaluating this Model. If the
     * Model is evaluated multiple times, this will be the number of test
     * DataItems used by the first evaluation. If the Model is not evaluated,
     * the number is 0.
     *
     * Generated from protobuf field <code>int64 test_data_items_count = 3;</code>
     */
    protected $test_data_items_count = 0;
    /**
     * Number of Annotations that are used for training this Model.
     *
     * Generated from protobuf field <code>int64 training_annotations_count = 4;</code>
     */
    protected $training_annotations_count = 0;
    /**
     * Number of Annotations that are used for validating this Model during
     * training.
     *
     * Generated from protobuf field <code>int64 validation_annotations_count = 5;</code>
     */
    protected $validation_annotations_count = 0;
    /**
     * Number of Annotations that are used for evaluating this Model. If the
     * Model is evaluated multiple times, this will be the number of test
     * Annotations used by the first evaluation. If the Model is not evaluated,
     * the number is 0.
     *
     * Generated from protobuf field <code>int64 test_annotations_count = 6;</code>
     */
    protected $test_annotations_count = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int|string $training_data_items_count
     *           Number of DataItems that were used for training this Model.
     *     @type int|string $validation_data_items_count
     *           Number of DataItems that were used for validating this Model during
     *           training.
     *     @type int|string $test_data_items_count
     *           Number of DataItems that were used for evaluating this Model. If the
     *           Model is evaluated multiple times, this will be the number of test
     *           DataItems used by the first evaluation. If the Model is not evaluated,
     *           the number is 0.
     *     @type int|string $training_annotations_count
     *           Number of Annotations that are used for training this Model.
     *     @type int|string $validation_annotations_count
     *           Number of Annotations that are used for validating this Model during
     *           training.
     *     @type int|string $test_annotations_count
     *           Number of Annotations that are used for evaluating this Model. If the
     *           Model is evaluated multiple times, this will be the number of test
     *           Annotations used by the first evaluation. If the Model is not evaluated,
     *           the number is 0.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\Model::initOnce();
        parent::__construct($data);
    }

    /**
     * Number of DataItems that were used for training this Model.
     *
     * Generated from protobuf field <code>int64 training_data_items_count = 1;</code>
     * @return int|string
     */
    public function getTrainingDataItemsCount()
    {
        return $this->training_data_items_count;
    }

    /**
     * Number of DataItems that were used for training this Model.
     *
     * Generated from protobuf field <code>int64 training_data_items_count = 1;</code>
     * @param int|string $var
     * @return $this
     */
    public function setTrainingDataItemsCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->training_data_items_count = $var;

        return $this;
    }

    /**
     * Number of DataItems that were used for validating this Model during
     * training.
     *
     * Generated from protobuf field <code>int64 validation_data_items_count = 2;</code>
     * @return int|string
     */
    public function getValidationDataItemsCount()
    {
        return $this->validation_data_items_count;
    }

    /**
     * Number of DataItems that were used for validating this Model during
     * training.
     *
     * Generated from protobuf field <code>int64 validation_data_items_count = 2;</code>
     * @param int|string $var
     * @return $this
     */
    public function setValidationDataItemsCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->validation_data_items_count = $var;

        return $this;
    }

    /**
     * Number of DataItems that were used for evaluating this Model. If the
     * Model is evaluated multiple times, this will be the number of test
     * DataItems used by the first evaluation. If the Model is not evaluated,
     * the number is 0.
     *
     * Generated from protobuf field <code>int64 test_data_items_count = 3;</code>
     * @return int|string
     */
    public function getTestDataItemsCount()
    {
        return $this->test_data_items_count;
    }

    /**
     * Number of DataItems that were used for evaluating this Model. If the
     * Model is evaluated multiple times, this will be the number of test
     * DataItems used by the first evaluation. If the Model is not evaluated,
     * the number is 0.
     *
     * Generated from protobuf field <code>int64 test_data_items_count = 3;</code>
     * @param int|string $var
     * @return $this
     */
    public function setTestDataItemsCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->test_data_items_count = $var;

        return $this;
    }

    /**
     * Number of Annotations that are used for training this Model.
     *
     * Generated from protobuf field <code>int64 training_annotations_count = 4;</code>
     * @return int|string
     */
    public function getTrainingAnnotationsCount()
    {
        return $this->training_annotations_count;
    }

    /**
     * Number of Annotations that are used for training this Model.
     *
     * Generated from protobuf field <code>int64 training_annotations_count = 4;</code>
     * @param int|string $var
     * @return $this
     */
    public function setTrainingAnnotationsCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->training_annotations_count = $var;

        return $this;
    }

    /**
     * Number of Annotations that are used for validating this Model during
     * training.
     *
     * Generated from protobuf field <code>int64 validation_annotations_count = 5;</code>
     * @return int|string
     */
    public function getValidationAnnotationsCount()
    {
        return $this->validation_annotations_count;
    }

    /**
     * Number of Annotations that are used for validating this Model during
     * training.
     *
     * Generated from protobuf field <code>int64 validation_annotations_count = 5;</code>
     * @param int|string $var
     * @return $this
     */
    public function setValidationAnnotationsCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->validation_annotations_count = $var;

        return $this;
    }

    /**
     * Number of Annotations that are used for evaluating this Model. If the
     * Model is evaluated multiple times, this will be the number of test
     * Annotations used by the first evaluation. If the Model is not evaluated,
     * the number is 0.
     *
     * Generated from protobuf field <code>int64 test_annotations_count = 6;</code>
     * @return int|string
     */
    public function getTestAnnotationsCount()
    {
        return $this->test_annotations_count;
    }

    /**
     * Number of Annotations that are used for evaluating this Model. If the
     * Model is evaluated multiple times, this will be the number of test
     * Annotations used by the first evaluation. If the Model is not evaluated,
     * the number is 0.
     *
     * Generated from protobuf field <code>int64 test_annotations_count = 6;</code>
     * @param int|string $var
     * @return $this
     */
    public function setTestAnnotationsCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->test_annotations_count = $var;

        return $this;
    }

}


