<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/endpoint_service.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [EndpointService.MutateDeployedModel][google.cloud.aiplatform.v1.EndpointService.MutateDeployedModel].
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.MutateDeployedModelRequest</code>
 */
class MutateDeployedModelRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the Endpoint resource into which to mutate a
     * DeployedModel. Format:
     * `projects/{project}/locations/{location}/endpoints/{endpoint}`
     *
     * Generated from protobuf field <code>string endpoint = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $endpoint = '';
    /**
     * Required. The DeployedModel to be mutated within the Endpoint. Only the
     * following fields can be mutated:
     * * `min_replica_count` in either
     * [DedicatedResources][google.cloud.aiplatform.v1.DedicatedResources] or
     * [AutomaticResources][google.cloud.aiplatform.v1.AutomaticResources]
     * * `max_replica_count` in either
     * [DedicatedResources][google.cloud.aiplatform.v1.DedicatedResources] or
     * [AutomaticResources][google.cloud.aiplatform.v1.AutomaticResources]
     * * [autoscaling_metric_specs][google.cloud.aiplatform.v1.DedicatedResources.autoscaling_metric_specs]
     * * `disable_container_logging` (v1 only)
     * * `enable_container_logging` (v1beta1 only)
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.DeployedModel deployed_model = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $deployed_model = null;
    /**
     * Required. The update mask applies to the resource. See
     * [google.protobuf.FieldMask][google.protobuf.FieldMask].
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $update_mask = null;

    /**
     * @param string                                    $endpoint      Required. The name of the Endpoint resource into which to mutate a
     *                                                                 DeployedModel. Format:
     *                                                                 `projects/{project}/locations/{location}/endpoints/{endpoint}`
     *                                                                 Please see {@see EndpointServiceClient::endpointName()} for help formatting this field.
     * @param \Google\Cloud\AIPlatform\V1\DeployedModel $deployedModel Required. The DeployedModel to be mutated within the Endpoint. Only the
     *                                                                 following fields can be mutated:
     *
     *                                                                 * `min_replica_count` in either
     *                                                                 [DedicatedResources][google.cloud.aiplatform.v1.DedicatedResources] or
     *                                                                 [AutomaticResources][google.cloud.aiplatform.v1.AutomaticResources]
     *                                                                 * `max_replica_count` in either
     *                                                                 [DedicatedResources][google.cloud.aiplatform.v1.DedicatedResources] or
     *                                                                 [AutomaticResources][google.cloud.aiplatform.v1.AutomaticResources]
     *                                                                 * [autoscaling_metric_specs][google.cloud.aiplatform.v1.DedicatedResources.autoscaling_metric_specs]
     *                                                                 * `disable_container_logging` (v1 only)
     *                                                                 * `enable_container_logging` (v1beta1 only)
     * @param \Google\Protobuf\FieldMask                $updateMask    Required. The update mask applies to the resource. See
     *                                                                 [google.protobuf.FieldMask][google.protobuf.FieldMask].
     *
     * @return \Google\Cloud\AIPlatform\V1\MutateDeployedModelRequest
     *
     * @experimental
     */
    public static function build(string $endpoint, \Google\Cloud\AIPlatform\V1\DeployedModel $deployedModel, \Google\Protobuf\FieldMask $updateMask): self
    {
        return (new self())
            ->setEndpoint($endpoint)
            ->setDeployedModel($deployedModel)
            ->setUpdateMask($updateMask);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $endpoint
     *           Required. The name of the Endpoint resource into which to mutate a
     *           DeployedModel. Format:
     *           `projects/{project}/locations/{location}/endpoints/{endpoint}`
     *     @type \Google\Cloud\AIPlatform\V1\DeployedModel $deployed_model
     *           Required. The DeployedModel to be mutated within the Endpoint. Only the
     *           following fields can be mutated:
     *           * `min_replica_count` in either
     *           [DedicatedResources][google.cloud.aiplatform.v1.DedicatedResources] or
     *           [AutomaticResources][google.cloud.aiplatform.v1.AutomaticResources]
     *           * `max_replica_count` in either
     *           [DedicatedResources][google.cloud.aiplatform.v1.DedicatedResources] or
     *           [AutomaticResources][google.cloud.aiplatform.v1.AutomaticResources]
     *           * [autoscaling_metric_specs][google.cloud.aiplatform.v1.DedicatedResources.autoscaling_metric_specs]
     *           * `disable_container_logging` (v1 only)
     *           * `enable_container_logging` (v1beta1 only)
     *     @type \Google\Protobuf\FieldMask $update_mask
     *           Required. The update mask applies to the resource. See
     *           [google.protobuf.FieldMask][google.protobuf.FieldMask].
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\EndpointService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the Endpoint resource into which to mutate a
     * DeployedModel. Format:
     * `projects/{project}/locations/{location}/endpoints/{endpoint}`
     *
     * Generated from protobuf field <code>string endpoint = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getEndpoint()
    {
        return $this->endpoint;
    }

    /**
     * Required. The name of the Endpoint resource into which to mutate a
     * DeployedModel. Format:
     * `projects/{project}/locations/{location}/endpoints/{endpoint}`
     *
     * Generated from protobuf field <code>string endpoint = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setEndpoint($var)
    {
        GPBUtil::checkString($var, True);
        $this->endpoint = $var;

        return $this;
    }

    /**
     * Required. The DeployedModel to be mutated within the Endpoint. Only the
     * following fields can be mutated:
     * * `min_replica_count` in either
     * [DedicatedResources][google.cloud.aiplatform.v1.DedicatedResources] or
     * [AutomaticResources][google.cloud.aiplatform.v1.AutomaticResources]
     * * `max_replica_count` in either
     * [DedicatedResources][google.cloud.aiplatform.v1.DedicatedResources] or
     * [AutomaticResources][google.cloud.aiplatform.v1.AutomaticResources]
     * * [autoscaling_metric_specs][google.cloud.aiplatform.v1.DedicatedResources.autoscaling_metric_specs]
     * * `disable_container_logging` (v1 only)
     * * `enable_container_logging` (v1beta1 only)
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.DeployedModel deployed_model = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\AIPlatform\V1\DeployedModel|null
     */
    public function getDeployedModel()
    {
        return $this->deployed_model;
    }

    public function hasDeployedModel()
    {
        return isset($this->deployed_model);
    }

    public function clearDeployedModel()
    {
        unset($this->deployed_model);
    }

    /**
     * Required. The DeployedModel to be mutated within the Endpoint. Only the
     * following fields can be mutated:
     * * `min_replica_count` in either
     * [DedicatedResources][google.cloud.aiplatform.v1.DedicatedResources] or
     * [AutomaticResources][google.cloud.aiplatform.v1.AutomaticResources]
     * * `max_replica_count` in either
     * [DedicatedResources][google.cloud.aiplatform.v1.DedicatedResources] or
     * [AutomaticResources][google.cloud.aiplatform.v1.AutomaticResources]
     * * [autoscaling_metric_specs][google.cloud.aiplatform.v1.DedicatedResources.autoscaling_metric_specs]
     * * `disable_container_logging` (v1 only)
     * * `enable_container_logging` (v1beta1 only)
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.DeployedModel deployed_model = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\AIPlatform\V1\DeployedModel $var
     * @return $this
     */
    public function setDeployedModel($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\DeployedModel::class);
        $this->deployed_model = $var;

        return $this;
    }

    /**
     * Required. The update mask applies to the resource. See
     * [google.protobuf.FieldMask][google.protobuf.FieldMask].
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\FieldMask|null
     */
    public function getUpdateMask()
    {
        return $this->update_mask;
    }

    public function hasUpdateMask()
    {
        return isset($this->update_mask);
    }

    public function clearUpdateMask()
    {
        unset($this->update_mask);
    }

    /**
     * Required. The update mask applies to the resource. See
     * [google.protobuf.FieldMask][google.protobuf.FieldMask].
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Protobuf\FieldMask $var
     * @return $this
     */
    public function setUpdateMask($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\FieldMask::class);
        $this->update_mask = $var;

        return $this;
    }

}

