<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/notebook_runtime.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A runtime is a virtual machine allocated to a particular user for a
 * particular Notebook file on temporary basis with lifetime limited to 24
 * hours.
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.NotebookRuntime</code>
 */
class NotebookRuntime extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The resource name of the NotebookRuntime.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $name = '';
    /**
     * Required. The user email of the NotebookRuntime.
     *
     * Generated from protobuf field <code>string runtime_user = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $runtime_user = '';
    /**
     * Output only. The pointer to NotebookRuntimeTemplate this NotebookRuntime is
     * created from.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookRuntimeTemplateRef notebook_runtime_template_ref = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $notebook_runtime_template_ref = null;
    /**
     * Output only. The proxy endpoint used to access the NotebookRuntime.
     *
     * Generated from protobuf field <code>string proxy_uri = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $proxy_uri = '';
    /**
     * Output only. Timestamp when this NotebookRuntime was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. Timestamp when this NotebookRuntime was most recently updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Output only. The health state of the NotebookRuntime.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookRuntime.HealthState health_state = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $health_state = 0;
    /**
     * Required. The display name of the NotebookRuntime.
     * The name can be up to 128 characters long and can consist of any UTF-8
     * characters.
     *
     * Generated from protobuf field <code>string display_name = 10 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $display_name = '';
    /**
     * The description of the NotebookRuntime.
     *
     * Generated from protobuf field <code>string description = 11;</code>
     */
    protected $description = '';
    /**
     * Output only. The service account that the NotebookRuntime workload runs as.
     *
     * Generated from protobuf field <code>string service_account = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $service_account = '';
    /**
     * Output only. The runtime (instance) state of the NotebookRuntime.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookRuntime.RuntimeState runtime_state = 14 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $runtime_state = 0;
    /**
     * Output only. Whether NotebookRuntime is upgradable.
     *
     * Generated from protobuf field <code>bool is_upgradable = 15 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $is_upgradable = false;
    /**
     * The labels with user-defined metadata to organize your
     * NotebookRuntime.
     * Label keys and values can be no longer than 64 characters
     * (Unicode codepoints), can only contain lowercase letters, numeric
     * characters, underscores and dashes. International characters are allowed.
     * No more than 64 user labels can be associated with one NotebookRuntime
     * (System labels are excluded).
     * See https://goo.gl/xmQnxf for more information and examples of labels.
     * System reserved label keys are prefixed with "aiplatform.googleapis.com/"
     * and are immutable. Following system labels exist for NotebookRuntime:
     * * "aiplatform.googleapis.com/notebook_runtime_gce_instance_id": output
     * only, its value is the Compute Engine instance id.
     * * "aiplatform.googleapis.com/colab_enterprise_entry_service": its value is
     * either "bigquery" or "vertex"; if absent, it should be "vertex". This is to
     * describe the entry service, either BigQuery or Vertex.
     *
     * Generated from protobuf field <code>map<string, string> labels = 16;</code>
     */
    private $labels;
    /**
     * Output only. Timestamp when this NotebookRuntime will be expired:
     * 1. System Predefined NotebookRuntime: 24 hours after creation. After
     * expiration, system predifined runtime will be deleted.
     * 2. User created NotebookRuntime: 6 months after last upgrade. After
     * expiration, user created runtime will be stopped and allowed for upgrade.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp expiration_time = 17 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $expiration_time = null;
    /**
     * Output only. The VM os image version of NotebookRuntime.
     *
     * Generated from protobuf field <code>string version = 18 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $version = '';
    /**
     * Output only. The type of the notebook runtime.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookRuntimeType notebook_runtime_type = 19 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $notebook_runtime_type = 0;
    /**
     * Output only. The idle shutdown configuration of the notebook runtime.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookIdleShutdownConfig idle_shutdown_config = 23 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $idle_shutdown_config = null;
    /**
     * Optional. The Compute Engine tags to add to runtime (see [Tagging
     * instances](https://cloud.google.com/vpc/docs/add-remove-network-tags)).
     *
     * Generated from protobuf field <code>repeated string network_tags = 25 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $network_tags;
    /**
     * Output only. Customer-managed encryption key spec for the notebook runtime.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.EncryptionSpec encryption_spec = 28 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $encryption_spec = null;
    /**
     * Output only. Reserved for future use.
     *
     * Generated from protobuf field <code>bool satisfies_pzs = 29 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $satisfies_pzs = false;
    /**
     * Output only. Reserved for future use.
     *
     * Generated from protobuf field <code>bool satisfies_pzi = 30 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $satisfies_pzi = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. The resource name of the NotebookRuntime.
     *     @type string $runtime_user
     *           Required. The user email of the NotebookRuntime.
     *     @type \Google\Cloud\AIPlatform\V1\NotebookRuntimeTemplateRef $notebook_runtime_template_ref
     *           Output only. The pointer to NotebookRuntimeTemplate this NotebookRuntime is
     *           created from.
     *     @type string $proxy_uri
     *           Output only. The proxy endpoint used to access the NotebookRuntime.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. Timestamp when this NotebookRuntime was created.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. Timestamp when this NotebookRuntime was most recently updated.
     *     @type int $health_state
     *           Output only. The health state of the NotebookRuntime.
     *     @type string $display_name
     *           Required. The display name of the NotebookRuntime.
     *           The name can be up to 128 characters long and can consist of any UTF-8
     *           characters.
     *     @type string $description
     *           The description of the NotebookRuntime.
     *     @type string $service_account
     *           Output only. The service account that the NotebookRuntime workload runs as.
     *     @type int $runtime_state
     *           Output only. The runtime (instance) state of the NotebookRuntime.
     *     @type bool $is_upgradable
     *           Output only. Whether NotebookRuntime is upgradable.
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           The labels with user-defined metadata to organize your
     *           NotebookRuntime.
     *           Label keys and values can be no longer than 64 characters
     *           (Unicode codepoints), can only contain lowercase letters, numeric
     *           characters, underscores and dashes. International characters are allowed.
     *           No more than 64 user labels can be associated with one NotebookRuntime
     *           (System labels are excluded).
     *           See https://goo.gl/xmQnxf for more information and examples of labels.
     *           System reserved label keys are prefixed with "aiplatform.googleapis.com/"
     *           and are immutable. Following system labels exist for NotebookRuntime:
     *           * "aiplatform.googleapis.com/notebook_runtime_gce_instance_id": output
     *           only, its value is the Compute Engine instance id.
     *           * "aiplatform.googleapis.com/colab_enterprise_entry_service": its value is
     *           either "bigquery" or "vertex"; if absent, it should be "vertex". This is to
     *           describe the entry service, either BigQuery or Vertex.
     *     @type \Google\Protobuf\Timestamp $expiration_time
     *           Output only. Timestamp when this NotebookRuntime will be expired:
     *           1. System Predefined NotebookRuntime: 24 hours after creation. After
     *           expiration, system predifined runtime will be deleted.
     *           2. User created NotebookRuntime: 6 months after last upgrade. After
     *           expiration, user created runtime will be stopped and allowed for upgrade.
     *     @type string $version
     *           Output only. The VM os image version of NotebookRuntime.
     *     @type int $notebook_runtime_type
     *           Output only. The type of the notebook runtime.
     *     @type \Google\Cloud\AIPlatform\V1\NotebookIdleShutdownConfig $idle_shutdown_config
     *           Output only. The idle shutdown configuration of the notebook runtime.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $network_tags
     *           Optional. The Compute Engine tags to add to runtime (see [Tagging
     *           instances](https://cloud.google.com/vpc/docs/add-remove-network-tags)).
     *     @type \Google\Cloud\AIPlatform\V1\EncryptionSpec $encryption_spec
     *           Output only. Customer-managed encryption key spec for the notebook runtime.
     *     @type bool $satisfies_pzs
     *           Output only. Reserved for future use.
     *     @type bool $satisfies_pzi
     *           Output only. Reserved for future use.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\NotebookRuntime::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The resource name of the NotebookRuntime.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. The resource name of the NotebookRuntime.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Required. The user email of the NotebookRuntime.
     *
     * Generated from protobuf field <code>string runtime_user = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getRuntimeUser()
    {
        return $this->runtime_user;
    }

    /**
     * Required. The user email of the NotebookRuntime.
     *
     * Generated from protobuf field <code>string runtime_user = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setRuntimeUser($var)
    {
        GPBUtil::checkString($var, True);
        $this->runtime_user = $var;

        return $this;
    }

    /**
     * Output only. The pointer to NotebookRuntimeTemplate this NotebookRuntime is
     * created from.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookRuntimeTemplateRef notebook_runtime_template_ref = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\AIPlatform\V1\NotebookRuntimeTemplateRef|null
     */
    public function getNotebookRuntimeTemplateRef()
    {
        return $this->notebook_runtime_template_ref;
    }

    public function hasNotebookRuntimeTemplateRef()
    {
        return isset($this->notebook_runtime_template_ref);
    }

    public function clearNotebookRuntimeTemplateRef()
    {
        unset($this->notebook_runtime_template_ref);
    }

    /**
     * Output only. The pointer to NotebookRuntimeTemplate this NotebookRuntime is
     * created from.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookRuntimeTemplateRef notebook_runtime_template_ref = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\AIPlatform\V1\NotebookRuntimeTemplateRef $var
     * @return $this
     */
    public function setNotebookRuntimeTemplateRef($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\NotebookRuntimeTemplateRef::class);
        $this->notebook_runtime_template_ref = $var;

        return $this;
    }

    /**
     * Output only. The proxy endpoint used to access the NotebookRuntime.
     *
     * Generated from protobuf field <code>string proxy_uri = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getProxyUri()
    {
        return $this->proxy_uri;
    }

    /**
     * Output only. The proxy endpoint used to access the NotebookRuntime.
     *
     * Generated from protobuf field <code>string proxy_uri = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setProxyUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->proxy_uri = $var;

        return $this;
    }

    /**
     * Output only. Timestamp when this NotebookRuntime was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. Timestamp when this NotebookRuntime was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. Timestamp when this NotebookRuntime was most recently updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. Timestamp when this NotebookRuntime was most recently updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Output only. The health state of the NotebookRuntime.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookRuntime.HealthState health_state = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getHealthState()
    {
        return $this->health_state;
    }

    /**
     * Output only. The health state of the NotebookRuntime.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookRuntime.HealthState health_state = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setHealthState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\AIPlatform\V1\NotebookRuntime\HealthState::class);
        $this->health_state = $var;

        return $this;
    }

    /**
     * Required. The display name of the NotebookRuntime.
     * The name can be up to 128 characters long and can consist of any UTF-8
     * characters.
     *
     * Generated from protobuf field <code>string display_name = 10 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * Required. The display name of the NotebookRuntime.
     * The name can be up to 128 characters long and can consist of any UTF-8
     * characters.
     *
     * Generated from protobuf field <code>string display_name = 10 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * The description of the NotebookRuntime.
     *
     * Generated from protobuf field <code>string description = 11;</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * The description of the NotebookRuntime.
     *
     * Generated from protobuf field <code>string description = 11;</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Output only. The service account that the NotebookRuntime workload runs as.
     *
     * Generated from protobuf field <code>string service_account = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getServiceAccount()
    {
        return $this->service_account;
    }

    /**
     * Output only. The service account that the NotebookRuntime workload runs as.
     *
     * Generated from protobuf field <code>string service_account = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setServiceAccount($var)
    {
        GPBUtil::checkString($var, True);
        $this->service_account = $var;

        return $this;
    }

    /**
     * Output only. The runtime (instance) state of the NotebookRuntime.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookRuntime.RuntimeState runtime_state = 14 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getRuntimeState()
    {
        return $this->runtime_state;
    }

    /**
     * Output only. The runtime (instance) state of the NotebookRuntime.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookRuntime.RuntimeState runtime_state = 14 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setRuntimeState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\AIPlatform\V1\NotebookRuntime\RuntimeState::class);
        $this->runtime_state = $var;

        return $this;
    }

    /**
     * Output only. Whether NotebookRuntime is upgradable.
     *
     * Generated from protobuf field <code>bool is_upgradable = 15 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return bool
     */
    public function getIsUpgradable()
    {
        return $this->is_upgradable;
    }

    /**
     * Output only. Whether NotebookRuntime is upgradable.
     *
     * Generated from protobuf field <code>bool is_upgradable = 15 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param bool $var
     * @return $this
     */
    public function setIsUpgradable($var)
    {
        GPBUtil::checkBool($var);
        $this->is_upgradable = $var;

        return $this;
    }

    /**
     * The labels with user-defined metadata to organize your
     * NotebookRuntime.
     * Label keys and values can be no longer than 64 characters
     * (Unicode codepoints), can only contain lowercase letters, numeric
     * characters, underscores and dashes. International characters are allowed.
     * No more than 64 user labels can be associated with one NotebookRuntime
     * (System labels are excluded).
     * See https://goo.gl/xmQnxf for more information and examples of labels.
     * System reserved label keys are prefixed with "aiplatform.googleapis.com/"
     * and are immutable. Following system labels exist for NotebookRuntime:
     * * "aiplatform.googleapis.com/notebook_runtime_gce_instance_id": output
     * only, its value is the Compute Engine instance id.
     * * "aiplatform.googleapis.com/colab_enterprise_entry_service": its value is
     * either "bigquery" or "vertex"; if absent, it should be "vertex". This is to
     * describe the entry service, either BigQuery or Vertex.
     *
     * Generated from protobuf field <code>map<string, string> labels = 16;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * The labels with user-defined metadata to organize your
     * NotebookRuntime.
     * Label keys and values can be no longer than 64 characters
     * (Unicode codepoints), can only contain lowercase letters, numeric
     * characters, underscores and dashes. International characters are allowed.
     * No more than 64 user labels can be associated with one NotebookRuntime
     * (System labels are excluded).
     * See https://goo.gl/xmQnxf for more information and examples of labels.
     * System reserved label keys are prefixed with "aiplatform.googleapis.com/"
     * and are immutable. Following system labels exist for NotebookRuntime:
     * * "aiplatform.googleapis.com/notebook_runtime_gce_instance_id": output
     * only, its value is the Compute Engine instance id.
     * * "aiplatform.googleapis.com/colab_enterprise_entry_service": its value is
     * either "bigquery" or "vertex"; if absent, it should be "vertex". This is to
     * describe the entry service, either BigQuery or Vertex.
     *
     * Generated from protobuf field <code>map<string, string> labels = 16;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * Output only. Timestamp when this NotebookRuntime will be expired:
     * 1. System Predefined NotebookRuntime: 24 hours after creation. After
     * expiration, system predifined runtime will be deleted.
     * 2. User created NotebookRuntime: 6 months after last upgrade. After
     * expiration, user created runtime will be stopped and allowed for upgrade.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp expiration_time = 17 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getExpirationTime()
    {
        return $this->expiration_time;
    }

    public function hasExpirationTime()
    {
        return isset($this->expiration_time);
    }

    public function clearExpirationTime()
    {
        unset($this->expiration_time);
    }

    /**
     * Output only. Timestamp when this NotebookRuntime will be expired:
     * 1. System Predefined NotebookRuntime: 24 hours after creation. After
     * expiration, system predifined runtime will be deleted.
     * 2. User created NotebookRuntime: 6 months after last upgrade. After
     * expiration, user created runtime will be stopped and allowed for upgrade.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp expiration_time = 17 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setExpirationTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->expiration_time = $var;

        return $this;
    }

    /**
     * Output only. The VM os image version of NotebookRuntime.
     *
     * Generated from protobuf field <code>string version = 18 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getVersion()
    {
        return $this->version;
    }

    /**
     * Output only. The VM os image version of NotebookRuntime.
     *
     * Generated from protobuf field <code>string version = 18 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->version = $var;

        return $this;
    }

    /**
     * Output only. The type of the notebook runtime.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookRuntimeType notebook_runtime_type = 19 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getNotebookRuntimeType()
    {
        return $this->notebook_runtime_type;
    }

    /**
     * Output only. The type of the notebook runtime.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookRuntimeType notebook_runtime_type = 19 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setNotebookRuntimeType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\AIPlatform\V1\NotebookRuntimeType::class);
        $this->notebook_runtime_type = $var;

        return $this;
    }

    /**
     * Output only. The idle shutdown configuration of the notebook runtime.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookIdleShutdownConfig idle_shutdown_config = 23 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\AIPlatform\V1\NotebookIdleShutdownConfig|null
     */
    public function getIdleShutdownConfig()
    {
        return $this->idle_shutdown_config;
    }

    public function hasIdleShutdownConfig()
    {
        return isset($this->idle_shutdown_config);
    }

    public function clearIdleShutdownConfig()
    {
        unset($this->idle_shutdown_config);
    }

    /**
     * Output only. The idle shutdown configuration of the notebook runtime.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.NotebookIdleShutdownConfig idle_shutdown_config = 23 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\AIPlatform\V1\NotebookIdleShutdownConfig $var
     * @return $this
     */
    public function setIdleShutdownConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\NotebookIdleShutdownConfig::class);
        $this->idle_shutdown_config = $var;

        return $this;
    }

    /**
     * Optional. The Compute Engine tags to add to runtime (see [Tagging
     * instances](https://cloud.google.com/vpc/docs/add-remove-network-tags)).
     *
     * Generated from protobuf field <code>repeated string network_tags = 25 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getNetworkTags()
    {
        return $this->network_tags;
    }

    /**
     * Optional. The Compute Engine tags to add to runtime (see [Tagging
     * instances](https://cloud.google.com/vpc/docs/add-remove-network-tags)).
     *
     * Generated from protobuf field <code>repeated string network_tags = 25 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setNetworkTags($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->network_tags = $arr;

        return $this;
    }

    /**
     * Output only. Customer-managed encryption key spec for the notebook runtime.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.EncryptionSpec encryption_spec = 28 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\AIPlatform\V1\EncryptionSpec|null
     */
    public function getEncryptionSpec()
    {
        return $this->encryption_spec;
    }

    public function hasEncryptionSpec()
    {
        return isset($this->encryption_spec);
    }

    public function clearEncryptionSpec()
    {
        unset($this->encryption_spec);
    }

    /**
     * Output only. Customer-managed encryption key spec for the notebook runtime.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.EncryptionSpec encryption_spec = 28 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\AIPlatform\V1\EncryptionSpec $var
     * @return $this
     */
    public function setEncryptionSpec($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\EncryptionSpec::class);
        $this->encryption_spec = $var;

        return $this;
    }

    /**
     * Output only. Reserved for future use.
     *
     * Generated from protobuf field <code>bool satisfies_pzs = 29 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return bool
     */
    public function getSatisfiesPzs()
    {
        return $this->satisfies_pzs;
    }

    /**
     * Output only. Reserved for future use.
     *
     * Generated from protobuf field <code>bool satisfies_pzs = 29 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param bool $var
     * @return $this
     */
    public function setSatisfiesPzs($var)
    {
        GPBUtil::checkBool($var);
        $this->satisfies_pzs = $var;

        return $this;
    }

    /**
     * Output only. Reserved for future use.
     *
     * Generated from protobuf field <code>bool satisfies_pzi = 30 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return bool
     */
    public function getSatisfiesPzi()
    {
        return $this->satisfies_pzi;
    }

    /**
     * Output only. Reserved for future use.
     *
     * Generated from protobuf field <code>bool satisfies_pzi = 30 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param bool $var
     * @return $this
     */
    public function setSatisfiesPzi($var)
    {
        GPBUtil::checkBool($var);
        $this->satisfies_pzi = $var;

        return $this;
    }

}

