<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/pipeline_job.proto

namespace Google\Cloud\AIPlatform\V1\PipelineTaskExecutorDetail;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The detail of a container execution. It contains the job names of the
 * lifecycle of a container execution.
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.PipelineTaskExecutorDetail.ContainerDetail</code>
 */
class ContainerDetail extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The name of the
     * [CustomJob][google.cloud.aiplatform.v1.CustomJob] for the main container
     * execution.
     *
     * Generated from protobuf field <code>string main_job = 1 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     */
    protected $main_job = '';
    /**
     * Output only. The name of the
     * [CustomJob][google.cloud.aiplatform.v1.CustomJob] for the
     * pre-caching-check container execution. This job will be available if the
     * [PipelineJob.pipeline_spec][google.cloud.aiplatform.v1.PipelineJob.pipeline_spec]
     * specifies the `pre_caching_check` hook in the lifecycle events.
     *
     * Generated from protobuf field <code>string pre_caching_check_job = 2 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     */
    protected $pre_caching_check_job = '';
    /**
     * Output only. The names of the previously failed
     * [CustomJob][google.cloud.aiplatform.v1.CustomJob] for the main container
     * executions. The list includes the all attempts in chronological order.
     *
     * Generated from protobuf field <code>repeated string failed_main_jobs = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $failed_main_jobs;
    /**
     * Output only. The names of the previously failed
     * [CustomJob][google.cloud.aiplatform.v1.CustomJob] for the
     * pre-caching-check container executions. This job will be available if the
     * [PipelineJob.pipeline_spec][google.cloud.aiplatform.v1.PipelineJob.pipeline_spec]
     * specifies the `pre_caching_check` hook in the lifecycle events. The list
     * includes the all attempts in chronological order.
     *
     * Generated from protobuf field <code>repeated string failed_pre_caching_check_jobs = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $failed_pre_caching_check_jobs;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $main_job
     *           Output only. The name of the
     *           [CustomJob][google.cloud.aiplatform.v1.CustomJob] for the main container
     *           execution.
     *     @type string $pre_caching_check_job
     *           Output only. The name of the
     *           [CustomJob][google.cloud.aiplatform.v1.CustomJob] for the
     *           pre-caching-check container execution. This job will be available if the
     *           [PipelineJob.pipeline_spec][google.cloud.aiplatform.v1.PipelineJob.pipeline_spec]
     *           specifies the `pre_caching_check` hook in the lifecycle events.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $failed_main_jobs
     *           Output only. The names of the previously failed
     *           [CustomJob][google.cloud.aiplatform.v1.CustomJob] for the main container
     *           executions. The list includes the all attempts in chronological order.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $failed_pre_caching_check_jobs
     *           Output only. The names of the previously failed
     *           [CustomJob][google.cloud.aiplatform.v1.CustomJob] for the
     *           pre-caching-check container executions. This job will be available if the
     *           [PipelineJob.pipeline_spec][google.cloud.aiplatform.v1.PipelineJob.pipeline_spec]
     *           specifies the `pre_caching_check` hook in the lifecycle events. The list
     *           includes the all attempts in chronological order.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\PipelineJob::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The name of the
     * [CustomJob][google.cloud.aiplatform.v1.CustomJob] for the main container
     * execution.
     *
     * Generated from protobuf field <code>string main_job = 1 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getMainJob()
    {
        return $this->main_job;
    }

    /**
     * Output only. The name of the
     * [CustomJob][google.cloud.aiplatform.v1.CustomJob] for the main container
     * execution.
     *
     * Generated from protobuf field <code>string main_job = 1 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setMainJob($var)
    {
        GPBUtil::checkString($var, True);
        $this->main_job = $var;

        return $this;
    }

    /**
     * Output only. The name of the
     * [CustomJob][google.cloud.aiplatform.v1.CustomJob] for the
     * pre-caching-check container execution. This job will be available if the
     * [PipelineJob.pipeline_spec][google.cloud.aiplatform.v1.PipelineJob.pipeline_spec]
     * specifies the `pre_caching_check` hook in the lifecycle events.
     *
     * Generated from protobuf field <code>string pre_caching_check_job = 2 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getPreCachingCheckJob()
    {
        return $this->pre_caching_check_job;
    }

    /**
     * Output only. The name of the
     * [CustomJob][google.cloud.aiplatform.v1.CustomJob] for the
     * pre-caching-check container execution. This job will be available if the
     * [PipelineJob.pipeline_spec][google.cloud.aiplatform.v1.PipelineJob.pipeline_spec]
     * specifies the `pre_caching_check` hook in the lifecycle events.
     *
     * Generated from protobuf field <code>string pre_caching_check_job = 2 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setPreCachingCheckJob($var)
    {
        GPBUtil::checkString($var, True);
        $this->pre_caching_check_job = $var;

        return $this;
    }

    /**
     * Output only. The names of the previously failed
     * [CustomJob][google.cloud.aiplatform.v1.CustomJob] for the main container
     * executions. The list includes the all attempts in chronological order.
     *
     * Generated from protobuf field <code>repeated string failed_main_jobs = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getFailedMainJobs()
    {
        return $this->failed_main_jobs;
    }

    /**
     * Output only. The names of the previously failed
     * [CustomJob][google.cloud.aiplatform.v1.CustomJob] for the main container
     * executions. The list includes the all attempts in chronological order.
     *
     * Generated from protobuf field <code>repeated string failed_main_jobs = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setFailedMainJobs($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->failed_main_jobs = $arr;

        return $this;
    }

    /**
     * Output only. The names of the previously failed
     * [CustomJob][google.cloud.aiplatform.v1.CustomJob] for the
     * pre-caching-check container executions. This job will be available if the
     * [PipelineJob.pipeline_spec][google.cloud.aiplatform.v1.PipelineJob.pipeline_spec]
     * specifies the `pre_caching_check` hook in the lifecycle events. The list
     * includes the all attempts in chronological order.
     *
     * Generated from protobuf field <code>repeated string failed_pre_caching_check_jobs = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getFailedPreCachingCheckJobs()
    {
        return $this->failed_pre_caching_check_jobs;
    }

    /**
     * Output only. The names of the previously failed
     * [CustomJob][google.cloud.aiplatform.v1.CustomJob] for the
     * pre-caching-check container executions. This job will be available if the
     * [PipelineJob.pipeline_spec][google.cloud.aiplatform.v1.PipelineJob.pipeline_spec]
     * specifies the `pre_caching_check` hook in the lifecycle events. The list
     * includes the all attempts in chronological order.
     *
     * Generated from protobuf field <code>repeated string failed_pre_caching_check_jobs = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setFailedPreCachingCheckJobs($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->failed_pre_caching_check_jobs = $arr;

        return $this;
    }

}


