<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/model.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Probe describes a health check to be performed against a container to
 * determine whether it is alive or ready to receive traffic.
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.Probe</code>
 */
class Probe extends \Google\Protobuf\Internal\Message
{
    /**
     * How often (in seconds) to perform the probe. Default to 10 seconds.
     * Minimum value is 1. Must be less than timeout_seconds.
     * Maps to Kubernetes probe argument 'periodSeconds'.
     *
     * Generated from protobuf field <code>int32 period_seconds = 2;</code>
     */
    protected $period_seconds = 0;
    /**
     * Number of seconds after which the probe times out. Defaults to 1 second.
     * Minimum value is 1. Must be greater or equal to period_seconds.
     * Maps to Kubernetes probe argument 'timeoutSeconds'.
     *
     * Generated from protobuf field <code>int32 timeout_seconds = 3;</code>
     */
    protected $timeout_seconds = 0;
    protected $probe_type;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\AIPlatform\V1\Probe\ExecAction $exec
     *           ExecAction probes the health of a container by executing a command.
     *     @type int $period_seconds
     *           How often (in seconds) to perform the probe. Default to 10 seconds.
     *           Minimum value is 1. Must be less than timeout_seconds.
     *           Maps to Kubernetes probe argument 'periodSeconds'.
     *     @type int $timeout_seconds
     *           Number of seconds after which the probe times out. Defaults to 1 second.
     *           Minimum value is 1. Must be greater or equal to period_seconds.
     *           Maps to Kubernetes probe argument 'timeoutSeconds'.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\Model::initOnce();
        parent::__construct($data);
    }

    /**
     * ExecAction probes the health of a container by executing a command.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.Probe.ExecAction exec = 1;</code>
     * @return \Google\Cloud\AIPlatform\V1\Probe\ExecAction|null
     */
    public function getExec()
    {
        return $this->readOneof(1);
    }

    public function hasExec()
    {
        return $this->hasOneof(1);
    }

    /**
     * ExecAction probes the health of a container by executing a command.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.Probe.ExecAction exec = 1;</code>
     * @param \Google\Cloud\AIPlatform\V1\Probe\ExecAction $var
     * @return $this
     */
    public function setExec($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\Probe\ExecAction::class);
        $this->writeOneof(1, $var);

        return $this;
    }

    /**
     * How often (in seconds) to perform the probe. Default to 10 seconds.
     * Minimum value is 1. Must be less than timeout_seconds.
     * Maps to Kubernetes probe argument 'periodSeconds'.
     *
     * Generated from protobuf field <code>int32 period_seconds = 2;</code>
     * @return int
     */
    public function getPeriodSeconds()
    {
        return $this->period_seconds;
    }

    /**
     * How often (in seconds) to perform the probe. Default to 10 seconds.
     * Minimum value is 1. Must be less than timeout_seconds.
     * Maps to Kubernetes probe argument 'periodSeconds'.
     *
     * Generated from protobuf field <code>int32 period_seconds = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setPeriodSeconds($var)
    {
        GPBUtil::checkInt32($var);
        $this->period_seconds = $var;

        return $this;
    }

    /**
     * Number of seconds after which the probe times out. Defaults to 1 second.
     * Minimum value is 1. Must be greater or equal to period_seconds.
     * Maps to Kubernetes probe argument 'timeoutSeconds'.
     *
     * Generated from protobuf field <code>int32 timeout_seconds = 3;</code>
     * @return int
     */
    public function getTimeoutSeconds()
    {
        return $this->timeout_seconds;
    }

    /**
     * Number of seconds after which the probe times out. Defaults to 1 second.
     * Minimum value is 1. Must be greater or equal to period_seconds.
     * Maps to Kubernetes probe argument 'timeoutSeconds'.
     *
     * Generated from protobuf field <code>int32 timeout_seconds = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setTimeoutSeconds($var)
    {
        GPBUtil::checkInt32($var);
        $this->timeout_seconds = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getProbeType()
    {
        return $this->whichOneof("probe_type");
    }

}

