<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/publisher_model.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A Model Garden Publisher Model.
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.PublisherModel</code>
 */
class PublisherModel extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The resource name of the PublisherModel.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $name = '';
    /**
     * Output only. Immutable. The version ID of the PublisherModel.
     * A new version is committed when a new model version is uploaded under an
     * existing model id. It is an auto-incrementing decimal number in string
     * representation.
     *
     * Generated from protobuf field <code>string version_id = 2 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $version_id = '';
    /**
     * Required. Indicates the open source category of the publisher model.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PublisherModel.OpenSourceCategory open_source_category = 7 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $open_source_category = 0;
    /**
     * Optional. Supported call-to-action options.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PublisherModel.CallToAction supported_actions = 19 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $supported_actions = null;
    /**
     * Optional. Additional information about the model's Frameworks.
     *
     * Generated from protobuf field <code>repeated string frameworks = 23 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $frameworks;
    /**
     * Optional. Indicates the launch stage of the model.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PublisherModel.LaunchStage launch_stage = 29 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $launch_stage = 0;
    /**
     * Optional. Indicates the state of the model version.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PublisherModel.VersionState version_state = 37 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $version_state = 0;
    /**
     * Optional. Output only. Immutable. Used to indicate this model has a
     * publisher model and provide the template of the publisher model resource
     * name.
     *
     * Generated from protobuf field <code>string publisher_model_template = 30 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $publisher_model_template = '';
    /**
     * Optional. The schemata that describes formats of the PublisherModel's
     * predictions and explanations as given and returned via
     * [PredictionService.Predict][google.cloud.aiplatform.v1.PredictionService.Predict].
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PredictSchemata predict_schemata = 31 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $predict_schemata = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. The resource name of the PublisherModel.
     *     @type string $version_id
     *           Output only. Immutable. The version ID of the PublisherModel.
     *           A new version is committed when a new model version is uploaded under an
     *           existing model id. It is an auto-incrementing decimal number in string
     *           representation.
     *     @type int $open_source_category
     *           Required. Indicates the open source category of the publisher model.
     *     @type \Google\Cloud\AIPlatform\V1\PublisherModel\CallToAction $supported_actions
     *           Optional. Supported call-to-action options.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $frameworks
     *           Optional. Additional information about the model's Frameworks.
     *     @type int $launch_stage
     *           Optional. Indicates the launch stage of the model.
     *     @type int $version_state
     *           Optional. Indicates the state of the model version.
     *     @type string $publisher_model_template
     *           Optional. Output only. Immutable. Used to indicate this model has a
     *           publisher model and provide the template of the publisher model resource
     *           name.
     *     @type \Google\Cloud\AIPlatform\V1\PredictSchemata $predict_schemata
     *           Optional. The schemata that describes formats of the PublisherModel's
     *           predictions and explanations as given and returned via
     *           [PredictionService.Predict][google.cloud.aiplatform.v1.PredictionService.Predict].
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\PublisherModel::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The resource name of the PublisherModel.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. The resource name of the PublisherModel.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. Immutable. The version ID of the PublisherModel.
     * A new version is committed when a new model version is uploaded under an
     * existing model id. It is an auto-incrementing decimal number in string
     * representation.
     *
     * Generated from protobuf field <code>string version_id = 2 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getVersionId()
    {
        return $this->version_id;
    }

    /**
     * Output only. Immutable. The version ID of the PublisherModel.
     * A new version is committed when a new model version is uploaded under an
     * existing model id. It is an auto-incrementing decimal number in string
     * representation.
     *
     * Generated from protobuf field <code>string version_id = 2 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setVersionId($var)
    {
        GPBUtil::checkString($var, True);
        $this->version_id = $var;

        return $this;
    }

    /**
     * Required. Indicates the open source category of the publisher model.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PublisherModel.OpenSourceCategory open_source_category = 7 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return int
     */
    public function getOpenSourceCategory()
    {
        return $this->open_source_category;
    }

    /**
     * Required. Indicates the open source category of the publisher model.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PublisherModel.OpenSourceCategory open_source_category = 7 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int $var
     * @return $this
     */
    public function setOpenSourceCategory($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\AIPlatform\V1\PublisherModel\OpenSourceCategory::class);
        $this->open_source_category = $var;

        return $this;
    }

    /**
     * Optional. Supported call-to-action options.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PublisherModel.CallToAction supported_actions = 19 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\AIPlatform\V1\PublisherModel\CallToAction|null
     */
    public function getSupportedActions()
    {
        return $this->supported_actions;
    }

    public function hasSupportedActions()
    {
        return isset($this->supported_actions);
    }

    public function clearSupportedActions()
    {
        unset($this->supported_actions);
    }

    /**
     * Optional. Supported call-to-action options.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PublisherModel.CallToAction supported_actions = 19 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\AIPlatform\V1\PublisherModel\CallToAction $var
     * @return $this
     */
    public function setSupportedActions($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\PublisherModel\CallToAction::class);
        $this->supported_actions = $var;

        return $this;
    }

    /**
     * Optional. Additional information about the model's Frameworks.
     *
     * Generated from protobuf field <code>repeated string frameworks = 23 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getFrameworks()
    {
        return $this->frameworks;
    }

    /**
     * Optional. Additional information about the model's Frameworks.
     *
     * Generated from protobuf field <code>repeated string frameworks = 23 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setFrameworks($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->frameworks = $arr;

        return $this;
    }

    /**
     * Optional. Indicates the launch stage of the model.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PublisherModel.LaunchStage launch_stage = 29 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getLaunchStage()
    {
        return $this->launch_stage;
    }

    /**
     * Optional. Indicates the launch stage of the model.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PublisherModel.LaunchStage launch_stage = 29 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setLaunchStage($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\AIPlatform\V1\PublisherModel\LaunchStage::class);
        $this->launch_stage = $var;

        return $this;
    }

    /**
     * Optional. Indicates the state of the model version.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PublisherModel.VersionState version_state = 37 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getVersionState()
    {
        return $this->version_state;
    }

    /**
     * Optional. Indicates the state of the model version.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PublisherModel.VersionState version_state = 37 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setVersionState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\AIPlatform\V1\PublisherModel\VersionState::class);
        $this->version_state = $var;

        return $this;
    }

    /**
     * Optional. Output only. Immutable. Used to indicate this model has a
     * publisher model and provide the template of the publisher model resource
     * name.
     *
     * Generated from protobuf field <code>string publisher_model_template = 30 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getPublisherModelTemplate()
    {
        return $this->publisher_model_template;
    }

    /**
     * Optional. Output only. Immutable. Used to indicate this model has a
     * publisher model and provide the template of the publisher model resource
     * name.
     *
     * Generated from protobuf field <code>string publisher_model_template = 30 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setPublisherModelTemplate($var)
    {
        GPBUtil::checkString($var, True);
        $this->publisher_model_template = $var;

        return $this;
    }

    /**
     * Optional. The schemata that describes formats of the PublisherModel's
     * predictions and explanations as given and returned via
     * [PredictionService.Predict][google.cloud.aiplatform.v1.PredictionService.Predict].
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PredictSchemata predict_schemata = 31 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\AIPlatform\V1\PredictSchemata|null
     */
    public function getPredictSchemata()
    {
        return $this->predict_schemata;
    }

    public function hasPredictSchemata()
    {
        return isset($this->predict_schemata);
    }

    public function clearPredictSchemata()
    {
        unset($this->predict_schemata);
    }

    /**
     * Optional. The schemata that describes formats of the PublisherModel's
     * predictions and explanations as given and returned via
     * [PredictionService.Predict][google.cloud.aiplatform.v1.PredictionService.Predict].
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.PredictSchemata predict_schemata = 31 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\AIPlatform\V1\PredictSchemata $var
     * @return $this
     */
    public function setPredictSchemata($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\PredictSchemata::class);
        $this->predict_schemata = $var;

        return $this;
    }

}

