<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/persistent_resource.proto

namespace Google\Cloud\AIPlatform\V1\ResourcePool;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The min/max number of replicas allowed if enabling autoscaling
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.ResourcePool.AutoscalingSpec</code>
 */
class AutoscalingSpec extends \Google\Protobuf\Internal\Message
{
    /**
     * Optional. min replicas in the node pool,
     * must be ≤ replica_count and < max_replica_count or will throw error.
     * For autoscaling enabled Ray-on-Vertex, we allow min_replica_count of a
     * resource_pool to be 0 to match the OSS Ray
     * behavior(https://docs.ray.io/en/latest/cluster/vms/user-guides/configuring-autoscaling.html#cluster-config-parameters).
     * As for Persistent Resource, the min_replica_count must be > 0, we added
     * a corresponding validation inside
     * CreatePersistentResourceRequestValidator.java.
     *
     * Generated from protobuf field <code>optional int64 min_replica_count = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $min_replica_count = null;
    /**
     * Optional. max replicas in the node pool,
     * must be ≥ replica_count and > min_replica_count or will throw error
     *
     * Generated from protobuf field <code>optional int64 max_replica_count = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $max_replica_count = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int|string $min_replica_count
     *           Optional. min replicas in the node pool,
     *           must be ≤ replica_count and < max_replica_count or will throw error.
     *           For autoscaling enabled Ray-on-Vertex, we allow min_replica_count of a
     *           resource_pool to be 0 to match the OSS Ray
     *           behavior(https://docs.ray.io/en/latest/cluster/vms/user-guides/configuring-autoscaling.html#cluster-config-parameters).
     *           As for Persistent Resource, the min_replica_count must be > 0, we added
     *           a corresponding validation inside
     *           CreatePersistentResourceRequestValidator.java.
     *     @type int|string $max_replica_count
     *           Optional. max replicas in the node pool,
     *           must be ≥ replica_count and > min_replica_count or will throw error
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\PersistentResource::initOnce();
        parent::__construct($data);
    }

    /**
     * Optional. min replicas in the node pool,
     * must be ≤ replica_count and < max_replica_count or will throw error.
     * For autoscaling enabled Ray-on-Vertex, we allow min_replica_count of a
     * resource_pool to be 0 to match the OSS Ray
     * behavior(https://docs.ray.io/en/latest/cluster/vms/user-guides/configuring-autoscaling.html#cluster-config-parameters).
     * As for Persistent Resource, the min_replica_count must be > 0, we added
     * a corresponding validation inside
     * CreatePersistentResourceRequestValidator.java.
     *
     * Generated from protobuf field <code>optional int64 min_replica_count = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int|string
     */
    public function getMinReplicaCount()
    {
        return isset($this->min_replica_count) ? $this->min_replica_count : 0;
    }

    public function hasMinReplicaCount()
    {
        return isset($this->min_replica_count);
    }

    public function clearMinReplicaCount()
    {
        unset($this->min_replica_count);
    }

    /**
     * Optional. min replicas in the node pool,
     * must be ≤ replica_count and < max_replica_count or will throw error.
     * For autoscaling enabled Ray-on-Vertex, we allow min_replica_count of a
     * resource_pool to be 0 to match the OSS Ray
     * behavior(https://docs.ray.io/en/latest/cluster/vms/user-guides/configuring-autoscaling.html#cluster-config-parameters).
     * As for Persistent Resource, the min_replica_count must be > 0, we added
     * a corresponding validation inside
     * CreatePersistentResourceRequestValidator.java.
     *
     * Generated from protobuf field <code>optional int64 min_replica_count = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int|string $var
     * @return $this
     */
    public function setMinReplicaCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->min_replica_count = $var;

        return $this;
    }

    /**
     * Optional. max replicas in the node pool,
     * must be ≥ replica_count and > min_replica_count or will throw error
     *
     * Generated from protobuf field <code>optional int64 max_replica_count = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int|string
     */
    public function getMaxReplicaCount()
    {
        return isset($this->max_replica_count) ? $this->max_replica_count : 0;
    }

    public function hasMaxReplicaCount()
    {
        return isset($this->max_replica_count);
    }

    public function clearMaxReplicaCount()
    {
        unset($this->max_replica_count);
    }

    /**
     * Optional. max replicas in the node pool,
     * must be ≥ replica_count and > min_replica_count or will throw error
     *
     * Generated from protobuf field <code>optional int64 max_replica_count = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int|string $var
     * @return $this
     */
    public function setMaxReplicaCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->max_replica_count = $var;

        return $this;
    }

}


