<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/schedule_service.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [ScheduleService.ResumeSchedule][google.cloud.aiplatform.v1.ScheduleService.ResumeSchedule].
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.ResumeScheduleRequest</code>
 */
class ResumeScheduleRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the Schedule resource to be resumed.
     * Format:
     * `projects/{project}/locations/{location}/schedules/{schedule}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';
    /**
     * Optional. Whether to backfill missed runs when the schedule is resumed from
     * PAUSED state. If set to true, all missed runs will be scheduled. New runs
     * will be scheduled after the backfill is complete. This will also update
     * [Schedule.catch_up][google.cloud.aiplatform.v1.Schedule.catch_up] field.
     * Default to false.
     *
     * Generated from protobuf field <code>bool catch_up = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $catch_up = false;

    /**
     * @param string $name Required. The name of the Schedule resource to be resumed.
     *                     Format:
     *                     `projects/{project}/locations/{location}/schedules/{schedule}`
     *                     Please see {@see ScheduleServiceClient::scheduleName()} for help formatting this field.
     *
     * @return \Google\Cloud\AIPlatform\V1\ResumeScheduleRequest
     *
     * @experimental
     */
    public static function build(string $name): self
    {
        return (new self())
            ->setName($name);
    }

    /**
     * @param string $name    Required. The name of the Schedule resource to be resumed.
     *                        Format:
     *                        `projects/{project}/locations/{location}/schedules/{schedule}`
     *                        Please see {@see ScheduleServiceClient::scheduleName()} for help formatting this field.
     * @param bool   $catchUp Optional. Whether to backfill missed runs when the schedule is resumed from
     *                        PAUSED state. If set to true, all missed runs will be scheduled. New runs
     *                        will be scheduled after the backfill is complete. This will also update
     *                        [Schedule.catch_up][google.cloud.aiplatform.v1.Schedule.catch_up] field.
     *                        Default to false.
     *
     * @return \Google\Cloud\AIPlatform\V1\ResumeScheduleRequest
     *
     * @experimental
     */
    public static function buildFromNameCatchUp(string $name, bool $catchUp): self
    {
        return (new self())
            ->setName($name)
            ->setCatchUp($catchUp);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. The name of the Schedule resource to be resumed.
     *           Format:
     *           `projects/{project}/locations/{location}/schedules/{schedule}`
     *     @type bool $catch_up
     *           Optional. Whether to backfill missed runs when the schedule is resumed from
     *           PAUSED state. If set to true, all missed runs will be scheduled. New runs
     *           will be scheduled after the backfill is complete. This will also update
     *           [Schedule.catch_up][google.cloud.aiplatform.v1.Schedule.catch_up] field.
     *           Default to false.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\ScheduleService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the Schedule resource to be resumed.
     * Format:
     * `projects/{project}/locations/{location}/schedules/{schedule}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. The name of the Schedule resource to be resumed.
     * Format:
     * `projects/{project}/locations/{location}/schedules/{schedule}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Optional. Whether to backfill missed runs when the schedule is resumed from
     * PAUSED state. If set to true, all missed runs will be scheduled. New runs
     * will be scheduled after the backfill is complete. This will also update
     * [Schedule.catch_up][google.cloud.aiplatform.v1.Schedule.catch_up] field.
     * Default to false.
     *
     * Generated from protobuf field <code>bool catch_up = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getCatchUp()
    {
        return $this->catch_up;
    }

    /**
     * Optional. Whether to backfill missed runs when the schedule is resumed from
     * PAUSED state. If set to true, all missed runs will be scheduled. New runs
     * will be scheduled after the backfill is complete. This will also update
     * [Schedule.catch_up][google.cloud.aiplatform.v1.Schedule.catch_up] field.
     * Default to false.
     *
     * Generated from protobuf field <code>bool catch_up = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setCatchUp($var)
    {
        GPBUtil::checkBool($var);
        $this->catch_up = $var;

        return $this;
    }

}

