<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/job_service.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [JobService.SearchModelDeploymentMonitoringStatsAnomalies][google.cloud.aiplatform.v1.JobService.SearchModelDeploymentMonitoringStatsAnomalies].
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.SearchModelDeploymentMonitoringStatsAnomaliesRequest</code>
 */
class SearchModelDeploymentMonitoringStatsAnomaliesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. ModelDeploymentMonitoring Job resource name.
     * Format:
     * `projects/{project}/locations/{location}/modelDeploymentMonitoringJobs/{model_deployment_monitoring_job}`
     *
     * Generated from protobuf field <code>string model_deployment_monitoring_job = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $model_deployment_monitoring_job = '';
    /**
     * Required. The DeployedModel ID of the
     * [ModelDeploymentMonitoringObjectiveConfig.deployed_model_id].
     *
     * Generated from protobuf field <code>string deployed_model_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $deployed_model_id = '';
    /**
     * The feature display name. If specified, only return the stats belonging to
     * this feature. Format:
     * [ModelMonitoringStatsAnomalies.FeatureHistoricStatsAnomalies.feature_display_name][google.cloud.aiplatform.v1.ModelMonitoringStatsAnomalies.FeatureHistoricStatsAnomalies.feature_display_name],
     * example: "user_destination".
     *
     * Generated from protobuf field <code>string feature_display_name = 3;</code>
     */
    protected $feature_display_name = '';
    /**
     * Required. Objectives of the stats to retrieve.
     *
     * Generated from protobuf field <code>repeated .google.cloud.aiplatform.v1.SearchModelDeploymentMonitoringStatsAnomaliesRequest.StatsAnomaliesObjective objectives = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $objectives;
    /**
     * The standard list page size.
     *
     * Generated from protobuf field <code>int32 page_size = 5;</code>
     */
    protected $page_size = 0;
    /**
     * A page token received from a previous
     * [JobService.SearchModelDeploymentMonitoringStatsAnomalies][google.cloud.aiplatform.v1.JobService.SearchModelDeploymentMonitoringStatsAnomalies]
     * call.
     *
     * Generated from protobuf field <code>string page_token = 6;</code>
     */
    protected $page_token = '';
    /**
     * The earliest timestamp of stats being generated.
     * If not set, indicates fetching stats till the earliest possible one.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 7;</code>
     */
    protected $start_time = null;
    /**
     * The latest timestamp of stats being generated.
     * If not set, indicates feching stats till the latest possible one.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_time = 8;</code>
     */
    protected $end_time = null;

    /**
     * @param string $modelDeploymentMonitoringJob Required. ModelDeploymentMonitoring Job resource name.
     *                                             Format:
     *                                             `projects/{project}/locations/{location}/modelDeploymentMonitoringJobs/{model_deployment_monitoring_job}`
     *                                             Please see {@see JobServiceClient::modelDeploymentMonitoringJobName()} for help formatting this field.
     * @param string $deployedModelId              Required. The DeployedModel ID of the
     *                                             [ModelDeploymentMonitoringObjectiveConfig.deployed_model_id].
     *
     * @return \Google\Cloud\AIPlatform\V1\SearchModelDeploymentMonitoringStatsAnomaliesRequest
     *
     * @experimental
     */
    public static function build(string $modelDeploymentMonitoringJob, string $deployedModelId): self
    {
        return (new self())
            ->setModelDeploymentMonitoringJob($modelDeploymentMonitoringJob)
            ->setDeployedModelId($deployedModelId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $model_deployment_monitoring_job
     *           Required. ModelDeploymentMonitoring Job resource name.
     *           Format:
     *           `projects/{project}/locations/{location}/modelDeploymentMonitoringJobs/{model_deployment_monitoring_job}`
     *     @type string $deployed_model_id
     *           Required. The DeployedModel ID of the
     *           [ModelDeploymentMonitoringObjectiveConfig.deployed_model_id].
     *     @type string $feature_display_name
     *           The feature display name. If specified, only return the stats belonging to
     *           this feature. Format:
     *           [ModelMonitoringStatsAnomalies.FeatureHistoricStatsAnomalies.feature_display_name][google.cloud.aiplatform.v1.ModelMonitoringStatsAnomalies.FeatureHistoricStatsAnomalies.feature_display_name],
     *           example: "user_destination".
     *     @type array<\Google\Cloud\AIPlatform\V1\SearchModelDeploymentMonitoringStatsAnomaliesRequest\StatsAnomaliesObjective>|\Google\Protobuf\Internal\RepeatedField $objectives
     *           Required. Objectives of the stats to retrieve.
     *     @type int $page_size
     *           The standard list page size.
     *     @type string $page_token
     *           A page token received from a previous
     *           [JobService.SearchModelDeploymentMonitoringStatsAnomalies][google.cloud.aiplatform.v1.JobService.SearchModelDeploymentMonitoringStatsAnomalies]
     *           call.
     *     @type \Google\Protobuf\Timestamp $start_time
     *           The earliest timestamp of stats being generated.
     *           If not set, indicates fetching stats till the earliest possible one.
     *     @type \Google\Protobuf\Timestamp $end_time
     *           The latest timestamp of stats being generated.
     *           If not set, indicates feching stats till the latest possible one.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\JobService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. ModelDeploymentMonitoring Job resource name.
     * Format:
     * `projects/{project}/locations/{location}/modelDeploymentMonitoringJobs/{model_deployment_monitoring_job}`
     *
     * Generated from protobuf field <code>string model_deployment_monitoring_job = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getModelDeploymentMonitoringJob()
    {
        return $this->model_deployment_monitoring_job;
    }

    /**
     * Required. ModelDeploymentMonitoring Job resource name.
     * Format:
     * `projects/{project}/locations/{location}/modelDeploymentMonitoringJobs/{model_deployment_monitoring_job}`
     *
     * Generated from protobuf field <code>string model_deployment_monitoring_job = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setModelDeploymentMonitoringJob($var)
    {
        GPBUtil::checkString($var, True);
        $this->model_deployment_monitoring_job = $var;

        return $this;
    }

    /**
     * Required. The DeployedModel ID of the
     * [ModelDeploymentMonitoringObjectiveConfig.deployed_model_id].
     *
     * Generated from protobuf field <code>string deployed_model_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getDeployedModelId()
    {
        return $this->deployed_model_id;
    }

    /**
     * Required. The DeployedModel ID of the
     * [ModelDeploymentMonitoringObjectiveConfig.deployed_model_id].
     *
     * Generated from protobuf field <code>string deployed_model_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setDeployedModelId($var)
    {
        GPBUtil::checkString($var, True);
        $this->deployed_model_id = $var;

        return $this;
    }

    /**
     * The feature display name. If specified, only return the stats belonging to
     * this feature. Format:
     * [ModelMonitoringStatsAnomalies.FeatureHistoricStatsAnomalies.feature_display_name][google.cloud.aiplatform.v1.ModelMonitoringStatsAnomalies.FeatureHistoricStatsAnomalies.feature_display_name],
     * example: "user_destination".
     *
     * Generated from protobuf field <code>string feature_display_name = 3;</code>
     * @return string
     */
    public function getFeatureDisplayName()
    {
        return $this->feature_display_name;
    }

    /**
     * The feature display name. If specified, only return the stats belonging to
     * this feature. Format:
     * [ModelMonitoringStatsAnomalies.FeatureHistoricStatsAnomalies.feature_display_name][google.cloud.aiplatform.v1.ModelMonitoringStatsAnomalies.FeatureHistoricStatsAnomalies.feature_display_name],
     * example: "user_destination".
     *
     * Generated from protobuf field <code>string feature_display_name = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setFeatureDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->feature_display_name = $var;

        return $this;
    }

    /**
     * Required. Objectives of the stats to retrieve.
     *
     * Generated from protobuf field <code>repeated .google.cloud.aiplatform.v1.SearchModelDeploymentMonitoringStatsAnomaliesRequest.StatsAnomaliesObjective objectives = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getObjectives()
    {
        return $this->objectives;
    }

    /**
     * Required. Objectives of the stats to retrieve.
     *
     * Generated from protobuf field <code>repeated .google.cloud.aiplatform.v1.SearchModelDeploymentMonitoringStatsAnomaliesRequest.StatsAnomaliesObjective objectives = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param array<\Google\Cloud\AIPlatform\V1\SearchModelDeploymentMonitoringStatsAnomaliesRequest\StatsAnomaliesObjective>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setObjectives($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\AIPlatform\V1\SearchModelDeploymentMonitoringStatsAnomaliesRequest\StatsAnomaliesObjective::class);
        $this->objectives = $arr;

        return $this;
    }

    /**
     * The standard list page size.
     *
     * Generated from protobuf field <code>int32 page_size = 5;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The standard list page size.
     *
     * Generated from protobuf field <code>int32 page_size = 5;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * A page token received from a previous
     * [JobService.SearchModelDeploymentMonitoringStatsAnomalies][google.cloud.aiplatform.v1.JobService.SearchModelDeploymentMonitoringStatsAnomalies]
     * call.
     *
     * Generated from protobuf field <code>string page_token = 6;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * A page token received from a previous
     * [JobService.SearchModelDeploymentMonitoringStatsAnomalies][google.cloud.aiplatform.v1.JobService.SearchModelDeploymentMonitoringStatsAnomalies]
     * call.
     *
     * Generated from protobuf field <code>string page_token = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * The earliest timestamp of stats being generated.
     * If not set, indicates fetching stats till the earliest possible one.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 7;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getStartTime()
    {
        return $this->start_time;
    }

    public function hasStartTime()
    {
        return isset($this->start_time);
    }

    public function clearStartTime()
    {
        unset($this->start_time);
    }

    /**
     * The earliest timestamp of stats being generated.
     * If not set, indicates fetching stats till the earliest possible one.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 7;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setStartTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->start_time = $var;

        return $this;
    }

    /**
     * The latest timestamp of stats being generated.
     * If not set, indicates feching stats till the latest possible one.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_time = 8;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getEndTime()
    {
        return $this->end_time;
    }

    public function hasEndTime()
    {
        return isset($this->end_time);
    }

    public function clearEndTime()
    {
        unset($this->end_time);
    }

    /**
     * The latest timestamp of stats being generated.
     * If not set, indicates feching stats till the latest possible one.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_time = 8;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setEndTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->end_time = $var;

        return $this;
    }

}

