<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/tuning_job.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Tuning data statistics for Supervised Tuning.
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.SupervisedTuningDataStats</code>
 */
class SupervisedTuningDataStats extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. Number of examples in the tuning dataset.
     *
     * Generated from protobuf field <code>int64 tuning_dataset_example_count = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $tuning_dataset_example_count = 0;
    /**
     * Output only. Number of tuning characters in the tuning dataset.
     *
     * Generated from protobuf field <code>int64 total_tuning_character_count = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $total_tuning_character_count = 0;
    /**
     * Output only. Number of billable characters in the tuning dataset.
     *
     * Generated from protobuf field <code>int64 total_billable_character_count = 3 [deprecated = true, (.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @deprecated
     */
    protected $total_billable_character_count = 0;
    /**
     * Output only. Number of billable tokens in the tuning dataset.
     *
     * Generated from protobuf field <code>int64 total_billable_token_count = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $total_billable_token_count = 0;
    /**
     * Output only. Number of tuning steps for this Tuning Job.
     *
     * Generated from protobuf field <code>int64 tuning_step_count = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $tuning_step_count = 0;
    /**
     * Output only. Dataset distributions for the user input tokens.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.SupervisedTuningDatasetDistribution user_input_token_distribution = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $user_input_token_distribution = null;
    /**
     * Output only. Dataset distributions for the user output tokens.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.SupervisedTuningDatasetDistribution user_output_token_distribution = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $user_output_token_distribution = null;
    /**
     * Output only. Dataset distributions for the messages per example.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.SupervisedTuningDatasetDistribution user_message_per_example_distribution = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $user_message_per_example_distribution = null;
    /**
     * Output only. Sample user messages in the training dataset uri.
     *
     * Generated from protobuf field <code>repeated .google.cloud.aiplatform.v1.Content user_dataset_examples = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $user_dataset_examples;
    /**
     * The number of examples in the dataset that have been truncated by any
     * amount.
     *
     * Generated from protobuf field <code>int64 total_truncated_example_count = 10;</code>
     */
    protected $total_truncated_example_count = 0;
    /**
     * A partial sample of the indices (starting from 1) of the truncated
     * examples.
     *
     * Generated from protobuf field <code>repeated int64 truncated_example_indices = 11;</code>
     */
    private $truncated_example_indices;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int|string $tuning_dataset_example_count
     *           Output only. Number of examples in the tuning dataset.
     *     @type int|string $total_tuning_character_count
     *           Output only. Number of tuning characters in the tuning dataset.
     *     @type int|string $total_billable_character_count
     *           Output only. Number of billable characters in the tuning dataset.
     *     @type int|string $total_billable_token_count
     *           Output only. Number of billable tokens in the tuning dataset.
     *     @type int|string $tuning_step_count
     *           Output only. Number of tuning steps for this Tuning Job.
     *     @type \Google\Cloud\AIPlatform\V1\SupervisedTuningDatasetDistribution $user_input_token_distribution
     *           Output only. Dataset distributions for the user input tokens.
     *     @type \Google\Cloud\AIPlatform\V1\SupervisedTuningDatasetDistribution $user_output_token_distribution
     *           Output only. Dataset distributions for the user output tokens.
     *     @type \Google\Cloud\AIPlatform\V1\SupervisedTuningDatasetDistribution $user_message_per_example_distribution
     *           Output only. Dataset distributions for the messages per example.
     *     @type array<\Google\Cloud\AIPlatform\V1\Content>|\Google\Protobuf\Internal\RepeatedField $user_dataset_examples
     *           Output only. Sample user messages in the training dataset uri.
     *     @type int|string $total_truncated_example_count
     *           The number of examples in the dataset that have been truncated by any
     *           amount.
     *     @type array<int>|array<string>|\Google\Protobuf\Internal\RepeatedField $truncated_example_indices
     *           A partial sample of the indices (starting from 1) of the truncated
     *           examples.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\TuningJob::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. Number of examples in the tuning dataset.
     *
     * Generated from protobuf field <code>int64 tuning_dataset_example_count = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int|string
     */
    public function getTuningDatasetExampleCount()
    {
        return $this->tuning_dataset_example_count;
    }

    /**
     * Output only. Number of examples in the tuning dataset.
     *
     * Generated from protobuf field <code>int64 tuning_dataset_example_count = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int|string $var
     * @return $this
     */
    public function setTuningDatasetExampleCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->tuning_dataset_example_count = $var;

        return $this;
    }

    /**
     * Output only. Number of tuning characters in the tuning dataset.
     *
     * Generated from protobuf field <code>int64 total_tuning_character_count = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int|string
     */
    public function getTotalTuningCharacterCount()
    {
        return $this->total_tuning_character_count;
    }

    /**
     * Output only. Number of tuning characters in the tuning dataset.
     *
     * Generated from protobuf field <code>int64 total_tuning_character_count = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int|string $var
     * @return $this
     */
    public function setTotalTuningCharacterCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->total_tuning_character_count = $var;

        return $this;
    }

    /**
     * Output only. Number of billable characters in the tuning dataset.
     *
     * Generated from protobuf field <code>int64 total_billable_character_count = 3 [deprecated = true, (.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int|string
     * @deprecated
     */
    public function getTotalBillableCharacterCount()
    {
        @trigger_error('total_billable_character_count is deprecated.', E_USER_DEPRECATED);
        return $this->total_billable_character_count;
    }

    /**
     * Output only. Number of billable characters in the tuning dataset.
     *
     * Generated from protobuf field <code>int64 total_billable_character_count = 3 [deprecated = true, (.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int|string $var
     * @return $this
     * @deprecated
     */
    public function setTotalBillableCharacterCount($var)
    {
        @trigger_error('total_billable_character_count is deprecated.', E_USER_DEPRECATED);
        GPBUtil::checkInt64($var);
        $this->total_billable_character_count = $var;

        return $this;
    }

    /**
     * Output only. Number of billable tokens in the tuning dataset.
     *
     * Generated from protobuf field <code>int64 total_billable_token_count = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int|string
     */
    public function getTotalBillableTokenCount()
    {
        return $this->total_billable_token_count;
    }

    /**
     * Output only. Number of billable tokens in the tuning dataset.
     *
     * Generated from protobuf field <code>int64 total_billable_token_count = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int|string $var
     * @return $this
     */
    public function setTotalBillableTokenCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->total_billable_token_count = $var;

        return $this;
    }

    /**
     * Output only. Number of tuning steps for this Tuning Job.
     *
     * Generated from protobuf field <code>int64 tuning_step_count = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int|string
     */
    public function getTuningStepCount()
    {
        return $this->tuning_step_count;
    }

    /**
     * Output only. Number of tuning steps for this Tuning Job.
     *
     * Generated from protobuf field <code>int64 tuning_step_count = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int|string $var
     * @return $this
     */
    public function setTuningStepCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->tuning_step_count = $var;

        return $this;
    }

    /**
     * Output only. Dataset distributions for the user input tokens.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.SupervisedTuningDatasetDistribution user_input_token_distribution = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\AIPlatform\V1\SupervisedTuningDatasetDistribution|null
     */
    public function getUserInputTokenDistribution()
    {
        return $this->user_input_token_distribution;
    }

    public function hasUserInputTokenDistribution()
    {
        return isset($this->user_input_token_distribution);
    }

    public function clearUserInputTokenDistribution()
    {
        unset($this->user_input_token_distribution);
    }

    /**
     * Output only. Dataset distributions for the user input tokens.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.SupervisedTuningDatasetDistribution user_input_token_distribution = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\AIPlatform\V1\SupervisedTuningDatasetDistribution $var
     * @return $this
     */
    public function setUserInputTokenDistribution($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\SupervisedTuningDatasetDistribution::class);
        $this->user_input_token_distribution = $var;

        return $this;
    }

    /**
     * Output only. Dataset distributions for the user output tokens.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.SupervisedTuningDatasetDistribution user_output_token_distribution = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\AIPlatform\V1\SupervisedTuningDatasetDistribution|null
     */
    public function getUserOutputTokenDistribution()
    {
        return $this->user_output_token_distribution;
    }

    public function hasUserOutputTokenDistribution()
    {
        return isset($this->user_output_token_distribution);
    }

    public function clearUserOutputTokenDistribution()
    {
        unset($this->user_output_token_distribution);
    }

    /**
     * Output only. Dataset distributions for the user output tokens.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.SupervisedTuningDatasetDistribution user_output_token_distribution = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\AIPlatform\V1\SupervisedTuningDatasetDistribution $var
     * @return $this
     */
    public function setUserOutputTokenDistribution($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\SupervisedTuningDatasetDistribution::class);
        $this->user_output_token_distribution = $var;

        return $this;
    }

    /**
     * Output only. Dataset distributions for the messages per example.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.SupervisedTuningDatasetDistribution user_message_per_example_distribution = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\AIPlatform\V1\SupervisedTuningDatasetDistribution|null
     */
    public function getUserMessagePerExampleDistribution()
    {
        return $this->user_message_per_example_distribution;
    }

    public function hasUserMessagePerExampleDistribution()
    {
        return isset($this->user_message_per_example_distribution);
    }

    public function clearUserMessagePerExampleDistribution()
    {
        unset($this->user_message_per_example_distribution);
    }

    /**
     * Output only. Dataset distributions for the messages per example.
     *
     * Generated from protobuf field <code>.google.cloud.aiplatform.v1.SupervisedTuningDatasetDistribution user_message_per_example_distribution = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\AIPlatform\V1\SupervisedTuningDatasetDistribution $var
     * @return $this
     */
    public function setUserMessagePerExampleDistribution($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AIPlatform\V1\SupervisedTuningDatasetDistribution::class);
        $this->user_message_per_example_distribution = $var;

        return $this;
    }

    /**
     * Output only. Sample user messages in the training dataset uri.
     *
     * Generated from protobuf field <code>repeated .google.cloud.aiplatform.v1.Content user_dataset_examples = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getUserDatasetExamples()
    {
        return $this->user_dataset_examples;
    }

    /**
     * Output only. Sample user messages in the training dataset uri.
     *
     * Generated from protobuf field <code>repeated .google.cloud.aiplatform.v1.Content user_dataset_examples = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param array<\Google\Cloud\AIPlatform\V1\Content>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setUserDatasetExamples($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\AIPlatform\V1\Content::class);
        $this->user_dataset_examples = $arr;

        return $this;
    }

    /**
     * The number of examples in the dataset that have been truncated by any
     * amount.
     *
     * Generated from protobuf field <code>int64 total_truncated_example_count = 10;</code>
     * @return int|string
     */
    public function getTotalTruncatedExampleCount()
    {
        return $this->total_truncated_example_count;
    }

    /**
     * The number of examples in the dataset that have been truncated by any
     * amount.
     *
     * Generated from protobuf field <code>int64 total_truncated_example_count = 10;</code>
     * @param int|string $var
     * @return $this
     */
    public function setTotalTruncatedExampleCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->total_truncated_example_count = $var;

        return $this;
    }

    /**
     * A partial sample of the indices (starting from 1) of the truncated
     * examples.
     *
     * Generated from protobuf field <code>repeated int64 truncated_example_indices = 11;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getTruncatedExampleIndices()
    {
        return $this->truncated_example_indices;
    }

    /**
     * A partial sample of the indices (starting from 1) of the truncated
     * examples.
     *
     * Generated from protobuf field <code>repeated int64 truncated_example_indices = 11;</code>
     * @param array<int>|array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setTruncatedExampleIndices($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::INT64);
        $this->truncated_example_indices = $arr;

        return $this;
    }

}

