<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/aiplatform/v1/index_service.proto

namespace Google\Cloud\AIPlatform\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [IndexService.UpsertDatapoints][google.cloud.aiplatform.v1.IndexService.UpsertDatapoints]
 *
 * Generated from protobuf message <code>google.cloud.aiplatform.v1.UpsertDatapointsRequest</code>
 */
class UpsertDatapointsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the Index resource to be updated.
     * Format:
     * `projects/{project}/locations/{location}/indexes/{index}`
     *
     * Generated from protobuf field <code>string index = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $index = '';
    /**
     * A list of datapoints to be created/updated.
     *
     * Generated from protobuf field <code>repeated .google.cloud.aiplatform.v1.IndexDatapoint datapoints = 2;</code>
     */
    private $datapoints;
    /**
     * Optional. Update mask is used to specify the fields to be overwritten in
     * the datapoints by the update. The fields specified in the update_mask are
     * relative to each IndexDatapoint inside datapoints, not the full request.
     * Updatable fields:
     *   * Use `all_restricts` to update both restricts and numeric_restricts.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $update_mask = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $index
     *           Required. The name of the Index resource to be updated.
     *           Format:
     *           `projects/{project}/locations/{location}/indexes/{index}`
     *     @type array<\Google\Cloud\AIPlatform\V1\IndexDatapoint>|\Google\Protobuf\Internal\RepeatedField $datapoints
     *           A list of datapoints to be created/updated.
     *     @type \Google\Protobuf\FieldMask $update_mask
     *           Optional. Update mask is used to specify the fields to be overwritten in
     *           the datapoints by the update. The fields specified in the update_mask are
     *           relative to each IndexDatapoint inside datapoints, not the full request.
     *           Updatable fields:
     *             * Use `all_restricts` to update both restricts and numeric_restricts.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Aiplatform\V1\IndexService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the Index resource to be updated.
     * Format:
     * `projects/{project}/locations/{location}/indexes/{index}`
     *
     * Generated from protobuf field <code>string index = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getIndex()
    {
        return $this->index;
    }

    /**
     * Required. The name of the Index resource to be updated.
     * Format:
     * `projects/{project}/locations/{location}/indexes/{index}`
     *
     * Generated from protobuf field <code>string index = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setIndex($var)
    {
        GPBUtil::checkString($var, True);
        $this->index = $var;

        return $this;
    }

    /**
     * A list of datapoints to be created/updated.
     *
     * Generated from protobuf field <code>repeated .google.cloud.aiplatform.v1.IndexDatapoint datapoints = 2;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getDatapoints()
    {
        return $this->datapoints;
    }

    /**
     * A list of datapoints to be created/updated.
     *
     * Generated from protobuf field <code>repeated .google.cloud.aiplatform.v1.IndexDatapoint datapoints = 2;</code>
     * @param array<\Google\Cloud\AIPlatform\V1\IndexDatapoint>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setDatapoints($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\AIPlatform\V1\IndexDatapoint::class);
        $this->datapoints = $arr;

        return $this;
    }

    /**
     * Optional. Update mask is used to specify the fields to be overwritten in
     * the datapoints by the update. The fields specified in the update_mask are
     * relative to each IndexDatapoint inside datapoints, not the full request.
     * Updatable fields:
     *   * Use `all_restricts` to update both restricts and numeric_restricts.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\FieldMask|null
     */
    public function getUpdateMask()
    {
        return $this->update_mask;
    }

    public function hasUpdateMask()
    {
        return isset($this->update_mask);
    }

    public function clearUpdateMask()
    {
        unset($this->update_mask);
    }

    /**
     * Optional. Update mask is used to specify the fields to be overwritten in
     * the datapoints by the update. The fields specified in the update_mask are
     * relative to each IndexDatapoint inside datapoints, not the full request.
     * Updatable fields:
     *   * Use `all_restricts` to update both restricts and numeric_restricts.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Protobuf\FieldMask $var
     * @return $this
     */
    public function setUpdateMask($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\FieldMask::class);
        $this->update_mask = $var;

        return $this;
    }

}

