<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/alloydb/v1/resources.proto

namespace Google\Cloud\AlloyDb\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message describing Backup object
 *
 * Generated from protobuf message <code>google.cloud.alloydb.v1.Backup</code>
 */
class Backup extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The name of the backup resource with the format:
     *  * projects/{project}/locations/{region}/backups/{backup_id}
     * where the cluster and backup ID segments should satisfy the regex
     * expression `[a-z]([a-z0-9-]{0,61}[a-z0-9])?`, e.g. 1-63 characters of
     * lowercase letters, numbers, and dashes, starting with a letter, and ending
     * with a letter or number. For more details see https://google.aip.dev/122.
     * The prefix of the backup resource name is the name of the parent
     * resource:
     *  * projects/{project}/locations/{region}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $name = '';
    /**
     * User-settable and human-readable display name for the Backup.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     */
    protected $display_name = '';
    /**
     * Output only. The system-generated UID of the resource. The UID is assigned
     * when the resource is created, and it is retained until it is deleted.
     *
     * Generated from protobuf field <code>string uid = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $uid = '';
    /**
     * Output only. Create time stamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. Update time stamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Output only. Delete time stamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp delete_time = 15 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $delete_time = null;
    /**
     * Labels as key value pairs
     *
     * Generated from protobuf field <code>map<string, string> labels = 6;</code>
     */
    private $labels;
    /**
     * Output only. The current state of the backup.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1.Backup.State state = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;
    /**
     * The backup type, which suggests the trigger for the backup.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1.Backup.Type type = 8;</code>
     */
    protected $type = 0;
    /**
     * User-provided description of the backup.
     *
     * Generated from protobuf field <code>string description = 9;</code>
     */
    protected $description = '';
    /**
     * Output only. The system-generated UID of the cluster which was used to
     * create this resource.
     *
     * Generated from protobuf field <code>string cluster_uid = 18 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $cluster_uid = '';
    /**
     * Required. The full resource name of the backup source cluster
     * (e.g., projects/{project}/locations/{region}/clusters/{cluster_id}).
     *
     * Generated from protobuf field <code>string cluster_name = 10 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $cluster_name = '';
    /**
     * Output only. Reconciling (https://google.aip.dev/128#reconciliation), if
     * true, indicates that the service is actively updating the resource. This
     * can happen due to user-triggered updates or system actions like failover or
     * maintenance.
     *
     * Generated from protobuf field <code>bool reconciling = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $reconciling = false;
    /**
     * Optional. The encryption config can be specified to encrypt the
     * backup with a customer-managed encryption key (CMEK). When this field is
     * not specified, the backup will then use default encryption scheme to
     * protect the user data.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1.EncryptionConfig encryption_config = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $encryption_config = null;
    /**
     * Output only. The encryption information for the backup.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1.EncryptionInfo encryption_info = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $encryption_info = null;
    /**
     * For Resource freshness validation (https://google.aip.dev/154)
     *
     * Generated from protobuf field <code>string etag = 14;</code>
     */
    protected $etag = '';
    /**
     * Annotations to allow client tools to store small amount of arbitrary data.
     * This is distinct from labels.
     * https://google.aip.dev/128
     *
     * Generated from protobuf field <code>map<string, string> annotations = 16;</code>
     */
    private $annotations;
    /**
     * Output only. The size of the backup in bytes.
     *
     * Generated from protobuf field <code>int64 size_bytes = 17 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $size_bytes = 0;
    /**
     * Output only. The time at which after the backup is eligible to be garbage
     * collected. It is the duration specified by the backup's retention policy,
     * added to the backup's create_time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp expiry_time = 19 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $expiry_time = null;
    /**
     * Output only. The QuantityBasedExpiry of the backup, specified by the
     * backup's retention policy. Once the expiry quantity is over retention, the
     * backup is eligible to be garbage collected.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1.Backup.QuantityBasedExpiry expiry_quantity = 20 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $expiry_quantity = null;
    /**
     * Output only. The database engine major version of the cluster this backup
     * was created from. Any restored cluster created from this backup will have
     * the same database version.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1.DatabaseVersion database_version = 22 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $database_version = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. The name of the backup resource with the format:
     *            * projects/{project}/locations/{region}/backups/{backup_id}
     *           where the cluster and backup ID segments should satisfy the regex
     *           expression `[a-z]([a-z0-9-]{0,61}[a-z0-9])?`, e.g. 1-63 characters of
     *           lowercase letters, numbers, and dashes, starting with a letter, and ending
     *           with a letter or number. For more details see https://google.aip.dev/122.
     *           The prefix of the backup resource name is the name of the parent
     *           resource:
     *            * projects/{project}/locations/{region}
     *     @type string $display_name
     *           User-settable and human-readable display name for the Backup.
     *     @type string $uid
     *           Output only. The system-generated UID of the resource. The UID is assigned
     *           when the resource is created, and it is retained until it is deleted.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. Create time stamp
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. Update time stamp
     *     @type \Google\Protobuf\Timestamp $delete_time
     *           Output only. Delete time stamp
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Labels as key value pairs
     *     @type int $state
     *           Output only. The current state of the backup.
     *     @type int $type
     *           The backup type, which suggests the trigger for the backup.
     *     @type string $description
     *           User-provided description of the backup.
     *     @type string $cluster_uid
     *           Output only. The system-generated UID of the cluster which was used to
     *           create this resource.
     *     @type string $cluster_name
     *           Required. The full resource name of the backup source cluster
     *           (e.g., projects/{project}/locations/{region}/clusters/{cluster_id}).
     *     @type bool $reconciling
     *           Output only. Reconciling (https://google.aip.dev/128#reconciliation), if
     *           true, indicates that the service is actively updating the resource. This
     *           can happen due to user-triggered updates or system actions like failover or
     *           maintenance.
     *     @type \Google\Cloud\AlloyDb\V1\EncryptionConfig $encryption_config
     *           Optional. The encryption config can be specified to encrypt the
     *           backup with a customer-managed encryption key (CMEK). When this field is
     *           not specified, the backup will then use default encryption scheme to
     *           protect the user data.
     *     @type \Google\Cloud\AlloyDb\V1\EncryptionInfo $encryption_info
     *           Output only. The encryption information for the backup.
     *     @type string $etag
     *           For Resource freshness validation (https://google.aip.dev/154)
     *     @type array|\Google\Protobuf\Internal\MapField $annotations
     *           Annotations to allow client tools to store small amount of arbitrary data.
     *           This is distinct from labels.
     *           https://google.aip.dev/128
     *     @type int|string $size_bytes
     *           Output only. The size of the backup in bytes.
     *     @type \Google\Protobuf\Timestamp $expiry_time
     *           Output only. The time at which after the backup is eligible to be garbage
     *           collected. It is the duration specified by the backup's retention policy,
     *           added to the backup's create_time.
     *     @type \Google\Cloud\AlloyDb\V1\Backup\QuantityBasedExpiry $expiry_quantity
     *           Output only. The QuantityBasedExpiry of the backup, specified by the
     *           backup's retention policy. Once the expiry quantity is over retention, the
     *           backup is eligible to be garbage collected.
     *     @type int $database_version
     *           Output only. The database engine major version of the cluster this backup
     *           was created from. Any restored cluster created from this backup will have
     *           the same database version.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Alloydb\V1\Resources::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The name of the backup resource with the format:
     *  * projects/{project}/locations/{region}/backups/{backup_id}
     * where the cluster and backup ID segments should satisfy the regex
     * expression `[a-z]([a-z0-9-]{0,61}[a-z0-9])?`, e.g. 1-63 characters of
     * lowercase letters, numbers, and dashes, starting with a letter, and ending
     * with a letter or number. For more details see https://google.aip.dev/122.
     * The prefix of the backup resource name is the name of the parent
     * resource:
     *  * projects/{project}/locations/{region}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. The name of the backup resource with the format:
     *  * projects/{project}/locations/{region}/backups/{backup_id}
     * where the cluster and backup ID segments should satisfy the regex
     * expression `[a-z]([a-z0-9-]{0,61}[a-z0-9])?`, e.g. 1-63 characters of
     * lowercase letters, numbers, and dashes, starting with a letter, and ending
     * with a letter or number. For more details see https://google.aip.dev/122.
     * The prefix of the backup resource name is the name of the parent
     * resource:
     *  * projects/{project}/locations/{region}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * User-settable and human-readable display name for the Backup.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * User-settable and human-readable display name for the Backup.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * Output only. The system-generated UID of the resource. The UID is assigned
     * when the resource is created, and it is retained until it is deleted.
     *
     * Generated from protobuf field <code>string uid = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getUid()
    {
        return $this->uid;
    }

    /**
     * Output only. The system-generated UID of the resource. The UID is assigned
     * when the resource is created, and it is retained until it is deleted.
     *
     * Generated from protobuf field <code>string uid = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setUid($var)
    {
        GPBUtil::checkString($var, True);
        $this->uid = $var;

        return $this;
    }

    /**
     * Output only. Create time stamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. Create time stamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. Update time stamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. Update time stamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Output only. Delete time stamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp delete_time = 15 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getDeleteTime()
    {
        return $this->delete_time;
    }

    public function hasDeleteTime()
    {
        return isset($this->delete_time);
    }

    public function clearDeleteTime()
    {
        unset($this->delete_time);
    }

    /**
     * Output only. Delete time stamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp delete_time = 15 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setDeleteTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->delete_time = $var;

        return $this;
    }

    /**
     * Labels as key value pairs
     *
     * Generated from protobuf field <code>map<string, string> labels = 6;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Labels as key value pairs
     *
     * Generated from protobuf field <code>map<string, string> labels = 6;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * Output only. The current state of the backup.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1.Backup.State state = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. The current state of the backup.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1.Backup.State state = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\AlloyDb\V1\Backup\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * The backup type, which suggests the trigger for the backup.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1.Backup.Type type = 8;</code>
     * @return int
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * The backup type, which suggests the trigger for the backup.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1.Backup.Type type = 8;</code>
     * @param int $var
     * @return $this
     */
    public function setType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\AlloyDb\V1\Backup\Type::class);
        $this->type = $var;

        return $this;
    }

    /**
     * User-provided description of the backup.
     *
     * Generated from protobuf field <code>string description = 9;</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * User-provided description of the backup.
     *
     * Generated from protobuf field <code>string description = 9;</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Output only. The system-generated UID of the cluster which was used to
     * create this resource.
     *
     * Generated from protobuf field <code>string cluster_uid = 18 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getClusterUid()
    {
        return $this->cluster_uid;
    }

    /**
     * Output only. The system-generated UID of the cluster which was used to
     * create this resource.
     *
     * Generated from protobuf field <code>string cluster_uid = 18 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setClusterUid($var)
    {
        GPBUtil::checkString($var, True);
        $this->cluster_uid = $var;

        return $this;
    }

    /**
     * Required. The full resource name of the backup source cluster
     * (e.g., projects/{project}/locations/{region}/clusters/{cluster_id}).
     *
     * Generated from protobuf field <code>string cluster_name = 10 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getClusterName()
    {
        return $this->cluster_name;
    }

    /**
     * Required. The full resource name of the backup source cluster
     * (e.g., projects/{project}/locations/{region}/clusters/{cluster_id}).
     *
     * Generated from protobuf field <code>string cluster_name = 10 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setClusterName($var)
    {
        GPBUtil::checkString($var, True);
        $this->cluster_name = $var;

        return $this;
    }

    /**
     * Output only. Reconciling (https://google.aip.dev/128#reconciliation), if
     * true, indicates that the service is actively updating the resource. This
     * can happen due to user-triggered updates or system actions like failover or
     * maintenance.
     *
     * Generated from protobuf field <code>bool reconciling = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return bool
     */
    public function getReconciling()
    {
        return $this->reconciling;
    }

    /**
     * Output only. Reconciling (https://google.aip.dev/128#reconciliation), if
     * true, indicates that the service is actively updating the resource. This
     * can happen due to user-triggered updates or system actions like failover or
     * maintenance.
     *
     * Generated from protobuf field <code>bool reconciling = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param bool $var
     * @return $this
     */
    public function setReconciling($var)
    {
        GPBUtil::checkBool($var);
        $this->reconciling = $var;

        return $this;
    }

    /**
     * Optional. The encryption config can be specified to encrypt the
     * backup with a customer-managed encryption key (CMEK). When this field is
     * not specified, the backup will then use default encryption scheme to
     * protect the user data.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1.EncryptionConfig encryption_config = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\AlloyDb\V1\EncryptionConfig|null
     */
    public function getEncryptionConfig()
    {
        return $this->encryption_config;
    }

    public function hasEncryptionConfig()
    {
        return isset($this->encryption_config);
    }

    public function clearEncryptionConfig()
    {
        unset($this->encryption_config);
    }

    /**
     * Optional. The encryption config can be specified to encrypt the
     * backup with a customer-managed encryption key (CMEK). When this field is
     * not specified, the backup will then use default encryption scheme to
     * protect the user data.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1.EncryptionConfig encryption_config = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\AlloyDb\V1\EncryptionConfig $var
     * @return $this
     */
    public function setEncryptionConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AlloyDb\V1\EncryptionConfig::class);
        $this->encryption_config = $var;

        return $this;
    }

    /**
     * Output only. The encryption information for the backup.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1.EncryptionInfo encryption_info = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\AlloyDb\V1\EncryptionInfo|null
     */
    public function getEncryptionInfo()
    {
        return $this->encryption_info;
    }

    public function hasEncryptionInfo()
    {
        return isset($this->encryption_info);
    }

    public function clearEncryptionInfo()
    {
        unset($this->encryption_info);
    }

    /**
     * Output only. The encryption information for the backup.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1.EncryptionInfo encryption_info = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\AlloyDb\V1\EncryptionInfo $var
     * @return $this
     */
    public function setEncryptionInfo($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AlloyDb\V1\EncryptionInfo::class);
        $this->encryption_info = $var;

        return $this;
    }

    /**
     * For Resource freshness validation (https://google.aip.dev/154)
     *
     * Generated from protobuf field <code>string etag = 14;</code>
     * @return string
     */
    public function getEtag()
    {
        return $this->etag;
    }

    /**
     * For Resource freshness validation (https://google.aip.dev/154)
     *
     * Generated from protobuf field <code>string etag = 14;</code>
     * @param string $var
     * @return $this
     */
    public function setEtag($var)
    {
        GPBUtil::checkString($var, True);
        $this->etag = $var;

        return $this;
    }

    /**
     * Annotations to allow client tools to store small amount of arbitrary data.
     * This is distinct from labels.
     * https://google.aip.dev/128
     *
     * Generated from protobuf field <code>map<string, string> annotations = 16;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getAnnotations()
    {
        return $this->annotations;
    }

    /**
     * Annotations to allow client tools to store small amount of arbitrary data.
     * This is distinct from labels.
     * https://google.aip.dev/128
     *
     * Generated from protobuf field <code>map<string, string> annotations = 16;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setAnnotations($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->annotations = $arr;

        return $this;
    }

    /**
     * Output only. The size of the backup in bytes.
     *
     * Generated from protobuf field <code>int64 size_bytes = 17 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int|string
     */
    public function getSizeBytes()
    {
        return $this->size_bytes;
    }

    /**
     * Output only. The size of the backup in bytes.
     *
     * Generated from protobuf field <code>int64 size_bytes = 17 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int|string $var
     * @return $this
     */
    public function setSizeBytes($var)
    {
        GPBUtil::checkInt64($var);
        $this->size_bytes = $var;

        return $this;
    }

    /**
     * Output only. The time at which after the backup is eligible to be garbage
     * collected. It is the duration specified by the backup's retention policy,
     * added to the backup's create_time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp expiry_time = 19 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getExpiryTime()
    {
        return $this->expiry_time;
    }

    public function hasExpiryTime()
    {
        return isset($this->expiry_time);
    }

    public function clearExpiryTime()
    {
        unset($this->expiry_time);
    }

    /**
     * Output only. The time at which after the backup is eligible to be garbage
     * collected. It is the duration specified by the backup's retention policy,
     * added to the backup's create_time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp expiry_time = 19 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setExpiryTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->expiry_time = $var;

        return $this;
    }

    /**
     * Output only. The QuantityBasedExpiry of the backup, specified by the
     * backup's retention policy. Once the expiry quantity is over retention, the
     * backup is eligible to be garbage collected.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1.Backup.QuantityBasedExpiry expiry_quantity = 20 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\AlloyDb\V1\Backup\QuantityBasedExpiry|null
     */
    public function getExpiryQuantity()
    {
        return $this->expiry_quantity;
    }

    public function hasExpiryQuantity()
    {
        return isset($this->expiry_quantity);
    }

    public function clearExpiryQuantity()
    {
        unset($this->expiry_quantity);
    }

    /**
     * Output only. The QuantityBasedExpiry of the backup, specified by the
     * backup's retention policy. Once the expiry quantity is over retention, the
     * backup is eligible to be garbage collected.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1.Backup.QuantityBasedExpiry expiry_quantity = 20 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\AlloyDb\V1\Backup\QuantityBasedExpiry $var
     * @return $this
     */
    public function setExpiryQuantity($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AlloyDb\V1\Backup\QuantityBasedExpiry::class);
        $this->expiry_quantity = $var;

        return $this;
    }

    /**
     * Output only. The database engine major version of the cluster this backup
     * was created from. Any restored cluster created from this backup will have
     * the same database version.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1.DatabaseVersion database_version = 22 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getDatabaseVersion()
    {
        return $this->database_version;
    }

    /**
     * Output only. The database engine major version of the cluster this backup
     * was created from. Any restored cluster created from this backup will have
     * the same database version.
     *
     * Generated from protobuf field <code>.google.cloud.alloydb.v1.DatabaseVersion database_version = 22 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setDatabaseVersion($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\AlloyDb\V1\DatabaseVersion::class);
        $this->database_version = $var;

        return $this;
    }

}

