<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/apihub/v1/common_fields.proto

namespace Google\Cloud\ApiHub\V1\Attribute;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The value that can be assigned to the attribute when the data type is
 * enum.
 *
 * Generated from protobuf message <code>google.cloud.apihub.v1.Attribute.AllowedValue</code>
 */
class AllowedValue extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The ID of the allowed value.
     * * If provided, the same will be used. The service will throw an error if
     * the specified id is already used by another allowed value in the same
     * attribute resource.
     * * If not provided, a system generated id derived from the display name
     * will be used. In this case, the service will handle conflict resolution
     * by adding a system generated suffix in case of duplicates.
     * This value should be 4-63 characters, and valid characters
     * are /[a-z][0-9]-/.
     *
     * Generated from protobuf field <code>string id = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $id = '';
    /**
     * Required. The display name of the allowed value.
     *
     * Generated from protobuf field <code>string display_name = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $display_name = '';
    /**
     * Optional. The detailed description of the allowed value.
     *
     * Generated from protobuf field <code>string description = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $description = '';
    /**
     * Optional. When set to true, the allowed value cannot be updated or
     * deleted by the user. It can only be true for System defined attributes.
     *
     * Generated from protobuf field <code>bool immutable = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $immutable = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $id
     *           Required. The ID of the allowed value.
     *           * If provided, the same will be used. The service will throw an error if
     *           the specified id is already used by another allowed value in the same
     *           attribute resource.
     *           * If not provided, a system generated id derived from the display name
     *           will be used. In this case, the service will handle conflict resolution
     *           by adding a system generated suffix in case of duplicates.
     *           This value should be 4-63 characters, and valid characters
     *           are /[a-z][0-9]-/.
     *     @type string $display_name
     *           Required. The display name of the allowed value.
     *     @type string $description
     *           Optional. The detailed description of the allowed value.
     *     @type bool $immutable
     *           Optional. When set to true, the allowed value cannot be updated or
     *           deleted by the user. It can only be true for System defined attributes.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Apihub\V1\CommonFields::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The ID of the allowed value.
     * * If provided, the same will be used. The service will throw an error if
     * the specified id is already used by another allowed value in the same
     * attribute resource.
     * * If not provided, a system generated id derived from the display name
     * will be used. In this case, the service will handle conflict resolution
     * by adding a system generated suffix in case of duplicates.
     * This value should be 4-63 characters, and valid characters
     * are /[a-z][0-9]-/.
     *
     * Generated from protobuf field <code>string id = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Required. The ID of the allowed value.
     * * If provided, the same will be used. The service will throw an error if
     * the specified id is already used by another allowed value in the same
     * attribute resource.
     * * If not provided, a system generated id derived from the display name
     * will be used. In this case, the service will handle conflict resolution
     * by adding a system generated suffix in case of duplicates.
     * This value should be 4-63 characters, and valid characters
     * are /[a-z][0-9]-/.
     *
     * Generated from protobuf field <code>string id = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setId($var)
    {
        GPBUtil::checkString($var, True);
        $this->id = $var;

        return $this;
    }

    /**
     * Required. The display name of the allowed value.
     *
     * Generated from protobuf field <code>string display_name = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * Required. The display name of the allowed value.
     *
     * Generated from protobuf field <code>string display_name = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * Optional. The detailed description of the allowed value.
     *
     * Generated from protobuf field <code>string description = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Optional. The detailed description of the allowed value.
     *
     * Generated from protobuf field <code>string description = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Optional. When set to true, the allowed value cannot be updated or
     * deleted by the user. It can only be true for System defined attributes.
     *
     * Generated from protobuf field <code>bool immutable = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getImmutable()
    {
        return $this->immutable;
    }

    /**
     * Optional. When set to true, the allowed value cannot be updated or
     * deleted by the user. It can only be true for System defined attributes.
     *
     * Generated from protobuf field <code>bool immutable = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setImmutable($var)
    {
        GPBUtil::checkBool($var);
        $this->immutable = $var;

        return $this;
    }

}


