<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/apihub/v1/provisioning_service.proto

namespace Google\Cloud\ApiHub\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The
 * [CreateApiHubInstance][google.cloud.apihub.v1.Provisioning.CreateApiHubInstance]
 * method's request.
 *
 * Generated from protobuf message <code>google.cloud.apihub.v1.CreateApiHubInstanceRequest</code>
 */
class CreateApiHubInstanceRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent resource for the Api Hub instance resource.
     * Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. Identifier to assign to the Api Hub instance. Must be unique
     * within scope of the parent resource. If the field is not provided, system
     * generated id will be used.
     * This value should be 4-40 characters, and valid characters
     * are `/[a-z][A-Z][0-9]-_/`.
     *
     * Generated from protobuf field <code>string api_hub_instance_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $api_hub_instance_id = '';
    /**
     * Required. The ApiHub instance.
     *
     * Generated from protobuf field <code>.google.cloud.apihub.v1.ApiHubInstance api_hub_instance = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $api_hub_instance = null;

    /**
     * @param string                                 $parent           Required. The parent resource for the Api Hub instance resource.
     *                                                                 Format: `projects/{project}/locations/{location}`
     *                                                                 Please see {@see ProvisioningClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\ApiHub\V1\ApiHubInstance $apiHubInstance   Required. The ApiHub instance.
     * @param string                                 $apiHubInstanceId Optional. Identifier to assign to the Api Hub instance. Must be unique
     *                                                                 within scope of the parent resource. If the field is not provided, system
     *                                                                 generated id will be used.
     *
     *                                                                 This value should be 4-40 characters, and valid characters
     *                                                                 are `/[a-z][A-Z][0-9]-_/`.
     *
     * @return \Google\Cloud\ApiHub\V1\CreateApiHubInstanceRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\ApiHub\V1\ApiHubInstance $apiHubInstance, string $apiHubInstanceId): self
    {
        return (new self())
            ->setParent($parent)
            ->setApiHubInstance($apiHubInstance)
            ->setApiHubInstanceId($apiHubInstanceId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent resource for the Api Hub instance resource.
     *           Format: `projects/{project}/locations/{location}`
     *     @type string $api_hub_instance_id
     *           Optional. Identifier to assign to the Api Hub instance. Must be unique
     *           within scope of the parent resource. If the field is not provided, system
     *           generated id will be used.
     *           This value should be 4-40 characters, and valid characters
     *           are `/[a-z][A-Z][0-9]-_/`.
     *     @type \Google\Cloud\ApiHub\V1\ApiHubInstance $api_hub_instance
     *           Required. The ApiHub instance.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Apihub\V1\ProvisioningService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent resource for the Api Hub instance resource.
     * Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent resource for the Api Hub instance resource.
     * Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. Identifier to assign to the Api Hub instance. Must be unique
     * within scope of the parent resource. If the field is not provided, system
     * generated id will be used.
     * This value should be 4-40 characters, and valid characters
     * are `/[a-z][A-Z][0-9]-_/`.
     *
     * Generated from protobuf field <code>string api_hub_instance_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getApiHubInstanceId()
    {
        return $this->api_hub_instance_id;
    }

    /**
     * Optional. Identifier to assign to the Api Hub instance. Must be unique
     * within scope of the parent resource. If the field is not provided, system
     * generated id will be used.
     * This value should be 4-40 characters, and valid characters
     * are `/[a-z][A-Z][0-9]-_/`.
     *
     * Generated from protobuf field <code>string api_hub_instance_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setApiHubInstanceId($var)
    {
        GPBUtil::checkString($var, True);
        $this->api_hub_instance_id = $var;

        return $this;
    }

    /**
     * Required. The ApiHub instance.
     *
     * Generated from protobuf field <code>.google.cloud.apihub.v1.ApiHubInstance api_hub_instance = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\ApiHub\V1\ApiHubInstance|null
     */
    public function getApiHubInstance()
    {
        return $this->api_hub_instance;
    }

    public function hasApiHubInstance()
    {
        return isset($this->api_hub_instance);
    }

    public function clearApiHubInstance()
    {
        unset($this->api_hub_instance);
    }

    /**
     * Required. The ApiHub instance.
     *
     * Generated from protobuf field <code>.google.cloud.apihub.v1.ApiHubInstance api_hub_instance = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\ApiHub\V1\ApiHubInstance $var
     * @return $this
     */
    public function setApiHubInstance($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ApiHub\V1\ApiHubInstance::class);
        $this->api_hub_instance = $var;

        return $this;
    }

}

