<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/apihub/v1/apihub_service.proto

namespace Google\Cloud\ApiHub\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The [CreateApi][google.cloud.apihub.v1.ApiHub.CreateApi] method's request.
 *
 * Generated from protobuf message <code>google.cloud.apihub.v1.CreateApiRequest</code>
 */
class CreateApiRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent resource for the API resource.
     * Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. The ID to use for the API resource, which will become the final
     * component of the API's resource name. This field is optional.
     * * If provided, the same will be used. The service will throw an error if
     * the specified id is already used by another API resource in the API hub.
     * * If not provided, a system generated id will be used.
     * This value should be 4-500 characters, and valid characters
     * are /[a-z][A-Z][0-9]-_/.
     *
     * Generated from protobuf field <code>string api_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $api_id = '';
    /**
     * Required. The API resource to create.
     *
     * Generated from protobuf field <code>.google.cloud.apihub.v1.Api api = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $api = null;

    /**
     * @param string                      $parent Required. The parent resource for the API resource.
     *                                            Format: `projects/{project}/locations/{location}`
     *                                            Please see {@see ApiHubClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\ApiHub\V1\Api $api    Required. The API resource to create.
     * @param string                      $apiId  Optional. The ID to use for the API resource, which will become the final
     *                                            component of the API's resource name. This field is optional.
     *
     *                                            * If provided, the same will be used. The service will throw an error if
     *                                            the specified id is already used by another API resource in the API hub.
     *                                            * If not provided, a system generated id will be used.
     *
     *                                            This value should be 4-500 characters, and valid characters
     *                                            are /[a-z][A-Z][0-9]-_/.
     *
     * @return \Google\Cloud\ApiHub\V1\CreateApiRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\ApiHub\V1\Api $api, string $apiId): self
    {
        return (new self())
            ->setParent($parent)
            ->setApi($api)
            ->setApiId($apiId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent resource for the API resource.
     *           Format: `projects/{project}/locations/{location}`
     *     @type string $api_id
     *           Optional. The ID to use for the API resource, which will become the final
     *           component of the API's resource name. This field is optional.
     *           * If provided, the same will be used. The service will throw an error if
     *           the specified id is already used by another API resource in the API hub.
     *           * If not provided, a system generated id will be used.
     *           This value should be 4-500 characters, and valid characters
     *           are /[a-z][A-Z][0-9]-_/.
     *     @type \Google\Cloud\ApiHub\V1\Api $api
     *           Required. The API resource to create.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Apihub\V1\ApihubService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent resource for the API resource.
     * Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent resource for the API resource.
     * Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. The ID to use for the API resource, which will become the final
     * component of the API's resource name. This field is optional.
     * * If provided, the same will be used. The service will throw an error if
     * the specified id is already used by another API resource in the API hub.
     * * If not provided, a system generated id will be used.
     * This value should be 4-500 characters, and valid characters
     * are /[a-z][A-Z][0-9]-_/.
     *
     * Generated from protobuf field <code>string api_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getApiId()
    {
        return $this->api_id;
    }

    /**
     * Optional. The ID to use for the API resource, which will become the final
     * component of the API's resource name. This field is optional.
     * * If provided, the same will be used. The service will throw an error if
     * the specified id is already used by another API resource in the API hub.
     * * If not provided, a system generated id will be used.
     * This value should be 4-500 characters, and valid characters
     * are /[a-z][A-Z][0-9]-_/.
     *
     * Generated from protobuf field <code>string api_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setApiId($var)
    {
        GPBUtil::checkString($var, True);
        $this->api_id = $var;

        return $this;
    }

    /**
     * Required. The API resource to create.
     *
     * Generated from protobuf field <code>.google.cloud.apihub.v1.Api api = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\ApiHub\V1\Api|null
     */
    public function getApi()
    {
        return $this->api;
    }

    public function hasApi()
    {
        return isset($this->api);
    }

    public function clearApi()
    {
        unset($this->api);
    }

    /**
     * Required. The API resource to create.
     *
     * Generated from protobuf field <code>.google.cloud.apihub.v1.Api api = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\ApiHub\V1\Api $var
     * @return $this
     */
    public function setApi($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ApiHub\V1\Api::class);
        $this->api = $var;

        return $this;
    }

}

