<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/apihub/v1/apihub_service.proto

namespace Google\Cloud\ApiHub\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The
 * [CreateDependency][google.cloud.apihub.v1.ApiHubDependencies.CreateDependency]
 * method's request.
 *
 * Generated from protobuf message <code>google.cloud.apihub.v1.CreateDependencyRequest</code>
 */
class CreateDependencyRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent resource for the dependency resource.
     * Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. The ID to use for the dependency resource, which will become the
     * final component of the dependency's resource name. This field is optional.
     * * If provided, the same will be used. The service will throw an error if
     * duplicate id is provided by the client.
     * * If not provided, a system generated id will be used.
     * This value should be 4-500 characters, and valid characters
     * are `[a-z][A-Z][0-9]-_`.
     *
     * Generated from protobuf field <code>string dependency_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $dependency_id = '';
    /**
     * Required. The dependency resource to create.
     *
     * Generated from protobuf field <code>.google.cloud.apihub.v1.Dependency dependency = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $dependency = null;

    /**
     * @param string                             $parent       Required. The parent resource for the dependency resource.
     *                                                         Format: `projects/{project}/locations/{location}`
     *                                                         Please see {@see ApiHubDependenciesClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\ApiHub\V1\Dependency $dependency   Required. The dependency resource to create.
     * @param string                             $dependencyId Optional. The ID to use for the dependency resource, which will become the
     *                                                         final component of the dependency's resource name. This field is optional.
     *                                                         * If provided, the same will be used. The service will throw an error if
     *                                                         duplicate id is provided by the client.
     *                                                         * If not provided, a system generated id will be used.
     *
     *                                                         This value should be 4-500 characters, and valid characters
     *                                                         are `[a-z][A-Z][0-9]-_`.
     *
     * @return \Google\Cloud\ApiHub\V1\CreateDependencyRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\ApiHub\V1\Dependency $dependency, string $dependencyId): self
    {
        return (new self())
            ->setParent($parent)
            ->setDependency($dependency)
            ->setDependencyId($dependencyId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent resource for the dependency resource.
     *           Format: `projects/{project}/locations/{location}`
     *     @type string $dependency_id
     *           Optional. The ID to use for the dependency resource, which will become the
     *           final component of the dependency's resource name. This field is optional.
     *           * If provided, the same will be used. The service will throw an error if
     *           duplicate id is provided by the client.
     *           * If not provided, a system generated id will be used.
     *           This value should be 4-500 characters, and valid characters
     *           are `[a-z][A-Z][0-9]-_`.
     *     @type \Google\Cloud\ApiHub\V1\Dependency $dependency
     *           Required. The dependency resource to create.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Apihub\V1\ApihubService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent resource for the dependency resource.
     * Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent resource for the dependency resource.
     * Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. The ID to use for the dependency resource, which will become the
     * final component of the dependency's resource name. This field is optional.
     * * If provided, the same will be used. The service will throw an error if
     * duplicate id is provided by the client.
     * * If not provided, a system generated id will be used.
     * This value should be 4-500 characters, and valid characters
     * are `[a-z][A-Z][0-9]-_`.
     *
     * Generated from protobuf field <code>string dependency_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDependencyId()
    {
        return $this->dependency_id;
    }

    /**
     * Optional. The ID to use for the dependency resource, which will become the
     * final component of the dependency's resource name. This field is optional.
     * * If provided, the same will be used. The service will throw an error if
     * duplicate id is provided by the client.
     * * If not provided, a system generated id will be used.
     * This value should be 4-500 characters, and valid characters
     * are `[a-z][A-Z][0-9]-_`.
     *
     * Generated from protobuf field <code>string dependency_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDependencyId($var)
    {
        GPBUtil::checkString($var, True);
        $this->dependency_id = $var;

        return $this;
    }

    /**
     * Required. The dependency resource to create.
     *
     * Generated from protobuf field <code>.google.cloud.apihub.v1.Dependency dependency = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\ApiHub\V1\Dependency|null
     */
    public function getDependency()
    {
        return $this->dependency;
    }

    public function hasDependency()
    {
        return isset($this->dependency);
    }

    public function clearDependency()
    {
        unset($this->dependency);
    }

    /**
     * Required. The dependency resource to create.
     *
     * Generated from protobuf field <code>.google.cloud.apihub.v1.Dependency dependency = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\ApiHub\V1\Dependency $var
     * @return $this
     */
    public function setDependency($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ApiHub\V1\Dependency::class);
        $this->dependency = $var;

        return $this;
    }

}

