<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/apihub/v1/apihub_service.proto

namespace Google\Cloud\ApiHub\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The [CreateExternalApi][google.cloud.apihub.v1.ApiHub.CreateExternalApi]
 * method's request.
 *
 * Generated from protobuf message <code>google.cloud.apihub.v1.CreateExternalApiRequest</code>
 */
class CreateExternalApiRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent resource for the External API resource.
     * Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. The ID to use for the External API resource, which will become
     * the final component of the External API's resource name. This field is
     * optional.
     * * If provided, the same will be used. The service will throw an error if
     * the specified id is already used by another External API resource in the
     * API hub.
     * * If not provided, a system generated id will be used.
     * This value should be 4-500 characters, and valid characters
     * are /[a-z][A-Z][0-9]-_/.
     *
     * Generated from protobuf field <code>string external_api_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $external_api_id = '';
    /**
     * Required. The External API resource to create.
     *
     * Generated from protobuf field <code>.google.cloud.apihub.v1.ExternalApi external_api = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $external_api = null;

    /**
     * @param string                              $parent        Required. The parent resource for the External API resource.
     *                                                           Format: `projects/{project}/locations/{location}`
     *                                                           Please see {@see ApiHubClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\ApiHub\V1\ExternalApi $externalApi   Required. The External API resource to create.
     * @param string                              $externalApiId Optional. The ID to use for the External API resource, which will become
     *                                                           the final component of the External API's resource name. This field is
     *                                                           optional.
     *
     *                                                           * If provided, the same will be used. The service will throw an error if
     *                                                           the specified id is already used by another External API resource in the
     *                                                           API hub.
     *                                                           * If not provided, a system generated id will be used.
     *
     *                                                           This value should be 4-500 characters, and valid characters
     *                                                           are /[a-z][A-Z][0-9]-_/.
     *
     * @return \Google\Cloud\ApiHub\V1\CreateExternalApiRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\ApiHub\V1\ExternalApi $externalApi, string $externalApiId): self
    {
        return (new self())
            ->setParent($parent)
            ->setExternalApi($externalApi)
            ->setExternalApiId($externalApiId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent resource for the External API resource.
     *           Format: `projects/{project}/locations/{location}`
     *     @type string $external_api_id
     *           Optional. The ID to use for the External API resource, which will become
     *           the final component of the External API's resource name. This field is
     *           optional.
     *           * If provided, the same will be used. The service will throw an error if
     *           the specified id is already used by another External API resource in the
     *           API hub.
     *           * If not provided, a system generated id will be used.
     *           This value should be 4-500 characters, and valid characters
     *           are /[a-z][A-Z][0-9]-_/.
     *     @type \Google\Cloud\ApiHub\V1\ExternalApi $external_api
     *           Required. The External API resource to create.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Apihub\V1\ApihubService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent resource for the External API resource.
     * Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent resource for the External API resource.
     * Format: `projects/{project}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. The ID to use for the External API resource, which will become
     * the final component of the External API's resource name. This field is
     * optional.
     * * If provided, the same will be used. The service will throw an error if
     * the specified id is already used by another External API resource in the
     * API hub.
     * * If not provided, a system generated id will be used.
     * This value should be 4-500 characters, and valid characters
     * are /[a-z][A-Z][0-9]-_/.
     *
     * Generated from protobuf field <code>string external_api_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getExternalApiId()
    {
        return $this->external_api_id;
    }

    /**
     * Optional. The ID to use for the External API resource, which will become
     * the final component of the External API's resource name. This field is
     * optional.
     * * If provided, the same will be used. The service will throw an error if
     * the specified id is already used by another External API resource in the
     * API hub.
     * * If not provided, a system generated id will be used.
     * This value should be 4-500 characters, and valid characters
     * are /[a-z][A-Z][0-9]-_/.
     *
     * Generated from protobuf field <code>string external_api_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setExternalApiId($var)
    {
        GPBUtil::checkString($var, True);
        $this->external_api_id = $var;

        return $this;
    }

    /**
     * Required. The External API resource to create.
     *
     * Generated from protobuf field <code>.google.cloud.apihub.v1.ExternalApi external_api = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\ApiHub\V1\ExternalApi|null
     */
    public function getExternalApi()
    {
        return $this->external_api;
    }

    public function hasExternalApi()
    {
        return isset($this->external_api);
    }

    public function clearExternalApi()
    {
        unset($this->external_api);
    }

    /**
     * Required. The External API resource to create.
     *
     * Generated from protobuf field <code>.google.cloud.apihub.v1.ExternalApi external_api = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\ApiHub\V1\ExternalApi $var
     * @return $this
     */
    public function setExternalApi($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ApiHub\V1\ExternalApi::class);
        $this->external_api = $var;

        return $this;
    }

}

