<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/apihub/v1/apihub_service.proto

namespace Google\Cloud\ApiHub\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The [CreateVersion][google.cloud.apihub.v1.ApiHub.CreateVersion] method's
 * request.
 *
 * Generated from protobuf message <code>google.cloud.apihub.v1.CreateVersionRequest</code>
 */
class CreateVersionRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent resource for API version.
     * Format: `projects/{project}/locations/{location}/apis/{api}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. The ID to use for the API version, which will become the final
     * component of the version's resource name. This field is optional.
     * * If provided, the same will be used. The service will throw an error if
     * the specified id is already used by another version in the API resource.
     * * If not provided, a system generated id will be used.
     * This value should be 4-500 characters, and valid characters
     * are /[a-z][A-Z][0-9]-_/.
     *
     * Generated from protobuf field <code>string version_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $version_id = '';
    /**
     * Required. The version to create.
     *
     * Generated from protobuf field <code>.google.cloud.apihub.v1.Version version = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $version = null;

    /**
     * @param string                          $parent    Required. The parent resource for API version.
     *                                                   Format: `projects/{project}/locations/{location}/apis/{api}`
     *                                                   Please see {@see ApiHubClient::apiName()} for help formatting this field.
     * @param \Google\Cloud\ApiHub\V1\Version $version   Required. The version to create.
     * @param string                          $versionId Optional. The ID to use for the API version, which will become the final
     *                                                   component of the version's resource name. This field is optional.
     *
     *                                                   * If provided, the same will be used. The service will throw an error if
     *                                                   the specified id is already used by another version in the API resource.
     *                                                   * If not provided, a system generated id will be used.
     *
     *                                                   This value should be 4-500 characters, and valid characters
     *                                                   are /[a-z][A-Z][0-9]-_/.
     *
     * @return \Google\Cloud\ApiHub\V1\CreateVersionRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\ApiHub\V1\Version $version, string $versionId): self
    {
        return (new self())
            ->setParent($parent)
            ->setVersion($version)
            ->setVersionId($versionId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent resource for API version.
     *           Format: `projects/{project}/locations/{location}/apis/{api}`
     *     @type string $version_id
     *           Optional. The ID to use for the API version, which will become the final
     *           component of the version's resource name. This field is optional.
     *           * If provided, the same will be used. The service will throw an error if
     *           the specified id is already used by another version in the API resource.
     *           * If not provided, a system generated id will be used.
     *           This value should be 4-500 characters, and valid characters
     *           are /[a-z][A-Z][0-9]-_/.
     *     @type \Google\Cloud\ApiHub\V1\Version $version
     *           Required. The version to create.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Apihub\V1\ApihubService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent resource for API version.
     * Format: `projects/{project}/locations/{location}/apis/{api}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent resource for API version.
     * Format: `projects/{project}/locations/{location}/apis/{api}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. The ID to use for the API version, which will become the final
     * component of the version's resource name. This field is optional.
     * * If provided, the same will be used. The service will throw an error if
     * the specified id is already used by another version in the API resource.
     * * If not provided, a system generated id will be used.
     * This value should be 4-500 characters, and valid characters
     * are /[a-z][A-Z][0-9]-_/.
     *
     * Generated from protobuf field <code>string version_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getVersionId()
    {
        return $this->version_id;
    }

    /**
     * Optional. The ID to use for the API version, which will become the final
     * component of the version's resource name. This field is optional.
     * * If provided, the same will be used. The service will throw an error if
     * the specified id is already used by another version in the API resource.
     * * If not provided, a system generated id will be used.
     * This value should be 4-500 characters, and valid characters
     * are /[a-z][A-Z][0-9]-_/.
     *
     * Generated from protobuf field <code>string version_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setVersionId($var)
    {
        GPBUtil::checkString($var, True);
        $this->version_id = $var;

        return $this;
    }

    /**
     * Required. The version to create.
     *
     * Generated from protobuf field <code>.google.cloud.apihub.v1.Version version = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\ApiHub\V1\Version|null
     */
    public function getVersion()
    {
        return $this->version;
    }

    public function hasVersion()
    {
        return isset($this->version);
    }

    public function clearVersion()
    {
        unset($this->version);
    }

    /**
     * Required. The version to create.
     *
     * Generated from protobuf field <code>.google.cloud.apihub.v1.Version version = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\ApiHub\V1\Version $var
     * @return $this
     */
    public function setVersion($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ApiHub\V1\Version::class);
        $this->version = $var;

        return $this;
    }

}

