<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/apihub/v1/host_project_registration_service.proto

namespace Google\Cloud\ApiHub\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The
 * [ListHostProjectRegistrations][google.cloud.apihub.v1.HostProjectRegistrationService.ListHostProjectRegistrations]
 * method's request.
 *
 * Generated from protobuf message <code>google.cloud.apihub.v1.ListHostProjectRegistrationsRequest</code>
 */
class ListHostProjectRegistrationsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent, which owns this collection of host projects.
     * Format: `projects/&#42;&#47;locations/&#42;`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. The maximum number of host project registrations to return. The
     * service may return fewer than this value. If unspecified, at most 50 host
     * project registrations will be returned. The maximum value is 1000; values
     * above 1000 will be coerced to 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. A page token, received from a previous
     * `ListHostProjectRegistrations` call. Provide this to retrieve the
     * subsequent page.
     * When paginating, all other parameters (except page_size) provided to
     * `ListHostProjectRegistrations` must match the call that provided the page
     * token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';
    /**
     * Optional. An expression that filters the list of HostProjectRegistrations.
     * A filter expression consists of a field name, a comparison
     * operator, and a value for filtering. The value must be a string. All
     * standard operators as documented at https://google.aip.dev/160 are
     * supported.
     * The following fields in the `HostProjectRegistration` are eligible for
     * filtering:
     *   * `name` - The name of the HostProjectRegistration.
     *   * `create_time` - The time at which the HostProjectRegistration was
     *   created. The value should be in the
     *   (RFC3339)[https://tools.ietf.org/html/rfc3339] format.
     *   * `gcp_project` - The Google cloud project associated with the
     *   HostProjectRegistration.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $filter = '';
    /**
     * Optional. Hint for how to order the results.
     *
     * Generated from protobuf field <code>string order_by = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $order_by = '';

    /**
     * @param string $parent Required. The parent, which owns this collection of host projects.
     *                       Format: `projects/&#42;/locations/*`
     *                       Please see {@see HostProjectRegistrationServiceClient::locationName()} for help formatting this field.
     *
     * @return \Google\Cloud\ApiHub\V1\ListHostProjectRegistrationsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent, which owns this collection of host projects.
     *           Format: `projects/&#42;&#47;locations/&#42;`
     *     @type int $page_size
     *           Optional. The maximum number of host project registrations to return. The
     *           service may return fewer than this value. If unspecified, at most 50 host
     *           project registrations will be returned. The maximum value is 1000; values
     *           above 1000 will be coerced to 1000.
     *     @type string $page_token
     *           Optional. A page token, received from a previous
     *           `ListHostProjectRegistrations` call. Provide this to retrieve the
     *           subsequent page.
     *           When paginating, all other parameters (except page_size) provided to
     *           `ListHostProjectRegistrations` must match the call that provided the page
     *           token.
     *     @type string $filter
     *           Optional. An expression that filters the list of HostProjectRegistrations.
     *           A filter expression consists of a field name, a comparison
     *           operator, and a value for filtering. The value must be a string. All
     *           standard operators as documented at https://google.aip.dev/160 are
     *           supported.
     *           The following fields in the `HostProjectRegistration` are eligible for
     *           filtering:
     *             * `name` - The name of the HostProjectRegistration.
     *             * `create_time` - The time at which the HostProjectRegistration was
     *             created. The value should be in the
     *             (RFC3339)[https://tools.ietf.org/html/rfc3339] format.
     *             * `gcp_project` - The Google cloud project associated with the
     *             HostProjectRegistration.
     *     @type string $order_by
     *           Optional. Hint for how to order the results.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Apihub\V1\HostProjectRegistrationService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent, which owns this collection of host projects.
     * Format: `projects/&#42;&#47;locations/&#42;`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent, which owns this collection of host projects.
     * Format: `projects/&#42;&#47;locations/&#42;`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. The maximum number of host project registrations to return. The
     * service may return fewer than this value. If unspecified, at most 50 host
     * project registrations will be returned. The maximum value is 1000; values
     * above 1000 will be coerced to 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. The maximum number of host project registrations to return. The
     * service may return fewer than this value. If unspecified, at most 50 host
     * project registrations will be returned. The maximum value is 1000; values
     * above 1000 will be coerced to 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. A page token, received from a previous
     * `ListHostProjectRegistrations` call. Provide this to retrieve the
     * subsequent page.
     * When paginating, all other parameters (except page_size) provided to
     * `ListHostProjectRegistrations` must match the call that provided the page
     * token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. A page token, received from a previous
     * `ListHostProjectRegistrations` call. Provide this to retrieve the
     * subsequent page.
     * When paginating, all other parameters (except page_size) provided to
     * `ListHostProjectRegistrations` must match the call that provided the page
     * token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. An expression that filters the list of HostProjectRegistrations.
     * A filter expression consists of a field name, a comparison
     * operator, and a value for filtering. The value must be a string. All
     * standard operators as documented at https://google.aip.dev/160 are
     * supported.
     * The following fields in the `HostProjectRegistration` are eligible for
     * filtering:
     *   * `name` - The name of the HostProjectRegistration.
     *   * `create_time` - The time at which the HostProjectRegistration was
     *   created. The value should be in the
     *   (RFC3339)[https://tools.ietf.org/html/rfc3339] format.
     *   * `gcp_project` - The Google cloud project associated with the
     *   HostProjectRegistration.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Optional. An expression that filters the list of HostProjectRegistrations.
     * A filter expression consists of a field name, a comparison
     * operator, and a value for filtering. The value must be a string. All
     * standard operators as documented at https://google.aip.dev/160 are
     * supported.
     * The following fields in the `HostProjectRegistration` are eligible for
     * filtering:
     *   * `name` - The name of the HostProjectRegistration.
     *   * `create_time` - The time at which the HostProjectRegistration was
     *   created. The value should be in the
     *   (RFC3339)[https://tools.ietf.org/html/rfc3339] format.
     *   * `gcp_project` - The Google cloud project associated with the
     *   HostProjectRegistration.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * Optional. Hint for how to order the results.
     *
     * Generated from protobuf field <code>string order_by = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getOrderBy()
    {
        return $this->order_by;
    }

    /**
     * Optional. Hint for how to order the results.
     *
     * Generated from protobuf field <code>string order_by = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setOrderBy($var)
    {
        GPBUtil::checkString($var, True);
        $this->order_by = $var;

        return $this;
    }

}

