<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/apigeeregistry/v1/registry_service.proto

namespace Google\Cloud\ApigeeRegistry\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for CreateApiSpec.
 *
 * Generated from protobuf message <code>google.cloud.apigeeregistry.v1.CreateApiSpecRequest</code>
 */
class CreateApiSpecRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent, which owns this collection of specs.
     * Format: `projects/&#42;&#47;locations/&#42;&#47;apis/&#42;&#47;versions/&#42;`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The spec to create.
     *
     * Generated from protobuf field <code>.google.cloud.apigeeregistry.v1.ApiSpec api_spec = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $api_spec = null;
    /**
     * Required. The ID to use for the spec, which will become the final component of
     * the spec's resource name.
     * This value should be 4-63 characters, and valid characters
     * are /[a-z][0-9]-/.
     * Following AIP-162, IDs must not have the form of a UUID.
     *
     * Generated from protobuf field <code>string api_spec_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $api_spec_id = '';

    /**
     * @param string                                  $parent    Required. The parent, which owns this collection of specs.
     *                                                           Format: `projects/&#42;/locations/&#42;/apis/&#42;/versions/*`
     *                                                           Please see {@see RegistryClient::apiVersionName()} for help formatting this field.
     * @param \Google\Cloud\ApigeeRegistry\V1\ApiSpec $apiSpec   Required. The spec to create.
     * @param string                                  $apiSpecId Required. The ID to use for the spec, which will become the final component of
     *                                                           the spec's resource name.
     *
     *                                                           This value should be 4-63 characters, and valid characters
     *                                                           are /[a-z][0-9]-/.
     *
     *                                                           Following AIP-162, IDs must not have the form of a UUID.
     *
     * @return \Google\Cloud\ApigeeRegistry\V1\CreateApiSpecRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\ApigeeRegistry\V1\ApiSpec $apiSpec, string $apiSpecId): self
    {
        return (new self())
            ->setParent($parent)
            ->setApiSpec($apiSpec)
            ->setApiSpecId($apiSpecId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent, which owns this collection of specs.
     *           Format: `projects/&#42;&#47;locations/&#42;&#47;apis/&#42;&#47;versions/&#42;`
     *     @type \Google\Cloud\ApigeeRegistry\V1\ApiSpec $api_spec
     *           Required. The spec to create.
     *     @type string $api_spec_id
     *           Required. The ID to use for the spec, which will become the final component of
     *           the spec's resource name.
     *           This value should be 4-63 characters, and valid characters
     *           are /[a-z][0-9]-/.
     *           Following AIP-162, IDs must not have the form of a UUID.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Apigeeregistry\V1\RegistryService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent, which owns this collection of specs.
     * Format: `projects/&#42;&#47;locations/&#42;&#47;apis/&#42;&#47;versions/&#42;`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent, which owns this collection of specs.
     * Format: `projects/&#42;&#47;locations/&#42;&#47;apis/&#42;&#47;versions/&#42;`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The spec to create.
     *
     * Generated from protobuf field <code>.google.cloud.apigeeregistry.v1.ApiSpec api_spec = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\ApigeeRegistry\V1\ApiSpec|null
     */
    public function getApiSpec()
    {
        return $this->api_spec;
    }

    public function hasApiSpec()
    {
        return isset($this->api_spec);
    }

    public function clearApiSpec()
    {
        unset($this->api_spec);
    }

    /**
     * Required. The spec to create.
     *
     * Generated from protobuf field <code>.google.cloud.apigeeregistry.v1.ApiSpec api_spec = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\ApigeeRegistry\V1\ApiSpec $var
     * @return $this
     */
    public function setApiSpec($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ApigeeRegistry\V1\ApiSpec::class);
        $this->api_spec = $var;

        return $this;
    }

    /**
     * Required. The ID to use for the spec, which will become the final component of
     * the spec's resource name.
     * This value should be 4-63 characters, and valid characters
     * are /[a-z][0-9]-/.
     * Following AIP-162, IDs must not have the form of a UUID.
     *
     * Generated from protobuf field <code>string api_spec_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getApiSpecId()
    {
        return $this->api_spec_id;
    }

    /**
     * Required. The ID to use for the spec, which will become the final component of
     * the spec's resource name.
     * This value should be 4-63 characters, and valid characters
     * are /[a-z][0-9]-/.
     * Following AIP-162, IDs must not have the form of a UUID.
     *
     * Generated from protobuf field <code>string api_spec_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setApiSpecId($var)
    {
        GPBUtil::checkString($var, True);
        $this->api_spec_id = $var;

        return $this;
    }

}

