<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/apigeeregistry/v1/registry_service.proto

namespace Google\Cloud\ApigeeRegistry\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for ListApis.
 *
 * Generated from protobuf message <code>google.cloud.apigeeregistry.v1.ListApisRequest</code>
 */
class ListApisRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent, which owns this collection of APIs.
     * Format: `projects/&#42;&#47;locations/&#42;`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * The maximum number of APIs to return.
     * The service may return fewer than this value.
     * If unspecified, at most 50 values will be returned.
     * The maximum is 1000; values above 1000 will be coerced to 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     */
    protected $page_size = 0;
    /**
     * A page token, received from a previous `ListApis` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListApis` must match
     * the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     */
    protected $page_token = '';
    /**
     * An expression that can be used to filter the list. Filters use the Common
     * Expression Language and can refer to all message fields.
     *
     * Generated from protobuf field <code>string filter = 4;</code>
     */
    protected $filter = '';

    /**
     * @param string $parent Required. The parent, which owns this collection of APIs.
     *                       Format: `projects/&#42;/locations/*`
     *                       Please see {@see RegistryClient::locationName()} for help formatting this field.
     *
     * @return \Google\Cloud\ApigeeRegistry\V1\ListApisRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent, which owns this collection of APIs.
     *           Format: `projects/&#42;&#47;locations/&#42;`
     *     @type int $page_size
     *           The maximum number of APIs to return.
     *           The service may return fewer than this value.
     *           If unspecified, at most 50 values will be returned.
     *           The maximum is 1000; values above 1000 will be coerced to 1000.
     *     @type string $page_token
     *           A page token, received from a previous `ListApis` call.
     *           Provide this to retrieve the subsequent page.
     *           When paginating, all other parameters provided to `ListApis` must match
     *           the call that provided the page token.
     *     @type string $filter
     *           An expression that can be used to filter the list. Filters use the Common
     *           Expression Language and can refer to all message fields.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Apigeeregistry\V1\RegistryService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent, which owns this collection of APIs.
     * Format: `projects/&#42;&#47;locations/&#42;`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent, which owns this collection of APIs.
     * Format: `projects/&#42;&#47;locations/&#42;`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * The maximum number of APIs to return.
     * The service may return fewer than this value.
     * If unspecified, at most 50 values will be returned.
     * The maximum is 1000; values above 1000 will be coerced to 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The maximum number of APIs to return.
     * The service may return fewer than this value.
     * If unspecified, at most 50 values will be returned.
     * The maximum is 1000; values above 1000 will be coerced to 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * A page token, received from a previous `ListApis` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListApis` must match
     * the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * A page token, received from a previous `ListApis` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListApis` must match
     * the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * An expression that can be used to filter the list. Filters use the Common
     * Expression Language and can refer to all message fields.
     *
     * Generated from protobuf field <code>string filter = 4;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * An expression that can be used to filter the list. Filters use the Common
     * Expression Language and can refer to all message fields.
     *
     * Generated from protobuf field <code>string filter = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

}

