<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/apphub/v1/application.proto

namespace Google\Cloud\AppHub\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Application defines the governance boundary for App Hub Entities that
 * perform a logical end-to-end business function.
 * App Hub supports application level IAM permission to align with governance
 * requirements.
 *
 * Generated from protobuf message <code>google.cloud.apphub.v1.Application</code>
 */
class Application extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. The resource name of an Application. Format:
     * "projects/{host-project-id}/locations/{location}/applications/{application-id}"
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Optional. User-defined name for the Application.
     * Can have a maximum length of 63 characters.
     *
     * Generated from protobuf field <code>string display_name = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $display_name = '';
    /**
     * Optional. User-defined description of an Application.
     * Can have a maximum length of 2048 characters.
     *
     * Generated from protobuf field <code>string description = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $description = '';
    /**
     * Optional. Consumer provided attributes.
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.Attributes attributes = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $attributes = null;
    /**
     * Output only. Create time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. Update time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Required. Immutable. Defines what data can be included into this
     * Application. Limits which Services and Workloads can be registered.
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.Scope scope = 9 [(.google.api.field_behavior) = REQUIRED, (.google.api.field_behavior) = IMMUTABLE];</code>
     */
    protected $scope = null;
    /**
     * Output only. A universally unique identifier (in UUID4 format) for the
     * `Application`.
     *
     * Generated from protobuf field <code>string uid = 10 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_info) = {</code>
     */
    protected $uid = '';
    /**
     * Output only. Application state.
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.Application.State state = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. The resource name of an Application. Format:
     *           "projects/{host-project-id}/locations/{location}/applications/{application-id}"
     *     @type string $display_name
     *           Optional. User-defined name for the Application.
     *           Can have a maximum length of 63 characters.
     *     @type string $description
     *           Optional. User-defined description of an Application.
     *           Can have a maximum length of 2048 characters.
     *     @type \Google\Cloud\AppHub\V1\Attributes $attributes
     *           Optional. Consumer provided attributes.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. Create time.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. Update time.
     *     @type \Google\Cloud\AppHub\V1\Scope $scope
     *           Required. Immutable. Defines what data can be included into this
     *           Application. Limits which Services and Workloads can be registered.
     *     @type string $uid
     *           Output only. A universally unique identifier (in UUID4 format) for the
     *           `Application`.
     *     @type int $state
     *           Output only. Application state.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Apphub\V1\Application::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. The resource name of an Application. Format:
     * "projects/{host-project-id}/locations/{location}/applications/{application-id}"
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. The resource name of an Application. Format:
     * "projects/{host-project-id}/locations/{location}/applications/{application-id}"
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Optional. User-defined name for the Application.
     * Can have a maximum length of 63 characters.
     *
     * Generated from protobuf field <code>string display_name = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * Optional. User-defined name for the Application.
     * Can have a maximum length of 63 characters.
     *
     * Generated from protobuf field <code>string display_name = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * Optional. User-defined description of an Application.
     * Can have a maximum length of 2048 characters.
     *
     * Generated from protobuf field <code>string description = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Optional. User-defined description of an Application.
     * Can have a maximum length of 2048 characters.
     *
     * Generated from protobuf field <code>string description = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Optional. Consumer provided attributes.
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.Attributes attributes = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\AppHub\V1\Attributes|null
     */
    public function getAttributes()
    {
        return $this->attributes;
    }

    public function hasAttributes()
    {
        return isset($this->attributes);
    }

    public function clearAttributes()
    {
        unset($this->attributes);
    }

    /**
     * Optional. Consumer provided attributes.
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.Attributes attributes = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\AppHub\V1\Attributes $var
     * @return $this
     */
    public function setAttributes($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AppHub\V1\Attributes::class);
        $this->attributes = $var;

        return $this;
    }

    /**
     * Output only. Create time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. Create time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. Update time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. Update time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Required. Immutable. Defines what data can be included into this
     * Application. Limits which Services and Workloads can be registered.
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.Scope scope = 9 [(.google.api.field_behavior) = REQUIRED, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @return \Google\Cloud\AppHub\V1\Scope|null
     */
    public function getScope()
    {
        return $this->scope;
    }

    public function hasScope()
    {
        return isset($this->scope);
    }

    public function clearScope()
    {
        unset($this->scope);
    }

    /**
     * Required. Immutable. Defines what data can be included into this
     * Application. Limits which Services and Workloads can be registered.
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.Scope scope = 9 [(.google.api.field_behavior) = REQUIRED, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @param \Google\Cloud\AppHub\V1\Scope $var
     * @return $this
     */
    public function setScope($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AppHub\V1\Scope::class);
        $this->scope = $var;

        return $this;
    }

    /**
     * Output only. A universally unique identifier (in UUID4 format) for the
     * `Application`.
     *
     * Generated from protobuf field <code>string uid = 10 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_info) = {</code>
     * @return string
     */
    public function getUid()
    {
        return $this->uid;
    }

    /**
     * Output only. A universally unique identifier (in UUID4 format) for the
     * `Application`.
     *
     * Generated from protobuf field <code>string uid = 10 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_info) = {</code>
     * @param string $var
     * @return $this
     */
    public function setUid($var)
    {
        GPBUtil::checkString($var, True);
        $this->uid = $var;

        return $this;
    }

    /**
     * Output only. Application state.
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.Application.State state = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. Application state.
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.Application.State state = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\AppHub\V1\Application\State::class);
        $this->state = $var;

        return $this;
    }

}

