<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/apphub/v1/apphub_service.proto

namespace Google\Cloud\AppHub\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request for CreateApplication.
 *
 * Generated from protobuf message <code>google.cloud.apphub.v1.CreateApplicationRequest</code>
 */
class CreateApplicationRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Project and location to create Application in.
     * Expected format: `projects/{project}/locations/{location}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The Application identifier.
     * Must contain only lowercase letters, numbers
     * or hyphens, with the first character a letter, the last a letter or a
     * number, and a 63 character maximum.
     *
     * Generated from protobuf field <code>string application_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $application_id = '';
    /**
     * Required. The resource being created
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.Application application = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $application = null;
    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $request_id = '';

    /**
     * @param string                              $parent        Required. Project and location to create Application in.
     *                                                           Expected format: `projects/{project}/locations/{location}`. Please see
     *                                                           {@see AppHubClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\AppHub\V1\Application $application   Required. The resource being created
     * @param string                              $applicationId Required. The Application identifier.
     *                                                           Must contain only lowercase letters, numbers
     *                                                           or hyphens, with the first character a letter, the last a letter or a
     *                                                           number, and a 63 character maximum.
     *
     * @return \Google\Cloud\AppHub\V1\CreateApplicationRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\AppHub\V1\Application $application, string $applicationId): self
    {
        return (new self())
            ->setParent($parent)
            ->setApplication($application)
            ->setApplicationId($applicationId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Project and location to create Application in.
     *           Expected format: `projects/{project}/locations/{location}`.
     *     @type string $application_id
     *           Required. The Application identifier.
     *           Must contain only lowercase letters, numbers
     *           or hyphens, with the first character a letter, the last a letter or a
     *           number, and a 63 character maximum.
     *     @type \Google\Cloud\AppHub\V1\Application $application
     *           Required. The resource being created
     *     @type string $request_id
     *           Optional. An optional request ID to identify requests. Specify a unique
     *           request ID so that if you must retry your request, the server will know to
     *           ignore the request if it has already been completed. The server will
     *           guarantee that for at least 60 minutes since the first request.
     *           For example, consider a situation where you make an initial request and the
     *           request times out. If you make the request again with the same request
     *           ID, the server can check if original operation with the same request ID
     *           was received, and if so, will ignore the second request. This prevents
     *           clients from accidentally creating duplicate commitments.
     *           The request ID must be a valid UUID with the exception that zero UUID is
     *           not supported (00000000-0000-0000-0000-000000000000).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Apphub\V1\ApphubService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Project and location to create Application in.
     * Expected format: `projects/{project}/locations/{location}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Project and location to create Application in.
     * Expected format: `projects/{project}/locations/{location}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The Application identifier.
     * Must contain only lowercase letters, numbers
     * or hyphens, with the first character a letter, the last a letter or a
     * number, and a 63 character maximum.
     *
     * Generated from protobuf field <code>string application_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getApplicationId()
    {
        return $this->application_id;
    }

    /**
     * Required. The Application identifier.
     * Must contain only lowercase letters, numbers
     * or hyphens, with the first character a letter, the last a letter or a
     * number, and a 63 character maximum.
     *
     * Generated from protobuf field <code>string application_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setApplicationId($var)
    {
        GPBUtil::checkString($var, True);
        $this->application_id = $var;

        return $this;
    }

    /**
     * Required. The resource being created
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.Application application = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\AppHub\V1\Application|null
     */
    public function getApplication()
    {
        return $this->application;
    }

    public function hasApplication()
    {
        return isset($this->application);
    }

    public function clearApplication()
    {
        unset($this->application);
    }

    /**
     * Required. The resource being created
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.Application application = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\AppHub\V1\Application $var
     * @return $this
     */
    public function setApplication($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AppHub\V1\Application::class);
        $this->application = $var;

        return $this;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getRequestId()
    {
        return $this->request_id;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setRequestId($var)
    {
        GPBUtil::checkString($var, True);
        $this->request_id = $var;

        return $this;
    }

}

