<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/apphub/v1/apphub_service.proto

namespace Google\Cloud\AppHub\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request for CreateWorkload.
 *
 * Generated from protobuf message <code>google.cloud.apphub.v1.CreateWorkloadRequest</code>
 */
class CreateWorkloadRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Fully qualified name of the Application to create Workload in.
     * Expected format:
     * `projects/{project}/locations/{location}/applications/{application}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The Workload identifier.
     * Must contain only lowercase letters, numbers
     * or hyphens, with the first character a letter, the last a letter or a
     * number, and a 63 character maximum.
     *
     * Generated from protobuf field <code>string workload_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $workload_id = '';
    /**
     * Required. The resource being created.
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.Workload workload = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $workload = null;
    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $request_id = '';

    /**
     * @param string                           $parent     Required. Fully qualified name of the Application to create Workload in.
     *                                                     Expected format:
     *                                                     `projects/{project}/locations/{location}/applications/{application}`. Please see
     *                                                     {@see AppHubClient::applicationName()} for help formatting this field.
     * @param \Google\Cloud\AppHub\V1\Workload $workload   Required. The resource being created.
     * @param string                           $workloadId Required. The Workload identifier.
     *                                                     Must contain only lowercase letters, numbers
     *                                                     or hyphens, with the first character a letter, the last a letter or a
     *                                                     number, and a 63 character maximum.
     *
     * @return \Google\Cloud\AppHub\V1\CreateWorkloadRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\AppHub\V1\Workload $workload, string $workloadId): self
    {
        return (new self())
            ->setParent($parent)
            ->setWorkload($workload)
            ->setWorkloadId($workloadId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Fully qualified name of the Application to create Workload in.
     *           Expected format:
     *           `projects/{project}/locations/{location}/applications/{application}`.
     *     @type string $workload_id
     *           Required. The Workload identifier.
     *           Must contain only lowercase letters, numbers
     *           or hyphens, with the first character a letter, the last a letter or a
     *           number, and a 63 character maximum.
     *     @type \Google\Cloud\AppHub\V1\Workload $workload
     *           Required. The resource being created.
     *     @type string $request_id
     *           Optional. An optional request ID to identify requests. Specify a unique
     *           request ID so that if you must retry your request, the server will know to
     *           ignore the request if it has already been completed. The server will
     *           guarantee that for at least 60 minutes since the first request.
     *           For example, consider a situation where you make an initial request and the
     *           request times out. If you make the request again with the same request
     *           ID, the server can check if original operation with the same request ID
     *           was received, and if so, will ignore the second request. This prevents
     *           clients from accidentally creating duplicate commitments.
     *           The request ID must be a valid UUID with the exception that zero UUID is
     *           not supported (00000000-0000-0000-0000-000000000000).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Apphub\V1\ApphubService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Fully qualified name of the Application to create Workload in.
     * Expected format:
     * `projects/{project}/locations/{location}/applications/{application}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Fully qualified name of the Application to create Workload in.
     * Expected format:
     * `projects/{project}/locations/{location}/applications/{application}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The Workload identifier.
     * Must contain only lowercase letters, numbers
     * or hyphens, with the first character a letter, the last a letter or a
     * number, and a 63 character maximum.
     *
     * Generated from protobuf field <code>string workload_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getWorkloadId()
    {
        return $this->workload_id;
    }

    /**
     * Required. The Workload identifier.
     * Must contain only lowercase letters, numbers
     * or hyphens, with the first character a letter, the last a letter or a
     * number, and a 63 character maximum.
     *
     * Generated from protobuf field <code>string workload_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setWorkloadId($var)
    {
        GPBUtil::checkString($var, True);
        $this->workload_id = $var;

        return $this;
    }

    /**
     * Required. The resource being created.
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.Workload workload = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\AppHub\V1\Workload|null
     */
    public function getWorkload()
    {
        return $this->workload;
    }

    public function hasWorkload()
    {
        return isset($this->workload);
    }

    public function clearWorkload()
    {
        unset($this->workload);
    }

    /**
     * Required. The resource being created.
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.Workload workload = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\AppHub\V1\Workload $var
     * @return $this
     */
    public function setWorkload($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AppHub\V1\Workload::class);
        $this->workload = $var;

        return $this;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getRequestId()
    {
        return $this->request_id;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setRequestId($var)
    {
        GPBUtil::checkString($var, True);
        $this->request_id = $var;

        return $this;
    }

}

