<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/apphub/v1/workload.proto

namespace Google\Cloud\AppHub\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * DiscoveredWorkload is a binary deployment (such as managed instance groups
 * (MIGs) and GKE deployments) that performs the smallest logical subset of
 * business functionality. A discovered workload can be registered to an App Hub
 * Workload.
 *
 * Generated from protobuf message <code>google.cloud.apphub.v1.DiscoveredWorkload</code>
 */
class DiscoveredWorkload extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. The resource name of the discovered workload. Format:
     * "projects/{host-project-id}/locations/{location}/discoveredWorkloads/{uuid}"
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Output only. Reference of an underlying compute resource represented by the
     * Workload. These are immutable.
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.WorkloadReference workload_reference = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $workload_reference = null;
    /**
     * Output only. Properties of an underlying compute resource represented by
     * the Workload. These are immutable.
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.WorkloadProperties workload_properties = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $workload_properties = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. The resource name of the discovered workload. Format:
     *           "projects/{host-project-id}/locations/{location}/discoveredWorkloads/{uuid}"
     *     @type \Google\Cloud\AppHub\V1\WorkloadReference $workload_reference
     *           Output only. Reference of an underlying compute resource represented by the
     *           Workload. These are immutable.
     *     @type \Google\Cloud\AppHub\V1\WorkloadProperties $workload_properties
     *           Output only. Properties of an underlying compute resource represented by
     *           the Workload. These are immutable.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Apphub\V1\Workload::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. The resource name of the discovered workload. Format:
     * "projects/{host-project-id}/locations/{location}/discoveredWorkloads/{uuid}"
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. The resource name of the discovered workload. Format:
     * "projects/{host-project-id}/locations/{location}/discoveredWorkloads/{uuid}"
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. Reference of an underlying compute resource represented by the
     * Workload. These are immutable.
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.WorkloadReference workload_reference = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\AppHub\V1\WorkloadReference|null
     */
    public function getWorkloadReference()
    {
        return $this->workload_reference;
    }

    public function hasWorkloadReference()
    {
        return isset($this->workload_reference);
    }

    public function clearWorkloadReference()
    {
        unset($this->workload_reference);
    }

    /**
     * Output only. Reference of an underlying compute resource represented by the
     * Workload. These are immutable.
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.WorkloadReference workload_reference = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\AppHub\V1\WorkloadReference $var
     * @return $this
     */
    public function setWorkloadReference($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AppHub\V1\WorkloadReference::class);
        $this->workload_reference = $var;

        return $this;
    }

    /**
     * Output only. Properties of an underlying compute resource represented by
     * the Workload. These are immutable.
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.WorkloadProperties workload_properties = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\AppHub\V1\WorkloadProperties|null
     */
    public function getWorkloadProperties()
    {
        return $this->workload_properties;
    }

    public function hasWorkloadProperties()
    {
        return isset($this->workload_properties);
    }

    public function clearWorkloadProperties()
    {
        unset($this->workload_properties);
    }

    /**
     * Output only. Properties of an underlying compute resource represented by
     * the Workload. These are immutable.
     *
     * Generated from protobuf field <code>.google.cloud.apphub.v1.WorkloadProperties workload_properties = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\AppHub\V1\WorkloadProperties $var
     * @return $this
     */
    public function setWorkloadProperties($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AppHub\V1\WorkloadProperties::class);
        $this->workload_properties = $var;

        return $this;
    }

}

