<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/apps/card/v1/card.proto

namespace Google\Apps\Card\V1\Card;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents a card header. For an example in Google Chat apps, see [Add a
 * header](https://developers.google.com/workspace/chat/design-components-card-dialog#add_a_header).
 * [Google Workspace Add-ons and Chat
 * apps](https://developers.google.com/workspace/extend):
 *
 * Generated from protobuf message <code>google.apps.card.v1.Card.CardHeader</code>
 */
class CardHeader extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The title of the card header.
     * The header has a fixed height: if both a
     * title and subtitle are specified, each takes up one line. If only the
     * title is specified, it takes up both lines.
     *
     * Generated from protobuf field <code>string title = 1;</code>
     */
    protected $title = '';
    /**
     * The subtitle of the card header. If specified, appears on its own line
     * below the `title`.
     *
     * Generated from protobuf field <code>string subtitle = 2;</code>
     */
    protected $subtitle = '';
    /**
     * The shape used to crop the image.
     * [Google Workspace Add-ons and Chat
     * apps](https://developers.google.com/workspace/extend):
     *
     * Generated from protobuf field <code>.google.apps.card.v1.Widget.ImageType image_type = 3;</code>
     */
    protected $image_type = 0;
    /**
     * The HTTPS URL of the image in the card header.
     *
     * Generated from protobuf field <code>string image_url = 4;</code>
     */
    protected $image_url = '';
    /**
     * The alternative text of this image that's used for accessibility.
     *
     * Generated from protobuf field <code>string image_alt_text = 5;</code>
     */
    protected $image_alt_text = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $title
     *           Required. The title of the card header.
     *           The header has a fixed height: if both a
     *           title and subtitle are specified, each takes up one line. If only the
     *           title is specified, it takes up both lines.
     *     @type string $subtitle
     *           The subtitle of the card header. If specified, appears on its own line
     *           below the `title`.
     *     @type int $image_type
     *           The shape used to crop the image.
     *           [Google Workspace Add-ons and Chat
     *           apps](https://developers.google.com/workspace/extend):
     *     @type string $image_url
     *           The HTTPS URL of the image in the card header.
     *     @type string $image_alt_text
     *           The alternative text of this image that's used for accessibility.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Apps\Card\V1\Card::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The title of the card header.
     * The header has a fixed height: if both a
     * title and subtitle are specified, each takes up one line. If only the
     * title is specified, it takes up both lines.
     *
     * Generated from protobuf field <code>string title = 1;</code>
     * @return string
     */
    public function getTitle()
    {
        return $this->title;
    }

    /**
     * Required. The title of the card header.
     * The header has a fixed height: if both a
     * title and subtitle are specified, each takes up one line. If only the
     * title is specified, it takes up both lines.
     *
     * Generated from protobuf field <code>string title = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setTitle($var)
    {
        GPBUtil::checkString($var, True);
        $this->title = $var;

        return $this;
    }

    /**
     * The subtitle of the card header. If specified, appears on its own line
     * below the `title`.
     *
     * Generated from protobuf field <code>string subtitle = 2;</code>
     * @return string
     */
    public function getSubtitle()
    {
        return $this->subtitle;
    }

    /**
     * The subtitle of the card header. If specified, appears on its own line
     * below the `title`.
     *
     * Generated from protobuf field <code>string subtitle = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setSubtitle($var)
    {
        GPBUtil::checkString($var, True);
        $this->subtitle = $var;

        return $this;
    }

    /**
     * The shape used to crop the image.
     * [Google Workspace Add-ons and Chat
     * apps](https://developers.google.com/workspace/extend):
     *
     * Generated from protobuf field <code>.google.apps.card.v1.Widget.ImageType image_type = 3;</code>
     * @return int
     */
    public function getImageType()
    {
        return $this->image_type;
    }

    /**
     * The shape used to crop the image.
     * [Google Workspace Add-ons and Chat
     * apps](https://developers.google.com/workspace/extend):
     *
     * Generated from protobuf field <code>.google.apps.card.v1.Widget.ImageType image_type = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setImageType($var)
    {
        GPBUtil::checkEnum($var, \Google\Apps\Card\V1\Widget\ImageType::class);
        $this->image_type = $var;

        return $this;
    }

    /**
     * The HTTPS URL of the image in the card header.
     *
     * Generated from protobuf field <code>string image_url = 4;</code>
     * @return string
     */
    public function getImageUrl()
    {
        return $this->image_url;
    }

    /**
     * The HTTPS URL of the image in the card header.
     *
     * Generated from protobuf field <code>string image_url = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setImageUrl($var)
    {
        GPBUtil::checkString($var, True);
        $this->image_url = $var;

        return $this;
    }

    /**
     * The alternative text of this image that's used for accessibility.
     *
     * Generated from protobuf field <code>string image_alt_text = 5;</code>
     * @return string
     */
    public function getImageAltText()
    {
        return $this->image_alt_text;
    }

    /**
     * The alternative text of this image that's used for accessibility.
     *
     * Generated from protobuf field <code>string image_alt_text = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setImageAltText($var)
    {
        GPBUtil::checkString($var, True);
        $this->image_alt_text = $var;

        return $this;
    }

}


