<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/apps/card/v1/card.proto

namespace Google\Apps\Card\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The `Columns` widget displays up to 2 columns in a card or dialog. You can
 * add widgets to each column; the widgets appear in the order that they are
 * specified. For an example in Google Chat apps, see
 * [Display cards and dialogs in
 * columns](https://developers.google.com/workspace/chat/format-structure-card-dialog#display_cards_and_dialogs_in_columns).
 * The height of each column is determined by the taller column. For example, if
 * the first column is taller than the second column, both columns have the
 * height of the first column. Because each column can contain a different
 * number of widgets, you can't define rows or align widgets between the
 * columns.
 * Columns are displayed side-by-side. You can customize the width of each
 * column using the `HorizontalSizeStyle` field. If the user's
 * screen width is too narrow, the second column wraps below the first:
 * * On web, the second column wraps if the screen width is less than or equal
 *   to 480 pixels.
 * * On iOS devices, the second column wraps if the screen width is
 *   less than or equal to 300 pt.
 * * On Android devices, the second column wraps if the screen width is
 *   less than or equal to 320 dp.
 * To include more than 2 columns, or to use rows, use the
 * [`Grid`][google.apps.card.v1.Grid] widget.
 * [Google Workspace Add-ons and Chat
 * apps](https://developers.google.com/workspace/extend):
 * Columns for Google Workspace Add-ons are in
 * Developer Preview.
 *
 * Generated from protobuf message <code>google.apps.card.v1.Columns</code>
 */
class Columns extends \Google\Protobuf\Internal\Message
{
    /**
     * An array of columns. You can include up to 2 columns in a card or dialog.
     *
     * Generated from protobuf field <code>repeated .google.apps.card.v1.Columns.Column column_items = 2;</code>
     */
    private $column_items;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type array<\Google\Apps\Card\V1\Columns\Column>|\Google\Protobuf\Internal\RepeatedField $column_items
     *           An array of columns. You can include up to 2 columns in a card or dialog.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Apps\Card\V1\Card::initOnce();
        parent::__construct($data);
    }

    /**
     * An array of columns. You can include up to 2 columns in a card or dialog.
     *
     * Generated from protobuf field <code>repeated .google.apps.card.v1.Columns.Column column_items = 2;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getColumnItems()
    {
        return $this->column_items;
    }

    /**
     * An array of columns. You can include up to 2 columns in a card or dialog.
     *
     * Generated from protobuf field <code>repeated .google.apps.card.v1.Columns.Column column_items = 2;</code>
     * @param array<\Google\Apps\Card\V1\Columns\Column>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setColumnItems($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Apps\Card\V1\Columns\Column::class);
        $this->column_items = $arr;

        return $this;
    }

}

