<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/apps/card/v1/card.proto

namespace Google\Apps\Card\V1\Grid;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents an item in a grid layout. Items can contain text, an image, or
 * both text and an image.
 * [Google Workspace Add-ons and Chat
 * apps](https://developers.google.com/workspace/extend):
 *
 * Generated from protobuf message <code>google.apps.card.v1.Grid.GridItem</code>
 */
class GridItem extends \Google\Protobuf\Internal\Message
{
    /**
     * A user-specified identifier for this grid item. This identifier is
     * returned in the parent grid's `onClick` callback parameters.
     *
     * Generated from protobuf field <code>string id = 1;</code>
     */
    protected $id = '';
    /**
     * The image that displays in the grid item.
     *
     * Generated from protobuf field <code>.google.apps.card.v1.ImageComponent image = 2;</code>
     */
    protected $image = null;
    /**
     * The grid item's title.
     *
     * Generated from protobuf field <code>string title = 3;</code>
     */
    protected $title = '';
    /**
     * The grid item's subtitle.
     *
     * Generated from protobuf field <code>string subtitle = 4;</code>
     */
    protected $subtitle = '';
    /**
     * The layout to use for the grid item.
     *
     * Generated from protobuf field <code>.google.apps.card.v1.Grid.GridItem.GridItemLayout layout = 9;</code>
     */
    protected $layout = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $id
     *           A user-specified identifier for this grid item. This identifier is
     *           returned in the parent grid's `onClick` callback parameters.
     *     @type \Google\Apps\Card\V1\ImageComponent $image
     *           The image that displays in the grid item.
     *     @type string $title
     *           The grid item's title.
     *     @type string $subtitle
     *           The grid item's subtitle.
     *     @type int $layout
     *           The layout to use for the grid item.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Apps\Card\V1\Card::initOnce();
        parent::__construct($data);
    }

    /**
     * A user-specified identifier for this grid item. This identifier is
     * returned in the parent grid's `onClick` callback parameters.
     *
     * Generated from protobuf field <code>string id = 1;</code>
     * @return string
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * A user-specified identifier for this grid item. This identifier is
     * returned in the parent grid's `onClick` callback parameters.
     *
     * Generated from protobuf field <code>string id = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setId($var)
    {
        GPBUtil::checkString($var, True);
        $this->id = $var;

        return $this;
    }

    /**
     * The image that displays in the grid item.
     *
     * Generated from protobuf field <code>.google.apps.card.v1.ImageComponent image = 2;</code>
     * @return \Google\Apps\Card\V1\ImageComponent|null
     */
    public function getImage()
    {
        return $this->image;
    }

    public function hasImage()
    {
        return isset($this->image);
    }

    public function clearImage()
    {
        unset($this->image);
    }

    /**
     * The image that displays in the grid item.
     *
     * Generated from protobuf field <code>.google.apps.card.v1.ImageComponent image = 2;</code>
     * @param \Google\Apps\Card\V1\ImageComponent $var
     * @return $this
     */
    public function setImage($var)
    {
        GPBUtil::checkMessage($var, \Google\Apps\Card\V1\ImageComponent::class);
        $this->image = $var;

        return $this;
    }

    /**
     * The grid item's title.
     *
     * Generated from protobuf field <code>string title = 3;</code>
     * @return string
     */
    public function getTitle()
    {
        return $this->title;
    }

    /**
     * The grid item's title.
     *
     * Generated from protobuf field <code>string title = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setTitle($var)
    {
        GPBUtil::checkString($var, True);
        $this->title = $var;

        return $this;
    }

    /**
     * The grid item's subtitle.
     *
     * Generated from protobuf field <code>string subtitle = 4;</code>
     * @return string
     */
    public function getSubtitle()
    {
        return $this->subtitle;
    }

    /**
     * The grid item's subtitle.
     *
     * Generated from protobuf field <code>string subtitle = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setSubtitle($var)
    {
        GPBUtil::checkString($var, True);
        $this->subtitle = $var;

        return $this;
    }

    /**
     * The layout to use for the grid item.
     *
     * Generated from protobuf field <code>.google.apps.card.v1.Grid.GridItem.GridItemLayout layout = 9;</code>
     * @return int
     */
    public function getLayout()
    {
        return $this->layout;
    }

    /**
     * The layout to use for the grid item.
     *
     * Generated from protobuf field <code>.google.apps.card.v1.Grid.GridItem.GridItemLayout layout = 9;</code>
     * @param int $var
     * @return $this
     */
    public function setLayout($var)
    {
        GPBUtil::checkEnum($var, \Google\Apps\Card\V1\Grid\GridItem\GridItemLayout::class);
        $this->layout = $var;

        return $this;
    }

}


