<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/apps/card/v1/card.proto

namespace Google\Apps\Card\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An image that is specified by a URL and can have an `onClick` action. For an
 * example, see [Add an
 * image](https://developers.google.com/workspace/chat/add-text-image-card-dialog#add_an_image).
 * [Google Workspace Add-ons and Chat
 * apps](https://developers.google.com/workspace/extend):
 *
 * Generated from protobuf message <code>google.apps.card.v1.Image</code>
 */
class Image extends \Google\Protobuf\Internal\Message
{
    /**
     * The HTTPS URL that hosts the image.
     * For example:
     * ```
     * https://developers.google.com/workspace/chat/images/quickstart-app-avatar.png
     * ```
     *
     * Generated from protobuf field <code>string image_url = 1;</code>
     */
    protected $image_url = '';
    /**
     * When a user clicks the image, the click triggers this action.
     *
     * Generated from protobuf field <code>.google.apps.card.v1.OnClick on_click = 2;</code>
     */
    protected $on_click = null;
    /**
     * The alternative text of this image that's used for accessibility.
     *
     * Generated from protobuf field <code>string alt_text = 3;</code>
     */
    protected $alt_text = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $image_url
     *           The HTTPS URL that hosts the image.
     *           For example:
     *           ```
     *           https://developers.google.com/workspace/chat/images/quickstart-app-avatar.png
     *           ```
     *     @type \Google\Apps\Card\V1\OnClick $on_click
     *           When a user clicks the image, the click triggers this action.
     *     @type string $alt_text
     *           The alternative text of this image that's used for accessibility.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Apps\Card\V1\Card::initOnce();
        parent::__construct($data);
    }

    /**
     * The HTTPS URL that hosts the image.
     * For example:
     * ```
     * https://developers.google.com/workspace/chat/images/quickstart-app-avatar.png
     * ```
     *
     * Generated from protobuf field <code>string image_url = 1;</code>
     * @return string
     */
    public function getImageUrl()
    {
        return $this->image_url;
    }

    /**
     * The HTTPS URL that hosts the image.
     * For example:
     * ```
     * https://developers.google.com/workspace/chat/images/quickstart-app-avatar.png
     * ```
     *
     * Generated from protobuf field <code>string image_url = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setImageUrl($var)
    {
        GPBUtil::checkString($var, True);
        $this->image_url = $var;

        return $this;
    }

    /**
     * When a user clicks the image, the click triggers this action.
     *
     * Generated from protobuf field <code>.google.apps.card.v1.OnClick on_click = 2;</code>
     * @return \Google\Apps\Card\V1\OnClick|null
     */
    public function getOnClick()
    {
        return $this->on_click;
    }

    public function hasOnClick()
    {
        return isset($this->on_click);
    }

    public function clearOnClick()
    {
        unset($this->on_click);
    }

    /**
     * When a user clicks the image, the click triggers this action.
     *
     * Generated from protobuf field <code>.google.apps.card.v1.OnClick on_click = 2;</code>
     * @param \Google\Apps\Card\V1\OnClick $var
     * @return $this
     */
    public function setOnClick($var)
    {
        GPBUtil::checkMessage($var, \Google\Apps\Card\V1\OnClick::class);
        $this->on_click = $var;

        return $this;
    }

    /**
     * The alternative text of this image that's used for accessibility.
     *
     * Generated from protobuf field <code>string alt_text = 3;</code>
     * @return string
     */
    public function getAltText()
    {
        return $this->alt_text;
    }

    /**
     * The alternative text of this image that's used for accessibility.
     *
     * Generated from protobuf field <code>string alt_text = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setAltText($var)
    {
        GPBUtil::checkString($var, True);
        $this->alt_text = $var;

        return $this;
    }

}

