<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/apps/card/v1/card.proto

namespace Google\Apps\Card\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents how to respond when users click an interactive element on
 * a card, such as a button.
 * [Google Workspace Add-ons and Chat
 * apps](https://developers.google.com/workspace/extend):
 *
 * Generated from protobuf message <code>google.apps.card.v1.OnClick</code>
 */
class OnClick extends \Google\Protobuf\Internal\Message
{
    protected $data;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Apps\Card\V1\Action $action
     *           If specified, an action is triggered by this `onClick`.
     *     @type \Google\Apps\Card\V1\OpenLink $open_link
     *           If specified, this `onClick` triggers an open link action.
     *     @type \Google\Apps\Card\V1\Action $open_dynamic_link_action
     *           An add-on triggers this action when the action needs to open a
     *           link. This differs from the `open_link` above in that this needs to talk
     *           to server to get the link. Thus some preparation work is required for
     *           web client to do before the open link action response comes back.
     *           [Google Workspace
     *           Add-ons](https://developers.google.com/workspace/add-ons):
     *     @type \Google\Apps\Card\V1\Card $card
     *           A new card is pushed to the card stack after clicking if specified.
     *           [Google Workspace
     *           Add-ons](https://developers.google.com/workspace/add-ons):
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Apps\Card\V1\Card::initOnce();
        parent::__construct($data);
    }

    /**
     * If specified, an action is triggered by this `onClick`.
     *
     * Generated from protobuf field <code>.google.apps.card.v1.Action action = 1;</code>
     * @return \Google\Apps\Card\V1\Action|null
     */
    public function getAction()
    {
        return $this->readOneof(1);
    }

    public function hasAction()
    {
        return $this->hasOneof(1);
    }

    /**
     * If specified, an action is triggered by this `onClick`.
     *
     * Generated from protobuf field <code>.google.apps.card.v1.Action action = 1;</code>
     * @param \Google\Apps\Card\V1\Action $var
     * @return $this
     */
    public function setAction($var)
    {
        GPBUtil::checkMessage($var, \Google\Apps\Card\V1\Action::class);
        $this->writeOneof(1, $var);

        return $this;
    }

    /**
     * If specified, this `onClick` triggers an open link action.
     *
     * Generated from protobuf field <code>.google.apps.card.v1.OpenLink open_link = 2;</code>
     * @return \Google\Apps\Card\V1\OpenLink|null
     */
    public function getOpenLink()
    {
        return $this->readOneof(2);
    }

    public function hasOpenLink()
    {
        return $this->hasOneof(2);
    }

    /**
     * If specified, this `onClick` triggers an open link action.
     *
     * Generated from protobuf field <code>.google.apps.card.v1.OpenLink open_link = 2;</code>
     * @param \Google\Apps\Card\V1\OpenLink $var
     * @return $this
     */
    public function setOpenLink($var)
    {
        GPBUtil::checkMessage($var, \Google\Apps\Card\V1\OpenLink::class);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     * An add-on triggers this action when the action needs to open a
     * link. This differs from the `open_link` above in that this needs to talk
     * to server to get the link. Thus some preparation work is required for
     * web client to do before the open link action response comes back.
     * [Google Workspace
     * Add-ons](https://developers.google.com/workspace/add-ons):
     *
     * Generated from protobuf field <code>.google.apps.card.v1.Action open_dynamic_link_action = 3;</code>
     * @return \Google\Apps\Card\V1\Action|null
     */
    public function getOpenDynamicLinkAction()
    {
        return $this->readOneof(3);
    }

    public function hasOpenDynamicLinkAction()
    {
        return $this->hasOneof(3);
    }

    /**
     * An add-on triggers this action when the action needs to open a
     * link. This differs from the `open_link` above in that this needs to talk
     * to server to get the link. Thus some preparation work is required for
     * web client to do before the open link action response comes back.
     * [Google Workspace
     * Add-ons](https://developers.google.com/workspace/add-ons):
     *
     * Generated from protobuf field <code>.google.apps.card.v1.Action open_dynamic_link_action = 3;</code>
     * @param \Google\Apps\Card\V1\Action $var
     * @return $this
     */
    public function setOpenDynamicLinkAction($var)
    {
        GPBUtil::checkMessage($var, \Google\Apps\Card\V1\Action::class);
        $this->writeOneof(3, $var);

        return $this;
    }

    /**
     * A new card is pushed to the card stack after clicking if specified.
     * [Google Workspace
     * Add-ons](https://developers.google.com/workspace/add-ons):
     *
     * Generated from protobuf field <code>.google.apps.card.v1.Card card = 4;</code>
     * @return \Google\Apps\Card\V1\Card|null
     */
    public function getCard()
    {
        return $this->readOneof(4);
    }

    public function hasCard()
    {
        return $this->hasOneof(4);
    }

    /**
     * A new card is pushed to the card stack after clicking if specified.
     * [Google Workspace
     * Add-ons](https://developers.google.com/workspace/add-ons):
     *
     * Generated from protobuf field <code>.google.apps.card.v1.Card card = 4;</code>
     * @param \Google\Apps\Card\V1\Card $var
     * @return $this
     */
    public function setCard($var)
    {
        GPBUtil::checkMessage($var, \Google\Apps\Card\V1\Card::class);
        $this->writeOneof(4, $var);

        return $this;
    }

    /**
     * @return string
     */
    public function getData()
    {
        return $this->whichOneof("data");
    }

}

