<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/apps/card/v1/card.proto

namespace Google\Apps\Card\V1\SelectionInput;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An item that users can select in a selection input, such as a checkbox
 * or switch.
 * [Google Workspace Add-ons and Chat
 * apps](https://developers.google.com/workspace/extend):
 *
 * Generated from protobuf message <code>google.apps.card.v1.SelectionInput.SelectionItem</code>
 */
class SelectionItem extends \Google\Protobuf\Internal\Message
{
    /**
     * The text that identifies or describes the item to users.
     *
     * Generated from protobuf field <code>string text = 1;</code>
     */
    protected $text = '';
    /**
     * The value associated with this item. The client should use this as a form
     * input value.
     * For details about working with form inputs, see [Receive form
     * data](https://developers.google.com/workspace/chat/read-form-data).
     *
     * Generated from protobuf field <code>string value = 2;</code>
     */
    protected $value = '';
    /**
     * Whether the item is selected by default. If the selection input only
     * accepts one value (such as for radio buttons or a dropdown menu), only
     * set this field for one item.
     *
     * Generated from protobuf field <code>bool selected = 3;</code>
     */
    protected $selected = false;
    /**
     * For multiselect menus, the URL for the icon displayed next to
     * the item's `text` field. Supports PNG and JPEG files. Must be an `HTTPS`
     * URL. For example,
     * `https://developers.google.com/workspace/chat/images/quickstart-app-avatar.png`.
     *
     * Generated from protobuf field <code>string start_icon_uri = 4;</code>
     */
    protected $start_icon_uri = '';
    /**
     * For multiselect menus, a text description or label that's
     * displayed below the item's `text` field.
     *
     * Generated from protobuf field <code>string bottom_text = 5;</code>
     */
    protected $bottom_text = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $text
     *           The text that identifies or describes the item to users.
     *     @type string $value
     *           The value associated with this item. The client should use this as a form
     *           input value.
     *           For details about working with form inputs, see [Receive form
     *           data](https://developers.google.com/workspace/chat/read-form-data).
     *     @type bool $selected
     *           Whether the item is selected by default. If the selection input only
     *           accepts one value (such as for radio buttons or a dropdown menu), only
     *           set this field for one item.
     *     @type string $start_icon_uri
     *           For multiselect menus, the URL for the icon displayed next to
     *           the item's `text` field. Supports PNG and JPEG files. Must be an `HTTPS`
     *           URL. For example,
     *           `https://developers.google.com/workspace/chat/images/quickstart-app-avatar.png`.
     *     @type string $bottom_text
     *           For multiselect menus, a text description or label that's
     *           displayed below the item's `text` field.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Apps\Card\V1\Card::initOnce();
        parent::__construct($data);
    }

    /**
     * The text that identifies or describes the item to users.
     *
     * Generated from protobuf field <code>string text = 1;</code>
     * @return string
     */
    public function getText()
    {
        return $this->text;
    }

    /**
     * The text that identifies or describes the item to users.
     *
     * Generated from protobuf field <code>string text = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setText($var)
    {
        GPBUtil::checkString($var, True);
        $this->text = $var;

        return $this;
    }

    /**
     * The value associated with this item. The client should use this as a form
     * input value.
     * For details about working with form inputs, see [Receive form
     * data](https://developers.google.com/workspace/chat/read-form-data).
     *
     * Generated from protobuf field <code>string value = 2;</code>
     * @return string
     */
    public function getValue()
    {
        return $this->value;
    }

    /**
     * The value associated with this item. The client should use this as a form
     * input value.
     * For details about working with form inputs, see [Receive form
     * data](https://developers.google.com/workspace/chat/read-form-data).
     *
     * Generated from protobuf field <code>string value = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setValue($var)
    {
        GPBUtil::checkString($var, True);
        $this->value = $var;

        return $this;
    }

    /**
     * Whether the item is selected by default. If the selection input only
     * accepts one value (such as for radio buttons or a dropdown menu), only
     * set this field for one item.
     *
     * Generated from protobuf field <code>bool selected = 3;</code>
     * @return bool
     */
    public function getSelected()
    {
        return $this->selected;
    }

    /**
     * Whether the item is selected by default. If the selection input only
     * accepts one value (such as for radio buttons or a dropdown menu), only
     * set this field for one item.
     *
     * Generated from protobuf field <code>bool selected = 3;</code>
     * @param bool $var
     * @return $this
     */
    public function setSelected($var)
    {
        GPBUtil::checkBool($var);
        $this->selected = $var;

        return $this;
    }

    /**
     * For multiselect menus, the URL for the icon displayed next to
     * the item's `text` field. Supports PNG and JPEG files. Must be an `HTTPS`
     * URL. For example,
     * `https://developers.google.com/workspace/chat/images/quickstart-app-avatar.png`.
     *
     * Generated from protobuf field <code>string start_icon_uri = 4;</code>
     * @return string
     */
    public function getStartIconUri()
    {
        return $this->start_icon_uri;
    }

    /**
     * For multiselect menus, the URL for the icon displayed next to
     * the item's `text` field. Supports PNG and JPEG files. Must be an `HTTPS`
     * URL. For example,
     * `https://developers.google.com/workspace/chat/images/quickstart-app-avatar.png`.
     *
     * Generated from protobuf field <code>string start_icon_uri = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setStartIconUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->start_icon_uri = $var;

        return $this;
    }

    /**
     * For multiselect menus, a text description or label that's
     * displayed below the item's `text` field.
     *
     * Generated from protobuf field <code>string bottom_text = 5;</code>
     * @return string
     */
    public function getBottomText()
    {
        return $this->bottom_text;
    }

    /**
     * For multiselect menus, a text description or label that's
     * displayed below the item's `text` field.
     *
     * Generated from protobuf field <code>string bottom_text = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setBottomText($var)
    {
        GPBUtil::checkString($var, True);
        $this->bottom_text = $var;

        return $this;
    }

}


