<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/chat/v1/message.proto

namespace Google\Apps\Chat\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request to delete a message.
 *
 * Generated from protobuf message <code>google.chat.v1.DeleteMessageRequest</code>
 */
class DeleteMessageRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Resource name of the message.
     * Format: `spaces/{space}/messages/{message}`
     * If you've set a custom ID for your message, you can use the value from the
     * `clientAssignedMessageId` field for `{message}`. For details, see [Name a
     * message]
     * (https://developers.google.com/workspace/chat/create-messages#name_a_created_message).
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';
    /**
     * When `true`, deleting a message also deletes its threaded replies. When
     * `false`, if a message has threaded replies, deletion fails.
     * Only applies when [authenticating as a
     * user](https://developers.google.com/workspace/chat/authenticate-authorize-chat-user).
     * Has no effect when [authenticating as a Chat app]
     * (https://developers.google.com/workspace/chat/authenticate-authorize-chat-app).
     *
     * Generated from protobuf field <code>bool force = 2;</code>
     */
    protected $force = false;

    /**
     * @param string $name Required. Resource name of the message.
     *
     *                     Format: `spaces/{space}/messages/{message}`
     *
     *                     If you've set a custom ID for your message, you can use the value from the
     *                     `clientAssignedMessageId` field for `{message}`. For details, see [Name a
     *                     message]
     *                     (https://developers.google.com/workspace/chat/create-messages#name_a_created_message). Please see
     *                     {@see ChatServiceClient::messageName()} for help formatting this field.
     *
     * @return \Google\Apps\Chat\V1\DeleteMessageRequest
     *
     * @experimental
     */
    public static function build(string $name): self
    {
        return (new self())
            ->setName($name);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. Resource name of the message.
     *           Format: `spaces/{space}/messages/{message}`
     *           If you've set a custom ID for your message, you can use the value from the
     *           `clientAssignedMessageId` field for `{message}`. For details, see [Name a
     *           message]
     *           (https://developers.google.com/workspace/chat/create-messages#name_a_created_message).
     *     @type bool $force
     *           When `true`, deleting a message also deletes its threaded replies. When
     *           `false`, if a message has threaded replies, deletion fails.
     *           Only applies when [authenticating as a
     *           user](https://developers.google.com/workspace/chat/authenticate-authorize-chat-user).
     *           Has no effect when [authenticating as a Chat app]
     *           (https://developers.google.com/workspace/chat/authenticate-authorize-chat-app).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Chat\V1\Message::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Resource name of the message.
     * Format: `spaces/{space}/messages/{message}`
     * If you've set a custom ID for your message, you can use the value from the
     * `clientAssignedMessageId` field for `{message}`. For details, see [Name a
     * message]
     * (https://developers.google.com/workspace/chat/create-messages#name_a_created_message).
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. Resource name of the message.
     * Format: `spaces/{space}/messages/{message}`
     * If you've set a custom ID for your message, you can use the value from the
     * `clientAssignedMessageId` field for `{message}`. For details, see [Name a
     * message]
     * (https://developers.google.com/workspace/chat/create-messages#name_a_created_message).
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * When `true`, deleting a message also deletes its threaded replies. When
     * `false`, if a message has threaded replies, deletion fails.
     * Only applies when [authenticating as a
     * user](https://developers.google.com/workspace/chat/authenticate-authorize-chat-user).
     * Has no effect when [authenticating as a Chat app]
     * (https://developers.google.com/workspace/chat/authenticate-authorize-chat-app).
     *
     * Generated from protobuf field <code>bool force = 2;</code>
     * @return bool
     */
    public function getForce()
    {
        return $this->force;
    }

    /**
     * When `true`, deleting a message also deletes its threaded replies. When
     * `false`, if a message has threaded replies, deletion fails.
     * Only applies when [authenticating as a
     * user](https://developers.google.com/workspace/chat/authenticate-authorize-chat-user).
     * Has no effect when [authenticating as a Chat app]
     * (https://developers.google.com/workspace/chat/authenticate-authorize-chat-app).
     *
     * Generated from protobuf field <code>bool force = 2;</code>
     * @param bool $var
     * @return $this
     */
    public function setForce($var)
    {
        GPBUtil::checkBool($var);
        $this->force = $var;

        return $this;
    }

}

