<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/chat/v1/membership.proto

namespace Google\Apps\Chat\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for updating a membership.
 *
 * Generated from protobuf message <code>google.chat.v1.UpdateMembershipRequest</code>
 */
class UpdateMembershipRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The membership to update. Only fields specified by `update_mask`
     * are updated.
     *
     * Generated from protobuf field <code>.google.chat.v1.Membership membership = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $membership = null;
    /**
     * Required. The field paths to update. Separate multiple values with commas
     * or use `*` to update all field paths.
     * Currently supported field paths:
     * - `role`
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $update_mask = null;
    /**
     * When `true`, the method runs using the user's Google Workspace
     * administrator privileges.
     * The calling user must be a Google Workspace administrator with the
     * [manage chat and spaces conversations
     * privilege](https://support.google.com/a/answer/13369245).
     * Requires the `chat.admin.memberships` [OAuth 2.0
     * scope](https://developers.google.com/workspace/chat/authenticate-authorize#chat-api-scopes).
     *
     * Generated from protobuf field <code>bool use_admin_access = 3;</code>
     */
    protected $use_admin_access = false;

    /**
     * @param \Google\Apps\Chat\V1\Membership $membership Required. The membership to update. Only fields specified by `update_mask`
     *                                                    are updated.
     * @param \Google\Protobuf\FieldMask      $updateMask Required. The field paths to update. Separate multiple values with commas
     *                                                    or use `*` to update all field paths.
     *
     *                                                    Currently supported field paths:
     *
     *                                                    - `role`
     *
     * @return \Google\Apps\Chat\V1\UpdateMembershipRequest
     *
     * @experimental
     */
    public static function build(\Google\Apps\Chat\V1\Membership $membership, \Google\Protobuf\FieldMask $updateMask): self
    {
        return (new self())
            ->setMembership($membership)
            ->setUpdateMask($updateMask);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Apps\Chat\V1\Membership $membership
     *           Required. The membership to update. Only fields specified by `update_mask`
     *           are updated.
     *     @type \Google\Protobuf\FieldMask $update_mask
     *           Required. The field paths to update. Separate multiple values with commas
     *           or use `*` to update all field paths.
     *           Currently supported field paths:
     *           - `role`
     *     @type bool $use_admin_access
     *           When `true`, the method runs using the user's Google Workspace
     *           administrator privileges.
     *           The calling user must be a Google Workspace administrator with the
     *           [manage chat and spaces conversations
     *           privilege](https://support.google.com/a/answer/13369245).
     *           Requires the `chat.admin.memberships` [OAuth 2.0
     *           scope](https://developers.google.com/workspace/chat/authenticate-authorize#chat-api-scopes).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Chat\V1\Membership::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The membership to update. Only fields specified by `update_mask`
     * are updated.
     *
     * Generated from protobuf field <code>.google.chat.v1.Membership membership = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Apps\Chat\V1\Membership|null
     */
    public function getMembership()
    {
        return $this->membership;
    }

    public function hasMembership()
    {
        return isset($this->membership);
    }

    public function clearMembership()
    {
        unset($this->membership);
    }

    /**
     * Required. The membership to update. Only fields specified by `update_mask`
     * are updated.
     *
     * Generated from protobuf field <code>.google.chat.v1.Membership membership = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Apps\Chat\V1\Membership $var
     * @return $this
     */
    public function setMembership($var)
    {
        GPBUtil::checkMessage($var, \Google\Apps\Chat\V1\Membership::class);
        $this->membership = $var;

        return $this;
    }

    /**
     * Required. The field paths to update. Separate multiple values with commas
     * or use `*` to update all field paths.
     * Currently supported field paths:
     * - `role`
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\FieldMask|null
     */
    public function getUpdateMask()
    {
        return $this->update_mask;
    }

    public function hasUpdateMask()
    {
        return isset($this->update_mask);
    }

    public function clearUpdateMask()
    {
        unset($this->update_mask);
    }

    /**
     * Required. The field paths to update. Separate multiple values with commas
     * or use `*` to update all field paths.
     * Currently supported field paths:
     * - `role`
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Protobuf\FieldMask $var
     * @return $this
     */
    public function setUpdateMask($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\FieldMask::class);
        $this->update_mask = $var;

        return $this;
    }

    /**
     * When `true`, the method runs using the user's Google Workspace
     * administrator privileges.
     * The calling user must be a Google Workspace administrator with the
     * [manage chat and spaces conversations
     * privilege](https://support.google.com/a/answer/13369245).
     * Requires the `chat.admin.memberships` [OAuth 2.0
     * scope](https://developers.google.com/workspace/chat/authenticate-authorize#chat-api-scopes).
     *
     * Generated from protobuf field <code>bool use_admin_access = 3;</code>
     * @return bool
     */
    public function getUseAdminAccess()
    {
        return $this->use_admin_access;
    }

    /**
     * When `true`, the method runs using the user's Google Workspace
     * administrator privileges.
     * The calling user must be a Google Workspace administrator with the
     * [manage chat and spaces conversations
     * privilege](https://support.google.com/a/answer/13369245).
     * Requires the `chat.admin.memberships` [OAuth 2.0
     * scope](https://developers.google.com/workspace/chat/authenticate-authorize#chat-api-scopes).
     *
     * Generated from protobuf field <code>bool use_admin_access = 3;</code>
     * @param bool $var
     * @return $this
     */
    public function setUseAdminAccess($var)
    {
        GPBUtil::checkBool($var);
        $this->use_admin_access = $var;

        return $this;
    }

}

