<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/apps/events/subscriptions/v1/subscriptions_service.proto

namespace Google\Apps\Events\Subscriptions\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for
 * [SubscriptionsService.DeleteSubscription][google.apps.events.subscriptions.v1.SubscriptionsService.DeleteSubscription].
 *
 * Generated from protobuf message <code>google.apps.events.subscriptions.v1.DeleteSubscriptionRequest</code>
 */
class DeleteSubscriptionRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Resource name of the subscription to delete.
     * Format: `subscriptions/{subscription}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';
    /**
     * Optional. If set to `true`, validates and previews the request, but doesn't
     * delete the subscription.
     *
     * Generated from protobuf field <code>bool validate_only = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $validate_only = false;
    /**
     * Optional. If set to `true` and the subscription isn't found, the request
     * succeeds but doesn't delete the subscription.
     *
     * Generated from protobuf field <code>bool allow_missing = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $allow_missing = false;
    /**
     * Optional. Etag of the subscription.
     * If present, it must match with the server's etag. Otherwise, request
     * fails with the status `ABORTED`.
     *
     * Generated from protobuf field <code>string etag = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $etag = '';

    /**
     * @param string $name Required. Resource name of the subscription to delete.
     *
     *                     Format: `subscriptions/{subscription}`
     *                     Please see {@see SubscriptionsServiceClient::subscriptionName()} for help formatting this field.
     *
     * @return \Google\Apps\Events\Subscriptions\V1\DeleteSubscriptionRequest
     *
     * @experimental
     */
    public static function build(string $name): self
    {
        return (new self())
            ->setName($name);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. Resource name of the subscription to delete.
     *           Format: `subscriptions/{subscription}`
     *     @type bool $validate_only
     *           Optional. If set to `true`, validates and previews the request, but doesn't
     *           delete the subscription.
     *     @type bool $allow_missing
     *           Optional. If set to `true` and the subscription isn't found, the request
     *           succeeds but doesn't delete the subscription.
     *     @type string $etag
     *           Optional. Etag of the subscription.
     *           If present, it must match with the server's etag. Otherwise, request
     *           fails with the status `ABORTED`.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Apps\Events\Subscriptions\V1\SubscriptionsService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Resource name of the subscription to delete.
     * Format: `subscriptions/{subscription}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. Resource name of the subscription to delete.
     * Format: `subscriptions/{subscription}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Optional. If set to `true`, validates and previews the request, but doesn't
     * delete the subscription.
     *
     * Generated from protobuf field <code>bool validate_only = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getValidateOnly()
    {
        return $this->validate_only;
    }

    /**
     * Optional. If set to `true`, validates and previews the request, but doesn't
     * delete the subscription.
     *
     * Generated from protobuf field <code>bool validate_only = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setValidateOnly($var)
    {
        GPBUtil::checkBool($var);
        $this->validate_only = $var;

        return $this;
    }

    /**
     * Optional. If set to `true` and the subscription isn't found, the request
     * succeeds but doesn't delete the subscription.
     *
     * Generated from protobuf field <code>bool allow_missing = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getAllowMissing()
    {
        return $this->allow_missing;
    }

    /**
     * Optional. If set to `true` and the subscription isn't found, the request
     * succeeds but doesn't delete the subscription.
     *
     * Generated from protobuf field <code>bool allow_missing = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setAllowMissing($var)
    {
        GPBUtil::checkBool($var);
        $this->allow_missing = $var;

        return $this;
    }

    /**
     * Optional. Etag of the subscription.
     * If present, it must match with the server's etag. Otherwise, request
     * fails with the status `ABORTED`.
     *
     * Generated from protobuf field <code>string etag = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getEtag()
    {
        return $this->etag;
    }

    /**
     * Optional. Etag of the subscription.
     * If present, it must match with the server's etag. Otherwise, request
     * fails with the status `ABORTED`.
     *
     * Generated from protobuf field <code>string etag = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setEtag($var)
    {
        GPBUtil::checkString($var, True);
        $this->etag = $var;

        return $this;
    }

}

