<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/apps/events/subscriptions/v1/subscription_resource.proto

namespace Google\Apps\Events\Subscriptions\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Options about what data to include in the event payload. Only supported for
 * Google Chat events.
 *
 * Generated from protobuf message <code>google.apps.events.subscriptions.v1.PayloadOptions</code>
 */
class PayloadOptions extends \Google\Protobuf\Internal\Message
{
    /**
     * Optional. Whether the event payload includes data about the resource that
     * changed. For example, for an event where a Google Chat message was created,
     * whether the payload contains data about the
     * [`Message`](https://developers.google.com/chat/api/reference/rest/v1/spaces.messages)
     * resource. If false, the event payload only includes the name of the changed
     * resource.
     *
     * Generated from protobuf field <code>bool include_resource = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $include_resource = false;
    /**
     * Optional. If `include_resource` is set to `true`, the list of fields to
     * include in the event payload. Separate fields with a comma. For example, to
     * include a Google Chat message's sender and create time, enter
     * `message.sender,message.createTime`. If omitted, the payload includes all
     * fields for the resource.
     * If you specify a field that doesn't exist for the resource, the system
     * ignores the field.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask field_mask = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $field_mask = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type bool $include_resource
     *           Optional. Whether the event payload includes data about the resource that
     *           changed. For example, for an event where a Google Chat message was created,
     *           whether the payload contains data about the
     *           [`Message`](https://developers.google.com/chat/api/reference/rest/v1/spaces.messages)
     *           resource. If false, the event payload only includes the name of the changed
     *           resource.
     *     @type \Google\Protobuf\FieldMask $field_mask
     *           Optional. If `include_resource` is set to `true`, the list of fields to
     *           include in the event payload. Separate fields with a comma. For example, to
     *           include a Google Chat message's sender and create time, enter
     *           `message.sender,message.createTime`. If omitted, the payload includes all
     *           fields for the resource.
     *           If you specify a field that doesn't exist for the resource, the system
     *           ignores the field.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Apps\Events\Subscriptions\V1\SubscriptionResource::initOnce();
        parent::__construct($data);
    }

    /**
     * Optional. Whether the event payload includes data about the resource that
     * changed. For example, for an event where a Google Chat message was created,
     * whether the payload contains data about the
     * [`Message`](https://developers.google.com/chat/api/reference/rest/v1/spaces.messages)
     * resource. If false, the event payload only includes the name of the changed
     * resource.
     *
     * Generated from protobuf field <code>bool include_resource = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getIncludeResource()
    {
        return $this->include_resource;
    }

    /**
     * Optional. Whether the event payload includes data about the resource that
     * changed. For example, for an event where a Google Chat message was created,
     * whether the payload contains data about the
     * [`Message`](https://developers.google.com/chat/api/reference/rest/v1/spaces.messages)
     * resource. If false, the event payload only includes the name of the changed
     * resource.
     *
     * Generated from protobuf field <code>bool include_resource = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setIncludeResource($var)
    {
        GPBUtil::checkBool($var);
        $this->include_resource = $var;

        return $this;
    }

    /**
     * Optional. If `include_resource` is set to `true`, the list of fields to
     * include in the event payload. Separate fields with a comma. For example, to
     * include a Google Chat message's sender and create time, enter
     * `message.sender,message.createTime`. If omitted, the payload includes all
     * fields for the resource.
     * If you specify a field that doesn't exist for the resource, the system
     * ignores the field.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask field_mask = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\FieldMask|null
     */
    public function getFieldMask()
    {
        return $this->field_mask;
    }

    public function hasFieldMask()
    {
        return isset($this->field_mask);
    }

    public function clearFieldMask()
    {
        unset($this->field_mask);
    }

    /**
     * Optional. If `include_resource` is set to `true`, the list of fields to
     * include in the event payload. Separate fields with a comma. For example, to
     * include a Google Chat message's sender and create time, enter
     * `message.sender,message.createTime`. If omitted, the payload includes all
     * fields for the resource.
     * If you specify a field that doesn't exist for the resource, the system
     * ignores the field.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask field_mask = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Protobuf\FieldMask $var
     * @return $this
     */
    public function setFieldMask($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\FieldMask::class);
        $this->field_mask = $var;

        return $this;
    }

}

