<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/apps/meet/v2/service.proto

namespace Google\Apps\Meet\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request to fetch list of participant sessions per conference record, per
 * participant.
 *
 * Generated from protobuf message <code>google.apps.meet.v2.ListParticipantSessionsRequest</code>
 */
class ListParticipantSessionsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Format:
     * `conferenceRecords/{conference_record}/participants/{participant}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. Maximum number of participant sessions to return. The service
     * might return fewer than this value. If unspecified, at most 100
     * participants are returned. The maximum value is 250; values above 250 are
     * coerced to 250. Maximum might change in the future.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. Page token returned from previous List Call.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';
    /**
     * Optional. User specified filtering condition in [EBNF
     * format](https://en.wikipedia.org/wiki/Extended_Backus%E2%80%93Naur_form).
     * The following are the filterable fields:
     * * `start_time`
     * * `end_time`
     * For example, `end_time IS NULL` returns active participant sessions in
     * the conference record.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $filter = '';

    /**
     * @param string $parent Required. Format:
     *                       `conferenceRecords/{conference_record}/participants/{participant}`
     *                       Please see {@see ConferenceRecordsServiceClient::participantName()} for help formatting this field.
     *
     * @return \Google\Apps\Meet\V2\ListParticipantSessionsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Format:
     *           `conferenceRecords/{conference_record}/participants/{participant}`
     *     @type int $page_size
     *           Optional. Maximum number of participant sessions to return. The service
     *           might return fewer than this value. If unspecified, at most 100
     *           participants are returned. The maximum value is 250; values above 250 are
     *           coerced to 250. Maximum might change in the future.
     *     @type string $page_token
     *           Optional. Page token returned from previous List Call.
     *     @type string $filter
     *           Optional. User specified filtering condition in [EBNF
     *           format](https://en.wikipedia.org/wiki/Extended_Backus%E2%80%93Naur_form).
     *           The following are the filterable fields:
     *           * `start_time`
     *           * `end_time`
     *           For example, `end_time IS NULL` returns active participant sessions in
     *           the conference record.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Apps\Meet\V2\Service::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Format:
     * `conferenceRecords/{conference_record}/participants/{participant}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Format:
     * `conferenceRecords/{conference_record}/participants/{participant}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. Maximum number of participant sessions to return. The service
     * might return fewer than this value. If unspecified, at most 100
     * participants are returned. The maximum value is 250; values above 250 are
     * coerced to 250. Maximum might change in the future.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. Maximum number of participant sessions to return. The service
     * might return fewer than this value. If unspecified, at most 100
     * participants are returned. The maximum value is 250; values above 250 are
     * coerced to 250. Maximum might change in the future.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. Page token returned from previous List Call.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. Page token returned from previous List Call.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. User specified filtering condition in [EBNF
     * format](https://en.wikipedia.org/wiki/Extended_Backus%E2%80%93Naur_form).
     * The following are the filterable fields:
     * * `start_time`
     * * `end_time`
     * For example, `end_time IS NULL` returns active participant sessions in
     * the conference record.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Optional. User specified filtering condition in [EBNF
     * format](https://en.wikipedia.org/wiki/Extended_Backus%E2%80%93Naur_form).
     * The following are the filterable fields:
     * * `start_time`
     * * `end_time`
     * For example, `end_time IS NULL` returns active participant sessions in
     * the conference record.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

}

