<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/apps/meet/v2beta/service.proto

namespace Google\Apps\Meet\V2beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request to fetch list of participant per conference.
 *
 * Generated from protobuf message <code>google.apps.meet.v2beta.ListParticipantsRequest</code>
 */
class ListParticipantsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Format: `conferenceRecords/{conference_record}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Maximum number of participants to return. The service might return fewer
     * than this value.
     * If unspecified, at most 100 participants are returned.
     * The maximum value is 250; values above 250 are coerced to 250.
     * Maximum might change in the future.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     */
    protected $page_size = 0;
    /**
     * Page token returned from previous List Call.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     */
    protected $page_token = '';
    /**
     * Optional. User specified filtering condition in EBNF format. The following
     * are the filterable fields:
     * * `earliest_start_time`
     * * `latest_end_time`
     * For example, `latest_end_time IS NULL` returns active participants in
     * the conference.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $filter = '';

    /**
     * @param string $parent Required. Format: `conferenceRecords/{conference_record}`
     *                       Please see {@see ConferenceRecordsServiceClient::conferenceRecordName()} for help formatting this field.
     *
     * @return \Google\Apps\Meet\V2beta\ListParticipantsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Format: `conferenceRecords/{conference_record}`
     *     @type int $page_size
     *           Maximum number of participants to return. The service might return fewer
     *           than this value.
     *           If unspecified, at most 100 participants are returned.
     *           The maximum value is 250; values above 250 are coerced to 250.
     *           Maximum might change in the future.
     *     @type string $page_token
     *           Page token returned from previous List Call.
     *     @type string $filter
     *           Optional. User specified filtering condition in EBNF format. The following
     *           are the filterable fields:
     *           * `earliest_start_time`
     *           * `latest_end_time`
     *           For example, `latest_end_time IS NULL` returns active participants in
     *           the conference.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Apps\Meet\V2Beta\Service::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Format: `conferenceRecords/{conference_record}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Format: `conferenceRecords/{conference_record}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Maximum number of participants to return. The service might return fewer
     * than this value.
     * If unspecified, at most 100 participants are returned.
     * The maximum value is 250; values above 250 are coerced to 250.
     * Maximum might change in the future.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Maximum number of participants to return. The service might return fewer
     * than this value.
     * If unspecified, at most 100 participants are returned.
     * The maximum value is 250; values above 250 are coerced to 250.
     * Maximum might change in the future.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Page token returned from previous List Call.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Page token returned from previous List Call.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. User specified filtering condition in EBNF format. The following
     * are the filterable fields:
     * * `earliest_start_time`
     * * `latest_end_time`
     * For example, `latest_end_time IS NULL` returns active participants in
     * the conference.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Optional. User specified filtering condition in EBNF format. The following
     * are the filterable fields:
     * * `earliest_start_time`
     * * `latest_end_time`
     * For example, `latest_end_time IS NULL` returns active participants in
     * the conference.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

}

