<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/apps/meet/v2beta/resource.proto

namespace Google\Apps\Meet\V2beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * [Developer Preview](https://developers.google.com/workspace/preview).
 * Metadata about a recording created during a conference.
 *
 * Generated from protobuf message <code>google.apps.meet.v2beta.Recording</code>
 */
class Recording extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. Resource name of the recording.
     * Format: `conferenceRecords/{conference_record}/recordings/{recording}`
     * where `{recording}` is a 1:1 mapping to each unique recording session
     * during the conference.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $name = '';
    /**
     * Output only. Current state.
     *
     * Generated from protobuf field <code>.google.apps.meet.v2beta.Recording.State state = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;
    /**
     * Output only. Timestamp when the recording started.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $start_time = null;
    /**
     * Output only. Timestamp when the recording ended.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $end_time = null;
    protected $destination;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Apps\Meet\V2beta\DriveDestination $drive_destination
     *           Output only. Recording is saved to Google Drive as an mp4 file. The
     *           `drive_destination` includes the Drive `fileId` that can be used to
     *           download the file using the `files.get` method of the Drive API.
     *     @type string $name
     *           Output only. Resource name of the recording.
     *           Format: `conferenceRecords/{conference_record}/recordings/{recording}`
     *           where `{recording}` is a 1:1 mapping to each unique recording session
     *           during the conference.
     *     @type int $state
     *           Output only. Current state.
     *     @type \Google\Protobuf\Timestamp $start_time
     *           Output only. Timestamp when the recording started.
     *     @type \Google\Protobuf\Timestamp $end_time
     *           Output only. Timestamp when the recording ended.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Apps\Meet\V2Beta\Resource::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. Recording is saved to Google Drive as an mp4 file. The
     * `drive_destination` includes the Drive `fileId` that can be used to
     * download the file using the `files.get` method of the Drive API.
     *
     * Generated from protobuf field <code>.google.apps.meet.v2beta.DriveDestination drive_destination = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Apps\Meet\V2beta\DriveDestination|null
     */
    public function getDriveDestination()
    {
        return $this->readOneof(6);
    }

    public function hasDriveDestination()
    {
        return $this->hasOneof(6);
    }

    /**
     * Output only. Recording is saved to Google Drive as an mp4 file. The
     * `drive_destination` includes the Drive `fileId` that can be used to
     * download the file using the `files.get` method of the Drive API.
     *
     * Generated from protobuf field <code>.google.apps.meet.v2beta.DriveDestination drive_destination = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Apps\Meet\V2beta\DriveDestination $var
     * @return $this
     */
    public function setDriveDestination($var)
    {
        GPBUtil::checkMessage($var, \Google\Apps\Meet\V2beta\DriveDestination::class);
        $this->writeOneof(6, $var);

        return $this;
    }

    /**
     * Output only. Resource name of the recording.
     * Format: `conferenceRecords/{conference_record}/recordings/{recording}`
     * where `{recording}` is a 1:1 mapping to each unique recording session
     * during the conference.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. Resource name of the recording.
     * Format: `conferenceRecords/{conference_record}/recordings/{recording}`
     * where `{recording}` is a 1:1 mapping to each unique recording session
     * during the conference.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. Current state.
     *
     * Generated from protobuf field <code>.google.apps.meet.v2beta.Recording.State state = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. Current state.
     *
     * Generated from protobuf field <code>.google.apps.meet.v2beta.Recording.State state = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Apps\Meet\V2beta\Recording\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Output only. Timestamp when the recording started.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getStartTime()
    {
        return $this->start_time;
    }

    public function hasStartTime()
    {
        return isset($this->start_time);
    }

    public function clearStartTime()
    {
        unset($this->start_time);
    }

    /**
     * Output only. Timestamp when the recording started.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setStartTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->start_time = $var;

        return $this;
    }

    /**
     * Output only. Timestamp when the recording ended.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getEndTime()
    {
        return $this->end_time;
    }

    public function hasEndTime()
    {
        return isset($this->end_time);
    }

    public function clearEndTime()
    {
        unset($this->end_time);
    }

    /**
     * Output only. Timestamp when the recording ended.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setEndTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->end_time = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getDestination()
    {
        return $this->whichOneof("destination");
    }

}

