<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/devtools/artifactregistry/v1/repository.proto

namespace Google\Cloud\ArtifactRegistry\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * CleanupPolicyCondition is a set of conditions attached to a CleanupPolicy.
 * If multiple entries are set, all must be satisfied for the condition to be
 * satisfied.
 *
 * Generated from protobuf message <code>google.devtools.artifactregistry.v1.CleanupPolicyCondition</code>
 */
class CleanupPolicyCondition extends \Google\Protobuf\Internal\Message
{
    /**
     * Match versions by tag status.
     *
     * Generated from protobuf field <code>optional .google.devtools.artifactregistry.v1.CleanupPolicyCondition.TagState tag_state = 2;</code>
     */
    protected $tag_state = null;
    /**
     * Match versions by tag prefix. Applied on any prefix match.
     *
     * Generated from protobuf field <code>repeated string tag_prefixes = 3;</code>
     */
    private $tag_prefixes;
    /**
     * Match versions by version name prefix. Applied on any prefix match.
     *
     * Generated from protobuf field <code>repeated string version_name_prefixes = 4;</code>
     */
    private $version_name_prefixes;
    /**
     * Match versions by package prefix. Applied on any prefix match.
     *
     * Generated from protobuf field <code>repeated string package_name_prefixes = 5;</code>
     */
    private $package_name_prefixes;
    /**
     * Match versions older than a duration.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Duration older_than = 6;</code>
     */
    protected $older_than = null;
    /**
     * Match versions newer than a duration.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Duration newer_than = 7;</code>
     */
    protected $newer_than = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int $tag_state
     *           Match versions by tag status.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $tag_prefixes
     *           Match versions by tag prefix. Applied on any prefix match.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $version_name_prefixes
     *           Match versions by version name prefix. Applied on any prefix match.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $package_name_prefixes
     *           Match versions by package prefix. Applied on any prefix match.
     *     @type \Google\Protobuf\Duration $older_than
     *           Match versions older than a duration.
     *     @type \Google\Protobuf\Duration $newer_than
     *           Match versions newer than a duration.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Devtools\Artifactregistry\V1\Repository::initOnce();
        parent::__construct($data);
    }

    /**
     * Match versions by tag status.
     *
     * Generated from protobuf field <code>optional .google.devtools.artifactregistry.v1.CleanupPolicyCondition.TagState tag_state = 2;</code>
     * @return int
     */
    public function getTagState()
    {
        return isset($this->tag_state) ? $this->tag_state : 0;
    }

    public function hasTagState()
    {
        return isset($this->tag_state);
    }

    public function clearTagState()
    {
        unset($this->tag_state);
    }

    /**
     * Match versions by tag status.
     *
     * Generated from protobuf field <code>optional .google.devtools.artifactregistry.v1.CleanupPolicyCondition.TagState tag_state = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setTagState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\ArtifactRegistry\V1\CleanupPolicyCondition\TagState::class);
        $this->tag_state = $var;

        return $this;
    }

    /**
     * Match versions by tag prefix. Applied on any prefix match.
     *
     * Generated from protobuf field <code>repeated string tag_prefixes = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getTagPrefixes()
    {
        return $this->tag_prefixes;
    }

    /**
     * Match versions by tag prefix. Applied on any prefix match.
     *
     * Generated from protobuf field <code>repeated string tag_prefixes = 3;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setTagPrefixes($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->tag_prefixes = $arr;

        return $this;
    }

    /**
     * Match versions by version name prefix. Applied on any prefix match.
     *
     * Generated from protobuf field <code>repeated string version_name_prefixes = 4;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getVersionNamePrefixes()
    {
        return $this->version_name_prefixes;
    }

    /**
     * Match versions by version name prefix. Applied on any prefix match.
     *
     * Generated from protobuf field <code>repeated string version_name_prefixes = 4;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setVersionNamePrefixes($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->version_name_prefixes = $arr;

        return $this;
    }

    /**
     * Match versions by package prefix. Applied on any prefix match.
     *
     * Generated from protobuf field <code>repeated string package_name_prefixes = 5;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getPackageNamePrefixes()
    {
        return $this->package_name_prefixes;
    }

    /**
     * Match versions by package prefix. Applied on any prefix match.
     *
     * Generated from protobuf field <code>repeated string package_name_prefixes = 5;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setPackageNamePrefixes($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->package_name_prefixes = $arr;

        return $this;
    }

    /**
     * Match versions older than a duration.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Duration older_than = 6;</code>
     * @return \Google\Protobuf\Duration|null
     */
    public function getOlderThan()
    {
        return $this->older_than;
    }

    public function hasOlderThan()
    {
        return isset($this->older_than);
    }

    public function clearOlderThan()
    {
        unset($this->older_than);
    }

    /**
     * Match versions older than a duration.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Duration older_than = 6;</code>
     * @param \Google\Protobuf\Duration $var
     * @return $this
     */
    public function setOlderThan($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Duration::class);
        $this->older_than = $var;

        return $this;
    }

    /**
     * Match versions newer than a duration.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Duration newer_than = 7;</code>
     * @return \Google\Protobuf\Duration|null
     */
    public function getNewerThan()
    {
        return $this->newer_than;
    }

    public function hasNewerThan()
    {
        return isset($this->newer_than);
    }

    public function clearNewerThan()
    {
        unset($this->newer_than);
    }

    /**
     * Match versions newer than a duration.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Duration newer_than = 7;</code>
     * @param \Google\Protobuf\Duration $var
     * @return $this
     */
    public function setNewerThan($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Duration::class);
        $this->newer_than = $var;

        return $this;
    }

}

