<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/asset/v1/asset_service.proto

namespace Google\Cloud\Asset\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for performing resource move analysis.
 *
 * Generated from protobuf message <code>google.cloud.asset.v1.AnalyzeMoveRequest</code>
 */
class AnalyzeMoveRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Name of the resource to perform the analysis against.
     * Only Google Cloud projects are supported as of today. Hence, this can only
     * be a project ID (such as "projects/my-project-id") or a project number
     * (such as "projects/12345").
     *
     * Generated from protobuf field <code>string resource = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $resource = '';
    /**
     * Required. Name of the Google Cloud folder or organization to reparent the
     * target resource. The analysis will be performed against hypothetically
     * moving the resource to this specified desitination parent. This can only be
     * a folder number (such as "folders/123") or an organization number (such as
     * "organizations/123").
     *
     * Generated from protobuf field <code>string destination_parent = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $destination_parent = '';
    /**
     * Analysis view indicating what information should be included in the
     * analysis response. If unspecified, the default view is FULL.
     *
     * Generated from protobuf field <code>.google.cloud.asset.v1.AnalyzeMoveRequest.AnalysisView view = 3;</code>
     */
    protected $view = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $resource
     *           Required. Name of the resource to perform the analysis against.
     *           Only Google Cloud projects are supported as of today. Hence, this can only
     *           be a project ID (such as "projects/my-project-id") or a project number
     *           (such as "projects/12345").
     *     @type string $destination_parent
     *           Required. Name of the Google Cloud folder or organization to reparent the
     *           target resource. The analysis will be performed against hypothetically
     *           moving the resource to this specified desitination parent. This can only be
     *           a folder number (such as "folders/123") or an organization number (such as
     *           "organizations/123").
     *     @type int $view
     *           Analysis view indicating what information should be included in the
     *           analysis response. If unspecified, the default view is FULL.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Asset\V1\AssetService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Name of the resource to perform the analysis against.
     * Only Google Cloud projects are supported as of today. Hence, this can only
     * be a project ID (such as "projects/my-project-id") or a project number
     * (such as "projects/12345").
     *
     * Generated from protobuf field <code>string resource = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getResource()
    {
        return $this->resource;
    }

    /**
     * Required. Name of the resource to perform the analysis against.
     * Only Google Cloud projects are supported as of today. Hence, this can only
     * be a project ID (such as "projects/my-project-id") or a project number
     * (such as "projects/12345").
     *
     * Generated from protobuf field <code>string resource = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setResource($var)
    {
        GPBUtil::checkString($var, True);
        $this->resource = $var;

        return $this;
    }

    /**
     * Required. Name of the Google Cloud folder or organization to reparent the
     * target resource. The analysis will be performed against hypothetically
     * moving the resource to this specified desitination parent. This can only be
     * a folder number (such as "folders/123") or an organization number (such as
     * "organizations/123").
     *
     * Generated from protobuf field <code>string destination_parent = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getDestinationParent()
    {
        return $this->destination_parent;
    }

    /**
     * Required. Name of the Google Cloud folder or organization to reparent the
     * target resource. The analysis will be performed against hypothetically
     * moving the resource to this specified desitination parent. This can only be
     * a folder number (such as "folders/123") or an organization number (such as
     * "organizations/123").
     *
     * Generated from protobuf field <code>string destination_parent = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setDestinationParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->destination_parent = $var;

        return $this;
    }

    /**
     * Analysis view indicating what information should be included in the
     * analysis response. If unspecified, the default view is FULL.
     *
     * Generated from protobuf field <code>.google.cloud.asset.v1.AnalyzeMoveRequest.AnalysisView view = 3;</code>
     * @return int
     */
    public function getView()
    {
        return $this->view;
    }

    /**
     * Analysis view indicating what information should be included in the
     * analysis response. If unspecified, the default view is FULL.
     *
     * Generated from protobuf field <code>.google.cloud.asset.v1.AnalyzeMoveRequest.AnalysisView view = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setView($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Asset\V1\AnalyzeMoveRequest\AnalysisView::class);
        $this->view = $var;

        return $this;
    }

}

