<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/asset/v1/asset_service.proto

namespace Google\Cloud\Asset\V1\AnalyzeOrgPoliciesResponse;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The organization policy result to the query.
 *
 * Generated from protobuf message <code>google.cloud.asset.v1.AnalyzeOrgPoliciesResponse.OrgPolicyResult</code>
 */
class OrgPolicyResult extends \Google\Protobuf\Internal\Message
{
    /**
     * The consolidated organization policy for the analyzed resource. The
     * consolidated organization policy is computed by merging and evaluating
     * [AnalyzeOrgPoliciesResponse.policy_bundle][].
     * The evaluation will respect the organization policy [hierarchy
     * rules](https://cloud.google.com/resource-manager/docs/organization-policy/understanding-hierarchy).
     *
     * Generated from protobuf field <code>.google.cloud.asset.v1.AnalyzerOrgPolicy consolidated_policy = 1;</code>
     */
    protected $consolidated_policy = null;
    /**
     * The ordered list of all organization policies from the
     * [AnalyzeOrgPoliciesResponse.OrgPolicyResult.consolidated_policy.attached_resource][].
     * to the scope specified in the request.
     * If the constraint is defined with default policy, it will also appear in
     * the list.
     *
     * Generated from protobuf field <code>repeated .google.cloud.asset.v1.AnalyzerOrgPolicy policy_bundle = 2;</code>
     */
    private $policy_bundle;
    /**
     * The project that this consolidated policy belongs to, in the format of
     * projects/{PROJECT_NUMBER}. This field is available when the consolidated
     * policy belongs to a project.
     *
     * Generated from protobuf field <code>string project = 3;</code>
     */
    protected $project = '';
    /**
     * The folder(s) that this consolidated policy belongs to, in the format of
     * folders/{FOLDER_NUMBER}. This field is available when the consolidated
     * policy belongs (directly or cascadingly) to one or more folders.
     *
     * Generated from protobuf field <code>repeated string folders = 4;</code>
     */
    private $folders;
    /**
     * The organization that this consolidated policy belongs to, in the format
     * of organizations/{ORGANIZATION_NUMBER}. This field is available when the
     * consolidated policy belongs (directly or cascadingly) to an organization.
     *
     * Generated from protobuf field <code>string organization = 5;</code>
     */
    protected $organization = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\Asset\V1\AnalyzerOrgPolicy $consolidated_policy
     *           The consolidated organization policy for the analyzed resource. The
     *           consolidated organization policy is computed by merging and evaluating
     *           [AnalyzeOrgPoliciesResponse.policy_bundle][].
     *           The evaluation will respect the organization policy [hierarchy
     *           rules](https://cloud.google.com/resource-manager/docs/organization-policy/understanding-hierarchy).
     *     @type array<\Google\Cloud\Asset\V1\AnalyzerOrgPolicy>|\Google\Protobuf\Internal\RepeatedField $policy_bundle
     *           The ordered list of all organization policies from the
     *           [AnalyzeOrgPoliciesResponse.OrgPolicyResult.consolidated_policy.attached_resource][].
     *           to the scope specified in the request.
     *           If the constraint is defined with default policy, it will also appear in
     *           the list.
     *     @type string $project
     *           The project that this consolidated policy belongs to, in the format of
     *           projects/{PROJECT_NUMBER}. This field is available when the consolidated
     *           policy belongs to a project.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $folders
     *           The folder(s) that this consolidated policy belongs to, in the format of
     *           folders/{FOLDER_NUMBER}. This field is available when the consolidated
     *           policy belongs (directly or cascadingly) to one or more folders.
     *     @type string $organization
     *           The organization that this consolidated policy belongs to, in the format
     *           of organizations/{ORGANIZATION_NUMBER}. This field is available when the
     *           consolidated policy belongs (directly or cascadingly) to an organization.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Asset\V1\AssetService::initOnce();
        parent::__construct($data);
    }

    /**
     * The consolidated organization policy for the analyzed resource. The
     * consolidated organization policy is computed by merging and evaluating
     * [AnalyzeOrgPoliciesResponse.policy_bundle][].
     * The evaluation will respect the organization policy [hierarchy
     * rules](https://cloud.google.com/resource-manager/docs/organization-policy/understanding-hierarchy).
     *
     * Generated from protobuf field <code>.google.cloud.asset.v1.AnalyzerOrgPolicy consolidated_policy = 1;</code>
     * @return \Google\Cloud\Asset\V1\AnalyzerOrgPolicy|null
     */
    public function getConsolidatedPolicy()
    {
        return $this->consolidated_policy;
    }

    public function hasConsolidatedPolicy()
    {
        return isset($this->consolidated_policy);
    }

    public function clearConsolidatedPolicy()
    {
        unset($this->consolidated_policy);
    }

    /**
     * The consolidated organization policy for the analyzed resource. The
     * consolidated organization policy is computed by merging and evaluating
     * [AnalyzeOrgPoliciesResponse.policy_bundle][].
     * The evaluation will respect the organization policy [hierarchy
     * rules](https://cloud.google.com/resource-manager/docs/organization-policy/understanding-hierarchy).
     *
     * Generated from protobuf field <code>.google.cloud.asset.v1.AnalyzerOrgPolicy consolidated_policy = 1;</code>
     * @param \Google\Cloud\Asset\V1\AnalyzerOrgPolicy $var
     * @return $this
     */
    public function setConsolidatedPolicy($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Asset\V1\AnalyzerOrgPolicy::class);
        $this->consolidated_policy = $var;

        return $this;
    }

    /**
     * The ordered list of all organization policies from the
     * [AnalyzeOrgPoliciesResponse.OrgPolicyResult.consolidated_policy.attached_resource][].
     * to the scope specified in the request.
     * If the constraint is defined with default policy, it will also appear in
     * the list.
     *
     * Generated from protobuf field <code>repeated .google.cloud.asset.v1.AnalyzerOrgPolicy policy_bundle = 2;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getPolicyBundle()
    {
        return $this->policy_bundle;
    }

    /**
     * The ordered list of all organization policies from the
     * [AnalyzeOrgPoliciesResponse.OrgPolicyResult.consolidated_policy.attached_resource][].
     * to the scope specified in the request.
     * If the constraint is defined with default policy, it will also appear in
     * the list.
     *
     * Generated from protobuf field <code>repeated .google.cloud.asset.v1.AnalyzerOrgPolicy policy_bundle = 2;</code>
     * @param array<\Google\Cloud\Asset\V1\AnalyzerOrgPolicy>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setPolicyBundle($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Asset\V1\AnalyzerOrgPolicy::class);
        $this->policy_bundle = $arr;

        return $this;
    }

    /**
     * The project that this consolidated policy belongs to, in the format of
     * projects/{PROJECT_NUMBER}. This field is available when the consolidated
     * policy belongs to a project.
     *
     * Generated from protobuf field <code>string project = 3;</code>
     * @return string
     */
    public function getProject()
    {
        return $this->project;
    }

    /**
     * The project that this consolidated policy belongs to, in the format of
     * projects/{PROJECT_NUMBER}. This field is available when the consolidated
     * policy belongs to a project.
     *
     * Generated from protobuf field <code>string project = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setProject($var)
    {
        GPBUtil::checkString($var, True);
        $this->project = $var;

        return $this;
    }

    /**
     * The folder(s) that this consolidated policy belongs to, in the format of
     * folders/{FOLDER_NUMBER}. This field is available when the consolidated
     * policy belongs (directly or cascadingly) to one or more folders.
     *
     * Generated from protobuf field <code>repeated string folders = 4;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getFolders()
    {
        return $this->folders;
    }

    /**
     * The folder(s) that this consolidated policy belongs to, in the format of
     * folders/{FOLDER_NUMBER}. This field is available when the consolidated
     * policy belongs (directly or cascadingly) to one or more folders.
     *
     * Generated from protobuf field <code>repeated string folders = 4;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setFolders($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->folders = $arr;

        return $this;
    }

    /**
     * The organization that this consolidated policy belongs to, in the format
     * of organizations/{ORGANIZATION_NUMBER}. This field is available when the
     * consolidated policy belongs (directly or cascadingly) to an organization.
     *
     * Generated from protobuf field <code>string organization = 5;</code>
     * @return string
     */
    public function getOrganization()
    {
        return $this->organization;
    }

    /**
     * The organization that this consolidated policy belongs to, in the format
     * of organizations/{ORGANIZATION_NUMBER}. This field is available when the
     * consolidated policy belongs (directly or cascadingly) to an organization.
     *
     * Generated from protobuf field <code>string organization = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setOrganization($var)
    {
        GPBUtil::checkString($var, True);
        $this->organization = $var;

        return $this;
    }

}


