<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/asset/v1/assets.proto

namespace Google\Cloud\Asset\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The effective tags and the ancestor resources from which they were inherited.
 *
 * Generated from protobuf message <code>google.cloud.asset.v1.EffectiveTagDetails</code>
 */
class EffectiveTagDetails extends \Google\Protobuf\Internal\Message
{
    /**
     * The [full resource
     * name](https://cloud.google.com/asset-inventory/docs/resource-name-format)
     * of the ancestor from which an [effective_tag][] is inherited, according to
     * [tag
     * inheritance](https://cloud.google.com/resource-manager/docs/tags/tags-overview#inheritance).
     *
     * Generated from protobuf field <code>optional string attached_resource = 1;</code>
     */
    protected $attached_resource = null;
    /**
     * The effective tags inherited from the
     * [attached_resource][google.cloud.asset.v1.EffectiveTagDetails.attached_resource].
     * Note that tags with the same key but different values may attach to
     * resources at a different hierarchy levels. The lower hierarchy tag value
     * will overwrite the higher hierarchy tag value of the same tag key. In this
     * case, the tag value at the higher hierarchy level will be removed. For more
     * information, see [tag
     * inheritance](https://cloud.google.com/resource-manager/docs/tags/tags-overview#inheritance).
     *
     * Generated from protobuf field <code>repeated .google.cloud.asset.v1.Tag effective_tags = 2;</code>
     */
    private $effective_tags;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $attached_resource
     *           The [full resource
     *           name](https://cloud.google.com/asset-inventory/docs/resource-name-format)
     *           of the ancestor from which an [effective_tag][] is inherited, according to
     *           [tag
     *           inheritance](https://cloud.google.com/resource-manager/docs/tags/tags-overview#inheritance).
     *     @type array<\Google\Cloud\Asset\V1\Tag>|\Google\Protobuf\Internal\RepeatedField $effective_tags
     *           The effective tags inherited from the
     *           [attached_resource][google.cloud.asset.v1.EffectiveTagDetails.attached_resource].
     *           Note that tags with the same key but different values may attach to
     *           resources at a different hierarchy levels. The lower hierarchy tag value
     *           will overwrite the higher hierarchy tag value of the same tag key. In this
     *           case, the tag value at the higher hierarchy level will be removed. For more
     *           information, see [tag
     *           inheritance](https://cloud.google.com/resource-manager/docs/tags/tags-overview#inheritance).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Asset\V1\Assets::initOnce();
        parent::__construct($data);
    }

    /**
     * The [full resource
     * name](https://cloud.google.com/asset-inventory/docs/resource-name-format)
     * of the ancestor from which an [effective_tag][] is inherited, according to
     * [tag
     * inheritance](https://cloud.google.com/resource-manager/docs/tags/tags-overview#inheritance).
     *
     * Generated from protobuf field <code>optional string attached_resource = 1;</code>
     * @return string
     */
    public function getAttachedResource()
    {
        return isset($this->attached_resource) ? $this->attached_resource : '';
    }

    public function hasAttachedResource()
    {
        return isset($this->attached_resource);
    }

    public function clearAttachedResource()
    {
        unset($this->attached_resource);
    }

    /**
     * The [full resource
     * name](https://cloud.google.com/asset-inventory/docs/resource-name-format)
     * of the ancestor from which an [effective_tag][] is inherited, according to
     * [tag
     * inheritance](https://cloud.google.com/resource-manager/docs/tags/tags-overview#inheritance).
     *
     * Generated from protobuf field <code>optional string attached_resource = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setAttachedResource($var)
    {
        GPBUtil::checkString($var, True);
        $this->attached_resource = $var;

        return $this;
    }

    /**
     * The effective tags inherited from the
     * [attached_resource][google.cloud.asset.v1.EffectiveTagDetails.attached_resource].
     * Note that tags with the same key but different values may attach to
     * resources at a different hierarchy levels. The lower hierarchy tag value
     * will overwrite the higher hierarchy tag value of the same tag key. In this
     * case, the tag value at the higher hierarchy level will be removed. For more
     * information, see [tag
     * inheritance](https://cloud.google.com/resource-manager/docs/tags/tags-overview#inheritance).
     *
     * Generated from protobuf field <code>repeated .google.cloud.asset.v1.Tag effective_tags = 2;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getEffectiveTags()
    {
        return $this->effective_tags;
    }

    /**
     * The effective tags inherited from the
     * [attached_resource][google.cloud.asset.v1.EffectiveTagDetails.attached_resource].
     * Note that tags with the same key but different values may attach to
     * resources at a different hierarchy levels. The lower hierarchy tag value
     * will overwrite the higher hierarchy tag value of the same tag key. In this
     * case, the tag value at the higher hierarchy level will be removed. For more
     * information, see [tag
     * inheritance](https://cloud.google.com/resource-manager/docs/tags/tags-overview#inheritance).
     *
     * Generated from protobuf field <code>repeated .google.cloud.asset.v1.Tag effective_tags = 2;</code>
     * @param array<\Google\Cloud\Asset\V1\Tag>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setEffectiveTags($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Asset\V1\Tag::class);
        $this->effective_tags = $arr;

        return $this;
    }

}

