<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/assuredworkloads/v1/assuredworkloads.proto

namespace Google\Cloud\AssuredWorkloads\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request for fetching violations in an organization.
 *
 * Generated from protobuf message <code>google.cloud.assuredworkloads.v1.ListViolationsRequest</code>
 */
class ListViolationsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The Workload name.
     * Format `organizations/{org_id}/locations/{location}/workloads/{workload}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. Specifies the time window for retrieving active Violations.
     * When specified, retrieves Violations that were active between start_time
     * and end_time.
     *
     * Generated from protobuf field <code>.google.cloud.assuredworkloads.v1.TimeWindow interval = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $interval = null;
    /**
     * Optional. Page size.
     *
     * Generated from protobuf field <code>int32 page_size = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. Page token returned from previous request.
     *
     * Generated from protobuf field <code>string page_token = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';
    /**
     * Optional. A custom filter for filtering by the Violations properties.
     *
     * Generated from protobuf field <code>string filter = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $filter = '';

    /**
     * @param string $parent Required. The Workload name.
     *                       Format `organizations/{org_id}/locations/{location}/workloads/{workload}`. Please see
     *                       {@see AssuredWorkloadsServiceClient::workloadName()} for help formatting this field.
     *
     * @return \Google\Cloud\AssuredWorkloads\V1\ListViolationsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The Workload name.
     *           Format `organizations/{org_id}/locations/{location}/workloads/{workload}`.
     *     @type \Google\Cloud\AssuredWorkloads\V1\TimeWindow $interval
     *           Optional. Specifies the time window for retrieving active Violations.
     *           When specified, retrieves Violations that were active between start_time
     *           and end_time.
     *     @type int $page_size
     *           Optional. Page size.
     *     @type string $page_token
     *           Optional. Page token returned from previous request.
     *     @type string $filter
     *           Optional. A custom filter for filtering by the Violations properties.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Assuredworkloads\V1\Assuredworkloads::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The Workload name.
     * Format `organizations/{org_id}/locations/{location}/workloads/{workload}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The Workload name.
     * Format `organizations/{org_id}/locations/{location}/workloads/{workload}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. Specifies the time window for retrieving active Violations.
     * When specified, retrieves Violations that were active between start_time
     * and end_time.
     *
     * Generated from protobuf field <code>.google.cloud.assuredworkloads.v1.TimeWindow interval = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\AssuredWorkloads\V1\TimeWindow|null
     */
    public function getInterval()
    {
        return $this->interval;
    }

    public function hasInterval()
    {
        return isset($this->interval);
    }

    public function clearInterval()
    {
        unset($this->interval);
    }

    /**
     * Optional. Specifies the time window for retrieving active Violations.
     * When specified, retrieves Violations that were active between start_time
     * and end_time.
     *
     * Generated from protobuf field <code>.google.cloud.assuredworkloads.v1.TimeWindow interval = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\AssuredWorkloads\V1\TimeWindow $var
     * @return $this
     */
    public function setInterval($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AssuredWorkloads\V1\TimeWindow::class);
        $this->interval = $var;

        return $this;
    }

    /**
     * Optional. Page size.
     *
     * Generated from protobuf field <code>int32 page_size = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. Page size.
     *
     * Generated from protobuf field <code>int32 page_size = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. Page token returned from previous request.
     *
     * Generated from protobuf field <code>string page_token = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. Page token returned from previous request.
     *
     * Generated from protobuf field <code>string page_token = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. A custom filter for filtering by the Violations properties.
     *
     * Generated from protobuf field <code>string filter = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Optional. A custom filter for filtering by the Violations properties.
     *
     * Generated from protobuf field <code>string filter = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

}

