<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/assuredworkloads/v1/assuredworkloads.proto

namespace Google\Cloud\AssuredWorkloads\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Workload monitoring Violation.
 *
 * Generated from protobuf message <code>google.cloud.assuredworkloads.v1.Violation</code>
 */
class Violation extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. Immutable. Name of the Violation.
     * Format:
     * organizations/{organization}/locations/{location}/workloads/{workload_id}/violations/{violations_id}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     */
    protected $name = '';
    /**
     * Output only. Description for the Violation.
     * e.g. OrgPolicy gcp.resourceLocations has non compliant value.
     *
     * Generated from protobuf field <code>string description = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $description = '';
    /**
     * Output only. Time of the event which triggered the Violation.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp begin_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $begin_time = null;
    /**
     * Output only. The last time when the Violation record was updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Output only. Time of the event which fixed the Violation.
     * If the violation is ACTIVE this will be empty.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp resolve_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $resolve_time = null;
    /**
     * Output only. Category under which this violation is mapped.
     * e.g. Location, Service Usage, Access, Encryption, etc.
     *
     * Generated from protobuf field <code>string category = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $category = '';
    /**
     * Output only. State of the violation
     *
     * Generated from protobuf field <code>.google.cloud.assuredworkloads.v1.Violation.State state = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;
    /**
     * Output only. Immutable. The org-policy-constraint that was incorrectly changed, which resulted in
     * this violation.
     *
     * Generated from protobuf field <code>string org_policy_constraint = 8 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     */
    protected $org_policy_constraint = '';
    /**
     * Output only. Immutable. Audit Log Link for violated resource
     * Format:
     * https://console.cloud.google.com/logs/query;query={logName}{protoPayload.resourceName}{timeRange}{folder}
     *
     * Generated from protobuf field <code>string audit_log_link = 11 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     */
    protected $audit_log_link = '';
    /**
     * Output only. Immutable. Name of the OrgPolicy which was modified with non-compliant change and
     * resulted this violation.
     *  Format:
     *  projects/{project_number}/policies/{constraint_name}
     *  folders/{folder_id}/policies/{constraint_name}
     *  organizations/{organization_id}/policies/{constraint_name}
     *
     * Generated from protobuf field <code>string non_compliant_org_policy = 12 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     */
    protected $non_compliant_org_policy = '';
    /**
     * Output only. Compliance violation remediation
     *
     * Generated from protobuf field <code>.google.cloud.assuredworkloads.v1.Violation.Remediation remediation = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $remediation = null;
    /**
     * Output only. A boolean that indicates if the violation is acknowledged
     *
     * Generated from protobuf field <code>bool acknowledged = 14 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $acknowledged = false;
    /**
     * Optional. Timestamp when this violation was acknowledged last.
     * This will be absent when acknowledged field is marked as false.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp acknowledgement_time = 15 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $acknowledgement_time = null;
    /**
     * Output only. Immutable. Audit Log link to find business justification provided for violation
     * exception. Format:
     * https://console.cloud.google.com/logs/query;query={logName}{protoPayload.resourceName}{protoPayload.methodName}{timeRange}{organization}
     *
     * Generated from protobuf field <code>string exception_audit_log_link = 16 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     */
    protected $exception_audit_log_link = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. Immutable. Name of the Violation.
     *           Format:
     *           organizations/{organization}/locations/{location}/workloads/{workload_id}/violations/{violations_id}
     *     @type string $description
     *           Output only. Description for the Violation.
     *           e.g. OrgPolicy gcp.resourceLocations has non compliant value.
     *     @type \Google\Protobuf\Timestamp $begin_time
     *           Output only. Time of the event which triggered the Violation.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. The last time when the Violation record was updated.
     *     @type \Google\Protobuf\Timestamp $resolve_time
     *           Output only. Time of the event which fixed the Violation.
     *           If the violation is ACTIVE this will be empty.
     *     @type string $category
     *           Output only. Category under which this violation is mapped.
     *           e.g. Location, Service Usage, Access, Encryption, etc.
     *     @type int $state
     *           Output only. State of the violation
     *     @type string $org_policy_constraint
     *           Output only. Immutable. The org-policy-constraint that was incorrectly changed, which resulted in
     *           this violation.
     *     @type string $audit_log_link
     *           Output only. Immutable. Audit Log Link for violated resource
     *           Format:
     *           https://console.cloud.google.com/logs/query;query={logName}{protoPayload.resourceName}{timeRange}{folder}
     *     @type string $non_compliant_org_policy
     *           Output only. Immutable. Name of the OrgPolicy which was modified with non-compliant change and
     *           resulted this violation.
     *            Format:
     *            projects/{project_number}/policies/{constraint_name}
     *            folders/{folder_id}/policies/{constraint_name}
     *            organizations/{organization_id}/policies/{constraint_name}
     *     @type \Google\Cloud\AssuredWorkloads\V1\Violation\Remediation $remediation
     *           Output only. Compliance violation remediation
     *     @type bool $acknowledged
     *           Output only. A boolean that indicates if the violation is acknowledged
     *     @type \Google\Protobuf\Timestamp $acknowledgement_time
     *           Optional. Timestamp when this violation was acknowledged last.
     *           This will be absent when acknowledged field is marked as false.
     *     @type string $exception_audit_log_link
     *           Output only. Immutable. Audit Log link to find business justification provided for violation
     *           exception. Format:
     *           https://console.cloud.google.com/logs/query;query={logName}{protoPayload.resourceName}{protoPayload.methodName}{timeRange}{organization}
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Assuredworkloads\V1\Assuredworkloads::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. Immutable. Name of the Violation.
     * Format:
     * organizations/{organization}/locations/{location}/workloads/{workload_id}/violations/{violations_id}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. Immutable. Name of the Violation.
     * Format:
     * organizations/{organization}/locations/{location}/workloads/{workload_id}/violations/{violations_id}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. Description for the Violation.
     * e.g. OrgPolicy gcp.resourceLocations has non compliant value.
     *
     * Generated from protobuf field <code>string description = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Output only. Description for the Violation.
     * e.g. OrgPolicy gcp.resourceLocations has non compliant value.
     *
     * Generated from protobuf field <code>string description = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Output only. Time of the event which triggered the Violation.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp begin_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getBeginTime()
    {
        return $this->begin_time;
    }

    public function hasBeginTime()
    {
        return isset($this->begin_time);
    }

    public function clearBeginTime()
    {
        unset($this->begin_time);
    }

    /**
     * Output only. Time of the event which triggered the Violation.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp begin_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setBeginTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->begin_time = $var;

        return $this;
    }

    /**
     * Output only. The last time when the Violation record was updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. The last time when the Violation record was updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Output only. Time of the event which fixed the Violation.
     * If the violation is ACTIVE this will be empty.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp resolve_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getResolveTime()
    {
        return $this->resolve_time;
    }

    public function hasResolveTime()
    {
        return isset($this->resolve_time);
    }

    public function clearResolveTime()
    {
        unset($this->resolve_time);
    }

    /**
     * Output only. Time of the event which fixed the Violation.
     * If the violation is ACTIVE this will be empty.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp resolve_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setResolveTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->resolve_time = $var;

        return $this;
    }

    /**
     * Output only. Category under which this violation is mapped.
     * e.g. Location, Service Usage, Access, Encryption, etc.
     *
     * Generated from protobuf field <code>string category = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getCategory()
    {
        return $this->category;
    }

    /**
     * Output only. Category under which this violation is mapped.
     * e.g. Location, Service Usage, Access, Encryption, etc.
     *
     * Generated from protobuf field <code>string category = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setCategory($var)
    {
        GPBUtil::checkString($var, True);
        $this->category = $var;

        return $this;
    }

    /**
     * Output only. State of the violation
     *
     * Generated from protobuf field <code>.google.cloud.assuredworkloads.v1.Violation.State state = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. State of the violation
     *
     * Generated from protobuf field <code>.google.cloud.assuredworkloads.v1.Violation.State state = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\AssuredWorkloads\V1\Violation\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Output only. Immutable. The org-policy-constraint that was incorrectly changed, which resulted in
     * this violation.
     *
     * Generated from protobuf field <code>string org_policy_constraint = 8 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @return string
     */
    public function getOrgPolicyConstraint()
    {
        return $this->org_policy_constraint;
    }

    /**
     * Output only. Immutable. The org-policy-constraint that was incorrectly changed, which resulted in
     * this violation.
     *
     * Generated from protobuf field <code>string org_policy_constraint = 8 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @param string $var
     * @return $this
     */
    public function setOrgPolicyConstraint($var)
    {
        GPBUtil::checkString($var, True);
        $this->org_policy_constraint = $var;

        return $this;
    }

    /**
     * Output only. Immutable. Audit Log Link for violated resource
     * Format:
     * https://console.cloud.google.com/logs/query;query={logName}{protoPayload.resourceName}{timeRange}{folder}
     *
     * Generated from protobuf field <code>string audit_log_link = 11 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @return string
     */
    public function getAuditLogLink()
    {
        return $this->audit_log_link;
    }

    /**
     * Output only. Immutable. Audit Log Link for violated resource
     * Format:
     * https://console.cloud.google.com/logs/query;query={logName}{protoPayload.resourceName}{timeRange}{folder}
     *
     * Generated from protobuf field <code>string audit_log_link = 11 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @param string $var
     * @return $this
     */
    public function setAuditLogLink($var)
    {
        GPBUtil::checkString($var, True);
        $this->audit_log_link = $var;

        return $this;
    }

    /**
     * Output only. Immutable. Name of the OrgPolicy which was modified with non-compliant change and
     * resulted this violation.
     *  Format:
     *  projects/{project_number}/policies/{constraint_name}
     *  folders/{folder_id}/policies/{constraint_name}
     *  organizations/{organization_id}/policies/{constraint_name}
     *
     * Generated from protobuf field <code>string non_compliant_org_policy = 12 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @return string
     */
    public function getNonCompliantOrgPolicy()
    {
        return $this->non_compliant_org_policy;
    }

    /**
     * Output only. Immutable. Name of the OrgPolicy which was modified with non-compliant change and
     * resulted this violation.
     *  Format:
     *  projects/{project_number}/policies/{constraint_name}
     *  folders/{folder_id}/policies/{constraint_name}
     *  organizations/{organization_id}/policies/{constraint_name}
     *
     * Generated from protobuf field <code>string non_compliant_org_policy = 12 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @param string $var
     * @return $this
     */
    public function setNonCompliantOrgPolicy($var)
    {
        GPBUtil::checkString($var, True);
        $this->non_compliant_org_policy = $var;

        return $this;
    }

    /**
     * Output only. Compliance violation remediation
     *
     * Generated from protobuf field <code>.google.cloud.assuredworkloads.v1.Violation.Remediation remediation = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\AssuredWorkloads\V1\Violation\Remediation|null
     */
    public function getRemediation()
    {
        return $this->remediation;
    }

    public function hasRemediation()
    {
        return isset($this->remediation);
    }

    public function clearRemediation()
    {
        unset($this->remediation);
    }

    /**
     * Output only. Compliance violation remediation
     *
     * Generated from protobuf field <code>.google.cloud.assuredworkloads.v1.Violation.Remediation remediation = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\AssuredWorkloads\V1\Violation\Remediation $var
     * @return $this
     */
    public function setRemediation($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AssuredWorkloads\V1\Violation\Remediation::class);
        $this->remediation = $var;

        return $this;
    }

    /**
     * Output only. A boolean that indicates if the violation is acknowledged
     *
     * Generated from protobuf field <code>bool acknowledged = 14 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return bool
     */
    public function getAcknowledged()
    {
        return $this->acknowledged;
    }

    /**
     * Output only. A boolean that indicates if the violation is acknowledged
     *
     * Generated from protobuf field <code>bool acknowledged = 14 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param bool $var
     * @return $this
     */
    public function setAcknowledged($var)
    {
        GPBUtil::checkBool($var);
        $this->acknowledged = $var;

        return $this;
    }

    /**
     * Optional. Timestamp when this violation was acknowledged last.
     * This will be absent when acknowledged field is marked as false.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp acknowledgement_time = 15 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getAcknowledgementTime()
    {
        return $this->acknowledgement_time;
    }

    public function hasAcknowledgementTime()
    {
        return isset($this->acknowledgement_time);
    }

    public function clearAcknowledgementTime()
    {
        unset($this->acknowledgement_time);
    }

    /**
     * Optional. Timestamp when this violation was acknowledged last.
     * This will be absent when acknowledged field is marked as false.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp acknowledgement_time = 15 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setAcknowledgementTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->acknowledgement_time = $var;

        return $this;
    }

    /**
     * Output only. Immutable. Audit Log link to find business justification provided for violation
     * exception. Format:
     * https://console.cloud.google.com/logs/query;query={logName}{protoPayload.resourceName}{protoPayload.methodName}{timeRange}{organization}
     *
     * Generated from protobuf field <code>string exception_audit_log_link = 16 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @return string
     */
    public function getExceptionAuditLogLink()
    {
        return $this->exception_audit_log_link;
    }

    /**
     * Output only. Immutable. Audit Log link to find business justification provided for violation
     * exception. Format:
     * https://console.cloud.google.com/logs/query;query={logName}{protoPayload.resourceName}{protoPayload.methodName}{timeRange}{organization}
     *
     * Generated from protobuf field <code>string exception_audit_log_link = 16 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @param string $var
     * @return $this
     */
    public function setExceptionAuditLogLink($var)
    {
        GPBUtil::checkString($var, True);
        $this->exception_audit_log_link = $var;

        return $this;
    }

}

