<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/backupdr/v1/backupplan.proto

namespace Google\Cloud\BackupDR\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * `BackupRule` binds the backup schedule to a retention policy.
 *
 * Generated from protobuf message <code>google.cloud.backupdr.v1.BackupRule</code>
 */
class BackupRule extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Immutable. The unique id of this `BackupRule`. The `rule_id` is
     * unique per `BackupPlan`.The `rule_id` must start with a lowercase letter
     * followed by up to 62 lowercase letters, numbers, or hyphens. Pattern,
     * /[a-z][a-z0-9-]{,62}/.
     *
     * Generated from protobuf field <code>string rule_id = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.field_behavior) = IMMUTABLE];</code>
     */
    protected $rule_id = '';
    /**
     * Required. Configures the duration for which backup data will be kept. It is
     * defined in “days”. The value should be greater than or equal to minimum
     * enforced retention of the backup vault.
     *
     * Generated from protobuf field <code>int32 backup_retention_days = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $backup_retention_days = 0;
    protected $backup_schedule_oneof;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $rule_id
     *           Required. Immutable. The unique id of this `BackupRule`. The `rule_id` is
     *           unique per `BackupPlan`.The `rule_id` must start with a lowercase letter
     *           followed by up to 62 lowercase letters, numbers, or hyphens. Pattern,
     *           /[a-z][a-z0-9-]{,62}/.
     *     @type int $backup_retention_days
     *           Required. Configures the duration for which backup data will be kept. It is
     *           defined in “days”. The value should be greater than or equal to minimum
     *           enforced retention of the backup vault.
     *     @type \Google\Cloud\BackupDR\V1\StandardSchedule $standard_schedule
     *           Required. Defines a schedule that runs within the confines of a defined
     *           window of time.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Backupdr\V1\Backupplan::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Immutable. The unique id of this `BackupRule`. The `rule_id` is
     * unique per `BackupPlan`.The `rule_id` must start with a lowercase letter
     * followed by up to 62 lowercase letters, numbers, or hyphens. Pattern,
     * /[a-z][a-z0-9-]{,62}/.
     *
     * Generated from protobuf field <code>string rule_id = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @return string
     */
    public function getRuleId()
    {
        return $this->rule_id;
    }

    /**
     * Required. Immutable. The unique id of this `BackupRule`. The `rule_id` is
     * unique per `BackupPlan`.The `rule_id` must start with a lowercase letter
     * followed by up to 62 lowercase letters, numbers, or hyphens. Pattern,
     * /[a-z][a-z0-9-]{,62}/.
     *
     * Generated from protobuf field <code>string rule_id = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @param string $var
     * @return $this
     */
    public function setRuleId($var)
    {
        GPBUtil::checkString($var, True);
        $this->rule_id = $var;

        return $this;
    }

    /**
     * Required. Configures the duration for which backup data will be kept. It is
     * defined in “days”. The value should be greater than or equal to minimum
     * enforced retention of the backup vault.
     *
     * Generated from protobuf field <code>int32 backup_retention_days = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return int
     */
    public function getBackupRetentionDays()
    {
        return $this->backup_retention_days;
    }

    /**
     * Required. Configures the duration for which backup data will be kept. It is
     * defined in “days”. The value should be greater than or equal to minimum
     * enforced retention of the backup vault.
     *
     * Generated from protobuf field <code>int32 backup_retention_days = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int $var
     * @return $this
     */
    public function setBackupRetentionDays($var)
    {
        GPBUtil::checkInt32($var);
        $this->backup_retention_days = $var;

        return $this;
    }

    /**
     * Required. Defines a schedule that runs within the confines of a defined
     * window of time.
     *
     * Generated from protobuf field <code>.google.cloud.backupdr.v1.StandardSchedule standard_schedule = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\BackupDR\V1\StandardSchedule|null
     */
    public function getStandardSchedule()
    {
        return $this->readOneof(5);
    }

    public function hasStandardSchedule()
    {
        return $this->hasOneof(5);
    }

    /**
     * Required. Defines a schedule that runs within the confines of a defined
     * window of time.
     *
     * Generated from protobuf field <code>.google.cloud.backupdr.v1.StandardSchedule standard_schedule = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\BackupDR\V1\StandardSchedule $var
     * @return $this
     */
    public function setStandardSchedule($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\BackupDR\V1\StandardSchedule::class);
        $this->writeOneof(5, $var);

        return $this;
    }

    /**
     * @return string
     */
    public function getBackupScheduleOneof()
    {
        return $this->whichOneof("backup_schedule_oneof");
    }

}

