<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/backupdr/v1/backupvault.proto

namespace Google\Cloud\BackupDR\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message describing a BackupVault object.
 *
 * Generated from protobuf message <code>google.cloud.backupdr.v1.BackupVault</code>
 */
class BackupVault extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. Identifier. Name of the backup vault to create. It must have
     * the
     * format`"projects/{project}/locations/{location}/backupVaults/{backupvault}"`.
     * `{backupvault}` cannot be changed after creation. It must be between 3-63
     * characters long and must be unique within the project and location.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Optional. The description of the BackupVault instance (2048 characters or
     * less).
     *
     * Generated from protobuf field <code>optional string description = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $description = null;
    /**
     * Optional. Resource labels to represent user provided metadata.
     * No labels currently defined:
     *
     * Generated from protobuf field <code>map<string, string> labels = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $labels;
    /**
     * Output only. The time when the instance was created.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp create_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. The time when the instance was updated.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp update_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Required. The default and minimum enforced retention for each backup within
     * the backup vault.  The enforced retention for each backup can be extended.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Duration backup_minimum_enforced_retention_duration = 20 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $backup_minimum_enforced_retention_duration = null;
    /**
     * Output only. Set to true when there are no backups nested under this
     * resource.
     *
     * Generated from protobuf field <code>optional bool deletable = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $deletable = null;
    /**
     * Optional. Server specified ETag for the backup vault resource to
     * prevent simultaneous updates from overwiting each other.
     *
     * Generated from protobuf field <code>optional string etag = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $etag = null;
    /**
     * Output only. The BackupVault resource instance state.
     *
     * Generated from protobuf field <code>.google.cloud.backupdr.v1.BackupVault.State state = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;
    /**
     * Optional. Time after which the BackupVault resource is locked.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp effective_time = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $effective_time = null;
    /**
     * Output only. The number of backups in this backup vault.
     *
     * Generated from protobuf field <code>int64 backup_count = 17 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $backup_count = 0;
    /**
     * Output only. Service account used by the BackupVault Service for this
     * BackupVault.  The user should grant this account permissions in their
     * workload project to enable the service to run backups and restores there.
     *
     * Generated from protobuf field <code>string service_account = 18 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $service_account = '';
    /**
     * Output only. Total size of the storage used by all backup resources.
     *
     * Generated from protobuf field <code>int64 total_stored_bytes = 19 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $total_stored_bytes = 0;
    /**
     * Output only. Output only
     * Immutable after resource creation until resource deletion.
     *
     * Generated from protobuf field <code>string uid = 21 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_info) = {</code>
     */
    protected $uid = '';
    /**
     * Optional. User annotations. See https://google.aip.dev/128#annotations
     * Stores small amounts of arbitrary data.
     *
     * Generated from protobuf field <code>map<string, string> annotations = 22 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $annotations;
    /**
     * Optional. Note: This field is added for future use case and will not be
     * supported in the current release.
     * Optional.
     * Access restriction for the backup vault.
     * Default value is WITHIN_ORGANIZATION if not provided during creation.
     *
     * Generated from protobuf field <code>.google.cloud.backupdr.v1.BackupVault.AccessRestriction access_restriction = 24 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $access_restriction = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. Identifier. Name of the backup vault to create. It must have
     *           the
     *           format`"projects/{project}/locations/{location}/backupVaults/{backupvault}"`.
     *           `{backupvault}` cannot be changed after creation. It must be between 3-63
     *           characters long and must be unique within the project and location.
     *     @type string $description
     *           Optional. The description of the BackupVault instance (2048 characters or
     *           less).
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Optional. Resource labels to represent user provided metadata.
     *           No labels currently defined:
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. The time when the instance was created.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. The time when the instance was updated.
     *     @type \Google\Protobuf\Duration $backup_minimum_enforced_retention_duration
     *           Required. The default and minimum enforced retention for each backup within
     *           the backup vault.  The enforced retention for each backup can be extended.
     *     @type bool $deletable
     *           Output only. Set to true when there are no backups nested under this
     *           resource.
     *     @type string $etag
     *           Optional. Server specified ETag for the backup vault resource to
     *           prevent simultaneous updates from overwiting each other.
     *     @type int $state
     *           Output only. The BackupVault resource instance state.
     *     @type \Google\Protobuf\Timestamp $effective_time
     *           Optional. Time after which the BackupVault resource is locked.
     *     @type int|string $backup_count
     *           Output only. The number of backups in this backup vault.
     *     @type string $service_account
     *           Output only. Service account used by the BackupVault Service for this
     *           BackupVault.  The user should grant this account permissions in their
     *           workload project to enable the service to run backups and restores there.
     *     @type int|string $total_stored_bytes
     *           Output only. Total size of the storage used by all backup resources.
     *     @type string $uid
     *           Output only. Output only
     *           Immutable after resource creation until resource deletion.
     *     @type array|\Google\Protobuf\Internal\MapField $annotations
     *           Optional. User annotations. See https://google.aip.dev/128#annotations
     *           Stores small amounts of arbitrary data.
     *     @type int $access_restriction
     *           Optional. Note: This field is added for future use case and will not be
     *           supported in the current release.
     *           Optional.
     *           Access restriction for the backup vault.
     *           Default value is WITHIN_ORGANIZATION if not provided during creation.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Backupdr\V1\Backupvault::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. Identifier. Name of the backup vault to create. It must have
     * the
     * format`"projects/{project}/locations/{location}/backupVaults/{backupvault}"`.
     * `{backupvault}` cannot be changed after creation. It must be between 3-63
     * characters long and must be unique within the project and location.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. Identifier. Name of the backup vault to create. It must have
     * the
     * format`"projects/{project}/locations/{location}/backupVaults/{backupvault}"`.
     * `{backupvault}` cannot be changed after creation. It must be between 3-63
     * characters long and must be unique within the project and location.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Optional. The description of the BackupVault instance (2048 characters or
     * less).
     *
     * Generated from protobuf field <code>optional string description = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDescription()
    {
        return isset($this->description) ? $this->description : '';
    }

    public function hasDescription()
    {
        return isset($this->description);
    }

    public function clearDescription()
    {
        unset($this->description);
    }

    /**
     * Optional. The description of the BackupVault instance (2048 characters or
     * less).
     *
     * Generated from protobuf field <code>optional string description = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Optional. Resource labels to represent user provided metadata.
     * No labels currently defined:
     *
     * Generated from protobuf field <code>map<string, string> labels = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Optional. Resource labels to represent user provided metadata.
     * No labels currently defined:
     *
     * Generated from protobuf field <code>map<string, string> labels = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * Output only. The time when the instance was created.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp create_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. The time when the instance was created.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp create_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. The time when the instance was updated.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp update_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. The time when the instance was updated.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp update_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Required. The default and minimum enforced retention for each backup within
     * the backup vault.  The enforced retention for each backup can be extended.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Duration backup_minimum_enforced_retention_duration = 20 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Duration|null
     */
    public function getBackupMinimumEnforcedRetentionDuration()
    {
        return $this->backup_minimum_enforced_retention_duration;
    }

    public function hasBackupMinimumEnforcedRetentionDuration()
    {
        return isset($this->backup_minimum_enforced_retention_duration);
    }

    public function clearBackupMinimumEnforcedRetentionDuration()
    {
        unset($this->backup_minimum_enforced_retention_duration);
    }

    /**
     * Required. The default and minimum enforced retention for each backup within
     * the backup vault.  The enforced retention for each backup can be extended.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Duration backup_minimum_enforced_retention_duration = 20 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Protobuf\Duration $var
     * @return $this
     */
    public function setBackupMinimumEnforcedRetentionDuration($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Duration::class);
        $this->backup_minimum_enforced_retention_duration = $var;

        return $this;
    }

    /**
     * Output only. Set to true when there are no backups nested under this
     * resource.
     *
     * Generated from protobuf field <code>optional bool deletable = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return bool
     */
    public function getDeletable()
    {
        return isset($this->deletable) ? $this->deletable : false;
    }

    public function hasDeletable()
    {
        return isset($this->deletable);
    }

    public function clearDeletable()
    {
        unset($this->deletable);
    }

    /**
     * Output only. Set to true when there are no backups nested under this
     * resource.
     *
     * Generated from protobuf field <code>optional bool deletable = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param bool $var
     * @return $this
     */
    public function setDeletable($var)
    {
        GPBUtil::checkBool($var);
        $this->deletable = $var;

        return $this;
    }

    /**
     * Optional. Server specified ETag for the backup vault resource to
     * prevent simultaneous updates from overwiting each other.
     *
     * Generated from protobuf field <code>optional string etag = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getEtag()
    {
        return isset($this->etag) ? $this->etag : '';
    }

    public function hasEtag()
    {
        return isset($this->etag);
    }

    public function clearEtag()
    {
        unset($this->etag);
    }

    /**
     * Optional. Server specified ETag for the backup vault resource to
     * prevent simultaneous updates from overwiting each other.
     *
     * Generated from protobuf field <code>optional string etag = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setEtag($var)
    {
        GPBUtil::checkString($var, True);
        $this->etag = $var;

        return $this;
    }

    /**
     * Output only. The BackupVault resource instance state.
     *
     * Generated from protobuf field <code>.google.cloud.backupdr.v1.BackupVault.State state = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. The BackupVault resource instance state.
     *
     * Generated from protobuf field <code>.google.cloud.backupdr.v1.BackupVault.State state = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\BackupDR\V1\BackupVault\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Optional. Time after which the BackupVault resource is locked.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp effective_time = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getEffectiveTime()
    {
        return $this->effective_time;
    }

    public function hasEffectiveTime()
    {
        return isset($this->effective_time);
    }

    public function clearEffectiveTime()
    {
        unset($this->effective_time);
    }

    /**
     * Optional. Time after which the BackupVault resource is locked.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp effective_time = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setEffectiveTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->effective_time = $var;

        return $this;
    }

    /**
     * Output only. The number of backups in this backup vault.
     *
     * Generated from protobuf field <code>int64 backup_count = 17 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int|string
     */
    public function getBackupCount()
    {
        return $this->backup_count;
    }

    /**
     * Output only. The number of backups in this backup vault.
     *
     * Generated from protobuf field <code>int64 backup_count = 17 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int|string $var
     * @return $this
     */
    public function setBackupCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->backup_count = $var;

        return $this;
    }

    /**
     * Output only. Service account used by the BackupVault Service for this
     * BackupVault.  The user should grant this account permissions in their
     * workload project to enable the service to run backups and restores there.
     *
     * Generated from protobuf field <code>string service_account = 18 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getServiceAccount()
    {
        return $this->service_account;
    }

    /**
     * Output only. Service account used by the BackupVault Service for this
     * BackupVault.  The user should grant this account permissions in their
     * workload project to enable the service to run backups and restores there.
     *
     * Generated from protobuf field <code>string service_account = 18 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setServiceAccount($var)
    {
        GPBUtil::checkString($var, True);
        $this->service_account = $var;

        return $this;
    }

    /**
     * Output only. Total size of the storage used by all backup resources.
     *
     * Generated from protobuf field <code>int64 total_stored_bytes = 19 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int|string
     */
    public function getTotalStoredBytes()
    {
        return $this->total_stored_bytes;
    }

    /**
     * Output only. Total size of the storage used by all backup resources.
     *
     * Generated from protobuf field <code>int64 total_stored_bytes = 19 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int|string $var
     * @return $this
     */
    public function setTotalStoredBytes($var)
    {
        GPBUtil::checkInt64($var);
        $this->total_stored_bytes = $var;

        return $this;
    }

    /**
     * Output only. Output only
     * Immutable after resource creation until resource deletion.
     *
     * Generated from protobuf field <code>string uid = 21 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_info) = {</code>
     * @return string
     */
    public function getUid()
    {
        return $this->uid;
    }

    /**
     * Output only. Output only
     * Immutable after resource creation until resource deletion.
     *
     * Generated from protobuf field <code>string uid = 21 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_info) = {</code>
     * @param string $var
     * @return $this
     */
    public function setUid($var)
    {
        GPBUtil::checkString($var, True);
        $this->uid = $var;

        return $this;
    }

    /**
     * Optional. User annotations. See https://google.aip.dev/128#annotations
     * Stores small amounts of arbitrary data.
     *
     * Generated from protobuf field <code>map<string, string> annotations = 22 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getAnnotations()
    {
        return $this->annotations;
    }

    /**
     * Optional. User annotations. See https://google.aip.dev/128#annotations
     * Stores small amounts of arbitrary data.
     *
     * Generated from protobuf field <code>map<string, string> annotations = 22 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setAnnotations($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->annotations = $arr;

        return $this;
    }

    /**
     * Optional. Note: This field is added for future use case and will not be
     * supported in the current release.
     * Optional.
     * Access restriction for the backup vault.
     * Default value is WITHIN_ORGANIZATION if not provided during creation.
     *
     * Generated from protobuf field <code>.google.cloud.backupdr.v1.BackupVault.AccessRestriction access_restriction = 24 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getAccessRestriction()
    {
        return $this->access_restriction;
    }

    /**
     * Optional. Note: This field is added for future use case and will not be
     * supported in the current release.
     * Optional.
     * Access restriction for the backup vault.
     * Default value is WITHIN_ORGANIZATION if not provided during creation.
     *
     * Generated from protobuf field <code>.google.cloud.backupdr.v1.BackupVault.AccessRestriction access_restriction = 24 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setAccessRestriction($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\BackupDR\V1\BackupVault\AccessRestriction::class);
        $this->access_restriction = $var;

        return $this;
    }

}

