<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/backupdr/v1/backupplanassociation.proto

namespace Google\Cloud\BackupDR\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for creating a backup plan.
 *
 * Generated from protobuf message <code>google.cloud.backupdr.v1.CreateBackupPlanAssociationRequest</code>
 */
class CreateBackupPlanAssociationRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The backup plan association project and location in the format
     * `projects/{project_id}/locations/{location}`. In Cloud BackupDR locations
     * map to GCP regions, for example **us-central1**.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The name of the backup plan association to create. The name must
     * be unique for the specified project and location.
     *
     * Generated from protobuf field <code>string backup_plan_association_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $backup_plan_association_id = '';
    /**
     * Required. The resource being created
     *
     * Generated from protobuf field <code>.google.cloud.backupdr.v1.BackupPlanAssociation backup_plan_association = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $backup_plan_association = null;
    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and t
     * he request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL, (.google.api.field_info) = {</code>
     */
    protected $request_id = '';

    /**
     * @param string                                          $parent                  Required. The backup plan association project and location in the format
     *                                                                                 `projects/{project_id}/locations/{location}`. In Cloud BackupDR locations
     *                                                                                 map to GCP regions, for example **us-central1**. Please see
     *                                                                                 {@see BackupDRClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\BackupDR\V1\BackupPlanAssociation $backupPlanAssociation   Required. The resource being created
     * @param string                                          $backupPlanAssociationId Required. The name of the backup plan association to create. The name must
     *                                                                                 be unique for the specified project and location.
     *
     * @return \Google\Cloud\BackupDR\V1\CreateBackupPlanAssociationRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\BackupDR\V1\BackupPlanAssociation $backupPlanAssociation, string $backupPlanAssociationId): self
    {
        return (new self())
            ->setParent($parent)
            ->setBackupPlanAssociation($backupPlanAssociation)
            ->setBackupPlanAssociationId($backupPlanAssociationId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The backup plan association project and location in the format
     *           `projects/{project_id}/locations/{location}`. In Cloud BackupDR locations
     *           map to GCP regions, for example **us-central1**.
     *     @type string $backup_plan_association_id
     *           Required. The name of the backup plan association to create. The name must
     *           be unique for the specified project and location.
     *     @type \Google\Cloud\BackupDR\V1\BackupPlanAssociation $backup_plan_association
     *           Required. The resource being created
     *     @type string $request_id
     *           Optional. An optional request ID to identify requests. Specify a unique
     *           request ID so that if you must retry your request, the server will know to
     *           ignore the request if it has already been completed. The server will
     *           guarantee that for at least 60 minutes since the first request.
     *           For example, consider a situation where you make an initial request and t
     *           he request times out. If you make the request again with the same request
     *           ID, the server can check if original operation with the same request ID
     *           was received, and if so, will ignore the second request. This prevents
     *           clients from accidentally creating duplicate commitments.
     *           The request ID must be a valid UUID with the exception that zero UUID is
     *           not supported (00000000-0000-0000-0000-000000000000).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Backupdr\V1\Backupplanassociation::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The backup plan association project and location in the format
     * `projects/{project_id}/locations/{location}`. In Cloud BackupDR locations
     * map to GCP regions, for example **us-central1**.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The backup plan association project and location in the format
     * `projects/{project_id}/locations/{location}`. In Cloud BackupDR locations
     * map to GCP regions, for example **us-central1**.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The name of the backup plan association to create. The name must
     * be unique for the specified project and location.
     *
     * Generated from protobuf field <code>string backup_plan_association_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getBackupPlanAssociationId()
    {
        return $this->backup_plan_association_id;
    }

    /**
     * Required. The name of the backup plan association to create. The name must
     * be unique for the specified project and location.
     *
     * Generated from protobuf field <code>string backup_plan_association_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setBackupPlanAssociationId($var)
    {
        GPBUtil::checkString($var, True);
        $this->backup_plan_association_id = $var;

        return $this;
    }

    /**
     * Required. The resource being created
     *
     * Generated from protobuf field <code>.google.cloud.backupdr.v1.BackupPlanAssociation backup_plan_association = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\BackupDR\V1\BackupPlanAssociation|null
     */
    public function getBackupPlanAssociation()
    {
        return $this->backup_plan_association;
    }

    public function hasBackupPlanAssociation()
    {
        return isset($this->backup_plan_association);
    }

    public function clearBackupPlanAssociation()
    {
        unset($this->backup_plan_association);
    }

    /**
     * Required. The resource being created
     *
     * Generated from protobuf field <code>.google.cloud.backupdr.v1.BackupPlanAssociation backup_plan_association = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\BackupDR\V1\BackupPlanAssociation $var
     * @return $this
     */
    public function setBackupPlanAssociation($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\BackupDR\V1\BackupPlanAssociation::class);
        $this->backup_plan_association = $var;

        return $this;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and t
     * he request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL, (.google.api.field_info) = {</code>
     * @return string
     */
    public function getRequestId()
    {
        return $this->request_id;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and t
     * he request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL, (.google.api.field_info) = {</code>
     * @param string $var
     * @return $this
     */
    public function setRequestId($var)
    {
        GPBUtil::checkString($var, True);
        $this->request_id = $var;

        return $this;
    }

}

