<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/backupdr/v1/backupvault_gce.proto

namespace Google\Cloud\BackupDR\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A customer-supplied encryption key.
 *
 * Generated from protobuf message <code>google.cloud.backupdr.v1.CustomerEncryptionKey</code>
 */
class CustomerEncryptionKey extends \Google\Protobuf\Internal\Message
{
    /**
     * Optional. The service account being used for the encryption request for the
     * given KMS key. If absent, the Compute Engine default service account is
     * used.
     *
     * Generated from protobuf field <code>optional string kms_key_service_account = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $kms_key_service_account = null;
    protected $key;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $raw_key
     *           Optional. Specifies a 256-bit customer-supplied
     *           encryption key.
     *     @type string $rsa_encrypted_key
     *           Optional. RSA-wrapped 2048-bit
     *           customer-supplied encryption key to either encrypt or decrypt this
     *           resource.
     *     @type string $kms_key_name
     *           Optional. The name of the encryption key that is stored in Google Cloud
     *           KMS.
     *     @type string $kms_key_service_account
     *           Optional. The service account being used for the encryption request for the
     *           given KMS key. If absent, the Compute Engine default service account is
     *           used.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Backupdr\V1\BackupvaultGce::initOnce();
        parent::__construct($data);
    }

    /**
     * Optional. Specifies a 256-bit customer-supplied
     * encryption key.
     *
     * Generated from protobuf field <code>string raw_key = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getRawKey()
    {
        return $this->readOneof(1);
    }

    public function hasRawKey()
    {
        return $this->hasOneof(1);
    }

    /**
     * Optional. Specifies a 256-bit customer-supplied
     * encryption key.
     *
     * Generated from protobuf field <code>string raw_key = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setRawKey($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(1, $var);

        return $this;
    }

    /**
     * Optional. RSA-wrapped 2048-bit
     * customer-supplied encryption key to either encrypt or decrypt this
     * resource.
     *
     * Generated from protobuf field <code>string rsa_encrypted_key = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getRsaEncryptedKey()
    {
        return $this->readOneof(2);
    }

    public function hasRsaEncryptedKey()
    {
        return $this->hasOneof(2);
    }

    /**
     * Optional. RSA-wrapped 2048-bit
     * customer-supplied encryption key to either encrypt or decrypt this
     * resource.
     *
     * Generated from protobuf field <code>string rsa_encrypted_key = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setRsaEncryptedKey($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     * Optional. The name of the encryption key that is stored in Google Cloud
     * KMS.
     *
     * Generated from protobuf field <code>string kms_key_name = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getKmsKeyName()
    {
        return $this->readOneof(3);
    }

    public function hasKmsKeyName()
    {
        return $this->hasOneof(3);
    }

    /**
     * Optional. The name of the encryption key that is stored in Google Cloud
     * KMS.
     *
     * Generated from protobuf field <code>string kms_key_name = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setKmsKeyName($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(3, $var);

        return $this;
    }

    /**
     * Optional. The service account being used for the encryption request for the
     * given KMS key. If absent, the Compute Engine default service account is
     * used.
     *
     * Generated from protobuf field <code>optional string kms_key_service_account = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getKmsKeyServiceAccount()
    {
        return isset($this->kms_key_service_account) ? $this->kms_key_service_account : '';
    }

    public function hasKmsKeyServiceAccount()
    {
        return isset($this->kms_key_service_account);
    }

    public function clearKmsKeyServiceAccount()
    {
        unset($this->kms_key_service_account);
    }

    /**
     * Optional. The service account being used for the encryption request for the
     * given KMS key. If absent, the Compute Engine default service account is
     * used.
     *
     * Generated from protobuf field <code>optional string kms_key_service_account = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setKmsKeyServiceAccount($var)
    {
        GPBUtil::checkString($var, True);
        $this->kms_key_service_account = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getKey()
    {
        return $this->whichOneof("key");
    }

}

