<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/baremetalsolution/v2/ssh_key.proto

namespace Google\Cloud\BareMetalSolution\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message for registering a public SSH key in a project.
 *
 * Generated from protobuf message <code>google.cloud.baremetalsolution.v2.CreateSSHKeyRequest</code>
 */
class CreateSSHKeyRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent containing the SSH keys.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The SSH key to register.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.SSHKey ssh_key = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $ssh_key = null;
    /**
     * Required. The ID to use for the key, which will become the final component
     * of the key's resource name.
     * This value must match the regex:
     *   [a-zA-Z0-9&#64;.\-_]{1,64}
     *
     * Generated from protobuf field <code>string ssh_key_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $ssh_key_id = '';

    /**
     * @param string                                    $parent   Required. The parent containing the SSH keys. Please see
     *                                                            {@see BareMetalSolutionClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\BareMetalSolution\V2\SSHKey $sshKey   Required. The SSH key to register.
     * @param string                                    $sshKeyId Required. The ID to use for the key, which will become the final component
     *                                                            of the key's resource name.
     *
     *                                                            This value must match the regex:
     *                                                            [a-zA-Z0-9&#64;.\-_]{1,64}
     *
     * @return \Google\Cloud\BareMetalSolution\V2\CreateSSHKeyRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\BareMetalSolution\V2\SSHKey $sshKey, string $sshKeyId): self
    {
        return (new self())
            ->setParent($parent)
            ->setSshKey($sshKey)
            ->setSshKeyId($sshKeyId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent containing the SSH keys.
     *     @type \Google\Cloud\BareMetalSolution\V2\SSHKey $ssh_key
     *           Required. The SSH key to register.
     *     @type string $ssh_key_id
     *           Required. The ID to use for the key, which will become the final component
     *           of the key's resource name.
     *           This value must match the regex:
     *             [a-zA-Z0-9&#64;.\-_]{1,64}
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Baremetalsolution\V2\SshKey::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent containing the SSH keys.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent containing the SSH keys.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The SSH key to register.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.SSHKey ssh_key = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\BareMetalSolution\V2\SSHKey|null
     */
    public function getSshKey()
    {
        return $this->ssh_key;
    }

    public function hasSshKey()
    {
        return isset($this->ssh_key);
    }

    public function clearSshKey()
    {
        unset($this->ssh_key);
    }

    /**
     * Required. The SSH key to register.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.SSHKey ssh_key = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\BareMetalSolution\V2\SSHKey $var
     * @return $this
     */
    public function setSshKey($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\BareMetalSolution\V2\SSHKey::class);
        $this->ssh_key = $var;

        return $this;
    }

    /**
     * Required. The ID to use for the key, which will become the final component
     * of the key's resource name.
     * This value must match the regex:
     *   [a-zA-Z0-9&#64;.\-_]{1,64}
     *
     * Generated from protobuf field <code>string ssh_key_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getSshKeyId()
    {
        return $this->ssh_key_id;
    }

    /**
     * Required. The ID to use for the key, which will become the final component
     * of the key's resource name.
     * This value must match the regex:
     *   [a-zA-Z0-9&#64;.\-_]{1,64}
     *
     * Generated from protobuf field <code>string ssh_key_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setSshKeyId($var)
    {
        GPBUtil::checkString($var, True);
        $this->ssh_key_id = $var;

        return $this;
    }

}

