<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/baremetalsolution/v2/provisioning.proto

namespace Google\Cloud\BareMetalSolution\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Configuration parameters for a new network.
 *
 * Generated from protobuf message <code>google.cloud.baremetalsolution.v2.NetworkConfig</code>
 */
class NetworkConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The name of the network config.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $name = '';
    /**
     * A transient unique identifier to identify a volume within an
     * ProvisioningConfig request.
     *
     * Generated from protobuf field <code>string id = 2;</code>
     */
    protected $id = '';
    /**
     * The type of this network, either Client or Private.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.NetworkConfig.Type type = 3;</code>
     */
    protected $type = 0;
    /**
     * Interconnect bandwidth. Set only when type is CLIENT.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.NetworkConfig.Bandwidth bandwidth = 4;</code>
     */
    protected $bandwidth = 0;
    /**
     * List of VLAN attachments. As of now there are always 2 attachments, but it
     * is going to change in  the future (multi vlan).
     *
     * Generated from protobuf field <code>repeated .google.cloud.baremetalsolution.v2.NetworkConfig.IntakeVlanAttachment vlan_attachments = 5;</code>
     */
    private $vlan_attachments;
    /**
     * CIDR range of the network.
     *
     * Generated from protobuf field <code>string cidr = 6;</code>
     */
    protected $cidr = '';
    /**
     * Service CIDR, if any.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.NetworkConfig.ServiceCidr service_cidr = 7;</code>
     */
    protected $service_cidr = 0;
    /**
     * User note field, it can be used by customers to add additional information
     * for the BMS Ops team .
     *
     * Generated from protobuf field <code>string user_note = 8;</code>
     */
    protected $user_note = '';
    /**
     * The GCP service of the network. Available gcp_service are in
     * https://cloud.google.com/bare-metal/docs/bms-planning.
     *
     * Generated from protobuf field <code>string gcp_service = 9;</code>
     */
    protected $gcp_service = '';
    /**
     * Whether the VLAN attachment pair is located in the same project.
     *
     * Generated from protobuf field <code>bool vlan_same_project = 10;</code>
     */
    protected $vlan_same_project = false;
    /**
     * The JumboFramesEnabled option for customer to set.
     *
     * Generated from protobuf field <code>bool jumbo_frames_enabled = 11;</code>
     */
    protected $jumbo_frames_enabled = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. The name of the network config.
     *     @type string $id
     *           A transient unique identifier to identify a volume within an
     *           ProvisioningConfig request.
     *     @type int $type
     *           The type of this network, either Client or Private.
     *     @type int $bandwidth
     *           Interconnect bandwidth. Set only when type is CLIENT.
     *     @type array<\Google\Cloud\BareMetalSolution\V2\NetworkConfig\IntakeVlanAttachment>|\Google\Protobuf\Internal\RepeatedField $vlan_attachments
     *           List of VLAN attachments. As of now there are always 2 attachments, but it
     *           is going to change in  the future (multi vlan).
     *     @type string $cidr
     *           CIDR range of the network.
     *     @type int $service_cidr
     *           Service CIDR, if any.
     *     @type string $user_note
     *           User note field, it can be used by customers to add additional information
     *           for the BMS Ops team .
     *     @type string $gcp_service
     *           The GCP service of the network. Available gcp_service are in
     *           https://cloud.google.com/bare-metal/docs/bms-planning.
     *     @type bool $vlan_same_project
     *           Whether the VLAN attachment pair is located in the same project.
     *     @type bool $jumbo_frames_enabled
     *           The JumboFramesEnabled option for customer to set.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Baremetalsolution\V2\Provisioning::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The name of the network config.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. The name of the network config.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * A transient unique identifier to identify a volume within an
     * ProvisioningConfig request.
     *
     * Generated from protobuf field <code>string id = 2;</code>
     * @return string
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * A transient unique identifier to identify a volume within an
     * ProvisioningConfig request.
     *
     * Generated from protobuf field <code>string id = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setId($var)
    {
        GPBUtil::checkString($var, True);
        $this->id = $var;

        return $this;
    }

    /**
     * The type of this network, either Client or Private.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.NetworkConfig.Type type = 3;</code>
     * @return int
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * The type of this network, either Client or Private.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.NetworkConfig.Type type = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\BareMetalSolution\V2\NetworkConfig\Type::class);
        $this->type = $var;

        return $this;
    }

    /**
     * Interconnect bandwidth. Set only when type is CLIENT.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.NetworkConfig.Bandwidth bandwidth = 4;</code>
     * @return int
     */
    public function getBandwidth()
    {
        return $this->bandwidth;
    }

    /**
     * Interconnect bandwidth. Set only when type is CLIENT.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.NetworkConfig.Bandwidth bandwidth = 4;</code>
     * @param int $var
     * @return $this
     */
    public function setBandwidth($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\BareMetalSolution\V2\NetworkConfig\Bandwidth::class);
        $this->bandwidth = $var;

        return $this;
    }

    /**
     * List of VLAN attachments. As of now there are always 2 attachments, but it
     * is going to change in  the future (multi vlan).
     *
     * Generated from protobuf field <code>repeated .google.cloud.baremetalsolution.v2.NetworkConfig.IntakeVlanAttachment vlan_attachments = 5;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getVlanAttachments()
    {
        return $this->vlan_attachments;
    }

    /**
     * List of VLAN attachments. As of now there are always 2 attachments, but it
     * is going to change in  the future (multi vlan).
     *
     * Generated from protobuf field <code>repeated .google.cloud.baremetalsolution.v2.NetworkConfig.IntakeVlanAttachment vlan_attachments = 5;</code>
     * @param array<\Google\Cloud\BareMetalSolution\V2\NetworkConfig\IntakeVlanAttachment>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setVlanAttachments($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\BareMetalSolution\V2\NetworkConfig\IntakeVlanAttachment::class);
        $this->vlan_attachments = $arr;

        return $this;
    }

    /**
     * CIDR range of the network.
     *
     * Generated from protobuf field <code>string cidr = 6;</code>
     * @return string
     */
    public function getCidr()
    {
        return $this->cidr;
    }

    /**
     * CIDR range of the network.
     *
     * Generated from protobuf field <code>string cidr = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setCidr($var)
    {
        GPBUtil::checkString($var, True);
        $this->cidr = $var;

        return $this;
    }

    /**
     * Service CIDR, if any.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.NetworkConfig.ServiceCidr service_cidr = 7;</code>
     * @return int
     */
    public function getServiceCidr()
    {
        return $this->service_cidr;
    }

    /**
     * Service CIDR, if any.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.NetworkConfig.ServiceCidr service_cidr = 7;</code>
     * @param int $var
     * @return $this
     */
    public function setServiceCidr($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\BareMetalSolution\V2\NetworkConfig\ServiceCidr::class);
        $this->service_cidr = $var;

        return $this;
    }

    /**
     * User note field, it can be used by customers to add additional information
     * for the BMS Ops team .
     *
     * Generated from protobuf field <code>string user_note = 8;</code>
     * @return string
     */
    public function getUserNote()
    {
        return $this->user_note;
    }

    /**
     * User note field, it can be used by customers to add additional information
     * for the BMS Ops team .
     *
     * Generated from protobuf field <code>string user_note = 8;</code>
     * @param string $var
     * @return $this
     */
    public function setUserNote($var)
    {
        GPBUtil::checkString($var, True);
        $this->user_note = $var;

        return $this;
    }

    /**
     * The GCP service of the network. Available gcp_service are in
     * https://cloud.google.com/bare-metal/docs/bms-planning.
     *
     * Generated from protobuf field <code>string gcp_service = 9;</code>
     * @return string
     */
    public function getGcpService()
    {
        return $this->gcp_service;
    }

    /**
     * The GCP service of the network. Available gcp_service are in
     * https://cloud.google.com/bare-metal/docs/bms-planning.
     *
     * Generated from protobuf field <code>string gcp_service = 9;</code>
     * @param string $var
     * @return $this
     */
    public function setGcpService($var)
    {
        GPBUtil::checkString($var, True);
        $this->gcp_service = $var;

        return $this;
    }

    /**
     * Whether the VLAN attachment pair is located in the same project.
     *
     * Generated from protobuf field <code>bool vlan_same_project = 10;</code>
     * @return bool
     */
    public function getVlanSameProject()
    {
        return $this->vlan_same_project;
    }

    /**
     * Whether the VLAN attachment pair is located in the same project.
     *
     * Generated from protobuf field <code>bool vlan_same_project = 10;</code>
     * @param bool $var
     * @return $this
     */
    public function setVlanSameProject($var)
    {
        GPBUtil::checkBool($var);
        $this->vlan_same_project = $var;

        return $this;
    }

    /**
     * The JumboFramesEnabled option for customer to set.
     *
     * Generated from protobuf field <code>bool jumbo_frames_enabled = 11;</code>
     * @return bool
     */
    public function getJumboFramesEnabled()
    {
        return $this->jumbo_frames_enabled;
    }

    /**
     * The JumboFramesEnabled option for customer to set.
     *
     * Generated from protobuf field <code>bool jumbo_frames_enabled = 11;</code>
     * @param bool $var
     * @return $this
     */
    public function setJumboFramesEnabled($var)
    {
        GPBUtil::checkBool($var);
        $this->jumbo_frames_enabled = $var;

        return $this;
    }

}

