<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/baremetalsolution/v2/nfs_share.proto

namespace Google\Cloud\BareMetalSolution\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An NFS share.
 *
 * Generated from protobuf message <code>google.cloud.baremetalsolution.v2.NfsShare</code>
 */
class NfsShare extends \Google\Protobuf\Internal\Message
{
    /**
     * Immutable. The name of the NFS share.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IMMUTABLE];</code>
     */
    protected $name = '';
    /**
     * Output only. An identifier for the NFS share, generated by the backend.
     * This field will be deprecated in the future, use `id` instead.
     *
     * Generated from protobuf field <code>string nfs_share_id = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $nfs_share_id = '';
    /**
     * Output only. An identifier for the NFS share, generated by the backend.
     * This is the same value as nfs_share_id and will replace it in the future.
     *
     * Generated from protobuf field <code>string id = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $id = '';
    /**
     * Output only. The state of the NFS share.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.NfsShare.State state = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;
    /**
     * Output only. The underlying volume of the share. Created automatically
     * during provisioning.
     *
     * Generated from protobuf field <code>string volume = 4 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     */
    protected $volume = '';
    /**
     * List of allowed access points.
     *
     * Generated from protobuf field <code>repeated .google.cloud.baremetalsolution.v2.NfsShare.AllowedClient allowed_clients = 5;</code>
     */
    private $allowed_clients;
    /**
     * Labels as key value pairs.
     *
     * Generated from protobuf field <code>map<string, string> labels = 6;</code>
     */
    private $labels;
    /**
     * The requested size, in GiB.
     *
     * Generated from protobuf field <code>int64 requested_size_gib = 7;</code>
     */
    protected $requested_size_gib = 0;
    /**
     * Immutable. The storage type of the underlying volume.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.NfsShare.StorageType storage_type = 9 [(.google.api.field_behavior) = IMMUTABLE];</code>
     */
    protected $storage_type = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Immutable. The name of the NFS share.
     *     @type string $nfs_share_id
     *           Output only. An identifier for the NFS share, generated by the backend.
     *           This field will be deprecated in the future, use `id` instead.
     *     @type string $id
     *           Output only. An identifier for the NFS share, generated by the backend.
     *           This is the same value as nfs_share_id and will replace it in the future.
     *     @type int $state
     *           Output only. The state of the NFS share.
     *     @type string $volume
     *           Output only. The underlying volume of the share. Created automatically
     *           during provisioning.
     *     @type array<\Google\Cloud\BareMetalSolution\V2\NfsShare\AllowedClient>|\Google\Protobuf\Internal\RepeatedField $allowed_clients
     *           List of allowed access points.
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Labels as key value pairs.
     *     @type int|string $requested_size_gib
     *           The requested size, in GiB.
     *     @type int $storage_type
     *           Immutable. The storage type of the underlying volume.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Baremetalsolution\V2\NfsShare::initOnce();
        parent::__construct($data);
    }

    /**
     * Immutable. The name of the NFS share.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Immutable. The name of the NFS share.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. An identifier for the NFS share, generated by the backend.
     * This field will be deprecated in the future, use `id` instead.
     *
     * Generated from protobuf field <code>string nfs_share_id = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getNfsShareId()
    {
        return $this->nfs_share_id;
    }

    /**
     * Output only. An identifier for the NFS share, generated by the backend.
     * This field will be deprecated in the future, use `id` instead.
     *
     * Generated from protobuf field <code>string nfs_share_id = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setNfsShareId($var)
    {
        GPBUtil::checkString($var, True);
        $this->nfs_share_id = $var;

        return $this;
    }

    /**
     * Output only. An identifier for the NFS share, generated by the backend.
     * This is the same value as nfs_share_id and will replace it in the future.
     *
     * Generated from protobuf field <code>string id = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Output only. An identifier for the NFS share, generated by the backend.
     * This is the same value as nfs_share_id and will replace it in the future.
     *
     * Generated from protobuf field <code>string id = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setId($var)
    {
        GPBUtil::checkString($var, True);
        $this->id = $var;

        return $this;
    }

    /**
     * Output only. The state of the NFS share.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.NfsShare.State state = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. The state of the NFS share.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.NfsShare.State state = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\BareMetalSolution\V2\NfsShare\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Output only. The underlying volume of the share. Created automatically
     * during provisioning.
     *
     * Generated from protobuf field <code>string volume = 4 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getVolume()
    {
        return $this->volume;
    }

    /**
     * Output only. The underlying volume of the share. Created automatically
     * during provisioning.
     *
     * Generated from protobuf field <code>string volume = 4 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setVolume($var)
    {
        GPBUtil::checkString($var, True);
        $this->volume = $var;

        return $this;
    }

    /**
     * List of allowed access points.
     *
     * Generated from protobuf field <code>repeated .google.cloud.baremetalsolution.v2.NfsShare.AllowedClient allowed_clients = 5;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getAllowedClients()
    {
        return $this->allowed_clients;
    }

    /**
     * List of allowed access points.
     *
     * Generated from protobuf field <code>repeated .google.cloud.baremetalsolution.v2.NfsShare.AllowedClient allowed_clients = 5;</code>
     * @param array<\Google\Cloud\BareMetalSolution\V2\NfsShare\AllowedClient>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setAllowedClients($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\BareMetalSolution\V2\NfsShare\AllowedClient::class);
        $this->allowed_clients = $arr;

        return $this;
    }

    /**
     * Labels as key value pairs.
     *
     * Generated from protobuf field <code>map<string, string> labels = 6;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Labels as key value pairs.
     *
     * Generated from protobuf field <code>map<string, string> labels = 6;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * The requested size, in GiB.
     *
     * Generated from protobuf field <code>int64 requested_size_gib = 7;</code>
     * @return int|string
     */
    public function getRequestedSizeGib()
    {
        return $this->requested_size_gib;
    }

    /**
     * The requested size, in GiB.
     *
     * Generated from protobuf field <code>int64 requested_size_gib = 7;</code>
     * @param int|string $var
     * @return $this
     */
    public function setRequestedSizeGib($var)
    {
        GPBUtil::checkInt64($var);
        $this->requested_size_gib = $var;

        return $this;
    }

    /**
     * Immutable. The storage type of the underlying volume.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.NfsShare.StorageType storage_type = 9 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @return int
     */
    public function getStorageType()
    {
        return $this->storage_type;
    }

    /**
     * Immutable. The storage type of the underlying volume.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.NfsShare.StorageType storage_type = 9 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @param int $var
     * @return $this
     */
    public function setStorageType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\BareMetalSolution\V2\NfsShare\StorageType::class);
        $this->storage_type = $var;

        return $this;
    }

}

