<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/baremetalsolution/v2/provisioning.proto

namespace Google\Cloud\BareMetalSolution\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A provisioning configuration.
 *
 * Generated from protobuf message <code>google.cloud.baremetalsolution.v2.ProvisioningConfig</code>
 */
class ProvisioningConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The system-generated name of the provisioning config. This
     * follows the UUID format.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $name = '';
    /**
     * Instances to be created.
     *
     * Generated from protobuf field <code>repeated .google.cloud.baremetalsolution.v2.InstanceConfig instances = 2;</code>
     */
    private $instances;
    /**
     * Networks to be created.
     *
     * Generated from protobuf field <code>repeated .google.cloud.baremetalsolution.v2.NetworkConfig networks = 3;</code>
     */
    private $networks;
    /**
     * Volumes to be created.
     *
     * Generated from protobuf field <code>repeated .google.cloud.baremetalsolution.v2.VolumeConfig volumes = 4;</code>
     */
    private $volumes;
    /**
     * A generated ticket id to track provisioning request.
     *
     * Generated from protobuf field <code>string ticket_id = 5;</code>
     */
    protected $ticket_id = '';
    /**
     * A service account to enable customers to access instance credentials upon
     * handover.
     *
     * Generated from protobuf field <code>string handover_service_account = 6;</code>
     */
    protected $handover_service_account = '';
    /**
     * Email provided to send a confirmation with provisioning config to.
     * Deprecated in favour of email field in request messages.
     *
     * Generated from protobuf field <code>string email = 7 [deprecated = true];</code>
     * @deprecated
     */
    protected $email = '';
    /**
     * Output only. State of ProvisioningConfig.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.ProvisioningConfig.State state = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;
    /**
     * Optional. Location name of this ProvisioningConfig.
     * It is optional only for Intake UI transition period.
     *
     * Generated from protobuf field <code>string location = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $location = '';
    /**
     * Output only. Last update timestamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Output only. URI to Cloud Console UI view of this provisioning config.
     *
     * Generated from protobuf field <code>string cloud_console_uri = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $cloud_console_uri = '';
    /**
     * If true, VPC SC is enabled for the cluster.
     *
     * Generated from protobuf field <code>bool vpc_sc_enabled = 12;</code>
     */
    protected $vpc_sc_enabled = false;
    /**
     * Optional status messages associated with the FAILED state.
     *
     * Generated from protobuf field <code>string status_message = 13;</code>
     */
    protected $status_message = '';
    /**
     * Optional. The user-defined identifier of the provisioning config.
     *
     * Generated from protobuf field <code>string custom_id = 14 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $custom_id = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. The system-generated name of the provisioning config. This
     *           follows the UUID format.
     *     @type array<\Google\Cloud\BareMetalSolution\V2\InstanceConfig>|\Google\Protobuf\Internal\RepeatedField $instances
     *           Instances to be created.
     *     @type array<\Google\Cloud\BareMetalSolution\V2\NetworkConfig>|\Google\Protobuf\Internal\RepeatedField $networks
     *           Networks to be created.
     *     @type array<\Google\Cloud\BareMetalSolution\V2\VolumeConfig>|\Google\Protobuf\Internal\RepeatedField $volumes
     *           Volumes to be created.
     *     @type string $ticket_id
     *           A generated ticket id to track provisioning request.
     *     @type string $handover_service_account
     *           A service account to enable customers to access instance credentials upon
     *           handover.
     *     @type string $email
     *           Email provided to send a confirmation with provisioning config to.
     *           Deprecated in favour of email field in request messages.
     *     @type int $state
     *           Output only. State of ProvisioningConfig.
     *     @type string $location
     *           Optional. Location name of this ProvisioningConfig.
     *           It is optional only for Intake UI transition period.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. Last update timestamp.
     *     @type string $cloud_console_uri
     *           Output only. URI to Cloud Console UI view of this provisioning config.
     *     @type bool $vpc_sc_enabled
     *           If true, VPC SC is enabled for the cluster.
     *     @type string $status_message
     *           Optional status messages associated with the FAILED state.
     *     @type string $custom_id
     *           Optional. The user-defined identifier of the provisioning config.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Baremetalsolution\V2\Provisioning::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The system-generated name of the provisioning config. This
     * follows the UUID format.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. The system-generated name of the provisioning config. This
     * follows the UUID format.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Instances to be created.
     *
     * Generated from protobuf field <code>repeated .google.cloud.baremetalsolution.v2.InstanceConfig instances = 2;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getInstances()
    {
        return $this->instances;
    }

    /**
     * Instances to be created.
     *
     * Generated from protobuf field <code>repeated .google.cloud.baremetalsolution.v2.InstanceConfig instances = 2;</code>
     * @param array<\Google\Cloud\BareMetalSolution\V2\InstanceConfig>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setInstances($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\BareMetalSolution\V2\InstanceConfig::class);
        $this->instances = $arr;

        return $this;
    }

    /**
     * Networks to be created.
     *
     * Generated from protobuf field <code>repeated .google.cloud.baremetalsolution.v2.NetworkConfig networks = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getNetworks()
    {
        return $this->networks;
    }

    /**
     * Networks to be created.
     *
     * Generated from protobuf field <code>repeated .google.cloud.baremetalsolution.v2.NetworkConfig networks = 3;</code>
     * @param array<\Google\Cloud\BareMetalSolution\V2\NetworkConfig>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setNetworks($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\BareMetalSolution\V2\NetworkConfig::class);
        $this->networks = $arr;

        return $this;
    }

    /**
     * Volumes to be created.
     *
     * Generated from protobuf field <code>repeated .google.cloud.baremetalsolution.v2.VolumeConfig volumes = 4;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getVolumes()
    {
        return $this->volumes;
    }

    /**
     * Volumes to be created.
     *
     * Generated from protobuf field <code>repeated .google.cloud.baremetalsolution.v2.VolumeConfig volumes = 4;</code>
     * @param array<\Google\Cloud\BareMetalSolution\V2\VolumeConfig>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setVolumes($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\BareMetalSolution\V2\VolumeConfig::class);
        $this->volumes = $arr;

        return $this;
    }

    /**
     * A generated ticket id to track provisioning request.
     *
     * Generated from protobuf field <code>string ticket_id = 5;</code>
     * @return string
     */
    public function getTicketId()
    {
        return $this->ticket_id;
    }

    /**
     * A generated ticket id to track provisioning request.
     *
     * Generated from protobuf field <code>string ticket_id = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setTicketId($var)
    {
        GPBUtil::checkString($var, True);
        $this->ticket_id = $var;

        return $this;
    }

    /**
     * A service account to enable customers to access instance credentials upon
     * handover.
     *
     * Generated from protobuf field <code>string handover_service_account = 6;</code>
     * @return string
     */
    public function getHandoverServiceAccount()
    {
        return $this->handover_service_account;
    }

    /**
     * A service account to enable customers to access instance credentials upon
     * handover.
     *
     * Generated from protobuf field <code>string handover_service_account = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setHandoverServiceAccount($var)
    {
        GPBUtil::checkString($var, True);
        $this->handover_service_account = $var;

        return $this;
    }

    /**
     * Email provided to send a confirmation with provisioning config to.
     * Deprecated in favour of email field in request messages.
     *
     * Generated from protobuf field <code>string email = 7 [deprecated = true];</code>
     * @return string
     * @deprecated
     */
    public function getEmail()
    {
        @trigger_error('email is deprecated.', E_USER_DEPRECATED);
        return $this->email;
    }

    /**
     * Email provided to send a confirmation with provisioning config to.
     * Deprecated in favour of email field in request messages.
     *
     * Generated from protobuf field <code>string email = 7 [deprecated = true];</code>
     * @param string $var
     * @return $this
     * @deprecated
     */
    public function setEmail($var)
    {
        @trigger_error('email is deprecated.', E_USER_DEPRECATED);
        GPBUtil::checkString($var, True);
        $this->email = $var;

        return $this;
    }

    /**
     * Output only. State of ProvisioningConfig.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.ProvisioningConfig.State state = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. State of ProvisioningConfig.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.ProvisioningConfig.State state = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\BareMetalSolution\V2\ProvisioningConfig\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Optional. Location name of this ProvisioningConfig.
     * It is optional only for Intake UI transition period.
     *
     * Generated from protobuf field <code>string location = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getLocation()
    {
        return $this->location;
    }

    /**
     * Optional. Location name of this ProvisioningConfig.
     * It is optional only for Intake UI transition period.
     *
     * Generated from protobuf field <code>string location = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setLocation($var)
    {
        GPBUtil::checkString($var, True);
        $this->location = $var;

        return $this;
    }

    /**
     * Output only. Last update timestamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. Last update timestamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Output only. URI to Cloud Console UI view of this provisioning config.
     *
     * Generated from protobuf field <code>string cloud_console_uri = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getCloudConsoleUri()
    {
        return $this->cloud_console_uri;
    }

    /**
     * Output only. URI to Cloud Console UI view of this provisioning config.
     *
     * Generated from protobuf field <code>string cloud_console_uri = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setCloudConsoleUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->cloud_console_uri = $var;

        return $this;
    }

    /**
     * If true, VPC SC is enabled for the cluster.
     *
     * Generated from protobuf field <code>bool vpc_sc_enabled = 12;</code>
     * @return bool
     */
    public function getVpcScEnabled()
    {
        return $this->vpc_sc_enabled;
    }

    /**
     * If true, VPC SC is enabled for the cluster.
     *
     * Generated from protobuf field <code>bool vpc_sc_enabled = 12;</code>
     * @param bool $var
     * @return $this
     */
    public function setVpcScEnabled($var)
    {
        GPBUtil::checkBool($var);
        $this->vpc_sc_enabled = $var;

        return $this;
    }

    /**
     * Optional status messages associated with the FAILED state.
     *
     * Generated from protobuf field <code>string status_message = 13;</code>
     * @return string
     */
    public function getStatusMessage()
    {
        return $this->status_message;
    }

    /**
     * Optional status messages associated with the FAILED state.
     *
     * Generated from protobuf field <code>string status_message = 13;</code>
     * @param string $var
     * @return $this
     */
    public function setStatusMessage($var)
    {
        GPBUtil::checkString($var, True);
        $this->status_message = $var;

        return $this;
    }

    /**
     * Optional. The user-defined identifier of the provisioning config.
     *
     * Generated from protobuf field <code>string custom_id = 14 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getCustomId()
    {
        return $this->custom_id;
    }

    /**
     * Optional. The user-defined identifier of the provisioning config.
     *
     * Generated from protobuf field <code>string custom_id = 14 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setCustomId($var)
    {
        GPBUtil::checkString($var, True);
        $this->custom_id = $var;

        return $this;
    }

}

