<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/baremetalsolution/v2/provisioning.proto

namespace Google\Cloud\BareMetalSolution\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A provisioning quota for a given project.
 *
 * Generated from protobuf message <code>google.cloud.baremetalsolution.v2.ProvisioningQuota</code>
 */
class ProvisioningQuota extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The name of the provisioning quota.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $name = '';
    /**
     * The asset type of this provisioning quota.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.ProvisioningQuota.AssetType asset_type = 2;</code>
     */
    protected $asset_type = 0;
    /**
     * The gcp service of the provisioning quota.
     *
     * Generated from protobuf field <code>string gcp_service = 3;</code>
     */
    protected $gcp_service = '';
    /**
     * The specific location of the provisioining quota.
     *
     * Generated from protobuf field <code>string location = 4;</code>
     */
    protected $location = '';
    /**
     * The available count of the provisioning quota.
     *
     * Generated from protobuf field <code>int32 available_count = 5;</code>
     */
    protected $available_count = 0;
    protected $quota;
    protected $availability;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. The name of the provisioning quota.
     *     @type int $asset_type
     *           The asset type of this provisioning quota.
     *     @type string $gcp_service
     *           The gcp service of the provisioning quota.
     *     @type string $location
     *           The specific location of the provisioining quota.
     *     @type int $available_count
     *           The available count of the provisioning quota.
     *     @type \Google\Cloud\BareMetalSolution\V2\InstanceQuota $instance_quota
     *           Instance quota.
     *     @type int|string $server_count
     *           Server count.
     *     @type int|string $network_bandwidth
     *           Network bandwidth, Gbps
     *     @type int|string $storage_gib
     *           Storage size (GB).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Baremetalsolution\V2\Provisioning::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The name of the provisioning quota.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. The name of the provisioning quota.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The asset type of this provisioning quota.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.ProvisioningQuota.AssetType asset_type = 2;</code>
     * @return int
     */
    public function getAssetType()
    {
        return $this->asset_type;
    }

    /**
     * The asset type of this provisioning quota.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.ProvisioningQuota.AssetType asset_type = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setAssetType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\BareMetalSolution\V2\ProvisioningQuota\AssetType::class);
        $this->asset_type = $var;

        return $this;
    }

    /**
     * The gcp service of the provisioning quota.
     *
     * Generated from protobuf field <code>string gcp_service = 3;</code>
     * @return string
     */
    public function getGcpService()
    {
        return $this->gcp_service;
    }

    /**
     * The gcp service of the provisioning quota.
     *
     * Generated from protobuf field <code>string gcp_service = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setGcpService($var)
    {
        GPBUtil::checkString($var, True);
        $this->gcp_service = $var;

        return $this;
    }

    /**
     * The specific location of the provisioining quota.
     *
     * Generated from protobuf field <code>string location = 4;</code>
     * @return string
     */
    public function getLocation()
    {
        return $this->location;
    }

    /**
     * The specific location of the provisioining quota.
     *
     * Generated from protobuf field <code>string location = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setLocation($var)
    {
        GPBUtil::checkString($var, True);
        $this->location = $var;

        return $this;
    }

    /**
     * The available count of the provisioning quota.
     *
     * Generated from protobuf field <code>int32 available_count = 5;</code>
     * @return int
     */
    public function getAvailableCount()
    {
        return $this->available_count;
    }

    /**
     * The available count of the provisioning quota.
     *
     * Generated from protobuf field <code>int32 available_count = 5;</code>
     * @param int $var
     * @return $this
     */
    public function setAvailableCount($var)
    {
        GPBUtil::checkInt32($var);
        $this->available_count = $var;

        return $this;
    }

    /**
     * Instance quota.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.InstanceQuota instance_quota = 6;</code>
     * @return \Google\Cloud\BareMetalSolution\V2\InstanceQuota|null
     */
    public function getInstanceQuota()
    {
        return $this->readOneof(6);
    }

    public function hasInstanceQuota()
    {
        return $this->hasOneof(6);
    }

    /**
     * Instance quota.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.InstanceQuota instance_quota = 6;</code>
     * @param \Google\Cloud\BareMetalSolution\V2\InstanceQuota $var
     * @return $this
     */
    public function setInstanceQuota($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\BareMetalSolution\V2\InstanceQuota::class);
        $this->writeOneof(6, $var);

        return $this;
    }

    /**
     * Server count.
     *
     * Generated from protobuf field <code>int64 server_count = 7;</code>
     * @return int|string
     */
    public function getServerCount()
    {
        return $this->readOneof(7);
    }

    public function hasServerCount()
    {
        return $this->hasOneof(7);
    }

    /**
     * Server count.
     *
     * Generated from protobuf field <code>int64 server_count = 7;</code>
     * @param int|string $var
     * @return $this
     */
    public function setServerCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->writeOneof(7, $var);

        return $this;
    }

    /**
     * Network bandwidth, Gbps
     *
     * Generated from protobuf field <code>int64 network_bandwidth = 8;</code>
     * @return int|string
     */
    public function getNetworkBandwidth()
    {
        return $this->readOneof(8);
    }

    public function hasNetworkBandwidth()
    {
        return $this->hasOneof(8);
    }

    /**
     * Network bandwidth, Gbps
     *
     * Generated from protobuf field <code>int64 network_bandwidth = 8;</code>
     * @param int|string $var
     * @return $this
     */
    public function setNetworkBandwidth($var)
    {
        GPBUtil::checkInt64($var);
        $this->writeOneof(8, $var);

        return $this;
    }

    /**
     * Storage size (GB).
     *
     * Generated from protobuf field <code>int64 storage_gib = 9;</code>
     * @return int|string
     */
    public function getStorageGib()
    {
        return $this->readOneof(9);
    }

    public function hasStorageGib()
    {
        return $this->hasOneof(9);
    }

    /**
     * Storage size (GB).
     *
     * Generated from protobuf field <code>int64 storage_gib = 9;</code>
     * @param int|string $var
     * @return $this
     */
    public function setStorageGib($var)
    {
        GPBUtil::checkInt64($var);
        $this->writeOneof(9, $var);

        return $this;
    }

    /**
     * @return string
     */
    public function getQuota()
    {
        return $this->whichOneof("quota");
    }

    /**
     * @return string
     */
    public function getAvailability()
    {
        return $this->whichOneof("availability");
    }

}

