<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/baremetalsolution/v2/volume.proto

namespace Google\Cloud\BareMetalSolution\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A storage volume.
 *
 * Generated from protobuf message <code>google.cloud.baremetalsolution.v2.Volume</code>
 */
class Volume extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The resource name of this `Volume`.
     * Resource names are schemeless URIs that follow the conventions in
     * https://cloud.google.com/apis/design/resource_names.
     * Format:
     * `projects/{project}/locations/{location}/volumes/{volume}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $name = '';
    /**
     * An identifier for the `Volume`, generated by the backend.
     *
     * Generated from protobuf field <code>string id = 11;</code>
     */
    protected $id = '';
    /**
     * The storage type for this volume.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.Volume.StorageType storage_type = 2;</code>
     */
    protected $storage_type = 0;
    /**
     * The state of this storage volume.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.Volume.State state = 3;</code>
     */
    protected $state = 0;
    /**
     * The requested size of this storage volume, in GiB.
     *
     * Generated from protobuf field <code>int64 requested_size_gib = 4;</code>
     */
    protected $requested_size_gib = 0;
    /**
     * Originally requested size, in GiB.
     *
     * Generated from protobuf field <code>int64 originally_requested_size_gib = 16;</code>
     */
    protected $originally_requested_size_gib = 0;
    /**
     * The current size of this storage volume, in GiB, including space reserved
     * for snapshots. This size might be different than the requested size if the
     * storage volume has been configured with auto grow or auto shrink.
     *
     * Generated from protobuf field <code>int64 current_size_gib = 5;</code>
     */
    protected $current_size_gib = 0;
    /**
     * Additional emergency size that was requested for this Volume, in GiB.
     * current_size_gib includes this value.
     *
     * Generated from protobuf field <code>int64 emergency_size_gib = 14;</code>
     */
    protected $emergency_size_gib = 0;
    /**
     * Maximum size volume can be expanded to in case of evergency, in GiB.
     *
     * Generated from protobuf field <code>int64 max_size_gib = 17;</code>
     */
    protected $max_size_gib = 0;
    /**
     * The size, in GiB, that this storage volume has expanded as a result of an
     * auto grow policy. In the absence of auto-grow, the value is 0.
     *
     * Generated from protobuf field <code>int64 auto_grown_size_gib = 6;</code>
     */
    protected $auto_grown_size_gib = 0;
    /**
     * The space remaining in the storage volume for new LUNs, in GiB, excluding
     * space reserved for snapshots.
     *
     * Generated from protobuf field <code>int64 remaining_space_gib = 7;</code>
     */
    protected $remaining_space_gib = 0;
    /**
     * Details about snapshot space reservation and usage on the storage volume.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.Volume.SnapshotReservationDetail snapshot_reservation_detail = 8;</code>
     */
    protected $snapshot_reservation_detail = null;
    /**
     * The behavior to use when snapshot reserved space is full.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.Volume.SnapshotAutoDeleteBehavior snapshot_auto_delete_behavior = 9;</code>
     */
    protected $snapshot_auto_delete_behavior = 0;
    /**
     * Labels as key value pairs.
     *
     * Generated from protobuf field <code>map<string, string> labels = 12;</code>
     */
    private $labels;
    /**
     * Whether snapshots are enabled.
     *
     * Generated from protobuf field <code>bool snapshot_enabled = 13;</code>
     */
    protected $snapshot_enabled = false;
    /**
     * Immutable. Pod name.
     *
     * Generated from protobuf field <code>string pod = 15 [(.google.api.field_behavior) = IMMUTABLE];</code>
     */
    protected $pod = '';
    /**
     * Output only. Storage protocol for the Volume.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.Volume.Protocol protocol = 18 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $protocol = 0;
    /**
     * Output only. Whether this volume is a boot volume. A boot volume is one
     * which contains a boot LUN.
     *
     * Generated from protobuf field <code>bool boot_volume = 19 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $boot_volume = false;
    /**
     * Immutable. Performance tier of the Volume.
     * Default is SHARED.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.VolumePerformanceTier performance_tier = 20 [(.google.api.field_behavior) = IMMUTABLE];</code>
     */
    protected $performance_tier = 0;
    /**
     * Input only. User-specified notes for new Volume.
     * Used to provision Volumes that require manual intervention.
     *
     * Generated from protobuf field <code>string notes = 21 [(.google.api.field_behavior) = INPUT_ONLY];</code>
     */
    protected $notes = '';
    /**
     * The workload profile for the volume.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.Volume.WorkloadProfile workload_profile = 22;</code>
     */
    protected $workload_profile = 0;
    /**
     * Output only. Time after which volume will be fully deleted.
     * It is filled only for volumes in COOLOFF state.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp expire_time = 24 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $expire_time = null;
    /**
     * Output only. Instances this Volume is attached to.
     * This field is set only in Get requests.
     *
     * Generated from protobuf field <code>repeated string instances = 25 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     */
    private $instances;
    /**
     * Output only. Is the Volume attached at at least one instance.
     * This field is a lightweight counterpart of `instances` field.
     * It is filled in List responses as well.
     *
     * Generated from protobuf field <code>bool attached = 26 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $attached = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. The resource name of this `Volume`.
     *           Resource names are schemeless URIs that follow the conventions in
     *           https://cloud.google.com/apis/design/resource_names.
     *           Format:
     *           `projects/{project}/locations/{location}/volumes/{volume}`
     *     @type string $id
     *           An identifier for the `Volume`, generated by the backend.
     *     @type int $storage_type
     *           The storage type for this volume.
     *     @type int $state
     *           The state of this storage volume.
     *     @type int|string $requested_size_gib
     *           The requested size of this storage volume, in GiB.
     *     @type int|string $originally_requested_size_gib
     *           Originally requested size, in GiB.
     *     @type int|string $current_size_gib
     *           The current size of this storage volume, in GiB, including space reserved
     *           for snapshots. This size might be different than the requested size if the
     *           storage volume has been configured with auto grow or auto shrink.
     *     @type int|string $emergency_size_gib
     *           Additional emergency size that was requested for this Volume, in GiB.
     *           current_size_gib includes this value.
     *     @type int|string $max_size_gib
     *           Maximum size volume can be expanded to in case of evergency, in GiB.
     *     @type int|string $auto_grown_size_gib
     *           The size, in GiB, that this storage volume has expanded as a result of an
     *           auto grow policy. In the absence of auto-grow, the value is 0.
     *     @type int|string $remaining_space_gib
     *           The space remaining in the storage volume for new LUNs, in GiB, excluding
     *           space reserved for snapshots.
     *     @type \Google\Cloud\BareMetalSolution\V2\Volume\SnapshotReservationDetail $snapshot_reservation_detail
     *           Details about snapshot space reservation and usage on the storage volume.
     *     @type int $snapshot_auto_delete_behavior
     *           The behavior to use when snapshot reserved space is full.
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Labels as key value pairs.
     *     @type bool $snapshot_enabled
     *           Whether snapshots are enabled.
     *     @type string $pod
     *           Immutable. Pod name.
     *     @type int $protocol
     *           Output only. Storage protocol for the Volume.
     *     @type bool $boot_volume
     *           Output only. Whether this volume is a boot volume. A boot volume is one
     *           which contains a boot LUN.
     *     @type int $performance_tier
     *           Immutable. Performance tier of the Volume.
     *           Default is SHARED.
     *     @type string $notes
     *           Input only. User-specified notes for new Volume.
     *           Used to provision Volumes that require manual intervention.
     *     @type int $workload_profile
     *           The workload profile for the volume.
     *     @type \Google\Protobuf\Timestamp $expire_time
     *           Output only. Time after which volume will be fully deleted.
     *           It is filled only for volumes in COOLOFF state.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $instances
     *           Output only. Instances this Volume is attached to.
     *           This field is set only in Get requests.
     *     @type bool $attached
     *           Output only. Is the Volume attached at at least one instance.
     *           This field is a lightweight counterpart of `instances` field.
     *           It is filled in List responses as well.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Baremetalsolution\V2\Volume::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The resource name of this `Volume`.
     * Resource names are schemeless URIs that follow the conventions in
     * https://cloud.google.com/apis/design/resource_names.
     * Format:
     * `projects/{project}/locations/{location}/volumes/{volume}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. The resource name of this `Volume`.
     * Resource names are schemeless URIs that follow the conventions in
     * https://cloud.google.com/apis/design/resource_names.
     * Format:
     * `projects/{project}/locations/{location}/volumes/{volume}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * An identifier for the `Volume`, generated by the backend.
     *
     * Generated from protobuf field <code>string id = 11;</code>
     * @return string
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * An identifier for the `Volume`, generated by the backend.
     *
     * Generated from protobuf field <code>string id = 11;</code>
     * @param string $var
     * @return $this
     */
    public function setId($var)
    {
        GPBUtil::checkString($var, True);
        $this->id = $var;

        return $this;
    }

    /**
     * The storage type for this volume.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.Volume.StorageType storage_type = 2;</code>
     * @return int
     */
    public function getStorageType()
    {
        return $this->storage_type;
    }

    /**
     * The storage type for this volume.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.Volume.StorageType storage_type = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setStorageType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\BareMetalSolution\V2\Volume\StorageType::class);
        $this->storage_type = $var;

        return $this;
    }

    /**
     * The state of this storage volume.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.Volume.State state = 3;</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * The state of this storage volume.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.Volume.State state = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\BareMetalSolution\V2\Volume\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * The requested size of this storage volume, in GiB.
     *
     * Generated from protobuf field <code>int64 requested_size_gib = 4;</code>
     * @return int|string
     */
    public function getRequestedSizeGib()
    {
        return $this->requested_size_gib;
    }

    /**
     * The requested size of this storage volume, in GiB.
     *
     * Generated from protobuf field <code>int64 requested_size_gib = 4;</code>
     * @param int|string $var
     * @return $this
     */
    public function setRequestedSizeGib($var)
    {
        GPBUtil::checkInt64($var);
        $this->requested_size_gib = $var;

        return $this;
    }

    /**
     * Originally requested size, in GiB.
     *
     * Generated from protobuf field <code>int64 originally_requested_size_gib = 16;</code>
     * @return int|string
     */
    public function getOriginallyRequestedSizeGib()
    {
        return $this->originally_requested_size_gib;
    }

    /**
     * Originally requested size, in GiB.
     *
     * Generated from protobuf field <code>int64 originally_requested_size_gib = 16;</code>
     * @param int|string $var
     * @return $this
     */
    public function setOriginallyRequestedSizeGib($var)
    {
        GPBUtil::checkInt64($var);
        $this->originally_requested_size_gib = $var;

        return $this;
    }

    /**
     * The current size of this storage volume, in GiB, including space reserved
     * for snapshots. This size might be different than the requested size if the
     * storage volume has been configured with auto grow or auto shrink.
     *
     * Generated from protobuf field <code>int64 current_size_gib = 5;</code>
     * @return int|string
     */
    public function getCurrentSizeGib()
    {
        return $this->current_size_gib;
    }

    /**
     * The current size of this storage volume, in GiB, including space reserved
     * for snapshots. This size might be different than the requested size if the
     * storage volume has been configured with auto grow or auto shrink.
     *
     * Generated from protobuf field <code>int64 current_size_gib = 5;</code>
     * @param int|string $var
     * @return $this
     */
    public function setCurrentSizeGib($var)
    {
        GPBUtil::checkInt64($var);
        $this->current_size_gib = $var;

        return $this;
    }

    /**
     * Additional emergency size that was requested for this Volume, in GiB.
     * current_size_gib includes this value.
     *
     * Generated from protobuf field <code>int64 emergency_size_gib = 14;</code>
     * @return int|string
     */
    public function getEmergencySizeGib()
    {
        return $this->emergency_size_gib;
    }

    /**
     * Additional emergency size that was requested for this Volume, in GiB.
     * current_size_gib includes this value.
     *
     * Generated from protobuf field <code>int64 emergency_size_gib = 14;</code>
     * @param int|string $var
     * @return $this
     */
    public function setEmergencySizeGib($var)
    {
        GPBUtil::checkInt64($var);
        $this->emergency_size_gib = $var;

        return $this;
    }

    /**
     * Maximum size volume can be expanded to in case of evergency, in GiB.
     *
     * Generated from protobuf field <code>int64 max_size_gib = 17;</code>
     * @return int|string
     */
    public function getMaxSizeGib()
    {
        return $this->max_size_gib;
    }

    /**
     * Maximum size volume can be expanded to in case of evergency, in GiB.
     *
     * Generated from protobuf field <code>int64 max_size_gib = 17;</code>
     * @param int|string $var
     * @return $this
     */
    public function setMaxSizeGib($var)
    {
        GPBUtil::checkInt64($var);
        $this->max_size_gib = $var;

        return $this;
    }

    /**
     * The size, in GiB, that this storage volume has expanded as a result of an
     * auto grow policy. In the absence of auto-grow, the value is 0.
     *
     * Generated from protobuf field <code>int64 auto_grown_size_gib = 6;</code>
     * @return int|string
     */
    public function getAutoGrownSizeGib()
    {
        return $this->auto_grown_size_gib;
    }

    /**
     * The size, in GiB, that this storage volume has expanded as a result of an
     * auto grow policy. In the absence of auto-grow, the value is 0.
     *
     * Generated from protobuf field <code>int64 auto_grown_size_gib = 6;</code>
     * @param int|string $var
     * @return $this
     */
    public function setAutoGrownSizeGib($var)
    {
        GPBUtil::checkInt64($var);
        $this->auto_grown_size_gib = $var;

        return $this;
    }

    /**
     * The space remaining in the storage volume for new LUNs, in GiB, excluding
     * space reserved for snapshots.
     *
     * Generated from protobuf field <code>int64 remaining_space_gib = 7;</code>
     * @return int|string
     */
    public function getRemainingSpaceGib()
    {
        return $this->remaining_space_gib;
    }

    /**
     * The space remaining in the storage volume for new LUNs, in GiB, excluding
     * space reserved for snapshots.
     *
     * Generated from protobuf field <code>int64 remaining_space_gib = 7;</code>
     * @param int|string $var
     * @return $this
     */
    public function setRemainingSpaceGib($var)
    {
        GPBUtil::checkInt64($var);
        $this->remaining_space_gib = $var;

        return $this;
    }

    /**
     * Details about snapshot space reservation and usage on the storage volume.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.Volume.SnapshotReservationDetail snapshot_reservation_detail = 8;</code>
     * @return \Google\Cloud\BareMetalSolution\V2\Volume\SnapshotReservationDetail|null
     */
    public function getSnapshotReservationDetail()
    {
        return $this->snapshot_reservation_detail;
    }

    public function hasSnapshotReservationDetail()
    {
        return isset($this->snapshot_reservation_detail);
    }

    public function clearSnapshotReservationDetail()
    {
        unset($this->snapshot_reservation_detail);
    }

    /**
     * Details about snapshot space reservation and usage on the storage volume.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.Volume.SnapshotReservationDetail snapshot_reservation_detail = 8;</code>
     * @param \Google\Cloud\BareMetalSolution\V2\Volume\SnapshotReservationDetail $var
     * @return $this
     */
    public function setSnapshotReservationDetail($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\BareMetalSolution\V2\Volume\SnapshotReservationDetail::class);
        $this->snapshot_reservation_detail = $var;

        return $this;
    }

    /**
     * The behavior to use when snapshot reserved space is full.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.Volume.SnapshotAutoDeleteBehavior snapshot_auto_delete_behavior = 9;</code>
     * @return int
     */
    public function getSnapshotAutoDeleteBehavior()
    {
        return $this->snapshot_auto_delete_behavior;
    }

    /**
     * The behavior to use when snapshot reserved space is full.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.Volume.SnapshotAutoDeleteBehavior snapshot_auto_delete_behavior = 9;</code>
     * @param int $var
     * @return $this
     */
    public function setSnapshotAutoDeleteBehavior($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\BareMetalSolution\V2\Volume\SnapshotAutoDeleteBehavior::class);
        $this->snapshot_auto_delete_behavior = $var;

        return $this;
    }

    /**
     * Labels as key value pairs.
     *
     * Generated from protobuf field <code>map<string, string> labels = 12;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Labels as key value pairs.
     *
     * Generated from protobuf field <code>map<string, string> labels = 12;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * Whether snapshots are enabled.
     *
     * Generated from protobuf field <code>bool snapshot_enabled = 13;</code>
     * @return bool
     */
    public function getSnapshotEnabled()
    {
        return $this->snapshot_enabled;
    }

    /**
     * Whether snapshots are enabled.
     *
     * Generated from protobuf field <code>bool snapshot_enabled = 13;</code>
     * @param bool $var
     * @return $this
     */
    public function setSnapshotEnabled($var)
    {
        GPBUtil::checkBool($var);
        $this->snapshot_enabled = $var;

        return $this;
    }

    /**
     * Immutable. Pod name.
     *
     * Generated from protobuf field <code>string pod = 15 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @return string
     */
    public function getPod()
    {
        return $this->pod;
    }

    /**
     * Immutable. Pod name.
     *
     * Generated from protobuf field <code>string pod = 15 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @param string $var
     * @return $this
     */
    public function setPod($var)
    {
        GPBUtil::checkString($var, True);
        $this->pod = $var;

        return $this;
    }

    /**
     * Output only. Storage protocol for the Volume.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.Volume.Protocol protocol = 18 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getProtocol()
    {
        return $this->protocol;
    }

    /**
     * Output only. Storage protocol for the Volume.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.Volume.Protocol protocol = 18 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setProtocol($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\BareMetalSolution\V2\Volume\Protocol::class);
        $this->protocol = $var;

        return $this;
    }

    /**
     * Output only. Whether this volume is a boot volume. A boot volume is one
     * which contains a boot LUN.
     *
     * Generated from protobuf field <code>bool boot_volume = 19 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return bool
     */
    public function getBootVolume()
    {
        return $this->boot_volume;
    }

    /**
     * Output only. Whether this volume is a boot volume. A boot volume is one
     * which contains a boot LUN.
     *
     * Generated from protobuf field <code>bool boot_volume = 19 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param bool $var
     * @return $this
     */
    public function setBootVolume($var)
    {
        GPBUtil::checkBool($var);
        $this->boot_volume = $var;

        return $this;
    }

    /**
     * Immutable. Performance tier of the Volume.
     * Default is SHARED.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.VolumePerformanceTier performance_tier = 20 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @return int
     */
    public function getPerformanceTier()
    {
        return $this->performance_tier;
    }

    /**
     * Immutable. Performance tier of the Volume.
     * Default is SHARED.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.VolumePerformanceTier performance_tier = 20 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @param int $var
     * @return $this
     */
    public function setPerformanceTier($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\BareMetalSolution\V2\VolumePerformanceTier::class);
        $this->performance_tier = $var;

        return $this;
    }

    /**
     * Input only. User-specified notes for new Volume.
     * Used to provision Volumes that require manual intervention.
     *
     * Generated from protobuf field <code>string notes = 21 [(.google.api.field_behavior) = INPUT_ONLY];</code>
     * @return string
     */
    public function getNotes()
    {
        return $this->notes;
    }

    /**
     * Input only. User-specified notes for new Volume.
     * Used to provision Volumes that require manual intervention.
     *
     * Generated from protobuf field <code>string notes = 21 [(.google.api.field_behavior) = INPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setNotes($var)
    {
        GPBUtil::checkString($var, True);
        $this->notes = $var;

        return $this;
    }

    /**
     * The workload profile for the volume.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.Volume.WorkloadProfile workload_profile = 22;</code>
     * @return int
     */
    public function getWorkloadProfile()
    {
        return $this->workload_profile;
    }

    /**
     * The workload profile for the volume.
     *
     * Generated from protobuf field <code>.google.cloud.baremetalsolution.v2.Volume.WorkloadProfile workload_profile = 22;</code>
     * @param int $var
     * @return $this
     */
    public function setWorkloadProfile($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\BareMetalSolution\V2\Volume\WorkloadProfile::class);
        $this->workload_profile = $var;

        return $this;
    }

    /**
     * Output only. Time after which volume will be fully deleted.
     * It is filled only for volumes in COOLOFF state.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp expire_time = 24 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getExpireTime()
    {
        return $this->expire_time;
    }

    public function hasExpireTime()
    {
        return isset($this->expire_time);
    }

    public function clearExpireTime()
    {
        unset($this->expire_time);
    }

    /**
     * Output only. Time after which volume will be fully deleted.
     * It is filled only for volumes in COOLOFF state.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp expire_time = 24 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setExpireTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->expire_time = $var;

        return $this;
    }

    /**
     * Output only. Instances this Volume is attached to.
     * This field is set only in Get requests.
     *
     * Generated from protobuf field <code>repeated string instances = 25 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getInstances()
    {
        return $this->instances;
    }

    /**
     * Output only. Instances this Volume is attached to.
     * This field is set only in Get requests.
     *
     * Generated from protobuf field <code>repeated string instances = 25 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setInstances($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->instances = $arr;

        return $this;
    }

    /**
     * Output only. Is the Volume attached at at least one instance.
     * This field is a lightweight counterpart of `instances` field.
     * It is filled in List responses as well.
     *
     * Generated from protobuf field <code>bool attached = 26 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return bool
     */
    public function getAttached()
    {
        return $this->attached;
    }

    /**
     * Output only. Is the Volume attached at at least one instance.
     * This field is a lightweight counterpart of `instances` field.
     * It is filled in List responses as well.
     *
     * Generated from protobuf field <code>bool attached = 26 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param bool $var
     * @return $this
     */
    public function setAttached($var)
    {
        GPBUtil::checkBool($var);
        $this->attached = $var;

        return $this;
    }

}

