<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/batch/v1/job.proto

namespace Google\Cloud\Batch\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A Job's resource allocation policy describes when, where, and how compute
 * resources should be allocated for the Job.
 *
 * Generated from protobuf message <code>google.cloud.batch.v1.AllocationPolicy</code>
 */
class AllocationPolicy extends \Google\Protobuf\Internal\Message
{
    /**
     * Location where compute resources should be allocated for the Job.
     *
     * Generated from protobuf field <code>.google.cloud.batch.v1.AllocationPolicy.LocationPolicy location = 1;</code>
     */
    protected $location = null;
    /**
     * Describe instances that can be created by this AllocationPolicy.
     * Only instances[0] is supported now.
     *
     * Generated from protobuf field <code>repeated .google.cloud.batch.v1.AllocationPolicy.InstancePolicyOrTemplate instances = 8;</code>
     */
    private $instances;
    /**
     * Defines the service account for Batch-created VMs. If omitted, the [default
     * Compute Engine service
     * account](https://cloud.google.com/compute/docs/access/service-accounts#default_service_account)
     * is used. Must match the service account specified in any used instance
     * template configured in the Batch job.
     * Includes the following fields:
     *  * email: The service account's email address. If not set, the default
     *  Compute Engine service account is used.
     *  * scopes: Additional OAuth scopes to grant the service account, beyond the
     *  default cloud-platform scope. (list of strings)
     *
     * Generated from protobuf field <code>.google.cloud.batch.v1.ServiceAccount service_account = 9;</code>
     */
    protected $service_account = null;
    /**
     * Labels applied to all VM instances and other resources
     * created by AllocationPolicy.
     * Labels could be user provided or system generated.
     * You can assign up to 64 labels. [Google Compute Engine label
     * restrictions](https://cloud.google.com/compute/docs/labeling-resources#restrictions)
     * apply.
     * Label names that start with "goog-" or "google-" are reserved.
     *
     * Generated from protobuf field <code>map<string, string> labels = 6;</code>
     */
    private $labels;
    /**
     * The network policy.
     * If you define an instance template in the `InstancePolicyOrTemplate` field,
     * Batch will use the network settings in the instance template instead of
     * this field.
     *
     * Generated from protobuf field <code>.google.cloud.batch.v1.AllocationPolicy.NetworkPolicy network = 7;</code>
     */
    protected $network = null;
    /**
     * The placement policy.
     *
     * Generated from protobuf field <code>.google.cloud.batch.v1.AllocationPolicy.PlacementPolicy placement = 10;</code>
     */
    protected $placement = null;
    /**
     * Optional. Tags applied to the VM instances.
     * The tags identify valid sources or targets for network firewalls.
     * Each tag must be 1-63 characters long, and comply with
     * [RFC1035](https://www.ietf.org/rfc/rfc1035.txt).
     *
     * Generated from protobuf field <code>repeated string tags = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $tags;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\Batch\V1\AllocationPolicy\LocationPolicy $location
     *           Location where compute resources should be allocated for the Job.
     *     @type array<\Google\Cloud\Batch\V1\AllocationPolicy\InstancePolicyOrTemplate>|\Google\Protobuf\Internal\RepeatedField $instances
     *           Describe instances that can be created by this AllocationPolicy.
     *           Only instances[0] is supported now.
     *     @type \Google\Cloud\Batch\V1\ServiceAccount $service_account
     *           Defines the service account for Batch-created VMs. If omitted, the [default
     *           Compute Engine service
     *           account](https://cloud.google.com/compute/docs/access/service-accounts#default_service_account)
     *           is used. Must match the service account specified in any used instance
     *           template configured in the Batch job.
     *           Includes the following fields:
     *            * email: The service account's email address. If not set, the default
     *            Compute Engine service account is used.
     *            * scopes: Additional OAuth scopes to grant the service account, beyond the
     *            default cloud-platform scope. (list of strings)
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Labels applied to all VM instances and other resources
     *           created by AllocationPolicy.
     *           Labels could be user provided or system generated.
     *           You can assign up to 64 labels. [Google Compute Engine label
     *           restrictions](https://cloud.google.com/compute/docs/labeling-resources#restrictions)
     *           apply.
     *           Label names that start with "goog-" or "google-" are reserved.
     *     @type \Google\Cloud\Batch\V1\AllocationPolicy\NetworkPolicy $network
     *           The network policy.
     *           If you define an instance template in the `InstancePolicyOrTemplate` field,
     *           Batch will use the network settings in the instance template instead of
     *           this field.
     *     @type \Google\Cloud\Batch\V1\AllocationPolicy\PlacementPolicy $placement
     *           The placement policy.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $tags
     *           Optional. Tags applied to the VM instances.
     *           The tags identify valid sources or targets for network firewalls.
     *           Each tag must be 1-63 characters long, and comply with
     *           [RFC1035](https://www.ietf.org/rfc/rfc1035.txt).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Batch\V1\Job::initOnce();
        parent::__construct($data);
    }

    /**
     * Location where compute resources should be allocated for the Job.
     *
     * Generated from protobuf field <code>.google.cloud.batch.v1.AllocationPolicy.LocationPolicy location = 1;</code>
     * @return \Google\Cloud\Batch\V1\AllocationPolicy\LocationPolicy|null
     */
    public function getLocation()
    {
        return $this->location;
    }

    public function hasLocation()
    {
        return isset($this->location);
    }

    public function clearLocation()
    {
        unset($this->location);
    }

    /**
     * Location where compute resources should be allocated for the Job.
     *
     * Generated from protobuf field <code>.google.cloud.batch.v1.AllocationPolicy.LocationPolicy location = 1;</code>
     * @param \Google\Cloud\Batch\V1\AllocationPolicy\LocationPolicy $var
     * @return $this
     */
    public function setLocation($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Batch\V1\AllocationPolicy\LocationPolicy::class);
        $this->location = $var;

        return $this;
    }

    /**
     * Describe instances that can be created by this AllocationPolicy.
     * Only instances[0] is supported now.
     *
     * Generated from protobuf field <code>repeated .google.cloud.batch.v1.AllocationPolicy.InstancePolicyOrTemplate instances = 8;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getInstances()
    {
        return $this->instances;
    }

    /**
     * Describe instances that can be created by this AllocationPolicy.
     * Only instances[0] is supported now.
     *
     * Generated from protobuf field <code>repeated .google.cloud.batch.v1.AllocationPolicy.InstancePolicyOrTemplate instances = 8;</code>
     * @param array<\Google\Cloud\Batch\V1\AllocationPolicy\InstancePolicyOrTemplate>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setInstances($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Batch\V1\AllocationPolicy\InstancePolicyOrTemplate::class);
        $this->instances = $arr;

        return $this;
    }

    /**
     * Defines the service account for Batch-created VMs. If omitted, the [default
     * Compute Engine service
     * account](https://cloud.google.com/compute/docs/access/service-accounts#default_service_account)
     * is used. Must match the service account specified in any used instance
     * template configured in the Batch job.
     * Includes the following fields:
     *  * email: The service account's email address. If not set, the default
     *  Compute Engine service account is used.
     *  * scopes: Additional OAuth scopes to grant the service account, beyond the
     *  default cloud-platform scope. (list of strings)
     *
     * Generated from protobuf field <code>.google.cloud.batch.v1.ServiceAccount service_account = 9;</code>
     * @return \Google\Cloud\Batch\V1\ServiceAccount|null
     */
    public function getServiceAccount()
    {
        return $this->service_account;
    }

    public function hasServiceAccount()
    {
        return isset($this->service_account);
    }

    public function clearServiceAccount()
    {
        unset($this->service_account);
    }

    /**
     * Defines the service account for Batch-created VMs. If omitted, the [default
     * Compute Engine service
     * account](https://cloud.google.com/compute/docs/access/service-accounts#default_service_account)
     * is used. Must match the service account specified in any used instance
     * template configured in the Batch job.
     * Includes the following fields:
     *  * email: The service account's email address. If not set, the default
     *  Compute Engine service account is used.
     *  * scopes: Additional OAuth scopes to grant the service account, beyond the
     *  default cloud-platform scope. (list of strings)
     *
     * Generated from protobuf field <code>.google.cloud.batch.v1.ServiceAccount service_account = 9;</code>
     * @param \Google\Cloud\Batch\V1\ServiceAccount $var
     * @return $this
     */
    public function setServiceAccount($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Batch\V1\ServiceAccount::class);
        $this->service_account = $var;

        return $this;
    }

    /**
     * Labels applied to all VM instances and other resources
     * created by AllocationPolicy.
     * Labels could be user provided or system generated.
     * You can assign up to 64 labels. [Google Compute Engine label
     * restrictions](https://cloud.google.com/compute/docs/labeling-resources#restrictions)
     * apply.
     * Label names that start with "goog-" or "google-" are reserved.
     *
     * Generated from protobuf field <code>map<string, string> labels = 6;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Labels applied to all VM instances and other resources
     * created by AllocationPolicy.
     * Labels could be user provided or system generated.
     * You can assign up to 64 labels. [Google Compute Engine label
     * restrictions](https://cloud.google.com/compute/docs/labeling-resources#restrictions)
     * apply.
     * Label names that start with "goog-" or "google-" are reserved.
     *
     * Generated from protobuf field <code>map<string, string> labels = 6;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * The network policy.
     * If you define an instance template in the `InstancePolicyOrTemplate` field,
     * Batch will use the network settings in the instance template instead of
     * this field.
     *
     * Generated from protobuf field <code>.google.cloud.batch.v1.AllocationPolicy.NetworkPolicy network = 7;</code>
     * @return \Google\Cloud\Batch\V1\AllocationPolicy\NetworkPolicy|null
     */
    public function getNetwork()
    {
        return $this->network;
    }

    public function hasNetwork()
    {
        return isset($this->network);
    }

    public function clearNetwork()
    {
        unset($this->network);
    }

    /**
     * The network policy.
     * If you define an instance template in the `InstancePolicyOrTemplate` field,
     * Batch will use the network settings in the instance template instead of
     * this field.
     *
     * Generated from protobuf field <code>.google.cloud.batch.v1.AllocationPolicy.NetworkPolicy network = 7;</code>
     * @param \Google\Cloud\Batch\V1\AllocationPolicy\NetworkPolicy $var
     * @return $this
     */
    public function setNetwork($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Batch\V1\AllocationPolicy\NetworkPolicy::class);
        $this->network = $var;

        return $this;
    }

    /**
     * The placement policy.
     *
     * Generated from protobuf field <code>.google.cloud.batch.v1.AllocationPolicy.PlacementPolicy placement = 10;</code>
     * @return \Google\Cloud\Batch\V1\AllocationPolicy\PlacementPolicy|null
     */
    public function getPlacement()
    {
        return $this->placement;
    }

    public function hasPlacement()
    {
        return isset($this->placement);
    }

    public function clearPlacement()
    {
        unset($this->placement);
    }

    /**
     * The placement policy.
     *
     * Generated from protobuf field <code>.google.cloud.batch.v1.AllocationPolicy.PlacementPolicy placement = 10;</code>
     * @param \Google\Cloud\Batch\V1\AllocationPolicy\PlacementPolicy $var
     * @return $this
     */
    public function setPlacement($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Batch\V1\AllocationPolicy\PlacementPolicy::class);
        $this->placement = $var;

        return $this;
    }

    /**
     * Optional. Tags applied to the VM instances.
     * The tags identify valid sources or targets for network firewalls.
     * Each tag must be 1-63 characters long, and comply with
     * [RFC1035](https://www.ietf.org/rfc/rfc1035.txt).
     *
     * Generated from protobuf field <code>repeated string tags = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getTags()
    {
        return $this->tags;
    }

    /**
     * Optional. Tags applied to the VM instances.
     * The tags identify valid sources or targets for network firewalls.
     * Each tag must be 1-63 characters long, and comply with
     * [RFC1035](https://www.ietf.org/rfc/rfc1035.txt).
     *
     * Generated from protobuf field <code>repeated string tags = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setTags($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->tags = $arr;

        return $this;
    }

}

