<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/batch/v1/batch.proto

namespace Google\Cloud\Batch\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * CreateJob Request.
 *
 * Generated from protobuf message <code>google.cloud.batch.v1.CreateJobRequest</code>
 */
class CreateJobRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent resource name where the Job will be created.
     * Pattern: "projects/{project}/locations/{location}"
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * ID used to uniquely identify the Job within its parent scope.
     * This field should contain at most 63 characters and must start with
     * lowercase characters.
     * Only lowercase characters, numbers and '-' are accepted.
     * The '-' character cannot be the first or the last one.
     * A system generated ID will be used if the field is not set.
     * The job.name field in the request will be ignored and the created resource
     * name of the Job will be "{parent}/jobs/{job_id}".
     *
     * Generated from protobuf field <code>string job_id = 2;</code>
     */
    protected $job_id = '';
    /**
     * Required. The Job to create.
     *
     * Generated from protobuf field <code>.google.cloud.batch.v1.Job job = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $job = null;
    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and
     * the request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $request_id = '';

    /**
     * @param string                     $parent Required. The parent resource name where the Job will be created.
     *                                           Pattern: "projects/{project}/locations/{location}"
     *                                           Please see {@see BatchServiceClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\Batch\V1\Job $job    Required. The Job to create.
     * @param string                     $jobId  ID used to uniquely identify the Job within its parent scope.
     *                                           This field should contain at most 63 characters and must start with
     *                                           lowercase characters.
     *                                           Only lowercase characters, numbers and '-' are accepted.
     *                                           The '-' character cannot be the first or the last one.
     *                                           A system generated ID will be used if the field is not set.
     *
     *                                           The job.name field in the request will be ignored and the created resource
     *                                           name of the Job will be "{parent}/jobs/{job_id}".
     *
     * @return \Google\Cloud\Batch\V1\CreateJobRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\Batch\V1\Job $job, string $jobId): self
    {
        return (new self())
            ->setParent($parent)
            ->setJob($job)
            ->setJobId($jobId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent resource name where the Job will be created.
     *           Pattern: "projects/{project}/locations/{location}"
     *     @type string $job_id
     *           ID used to uniquely identify the Job within its parent scope.
     *           This field should contain at most 63 characters and must start with
     *           lowercase characters.
     *           Only lowercase characters, numbers and '-' are accepted.
     *           The '-' character cannot be the first or the last one.
     *           A system generated ID will be used if the field is not set.
     *           The job.name field in the request will be ignored and the created resource
     *           name of the Job will be "{parent}/jobs/{job_id}".
     *     @type \Google\Cloud\Batch\V1\Job $job
     *           Required. The Job to create.
     *     @type string $request_id
     *           Optional. An optional request ID to identify requests. Specify a unique
     *           request ID so that if you must retry your request, the server will know to
     *           ignore the request if it has already been completed. The server will
     *           guarantee that for at least 60 minutes since the first request.
     *           For example, consider a situation where you make an initial request and
     *           the request times out. If you make the request again with the same request
     *           ID, the server can check if original operation with the same request ID
     *           was received, and if so, will ignore the second request. This prevents
     *           clients from accidentally creating duplicate commitments.
     *           The request ID must be a valid UUID with the exception that zero UUID is
     *           not supported (00000000-0000-0000-0000-000000000000).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Batch\V1\Batch::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent resource name where the Job will be created.
     * Pattern: "projects/{project}/locations/{location}"
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent resource name where the Job will be created.
     * Pattern: "projects/{project}/locations/{location}"
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * ID used to uniquely identify the Job within its parent scope.
     * This field should contain at most 63 characters and must start with
     * lowercase characters.
     * Only lowercase characters, numbers and '-' are accepted.
     * The '-' character cannot be the first or the last one.
     * A system generated ID will be used if the field is not set.
     * The job.name field in the request will be ignored and the created resource
     * name of the Job will be "{parent}/jobs/{job_id}".
     *
     * Generated from protobuf field <code>string job_id = 2;</code>
     * @return string
     */
    public function getJobId()
    {
        return $this->job_id;
    }

    /**
     * ID used to uniquely identify the Job within its parent scope.
     * This field should contain at most 63 characters and must start with
     * lowercase characters.
     * Only lowercase characters, numbers and '-' are accepted.
     * The '-' character cannot be the first or the last one.
     * A system generated ID will be used if the field is not set.
     * The job.name field in the request will be ignored and the created resource
     * name of the Job will be "{parent}/jobs/{job_id}".
     *
     * Generated from protobuf field <code>string job_id = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setJobId($var)
    {
        GPBUtil::checkString($var, True);
        $this->job_id = $var;

        return $this;
    }

    /**
     * Required. The Job to create.
     *
     * Generated from protobuf field <code>.google.cloud.batch.v1.Job job = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\Batch\V1\Job|null
     */
    public function getJob()
    {
        return $this->job;
    }

    public function hasJob()
    {
        return isset($this->job);
    }

    public function clearJob()
    {
        unset($this->job);
    }

    /**
     * Required. The Job to create.
     *
     * Generated from protobuf field <code>.google.cloud.batch.v1.Job job = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\Batch\V1\Job $var
     * @return $this
     */
    public function setJob($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Batch\V1\Job::class);
        $this->job = $var;

        return $this;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and
     * the request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getRequestId()
    {
        return $this->request_id;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and
     * the request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setRequestId($var)
    {
        GPBUtil::checkString($var, True);
        $this->request_id = $var;

        return $this;
    }

}

