<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/batch/v1/task.proto

namespace Google\Cloud\Batch\V1\Runnable;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Script runnable.
 *
 * Generated from protobuf message <code>google.cloud.batch.v1.Runnable.Script</code>
 */
class Script extends \Google\Protobuf\Internal\Message
{
    protected $command;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $path
     *           The path to a script file that is accessible from the host VM(s).
     *           Unless the script file supports the default `#!/bin/sh` shell
     *           interpreter, you must specify an interpreter by including a
     *           [shebang line](https://en.wikipedia.org/wiki/Shebang_(Unix) as the
     *           first line of the file. For example, to execute the script using bash,
     *           include `#!/bin/bash` as the first line of the file. Alternatively,
     *           to execute the script using Python3, include `#!/usr/bin/env python3`
     *           as the first line of the file.
     *     @type string $text
     *           The text for a script.
     *           Unless the script text supports the default `#!/bin/sh` shell
     *           interpreter, you must specify an interpreter by including a
     *           [shebang line](https://en.wikipedia.org/wiki/Shebang_(Unix) at the
     *           beginning of the text. For example, to execute the script using bash,
     *           include `#!/bin/bash\n` at the beginning of the text. Alternatively,
     *           to execute the script using Python3, include `#!/usr/bin/env python3\n`
     *           at the beginning of the text.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Batch\V1\Task::initOnce();
        parent::__construct($data);
    }

    /**
     * The path to a script file that is accessible from the host VM(s).
     * Unless the script file supports the default `#!/bin/sh` shell
     * interpreter, you must specify an interpreter by including a
     * [shebang line](https://en.wikipedia.org/wiki/Shebang_(Unix) as the
     * first line of the file. For example, to execute the script using bash,
     * include `#!/bin/bash` as the first line of the file. Alternatively,
     * to execute the script using Python3, include `#!/usr/bin/env python3`
     * as the first line of the file.
     *
     * Generated from protobuf field <code>string path = 1;</code>
     * @return string
     */
    public function getPath()
    {
        return $this->readOneof(1);
    }

    public function hasPath()
    {
        return $this->hasOneof(1);
    }

    /**
     * The path to a script file that is accessible from the host VM(s).
     * Unless the script file supports the default `#!/bin/sh` shell
     * interpreter, you must specify an interpreter by including a
     * [shebang line](https://en.wikipedia.org/wiki/Shebang_(Unix) as the
     * first line of the file. For example, to execute the script using bash,
     * include `#!/bin/bash` as the first line of the file. Alternatively,
     * to execute the script using Python3, include `#!/usr/bin/env python3`
     * as the first line of the file.
     *
     * Generated from protobuf field <code>string path = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setPath($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(1, $var);

        return $this;
    }

    /**
     * The text for a script.
     * Unless the script text supports the default `#!/bin/sh` shell
     * interpreter, you must specify an interpreter by including a
     * [shebang line](https://en.wikipedia.org/wiki/Shebang_(Unix) at the
     * beginning of the text. For example, to execute the script using bash,
     * include `#!/bin/bash\n` at the beginning of the text. Alternatively,
     * to execute the script using Python3, include `#!/usr/bin/env python3\n`
     * at the beginning of the text.
     *
     * Generated from protobuf field <code>string text = 2;</code>
     * @return string
     */
    public function getText()
    {
        return $this->readOneof(2);
    }

    public function hasText()
    {
        return $this->hasOneof(2);
    }

    /**
     * The text for a script.
     * Unless the script text supports the default `#!/bin/sh` shell
     * interpreter, you must specify an interpreter by including a
     * [shebang line](https://en.wikipedia.org/wiki/Shebang_(Unix) at the
     * beginning of the text. For example, to execute the script using bash,
     * include `#!/bin/bash\n` at the beginning of the text. Alternatively,
     * to execute the script using Python3, include `#!/usr/bin/env python3\n`
     * at the beginning of the text.
     *
     * Generated from protobuf field <code>string text = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setText($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     * @return string
     */
    public function getCommand()
    {
        return $this->whichOneof("command");
    }

}


