<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/batch/v1/task.proto

namespace Google\Cloud\Batch\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * This Task Execution field includes detail information for
 * task execution procedures, based on StatusEvent types.
 *
 * Generated from protobuf message <code>google.cloud.batch.v1.TaskExecution</code>
 */
class TaskExecution extends \Google\Protobuf\Internal\Message
{
    /**
     * The exit code of a finished task.
     * If the task succeeded, the exit code will be 0. If the task failed but not
     * due to the following reasons, the exit code will be 50000.
     * Otherwise, it can be from different sources:
     * * Batch known failures:
     * https://cloud.google.com/batch/docs/troubleshooting#reserved-exit-codes.
     * * Batch runnable execution failures; you can rely on Batch logs to further
     * diagnose: https://cloud.google.com/batch/docs/analyze-job-using-logs. If
     * there are multiple runnables failures, Batch only exposes the first error.
     *
     * Generated from protobuf field <code>int32 exit_code = 1;</code>
     */
    protected $exit_code = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int $exit_code
     *           The exit code of a finished task.
     *           If the task succeeded, the exit code will be 0. If the task failed but not
     *           due to the following reasons, the exit code will be 50000.
     *           Otherwise, it can be from different sources:
     *           * Batch known failures:
     *           https://cloud.google.com/batch/docs/troubleshooting#reserved-exit-codes.
     *           * Batch runnable execution failures; you can rely on Batch logs to further
     *           diagnose: https://cloud.google.com/batch/docs/analyze-job-using-logs. If
     *           there are multiple runnables failures, Batch only exposes the first error.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Batch\V1\Task::initOnce();
        parent::__construct($data);
    }

    /**
     * The exit code of a finished task.
     * If the task succeeded, the exit code will be 0. If the task failed but not
     * due to the following reasons, the exit code will be 50000.
     * Otherwise, it can be from different sources:
     * * Batch known failures:
     * https://cloud.google.com/batch/docs/troubleshooting#reserved-exit-codes.
     * * Batch runnable execution failures; you can rely on Batch logs to further
     * diagnose: https://cloud.google.com/batch/docs/analyze-job-using-logs. If
     * there are multiple runnables failures, Batch only exposes the first error.
     *
     * Generated from protobuf field <code>int32 exit_code = 1;</code>
     * @return int
     */
    public function getExitCode()
    {
        return $this->exit_code;
    }

    /**
     * The exit code of a finished task.
     * If the task succeeded, the exit code will be 0. If the task failed but not
     * due to the following reasons, the exit code will be 50000.
     * Otherwise, it can be from different sources:
     * * Batch known failures:
     * https://cloud.google.com/batch/docs/troubleshooting#reserved-exit-codes.
     * * Batch runnable execution failures; you can rely on Batch logs to further
     * diagnose: https://cloud.google.com/batch/docs/analyze-job-using-logs. If
     * there are multiple runnables failures, Batch only exposes the first error.
     *
     * Generated from protobuf field <code>int32 exit_code = 1;</code>
     * @param int $var
     * @return $this
     */
    public function setExitCode($var)
    {
        GPBUtil::checkInt32($var);
        $this->exit_code = $var;

        return $this;
    }

}

