<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/bigquery/analyticshub/v1/analyticshub.proto

namespace Google\Cloud\BigQuery\AnalyticsHub\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message for listing subscriptions of a shared resource.
 *
 * Generated from protobuf message <code>google.cloud.bigquery.analyticshub.v1.ListSharedResourceSubscriptionsRequest</code>
 */
class ListSharedResourceSubscriptionsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Resource name of the requested target. This resource may be
     * either a Listing or a DataExchange. e.g.
     * projects/123/locations/US/dataExchanges/456 OR e.g.
     * projects/123/locations/US/dataExchanges/456/listings/789
     *
     * Generated from protobuf field <code>string resource = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $resource = '';
    /**
     * If selected, includes deleted subscriptions in the response
     * (up to 63 days after deletion).
     *
     * Generated from protobuf field <code>bool include_deleted_subscriptions = 2;</code>
     */
    protected $include_deleted_subscriptions = false;
    /**
     * The maximum number of results to return in a single response page.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     */
    protected $page_size = 0;
    /**
     * Page token, returned by a previous call.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     */
    protected $page_token = '';

    /**
     * @param string $resource Required. Resource name of the requested target. This resource may be
     *                         either a Listing or a DataExchange. e.g.
     *                         projects/123/locations/US/dataExchanges/456 OR e.g.
     *                         projects/123/locations/US/dataExchanges/456/listings/789
     *
     * @return \Google\Cloud\BigQuery\AnalyticsHub\V1\ListSharedResourceSubscriptionsRequest
     *
     * @experimental
     */
    public static function build(string $resource): self
    {
        return (new self())
            ->setResource($resource);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $resource
     *           Required. Resource name of the requested target. This resource may be
     *           either a Listing or a DataExchange. e.g.
     *           projects/123/locations/US/dataExchanges/456 OR e.g.
     *           projects/123/locations/US/dataExchanges/456/listings/789
     *     @type bool $include_deleted_subscriptions
     *           If selected, includes deleted subscriptions in the response
     *           (up to 63 days after deletion).
     *     @type int $page_size
     *           The maximum number of results to return in a single response page.
     *     @type string $page_token
     *           Page token, returned by a previous call.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Bigquery\Analyticshub\V1\Analyticshub::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Resource name of the requested target. This resource may be
     * either a Listing or a DataExchange. e.g.
     * projects/123/locations/US/dataExchanges/456 OR e.g.
     * projects/123/locations/US/dataExchanges/456/listings/789
     *
     * Generated from protobuf field <code>string resource = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getResource()
    {
        return $this->resource;
    }

    /**
     * Required. Resource name of the requested target. This resource may be
     * either a Listing or a DataExchange. e.g.
     * projects/123/locations/US/dataExchanges/456 OR e.g.
     * projects/123/locations/US/dataExchanges/456/listings/789
     *
     * Generated from protobuf field <code>string resource = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setResource($var)
    {
        GPBUtil::checkString($var, True);
        $this->resource = $var;

        return $this;
    }

    /**
     * If selected, includes deleted subscriptions in the response
     * (up to 63 days after deletion).
     *
     * Generated from protobuf field <code>bool include_deleted_subscriptions = 2;</code>
     * @return bool
     */
    public function getIncludeDeletedSubscriptions()
    {
        return $this->include_deleted_subscriptions;
    }

    /**
     * If selected, includes deleted subscriptions in the response
     * (up to 63 days after deletion).
     *
     * Generated from protobuf field <code>bool include_deleted_subscriptions = 2;</code>
     * @param bool $var
     * @return $this
     */
    public function setIncludeDeletedSubscriptions($var)
    {
        GPBUtil::checkBool($var);
        $this->include_deleted_subscriptions = $var;

        return $this;
    }

    /**
     * The maximum number of results to return in a single response page.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The maximum number of results to return in a single response page.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Page token, returned by a previous call.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Page token, returned by a previous call.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

