<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/bigquery/datatransfer/v1/transfer.proto

namespace Google\Cloud\BigQuery\DataTransfer\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Options customizing the data transfer schedule.
 *
 * Generated from protobuf message <code>google.cloud.bigquery.datatransfer.v1.ScheduleOptions</code>
 */
class ScheduleOptions extends \Google\Protobuf\Internal\Message
{
    /**
     * If true, automatic scheduling of data transfer runs for this configuration
     * will be disabled. The runs can be started on ad-hoc basis using
     * StartManualTransferRuns API. When automatic scheduling is disabled, the
     * TransferConfig.schedule field will be ignored.
     *
     * Generated from protobuf field <code>bool disable_auto_scheduling = 3;</code>
     */
    protected $disable_auto_scheduling = false;
    /**
     * Specifies time to start scheduling transfer runs. The first run will be
     * scheduled at or after the start time according to a recurrence pattern
     * defined in the schedule string. The start time can be changed at any
     * moment. The time when a data transfer can be triggered manually is not
     * limited by this option.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 1;</code>
     */
    protected $start_time = null;
    /**
     * Defines time to stop scheduling transfer runs. A transfer run cannot be
     * scheduled at or after the end time. The end time can be changed at any
     * moment. The time when a data transfer can be triggered manually is not
     * limited by this option.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_time = 2;</code>
     */
    protected $end_time = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type bool $disable_auto_scheduling
     *           If true, automatic scheduling of data transfer runs for this configuration
     *           will be disabled. The runs can be started on ad-hoc basis using
     *           StartManualTransferRuns API. When automatic scheduling is disabled, the
     *           TransferConfig.schedule field will be ignored.
     *     @type \Google\Protobuf\Timestamp $start_time
     *           Specifies time to start scheduling transfer runs. The first run will be
     *           scheduled at or after the start time according to a recurrence pattern
     *           defined in the schedule string. The start time can be changed at any
     *           moment. The time when a data transfer can be triggered manually is not
     *           limited by this option.
     *     @type \Google\Protobuf\Timestamp $end_time
     *           Defines time to stop scheduling transfer runs. A transfer run cannot be
     *           scheduled at or after the end time. The end time can be changed at any
     *           moment. The time when a data transfer can be triggered manually is not
     *           limited by this option.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Bigquery\Datatransfer\V1\Transfer::initOnce();
        parent::__construct($data);
    }

    /**
     * If true, automatic scheduling of data transfer runs for this configuration
     * will be disabled. The runs can be started on ad-hoc basis using
     * StartManualTransferRuns API. When automatic scheduling is disabled, the
     * TransferConfig.schedule field will be ignored.
     *
     * Generated from protobuf field <code>bool disable_auto_scheduling = 3;</code>
     * @return bool
     */
    public function getDisableAutoScheduling()
    {
        return $this->disable_auto_scheduling;
    }

    /**
     * If true, automatic scheduling of data transfer runs for this configuration
     * will be disabled. The runs can be started on ad-hoc basis using
     * StartManualTransferRuns API. When automatic scheduling is disabled, the
     * TransferConfig.schedule field will be ignored.
     *
     * Generated from protobuf field <code>bool disable_auto_scheduling = 3;</code>
     * @param bool $var
     * @return $this
     */
    public function setDisableAutoScheduling($var)
    {
        GPBUtil::checkBool($var);
        $this->disable_auto_scheduling = $var;

        return $this;
    }

    /**
     * Specifies time to start scheduling transfer runs. The first run will be
     * scheduled at or after the start time according to a recurrence pattern
     * defined in the schedule string. The start time can be changed at any
     * moment. The time when a data transfer can be triggered manually is not
     * limited by this option.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 1;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getStartTime()
    {
        return $this->start_time;
    }

    public function hasStartTime()
    {
        return isset($this->start_time);
    }

    public function clearStartTime()
    {
        unset($this->start_time);
    }

    /**
     * Specifies time to start scheduling transfer runs. The first run will be
     * scheduled at or after the start time according to a recurrence pattern
     * defined in the schedule string. The start time can be changed at any
     * moment. The time when a data transfer can be triggered manually is not
     * limited by this option.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 1;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setStartTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->start_time = $var;

        return $this;
    }

    /**
     * Defines time to stop scheduling transfer runs. A transfer run cannot be
     * scheduled at or after the end time. The end time can be changed at any
     * moment. The time when a data transfer can be triggered manually is not
     * limited by this option.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_time = 2;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getEndTime()
    {
        return $this->end_time;
    }

    public function hasEndTime()
    {
        return isset($this->end_time);
    }

    public function clearEndTime()
    {
        unset($this->end_time);
    }

    /**
     * Defines time to stop scheduling transfer runs. A transfer run cannot be
     * scheduled at or after the end time. The end time can be changed at any
     * moment. The time when a data transfer can be triggered manually is not
     * limited by this option.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_time = 2;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setEndTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->end_time = $var;

        return $this;
    }

}

