<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/bigquery/migration/v2/translation_usability.proto

namespace Google\Cloud\BigQuery\Migration\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A record in the aggregate CSV report for a migration workflow
 *
 * Generated from protobuf message <code>google.cloud.bigquery.migration.v2.GcsReportLogMessage</code>
 */
class GcsReportLogMessage extends \Google\Protobuf\Internal\Message
{
    /**
     * Severity of the translation record.
     *
     * Generated from protobuf field <code>string severity = 1;</code>
     */
    protected $severity = '';
    /**
     * Category of the error/warning. Example: SyntaxError
     *
     * Generated from protobuf field <code>string category = 2;</code>
     */
    protected $category = '';
    /**
     * The file path in which the error occurred
     *
     * Generated from protobuf field <code>string file_path = 3;</code>
     */
    protected $file_path = '';
    /**
     * The file name in which the error occurred
     *
     * Generated from protobuf field <code>string filename = 4;</code>
     */
    protected $filename = '';
    /**
     * Specifies the row from the source text where the error occurred (0 based,
     * -1 for messages without line location). Example: 2
     *
     * Generated from protobuf field <code>int32 source_script_line = 5;</code>
     */
    protected $source_script_line = 0;
    /**
     * Specifies the column from the source texts where the error occurred. (0
     * based, -1 for messages without column location) example: 6
     *
     * Generated from protobuf field <code>int32 source_script_column = 6;</code>
     */
    protected $source_script_column = 0;
    /**
     * Detailed message of the record.
     *
     * Generated from protobuf field <code>string message = 7;</code>
     */
    protected $message = '';
    /**
     * The script context (obfuscated) in which the error occurred
     *
     * Generated from protobuf field <code>string script_context = 8;</code>
     */
    protected $script_context = '';
    /**
     * Category of the error/warning. Example: SyntaxError
     *
     * Generated from protobuf field <code>string action = 9;</code>
     */
    protected $action = '';
    /**
     * Effect of the error/warning. Example: COMPATIBILITY
     *
     * Generated from protobuf field <code>string effect = 10;</code>
     */
    protected $effect = '';
    /**
     * Name of the affected object in the log message.
     *
     * Generated from protobuf field <code>string object_name = 11;</code>
     */
    protected $object_name = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $severity
     *           Severity of the translation record.
     *     @type string $category
     *           Category of the error/warning. Example: SyntaxError
     *     @type string $file_path
     *           The file path in which the error occurred
     *     @type string $filename
     *           The file name in which the error occurred
     *     @type int $source_script_line
     *           Specifies the row from the source text where the error occurred (0 based,
     *           -1 for messages without line location). Example: 2
     *     @type int $source_script_column
     *           Specifies the column from the source texts where the error occurred. (0
     *           based, -1 for messages without column location) example: 6
     *     @type string $message
     *           Detailed message of the record.
     *     @type string $script_context
     *           The script context (obfuscated) in which the error occurred
     *     @type string $action
     *           Category of the error/warning. Example: SyntaxError
     *     @type string $effect
     *           Effect of the error/warning. Example: COMPATIBILITY
     *     @type string $object_name
     *           Name of the affected object in the log message.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Bigquery\Migration\V2\TranslationUsability::initOnce();
        parent::__construct($data);
    }

    /**
     * Severity of the translation record.
     *
     * Generated from protobuf field <code>string severity = 1;</code>
     * @return string
     */
    public function getSeverity()
    {
        return $this->severity;
    }

    /**
     * Severity of the translation record.
     *
     * Generated from protobuf field <code>string severity = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setSeverity($var)
    {
        GPBUtil::checkString($var, True);
        $this->severity = $var;

        return $this;
    }

    /**
     * Category of the error/warning. Example: SyntaxError
     *
     * Generated from protobuf field <code>string category = 2;</code>
     * @return string
     */
    public function getCategory()
    {
        return $this->category;
    }

    /**
     * Category of the error/warning. Example: SyntaxError
     *
     * Generated from protobuf field <code>string category = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setCategory($var)
    {
        GPBUtil::checkString($var, True);
        $this->category = $var;

        return $this;
    }

    /**
     * The file path in which the error occurred
     *
     * Generated from protobuf field <code>string file_path = 3;</code>
     * @return string
     */
    public function getFilePath()
    {
        return $this->file_path;
    }

    /**
     * The file path in which the error occurred
     *
     * Generated from protobuf field <code>string file_path = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setFilePath($var)
    {
        GPBUtil::checkString($var, True);
        $this->file_path = $var;

        return $this;
    }

    /**
     * The file name in which the error occurred
     *
     * Generated from protobuf field <code>string filename = 4;</code>
     * @return string
     */
    public function getFilename()
    {
        return $this->filename;
    }

    /**
     * The file name in which the error occurred
     *
     * Generated from protobuf field <code>string filename = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setFilename($var)
    {
        GPBUtil::checkString($var, True);
        $this->filename = $var;

        return $this;
    }

    /**
     * Specifies the row from the source text where the error occurred (0 based,
     * -1 for messages without line location). Example: 2
     *
     * Generated from protobuf field <code>int32 source_script_line = 5;</code>
     * @return int
     */
    public function getSourceScriptLine()
    {
        return $this->source_script_line;
    }

    /**
     * Specifies the row from the source text where the error occurred (0 based,
     * -1 for messages without line location). Example: 2
     *
     * Generated from protobuf field <code>int32 source_script_line = 5;</code>
     * @param int $var
     * @return $this
     */
    public function setSourceScriptLine($var)
    {
        GPBUtil::checkInt32($var);
        $this->source_script_line = $var;

        return $this;
    }

    /**
     * Specifies the column from the source texts where the error occurred. (0
     * based, -1 for messages without column location) example: 6
     *
     * Generated from protobuf field <code>int32 source_script_column = 6;</code>
     * @return int
     */
    public function getSourceScriptColumn()
    {
        return $this->source_script_column;
    }

    /**
     * Specifies the column from the source texts where the error occurred. (0
     * based, -1 for messages without column location) example: 6
     *
     * Generated from protobuf field <code>int32 source_script_column = 6;</code>
     * @param int $var
     * @return $this
     */
    public function setSourceScriptColumn($var)
    {
        GPBUtil::checkInt32($var);
        $this->source_script_column = $var;

        return $this;
    }

    /**
     * Detailed message of the record.
     *
     * Generated from protobuf field <code>string message = 7;</code>
     * @return string
     */
    public function getMessage()
    {
        return $this->message;
    }

    /**
     * Detailed message of the record.
     *
     * Generated from protobuf field <code>string message = 7;</code>
     * @param string $var
     * @return $this
     */
    public function setMessage($var)
    {
        GPBUtil::checkString($var, True);
        $this->message = $var;

        return $this;
    }

    /**
     * The script context (obfuscated) in which the error occurred
     *
     * Generated from protobuf field <code>string script_context = 8;</code>
     * @return string
     */
    public function getScriptContext()
    {
        return $this->script_context;
    }

    /**
     * The script context (obfuscated) in which the error occurred
     *
     * Generated from protobuf field <code>string script_context = 8;</code>
     * @param string $var
     * @return $this
     */
    public function setScriptContext($var)
    {
        GPBUtil::checkString($var, True);
        $this->script_context = $var;

        return $this;
    }

    /**
     * Category of the error/warning. Example: SyntaxError
     *
     * Generated from protobuf field <code>string action = 9;</code>
     * @return string
     */
    public function getAction()
    {
        return $this->action;
    }

    /**
     * Category of the error/warning. Example: SyntaxError
     *
     * Generated from protobuf field <code>string action = 9;</code>
     * @param string $var
     * @return $this
     */
    public function setAction($var)
    {
        GPBUtil::checkString($var, True);
        $this->action = $var;

        return $this;
    }

    /**
     * Effect of the error/warning. Example: COMPATIBILITY
     *
     * Generated from protobuf field <code>string effect = 10;</code>
     * @return string
     */
    public function getEffect()
    {
        return $this->effect;
    }

    /**
     * Effect of the error/warning. Example: COMPATIBILITY
     *
     * Generated from protobuf field <code>string effect = 10;</code>
     * @param string $var
     * @return $this
     */
    public function setEffect($var)
    {
        GPBUtil::checkString($var, True);
        $this->effect = $var;

        return $this;
    }

    /**
     * Name of the affected object in the log message.
     *
     * Generated from protobuf field <code>string object_name = 11;</code>
     * @return string
     */
    public function getObjectName()
    {
        return $this->object_name;
    }

    /**
     * Name of the affected object in the log message.
     *
     * Generated from protobuf field <code>string object_name = 11;</code>
     * @param string $var
     * @return $this
     */
    public function setObjectName($var)
    {
        GPBUtil::checkString($var, True);
        $this->object_name = $var;

        return $this;
    }

}

