<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/bigquery/reservation/v1/reservation.proto

namespace Google\Cloud\BigQuery\Reservation\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request for
 * [ReservationService.DeleteCapacityCommitment][google.cloud.bigquery.reservation.v1.ReservationService.DeleteCapacityCommitment].
 *
 * Generated from protobuf message <code>google.cloud.bigquery.reservation.v1.DeleteCapacityCommitmentRequest</code>
 */
class DeleteCapacityCommitmentRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Resource name of the capacity commitment to delete. E.g.,
     *    `projects/myproject/locations/US/capacityCommitments/123`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';
    /**
     * Can be used to force delete commitments even if assignments exist. Deleting
     * commitments with assignments may cause queries to fail if they no longer
     * have access to slots.
     *
     * Generated from protobuf field <code>bool force = 3;</code>
     */
    protected $force = false;

    /**
     * @param string $name Required. Resource name of the capacity commitment to delete. E.g.,
     *                     `projects/myproject/locations/US/capacityCommitments/123`
     *                     Please see {@see ReservationServiceClient::capacityCommitmentName()} for help formatting this field.
     *
     * @return \Google\Cloud\BigQuery\Reservation\V1\DeleteCapacityCommitmentRequest
     *
     * @experimental
     */
    public static function build(string $name): self
    {
        return (new self())
            ->setName($name);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. Resource name of the capacity commitment to delete. E.g.,
     *              `projects/myproject/locations/US/capacityCommitments/123`
     *     @type bool $force
     *           Can be used to force delete commitments even if assignments exist. Deleting
     *           commitments with assignments may cause queries to fail if they no longer
     *           have access to slots.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Bigquery\Reservation\V1\Reservation::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Resource name of the capacity commitment to delete. E.g.,
     *    `projects/myproject/locations/US/capacityCommitments/123`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. Resource name of the capacity commitment to delete. E.g.,
     *    `projects/myproject/locations/US/capacityCommitments/123`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Can be used to force delete commitments even if assignments exist. Deleting
     * commitments with assignments may cause queries to fail if they no longer
     * have access to slots.
     *
     * Generated from protobuf field <code>bool force = 3;</code>
     * @return bool
     */
    public function getForce()
    {
        return $this->force;
    }

    /**
     * Can be used to force delete commitments even if assignments exist. Deleting
     * commitments with assignments may cause queries to fail if they no longer
     * have access to slots.
     *
     * Generated from protobuf field <code>bool force = 3;</code>
     * @param bool $var
     * @return $this
     */
    public function setForce($var)
    {
        GPBUtil::checkBool($var);
        $this->force = $var;

        return $this;
    }

}

