<?php
/*
 * Copyright 2024 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * GENERATED CODE WARNING
 * This file was automatically generated - do not edit!
 */

return [
    'interfaces' => [
        'google.cloud.bigquery.storage.v1.BigQueryWrite' => [
            'BatchCommitWriteStreams' => [
                'method' => 'get',
                'uriTemplate' => '/v1/{parent=projects/*/datasets/*/tables/*}',
                'placeholders' => [
                    'parent' => [
                        'getters' => [
                            'getParent',
                        ],
                    ],
                ],
                'queryParams' => [
                    'write_streams',
                ],
            ],
            'CreateWriteStream' => [
                'method' => 'post',
                'uriTemplate' => '/v1/{parent=projects/*/datasets/*/tables/*}',
                'body' => 'write_stream',
                'placeholders' => [
                    'parent' => [
                        'getters' => [
                            'getParent',
                        ],
                    ],
                ],
            ],
            'FinalizeWriteStream' => [
                'method' => 'post',
                'uriTemplate' => '/v1/{name=projects/*/datasets/*/tables/*/streams/*}',
                'body' => '*',
                'placeholders' => [
                    'name' => [
                        'getters' => [
                            'getName',
                        ],
                    ],
                ],
            ],
            'FlushRows' => [
                'method' => 'post',
                'uriTemplate' => '/v1/{write_stream=projects/*/datasets/*/tables/*/streams/*}',
                'body' => '*',
                'placeholders' => [
                    'write_stream' => [
                        'getters' => [
                            'getWriteStream',
                        ],
                    ],
                ],
            ],
            'GetWriteStream' => [
                'method' => 'post',
                'uriTemplate' => '/v1/{name=projects/*/datasets/*/tables/*/streams/*}',
                'body' => '*',
                'placeholders' => [
                    'name' => [
                        'getters' => [
                            'getName',
                        ],
                    ],
                ],
            ],
        ],
    ],
];
