<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/bigtable/admin/v2/bigtable_table_admin.proto

namespace Google\Cloud\Bigtable\Admin\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [google.bigtable.admin.v2.BigtableTableAdmin.ListAuthorizedViews][google.bigtable.admin.v2.BigtableTableAdmin.ListAuthorizedViews]
 *
 * Generated from protobuf message <code>google.bigtable.admin.v2.ListAuthorizedViewsRequest</code>
 */
class ListAuthorizedViewsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The unique name of the table for which AuthorizedViews should be
     * listed. Values are of the form
     * `projects/{project}/instances/{instance}/tables/{table}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. Maximum number of results per page.
     * A page_size of zero lets the server choose the number of items to return.
     * A page_size which is strictly positive will return at most that many items.
     * A negative page_size will cause an error.
     * Following the first request, subsequent paginated calls are not required
     * to pass a page_size. If a page_size is set in subsequent calls, it must
     * match the page_size given in the first request.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. The value of `next_page_token` returned by a previous call.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';
    /**
     * Optional. The resource_view to be applied to the returned views' fields.
     * Default to NAME_ONLY.
     *
     * Generated from protobuf field <code>.google.bigtable.admin.v2.AuthorizedView.ResponseView view = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $view = 0;

    /**
     * @param string $parent Required. The unique name of the table for which AuthorizedViews should be
     *                       listed. Values are of the form
     *                       `projects/{project}/instances/{instance}/tables/{table}`. Please see
     *                       {@see BigtableTableAdminClient::tableName()} for help formatting this field.
     *
     * @return \Google\Cloud\Bigtable\Admin\V2\ListAuthorizedViewsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The unique name of the table for which AuthorizedViews should be
     *           listed. Values are of the form
     *           `projects/{project}/instances/{instance}/tables/{table}`.
     *     @type int $page_size
     *           Optional. Maximum number of results per page.
     *           A page_size of zero lets the server choose the number of items to return.
     *           A page_size which is strictly positive will return at most that many items.
     *           A negative page_size will cause an error.
     *           Following the first request, subsequent paginated calls are not required
     *           to pass a page_size. If a page_size is set in subsequent calls, it must
     *           match the page_size given in the first request.
     *     @type string $page_token
     *           Optional. The value of `next_page_token` returned by a previous call.
     *     @type int $view
     *           Optional. The resource_view to be applied to the returned views' fields.
     *           Default to NAME_ONLY.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Bigtable\Admin\V2\BigtableTableAdmin::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The unique name of the table for which AuthorizedViews should be
     * listed. Values are of the form
     * `projects/{project}/instances/{instance}/tables/{table}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The unique name of the table for which AuthorizedViews should be
     * listed. Values are of the form
     * `projects/{project}/instances/{instance}/tables/{table}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. Maximum number of results per page.
     * A page_size of zero lets the server choose the number of items to return.
     * A page_size which is strictly positive will return at most that many items.
     * A negative page_size will cause an error.
     * Following the first request, subsequent paginated calls are not required
     * to pass a page_size. If a page_size is set in subsequent calls, it must
     * match the page_size given in the first request.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. Maximum number of results per page.
     * A page_size of zero lets the server choose the number of items to return.
     * A page_size which is strictly positive will return at most that many items.
     * A negative page_size will cause an error.
     * Following the first request, subsequent paginated calls are not required
     * to pass a page_size. If a page_size is set in subsequent calls, it must
     * match the page_size given in the first request.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. The value of `next_page_token` returned by a previous call.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. The value of `next_page_token` returned by a previous call.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. The resource_view to be applied to the returned views' fields.
     * Default to NAME_ONLY.
     *
     * Generated from protobuf field <code>.google.bigtable.admin.v2.AuthorizedView.ResponseView view = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getView()
    {
        return $this->view;
    }

    /**
     * Optional. The resource_view to be applied to the returned views' fields.
     * Default to NAME_ONLY.
     *
     * Generated from protobuf field <code>.google.bigtable.admin.v2.AuthorizedView.ResponseView view = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setView($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Bigtable\Admin\V2\AuthorizedView\ResponseView::class);
        $this->view = $var;

        return $this;
    }

}

