<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/bigtable/v2/bigtable.proto

namespace Google\Cloud\Bigtable\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * NOTE: This API is intended to be used by Apache Beam BigtableIO.
 * Request message for Bigtable.GenerateInitialChangeStreamPartitions.
 *
 * Generated from protobuf message <code>google.bigtable.v2.GenerateInitialChangeStreamPartitionsRequest</code>
 */
class GenerateInitialChangeStreamPartitionsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The unique name of the table from which to get change stream
     * partitions. Values are of the form
     * `projects/<project>/instances/<instance>/tables/<table>`.
     * Change streaming must be enabled on the table.
     *
     * Generated from protobuf field <code>string table_name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $table_name = '';
    /**
     * This value specifies routing for replication. If not specified, the
     * "default" application profile will be used.
     * Single cluster routing must be configured on the profile.
     *
     * Generated from protobuf field <code>string app_profile_id = 2;</code>
     */
    protected $app_profile_id = '';

    /**
     * @param string $tableName Required. The unique name of the table from which to get change stream
     *                          partitions. Values are of the form
     *                          `projects/<project>/instances/<instance>/tables/<table>`.
     *                          Change streaming must be enabled on the table. Please see
     *                          {@see BigtableClient::tableName()} for help formatting this field.
     *
     * @return \Google\Cloud\Bigtable\V2\GenerateInitialChangeStreamPartitionsRequest
     *
     * @experimental
     */
    public static function build(string $tableName): self
    {
        return (new self())
            ->setTableName($tableName);
    }

    /**
     * @param string $tableName    Required. The unique name of the table from which to get change stream
     *                             partitions. Values are of the form
     *                             `projects/<project>/instances/<instance>/tables/<table>`.
     *                             Change streaming must be enabled on the table. Please see
     *                             {@see BigtableClient::tableName()} for help formatting this field.
     * @param string $appProfileId This value specifies routing for replication. If not specified, the
     *                             "default" application profile will be used.
     *                             Single cluster routing must be configured on the profile.
     *
     * @return \Google\Cloud\Bigtable\V2\GenerateInitialChangeStreamPartitionsRequest
     *
     * @experimental
     */
    public static function buildFromTableNameAppProfileId(string $tableName, string $appProfileId): self
    {
        return (new self())
            ->setTableName($tableName)
            ->setAppProfileId($appProfileId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $table_name
     *           Required. The unique name of the table from which to get change stream
     *           partitions. Values are of the form
     *           `projects/<project>/instances/<instance>/tables/<table>`.
     *           Change streaming must be enabled on the table.
     *     @type string $app_profile_id
     *           This value specifies routing for replication. If not specified, the
     *           "default" application profile will be used.
     *           Single cluster routing must be configured on the profile.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Bigtable\V2\Bigtable::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The unique name of the table from which to get change stream
     * partitions. Values are of the form
     * `projects/<project>/instances/<instance>/tables/<table>`.
     * Change streaming must be enabled on the table.
     *
     * Generated from protobuf field <code>string table_name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getTableName()
    {
        return $this->table_name;
    }

    /**
     * Required. The unique name of the table from which to get change stream
     * partitions. Values are of the form
     * `projects/<project>/instances/<instance>/tables/<table>`.
     * Change streaming must be enabled on the table.
     *
     * Generated from protobuf field <code>string table_name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setTableName($var)
    {
        GPBUtil::checkString($var, True);
        $this->table_name = $var;

        return $this;
    }

    /**
     * This value specifies routing for replication. If not specified, the
     * "default" application profile will be used.
     * Single cluster routing must be configured on the profile.
     *
     * Generated from protobuf field <code>string app_profile_id = 2;</code>
     * @return string
     */
    public function getAppProfileId()
    {
        return $this->app_profile_id;
    }

    /**
     * This value specifies routing for replication. If not specified, the
     * "default" application profile will be used.
     * Single cluster routing must be configured on the profile.
     *
     * Generated from protobuf field <code>string app_profile_id = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setAppProfileId($var)
    {
        GPBUtil::checkString($var, True);
        $this->app_profile_id = $var;

        return $this;
    }

}

