<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/bigtable/v2/request_stats.proto

namespace Google\Cloud\Bigtable\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * ReadIterationStats captures information about the iteration of rows or cells
 * over the course of a read, e.g. how many results were scanned in a read
 * operation versus the results returned.
 *
 * Generated from protobuf message <code>google.bigtable.v2.ReadIterationStats</code>
 */
class ReadIterationStats extends \Google\Protobuf\Internal\Message
{
    /**
     * The rows seen (scanned) as part of the request. This includes the count of
     * rows returned, as captured below.
     *
     * Generated from protobuf field <code>int64 rows_seen_count = 1;</code>
     */
    protected $rows_seen_count = 0;
    /**
     * The rows returned as part of the request.
     *
     * Generated from protobuf field <code>int64 rows_returned_count = 2;</code>
     */
    protected $rows_returned_count = 0;
    /**
     * The cells seen (scanned) as part of the request. This includes the count of
     * cells returned, as captured below.
     *
     * Generated from protobuf field <code>int64 cells_seen_count = 3;</code>
     */
    protected $cells_seen_count = 0;
    /**
     * The cells returned as part of the request.
     *
     * Generated from protobuf field <code>int64 cells_returned_count = 4;</code>
     */
    protected $cells_returned_count = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int|string $rows_seen_count
     *           The rows seen (scanned) as part of the request. This includes the count of
     *           rows returned, as captured below.
     *     @type int|string $rows_returned_count
     *           The rows returned as part of the request.
     *     @type int|string $cells_seen_count
     *           The cells seen (scanned) as part of the request. This includes the count of
     *           cells returned, as captured below.
     *     @type int|string $cells_returned_count
     *           The cells returned as part of the request.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Bigtable\V2\RequestStats::initOnce();
        parent::__construct($data);
    }

    /**
     * The rows seen (scanned) as part of the request. This includes the count of
     * rows returned, as captured below.
     *
     * Generated from protobuf field <code>int64 rows_seen_count = 1;</code>
     * @return int|string
     */
    public function getRowsSeenCount()
    {
        return $this->rows_seen_count;
    }

    /**
     * The rows seen (scanned) as part of the request. This includes the count of
     * rows returned, as captured below.
     *
     * Generated from protobuf field <code>int64 rows_seen_count = 1;</code>
     * @param int|string $var
     * @return $this
     */
    public function setRowsSeenCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->rows_seen_count = $var;

        return $this;
    }

    /**
     * The rows returned as part of the request.
     *
     * Generated from protobuf field <code>int64 rows_returned_count = 2;</code>
     * @return int|string
     */
    public function getRowsReturnedCount()
    {
        return $this->rows_returned_count;
    }

    /**
     * The rows returned as part of the request.
     *
     * Generated from protobuf field <code>int64 rows_returned_count = 2;</code>
     * @param int|string $var
     * @return $this
     */
    public function setRowsReturnedCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->rows_returned_count = $var;

        return $this;
    }

    /**
     * The cells seen (scanned) as part of the request. This includes the count of
     * cells returned, as captured below.
     *
     * Generated from protobuf field <code>int64 cells_seen_count = 3;</code>
     * @return int|string
     */
    public function getCellsSeenCount()
    {
        return $this->cells_seen_count;
    }

    /**
     * The cells seen (scanned) as part of the request. This includes the count of
     * cells returned, as captured below.
     *
     * Generated from protobuf field <code>int64 cells_seen_count = 3;</code>
     * @param int|string $var
     * @return $this
     */
    public function setCellsSeenCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->cells_seen_count = $var;

        return $this;
    }

    /**
     * The cells returned as part of the request.
     *
     * Generated from protobuf field <code>int64 cells_returned_count = 4;</code>
     * @return int|string
     */
    public function getCellsReturnedCount()
    {
        return $this->cells_returned_count;
    }

    /**
     * The cells returned as part of the request.
     *
     * Generated from protobuf field <code>int64 cells_returned_count = 4;</code>
     * @param int|string $var
     * @return $this
     */
    public function setCellsReturnedCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->cells_returned_count = $var;

        return $this;
    }

}

