<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/billing/v1/cloud_catalog.proto

namespace Google\Cloud\Billing\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents the category hierarchy of a SKU.
 *
 * Generated from protobuf message <code>google.cloud.billing.v1.Category</code>
 */
class Category extends \Google\Protobuf\Internal\Message
{
    /**
     * The display name of the service this SKU belongs to.
     *
     * Generated from protobuf field <code>string service_display_name = 1;</code>
     */
    protected $service_display_name = '';
    /**
     * The type of product the SKU refers to.
     * Example: "Compute", "Storage", "Network", "ApplicationServices" etc.
     *
     * Generated from protobuf field <code>string resource_family = 2;</code>
     */
    protected $resource_family = '';
    /**
     * A group classification for related SKUs.
     * Example: "RAM", "GPU", "Prediction", "Ops", "GoogleEgress" etc.
     *
     * Generated from protobuf field <code>string resource_group = 3;</code>
     */
    protected $resource_group = '';
    /**
     * Represents how the SKU is consumed.
     * Example: "OnDemand", "Preemptible", "Commit1Mo", "Commit1Yr" etc.
     *
     * Generated from protobuf field <code>string usage_type = 4;</code>
     */
    protected $usage_type = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $service_display_name
     *           The display name of the service this SKU belongs to.
     *     @type string $resource_family
     *           The type of product the SKU refers to.
     *           Example: "Compute", "Storage", "Network", "ApplicationServices" etc.
     *     @type string $resource_group
     *           A group classification for related SKUs.
     *           Example: "RAM", "GPU", "Prediction", "Ops", "GoogleEgress" etc.
     *     @type string $usage_type
     *           Represents how the SKU is consumed.
     *           Example: "OnDemand", "Preemptible", "Commit1Mo", "Commit1Yr" etc.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Billing\V1\CloudCatalog::initOnce();
        parent::__construct($data);
    }

    /**
     * The display name of the service this SKU belongs to.
     *
     * Generated from protobuf field <code>string service_display_name = 1;</code>
     * @return string
     */
    public function getServiceDisplayName()
    {
        return $this->service_display_name;
    }

    /**
     * The display name of the service this SKU belongs to.
     *
     * Generated from protobuf field <code>string service_display_name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setServiceDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->service_display_name = $var;

        return $this;
    }

    /**
     * The type of product the SKU refers to.
     * Example: "Compute", "Storage", "Network", "ApplicationServices" etc.
     *
     * Generated from protobuf field <code>string resource_family = 2;</code>
     * @return string
     */
    public function getResourceFamily()
    {
        return $this->resource_family;
    }

    /**
     * The type of product the SKU refers to.
     * Example: "Compute", "Storage", "Network", "ApplicationServices" etc.
     *
     * Generated from protobuf field <code>string resource_family = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setResourceFamily($var)
    {
        GPBUtil::checkString($var, True);
        $this->resource_family = $var;

        return $this;
    }

    /**
     * A group classification for related SKUs.
     * Example: "RAM", "GPU", "Prediction", "Ops", "GoogleEgress" etc.
     *
     * Generated from protobuf field <code>string resource_group = 3;</code>
     * @return string
     */
    public function getResourceGroup()
    {
        return $this->resource_group;
    }

    /**
     * A group classification for related SKUs.
     * Example: "RAM", "GPU", "Prediction", "Ops", "GoogleEgress" etc.
     *
     * Generated from protobuf field <code>string resource_group = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setResourceGroup($var)
    {
        GPBUtil::checkString($var, True);
        $this->resource_group = $var;

        return $this;
    }

    /**
     * Represents how the SKU is consumed.
     * Example: "OnDemand", "Preemptible", "Commit1Mo", "Commit1Yr" etc.
     *
     * Generated from protobuf field <code>string usage_type = 4;</code>
     * @return string
     */
    public function getUsageType()
    {
        return $this->usage_type;
    }

    /**
     * Represents how the SKU is consumed.
     * Example: "OnDemand", "Preemptible", "Commit1Mo", "Commit1Yr" etc.
     *
     * Generated from protobuf field <code>string usage_type = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setUsageType($var)
    {
        GPBUtil::checkString($var, True);
        $this->usage_type = $var;

        return $this;
    }

}

