<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/billing/v1/cloud_billing.proto

namespace Google\Cloud\Billing\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for `ListBillingAccounts`.
 *
 * Generated from protobuf message <code>google.cloud.billing.v1.ListBillingAccountsRequest</code>
 */
class ListBillingAccountsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Requested page size. The maximum page size is 100; this is also the
     * default.
     *
     * Generated from protobuf field <code>int32 page_size = 1;</code>
     */
    protected $page_size = 0;
    /**
     * A token identifying a page of results to return. This should be a
     * `next_page_token` value returned from a previous `ListBillingAccounts`
     * call. If unspecified, the first page of results is returned.
     *
     * Generated from protobuf field <code>string page_token = 2;</code>
     */
    protected $page_token = '';
    /**
     * Options for how to filter the returned billing accounts.
     * This only supports filtering for
     * [subaccounts](https://cloud.google.com/billing/docs/concepts) under a
     * single provided parent billing account.
     * (for example,
     * `master_billing_account=billingAccounts/012345-678901-ABCDEF`).
     * Boolean algebra and other fields are not currently supported.
     *
     * Generated from protobuf field <code>string filter = 3;</code>
     */
    protected $filter = '';
    /**
     * Optional. The parent resource to list billing accounts from.
     * Format:
     *   - `organizations/{organization_id}`, for example,
     *     `organizations/12345678`
     *   - `billingAccounts/{billing_account_id}`, for example,
     *     `billingAccounts/012345-567890-ABCDEF`
     *
     * Generated from protobuf field <code>string parent = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $parent = '';

    /**
     * @param string $parent Optional. The parent resource to list billing accounts from.
     *                       Format:
     *                       - `organizations/{organization_id}`, for example,
     *                       `organizations/12345678`
     *                       - `billingAccounts/{billing_account_id}`, for example,
     *                       `billingAccounts/012345-567890-ABCDEF`
     *
     * @return \Google\Cloud\Billing\V1\ListBillingAccountsRequest
     *
     * @experimental
     */
    public static function buildFromParent(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int $page_size
     *           Requested page size. The maximum page size is 100; this is also the
     *           default.
     *     @type string $page_token
     *           A token identifying a page of results to return. This should be a
     *           `next_page_token` value returned from a previous `ListBillingAccounts`
     *           call. If unspecified, the first page of results is returned.
     *     @type string $filter
     *           Options for how to filter the returned billing accounts.
     *           This only supports filtering for
     *           [subaccounts](https://cloud.google.com/billing/docs/concepts) under a
     *           single provided parent billing account.
     *           (for example,
     *           `master_billing_account=billingAccounts/012345-678901-ABCDEF`).
     *           Boolean algebra and other fields are not currently supported.
     *     @type string $parent
     *           Optional. The parent resource to list billing accounts from.
     *           Format:
     *             - `organizations/{organization_id}`, for example,
     *               `organizations/12345678`
     *             - `billingAccounts/{billing_account_id}`, for example,
     *               `billingAccounts/012345-567890-ABCDEF`
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Billing\V1\CloudBilling::initOnce();
        parent::__construct($data);
    }

    /**
     * Requested page size. The maximum page size is 100; this is also the
     * default.
     *
     * Generated from protobuf field <code>int32 page_size = 1;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Requested page size. The maximum page size is 100; this is also the
     * default.
     *
     * Generated from protobuf field <code>int32 page_size = 1;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * A token identifying a page of results to return. This should be a
     * `next_page_token` value returned from a previous `ListBillingAccounts`
     * call. If unspecified, the first page of results is returned.
     *
     * Generated from protobuf field <code>string page_token = 2;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * A token identifying a page of results to return. This should be a
     * `next_page_token` value returned from a previous `ListBillingAccounts`
     * call. If unspecified, the first page of results is returned.
     *
     * Generated from protobuf field <code>string page_token = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Options for how to filter the returned billing accounts.
     * This only supports filtering for
     * [subaccounts](https://cloud.google.com/billing/docs/concepts) under a
     * single provided parent billing account.
     * (for example,
     * `master_billing_account=billingAccounts/012345-678901-ABCDEF`).
     * Boolean algebra and other fields are not currently supported.
     *
     * Generated from protobuf field <code>string filter = 3;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Options for how to filter the returned billing accounts.
     * This only supports filtering for
     * [subaccounts](https://cloud.google.com/billing/docs/concepts) under a
     * single provided parent billing account.
     * (for example,
     * `master_billing_account=billingAccounts/012345-678901-ABCDEF`).
     * Boolean algebra and other fields are not currently supported.
     *
     * Generated from protobuf field <code>string filter = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * Optional. The parent resource to list billing accounts from.
     * Format:
     *   - `organizations/{organization_id}`, for example,
     *     `organizations/12345678`
     *   - `billingAccounts/{billing_account_id}`, for example,
     *     `billingAccounts/012345-567890-ABCDEF`
     *
     * Generated from protobuf field <code>string parent = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Optional. The parent resource to list billing accounts from.
     * Format:
     *   - `organizations/{organization_id}`, for example,
     *     `organizations/12345678`
     *   - `billingAccounts/{billing_account_id}`, for example,
     *     `billingAccounts/012345-567890-ABCDEF`
     *
     * Generated from protobuf field <code>string parent = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

}

