<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/billing/v1/cloud_billing.proto

namespace Google\Cloud\Billing\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for `ListProjectBillingInfo`.
 *
 * Generated from protobuf message <code>google.cloud.billing.v1.ListProjectBillingInfoRequest</code>
 */
class ListProjectBillingInfoRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the billing account associated with the
     * projects that you want to list. For example,
     * `billingAccounts/012345-567890-ABCDEF`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';
    /**
     * Requested page size. The maximum page size is 100; this is also the
     * default.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     */
    protected $page_size = 0;
    /**
     * A token identifying a page of results to be returned. This should be a
     * `next_page_token` value returned from a previous `ListProjectBillingInfo`
     * call. If unspecified, the first page of results is returned.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     */
    protected $page_token = '';

    /**
     * @param string $name Required. The resource name of the billing account associated with the
     *                     projects that you want to list. For example,
     *                     `billingAccounts/012345-567890-ABCDEF`. Please see
     *                     {@see CloudBillingClient::billingAccountName()} for help formatting this field.
     *
     * @return \Google\Cloud\Billing\V1\ListProjectBillingInfoRequest
     *
     * @experimental
     */
    public static function build(string $name): self
    {
        return (new self())
            ->setName($name);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. The resource name of the billing account associated with the
     *           projects that you want to list. For example,
     *           `billingAccounts/012345-567890-ABCDEF`.
     *     @type int $page_size
     *           Requested page size. The maximum page size is 100; this is also the
     *           default.
     *     @type string $page_token
     *           A token identifying a page of results to be returned. This should be a
     *           `next_page_token` value returned from a previous `ListProjectBillingInfo`
     *           call. If unspecified, the first page of results is returned.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Billing\V1\CloudBilling::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the billing account associated with the
     * projects that you want to list. For example,
     * `billingAccounts/012345-567890-ABCDEF`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. The resource name of the billing account associated with the
     * projects that you want to list. For example,
     * `billingAccounts/012345-567890-ABCDEF`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Requested page size. The maximum page size is 100; this is also the
     * default.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Requested page size. The maximum page size is 100; this is also the
     * default.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * A token identifying a page of results to be returned. This should be a
     * `next_page_token` value returned from a previous `ListProjectBillingInfo`
     * call. If unspecified, the first page of results is returned.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * A token identifying a page of results to be returned. This should be a
     * `next_page_token` value returned from a previous `ListProjectBillingInfo`
     * call. If unspecified, the first page of results is returned.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

