<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/billing/budgets/v1/budget_service.proto

namespace Google\Cloud\Billing\Budgets\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request for ListBudgets
 *
 * Generated from protobuf message <code>google.cloud.billing.budgets.v1.ListBudgetsRequest</code>
 */
class ListBudgetsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Name of billing account to list budgets under. Values
     * are of the form `billingAccounts/{billingAccountId}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. Set the scope of the budgets to be returned, in the format of the
     * resource name. The scope of a budget is the cost that it tracks, such as
     * costs for a single project, or the costs for all projects in a folder. Only
     * project scope (in the format of "projects/project-id" or "projects/123") is
     * supported in this field. When this field is set to a project's resource
     * name, the budgets returned are tracking the costs for that project.
     *
     * Generated from protobuf field <code>string scope = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $scope = '';
    /**
     * Optional. The maximum number of budgets to return per page.
     * The default and maximum value are 100.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. The value returned by the last `ListBudgetsResponse` which
     * indicates that this is a continuation of a prior `ListBudgets` call,
     * and that the system should return the next page of data.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';

    /**
     * @param string $parent Required. Name of billing account to list budgets under. Values
     *                       are of the form `billingAccounts/{billingAccountId}`. Please see
     *                       {@see BudgetServiceClient::billingAccountName()} for help formatting this field.
     *
     * @return \Google\Cloud\Billing\Budgets\V1\ListBudgetsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Name of billing account to list budgets under. Values
     *           are of the form `billingAccounts/{billingAccountId}`.
     *     @type string $scope
     *           Optional. Set the scope of the budgets to be returned, in the format of the
     *           resource name. The scope of a budget is the cost that it tracks, such as
     *           costs for a single project, or the costs for all projects in a folder. Only
     *           project scope (in the format of "projects/project-id" or "projects/123") is
     *           supported in this field. When this field is set to a project's resource
     *           name, the budgets returned are tracking the costs for that project.
     *     @type int $page_size
     *           Optional. The maximum number of budgets to return per page.
     *           The default and maximum value are 100.
     *     @type string $page_token
     *           Optional. The value returned by the last `ListBudgetsResponse` which
     *           indicates that this is a continuation of a prior `ListBudgets` call,
     *           and that the system should return the next page of data.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Billing\Budgets\V1\BudgetService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Name of billing account to list budgets under. Values
     * are of the form `billingAccounts/{billingAccountId}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Name of billing account to list budgets under. Values
     * are of the form `billingAccounts/{billingAccountId}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. Set the scope of the budgets to be returned, in the format of the
     * resource name. The scope of a budget is the cost that it tracks, such as
     * costs for a single project, or the costs for all projects in a folder. Only
     * project scope (in the format of "projects/project-id" or "projects/123") is
     * supported in this field. When this field is set to a project's resource
     * name, the budgets returned are tracking the costs for that project.
     *
     * Generated from protobuf field <code>string scope = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getScope()
    {
        return $this->scope;
    }

    /**
     * Optional. Set the scope of the budgets to be returned, in the format of the
     * resource name. The scope of a budget is the cost that it tracks, such as
     * costs for a single project, or the costs for all projects in a folder. Only
     * project scope (in the format of "projects/project-id" or "projects/123") is
     * supported in this field. When this field is set to a project's resource
     * name, the budgets returned are tracking the costs for that project.
     *
     * Generated from protobuf field <code>string scope = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setScope($var)
    {
        GPBUtil::checkString($var, True);
        $this->scope = $var;

        return $this;
    }

    /**
     * Optional. The maximum number of budgets to return per page.
     * The default and maximum value are 100.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. The maximum number of budgets to return per page.
     * The default and maximum value are 100.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. The value returned by the last `ListBudgetsResponse` which
     * indicates that this is a continuation of a prior `ListBudgets` call,
     * and that the system should return the next page of data.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. The value returned by the last `ListBudgetsResponse` which
     * indicates that this is a continuation of a prior `ListBudgets` call,
     * and that the system should return the next page of data.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

