<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/devtools/cloudbuild/v2/repositories.proto

namespace Google\Cloud\Build\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message for requesting list of Repositories.
 *
 * Generated from protobuf message <code>google.devtools.cloudbuild.v2.ListRepositoriesRequest</code>
 */
class ListRepositoriesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent, which owns this collection of Repositories.
     * Format: `projects/&#42;&#47;locations/&#42;&#47;connections/&#42;`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Number of results to return in the list.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     */
    protected $page_size = 0;
    /**
     * Page start.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     */
    protected $page_token = '';
    /**
     * A filter expression that filters resources listed in the response.
     * Expressions must follow API improvement proposal
     * [AIP-160](https://google.aip.dev/160). e.g.
     * `remote_uri:"https://github.com*"`.
     *
     * Generated from protobuf field <code>string filter = 4;</code>
     */
    protected $filter = '';

    /**
     * @param string $parent Required. The parent, which owns this collection of Repositories.
     *                       Format: `projects/&#42;/locations/&#42;/connections/*`. Please see
     *                       {@see RepositoryManagerClient::connectionName()} for help formatting this field.
     *
     * @return \Google\Cloud\Build\V2\ListRepositoriesRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent, which owns this collection of Repositories.
     *           Format: `projects/&#42;&#47;locations/&#42;&#47;connections/&#42;`.
     *     @type int $page_size
     *           Number of results to return in the list.
     *     @type string $page_token
     *           Page start.
     *     @type string $filter
     *           A filter expression that filters resources listed in the response.
     *           Expressions must follow API improvement proposal
     *           [AIP-160](https://google.aip.dev/160). e.g.
     *           `remote_uri:"https://github.com*"`.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Devtools\Cloudbuild\V2\Repositories::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent, which owns this collection of Repositories.
     * Format: `projects/&#42;&#47;locations/&#42;&#47;connections/&#42;`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent, which owns this collection of Repositories.
     * Format: `projects/&#42;&#47;locations/&#42;&#47;connections/&#42;`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Number of results to return in the list.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Number of results to return in the list.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Page start.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Page start.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * A filter expression that filters resources listed in the response.
     * Expressions must follow API improvement proposal
     * [AIP-160](https://google.aip.dev/160). e.g.
     * `remote_uri:"https://github.com*"`.
     *
     * Generated from protobuf field <code>string filter = 4;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * A filter expression that filters resources listed in the response.
     * Expressions must follow API improvement proposal
     * [AIP-160](https://google.aip.dev/160). e.g.
     * `remote_uri:"https://github.com*"`.
     *
     * Generated from protobuf field <code>string filter = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

}

