<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/certificatemanager/v1/trust_config.proto

namespace Google\Cloud\CertificateManager\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request for the `CreateTrustConfig` method.
 *
 * Generated from protobuf message <code>google.cloud.certificatemanager.v1.CreateTrustConfigRequest</code>
 */
class CreateTrustConfigRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent resource of the TrustConfig. Must be in the format
     * `projects/&#42;&#47;locations/&#42;`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. A user-provided name of the TrustConfig. Must match the regexp
     * `[a-z0-9-]{1,63}`.
     *
     * Generated from protobuf field <code>string trust_config_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $trust_config_id = '';
    /**
     * Required. A definition of the TrustConfig to create.
     *
     * Generated from protobuf field <code>.google.cloud.certificatemanager.v1.TrustConfig trust_config = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $trust_config = null;

    /**
     * @param string                                          $parent        Required. The parent resource of the TrustConfig. Must be in the format
     *                                                                       `projects/&#42;/locations/*`. Please see
     *                                                                       {@see CertificateManagerClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\CertificateManager\V1\TrustConfig $trustConfig   Required. A definition of the TrustConfig to create.
     * @param string                                          $trustConfigId Required. A user-provided name of the TrustConfig. Must match the regexp
     *                                                                       `[a-z0-9-]{1,63}`.
     *
     * @return \Google\Cloud\CertificateManager\V1\CreateTrustConfigRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\CertificateManager\V1\TrustConfig $trustConfig, string $trustConfigId): self
    {
        return (new self())
            ->setParent($parent)
            ->setTrustConfig($trustConfig)
            ->setTrustConfigId($trustConfigId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent resource of the TrustConfig. Must be in the format
     *           `projects/&#42;&#47;locations/&#42;`.
     *     @type string $trust_config_id
     *           Required. A user-provided name of the TrustConfig. Must match the regexp
     *           `[a-z0-9-]{1,63}`.
     *     @type \Google\Cloud\CertificateManager\V1\TrustConfig $trust_config
     *           Required. A definition of the TrustConfig to create.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Certificatemanager\V1\TrustConfig::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent resource of the TrustConfig. Must be in the format
     * `projects/&#42;&#47;locations/&#42;`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent resource of the TrustConfig. Must be in the format
     * `projects/&#42;&#47;locations/&#42;`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. A user-provided name of the TrustConfig. Must match the regexp
     * `[a-z0-9-]{1,63}`.
     *
     * Generated from protobuf field <code>string trust_config_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getTrustConfigId()
    {
        return $this->trust_config_id;
    }

    /**
     * Required. A user-provided name of the TrustConfig. Must match the regexp
     * `[a-z0-9-]{1,63}`.
     *
     * Generated from protobuf field <code>string trust_config_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setTrustConfigId($var)
    {
        GPBUtil::checkString($var, True);
        $this->trust_config_id = $var;

        return $this;
    }

    /**
     * Required. A definition of the TrustConfig to create.
     *
     * Generated from protobuf field <code>.google.cloud.certificatemanager.v1.TrustConfig trust_config = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\CertificateManager\V1\TrustConfig|null
     */
    public function getTrustConfig()
    {
        return $this->trust_config;
    }

    public function hasTrustConfig()
    {
        return isset($this->trust_config);
    }

    public function clearTrustConfig()
    {
        unset($this->trust_config);
    }

    /**
     * Required. A definition of the TrustConfig to create.
     *
     * Generated from protobuf field <code>.google.cloud.certificatemanager.v1.TrustConfig trust_config = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\CertificateManager\V1\TrustConfig $var
     * @return $this
     */
    public function setTrustConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\CertificateManager\V1\TrustConfig::class);
        $this->trust_config = $var;

        return $this;
    }

}

