<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/channel/v1/reports_service.proto

namespace Google\Cloud\Channel\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [CloudChannelReportsService.ListReports][google.cloud.channel.v1.CloudChannelReportsService.ListReports].
 *
 * @deprecated
 * Generated from protobuf message <code>google.cloud.channel.v1.ListReportsRequest</code>
 */
class ListReportsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the partner account to list available
     * reports for. Parent uses the format: accounts/{account_id}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $parent = '';
    /**
     * Optional. Requested page size of the report. The server might return fewer
     * results than requested. If unspecified, returns 20 reports. The maximum
     * value is 100.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. A token that specifies a page of results beyond the first page.
     * Obtained through
     * [ListReportsResponse.next_page_token][google.cloud.channel.v1.ListReportsResponse.next_page_token]
     * of the previous
     * [CloudChannelReportsService.ListReports][google.cloud.channel.v1.CloudChannelReportsService.ListReports]
     * call.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';
    /**
     * Optional. The BCP-47 language code, such as "en-US".  If specified, the
     * response is localized to the corresponding language code if the
     * original data sources support it.
     * Default is "en-US".
     *
     * Generated from protobuf field <code>string language_code = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $language_code = '';

    /**
     * @param string $parent Required. The resource name of the partner account to list available
     *                       reports for. Parent uses the format: accounts/{account_id}
     *
     * @return \Google\Cloud\Channel\V1\ListReportsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The resource name of the partner account to list available
     *           reports for. Parent uses the format: accounts/{account_id}
     *     @type int $page_size
     *           Optional. Requested page size of the report. The server might return fewer
     *           results than requested. If unspecified, returns 20 reports. The maximum
     *           value is 100.
     *     @type string $page_token
     *           Optional. A token that specifies a page of results beyond the first page.
     *           Obtained through
     *           [ListReportsResponse.next_page_token][google.cloud.channel.v1.ListReportsResponse.next_page_token]
     *           of the previous
     *           [CloudChannelReportsService.ListReports][google.cloud.channel.v1.CloudChannelReportsService.ListReports]
     *           call.
     *     @type string $language_code
     *           Optional. The BCP-47 language code, such as "en-US".  If specified, the
     *           response is localized to the corresponding language code if the
     *           original data sources support it.
     *           Default is "en-US".
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Channel\V1\ReportsService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the partner account to list available
     * reports for. Parent uses the format: accounts/{account_id}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The resource name of the partner account to list available
     * reports for. Parent uses the format: accounts/{account_id}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. Requested page size of the report. The server might return fewer
     * results than requested. If unspecified, returns 20 reports. The maximum
     * value is 100.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. Requested page size of the report. The server might return fewer
     * results than requested. If unspecified, returns 20 reports. The maximum
     * value is 100.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. A token that specifies a page of results beyond the first page.
     * Obtained through
     * [ListReportsResponse.next_page_token][google.cloud.channel.v1.ListReportsResponse.next_page_token]
     * of the previous
     * [CloudChannelReportsService.ListReports][google.cloud.channel.v1.CloudChannelReportsService.ListReports]
     * call.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. A token that specifies a page of results beyond the first page.
     * Obtained through
     * [ListReportsResponse.next_page_token][google.cloud.channel.v1.ListReportsResponse.next_page_token]
     * of the previous
     * [CloudChannelReportsService.ListReports][google.cloud.channel.v1.CloudChannelReportsService.ListReports]
     * call.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. The BCP-47 language code, such as "en-US".  If specified, the
     * response is localized to the corresponding language code if the
     * original data sources support it.
     * Default is "en-US".
     *
     * Generated from protobuf field <code>string language_code = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getLanguageCode()
    {
        return $this->language_code;
    }

    /**
     * Optional. The BCP-47 language code, such as "en-US".  If specified, the
     * response is localized to the corresponding language code if the
     * original data sources support it.
     * Default is "en-US".
     *
     * Generated from protobuf field <code>string language_code = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setLanguageCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->language_code = $var;

        return $this;
    }

}

