<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/channel/v1/service.proto

namespace Google\Cloud\Channel\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for ListSkuGroupBillableSkus.
 *
 * Generated from protobuf message <code>google.cloud.channel.v1.ListSkuGroupBillableSkusRequest</code>
 */
class ListSkuGroupBillableSkusRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Resource name of the SKU group.
     * Format: accounts/{account}/skuGroups/{sku_group}.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. The maximum number of SKUs to return. The service may return
     * fewer than this value. If unspecified, returns a maximum of 100000 SKUs.
     * The maximum value is 100000; values above 100000 will be coerced to 100000.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. A token identifying a page of results beyond the first page.
     * Obtained through
     * [ListSkuGroupBillableSkus.next_page_token][] of the previous
     * [CloudChannelService.ListSkuGroupBillableSkus][google.cloud.channel.v1.CloudChannelService.ListSkuGroupBillableSkus]
     * call.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';

    /**
     * @param string $parent Required. Resource name of the SKU group.
     *                       Format: accounts/{account}/skuGroups/{sku_group}. Please see
     *                       {@see CloudChannelServiceClient::skuGroupName()} for help formatting this field.
     *
     * @return \Google\Cloud\Channel\V1\ListSkuGroupBillableSkusRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Resource name of the SKU group.
     *           Format: accounts/{account}/skuGroups/{sku_group}.
     *     @type int $page_size
     *           Optional. The maximum number of SKUs to return. The service may return
     *           fewer than this value. If unspecified, returns a maximum of 100000 SKUs.
     *           The maximum value is 100000; values above 100000 will be coerced to 100000.
     *     @type string $page_token
     *           Optional. A token identifying a page of results beyond the first page.
     *           Obtained through
     *           [ListSkuGroupBillableSkus.next_page_token][] of the previous
     *           [CloudChannelService.ListSkuGroupBillableSkus][google.cloud.channel.v1.CloudChannelService.ListSkuGroupBillableSkus]
     *           call.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Channel\V1\Service::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Resource name of the SKU group.
     * Format: accounts/{account}/skuGroups/{sku_group}.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Resource name of the SKU group.
     * Format: accounts/{account}/skuGroups/{sku_group}.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. The maximum number of SKUs to return. The service may return
     * fewer than this value. If unspecified, returns a maximum of 100000 SKUs.
     * The maximum value is 100000; values above 100000 will be coerced to 100000.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. The maximum number of SKUs to return. The service may return
     * fewer than this value. If unspecified, returns a maximum of 100000 SKUs.
     * The maximum value is 100000; values above 100000 will be coerced to 100000.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. A token identifying a page of results beyond the first page.
     * Obtained through
     * [ListSkuGroupBillableSkus.next_page_token][] of the previous
     * [CloudChannelService.ListSkuGroupBillableSkus][google.cloud.channel.v1.CloudChannelService.ListSkuGroupBillableSkus]
     * call.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. A token identifying a page of results beyond the first page.
     * Obtained through
     * [ListSkuGroupBillableSkus.next_page_token][] of the previous
     * [CloudChannelService.ListSkuGroupBillableSkus][google.cloud.channel.v1.CloudChannelService.ListSkuGroupBillableSkus]
     * call.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

