<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/channel/v1/reports_service.proto

namespace Google\Cloud\Channel\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The ID and description of a report that was used to generate report data.
 * For example, "Google Cloud Daily Spend", "Google Workspace License Activity",
 * etc.
 *
 * @deprecated
 * Generated from protobuf message <code>google.cloud.channel.v1.Report</code>
 */
class Report extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The report's resource name. Specifies the account and report used
     * to generate report data. The report_id identifier is a UID (for example,
     * `613bf59q`).
     * Name uses the format:
     * accounts/{account_id}/reports/{report_id}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $name = '';
    /**
     * A human-readable name for this report.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     */
    protected $display_name = '';
    /**
     * The list of columns included in the report. This defines the schema of
     * the report results.
     *
     * Generated from protobuf field <code>repeated .google.cloud.channel.v1.Column columns = 3;</code>
     */
    private $columns;
    /**
     * A description of other aspects of the report, such as the products
     * it supports.
     *
     * Generated from protobuf field <code>string description = 4;</code>
     */
    protected $description = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. The report's resource name. Specifies the account and report used
     *           to generate report data. The report_id identifier is a UID (for example,
     *           `613bf59q`).
     *           Name uses the format:
     *           accounts/{account_id}/reports/{report_id}
     *     @type string $display_name
     *           A human-readable name for this report.
     *     @type array<\Google\Cloud\Channel\V1\Column>|\Google\Protobuf\Internal\RepeatedField $columns
     *           The list of columns included in the report. This defines the schema of
     *           the report results.
     *     @type string $description
     *           A description of other aspects of the report, such as the products
     *           it supports.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Channel\V1\ReportsService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The report's resource name. Specifies the account and report used
     * to generate report data. The report_id identifier is a UID (for example,
     * `613bf59q`).
     * Name uses the format:
     * accounts/{account_id}/reports/{report_id}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. The report's resource name. Specifies the account and report used
     * to generate report data. The report_id identifier is a UID (for example,
     * `613bf59q`).
     * Name uses the format:
     * accounts/{account_id}/reports/{report_id}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * A human-readable name for this report.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * A human-readable name for this report.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * The list of columns included in the report. This defines the schema of
     * the report results.
     *
     * Generated from protobuf field <code>repeated .google.cloud.channel.v1.Column columns = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getColumns()
    {
        return $this->columns;
    }

    /**
     * The list of columns included in the report. This defines the schema of
     * the report results.
     *
     * Generated from protobuf field <code>repeated .google.cloud.channel.v1.Column columns = 3;</code>
     * @param array<\Google\Cloud\Channel\V1\Column>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setColumns($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Channel\V1\Column::class);
        $this->columns = $arr;

        return $this;
    }

    /**
     * A description of other aspects of the report, such as the products
     * it supports.
     *
     * Generated from protobuf field <code>string description = 4;</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * A description of other aspects of the report, such as the products
     * it supports.
     *
     * Generated from protobuf field <code>string description = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

}

