<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/commerce/consumer/procurement/v1/procurement_service.proto

namespace Google\Cloud\Commerce\Consumer\Procurement\V1\ModifyOrderRequest;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Modifications to make on the order.
 *
 * Generated from protobuf message <code>google.cloud.commerce.consumer.procurement.v1.ModifyOrderRequest.Modification</code>
 */
class Modification extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. ID of the existing line item to make change to.
     * Required when change type is
     * [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_UPDATE] or
     * [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_CANCEL].
     *
     * Generated from protobuf field <code>string line_item_id = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $line_item_id = '';
    /**
     * Required. Type of change to make.
     *
     * Generated from protobuf field <code>.google.cloud.commerce.consumer.procurement.v1.LineItemChangeType change_type = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $change_type = 0;
    /**
     * Optional. The line item to update to.
     * Required when change_type is
     * [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_CREATE] or
     * [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_UPDATE].
     *
     * Generated from protobuf field <code>.google.cloud.commerce.consumer.procurement.v1.LineItemInfo new_line_item_info = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $new_line_item_info = null;
    /**
     * Optional. Auto renewal behavior of the subscription for the update.
     * Applied when change_type is
     * [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_UPDATE]. Follows plan default
     * config when this field is not specified.
     *
     * Generated from protobuf field <code>.google.cloud.commerce.consumer.procurement.v1.AutoRenewalBehavior auto_renewal_behavior = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $auto_renewal_behavior = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $line_item_id
     *           Required. ID of the existing line item to make change to.
     *           Required when change type is
     *           [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_UPDATE] or
     *           [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_CANCEL].
     *     @type int $change_type
     *           Required. Type of change to make.
     *     @type \Google\Cloud\Commerce\Consumer\Procurement\V1\LineItemInfo $new_line_item_info
     *           Optional. The line item to update to.
     *           Required when change_type is
     *           [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_CREATE] or
     *           [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_UPDATE].
     *     @type int $auto_renewal_behavior
     *           Optional. Auto renewal behavior of the subscription for the update.
     *           Applied when change_type is
     *           [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_UPDATE]. Follows plan default
     *           config when this field is not specified.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Commerce\Consumer\Procurement\V1\ProcurementService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. ID of the existing line item to make change to.
     * Required when change type is
     * [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_UPDATE] or
     * [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_CANCEL].
     *
     * Generated from protobuf field <code>string line_item_id = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getLineItemId()
    {
        return $this->line_item_id;
    }

    /**
     * Required. ID of the existing line item to make change to.
     * Required when change type is
     * [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_UPDATE] or
     * [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_CANCEL].
     *
     * Generated from protobuf field <code>string line_item_id = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setLineItemId($var)
    {
        GPBUtil::checkString($var, True);
        $this->line_item_id = $var;

        return $this;
    }

    /**
     * Required. Type of change to make.
     *
     * Generated from protobuf field <code>.google.cloud.commerce.consumer.procurement.v1.LineItemChangeType change_type = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return int
     */
    public function getChangeType()
    {
        return $this->change_type;
    }

    /**
     * Required. Type of change to make.
     *
     * Generated from protobuf field <code>.google.cloud.commerce.consumer.procurement.v1.LineItemChangeType change_type = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int $var
     * @return $this
     */
    public function setChangeType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Commerce\Consumer\Procurement\V1\LineItemChangeType::class);
        $this->change_type = $var;

        return $this;
    }

    /**
     * Optional. The line item to update to.
     * Required when change_type is
     * [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_CREATE] or
     * [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_UPDATE].
     *
     * Generated from protobuf field <code>.google.cloud.commerce.consumer.procurement.v1.LineItemInfo new_line_item_info = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\Commerce\Consumer\Procurement\V1\LineItemInfo|null
     */
    public function getNewLineItemInfo()
    {
        return $this->new_line_item_info;
    }

    public function hasNewLineItemInfo()
    {
        return isset($this->new_line_item_info);
    }

    public function clearNewLineItemInfo()
    {
        unset($this->new_line_item_info);
    }

    /**
     * Optional. The line item to update to.
     * Required when change_type is
     * [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_CREATE] or
     * [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_UPDATE].
     *
     * Generated from protobuf field <code>.google.cloud.commerce.consumer.procurement.v1.LineItemInfo new_line_item_info = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\Commerce\Consumer\Procurement\V1\LineItemInfo $var
     * @return $this
     */
    public function setNewLineItemInfo($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Commerce\Consumer\Procurement\V1\LineItemInfo::class);
        $this->new_line_item_info = $var;

        return $this;
    }

    /**
     * Optional. Auto renewal behavior of the subscription for the update.
     * Applied when change_type is
     * [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_UPDATE]. Follows plan default
     * config when this field is not specified.
     *
     * Generated from protobuf field <code>.google.cloud.commerce.consumer.procurement.v1.AutoRenewalBehavior auto_renewal_behavior = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getAutoRenewalBehavior()
    {
        return $this->auto_renewal_behavior;
    }

    /**
     * Optional. Auto renewal behavior of the subscription for the update.
     * Applied when change_type is
     * [LineItemChangeType.LINE_ITEM_CHANGE_TYPE_UPDATE]. Follows plan default
     * config when this field is not specified.
     *
     * Generated from protobuf field <code>.google.cloud.commerce.consumer.procurement.v1.AutoRenewalBehavior auto_renewal_behavior = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setAutoRenewalBehavior($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Commerce\Consumer\Procurement\V1\AutoRenewalBehavior::class);
        $this->auto_renewal_behavior = $var;

        return $this;
    }

}


