<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/compute/v1/compute.proto

namespace Google\Cloud\Compute\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * This reservation type is specified by total resource amounts (e.g. total count of CPUs) and can account for multiple instance SKUs. In other words, one can create instances of varying shapes against this reservation.
 *
 * Generated from protobuf message <code>google.cloud.compute.v1.AllocationAggregateReservation</code>
 */
class AllocationAggregateReservation extends \Google\Protobuf\Internal\Message
{
    /**
     * [Output only] List of resources currently in use.
     *
     * Generated from protobuf field <code>repeated .google.cloud.compute.v1.AllocationAggregateReservationReservedResourceInfo in_use_resources = 409009107;</code>
     */
    private $in_use_resources;
    /**
     * List of reserved resources (CPUs, memory, accelerators).
     *
     * Generated from protobuf field <code>repeated .google.cloud.compute.v1.AllocationAggregateReservationReservedResourceInfo reserved_resources = 213217742;</code>
     */
    private $reserved_resources;
    /**
     * The VM family that all instances scheduled against this reservation must belong to.
     * Check the VmFamily enum for the list of possible values.
     *
     * Generated from protobuf field <code>optional string vm_family = 125017580;</code>
     */
    private $vm_family = null;
    /**
     * The workload type of the instances that will target this reservation.
     * Check the WorkloadType enum for the list of possible values.
     *
     * Generated from protobuf field <code>optional string workload_type = 273432322;</code>
     */
    private $workload_type = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type array<\Google\Cloud\Compute\V1\AllocationAggregateReservationReservedResourceInfo>|\Google\Protobuf\Internal\RepeatedField $in_use_resources
     *           [Output only] List of resources currently in use.
     *     @type array<\Google\Cloud\Compute\V1\AllocationAggregateReservationReservedResourceInfo>|\Google\Protobuf\Internal\RepeatedField $reserved_resources
     *           List of reserved resources (CPUs, memory, accelerators).
     *     @type string $vm_family
     *           The VM family that all instances scheduled against this reservation must belong to.
     *           Check the VmFamily enum for the list of possible values.
     *     @type string $workload_type
     *           The workload type of the instances that will target this reservation.
     *           Check the WorkloadType enum for the list of possible values.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Compute\V1\Compute::initOnce();
        parent::__construct($data);
    }

    /**
     * [Output only] List of resources currently in use.
     *
     * Generated from protobuf field <code>repeated .google.cloud.compute.v1.AllocationAggregateReservationReservedResourceInfo in_use_resources = 409009107;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getInUseResources()
    {
        return $this->in_use_resources;
    }

    /**
     * [Output only] List of resources currently in use.
     *
     * Generated from protobuf field <code>repeated .google.cloud.compute.v1.AllocationAggregateReservationReservedResourceInfo in_use_resources = 409009107;</code>
     * @param array<\Google\Cloud\Compute\V1\AllocationAggregateReservationReservedResourceInfo>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setInUseResources($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Compute\V1\AllocationAggregateReservationReservedResourceInfo::class);
        $this->in_use_resources = $arr;

        return $this;
    }

    /**
     * List of reserved resources (CPUs, memory, accelerators).
     *
     * Generated from protobuf field <code>repeated .google.cloud.compute.v1.AllocationAggregateReservationReservedResourceInfo reserved_resources = 213217742;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getReservedResources()
    {
        return $this->reserved_resources;
    }

    /**
     * List of reserved resources (CPUs, memory, accelerators).
     *
     * Generated from protobuf field <code>repeated .google.cloud.compute.v1.AllocationAggregateReservationReservedResourceInfo reserved_resources = 213217742;</code>
     * @param array<\Google\Cloud\Compute\V1\AllocationAggregateReservationReservedResourceInfo>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setReservedResources($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Compute\V1\AllocationAggregateReservationReservedResourceInfo::class);
        $this->reserved_resources = $arr;

        return $this;
    }

    /**
     * The VM family that all instances scheduled against this reservation must belong to.
     * Check the VmFamily enum for the list of possible values.
     *
     * Generated from protobuf field <code>optional string vm_family = 125017580;</code>
     * @return string
     */
    public function getVmFamily()
    {
        return isset($this->vm_family) ? $this->vm_family : '';
    }

    public function hasVmFamily()
    {
        return isset($this->vm_family);
    }

    public function clearVmFamily()
    {
        unset($this->vm_family);
    }

    /**
     * The VM family that all instances scheduled against this reservation must belong to.
     * Check the VmFamily enum for the list of possible values.
     *
     * Generated from protobuf field <code>optional string vm_family = 125017580;</code>
     * @param string $var
     * @return $this
     */
    public function setVmFamily($var)
    {
        GPBUtil::checkString($var, True);
        $this->vm_family = $var;

        return $this;
    }

    /**
     * The workload type of the instances that will target this reservation.
     * Check the WorkloadType enum for the list of possible values.
     *
     * Generated from protobuf field <code>optional string workload_type = 273432322;</code>
     * @return string
     */
    public function getWorkloadType()
    {
        return isset($this->workload_type) ? $this->workload_type : '';
    }

    public function hasWorkloadType()
    {
        return isset($this->workload_type);
    }

    public function clearWorkloadType()
    {
        unset($this->workload_type);
    }

    /**
     * The workload type of the instances that will target this reservation.
     * Check the WorkloadType enum for the list of possible values.
     *
     * Generated from protobuf field <code>optional string workload_type = 273432322;</code>
     * @param string $var
     * @return $this
     */
    public function setWorkloadType($var)
    {
        GPBUtil::checkString($var, True);
        $this->workload_type = $var;

        return $this;
    }

}

