<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/compute/v1/compute.proto

namespace Google\Cloud\Compute\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Configuration information for enabling Media Access Control security (MACsec) on this Cloud Interconnect connection between Google and your on-premises router.
 *
 * Generated from protobuf message <code>google.cloud.compute.v1.InterconnectMacsec</code>
 */
class InterconnectMacsec extends \Google\Protobuf\Internal\Message
{
    /**
     * If set to true, the Interconnect connection is configured with a should-secure MACsec security policy, that allows the Google router to fallback to cleartext traffic if the MKA session cannot be established. By default, the Interconnect connection is configured with a must-secure security policy that drops all traffic if the MKA session cannot be established with your router.
     *
     * Generated from protobuf field <code>optional bool fail_open = 532597451;</code>
     */
    private $fail_open = null;
    /**
     * Required. A keychain placeholder describing a set of named key objects along with their start times. A MACsec CKN/CAK is generated for each key in the key chain. Google router automatically picks the key with the most recent startTime when establishing or re-establishing a MACsec secure link.
     *
     * Generated from protobuf field <code>repeated .google.cloud.compute.v1.InterconnectMacsecPreSharedKey pre_shared_keys = 420308466;</code>
     */
    private $pre_shared_keys;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type bool $fail_open
     *           If set to true, the Interconnect connection is configured with a should-secure MACsec security policy, that allows the Google router to fallback to cleartext traffic if the MKA session cannot be established. By default, the Interconnect connection is configured with a must-secure security policy that drops all traffic if the MKA session cannot be established with your router.
     *     @type array<\Google\Cloud\Compute\V1\InterconnectMacsecPreSharedKey>|\Google\Protobuf\Internal\RepeatedField $pre_shared_keys
     *           Required. A keychain placeholder describing a set of named key objects along with their start times. A MACsec CKN/CAK is generated for each key in the key chain. Google router automatically picks the key with the most recent startTime when establishing or re-establishing a MACsec secure link.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Compute\V1\Compute::initOnce();
        parent::__construct($data);
    }

    /**
     * If set to true, the Interconnect connection is configured with a should-secure MACsec security policy, that allows the Google router to fallback to cleartext traffic if the MKA session cannot be established. By default, the Interconnect connection is configured with a must-secure security policy that drops all traffic if the MKA session cannot be established with your router.
     *
     * Generated from protobuf field <code>optional bool fail_open = 532597451;</code>
     * @return bool
     */
    public function getFailOpen()
    {
        return isset($this->fail_open) ? $this->fail_open : false;
    }

    public function hasFailOpen()
    {
        return isset($this->fail_open);
    }

    public function clearFailOpen()
    {
        unset($this->fail_open);
    }

    /**
     * If set to true, the Interconnect connection is configured with a should-secure MACsec security policy, that allows the Google router to fallback to cleartext traffic if the MKA session cannot be established. By default, the Interconnect connection is configured with a must-secure security policy that drops all traffic if the MKA session cannot be established with your router.
     *
     * Generated from protobuf field <code>optional bool fail_open = 532597451;</code>
     * @param bool $var
     * @return $this
     */
    public function setFailOpen($var)
    {
        GPBUtil::checkBool($var);
        $this->fail_open = $var;

        return $this;
    }

    /**
     * Required. A keychain placeholder describing a set of named key objects along with their start times. A MACsec CKN/CAK is generated for each key in the key chain. Google router automatically picks the key with the most recent startTime when establishing or re-establishing a MACsec secure link.
     *
     * Generated from protobuf field <code>repeated .google.cloud.compute.v1.InterconnectMacsecPreSharedKey pre_shared_keys = 420308466;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getPreSharedKeys()
    {
        return $this->pre_shared_keys;
    }

    /**
     * Required. A keychain placeholder describing a set of named key objects along with their start times. A MACsec CKN/CAK is generated for each key in the key chain. Google router automatically picks the key with the most recent startTime when establishing or re-establishing a MACsec secure link.
     *
     * Generated from protobuf field <code>repeated .google.cloud.compute.v1.InterconnectMacsecPreSharedKey pre_shared_keys = 420308466;</code>
     * @param array<\Google\Cloud\Compute\V1\InterconnectMacsecPreSharedKey>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setPreSharedKeys($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Compute\V1\InterconnectMacsecPreSharedKey::class);
        $this->pre_shared_keys = $arr;

        return $this;
    }

}

