<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/compute/v1/compute.proto

namespace Google\Cloud\Compute\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents a zonal storage pool resource.
 *
 * Generated from protobuf message <code>google.cloud.compute.v1.StoragePool</code>
 */
class StoragePool extends \Google\Protobuf\Internal\Message
{
    /**
     * Provisioning type of the byte capacity of the pool.
     * Check the CapacityProvisioningType enum for the list of possible values.
     *
     * Generated from protobuf field <code>optional string capacity_provisioning_type = 251610375;</code>
     */
    private $capacity_provisioning_type = null;
    /**
     * [Output Only] Creation timestamp in RFC3339 text format.
     *
     * Generated from protobuf field <code>optional string creation_timestamp = 30525366;</code>
     */
    private $creation_timestamp = null;
    /**
     * An optional description of this resource. Provide this property when you create the resource.
     *
     * Generated from protobuf field <code>optional string description = 422937596;</code>
     */
    private $description = null;
    /**
     * [Output Only] The unique identifier for the resource. This identifier is defined by the server.
     *
     * Generated from protobuf field <code>optional uint64 id = 3355;</code>
     */
    private $id = null;
    /**
     * [Output Only] Type of the resource. Always compute#storagePool for storage pools.
     *
     * Generated from protobuf field <code>optional string kind = 3292052;</code>
     */
    private $kind = null;
    /**
     * A fingerprint for the labels being applied to this storage pool, which is essentially a hash of the labels set used for optimistic locking. The fingerprint is initially generated by Compute Engine and changes after every request to modify or update labels. You must always provide an up-to-date fingerprint hash in order to update or change labels, otherwise the request will fail with error 412 conditionNotMet. To see the latest fingerprint, make a get() request to retrieve a storage pool.
     *
     * Generated from protobuf field <code>optional string label_fingerprint = 178124825;</code>
     */
    private $label_fingerprint = null;
    /**
     * Labels to apply to this storage pool. These can be later modified by the setLabels method.
     *
     * Generated from protobuf field <code>map<string, string> labels = 500195327;</code>
     */
    private $labels;
    /**
     * Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.
     *
     * Generated from protobuf field <code>optional string name = 3373707;</code>
     */
    private $name = null;
    /**
     * Provisioning type of the performance-related parameters of the pool, such as throughput and IOPS.
     * Check the PerformanceProvisioningType enum for the list of possible values.
     *
     * Generated from protobuf field <code>optional string performance_provisioning_type = 468553469;</code>
     */
    private $performance_provisioning_type = null;
    /**
     * Size, in GiB, of the storage pool.
     *
     * Generated from protobuf field <code>optional int64 pool_provisioned_capacity_gb = 478537682;</code>
     */
    private $pool_provisioned_capacity_gb = null;
    /**
     * Provisioned IOPS of the storage pool. Only relevant if the storage pool type is hyperdisk-balanced.
     *
     * Generated from protobuf field <code>optional int64 pool_provisioned_iops = 112092311;</code>
     */
    private $pool_provisioned_iops = null;
    /**
     * Provisioned throughput of the storage pool. Only relevant if the storage pool type is hyperdisk-balanced or hyperdisk-throughput.
     *
     * Generated from protobuf field <code>optional int64 pool_provisioned_throughput = 169215640;</code>
     */
    private $pool_provisioned_throughput = null;
    /**
     * [Output Only] Status information for the storage pool resource.
     *
     * Generated from protobuf field <code>optional .google.cloud.compute.v1.StoragePoolResourceStatus resource_status = 249429315;</code>
     */
    private $resource_status = null;
    /**
     * [Output Only] Server-defined fully-qualified URL for this resource.
     *
     * Generated from protobuf field <code>optional string self_link = 456214797;</code>
     */
    private $self_link = null;
    /**
     * [Output Only] Server-defined URL for this resource's resource id.
     *
     * Generated from protobuf field <code>optional string self_link_with_id = 44520962;</code>
     */
    private $self_link_with_id = null;
    /**
     * [Output Only] The status of storage pool creation. - CREATING: Storage pool is provisioning. storagePool. - FAILED: Storage pool creation failed. - READY: Storage pool is ready for use. - DELETING: Storage pool is deleting.
     * Check the State enum for the list of possible values.
     *
     * Generated from protobuf field <code>optional string state = 109757585;</code>
     */
    private $state = null;
    /**
     * [Output Only] Status information for the storage pool resource.
     *
     * Generated from protobuf field <code>optional .google.cloud.compute.v1.StoragePoolResourceStatus status = 181260274;</code>
     */
    private $status = null;
    /**
     * Type of the storage pool.
     *
     * Generated from protobuf field <code>optional string storage_pool_type = 285999289;</code>
     */
    private $storage_pool_type = null;
    /**
     * [Output Only] URL of the zone where the storage pool resides. You must specify this field as part of the HTTP request URL. It is not settable as a field in the request body.
     *
     * Generated from protobuf field <code>optional string zone = 3744684;</code>
     */
    private $zone = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $capacity_provisioning_type
     *           Provisioning type of the byte capacity of the pool.
     *           Check the CapacityProvisioningType enum for the list of possible values.
     *     @type string $creation_timestamp
     *           [Output Only] Creation timestamp in RFC3339 text format.
     *     @type string $description
     *           An optional description of this resource. Provide this property when you create the resource.
     *     @type int|string $id
     *           [Output Only] The unique identifier for the resource. This identifier is defined by the server.
     *     @type string $kind
     *           [Output Only] Type of the resource. Always compute#storagePool for storage pools.
     *     @type string $label_fingerprint
     *           A fingerprint for the labels being applied to this storage pool, which is essentially a hash of the labels set used for optimistic locking. The fingerprint is initially generated by Compute Engine and changes after every request to modify or update labels. You must always provide an up-to-date fingerprint hash in order to update or change labels, otherwise the request will fail with error 412 conditionNotMet. To see the latest fingerprint, make a get() request to retrieve a storage pool.
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Labels to apply to this storage pool. These can be later modified by the setLabels method.
     *     @type string $name
     *           Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.
     *     @type string $performance_provisioning_type
     *           Provisioning type of the performance-related parameters of the pool, such as throughput and IOPS.
     *           Check the PerformanceProvisioningType enum for the list of possible values.
     *     @type int|string $pool_provisioned_capacity_gb
     *           Size, in GiB, of the storage pool.
     *     @type int|string $pool_provisioned_iops
     *           Provisioned IOPS of the storage pool. Only relevant if the storage pool type is hyperdisk-balanced.
     *     @type int|string $pool_provisioned_throughput
     *           Provisioned throughput of the storage pool. Only relevant if the storage pool type is hyperdisk-balanced or hyperdisk-throughput.
     *     @type \Google\Cloud\Compute\V1\StoragePoolResourceStatus $resource_status
     *           [Output Only] Status information for the storage pool resource.
     *     @type string $self_link
     *           [Output Only] Server-defined fully-qualified URL for this resource.
     *     @type string $self_link_with_id
     *           [Output Only] Server-defined URL for this resource's resource id.
     *     @type string $state
     *           [Output Only] The status of storage pool creation. - CREATING: Storage pool is provisioning. storagePool. - FAILED: Storage pool creation failed. - READY: Storage pool is ready for use. - DELETING: Storage pool is deleting.
     *           Check the State enum for the list of possible values.
     *     @type \Google\Cloud\Compute\V1\StoragePoolResourceStatus $status
     *           [Output Only] Status information for the storage pool resource.
     *     @type string $storage_pool_type
     *           Type of the storage pool.
     *     @type string $zone
     *           [Output Only] URL of the zone where the storage pool resides. You must specify this field as part of the HTTP request URL. It is not settable as a field in the request body.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Compute\V1\Compute::initOnce();
        parent::__construct($data);
    }

    /**
     * Provisioning type of the byte capacity of the pool.
     * Check the CapacityProvisioningType enum for the list of possible values.
     *
     * Generated from protobuf field <code>optional string capacity_provisioning_type = 251610375;</code>
     * @return string
     */
    public function getCapacityProvisioningType()
    {
        return isset($this->capacity_provisioning_type) ? $this->capacity_provisioning_type : '';
    }

    public function hasCapacityProvisioningType()
    {
        return isset($this->capacity_provisioning_type);
    }

    public function clearCapacityProvisioningType()
    {
        unset($this->capacity_provisioning_type);
    }

    /**
     * Provisioning type of the byte capacity of the pool.
     * Check the CapacityProvisioningType enum for the list of possible values.
     *
     * Generated from protobuf field <code>optional string capacity_provisioning_type = 251610375;</code>
     * @param string $var
     * @return $this
     */
    public function setCapacityProvisioningType($var)
    {
        GPBUtil::checkString($var, True);
        $this->capacity_provisioning_type = $var;

        return $this;
    }

    /**
     * [Output Only] Creation timestamp in RFC3339 text format.
     *
     * Generated from protobuf field <code>optional string creation_timestamp = 30525366;</code>
     * @return string
     */
    public function getCreationTimestamp()
    {
        return isset($this->creation_timestamp) ? $this->creation_timestamp : '';
    }

    public function hasCreationTimestamp()
    {
        return isset($this->creation_timestamp);
    }

    public function clearCreationTimestamp()
    {
        unset($this->creation_timestamp);
    }

    /**
     * [Output Only] Creation timestamp in RFC3339 text format.
     *
     * Generated from protobuf field <code>optional string creation_timestamp = 30525366;</code>
     * @param string $var
     * @return $this
     */
    public function setCreationTimestamp($var)
    {
        GPBUtil::checkString($var, True);
        $this->creation_timestamp = $var;

        return $this;
    }

    /**
     * An optional description of this resource. Provide this property when you create the resource.
     *
     * Generated from protobuf field <code>optional string description = 422937596;</code>
     * @return string
     */
    public function getDescription()
    {
        return isset($this->description) ? $this->description : '';
    }

    public function hasDescription()
    {
        return isset($this->description);
    }

    public function clearDescription()
    {
        unset($this->description);
    }

    /**
     * An optional description of this resource. Provide this property when you create the resource.
     *
     * Generated from protobuf field <code>optional string description = 422937596;</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * [Output Only] The unique identifier for the resource. This identifier is defined by the server.
     *
     * Generated from protobuf field <code>optional uint64 id = 3355;</code>
     * @return int|string
     */
    public function getId()
    {
        return isset($this->id) ? $this->id : 0;
    }

    public function hasId()
    {
        return isset($this->id);
    }

    public function clearId()
    {
        unset($this->id);
    }

    /**
     * [Output Only] The unique identifier for the resource. This identifier is defined by the server.
     *
     * Generated from protobuf field <code>optional uint64 id = 3355;</code>
     * @param int|string $var
     * @return $this
     */
    public function setId($var)
    {
        GPBUtil::checkUint64($var);
        $this->id = $var;

        return $this;
    }

    /**
     * [Output Only] Type of the resource. Always compute#storagePool for storage pools.
     *
     * Generated from protobuf field <code>optional string kind = 3292052;</code>
     * @return string
     */
    public function getKind()
    {
        return isset($this->kind) ? $this->kind : '';
    }

    public function hasKind()
    {
        return isset($this->kind);
    }

    public function clearKind()
    {
        unset($this->kind);
    }

    /**
     * [Output Only] Type of the resource. Always compute#storagePool for storage pools.
     *
     * Generated from protobuf field <code>optional string kind = 3292052;</code>
     * @param string $var
     * @return $this
     */
    public function setKind($var)
    {
        GPBUtil::checkString($var, True);
        $this->kind = $var;

        return $this;
    }

    /**
     * A fingerprint for the labels being applied to this storage pool, which is essentially a hash of the labels set used for optimistic locking. The fingerprint is initially generated by Compute Engine and changes after every request to modify or update labels. You must always provide an up-to-date fingerprint hash in order to update or change labels, otherwise the request will fail with error 412 conditionNotMet. To see the latest fingerprint, make a get() request to retrieve a storage pool.
     *
     * Generated from protobuf field <code>optional string label_fingerprint = 178124825;</code>
     * @return string
     */
    public function getLabelFingerprint()
    {
        return isset($this->label_fingerprint) ? $this->label_fingerprint : '';
    }

    public function hasLabelFingerprint()
    {
        return isset($this->label_fingerprint);
    }

    public function clearLabelFingerprint()
    {
        unset($this->label_fingerprint);
    }

    /**
     * A fingerprint for the labels being applied to this storage pool, which is essentially a hash of the labels set used for optimistic locking. The fingerprint is initially generated by Compute Engine and changes after every request to modify or update labels. You must always provide an up-to-date fingerprint hash in order to update or change labels, otherwise the request will fail with error 412 conditionNotMet. To see the latest fingerprint, make a get() request to retrieve a storage pool.
     *
     * Generated from protobuf field <code>optional string label_fingerprint = 178124825;</code>
     * @param string $var
     * @return $this
     */
    public function setLabelFingerprint($var)
    {
        GPBUtil::checkString($var, True);
        $this->label_fingerprint = $var;

        return $this;
    }

    /**
     * Labels to apply to this storage pool. These can be later modified by the setLabels method.
     *
     * Generated from protobuf field <code>map<string, string> labels = 500195327;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Labels to apply to this storage pool. These can be later modified by the setLabels method.
     *
     * Generated from protobuf field <code>map<string, string> labels = 500195327;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.
     *
     * Generated from protobuf field <code>optional string name = 3373707;</code>
     * @return string
     */
    public function getName()
    {
        return isset($this->name) ? $this->name : '';
    }

    public function hasName()
    {
        return isset($this->name);
    }

    public function clearName()
    {
        unset($this->name);
    }

    /**
     * Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.
     *
     * Generated from protobuf field <code>optional string name = 3373707;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Provisioning type of the performance-related parameters of the pool, such as throughput and IOPS.
     * Check the PerformanceProvisioningType enum for the list of possible values.
     *
     * Generated from protobuf field <code>optional string performance_provisioning_type = 468553469;</code>
     * @return string
     */
    public function getPerformanceProvisioningType()
    {
        return isset($this->performance_provisioning_type) ? $this->performance_provisioning_type : '';
    }

    public function hasPerformanceProvisioningType()
    {
        return isset($this->performance_provisioning_type);
    }

    public function clearPerformanceProvisioningType()
    {
        unset($this->performance_provisioning_type);
    }

    /**
     * Provisioning type of the performance-related parameters of the pool, such as throughput and IOPS.
     * Check the PerformanceProvisioningType enum for the list of possible values.
     *
     * Generated from protobuf field <code>optional string performance_provisioning_type = 468553469;</code>
     * @param string $var
     * @return $this
     */
    public function setPerformanceProvisioningType($var)
    {
        GPBUtil::checkString($var, True);
        $this->performance_provisioning_type = $var;

        return $this;
    }

    /**
     * Size, in GiB, of the storage pool.
     *
     * Generated from protobuf field <code>optional int64 pool_provisioned_capacity_gb = 478537682;</code>
     * @return int|string
     */
    public function getPoolProvisionedCapacityGb()
    {
        return isset($this->pool_provisioned_capacity_gb) ? $this->pool_provisioned_capacity_gb : 0;
    }

    public function hasPoolProvisionedCapacityGb()
    {
        return isset($this->pool_provisioned_capacity_gb);
    }

    public function clearPoolProvisionedCapacityGb()
    {
        unset($this->pool_provisioned_capacity_gb);
    }

    /**
     * Size, in GiB, of the storage pool.
     *
     * Generated from protobuf field <code>optional int64 pool_provisioned_capacity_gb = 478537682;</code>
     * @param int|string $var
     * @return $this
     */
    public function setPoolProvisionedCapacityGb($var)
    {
        GPBUtil::checkInt64($var);
        $this->pool_provisioned_capacity_gb = $var;

        return $this;
    }

    /**
     * Provisioned IOPS of the storage pool. Only relevant if the storage pool type is hyperdisk-balanced.
     *
     * Generated from protobuf field <code>optional int64 pool_provisioned_iops = 112092311;</code>
     * @return int|string
     */
    public function getPoolProvisionedIops()
    {
        return isset($this->pool_provisioned_iops) ? $this->pool_provisioned_iops : 0;
    }

    public function hasPoolProvisionedIops()
    {
        return isset($this->pool_provisioned_iops);
    }

    public function clearPoolProvisionedIops()
    {
        unset($this->pool_provisioned_iops);
    }

    /**
     * Provisioned IOPS of the storage pool. Only relevant if the storage pool type is hyperdisk-balanced.
     *
     * Generated from protobuf field <code>optional int64 pool_provisioned_iops = 112092311;</code>
     * @param int|string $var
     * @return $this
     */
    public function setPoolProvisionedIops($var)
    {
        GPBUtil::checkInt64($var);
        $this->pool_provisioned_iops = $var;

        return $this;
    }

    /**
     * Provisioned throughput of the storage pool. Only relevant if the storage pool type is hyperdisk-balanced or hyperdisk-throughput.
     *
     * Generated from protobuf field <code>optional int64 pool_provisioned_throughput = 169215640;</code>
     * @return int|string
     */
    public function getPoolProvisionedThroughput()
    {
        return isset($this->pool_provisioned_throughput) ? $this->pool_provisioned_throughput : 0;
    }

    public function hasPoolProvisionedThroughput()
    {
        return isset($this->pool_provisioned_throughput);
    }

    public function clearPoolProvisionedThroughput()
    {
        unset($this->pool_provisioned_throughput);
    }

    /**
     * Provisioned throughput of the storage pool. Only relevant if the storage pool type is hyperdisk-balanced or hyperdisk-throughput.
     *
     * Generated from protobuf field <code>optional int64 pool_provisioned_throughput = 169215640;</code>
     * @param int|string $var
     * @return $this
     */
    public function setPoolProvisionedThroughput($var)
    {
        GPBUtil::checkInt64($var);
        $this->pool_provisioned_throughput = $var;

        return $this;
    }

    /**
     * [Output Only] Status information for the storage pool resource.
     *
     * Generated from protobuf field <code>optional .google.cloud.compute.v1.StoragePoolResourceStatus resource_status = 249429315;</code>
     * @return \Google\Cloud\Compute\V1\StoragePoolResourceStatus|null
     */
    public function getResourceStatus()
    {
        return $this->resource_status;
    }

    public function hasResourceStatus()
    {
        return isset($this->resource_status);
    }

    public function clearResourceStatus()
    {
        unset($this->resource_status);
    }

    /**
     * [Output Only] Status information for the storage pool resource.
     *
     * Generated from protobuf field <code>optional .google.cloud.compute.v1.StoragePoolResourceStatus resource_status = 249429315;</code>
     * @param \Google\Cloud\Compute\V1\StoragePoolResourceStatus $var
     * @return $this
     */
    public function setResourceStatus($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Compute\V1\StoragePoolResourceStatus::class);
        $this->resource_status = $var;

        return $this;
    }

    /**
     * [Output Only] Server-defined fully-qualified URL for this resource.
     *
     * Generated from protobuf field <code>optional string self_link = 456214797;</code>
     * @return string
     */
    public function getSelfLink()
    {
        return isset($this->self_link) ? $this->self_link : '';
    }

    public function hasSelfLink()
    {
        return isset($this->self_link);
    }

    public function clearSelfLink()
    {
        unset($this->self_link);
    }

    /**
     * [Output Only] Server-defined fully-qualified URL for this resource.
     *
     * Generated from protobuf field <code>optional string self_link = 456214797;</code>
     * @param string $var
     * @return $this
     */
    public function setSelfLink($var)
    {
        GPBUtil::checkString($var, True);
        $this->self_link = $var;

        return $this;
    }

    /**
     * [Output Only] Server-defined URL for this resource's resource id.
     *
     * Generated from protobuf field <code>optional string self_link_with_id = 44520962;</code>
     * @return string
     */
    public function getSelfLinkWithId()
    {
        return isset($this->self_link_with_id) ? $this->self_link_with_id : '';
    }

    public function hasSelfLinkWithId()
    {
        return isset($this->self_link_with_id);
    }

    public function clearSelfLinkWithId()
    {
        unset($this->self_link_with_id);
    }

    /**
     * [Output Only] Server-defined URL for this resource's resource id.
     *
     * Generated from protobuf field <code>optional string self_link_with_id = 44520962;</code>
     * @param string $var
     * @return $this
     */
    public function setSelfLinkWithId($var)
    {
        GPBUtil::checkString($var, True);
        $this->self_link_with_id = $var;

        return $this;
    }

    /**
     * [Output Only] The status of storage pool creation. - CREATING: Storage pool is provisioning. storagePool. - FAILED: Storage pool creation failed. - READY: Storage pool is ready for use. - DELETING: Storage pool is deleting.
     * Check the State enum for the list of possible values.
     *
     * Generated from protobuf field <code>optional string state = 109757585;</code>
     * @return string
     */
    public function getState()
    {
        return isset($this->state) ? $this->state : '';
    }

    public function hasState()
    {
        return isset($this->state);
    }

    public function clearState()
    {
        unset($this->state);
    }

    /**
     * [Output Only] The status of storage pool creation. - CREATING: Storage pool is provisioning. storagePool. - FAILED: Storage pool creation failed. - READY: Storage pool is ready for use. - DELETING: Storage pool is deleting.
     * Check the State enum for the list of possible values.
     *
     * Generated from protobuf field <code>optional string state = 109757585;</code>
     * @param string $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkString($var, True);
        $this->state = $var;

        return $this;
    }

    /**
     * [Output Only] Status information for the storage pool resource.
     *
     * Generated from protobuf field <code>optional .google.cloud.compute.v1.StoragePoolResourceStatus status = 181260274;</code>
     * @return \Google\Cloud\Compute\V1\StoragePoolResourceStatus|null
     */
    public function getStatus()
    {
        return $this->status;
    }

    public function hasStatus()
    {
        return isset($this->status);
    }

    public function clearStatus()
    {
        unset($this->status);
    }

    /**
     * [Output Only] Status information for the storage pool resource.
     *
     * Generated from protobuf field <code>optional .google.cloud.compute.v1.StoragePoolResourceStatus status = 181260274;</code>
     * @param \Google\Cloud\Compute\V1\StoragePoolResourceStatus $var
     * @return $this
     */
    public function setStatus($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Compute\V1\StoragePoolResourceStatus::class);
        $this->status = $var;

        return $this;
    }

    /**
     * Type of the storage pool.
     *
     * Generated from protobuf field <code>optional string storage_pool_type = 285999289;</code>
     * @return string
     */
    public function getStoragePoolType()
    {
        return isset($this->storage_pool_type) ? $this->storage_pool_type : '';
    }

    public function hasStoragePoolType()
    {
        return isset($this->storage_pool_type);
    }

    public function clearStoragePoolType()
    {
        unset($this->storage_pool_type);
    }

    /**
     * Type of the storage pool.
     *
     * Generated from protobuf field <code>optional string storage_pool_type = 285999289;</code>
     * @param string $var
     * @return $this
     */
    public function setStoragePoolType($var)
    {
        GPBUtil::checkString($var, True);
        $this->storage_pool_type = $var;

        return $this;
    }

    /**
     * [Output Only] URL of the zone where the storage pool resides. You must specify this field as part of the HTTP request URL. It is not settable as a field in the request body.
     *
     * Generated from protobuf field <code>optional string zone = 3744684;</code>
     * @return string
     */
    public function getZone()
    {
        return isset($this->zone) ? $this->zone : '';
    }

    public function hasZone()
    {
        return isset($this->zone);
    }

    public function clearZone()
    {
        unset($this->zone);
    }

    /**
     * [Output Only] URL of the zone where the storage pool resides. You must specify this field as part of the HTTP request URL. It is not settable as a field in the request body.
     *
     * Generated from protobuf field <code>optional string zone = 3744684;</code>
     * @param string $var
     * @return $this
     */
    public function setZone($var)
    {
        GPBUtil::checkString($var, True);
        $this->zone = $var;

        return $this;
    }

}

