<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/config/v1/config.proto

namespace Google\Cloud\Config\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A request to create a preview.
 *
 * Generated from protobuf message <code>google.cloud.config.v1.CreatePreviewRequest</code>
 */
class CreatePreviewRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent in whose context the Preview is created. The parent
     * value is in the format: 'projects/{project_id}/locations/{location}'.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. The preview ID.
     *
     * Generated from protobuf field <code>string preview_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $preview_id = '';
    /**
     * Required. [Preview][google.cloud.config.v1.Preview] resource to be created.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.Preview preview = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $preview = null;
    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request ID,
     * the server can check if original operation with the same request ID was
     * received, and if so, will ignore the second request. This prevents clients
     * from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL, (.google.api.field_info) = {</code>
     */
    protected $request_id = '';

    /**
     * @param string                          $parent  Required. The parent in whose context the Preview is created. The parent
     *                                                 value is in the format: 'projects/{project_id}/locations/{location}'. Please see
     *                                                 {@see ConfigClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\Config\V1\Preview $preview Required. [Preview][google.cloud.config.v1.Preview] resource to be created.
     *
     * @return \Google\Cloud\Config\V1\CreatePreviewRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\Config\V1\Preview $preview): self
    {
        return (new self())
            ->setParent($parent)
            ->setPreview($preview);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent in whose context the Preview is created. The parent
     *           value is in the format: 'projects/{project_id}/locations/{location}'.
     *     @type string $preview_id
     *           Optional. The preview ID.
     *     @type \Google\Cloud\Config\V1\Preview $preview
     *           Required. [Preview][google.cloud.config.v1.Preview] resource to be created.
     *     @type string $request_id
     *           Optional. An optional request ID to identify requests. Specify a unique
     *           request ID so that if you must retry your request, the server will know to
     *           ignore the request if it has already been completed. The server will
     *           guarantee that for at least 60 minutes since the first request.
     *           For example, consider a situation where you make an initial request and the
     *           request times out. If you make the request again with the same request ID,
     *           the server can check if original operation with the same request ID was
     *           received, and if so, will ignore the second request. This prevents clients
     *           from accidentally creating duplicate commitments.
     *           The request ID must be a valid UUID with the exception that zero UUID is
     *           not supported (00000000-0000-0000-0000-000000000000).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Config\V1\Config::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent in whose context the Preview is created. The parent
     * value is in the format: 'projects/{project_id}/locations/{location}'.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent in whose context the Preview is created. The parent
     * value is in the format: 'projects/{project_id}/locations/{location}'.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. The preview ID.
     *
     * Generated from protobuf field <code>string preview_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPreviewId()
    {
        return $this->preview_id;
    }

    /**
     * Optional. The preview ID.
     *
     * Generated from protobuf field <code>string preview_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPreviewId($var)
    {
        GPBUtil::checkString($var, True);
        $this->preview_id = $var;

        return $this;
    }

    /**
     * Required. [Preview][google.cloud.config.v1.Preview] resource to be created.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.Preview preview = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\Config\V1\Preview|null
     */
    public function getPreview()
    {
        return $this->preview;
    }

    public function hasPreview()
    {
        return isset($this->preview);
    }

    public function clearPreview()
    {
        unset($this->preview);
    }

    /**
     * Required. [Preview][google.cloud.config.v1.Preview] resource to be created.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.Preview preview = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\Config\V1\Preview $var
     * @return $this
     */
    public function setPreview($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Config\V1\Preview::class);
        $this->preview = $var;

        return $this;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request ID,
     * the server can check if original operation with the same request ID was
     * received, and if so, will ignore the second request. This prevents clients
     * from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL, (.google.api.field_info) = {</code>
     * @return string
     */
    public function getRequestId()
    {
        return $this->request_id;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request ID,
     * the server can check if original operation with the same request ID was
     * received, and if so, will ignore the second request. This prevents clients
     * from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL, (.google.api.field_info) = {</code>
     * @param string $var
     * @return $this
     */
    public function setRequestId($var)
    {
        GPBUtil::checkString($var, True);
        $this->request_id = $var;

        return $this;
    }

}

