<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/config/v1/config.proto

namespace Google\Cloud\Config\V1\DeploymentOperationMetadata;

use UnexpectedValueException;

/**
 * The possible steps a deployment may be running.
 *
 * Protobuf type <code>google.cloud.config.v1.DeploymentOperationMetadata.DeploymentStep</code>
 */
class DeploymentStep
{
    /**
     * Unspecified deployment step
     *
     * Generated from protobuf enum <code>DEPLOYMENT_STEP_UNSPECIFIED = 0;</code>
     */
    const DEPLOYMENT_STEP_UNSPECIFIED = 0;
    /**
     * Infra Manager is creating a Google Cloud Storage bucket to store
     * artifacts and metadata about the deployment and revision
     *
     * Generated from protobuf enum <code>PREPARING_STORAGE_BUCKET = 1;</code>
     */
    const PREPARING_STORAGE_BUCKET = 1;
    /**
     * Downloading the blueprint onto the Google Cloud Storage bucket
     *
     * Generated from protobuf enum <code>DOWNLOADING_BLUEPRINT = 2;</code>
     */
    const DOWNLOADING_BLUEPRINT = 2;
    /**
     * Initializing Terraform using `terraform init`
     *
     * Generated from protobuf enum <code>RUNNING_TF_INIT = 3;</code>
     */
    const RUNNING_TF_INIT = 3;
    /**
     * Running `terraform plan`
     *
     * Generated from protobuf enum <code>RUNNING_TF_PLAN = 4;</code>
     */
    const RUNNING_TF_PLAN = 4;
    /**
     * Actuating resources using Terraform using `terraform apply`
     *
     * Generated from protobuf enum <code>RUNNING_TF_APPLY = 5;</code>
     */
    const RUNNING_TF_APPLY = 5;
    /**
     * Destroying resources using Terraform using `terraform destroy`
     *
     * Generated from protobuf enum <code>RUNNING_TF_DESTROY = 6;</code>
     */
    const RUNNING_TF_DESTROY = 6;
    /**
     * Validating the uploaded TF state file when unlocking a deployment
     *
     * Generated from protobuf enum <code>RUNNING_TF_VALIDATE = 7;</code>
     */
    const RUNNING_TF_VALIDATE = 7;
    /**
     * Unlocking a deployment
     *
     * Generated from protobuf enum <code>UNLOCKING_DEPLOYMENT = 8;</code>
     */
    const UNLOCKING_DEPLOYMENT = 8;
    /**
     * Operation was successful
     *
     * Generated from protobuf enum <code>SUCCEEDED = 9;</code>
     */
    const SUCCEEDED = 9;
    /**
     * Operation failed
     *
     * Generated from protobuf enum <code>FAILED = 10;</code>
     */
    const FAILED = 10;
    /**
     * Validating the provided repository.
     *
     * Generated from protobuf enum <code>VALIDATING_REPOSITORY = 11;</code>
     */
    const VALIDATING_REPOSITORY = 11;
    /**
     * Running quota validation
     *
     * Generated from protobuf enum <code>RUNNING_QUOTA_VALIDATION = 12;</code>
     */
    const RUNNING_QUOTA_VALIDATION = 12;

    private static $valueToName = [
        self::DEPLOYMENT_STEP_UNSPECIFIED => 'DEPLOYMENT_STEP_UNSPECIFIED',
        self::PREPARING_STORAGE_BUCKET => 'PREPARING_STORAGE_BUCKET',
        self::DOWNLOADING_BLUEPRINT => 'DOWNLOADING_BLUEPRINT',
        self::RUNNING_TF_INIT => 'RUNNING_TF_INIT',
        self::RUNNING_TF_PLAN => 'RUNNING_TF_PLAN',
        self::RUNNING_TF_APPLY => 'RUNNING_TF_APPLY',
        self::RUNNING_TF_DESTROY => 'RUNNING_TF_DESTROY',
        self::RUNNING_TF_VALIDATE => 'RUNNING_TF_VALIDATE',
        self::UNLOCKING_DEPLOYMENT => 'UNLOCKING_DEPLOYMENT',
        self::SUCCEEDED => 'SUCCEEDED',
        self::FAILED => 'FAILED',
        self::VALIDATING_REPOSITORY => 'VALIDATING_REPOSITORY',
        self::RUNNING_QUOTA_VALIDATION => 'RUNNING_QUOTA_VALIDATION',
    ];

    public static function name($value)
    {
        if (!isset(self::$valueToName[$value])) {
            throw new UnexpectedValueException(sprintf(
                    'Enum %s has no name defined for value %s', __CLASS__, $value));
        }
        return self::$valueToName[$value];
    }


    public static function value($name)
    {
        $const = __CLASS__ . '::' . strtoupper($name);
        if (!defined($const)) {
            throw new UnexpectedValueException(sprintf(
                    'Enum %s has no value defined for name %s', __CLASS__, $name));
        }
        return constant($const);
    }
}


