<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/config/v1/config.proto

namespace Google\Cloud\Config\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A child resource of a Deployment generated by a 'CreateDeployment' or
 * 'UpdateDeployment' call. Each Revision contains metadata pertaining to a
 * snapshot of a particular Deployment.
 *
 * Generated from protobuf message <code>google.cloud.config.v1.Revision</code>
 */
class Revision extends \Google\Protobuf\Internal\Message
{
    /**
     * Revision name. Format:
     * `projects/{project}/locations/{location}/deployments/{deployment}/
     * revisions/{revision}`
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    protected $name = '';
    /**
     * Output only. Time when the revision was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. Time when the revision was last modified.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Output only. The action which created this revision
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.Revision.Action action = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $action = 0;
    /**
     * Output only. Current state of the revision.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.Revision.State state = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;
    /**
     * Output only. Outputs and artifacts from applying a deployment.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.ApplyResults apply_results = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $apply_results = null;
    /**
     * Output only. Additional info regarding the current state.
     *
     * Generated from protobuf field <code>string state_detail = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state_detail = '';
    /**
     * Output only. Code describing any errors that may have occurred.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.Revision.ErrorCode error_code = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $error_code = 0;
    /**
     * Output only. Cloud Build instance UUID associated with this revision.
     *
     * Generated from protobuf field <code>string build = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $build = '';
    /**
     * Output only. Location of Revision operation logs in
     * `gs://{bucket}/{object}` format.
     *
     * Generated from protobuf field <code>string logs = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $logs = '';
    /**
     * Output only. Errors encountered when creating or updating this deployment.
     * Errors are truncated to 10 entries, see `delete_results` and `error_logs`
     * for full details.
     *
     * Generated from protobuf field <code>repeated .google.cloud.config.v1.TerraformError tf_errors = 12 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $tf_errors;
    /**
     * Output only. Location of Terraform error logs in Google Cloud Storage.
     * Format: `gs://{bucket}/{object}`.
     *
     * Generated from protobuf field <code>string error_logs = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $error_logs = '';
    /**
     * Output only. User-specified Service Account (SA) to be used as credential
     * to manage resources. Format:
     * `projects/{projectID}/serviceAccounts/{serviceAccount}`
     *
     * Generated from protobuf field <code>string service_account = 14 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     */
    protected $service_account = '';
    /**
     * Output only. By default, Infra Manager will return a failure when
     * Terraform encounters a 409 code (resource conflict error) during actuation.
     * If this flag is set to true, Infra Manager will instead
     * attempt to automatically import the resource into the Terraform state (for
     * supported resource types) and continue actuation.
     * Not all resource types are supported, refer to documentation.
     *
     * Generated from protobuf field <code>bool import_existing_resources = 15 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $import_existing_resources = false;
    /**
     * Output only. The user-specified Cloud Build worker pool resource in which
     * the Cloud Build job will execute. Format:
     * `projects/{project}/locations/{location}/workerPools/{workerPoolId}`.
     * If this field is unspecified, the default Cloud Build worker pool will be
     * used.
     *
     * Generated from protobuf field <code>string worker_pool = 17 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     */
    protected $worker_pool = '';
    /**
     * Output only. The user-specified Terraform version constraint.
     * Example: "=1.3.10".
     *
     * Generated from protobuf field <code>string tf_version_constraint = 18 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $tf_version_constraint = '';
    /**
     * Output only. The version of Terraform used to create the Revision.
     * It is in the format of "Major.Minor.Patch", for example, "1.3.10".
     *
     * Generated from protobuf field <code>string tf_version = 19 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $tf_version = '';
    /**
     * Output only. Cloud Storage path containing quota validation results. This
     * field is set when a user sets Deployment.quota_validation field to ENABLED
     * or ENFORCED. Format: `gs://{bucket}/{object}`.
     *
     * Generated from protobuf field <code>string quota_validation_results = 29 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $quota_validation_results = '';
    /**
     * Optional. Input to control quota checks for resources in terraform
     * configuration files. There are limited resources on which quota validation
     * applies.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.QuotaValidation quota_validation = 20 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $quota_validation = 0;
    protected $blueprint;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\Config\V1\TerraformBlueprint $terraform_blueprint
     *           Output only. A blueprint described using Terraform's HashiCorp
     *           Configuration Language as a root module.
     *     @type string $name
     *           Revision name. Format:
     *           `projects/{project}/locations/{location}/deployments/{deployment}/
     *           revisions/{revision}`
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. Time when the revision was created.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. Time when the revision was last modified.
     *     @type int $action
     *           Output only. The action which created this revision
     *     @type int $state
     *           Output only. Current state of the revision.
     *     @type \Google\Cloud\Config\V1\ApplyResults $apply_results
     *           Output only. Outputs and artifacts from applying a deployment.
     *     @type string $state_detail
     *           Output only. Additional info regarding the current state.
     *     @type int $error_code
     *           Output only. Code describing any errors that may have occurred.
     *     @type string $build
     *           Output only. Cloud Build instance UUID associated with this revision.
     *     @type string $logs
     *           Output only. Location of Revision operation logs in
     *           `gs://{bucket}/{object}` format.
     *     @type array<\Google\Cloud\Config\V1\TerraformError>|\Google\Protobuf\Internal\RepeatedField $tf_errors
     *           Output only. Errors encountered when creating or updating this deployment.
     *           Errors are truncated to 10 entries, see `delete_results` and `error_logs`
     *           for full details.
     *     @type string $error_logs
     *           Output only. Location of Terraform error logs in Google Cloud Storage.
     *           Format: `gs://{bucket}/{object}`.
     *     @type string $service_account
     *           Output only. User-specified Service Account (SA) to be used as credential
     *           to manage resources. Format:
     *           `projects/{projectID}/serviceAccounts/{serviceAccount}`
     *     @type bool $import_existing_resources
     *           Output only. By default, Infra Manager will return a failure when
     *           Terraform encounters a 409 code (resource conflict error) during actuation.
     *           If this flag is set to true, Infra Manager will instead
     *           attempt to automatically import the resource into the Terraform state (for
     *           supported resource types) and continue actuation.
     *           Not all resource types are supported, refer to documentation.
     *     @type string $worker_pool
     *           Output only. The user-specified Cloud Build worker pool resource in which
     *           the Cloud Build job will execute. Format:
     *           `projects/{project}/locations/{location}/workerPools/{workerPoolId}`.
     *           If this field is unspecified, the default Cloud Build worker pool will be
     *           used.
     *     @type string $tf_version_constraint
     *           Output only. The user-specified Terraform version constraint.
     *           Example: "=1.3.10".
     *     @type string $tf_version
     *           Output only. The version of Terraform used to create the Revision.
     *           It is in the format of "Major.Minor.Patch", for example, "1.3.10".
     *     @type string $quota_validation_results
     *           Output only. Cloud Storage path containing quota validation results. This
     *           field is set when a user sets Deployment.quota_validation field to ENABLED
     *           or ENFORCED. Format: `gs://{bucket}/{object}`.
     *     @type int $quota_validation
     *           Optional. Input to control quota checks for resources in terraform
     *           configuration files. There are limited resources on which quota validation
     *           applies.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Config\V1\Config::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. A blueprint described using Terraform's HashiCorp
     * Configuration Language as a root module.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.TerraformBlueprint terraform_blueprint = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\Config\V1\TerraformBlueprint|null
     */
    public function getTerraformBlueprint()
    {
        return $this->readOneof(6);
    }

    public function hasTerraformBlueprint()
    {
        return $this->hasOneof(6);
    }

    /**
     * Output only. A blueprint described using Terraform's HashiCorp
     * Configuration Language as a root module.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.TerraformBlueprint terraform_blueprint = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\Config\V1\TerraformBlueprint $var
     * @return $this
     */
    public function setTerraformBlueprint($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Config\V1\TerraformBlueprint::class);
        $this->writeOneof(6, $var);

        return $this;
    }

    /**
     * Revision name. Format:
     * `projects/{project}/locations/{location}/deployments/{deployment}/
     * revisions/{revision}`
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Revision name. Format:
     * `projects/{project}/locations/{location}/deployments/{deployment}/
     * revisions/{revision}`
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. Time when the revision was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. Time when the revision was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. Time when the revision was last modified.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. Time when the revision was last modified.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Output only. The action which created this revision
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.Revision.Action action = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getAction()
    {
        return $this->action;
    }

    /**
     * Output only. The action which created this revision
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.Revision.Action action = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setAction($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Config\V1\Revision\Action::class);
        $this->action = $var;

        return $this;
    }

    /**
     * Output only. Current state of the revision.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.Revision.State state = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. Current state of the revision.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.Revision.State state = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Config\V1\Revision\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Output only. Outputs and artifacts from applying a deployment.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.ApplyResults apply_results = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\Config\V1\ApplyResults|null
     */
    public function getApplyResults()
    {
        return $this->apply_results;
    }

    public function hasApplyResults()
    {
        return isset($this->apply_results);
    }

    public function clearApplyResults()
    {
        unset($this->apply_results);
    }

    /**
     * Output only. Outputs and artifacts from applying a deployment.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.ApplyResults apply_results = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\Config\V1\ApplyResults $var
     * @return $this
     */
    public function setApplyResults($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Config\V1\ApplyResults::class);
        $this->apply_results = $var;

        return $this;
    }

    /**
     * Output only. Additional info regarding the current state.
     *
     * Generated from protobuf field <code>string state_detail = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getStateDetail()
    {
        return $this->state_detail;
    }

    /**
     * Output only. Additional info regarding the current state.
     *
     * Generated from protobuf field <code>string state_detail = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setStateDetail($var)
    {
        GPBUtil::checkString($var, True);
        $this->state_detail = $var;

        return $this;
    }

    /**
     * Output only. Code describing any errors that may have occurred.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.Revision.ErrorCode error_code = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getErrorCode()
    {
        return $this->error_code;
    }

    /**
     * Output only. Code describing any errors that may have occurred.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.Revision.ErrorCode error_code = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setErrorCode($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Config\V1\Revision\ErrorCode::class);
        $this->error_code = $var;

        return $this;
    }

    /**
     * Output only. Cloud Build instance UUID associated with this revision.
     *
     * Generated from protobuf field <code>string build = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getBuild()
    {
        return $this->build;
    }

    /**
     * Output only. Cloud Build instance UUID associated with this revision.
     *
     * Generated from protobuf field <code>string build = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setBuild($var)
    {
        GPBUtil::checkString($var, True);
        $this->build = $var;

        return $this;
    }

    /**
     * Output only. Location of Revision operation logs in
     * `gs://{bucket}/{object}` format.
     *
     * Generated from protobuf field <code>string logs = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getLogs()
    {
        return $this->logs;
    }

    /**
     * Output only. Location of Revision operation logs in
     * `gs://{bucket}/{object}` format.
     *
     * Generated from protobuf field <code>string logs = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setLogs($var)
    {
        GPBUtil::checkString($var, True);
        $this->logs = $var;

        return $this;
    }

    /**
     * Output only. Errors encountered when creating or updating this deployment.
     * Errors are truncated to 10 entries, see `delete_results` and `error_logs`
     * for full details.
     *
     * Generated from protobuf field <code>repeated .google.cloud.config.v1.TerraformError tf_errors = 12 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getTfErrors()
    {
        return $this->tf_errors;
    }

    /**
     * Output only. Errors encountered when creating or updating this deployment.
     * Errors are truncated to 10 entries, see `delete_results` and `error_logs`
     * for full details.
     *
     * Generated from protobuf field <code>repeated .google.cloud.config.v1.TerraformError tf_errors = 12 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param array<\Google\Cloud\Config\V1\TerraformError>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setTfErrors($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Config\V1\TerraformError::class);
        $this->tf_errors = $arr;

        return $this;
    }

    /**
     * Output only. Location of Terraform error logs in Google Cloud Storage.
     * Format: `gs://{bucket}/{object}`.
     *
     * Generated from protobuf field <code>string error_logs = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getErrorLogs()
    {
        return $this->error_logs;
    }

    /**
     * Output only. Location of Terraform error logs in Google Cloud Storage.
     * Format: `gs://{bucket}/{object}`.
     *
     * Generated from protobuf field <code>string error_logs = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setErrorLogs($var)
    {
        GPBUtil::checkString($var, True);
        $this->error_logs = $var;

        return $this;
    }

    /**
     * Output only. User-specified Service Account (SA) to be used as credential
     * to manage resources. Format:
     * `projects/{projectID}/serviceAccounts/{serviceAccount}`
     *
     * Generated from protobuf field <code>string service_account = 14 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getServiceAccount()
    {
        return $this->service_account;
    }

    /**
     * Output only. User-specified Service Account (SA) to be used as credential
     * to manage resources. Format:
     * `projects/{projectID}/serviceAccounts/{serviceAccount}`
     *
     * Generated from protobuf field <code>string service_account = 14 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setServiceAccount($var)
    {
        GPBUtil::checkString($var, True);
        $this->service_account = $var;

        return $this;
    }

    /**
     * Output only. By default, Infra Manager will return a failure when
     * Terraform encounters a 409 code (resource conflict error) during actuation.
     * If this flag is set to true, Infra Manager will instead
     * attempt to automatically import the resource into the Terraform state (for
     * supported resource types) and continue actuation.
     * Not all resource types are supported, refer to documentation.
     *
     * Generated from protobuf field <code>bool import_existing_resources = 15 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return bool
     */
    public function getImportExistingResources()
    {
        return $this->import_existing_resources;
    }

    /**
     * Output only. By default, Infra Manager will return a failure when
     * Terraform encounters a 409 code (resource conflict error) during actuation.
     * If this flag is set to true, Infra Manager will instead
     * attempt to automatically import the resource into the Terraform state (for
     * supported resource types) and continue actuation.
     * Not all resource types are supported, refer to documentation.
     *
     * Generated from protobuf field <code>bool import_existing_resources = 15 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param bool $var
     * @return $this
     */
    public function setImportExistingResources($var)
    {
        GPBUtil::checkBool($var);
        $this->import_existing_resources = $var;

        return $this;
    }

    /**
     * Output only. The user-specified Cloud Build worker pool resource in which
     * the Cloud Build job will execute. Format:
     * `projects/{project}/locations/{location}/workerPools/{workerPoolId}`.
     * If this field is unspecified, the default Cloud Build worker pool will be
     * used.
     *
     * Generated from protobuf field <code>string worker_pool = 17 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getWorkerPool()
    {
        return $this->worker_pool;
    }

    /**
     * Output only. The user-specified Cloud Build worker pool resource in which
     * the Cloud Build job will execute. Format:
     * `projects/{project}/locations/{location}/workerPools/{workerPoolId}`.
     * If this field is unspecified, the default Cloud Build worker pool will be
     * used.
     *
     * Generated from protobuf field <code>string worker_pool = 17 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setWorkerPool($var)
    {
        GPBUtil::checkString($var, True);
        $this->worker_pool = $var;

        return $this;
    }

    /**
     * Output only. The user-specified Terraform version constraint.
     * Example: "=1.3.10".
     *
     * Generated from protobuf field <code>string tf_version_constraint = 18 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getTfVersionConstraint()
    {
        return $this->tf_version_constraint;
    }

    /**
     * Output only. The user-specified Terraform version constraint.
     * Example: "=1.3.10".
     *
     * Generated from protobuf field <code>string tf_version_constraint = 18 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setTfVersionConstraint($var)
    {
        GPBUtil::checkString($var, True);
        $this->tf_version_constraint = $var;

        return $this;
    }

    /**
     * Output only. The version of Terraform used to create the Revision.
     * It is in the format of "Major.Minor.Patch", for example, "1.3.10".
     *
     * Generated from protobuf field <code>string tf_version = 19 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getTfVersion()
    {
        return $this->tf_version;
    }

    /**
     * Output only. The version of Terraform used to create the Revision.
     * It is in the format of "Major.Minor.Patch", for example, "1.3.10".
     *
     * Generated from protobuf field <code>string tf_version = 19 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setTfVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->tf_version = $var;

        return $this;
    }

    /**
     * Output only. Cloud Storage path containing quota validation results. This
     * field is set when a user sets Deployment.quota_validation field to ENABLED
     * or ENFORCED. Format: `gs://{bucket}/{object}`.
     *
     * Generated from protobuf field <code>string quota_validation_results = 29 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getQuotaValidationResults()
    {
        return $this->quota_validation_results;
    }

    /**
     * Output only. Cloud Storage path containing quota validation results. This
     * field is set when a user sets Deployment.quota_validation field to ENABLED
     * or ENFORCED. Format: `gs://{bucket}/{object}`.
     *
     * Generated from protobuf field <code>string quota_validation_results = 29 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setQuotaValidationResults($var)
    {
        GPBUtil::checkString($var, True);
        $this->quota_validation_results = $var;

        return $this;
    }

    /**
     * Optional. Input to control quota checks for resources in terraform
     * configuration files. There are limited resources on which quota validation
     * applies.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.QuotaValidation quota_validation = 20 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getQuotaValidation()
    {
        return $this->quota_validation;
    }

    /**
     * Optional. Input to control quota checks for resources in terraform
     * configuration files. There are limited resources on which quota validation
     * applies.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.QuotaValidation quota_validation = 20 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setQuotaValidation($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Config\V1\QuotaValidation::class);
        $this->quota_validation = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getBlueprint()
    {
        return $this->whichOneof("blueprint");
    }

}

