<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/config/v1/config.proto

namespace Google\Cloud\Config\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Errors encountered during actuation using Terraform
 *
 * Generated from protobuf message <code>google.cloud.config.v1.TerraformError</code>
 */
class TerraformError extends \Google\Protobuf\Internal\Message
{
    /**
     * Address of the resource associated with the error,
     * e.g. `google_compute_network.vpc_network`.
     *
     * Generated from protobuf field <code>string resource_address = 1;</code>
     */
    protected $resource_address = '';
    /**
     * HTTP response code returned from Google Cloud Platform APIs when Terraform
     * fails to provision the resource. If unset or 0, no HTTP response code was
     * returned by Terraform.
     *
     * Generated from protobuf field <code>int32 http_response_code = 2;</code>
     */
    protected $http_response_code = 0;
    /**
     * A human-readable error description.
     *
     * Generated from protobuf field <code>string error_description = 3;</code>
     */
    protected $error_description = '';
    /**
     * Original error response from underlying Google API, if available.
     *
     * Generated from protobuf field <code>.google.rpc.Status error = 4;</code>
     */
    protected $error = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $resource_address
     *           Address of the resource associated with the error,
     *           e.g. `google_compute_network.vpc_network`.
     *     @type int $http_response_code
     *           HTTP response code returned from Google Cloud Platform APIs when Terraform
     *           fails to provision the resource. If unset or 0, no HTTP response code was
     *           returned by Terraform.
     *     @type string $error_description
     *           A human-readable error description.
     *     @type \Google\Rpc\Status $error
     *           Original error response from underlying Google API, if available.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Config\V1\Config::initOnce();
        parent::__construct($data);
    }

    /**
     * Address of the resource associated with the error,
     * e.g. `google_compute_network.vpc_network`.
     *
     * Generated from protobuf field <code>string resource_address = 1;</code>
     * @return string
     */
    public function getResourceAddress()
    {
        return $this->resource_address;
    }

    /**
     * Address of the resource associated with the error,
     * e.g. `google_compute_network.vpc_network`.
     *
     * Generated from protobuf field <code>string resource_address = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setResourceAddress($var)
    {
        GPBUtil::checkString($var, True);
        $this->resource_address = $var;

        return $this;
    }

    /**
     * HTTP response code returned from Google Cloud Platform APIs when Terraform
     * fails to provision the resource. If unset or 0, no HTTP response code was
     * returned by Terraform.
     *
     * Generated from protobuf field <code>int32 http_response_code = 2;</code>
     * @return int
     */
    public function getHttpResponseCode()
    {
        return $this->http_response_code;
    }

    /**
     * HTTP response code returned from Google Cloud Platform APIs when Terraform
     * fails to provision the resource. If unset or 0, no HTTP response code was
     * returned by Terraform.
     *
     * Generated from protobuf field <code>int32 http_response_code = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setHttpResponseCode($var)
    {
        GPBUtil::checkInt32($var);
        $this->http_response_code = $var;

        return $this;
    }

    /**
     * A human-readable error description.
     *
     * Generated from protobuf field <code>string error_description = 3;</code>
     * @return string
     */
    public function getErrorDescription()
    {
        return $this->error_description;
    }

    /**
     * A human-readable error description.
     *
     * Generated from protobuf field <code>string error_description = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setErrorDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->error_description = $var;

        return $this;
    }

    /**
     * Original error response from underlying Google API, if available.
     *
     * Generated from protobuf field <code>.google.rpc.Status error = 4;</code>
     * @return \Google\Rpc\Status|null
     */
    public function getError()
    {
        return $this->error;
    }

    public function hasError()
    {
        return isset($this->error);
    }

    public function clearError()
    {
        unset($this->error);
    }

    /**
     * Original error response from underlying Google API, if available.
     *
     * Generated from protobuf field <code>.google.rpc.Status error = 4;</code>
     * @param \Google\Rpc\Status $var
     * @return $this
     */
    public function setError($var)
    {
        GPBUtil::checkMessage($var, \Google\Rpc\Status::class);
        $this->error = $var;

        return $this;
    }

}

