<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/config/v1/config.proto

namespace Google\Cloud\Config\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A TerraformVersion represents the support state the corresponding
 * Terraform version.
 *
 * Generated from protobuf message <code>google.cloud.config.v1.TerraformVersion</code>
 */
class TerraformVersion extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. The version name is in the format:
     * 'projects/{project_id}/locations/{location}/terraformVersions/{terraform_version}'.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Output only. The state of the version, ACTIVE, DEPRECATED or OBSOLETE.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.TerraformVersion.State state = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;
    /**
     * Output only. When the version is supported.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp support_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $support_time = null;
    /**
     * Output only. When the version is deprecated.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp deprecate_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $deprecate_time = null;
    /**
     * Output only. When the version is obsolete.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp obsolete_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $obsolete_time = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. The version name is in the format:
     *           'projects/{project_id}/locations/{location}/terraformVersions/{terraform_version}'.
     *     @type int $state
     *           Output only. The state of the version, ACTIVE, DEPRECATED or OBSOLETE.
     *     @type \Google\Protobuf\Timestamp $support_time
     *           Output only. When the version is supported.
     *     @type \Google\Protobuf\Timestamp $deprecate_time
     *           Output only. When the version is deprecated.
     *     @type \Google\Protobuf\Timestamp $obsolete_time
     *           Output only. When the version is obsolete.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Config\V1\Config::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. The version name is in the format:
     * 'projects/{project_id}/locations/{location}/terraformVersions/{terraform_version}'.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. The version name is in the format:
     * 'projects/{project_id}/locations/{location}/terraformVersions/{terraform_version}'.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. The state of the version, ACTIVE, DEPRECATED or OBSOLETE.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.TerraformVersion.State state = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. The state of the version, ACTIVE, DEPRECATED or OBSOLETE.
     *
     * Generated from protobuf field <code>.google.cloud.config.v1.TerraformVersion.State state = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Config\V1\TerraformVersion\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Output only. When the version is supported.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp support_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getSupportTime()
    {
        return $this->support_time;
    }

    public function hasSupportTime()
    {
        return isset($this->support_time);
    }

    public function clearSupportTime()
    {
        unset($this->support_time);
    }

    /**
     * Output only. When the version is supported.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp support_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setSupportTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->support_time = $var;

        return $this;
    }

    /**
     * Output only. When the version is deprecated.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp deprecate_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getDeprecateTime()
    {
        return $this->deprecate_time;
    }

    public function hasDeprecateTime()
    {
        return isset($this->deprecate_time);
    }

    public function clearDeprecateTime()
    {
        unset($this->deprecate_time);
    }

    /**
     * Output only. When the version is deprecated.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp deprecate_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setDeprecateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->deprecate_time = $var;

        return $this;
    }

    /**
     * Output only. When the version is obsolete.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp obsolete_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getObsoleteTime()
    {
        return $this->obsolete_time;
    }

    public function hasObsoleteTime()
    {
        return isset($this->obsolete_time);
    }

    public function clearObsoleteTime()
    {
        unset($this->obsolete_time);
    }

    /**
     * Output only. When the version is obsolete.
     *
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp obsolete_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setObsoleteTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->obsolete_time = $var;

        return $this;
    }

}

