<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/contactcenterinsights/v1/contact_center_insights.proto

namespace Google\Cloud\ContactCenterInsights\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request to analyze conversations in bulk.
 *
 * Generated from protobuf message <code>google.cloud.contactcenterinsights.v1.BulkAnalyzeConversationsRequest</code>
 */
class BulkAnalyzeConversationsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent resource to create analyses in.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. Filter used to select the subset of conversations to analyze.
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $filter = '';
    /**
     * Required. Percentage of selected conversation to analyze, between
     * [0, 100].
     *
     * Generated from protobuf field <code>float analysis_percentage = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $analysis_percentage = 0.0;
    /**
     * To select the annotators to run and the phrase matchers to use
     * (if any). If not specified, all annotators will be run.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.AnnotatorSelector annotator_selector = 8;</code>
     */
    protected $annotator_selector = null;

    /**
     * @param string $parent             Required. The parent resource to create analyses in. Please see
     *                                   {@see ContactCenterInsightsClient::locationName()} for help formatting this field.
     * @param string $filter             Required. Filter used to select the subset of conversations to analyze.
     * @param float  $analysisPercentage Required. Percentage of selected conversation to analyze, between
     *                                   [0, 100].
     *
     * @return \Google\Cloud\ContactCenterInsights\V1\BulkAnalyzeConversationsRequest
     *
     * @experimental
     */
    public static function build(string $parent, string $filter, float $analysisPercentage): self
    {
        return (new self())
            ->setParent($parent)
            ->setFilter($filter)
            ->setAnalysisPercentage($analysisPercentage);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent resource to create analyses in.
     *     @type string $filter
     *           Required. Filter used to select the subset of conversations to analyze.
     *     @type float $analysis_percentage
     *           Required. Percentage of selected conversation to analyze, between
     *           [0, 100].
     *     @type \Google\Cloud\ContactCenterInsights\V1\AnnotatorSelector $annotator_selector
     *           To select the annotators to run and the phrase matchers to use
     *           (if any). If not specified, all annotators will be run.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Contactcenterinsights\V1\ContactCenterInsights::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent resource to create analyses in.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent resource to create analyses in.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. Filter used to select the subset of conversations to analyze.
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Required. Filter used to select the subset of conversations to analyze.
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * Required. Percentage of selected conversation to analyze, between
     * [0, 100].
     *
     * Generated from protobuf field <code>float analysis_percentage = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return float
     */
    public function getAnalysisPercentage()
    {
        return $this->analysis_percentage;
    }

    /**
     * Required. Percentage of selected conversation to analyze, between
     * [0, 100].
     *
     * Generated from protobuf field <code>float analysis_percentage = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param float $var
     * @return $this
     */
    public function setAnalysisPercentage($var)
    {
        GPBUtil::checkFloat($var);
        $this->analysis_percentage = $var;

        return $this;
    }

    /**
     * To select the annotators to run and the phrase matchers to use
     * (if any). If not specified, all annotators will be run.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.AnnotatorSelector annotator_selector = 8;</code>
     * @return \Google\Cloud\ContactCenterInsights\V1\AnnotatorSelector|null
     */
    public function getAnnotatorSelector()
    {
        return $this->annotator_selector;
    }

    public function hasAnnotatorSelector()
    {
        return isset($this->annotator_selector);
    }

    public function clearAnnotatorSelector()
    {
        unset($this->annotator_selector);
    }

    /**
     * To select the annotators to run and the phrase matchers to use
     * (if any). If not specified, all annotators will be run.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.AnnotatorSelector annotator_selector = 8;</code>
     * @param \Google\Cloud\ContactCenterInsights\V1\AnnotatorSelector $var
     * @return $this
     */
    public function setAnnotatorSelector($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ContactCenterInsights\V1\AnnotatorSelector::class);
        $this->annotator_selector = $var;

        return $this;
    }

}

