<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/contactcenterinsights/v1/resources.proto

namespace Google\Cloud\ContactCenterInsights\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Conversation summarization suggestion data.
 *
 * Generated from protobuf message <code>google.cloud.contactcenterinsights.v1.ConversationSummarizationSuggestionData</code>
 */
class ConversationSummarizationSuggestionData extends \Google\Protobuf\Internal\Message
{
    /**
     * The summarization content that is concatenated into one string.
     *
     * Generated from protobuf field <code>string text = 1;</code>
     */
    protected $text = '';
    /**
     * The summarization content that is divided into sections. The key is the
     * section's name and the value is the section's content. There is no
     * specific format for the key or value.
     *
     * Generated from protobuf field <code>map<string, string> text_sections = 5;</code>
     */
    private $text_sections;
    /**
     * The confidence score of the summarization.
     *
     * Generated from protobuf field <code>float confidence = 2;</code>
     */
    protected $confidence = 0.0;
    /**
     * A map that contains metadata about the summarization and the document
     * from which it originates.
     *
     * Generated from protobuf field <code>map<string, string> metadata = 3;</code>
     */
    private $metadata;
    /**
     * The name of the answer record.
     * Format:
     * projects/{project}/locations/{location}/answerRecords/{answer_record}
     *
     * Generated from protobuf field <code>string answer_record = 4;</code>
     */
    protected $answer_record = '';
    /**
     * The name of the model that generates this summary.
     * Format:
     * projects/{project}/locations/{location}/conversationModels/{conversation_model}
     *
     * Generated from protobuf field <code>string conversation_model = 6;</code>
     */
    protected $conversation_model = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $text
     *           The summarization content that is concatenated into one string.
     *     @type array|\Google\Protobuf\Internal\MapField $text_sections
     *           The summarization content that is divided into sections. The key is the
     *           section's name and the value is the section's content. There is no
     *           specific format for the key or value.
     *     @type float $confidence
     *           The confidence score of the summarization.
     *     @type array|\Google\Protobuf\Internal\MapField $metadata
     *           A map that contains metadata about the summarization and the document
     *           from which it originates.
     *     @type string $answer_record
     *           The name of the answer record.
     *           Format:
     *           projects/{project}/locations/{location}/answerRecords/{answer_record}
     *     @type string $conversation_model
     *           The name of the model that generates this summary.
     *           Format:
     *           projects/{project}/locations/{location}/conversationModels/{conversation_model}
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Contactcenterinsights\V1\Resources::initOnce();
        parent::__construct($data);
    }

    /**
     * The summarization content that is concatenated into one string.
     *
     * Generated from protobuf field <code>string text = 1;</code>
     * @return string
     */
    public function getText()
    {
        return $this->text;
    }

    /**
     * The summarization content that is concatenated into one string.
     *
     * Generated from protobuf field <code>string text = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setText($var)
    {
        GPBUtil::checkString($var, True);
        $this->text = $var;

        return $this;
    }

    /**
     * The summarization content that is divided into sections. The key is the
     * section's name and the value is the section's content. There is no
     * specific format for the key or value.
     *
     * Generated from protobuf field <code>map<string, string> text_sections = 5;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getTextSections()
    {
        return $this->text_sections;
    }

    /**
     * The summarization content that is divided into sections. The key is the
     * section's name and the value is the section's content. There is no
     * specific format for the key or value.
     *
     * Generated from protobuf field <code>map<string, string> text_sections = 5;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setTextSections($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->text_sections = $arr;

        return $this;
    }

    /**
     * The confidence score of the summarization.
     *
     * Generated from protobuf field <code>float confidence = 2;</code>
     * @return float
     */
    public function getConfidence()
    {
        return $this->confidence;
    }

    /**
     * The confidence score of the summarization.
     *
     * Generated from protobuf field <code>float confidence = 2;</code>
     * @param float $var
     * @return $this
     */
    public function setConfidence($var)
    {
        GPBUtil::checkFloat($var);
        $this->confidence = $var;

        return $this;
    }

    /**
     * A map that contains metadata about the summarization and the document
     * from which it originates.
     *
     * Generated from protobuf field <code>map<string, string> metadata = 3;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getMetadata()
    {
        return $this->metadata;
    }

    /**
     * A map that contains metadata about the summarization and the document
     * from which it originates.
     *
     * Generated from protobuf field <code>map<string, string> metadata = 3;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setMetadata($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->metadata = $arr;

        return $this;
    }

    /**
     * The name of the answer record.
     * Format:
     * projects/{project}/locations/{location}/answerRecords/{answer_record}
     *
     * Generated from protobuf field <code>string answer_record = 4;</code>
     * @return string
     */
    public function getAnswerRecord()
    {
        return $this->answer_record;
    }

    /**
     * The name of the answer record.
     * Format:
     * projects/{project}/locations/{location}/answerRecords/{answer_record}
     *
     * Generated from protobuf field <code>string answer_record = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setAnswerRecord($var)
    {
        GPBUtil::checkString($var, True);
        $this->answer_record = $var;

        return $this;
    }

    /**
     * The name of the model that generates this summary.
     * Format:
     * projects/{project}/locations/{location}/conversationModels/{conversation_model}
     *
     * Generated from protobuf field <code>string conversation_model = 6;</code>
     * @return string
     */
    public function getConversationModel()
    {
        return $this->conversation_model;
    }

    /**
     * The name of the model that generates this summary.
     * Format:
     * projects/{project}/locations/{location}/conversationModels/{conversation_model}
     *
     * Generated from protobuf field <code>string conversation_model = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setConversationModel($var)
    {
        GPBUtil::checkString($var, True);
        $this->conversation_model = $var;

        return $this;
    }

}

