<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/contactcenterinsights/v1/contact_center_insights.proto

namespace Google\Cloud\ContactCenterInsights\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request to ingest conversations.
 *
 * Generated from protobuf message <code>google.cloud.contactcenterinsights.v1.IngestConversationsRequest</code>
 */
class IngestConversationsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent resource for new conversations.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Configuration that applies to all conversations.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.IngestConversationsRequest.ConversationConfig conversation_config = 4;</code>
     */
    protected $conversation_config = null;
    /**
     * Optional. DLP settings for transcript redaction. Optional, will default to
     * the config specified in Settings.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.RedactionConfig redaction_config = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $redaction_config = null;
    /**
     * Optional. Default Speech-to-Text configuration. Optional, will default to
     * the config specified in Settings.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.SpeechConfig speech_config = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $speech_config = null;
    /**
     * Optional. If set, this fields indicates the number of objects to ingest
     * from the Cloud Storage bucket. If empty, the entire bucket will be
     * ingested. Unless they are first deleted, conversations produced through
     * sampling won't be ingested by subsequent ingest requests.
     *
     * Generated from protobuf field <code>optional int32 sample_size = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $sample_size = null;
    protected $source;
    protected $object_config;

    /**
     * @param string $parent Required. The parent resource for new conversations. Please see
     *                       {@see ContactCenterInsightsClient::locationName()} for help formatting this field.
     *
     * @return \Google\Cloud\ContactCenterInsights\V1\IngestConversationsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\ContactCenterInsights\V1\IngestConversationsRequest\GcsSource $gcs_source
     *           A cloud storage bucket source. Note that any previously ingested objects
     *           from the source will be skipped to avoid duplication.
     *     @type \Google\Cloud\ContactCenterInsights\V1\IngestConversationsRequest\TranscriptObjectConfig $transcript_object_config
     *           Configuration for when `source` contains conversation transcripts.
     *     @type string $parent
     *           Required. The parent resource for new conversations.
     *     @type \Google\Cloud\ContactCenterInsights\V1\IngestConversationsRequest\ConversationConfig $conversation_config
     *           Configuration that applies to all conversations.
     *     @type \Google\Cloud\ContactCenterInsights\V1\RedactionConfig $redaction_config
     *           Optional. DLP settings for transcript redaction. Optional, will default to
     *           the config specified in Settings.
     *     @type \Google\Cloud\ContactCenterInsights\V1\SpeechConfig $speech_config
     *           Optional. Default Speech-to-Text configuration. Optional, will default to
     *           the config specified in Settings.
     *     @type int $sample_size
     *           Optional. If set, this fields indicates the number of objects to ingest
     *           from the Cloud Storage bucket. If empty, the entire bucket will be
     *           ingested. Unless they are first deleted, conversations produced through
     *           sampling won't be ingested by subsequent ingest requests.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Contactcenterinsights\V1\ContactCenterInsights::initOnce();
        parent::__construct($data);
    }

    /**
     * A cloud storage bucket source. Note that any previously ingested objects
     * from the source will be skipped to avoid duplication.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.IngestConversationsRequest.GcsSource gcs_source = 2;</code>
     * @return \Google\Cloud\ContactCenterInsights\V1\IngestConversationsRequest\GcsSource|null
     */
    public function getGcsSource()
    {
        return $this->readOneof(2);
    }

    public function hasGcsSource()
    {
        return $this->hasOneof(2);
    }

    /**
     * A cloud storage bucket source. Note that any previously ingested objects
     * from the source will be skipped to avoid duplication.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.IngestConversationsRequest.GcsSource gcs_source = 2;</code>
     * @param \Google\Cloud\ContactCenterInsights\V1\IngestConversationsRequest\GcsSource $var
     * @return $this
     */
    public function setGcsSource($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ContactCenterInsights\V1\IngestConversationsRequest\GcsSource::class);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     * Configuration for when `source` contains conversation transcripts.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.IngestConversationsRequest.TranscriptObjectConfig transcript_object_config = 3;</code>
     * @return \Google\Cloud\ContactCenterInsights\V1\IngestConversationsRequest\TranscriptObjectConfig|null
     */
    public function getTranscriptObjectConfig()
    {
        return $this->readOneof(3);
    }

    public function hasTranscriptObjectConfig()
    {
        return $this->hasOneof(3);
    }

    /**
     * Configuration for when `source` contains conversation transcripts.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.IngestConversationsRequest.TranscriptObjectConfig transcript_object_config = 3;</code>
     * @param \Google\Cloud\ContactCenterInsights\V1\IngestConversationsRequest\TranscriptObjectConfig $var
     * @return $this
     */
    public function setTranscriptObjectConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ContactCenterInsights\V1\IngestConversationsRequest\TranscriptObjectConfig::class);
        $this->writeOneof(3, $var);

        return $this;
    }

    /**
     * Required. The parent resource for new conversations.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent resource for new conversations.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Configuration that applies to all conversations.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.IngestConversationsRequest.ConversationConfig conversation_config = 4;</code>
     * @return \Google\Cloud\ContactCenterInsights\V1\IngestConversationsRequest\ConversationConfig|null
     */
    public function getConversationConfig()
    {
        return $this->conversation_config;
    }

    public function hasConversationConfig()
    {
        return isset($this->conversation_config);
    }

    public function clearConversationConfig()
    {
        unset($this->conversation_config);
    }

    /**
     * Configuration that applies to all conversations.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.IngestConversationsRequest.ConversationConfig conversation_config = 4;</code>
     * @param \Google\Cloud\ContactCenterInsights\V1\IngestConversationsRequest\ConversationConfig $var
     * @return $this
     */
    public function setConversationConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ContactCenterInsights\V1\IngestConversationsRequest\ConversationConfig::class);
        $this->conversation_config = $var;

        return $this;
    }

    /**
     * Optional. DLP settings for transcript redaction. Optional, will default to
     * the config specified in Settings.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.RedactionConfig redaction_config = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\ContactCenterInsights\V1\RedactionConfig|null
     */
    public function getRedactionConfig()
    {
        return $this->redaction_config;
    }

    public function hasRedactionConfig()
    {
        return isset($this->redaction_config);
    }

    public function clearRedactionConfig()
    {
        unset($this->redaction_config);
    }

    /**
     * Optional. DLP settings for transcript redaction. Optional, will default to
     * the config specified in Settings.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.RedactionConfig redaction_config = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\ContactCenterInsights\V1\RedactionConfig $var
     * @return $this
     */
    public function setRedactionConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ContactCenterInsights\V1\RedactionConfig::class);
        $this->redaction_config = $var;

        return $this;
    }

    /**
     * Optional. Default Speech-to-Text configuration. Optional, will default to
     * the config specified in Settings.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.SpeechConfig speech_config = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\ContactCenterInsights\V1\SpeechConfig|null
     */
    public function getSpeechConfig()
    {
        return $this->speech_config;
    }

    public function hasSpeechConfig()
    {
        return isset($this->speech_config);
    }

    public function clearSpeechConfig()
    {
        unset($this->speech_config);
    }

    /**
     * Optional. Default Speech-to-Text configuration. Optional, will default to
     * the config specified in Settings.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.SpeechConfig speech_config = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\ContactCenterInsights\V1\SpeechConfig $var
     * @return $this
     */
    public function setSpeechConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ContactCenterInsights\V1\SpeechConfig::class);
        $this->speech_config = $var;

        return $this;
    }

    /**
     * Optional. If set, this fields indicates the number of objects to ingest
     * from the Cloud Storage bucket. If empty, the entire bucket will be
     * ingested. Unless they are first deleted, conversations produced through
     * sampling won't be ingested by subsequent ingest requests.
     *
     * Generated from protobuf field <code>optional int32 sample_size = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getSampleSize()
    {
        return isset($this->sample_size) ? $this->sample_size : 0;
    }

    public function hasSampleSize()
    {
        return isset($this->sample_size);
    }

    public function clearSampleSize()
    {
        unset($this->sample_size);
    }

    /**
     * Optional. If set, this fields indicates the number of objects to ingest
     * from the Cloud Storage bucket. If empty, the entire bucket will be
     * ingested. Unless they are first deleted, conversations produced through
     * sampling won't be ingested by subsequent ingest requests.
     *
     * Generated from protobuf field <code>optional int32 sample_size = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setSampleSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->sample_size = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getSource()
    {
        return $this->whichOneof("source");
    }

    /**
     * @return string
     */
    public function getObjectConfig()
    {
        return $this->whichOneof("object_config");
    }

}

