<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/contactcenterinsights/v1/resources.proto

namespace Google\Cloud\ContactCenterInsights\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The issue resource.
 *
 * Generated from protobuf message <code>google.cloud.contactcenterinsights.v1.Issue</code>
 */
class Issue extends \Google\Protobuf\Internal\Message
{
    /**
     * Immutable. The resource name of the issue.
     * Format:
     * projects/{project}/locations/{location}/issueModels/{issue_model}/issues/{issue}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IMMUTABLE];</code>
     */
    protected $name = '';
    /**
     * The representative name for the issue.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     */
    protected $display_name = '';
    /**
     * Output only. The time at which this issue was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. The most recent time that this issue was updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Output only. Resource names of the sample representative utterances that
     * match to this issue.
     *
     * Generated from protobuf field <code>repeated string sample_utterances = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $sample_utterances;
    /**
     * Representative description of the issue.
     *
     * Generated from protobuf field <code>string display_description = 14;</code>
     */
    protected $display_description = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Immutable. The resource name of the issue.
     *           Format:
     *           projects/{project}/locations/{location}/issueModels/{issue_model}/issues/{issue}
     *     @type string $display_name
     *           The representative name for the issue.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. The time at which this issue was created.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. The most recent time that this issue was updated.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $sample_utterances
     *           Output only. Resource names of the sample representative utterances that
     *           match to this issue.
     *     @type string $display_description
     *           Representative description of the issue.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Contactcenterinsights\V1\Resources::initOnce();
        parent::__construct($data);
    }

    /**
     * Immutable. The resource name of the issue.
     * Format:
     * projects/{project}/locations/{location}/issueModels/{issue_model}/issues/{issue}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Immutable. The resource name of the issue.
     * Format:
     * projects/{project}/locations/{location}/issueModels/{issue_model}/issues/{issue}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The representative name for the issue.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * The representative name for the issue.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * Output only. The time at which this issue was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. The time at which this issue was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. The most recent time that this issue was updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. The most recent time that this issue was updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Output only. Resource names of the sample representative utterances that
     * match to this issue.
     *
     * Generated from protobuf field <code>repeated string sample_utterances = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSampleUtterances()
    {
        return $this->sample_utterances;
    }

    /**
     * Output only. Resource names of the sample representative utterances that
     * match to this issue.
     *
     * Generated from protobuf field <code>repeated string sample_utterances = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSampleUtterances($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->sample_utterances = $arr;

        return $this;
    }

    /**
     * Representative description of the issue.
     *
     * Generated from protobuf field <code>string display_description = 14;</code>
     * @return string
     */
    public function getDisplayDescription()
    {
        return $this->display_description;
    }

    /**
     * Representative description of the issue.
     *
     * Generated from protobuf field <code>string display_description = 14;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_description = $var;

        return $this;
    }

}

