<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/contactcenterinsights/v1/resources.proto

namespace Google\Cloud\ContactCenterInsights\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * DLP resources used for redaction while ingesting conversations.
 * DLP settings are applied to conversations ingested from the
 * `UploadConversation` and `IngestConversations` endpoints, including
 * conversation coming from CCAI Platform. They are not applied to conversations
 * ingested from the `CreateConversation` endpoint or the Dialogflow / Agent
 * Assist runtime integrations. When using Dialogflow / Agent Assist runtime
 * integrations, redaction should be performed in Dialogflow / Agent Assist.
 *
 * Generated from protobuf message <code>google.cloud.contactcenterinsights.v1.RedactionConfig</code>
 */
class RedactionConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * The fully-qualified DLP deidentify template resource name.
     * Format:
     * `projects/{project}/deidentifyTemplates/{template}`
     *
     * Generated from protobuf field <code>string deidentify_template = 1;</code>
     */
    protected $deidentify_template = '';
    /**
     * The fully-qualified DLP inspect template resource name.
     * Format:
     * `projects/{project}/locations/{location}/inspectTemplates/{template}`
     *
     * Generated from protobuf field <code>string inspect_template = 2;</code>
     */
    protected $inspect_template = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $deidentify_template
     *           The fully-qualified DLP deidentify template resource name.
     *           Format:
     *           `projects/{project}/deidentifyTemplates/{template}`
     *     @type string $inspect_template
     *           The fully-qualified DLP inspect template resource name.
     *           Format:
     *           `projects/{project}/locations/{location}/inspectTemplates/{template}`
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Contactcenterinsights\V1\Resources::initOnce();
        parent::__construct($data);
    }

    /**
     * The fully-qualified DLP deidentify template resource name.
     * Format:
     * `projects/{project}/deidentifyTemplates/{template}`
     *
     * Generated from protobuf field <code>string deidentify_template = 1;</code>
     * @return string
     */
    public function getDeidentifyTemplate()
    {
        return $this->deidentify_template;
    }

    /**
     * The fully-qualified DLP deidentify template resource name.
     * Format:
     * `projects/{project}/deidentifyTemplates/{template}`
     *
     * Generated from protobuf field <code>string deidentify_template = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setDeidentifyTemplate($var)
    {
        GPBUtil::checkString($var, True);
        $this->deidentify_template = $var;

        return $this;
    }

    /**
     * The fully-qualified DLP inspect template resource name.
     * Format:
     * `projects/{project}/locations/{location}/inspectTemplates/{template}`
     *
     * Generated from protobuf field <code>string inspect_template = 2;</code>
     * @return string
     */
    public function getInspectTemplate()
    {
        return $this->inspect_template;
    }

    /**
     * The fully-qualified DLP inspect template resource name.
     * Format:
     * `projects/{project}/locations/{location}/inspectTemplates/{template}`
     *
     * Generated from protobuf field <code>string inspect_template = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setInspectTemplate($var)
    {
        GPBUtil::checkString($var, True);
        $this->inspect_template = $var;

        return $this;
    }

}

