<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/contactcenterinsights/v1/contact_center_insights.proto

namespace Google\Cloud\ContactCenterInsights\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request to update a conversation.
 *
 * Generated from protobuf message <code>google.cloud.contactcenterinsights.v1.UpdateConversationRequest</code>
 */
class UpdateConversationRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The new values for the conversation.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.Conversation conversation = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $conversation = null;
    /**
     * The list of fields to be updated. All possible fields can be updated by
     * passing `*`, or a subset of the following updateable fields can be
     * provided:
     * * `agent_id`
     * * `language_code`
     * * `labels`
     * * `metadata`
     * * `quality_metadata`
     * * `call_metadata`
     * * `start_time`
     * * `expire_time` or `ttl`
     * * `data_source.gcs_source.audio_uri` or
     * `data_source.dialogflow_source.audio_uri`
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 2;</code>
     */
    protected $update_mask = null;

    /**
     * @param \Google\Cloud\ContactCenterInsights\V1\Conversation $conversation Required. The new values for the conversation.
     * @param \Google\Protobuf\FieldMask                          $updateMask   The list of fields to be updated. All possible fields can be updated by
     *                                                                          passing `*`, or a subset of the following updateable fields can be
     *                                                                          provided:
     *
     *                                                                          * `agent_id`
     *                                                                          * `language_code`
     *                                                                          * `labels`
     *                                                                          * `metadata`
     *                                                                          * `quality_metadata`
     *                                                                          * `call_metadata`
     *                                                                          * `start_time`
     *                                                                          * `expire_time` or `ttl`
     *                                                                          * `data_source.gcs_source.audio_uri` or
     *                                                                          `data_source.dialogflow_source.audio_uri`
     *
     * @return \Google\Cloud\ContactCenterInsights\V1\UpdateConversationRequest
     *
     * @experimental
     */
    public static function build(\Google\Cloud\ContactCenterInsights\V1\Conversation $conversation, \Google\Protobuf\FieldMask $updateMask): self
    {
        return (new self())
            ->setConversation($conversation)
            ->setUpdateMask($updateMask);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\ContactCenterInsights\V1\Conversation $conversation
     *           Required. The new values for the conversation.
     *     @type \Google\Protobuf\FieldMask $update_mask
     *           The list of fields to be updated. All possible fields can be updated by
     *           passing `*`, or a subset of the following updateable fields can be
     *           provided:
     *           * `agent_id`
     *           * `language_code`
     *           * `labels`
     *           * `metadata`
     *           * `quality_metadata`
     *           * `call_metadata`
     *           * `start_time`
     *           * `expire_time` or `ttl`
     *           * `data_source.gcs_source.audio_uri` or
     *           `data_source.dialogflow_source.audio_uri`
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Contactcenterinsights\V1\ContactCenterInsights::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The new values for the conversation.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.Conversation conversation = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\ContactCenterInsights\V1\Conversation|null
     */
    public function getConversation()
    {
        return $this->conversation;
    }

    public function hasConversation()
    {
        return isset($this->conversation);
    }

    public function clearConversation()
    {
        unset($this->conversation);
    }

    /**
     * Required. The new values for the conversation.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.Conversation conversation = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\ContactCenterInsights\V1\Conversation $var
     * @return $this
     */
    public function setConversation($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ContactCenterInsights\V1\Conversation::class);
        $this->conversation = $var;

        return $this;
    }

    /**
     * The list of fields to be updated. All possible fields can be updated by
     * passing `*`, or a subset of the following updateable fields can be
     * provided:
     * * `agent_id`
     * * `language_code`
     * * `labels`
     * * `metadata`
     * * `quality_metadata`
     * * `call_metadata`
     * * `start_time`
     * * `expire_time` or `ttl`
     * * `data_source.gcs_source.audio_uri` or
     * `data_source.dialogflow_source.audio_uri`
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 2;</code>
     * @return \Google\Protobuf\FieldMask|null
     */
    public function getUpdateMask()
    {
        return $this->update_mask;
    }

    public function hasUpdateMask()
    {
        return isset($this->update_mask);
    }

    public function clearUpdateMask()
    {
        unset($this->update_mask);
    }

    /**
     * The list of fields to be updated. All possible fields can be updated by
     * passing `*`, or a subset of the following updateable fields can be
     * provided:
     * * `agent_id`
     * * `language_code`
     * * `labels`
     * * `metadata`
     * * `quality_metadata`
     * * `call_metadata`
     * * `start_time`
     * * `expire_time` or `ttl`
     * * `data_source.gcs_source.audio_uri` or
     * `data_source.dialogflow_source.audio_uri`
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 2;</code>
     * @param \Google\Protobuf\FieldMask $var
     * @return $this
     */
    public function setUpdateMask($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\FieldMask::class);
        $this->update_mask = $var;

        return $this;
    }

}

