<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/contactcenterinsights/v1/contact_center_insights.proto

namespace Google\Cloud\ContactCenterInsights\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request to upload a conversation.
 *
 * Generated from protobuf message <code>google.cloud.contactcenterinsights.v1.UploadConversationRequest</code>
 */
class UploadConversationRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent resource of the conversation.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The conversation resource to create.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.Conversation conversation = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $conversation = null;
    /**
     * Optional. A unique ID for the new conversation. This ID will become the
     * final component of the conversation's resource name. If no ID is specified,
     * a server-generated ID will be used.
     * This value should be 4-64 characters and must match the regular
     * expression `^[a-z0-9-]{4,64}$`. Valid characters are `[a-z][0-9]-`
     *
     * Generated from protobuf field <code>string conversation_id = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $conversation_id = '';
    /**
     * Optional. DLP settings for transcript redaction. Will default to the config
     * specified in Settings.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.RedactionConfig redaction_config = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $redaction_config = null;
    /**
     * Optional. Speech-to-Text configuration. Will default to the config
     * specified in Settings.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.SpeechConfig speech_config = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $speech_config = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent resource of the conversation.
     *     @type \Google\Cloud\ContactCenterInsights\V1\Conversation $conversation
     *           Required. The conversation resource to create.
     *     @type string $conversation_id
     *           Optional. A unique ID for the new conversation. This ID will become the
     *           final component of the conversation's resource name. If no ID is specified,
     *           a server-generated ID will be used.
     *           This value should be 4-64 characters and must match the regular
     *           expression `^[a-z0-9-]{4,64}$`. Valid characters are `[a-z][0-9]-`
     *     @type \Google\Cloud\ContactCenterInsights\V1\RedactionConfig $redaction_config
     *           Optional. DLP settings for transcript redaction. Will default to the config
     *           specified in Settings.
     *     @type \Google\Cloud\ContactCenterInsights\V1\SpeechConfig $speech_config
     *           Optional. Speech-to-Text configuration. Will default to the config
     *           specified in Settings.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Contactcenterinsights\V1\ContactCenterInsights::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent resource of the conversation.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent resource of the conversation.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The conversation resource to create.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.Conversation conversation = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\ContactCenterInsights\V1\Conversation|null
     */
    public function getConversation()
    {
        return $this->conversation;
    }

    public function hasConversation()
    {
        return isset($this->conversation);
    }

    public function clearConversation()
    {
        unset($this->conversation);
    }

    /**
     * Required. The conversation resource to create.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.Conversation conversation = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\ContactCenterInsights\V1\Conversation $var
     * @return $this
     */
    public function setConversation($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ContactCenterInsights\V1\Conversation::class);
        $this->conversation = $var;

        return $this;
    }

    /**
     * Optional. A unique ID for the new conversation. This ID will become the
     * final component of the conversation's resource name. If no ID is specified,
     * a server-generated ID will be used.
     * This value should be 4-64 characters and must match the regular
     * expression `^[a-z0-9-]{4,64}$`. Valid characters are `[a-z][0-9]-`
     *
     * Generated from protobuf field <code>string conversation_id = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getConversationId()
    {
        return $this->conversation_id;
    }

    /**
     * Optional. A unique ID for the new conversation. This ID will become the
     * final component of the conversation's resource name. If no ID is specified,
     * a server-generated ID will be used.
     * This value should be 4-64 characters and must match the regular
     * expression `^[a-z0-9-]{4,64}$`. Valid characters are `[a-z][0-9]-`
     *
     * Generated from protobuf field <code>string conversation_id = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setConversationId($var)
    {
        GPBUtil::checkString($var, True);
        $this->conversation_id = $var;

        return $this;
    }

    /**
     * Optional. DLP settings for transcript redaction. Will default to the config
     * specified in Settings.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.RedactionConfig redaction_config = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\ContactCenterInsights\V1\RedactionConfig|null
     */
    public function getRedactionConfig()
    {
        return $this->redaction_config;
    }

    public function hasRedactionConfig()
    {
        return isset($this->redaction_config);
    }

    public function clearRedactionConfig()
    {
        unset($this->redaction_config);
    }

    /**
     * Optional. DLP settings for transcript redaction. Will default to the config
     * specified in Settings.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.RedactionConfig redaction_config = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\ContactCenterInsights\V1\RedactionConfig $var
     * @return $this
     */
    public function setRedactionConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ContactCenterInsights\V1\RedactionConfig::class);
        $this->redaction_config = $var;

        return $this;
    }

    /**
     * Optional. Speech-to-Text configuration. Will default to the config
     * specified in Settings.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.SpeechConfig speech_config = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\ContactCenterInsights\V1\SpeechConfig|null
     */
    public function getSpeechConfig()
    {
        return $this->speech_config;
    }

    public function hasSpeechConfig()
    {
        return isset($this->speech_config);
    }

    public function clearSpeechConfig()
    {
        unset($this->speech_config);
    }

    /**
     * Optional. Speech-to-Text configuration. Will default to the config
     * specified in Settings.
     *
     * Generated from protobuf field <code>.google.cloud.contactcenterinsights.v1.SpeechConfig speech_config = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\ContactCenterInsights\V1\SpeechConfig $var
     * @return $this
     */
    public function setSpeechConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ContactCenterInsights\V1\SpeechConfig::class);
        $this->speech_config = $var;

        return $this;
    }

}

