<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/container/v1/cluster_service.proto

namespace Google\Cloud\Container\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Configuration options for private clusters.
 *
 * Generated from protobuf message <code>google.container.v1.PrivateClusterConfig</code>
 */
class PrivateClusterConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * Whether nodes have internal IP addresses only. If enabled, all nodes are
     * given only RFC 1918 private addresses and communicate with the master via
     * private networking.
     * Deprecated: Use
     * [NetworkConfig.default_enable_private_nodes][google.container.v1.NetworkConfig.default_enable_private_nodes]
     * instead.
     *
     * Generated from protobuf field <code>bool enable_private_nodes = 1 [deprecated = true];</code>
     * @deprecated
     */
    protected $enable_private_nodes = false;
    /**
     * Whether the master's internal IP address is used as the cluster endpoint.
     * Deprecated: Use
     * [ControlPlaneEndpointsConfig.IPEndpointsConfig.enable_public_endpoint][google.container.v1.ControlPlaneEndpointsConfig.IPEndpointsConfig.enable_public_endpoint]
     * instead. Note that the value of enable_public_endpoint is reversed: if
     * enable_private_endpoint is false, then enable_public_endpoint will be true.
     *
     * Generated from protobuf field <code>bool enable_private_endpoint = 2 [deprecated = true];</code>
     * @deprecated
     */
    protected $enable_private_endpoint = false;
    /**
     * The IP range in CIDR notation to use for the hosted master network. This
     * range will be used for assigning internal IP addresses to the master or
     * set of masters, as well as the ILB VIP. This range must not overlap with
     * any other ranges in use within the cluster's network.
     *
     * Generated from protobuf field <code>string master_ipv4_cidr_block = 3;</code>
     */
    protected $master_ipv4_cidr_block = '';
    /**
     * Output only. The internal IP address of this cluster's master endpoint.
     * Deprecated: Use
     * [ControlPlaneEndpointsConfig.IPEndpointsConfig.private_endpoint][google.container.v1.ControlPlaneEndpointsConfig.IPEndpointsConfig.private_endpoint]
     * instead.
     *
     * Generated from protobuf field <code>string private_endpoint = 4 [deprecated = true, (.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @deprecated
     */
    protected $private_endpoint = '';
    /**
     * Output only. The external IP address of this cluster's master endpoint.
     * Deprecated:Use
     * [ControlPlaneEndpointsConfig.IPEndpointsConfig.public_endpoint][google.container.v1.ControlPlaneEndpointsConfig.IPEndpointsConfig.public_endpoint]
     * instead.
     *
     * Generated from protobuf field <code>string public_endpoint = 5 [deprecated = true, (.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @deprecated
     */
    protected $public_endpoint = '';
    /**
     * Output only. The peering name in the customer VPC used by this cluster.
     *
     * Generated from protobuf field <code>string peering_name = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $peering_name = '';
    /**
     * Controls master global access settings.
     * Deprecated: Use
     * [ControlPlaneEndpointsConfig.IPEndpointsConfig.enable_global_access][]
     * instead.
     *
     * Generated from protobuf field <code>.google.container.v1.PrivateClusterMasterGlobalAccessConfig master_global_access_config = 8 [deprecated = true];</code>
     * @deprecated
     */
    protected $master_global_access_config = null;
    /**
     * Subnet to provision the master's private endpoint during cluster creation.
     * Specified in projects/&#42;&#47;regions/&#42;&#47;subnetworks/&#42; format.
     * Deprecated: Use
     * [ControlPlaneEndpointsConfig.IPEndpointsConfig.private_endpoint_subnetwork][google.container.v1.ControlPlaneEndpointsConfig.IPEndpointsConfig.private_endpoint_subnetwork]
     * instead.
     *
     * Generated from protobuf field <code>string private_endpoint_subnetwork = 10 [deprecated = true];</code>
     * @deprecated
     */
    protected $private_endpoint_subnetwork = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type bool $enable_private_nodes
     *           Whether nodes have internal IP addresses only. If enabled, all nodes are
     *           given only RFC 1918 private addresses and communicate with the master via
     *           private networking.
     *           Deprecated: Use
     *           [NetworkConfig.default_enable_private_nodes][google.container.v1.NetworkConfig.default_enable_private_nodes]
     *           instead.
     *     @type bool $enable_private_endpoint
     *           Whether the master's internal IP address is used as the cluster endpoint.
     *           Deprecated: Use
     *           [ControlPlaneEndpointsConfig.IPEndpointsConfig.enable_public_endpoint][google.container.v1.ControlPlaneEndpointsConfig.IPEndpointsConfig.enable_public_endpoint]
     *           instead. Note that the value of enable_public_endpoint is reversed: if
     *           enable_private_endpoint is false, then enable_public_endpoint will be true.
     *     @type string $master_ipv4_cidr_block
     *           The IP range in CIDR notation to use for the hosted master network. This
     *           range will be used for assigning internal IP addresses to the master or
     *           set of masters, as well as the ILB VIP. This range must not overlap with
     *           any other ranges in use within the cluster's network.
     *     @type string $private_endpoint
     *           Output only. The internal IP address of this cluster's master endpoint.
     *           Deprecated: Use
     *           [ControlPlaneEndpointsConfig.IPEndpointsConfig.private_endpoint][google.container.v1.ControlPlaneEndpointsConfig.IPEndpointsConfig.private_endpoint]
     *           instead.
     *     @type string $public_endpoint
     *           Output only. The external IP address of this cluster's master endpoint.
     *           Deprecated:Use
     *           [ControlPlaneEndpointsConfig.IPEndpointsConfig.public_endpoint][google.container.v1.ControlPlaneEndpointsConfig.IPEndpointsConfig.public_endpoint]
     *           instead.
     *     @type string $peering_name
     *           Output only. The peering name in the customer VPC used by this cluster.
     *     @type \Google\Cloud\Container\V1\PrivateClusterMasterGlobalAccessConfig $master_global_access_config
     *           Controls master global access settings.
     *           Deprecated: Use
     *           [ControlPlaneEndpointsConfig.IPEndpointsConfig.enable_global_access][]
     *           instead.
     *     @type string $private_endpoint_subnetwork
     *           Subnet to provision the master's private endpoint during cluster creation.
     *           Specified in projects/&#42;&#47;regions/&#42;&#47;subnetworks/&#42; format.
     *           Deprecated: Use
     *           [ControlPlaneEndpointsConfig.IPEndpointsConfig.private_endpoint_subnetwork][google.container.v1.ControlPlaneEndpointsConfig.IPEndpointsConfig.private_endpoint_subnetwork]
     *           instead.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Container\V1\ClusterService::initOnce();
        parent::__construct($data);
    }

    /**
     * Whether nodes have internal IP addresses only. If enabled, all nodes are
     * given only RFC 1918 private addresses and communicate with the master via
     * private networking.
     * Deprecated: Use
     * [NetworkConfig.default_enable_private_nodes][google.container.v1.NetworkConfig.default_enable_private_nodes]
     * instead.
     *
     * Generated from protobuf field <code>bool enable_private_nodes = 1 [deprecated = true];</code>
     * @return bool
     * @deprecated
     */
    public function getEnablePrivateNodes()
    {
        @trigger_error('enable_private_nodes is deprecated.', E_USER_DEPRECATED);
        return $this->enable_private_nodes;
    }

    /**
     * Whether nodes have internal IP addresses only. If enabled, all nodes are
     * given only RFC 1918 private addresses and communicate with the master via
     * private networking.
     * Deprecated: Use
     * [NetworkConfig.default_enable_private_nodes][google.container.v1.NetworkConfig.default_enable_private_nodes]
     * instead.
     *
     * Generated from protobuf field <code>bool enable_private_nodes = 1 [deprecated = true];</code>
     * @param bool $var
     * @return $this
     * @deprecated
     */
    public function setEnablePrivateNodes($var)
    {
        @trigger_error('enable_private_nodes is deprecated.', E_USER_DEPRECATED);
        GPBUtil::checkBool($var);
        $this->enable_private_nodes = $var;

        return $this;
    }

    /**
     * Whether the master's internal IP address is used as the cluster endpoint.
     * Deprecated: Use
     * [ControlPlaneEndpointsConfig.IPEndpointsConfig.enable_public_endpoint][google.container.v1.ControlPlaneEndpointsConfig.IPEndpointsConfig.enable_public_endpoint]
     * instead. Note that the value of enable_public_endpoint is reversed: if
     * enable_private_endpoint is false, then enable_public_endpoint will be true.
     *
     * Generated from protobuf field <code>bool enable_private_endpoint = 2 [deprecated = true];</code>
     * @return bool
     * @deprecated
     */
    public function getEnablePrivateEndpoint()
    {
        @trigger_error('enable_private_endpoint is deprecated.', E_USER_DEPRECATED);
        return $this->enable_private_endpoint;
    }

    /**
     * Whether the master's internal IP address is used as the cluster endpoint.
     * Deprecated: Use
     * [ControlPlaneEndpointsConfig.IPEndpointsConfig.enable_public_endpoint][google.container.v1.ControlPlaneEndpointsConfig.IPEndpointsConfig.enable_public_endpoint]
     * instead. Note that the value of enable_public_endpoint is reversed: if
     * enable_private_endpoint is false, then enable_public_endpoint will be true.
     *
     * Generated from protobuf field <code>bool enable_private_endpoint = 2 [deprecated = true];</code>
     * @param bool $var
     * @return $this
     * @deprecated
     */
    public function setEnablePrivateEndpoint($var)
    {
        @trigger_error('enable_private_endpoint is deprecated.', E_USER_DEPRECATED);
        GPBUtil::checkBool($var);
        $this->enable_private_endpoint = $var;

        return $this;
    }

    /**
     * The IP range in CIDR notation to use for the hosted master network. This
     * range will be used for assigning internal IP addresses to the master or
     * set of masters, as well as the ILB VIP. This range must not overlap with
     * any other ranges in use within the cluster's network.
     *
     * Generated from protobuf field <code>string master_ipv4_cidr_block = 3;</code>
     * @return string
     */
    public function getMasterIpv4CidrBlock()
    {
        return $this->master_ipv4_cidr_block;
    }

    /**
     * The IP range in CIDR notation to use for the hosted master network. This
     * range will be used for assigning internal IP addresses to the master or
     * set of masters, as well as the ILB VIP. This range must not overlap with
     * any other ranges in use within the cluster's network.
     *
     * Generated from protobuf field <code>string master_ipv4_cidr_block = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setMasterIpv4CidrBlock($var)
    {
        GPBUtil::checkString($var, True);
        $this->master_ipv4_cidr_block = $var;

        return $this;
    }

    /**
     * Output only. The internal IP address of this cluster's master endpoint.
     * Deprecated: Use
     * [ControlPlaneEndpointsConfig.IPEndpointsConfig.private_endpoint][google.container.v1.ControlPlaneEndpointsConfig.IPEndpointsConfig.private_endpoint]
     * instead.
     *
     * Generated from protobuf field <code>string private_endpoint = 4 [deprecated = true, (.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     * @deprecated
     */
    public function getPrivateEndpoint()
    {
        @trigger_error('private_endpoint is deprecated.', E_USER_DEPRECATED);
        return $this->private_endpoint;
    }

    /**
     * Output only. The internal IP address of this cluster's master endpoint.
     * Deprecated: Use
     * [ControlPlaneEndpointsConfig.IPEndpointsConfig.private_endpoint][google.container.v1.ControlPlaneEndpointsConfig.IPEndpointsConfig.private_endpoint]
     * instead.
     *
     * Generated from protobuf field <code>string private_endpoint = 4 [deprecated = true, (.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     * @deprecated
     */
    public function setPrivateEndpoint($var)
    {
        @trigger_error('private_endpoint is deprecated.', E_USER_DEPRECATED);
        GPBUtil::checkString($var, True);
        $this->private_endpoint = $var;

        return $this;
    }

    /**
     * Output only. The external IP address of this cluster's master endpoint.
     * Deprecated:Use
     * [ControlPlaneEndpointsConfig.IPEndpointsConfig.public_endpoint][google.container.v1.ControlPlaneEndpointsConfig.IPEndpointsConfig.public_endpoint]
     * instead.
     *
     * Generated from protobuf field <code>string public_endpoint = 5 [deprecated = true, (.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     * @deprecated
     */
    public function getPublicEndpoint()
    {
        @trigger_error('public_endpoint is deprecated.', E_USER_DEPRECATED);
        return $this->public_endpoint;
    }

    /**
     * Output only. The external IP address of this cluster's master endpoint.
     * Deprecated:Use
     * [ControlPlaneEndpointsConfig.IPEndpointsConfig.public_endpoint][google.container.v1.ControlPlaneEndpointsConfig.IPEndpointsConfig.public_endpoint]
     * instead.
     *
     * Generated from protobuf field <code>string public_endpoint = 5 [deprecated = true, (.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     * @deprecated
     */
    public function setPublicEndpoint($var)
    {
        @trigger_error('public_endpoint is deprecated.', E_USER_DEPRECATED);
        GPBUtil::checkString($var, True);
        $this->public_endpoint = $var;

        return $this;
    }

    /**
     * Output only. The peering name in the customer VPC used by this cluster.
     *
     * Generated from protobuf field <code>string peering_name = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getPeeringName()
    {
        return $this->peering_name;
    }

    /**
     * Output only. The peering name in the customer VPC used by this cluster.
     *
     * Generated from protobuf field <code>string peering_name = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setPeeringName($var)
    {
        GPBUtil::checkString($var, True);
        $this->peering_name = $var;

        return $this;
    }

    /**
     * Controls master global access settings.
     * Deprecated: Use
     * [ControlPlaneEndpointsConfig.IPEndpointsConfig.enable_global_access][]
     * instead.
     *
     * Generated from protobuf field <code>.google.container.v1.PrivateClusterMasterGlobalAccessConfig master_global_access_config = 8 [deprecated = true];</code>
     * @return \Google\Cloud\Container\V1\PrivateClusterMasterGlobalAccessConfig|null
     * @deprecated
     */
    public function getMasterGlobalAccessConfig()
    {
        @trigger_error('master_global_access_config is deprecated.', E_USER_DEPRECATED);
        return $this->master_global_access_config;
    }

    public function hasMasterGlobalAccessConfig()
    {
        @trigger_error('master_global_access_config is deprecated.', E_USER_DEPRECATED);
        return isset($this->master_global_access_config);
    }

    public function clearMasterGlobalAccessConfig()
    {
        @trigger_error('master_global_access_config is deprecated.', E_USER_DEPRECATED);
        unset($this->master_global_access_config);
    }

    /**
     * Controls master global access settings.
     * Deprecated: Use
     * [ControlPlaneEndpointsConfig.IPEndpointsConfig.enable_global_access][]
     * instead.
     *
     * Generated from protobuf field <code>.google.container.v1.PrivateClusterMasterGlobalAccessConfig master_global_access_config = 8 [deprecated = true];</code>
     * @param \Google\Cloud\Container\V1\PrivateClusterMasterGlobalAccessConfig $var
     * @return $this
     * @deprecated
     */
    public function setMasterGlobalAccessConfig($var)
    {
        @trigger_error('master_global_access_config is deprecated.', E_USER_DEPRECATED);
        GPBUtil::checkMessage($var, \Google\Cloud\Container\V1\PrivateClusterMasterGlobalAccessConfig::class);
        $this->master_global_access_config = $var;

        return $this;
    }

    /**
     * Subnet to provision the master's private endpoint during cluster creation.
     * Specified in projects/&#42;&#47;regions/&#42;&#47;subnetworks/&#42; format.
     * Deprecated: Use
     * [ControlPlaneEndpointsConfig.IPEndpointsConfig.private_endpoint_subnetwork][google.container.v1.ControlPlaneEndpointsConfig.IPEndpointsConfig.private_endpoint_subnetwork]
     * instead.
     *
     * Generated from protobuf field <code>string private_endpoint_subnetwork = 10 [deprecated = true];</code>
     * @return string
     * @deprecated
     */
    public function getPrivateEndpointSubnetwork()
    {
        @trigger_error('private_endpoint_subnetwork is deprecated.', E_USER_DEPRECATED);
        return $this->private_endpoint_subnetwork;
    }

    /**
     * Subnet to provision the master's private endpoint during cluster creation.
     * Specified in projects/&#42;&#47;regions/&#42;&#47;subnetworks/&#42; format.
     * Deprecated: Use
     * [ControlPlaneEndpointsConfig.IPEndpointsConfig.private_endpoint_subnetwork][google.container.v1.ControlPlaneEndpointsConfig.IPEndpointsConfig.private_endpoint_subnetwork]
     * instead.
     *
     * Generated from protobuf field <code>string private_endpoint_subnetwork = 10 [deprecated = true];</code>
     * @param string $var
     * @return $this
     * @deprecated
     */
    public function setPrivateEndpointSubnetwork($var)
    {
        @trigger_error('private_endpoint_subnetwork is deprecated.', E_USER_DEPRECATED);
        GPBUtil::checkString($var, True);
        $this->private_endpoint_subnetwork = $var;

        return $this;
    }

}

