<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/cloudcontrolspartner/v1beta/violations.proto

namespace Google\Cloud\CloudControlsPartner\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message for requesting list of Violations
 *
 * Generated from protobuf message <code>google.cloud.cloudcontrolspartner.v1beta.ListViolationsRequest</code>
 */
class ListViolationsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Parent resource
     * Format
     * `organizations/{organization}/locations/{location}/customers/{customer}/workloads/{workload}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. The maximum number of customers row to return. The service may
     * return fewer than this value. If unspecified, at most 10 customers will be
     * returned.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. A page token, received from a previous `ListViolations` call.
     * Provide this to retrieve the subsequent page.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';
    /**
     * Optional. Filtering results
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $filter = '';
    /**
     * Optional. Hint for how to order the results
     *
     * Generated from protobuf field <code>string order_by = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $order_by = '';
    /**
     * Optional. Specifies the interval for retrieving violations.
     * if unspecified, all violations will be returned.
     *
     * Generated from protobuf field <code>.google.type.Interval interval = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $interval = null;

    /**
     * @param string $parent Required. Parent resource
     *                       Format
     *                       `organizations/{organization}/locations/{location}/customers/{customer}/workloads/{workload}`
     *                       Please see {@see CloudControlsPartnerMonitoringClient::workloadName()} for help formatting this field.
     *
     * @return \Google\Cloud\CloudControlsPartner\V1beta\ListViolationsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Parent resource
     *           Format
     *           `organizations/{organization}/locations/{location}/customers/{customer}/workloads/{workload}`
     *     @type int $page_size
     *           Optional. The maximum number of customers row to return. The service may
     *           return fewer than this value. If unspecified, at most 10 customers will be
     *           returned.
     *     @type string $page_token
     *           Optional. A page token, received from a previous `ListViolations` call.
     *           Provide this to retrieve the subsequent page.
     *     @type string $filter
     *           Optional. Filtering results
     *     @type string $order_by
     *           Optional. Hint for how to order the results
     *     @type \Google\Type\Interval $interval
     *           Optional. Specifies the interval for retrieving violations.
     *           if unspecified, all violations will be returned.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Cloudcontrolspartner\V1Beta\Violations::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Parent resource
     * Format
     * `organizations/{organization}/locations/{location}/customers/{customer}/workloads/{workload}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Parent resource
     * Format
     * `organizations/{organization}/locations/{location}/customers/{customer}/workloads/{workload}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. The maximum number of customers row to return. The service may
     * return fewer than this value. If unspecified, at most 10 customers will be
     * returned.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. The maximum number of customers row to return. The service may
     * return fewer than this value. If unspecified, at most 10 customers will be
     * returned.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. A page token, received from a previous `ListViolations` call.
     * Provide this to retrieve the subsequent page.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. A page token, received from a previous `ListViolations` call.
     * Provide this to retrieve the subsequent page.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. Filtering results
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Optional. Filtering results
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * Optional. Hint for how to order the results
     *
     * Generated from protobuf field <code>string order_by = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getOrderBy()
    {
        return $this->order_by;
    }

    /**
     * Optional. Hint for how to order the results
     *
     * Generated from protobuf field <code>string order_by = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setOrderBy($var)
    {
        GPBUtil::checkString($var, True);
        $this->order_by = $var;

        return $this;
    }

    /**
     * Optional. Specifies the interval for retrieving violations.
     * if unspecified, all violations will be returned.
     *
     * Generated from protobuf field <code>.google.type.Interval interval = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Type\Interval|null
     */
    public function getInterval()
    {
        return $this->interval;
    }

    public function hasInterval()
    {
        return isset($this->interval);
    }

    public function clearInterval()
    {
        unset($this->interval);
    }

    /**
     * Optional. Specifies the interval for retrieving violations.
     * if unspecified, all violations will be returned.
     *
     * Generated from protobuf field <code>.google.type.Interval interval = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Type\Interval $var
     * @return $this
     */
    public function setInterval($var)
    {
        GPBUtil::checkMessage($var, \Google\Type\Interval::class);
        $this->interval = $var;

        return $this;
    }

}

