<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/cloudcontrolspartner/v1beta/partners.proto

namespace Google\Cloud\CloudControlsPartner\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message describing Partner resource
 *
 * Generated from protobuf message <code>google.cloud.cloudcontrolspartner.v1beta.Partner</code>
 */
class Partner extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. The resource name of the partner.
     * Format: `organizations/{organization}/locations/{location}/partner`
     * Example: "organizations/123456/locations/us-central1/partner"
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * List of SKUs the partner is offering
     *
     * Generated from protobuf field <code>repeated .google.cloud.cloudcontrolspartner.v1beta.Sku skus = 3;</code>
     */
    private $skus;
    /**
     * List of Google Cloud supported EKM partners supported by the partner
     *
     * Generated from protobuf field <code>repeated .google.cloud.cloudcontrolspartner.v1beta.EkmMetadata ekm_solutions = 4;</code>
     */
    private $ekm_solutions;
    /**
     * List of Google Cloud regions that the partner sells services to customers.
     * Valid Google Cloud regions found here:
     * https://cloud.google.com/compute/docs/regions-zones
     *
     * Generated from protobuf field <code>repeated string operated_cloud_regions = 5;</code>
     */
    private $operated_cloud_regions;
    /**
     * Google Cloud project ID in the partner's Google Cloud organization for
     * receiving enhanced Logs for Partners.
     *
     * Generated from protobuf field <code>string partner_project_id = 7;</code>
     */
    protected $partner_project_id = '';
    /**
     * Output only. Time the resource was created
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. The last time the resource was updated
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. The resource name of the partner.
     *           Format: `organizations/{organization}/locations/{location}/partner`
     *           Example: "organizations/123456/locations/us-central1/partner"
     *     @type array<\Google\Cloud\CloudControlsPartner\V1beta\Sku>|\Google\Protobuf\Internal\RepeatedField $skus
     *           List of SKUs the partner is offering
     *     @type array<\Google\Cloud\CloudControlsPartner\V1beta\EkmMetadata>|\Google\Protobuf\Internal\RepeatedField $ekm_solutions
     *           List of Google Cloud supported EKM partners supported by the partner
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $operated_cloud_regions
     *           List of Google Cloud regions that the partner sells services to customers.
     *           Valid Google Cloud regions found here:
     *           https://cloud.google.com/compute/docs/regions-zones
     *     @type string $partner_project_id
     *           Google Cloud project ID in the partner's Google Cloud organization for
     *           receiving enhanced Logs for Partners.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. Time the resource was created
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. The last time the resource was updated
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Cloudcontrolspartner\V1Beta\Partners::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. The resource name of the partner.
     * Format: `organizations/{organization}/locations/{location}/partner`
     * Example: "organizations/123456/locations/us-central1/partner"
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. The resource name of the partner.
     * Format: `organizations/{organization}/locations/{location}/partner`
     * Example: "organizations/123456/locations/us-central1/partner"
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * List of SKUs the partner is offering
     *
     * Generated from protobuf field <code>repeated .google.cloud.cloudcontrolspartner.v1beta.Sku skus = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSkus()
    {
        return $this->skus;
    }

    /**
     * List of SKUs the partner is offering
     *
     * Generated from protobuf field <code>repeated .google.cloud.cloudcontrolspartner.v1beta.Sku skus = 3;</code>
     * @param array<\Google\Cloud\CloudControlsPartner\V1beta\Sku>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSkus($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\CloudControlsPartner\V1beta\Sku::class);
        $this->skus = $arr;

        return $this;
    }

    /**
     * List of Google Cloud supported EKM partners supported by the partner
     *
     * Generated from protobuf field <code>repeated .google.cloud.cloudcontrolspartner.v1beta.EkmMetadata ekm_solutions = 4;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getEkmSolutions()
    {
        return $this->ekm_solutions;
    }

    /**
     * List of Google Cloud supported EKM partners supported by the partner
     *
     * Generated from protobuf field <code>repeated .google.cloud.cloudcontrolspartner.v1beta.EkmMetadata ekm_solutions = 4;</code>
     * @param array<\Google\Cloud\CloudControlsPartner\V1beta\EkmMetadata>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setEkmSolutions($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\CloudControlsPartner\V1beta\EkmMetadata::class);
        $this->ekm_solutions = $arr;

        return $this;
    }

    /**
     * List of Google Cloud regions that the partner sells services to customers.
     * Valid Google Cloud regions found here:
     * https://cloud.google.com/compute/docs/regions-zones
     *
     * Generated from protobuf field <code>repeated string operated_cloud_regions = 5;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getOperatedCloudRegions()
    {
        return $this->operated_cloud_regions;
    }

    /**
     * List of Google Cloud regions that the partner sells services to customers.
     * Valid Google Cloud regions found here:
     * https://cloud.google.com/compute/docs/regions-zones
     *
     * Generated from protobuf field <code>repeated string operated_cloud_regions = 5;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setOperatedCloudRegions($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->operated_cloud_regions = $arr;

        return $this;
    }

    /**
     * Google Cloud project ID in the partner's Google Cloud organization for
     * receiving enhanced Logs for Partners.
     *
     * Generated from protobuf field <code>string partner_project_id = 7;</code>
     * @return string
     */
    public function getPartnerProjectId()
    {
        return $this->partner_project_id;
    }

    /**
     * Google Cloud project ID in the partner's Google Cloud organization for
     * receiving enhanced Logs for Partners.
     *
     * Generated from protobuf field <code>string partner_project_id = 7;</code>
     * @param string $var
     * @return $this
     */
    public function setPartnerProjectId($var)
    {
        GPBUtil::checkString($var, True);
        $this->partner_project_id = $var;

        return $this;
    }

    /**
     * Output only. Time the resource was created
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. Time the resource was created
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. The last time the resource was updated
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. The last time the resource was updated
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

}

