<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/cloudcontrolspartner/v1beta/violations.proto

namespace Google\Cloud\CloudControlsPartner\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Details of resource Violation
 *
 * Generated from protobuf message <code>google.cloud.cloudcontrolspartner.v1beta.Violation</code>
 */
class Violation extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. Format:
     * `organizations/{organization}/locations/{location}/customers/{customer}/workloads/{workload}/violations/{violation}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Output only. Description for the Violation.
     * e.g. OrgPolicy gcp.resourceLocations has non compliant value.
     *
     * Generated from protobuf field <code>string description = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $description = '';
    /**
     * Output only. Time of the event which triggered the Violation.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp begin_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $begin_time = null;
    /**
     * Output only. The last time when the Violation record was updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Output only. Time of the event which fixed the Violation.
     * If the violation is ACTIVE this will be empty.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp resolve_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $resolve_time = null;
    /**
     * Output only. Category under which this violation is mapped.
     * e.g. Location, Service Usage, Access, Encryption, etc.
     *
     * Generated from protobuf field <code>string category = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $category = '';
    /**
     * Output only. State of the violation
     *
     * Generated from protobuf field <code>.google.cloud.cloudcontrolspartner.v1beta.Violation.State state = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;
    /**
     * Output only. Immutable. Name of the OrgPolicy which was modified with
     * non-compliant change and resulted this violation. Format:
     *  `projects/{project_number}/policies/{constraint_name}`
     *  `folders/{folder_id}/policies/{constraint_name}`
     *  `organizations/{organization_id}/policies/{constraint_name}`
     *
     * Generated from protobuf field <code>string non_compliant_org_policy = 8 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     */
    protected $non_compliant_org_policy = '';
    /**
     * The folder_id of the violation
     *
     * Generated from protobuf field <code>int64 folder_id = 9;</code>
     */
    protected $folder_id = 0;
    /**
     * Output only. Compliance violation remediation
     *
     * Generated from protobuf field <code>.google.cloud.cloudcontrolspartner.v1beta.Violation.Remediation remediation = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $remediation = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. Format:
     *           `organizations/{organization}/locations/{location}/customers/{customer}/workloads/{workload}/violations/{violation}`
     *     @type string $description
     *           Output only. Description for the Violation.
     *           e.g. OrgPolicy gcp.resourceLocations has non compliant value.
     *     @type \Google\Protobuf\Timestamp $begin_time
     *           Output only. Time of the event which triggered the Violation.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. The last time when the Violation record was updated.
     *     @type \Google\Protobuf\Timestamp $resolve_time
     *           Output only. Time of the event which fixed the Violation.
     *           If the violation is ACTIVE this will be empty.
     *     @type string $category
     *           Output only. Category under which this violation is mapped.
     *           e.g. Location, Service Usage, Access, Encryption, etc.
     *     @type int $state
     *           Output only. State of the violation
     *     @type string $non_compliant_org_policy
     *           Output only. Immutable. Name of the OrgPolicy which was modified with
     *           non-compliant change and resulted this violation. Format:
     *            `projects/{project_number}/policies/{constraint_name}`
     *            `folders/{folder_id}/policies/{constraint_name}`
     *            `organizations/{organization_id}/policies/{constraint_name}`
     *     @type int|string $folder_id
     *           The folder_id of the violation
     *     @type \Google\Cloud\CloudControlsPartner\V1beta\Violation\Remediation $remediation
     *           Output only. Compliance violation remediation
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Cloudcontrolspartner\V1Beta\Violations::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. Format:
     * `organizations/{organization}/locations/{location}/customers/{customer}/workloads/{workload}/violations/{violation}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. Format:
     * `organizations/{organization}/locations/{location}/customers/{customer}/workloads/{workload}/violations/{violation}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. Description for the Violation.
     * e.g. OrgPolicy gcp.resourceLocations has non compliant value.
     *
     * Generated from protobuf field <code>string description = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Output only. Description for the Violation.
     * e.g. OrgPolicy gcp.resourceLocations has non compliant value.
     *
     * Generated from protobuf field <code>string description = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Output only. Time of the event which triggered the Violation.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp begin_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getBeginTime()
    {
        return $this->begin_time;
    }

    public function hasBeginTime()
    {
        return isset($this->begin_time);
    }

    public function clearBeginTime()
    {
        unset($this->begin_time);
    }

    /**
     * Output only. Time of the event which triggered the Violation.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp begin_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setBeginTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->begin_time = $var;

        return $this;
    }

    /**
     * Output only. The last time when the Violation record was updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. The last time when the Violation record was updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Output only. Time of the event which fixed the Violation.
     * If the violation is ACTIVE this will be empty.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp resolve_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getResolveTime()
    {
        return $this->resolve_time;
    }

    public function hasResolveTime()
    {
        return isset($this->resolve_time);
    }

    public function clearResolveTime()
    {
        unset($this->resolve_time);
    }

    /**
     * Output only. Time of the event which fixed the Violation.
     * If the violation is ACTIVE this will be empty.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp resolve_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setResolveTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->resolve_time = $var;

        return $this;
    }

    /**
     * Output only. Category under which this violation is mapped.
     * e.g. Location, Service Usage, Access, Encryption, etc.
     *
     * Generated from protobuf field <code>string category = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getCategory()
    {
        return $this->category;
    }

    /**
     * Output only. Category under which this violation is mapped.
     * e.g. Location, Service Usage, Access, Encryption, etc.
     *
     * Generated from protobuf field <code>string category = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setCategory($var)
    {
        GPBUtil::checkString($var, True);
        $this->category = $var;

        return $this;
    }

    /**
     * Output only. State of the violation
     *
     * Generated from protobuf field <code>.google.cloud.cloudcontrolspartner.v1beta.Violation.State state = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. State of the violation
     *
     * Generated from protobuf field <code>.google.cloud.cloudcontrolspartner.v1beta.Violation.State state = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\CloudControlsPartner\V1beta\Violation\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Output only. Immutable. Name of the OrgPolicy which was modified with
     * non-compliant change and resulted this violation. Format:
     *  `projects/{project_number}/policies/{constraint_name}`
     *  `folders/{folder_id}/policies/{constraint_name}`
     *  `organizations/{organization_id}/policies/{constraint_name}`
     *
     * Generated from protobuf field <code>string non_compliant_org_policy = 8 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @return string
     */
    public function getNonCompliantOrgPolicy()
    {
        return $this->non_compliant_org_policy;
    }

    /**
     * Output only. Immutable. Name of the OrgPolicy which was modified with
     * non-compliant change and resulted this violation. Format:
     *  `projects/{project_number}/policies/{constraint_name}`
     *  `folders/{folder_id}/policies/{constraint_name}`
     *  `organizations/{organization_id}/policies/{constraint_name}`
     *
     * Generated from protobuf field <code>string non_compliant_org_policy = 8 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @param string $var
     * @return $this
     */
    public function setNonCompliantOrgPolicy($var)
    {
        GPBUtil::checkString($var, True);
        $this->non_compliant_org_policy = $var;

        return $this;
    }

    /**
     * The folder_id of the violation
     *
     * Generated from protobuf field <code>int64 folder_id = 9;</code>
     * @return int|string
     */
    public function getFolderId()
    {
        return $this->folder_id;
    }

    /**
     * The folder_id of the violation
     *
     * Generated from protobuf field <code>int64 folder_id = 9;</code>
     * @param int|string $var
     * @return $this
     */
    public function setFolderId($var)
    {
        GPBUtil::checkInt64($var);
        $this->folder_id = $var;

        return $this;
    }

    /**
     * Output only. Compliance violation remediation
     *
     * Generated from protobuf field <code>.google.cloud.cloudcontrolspartner.v1beta.Violation.Remediation remediation = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\CloudControlsPartner\V1beta\Violation\Remediation|null
     */
    public function getRemediation()
    {
        return $this->remediation;
    }

    public function hasRemediation()
    {
        return isset($this->remediation);
    }

    public function clearRemediation()
    {
        unset($this->remediation);
    }

    /**
     * Output only. Compliance violation remediation
     *
     * Generated from protobuf field <code>.google.cloud.cloudcontrolspartner.v1beta.Violation.Remediation remediation = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\CloudControlsPartner\V1beta\Violation\Remediation $var
     * @return $this
     */
    public function setRemediation($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\CloudControlsPartner\V1beta\Violation\Remediation::class);
        $this->remediation = $var;

        return $this;
    }

}

