<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/cloudcontrolspartner/v1beta/customer_workloads.proto

namespace Google\Cloud\CloudControlsPartner\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Contains metadata around the [Workload
 * resource](https://cloud.google.com/assured-workloads/docs/reference/rest/Shared.Types/Workload)
 * in the Assured Workloads API.
 *
 * Generated from protobuf message <code>google.cloud.cloudcontrolspartner.v1beta.Workload</code>
 */
class Workload extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. Format:
     * `organizations/{organization}/locations/{location}/customers/{customer}/workloads/{workload}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Output only. Folder id this workload is associated with
     *
     * Generated from protobuf field <code>int64 folder_id = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $folder_id = 0;
    /**
     * Output only. Time the resource was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. The name of container folder of the assured workload
     *
     * Generated from protobuf field <code>string folder = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $folder = '';
    /**
     * Container for workload onboarding steps.
     *
     * Generated from protobuf field <code>.google.cloud.cloudcontrolspartner.v1beta.WorkloadOnboardingState workload_onboarding_state = 5;</code>
     */
    protected $workload_onboarding_state = null;
    /**
     * Indicates whether a workload is fully onboarded.
     *
     * Generated from protobuf field <code>bool is_onboarded = 6;</code>
     */
    protected $is_onboarded = false;
    /**
     * The project id of the key management project for the workload
     *
     * Generated from protobuf field <code>string key_management_project_id = 7;</code>
     */
    protected $key_management_project_id = '';
    /**
     * The Google Cloud location of the workload
     *
     * Generated from protobuf field <code>string location = 8;</code>
     */
    protected $location = '';
    /**
     * Partner associated with this workload.
     *
     * Generated from protobuf field <code>.google.cloud.cloudcontrolspartner.v1beta.Workload.Partner partner = 9;</code>
     */
    protected $partner = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. Format:
     *           `organizations/{organization}/locations/{location}/customers/{customer}/workloads/{workload}`
     *     @type int|string $folder_id
     *           Output only. Folder id this workload is associated with
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. Time the resource was created.
     *     @type string $folder
     *           Output only. The name of container folder of the assured workload
     *     @type \Google\Cloud\CloudControlsPartner\V1beta\WorkloadOnboardingState $workload_onboarding_state
     *           Container for workload onboarding steps.
     *     @type bool $is_onboarded
     *           Indicates whether a workload is fully onboarded.
     *     @type string $key_management_project_id
     *           The project id of the key management project for the workload
     *     @type string $location
     *           The Google Cloud location of the workload
     *     @type int $partner
     *           Partner associated with this workload.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Cloudcontrolspartner\V1Beta\CustomerWorkloads::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. Format:
     * `organizations/{organization}/locations/{location}/customers/{customer}/workloads/{workload}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. Format:
     * `organizations/{organization}/locations/{location}/customers/{customer}/workloads/{workload}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. Folder id this workload is associated with
     *
     * Generated from protobuf field <code>int64 folder_id = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int|string
     */
    public function getFolderId()
    {
        return $this->folder_id;
    }

    /**
     * Output only. Folder id this workload is associated with
     *
     * Generated from protobuf field <code>int64 folder_id = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int|string $var
     * @return $this
     */
    public function setFolderId($var)
    {
        GPBUtil::checkInt64($var);
        $this->folder_id = $var;

        return $this;
    }

    /**
     * Output only. Time the resource was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. Time the resource was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. The name of container folder of the assured workload
     *
     * Generated from protobuf field <code>string folder = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getFolder()
    {
        return $this->folder;
    }

    /**
     * Output only. The name of container folder of the assured workload
     *
     * Generated from protobuf field <code>string folder = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setFolder($var)
    {
        GPBUtil::checkString($var, True);
        $this->folder = $var;

        return $this;
    }

    /**
     * Container for workload onboarding steps.
     *
     * Generated from protobuf field <code>.google.cloud.cloudcontrolspartner.v1beta.WorkloadOnboardingState workload_onboarding_state = 5;</code>
     * @return \Google\Cloud\CloudControlsPartner\V1beta\WorkloadOnboardingState|null
     */
    public function getWorkloadOnboardingState()
    {
        return $this->workload_onboarding_state;
    }

    public function hasWorkloadOnboardingState()
    {
        return isset($this->workload_onboarding_state);
    }

    public function clearWorkloadOnboardingState()
    {
        unset($this->workload_onboarding_state);
    }

    /**
     * Container for workload onboarding steps.
     *
     * Generated from protobuf field <code>.google.cloud.cloudcontrolspartner.v1beta.WorkloadOnboardingState workload_onboarding_state = 5;</code>
     * @param \Google\Cloud\CloudControlsPartner\V1beta\WorkloadOnboardingState $var
     * @return $this
     */
    public function setWorkloadOnboardingState($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\CloudControlsPartner\V1beta\WorkloadOnboardingState::class);
        $this->workload_onboarding_state = $var;

        return $this;
    }

    /**
     * Indicates whether a workload is fully onboarded.
     *
     * Generated from protobuf field <code>bool is_onboarded = 6;</code>
     * @return bool
     */
    public function getIsOnboarded()
    {
        return $this->is_onboarded;
    }

    /**
     * Indicates whether a workload is fully onboarded.
     *
     * Generated from protobuf field <code>bool is_onboarded = 6;</code>
     * @param bool $var
     * @return $this
     */
    public function setIsOnboarded($var)
    {
        GPBUtil::checkBool($var);
        $this->is_onboarded = $var;

        return $this;
    }

    /**
     * The project id of the key management project for the workload
     *
     * Generated from protobuf field <code>string key_management_project_id = 7;</code>
     * @return string
     */
    public function getKeyManagementProjectId()
    {
        return $this->key_management_project_id;
    }

    /**
     * The project id of the key management project for the workload
     *
     * Generated from protobuf field <code>string key_management_project_id = 7;</code>
     * @param string $var
     * @return $this
     */
    public function setKeyManagementProjectId($var)
    {
        GPBUtil::checkString($var, True);
        $this->key_management_project_id = $var;

        return $this;
    }

    /**
     * The Google Cloud location of the workload
     *
     * Generated from protobuf field <code>string location = 8;</code>
     * @return string
     */
    public function getLocation()
    {
        return $this->location;
    }

    /**
     * The Google Cloud location of the workload
     *
     * Generated from protobuf field <code>string location = 8;</code>
     * @param string $var
     * @return $this
     */
    public function setLocation($var)
    {
        GPBUtil::checkString($var, True);
        $this->location = $var;

        return $this;
    }

    /**
     * Partner associated with this workload.
     *
     * Generated from protobuf field <code>.google.cloud.cloudcontrolspartner.v1beta.Workload.Partner partner = 9;</code>
     * @return int
     */
    public function getPartner()
    {
        return $this->partner;
    }

    /**
     * Partner associated with this workload.
     *
     * Generated from protobuf field <code>.google.cloud.cloudcontrolspartner.v1beta.Workload.Partner partner = 9;</code>
     * @param int $var
     * @return $this
     */
    public function setPartner($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\CloudControlsPartner\V1beta\Workload\Partner::class);
        $this->partner = $var;

        return $this;
    }

}

