<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/datacatalog/v1/datacatalog.proto

namespace Google\Cloud\DataCatalog\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [CreateEntry][google.cloud.datacatalog.v1.DataCatalog.CreateEntry].
 *
 * Generated from protobuf message <code>google.cloud.datacatalog.v1.CreateEntryRequest</code>
 */
class CreateEntryRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the entry group this entry belongs to.
     * Note: The entry itself and its child resources might not be stored in
     * the location specified in its name.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The ID of the entry to create.
     * The ID must contain only letters (a-z, A-Z), numbers (0-9),
     * and underscores (_).
     * The maximum size is 64 bytes when encoded in UTF-8.
     *
     * Generated from protobuf field <code>string entry_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $entry_id = '';
    /**
     * Required. The entry to create.
     *
     * Generated from protobuf field <code>.google.cloud.datacatalog.v1.Entry entry = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $entry = null;

    /**
     * @param string                             $parent  Required. The name of the entry group this entry belongs to.
     *
     *                                                    Note: The entry itself and its child resources might not be stored in
     *                                                    the location specified in its name. Please see
     *                                                    {@see DataCatalogClient::entryGroupName()} for help formatting this field.
     * @param string                             $entryId Required. The ID of the entry to create.
     *
     *                                                    The ID must contain only letters (a-z, A-Z), numbers (0-9),
     *                                                    and underscores (_).
     *                                                    The maximum size is 64 bytes when encoded in UTF-8.
     * @param \Google\Cloud\DataCatalog\V1\Entry $entry   Required. The entry to create.
     *
     * @return \Google\Cloud\DataCatalog\V1\CreateEntryRequest
     *
     * @experimental
     */
    public static function build(string $parent, string $entryId, \Google\Cloud\DataCatalog\V1\Entry $entry): self
    {
        return (new self())
            ->setParent($parent)
            ->setEntryId($entryId)
            ->setEntry($entry);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The name of the entry group this entry belongs to.
     *           Note: The entry itself and its child resources might not be stored in
     *           the location specified in its name.
     *     @type string $entry_id
     *           Required. The ID of the entry to create.
     *           The ID must contain only letters (a-z, A-Z), numbers (0-9),
     *           and underscores (_).
     *           The maximum size is 64 bytes when encoded in UTF-8.
     *     @type \Google\Cloud\DataCatalog\V1\Entry $entry
     *           Required. The entry to create.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Datacatalog\V1\Datacatalog::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the entry group this entry belongs to.
     * Note: The entry itself and its child resources might not be stored in
     * the location specified in its name.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The name of the entry group this entry belongs to.
     * Note: The entry itself and its child resources might not be stored in
     * the location specified in its name.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The ID of the entry to create.
     * The ID must contain only letters (a-z, A-Z), numbers (0-9),
     * and underscores (_).
     * The maximum size is 64 bytes when encoded in UTF-8.
     *
     * Generated from protobuf field <code>string entry_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getEntryId()
    {
        return $this->entry_id;
    }

    /**
     * Required. The ID of the entry to create.
     * The ID must contain only letters (a-z, A-Z), numbers (0-9),
     * and underscores (_).
     * The maximum size is 64 bytes when encoded in UTF-8.
     *
     * Generated from protobuf field <code>string entry_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setEntryId($var)
    {
        GPBUtil::checkString($var, True);
        $this->entry_id = $var;

        return $this;
    }

    /**
     * Required. The entry to create.
     *
     * Generated from protobuf field <code>.google.cloud.datacatalog.v1.Entry entry = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\DataCatalog\V1\Entry|null
     */
    public function getEntry()
    {
        return $this->entry;
    }

    public function hasEntry()
    {
        return isset($this->entry);
    }

    public function clearEntry()
    {
        unset($this->entry);
    }

    /**
     * Required. The entry to create.
     *
     * Generated from protobuf field <code>.google.cloud.datacatalog.v1.Entry entry = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\DataCatalog\V1\Entry $var
     * @return $this
     */
    public function setEntry($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DataCatalog\V1\Entry::class);
        $this->entry = $var;

        return $this;
    }

}

