<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/datacatalog/v1/datacatalog.proto

namespace Google\Cloud\DataCatalog\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Specification for vertex model resources.
 *
 * Generated from protobuf message <code>google.cloud.datacatalog.v1.VertexModelSpec</code>
 */
class VertexModelSpec extends \Google\Protobuf\Internal\Message
{
    /**
     * The version ID of the model.
     *
     * Generated from protobuf field <code>string version_id = 1;</code>
     */
    protected $version_id = '';
    /**
     * User provided version aliases so that a model version can be referenced via
     * alias
     *
     * Generated from protobuf field <code>repeated string version_aliases = 2;</code>
     */
    private $version_aliases;
    /**
     * The description of this version.
     *
     * Generated from protobuf field <code>string version_description = 3;</code>
     */
    protected $version_description = '';
    /**
     * Source of a Vertex model.
     *
     * Generated from protobuf field <code>.google.cloud.datacatalog.v1.VertexModelSourceInfo vertex_model_source_info = 4;</code>
     */
    protected $vertex_model_source_info = null;
    /**
     * URI of the Docker image to be used as the custom container for serving
     * predictions.
     *
     * Generated from protobuf field <code>string container_image_uri = 5;</code>
     */
    protected $container_image_uri = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $version_id
     *           The version ID of the model.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $version_aliases
     *           User provided version aliases so that a model version can be referenced via
     *           alias
     *     @type string $version_description
     *           The description of this version.
     *     @type \Google\Cloud\DataCatalog\V1\VertexModelSourceInfo $vertex_model_source_info
     *           Source of a Vertex model.
     *     @type string $container_image_uri
     *           URI of the Docker image to be used as the custom container for serving
     *           predictions.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Datacatalog\V1\Datacatalog::initOnce();
        parent::__construct($data);
    }

    /**
     * The version ID of the model.
     *
     * Generated from protobuf field <code>string version_id = 1;</code>
     * @return string
     */
    public function getVersionId()
    {
        return $this->version_id;
    }

    /**
     * The version ID of the model.
     *
     * Generated from protobuf field <code>string version_id = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setVersionId($var)
    {
        GPBUtil::checkString($var, True);
        $this->version_id = $var;

        return $this;
    }

    /**
     * User provided version aliases so that a model version can be referenced via
     * alias
     *
     * Generated from protobuf field <code>repeated string version_aliases = 2;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getVersionAliases()
    {
        return $this->version_aliases;
    }

    /**
     * User provided version aliases so that a model version can be referenced via
     * alias
     *
     * Generated from protobuf field <code>repeated string version_aliases = 2;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setVersionAliases($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->version_aliases = $arr;

        return $this;
    }

    /**
     * The description of this version.
     *
     * Generated from protobuf field <code>string version_description = 3;</code>
     * @return string
     */
    public function getVersionDescription()
    {
        return $this->version_description;
    }

    /**
     * The description of this version.
     *
     * Generated from protobuf field <code>string version_description = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setVersionDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->version_description = $var;

        return $this;
    }

    /**
     * Source of a Vertex model.
     *
     * Generated from protobuf field <code>.google.cloud.datacatalog.v1.VertexModelSourceInfo vertex_model_source_info = 4;</code>
     * @return \Google\Cloud\DataCatalog\V1\VertexModelSourceInfo|null
     */
    public function getVertexModelSourceInfo()
    {
        return $this->vertex_model_source_info;
    }

    public function hasVertexModelSourceInfo()
    {
        return isset($this->vertex_model_source_info);
    }

    public function clearVertexModelSourceInfo()
    {
        unset($this->vertex_model_source_info);
    }

    /**
     * Source of a Vertex model.
     *
     * Generated from protobuf field <code>.google.cloud.datacatalog.v1.VertexModelSourceInfo vertex_model_source_info = 4;</code>
     * @param \Google\Cloud\DataCatalog\V1\VertexModelSourceInfo $var
     * @return $this
     */
    public function setVertexModelSourceInfo($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DataCatalog\V1\VertexModelSourceInfo::class);
        $this->vertex_model_source_info = $var;

        return $this;
    }

    /**
     * URI of the Docker image to be used as the custom container for serving
     * predictions.
     *
     * Generated from protobuf field <code>string container_image_uri = 5;</code>
     * @return string
     */
    public function getContainerImageUri()
    {
        return $this->container_image_uri;
    }

    /**
     * URI of the Docker image to be used as the custom container for serving
     * predictions.
     *
     * Generated from protobuf field <code>string container_image_uri = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setContainerImageUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->container_image_uri = $var;

        return $this;
    }

}

