<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/datacatalog/lineage/v1/lineage.proto

namespace Google\Cloud\DataCatalog\Lineage\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [BatchSearchLinkProcesses][google.cloud.datacatalog.lineage.v1.Lineage.BatchSearchLinkProcesses].
 *
 * Generated from protobuf message <code>google.cloud.datacatalog.lineage.v1.BatchSearchLinkProcessesRequest</code>
 */
class BatchSearchLinkProcessesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The project and location where you want to search.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. An array of links to check for their associated LineageProcesses.
     * The maximum number of items in this array is 100.
     * If the request contains more than 100 links, it returns the
     * `INVALID_ARGUMENT` error.
     * Format: `projects/{project}/locations/{location}/links/{link}`.
     *
     * Generated from protobuf field <code>repeated string links = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $links;
    /**
     * The maximum number of processes to return in a single page of the response.
     * A page may contain fewer results than this value.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     */
    protected $page_size = 0;
    /**
     * The page token received from a previous `BatchSearchLinkProcesses` call.
     * Use it to get the next page.
     * When requesting subsequent pages of a response, remember that
     * all parameters must match the values you provided
     * in the original request.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     */
    protected $page_token = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The project and location where you want to search.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $links
     *           Required. An array of links to check for their associated LineageProcesses.
     *           The maximum number of items in this array is 100.
     *           If the request contains more than 100 links, it returns the
     *           `INVALID_ARGUMENT` error.
     *           Format: `projects/{project}/locations/{location}/links/{link}`.
     *     @type int $page_size
     *           The maximum number of processes to return in a single page of the response.
     *           A page may contain fewer results than this value.
     *     @type string $page_token
     *           The page token received from a previous `BatchSearchLinkProcesses` call.
     *           Use it to get the next page.
     *           When requesting subsequent pages of a response, remember that
     *           all parameters must match the values you provided
     *           in the original request.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Datacatalog\Lineage\V1\Lineage::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The project and location where you want to search.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The project and location where you want to search.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. An array of links to check for their associated LineageProcesses.
     * The maximum number of items in this array is 100.
     * If the request contains more than 100 links, it returns the
     * `INVALID_ARGUMENT` error.
     * Format: `projects/{project}/locations/{location}/links/{link}`.
     *
     * Generated from protobuf field <code>repeated string links = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getLinks()
    {
        return $this->links;
    }

    /**
     * Required. An array of links to check for their associated LineageProcesses.
     * The maximum number of items in this array is 100.
     * If the request contains more than 100 links, it returns the
     * `INVALID_ARGUMENT` error.
     * Format: `projects/{project}/locations/{location}/links/{link}`.
     *
     * Generated from protobuf field <code>repeated string links = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setLinks($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->links = $arr;

        return $this;
    }

    /**
     * The maximum number of processes to return in a single page of the response.
     * A page may contain fewer results than this value.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The maximum number of processes to return in a single page of the response.
     * A page may contain fewer results than this value.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * The page token received from a previous `BatchSearchLinkProcesses` call.
     * Use it to get the next page.
     * When requesting subsequent pages of a response, remember that
     * all parameters must match the values you provided
     * in the original request.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * The page token received from a previous `BatchSearchLinkProcesses` call.
     * Use it to get the next page.
     * When requesting subsequent pages of a response, remember that
     * all parameters must match the values you provided
     * in the original request.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

