<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/datacatalog/lineage/v1/lineage.proto

namespace Google\Cloud\DataCatalog\Lineage\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [ProcessOpenLineageRunEvent][google.cloud.datacatalog.lineage.v1.ProcessOpenLineageRunEvent].
 *
 * Generated from protobuf message <code>google.cloud.datacatalog.lineage.v1.ProcessOpenLineageRunEventRequest</code>
 */
class ProcessOpenLineageRunEventRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the project and its location that should own the
     * process, run, and lineage event.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $parent = '';
    /**
     * Required. OpenLineage message following OpenLineage format:
     * https://github.com/OpenLineage/OpenLineage/blob/main/spec/OpenLineage.json
     *
     * Generated from protobuf field <code>.google.protobuf.Struct open_lineage = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $open_lineage = null;
    /**
     * A unique identifier for this request. Restricted to 36 ASCII characters.
     * A random UUID is recommended. This request is idempotent only if a
     * `request_id` is provided.
     *
     * Generated from protobuf field <code>string request_id = 3;</code>
     */
    protected $request_id = '';

    /**
     * @param string                  $parent      Required. The name of the project and its location that should own the
     *                                             process, run, and lineage event.
     * @param \Google\Protobuf\Struct $openLineage Required. OpenLineage message following OpenLineage format:
     *                                             https://github.com/OpenLineage/OpenLineage/blob/main/spec/OpenLineage.json
     *
     * @return \Google\Cloud\DataCatalog\Lineage\V1\ProcessOpenLineageRunEventRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Protobuf\Struct $openLineage): self
    {
        return (new self())
            ->setParent($parent)
            ->setOpenLineage($openLineage);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The name of the project and its location that should own the
     *           process, run, and lineage event.
     *     @type \Google\Protobuf\Struct $open_lineage
     *           Required. OpenLineage message following OpenLineage format:
     *           https://github.com/OpenLineage/OpenLineage/blob/main/spec/OpenLineage.json
     *     @type string $request_id
     *           A unique identifier for this request. Restricted to 36 ASCII characters.
     *           A random UUID is recommended. This request is idempotent only if a
     *           `request_id` is provided.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Datacatalog\Lineage\V1\Lineage::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the project and its location that should own the
     * process, run, and lineage event.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The name of the project and its location that should own the
     * process, run, and lineage event.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. OpenLineage message following OpenLineage format:
     * https://github.com/OpenLineage/OpenLineage/blob/main/spec/OpenLineage.json
     *
     * Generated from protobuf field <code>.google.protobuf.Struct open_lineage = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Struct|null
     */
    public function getOpenLineage()
    {
        return $this->open_lineage;
    }

    public function hasOpenLineage()
    {
        return isset($this->open_lineage);
    }

    public function clearOpenLineage()
    {
        unset($this->open_lineage);
    }

    /**
     * Required. OpenLineage message following OpenLineage format:
     * https://github.com/OpenLineage/OpenLineage/blob/main/spec/OpenLineage.json
     *
     * Generated from protobuf field <code>.google.protobuf.Struct open_lineage = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Protobuf\Struct $var
     * @return $this
     */
    public function setOpenLineage($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Struct::class);
        $this->open_lineage = $var;

        return $this;
    }

    /**
     * A unique identifier for this request. Restricted to 36 ASCII characters.
     * A random UUID is recommended. This request is idempotent only if a
     * `request_id` is provided.
     *
     * Generated from protobuf field <code>string request_id = 3;</code>
     * @return string
     */
    public function getRequestId()
    {
        return $this->request_id;
    }

    /**
     * A unique identifier for this request. Restricted to 36 ASCII characters.
     * A random UUID is recommended. This request is idempotent only if a
     * `request_id` is provided.
     *
     * Generated from protobuf field <code>string request_id = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setRequestId($var)
    {
        GPBUtil::checkString($var, True);
        $this->request_id = $var;

        return $this;
    }

}

