<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dataform/v1beta1/dataform.proto

namespace Google\Cloud\Dataform\V1beta1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents a Dataform workflow configuration.
 *
 * Generated from protobuf message <code>google.cloud.dataform.v1beta1.WorkflowConfig</code>
 */
class WorkflowConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The workflow config's name.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $name = '';
    /**
     * Required. The name of the release config whose release_compilation_result
     * should be executed. Must be in the format
     * `projects/&#42;&#47;locations/&#42;&#47;repositories/&#42;&#47;releaseConfigs/&#42;`.
     *
     * Generated from protobuf field <code>string release_config = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $release_config = '';
    /**
     * Optional. If left unset, a default InvocationConfig will be used.
     *
     * Generated from protobuf field <code>.google.cloud.dataform.v1beta1.InvocationConfig invocation_config = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $invocation_config = null;
    /**
     * Optional. Optional schedule (in cron format) for automatic execution of
     * this workflow config.
     *
     * Generated from protobuf field <code>string cron_schedule = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $cron_schedule = '';
    /**
     * Optional. Specifies the time zone to be used when interpreting
     * cron_schedule. Must be a time zone name from the time zone database
     * (https://en.wikipedia.org/wiki/List_of_tz_database_time_zones). If left
     * unspecified, the default is UTC.
     *
     * Generated from protobuf field <code>string time_zone = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $time_zone = '';
    /**
     * Output only. Records of the 10 most recent scheduled execution attempts,
     * ordered in in descending order of `execution_time`. Updated whenever
     * automatic creation of a workflow invocation is triggered by cron_schedule.
     *
     * Generated from protobuf field <code>repeated .google.cloud.dataform.v1beta1.WorkflowConfig.ScheduledExecutionRecord recent_scheduled_execution_records = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $recent_scheduled_execution_records;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. The workflow config's name.
     *     @type string $release_config
     *           Required. The name of the release config whose release_compilation_result
     *           should be executed. Must be in the format
     *           `projects/&#42;&#47;locations/&#42;&#47;repositories/&#42;&#47;releaseConfigs/&#42;`.
     *     @type \Google\Cloud\Dataform\V1beta1\InvocationConfig $invocation_config
     *           Optional. If left unset, a default InvocationConfig will be used.
     *     @type string $cron_schedule
     *           Optional. Optional schedule (in cron format) for automatic execution of
     *           this workflow config.
     *     @type string $time_zone
     *           Optional. Specifies the time zone to be used when interpreting
     *           cron_schedule. Must be a time zone name from the time zone database
     *           (https://en.wikipedia.org/wiki/List_of_tz_database_time_zones). If left
     *           unspecified, the default is UTC.
     *     @type array<\Google\Cloud\Dataform\V1beta1\WorkflowConfig\ScheduledExecutionRecord>|\Google\Protobuf\Internal\RepeatedField $recent_scheduled_execution_records
     *           Output only. Records of the 10 most recent scheduled execution attempts,
     *           ordered in in descending order of `execution_time`. Updated whenever
     *           automatic creation of a workflow invocation is triggered by cron_schedule.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dataform\V1Beta1\Dataform::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The workflow config's name.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. The workflow config's name.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Required. The name of the release config whose release_compilation_result
     * should be executed. Must be in the format
     * `projects/&#42;&#47;locations/&#42;&#47;repositories/&#42;&#47;releaseConfigs/&#42;`.
     *
     * Generated from protobuf field <code>string release_config = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getReleaseConfig()
    {
        return $this->release_config;
    }

    /**
     * Required. The name of the release config whose release_compilation_result
     * should be executed. Must be in the format
     * `projects/&#42;&#47;locations/&#42;&#47;repositories/&#42;&#47;releaseConfigs/&#42;`.
     *
     * Generated from protobuf field <code>string release_config = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setReleaseConfig($var)
    {
        GPBUtil::checkString($var, True);
        $this->release_config = $var;

        return $this;
    }

    /**
     * Optional. If left unset, a default InvocationConfig will be used.
     *
     * Generated from protobuf field <code>.google.cloud.dataform.v1beta1.InvocationConfig invocation_config = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\Dataform\V1beta1\InvocationConfig|null
     */
    public function getInvocationConfig()
    {
        return $this->invocation_config;
    }

    public function hasInvocationConfig()
    {
        return isset($this->invocation_config);
    }

    public function clearInvocationConfig()
    {
        unset($this->invocation_config);
    }

    /**
     * Optional. If left unset, a default InvocationConfig will be used.
     *
     * Generated from protobuf field <code>.google.cloud.dataform.v1beta1.InvocationConfig invocation_config = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\Dataform\V1beta1\InvocationConfig $var
     * @return $this
     */
    public function setInvocationConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dataform\V1beta1\InvocationConfig::class);
        $this->invocation_config = $var;

        return $this;
    }

    /**
     * Optional. Optional schedule (in cron format) for automatic execution of
     * this workflow config.
     *
     * Generated from protobuf field <code>string cron_schedule = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getCronSchedule()
    {
        return $this->cron_schedule;
    }

    /**
     * Optional. Optional schedule (in cron format) for automatic execution of
     * this workflow config.
     *
     * Generated from protobuf field <code>string cron_schedule = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setCronSchedule($var)
    {
        GPBUtil::checkString($var, True);
        $this->cron_schedule = $var;

        return $this;
    }

    /**
     * Optional. Specifies the time zone to be used when interpreting
     * cron_schedule. Must be a time zone name from the time zone database
     * (https://en.wikipedia.org/wiki/List_of_tz_database_time_zones). If left
     * unspecified, the default is UTC.
     *
     * Generated from protobuf field <code>string time_zone = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getTimeZone()
    {
        return $this->time_zone;
    }

    /**
     * Optional. Specifies the time zone to be used when interpreting
     * cron_schedule. Must be a time zone name from the time zone database
     * (https://en.wikipedia.org/wiki/List_of_tz_database_time_zones). If left
     * unspecified, the default is UTC.
     *
     * Generated from protobuf field <code>string time_zone = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setTimeZone($var)
    {
        GPBUtil::checkString($var, True);
        $this->time_zone = $var;

        return $this;
    }

    /**
     * Output only. Records of the 10 most recent scheduled execution attempts,
     * ordered in in descending order of `execution_time`. Updated whenever
     * automatic creation of a workflow invocation is triggered by cron_schedule.
     *
     * Generated from protobuf field <code>repeated .google.cloud.dataform.v1beta1.WorkflowConfig.ScheduledExecutionRecord recent_scheduled_execution_records = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getRecentScheduledExecutionRecords()
    {
        return $this->recent_scheduled_execution_records;
    }

    /**
     * Output only. Records of the 10 most recent scheduled execution attempts,
     * ordered in in descending order of `execution_time`. Updated whenever
     * automatic creation of a workflow invocation is triggered by cron_schedule.
     *
     * Generated from protobuf field <code>repeated .google.cloud.dataform.v1beta1.WorkflowConfig.ScheduledExecutionRecord recent_scheduled_execution_records = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param array<\Google\Cloud\Dataform\V1beta1\WorkflowConfig\ScheduledExecutionRecord>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setRecentScheduledExecutionRecords($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Dataform\V1beta1\WorkflowConfig\ScheduledExecutionRecord::class);
        $this->recent_scheduled_execution_records = $arr;

        return $this;
    }

}

