<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dataplex/v1/data_taxonomy.proto

namespace Google\Cloud\Dataplex\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Create DataAttributeBinding request.
 *
 * Generated from protobuf message <code>google.cloud.dataplex.v1.CreateDataAttributeBindingRequest</code>
 */
class CreateDataAttributeBindingRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the parent data taxonomy
     * projects/{project_number}/locations/{location_id}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. DataAttributeBinding identifier.
     * * Must contain only lowercase letters, numbers and hyphens.
     * * Must start with a letter.
     * * Must be between 1-63 characters.
     * * Must end with a number or a letter.
     * * Must be unique within the Location.
     *
     * Generated from protobuf field <code>string data_attribute_binding_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $data_attribute_binding_id = '';
    /**
     * Required. DataAttributeBinding resource.
     *
     * Generated from protobuf field <code>.google.cloud.dataplex.v1.DataAttributeBinding data_attribute_binding = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $data_attribute_binding = null;
    /**
     * Optional. Only validate the request, but do not perform mutations.
     * The default is false.
     *
     * Generated from protobuf field <code>bool validate_only = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $validate_only = false;

    /**
     * @param string                                         $parent                 Required. The resource name of the parent data taxonomy
     *                                                                               projects/{project_number}/locations/{location_id}
     *                                                                               Please see {@see DataTaxonomyServiceClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\Dataplex\V1\DataAttributeBinding $dataAttributeBinding   Required. DataAttributeBinding resource.
     * @param string                                         $dataAttributeBindingId Required. DataAttributeBinding identifier.
     *                                                                               * Must contain only lowercase letters, numbers and hyphens.
     *                                                                               * Must start with a letter.
     *                                                                               * Must be between 1-63 characters.
     *                                                                               * Must end with a number or a letter.
     *                                                                               * Must be unique within the Location.
     *
     * @return \Google\Cloud\Dataplex\V1\CreateDataAttributeBindingRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\Dataplex\V1\DataAttributeBinding $dataAttributeBinding, string $dataAttributeBindingId): self
    {
        return (new self())
            ->setParent($parent)
            ->setDataAttributeBinding($dataAttributeBinding)
            ->setDataAttributeBindingId($dataAttributeBindingId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The resource name of the parent data taxonomy
     *           projects/{project_number}/locations/{location_id}
     *     @type string $data_attribute_binding_id
     *           Required. DataAttributeBinding identifier.
     *           * Must contain only lowercase letters, numbers and hyphens.
     *           * Must start with a letter.
     *           * Must be between 1-63 characters.
     *           * Must end with a number or a letter.
     *           * Must be unique within the Location.
     *     @type \Google\Cloud\Dataplex\V1\DataAttributeBinding $data_attribute_binding
     *           Required. DataAttributeBinding resource.
     *     @type bool $validate_only
     *           Optional. Only validate the request, but do not perform mutations.
     *           The default is false.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dataplex\V1\DataTaxonomy::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the parent data taxonomy
     * projects/{project_number}/locations/{location_id}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The resource name of the parent data taxonomy
     * projects/{project_number}/locations/{location_id}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. DataAttributeBinding identifier.
     * * Must contain only lowercase letters, numbers and hyphens.
     * * Must start with a letter.
     * * Must be between 1-63 characters.
     * * Must end with a number or a letter.
     * * Must be unique within the Location.
     *
     * Generated from protobuf field <code>string data_attribute_binding_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getDataAttributeBindingId()
    {
        return $this->data_attribute_binding_id;
    }

    /**
     * Required. DataAttributeBinding identifier.
     * * Must contain only lowercase letters, numbers and hyphens.
     * * Must start with a letter.
     * * Must be between 1-63 characters.
     * * Must end with a number or a letter.
     * * Must be unique within the Location.
     *
     * Generated from protobuf field <code>string data_attribute_binding_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setDataAttributeBindingId($var)
    {
        GPBUtil::checkString($var, True);
        $this->data_attribute_binding_id = $var;

        return $this;
    }

    /**
     * Required. DataAttributeBinding resource.
     *
     * Generated from protobuf field <code>.google.cloud.dataplex.v1.DataAttributeBinding data_attribute_binding = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\Dataplex\V1\DataAttributeBinding|null
     */
    public function getDataAttributeBinding()
    {
        return $this->data_attribute_binding;
    }

    public function hasDataAttributeBinding()
    {
        return isset($this->data_attribute_binding);
    }

    public function clearDataAttributeBinding()
    {
        unset($this->data_attribute_binding);
    }

    /**
     * Required. DataAttributeBinding resource.
     *
     * Generated from protobuf field <code>.google.cloud.dataplex.v1.DataAttributeBinding data_attribute_binding = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\Dataplex\V1\DataAttributeBinding $var
     * @return $this
     */
    public function setDataAttributeBinding($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dataplex\V1\DataAttributeBinding::class);
        $this->data_attribute_binding = $var;

        return $this;
    }

    /**
     * Optional. Only validate the request, but do not perform mutations.
     * The default is false.
     *
     * Generated from protobuf field <code>bool validate_only = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getValidateOnly()
    {
        return $this->validate_only;
    }

    /**
     * Optional. Only validate the request, but do not perform mutations.
     * The default is false.
     *
     * Generated from protobuf field <code>bool validate_only = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setValidateOnly($var)
    {
        GPBUtil::checkBool($var);
        $this->validate_only = $var;

        return $this;
    }

}

