<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dataplex/v1/data_taxonomy.proto

namespace Google\Cloud\Dataplex\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Create DataAttribute request.
 *
 * Generated from protobuf message <code>google.cloud.dataplex.v1.CreateDataAttributeRequest</code>
 */
class CreateDataAttributeRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the parent data taxonomy
     * projects/{project_number}/locations/{location_id}/dataTaxonomies/{data_taxonomy_id}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. DataAttribute identifier.
     * * Must contain only lowercase letters, numbers and hyphens.
     * * Must start with a letter.
     * * Must be between 1-63 characters.
     * * Must end with a number or a letter.
     * * Must be unique within the DataTaxonomy.
     *
     * Generated from protobuf field <code>string data_attribute_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $data_attribute_id = '';
    /**
     * Required. DataAttribute resource.
     *
     * Generated from protobuf field <code>.google.cloud.dataplex.v1.DataAttribute data_attribute = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $data_attribute = null;
    /**
     * Optional. Only validate the request, but do not perform mutations.
     * The default is false.
     *
     * Generated from protobuf field <code>bool validate_only = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $validate_only = false;

    /**
     * @param string                                  $parent          Required. The resource name of the parent data taxonomy
     *                                                                 projects/{project_number}/locations/{location_id}/dataTaxonomies/{data_taxonomy_id}
     *                                                                 Please see {@see DataTaxonomyServiceClient::dataTaxonomyName()} for help formatting this field.
     * @param \Google\Cloud\Dataplex\V1\DataAttribute $dataAttribute   Required. DataAttribute resource.
     * @param string                                  $dataAttributeId Required. DataAttribute identifier.
     *                                                                 * Must contain only lowercase letters, numbers and hyphens.
     *                                                                 * Must start with a letter.
     *                                                                 * Must be between 1-63 characters.
     *                                                                 * Must end with a number or a letter.
     *                                                                 * Must be unique within the DataTaxonomy.
     *
     * @return \Google\Cloud\Dataplex\V1\CreateDataAttributeRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\Dataplex\V1\DataAttribute $dataAttribute, string $dataAttributeId): self
    {
        return (new self())
            ->setParent($parent)
            ->setDataAttribute($dataAttribute)
            ->setDataAttributeId($dataAttributeId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The resource name of the parent data taxonomy
     *           projects/{project_number}/locations/{location_id}/dataTaxonomies/{data_taxonomy_id}
     *     @type string $data_attribute_id
     *           Required. DataAttribute identifier.
     *           * Must contain only lowercase letters, numbers and hyphens.
     *           * Must start with a letter.
     *           * Must be between 1-63 characters.
     *           * Must end with a number or a letter.
     *           * Must be unique within the DataTaxonomy.
     *     @type \Google\Cloud\Dataplex\V1\DataAttribute $data_attribute
     *           Required. DataAttribute resource.
     *     @type bool $validate_only
     *           Optional. Only validate the request, but do not perform mutations.
     *           The default is false.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dataplex\V1\DataTaxonomy::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the parent data taxonomy
     * projects/{project_number}/locations/{location_id}/dataTaxonomies/{data_taxonomy_id}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The resource name of the parent data taxonomy
     * projects/{project_number}/locations/{location_id}/dataTaxonomies/{data_taxonomy_id}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. DataAttribute identifier.
     * * Must contain only lowercase letters, numbers and hyphens.
     * * Must start with a letter.
     * * Must be between 1-63 characters.
     * * Must end with a number or a letter.
     * * Must be unique within the DataTaxonomy.
     *
     * Generated from protobuf field <code>string data_attribute_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getDataAttributeId()
    {
        return $this->data_attribute_id;
    }

    /**
     * Required. DataAttribute identifier.
     * * Must contain only lowercase letters, numbers and hyphens.
     * * Must start with a letter.
     * * Must be between 1-63 characters.
     * * Must end with a number or a letter.
     * * Must be unique within the DataTaxonomy.
     *
     * Generated from protobuf field <code>string data_attribute_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setDataAttributeId($var)
    {
        GPBUtil::checkString($var, True);
        $this->data_attribute_id = $var;

        return $this;
    }

    /**
     * Required. DataAttribute resource.
     *
     * Generated from protobuf field <code>.google.cloud.dataplex.v1.DataAttribute data_attribute = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\Dataplex\V1\DataAttribute|null
     */
    public function getDataAttribute()
    {
        return $this->data_attribute;
    }

    public function hasDataAttribute()
    {
        return isset($this->data_attribute);
    }

    public function clearDataAttribute()
    {
        unset($this->data_attribute);
    }

    /**
     * Required. DataAttribute resource.
     *
     * Generated from protobuf field <code>.google.cloud.dataplex.v1.DataAttribute data_attribute = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\Dataplex\V1\DataAttribute $var
     * @return $this
     */
    public function setDataAttribute($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dataplex\V1\DataAttribute::class);
        $this->data_attribute = $var;

        return $this;
    }

    /**
     * Optional. Only validate the request, but do not perform mutations.
     * The default is false.
     *
     * Generated from protobuf field <code>bool validate_only = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getValidateOnly()
    {
        return $this->validate_only;
    }

    /**
     * Optional. Only validate the request, but do not perform mutations.
     * The default is false.
     *
     * Generated from protobuf field <code>bool validate_only = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setValidateOnly($var)
    {
        GPBUtil::checkBool($var);
        $this->validate_only = $var;

        return $this;
    }

}

