<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dataplex/v1/catalog.proto

namespace Google\Cloud\Dataplex\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An entry is a representation of a data asset which can be described by
 * various metadata.
 *
 * Generated from protobuf message <code>google.cloud.dataplex.v1.Entry</code>
 */
class Entry extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. The relative resource name of the Entry, of the form:
     * projects/{project}/locations/{location}/entryGroups/{entry_group}/entries/{entry}.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Required. Immutable. The resource name of the EntryType used to create this
     * Entry.
     *
     * Generated from protobuf field <code>string entry_type = 4 [(.google.api.field_behavior) = REQUIRED, (.google.api.field_behavior) = IMMUTABLE];</code>
     */
    protected $entry_type = '';
    /**
     * Output only. The time when the Entry was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. The time when the Entry was last updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Optional. The Aspects attached to the Entry.
     * The format for the key can be one of the following:
     * 1. {projectId}.{locationId}.{aspectTypeId} (if the aspect is attached
     * directly to the entry)
     * 2. {projectId}.{locationId}.{aspectTypeId}&#64;{path} (if the aspect is
     * attached to an entry's path)
     *
     * Generated from protobuf field <code>map<string, .google.cloud.dataplex.v1.Aspect> aspects = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $aspects;
    /**
     * Optional. Immutable. The resource name of the parent entry.
     *
     * Generated from protobuf field <code>string parent_entry = 10 [(.google.api.field_behavior) = OPTIONAL, (.google.api.field_behavior) = IMMUTABLE];</code>
     */
    protected $parent_entry = '';
    /**
     * Optional. A name for the entry that can reference it in an external system.
     * The maximum size of the field is 4000 characters.
     *
     * Generated from protobuf field <code>string fully_qualified_name = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $fully_qualified_name = '';
    /**
     * Optional. Source system related information for an entry.
     *
     * Generated from protobuf field <code>.google.cloud.dataplex.v1.EntrySource entry_source = 15 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $entry_source = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. The relative resource name of the Entry, of the form:
     *           projects/{project}/locations/{location}/entryGroups/{entry_group}/entries/{entry}.
     *     @type string $entry_type
     *           Required. Immutable. The resource name of the EntryType used to create this
     *           Entry.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. The time when the Entry was created.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. The time when the Entry was last updated.
     *     @type array|\Google\Protobuf\Internal\MapField $aspects
     *           Optional. The Aspects attached to the Entry.
     *           The format for the key can be one of the following:
     *           1. {projectId}.{locationId}.{aspectTypeId} (if the aspect is attached
     *           directly to the entry)
     *           2. {projectId}.{locationId}.{aspectTypeId}&#64;{path} (if the aspect is
     *           attached to an entry's path)
     *     @type string $parent_entry
     *           Optional. Immutable. The resource name of the parent entry.
     *     @type string $fully_qualified_name
     *           Optional. A name for the entry that can reference it in an external system.
     *           The maximum size of the field is 4000 characters.
     *     @type \Google\Cloud\Dataplex\V1\EntrySource $entry_source
     *           Optional. Source system related information for an entry.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dataplex\V1\Catalog::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. The relative resource name of the Entry, of the form:
     * projects/{project}/locations/{location}/entryGroups/{entry_group}/entries/{entry}.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. The relative resource name of the Entry, of the form:
     * projects/{project}/locations/{location}/entryGroups/{entry_group}/entries/{entry}.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Required. Immutable. The resource name of the EntryType used to create this
     * Entry.
     *
     * Generated from protobuf field <code>string entry_type = 4 [(.google.api.field_behavior) = REQUIRED, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @return string
     */
    public function getEntryType()
    {
        return $this->entry_type;
    }

    /**
     * Required. Immutable. The resource name of the EntryType used to create this
     * Entry.
     *
     * Generated from protobuf field <code>string entry_type = 4 [(.google.api.field_behavior) = REQUIRED, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @param string $var
     * @return $this
     */
    public function setEntryType($var)
    {
        GPBUtil::checkString($var, True);
        $this->entry_type = $var;

        return $this;
    }

    /**
     * Output only. The time when the Entry was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. The time when the Entry was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. The time when the Entry was last updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. The time when the Entry was last updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Optional. The Aspects attached to the Entry.
     * The format for the key can be one of the following:
     * 1. {projectId}.{locationId}.{aspectTypeId} (if the aspect is attached
     * directly to the entry)
     * 2. {projectId}.{locationId}.{aspectTypeId}&#64;{path} (if the aspect is
     * attached to an entry's path)
     *
     * Generated from protobuf field <code>map<string, .google.cloud.dataplex.v1.Aspect> aspects = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getAspects()
    {
        return $this->aspects;
    }

    /**
     * Optional. The Aspects attached to the Entry.
     * The format for the key can be one of the following:
     * 1. {projectId}.{locationId}.{aspectTypeId} (if the aspect is attached
     * directly to the entry)
     * 2. {projectId}.{locationId}.{aspectTypeId}&#64;{path} (if the aspect is
     * attached to an entry's path)
     *
     * Generated from protobuf field <code>map<string, .google.cloud.dataplex.v1.Aspect> aspects = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setAspects($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Dataplex\V1\Aspect::class);
        $this->aspects = $arr;

        return $this;
    }

    /**
     * Optional. Immutable. The resource name of the parent entry.
     *
     * Generated from protobuf field <code>string parent_entry = 10 [(.google.api.field_behavior) = OPTIONAL, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @return string
     */
    public function getParentEntry()
    {
        return $this->parent_entry;
    }

    /**
     * Optional. Immutable. The resource name of the parent entry.
     *
     * Generated from protobuf field <code>string parent_entry = 10 [(.google.api.field_behavior) = OPTIONAL, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @param string $var
     * @return $this
     */
    public function setParentEntry($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent_entry = $var;

        return $this;
    }

    /**
     * Optional. A name for the entry that can reference it in an external system.
     * The maximum size of the field is 4000 characters.
     *
     * Generated from protobuf field <code>string fully_qualified_name = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFullyQualifiedName()
    {
        return $this->fully_qualified_name;
    }

    /**
     * Optional. A name for the entry that can reference it in an external system.
     * The maximum size of the field is 4000 characters.
     *
     * Generated from protobuf field <code>string fully_qualified_name = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFullyQualifiedName($var)
    {
        GPBUtil::checkString($var, True);
        $this->fully_qualified_name = $var;

        return $this;
    }

    /**
     * Optional. Source system related information for an entry.
     *
     * Generated from protobuf field <code>.google.cloud.dataplex.v1.EntrySource entry_source = 15 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\Dataplex\V1\EntrySource|null
     */
    public function getEntrySource()
    {
        return $this->entry_source;
    }

    public function hasEntrySource()
    {
        return isset($this->entry_source);
    }

    public function clearEntrySource()
    {
        unset($this->entry_source);
    }

    /**
     * Optional. Source system related information for an entry.
     *
     * Generated from protobuf field <code>.google.cloud.dataplex.v1.EntrySource entry_source = 15 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\Dataplex\V1\EntrySource $var
     * @return $this
     */
    public function setEntrySource($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dataplex\V1\EntrySource::class);
        $this->entry_source = $var;

        return $this;
    }

}

