<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dataplex/v1/analyze.proto

namespace Google\Cloud\Dataplex\V1\Environment\InfrastructureSpec;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Software Runtime Configuration to run Analyze.
 *
 * Generated from protobuf message <code>google.cloud.dataplex.v1.Environment.InfrastructureSpec.OsImageRuntime</code>
 */
class OsImageRuntime extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Dataplex Image version.
     *
     * Generated from protobuf field <code>string image_version = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $image_version = '';
    /**
     * Optional. List of Java jars to be included in the runtime environment.
     * Valid input includes Cloud Storage URIs to Jar binaries.
     * For example, gs://bucket-name/my/path/to/file.jar
     *
     * Generated from protobuf field <code>repeated string java_libraries = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $java_libraries;
    /**
     * Optional. A list of python packages to be installed.
     * Valid formats include Cloud Storage URI to a PIP installable library.
     * For example, gs://bucket-name/my/path/to/lib.tar.gz
     *
     * Generated from protobuf field <code>repeated string python_packages = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $python_packages;
    /**
     * Optional. Spark properties to provide configuration for use in sessions
     * created for this environment. The properties to set on daemon config
     * files. Property keys are specified in `prefix:property` format. The
     * prefix must be "spark".
     *
     * Generated from protobuf field <code>map<string, string> properties = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $properties;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $image_version
     *           Required. Dataplex Image version.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $java_libraries
     *           Optional. List of Java jars to be included in the runtime environment.
     *           Valid input includes Cloud Storage URIs to Jar binaries.
     *           For example, gs://bucket-name/my/path/to/file.jar
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $python_packages
     *           Optional. A list of python packages to be installed.
     *           Valid formats include Cloud Storage URI to a PIP installable library.
     *           For example, gs://bucket-name/my/path/to/lib.tar.gz
     *     @type array|\Google\Protobuf\Internal\MapField $properties
     *           Optional. Spark properties to provide configuration for use in sessions
     *           created for this environment. The properties to set on daemon config
     *           files. Property keys are specified in `prefix:property` format. The
     *           prefix must be "spark".
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dataplex\V1\Analyze::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Dataplex Image version.
     *
     * Generated from protobuf field <code>string image_version = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getImageVersion()
    {
        return $this->image_version;
    }

    /**
     * Required. Dataplex Image version.
     *
     * Generated from protobuf field <code>string image_version = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setImageVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->image_version = $var;

        return $this;
    }

    /**
     * Optional. List of Java jars to be included in the runtime environment.
     * Valid input includes Cloud Storage URIs to Jar binaries.
     * For example, gs://bucket-name/my/path/to/file.jar
     *
     * Generated from protobuf field <code>repeated string java_libraries = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getJavaLibraries()
    {
        return $this->java_libraries;
    }

    /**
     * Optional. List of Java jars to be included in the runtime environment.
     * Valid input includes Cloud Storage URIs to Jar binaries.
     * For example, gs://bucket-name/my/path/to/file.jar
     *
     * Generated from protobuf field <code>repeated string java_libraries = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setJavaLibraries($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->java_libraries = $arr;

        return $this;
    }

    /**
     * Optional. A list of python packages to be installed.
     * Valid formats include Cloud Storage URI to a PIP installable library.
     * For example, gs://bucket-name/my/path/to/lib.tar.gz
     *
     * Generated from protobuf field <code>repeated string python_packages = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getPythonPackages()
    {
        return $this->python_packages;
    }

    /**
     * Optional. A list of python packages to be installed.
     * Valid formats include Cloud Storage URI to a PIP installable library.
     * For example, gs://bucket-name/my/path/to/lib.tar.gz
     *
     * Generated from protobuf field <code>repeated string python_packages = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setPythonPackages($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->python_packages = $arr;

        return $this;
    }

    /**
     * Optional. Spark properties to provide configuration for use in sessions
     * created for this environment. The properties to set on daemon config
     * files. Property keys are specified in `prefix:property` format. The
     * prefix must be "spark".
     *
     * Generated from protobuf field <code>map<string, string> properties = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getProperties()
    {
        return $this->properties;
    }

    /**
     * Optional. Spark properties to provide configuration for use in sessions
     * created for this environment. The properties to set on daemon config
     * files. Property keys are specified in `prefix:property` format. The
     * prefix must be "spark".
     *
     * Generated from protobuf field <code>map<string, string> properties = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setProperties($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->properties = $arr;

        return $this;
    }

}


