<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dataplex/v1/service.proto

namespace Google\Cloud\Dataplex\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Generated from protobuf message <code>google.cloud.dataplex.v1.RunTaskRequest</code>
 */
class RunTaskRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the task:
     * `projects/{project_number}/locations/{location_id}/lakes/{lake_id}/tasks/{task_id}`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';
    /**
     * Optional. User-defined labels for the task. If the map is left empty, the
     * task will run with existing labels from task definition. If the map
     * contains an entry with a new key, the same will be added to existing set of
     * labels. If the map contains an entry with an existing label key in task
     * definition, the task will run with new label value for that entry. Clearing
     * an existing label will require label value to be explicitly set to a hyphen
     * "-". The label value cannot be empty.
     *
     * Generated from protobuf field <code>map<string, string> labels = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $labels;
    /**
     * Optional. Execution spec arguments. If the map is left empty, the task will
     * run with existing execution spec args from task definition. If the map
     * contains an entry with a new key, the same will be added to existing set of
     * args. If the map contains an entry with an existing arg key in task
     * definition, the task will run with new arg value for that entry. Clearing
     * an existing arg will require arg value to be explicitly set to a hyphen
     * "-". The arg value cannot be empty.
     *
     * Generated from protobuf field <code>map<string, string> args = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $args;

    /**
     * @param string $name Required. The resource name of the task:
     *                     `projects/{project_number}/locations/{location_id}/lakes/{lake_id}/tasks/{task_id}`. Please see
     *                     {@see DataplexServiceClient::taskName()} for help formatting this field.
     *
     * @return \Google\Cloud\Dataplex\V1\RunTaskRequest
     *
     * @experimental
     */
    public static function build(string $name): self
    {
        return (new self())
            ->setName($name);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. The resource name of the task:
     *           `projects/{project_number}/locations/{location_id}/lakes/{lake_id}/tasks/{task_id}`.
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Optional. User-defined labels for the task. If the map is left empty, the
     *           task will run with existing labels from task definition. If the map
     *           contains an entry with a new key, the same will be added to existing set of
     *           labels. If the map contains an entry with an existing label key in task
     *           definition, the task will run with new label value for that entry. Clearing
     *           an existing label will require label value to be explicitly set to a hyphen
     *           "-". The label value cannot be empty.
     *     @type array|\Google\Protobuf\Internal\MapField $args
     *           Optional. Execution spec arguments. If the map is left empty, the task will
     *           run with existing execution spec args from task definition. If the map
     *           contains an entry with a new key, the same will be added to existing set of
     *           args. If the map contains an entry with an existing arg key in task
     *           definition, the task will run with new arg value for that entry. Clearing
     *           an existing arg will require arg value to be explicitly set to a hyphen
     *           "-". The arg value cannot be empty.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dataplex\V1\Service::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the task:
     * `projects/{project_number}/locations/{location_id}/lakes/{lake_id}/tasks/{task_id}`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. The resource name of the task:
     * `projects/{project_number}/locations/{location_id}/lakes/{lake_id}/tasks/{task_id}`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Optional. User-defined labels for the task. If the map is left empty, the
     * task will run with existing labels from task definition. If the map
     * contains an entry with a new key, the same will be added to existing set of
     * labels. If the map contains an entry with an existing label key in task
     * definition, the task will run with new label value for that entry. Clearing
     * an existing label will require label value to be explicitly set to a hyphen
     * "-". The label value cannot be empty.
     *
     * Generated from protobuf field <code>map<string, string> labels = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Optional. User-defined labels for the task. If the map is left empty, the
     * task will run with existing labels from task definition. If the map
     * contains an entry with a new key, the same will be added to existing set of
     * labels. If the map contains an entry with an existing label key in task
     * definition, the task will run with new label value for that entry. Clearing
     * an existing label will require label value to be explicitly set to a hyphen
     * "-". The label value cannot be empty.
     *
     * Generated from protobuf field <code>map<string, string> labels = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * Optional. Execution spec arguments. If the map is left empty, the task will
     * run with existing execution spec args from task definition. If the map
     * contains an entry with a new key, the same will be added to existing set of
     * args. If the map contains an entry with an existing arg key in task
     * definition, the task will run with new arg value for that entry. Clearing
     * an existing arg will require arg value to be explicitly set to a hyphen
     * "-". The arg value cannot be empty.
     *
     * Generated from protobuf field <code>map<string, string> args = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getArgs()
    {
        return $this->args;
    }

    /**
     * Optional. Execution spec arguments. If the map is left empty, the task will
     * run with existing execution spec args from task definition. If the map
     * contains an entry with a new key, the same will be added to existing set of
     * args. If the map contains an entry with an existing arg key in task
     * definition, the task will run with new arg value for that entry. Clearing
     * an existing arg will require arg value to be explicitly set to a hyphen
     * "-". The arg value cannot be empty.
     *
     * Generated from protobuf field <code>map<string, string> args = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setArgs($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->args = $arr;

        return $this;
    }

}

