<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dataproc/v1/shared.proto

namespace Google\Cloud\Dataproc\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Usage metrics represent approximate total resources consumed by a workload.
 *
 * Generated from protobuf message <code>google.cloud.dataproc.v1.UsageMetrics</code>
 */
class UsageMetrics extends \Google\Protobuf\Internal\Message
{
    /**
     * Optional. DCU (Dataproc Compute Units) usage in (`milliDCU` x `seconds`)
     * (see [Dataproc Serverless pricing]
     * (https://cloud.google.com/dataproc-serverless/pricing)).
     *
     * Generated from protobuf field <code>int64 milli_dcu_seconds = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $milli_dcu_seconds = 0;
    /**
     * Optional. Shuffle storage usage in (`GB` x `seconds`) (see
     * [Dataproc Serverless pricing]
     * (https://cloud.google.com/dataproc-serverless/pricing)).
     *
     * Generated from protobuf field <code>int64 shuffle_storage_gb_seconds = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $shuffle_storage_gb_seconds = 0;
    /**
     * Optional. Accelerator usage in (`milliAccelerator` x `seconds`) (see
     * [Dataproc Serverless pricing]
     * (https://cloud.google.com/dataproc-serverless/pricing)).
     *
     * Generated from protobuf field <code>int64 milli_accelerator_seconds = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $milli_accelerator_seconds = 0;
    /**
     * Optional. Accelerator type being used, if any
     *
     * Generated from protobuf field <code>string accelerator_type = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $accelerator_type = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int|string $milli_dcu_seconds
     *           Optional. DCU (Dataproc Compute Units) usage in (`milliDCU` x `seconds`)
     *           (see [Dataproc Serverless pricing]
     *           (https://cloud.google.com/dataproc-serverless/pricing)).
     *     @type int|string $shuffle_storage_gb_seconds
     *           Optional. Shuffle storage usage in (`GB` x `seconds`) (see
     *           [Dataproc Serverless pricing]
     *           (https://cloud.google.com/dataproc-serverless/pricing)).
     *     @type int|string $milli_accelerator_seconds
     *           Optional. Accelerator usage in (`milliAccelerator` x `seconds`) (see
     *           [Dataproc Serverless pricing]
     *           (https://cloud.google.com/dataproc-serverless/pricing)).
     *     @type string $accelerator_type
     *           Optional. Accelerator type being used, if any
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dataproc\V1\Shared::initOnce();
        parent::__construct($data);
    }

    /**
     * Optional. DCU (Dataproc Compute Units) usage in (`milliDCU` x `seconds`)
     * (see [Dataproc Serverless pricing]
     * (https://cloud.google.com/dataproc-serverless/pricing)).
     *
     * Generated from protobuf field <code>int64 milli_dcu_seconds = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int|string
     */
    public function getMilliDcuSeconds()
    {
        return $this->milli_dcu_seconds;
    }

    /**
     * Optional. DCU (Dataproc Compute Units) usage in (`milliDCU` x `seconds`)
     * (see [Dataproc Serverless pricing]
     * (https://cloud.google.com/dataproc-serverless/pricing)).
     *
     * Generated from protobuf field <code>int64 milli_dcu_seconds = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int|string $var
     * @return $this
     */
    public function setMilliDcuSeconds($var)
    {
        GPBUtil::checkInt64($var);
        $this->milli_dcu_seconds = $var;

        return $this;
    }

    /**
     * Optional. Shuffle storage usage in (`GB` x `seconds`) (see
     * [Dataproc Serverless pricing]
     * (https://cloud.google.com/dataproc-serverless/pricing)).
     *
     * Generated from protobuf field <code>int64 shuffle_storage_gb_seconds = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int|string
     */
    public function getShuffleStorageGbSeconds()
    {
        return $this->shuffle_storage_gb_seconds;
    }

    /**
     * Optional. Shuffle storage usage in (`GB` x `seconds`) (see
     * [Dataproc Serverless pricing]
     * (https://cloud.google.com/dataproc-serverless/pricing)).
     *
     * Generated from protobuf field <code>int64 shuffle_storage_gb_seconds = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int|string $var
     * @return $this
     */
    public function setShuffleStorageGbSeconds($var)
    {
        GPBUtil::checkInt64($var);
        $this->shuffle_storage_gb_seconds = $var;

        return $this;
    }

    /**
     * Optional. Accelerator usage in (`milliAccelerator` x `seconds`) (see
     * [Dataproc Serverless pricing]
     * (https://cloud.google.com/dataproc-serverless/pricing)).
     *
     * Generated from protobuf field <code>int64 milli_accelerator_seconds = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int|string
     */
    public function getMilliAcceleratorSeconds()
    {
        return $this->milli_accelerator_seconds;
    }

    /**
     * Optional. Accelerator usage in (`milliAccelerator` x `seconds`) (see
     * [Dataproc Serverless pricing]
     * (https://cloud.google.com/dataproc-serverless/pricing)).
     *
     * Generated from protobuf field <code>int64 milli_accelerator_seconds = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int|string $var
     * @return $this
     */
    public function setMilliAcceleratorSeconds($var)
    {
        GPBUtil::checkInt64($var);
        $this->milli_accelerator_seconds = $var;

        return $this;
    }

    /**
     * Optional. Accelerator type being used, if any
     *
     * Generated from protobuf field <code>string accelerator_type = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getAcceleratorType()
    {
        return $this->accelerator_type;
    }

    /**
     * Optional. Accelerator type being used, if any
     *
     * Generated from protobuf field <code>string accelerator_type = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setAcceleratorType($var)
    {
        GPBUtil::checkString($var, True);
        $this->accelerator_type = $var;

        return $this;
    }

}

