<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dataproc/v1/shared.proto

namespace Google\Cloud\Dataproc\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The usage snapshot represents the resources consumed by a workload at a
 * specified time.
 *
 * Generated from protobuf message <code>google.cloud.dataproc.v1.UsageSnapshot</code>
 */
class UsageSnapshot extends \Google\Protobuf\Internal\Message
{
    /**
     * Optional. Milli (one-thousandth) Dataproc Compute Units (DCUs) (see
     * [Dataproc Serverless pricing]
     * (https://cloud.google.com/dataproc-serverless/pricing)).
     *
     * Generated from protobuf field <code>int64 milli_dcu = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $milli_dcu = 0;
    /**
     * Optional. Shuffle Storage in gigabytes (GB). (see [Dataproc Serverless
     * pricing] (https://cloud.google.com/dataproc-serverless/pricing))
     *
     * Generated from protobuf field <code>int64 shuffle_storage_gb = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $shuffle_storage_gb = 0;
    /**
     * Optional. Milli (one-thousandth) Dataproc Compute Units (DCUs) charged at
     * premium tier (see [Dataproc Serverless pricing]
     * (https://cloud.google.com/dataproc-serverless/pricing)).
     *
     * Generated from protobuf field <code>int64 milli_dcu_premium = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $milli_dcu_premium = 0;
    /**
     * Optional. Shuffle Storage in gigabytes (GB) charged at premium tier. (see
     * [Dataproc Serverless pricing]
     * (https://cloud.google.com/dataproc-serverless/pricing))
     *
     * Generated from protobuf field <code>int64 shuffle_storage_gb_premium = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $shuffle_storage_gb_premium = 0;
    /**
     * Optional. Milli (one-thousandth) accelerator. (see [Dataproc
     * Serverless pricing] (https://cloud.google.com/dataproc-serverless/pricing))
     *
     * Generated from protobuf field <code>int64 milli_accelerator = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $milli_accelerator = 0;
    /**
     * Optional. Accelerator type being used, if any
     *
     * Generated from protobuf field <code>string accelerator_type = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $accelerator_type = '';
    /**
     * Optional. The timestamp of the usage snapshot.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp snapshot_time = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $snapshot_time = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int|string $milli_dcu
     *           Optional. Milli (one-thousandth) Dataproc Compute Units (DCUs) (see
     *           [Dataproc Serverless pricing]
     *           (https://cloud.google.com/dataproc-serverless/pricing)).
     *     @type int|string $shuffle_storage_gb
     *           Optional. Shuffle Storage in gigabytes (GB). (see [Dataproc Serverless
     *           pricing] (https://cloud.google.com/dataproc-serverless/pricing))
     *     @type int|string $milli_dcu_premium
     *           Optional. Milli (one-thousandth) Dataproc Compute Units (DCUs) charged at
     *           premium tier (see [Dataproc Serverless pricing]
     *           (https://cloud.google.com/dataproc-serverless/pricing)).
     *     @type int|string $shuffle_storage_gb_premium
     *           Optional. Shuffle Storage in gigabytes (GB) charged at premium tier. (see
     *           [Dataproc Serverless pricing]
     *           (https://cloud.google.com/dataproc-serverless/pricing))
     *     @type int|string $milli_accelerator
     *           Optional. Milli (one-thousandth) accelerator. (see [Dataproc
     *           Serverless pricing] (https://cloud.google.com/dataproc-serverless/pricing))
     *     @type string $accelerator_type
     *           Optional. Accelerator type being used, if any
     *     @type \Google\Protobuf\Timestamp $snapshot_time
     *           Optional. The timestamp of the usage snapshot.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dataproc\V1\Shared::initOnce();
        parent::__construct($data);
    }

    /**
     * Optional. Milli (one-thousandth) Dataproc Compute Units (DCUs) (see
     * [Dataproc Serverless pricing]
     * (https://cloud.google.com/dataproc-serverless/pricing)).
     *
     * Generated from protobuf field <code>int64 milli_dcu = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int|string
     */
    public function getMilliDcu()
    {
        return $this->milli_dcu;
    }

    /**
     * Optional. Milli (one-thousandth) Dataproc Compute Units (DCUs) (see
     * [Dataproc Serverless pricing]
     * (https://cloud.google.com/dataproc-serverless/pricing)).
     *
     * Generated from protobuf field <code>int64 milli_dcu = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int|string $var
     * @return $this
     */
    public function setMilliDcu($var)
    {
        GPBUtil::checkInt64($var);
        $this->milli_dcu = $var;

        return $this;
    }

    /**
     * Optional. Shuffle Storage in gigabytes (GB). (see [Dataproc Serverless
     * pricing] (https://cloud.google.com/dataproc-serverless/pricing))
     *
     * Generated from protobuf field <code>int64 shuffle_storage_gb = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int|string
     */
    public function getShuffleStorageGb()
    {
        return $this->shuffle_storage_gb;
    }

    /**
     * Optional. Shuffle Storage in gigabytes (GB). (see [Dataproc Serverless
     * pricing] (https://cloud.google.com/dataproc-serverless/pricing))
     *
     * Generated from protobuf field <code>int64 shuffle_storage_gb = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int|string $var
     * @return $this
     */
    public function setShuffleStorageGb($var)
    {
        GPBUtil::checkInt64($var);
        $this->shuffle_storage_gb = $var;

        return $this;
    }

    /**
     * Optional. Milli (one-thousandth) Dataproc Compute Units (DCUs) charged at
     * premium tier (see [Dataproc Serverless pricing]
     * (https://cloud.google.com/dataproc-serverless/pricing)).
     *
     * Generated from protobuf field <code>int64 milli_dcu_premium = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int|string
     */
    public function getMilliDcuPremium()
    {
        return $this->milli_dcu_premium;
    }

    /**
     * Optional. Milli (one-thousandth) Dataproc Compute Units (DCUs) charged at
     * premium tier (see [Dataproc Serverless pricing]
     * (https://cloud.google.com/dataproc-serverless/pricing)).
     *
     * Generated from protobuf field <code>int64 milli_dcu_premium = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int|string $var
     * @return $this
     */
    public function setMilliDcuPremium($var)
    {
        GPBUtil::checkInt64($var);
        $this->milli_dcu_premium = $var;

        return $this;
    }

    /**
     * Optional. Shuffle Storage in gigabytes (GB) charged at premium tier. (see
     * [Dataproc Serverless pricing]
     * (https://cloud.google.com/dataproc-serverless/pricing))
     *
     * Generated from protobuf field <code>int64 shuffle_storage_gb_premium = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int|string
     */
    public function getShuffleStorageGbPremium()
    {
        return $this->shuffle_storage_gb_premium;
    }

    /**
     * Optional. Shuffle Storage in gigabytes (GB) charged at premium tier. (see
     * [Dataproc Serverless pricing]
     * (https://cloud.google.com/dataproc-serverless/pricing))
     *
     * Generated from protobuf field <code>int64 shuffle_storage_gb_premium = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int|string $var
     * @return $this
     */
    public function setShuffleStorageGbPremium($var)
    {
        GPBUtil::checkInt64($var);
        $this->shuffle_storage_gb_premium = $var;

        return $this;
    }

    /**
     * Optional. Milli (one-thousandth) accelerator. (see [Dataproc
     * Serverless pricing] (https://cloud.google.com/dataproc-serverless/pricing))
     *
     * Generated from protobuf field <code>int64 milli_accelerator = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int|string
     */
    public function getMilliAccelerator()
    {
        return $this->milli_accelerator;
    }

    /**
     * Optional. Milli (one-thousandth) accelerator. (see [Dataproc
     * Serverless pricing] (https://cloud.google.com/dataproc-serverless/pricing))
     *
     * Generated from protobuf field <code>int64 milli_accelerator = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int|string $var
     * @return $this
     */
    public function setMilliAccelerator($var)
    {
        GPBUtil::checkInt64($var);
        $this->milli_accelerator = $var;

        return $this;
    }

    /**
     * Optional. Accelerator type being used, if any
     *
     * Generated from protobuf field <code>string accelerator_type = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getAcceleratorType()
    {
        return $this->accelerator_type;
    }

    /**
     * Optional. Accelerator type being used, if any
     *
     * Generated from protobuf field <code>string accelerator_type = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setAcceleratorType($var)
    {
        GPBUtil::checkString($var, True);
        $this->accelerator_type = $var;

        return $this;
    }

    /**
     * Optional. The timestamp of the usage snapshot.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp snapshot_time = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getSnapshotTime()
    {
        return $this->snapshot_time;
    }

    public function hasSnapshotTime()
    {
        return isset($this->snapshot_time);
    }

    public function clearSnapshotTime()
    {
        unset($this->snapshot_time);
    }

    /**
     * Optional. The timestamp of the usage snapshot.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp snapshot_time = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setSnapshotTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->snapshot_time = $var;

        return $this;
    }

}

