<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/datastream/v1/datastream.proto

namespace Google\Cloud\Datastream\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request for creating a private connection.
 *
 * Generated from protobuf message <code>google.cloud.datastream.v1.CreatePrivateConnectionRequest</code>
 */
class CreatePrivateConnectionRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent that owns the collection of PrivateConnections.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The private connectivity identifier.
     *
     * Generated from protobuf field <code>string private_connection_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $private_connection_id = '';
    /**
     * Required. The Private Connectivity resource to create.
     *
     * Generated from protobuf field <code>.google.cloud.datastream.v1.PrivateConnection private_connection = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $private_connection = null;
    /**
     * Optional. A request ID to identify requests. Specify a unique request ID
     * so that if you must retry your request, the server will know to ignore
     * the request if it has already been completed. The server will guarantee
     * that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request ID,
     * the server can check if original operation with the same request ID was
     * received, and if so, will ignore the second request. This prevents clients
     * from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $request_id = '';
    /**
     * Optional. If set to true, will skip validations.
     *
     * Generated from protobuf field <code>bool force = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $force = false;

    /**
     * @param string                                        $parent              Required. The parent that owns the collection of PrivateConnections. Please see
     *                                                                           {@see DatastreamClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\Datastream\V1\PrivateConnection $privateConnection   Required. The Private Connectivity resource to create.
     * @param string                                        $privateConnectionId Required. The private connectivity identifier.
     *
     * @return \Google\Cloud\Datastream\V1\CreatePrivateConnectionRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\Datastream\V1\PrivateConnection $privateConnection, string $privateConnectionId): self
    {
        return (new self())
            ->setParent($parent)
            ->setPrivateConnection($privateConnection)
            ->setPrivateConnectionId($privateConnectionId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent that owns the collection of PrivateConnections.
     *     @type string $private_connection_id
     *           Required. The private connectivity identifier.
     *     @type \Google\Cloud\Datastream\V1\PrivateConnection $private_connection
     *           Required. The Private Connectivity resource to create.
     *     @type string $request_id
     *           Optional. A request ID to identify requests. Specify a unique request ID
     *           so that if you must retry your request, the server will know to ignore
     *           the request if it has already been completed. The server will guarantee
     *           that for at least 60 minutes since the first request.
     *           For example, consider a situation where you make an initial request and the
     *           request times out. If you make the request again with the same request ID,
     *           the server can check if original operation with the same request ID was
     *           received, and if so, will ignore the second request. This prevents clients
     *           from accidentally creating duplicate commitments.
     *           The request ID must be a valid UUID with the exception that zero UUID is
     *           not supported (00000000-0000-0000-0000-000000000000).
     *     @type bool $force
     *           Optional. If set to true, will skip validations.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Datastream\V1\Datastream::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent that owns the collection of PrivateConnections.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent that owns the collection of PrivateConnections.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The private connectivity identifier.
     *
     * Generated from protobuf field <code>string private_connection_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getPrivateConnectionId()
    {
        return $this->private_connection_id;
    }

    /**
     * Required. The private connectivity identifier.
     *
     * Generated from protobuf field <code>string private_connection_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setPrivateConnectionId($var)
    {
        GPBUtil::checkString($var, True);
        $this->private_connection_id = $var;

        return $this;
    }

    /**
     * Required. The Private Connectivity resource to create.
     *
     * Generated from protobuf field <code>.google.cloud.datastream.v1.PrivateConnection private_connection = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\Datastream\V1\PrivateConnection|null
     */
    public function getPrivateConnection()
    {
        return $this->private_connection;
    }

    public function hasPrivateConnection()
    {
        return isset($this->private_connection);
    }

    public function clearPrivateConnection()
    {
        unset($this->private_connection);
    }

    /**
     * Required. The Private Connectivity resource to create.
     *
     * Generated from protobuf field <code>.google.cloud.datastream.v1.PrivateConnection private_connection = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\Datastream\V1\PrivateConnection $var
     * @return $this
     */
    public function setPrivateConnection($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Datastream\V1\PrivateConnection::class);
        $this->private_connection = $var;

        return $this;
    }

    /**
     * Optional. A request ID to identify requests. Specify a unique request ID
     * so that if you must retry your request, the server will know to ignore
     * the request if it has already been completed. The server will guarantee
     * that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request ID,
     * the server can check if original operation with the same request ID was
     * received, and if so, will ignore the second request. This prevents clients
     * from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getRequestId()
    {
        return $this->request_id;
    }

    /**
     * Optional. A request ID to identify requests. Specify a unique request ID
     * so that if you must retry your request, the server will know to ignore
     * the request if it has already been completed. The server will guarantee
     * that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request ID,
     * the server can check if original operation with the same request ID was
     * received, and if so, will ignore the second request. This prevents clients
     * from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setRequestId($var)
    {
        GPBUtil::checkString($var, True);
        $this->request_id = $var;

        return $this;
    }

    /**
     * Optional. If set to true, will skip validations.
     *
     * Generated from protobuf field <code>bool force = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getForce()
    {
        return $this->force;
    }

    /**
     * Optional. If set to true, will skip validations.
     *
     * Generated from protobuf field <code>bool force = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setForce($var)
    {
        GPBUtil::checkBool($var);
        $this->force = $var;

        return $this;
    }

}

