<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/deploy/v1/cloud_deploy.proto

namespace Google\Cloud\Deploy\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An `AutomationRun` resource in the Cloud Deploy API.
 * An `AutomationRun` represents an execution instance of an
 * automation rule.
 *
 * Generated from protobuf message <code>google.cloud.deploy.v1.AutomationRun</code>
 */
class AutomationRun extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. Name of the `AutomationRun`. Format is
     * `projects/{project}/locations/{location}/deliveryPipelines/{delivery_pipeline}/automationRuns/{automation_run}`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $name = '';
    /**
     * Output only. Time at which the `AutomationRun` was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. Time at which the automationRun was updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Output only. The weak etag of the `AutomationRun` resource.
     * This checksum is computed by the server based on the value of other
     * fields, and may be sent on update and delete requests to ensure the
     * client has an up-to-date value before proceeding.
     *
     * Generated from protobuf field <code>string etag = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $etag = '';
    /**
     * Output only. Email address of the user-managed IAM service account that
     * performs the operations against Cloud Deploy resources.
     *
     * Generated from protobuf field <code>string service_account = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $service_account = '';
    /**
     * Output only. Snapshot of the Automation taken at AutomationRun creation
     * time.
     *
     * Generated from protobuf field <code>.google.cloud.deploy.v1.Automation automation_snapshot = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $automation_snapshot = null;
    /**
     * Output only. The ID of the target that represents the promotion stage that
     * initiates the `AutomationRun`. The value of this field is the last segment
     * of a target name.
     *
     * Generated from protobuf field <code>string target_id = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $target_id = '';
    /**
     * Output only. Current state of the `AutomationRun`.
     *
     * Generated from protobuf field <code>.google.cloud.deploy.v1.AutomationRun.State state = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;
    /**
     * Output only. Explains the current state of the `AutomationRun`. Present
     * only when an explanation is needed.
     *
     * Generated from protobuf field <code>string state_description = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state_description = '';
    /**
     * Output only. Contains information about what policies prevented the
     * `AutomationRun` from proceeding.
     *
     * Generated from protobuf field <code>.google.cloud.deploy.v1.PolicyViolation policy_violation = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $policy_violation = null;
    /**
     * Output only. Time the `AutomationRun` expires. An `AutomationRun` expires
     * after 14 days from its creation date.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp expire_time = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $expire_time = null;
    /**
     * Output only. The ID of the automation rule that initiated the operation.
     *
     * Generated from protobuf field <code>string rule_id = 12 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $rule_id = '';
    /**
     * Output only. The ID of the automation that initiated the operation.
     *
     * Generated from protobuf field <code>string automation_id = 15 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $automation_id = '';
    /**
     * Output only. Earliest time the `AutomationRun` will attempt to resume.
     * Wait-time is configured by `wait` in automation rule.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp wait_until_time = 16 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $wait_until_time = null;
    protected $operation;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. Name of the `AutomationRun`. Format is
     *           `projects/{project}/locations/{location}/deliveryPipelines/{delivery_pipeline}/automationRuns/{automation_run}`.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. Time at which the `AutomationRun` was created.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. Time at which the automationRun was updated.
     *     @type string $etag
     *           Output only. The weak etag of the `AutomationRun` resource.
     *           This checksum is computed by the server based on the value of other
     *           fields, and may be sent on update and delete requests to ensure the
     *           client has an up-to-date value before proceeding.
     *     @type string $service_account
     *           Output only. Email address of the user-managed IAM service account that
     *           performs the operations against Cloud Deploy resources.
     *     @type \Google\Cloud\Deploy\V1\Automation $automation_snapshot
     *           Output only. Snapshot of the Automation taken at AutomationRun creation
     *           time.
     *     @type string $target_id
     *           Output only. The ID of the target that represents the promotion stage that
     *           initiates the `AutomationRun`. The value of this field is the last segment
     *           of a target name.
     *     @type int $state
     *           Output only. Current state of the `AutomationRun`.
     *     @type string $state_description
     *           Output only. Explains the current state of the `AutomationRun`. Present
     *           only when an explanation is needed.
     *     @type \Google\Cloud\Deploy\V1\PolicyViolation $policy_violation
     *           Output only. Contains information about what policies prevented the
     *           `AutomationRun` from proceeding.
     *     @type \Google\Protobuf\Timestamp $expire_time
     *           Output only. Time the `AutomationRun` expires. An `AutomationRun` expires
     *           after 14 days from its creation date.
     *     @type string $rule_id
     *           Output only. The ID of the automation rule that initiated the operation.
     *     @type string $automation_id
     *           Output only. The ID of the automation that initiated the operation.
     *     @type \Google\Cloud\Deploy\V1\PromoteReleaseOperation $promote_release_operation
     *           Output only. Promotes a release to a specified 'Target'.
     *     @type \Google\Cloud\Deploy\V1\AdvanceRolloutOperation $advance_rollout_operation
     *           Output only. Advances a rollout to the next phase.
     *     @type \Google\Cloud\Deploy\V1\RepairRolloutOperation $repair_rollout_operation
     *           Output only. Repairs a failed 'Rollout'.
     *     @type \Google\Protobuf\Timestamp $wait_until_time
     *           Output only. Earliest time the `AutomationRun` will attempt to resume.
     *           Wait-time is configured by `wait` in automation rule.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Deploy\V1\CloudDeploy::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. Name of the `AutomationRun`. Format is
     * `projects/{project}/locations/{location}/deliveryPipelines/{delivery_pipeline}/automationRuns/{automation_run}`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. Name of the `AutomationRun`. Format is
     * `projects/{project}/locations/{location}/deliveryPipelines/{delivery_pipeline}/automationRuns/{automation_run}`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. Time at which the `AutomationRun` was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. Time at which the `AutomationRun` was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. Time at which the automationRun was updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. Time at which the automationRun was updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Output only. The weak etag of the `AutomationRun` resource.
     * This checksum is computed by the server based on the value of other
     * fields, and may be sent on update and delete requests to ensure the
     * client has an up-to-date value before proceeding.
     *
     * Generated from protobuf field <code>string etag = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getEtag()
    {
        return $this->etag;
    }

    /**
     * Output only. The weak etag of the `AutomationRun` resource.
     * This checksum is computed by the server based on the value of other
     * fields, and may be sent on update and delete requests to ensure the
     * client has an up-to-date value before proceeding.
     *
     * Generated from protobuf field <code>string etag = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setEtag($var)
    {
        GPBUtil::checkString($var, True);
        $this->etag = $var;

        return $this;
    }

    /**
     * Output only. Email address of the user-managed IAM service account that
     * performs the operations against Cloud Deploy resources.
     *
     * Generated from protobuf field <code>string service_account = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getServiceAccount()
    {
        return $this->service_account;
    }

    /**
     * Output only. Email address of the user-managed IAM service account that
     * performs the operations against Cloud Deploy resources.
     *
     * Generated from protobuf field <code>string service_account = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setServiceAccount($var)
    {
        GPBUtil::checkString($var, True);
        $this->service_account = $var;

        return $this;
    }

    /**
     * Output only. Snapshot of the Automation taken at AutomationRun creation
     * time.
     *
     * Generated from protobuf field <code>.google.cloud.deploy.v1.Automation automation_snapshot = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\Deploy\V1\Automation|null
     */
    public function getAutomationSnapshot()
    {
        return $this->automation_snapshot;
    }

    public function hasAutomationSnapshot()
    {
        return isset($this->automation_snapshot);
    }

    public function clearAutomationSnapshot()
    {
        unset($this->automation_snapshot);
    }

    /**
     * Output only. Snapshot of the Automation taken at AutomationRun creation
     * time.
     *
     * Generated from protobuf field <code>.google.cloud.deploy.v1.Automation automation_snapshot = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\Deploy\V1\Automation $var
     * @return $this
     */
    public function setAutomationSnapshot($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Deploy\V1\Automation::class);
        $this->automation_snapshot = $var;

        return $this;
    }

    /**
     * Output only. The ID of the target that represents the promotion stage that
     * initiates the `AutomationRun`. The value of this field is the last segment
     * of a target name.
     *
     * Generated from protobuf field <code>string target_id = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getTargetId()
    {
        return $this->target_id;
    }

    /**
     * Output only. The ID of the target that represents the promotion stage that
     * initiates the `AutomationRun`. The value of this field is the last segment
     * of a target name.
     *
     * Generated from protobuf field <code>string target_id = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setTargetId($var)
    {
        GPBUtil::checkString($var, True);
        $this->target_id = $var;

        return $this;
    }

    /**
     * Output only. Current state of the `AutomationRun`.
     *
     * Generated from protobuf field <code>.google.cloud.deploy.v1.AutomationRun.State state = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. Current state of the `AutomationRun`.
     *
     * Generated from protobuf field <code>.google.cloud.deploy.v1.AutomationRun.State state = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Deploy\V1\AutomationRun\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Output only. Explains the current state of the `AutomationRun`. Present
     * only when an explanation is needed.
     *
     * Generated from protobuf field <code>string state_description = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getStateDescription()
    {
        return $this->state_description;
    }

    /**
     * Output only. Explains the current state of the `AutomationRun`. Present
     * only when an explanation is needed.
     *
     * Generated from protobuf field <code>string state_description = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setStateDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->state_description = $var;

        return $this;
    }

    /**
     * Output only. Contains information about what policies prevented the
     * `AutomationRun` from proceeding.
     *
     * Generated from protobuf field <code>.google.cloud.deploy.v1.PolicyViolation policy_violation = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\Deploy\V1\PolicyViolation|null
     */
    public function getPolicyViolation()
    {
        return $this->policy_violation;
    }

    public function hasPolicyViolation()
    {
        return isset($this->policy_violation);
    }

    public function clearPolicyViolation()
    {
        unset($this->policy_violation);
    }

    /**
     * Output only. Contains information about what policies prevented the
     * `AutomationRun` from proceeding.
     *
     * Generated from protobuf field <code>.google.cloud.deploy.v1.PolicyViolation policy_violation = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\Deploy\V1\PolicyViolation $var
     * @return $this
     */
    public function setPolicyViolation($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Deploy\V1\PolicyViolation::class);
        $this->policy_violation = $var;

        return $this;
    }

    /**
     * Output only. Time the `AutomationRun` expires. An `AutomationRun` expires
     * after 14 days from its creation date.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp expire_time = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getExpireTime()
    {
        return $this->expire_time;
    }

    public function hasExpireTime()
    {
        return isset($this->expire_time);
    }

    public function clearExpireTime()
    {
        unset($this->expire_time);
    }

    /**
     * Output only. Time the `AutomationRun` expires. An `AutomationRun` expires
     * after 14 days from its creation date.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp expire_time = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setExpireTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->expire_time = $var;

        return $this;
    }

    /**
     * Output only. The ID of the automation rule that initiated the operation.
     *
     * Generated from protobuf field <code>string rule_id = 12 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getRuleId()
    {
        return $this->rule_id;
    }

    /**
     * Output only. The ID of the automation rule that initiated the operation.
     *
     * Generated from protobuf field <code>string rule_id = 12 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setRuleId($var)
    {
        GPBUtil::checkString($var, True);
        $this->rule_id = $var;

        return $this;
    }

    /**
     * Output only. The ID of the automation that initiated the operation.
     *
     * Generated from protobuf field <code>string automation_id = 15 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getAutomationId()
    {
        return $this->automation_id;
    }

    /**
     * Output only. The ID of the automation that initiated the operation.
     *
     * Generated from protobuf field <code>string automation_id = 15 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setAutomationId($var)
    {
        GPBUtil::checkString($var, True);
        $this->automation_id = $var;

        return $this;
    }

    /**
     * Output only. Promotes a release to a specified 'Target'.
     *
     * Generated from protobuf field <code>.google.cloud.deploy.v1.PromoteReleaseOperation promote_release_operation = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\Deploy\V1\PromoteReleaseOperation|null
     */
    public function getPromoteReleaseOperation()
    {
        return $this->readOneof(13);
    }

    public function hasPromoteReleaseOperation()
    {
        return $this->hasOneof(13);
    }

    /**
     * Output only. Promotes a release to a specified 'Target'.
     *
     * Generated from protobuf field <code>.google.cloud.deploy.v1.PromoteReleaseOperation promote_release_operation = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\Deploy\V1\PromoteReleaseOperation $var
     * @return $this
     */
    public function setPromoteReleaseOperation($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Deploy\V1\PromoteReleaseOperation::class);
        $this->writeOneof(13, $var);

        return $this;
    }

    /**
     * Output only. Advances a rollout to the next phase.
     *
     * Generated from protobuf field <code>.google.cloud.deploy.v1.AdvanceRolloutOperation advance_rollout_operation = 14 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\Deploy\V1\AdvanceRolloutOperation|null
     */
    public function getAdvanceRolloutOperation()
    {
        return $this->readOneof(14);
    }

    public function hasAdvanceRolloutOperation()
    {
        return $this->hasOneof(14);
    }

    /**
     * Output only. Advances a rollout to the next phase.
     *
     * Generated from protobuf field <code>.google.cloud.deploy.v1.AdvanceRolloutOperation advance_rollout_operation = 14 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\Deploy\V1\AdvanceRolloutOperation $var
     * @return $this
     */
    public function setAdvanceRolloutOperation($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Deploy\V1\AdvanceRolloutOperation::class);
        $this->writeOneof(14, $var);

        return $this;
    }

    /**
     * Output only. Repairs a failed 'Rollout'.
     *
     * Generated from protobuf field <code>.google.cloud.deploy.v1.RepairRolloutOperation repair_rollout_operation = 17 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\Deploy\V1\RepairRolloutOperation|null
     */
    public function getRepairRolloutOperation()
    {
        return $this->readOneof(17);
    }

    public function hasRepairRolloutOperation()
    {
        return $this->hasOneof(17);
    }

    /**
     * Output only. Repairs a failed 'Rollout'.
     *
     * Generated from protobuf field <code>.google.cloud.deploy.v1.RepairRolloutOperation repair_rollout_operation = 17 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\Deploy\V1\RepairRolloutOperation $var
     * @return $this
     */
    public function setRepairRolloutOperation($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Deploy\V1\RepairRolloutOperation::class);
        $this->writeOneof(17, $var);

        return $this;
    }

    /**
     * Output only. Earliest time the `AutomationRun` will attempt to resume.
     * Wait-time is configured by `wait` in automation rule.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp wait_until_time = 16 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getWaitUntilTime()
    {
        return $this->wait_until_time;
    }

    public function hasWaitUntilTime()
    {
        return isset($this->wait_until_time);
    }

    public function clearWaitUntilTime()
    {
        unset($this->wait_until_time);
    }

    /**
     * Output only. Earliest time the `AutomationRun` will attempt to resume.
     * Wait-time is configured by `wait` in automation rule.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp wait_until_time = 16 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setWaitUntilTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->wait_until_time = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getOperation()
    {
        return $this->whichOneof("operation");
    }

}

