<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/deploy/v1/cloud_deploy.proto

namespace Google\Cloud\Deploy\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * CloudRunConfig contains the Cloud Run runtime configuration.
 *
 * Generated from protobuf message <code>google.cloud.deploy.v1.CloudRunConfig</code>
 */
class CloudRunConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * Whether Cloud Deploy should update the traffic stanza in a Cloud Run
     * Service on the user's behalf to facilitate traffic splitting. This is
     * required to be true for CanaryDeployments, but optional for
     * CustomCanaryDeployments.
     *
     * Generated from protobuf field <code>bool automatic_traffic_control = 1;</code>
     */
    protected $automatic_traffic_control = false;
    /**
     * Optional. A list of tags that are added to the canary revision while the
     * canary phase is in progress.
     *
     * Generated from protobuf field <code>repeated string canary_revision_tags = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $canary_revision_tags;
    /**
     * Optional. A list of tags that are added to the prior revision while the
     * canary phase is in progress.
     *
     * Generated from protobuf field <code>repeated string prior_revision_tags = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $prior_revision_tags;
    /**
     * Optional. A list of tags that are added to the final stable revision when
     * the stable phase is applied.
     *
     * Generated from protobuf field <code>repeated string stable_revision_tags = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $stable_revision_tags;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type bool $automatic_traffic_control
     *           Whether Cloud Deploy should update the traffic stanza in a Cloud Run
     *           Service on the user's behalf to facilitate traffic splitting. This is
     *           required to be true for CanaryDeployments, but optional for
     *           CustomCanaryDeployments.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $canary_revision_tags
     *           Optional. A list of tags that are added to the canary revision while the
     *           canary phase is in progress.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $prior_revision_tags
     *           Optional. A list of tags that are added to the prior revision while the
     *           canary phase is in progress.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $stable_revision_tags
     *           Optional. A list of tags that are added to the final stable revision when
     *           the stable phase is applied.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Deploy\V1\CloudDeploy::initOnce();
        parent::__construct($data);
    }

    /**
     * Whether Cloud Deploy should update the traffic stanza in a Cloud Run
     * Service on the user's behalf to facilitate traffic splitting. This is
     * required to be true for CanaryDeployments, but optional for
     * CustomCanaryDeployments.
     *
     * Generated from protobuf field <code>bool automatic_traffic_control = 1;</code>
     * @return bool
     */
    public function getAutomaticTrafficControl()
    {
        return $this->automatic_traffic_control;
    }

    /**
     * Whether Cloud Deploy should update the traffic stanza in a Cloud Run
     * Service on the user's behalf to facilitate traffic splitting. This is
     * required to be true for CanaryDeployments, but optional for
     * CustomCanaryDeployments.
     *
     * Generated from protobuf field <code>bool automatic_traffic_control = 1;</code>
     * @param bool $var
     * @return $this
     */
    public function setAutomaticTrafficControl($var)
    {
        GPBUtil::checkBool($var);
        $this->automatic_traffic_control = $var;

        return $this;
    }

    /**
     * Optional. A list of tags that are added to the canary revision while the
     * canary phase is in progress.
     *
     * Generated from protobuf field <code>repeated string canary_revision_tags = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getCanaryRevisionTags()
    {
        return $this->canary_revision_tags;
    }

    /**
     * Optional. A list of tags that are added to the canary revision while the
     * canary phase is in progress.
     *
     * Generated from protobuf field <code>repeated string canary_revision_tags = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setCanaryRevisionTags($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->canary_revision_tags = $arr;

        return $this;
    }

    /**
     * Optional. A list of tags that are added to the prior revision while the
     * canary phase is in progress.
     *
     * Generated from protobuf field <code>repeated string prior_revision_tags = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getPriorRevisionTags()
    {
        return $this->prior_revision_tags;
    }

    /**
     * Optional. A list of tags that are added to the prior revision while the
     * canary phase is in progress.
     *
     * Generated from protobuf field <code>repeated string prior_revision_tags = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setPriorRevisionTags($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->prior_revision_tags = $arr;

        return $this;
    }

    /**
     * Optional. A list of tags that are added to the final stable revision when
     * the stable phase is applied.
     *
     * Generated from protobuf field <code>repeated string stable_revision_tags = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getStableRevisionTags()
    {
        return $this->stable_revision_tags;
    }

    /**
     * Optional. A list of tags that are added to the final stable revision when
     * the stable phase is applied.
     *
     * Generated from protobuf field <code>repeated string stable_revision_tags = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setStableRevisionTags($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->stable_revision_tags = $arr;

        return $this;
    }

}

