<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/deploy/v1/cloud_deploy.proto

namespace Google\Cloud\Deploy\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * CustomTargetSkaffoldActions represents the `CustomTargetType` configuration
 * using Skaffold custom actions.
 *
 * Generated from protobuf message <code>google.cloud.deploy.v1.CustomTargetSkaffoldActions</code>
 */
class CustomTargetSkaffoldActions extends \Google\Protobuf\Internal\Message
{
    /**
     * Optional. The Skaffold custom action responsible for render operations. If
     * not provided then Cloud Deploy will perform the render operations via
     * `skaffold render`.
     *
     * Generated from protobuf field <code>string render_action = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $render_action = '';
    /**
     * Required. The Skaffold custom action responsible for deploy operations.
     *
     * Generated from protobuf field <code>string deploy_action = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $deploy_action = '';
    /**
     * Optional. List of Skaffold modules Cloud Deploy will include in the
     * Skaffold Config as required before performing diagnose.
     *
     * Generated from protobuf field <code>repeated .google.cloud.deploy.v1.SkaffoldModules include_skaffold_modules = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $include_skaffold_modules;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $render_action
     *           Optional. The Skaffold custom action responsible for render operations. If
     *           not provided then Cloud Deploy will perform the render operations via
     *           `skaffold render`.
     *     @type string $deploy_action
     *           Required. The Skaffold custom action responsible for deploy operations.
     *     @type array<\Google\Cloud\Deploy\V1\SkaffoldModules>|\Google\Protobuf\Internal\RepeatedField $include_skaffold_modules
     *           Optional. List of Skaffold modules Cloud Deploy will include in the
     *           Skaffold Config as required before performing diagnose.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Deploy\V1\CloudDeploy::initOnce();
        parent::__construct($data);
    }

    /**
     * Optional. The Skaffold custom action responsible for render operations. If
     * not provided then Cloud Deploy will perform the render operations via
     * `skaffold render`.
     *
     * Generated from protobuf field <code>string render_action = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getRenderAction()
    {
        return $this->render_action;
    }

    /**
     * Optional. The Skaffold custom action responsible for render operations. If
     * not provided then Cloud Deploy will perform the render operations via
     * `skaffold render`.
     *
     * Generated from protobuf field <code>string render_action = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setRenderAction($var)
    {
        GPBUtil::checkString($var, True);
        $this->render_action = $var;

        return $this;
    }

    /**
     * Required. The Skaffold custom action responsible for deploy operations.
     *
     * Generated from protobuf field <code>string deploy_action = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getDeployAction()
    {
        return $this->deploy_action;
    }

    /**
     * Required. The Skaffold custom action responsible for deploy operations.
     *
     * Generated from protobuf field <code>string deploy_action = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setDeployAction($var)
    {
        GPBUtil::checkString($var, True);
        $this->deploy_action = $var;

        return $this;
    }

    /**
     * Optional. List of Skaffold modules Cloud Deploy will include in the
     * Skaffold Config as required before performing diagnose.
     *
     * Generated from protobuf field <code>repeated .google.cloud.deploy.v1.SkaffoldModules include_skaffold_modules = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getIncludeSkaffoldModules()
    {
        return $this->include_skaffold_modules;
    }

    /**
     * Optional. List of Skaffold modules Cloud Deploy will include in the
     * Skaffold Config as required before performing diagnose.
     *
     * Generated from protobuf field <code>repeated .google.cloud.deploy.v1.SkaffoldModules include_skaffold_modules = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<\Google\Cloud\Deploy\V1\SkaffoldModules>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setIncludeSkaffoldModules($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Deploy\V1\SkaffoldModules::class);
        $this->include_skaffold_modules = $arr;

        return $this;
    }

}

