<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/deploy/v1/cloud_deploy.proto

namespace Google\Cloud\Deploy\V1\KubernetesConfig;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Information about the Kubernetes Service networking configuration.
 *
 * Generated from protobuf message <code>google.cloud.deploy.v1.KubernetesConfig.ServiceNetworking</code>
 */
class ServiceNetworking extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Name of the Kubernetes Service.
     *
     * Generated from protobuf field <code>string service = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $service = '';
    /**
     * Required. Name of the Kubernetes Deployment whose traffic is managed by
     * the specified Service.
     *
     * Generated from protobuf field <code>string deployment = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $deployment = '';
    /**
     * Optional. Whether to disable Pod overprovisioning. If Pod
     * overprovisioning is disabled then Cloud Deploy will limit the number of
     * total Pods used for the deployment strategy to the number of Pods the
     * Deployment has on the cluster.
     *
     * Generated from protobuf field <code>bool disable_pod_overprovisioning = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $disable_pod_overprovisioning = false;
    /**
     * Optional. The label to use when selecting Pods for the Deployment
     * resource. This label must already be present in the Deployment.
     *
     * Generated from protobuf field <code>string pod_selector_label = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $pod_selector_label = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $service
     *           Required. Name of the Kubernetes Service.
     *     @type string $deployment
     *           Required. Name of the Kubernetes Deployment whose traffic is managed by
     *           the specified Service.
     *     @type bool $disable_pod_overprovisioning
     *           Optional. Whether to disable Pod overprovisioning. If Pod
     *           overprovisioning is disabled then Cloud Deploy will limit the number of
     *           total Pods used for the deployment strategy to the number of Pods the
     *           Deployment has on the cluster.
     *     @type string $pod_selector_label
     *           Optional. The label to use when selecting Pods for the Deployment
     *           resource. This label must already be present in the Deployment.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Deploy\V1\CloudDeploy::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Name of the Kubernetes Service.
     *
     * Generated from protobuf field <code>string service = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getService()
    {
        return $this->service;
    }

    /**
     * Required. Name of the Kubernetes Service.
     *
     * Generated from protobuf field <code>string service = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setService($var)
    {
        GPBUtil::checkString($var, True);
        $this->service = $var;

        return $this;
    }

    /**
     * Required. Name of the Kubernetes Deployment whose traffic is managed by
     * the specified Service.
     *
     * Generated from protobuf field <code>string deployment = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getDeployment()
    {
        return $this->deployment;
    }

    /**
     * Required. Name of the Kubernetes Deployment whose traffic is managed by
     * the specified Service.
     *
     * Generated from protobuf field <code>string deployment = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setDeployment($var)
    {
        GPBUtil::checkString($var, True);
        $this->deployment = $var;

        return $this;
    }

    /**
     * Optional. Whether to disable Pod overprovisioning. If Pod
     * overprovisioning is disabled then Cloud Deploy will limit the number of
     * total Pods used for the deployment strategy to the number of Pods the
     * Deployment has on the cluster.
     *
     * Generated from protobuf field <code>bool disable_pod_overprovisioning = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getDisablePodOverprovisioning()
    {
        return $this->disable_pod_overprovisioning;
    }

    /**
     * Optional. Whether to disable Pod overprovisioning. If Pod
     * overprovisioning is disabled then Cloud Deploy will limit the number of
     * total Pods used for the deployment strategy to the number of Pods the
     * Deployment has on the cluster.
     *
     * Generated from protobuf field <code>bool disable_pod_overprovisioning = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setDisablePodOverprovisioning($var)
    {
        GPBUtil::checkBool($var);
        $this->disable_pod_overprovisioning = $var;

        return $this;
    }

    /**
     * Optional. The label to use when selecting Pods for the Deployment
     * resource. This label must already be present in the Deployment.
     *
     * Generated from protobuf field <code>string pod_selector_label = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPodSelectorLabel()
    {
        return $this->pod_selector_label;
    }

    /**
     * Optional. The label to use when selecting Pods for the Deployment
     * resource. This label must already be present in the Deployment.
     *
     * Generated from protobuf field <code>string pod_selector_label = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPodSelectorLabel($var)
    {
        GPBUtil::checkString($var, True);
        $this->pod_selector_label = $var;

        return $this;
    }

}


