<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/developerconnect/v1/developer_connect.proto

namespace Google\Cloud\DeveloperConnect\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message describing Connection object
 *
 * Generated from protobuf message <code>google.cloud.developerconnect.v1.Connection</code>
 */
class Connection extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. The resource name of the connection, in the format
     * `projects/{project}/locations/{location}/connections/{connection_id}`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Output only. [Output only] Create timestamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. [Output only] Update timestamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Output only. [Output only] Delete timestamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp delete_time = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $delete_time = null;
    /**
     * Optional. Labels as key value pairs
     *
     * Generated from protobuf field <code>map<string, string> labels = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $labels;
    /**
     * Output only. Installation state of the Connection.
     *
     * Generated from protobuf field <code>.google.cloud.developerconnect.v1.InstallationState installation_state = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $installation_state = null;
    /**
     * Optional. If disabled is set to true, functionality is disabled for this
     * connection. Repository based API methods and webhooks processing for
     * repositories in this connection will be disabled.
     *
     * Generated from protobuf field <code>bool disabled = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $disabled = false;
    /**
     * Output only. Set to true when the connection is being set up or updated in
     * the background.
     *
     * Generated from protobuf field <code>bool reconciling = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $reconciling = false;
    /**
     * Optional. Allows clients to store small amounts of arbitrary data.
     *
     * Generated from protobuf field <code>map<string, string> annotations = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $annotations;
    /**
     * Optional. This checksum is computed by the server based on the value of
     * other fields, and may be sent on update and delete requests to ensure the
     * client has an up-to-date value before proceeding.
     *
     * Generated from protobuf field <code>string etag = 10 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $etag = '';
    /**
     * Output only. A system-assigned unique identifier for a the
     * GitRepositoryLink.
     *
     * Generated from protobuf field <code>string uid = 12 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_info) = {</code>
     */
    protected $uid = '';
    protected $connection_config;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\DeveloperConnect\V1\GitHubConfig $github_config
     *           Configuration for connections to github.com.
     *     @type string $name
     *           Identifier. The resource name of the connection, in the format
     *           `projects/{project}/locations/{location}/connections/{connection_id}`.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. [Output only] Create timestamp
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. [Output only] Update timestamp
     *     @type \Google\Protobuf\Timestamp $delete_time
     *           Output only. [Output only] Delete timestamp
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Optional. Labels as key value pairs
     *     @type \Google\Cloud\DeveloperConnect\V1\InstallationState $installation_state
     *           Output only. Installation state of the Connection.
     *     @type bool $disabled
     *           Optional. If disabled is set to true, functionality is disabled for this
     *           connection. Repository based API methods and webhooks processing for
     *           repositories in this connection will be disabled.
     *     @type bool $reconciling
     *           Output only. Set to true when the connection is being set up or updated in
     *           the background.
     *     @type array|\Google\Protobuf\Internal\MapField $annotations
     *           Optional. Allows clients to store small amounts of arbitrary data.
     *     @type string $etag
     *           Optional. This checksum is computed by the server based on the value of
     *           other fields, and may be sent on update and delete requests to ensure the
     *           client has an up-to-date value before proceeding.
     *     @type string $uid
     *           Output only. A system-assigned unique identifier for a the
     *           GitRepositoryLink.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Developerconnect\V1\DeveloperConnect::initOnce();
        parent::__construct($data);
    }

    /**
     * Configuration for connections to github.com.
     *
     * Generated from protobuf field <code>.google.cloud.developerconnect.v1.GitHubConfig github_config = 5;</code>
     * @return \Google\Cloud\DeveloperConnect\V1\GitHubConfig|null
     */
    public function getGithubConfig()
    {
        return $this->readOneof(5);
    }

    public function hasGithubConfig()
    {
        return $this->hasOneof(5);
    }

    /**
     * Configuration for connections to github.com.
     *
     * Generated from protobuf field <code>.google.cloud.developerconnect.v1.GitHubConfig github_config = 5;</code>
     * @param \Google\Cloud\DeveloperConnect\V1\GitHubConfig $var
     * @return $this
     */
    public function setGithubConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DeveloperConnect\V1\GitHubConfig::class);
        $this->writeOneof(5, $var);

        return $this;
    }

    /**
     * Identifier. The resource name of the connection, in the format
     * `projects/{project}/locations/{location}/connections/{connection_id}`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. The resource name of the connection, in the format
     * `projects/{project}/locations/{location}/connections/{connection_id}`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. [Output only] Create timestamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. [Output only] Create timestamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. [Output only] Update timestamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. [Output only] Update timestamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Output only. [Output only] Delete timestamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp delete_time = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getDeleteTime()
    {
        return $this->delete_time;
    }

    public function hasDeleteTime()
    {
        return isset($this->delete_time);
    }

    public function clearDeleteTime()
    {
        unset($this->delete_time);
    }

    /**
     * Output only. [Output only] Delete timestamp
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp delete_time = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setDeleteTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->delete_time = $var;

        return $this;
    }

    /**
     * Optional. Labels as key value pairs
     *
     * Generated from protobuf field <code>map<string, string> labels = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Optional. Labels as key value pairs
     *
     * Generated from protobuf field <code>map<string, string> labels = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * Output only. Installation state of the Connection.
     *
     * Generated from protobuf field <code>.google.cloud.developerconnect.v1.InstallationState installation_state = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\DeveloperConnect\V1\InstallationState|null
     */
    public function getInstallationState()
    {
        return $this->installation_state;
    }

    public function hasInstallationState()
    {
        return isset($this->installation_state);
    }

    public function clearInstallationState()
    {
        unset($this->installation_state);
    }

    /**
     * Output only. Installation state of the Connection.
     *
     * Generated from protobuf field <code>.google.cloud.developerconnect.v1.InstallationState installation_state = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\DeveloperConnect\V1\InstallationState $var
     * @return $this
     */
    public function setInstallationState($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DeveloperConnect\V1\InstallationState::class);
        $this->installation_state = $var;

        return $this;
    }

    /**
     * Optional. If disabled is set to true, functionality is disabled for this
     * connection. Repository based API methods and webhooks processing for
     * repositories in this connection will be disabled.
     *
     * Generated from protobuf field <code>bool disabled = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getDisabled()
    {
        return $this->disabled;
    }

    /**
     * Optional. If disabled is set to true, functionality is disabled for this
     * connection. Repository based API methods and webhooks processing for
     * repositories in this connection will be disabled.
     *
     * Generated from protobuf field <code>bool disabled = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setDisabled($var)
    {
        GPBUtil::checkBool($var);
        $this->disabled = $var;

        return $this;
    }

    /**
     * Output only. Set to true when the connection is being set up or updated in
     * the background.
     *
     * Generated from protobuf field <code>bool reconciling = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return bool
     */
    public function getReconciling()
    {
        return $this->reconciling;
    }

    /**
     * Output only. Set to true when the connection is being set up or updated in
     * the background.
     *
     * Generated from protobuf field <code>bool reconciling = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param bool $var
     * @return $this
     */
    public function setReconciling($var)
    {
        GPBUtil::checkBool($var);
        $this->reconciling = $var;

        return $this;
    }

    /**
     * Optional. Allows clients to store small amounts of arbitrary data.
     *
     * Generated from protobuf field <code>map<string, string> annotations = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getAnnotations()
    {
        return $this->annotations;
    }

    /**
     * Optional. Allows clients to store small amounts of arbitrary data.
     *
     * Generated from protobuf field <code>map<string, string> annotations = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setAnnotations($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->annotations = $arr;

        return $this;
    }

    /**
     * Optional. This checksum is computed by the server based on the value of
     * other fields, and may be sent on update and delete requests to ensure the
     * client has an up-to-date value before proceeding.
     *
     * Generated from protobuf field <code>string etag = 10 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getEtag()
    {
        return $this->etag;
    }

    /**
     * Optional. This checksum is computed by the server based on the value of
     * other fields, and may be sent on update and delete requests to ensure the
     * client has an up-to-date value before proceeding.
     *
     * Generated from protobuf field <code>string etag = 10 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setEtag($var)
    {
        GPBUtil::checkString($var, True);
        $this->etag = $var;

        return $this;
    }

    /**
     * Output only. A system-assigned unique identifier for a the
     * GitRepositoryLink.
     *
     * Generated from protobuf field <code>string uid = 12 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_info) = {</code>
     * @return string
     */
    public function getUid()
    {
        return $this->uid;
    }

    /**
     * Output only. A system-assigned unique identifier for a the
     * GitRepositoryLink.
     *
     * Generated from protobuf field <code>string uid = 12 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_info) = {</code>
     * @param string $var
     * @return $this
     */
    public function setUid($var)
    {
        GPBUtil::checkString($var, True);
        $this->uid = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getConnectionConfig()
    {
        return $this->whichOneof("connection_config");
    }

}

