<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/developerconnect/v1/developer_connect.proto

namespace Google\Cloud\DeveloperConnect\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message for creating a GitRepositoryLink
 *
 * Generated from protobuf message <code>google.cloud.developerconnect.v1.CreateGitRepositoryLinkRequest</code>
 */
class CreateGitRepositoryLinkRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Value for parent.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The resource being created
     *
     * Generated from protobuf field <code>.google.cloud.developerconnect.v1.GitRepositoryLink git_repository_link = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $git_repository_link = null;
    /**
     * Required. The ID to use for the repository, which will become the final
     * component of the repository's resource name. This ID should be unique in
     * the connection. Allows alphanumeric characters and any of
     * -._~%!$&'()*+,;=&#64;.
     *
     * Generated from protobuf field <code>string git_repository_link_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $git_repository_link_id = '';
    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL, (.google.api.field_info) = {</code>
     */
    protected $request_id = '';
    /**
     * Optional. If set, validate the request, but do not actually post it.
     *
     * Generated from protobuf field <code>bool validate_only = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $validate_only = false;

    /**
     * @param string                                              $parent              Required. Value for parent. Please see
     *                                                                                 {@see DeveloperConnectClient::connectionName()} for help formatting this field.
     * @param \Google\Cloud\DeveloperConnect\V1\GitRepositoryLink $gitRepositoryLink   Required. The resource being created
     * @param string                                              $gitRepositoryLinkId Required. The ID to use for the repository, which will become the final
     *                                                                                 component of the repository's resource name. This ID should be unique in
     *                                                                                 the connection. Allows alphanumeric characters and any of
     *                                                                                 -._~%!$&'()*+,;=&#64;.
     *
     * @return \Google\Cloud\DeveloperConnect\V1\CreateGitRepositoryLinkRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\DeveloperConnect\V1\GitRepositoryLink $gitRepositoryLink, string $gitRepositoryLinkId): self
    {
        return (new self())
            ->setParent($parent)
            ->setGitRepositoryLink($gitRepositoryLink)
            ->setGitRepositoryLinkId($gitRepositoryLinkId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Value for parent.
     *     @type \Google\Cloud\DeveloperConnect\V1\GitRepositoryLink $git_repository_link
     *           Required. The resource being created
     *     @type string $git_repository_link_id
     *           Required. The ID to use for the repository, which will become the final
     *           component of the repository's resource name. This ID should be unique in
     *           the connection. Allows alphanumeric characters and any of
     *           -._~%!$&'()*+,;=&#64;.
     *     @type string $request_id
     *           Optional. An optional request ID to identify requests. Specify a unique
     *           request ID so that if you must retry your request, the server will know to
     *           ignore the request if it has already been completed. The server will
     *           guarantee that for at least 60 minutes since the first request.
     *           For example, consider a situation where you make an initial request and the
     *           request times out. If you make the request again with the same request
     *           ID, the server can check if original operation with the same request ID
     *           was received, and if so, will ignore the second request. This prevents
     *           clients from accidentally creating duplicate commitments.
     *           The request ID must be a valid UUID with the exception that zero UUID is
     *           not supported (00000000-0000-0000-0000-000000000000).
     *     @type bool $validate_only
     *           Optional. If set, validate the request, but do not actually post it.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Developerconnect\V1\DeveloperConnect::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Value for parent.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Value for parent.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The resource being created
     *
     * Generated from protobuf field <code>.google.cloud.developerconnect.v1.GitRepositoryLink git_repository_link = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\DeveloperConnect\V1\GitRepositoryLink|null
     */
    public function getGitRepositoryLink()
    {
        return $this->git_repository_link;
    }

    public function hasGitRepositoryLink()
    {
        return isset($this->git_repository_link);
    }

    public function clearGitRepositoryLink()
    {
        unset($this->git_repository_link);
    }

    /**
     * Required. The resource being created
     *
     * Generated from protobuf field <code>.google.cloud.developerconnect.v1.GitRepositoryLink git_repository_link = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\DeveloperConnect\V1\GitRepositoryLink $var
     * @return $this
     */
    public function setGitRepositoryLink($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DeveloperConnect\V1\GitRepositoryLink::class);
        $this->git_repository_link = $var;

        return $this;
    }

    /**
     * Required. The ID to use for the repository, which will become the final
     * component of the repository's resource name. This ID should be unique in
     * the connection. Allows alphanumeric characters and any of
     * -._~%!$&'()*+,;=&#64;.
     *
     * Generated from protobuf field <code>string git_repository_link_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getGitRepositoryLinkId()
    {
        return $this->git_repository_link_id;
    }

    /**
     * Required. The ID to use for the repository, which will become the final
     * component of the repository's resource name. This ID should be unique in
     * the connection. Allows alphanumeric characters and any of
     * -._~%!$&'()*+,;=&#64;.
     *
     * Generated from protobuf field <code>string git_repository_link_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setGitRepositoryLinkId($var)
    {
        GPBUtil::checkString($var, True);
        $this->git_repository_link_id = $var;

        return $this;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL, (.google.api.field_info) = {</code>
     * @return string
     */
    public function getRequestId()
    {
        return $this->request_id;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL, (.google.api.field_info) = {</code>
     * @param string $var
     * @return $this
     */
    public function setRequestId($var)
    {
        GPBUtil::checkString($var, True);
        $this->request_id = $var;

        return $this;
    }

    /**
     * Optional. If set, validate the request, but do not actually post it.
     *
     * Generated from protobuf field <code>bool validate_only = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getValidateOnly()
    {
        return $this->validate_only;
    }

    /**
     * Optional. If set, validate the request, but do not actually post it.
     *
     * Generated from protobuf field <code>bool validate_only = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setValidateOnly($var)
    {
        GPBUtil::checkBool($var);
        $this->validate_only = $var;

        return $this;
    }

}

