<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/v2/intent.proto

namespace Google\Cloud\Dialogflow\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Generated from protobuf message <code>google.cloud.dialogflow.v2.BatchUpdateIntentsRequest</code>
 */
class BatchUpdateIntentsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the agent to update or create intents in.
     * Format: `projects/<Project ID>/agent`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * Optional. The language used to access language-specific data.
     * If not specified, the agent's default language is used.
     * For more information, see
     * [Multilingual intent and entity
     * data](https://cloud.google.com/dialogflow/docs/agents-multilingual#intent-entity).
     *
     * Generated from protobuf field <code>string language_code = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $language_code = '';
    /**
     * Optional. The mask to control which fields get updated.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $update_mask = null;
    /**
     * Optional. The resource view to apply to the returned intent.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.IntentView intent_view = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $intent_view = 0;
    protected $intent_batch;

    /**
     * @param string $parent         Required. The name of the agent to update or create intents in.
     *                               Format: `projects/<Project ID>/agent`. Please see
     *                               {@see IntentsClient::agentName()} for help formatting this field.
     * @param string $intentBatchUri The URI to a Google Cloud Storage file containing intents to update or
     *                               create. The file format can either be a serialized proto (of IntentBatch
     *                               type) or JSON object. Note: The URI must start with "gs://".
     *
     * @return \Google\Cloud\Dialogflow\V2\BatchUpdateIntentsRequest
     *
     * @experimental
     */
    public static function build(string $parent, string $intentBatchUri): self
    {
        return (new self())
            ->setParent($parent)
            ->setIntentBatchUri($intentBatchUri);
    }

    /**
     * @param string                                  $parent            Required. The name of the agent to update or create intents in.
     *                                                                   Format: `projects/<Project ID>/agent`. Please see
     *                                                                   {@see IntentsClient::agentName()} for help formatting this field.
     * @param \Google\Cloud\Dialogflow\V2\IntentBatch $intentBatchInline The collection of intents to update or create.
     *
     * @return \Google\Cloud\Dialogflow\V2\BatchUpdateIntentsRequest
     *
     * @experimental
     */
    public static function buildFromParentIntentBatchInline(string $parent, \Google\Cloud\Dialogflow\V2\IntentBatch $intentBatchInline): self
    {
        return (new self())
            ->setParent($parent)
            ->setIntentBatchInline($intentBatchInline);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The name of the agent to update or create intents in.
     *           Format: `projects/<Project ID>/agent`.
     *     @type string $intent_batch_uri
     *           The URI to a Google Cloud Storage file containing intents to update or
     *           create. The file format can either be a serialized proto (of IntentBatch
     *           type) or JSON object. Note: The URI must start with "gs://".
     *     @type \Google\Cloud\Dialogflow\V2\IntentBatch $intent_batch_inline
     *           The collection of intents to update or create.
     *     @type string $language_code
     *           Optional. The language used to access language-specific data.
     *           If not specified, the agent's default language is used.
     *           For more information, see
     *           [Multilingual intent and entity
     *           data](https://cloud.google.com/dialogflow/docs/agents-multilingual#intent-entity).
     *     @type \Google\Protobuf\FieldMask $update_mask
     *           Optional. The mask to control which fields get updated.
     *     @type int $intent_view
     *           Optional. The resource view to apply to the returned intent.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\V2\Intent::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the agent to update or create intents in.
     * Format: `projects/<Project ID>/agent`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The name of the agent to update or create intents in.
     * Format: `projects/<Project ID>/agent`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * The URI to a Google Cloud Storage file containing intents to update or
     * create. The file format can either be a serialized proto (of IntentBatch
     * type) or JSON object. Note: The URI must start with "gs://".
     *
     * Generated from protobuf field <code>string intent_batch_uri = 2;</code>
     * @return string
     */
    public function getIntentBatchUri()
    {
        return $this->readOneof(2);
    }

    public function hasIntentBatchUri()
    {
        return $this->hasOneof(2);
    }

    /**
     * The URI to a Google Cloud Storage file containing intents to update or
     * create. The file format can either be a serialized proto (of IntentBatch
     * type) or JSON object. Note: The URI must start with "gs://".
     *
     * Generated from protobuf field <code>string intent_batch_uri = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setIntentBatchUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     * The collection of intents to update or create.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.IntentBatch intent_batch_inline = 3;</code>
     * @return \Google\Cloud\Dialogflow\V2\IntentBatch|null
     */
    public function getIntentBatchInline()
    {
        return $this->readOneof(3);
    }

    public function hasIntentBatchInline()
    {
        return $this->hasOneof(3);
    }

    /**
     * The collection of intents to update or create.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.IntentBatch intent_batch_inline = 3;</code>
     * @param \Google\Cloud\Dialogflow\V2\IntentBatch $var
     * @return $this
     */
    public function setIntentBatchInline($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\V2\IntentBatch::class);
        $this->writeOneof(3, $var);

        return $this;
    }

    /**
     * Optional. The language used to access language-specific data.
     * If not specified, the agent's default language is used.
     * For more information, see
     * [Multilingual intent and entity
     * data](https://cloud.google.com/dialogflow/docs/agents-multilingual#intent-entity).
     *
     * Generated from protobuf field <code>string language_code = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getLanguageCode()
    {
        return $this->language_code;
    }

    /**
     * Optional. The language used to access language-specific data.
     * If not specified, the agent's default language is used.
     * For more information, see
     * [Multilingual intent and entity
     * data](https://cloud.google.com/dialogflow/docs/agents-multilingual#intent-entity).
     *
     * Generated from protobuf field <code>string language_code = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setLanguageCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->language_code = $var;

        return $this;
    }

    /**
     * Optional. The mask to control which fields get updated.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\FieldMask|null
     */
    public function getUpdateMask()
    {
        return $this->update_mask;
    }

    public function hasUpdateMask()
    {
        return isset($this->update_mask);
    }

    public function clearUpdateMask()
    {
        unset($this->update_mask);
    }

    /**
     * Optional. The mask to control which fields get updated.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Protobuf\FieldMask $var
     * @return $this
     */
    public function setUpdateMask($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\FieldMask::class);
        $this->update_mask = $var;

        return $this;
    }

    /**
     * Optional. The resource view to apply to the returned intent.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.IntentView intent_view = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getIntentView()
    {
        return $this->intent_view;
    }

    /**
     * Optional. The resource view to apply to the returned intent.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.IntentView intent_view = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setIntentView($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Dialogflow\V2\IntentView::class);
        $this->intent_view = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getIntentBatch()
    {
        return $this->whichOneof("intent_batch");
    }

}

