<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/v2/conversation_profile.proto

namespace Google\Cloud\Dialogflow\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for [ConversationProfiles.ClearFeature][].
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.v2.ClearSuggestionFeatureConfigRequest</code>
 */
class ClearSuggestionFeatureConfigRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The Conversation Profile to add or update the suggestion feature
     * config. Format: `projects/<Project ID>/locations/<Location
     * ID>/conversationProfiles/<Conversation Profile ID>`.
     *
     * Generated from protobuf field <code>string conversation_profile = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $conversation_profile = '';
    /**
     * Required. The participant role to remove the suggestion feature
     * config. Only HUMAN_AGENT or END_USER can be used.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.Participant.Role participant_role = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $participant_role = 0;
    /**
     * Required. The type of the suggestion feature to remove.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.SuggestionFeature.Type suggestion_feature_type = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $suggestion_feature_type = 0;

    /**
     * @param string $conversationProfile Required. The Conversation Profile to add or update the suggestion feature
     *                                    config. Format: `projects/<Project ID>/locations/<Location
     *                                    ID>/conversationProfiles/<Conversation Profile ID>`.
     *
     * @return \Google\Cloud\Dialogflow\V2\ClearSuggestionFeatureConfigRequest
     *
     * @experimental
     */
    public static function build(string $conversationProfile): self
    {
        return (new self())
            ->setConversationProfile($conversationProfile);
    }

    /**
     * @param string $conversationProfile   Required. The Conversation Profile to add or update the suggestion feature
     *                                      config. Format: `projects/<Project ID>/locations/<Location
     *                                      ID>/conversationProfiles/<Conversation Profile ID>`.
     * @param int    $participantRole       Required. The participant role to remove the suggestion feature
     *                                      config. Only HUMAN_AGENT or END_USER can be used.
     *                                      For allowed values, use constants defined on {@see \Google\Cloud\Dialogflow\V2\Participant\Role}
     * @param int    $suggestionFeatureType Required. The type of the suggestion feature to remove.
     *                                      For allowed values, use constants defined on {@see \Google\Cloud\Dialogflow\V2\SuggestionFeature\Type}
     *
     * @return \Google\Cloud\Dialogflow\V2\ClearSuggestionFeatureConfigRequest
     *
     * @experimental
     */
    public static function buildFromConversationProfileParticipantRoleSuggestionFeatureType(string $conversationProfile, int $participantRole, int $suggestionFeatureType): self
    {
        return (new self())
            ->setConversationProfile($conversationProfile)
            ->setParticipantRole($participantRole)
            ->setSuggestionFeatureType($suggestionFeatureType);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $conversation_profile
     *           Required. The Conversation Profile to add or update the suggestion feature
     *           config. Format: `projects/<Project ID>/locations/<Location
     *           ID>/conversationProfiles/<Conversation Profile ID>`.
     *     @type int $participant_role
     *           Required. The participant role to remove the suggestion feature
     *           config. Only HUMAN_AGENT or END_USER can be used.
     *     @type int $suggestion_feature_type
     *           Required. The type of the suggestion feature to remove.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\V2\ConversationProfile::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The Conversation Profile to add or update the suggestion feature
     * config. Format: `projects/<Project ID>/locations/<Location
     * ID>/conversationProfiles/<Conversation Profile ID>`.
     *
     * Generated from protobuf field <code>string conversation_profile = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getConversationProfile()
    {
        return $this->conversation_profile;
    }

    /**
     * Required. The Conversation Profile to add or update the suggestion feature
     * config. Format: `projects/<Project ID>/locations/<Location
     * ID>/conversationProfiles/<Conversation Profile ID>`.
     *
     * Generated from protobuf field <code>string conversation_profile = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setConversationProfile($var)
    {
        GPBUtil::checkString($var, True);
        $this->conversation_profile = $var;

        return $this;
    }

    /**
     * Required. The participant role to remove the suggestion feature
     * config. Only HUMAN_AGENT or END_USER can be used.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.Participant.Role participant_role = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return int
     */
    public function getParticipantRole()
    {
        return $this->participant_role;
    }

    /**
     * Required. The participant role to remove the suggestion feature
     * config. Only HUMAN_AGENT or END_USER can be used.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.Participant.Role participant_role = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int $var
     * @return $this
     */
    public function setParticipantRole($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Dialogflow\V2\Participant\Role::class);
        $this->participant_role = $var;

        return $this;
    }

    /**
     * Required. The type of the suggestion feature to remove.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.SuggestionFeature.Type suggestion_feature_type = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return int
     */
    public function getSuggestionFeatureType()
    {
        return $this->suggestion_feature_type;
    }

    /**
     * Required. The type of the suggestion feature to remove.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.SuggestionFeature.Type suggestion_feature_type = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int $var
     * @return $this
     */
    public function setSuggestionFeatureType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Dialogflow\V2\SuggestionFeature\Type::class);
        $this->suggestion_feature_type = $var;

        return $this;
    }

}

