<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/v2/context.proto

namespace Google\Cloud\Dialogflow\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for
 * [Contexts.CreateContext][google.cloud.dialogflow.v2.Contexts.CreateContext].
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.v2.CreateContextRequest</code>
 */
class CreateContextRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The session to create a context for.
     * Format: `projects/<Project ID>/agent/sessions/<Session ID>` or
     * `projects/<Project ID>/agent/environments/<Environment ID>/users/<User
     * ID>/sessions/<Session ID>`.
     * If `Environment ID` is not specified, we assume default 'draft'
     * environment. If `User ID` is not specified, we assume default '-' user.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * Required. The context to create.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.Context context = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $context = null;

    /**
     * @param string                              $parent  Required. The session to create a context for.
     *                                                     Format: `projects/<Project ID>/agent/sessions/<Session ID>` or
     *                                                     `projects/<Project ID>/agent/environments/<Environment ID>/users/<User
     *                                                     ID>/sessions/<Session ID>`.
     *                                                     If `Environment ID` is not specified, we assume default 'draft'
     *                                                     environment. If `User ID` is not specified, we assume default '-' user. Please see
     *                                                     {@see ContextsClient::sessionName()} for help formatting this field.
     * @param \Google\Cloud\Dialogflow\V2\Context $context Required. The context to create.
     *
     * @return \Google\Cloud\Dialogflow\V2\CreateContextRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\Dialogflow\V2\Context $context): self
    {
        return (new self())
            ->setParent($parent)
            ->setContext($context);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The session to create a context for.
     *           Format: `projects/<Project ID>/agent/sessions/<Session ID>` or
     *           `projects/<Project ID>/agent/environments/<Environment ID>/users/<User
     *           ID>/sessions/<Session ID>`.
     *           If `Environment ID` is not specified, we assume default 'draft'
     *           environment. If `User ID` is not specified, we assume default '-' user.
     *     @type \Google\Cloud\Dialogflow\V2\Context $context
     *           Required. The context to create.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\V2\Context::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The session to create a context for.
     * Format: `projects/<Project ID>/agent/sessions/<Session ID>` or
     * `projects/<Project ID>/agent/environments/<Environment ID>/users/<User
     * ID>/sessions/<Session ID>`.
     * If `Environment ID` is not specified, we assume default 'draft'
     * environment. If `User ID` is not specified, we assume default '-' user.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The session to create a context for.
     * Format: `projects/<Project ID>/agent/sessions/<Session ID>` or
     * `projects/<Project ID>/agent/environments/<Environment ID>/users/<User
     * ID>/sessions/<Session ID>`.
     * If `Environment ID` is not specified, we assume default 'draft'
     * environment. If `User ID` is not specified, we assume default '-' user.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The context to create.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.Context context = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\Dialogflow\V2\Context|null
     */
    public function getContext()
    {
        return $this->context;
    }

    public function hasContext()
    {
        return isset($this->context);
    }

    public function clearContext()
    {
        unset($this->context);
    }

    /**
     * Required. The context to create.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.Context context = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\Dialogflow\V2\Context $var
     * @return $this
     */
    public function setContext($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\V2\Context::class);
        $this->context = $var;

        return $this;
    }

}

