<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/v2/conversation_profile.proto

namespace Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Config for suggestion features.
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.v2.HumanAgentAssistantConfig.SuggestionFeatureConfig</code>
 */
class SuggestionFeatureConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * The suggestion feature.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.SuggestionFeature suggestion_feature = 5;</code>
     */
    private $suggestion_feature = null;
    /**
     * Automatically iterates all participants and tries to compile
     * suggestions.
     * Supported features: ARTICLE_SUGGESTION, FAQ, DIALOGFLOW_ASSIST,
     * KNOWLEDGE_ASSIST.
     *
     * Generated from protobuf field <code>bool enable_event_based_suggestion = 3;</code>
     */
    private $enable_event_based_suggestion = false;
    /**
     * Optional. Disable the logging of search queries sent by human agents. It
     * can prevent those queries from being stored at answer records.
     * Supported features: KNOWLEDGE_SEARCH.
     *
     * Generated from protobuf field <code>bool disable_agent_query_logging = 14 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $disable_agent_query_logging = false;
    /**
     * Optional. Enable query suggestion even if we can't find its answer.
     * By default, queries are suggested only if we find its answer.
     * Supported features: KNOWLEDGE_ASSIST
     *
     * Generated from protobuf field <code>bool enable_query_suggestion_when_no_answer = 15 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $enable_query_suggestion_when_no_answer = false;
    /**
     * Optional. Enable including conversation context during query answer
     * generation. Supported features: KNOWLEDGE_SEARCH.
     *
     * Generated from protobuf field <code>bool enable_conversation_augmented_query = 16 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $enable_conversation_augmented_query = false;
    /**
     * Optional. Enable query suggestion only.
     * Supported features: KNOWLEDGE_ASSIST
     *
     * Generated from protobuf field <code>bool enable_query_suggestion_only = 17 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $enable_query_suggestion_only = false;
    /**
     * Settings of suggestion trigger.
     * Currently, only ARTICLE_SUGGESTION and FAQ will use this field.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.HumanAgentAssistantConfig.SuggestionTriggerSettings suggestion_trigger_settings = 10;</code>
     */
    private $suggestion_trigger_settings = null;
    /**
     * Configs of query.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.HumanAgentAssistantConfig.SuggestionQueryConfig query_config = 6;</code>
     */
    private $query_config = null;
    /**
     * Configs of custom conversation model.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.HumanAgentAssistantConfig.ConversationModelConfig conversation_model_config = 7;</code>
     */
    private $conversation_model_config = null;
    /**
     * Configs for processing conversation.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.HumanAgentAssistantConfig.ConversationProcessConfig conversation_process_config = 8;</code>
     */
    private $conversation_process_config = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\Dialogflow\V2\SuggestionFeature $suggestion_feature
     *           The suggestion feature.
     *     @type bool $enable_event_based_suggestion
     *           Automatically iterates all participants and tries to compile
     *           suggestions.
     *           Supported features: ARTICLE_SUGGESTION, FAQ, DIALOGFLOW_ASSIST,
     *           KNOWLEDGE_ASSIST.
     *     @type bool $disable_agent_query_logging
     *           Optional. Disable the logging of search queries sent by human agents. It
     *           can prevent those queries from being stored at answer records.
     *           Supported features: KNOWLEDGE_SEARCH.
     *     @type bool $enable_query_suggestion_when_no_answer
     *           Optional. Enable query suggestion even if we can't find its answer.
     *           By default, queries are suggested only if we find its answer.
     *           Supported features: KNOWLEDGE_ASSIST
     *     @type bool $enable_conversation_augmented_query
     *           Optional. Enable including conversation context during query answer
     *           generation. Supported features: KNOWLEDGE_SEARCH.
     *     @type bool $enable_query_suggestion_only
     *           Optional. Enable query suggestion only.
     *           Supported features: KNOWLEDGE_ASSIST
     *     @type \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\SuggestionTriggerSettings $suggestion_trigger_settings
     *           Settings of suggestion trigger.
     *           Currently, only ARTICLE_SUGGESTION and FAQ will use this field.
     *     @type \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\SuggestionQueryConfig $query_config
     *           Configs of query.
     *     @type \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\ConversationModelConfig $conversation_model_config
     *           Configs of custom conversation model.
     *     @type \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\ConversationProcessConfig $conversation_process_config
     *           Configs for processing conversation.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\V2\ConversationProfile::initOnce();
        parent::__construct($data);
    }

    /**
     * The suggestion feature.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.SuggestionFeature suggestion_feature = 5;</code>
     * @return \Google\Cloud\Dialogflow\V2\SuggestionFeature|null
     */
    public function getSuggestionFeature()
    {
        return $this->suggestion_feature;
    }

    public function hasSuggestionFeature()
    {
        return isset($this->suggestion_feature);
    }

    public function clearSuggestionFeature()
    {
        unset($this->suggestion_feature);
    }

    /**
     * The suggestion feature.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.SuggestionFeature suggestion_feature = 5;</code>
     * @param \Google\Cloud\Dialogflow\V2\SuggestionFeature $var
     * @return $this
     */
    public function setSuggestionFeature($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\V2\SuggestionFeature::class);
        $this->suggestion_feature = $var;

        return $this;
    }

    /**
     * Automatically iterates all participants and tries to compile
     * suggestions.
     * Supported features: ARTICLE_SUGGESTION, FAQ, DIALOGFLOW_ASSIST,
     * KNOWLEDGE_ASSIST.
     *
     * Generated from protobuf field <code>bool enable_event_based_suggestion = 3;</code>
     * @return bool
     */
    public function getEnableEventBasedSuggestion()
    {
        return $this->enable_event_based_suggestion;
    }

    /**
     * Automatically iterates all participants and tries to compile
     * suggestions.
     * Supported features: ARTICLE_SUGGESTION, FAQ, DIALOGFLOW_ASSIST,
     * KNOWLEDGE_ASSIST.
     *
     * Generated from protobuf field <code>bool enable_event_based_suggestion = 3;</code>
     * @param bool $var
     * @return $this
     */
    public function setEnableEventBasedSuggestion($var)
    {
        GPBUtil::checkBool($var);
        $this->enable_event_based_suggestion = $var;

        return $this;
    }

    /**
     * Optional. Disable the logging of search queries sent by human agents. It
     * can prevent those queries from being stored at answer records.
     * Supported features: KNOWLEDGE_SEARCH.
     *
     * Generated from protobuf field <code>bool disable_agent_query_logging = 14 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getDisableAgentQueryLogging()
    {
        return $this->disable_agent_query_logging;
    }

    /**
     * Optional. Disable the logging of search queries sent by human agents. It
     * can prevent those queries from being stored at answer records.
     * Supported features: KNOWLEDGE_SEARCH.
     *
     * Generated from protobuf field <code>bool disable_agent_query_logging = 14 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setDisableAgentQueryLogging($var)
    {
        GPBUtil::checkBool($var);
        $this->disable_agent_query_logging = $var;

        return $this;
    }

    /**
     * Optional. Enable query suggestion even if we can't find its answer.
     * By default, queries are suggested only if we find its answer.
     * Supported features: KNOWLEDGE_ASSIST
     *
     * Generated from protobuf field <code>bool enable_query_suggestion_when_no_answer = 15 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getEnableQuerySuggestionWhenNoAnswer()
    {
        return $this->enable_query_suggestion_when_no_answer;
    }

    /**
     * Optional. Enable query suggestion even if we can't find its answer.
     * By default, queries are suggested only if we find its answer.
     * Supported features: KNOWLEDGE_ASSIST
     *
     * Generated from protobuf field <code>bool enable_query_suggestion_when_no_answer = 15 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setEnableQuerySuggestionWhenNoAnswer($var)
    {
        GPBUtil::checkBool($var);
        $this->enable_query_suggestion_when_no_answer = $var;

        return $this;
    }

    /**
     * Optional. Enable including conversation context during query answer
     * generation. Supported features: KNOWLEDGE_SEARCH.
     *
     * Generated from protobuf field <code>bool enable_conversation_augmented_query = 16 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getEnableConversationAugmentedQuery()
    {
        return $this->enable_conversation_augmented_query;
    }

    /**
     * Optional. Enable including conversation context during query answer
     * generation. Supported features: KNOWLEDGE_SEARCH.
     *
     * Generated from protobuf field <code>bool enable_conversation_augmented_query = 16 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setEnableConversationAugmentedQuery($var)
    {
        GPBUtil::checkBool($var);
        $this->enable_conversation_augmented_query = $var;

        return $this;
    }

    /**
     * Optional. Enable query suggestion only.
     * Supported features: KNOWLEDGE_ASSIST
     *
     * Generated from protobuf field <code>bool enable_query_suggestion_only = 17 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getEnableQuerySuggestionOnly()
    {
        return $this->enable_query_suggestion_only;
    }

    /**
     * Optional. Enable query suggestion only.
     * Supported features: KNOWLEDGE_ASSIST
     *
     * Generated from protobuf field <code>bool enable_query_suggestion_only = 17 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setEnableQuerySuggestionOnly($var)
    {
        GPBUtil::checkBool($var);
        $this->enable_query_suggestion_only = $var;

        return $this;
    }

    /**
     * Settings of suggestion trigger.
     * Currently, only ARTICLE_SUGGESTION and FAQ will use this field.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.HumanAgentAssistantConfig.SuggestionTriggerSettings suggestion_trigger_settings = 10;</code>
     * @return \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\SuggestionTriggerSettings|null
     */
    public function getSuggestionTriggerSettings()
    {
        return $this->suggestion_trigger_settings;
    }

    public function hasSuggestionTriggerSettings()
    {
        return isset($this->suggestion_trigger_settings);
    }

    public function clearSuggestionTriggerSettings()
    {
        unset($this->suggestion_trigger_settings);
    }

    /**
     * Settings of suggestion trigger.
     * Currently, only ARTICLE_SUGGESTION and FAQ will use this field.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.HumanAgentAssistantConfig.SuggestionTriggerSettings suggestion_trigger_settings = 10;</code>
     * @param \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\SuggestionTriggerSettings $var
     * @return $this
     */
    public function setSuggestionTriggerSettings($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\SuggestionTriggerSettings::class);
        $this->suggestion_trigger_settings = $var;

        return $this;
    }

    /**
     * Configs of query.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.HumanAgentAssistantConfig.SuggestionQueryConfig query_config = 6;</code>
     * @return \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\SuggestionQueryConfig|null
     */
    public function getQueryConfig()
    {
        return $this->query_config;
    }

    public function hasQueryConfig()
    {
        return isset($this->query_config);
    }

    public function clearQueryConfig()
    {
        unset($this->query_config);
    }

    /**
     * Configs of query.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.HumanAgentAssistantConfig.SuggestionQueryConfig query_config = 6;</code>
     * @param \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\SuggestionQueryConfig $var
     * @return $this
     */
    public function setQueryConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\SuggestionQueryConfig::class);
        $this->query_config = $var;

        return $this;
    }

    /**
     * Configs of custom conversation model.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.HumanAgentAssistantConfig.ConversationModelConfig conversation_model_config = 7;</code>
     * @return \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\ConversationModelConfig|null
     */
    public function getConversationModelConfig()
    {
        return $this->conversation_model_config;
    }

    public function hasConversationModelConfig()
    {
        return isset($this->conversation_model_config);
    }

    public function clearConversationModelConfig()
    {
        unset($this->conversation_model_config);
    }

    /**
     * Configs of custom conversation model.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.HumanAgentAssistantConfig.ConversationModelConfig conversation_model_config = 7;</code>
     * @param \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\ConversationModelConfig $var
     * @return $this
     */
    public function setConversationModelConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\ConversationModelConfig::class);
        $this->conversation_model_config = $var;

        return $this;
    }

    /**
     * Configs for processing conversation.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.HumanAgentAssistantConfig.ConversationProcessConfig conversation_process_config = 8;</code>
     * @return \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\ConversationProcessConfig|null
     */
    public function getConversationProcessConfig()
    {
        return $this->conversation_process_config;
    }

    public function hasConversationProcessConfig()
    {
        return isset($this->conversation_process_config);
    }

    public function clearConversationProcessConfig()
    {
        unset($this->conversation_process_config);
    }

    /**
     * Configs for processing conversation.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.HumanAgentAssistantConfig.ConversationProcessConfig conversation_process_config = 8;</code>
     * @param \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\ConversationProcessConfig $var
     * @return $this
     */
    public function setConversationProcessConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\ConversationProcessConfig::class);
        $this->conversation_process_config = $var;

        return $this;
    }

}


