<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/v2/conversation_profile.proto

namespace Google\Cloud\Dialogflow\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for
 * [ConversationProfiles.SetSuggestionFeature][].
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.v2.SetSuggestionFeatureConfigRequest</code>
 */
class SetSuggestionFeatureConfigRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The Conversation Profile to add or update the suggestion feature
     * config. Format: `projects/<Project ID>/locations/<Location
     * ID>/conversationProfiles/<Conversation Profile ID>`.
     *
     * Generated from protobuf field <code>string conversation_profile = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $conversation_profile = '';
    /**
     * Required. The participant role to add or update the suggestion feature
     * config. Only HUMAN_AGENT or END_USER can be used.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.Participant.Role participant_role = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $participant_role = 0;
    /**
     * Required. The suggestion feature config to add or update.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.HumanAgentAssistantConfig.SuggestionFeatureConfig suggestion_feature_config = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $suggestion_feature_config = null;

    /**
     * @param string $conversationProfile Required. The Conversation Profile to add or update the suggestion feature
     *                                    config. Format: `projects/<Project ID>/locations/<Location
     *                                    ID>/conversationProfiles/<Conversation Profile ID>`.
     *
     * @return \Google\Cloud\Dialogflow\V2\SetSuggestionFeatureConfigRequest
     *
     * @experimental
     */
    public static function build(string $conversationProfile): self
    {
        return (new self())
            ->setConversationProfile($conversationProfile);
    }

    /**
     * @param string                                                                        $conversationProfile     Required. The Conversation Profile to add or update the suggestion feature
     *                                                                                                               config. Format: `projects/<Project ID>/locations/<Location
     *                                                                                                               ID>/conversationProfiles/<Conversation Profile ID>`.
     * @param int                                                                           $participantRole         Required. The participant role to add or update the suggestion feature
     *                                                                                                               config. Only HUMAN_AGENT or END_USER can be used.
     *                                                                                                               For allowed values, use constants defined on {@see \Google\Cloud\Dialogflow\V2\Participant\Role}
     * @param \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\SuggestionFeatureConfig $suggestionFeatureConfig Required. The suggestion feature config to add or update.
     *
     * @return \Google\Cloud\Dialogflow\V2\SetSuggestionFeatureConfigRequest
     *
     * @experimental
     */
    public static function buildFromConversationProfileParticipantRoleSuggestionFeatureConfig(string $conversationProfile, int $participantRole, \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\SuggestionFeatureConfig $suggestionFeatureConfig): self
    {
        return (new self())
            ->setConversationProfile($conversationProfile)
            ->setParticipantRole($participantRole)
            ->setSuggestionFeatureConfig($suggestionFeatureConfig);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $conversation_profile
     *           Required. The Conversation Profile to add or update the suggestion feature
     *           config. Format: `projects/<Project ID>/locations/<Location
     *           ID>/conversationProfiles/<Conversation Profile ID>`.
     *     @type int $participant_role
     *           Required. The participant role to add or update the suggestion feature
     *           config. Only HUMAN_AGENT or END_USER can be used.
     *     @type \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\SuggestionFeatureConfig $suggestion_feature_config
     *           Required. The suggestion feature config to add or update.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\V2\ConversationProfile::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The Conversation Profile to add or update the suggestion feature
     * config. Format: `projects/<Project ID>/locations/<Location
     * ID>/conversationProfiles/<Conversation Profile ID>`.
     *
     * Generated from protobuf field <code>string conversation_profile = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getConversationProfile()
    {
        return $this->conversation_profile;
    }

    /**
     * Required. The Conversation Profile to add or update the suggestion feature
     * config. Format: `projects/<Project ID>/locations/<Location
     * ID>/conversationProfiles/<Conversation Profile ID>`.
     *
     * Generated from protobuf field <code>string conversation_profile = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setConversationProfile($var)
    {
        GPBUtil::checkString($var, True);
        $this->conversation_profile = $var;

        return $this;
    }

    /**
     * Required. The participant role to add or update the suggestion feature
     * config. Only HUMAN_AGENT or END_USER can be used.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.Participant.Role participant_role = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return int
     */
    public function getParticipantRole()
    {
        return $this->participant_role;
    }

    /**
     * Required. The participant role to add or update the suggestion feature
     * config. Only HUMAN_AGENT or END_USER can be used.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.Participant.Role participant_role = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int $var
     * @return $this
     */
    public function setParticipantRole($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Dialogflow\V2\Participant\Role::class);
        $this->participant_role = $var;

        return $this;
    }

    /**
     * Required. The suggestion feature config to add or update.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.HumanAgentAssistantConfig.SuggestionFeatureConfig suggestion_feature_config = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\SuggestionFeatureConfig|null
     */
    public function getSuggestionFeatureConfig()
    {
        return $this->suggestion_feature_config;
    }

    public function hasSuggestionFeatureConfig()
    {
        return isset($this->suggestion_feature_config);
    }

    public function clearSuggestionFeatureConfig()
    {
        unset($this->suggestion_feature_config);
    }

    /**
     * Required. The suggestion feature config to add or update.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.HumanAgentAssistantConfig.SuggestionFeatureConfig suggestion_feature_config = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\SuggestionFeatureConfig $var
     * @return $this
     */
    public function setSuggestionFeatureConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\V2\HumanAgentAssistantConfig\SuggestionFeatureConfig::class);
        $this->suggestion_feature_config = $var;

        return $this;
    }

}

