<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/environment.proto

namespace Google\Cloud\Dialogflow\Cx\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents a result from running a test case in an agent environment.
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.ContinuousTestResult</code>
 */
class ContinuousTestResult extends \Google\Protobuf\Internal\Message
{
    /**
     * The resource name for the continuous test result. Format:
     * `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/environments/<Environment
     * ID>/continuousTestResults/<ContinuousTestResult ID>`.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    protected $name = '';
    /**
     * The result of this continuous test run, i.e. whether all the tests in this
     * continuous test run pass or not.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.ContinuousTestResult.AggregatedTestResult result = 2;</code>
     */
    protected $result = 0;
    /**
     * A list of individual test case results names in this continuous test run.
     *
     * Generated from protobuf field <code>repeated string test_case_results = 3 [(.google.api.resource_reference) = {</code>
     */
    private $test_case_results;
    /**
     * Time when the continuous testing run starts.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp run_time = 4;</code>
     */
    protected $run_time = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           The resource name for the continuous test result. Format:
     *           `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     *           ID>/environments/<Environment
     *           ID>/continuousTestResults/<ContinuousTestResult ID>`.
     *     @type int $result
     *           The result of this continuous test run, i.e. whether all the tests in this
     *           continuous test run pass or not.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $test_case_results
     *           A list of individual test case results names in this continuous test run.
     *     @type \Google\Protobuf\Timestamp $run_time
     *           Time when the continuous testing run starts.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\Environment::initOnce();
        parent::__construct($data);
    }

    /**
     * The resource name for the continuous test result. Format:
     * `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/environments/<Environment
     * ID>/continuousTestResults/<ContinuousTestResult ID>`.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * The resource name for the continuous test result. Format:
     * `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/environments/<Environment
     * ID>/continuousTestResults/<ContinuousTestResult ID>`.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The result of this continuous test run, i.e. whether all the tests in this
     * continuous test run pass or not.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.ContinuousTestResult.AggregatedTestResult result = 2;</code>
     * @return int
     */
    public function getResult()
    {
        return $this->result;
    }

    /**
     * The result of this continuous test run, i.e. whether all the tests in this
     * continuous test run pass or not.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.ContinuousTestResult.AggregatedTestResult result = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setResult($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Dialogflow\Cx\V3\ContinuousTestResult\AggregatedTestResult::class);
        $this->result = $var;

        return $this;
    }

    /**
     * A list of individual test case results names in this continuous test run.
     *
     * Generated from protobuf field <code>repeated string test_case_results = 3 [(.google.api.resource_reference) = {</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getTestCaseResults()
    {
        return $this->test_case_results;
    }

    /**
     * A list of individual test case results names in this continuous test run.
     *
     * Generated from protobuf field <code>repeated string test_case_results = 3 [(.google.api.resource_reference) = {</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setTestCaseResults($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->test_case_results = $arr;

        return $this;
    }

    /**
     * Time when the continuous testing run starts.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp run_time = 4;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getRunTime()
    {
        return $this->run_time;
    }

    public function hasRunTime()
    {
        return isset($this->run_time);
    }

    public function clearRunTime()
    {
        unset($this->run_time);
    }

    /**
     * Time when the continuous testing run starts.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp run_time = 4;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setRunTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->run_time = $var;

        return $this;
    }

}

