<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/generator.proto

namespace Google\Cloud\Dialogflow\Cx\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for
 * [Generators.CreateGenerator][google.cloud.dialogflow.cx.v3.Generators.CreateGenerator].
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.CreateGeneratorRequest</code>
 */
class CreateGeneratorRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The agent to create a generator for.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The generator to create.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.Generator generator = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $generator = null;
    /**
     * The language to create generators for the following fields:
     * *  `Generator.prompt_text.text`
     * If not specified, the agent's default language is used.
     *
     * Generated from protobuf field <code>string language_code = 3;</code>
     */
    protected $language_code = '';

    /**
     * @param string                                   $parent    Required. The agent to create a generator for.
     *                                                            Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>`. Please see
     *                                                            {@see GeneratorsClient::agentName()} for help formatting this field.
     * @param \Google\Cloud\Dialogflow\Cx\V3\Generator $generator Required. The generator to create.
     *
     * @return \Google\Cloud\Dialogflow\Cx\V3\CreateGeneratorRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\Dialogflow\Cx\V3\Generator $generator): self
    {
        return (new self())
            ->setParent($parent)
            ->setGenerator($generator);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The agent to create a generator for.
     *           Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>`.
     *     @type \Google\Cloud\Dialogflow\Cx\V3\Generator $generator
     *           Required. The generator to create.
     *     @type string $language_code
     *           The language to create generators for the following fields:
     *           *  `Generator.prompt_text.text`
     *           If not specified, the agent's default language is used.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\Generator::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The agent to create a generator for.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The agent to create a generator for.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The generator to create.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.Generator generator = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\Dialogflow\Cx\V3\Generator|null
     */
    public function getGenerator()
    {
        return $this->generator;
    }

    public function hasGenerator()
    {
        return isset($this->generator);
    }

    public function clearGenerator()
    {
        unset($this->generator);
    }

    /**
     * Required. The generator to create.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.Generator generator = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\Dialogflow\Cx\V3\Generator $var
     * @return $this
     */
    public function setGenerator($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\Cx\V3\Generator::class);
        $this->generator = $var;

        return $this;
    }

    /**
     * The language to create generators for the following fields:
     * *  `Generator.prompt_text.text`
     * If not specified, the agent's default language is used.
     *
     * Generated from protobuf field <code>string language_code = 3;</code>
     * @return string
     */
    public function getLanguageCode()
    {
        return $this->language_code;
    }

    /**
     * The language to create generators for the following fields:
     * *  `Generator.prompt_text.text`
     * If not specified, the agent's default language is used.
     *
     * Generated from protobuf field <code>string language_code = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setLanguageCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->language_code = $var;

        return $this;
    }

}

