<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/page.proto

namespace Google\Cloud\Dialogflow\Cx\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for
 * [Pages.CreatePage][google.cloud.dialogflow.cx.v3.Pages.CreatePage].
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.CreatePageRequest</code>
 */
class CreatePageRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The flow to create a page for.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/flows/<Flow ID>`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The page to create.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.Page page = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $page = null;
    /**
     * The language of the following fields in `page`:
     * *  `Page.entry_fulfillment.messages`
     * *  `Page.entry_fulfillment.conditional_cases`
     * *  `Page.event_handlers.trigger_fulfillment.messages`
     * *  `Page.event_handlers.trigger_fulfillment.conditional_cases`
     * *  `Page.form.parameters.fill_behavior.initial_prompt_fulfillment.messages`
     * *
     * `Page.form.parameters.fill_behavior.initial_prompt_fulfillment.conditional_cases`
     * *  `Page.form.parameters.fill_behavior.reprompt_event_handlers.messages`
     * *
     * `Page.form.parameters.fill_behavior.reprompt_event_handlers.conditional_cases`
     * *  `Page.transition_routes.trigger_fulfillment.messages`
     * *  `Page.transition_routes.trigger_fulfillment.conditional_cases`
     * If not specified, the agent's default language is used.
     * [Many
     * languages](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     * are supported.
     * Note: languages must be enabled in the agent before they can be used.
     *
     * Generated from protobuf field <code>string language_code = 3;</code>
     */
    protected $language_code = '';

    /**
     * @param string                              $parent Required. The flow to create a page for.
     *                                                    Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     *                                                    ID>/flows/<Flow ID>`. Please see
     *                                                    {@see PagesClient::flowName()} for help formatting this field.
     * @param \Google\Cloud\Dialogflow\Cx\V3\Page $page   Required. The page to create.
     *
     * @return \Google\Cloud\Dialogflow\Cx\V3\CreatePageRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\Dialogflow\Cx\V3\Page $page): self
    {
        return (new self())
            ->setParent($parent)
            ->setPage($page);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The flow to create a page for.
     *           Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     *           ID>/flows/<Flow ID>`.
     *     @type \Google\Cloud\Dialogflow\Cx\V3\Page $page
     *           Required. The page to create.
     *     @type string $language_code
     *           The language of the following fields in `page`:
     *           *  `Page.entry_fulfillment.messages`
     *           *  `Page.entry_fulfillment.conditional_cases`
     *           *  `Page.event_handlers.trigger_fulfillment.messages`
     *           *  `Page.event_handlers.trigger_fulfillment.conditional_cases`
     *           *  `Page.form.parameters.fill_behavior.initial_prompt_fulfillment.messages`
     *           *
     *           `Page.form.parameters.fill_behavior.initial_prompt_fulfillment.conditional_cases`
     *           *  `Page.form.parameters.fill_behavior.reprompt_event_handlers.messages`
     *           *
     *           `Page.form.parameters.fill_behavior.reprompt_event_handlers.conditional_cases`
     *           *  `Page.transition_routes.trigger_fulfillment.messages`
     *           *  `Page.transition_routes.trigger_fulfillment.conditional_cases`
     *           If not specified, the agent's default language is used.
     *           [Many
     *           languages](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     *           are supported.
     *           Note: languages must be enabled in the agent before they can be used.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\Page::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The flow to create a page for.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/flows/<Flow ID>`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The flow to create a page for.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/flows/<Flow ID>`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The page to create.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.Page page = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\Dialogflow\Cx\V3\Page|null
     */
    public function getPage()
    {
        return $this->page;
    }

    public function hasPage()
    {
        return isset($this->page);
    }

    public function clearPage()
    {
        unset($this->page);
    }

    /**
     * Required. The page to create.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.Page page = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\Dialogflow\Cx\V3\Page $var
     * @return $this
     */
    public function setPage($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\Cx\V3\Page::class);
        $this->page = $var;

        return $this;
    }

    /**
     * The language of the following fields in `page`:
     * *  `Page.entry_fulfillment.messages`
     * *  `Page.entry_fulfillment.conditional_cases`
     * *  `Page.event_handlers.trigger_fulfillment.messages`
     * *  `Page.event_handlers.trigger_fulfillment.conditional_cases`
     * *  `Page.form.parameters.fill_behavior.initial_prompt_fulfillment.messages`
     * *
     * `Page.form.parameters.fill_behavior.initial_prompt_fulfillment.conditional_cases`
     * *  `Page.form.parameters.fill_behavior.reprompt_event_handlers.messages`
     * *
     * `Page.form.parameters.fill_behavior.reprompt_event_handlers.conditional_cases`
     * *  `Page.transition_routes.trigger_fulfillment.messages`
     * *  `Page.transition_routes.trigger_fulfillment.conditional_cases`
     * If not specified, the agent's default language is used.
     * [Many
     * languages](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     * are supported.
     * Note: languages must be enabled in the agent before they can be used.
     *
     * Generated from protobuf field <code>string language_code = 3;</code>
     * @return string
     */
    public function getLanguageCode()
    {
        return $this->language_code;
    }

    /**
     * The language of the following fields in `page`:
     * *  `Page.entry_fulfillment.messages`
     * *  `Page.entry_fulfillment.conditional_cases`
     * *  `Page.event_handlers.trigger_fulfillment.messages`
     * *  `Page.event_handlers.trigger_fulfillment.conditional_cases`
     * *  `Page.form.parameters.fill_behavior.initial_prompt_fulfillment.messages`
     * *
     * `Page.form.parameters.fill_behavior.initial_prompt_fulfillment.conditional_cases`
     * *  `Page.form.parameters.fill_behavior.reprompt_event_handlers.messages`
     * *
     * `Page.form.parameters.fill_behavior.reprompt_event_handlers.conditional_cases`
     * *  `Page.transition_routes.trigger_fulfillment.messages`
     * *  `Page.transition_routes.trigger_fulfillment.conditional_cases`
     * If not specified, the agent's default language is used.
     * [Many
     * languages](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     * are supported.
     * Note: languages must be enabled in the agent before they can be used.
     *
     * Generated from protobuf field <code>string language_code = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setLanguageCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->language_code = $var;

        return $this;
    }

}

