<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/transition_route_group.proto

namespace Google\Cloud\Dialogflow\Cx\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for
 * [TransitionRouteGroups.CreateTransitionRouteGroup][google.cloud.dialogflow.cx.v3.TransitionRouteGroups.CreateTransitionRouteGroup].
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.CreateTransitionRouteGroupRequest</code>
 */
class CreateTransitionRouteGroupRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The flow to create an
     * [TransitionRouteGroup][google.cloud.dialogflow.cx.v3.TransitionRouteGroup]
     * for. Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/flows/<Flow ID>`
     * or `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>`
     * for agent-level groups.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The transition route group to create.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.TransitionRouteGroup transition_route_group = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $transition_route_group = null;
    /**
     * The language of the following fields in `TransitionRouteGroup`:
     * *  `TransitionRouteGroup.transition_routes.trigger_fulfillment.messages`
     * *
     * `TransitionRouteGroup.transition_routes.trigger_fulfillment.conditional_cases`
     * If not specified, the agent's default language is used.
     * [Many
     * languages](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     * are supported.
     * Note: languages must be enabled in the agent before they can be used.
     *
     * Generated from protobuf field <code>string language_code = 3;</code>
     */
    protected $language_code = '';

    /**
     * @param string                                              $parent               Required. The flow to create an
     *                                                                                  [TransitionRouteGroup][google.cloud.dialogflow.cx.v3.TransitionRouteGroup]
     *                                                                                  for. Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     *                                                                                  ID>/flows/<Flow ID>`
     *                                                                                  or `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>`
     *                                                                                  for agent-level groups. Please see
     *                                                                                  {@see TransitionRouteGroupsClient::flowName()} for help formatting this field.
     * @param \Google\Cloud\Dialogflow\Cx\V3\TransitionRouteGroup $transitionRouteGroup Required. The transition route group to create.
     *
     * @return \Google\Cloud\Dialogflow\Cx\V3\CreateTransitionRouteGroupRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\Dialogflow\Cx\V3\TransitionRouteGroup $transitionRouteGroup): self
    {
        return (new self())
            ->setParent($parent)
            ->setTransitionRouteGroup($transitionRouteGroup);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The flow to create an
     *           [TransitionRouteGroup][google.cloud.dialogflow.cx.v3.TransitionRouteGroup]
     *           for. Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     *           ID>/flows/<Flow ID>`
     *           or `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>`
     *           for agent-level groups.
     *     @type \Google\Cloud\Dialogflow\Cx\V3\TransitionRouteGroup $transition_route_group
     *           Required. The transition route group to create.
     *     @type string $language_code
     *           The language of the following fields in `TransitionRouteGroup`:
     *           *  `TransitionRouteGroup.transition_routes.trigger_fulfillment.messages`
     *           *
     *           `TransitionRouteGroup.transition_routes.trigger_fulfillment.conditional_cases`
     *           If not specified, the agent's default language is used.
     *           [Many
     *           languages](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     *           are supported.
     *           Note: languages must be enabled in the agent before they can be used.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\TransitionRouteGroup::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The flow to create an
     * [TransitionRouteGroup][google.cloud.dialogflow.cx.v3.TransitionRouteGroup]
     * for. Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/flows/<Flow ID>`
     * or `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>`
     * for agent-level groups.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The flow to create an
     * [TransitionRouteGroup][google.cloud.dialogflow.cx.v3.TransitionRouteGroup]
     * for. Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/flows/<Flow ID>`
     * or `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>`
     * for agent-level groups.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The transition route group to create.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.TransitionRouteGroup transition_route_group = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\Dialogflow\Cx\V3\TransitionRouteGroup|null
     */
    public function getTransitionRouteGroup()
    {
        return $this->transition_route_group;
    }

    public function hasTransitionRouteGroup()
    {
        return isset($this->transition_route_group);
    }

    public function clearTransitionRouteGroup()
    {
        unset($this->transition_route_group);
    }

    /**
     * Required. The transition route group to create.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.TransitionRouteGroup transition_route_group = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\Dialogflow\Cx\V3\TransitionRouteGroup $var
     * @return $this
     */
    public function setTransitionRouteGroup($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\Cx\V3\TransitionRouteGroup::class);
        $this->transition_route_group = $var;

        return $this;
    }

    /**
     * The language of the following fields in `TransitionRouteGroup`:
     * *  `TransitionRouteGroup.transition_routes.trigger_fulfillment.messages`
     * *
     * `TransitionRouteGroup.transition_routes.trigger_fulfillment.conditional_cases`
     * If not specified, the agent's default language is used.
     * [Many
     * languages](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     * are supported.
     * Note: languages must be enabled in the agent before they can be used.
     *
     * Generated from protobuf field <code>string language_code = 3;</code>
     * @return string
     */
    public function getLanguageCode()
    {
        return $this->language_code;
    }

    /**
     * The language of the following fields in `TransitionRouteGroup`:
     * *  `TransitionRouteGroup.transition_routes.trigger_fulfillment.messages`
     * *
     * `TransitionRouteGroup.transition_routes.trigger_fulfillment.conditional_cases`
     * If not specified, the agent's default language is used.
     * [Many
     * languages](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     * are supported.
     * Note: languages must be enabled in the agent before they can be used.
     *
     * Generated from protobuf field <code>string language_code = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setLanguageCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->language_code = $var;

        return $this;
    }

}

