<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/page.proto

namespace Google\Cloud\Dialogflow\Cx\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for
 * [Pages.DeletePage][google.cloud.dialogflow.cx.v3.Pages.DeletePage].
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.DeletePageRequest</code>
 */
class DeletePageRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the page to delete.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/Flows/<flow ID>/pages/<Page ID>`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';
    /**
     * This field has no effect for pages with no incoming transitions.
     * For pages with incoming transitions:
     * *  If `force` is set to false, an error will be returned with message
     *    indicating the incoming transitions.
     * *  If `force` is set to true, Dialogflow will remove the page, as well as
     *    any transitions to the page (i.e. [Target
     *    page][EventHandler.target_page] in event handlers or [Target
     *    page][TransitionRoute.target_page] in transition routes that point to
     *    this page will be cleared).
     *
     * Generated from protobuf field <code>bool force = 2;</code>
     */
    protected $force = false;

    /**
     * @param string $name Required. The name of the page to delete.
     *                     Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     *                     ID>/Flows/<flow ID>/pages/<Page ID>`. Please see
     *                     {@see PagesClient::pageName()} for help formatting this field.
     *
     * @return \Google\Cloud\Dialogflow\Cx\V3\DeletePageRequest
     *
     * @experimental
     */
    public static function build(string $name): self
    {
        return (new self())
            ->setName($name);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. The name of the page to delete.
     *           Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     *           ID>/Flows/<flow ID>/pages/<Page ID>`.
     *     @type bool $force
     *           This field has no effect for pages with no incoming transitions.
     *           For pages with incoming transitions:
     *           *  If `force` is set to false, an error will be returned with message
     *              indicating the incoming transitions.
     *           *  If `force` is set to true, Dialogflow will remove the page, as well as
     *              any transitions to the page (i.e. [Target
     *              page][EventHandler.target_page] in event handlers or [Target
     *              page][TransitionRoute.target_page] in transition routes that point to
     *              this page will be cleared).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\Page::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the page to delete.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/Flows/<flow ID>/pages/<Page ID>`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. The name of the page to delete.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/Flows/<flow ID>/pages/<Page ID>`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * This field has no effect for pages with no incoming transitions.
     * For pages with incoming transitions:
     * *  If `force` is set to false, an error will be returned with message
     *    indicating the incoming transitions.
     * *  If `force` is set to true, Dialogflow will remove the page, as well as
     *    any transitions to the page (i.e. [Target
     *    page][EventHandler.target_page] in event handlers or [Target
     *    page][TransitionRoute.target_page] in transition routes that point to
     *    this page will be cleared).
     *
     * Generated from protobuf field <code>bool force = 2;</code>
     * @return bool
     */
    public function getForce()
    {
        return $this->force;
    }

    /**
     * This field has no effect for pages with no incoming transitions.
     * For pages with incoming transitions:
     * *  If `force` is set to false, an error will be returned with message
     *    indicating the incoming transitions.
     * *  If `force` is set to true, Dialogflow will remove the page, as well as
     *    any transitions to the page (i.e. [Target
     *    page][EventHandler.target_page] in event handlers or [Target
     *    page][TransitionRoute.target_page] in transition routes that point to
     *    this page will be cleared).
     *
     * Generated from protobuf field <code>bool force = 2;</code>
     * @param bool $var
     * @return $this
     */
    public function setForce($var)
    {
        GPBUtil::checkBool($var);
        $this->force = $var;

        return $this;
    }

}

