<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/flow.proto

namespace Google\Cloud\Dialogflow\Cx\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for
 * [Flows.ExportFlow][google.cloud.dialogflow.cx.v3.Flows.ExportFlow].
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.ExportFlowRequest</code>
 */
class ExportFlowRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the flow to export.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/flows/<Flow ID>`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';
    /**
     * Optional. The [Google Cloud
     * Storage](https://cloud.google.com/storage/docs/) URI to export the flow to.
     * The format of this URI must be `gs://<bucket-name>/<object-name>`. If left
     * unspecified, the serialized flow is returned inline.
     * Dialogflow performs a write operation for the Cloud Storage object
     * on the caller's behalf, so your request authentication must
     * have write permissions for the object. For more information, see
     * [Dialogflow access
     * control](https://cloud.google.com/dialogflow/cx/docs/concept/access-control#storage).
     *
     * Generated from protobuf field <code>string flow_uri = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $flow_uri = '';
    /**
     * Optional. Whether to export flows referenced by the specified flow.
     *
     * Generated from protobuf field <code>bool include_referenced_flows = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $include_referenced_flows = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. The name of the flow to export.
     *           Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     *           ID>/flows/<Flow ID>`.
     *     @type string $flow_uri
     *           Optional. The [Google Cloud
     *           Storage](https://cloud.google.com/storage/docs/) URI to export the flow to.
     *           The format of this URI must be `gs://<bucket-name>/<object-name>`. If left
     *           unspecified, the serialized flow is returned inline.
     *           Dialogflow performs a write operation for the Cloud Storage object
     *           on the caller's behalf, so your request authentication must
     *           have write permissions for the object. For more information, see
     *           [Dialogflow access
     *           control](https://cloud.google.com/dialogflow/cx/docs/concept/access-control#storage).
     *     @type bool $include_referenced_flows
     *           Optional. Whether to export flows referenced by the specified flow.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\Flow::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the flow to export.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/flows/<Flow ID>`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. The name of the flow to export.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/flows/<Flow ID>`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Optional. The [Google Cloud
     * Storage](https://cloud.google.com/storage/docs/) URI to export the flow to.
     * The format of this URI must be `gs://<bucket-name>/<object-name>`. If left
     * unspecified, the serialized flow is returned inline.
     * Dialogflow performs a write operation for the Cloud Storage object
     * on the caller's behalf, so your request authentication must
     * have write permissions for the object. For more information, see
     * [Dialogflow access
     * control](https://cloud.google.com/dialogflow/cx/docs/concept/access-control#storage).
     *
     * Generated from protobuf field <code>string flow_uri = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFlowUri()
    {
        return $this->flow_uri;
    }

    /**
     * Optional. The [Google Cloud
     * Storage](https://cloud.google.com/storage/docs/) URI to export the flow to.
     * The format of this URI must be `gs://<bucket-name>/<object-name>`. If left
     * unspecified, the serialized flow is returned inline.
     * Dialogflow performs a write operation for the Cloud Storage object
     * on the caller's behalf, so your request authentication must
     * have write permissions for the object. For more information, see
     * [Dialogflow access
     * control](https://cloud.google.com/dialogflow/cx/docs/concept/access-control#storage).
     *
     * Generated from protobuf field <code>string flow_uri = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFlowUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->flow_uri = $var;

        return $this;
    }

    /**
     * Optional. Whether to export flows referenced by the specified flow.
     *
     * Generated from protobuf field <code>bool include_referenced_flows = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getIncludeReferencedFlows()
    {
        return $this->include_referenced_flows;
    }

    /**
     * Optional. Whether to export flows referenced by the specified flow.
     *
     * Generated from protobuf field <code>bool include_referenced_flows = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setIncludeReferencedFlows($var)
    {
        GPBUtil::checkBool($var);
        $this->include_referenced_flows = $var;

        return $this;
    }

}

