<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/intent.proto

namespace Google\Cloud\Dialogflow\Cx\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for
 * [Intents.ExportIntents][google.cloud.dialogflow.cx.v3.Intents.ExportIntents].
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.ExportIntentsRequest</code>
 */
class ExportIntentsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the parent agent to export intents.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The name of the intents to export.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/intents/<Intent ID>`.
     *
     * Generated from protobuf field <code>repeated string intents = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $intents;
    /**
     * Optional. The data format of the exported intents. If not specified, `BLOB`
     * is assumed.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.ExportIntentsRequest.DataFormat data_format = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $data_format = 0;
    protected $destination;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The name of the parent agent to export intents.
     *           Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     *           ID>`.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $intents
     *           Required. The name of the intents to export.
     *           Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     *           ID>/intents/<Intent ID>`.
     *     @type string $intents_uri
     *           Optional. The [Google Cloud
     *           Storage](https://cloud.google.com/storage/docs/) URI to export the
     *           intents to. The format of this URI must be
     *           `gs://<bucket-name>/<object-name>`.
     *           Dialogflow performs a write operation for the Cloud Storage object
     *           on the caller's behalf, so your request authentication must
     *           have write permissions for the object. For more information, see
     *           [Dialogflow access
     *           control](https://cloud.google.com/dialogflow/cx/docs/concept/access-control#storage).
     *     @type bool $intents_content_inline
     *           Optional. The option to return the serialized intents inline.
     *     @type int $data_format
     *           Optional. The data format of the exported intents. If not specified, `BLOB`
     *           is assumed.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\Intent::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the parent agent to export intents.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The name of the parent agent to export intents.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The name of the intents to export.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/intents/<Intent ID>`.
     *
     * Generated from protobuf field <code>repeated string intents = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getIntents()
    {
        return $this->intents;
    }

    /**
     * Required. The name of the intents to export.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/intents/<Intent ID>`.
     *
     * Generated from protobuf field <code>repeated string intents = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setIntents($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->intents = $arr;

        return $this;
    }

    /**
     * Optional. The [Google Cloud
     * Storage](https://cloud.google.com/storage/docs/) URI to export the
     * intents to. The format of this URI must be
     * `gs://<bucket-name>/<object-name>`.
     * Dialogflow performs a write operation for the Cloud Storage object
     * on the caller's behalf, so your request authentication must
     * have write permissions for the object. For more information, see
     * [Dialogflow access
     * control](https://cloud.google.com/dialogflow/cx/docs/concept/access-control#storage).
     *
     * Generated from protobuf field <code>string intents_uri = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getIntentsUri()
    {
        return $this->readOneof(3);
    }

    public function hasIntentsUri()
    {
        return $this->hasOneof(3);
    }

    /**
     * Optional. The [Google Cloud
     * Storage](https://cloud.google.com/storage/docs/) URI to export the
     * intents to. The format of this URI must be
     * `gs://<bucket-name>/<object-name>`.
     * Dialogflow performs a write operation for the Cloud Storage object
     * on the caller's behalf, so your request authentication must
     * have write permissions for the object. For more information, see
     * [Dialogflow access
     * control](https://cloud.google.com/dialogflow/cx/docs/concept/access-control#storage).
     *
     * Generated from protobuf field <code>string intents_uri = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setIntentsUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(3, $var);

        return $this;
    }

    /**
     * Optional. The option to return the serialized intents inline.
     *
     * Generated from protobuf field <code>bool intents_content_inline = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getIntentsContentInline()
    {
        return $this->readOneof(4);
    }

    public function hasIntentsContentInline()
    {
        return $this->hasOneof(4);
    }

    /**
     * Optional. The option to return the serialized intents inline.
     *
     * Generated from protobuf field <code>bool intents_content_inline = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setIntentsContentInline($var)
    {
        GPBUtil::checkBool($var);
        $this->writeOneof(4, $var);

        return $this;
    }

    /**
     * Optional. The data format of the exported intents. If not specified, `BLOB`
     * is assumed.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.ExportIntentsRequest.DataFormat data_format = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getDataFormat()
    {
        return $this->data_format;
    }

    /**
     * Optional. The data format of the exported intents. If not specified, `BLOB`
     * is assumed.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.ExportIntentsRequest.DataFormat data_format = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setDataFormat($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Dialogflow\Cx\V3\ExportIntentsRequest\DataFormat::class);
        $this->data_format = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getDestination()
    {
        return $this->whichOneof("destination");
    }

}

