<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/flow.proto

namespace Google\Cloud\Dialogflow\Cx\V3\Flow;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Settings for multi-lingual agents.
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.Flow.MultiLanguageSettings</code>
 */
class MultiLanguageSettings extends \Google\Protobuf\Internal\Message
{
    /**
     * Optional. Enable multi-language detection for this flow. This can be set
     * only if [agent level multi language
     * setting][Agent.enable_multi_language_training] is enabled.
     *
     * Generated from protobuf field <code>bool enable_multi_language_detection = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $enable_multi_language_detection = false;
    /**
     * Optional. Agent will respond in the detected language if the detected
     * language code is in the supported resolved languages for this flow. This
     * will be used only if multi-language training is enabled in the
     * [agent][google.cloud.dialogflow.cx.v3.Agent.enable_multi_language_training]
     * and multi-language detection is enabled in the
     * [flow][google.cloud.dialogflow.cx.v3.Flow.MultiLanguageSettings.enable_multi_language_detection].
     * The supported languages must be a subset of the languages supported by
     * the agent.
     *
     * Generated from protobuf field <code>repeated string supported_response_language_codes = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $supported_response_language_codes;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type bool $enable_multi_language_detection
     *           Optional. Enable multi-language detection for this flow. This can be set
     *           only if [agent level multi language
     *           setting][Agent.enable_multi_language_training] is enabled.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $supported_response_language_codes
     *           Optional. Agent will respond in the detected language if the detected
     *           language code is in the supported resolved languages for this flow. This
     *           will be used only if multi-language training is enabled in the
     *           [agent][google.cloud.dialogflow.cx.v3.Agent.enable_multi_language_training]
     *           and multi-language detection is enabled in the
     *           [flow][google.cloud.dialogflow.cx.v3.Flow.MultiLanguageSettings.enable_multi_language_detection].
     *           The supported languages must be a subset of the languages supported by
     *           the agent.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\Flow::initOnce();
        parent::__construct($data);
    }

    /**
     * Optional. Enable multi-language detection for this flow. This can be set
     * only if [agent level multi language
     * setting][Agent.enable_multi_language_training] is enabled.
     *
     * Generated from protobuf field <code>bool enable_multi_language_detection = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getEnableMultiLanguageDetection()
    {
        return $this->enable_multi_language_detection;
    }

    /**
     * Optional. Enable multi-language detection for this flow. This can be set
     * only if [agent level multi language
     * setting][Agent.enable_multi_language_training] is enabled.
     *
     * Generated from protobuf field <code>bool enable_multi_language_detection = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setEnableMultiLanguageDetection($var)
    {
        GPBUtil::checkBool($var);
        $this->enable_multi_language_detection = $var;

        return $this;
    }

    /**
     * Optional. Agent will respond in the detected language if the detected
     * language code is in the supported resolved languages for this flow. This
     * will be used only if multi-language training is enabled in the
     * [agent][google.cloud.dialogflow.cx.v3.Agent.enable_multi_language_training]
     * and multi-language detection is enabled in the
     * [flow][google.cloud.dialogflow.cx.v3.Flow.MultiLanguageSettings.enable_multi_language_detection].
     * The supported languages must be a subset of the languages supported by
     * the agent.
     *
     * Generated from protobuf field <code>repeated string supported_response_language_codes = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSupportedResponseLanguageCodes()
    {
        return $this->supported_response_language_codes;
    }

    /**
     * Optional. Agent will respond in the detected language if the detected
     * language code is in the supported resolved languages for this flow. This
     * will be used only if multi-language training is enabled in the
     * [agent][google.cloud.dialogflow.cx.v3.Agent.enable_multi_language_training]
     * and multi-language detection is enabled in the
     * [flow][google.cloud.dialogflow.cx.v3.Flow.MultiLanguageSettings.enable_multi_language_detection].
     * The supported languages must be a subset of the languages supported by
     * the agent.
     *
     * Generated from protobuf field <code>repeated string supported_response_language_codes = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSupportedResponseLanguageCodes($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->supported_response_language_codes = $arr;

        return $this;
    }

}


