<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/generator.proto

namespace Google\Cloud\Dialogflow\Cx\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Generators contain prompt to be sent to the LLM model to generate text. The
 * prompt can contain parameters which will be resolved before calling the
 * model. It can optionally contain banned phrases to ensure the model responses
 * are safe.
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.Generator</code>
 */
class Generator extends \Google\Protobuf\Internal\Message
{
    /**
     * The unique identifier of the generator.
     * Must be set for the
     * [Generators.UpdateGenerator][google.cloud.dialogflow.cx.v3.Generators.UpdateGenerator]
     * method. [Generators.CreateGenerate][] populates the name automatically.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/generators/<Generator ID>`.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    protected $name = '';
    /**
     * Required. The human-readable name of the generator, unique within the
     * agent. The prompt contains pre-defined parameters such as $conversation,
     * $last-user-utterance, etc. populated by Dialogflow. It can also contain
     * custom placeholders which will be resolved during fulfillment.
     *
     * Generated from protobuf field <code>string display_name = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $display_name = '';
    /**
     * Required. Prompt for the LLM model.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.Phrase prompt_text = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $prompt_text = null;
    /**
     * Optional. List of custom placeholders in the prompt text.
     *
     * Generated from protobuf field <code>repeated .google.cloud.dialogflow.cx.v3.Generator.Placeholder placeholders = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $placeholders;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           The unique identifier of the generator.
     *           Must be set for the
     *           [Generators.UpdateGenerator][google.cloud.dialogflow.cx.v3.Generators.UpdateGenerator]
     *           method. [Generators.CreateGenerate][] populates the name automatically.
     *           Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     *           ID>/generators/<Generator ID>`.
     *     @type string $display_name
     *           Required. The human-readable name of the generator, unique within the
     *           agent. The prompt contains pre-defined parameters such as $conversation,
     *           $last-user-utterance, etc. populated by Dialogflow. It can also contain
     *           custom placeholders which will be resolved during fulfillment.
     *     @type \Google\Cloud\Dialogflow\Cx\V3\Phrase $prompt_text
     *           Required. Prompt for the LLM model.
     *     @type array<\Google\Cloud\Dialogflow\Cx\V3\Generator\Placeholder>|\Google\Protobuf\Internal\RepeatedField $placeholders
     *           Optional. List of custom placeholders in the prompt text.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\Generator::initOnce();
        parent::__construct($data);
    }

    /**
     * The unique identifier of the generator.
     * Must be set for the
     * [Generators.UpdateGenerator][google.cloud.dialogflow.cx.v3.Generators.UpdateGenerator]
     * method. [Generators.CreateGenerate][] populates the name automatically.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/generators/<Generator ID>`.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * The unique identifier of the generator.
     * Must be set for the
     * [Generators.UpdateGenerator][google.cloud.dialogflow.cx.v3.Generators.UpdateGenerator]
     * method. [Generators.CreateGenerate][] populates the name automatically.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/generators/<Generator ID>`.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Required. The human-readable name of the generator, unique within the
     * agent. The prompt contains pre-defined parameters such as $conversation,
     * $last-user-utterance, etc. populated by Dialogflow. It can also contain
     * custom placeholders which will be resolved during fulfillment.
     *
     * Generated from protobuf field <code>string display_name = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * Required. The human-readable name of the generator, unique within the
     * agent. The prompt contains pre-defined parameters such as $conversation,
     * $last-user-utterance, etc. populated by Dialogflow. It can also contain
     * custom placeholders which will be resolved during fulfillment.
     *
     * Generated from protobuf field <code>string display_name = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * Required. Prompt for the LLM model.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.Phrase prompt_text = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\Dialogflow\Cx\V3\Phrase|null
     */
    public function getPromptText()
    {
        return $this->prompt_text;
    }

    public function hasPromptText()
    {
        return isset($this->prompt_text);
    }

    public function clearPromptText()
    {
        unset($this->prompt_text);
    }

    /**
     * Required. Prompt for the LLM model.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.Phrase prompt_text = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\Dialogflow\Cx\V3\Phrase $var
     * @return $this
     */
    public function setPromptText($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\Cx\V3\Phrase::class);
        $this->prompt_text = $var;

        return $this;
    }

    /**
     * Optional. List of custom placeholders in the prompt text.
     *
     * Generated from protobuf field <code>repeated .google.cloud.dialogflow.cx.v3.Generator.Placeholder placeholders = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getPlaceholders()
    {
        return $this->placeholders;
    }

    /**
     * Optional. List of custom placeholders in the prompt text.
     *
     * Generated from protobuf field <code>repeated .google.cloud.dialogflow.cx.v3.Generator.Placeholder placeholders = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<\Google\Cloud\Dialogflow\Cx\V3\Generator\Placeholder>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setPlaceholders($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Dialogflow\Cx\V3\Generator\Placeholder::class);
        $this->placeholders = $arr;

        return $this;
    }

}

