<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/page.proto

namespace Google\Cloud\Dialogflow\Cx\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for
 * [Pages.GetPage][google.cloud.dialogflow.cx.v3.Pages.GetPage].
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.GetPageRequest</code>
 */
class GetPageRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the page.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/flows/<Flow ID>/pages/<Page ID>`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';
    /**
     * The language to retrieve the page for. The following fields are language
     * dependent:
     * *  `Page.entry_fulfillment.messages`
     * *  `Page.entry_fulfillment.conditional_cases`
     * *  `Page.event_handlers.trigger_fulfillment.messages`
     * *  `Page.event_handlers.trigger_fulfillment.conditional_cases`
     * *  `Page.form.parameters.fill_behavior.initial_prompt_fulfillment.messages`
     * *
     * `Page.form.parameters.fill_behavior.initial_prompt_fulfillment.conditional_cases`
     * *  `Page.form.parameters.fill_behavior.reprompt_event_handlers.messages`
     * *
     * `Page.form.parameters.fill_behavior.reprompt_event_handlers.conditional_cases`
     * *  `Page.transition_routes.trigger_fulfillment.messages`
     * *  `Page.transition_routes.trigger_fulfillment.conditional_cases`
     * If not specified, the agent's default language is used.
     * [Many
     * languages](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     * are supported.
     * Note: languages must be enabled in the agent before they can be used.
     *
     * Generated from protobuf field <code>string language_code = 2;</code>
     */
    protected $language_code = '';

    /**
     * @param string $name Required. The name of the page.
     *                     Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     *                     ID>/flows/<Flow ID>/pages/<Page ID>`. Please see
     *                     {@see PagesClient::pageName()} for help formatting this field.
     *
     * @return \Google\Cloud\Dialogflow\Cx\V3\GetPageRequest
     *
     * @experimental
     */
    public static function build(string $name): self
    {
        return (new self())
            ->setName($name);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. The name of the page.
     *           Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     *           ID>/flows/<Flow ID>/pages/<Page ID>`.
     *     @type string $language_code
     *           The language to retrieve the page for. The following fields are language
     *           dependent:
     *           *  `Page.entry_fulfillment.messages`
     *           *  `Page.entry_fulfillment.conditional_cases`
     *           *  `Page.event_handlers.trigger_fulfillment.messages`
     *           *  `Page.event_handlers.trigger_fulfillment.conditional_cases`
     *           *  `Page.form.parameters.fill_behavior.initial_prompt_fulfillment.messages`
     *           *
     *           `Page.form.parameters.fill_behavior.initial_prompt_fulfillment.conditional_cases`
     *           *  `Page.form.parameters.fill_behavior.reprompt_event_handlers.messages`
     *           *
     *           `Page.form.parameters.fill_behavior.reprompt_event_handlers.conditional_cases`
     *           *  `Page.transition_routes.trigger_fulfillment.messages`
     *           *  `Page.transition_routes.trigger_fulfillment.conditional_cases`
     *           If not specified, the agent's default language is used.
     *           [Many
     *           languages](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     *           are supported.
     *           Note: languages must be enabled in the agent before they can be used.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\Page::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the page.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/flows/<Flow ID>/pages/<Page ID>`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. The name of the page.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/flows/<Flow ID>/pages/<Page ID>`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The language to retrieve the page for. The following fields are language
     * dependent:
     * *  `Page.entry_fulfillment.messages`
     * *  `Page.entry_fulfillment.conditional_cases`
     * *  `Page.event_handlers.trigger_fulfillment.messages`
     * *  `Page.event_handlers.trigger_fulfillment.conditional_cases`
     * *  `Page.form.parameters.fill_behavior.initial_prompt_fulfillment.messages`
     * *
     * `Page.form.parameters.fill_behavior.initial_prompt_fulfillment.conditional_cases`
     * *  `Page.form.parameters.fill_behavior.reprompt_event_handlers.messages`
     * *
     * `Page.form.parameters.fill_behavior.reprompt_event_handlers.conditional_cases`
     * *  `Page.transition_routes.trigger_fulfillment.messages`
     * *  `Page.transition_routes.trigger_fulfillment.conditional_cases`
     * If not specified, the agent's default language is used.
     * [Many
     * languages](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     * are supported.
     * Note: languages must be enabled in the agent before they can be used.
     *
     * Generated from protobuf field <code>string language_code = 2;</code>
     * @return string
     */
    public function getLanguageCode()
    {
        return $this->language_code;
    }

    /**
     * The language to retrieve the page for. The following fields are language
     * dependent:
     * *  `Page.entry_fulfillment.messages`
     * *  `Page.entry_fulfillment.conditional_cases`
     * *  `Page.event_handlers.trigger_fulfillment.messages`
     * *  `Page.event_handlers.trigger_fulfillment.conditional_cases`
     * *  `Page.form.parameters.fill_behavior.initial_prompt_fulfillment.messages`
     * *
     * `Page.form.parameters.fill_behavior.initial_prompt_fulfillment.conditional_cases`
     * *  `Page.form.parameters.fill_behavior.reprompt_event_handlers.messages`
     * *
     * `Page.form.parameters.fill_behavior.reprompt_event_handlers.conditional_cases`
     * *  `Page.transition_routes.trigger_fulfillment.messages`
     * *  `Page.transition_routes.trigger_fulfillment.conditional_cases`
     * If not specified, the agent's default language is used.
     * [Many
     * languages](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     * are supported.
     * Note: languages must be enabled in the agent before they can be used.
     *
     * Generated from protobuf field <code>string language_code = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setLanguageCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->language_code = $var;

        return $this;
    }

}

