<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/intent.proto

namespace Google\Cloud\Dialogflow\Cx\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for
 * [Intents.ImportIntents][google.cloud.dialogflow.cx.v3.Intents.ImportIntents].
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.ImportIntentsRequest</code>
 */
class ImportIntentsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The agent to import the intents into.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Merge option for importing intents. If not specified, `REJECT` is assumed.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.ImportIntentsRequest.MergeOption merge_option = 4;</code>
     */
    protected $merge_option = 0;
    protected $intents;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The agent to import the intents into.
     *           Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>`.
     *     @type string $intents_uri
     *           The [Google Cloud Storage](https://cloud.google.com/storage/docs/) URI
     *           to import intents from. The format of this URI must be
     *           `gs://<bucket-name>/<object-name>`.
     *           Dialogflow performs a read operation for the Cloud Storage object
     *           on the caller's behalf, so your request authentication must
     *           have read permissions for the object. For more information, see
     *           [Dialogflow access
     *           control](https://cloud.google.com/dialogflow/cx/docs/concept/access-control#storage).
     *     @type \Google\Cloud\Dialogflow\Cx\V3\InlineSource $intents_content
     *           Uncompressed byte content of intents.
     *     @type int $merge_option
     *           Merge option for importing intents. If not specified, `REJECT` is assumed.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\Intent::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The agent to import the intents into.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The agent to import the intents into.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * The [Google Cloud Storage](https://cloud.google.com/storage/docs/) URI
     * to import intents from. The format of this URI must be
     * `gs://<bucket-name>/<object-name>`.
     * Dialogflow performs a read operation for the Cloud Storage object
     * on the caller's behalf, so your request authentication must
     * have read permissions for the object. For more information, see
     * [Dialogflow access
     * control](https://cloud.google.com/dialogflow/cx/docs/concept/access-control#storage).
     *
     * Generated from protobuf field <code>string intents_uri = 2;</code>
     * @return string
     */
    public function getIntentsUri()
    {
        return $this->readOneof(2);
    }

    public function hasIntentsUri()
    {
        return $this->hasOneof(2);
    }

    /**
     * The [Google Cloud Storage](https://cloud.google.com/storage/docs/) URI
     * to import intents from. The format of this URI must be
     * `gs://<bucket-name>/<object-name>`.
     * Dialogflow performs a read operation for the Cloud Storage object
     * on the caller's behalf, so your request authentication must
     * have read permissions for the object. For more information, see
     * [Dialogflow access
     * control](https://cloud.google.com/dialogflow/cx/docs/concept/access-control#storage).
     *
     * Generated from protobuf field <code>string intents_uri = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setIntentsUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     * Uncompressed byte content of intents.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.InlineSource intents_content = 3;</code>
     * @return \Google\Cloud\Dialogflow\Cx\V3\InlineSource|null
     */
    public function getIntentsContent()
    {
        return $this->readOneof(3);
    }

    public function hasIntentsContent()
    {
        return $this->hasOneof(3);
    }

    /**
     * Uncompressed byte content of intents.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.InlineSource intents_content = 3;</code>
     * @param \Google\Cloud\Dialogflow\Cx\V3\InlineSource $var
     * @return $this
     */
    public function setIntentsContent($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\Cx\V3\InlineSource::class);
        $this->writeOneof(3, $var);

        return $this;
    }

    /**
     * Merge option for importing intents. If not specified, `REJECT` is assumed.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.ImportIntentsRequest.MergeOption merge_option = 4;</code>
     * @return int
     */
    public function getMergeOption()
    {
        return $this->merge_option;
    }

    /**
     * Merge option for importing intents. If not specified, `REJECT` is assumed.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.ImportIntentsRequest.MergeOption merge_option = 4;</code>
     * @param int $var
     * @return $this
     */
    public function setMergeOption($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Dialogflow\Cx\V3\ImportIntentsRequest\MergeOption::class);
        $this->merge_option = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getIntents()
    {
        return $this->whichOneof("intents");
    }

}

