<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/intent.proto

namespace Google\Cloud\Dialogflow\Cx\V3\Intent;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents an intent parameter.
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.Intent.Parameter</code>
 */
class Parameter extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The unique identifier of the parameter. This field
     * is used by [training
     * phrases][google.cloud.dialogflow.cx.v3.Intent.TrainingPhrase] to annotate
     * their [parts][google.cloud.dialogflow.cx.v3.Intent.TrainingPhrase.Part].
     *
     * Generated from protobuf field <code>string id = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $id = '';
    /**
     * Required. The entity type of the parameter.
     * Format: `projects/-/locations/-/agents/-/entityTypes/<System Entity Type
     * ID>` for system entity types (for example,
     * `projects/-/locations/-/agents/-/entityTypes/sys.date`), or
     * `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/entityTypes/<Entity Type ID>` for developer entity types.
     *
     * Generated from protobuf field <code>string entity_type = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $entity_type = '';
    /**
     * Indicates whether the parameter represents a list of values.
     *
     * Generated from protobuf field <code>bool is_list = 3;</code>
     */
    protected $is_list = false;
    /**
     * Indicates whether the parameter content should be redacted in log. If
     * redaction is enabled, the parameter content will be replaced by parameter
     * name during logging.
     * Note: the parameter content is subject to redaction if either parameter
     * level redaction or [entity type level
     * redaction][google.cloud.dialogflow.cx.v3.EntityType.redact] is enabled.
     *
     * Generated from protobuf field <code>bool redact = 4;</code>
     */
    protected $redact = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $id
     *           Required. The unique identifier of the parameter. This field
     *           is used by [training
     *           phrases][google.cloud.dialogflow.cx.v3.Intent.TrainingPhrase] to annotate
     *           their [parts][google.cloud.dialogflow.cx.v3.Intent.TrainingPhrase.Part].
     *     @type string $entity_type
     *           Required. The entity type of the parameter.
     *           Format: `projects/-/locations/-/agents/-/entityTypes/<System Entity Type
     *           ID>` for system entity types (for example,
     *           `projects/-/locations/-/agents/-/entityTypes/sys.date`), or
     *           `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     *           ID>/entityTypes/<Entity Type ID>` for developer entity types.
     *     @type bool $is_list
     *           Indicates whether the parameter represents a list of values.
     *     @type bool $redact
     *           Indicates whether the parameter content should be redacted in log. If
     *           redaction is enabled, the parameter content will be replaced by parameter
     *           name during logging.
     *           Note: the parameter content is subject to redaction if either parameter
     *           level redaction or [entity type level
     *           redaction][google.cloud.dialogflow.cx.v3.EntityType.redact] is enabled.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\Intent::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The unique identifier of the parameter. This field
     * is used by [training
     * phrases][google.cloud.dialogflow.cx.v3.Intent.TrainingPhrase] to annotate
     * their [parts][google.cloud.dialogflow.cx.v3.Intent.TrainingPhrase.Part].
     *
     * Generated from protobuf field <code>string id = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Required. The unique identifier of the parameter. This field
     * is used by [training
     * phrases][google.cloud.dialogflow.cx.v3.Intent.TrainingPhrase] to annotate
     * their [parts][google.cloud.dialogflow.cx.v3.Intent.TrainingPhrase.Part].
     *
     * Generated from protobuf field <code>string id = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setId($var)
    {
        GPBUtil::checkString($var, True);
        $this->id = $var;

        return $this;
    }

    /**
     * Required. The entity type of the parameter.
     * Format: `projects/-/locations/-/agents/-/entityTypes/<System Entity Type
     * ID>` for system entity types (for example,
     * `projects/-/locations/-/agents/-/entityTypes/sys.date`), or
     * `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/entityTypes/<Entity Type ID>` for developer entity types.
     *
     * Generated from protobuf field <code>string entity_type = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getEntityType()
    {
        return $this->entity_type;
    }

    /**
     * Required. The entity type of the parameter.
     * Format: `projects/-/locations/-/agents/-/entityTypes/<System Entity Type
     * ID>` for system entity types (for example,
     * `projects/-/locations/-/agents/-/entityTypes/sys.date`), or
     * `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/entityTypes/<Entity Type ID>` for developer entity types.
     *
     * Generated from protobuf field <code>string entity_type = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setEntityType($var)
    {
        GPBUtil::checkString($var, True);
        $this->entity_type = $var;

        return $this;
    }

    /**
     * Indicates whether the parameter represents a list of values.
     *
     * Generated from protobuf field <code>bool is_list = 3;</code>
     * @return bool
     */
    public function getIsList()
    {
        return $this->is_list;
    }

    /**
     * Indicates whether the parameter represents a list of values.
     *
     * Generated from protobuf field <code>bool is_list = 3;</code>
     * @param bool $var
     * @return $this
     */
    public function setIsList($var)
    {
        GPBUtil::checkBool($var);
        $this->is_list = $var;

        return $this;
    }

    /**
     * Indicates whether the parameter content should be redacted in log. If
     * redaction is enabled, the parameter content will be replaced by parameter
     * name during logging.
     * Note: the parameter content is subject to redaction if either parameter
     * level redaction or [entity type level
     * redaction][google.cloud.dialogflow.cx.v3.EntityType.redact] is enabled.
     *
     * Generated from protobuf field <code>bool redact = 4;</code>
     * @return bool
     */
    public function getRedact()
    {
        return $this->redact;
    }

    /**
     * Indicates whether the parameter content should be redacted in log. If
     * redaction is enabled, the parameter content will be replaced by parameter
     * name during logging.
     * Note: the parameter content is subject to redaction if either parameter
     * level redaction or [entity type level
     * redaction][google.cloud.dialogflow.cx.v3.EntityType.redact] is enabled.
     *
     * Generated from protobuf field <code>bool redact = 4;</code>
     * @param bool $var
     * @return $this
     */
    public function setRedact($var)
    {
        GPBUtil::checkBool($var);
        $this->redact = $var;

        return $this;
    }

}


