<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/intent.proto

namespace Google\Cloud\Dialogflow\Cx\V3\Intent;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents an example that the agent is trained on to identify the intent.
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.Intent.TrainingPhrase</code>
 */
class TrainingPhrase extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The unique identifier of the training phrase.
     *
     * Generated from protobuf field <code>string id = 1;</code>
     */
    protected $id = '';
    /**
     * Required. The ordered list of training phrase parts.
     * The parts are concatenated in order to form the training phrase.
     * Note: The API does not automatically annotate training phrases like the
     * Dialogflow Console does.
     * Note: Do not forget to include whitespace at part boundaries, so the
     * training phrase is well formatted when the parts are concatenated.
     * If the training phrase does not need to be annotated with parameters,
     * you just need a single part with only the
     * [Part.text][google.cloud.dialogflow.cx.v3.Intent.TrainingPhrase.Part.text]
     * field set.
     * If you want to annotate the training phrase, you must create multiple
     * parts, where the fields of each part are populated in one of two ways:
     * -   `Part.text` is set to a part of the phrase that has no parameters.
     * -   `Part.text` is set to a part of the phrase that you want to annotate,
     *     and the `parameter_id` field is set.
     *
     * Generated from protobuf field <code>repeated .google.cloud.dialogflow.cx.v3.Intent.TrainingPhrase.Part parts = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $parts;
    /**
     * Indicates how many times this example was added to the intent.
     *
     * Generated from protobuf field <code>int32 repeat_count = 3;</code>
     */
    protected $repeat_count = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $id
     *           Output only. The unique identifier of the training phrase.
     *     @type array<\Google\Cloud\Dialogflow\Cx\V3\Intent\TrainingPhrase\Part>|\Google\Protobuf\Internal\RepeatedField $parts
     *           Required. The ordered list of training phrase parts.
     *           The parts are concatenated in order to form the training phrase.
     *           Note: The API does not automatically annotate training phrases like the
     *           Dialogflow Console does.
     *           Note: Do not forget to include whitespace at part boundaries, so the
     *           training phrase is well formatted when the parts are concatenated.
     *           If the training phrase does not need to be annotated with parameters,
     *           you just need a single part with only the
     *           [Part.text][google.cloud.dialogflow.cx.v3.Intent.TrainingPhrase.Part.text]
     *           field set.
     *           If you want to annotate the training phrase, you must create multiple
     *           parts, where the fields of each part are populated in one of two ways:
     *           -   `Part.text` is set to a part of the phrase that has no parameters.
     *           -   `Part.text` is set to a part of the phrase that you want to annotate,
     *               and the `parameter_id` field is set.
     *     @type int $repeat_count
     *           Indicates how many times this example was added to the intent.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\Intent::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The unique identifier of the training phrase.
     *
     * Generated from protobuf field <code>string id = 1;</code>
     * @return string
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Output only. The unique identifier of the training phrase.
     *
     * Generated from protobuf field <code>string id = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setId($var)
    {
        GPBUtil::checkString($var, True);
        $this->id = $var;

        return $this;
    }

    /**
     * Required. The ordered list of training phrase parts.
     * The parts are concatenated in order to form the training phrase.
     * Note: The API does not automatically annotate training phrases like the
     * Dialogflow Console does.
     * Note: Do not forget to include whitespace at part boundaries, so the
     * training phrase is well formatted when the parts are concatenated.
     * If the training phrase does not need to be annotated with parameters,
     * you just need a single part with only the
     * [Part.text][google.cloud.dialogflow.cx.v3.Intent.TrainingPhrase.Part.text]
     * field set.
     * If you want to annotate the training phrase, you must create multiple
     * parts, where the fields of each part are populated in one of two ways:
     * -   `Part.text` is set to a part of the phrase that has no parameters.
     * -   `Part.text` is set to a part of the phrase that you want to annotate,
     *     and the `parameter_id` field is set.
     *
     * Generated from protobuf field <code>repeated .google.cloud.dialogflow.cx.v3.Intent.TrainingPhrase.Part parts = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getParts()
    {
        return $this->parts;
    }

    /**
     * Required. The ordered list of training phrase parts.
     * The parts are concatenated in order to form the training phrase.
     * Note: The API does not automatically annotate training phrases like the
     * Dialogflow Console does.
     * Note: Do not forget to include whitespace at part boundaries, so the
     * training phrase is well formatted when the parts are concatenated.
     * If the training phrase does not need to be annotated with parameters,
     * you just need a single part with only the
     * [Part.text][google.cloud.dialogflow.cx.v3.Intent.TrainingPhrase.Part.text]
     * field set.
     * If you want to annotate the training phrase, you must create multiple
     * parts, where the fields of each part are populated in one of two ways:
     * -   `Part.text` is set to a part of the phrase that has no parameters.
     * -   `Part.text` is set to a part of the phrase that you want to annotate,
     *     and the `parameter_id` field is set.
     *
     * Generated from protobuf field <code>repeated .google.cloud.dialogflow.cx.v3.Intent.TrainingPhrase.Part parts = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param array<\Google\Cloud\Dialogflow\Cx\V3\Intent\TrainingPhrase\Part>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setParts($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Dialogflow\Cx\V3\Intent\TrainingPhrase\Part::class);
        $this->parts = $arr;

        return $this;
    }

    /**
     * Indicates how many times this example was added to the intent.
     *
     * Generated from protobuf field <code>int32 repeat_count = 3;</code>
     * @return int
     */
    public function getRepeatCount()
    {
        return $this->repeat_count;
    }

    /**
     * Indicates how many times this example was added to the intent.
     *
     * Generated from protobuf field <code>int32 repeat_count = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setRepeatCount($var)
    {
        GPBUtil::checkInt32($var);
        $this->repeat_count = $var;

        return $this;
    }

}


