<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/session.proto

namespace Google\Cloud\Dialogflow\Cx\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents the query input. It can contain one of:
 * 1. A conversational query in the form of text.
 * 2. An intent query that specifies which intent to trigger.
 * 3. Natural language speech audio to be processed.
 * 4. An event to be triggered.
 * 5. DTMF digits to invoke an intent and fill in parameter value.
 * 6. The results of a tool executed by the client.
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.QueryInput</code>
 */
class QueryInput extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The language of the input. See [Language
     * Support](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     * for a list of the currently supported language codes. Note that queries in
     * the same session do not necessarily need to specify the same language.
     *
     * Generated from protobuf field <code>string language_code = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $language_code = '';
    protected $input;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\Dialogflow\Cx\V3\TextInput $text
     *           The natural language text to be processed.
     *     @type \Google\Cloud\Dialogflow\Cx\V3\IntentInput $intent
     *           The intent to be triggered.
     *     @type \Google\Cloud\Dialogflow\Cx\V3\AudioInput $audio
     *           The natural language speech audio to be processed.
     *     @type \Google\Cloud\Dialogflow\Cx\V3\EventInput $event
     *           The event to be triggered.
     *     @type \Google\Cloud\Dialogflow\Cx\V3\DtmfInput $dtmf
     *           The DTMF event to be handled.
     *     @type string $language_code
     *           Required. The language of the input. See [Language
     *           Support](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     *           for a list of the currently supported language codes. Note that queries in
     *           the same session do not necessarily need to specify the same language.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\Session::initOnce();
        parent::__construct($data);
    }

    /**
     * The natural language text to be processed.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.TextInput text = 2;</code>
     * @return \Google\Cloud\Dialogflow\Cx\V3\TextInput|null
     */
    public function getText()
    {
        return $this->readOneof(2);
    }

    public function hasText()
    {
        return $this->hasOneof(2);
    }

    /**
     * The natural language text to be processed.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.TextInput text = 2;</code>
     * @param \Google\Cloud\Dialogflow\Cx\V3\TextInput $var
     * @return $this
     */
    public function setText($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\Cx\V3\TextInput::class);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     * The intent to be triggered.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.IntentInput intent = 3;</code>
     * @return \Google\Cloud\Dialogflow\Cx\V3\IntentInput|null
     */
    public function getIntent()
    {
        return $this->readOneof(3);
    }

    public function hasIntent()
    {
        return $this->hasOneof(3);
    }

    /**
     * The intent to be triggered.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.IntentInput intent = 3;</code>
     * @param \Google\Cloud\Dialogflow\Cx\V3\IntentInput $var
     * @return $this
     */
    public function setIntent($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\Cx\V3\IntentInput::class);
        $this->writeOneof(3, $var);

        return $this;
    }

    /**
     * The natural language speech audio to be processed.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.AudioInput audio = 5;</code>
     * @return \Google\Cloud\Dialogflow\Cx\V3\AudioInput|null
     */
    public function getAudio()
    {
        return $this->readOneof(5);
    }

    public function hasAudio()
    {
        return $this->hasOneof(5);
    }

    /**
     * The natural language speech audio to be processed.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.AudioInput audio = 5;</code>
     * @param \Google\Cloud\Dialogflow\Cx\V3\AudioInput $var
     * @return $this
     */
    public function setAudio($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\Cx\V3\AudioInput::class);
        $this->writeOneof(5, $var);

        return $this;
    }

    /**
     * The event to be triggered.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.EventInput event = 6;</code>
     * @return \Google\Cloud\Dialogflow\Cx\V3\EventInput|null
     */
    public function getEvent()
    {
        return $this->readOneof(6);
    }

    public function hasEvent()
    {
        return $this->hasOneof(6);
    }

    /**
     * The event to be triggered.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.EventInput event = 6;</code>
     * @param \Google\Cloud\Dialogflow\Cx\V3\EventInput $var
     * @return $this
     */
    public function setEvent($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\Cx\V3\EventInput::class);
        $this->writeOneof(6, $var);

        return $this;
    }

    /**
     * The DTMF event to be handled.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.DtmfInput dtmf = 7;</code>
     * @return \Google\Cloud\Dialogflow\Cx\V3\DtmfInput|null
     */
    public function getDtmf()
    {
        return $this->readOneof(7);
    }

    public function hasDtmf()
    {
        return $this->hasOneof(7);
    }

    /**
     * The DTMF event to be handled.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.DtmfInput dtmf = 7;</code>
     * @param \Google\Cloud\Dialogflow\Cx\V3\DtmfInput $var
     * @return $this
     */
    public function setDtmf($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\Cx\V3\DtmfInput::class);
        $this->writeOneof(7, $var);

        return $this;
    }

    /**
     * Required. The language of the input. See [Language
     * Support](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     * for a list of the currently supported language codes. Note that queries in
     * the same session do not necessarily need to specify the same language.
     *
     * Generated from protobuf field <code>string language_code = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getLanguageCode()
    {
        return $this->language_code;
    }

    /**
     * Required. The language of the input. See [Language
     * Support](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     * for a list of the currently supported language codes. Note that queries in
     * the same session do not necessarily need to specify the same language.
     *
     * Generated from protobuf field <code>string language_code = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setLanguageCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->language_code = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getInput()
    {
        return $this->whichOneof("input");
    }

}

