<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/agent.proto

namespace Google\Cloud\Dialogflow\Cx\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for
 * [Agents.RestoreAgent][google.cloud.dialogflow.cx.v3.Agents.RestoreAgent].
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.RestoreAgentRequest</code>
 */
class RestoreAgentRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the agent to restore into.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';
    /**
     * Agent restore mode. If not specified, `KEEP` is assumed.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.RestoreAgentRequest.RestoreOption restore_option = 5;</code>
     */
    protected $restore_option = 0;
    protected $agent;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. The name of the agent to restore into.
     *           Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>`.
     *     @type string $agent_uri
     *           The [Google Cloud Storage](https://cloud.google.com/storage/docs/) URI
     *           to restore agent from. The format of this URI must be
     *           `gs://<bucket-name>/<object-name>`.
     *           Dialogflow performs a read operation for the Cloud Storage object
     *           on the caller's behalf, so your request authentication must
     *           have read permissions for the object. For more information, see
     *           [Dialogflow access
     *           control](https://cloud.google.com/dialogflow/cx/docs/concept/access-control#storage).
     *     @type string $agent_content
     *           Uncompressed raw byte content for agent.
     *     @type \Google\Cloud\Dialogflow\Cx\V3\RestoreAgentRequest\GitSource $git_source
     *           Setting for restoring from a git branch
     *     @type int $restore_option
     *           Agent restore mode. If not specified, `KEEP` is assumed.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\Agent::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the agent to restore into.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. The name of the agent to restore into.
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The [Google Cloud Storage](https://cloud.google.com/storage/docs/) URI
     * to restore agent from. The format of this URI must be
     * `gs://<bucket-name>/<object-name>`.
     * Dialogflow performs a read operation for the Cloud Storage object
     * on the caller's behalf, so your request authentication must
     * have read permissions for the object. For more information, see
     * [Dialogflow access
     * control](https://cloud.google.com/dialogflow/cx/docs/concept/access-control#storage).
     *
     * Generated from protobuf field <code>string agent_uri = 2;</code>
     * @return string
     */
    public function getAgentUri()
    {
        return $this->readOneof(2);
    }

    public function hasAgentUri()
    {
        return $this->hasOneof(2);
    }

    /**
     * The [Google Cloud Storage](https://cloud.google.com/storage/docs/) URI
     * to restore agent from. The format of this URI must be
     * `gs://<bucket-name>/<object-name>`.
     * Dialogflow performs a read operation for the Cloud Storage object
     * on the caller's behalf, so your request authentication must
     * have read permissions for the object. For more information, see
     * [Dialogflow access
     * control](https://cloud.google.com/dialogflow/cx/docs/concept/access-control#storage).
     *
     * Generated from protobuf field <code>string agent_uri = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setAgentUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     * Uncompressed raw byte content for agent.
     *
     * Generated from protobuf field <code>bytes agent_content = 3;</code>
     * @return string
     */
    public function getAgentContent()
    {
        return $this->readOneof(3);
    }

    public function hasAgentContent()
    {
        return $this->hasOneof(3);
    }

    /**
     * Uncompressed raw byte content for agent.
     *
     * Generated from protobuf field <code>bytes agent_content = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setAgentContent($var)
    {
        GPBUtil::checkString($var, False);
        $this->writeOneof(3, $var);

        return $this;
    }

    /**
     * Setting for restoring from a git branch
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.RestoreAgentRequest.GitSource git_source = 6;</code>
     * @return \Google\Cloud\Dialogflow\Cx\V3\RestoreAgentRequest\GitSource|null
     */
    public function getGitSource()
    {
        return $this->readOneof(6);
    }

    public function hasGitSource()
    {
        return $this->hasOneof(6);
    }

    /**
     * Setting for restoring from a git branch
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.RestoreAgentRequest.GitSource git_source = 6;</code>
     * @param \Google\Cloud\Dialogflow\Cx\V3\RestoreAgentRequest\GitSource $var
     * @return $this
     */
    public function setGitSource($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\Cx\V3\RestoreAgentRequest\GitSource::class);
        $this->writeOneof(6, $var);

        return $this;
    }

    /**
     * Agent restore mode. If not specified, `KEEP` is assumed.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.RestoreAgentRequest.RestoreOption restore_option = 5;</code>
     * @return int
     */
    public function getRestoreOption()
    {
        return $this->restore_option;
    }

    /**
     * Agent restore mode. If not specified, `KEEP` is assumed.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.RestoreAgentRequest.RestoreOption restore_option = 5;</code>
     * @param int $var
     * @return $this
     */
    public function setRestoreOption($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Dialogflow\Cx\V3\RestoreAgentRequest\RestoreOption::class);
        $this->restore_option = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getAgent()
    {
        return $this->whichOneof("agent");
    }

}

