<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/experiment.proto

namespace Google\Cloud\Dialogflow\Cx\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The configuration for auto rollout.
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.RolloutConfig</code>
 */
class RolloutConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * Steps to roll out a flow version. Steps should be sorted by percentage in
     * ascending order.
     *
     * Generated from protobuf field <code>repeated .google.cloud.dialogflow.cx.v3.RolloutConfig.RolloutStep rollout_steps = 1;</code>
     */
    private $rollout_steps;
    /**
     * The conditions that are used to evaluate the success of a rollout
     * step. If not specified, all rollout steps will proceed to the next one
     * unless failure conditions are met. E.g. "containment_rate > 60% AND
     * callback_rate < 20%". See the [conditions
     * reference](https://cloud.google.com/dialogflow/cx/docs/reference/condition).
     *
     * Generated from protobuf field <code>string rollout_condition = 2;</code>
     */
    protected $rollout_condition = '';
    /**
     * The conditions that are used to evaluate the failure of a rollout
     * step. If not specified, no rollout steps will fail. E.g. "containment_rate
     * < 10% OR average_turn_count < 3". See the [conditions
     * reference](https://cloud.google.com/dialogflow/cx/docs/reference/condition).
     *
     * Generated from protobuf field <code>string failure_condition = 3;</code>
     */
    protected $failure_condition = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type array<\Google\Cloud\Dialogflow\Cx\V3\RolloutConfig\RolloutStep>|\Google\Protobuf\Internal\RepeatedField $rollout_steps
     *           Steps to roll out a flow version. Steps should be sorted by percentage in
     *           ascending order.
     *     @type string $rollout_condition
     *           The conditions that are used to evaluate the success of a rollout
     *           step. If not specified, all rollout steps will proceed to the next one
     *           unless failure conditions are met. E.g. "containment_rate > 60% AND
     *           callback_rate < 20%". See the [conditions
     *           reference](https://cloud.google.com/dialogflow/cx/docs/reference/condition).
     *     @type string $failure_condition
     *           The conditions that are used to evaluate the failure of a rollout
     *           step. If not specified, no rollout steps will fail. E.g. "containment_rate
     *           < 10% OR average_turn_count < 3". See the [conditions
     *           reference](https://cloud.google.com/dialogflow/cx/docs/reference/condition).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\Experiment::initOnce();
        parent::__construct($data);
    }

    /**
     * Steps to roll out a flow version. Steps should be sorted by percentage in
     * ascending order.
     *
     * Generated from protobuf field <code>repeated .google.cloud.dialogflow.cx.v3.RolloutConfig.RolloutStep rollout_steps = 1;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getRolloutSteps()
    {
        return $this->rollout_steps;
    }

    /**
     * Steps to roll out a flow version. Steps should be sorted by percentage in
     * ascending order.
     *
     * Generated from protobuf field <code>repeated .google.cloud.dialogflow.cx.v3.RolloutConfig.RolloutStep rollout_steps = 1;</code>
     * @param array<\Google\Cloud\Dialogflow\Cx\V3\RolloutConfig\RolloutStep>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setRolloutSteps($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Dialogflow\Cx\V3\RolloutConfig\RolloutStep::class);
        $this->rollout_steps = $arr;

        return $this;
    }

    /**
     * The conditions that are used to evaluate the success of a rollout
     * step. If not specified, all rollout steps will proceed to the next one
     * unless failure conditions are met. E.g. "containment_rate > 60% AND
     * callback_rate < 20%". See the [conditions
     * reference](https://cloud.google.com/dialogflow/cx/docs/reference/condition).
     *
     * Generated from protobuf field <code>string rollout_condition = 2;</code>
     * @return string
     */
    public function getRolloutCondition()
    {
        return $this->rollout_condition;
    }

    /**
     * The conditions that are used to evaluate the success of a rollout
     * step. If not specified, all rollout steps will proceed to the next one
     * unless failure conditions are met. E.g. "containment_rate > 60% AND
     * callback_rate < 20%". See the [conditions
     * reference](https://cloud.google.com/dialogflow/cx/docs/reference/condition).
     *
     * Generated from protobuf field <code>string rollout_condition = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setRolloutCondition($var)
    {
        GPBUtil::checkString($var, True);
        $this->rollout_condition = $var;

        return $this;
    }

    /**
     * The conditions that are used to evaluate the failure of a rollout
     * step. If not specified, no rollout steps will fail. E.g. "containment_rate
     * < 10% OR average_turn_count < 3". See the [conditions
     * reference](https://cloud.google.com/dialogflow/cx/docs/reference/condition).
     *
     * Generated from protobuf field <code>string failure_condition = 3;</code>
     * @return string
     */
    public function getFailureCondition()
    {
        return $this->failure_condition;
    }

    /**
     * The conditions that are used to evaluate the failure of a rollout
     * step. If not specified, no rollout steps will fail. E.g. "containment_rate
     * < 10% OR average_turn_count < 3". See the [conditions
     * reference](https://cloud.google.com/dialogflow/cx/docs/reference/condition).
     *
     * Generated from protobuf field <code>string failure_condition = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setFailureCondition($var)
    {
        GPBUtil::checkString($var, True);
        $this->failure_condition = $var;

        return $this;
    }

}

