<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/test_case.proto

namespace Google\Cloud\Dialogflow\Cx\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents a result from running a test case in an agent environment.
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.TestCaseResult</code>
 */
class TestCaseResult extends \Google\Protobuf\Internal\Message
{
    /**
     * The resource name for the test case result. Format:
     * `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>/testCases/
     * <TestCase ID>/results/<TestCaseResult ID>`.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    protected $name = '';
    /**
     * Environment where the test was run. If not set, it indicates the draft
     * environment.
     *
     * Generated from protobuf field <code>string environment = 2 [(.google.api.resource_reference) = {</code>
     */
    protected $environment = '';
    /**
     * The conversation turns uttered during the test case replay in chronological
     * order.
     *
     * Generated from protobuf field <code>repeated .google.cloud.dialogflow.cx.v3.ConversationTurn conversation_turns = 3;</code>
     */
    private $conversation_turns;
    /**
     * Whether the test case passed in the agent environment.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.TestResult test_result = 4;</code>
     */
    protected $test_result = 0;
    /**
     * The time that the test was run.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp test_time = 5;</code>
     */
    protected $test_time = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           The resource name for the test case result. Format:
     *           `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>/testCases/
     *           <TestCase ID>/results/<TestCaseResult ID>`.
     *     @type string $environment
     *           Environment where the test was run. If not set, it indicates the draft
     *           environment.
     *     @type array<\Google\Cloud\Dialogflow\Cx\V3\ConversationTurn>|\Google\Protobuf\Internal\RepeatedField $conversation_turns
     *           The conversation turns uttered during the test case replay in chronological
     *           order.
     *     @type int $test_result
     *           Whether the test case passed in the agent environment.
     *     @type \Google\Protobuf\Timestamp $test_time
     *           The time that the test was run.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\TestCase::initOnce();
        parent::__construct($data);
    }

    /**
     * The resource name for the test case result. Format:
     * `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>/testCases/
     * <TestCase ID>/results/<TestCaseResult ID>`.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * The resource name for the test case result. Format:
     * `projects/<Project ID>/locations/<Location ID>/agents/<Agent ID>/testCases/
     * <TestCase ID>/results/<TestCaseResult ID>`.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Environment where the test was run. If not set, it indicates the draft
     * environment.
     *
     * Generated from protobuf field <code>string environment = 2 [(.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getEnvironment()
    {
        return $this->environment;
    }

    /**
     * Environment where the test was run. If not set, it indicates the draft
     * environment.
     *
     * Generated from protobuf field <code>string environment = 2 [(.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setEnvironment($var)
    {
        GPBUtil::checkString($var, True);
        $this->environment = $var;

        return $this;
    }

    /**
     * The conversation turns uttered during the test case replay in chronological
     * order.
     *
     * Generated from protobuf field <code>repeated .google.cloud.dialogflow.cx.v3.ConversationTurn conversation_turns = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getConversationTurns()
    {
        return $this->conversation_turns;
    }

    /**
     * The conversation turns uttered during the test case replay in chronological
     * order.
     *
     * Generated from protobuf field <code>repeated .google.cloud.dialogflow.cx.v3.ConversationTurn conversation_turns = 3;</code>
     * @param array<\Google\Cloud\Dialogflow\Cx\V3\ConversationTurn>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setConversationTurns($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Dialogflow\Cx\V3\ConversationTurn::class);
        $this->conversation_turns = $arr;

        return $this;
    }

    /**
     * Whether the test case passed in the agent environment.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.TestResult test_result = 4;</code>
     * @return int
     */
    public function getTestResult()
    {
        return $this->test_result;
    }

    /**
     * Whether the test case passed in the agent environment.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.TestResult test_result = 4;</code>
     * @param int $var
     * @return $this
     */
    public function setTestResult($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Dialogflow\Cx\V3\TestResult::class);
        $this->test_result = $var;

        return $this;
    }

    /**
     * The time that the test was run.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp test_time = 5;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getTestTime()
    {
        return $this->test_time;
    }

    public function hasTestTime()
    {
        return isset($this->test_time);
    }

    public function clearTestTime()
    {
        unset($this->test_time);
    }

    /**
     * The time that the test was run.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp test_time = 5;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setTestTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->test_time = $var;

        return $this;
    }

}

