<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/audio_config.proto

namespace Google\Cloud\Dialogflow\Cx\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Settings related to speech synthesizing.
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.TextToSpeechSettings</code>
 */
class TextToSpeechSettings extends \Google\Protobuf\Internal\Message
{
    /**
     * Configuration of how speech should be synthesized, mapping from language
     * (https://cloud.google.com/dialogflow/cx/docs/reference/language) to
     * SynthesizeSpeechConfig.
     * These settings affect:
     *  - The [phone
     *  gateway](https://cloud.google.com/dialogflow/cx/docs/concept/integration/phone-gateway)
     *    synthesize configuration set via
     *    [Agent.text_to_speech_settings][google.cloud.dialogflow.cx.v3.Agent.text_to_speech_settings].
     *  - How speech is synthesized when invoking
     *  [session][google.cloud.dialogflow.cx.v3.Sessions] APIs.
     *    [Agent.text_to_speech_settings][google.cloud.dialogflow.cx.v3.Agent.text_to_speech_settings]
     *    only applies if
     *    [OutputAudioConfig.synthesize_speech_config][google.cloud.dialogflow.cx.v3.OutputAudioConfig.synthesize_speech_config]
     *    is not specified.
     *
     * Generated from protobuf field <code>map<string, .google.cloud.dialogflow.cx.v3.SynthesizeSpeechConfig> synthesize_speech_configs = 1;</code>
     */
    private $synthesize_speech_configs;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type array|\Google\Protobuf\Internal\MapField $synthesize_speech_configs
     *           Configuration of how speech should be synthesized, mapping from language
     *           (https://cloud.google.com/dialogflow/cx/docs/reference/language) to
     *           SynthesizeSpeechConfig.
     *           These settings affect:
     *            - The [phone
     *            gateway](https://cloud.google.com/dialogflow/cx/docs/concept/integration/phone-gateway)
     *              synthesize configuration set via
     *              [Agent.text_to_speech_settings][google.cloud.dialogflow.cx.v3.Agent.text_to_speech_settings].
     *            - How speech is synthesized when invoking
     *            [session][google.cloud.dialogflow.cx.v3.Sessions] APIs.
     *              [Agent.text_to_speech_settings][google.cloud.dialogflow.cx.v3.Agent.text_to_speech_settings]
     *              only applies if
     *              [OutputAudioConfig.synthesize_speech_config][google.cloud.dialogflow.cx.v3.OutputAudioConfig.synthesize_speech_config]
     *              is not specified.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\AudioConfig::initOnce();
        parent::__construct($data);
    }

    /**
     * Configuration of how speech should be synthesized, mapping from language
     * (https://cloud.google.com/dialogflow/cx/docs/reference/language) to
     * SynthesizeSpeechConfig.
     * These settings affect:
     *  - The [phone
     *  gateway](https://cloud.google.com/dialogflow/cx/docs/concept/integration/phone-gateway)
     *    synthesize configuration set via
     *    [Agent.text_to_speech_settings][google.cloud.dialogflow.cx.v3.Agent.text_to_speech_settings].
     *  - How speech is synthesized when invoking
     *  [session][google.cloud.dialogflow.cx.v3.Sessions] APIs.
     *    [Agent.text_to_speech_settings][google.cloud.dialogflow.cx.v3.Agent.text_to_speech_settings]
     *    only applies if
     *    [OutputAudioConfig.synthesize_speech_config][google.cloud.dialogflow.cx.v3.OutputAudioConfig.synthesize_speech_config]
     *    is not specified.
     *
     * Generated from protobuf field <code>map<string, .google.cloud.dialogflow.cx.v3.SynthesizeSpeechConfig> synthesize_speech_configs = 1;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getSynthesizeSpeechConfigs()
    {
        return $this->synthesize_speech_configs;
    }

    /**
     * Configuration of how speech should be synthesized, mapping from language
     * (https://cloud.google.com/dialogflow/cx/docs/reference/language) to
     * SynthesizeSpeechConfig.
     * These settings affect:
     *  - The [phone
     *  gateway](https://cloud.google.com/dialogflow/cx/docs/concept/integration/phone-gateway)
     *    synthesize configuration set via
     *    [Agent.text_to_speech_settings][google.cloud.dialogflow.cx.v3.Agent.text_to_speech_settings].
     *  - How speech is synthesized when invoking
     *  [session][google.cloud.dialogflow.cx.v3.Sessions] APIs.
     *    [Agent.text_to_speech_settings][google.cloud.dialogflow.cx.v3.Agent.text_to_speech_settings]
     *    only applies if
     *    [OutputAudioConfig.synthesize_speech_config][google.cloud.dialogflow.cx.v3.OutputAudioConfig.synthesize_speech_config]
     *    is not specified.
     *
     * Generated from protobuf field <code>map<string, .google.cloud.dialogflow.cx.v3.SynthesizeSpeechConfig> synthesize_speech_configs = 1;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setSynthesizeSpeechConfigs($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Dialogflow\Cx\V3\SynthesizeSpeechConfig::class);
        $this->synthesize_speech_configs = $arr;

        return $this;
    }

}

