<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/flow.proto

namespace Google\Cloud\Dialogflow\Cx\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for
 * [Flows.UpdateFlow][google.cloud.dialogflow.cx.v3.Flows.UpdateFlow].
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.UpdateFlowRequest</code>
 */
class UpdateFlowRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The flow to update.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.Flow flow = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $flow = null;
    /**
     * The mask to control which fields get updated. If the mask is not present,
     * all fields will be updated.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 2;</code>
     */
    protected $update_mask = null;
    /**
     * The language of the following fields in `flow`:
     * *  `Flow.event_handlers.trigger_fulfillment.messages`
     * *  `Flow.event_handlers.trigger_fulfillment.conditional_cases`
     * *  `Flow.transition_routes.trigger_fulfillment.messages`
     * *  `Flow.transition_routes.trigger_fulfillment.conditional_cases`
     * If not specified, the agent's default language is used.
     * [Many
     * languages](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     * are supported.
     * Note: languages must be enabled in the agent before they can be used.
     *
     * Generated from protobuf field <code>string language_code = 3;</code>
     */
    protected $language_code = '';

    /**
     * @param \Google\Cloud\Dialogflow\Cx\V3\Flow $flow       Required. The flow to update.
     * @param \Google\Protobuf\FieldMask          $updateMask The mask to control which fields get updated. If the mask is not present,
     *                                                        all fields will be updated.
     *
     * @return \Google\Cloud\Dialogflow\Cx\V3\UpdateFlowRequest
     *
     * @experimental
     */
    public static function build(\Google\Cloud\Dialogflow\Cx\V3\Flow $flow, \Google\Protobuf\FieldMask $updateMask): self
    {
        return (new self())
            ->setFlow($flow)
            ->setUpdateMask($updateMask);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\Dialogflow\Cx\V3\Flow $flow
     *           Required. The flow to update.
     *     @type \Google\Protobuf\FieldMask $update_mask
     *           The mask to control which fields get updated. If the mask is not present,
     *           all fields will be updated.
     *     @type string $language_code
     *           The language of the following fields in `flow`:
     *           *  `Flow.event_handlers.trigger_fulfillment.messages`
     *           *  `Flow.event_handlers.trigger_fulfillment.conditional_cases`
     *           *  `Flow.transition_routes.trigger_fulfillment.messages`
     *           *  `Flow.transition_routes.trigger_fulfillment.conditional_cases`
     *           If not specified, the agent's default language is used.
     *           [Many
     *           languages](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     *           are supported.
     *           Note: languages must be enabled in the agent before they can be used.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\Flow::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The flow to update.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.Flow flow = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\Dialogflow\Cx\V3\Flow|null
     */
    public function getFlow()
    {
        return $this->flow;
    }

    public function hasFlow()
    {
        return isset($this->flow);
    }

    public function clearFlow()
    {
        unset($this->flow);
    }

    /**
     * Required. The flow to update.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.Flow flow = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\Dialogflow\Cx\V3\Flow $var
     * @return $this
     */
    public function setFlow($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\Cx\V3\Flow::class);
        $this->flow = $var;

        return $this;
    }

    /**
     * The mask to control which fields get updated. If the mask is not present,
     * all fields will be updated.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 2;</code>
     * @return \Google\Protobuf\FieldMask|null
     */
    public function getUpdateMask()
    {
        return $this->update_mask;
    }

    public function hasUpdateMask()
    {
        return isset($this->update_mask);
    }

    public function clearUpdateMask()
    {
        unset($this->update_mask);
    }

    /**
     * The mask to control which fields get updated. If the mask is not present,
     * all fields will be updated.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 2;</code>
     * @param \Google\Protobuf\FieldMask $var
     * @return $this
     */
    public function setUpdateMask($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\FieldMask::class);
        $this->update_mask = $var;

        return $this;
    }

    /**
     * The language of the following fields in `flow`:
     * *  `Flow.event_handlers.trigger_fulfillment.messages`
     * *  `Flow.event_handlers.trigger_fulfillment.conditional_cases`
     * *  `Flow.transition_routes.trigger_fulfillment.messages`
     * *  `Flow.transition_routes.trigger_fulfillment.conditional_cases`
     * If not specified, the agent's default language is used.
     * [Many
     * languages](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     * are supported.
     * Note: languages must be enabled in the agent before they can be used.
     *
     * Generated from protobuf field <code>string language_code = 3;</code>
     * @return string
     */
    public function getLanguageCode()
    {
        return $this->language_code;
    }

    /**
     * The language of the following fields in `flow`:
     * *  `Flow.event_handlers.trigger_fulfillment.messages`
     * *  `Flow.event_handlers.trigger_fulfillment.conditional_cases`
     * *  `Flow.transition_routes.trigger_fulfillment.messages`
     * *  `Flow.transition_routes.trigger_fulfillment.conditional_cases`
     * If not specified, the agent's default language is used.
     * [Many
     * languages](https://cloud.google.com/dialogflow/cx/docs/reference/language)
     * are supported.
     * Note: languages must be enabled in the agent before they can be used.
     *
     * Generated from protobuf field <code>string language_code = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setLanguageCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->language_code = $var;

        return $this;
    }

}

