<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/webhook.proto

namespace Google\Cloud\Dialogflow\Cx\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for a webhook call. The request is sent as a JSON object
 * and the field names will be presented in camel cases.
 * You may see undocumented fields in an actual request. These fields are used
 * internally by Dialogflow and should be ignored.
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.WebhookRequest</code>
 */
class WebhookRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Always present. The unique identifier of the
     * [DetectIntentResponse][google.cloud.dialogflow.cx.v3.DetectIntentResponse]
     * that will be returned to the API caller.
     *
     * Generated from protobuf field <code>string detect_intent_response_id = 1;</code>
     */
    protected $detect_intent_response_id = '';
    /**
     * The language code specified in the [original
     * request][QueryInput.language_code].
     *
     * Generated from protobuf field <code>string language_code = 15;</code>
     */
    protected $language_code = '';
    /**
     * Always present. Information about the fulfillment that triggered this
     * webhook call.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.WebhookRequest.FulfillmentInfo fulfillment_info = 6;</code>
     */
    protected $fulfillment_info = null;
    /**
     * Information about the last matched intent.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.WebhookRequest.IntentInfo intent_info = 3;</code>
     */
    protected $intent_info = null;
    /**
     * Information about page status.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.PageInfo page_info = 4;</code>
     */
    protected $page_info = null;
    /**
     * Information about session status.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.SessionInfo session_info = 5;</code>
     */
    protected $session_info = null;
    /**
     * The list of rich message responses to present to the user. Webhook can
     * choose to append or replace this list in
     * [WebhookResponse.fulfillment_response][google.cloud.dialogflow.cx.v3.WebhookResponse.fulfillment_response];
     *
     * Generated from protobuf field <code>repeated .google.cloud.dialogflow.cx.v3.ResponseMessage messages = 7;</code>
     */
    private $messages;
    /**
     * Custom data set in
     * [QueryParameters.payload][google.cloud.dialogflow.cx.v3.QueryParameters.payload].
     *
     * Generated from protobuf field <code>.google.protobuf.Struct payload = 8;</code>
     */
    protected $payload = null;
    /**
     * The sentiment analysis result of the current user request. The field is
     * filled when sentiment analysis is configured to be enabled for the request.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.WebhookRequest.SentimentAnalysisResult sentiment_analysis_result = 9;</code>
     */
    protected $sentiment_analysis_result = null;
    /**
     * Information about the language of the request.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.LanguageInfo language_info = 18;</code>
     */
    protected $language_info = null;
    protected $query;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $detect_intent_response_id
     *           Always present. The unique identifier of the
     *           [DetectIntentResponse][google.cloud.dialogflow.cx.v3.DetectIntentResponse]
     *           that will be returned to the API caller.
     *     @type string $text
     *           If [natural language text][google.cloud.dialogflow.cx.v3.TextInput] was
     *           provided as input, this field will contain a copy of the text.
     *     @type string $trigger_intent
     *           If an [intent][google.cloud.dialogflow.cx.v3.IntentInput] was provided as
     *           input, this field will contain a copy of the intent identifier. Format:
     *           `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     *           ID>/intents/<Intent ID>`.
     *     @type string $transcript
     *           If [natural language speech
     *           audio][google.cloud.dialogflow.cx.v3.AudioInput] was provided as input,
     *           this field will contain the transcript for the audio.
     *     @type string $trigger_event
     *           If an [event][google.cloud.dialogflow.cx.v3.EventInput] was provided as
     *           input, this field will contain the name of the event.
     *     @type string $dtmf_digits
     *           If [DTMF][google.cloud.dialogflow.cx.v3.DtmfInput] was provided as input,
     *           this field will contain the DTMF digits.
     *     @type string $language_code
     *           The language code specified in the [original
     *           request][QueryInput.language_code].
     *     @type \Google\Cloud\Dialogflow\Cx\V3\WebhookRequest\FulfillmentInfo $fulfillment_info
     *           Always present. Information about the fulfillment that triggered this
     *           webhook call.
     *     @type \Google\Cloud\Dialogflow\Cx\V3\WebhookRequest\IntentInfo $intent_info
     *           Information about the last matched intent.
     *     @type \Google\Cloud\Dialogflow\Cx\V3\PageInfo $page_info
     *           Information about page status.
     *     @type \Google\Cloud\Dialogflow\Cx\V3\SessionInfo $session_info
     *           Information about session status.
     *     @type array<\Google\Cloud\Dialogflow\Cx\V3\ResponseMessage>|\Google\Protobuf\Internal\RepeatedField $messages
     *           The list of rich message responses to present to the user. Webhook can
     *           choose to append or replace this list in
     *           [WebhookResponse.fulfillment_response][google.cloud.dialogflow.cx.v3.WebhookResponse.fulfillment_response];
     *     @type \Google\Protobuf\Struct $payload
     *           Custom data set in
     *           [QueryParameters.payload][google.cloud.dialogflow.cx.v3.QueryParameters.payload].
     *     @type \Google\Cloud\Dialogflow\Cx\V3\WebhookRequest\SentimentAnalysisResult $sentiment_analysis_result
     *           The sentiment analysis result of the current user request. The field is
     *           filled when sentiment analysis is configured to be enabled for the request.
     *     @type \Google\Cloud\Dialogflow\Cx\V3\LanguageInfo $language_info
     *           Information about the language of the request.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\Webhook::initOnce();
        parent::__construct($data);
    }

    /**
     * Always present. The unique identifier of the
     * [DetectIntentResponse][google.cloud.dialogflow.cx.v3.DetectIntentResponse]
     * that will be returned to the API caller.
     *
     * Generated from protobuf field <code>string detect_intent_response_id = 1;</code>
     * @return string
     */
    public function getDetectIntentResponseId()
    {
        return $this->detect_intent_response_id;
    }

    /**
     * Always present. The unique identifier of the
     * [DetectIntentResponse][google.cloud.dialogflow.cx.v3.DetectIntentResponse]
     * that will be returned to the API caller.
     *
     * Generated from protobuf field <code>string detect_intent_response_id = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setDetectIntentResponseId($var)
    {
        GPBUtil::checkString($var, True);
        $this->detect_intent_response_id = $var;

        return $this;
    }

    /**
     * If [natural language text][google.cloud.dialogflow.cx.v3.TextInput] was
     * provided as input, this field will contain a copy of the text.
     *
     * Generated from protobuf field <code>string text = 10;</code>
     * @return string
     */
    public function getText()
    {
        return $this->readOneof(10);
    }

    public function hasText()
    {
        return $this->hasOneof(10);
    }

    /**
     * If [natural language text][google.cloud.dialogflow.cx.v3.TextInput] was
     * provided as input, this field will contain a copy of the text.
     *
     * Generated from protobuf field <code>string text = 10;</code>
     * @param string $var
     * @return $this
     */
    public function setText($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(10, $var);

        return $this;
    }

    /**
     * If an [intent][google.cloud.dialogflow.cx.v3.IntentInput] was provided as
     * input, this field will contain a copy of the intent identifier. Format:
     * `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/intents/<Intent ID>`.
     *
     * Generated from protobuf field <code>string trigger_intent = 11 [(.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getTriggerIntent()
    {
        return $this->readOneof(11);
    }

    public function hasTriggerIntent()
    {
        return $this->hasOneof(11);
    }

    /**
     * If an [intent][google.cloud.dialogflow.cx.v3.IntentInput] was provided as
     * input, this field will contain a copy of the intent identifier. Format:
     * `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/intents/<Intent ID>`.
     *
     * Generated from protobuf field <code>string trigger_intent = 11 [(.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setTriggerIntent($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(11, $var);

        return $this;
    }

    /**
     * If [natural language speech
     * audio][google.cloud.dialogflow.cx.v3.AudioInput] was provided as input,
     * this field will contain the transcript for the audio.
     *
     * Generated from protobuf field <code>string transcript = 12;</code>
     * @return string
     */
    public function getTranscript()
    {
        return $this->readOneof(12);
    }

    public function hasTranscript()
    {
        return $this->hasOneof(12);
    }

    /**
     * If [natural language speech
     * audio][google.cloud.dialogflow.cx.v3.AudioInput] was provided as input,
     * this field will contain the transcript for the audio.
     *
     * Generated from protobuf field <code>string transcript = 12;</code>
     * @param string $var
     * @return $this
     */
    public function setTranscript($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(12, $var);

        return $this;
    }

    /**
     * If an [event][google.cloud.dialogflow.cx.v3.EventInput] was provided as
     * input, this field will contain the name of the event.
     *
     * Generated from protobuf field <code>string trigger_event = 14;</code>
     * @return string
     */
    public function getTriggerEvent()
    {
        return $this->readOneof(14);
    }

    public function hasTriggerEvent()
    {
        return $this->hasOneof(14);
    }

    /**
     * If an [event][google.cloud.dialogflow.cx.v3.EventInput] was provided as
     * input, this field will contain the name of the event.
     *
     * Generated from protobuf field <code>string trigger_event = 14;</code>
     * @param string $var
     * @return $this
     */
    public function setTriggerEvent($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(14, $var);

        return $this;
    }

    /**
     * If [DTMF][google.cloud.dialogflow.cx.v3.DtmfInput] was provided as input,
     * this field will contain the DTMF digits.
     *
     * Generated from protobuf field <code>string dtmf_digits = 17;</code>
     * @return string
     */
    public function getDtmfDigits()
    {
        return $this->readOneof(17);
    }

    public function hasDtmfDigits()
    {
        return $this->hasOneof(17);
    }

    /**
     * If [DTMF][google.cloud.dialogflow.cx.v3.DtmfInput] was provided as input,
     * this field will contain the DTMF digits.
     *
     * Generated from protobuf field <code>string dtmf_digits = 17;</code>
     * @param string $var
     * @return $this
     */
    public function setDtmfDigits($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(17, $var);

        return $this;
    }

    /**
     * The language code specified in the [original
     * request][QueryInput.language_code].
     *
     * Generated from protobuf field <code>string language_code = 15;</code>
     * @return string
     */
    public function getLanguageCode()
    {
        return $this->language_code;
    }

    /**
     * The language code specified in the [original
     * request][QueryInput.language_code].
     *
     * Generated from protobuf field <code>string language_code = 15;</code>
     * @param string $var
     * @return $this
     */
    public function setLanguageCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->language_code = $var;

        return $this;
    }

    /**
     * Always present. Information about the fulfillment that triggered this
     * webhook call.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.WebhookRequest.FulfillmentInfo fulfillment_info = 6;</code>
     * @return \Google\Cloud\Dialogflow\Cx\V3\WebhookRequest\FulfillmentInfo|null
     */
    public function getFulfillmentInfo()
    {
        return $this->fulfillment_info;
    }

    public function hasFulfillmentInfo()
    {
        return isset($this->fulfillment_info);
    }

    public function clearFulfillmentInfo()
    {
        unset($this->fulfillment_info);
    }

    /**
     * Always present. Information about the fulfillment that triggered this
     * webhook call.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.WebhookRequest.FulfillmentInfo fulfillment_info = 6;</code>
     * @param \Google\Cloud\Dialogflow\Cx\V3\WebhookRequest\FulfillmentInfo $var
     * @return $this
     */
    public function setFulfillmentInfo($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\Cx\V3\WebhookRequest\FulfillmentInfo::class);
        $this->fulfillment_info = $var;

        return $this;
    }

    /**
     * Information about the last matched intent.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.WebhookRequest.IntentInfo intent_info = 3;</code>
     * @return \Google\Cloud\Dialogflow\Cx\V3\WebhookRequest\IntentInfo|null
     */
    public function getIntentInfo()
    {
        return $this->intent_info;
    }

    public function hasIntentInfo()
    {
        return isset($this->intent_info);
    }

    public function clearIntentInfo()
    {
        unset($this->intent_info);
    }

    /**
     * Information about the last matched intent.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.WebhookRequest.IntentInfo intent_info = 3;</code>
     * @param \Google\Cloud\Dialogflow\Cx\V3\WebhookRequest\IntentInfo $var
     * @return $this
     */
    public function setIntentInfo($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\Cx\V3\WebhookRequest\IntentInfo::class);
        $this->intent_info = $var;

        return $this;
    }

    /**
     * Information about page status.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.PageInfo page_info = 4;</code>
     * @return \Google\Cloud\Dialogflow\Cx\V3\PageInfo|null
     */
    public function getPageInfo()
    {
        return $this->page_info;
    }

    public function hasPageInfo()
    {
        return isset($this->page_info);
    }

    public function clearPageInfo()
    {
        unset($this->page_info);
    }

    /**
     * Information about page status.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.PageInfo page_info = 4;</code>
     * @param \Google\Cloud\Dialogflow\Cx\V3\PageInfo $var
     * @return $this
     */
    public function setPageInfo($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\Cx\V3\PageInfo::class);
        $this->page_info = $var;

        return $this;
    }

    /**
     * Information about session status.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.SessionInfo session_info = 5;</code>
     * @return \Google\Cloud\Dialogflow\Cx\V3\SessionInfo|null
     */
    public function getSessionInfo()
    {
        return $this->session_info;
    }

    public function hasSessionInfo()
    {
        return isset($this->session_info);
    }

    public function clearSessionInfo()
    {
        unset($this->session_info);
    }

    /**
     * Information about session status.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.SessionInfo session_info = 5;</code>
     * @param \Google\Cloud\Dialogflow\Cx\V3\SessionInfo $var
     * @return $this
     */
    public function setSessionInfo($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\Cx\V3\SessionInfo::class);
        $this->session_info = $var;

        return $this;
    }

    /**
     * The list of rich message responses to present to the user. Webhook can
     * choose to append or replace this list in
     * [WebhookResponse.fulfillment_response][google.cloud.dialogflow.cx.v3.WebhookResponse.fulfillment_response];
     *
     * Generated from protobuf field <code>repeated .google.cloud.dialogflow.cx.v3.ResponseMessage messages = 7;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getMessages()
    {
        return $this->messages;
    }

    /**
     * The list of rich message responses to present to the user. Webhook can
     * choose to append or replace this list in
     * [WebhookResponse.fulfillment_response][google.cloud.dialogflow.cx.v3.WebhookResponse.fulfillment_response];
     *
     * Generated from protobuf field <code>repeated .google.cloud.dialogflow.cx.v3.ResponseMessage messages = 7;</code>
     * @param array<\Google\Cloud\Dialogflow\Cx\V3\ResponseMessage>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setMessages($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Dialogflow\Cx\V3\ResponseMessage::class);
        $this->messages = $arr;

        return $this;
    }

    /**
     * Custom data set in
     * [QueryParameters.payload][google.cloud.dialogflow.cx.v3.QueryParameters.payload].
     *
     * Generated from protobuf field <code>.google.protobuf.Struct payload = 8;</code>
     * @return \Google\Protobuf\Struct|null
     */
    public function getPayload()
    {
        return $this->payload;
    }

    public function hasPayload()
    {
        return isset($this->payload);
    }

    public function clearPayload()
    {
        unset($this->payload);
    }

    /**
     * Custom data set in
     * [QueryParameters.payload][google.cloud.dialogflow.cx.v3.QueryParameters.payload].
     *
     * Generated from protobuf field <code>.google.protobuf.Struct payload = 8;</code>
     * @param \Google\Protobuf\Struct $var
     * @return $this
     */
    public function setPayload($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Struct::class);
        $this->payload = $var;

        return $this;
    }

    /**
     * The sentiment analysis result of the current user request. The field is
     * filled when sentiment analysis is configured to be enabled for the request.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.WebhookRequest.SentimentAnalysisResult sentiment_analysis_result = 9;</code>
     * @return \Google\Cloud\Dialogflow\Cx\V3\WebhookRequest\SentimentAnalysisResult|null
     */
    public function getSentimentAnalysisResult()
    {
        return $this->sentiment_analysis_result;
    }

    public function hasSentimentAnalysisResult()
    {
        return isset($this->sentiment_analysis_result);
    }

    public function clearSentimentAnalysisResult()
    {
        unset($this->sentiment_analysis_result);
    }

    /**
     * The sentiment analysis result of the current user request. The field is
     * filled when sentiment analysis is configured to be enabled for the request.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.WebhookRequest.SentimentAnalysisResult sentiment_analysis_result = 9;</code>
     * @param \Google\Cloud\Dialogflow\Cx\V3\WebhookRequest\SentimentAnalysisResult $var
     * @return $this
     */
    public function setSentimentAnalysisResult($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\Cx\V3\WebhookRequest\SentimentAnalysisResult::class);
        $this->sentiment_analysis_result = $var;

        return $this;
    }

    /**
     * Information about the language of the request.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.LanguageInfo language_info = 18;</code>
     * @return \Google\Cloud\Dialogflow\Cx\V3\LanguageInfo|null
     */
    public function getLanguageInfo()
    {
        return $this->language_info;
    }

    public function hasLanguageInfo()
    {
        return isset($this->language_info);
    }

    public function clearLanguageInfo()
    {
        unset($this->language_info);
    }

    /**
     * Information about the language of the request.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.cx.v3.LanguageInfo language_info = 18;</code>
     * @param \Google\Cloud\Dialogflow\Cx\V3\LanguageInfo $var
     * @return $this
     */
    public function setLanguageInfo($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dialogflow\Cx\V3\LanguageInfo::class);
        $this->language_info = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getQuery()
    {
        return $this->whichOneof("query");
    }

}

