<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/cx/v3/webhook.proto

namespace Google\Cloud\Dialogflow\Cx\V3\WebhookRequest;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents intent information communicated to the webhook.
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.cx.v3.WebhookRequest.IntentInfo</code>
 */
class IntentInfo extends \Google\Protobuf\Internal\Message
{
    /**
     * Always present. The unique identifier of the last matched
     * [intent][google.cloud.dialogflow.cx.v3.Intent].
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/intents/<Intent ID>`.
     *
     * Generated from protobuf field <code>string last_matched_intent = 1 [(.google.api.resource_reference) = {</code>
     */
    protected $last_matched_intent = '';
    /**
     * Always present. The display name of the last matched
     * [intent][google.cloud.dialogflow.cx.v3.Intent].
     *
     * Generated from protobuf field <code>string display_name = 3;</code>
     */
    protected $display_name = '';
    /**
     * Parameters identified as a result of intent matching. This is a map of
     * the name of the identified parameter to the value of the parameter
     * identified from the user's utterance. All parameters defined in the
     * matched intent that are identified will be surfaced here.
     *
     * Generated from protobuf field <code>map<string, .google.cloud.dialogflow.cx.v3.WebhookRequest.IntentInfo.IntentParameterValue> parameters = 2;</code>
     */
    private $parameters;
    /**
     * The confidence of the matched intent. Values range from 0.0 (completely
     * uncertain) to 1.0 (completely certain).
     *
     * Generated from protobuf field <code>float confidence = 4;</code>
     */
    protected $confidence = 0.0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $last_matched_intent
     *           Always present. The unique identifier of the last matched
     *           [intent][google.cloud.dialogflow.cx.v3.Intent].
     *           Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     *           ID>/intents/<Intent ID>`.
     *     @type string $display_name
     *           Always present. The display name of the last matched
     *           [intent][google.cloud.dialogflow.cx.v3.Intent].
     *     @type array|\Google\Protobuf\Internal\MapField $parameters
     *           Parameters identified as a result of intent matching. This is a map of
     *           the name of the identified parameter to the value of the parameter
     *           identified from the user's utterance. All parameters defined in the
     *           matched intent that are identified will be surfaced here.
     *     @type float $confidence
     *           The confidence of the matched intent. Values range from 0.0 (completely
     *           uncertain) to 1.0 (completely certain).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Dialogflow\Cx\V3\Webhook::initOnce();
        parent::__construct($data);
    }

    /**
     * Always present. The unique identifier of the last matched
     * [intent][google.cloud.dialogflow.cx.v3.Intent].
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/intents/<Intent ID>`.
     *
     * Generated from protobuf field <code>string last_matched_intent = 1 [(.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getLastMatchedIntent()
    {
        return $this->last_matched_intent;
    }

    /**
     * Always present. The unique identifier of the last matched
     * [intent][google.cloud.dialogflow.cx.v3.Intent].
     * Format: `projects/<Project ID>/locations/<Location ID>/agents/<Agent
     * ID>/intents/<Intent ID>`.
     *
     * Generated from protobuf field <code>string last_matched_intent = 1 [(.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setLastMatchedIntent($var)
    {
        GPBUtil::checkString($var, True);
        $this->last_matched_intent = $var;

        return $this;
    }

    /**
     * Always present. The display name of the last matched
     * [intent][google.cloud.dialogflow.cx.v3.Intent].
     *
     * Generated from protobuf field <code>string display_name = 3;</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * Always present. The display name of the last matched
     * [intent][google.cloud.dialogflow.cx.v3.Intent].
     *
     * Generated from protobuf field <code>string display_name = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * Parameters identified as a result of intent matching. This is a map of
     * the name of the identified parameter to the value of the parameter
     * identified from the user's utterance. All parameters defined in the
     * matched intent that are identified will be surfaced here.
     *
     * Generated from protobuf field <code>map<string, .google.cloud.dialogflow.cx.v3.WebhookRequest.IntentInfo.IntentParameterValue> parameters = 2;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getParameters()
    {
        return $this->parameters;
    }

    /**
     * Parameters identified as a result of intent matching. This is a map of
     * the name of the identified parameter to the value of the parameter
     * identified from the user's utterance. All parameters defined in the
     * matched intent that are identified will be surfaced here.
     *
     * Generated from protobuf field <code>map<string, .google.cloud.dialogflow.cx.v3.WebhookRequest.IntentInfo.IntentParameterValue> parameters = 2;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setParameters($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Dialogflow\Cx\V3\WebhookRequest\IntentInfo\IntentParameterValue::class);
        $this->parameters = $arr;

        return $this;
    }

    /**
     * The confidence of the matched intent. Values range from 0.0 (completely
     * uncertain) to 1.0 (completely certain).
     *
     * Generated from protobuf field <code>float confidence = 4;</code>
     * @return float
     */
    public function getConfidence()
    {
        return $this->confidence;
    }

    /**
     * The confidence of the matched intent. Values range from 0.0 (completely
     * uncertain) to 1.0 (completely certain).
     *
     * Generated from protobuf field <code>float confidence = 4;</code>
     * @param float $var
     * @return $this
     */
    public function setConfidence($var)
    {
        GPBUtil::checkFloat($var);
        $this->confidence = $var;

        return $this;
    }

}


