<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/discoveryengine/v1/import_config.proto

namespace Google\Cloud\DiscoveryEngine\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The Cloud Bigtable source for importing data.
 *
 * Generated from protobuf message <code>google.cloud.discoveryengine.v1.BigtableSource</code>
 */
class BigtableSource extends \Google\Protobuf\Internal\Message
{
    /**
     * The project ID that contains the Bigtable source. Has a length limit of 128
     * characters. If not specified, inherits the project ID from the parent
     * request.
     *
     * Generated from protobuf field <code>string project_id = 1;</code>
     */
    protected $project_id = '';
    /**
     * Required. The instance ID of the Cloud Bigtable that needs to be imported.
     *
     * Generated from protobuf field <code>string instance_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $instance_id = '';
    /**
     * Required. The table ID of the Cloud Bigtable that needs to be imported.
     *
     * Generated from protobuf field <code>string table_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $table_id = '';
    /**
     * Required. Bigtable options that contains information needed when parsing
     * data into typed structures. For example, column type annotations.
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1.BigtableOptions bigtable_options = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $bigtable_options = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $project_id
     *           The project ID that contains the Bigtable source. Has a length limit of 128
     *           characters. If not specified, inherits the project ID from the parent
     *           request.
     *     @type string $instance_id
     *           Required. The instance ID of the Cloud Bigtable that needs to be imported.
     *     @type string $table_id
     *           Required. The table ID of the Cloud Bigtable that needs to be imported.
     *     @type \Google\Cloud\DiscoveryEngine\V1\BigtableOptions $bigtable_options
     *           Required. Bigtable options that contains information needed when parsing
     *           data into typed structures. For example, column type annotations.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Discoveryengine\V1\ImportConfig::initOnce();
        parent::__construct($data);
    }

    /**
     * The project ID that contains the Bigtable source. Has a length limit of 128
     * characters. If not specified, inherits the project ID from the parent
     * request.
     *
     * Generated from protobuf field <code>string project_id = 1;</code>
     * @return string
     */
    public function getProjectId()
    {
        return $this->project_id;
    }

    /**
     * The project ID that contains the Bigtable source. Has a length limit of 128
     * characters. If not specified, inherits the project ID from the parent
     * request.
     *
     * Generated from protobuf field <code>string project_id = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setProjectId($var)
    {
        GPBUtil::checkString($var, True);
        $this->project_id = $var;

        return $this;
    }

    /**
     * Required. The instance ID of the Cloud Bigtable that needs to be imported.
     *
     * Generated from protobuf field <code>string instance_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getInstanceId()
    {
        return $this->instance_id;
    }

    /**
     * Required. The instance ID of the Cloud Bigtable that needs to be imported.
     *
     * Generated from protobuf field <code>string instance_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setInstanceId($var)
    {
        GPBUtil::checkString($var, True);
        $this->instance_id = $var;

        return $this;
    }

    /**
     * Required. The table ID of the Cloud Bigtable that needs to be imported.
     *
     * Generated from protobuf field <code>string table_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getTableId()
    {
        return $this->table_id;
    }

    /**
     * Required. The table ID of the Cloud Bigtable that needs to be imported.
     *
     * Generated from protobuf field <code>string table_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setTableId($var)
    {
        GPBUtil::checkString($var, True);
        $this->table_id = $var;

        return $this;
    }

    /**
     * Required. Bigtable options that contains information needed when parsing
     * data into typed structures. For example, column type annotations.
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1.BigtableOptions bigtable_options = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\DiscoveryEngine\V1\BigtableOptions|null
     */
    public function getBigtableOptions()
    {
        return $this->bigtable_options;
    }

    public function hasBigtableOptions()
    {
        return isset($this->bigtable_options);
    }

    public function clearBigtableOptions()
    {
        unset($this->bigtable_options);
    }

    /**
     * Required. Bigtable options that contains information needed when parsing
     * data into typed structures. For example, column type annotations.
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1.BigtableOptions bigtable_options = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\DiscoveryEngine\V1\BigtableOptions $var
     * @return $this
     */
    public function setBigtableOptions($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DiscoveryEngine\V1\BigtableOptions::class);
        $this->bigtable_options = $var;

        return $this;
    }

}

