<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/discoveryengine/v1/import_config.proto

namespace Google\Cloud\DiscoveryEngine\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Cloud SQL source import data from.
 *
 * Generated from protobuf message <code>google.cloud.discoveryengine.v1.CloudSqlSource</code>
 */
class CloudSqlSource extends \Google\Protobuf\Internal\Message
{
    /**
     * The project ID that contains the Cloud SQL source. Has a length limit of
     * 128 characters. If not specified, inherits the project ID from the parent
     * request.
     *
     * Generated from protobuf field <code>string project_id = 1;</code>
     */
    protected $project_id = '';
    /**
     * Required. The Cloud SQL instance to copy the data from with a length limit
     * of 256 characters.
     *
     * Generated from protobuf field <code>string instance_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $instance_id = '';
    /**
     * Required. The Cloud SQL database to copy the data from with a length limit
     * of 256 characters.
     *
     * Generated from protobuf field <code>string database_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $database_id = '';
    /**
     * Required. The Cloud SQL table to copy the data from with a length limit of
     * 256 characters.
     *
     * Generated from protobuf field <code>string table_id = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $table_id = '';
    /**
     * Intermediate Cloud Storage directory used for the import with a length
     * limit of 2,000 characters. Can be specified if one wants to have the
     * Cloud SQL export to a specific Cloud Storage directory.
     * Ensure that the Cloud SQL service account has the necessary Cloud
     * Storage Admin permissions to access the specified Cloud Storage directory.
     *
     * Generated from protobuf field <code>string gcs_staging_dir = 5;</code>
     */
    protected $gcs_staging_dir = '';
    /**
     * Option for serverless export. Enabling this option will incur additional
     * cost. More info can be found
     * [here](https://cloud.google.com/sql/pricing#serverless).
     *
     * Generated from protobuf field <code>bool offload = 6;</code>
     */
    protected $offload = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $project_id
     *           The project ID that contains the Cloud SQL source. Has a length limit of
     *           128 characters. If not specified, inherits the project ID from the parent
     *           request.
     *     @type string $instance_id
     *           Required. The Cloud SQL instance to copy the data from with a length limit
     *           of 256 characters.
     *     @type string $database_id
     *           Required. The Cloud SQL database to copy the data from with a length limit
     *           of 256 characters.
     *     @type string $table_id
     *           Required. The Cloud SQL table to copy the data from with a length limit of
     *           256 characters.
     *     @type string $gcs_staging_dir
     *           Intermediate Cloud Storage directory used for the import with a length
     *           limit of 2,000 characters. Can be specified if one wants to have the
     *           Cloud SQL export to a specific Cloud Storage directory.
     *           Ensure that the Cloud SQL service account has the necessary Cloud
     *           Storage Admin permissions to access the specified Cloud Storage directory.
     *     @type bool $offload
     *           Option for serverless export. Enabling this option will incur additional
     *           cost. More info can be found
     *           [here](https://cloud.google.com/sql/pricing#serverless).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Discoveryengine\V1\ImportConfig::initOnce();
        parent::__construct($data);
    }

    /**
     * The project ID that contains the Cloud SQL source. Has a length limit of
     * 128 characters. If not specified, inherits the project ID from the parent
     * request.
     *
     * Generated from protobuf field <code>string project_id = 1;</code>
     * @return string
     */
    public function getProjectId()
    {
        return $this->project_id;
    }

    /**
     * The project ID that contains the Cloud SQL source. Has a length limit of
     * 128 characters. If not specified, inherits the project ID from the parent
     * request.
     *
     * Generated from protobuf field <code>string project_id = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setProjectId($var)
    {
        GPBUtil::checkString($var, True);
        $this->project_id = $var;

        return $this;
    }

    /**
     * Required. The Cloud SQL instance to copy the data from with a length limit
     * of 256 characters.
     *
     * Generated from protobuf field <code>string instance_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getInstanceId()
    {
        return $this->instance_id;
    }

    /**
     * Required. The Cloud SQL instance to copy the data from with a length limit
     * of 256 characters.
     *
     * Generated from protobuf field <code>string instance_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setInstanceId($var)
    {
        GPBUtil::checkString($var, True);
        $this->instance_id = $var;

        return $this;
    }

    /**
     * Required. The Cloud SQL database to copy the data from with a length limit
     * of 256 characters.
     *
     * Generated from protobuf field <code>string database_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getDatabaseId()
    {
        return $this->database_id;
    }

    /**
     * Required. The Cloud SQL database to copy the data from with a length limit
     * of 256 characters.
     *
     * Generated from protobuf field <code>string database_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setDatabaseId($var)
    {
        GPBUtil::checkString($var, True);
        $this->database_id = $var;

        return $this;
    }

    /**
     * Required. The Cloud SQL table to copy the data from with a length limit of
     * 256 characters.
     *
     * Generated from protobuf field <code>string table_id = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getTableId()
    {
        return $this->table_id;
    }

    /**
     * Required. The Cloud SQL table to copy the data from with a length limit of
     * 256 characters.
     *
     * Generated from protobuf field <code>string table_id = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setTableId($var)
    {
        GPBUtil::checkString($var, True);
        $this->table_id = $var;

        return $this;
    }

    /**
     * Intermediate Cloud Storage directory used for the import with a length
     * limit of 2,000 characters. Can be specified if one wants to have the
     * Cloud SQL export to a specific Cloud Storage directory.
     * Ensure that the Cloud SQL service account has the necessary Cloud
     * Storage Admin permissions to access the specified Cloud Storage directory.
     *
     * Generated from protobuf field <code>string gcs_staging_dir = 5;</code>
     * @return string
     */
    public function getGcsStagingDir()
    {
        return $this->gcs_staging_dir;
    }

    /**
     * Intermediate Cloud Storage directory used for the import with a length
     * limit of 2,000 characters. Can be specified if one wants to have the
     * Cloud SQL export to a specific Cloud Storage directory.
     * Ensure that the Cloud SQL service account has the necessary Cloud
     * Storage Admin permissions to access the specified Cloud Storage directory.
     *
     * Generated from protobuf field <code>string gcs_staging_dir = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setGcsStagingDir($var)
    {
        GPBUtil::checkString($var, True);
        $this->gcs_staging_dir = $var;

        return $this;
    }

    /**
     * Option for serverless export. Enabling this option will incur additional
     * cost. More info can be found
     * [here](https://cloud.google.com/sql/pricing#serverless).
     *
     * Generated from protobuf field <code>bool offload = 6;</code>
     * @return bool
     */
    public function getOffload()
    {
        return $this->offload;
    }

    /**
     * Option for serverless export. Enabling this option will incur additional
     * cost. More info can be found
     * [here](https://cloud.google.com/sql/pricing#serverless).
     *
     * Generated from protobuf field <code>bool offload = 6;</code>
     * @param bool $var
     * @return $this
     */
    public function setOffload($var)
    {
        GPBUtil::checkBool($var);
        $this->offload = $var;

        return $this;
    }

}

