<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/discoveryengine/v1/custom_tuning_model.proto

namespace Google\Cloud\DiscoveryEngine\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Metadata that describes a custom tuned model.
 *
 * Generated from protobuf message <code>google.cloud.discoveryengine.v1.CustomTuningModel</code>
 */
class CustomTuningModel extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The fully qualified resource name of the model.
     * Format:
     * `projects/{project}/locations/{location}/collections/{collection}/dataStores/{data_store}/customTuningModels/{custom_tuning_model}`.
     * Model must be an alpha-numerical string with limit of 40 characters.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';
    /**
     * The display name of the model.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     */
    protected $display_name = '';
    /**
     * The version of the model.
     *
     * Generated from protobuf field <code>int64 model_version = 3;</code>
     */
    protected $model_version = 0;
    /**
     * The state that the model is in (e.g.`TRAINING` or `TRAINING_FAILED`).
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1.CustomTuningModel.ModelState model_state = 4;</code>
     */
    protected $model_state = 0;
    /**
     * Deprecated: Timestamp the Model was created at.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5 [deprecated = true];</code>
     * @deprecated
     */
    protected $create_time = null;
    /**
     * Timestamp the model training was initiated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp training_start_time = 6;</code>
     */
    protected $training_start_time = null;
    /**
     * The metrics of the trained model.
     *
     * Generated from protobuf field <code>map<string, double> metrics = 7;</code>
     */
    private $metrics;
    /**
     * Currently this is only populated if the model state is
     * `INPUT_VALIDATION_FAILED`.
     *
     * Generated from protobuf field <code>string error_message = 8;</code>
     */
    protected $error_message = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. The fully qualified resource name of the model.
     *           Format:
     *           `projects/{project}/locations/{location}/collections/{collection}/dataStores/{data_store}/customTuningModels/{custom_tuning_model}`.
     *           Model must be an alpha-numerical string with limit of 40 characters.
     *     @type string $display_name
     *           The display name of the model.
     *     @type int|string $model_version
     *           The version of the model.
     *     @type int $model_state
     *           The state that the model is in (e.g.`TRAINING` or `TRAINING_FAILED`).
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Deprecated: Timestamp the Model was created at.
     *     @type \Google\Protobuf\Timestamp $training_start_time
     *           Timestamp the model training was initiated.
     *     @type array|\Google\Protobuf\Internal\MapField $metrics
     *           The metrics of the trained model.
     *     @type string $error_message
     *           Currently this is only populated if the model state is
     *           `INPUT_VALIDATION_FAILED`.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Discoveryengine\V1\CustomTuningModel::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The fully qualified resource name of the model.
     * Format:
     * `projects/{project}/locations/{location}/collections/{collection}/dataStores/{data_store}/customTuningModels/{custom_tuning_model}`.
     * Model must be an alpha-numerical string with limit of 40 characters.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. The fully qualified resource name of the model.
     * Format:
     * `projects/{project}/locations/{location}/collections/{collection}/dataStores/{data_store}/customTuningModels/{custom_tuning_model}`.
     * Model must be an alpha-numerical string with limit of 40 characters.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The display name of the model.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * The display name of the model.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * The version of the model.
     *
     * Generated from protobuf field <code>int64 model_version = 3;</code>
     * @return int|string
     */
    public function getModelVersion()
    {
        return $this->model_version;
    }

    /**
     * The version of the model.
     *
     * Generated from protobuf field <code>int64 model_version = 3;</code>
     * @param int|string $var
     * @return $this
     */
    public function setModelVersion($var)
    {
        GPBUtil::checkInt64($var);
        $this->model_version = $var;

        return $this;
    }

    /**
     * The state that the model is in (e.g.`TRAINING` or `TRAINING_FAILED`).
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1.CustomTuningModel.ModelState model_state = 4;</code>
     * @return int
     */
    public function getModelState()
    {
        return $this->model_state;
    }

    /**
     * The state that the model is in (e.g.`TRAINING` or `TRAINING_FAILED`).
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1.CustomTuningModel.ModelState model_state = 4;</code>
     * @param int $var
     * @return $this
     */
    public function setModelState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\DiscoveryEngine\V1\CustomTuningModel\ModelState::class);
        $this->model_state = $var;

        return $this;
    }

    /**
     * Deprecated: Timestamp the Model was created at.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5 [deprecated = true];</code>
     * @return \Google\Protobuf\Timestamp|null
     * @deprecated
     */
    public function getCreateTime()
    {
        @trigger_error('create_time is deprecated.', E_USER_DEPRECATED);
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        @trigger_error('create_time is deprecated.', E_USER_DEPRECATED);
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        @trigger_error('create_time is deprecated.', E_USER_DEPRECATED);
        unset($this->create_time);
    }

    /**
     * Deprecated: Timestamp the Model was created at.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5 [deprecated = true];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     * @deprecated
     */
    public function setCreateTime($var)
    {
        @trigger_error('create_time is deprecated.', E_USER_DEPRECATED);
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Timestamp the model training was initiated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp training_start_time = 6;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getTrainingStartTime()
    {
        return $this->training_start_time;
    }

    public function hasTrainingStartTime()
    {
        return isset($this->training_start_time);
    }

    public function clearTrainingStartTime()
    {
        unset($this->training_start_time);
    }

    /**
     * Timestamp the model training was initiated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp training_start_time = 6;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setTrainingStartTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->training_start_time = $var;

        return $this;
    }

    /**
     * The metrics of the trained model.
     *
     * Generated from protobuf field <code>map<string, double> metrics = 7;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getMetrics()
    {
        return $this->metrics;
    }

    /**
     * The metrics of the trained model.
     *
     * Generated from protobuf field <code>map<string, double> metrics = 7;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setMetrics($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::DOUBLE);
        $this->metrics = $arr;

        return $this;
    }

    /**
     * Currently this is only populated if the model state is
     * `INPUT_VALIDATION_FAILED`.
     *
     * Generated from protobuf field <code>string error_message = 8;</code>
     * @return string
     */
    public function getErrorMessage()
    {
        return $this->error_message;
    }

    /**
     * Currently this is only populated if the model state is
     * `INPUT_VALIDATION_FAILED`.
     *
     * Generated from protobuf field <code>string error_message = 8;</code>
     * @param string $var
     * @return $this
     */
    public function setErrorMessage($var)
    {
        GPBUtil::checkString($var, True);
        $this->error_message = $var;

        return $this;
    }

}

