<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/discoveryengine/v1/data_store.proto

namespace Google\Cloud\DiscoveryEngine\V1\DataStore;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Estimation of data size per data store.
 *
 * Generated from protobuf message <code>google.cloud.discoveryengine.v1.DataStore.BillingEstimation</code>
 */
class BillingEstimation extends \Google\Protobuf\Internal\Message
{
    /**
     * Data size for structured data in terms of bytes.
     *
     * Generated from protobuf field <code>int64 structured_data_size = 1;</code>
     */
    protected $structured_data_size = 0;
    /**
     * Data size for unstructured data in terms of bytes.
     *
     * Generated from protobuf field <code>int64 unstructured_data_size = 2;</code>
     */
    protected $unstructured_data_size = 0;
    /**
     * Data size for websites in terms of bytes.
     *
     * Generated from protobuf field <code>int64 website_data_size = 3;</code>
     */
    protected $website_data_size = 0;
    /**
     * Last updated timestamp for structured data.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp structured_data_update_time = 4;</code>
     */
    protected $structured_data_update_time = null;
    /**
     * Last updated timestamp for unstructured data.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp unstructured_data_update_time = 5;</code>
     */
    protected $unstructured_data_update_time = null;
    /**
     * Last updated timestamp for websites.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp website_data_update_time = 6;</code>
     */
    protected $website_data_update_time = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int|string $structured_data_size
     *           Data size for structured data in terms of bytes.
     *     @type int|string $unstructured_data_size
     *           Data size for unstructured data in terms of bytes.
     *     @type int|string $website_data_size
     *           Data size for websites in terms of bytes.
     *     @type \Google\Protobuf\Timestamp $structured_data_update_time
     *           Last updated timestamp for structured data.
     *     @type \Google\Protobuf\Timestamp $unstructured_data_update_time
     *           Last updated timestamp for unstructured data.
     *     @type \Google\Protobuf\Timestamp $website_data_update_time
     *           Last updated timestamp for websites.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Discoveryengine\V1\DataStore::initOnce();
        parent::__construct($data);
    }

    /**
     * Data size for structured data in terms of bytes.
     *
     * Generated from protobuf field <code>int64 structured_data_size = 1;</code>
     * @return int|string
     */
    public function getStructuredDataSize()
    {
        return $this->structured_data_size;
    }

    /**
     * Data size for structured data in terms of bytes.
     *
     * Generated from protobuf field <code>int64 structured_data_size = 1;</code>
     * @param int|string $var
     * @return $this
     */
    public function setStructuredDataSize($var)
    {
        GPBUtil::checkInt64($var);
        $this->structured_data_size = $var;

        return $this;
    }

    /**
     * Data size for unstructured data in terms of bytes.
     *
     * Generated from protobuf field <code>int64 unstructured_data_size = 2;</code>
     * @return int|string
     */
    public function getUnstructuredDataSize()
    {
        return $this->unstructured_data_size;
    }

    /**
     * Data size for unstructured data in terms of bytes.
     *
     * Generated from protobuf field <code>int64 unstructured_data_size = 2;</code>
     * @param int|string $var
     * @return $this
     */
    public function setUnstructuredDataSize($var)
    {
        GPBUtil::checkInt64($var);
        $this->unstructured_data_size = $var;

        return $this;
    }

    /**
     * Data size for websites in terms of bytes.
     *
     * Generated from protobuf field <code>int64 website_data_size = 3;</code>
     * @return int|string
     */
    public function getWebsiteDataSize()
    {
        return $this->website_data_size;
    }

    /**
     * Data size for websites in terms of bytes.
     *
     * Generated from protobuf field <code>int64 website_data_size = 3;</code>
     * @param int|string $var
     * @return $this
     */
    public function setWebsiteDataSize($var)
    {
        GPBUtil::checkInt64($var);
        $this->website_data_size = $var;

        return $this;
    }

    /**
     * Last updated timestamp for structured data.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp structured_data_update_time = 4;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getStructuredDataUpdateTime()
    {
        return $this->structured_data_update_time;
    }

    public function hasStructuredDataUpdateTime()
    {
        return isset($this->structured_data_update_time);
    }

    public function clearStructuredDataUpdateTime()
    {
        unset($this->structured_data_update_time);
    }

    /**
     * Last updated timestamp for structured data.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp structured_data_update_time = 4;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setStructuredDataUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->structured_data_update_time = $var;

        return $this;
    }

    /**
     * Last updated timestamp for unstructured data.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp unstructured_data_update_time = 5;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUnstructuredDataUpdateTime()
    {
        return $this->unstructured_data_update_time;
    }

    public function hasUnstructuredDataUpdateTime()
    {
        return isset($this->unstructured_data_update_time);
    }

    public function clearUnstructuredDataUpdateTime()
    {
        unset($this->unstructured_data_update_time);
    }

    /**
     * Last updated timestamp for unstructured data.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp unstructured_data_update_time = 5;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUnstructuredDataUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->unstructured_data_update_time = $var;

        return $this;
    }

    /**
     * Last updated timestamp for websites.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp website_data_update_time = 6;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getWebsiteDataUpdateTime()
    {
        return $this->website_data_update_time;
    }

    public function hasWebsiteDataUpdateTime()
    {
        return isset($this->website_data_update_time);
    }

    public function clearWebsiteDataUpdateTime()
    {
        unset($this->website_data_update_time);
    }

    /**
     * Last updated timestamp for websites.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp website_data_update_time = 6;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setWebsiteDataUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->website_data_update_time = $var;

        return $this;
    }

}


