<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/discoveryengine/v1/import_config.proto

namespace Google\Cloud\DiscoveryEngine\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Firestore source import data from.
 *
 * Generated from protobuf message <code>google.cloud.discoveryengine.v1.FirestoreSource</code>
 */
class FirestoreSource extends \Google\Protobuf\Internal\Message
{
    /**
     * The project ID that the Cloud SQL source is in with a length limit of 128
     * characters. If not specified, inherits the project ID from the parent
     * request.
     *
     * Generated from protobuf field <code>string project_id = 1;</code>
     */
    protected $project_id = '';
    /**
     * Required. The Firestore database to copy the data from with a length limit
     * of 256 characters.
     *
     * Generated from protobuf field <code>string database_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $database_id = '';
    /**
     * Required. The Firestore collection (or entity) to copy the data from with a
     * length limit of 1,500 characters.
     *
     * Generated from protobuf field <code>string collection_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $collection_id = '';
    /**
     * Intermediate Cloud Storage directory used for the import with a length
     * limit of 2,000 characters. Can be specified if one wants to have the
     * Firestore export to a specific Cloud Storage directory.
     * Ensure that the Firestore service account has the necessary Cloud
     * Storage Admin permissions to access the specified Cloud Storage directory.
     *
     * Generated from protobuf field <code>string gcs_staging_dir = 4;</code>
     */
    protected $gcs_staging_dir = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $project_id
     *           The project ID that the Cloud SQL source is in with a length limit of 128
     *           characters. If not specified, inherits the project ID from the parent
     *           request.
     *     @type string $database_id
     *           Required. The Firestore database to copy the data from with a length limit
     *           of 256 characters.
     *     @type string $collection_id
     *           Required. The Firestore collection (or entity) to copy the data from with a
     *           length limit of 1,500 characters.
     *     @type string $gcs_staging_dir
     *           Intermediate Cloud Storage directory used for the import with a length
     *           limit of 2,000 characters. Can be specified if one wants to have the
     *           Firestore export to a specific Cloud Storage directory.
     *           Ensure that the Firestore service account has the necessary Cloud
     *           Storage Admin permissions to access the specified Cloud Storage directory.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Discoveryengine\V1\ImportConfig::initOnce();
        parent::__construct($data);
    }

    /**
     * The project ID that the Cloud SQL source is in with a length limit of 128
     * characters. If not specified, inherits the project ID from the parent
     * request.
     *
     * Generated from protobuf field <code>string project_id = 1;</code>
     * @return string
     */
    public function getProjectId()
    {
        return $this->project_id;
    }

    /**
     * The project ID that the Cloud SQL source is in with a length limit of 128
     * characters. If not specified, inherits the project ID from the parent
     * request.
     *
     * Generated from protobuf field <code>string project_id = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setProjectId($var)
    {
        GPBUtil::checkString($var, True);
        $this->project_id = $var;

        return $this;
    }

    /**
     * Required. The Firestore database to copy the data from with a length limit
     * of 256 characters.
     *
     * Generated from protobuf field <code>string database_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getDatabaseId()
    {
        return $this->database_id;
    }

    /**
     * Required. The Firestore database to copy the data from with a length limit
     * of 256 characters.
     *
     * Generated from protobuf field <code>string database_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setDatabaseId($var)
    {
        GPBUtil::checkString($var, True);
        $this->database_id = $var;

        return $this;
    }

    /**
     * Required. The Firestore collection (or entity) to copy the data from with a
     * length limit of 1,500 characters.
     *
     * Generated from protobuf field <code>string collection_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getCollectionId()
    {
        return $this->collection_id;
    }

    /**
     * Required. The Firestore collection (or entity) to copy the data from with a
     * length limit of 1,500 characters.
     *
     * Generated from protobuf field <code>string collection_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setCollectionId($var)
    {
        GPBUtil::checkString($var, True);
        $this->collection_id = $var;

        return $this;
    }

    /**
     * Intermediate Cloud Storage directory used for the import with a length
     * limit of 2,000 characters. Can be specified if one wants to have the
     * Firestore export to a specific Cloud Storage directory.
     * Ensure that the Firestore service account has the necessary Cloud
     * Storage Admin permissions to access the specified Cloud Storage directory.
     *
     * Generated from protobuf field <code>string gcs_staging_dir = 4;</code>
     * @return string
     */
    public function getGcsStagingDir()
    {
        return $this->gcs_staging_dir;
    }

    /**
     * Intermediate Cloud Storage directory used for the import with a length
     * limit of 2,000 characters. Can be specified if one wants to have the
     * Firestore export to a specific Cloud Storage directory.
     * Ensure that the Firestore service account has the necessary Cloud
     * Storage Admin permissions to access the specified Cloud Storage directory.
     *
     * Generated from protobuf field <code>string gcs_staging_dir = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setGcsStagingDir($var)
    {
        GPBUtil::checkString($var, True);
        $this->gcs_staging_dir = $var;

        return $this;
    }

}

