<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/discoveryengine/v1/grounded_generation_service.proto

namespace Google\Cloud\DiscoveryEngine\V1\GenerateGroundedContentRequest\GroundingSource;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message to be used for grounding with Vertex AI Search.
 *
 * Generated from protobuf message <code>google.cloud.discoveryengine.v1.GenerateGroundedContentRequest.GroundingSource.SearchSource</code>
 */
class SearchSource extends \Google\Protobuf\Internal\Message
{
    /**
     * The resource name of the Engine to use.
     * Format:
     * `projects/{project}/locations/{location}/collections/{collection_id}/engines/{engine_id}/servingConfigs/{serving_config_id}`
     *
     * Generated from protobuf field <code>string serving_config = 1 [(.google.api.resource_reference) = {</code>
     */
    protected $serving_config = '';
    /**
     * Number of search results to return.
     * The default value is 10. The maximumm allowed value is 10.
     *
     * Generated from protobuf field <code>int32 max_result_count = 2;</code>
     */
    protected $max_result_count = 0;
    /**
     * Filter expression to be applied to the search.
     * The syntax is the same as
     * [SearchRequest.filter][google.cloud.discoveryengine.v1.SearchRequest.filter].
     *
     * Generated from protobuf field <code>string filter = 3;</code>
     */
    protected $filter = '';
    /**
     * If set, safe search is enabled in Vertex AI Search requests.
     *
     * Generated from protobuf field <code>bool safe_search = 5;</code>
     */
    protected $safe_search = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $serving_config
     *           The resource name of the Engine to use.
     *           Format:
     *           `projects/{project}/locations/{location}/collections/{collection_id}/engines/{engine_id}/servingConfigs/{serving_config_id}`
     *     @type int $max_result_count
     *           Number of search results to return.
     *           The default value is 10. The maximumm allowed value is 10.
     *     @type string $filter
     *           Filter expression to be applied to the search.
     *           The syntax is the same as
     *           [SearchRequest.filter][google.cloud.discoveryengine.v1.SearchRequest.filter].
     *     @type bool $safe_search
     *           If set, safe search is enabled in Vertex AI Search requests.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Discoveryengine\V1\GroundedGenerationService::initOnce();
        parent::__construct($data);
    }

    /**
     * The resource name of the Engine to use.
     * Format:
     * `projects/{project}/locations/{location}/collections/{collection_id}/engines/{engine_id}/servingConfigs/{serving_config_id}`
     *
     * Generated from protobuf field <code>string serving_config = 1 [(.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getServingConfig()
    {
        return $this->serving_config;
    }

    /**
     * The resource name of the Engine to use.
     * Format:
     * `projects/{project}/locations/{location}/collections/{collection_id}/engines/{engine_id}/servingConfigs/{serving_config_id}`
     *
     * Generated from protobuf field <code>string serving_config = 1 [(.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setServingConfig($var)
    {
        GPBUtil::checkString($var, True);
        $this->serving_config = $var;

        return $this;
    }

    /**
     * Number of search results to return.
     * The default value is 10. The maximumm allowed value is 10.
     *
     * Generated from protobuf field <code>int32 max_result_count = 2;</code>
     * @return int
     */
    public function getMaxResultCount()
    {
        return $this->max_result_count;
    }

    /**
     * Number of search results to return.
     * The default value is 10. The maximumm allowed value is 10.
     *
     * Generated from protobuf field <code>int32 max_result_count = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setMaxResultCount($var)
    {
        GPBUtil::checkInt32($var);
        $this->max_result_count = $var;

        return $this;
    }

    /**
     * Filter expression to be applied to the search.
     * The syntax is the same as
     * [SearchRequest.filter][google.cloud.discoveryengine.v1.SearchRequest.filter].
     *
     * Generated from protobuf field <code>string filter = 3;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Filter expression to be applied to the search.
     * The syntax is the same as
     * [SearchRequest.filter][google.cloud.discoveryengine.v1.SearchRequest.filter].
     *
     * Generated from protobuf field <code>string filter = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * If set, safe search is enabled in Vertex AI Search requests.
     *
     * Generated from protobuf field <code>bool safe_search = 5;</code>
     * @return bool
     */
    public function getSafeSearch()
    {
        return $this->safe_search;
    }

    /**
     * If set, safe search is enabled in Vertex AI Search requests.
     *
     * Generated from protobuf field <code>bool safe_search = 5;</code>
     * @param bool $var
     * @return $this
     */
    public function setSafeSearch($var)
    {
        GPBUtil::checkBool($var);
        $this->safe_search = $var;

        return $this;
    }

}


