<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/discoveryengine/v1/import_config.proto

namespace Google\Cloud\DiscoveryEngine\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [CompletionService.ImportSuggestionDenyListEntries][google.cloud.discoveryengine.v1.CompletionService.ImportSuggestionDenyListEntries]
 * method.
 *
 * Generated from protobuf message <code>google.cloud.discoveryengine.v1.ImportSuggestionDenyListEntriesRequest</code>
 */
class ImportSuggestionDenyListEntriesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent data store resource name for which to import denylist
     * entries. Follows pattern projects/&#42;&#47;locations/&#42;&#47;collections/&#42;&#47;dataStores/&#42;.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    protected $source;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\DiscoveryEngine\V1\ImportSuggestionDenyListEntriesRequest\InlineSource $inline_source
     *           The Inline source for the input content for suggestion deny list entries.
     *     @type \Google\Cloud\DiscoveryEngine\V1\GcsSource $gcs_source
     *           Cloud Storage location for the input content.
     *           Only 1 file can be specified that contains all entries to import.
     *           Supported values `gcs_source.schema` for autocomplete suggestion deny
     *           list entry imports:
     *           * `suggestion_deny_list` (default): One JSON [SuggestionDenyListEntry]
     *           per line.
     *     @type string $parent
     *           Required. The parent data store resource name for which to import denylist
     *           entries. Follows pattern projects/&#42;&#47;locations/&#42;&#47;collections/&#42;&#47;dataStores/&#42;.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Discoveryengine\V1\ImportConfig::initOnce();
        parent::__construct($data);
    }

    /**
     * The Inline source for the input content for suggestion deny list entries.
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1.ImportSuggestionDenyListEntriesRequest.InlineSource inline_source = 2;</code>
     * @return \Google\Cloud\DiscoveryEngine\V1\ImportSuggestionDenyListEntriesRequest\InlineSource|null
     */
    public function getInlineSource()
    {
        return $this->readOneof(2);
    }

    public function hasInlineSource()
    {
        return $this->hasOneof(2);
    }

    /**
     * The Inline source for the input content for suggestion deny list entries.
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1.ImportSuggestionDenyListEntriesRequest.InlineSource inline_source = 2;</code>
     * @param \Google\Cloud\DiscoveryEngine\V1\ImportSuggestionDenyListEntriesRequest\InlineSource $var
     * @return $this
     */
    public function setInlineSource($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DiscoveryEngine\V1\ImportSuggestionDenyListEntriesRequest\InlineSource::class);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     * Cloud Storage location for the input content.
     * Only 1 file can be specified that contains all entries to import.
     * Supported values `gcs_source.schema` for autocomplete suggestion deny
     * list entry imports:
     * * `suggestion_deny_list` (default): One JSON [SuggestionDenyListEntry]
     * per line.
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1.GcsSource gcs_source = 3;</code>
     * @return \Google\Cloud\DiscoveryEngine\V1\GcsSource|null
     */
    public function getGcsSource()
    {
        return $this->readOneof(3);
    }

    public function hasGcsSource()
    {
        return $this->hasOneof(3);
    }

    /**
     * Cloud Storage location for the input content.
     * Only 1 file can be specified that contains all entries to import.
     * Supported values `gcs_source.schema` for autocomplete suggestion deny
     * list entry imports:
     * * `suggestion_deny_list` (default): One JSON [SuggestionDenyListEntry]
     * per line.
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1.GcsSource gcs_source = 3;</code>
     * @param \Google\Cloud\DiscoveryEngine\V1\GcsSource $var
     * @return $this
     */
    public function setGcsSource($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DiscoveryEngine\V1\GcsSource::class);
        $this->writeOneof(3, $var);

        return $this;
    }

    /**
     * Required. The parent data store resource name for which to import denylist
     * entries. Follows pattern projects/&#42;&#47;locations/&#42;&#47;collections/&#42;&#47;dataStores/&#42;.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent data store resource name for which to import denylist
     * entries. Follows pattern projects/&#42;&#47;locations/&#42;&#47;collections/&#42;&#47;dataStores/&#42;.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getSource()
    {
        return $this->whichOneof("source");
    }

}

