<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/discoveryengine/v1/control_service.proto

namespace Google\Cloud\DiscoveryEngine\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request for ListControls method.
 *
 * Generated from protobuf message <code>google.cloud.discoveryengine.v1.ListControlsRequest</code>
 */
class ListControlsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The data store resource name. Format:
     * `projects/{project}/locations/{location}/collections/{collection_id}/dataStores/{data_store_id}`
     * or
     * `projects/{project}/locations/{location}/collections/{collection_id}/engines/{engine_id}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. Maximum number of results to return. If unspecified, defaults
     * to 50. Max allowed value is 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. A page token, received from a previous `ListControls` call.
     * Provide this to retrieve the subsequent page.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';
    /**
     * Optional. A filter to apply on the list results. Supported features:
     * * List all the products under the parent branch if
     * [filter][google.cloud.discoveryengine.v1.ListControlsRequest.filter] is
     * unset. Currently this field is unsupported.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $filter = '';

    /**
     * @param string $parent Required. The data store resource name. Format:
     *                       `projects/{project}/locations/{location}/collections/{collection_id}/dataStores/{data_store_id}`
     *                       or
     *                       `projects/{project}/locations/{location}/collections/{collection_id}/engines/{engine_id}`. Please see
     *                       {@see ControlServiceClient::dataStoreName()} for help formatting this field.
     *
     * @return \Google\Cloud\DiscoveryEngine\V1\ListControlsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The data store resource name. Format:
     *           `projects/{project}/locations/{location}/collections/{collection_id}/dataStores/{data_store_id}`
     *           or
     *           `projects/{project}/locations/{location}/collections/{collection_id}/engines/{engine_id}`.
     *     @type int $page_size
     *           Optional. Maximum number of results to return. If unspecified, defaults
     *           to 50. Max allowed value is 1000.
     *     @type string $page_token
     *           Optional. A page token, received from a previous `ListControls` call.
     *           Provide this to retrieve the subsequent page.
     *     @type string $filter
     *           Optional. A filter to apply on the list results. Supported features:
     *           * List all the products under the parent branch if
     *           [filter][google.cloud.discoveryengine.v1.ListControlsRequest.filter] is
     *           unset. Currently this field is unsupported.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Discoveryengine\V1\ControlService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The data store resource name. Format:
     * `projects/{project}/locations/{location}/collections/{collection_id}/dataStores/{data_store_id}`
     * or
     * `projects/{project}/locations/{location}/collections/{collection_id}/engines/{engine_id}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The data store resource name. Format:
     * `projects/{project}/locations/{location}/collections/{collection_id}/dataStores/{data_store_id}`
     * or
     * `projects/{project}/locations/{location}/collections/{collection_id}/engines/{engine_id}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. Maximum number of results to return. If unspecified, defaults
     * to 50. Max allowed value is 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. Maximum number of results to return. If unspecified, defaults
     * to 50. Max allowed value is 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. A page token, received from a previous `ListControls` call.
     * Provide this to retrieve the subsequent page.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. A page token, received from a previous `ListControls` call.
     * Provide this to retrieve the subsequent page.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. A filter to apply on the list results. Supported features:
     * * List all the products under the parent branch if
     * [filter][google.cloud.discoveryengine.v1.ListControlsRequest.filter] is
     * unset. Currently this field is unsupported.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Optional. A filter to apply on the list results. Supported features:
     * * List all the products under the parent branch if
     * [filter][google.cloud.discoveryengine.v1.ListControlsRequest.filter] is
     * unset. Currently this field is unsupported.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

}

