<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/discoveryengine/v1/project_service.proto

namespace Google\Cloud\DiscoveryEngine\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request for
 * [ProjectService.ProvisionProject][google.cloud.discoveryengine.v1.ProjectService.ProvisionProject]
 * method.
 *
 * Generated from protobuf message <code>google.cloud.discoveryengine.v1.ProvisionProjectRequest</code>
 */
class ProvisionProjectRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Full resource name of a
     * [Project][google.cloud.discoveryengine.v1.Project], such as
     * `projects/{project_id_or_number}`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';
    /**
     * Required. Set to `true` to specify that caller has read and would like to
     * give consent to the [Terms for data
     * use](https://cloud.google.com/retail/data-use-terms).
     *
     * Generated from protobuf field <code>bool accept_data_use_terms = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $accept_data_use_terms = false;
    /**
     * Required. The version of the [Terms for data
     * use](https://cloud.google.com/retail/data-use-terms) that caller has read
     * and would like to give consent to.
     * Acceptable version is `2022-11-23`, and this may change over time.
     *
     * Generated from protobuf field <code>string data_use_terms_version = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $data_use_terms_version = '';

    /**
     * @param string $name Required. Full resource name of a
     *                     [Project][google.cloud.discoveryengine.v1.Project], such as
     *                     `projects/{project_id_or_number}`. Please see
     *                     {@see ProjectServiceClient::projectName()} for help formatting this field.
     *
     * @return \Google\Cloud\DiscoveryEngine\V1\ProvisionProjectRequest
     *
     * @experimental
     */
    public static function build(string $name): self
    {
        return (new self())
            ->setName($name);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. Full resource name of a
     *           [Project][google.cloud.discoveryengine.v1.Project], such as
     *           `projects/{project_id_or_number}`.
     *     @type bool $accept_data_use_terms
     *           Required. Set to `true` to specify that caller has read and would like to
     *           give consent to the [Terms for data
     *           use](https://cloud.google.com/retail/data-use-terms).
     *     @type string $data_use_terms_version
     *           Required. The version of the [Terms for data
     *           use](https://cloud.google.com/retail/data-use-terms) that caller has read
     *           and would like to give consent to.
     *           Acceptable version is `2022-11-23`, and this may change over time.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Discoveryengine\V1\ProjectService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Full resource name of a
     * [Project][google.cloud.discoveryengine.v1.Project], such as
     * `projects/{project_id_or_number}`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. Full resource name of a
     * [Project][google.cloud.discoveryengine.v1.Project], such as
     * `projects/{project_id_or_number}`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Required. Set to `true` to specify that caller has read and would like to
     * give consent to the [Terms for data
     * use](https://cloud.google.com/retail/data-use-terms).
     *
     * Generated from protobuf field <code>bool accept_data_use_terms = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return bool
     */
    public function getAcceptDataUseTerms()
    {
        return $this->accept_data_use_terms;
    }

    /**
     * Required. Set to `true` to specify that caller has read and would like to
     * give consent to the [Terms for data
     * use](https://cloud.google.com/retail/data-use-terms).
     *
     * Generated from protobuf field <code>bool accept_data_use_terms = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param bool $var
     * @return $this
     */
    public function setAcceptDataUseTerms($var)
    {
        GPBUtil::checkBool($var);
        $this->accept_data_use_terms = $var;

        return $this;
    }

    /**
     * Required. The version of the [Terms for data
     * use](https://cloud.google.com/retail/data-use-terms) that caller has read
     * and would like to give consent to.
     * Acceptable version is `2022-11-23`, and this may change over time.
     *
     * Generated from protobuf field <code>string data_use_terms_version = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getDataUseTermsVersion()
    {
        return $this->data_use_terms_version;
    }

    /**
     * Required. The version of the [Terms for data
     * use](https://cloud.google.com/retail/data-use-terms) that caller has read
     * and would like to give consent to.
     * Acceptable version is `2022-11-23`, and this may change over time.
     *
     * Generated from protobuf field <code>string data_use_terms_version = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setDataUseTermsVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->data_use_terms_version = $var;

        return $this;
    }

}

