<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/discoveryengine/v1/purge_config.proto

namespace Google\Cloud\DiscoveryEngine\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [DocumentService.PurgeDocuments][google.cloud.discoveryengine.v1.DocumentService.PurgeDocuments]
 * method.
 *
 * Generated from protobuf message <code>google.cloud.discoveryengine.v1.PurgeDocumentsRequest</code>
 */
class PurgeDocumentsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent resource name, such as
     * `projects/{project}/locations/{location}/collections/{collection}/dataStores/{data_store}/branches/{branch}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. Filter matching documents to purge. Only currently supported
     * value is
     * `*` (all items).
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $filter = '';
    /**
     * The desired location of errors incurred during the purge.
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1.PurgeErrorConfig error_config = 7;</code>
     */
    protected $error_config = null;
    /**
     * Actually performs the purge. If `force` is set to false, return the
     * expected purge count without deleting any documents.
     *
     * Generated from protobuf field <code>bool force = 3;</code>
     */
    protected $force = false;
    protected $source;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\DiscoveryEngine\V1\GcsSource $gcs_source
     *           Cloud Storage location for the input content.
     *           Supported `data_schema`:
     *           * `document_id`: One valid
     *           [Document.id][google.cloud.discoveryengine.v1.Document.id] per line.
     *     @type \Google\Cloud\DiscoveryEngine\V1\PurgeDocumentsRequest\InlineSource $inline_source
     *           Inline source for the input content for purge.
     *     @type string $parent
     *           Required. The parent resource name, such as
     *           `projects/{project}/locations/{location}/collections/{collection}/dataStores/{data_store}/branches/{branch}`.
     *     @type string $filter
     *           Required. Filter matching documents to purge. Only currently supported
     *           value is
     *           `*` (all items).
     *     @type \Google\Cloud\DiscoveryEngine\V1\PurgeErrorConfig $error_config
     *           The desired location of errors incurred during the purge.
     *     @type bool $force
     *           Actually performs the purge. If `force` is set to false, return the
     *           expected purge count without deleting any documents.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Discoveryengine\V1\PurgeConfig::initOnce();
        parent::__construct($data);
    }

    /**
     * Cloud Storage location for the input content.
     * Supported `data_schema`:
     * * `document_id`: One valid
     * [Document.id][google.cloud.discoveryengine.v1.Document.id] per line.
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1.GcsSource gcs_source = 5;</code>
     * @return \Google\Cloud\DiscoveryEngine\V1\GcsSource|null
     */
    public function getGcsSource()
    {
        return $this->readOneof(5);
    }

    public function hasGcsSource()
    {
        return $this->hasOneof(5);
    }

    /**
     * Cloud Storage location for the input content.
     * Supported `data_schema`:
     * * `document_id`: One valid
     * [Document.id][google.cloud.discoveryengine.v1.Document.id] per line.
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1.GcsSource gcs_source = 5;</code>
     * @param \Google\Cloud\DiscoveryEngine\V1\GcsSource $var
     * @return $this
     */
    public function setGcsSource($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DiscoveryEngine\V1\GcsSource::class);
        $this->writeOneof(5, $var);

        return $this;
    }

    /**
     * Inline source for the input content for purge.
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1.PurgeDocumentsRequest.InlineSource inline_source = 6;</code>
     * @return \Google\Cloud\DiscoveryEngine\V1\PurgeDocumentsRequest\InlineSource|null
     */
    public function getInlineSource()
    {
        return $this->readOneof(6);
    }

    public function hasInlineSource()
    {
        return $this->hasOneof(6);
    }

    /**
     * Inline source for the input content for purge.
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1.PurgeDocumentsRequest.InlineSource inline_source = 6;</code>
     * @param \Google\Cloud\DiscoveryEngine\V1\PurgeDocumentsRequest\InlineSource $var
     * @return $this
     */
    public function setInlineSource($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DiscoveryEngine\V1\PurgeDocumentsRequest\InlineSource::class);
        $this->writeOneof(6, $var);

        return $this;
    }

    /**
     * Required. The parent resource name, such as
     * `projects/{project}/locations/{location}/collections/{collection}/dataStores/{data_store}/branches/{branch}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent resource name, such as
     * `projects/{project}/locations/{location}/collections/{collection}/dataStores/{data_store}/branches/{branch}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. Filter matching documents to purge. Only currently supported
     * value is
     * `*` (all items).
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Required. Filter matching documents to purge. Only currently supported
     * value is
     * `*` (all items).
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * The desired location of errors incurred during the purge.
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1.PurgeErrorConfig error_config = 7;</code>
     * @return \Google\Cloud\DiscoveryEngine\V1\PurgeErrorConfig|null
     */
    public function getErrorConfig()
    {
        return $this->error_config;
    }

    public function hasErrorConfig()
    {
        return isset($this->error_config);
    }

    public function clearErrorConfig()
    {
        unset($this->error_config);
    }

    /**
     * The desired location of errors incurred during the purge.
     *
     * Generated from protobuf field <code>.google.cloud.discoveryengine.v1.PurgeErrorConfig error_config = 7;</code>
     * @param \Google\Cloud\DiscoveryEngine\V1\PurgeErrorConfig $var
     * @return $this
     */
    public function setErrorConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DiscoveryEngine\V1\PurgeErrorConfig::class);
        $this->error_config = $var;

        return $this;
    }

    /**
     * Actually performs the purge. If `force` is set to false, return the
     * expected purge count without deleting any documents.
     *
     * Generated from protobuf field <code>bool force = 3;</code>
     * @return bool
     */
    public function getForce()
    {
        return $this->force;
    }

    /**
     * Actually performs the purge. If `force` is set to false, return the
     * expected purge count without deleting any documents.
     *
     * Generated from protobuf field <code>bool force = 3;</code>
     * @param bool $var
     * @return $this
     */
    public function setForce($var)
    {
        GPBUtil::checkBool($var);
        $this->force = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getSource()
    {
        return $this->whichOneof("source");
    }

}

