<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/discoveryengine/v1/purge_config.proto

namespace Google\Cloud\DiscoveryEngine\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for PurgeUserEvents method.
 *
 * Generated from protobuf message <code>google.cloud.discoveryengine.v1.PurgeUserEventsRequest</code>
 */
class PurgeUserEventsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the catalog under which the events are
     * created. The format is
     * `projects/{project}/locations/global/collections/{collection}/dataStores/{dataStore}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The filter string to specify the events to be deleted with a
     * length limit of 5,000 characters. The eligible fields for filtering are:
     * * `eventType`: Double quoted
     * [UserEvent.event_type][google.cloud.discoveryengine.v1.UserEvent.event_type]
     * string.
     * * `eventTime`: in ISO 8601 "zulu" format.
     * * `userPseudoId`: Double quoted string. Specifying this will delete all
     *   events associated with a visitor.
     * * `userId`: Double quoted string. Specifying this will delete all events
     *   associated with a user.
     * Examples:
     * * Deleting all events in a time range:
     *   `eventTime > "2012-04-23T18:25:43.511Z"
     *   eventTime < "2012-04-23T18:30:43.511Z"`
     * * Deleting specific eventType:
     *   `eventType = "search"`
     * * Deleting all events for a specific visitor:
     *   `userPseudoId = "visitor1024"`
     * * Deleting all events inside a DataStore:
     *   `*`
     * The filtering fields are assumed to have an implicit AND.
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $filter = '';
    /**
     * The `force` field is currently not supported. Purge user event requests
     * will permanently delete all purgeable events. Once the development is
     * complete:
     * If `force` is set to false, the method will return the expected
     * purge count without deleting any user events. This field will default to
     * false if not included in the request.
     *
     * Generated from protobuf field <code>bool force = 3;</code>
     */
    protected $force = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The resource name of the catalog under which the events are
     *           created. The format is
     *           `projects/{project}/locations/global/collections/{collection}/dataStores/{dataStore}`.
     *     @type string $filter
     *           Required. The filter string to specify the events to be deleted with a
     *           length limit of 5,000 characters. The eligible fields for filtering are:
     *           * `eventType`: Double quoted
     *           [UserEvent.event_type][google.cloud.discoveryengine.v1.UserEvent.event_type]
     *           string.
     *           * `eventTime`: in ISO 8601 "zulu" format.
     *           * `userPseudoId`: Double quoted string. Specifying this will delete all
     *             events associated with a visitor.
     *           * `userId`: Double quoted string. Specifying this will delete all events
     *             associated with a user.
     *           Examples:
     *           * Deleting all events in a time range:
     *             `eventTime > "2012-04-23T18:25:43.511Z"
     *             eventTime < "2012-04-23T18:30:43.511Z"`
     *           * Deleting specific eventType:
     *             `eventType = "search"`
     *           * Deleting all events for a specific visitor:
     *             `userPseudoId = "visitor1024"`
     *           * Deleting all events inside a DataStore:
     *             `*`
     *           The filtering fields are assumed to have an implicit AND.
     *     @type bool $force
     *           The `force` field is currently not supported. Purge user event requests
     *           will permanently delete all purgeable events. Once the development is
     *           complete:
     *           If `force` is set to false, the method will return the expected
     *           purge count without deleting any user events. This field will default to
     *           false if not included in the request.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Discoveryengine\V1\PurgeConfig::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the catalog under which the events are
     * created. The format is
     * `projects/{project}/locations/global/collections/{collection}/dataStores/{dataStore}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The resource name of the catalog under which the events are
     * created. The format is
     * `projects/{project}/locations/global/collections/{collection}/dataStores/{dataStore}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The filter string to specify the events to be deleted with a
     * length limit of 5,000 characters. The eligible fields for filtering are:
     * * `eventType`: Double quoted
     * [UserEvent.event_type][google.cloud.discoveryengine.v1.UserEvent.event_type]
     * string.
     * * `eventTime`: in ISO 8601 "zulu" format.
     * * `userPseudoId`: Double quoted string. Specifying this will delete all
     *   events associated with a visitor.
     * * `userId`: Double quoted string. Specifying this will delete all events
     *   associated with a user.
     * Examples:
     * * Deleting all events in a time range:
     *   `eventTime > "2012-04-23T18:25:43.511Z"
     *   eventTime < "2012-04-23T18:30:43.511Z"`
     * * Deleting specific eventType:
     *   `eventType = "search"`
     * * Deleting all events for a specific visitor:
     *   `userPseudoId = "visitor1024"`
     * * Deleting all events inside a DataStore:
     *   `*`
     * The filtering fields are assumed to have an implicit AND.
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Required. The filter string to specify the events to be deleted with a
     * length limit of 5,000 characters. The eligible fields for filtering are:
     * * `eventType`: Double quoted
     * [UserEvent.event_type][google.cloud.discoveryengine.v1.UserEvent.event_type]
     * string.
     * * `eventTime`: in ISO 8601 "zulu" format.
     * * `userPseudoId`: Double quoted string. Specifying this will delete all
     *   events associated with a visitor.
     * * `userId`: Double quoted string. Specifying this will delete all events
     *   associated with a user.
     * Examples:
     * * Deleting all events in a time range:
     *   `eventTime > "2012-04-23T18:25:43.511Z"
     *   eventTime < "2012-04-23T18:30:43.511Z"`
     * * Deleting specific eventType:
     *   `eventType = "search"`
     * * Deleting all events for a specific visitor:
     *   `userPseudoId = "visitor1024"`
     * * Deleting all events inside a DataStore:
     *   `*`
     * The filtering fields are assumed to have an implicit AND.
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * The `force` field is currently not supported. Purge user event requests
     * will permanently delete all purgeable events. Once the development is
     * complete:
     * If `force` is set to false, the method will return the expected
     * purge count without deleting any user events. This field will default to
     * false if not included in the request.
     *
     * Generated from protobuf field <code>bool force = 3;</code>
     * @return bool
     */
    public function getForce()
    {
        return $this->force;
    }

    /**
     * The `force` field is currently not supported. Purge user event requests
     * will permanently delete all purgeable events. Once the development is
     * complete:
     * If `force` is set to false, the method will return the expected
     * purge count without deleting any user events. This field will default to
     * false if not included in the request.
     *
     * Generated from protobuf field <code>bool force = 3;</code>
     * @param bool $var
     * @return $this
     */
    public function setForce($var)
    {
        GPBUtil::checkBool($var);
        $this->force = $var;

        return $this;
    }

}

