<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/discoveryengine/v1/site_search_engine_service.proto

namespace Google\Cloud\DiscoveryEngine\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Metadata related to the progress of the
 * [SiteSearchEngineService.RecrawlUris][google.cloud.discoveryengine.v1.SiteSearchEngineService.RecrawlUris]
 * operation. This will be returned by the google.longrunning.Operation.metadata
 * field.
 *
 * Generated from protobuf message <code>google.cloud.discoveryengine.v1.RecrawlUrisMetadata</code>
 */
class RecrawlUrisMetadata extends \Google\Protobuf\Internal\Message
{
    /**
     * Operation create time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 1;</code>
     */
    protected $create_time = null;
    /**
     * Operation last update time. If the operation is done, this is also the
     * finish time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 2;</code>
     */
    protected $update_time = null;
    /**
     * Unique URIs in the request that don't match any TargetSite in the
     * DataStore, only match TargetSites that haven't been fully indexed, or match
     * a TargetSite with type EXCLUDE.
     *
     * Generated from protobuf field <code>repeated string invalid_uris = 3;</code>
     */
    private $invalid_uris;
    /**
     * Total number of unique URIs in the request that are not in invalid_uris.
     *
     * Generated from protobuf field <code>int32 valid_uris_count = 4;</code>
     */
    protected $valid_uris_count = 0;
    /**
     * Total number of URIs that have been crawled so far.
     *
     * Generated from protobuf field <code>int32 success_count = 5;</code>
     */
    protected $success_count = 0;
    /**
     * Total number of URIs that have yet to be crawled.
     *
     * Generated from protobuf field <code>int32 pending_count = 6;</code>
     */
    protected $pending_count = 0;
    /**
     * Total number of URIs that were rejected due to insufficient indexing
     * resources.
     *
     * Generated from protobuf field <code>int32 quota_exceeded_count = 7;</code>
     */
    protected $quota_exceeded_count = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Operation create time.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Operation last update time. If the operation is done, this is also the
     *           finish time.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $invalid_uris
     *           Unique URIs in the request that don't match any TargetSite in the
     *           DataStore, only match TargetSites that haven't been fully indexed, or match
     *           a TargetSite with type EXCLUDE.
     *     @type int $valid_uris_count
     *           Total number of unique URIs in the request that are not in invalid_uris.
     *     @type int $success_count
     *           Total number of URIs that have been crawled so far.
     *     @type int $pending_count
     *           Total number of URIs that have yet to be crawled.
     *     @type int $quota_exceeded_count
     *           Total number of URIs that were rejected due to insufficient indexing
     *           resources.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Discoveryengine\V1\SiteSearchEngineService::initOnce();
        parent::__construct($data);
    }

    /**
     * Operation create time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 1;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Operation create time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 1;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Operation last update time. If the operation is done, this is also the
     * finish time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 2;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Operation last update time. If the operation is done, this is also the
     * finish time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 2;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Unique URIs in the request that don't match any TargetSite in the
     * DataStore, only match TargetSites that haven't been fully indexed, or match
     * a TargetSite with type EXCLUDE.
     *
     * Generated from protobuf field <code>repeated string invalid_uris = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getInvalidUris()
    {
        return $this->invalid_uris;
    }

    /**
     * Unique URIs in the request that don't match any TargetSite in the
     * DataStore, only match TargetSites that haven't been fully indexed, or match
     * a TargetSite with type EXCLUDE.
     *
     * Generated from protobuf field <code>repeated string invalid_uris = 3;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setInvalidUris($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->invalid_uris = $arr;

        return $this;
    }

    /**
     * Total number of unique URIs in the request that are not in invalid_uris.
     *
     * Generated from protobuf field <code>int32 valid_uris_count = 4;</code>
     * @return int
     */
    public function getValidUrisCount()
    {
        return $this->valid_uris_count;
    }

    /**
     * Total number of unique URIs in the request that are not in invalid_uris.
     *
     * Generated from protobuf field <code>int32 valid_uris_count = 4;</code>
     * @param int $var
     * @return $this
     */
    public function setValidUrisCount($var)
    {
        GPBUtil::checkInt32($var);
        $this->valid_uris_count = $var;

        return $this;
    }

    /**
     * Total number of URIs that have been crawled so far.
     *
     * Generated from protobuf field <code>int32 success_count = 5;</code>
     * @return int
     */
    public function getSuccessCount()
    {
        return $this->success_count;
    }

    /**
     * Total number of URIs that have been crawled so far.
     *
     * Generated from protobuf field <code>int32 success_count = 5;</code>
     * @param int $var
     * @return $this
     */
    public function setSuccessCount($var)
    {
        GPBUtil::checkInt32($var);
        $this->success_count = $var;

        return $this;
    }

    /**
     * Total number of URIs that have yet to be crawled.
     *
     * Generated from protobuf field <code>int32 pending_count = 6;</code>
     * @return int
     */
    public function getPendingCount()
    {
        return $this->pending_count;
    }

    /**
     * Total number of URIs that have yet to be crawled.
     *
     * Generated from protobuf field <code>int32 pending_count = 6;</code>
     * @param int $var
     * @return $this
     */
    public function setPendingCount($var)
    {
        GPBUtil::checkInt32($var);
        $this->pending_count = $var;

        return $this;
    }

    /**
     * Total number of URIs that were rejected due to insufficient indexing
     * resources.
     *
     * Generated from protobuf field <code>int32 quota_exceeded_count = 7;</code>
     * @return int
     */
    public function getQuotaExceededCount()
    {
        return $this->quota_exceeded_count;
    }

    /**
     * Total number of URIs that were rejected due to insufficient indexing
     * resources.
     *
     * Generated from protobuf field <code>int32 quota_exceeded_count = 7;</code>
     * @param int $var
     * @return $this
     */
    public function setQuotaExceededCount($var)
    {
        GPBUtil::checkInt32($var);
        $this->quota_exceeded_count = $var;

        return $this;
    }

}

