<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/privacy/dlp/v2/dlp.proto

namespace Google\Cloud\Dlp\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The profile for a scanned column within a table.
 *
 * Generated from protobuf message <code>google.privacy.dlp.v2.ColumnDataProfile</code>
 */
class ColumnDataProfile extends \Google\Protobuf\Internal\Message
{
    /**
     * The name of the profile.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    protected $name = '';
    /**
     * Success or error status from the most recent profile generation attempt.
     * May be empty if the profile is still being generated.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.ProfileStatus profile_status = 17;</code>
     */
    protected $profile_status = null;
    /**
     * State of a profile.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.ColumnDataProfile.State state = 18;</code>
     */
    protected $state = 0;
    /**
     * The last time the profile was generated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp profile_last_generated = 3;</code>
     */
    protected $profile_last_generated = null;
    /**
     * The resource name of the table data profile.
     *
     * Generated from protobuf field <code>string table_data_profile = 4;</code>
     */
    protected $table_data_profile = '';
    /**
     * The resource name of the resource this column is within.
     *
     * Generated from protobuf field <code>string table_full_resource = 5;</code>
     */
    protected $table_full_resource = '';
    /**
     * The Google Cloud project ID that owns the profiled resource.
     *
     * Generated from protobuf field <code>string dataset_project_id = 19;</code>
     */
    protected $dataset_project_id = '';
    /**
     * The BigQuery location where the dataset's data is stored.
     * See https://cloud.google.com/bigquery/docs/locations for supported
     * locations.
     *
     * Generated from protobuf field <code>string dataset_location = 20;</code>
     */
    protected $dataset_location = '';
    /**
     * The BigQuery dataset ID.
     *
     * Generated from protobuf field <code>string dataset_id = 21;</code>
     */
    protected $dataset_id = '';
    /**
     * The BigQuery table ID.
     *
     * Generated from protobuf field <code>string table_id = 22;</code>
     */
    protected $table_id = '';
    /**
     * The name of the column.
     *
     * Generated from protobuf field <code>string column = 6;</code>
     */
    protected $column = '';
    /**
     * The sensitivity of this column.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.SensitivityScore sensitivity_score = 7;</code>
     */
    protected $sensitivity_score = null;
    /**
     * The data risk level for this column.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.DataRiskLevel data_risk_level = 8;</code>
     */
    protected $data_risk_level = null;
    /**
     * If it's been determined this column can be identified as a single type,
     * this will be set. Otherwise the column either has unidentifiable content
     * or mixed types.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.InfoTypeSummary column_info_type = 9;</code>
     */
    protected $column_info_type = null;
    /**
     * Other types found within this column. List will be unordered.
     *
     * Generated from protobuf field <code>repeated .google.privacy.dlp.v2.OtherInfoTypeSummary other_matches = 10;</code>
     */
    private $other_matches;
    /**
     * Approximate percentage of entries being null in the column.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.NullPercentageLevel estimated_null_percentage = 23;</code>
     */
    protected $estimated_null_percentage = 0;
    /**
     * Approximate uniqueness of the column.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.UniquenessScoreLevel estimated_uniqueness_score = 24;</code>
     */
    protected $estimated_uniqueness_score = 0;
    /**
     * The likelihood that this column contains free-form text.
     * A value close to 1 may indicate the column is likely to contain
     * free-form or natural language text.
     * Range in 0-1.
     *
     * Generated from protobuf field <code>double free_text_score = 13;</code>
     */
    protected $free_text_score = 0.0;
    /**
     * The data type of a given column.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.ColumnDataProfile.ColumnDataType column_type = 14;</code>
     */
    protected $column_type = 0;
    /**
     * Indicates if a policy tag has been applied to the column.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.ColumnDataProfile.ColumnPolicyState policy_state = 15;</code>
     */
    protected $policy_state = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           The name of the profile.
     *     @type \Google\Cloud\Dlp\V2\ProfileStatus $profile_status
     *           Success or error status from the most recent profile generation attempt.
     *           May be empty if the profile is still being generated.
     *     @type int $state
     *           State of a profile.
     *     @type \Google\Protobuf\Timestamp $profile_last_generated
     *           The last time the profile was generated.
     *     @type string $table_data_profile
     *           The resource name of the table data profile.
     *     @type string $table_full_resource
     *           The resource name of the resource this column is within.
     *     @type string $dataset_project_id
     *           The Google Cloud project ID that owns the profiled resource.
     *     @type string $dataset_location
     *           The BigQuery location where the dataset's data is stored.
     *           See https://cloud.google.com/bigquery/docs/locations for supported
     *           locations.
     *     @type string $dataset_id
     *           The BigQuery dataset ID.
     *     @type string $table_id
     *           The BigQuery table ID.
     *     @type string $column
     *           The name of the column.
     *     @type \Google\Cloud\Dlp\V2\SensitivityScore $sensitivity_score
     *           The sensitivity of this column.
     *     @type \Google\Cloud\Dlp\V2\DataRiskLevel $data_risk_level
     *           The data risk level for this column.
     *     @type \Google\Cloud\Dlp\V2\InfoTypeSummary $column_info_type
     *           If it's been determined this column can be identified as a single type,
     *           this will be set. Otherwise the column either has unidentifiable content
     *           or mixed types.
     *     @type array<\Google\Cloud\Dlp\V2\OtherInfoTypeSummary>|\Google\Protobuf\Internal\RepeatedField $other_matches
     *           Other types found within this column. List will be unordered.
     *     @type int $estimated_null_percentage
     *           Approximate percentage of entries being null in the column.
     *     @type int $estimated_uniqueness_score
     *           Approximate uniqueness of the column.
     *     @type float $free_text_score
     *           The likelihood that this column contains free-form text.
     *           A value close to 1 may indicate the column is likely to contain
     *           free-form or natural language text.
     *           Range in 0-1.
     *     @type int $column_type
     *           The data type of a given column.
     *     @type int $policy_state
     *           Indicates if a policy tag has been applied to the column.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Privacy\Dlp\V2\Dlp::initOnce();
        parent::__construct($data);
    }

    /**
     * The name of the profile.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * The name of the profile.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Success or error status from the most recent profile generation attempt.
     * May be empty if the profile is still being generated.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.ProfileStatus profile_status = 17;</code>
     * @return \Google\Cloud\Dlp\V2\ProfileStatus|null
     */
    public function getProfileStatus()
    {
        return $this->profile_status;
    }

    public function hasProfileStatus()
    {
        return isset($this->profile_status);
    }

    public function clearProfileStatus()
    {
        unset($this->profile_status);
    }

    /**
     * Success or error status from the most recent profile generation attempt.
     * May be empty if the profile is still being generated.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.ProfileStatus profile_status = 17;</code>
     * @param \Google\Cloud\Dlp\V2\ProfileStatus $var
     * @return $this
     */
    public function setProfileStatus($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dlp\V2\ProfileStatus::class);
        $this->profile_status = $var;

        return $this;
    }

    /**
     * State of a profile.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.ColumnDataProfile.State state = 18;</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * State of a profile.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.ColumnDataProfile.State state = 18;</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Dlp\V2\ColumnDataProfile\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * The last time the profile was generated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp profile_last_generated = 3;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getProfileLastGenerated()
    {
        return $this->profile_last_generated;
    }

    public function hasProfileLastGenerated()
    {
        return isset($this->profile_last_generated);
    }

    public function clearProfileLastGenerated()
    {
        unset($this->profile_last_generated);
    }

    /**
     * The last time the profile was generated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp profile_last_generated = 3;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setProfileLastGenerated($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->profile_last_generated = $var;

        return $this;
    }

    /**
     * The resource name of the table data profile.
     *
     * Generated from protobuf field <code>string table_data_profile = 4;</code>
     * @return string
     */
    public function getTableDataProfile()
    {
        return $this->table_data_profile;
    }

    /**
     * The resource name of the table data profile.
     *
     * Generated from protobuf field <code>string table_data_profile = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setTableDataProfile($var)
    {
        GPBUtil::checkString($var, True);
        $this->table_data_profile = $var;

        return $this;
    }

    /**
     * The resource name of the resource this column is within.
     *
     * Generated from protobuf field <code>string table_full_resource = 5;</code>
     * @return string
     */
    public function getTableFullResource()
    {
        return $this->table_full_resource;
    }

    /**
     * The resource name of the resource this column is within.
     *
     * Generated from protobuf field <code>string table_full_resource = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setTableFullResource($var)
    {
        GPBUtil::checkString($var, True);
        $this->table_full_resource = $var;

        return $this;
    }

    /**
     * The Google Cloud project ID that owns the profiled resource.
     *
     * Generated from protobuf field <code>string dataset_project_id = 19;</code>
     * @return string
     */
    public function getDatasetProjectId()
    {
        return $this->dataset_project_id;
    }

    /**
     * The Google Cloud project ID that owns the profiled resource.
     *
     * Generated from protobuf field <code>string dataset_project_id = 19;</code>
     * @param string $var
     * @return $this
     */
    public function setDatasetProjectId($var)
    {
        GPBUtil::checkString($var, True);
        $this->dataset_project_id = $var;

        return $this;
    }

    /**
     * The BigQuery location where the dataset's data is stored.
     * See https://cloud.google.com/bigquery/docs/locations for supported
     * locations.
     *
     * Generated from protobuf field <code>string dataset_location = 20;</code>
     * @return string
     */
    public function getDatasetLocation()
    {
        return $this->dataset_location;
    }

    /**
     * The BigQuery location where the dataset's data is stored.
     * See https://cloud.google.com/bigquery/docs/locations for supported
     * locations.
     *
     * Generated from protobuf field <code>string dataset_location = 20;</code>
     * @param string $var
     * @return $this
     */
    public function setDatasetLocation($var)
    {
        GPBUtil::checkString($var, True);
        $this->dataset_location = $var;

        return $this;
    }

    /**
     * The BigQuery dataset ID.
     *
     * Generated from protobuf field <code>string dataset_id = 21;</code>
     * @return string
     */
    public function getDatasetId()
    {
        return $this->dataset_id;
    }

    /**
     * The BigQuery dataset ID.
     *
     * Generated from protobuf field <code>string dataset_id = 21;</code>
     * @param string $var
     * @return $this
     */
    public function setDatasetId($var)
    {
        GPBUtil::checkString($var, True);
        $this->dataset_id = $var;

        return $this;
    }

    /**
     * The BigQuery table ID.
     *
     * Generated from protobuf field <code>string table_id = 22;</code>
     * @return string
     */
    public function getTableId()
    {
        return $this->table_id;
    }

    /**
     * The BigQuery table ID.
     *
     * Generated from protobuf field <code>string table_id = 22;</code>
     * @param string $var
     * @return $this
     */
    public function setTableId($var)
    {
        GPBUtil::checkString($var, True);
        $this->table_id = $var;

        return $this;
    }

    /**
     * The name of the column.
     *
     * Generated from protobuf field <code>string column = 6;</code>
     * @return string
     */
    public function getColumn()
    {
        return $this->column;
    }

    /**
     * The name of the column.
     *
     * Generated from protobuf field <code>string column = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setColumn($var)
    {
        GPBUtil::checkString($var, True);
        $this->column = $var;

        return $this;
    }

    /**
     * The sensitivity of this column.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.SensitivityScore sensitivity_score = 7;</code>
     * @return \Google\Cloud\Dlp\V2\SensitivityScore|null
     */
    public function getSensitivityScore()
    {
        return $this->sensitivity_score;
    }

    public function hasSensitivityScore()
    {
        return isset($this->sensitivity_score);
    }

    public function clearSensitivityScore()
    {
        unset($this->sensitivity_score);
    }

    /**
     * The sensitivity of this column.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.SensitivityScore sensitivity_score = 7;</code>
     * @param \Google\Cloud\Dlp\V2\SensitivityScore $var
     * @return $this
     */
    public function setSensitivityScore($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dlp\V2\SensitivityScore::class);
        $this->sensitivity_score = $var;

        return $this;
    }

    /**
     * The data risk level for this column.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.DataRiskLevel data_risk_level = 8;</code>
     * @return \Google\Cloud\Dlp\V2\DataRiskLevel|null
     */
    public function getDataRiskLevel()
    {
        return $this->data_risk_level;
    }

    public function hasDataRiskLevel()
    {
        return isset($this->data_risk_level);
    }

    public function clearDataRiskLevel()
    {
        unset($this->data_risk_level);
    }

    /**
     * The data risk level for this column.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.DataRiskLevel data_risk_level = 8;</code>
     * @param \Google\Cloud\Dlp\V2\DataRiskLevel $var
     * @return $this
     */
    public function setDataRiskLevel($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dlp\V2\DataRiskLevel::class);
        $this->data_risk_level = $var;

        return $this;
    }

    /**
     * If it's been determined this column can be identified as a single type,
     * this will be set. Otherwise the column either has unidentifiable content
     * or mixed types.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.InfoTypeSummary column_info_type = 9;</code>
     * @return \Google\Cloud\Dlp\V2\InfoTypeSummary|null
     */
    public function getColumnInfoType()
    {
        return $this->column_info_type;
    }

    public function hasColumnInfoType()
    {
        return isset($this->column_info_type);
    }

    public function clearColumnInfoType()
    {
        unset($this->column_info_type);
    }

    /**
     * If it's been determined this column can be identified as a single type,
     * this will be set. Otherwise the column either has unidentifiable content
     * or mixed types.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.InfoTypeSummary column_info_type = 9;</code>
     * @param \Google\Cloud\Dlp\V2\InfoTypeSummary $var
     * @return $this
     */
    public function setColumnInfoType($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dlp\V2\InfoTypeSummary::class);
        $this->column_info_type = $var;

        return $this;
    }

    /**
     * Other types found within this column. List will be unordered.
     *
     * Generated from protobuf field <code>repeated .google.privacy.dlp.v2.OtherInfoTypeSummary other_matches = 10;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getOtherMatches()
    {
        return $this->other_matches;
    }

    /**
     * Other types found within this column. List will be unordered.
     *
     * Generated from protobuf field <code>repeated .google.privacy.dlp.v2.OtherInfoTypeSummary other_matches = 10;</code>
     * @param array<\Google\Cloud\Dlp\V2\OtherInfoTypeSummary>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setOtherMatches($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Dlp\V2\OtherInfoTypeSummary::class);
        $this->other_matches = $arr;

        return $this;
    }

    /**
     * Approximate percentage of entries being null in the column.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.NullPercentageLevel estimated_null_percentage = 23;</code>
     * @return int
     */
    public function getEstimatedNullPercentage()
    {
        return $this->estimated_null_percentage;
    }

    /**
     * Approximate percentage of entries being null in the column.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.NullPercentageLevel estimated_null_percentage = 23;</code>
     * @param int $var
     * @return $this
     */
    public function setEstimatedNullPercentage($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Dlp\V2\NullPercentageLevel::class);
        $this->estimated_null_percentage = $var;

        return $this;
    }

    /**
     * Approximate uniqueness of the column.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.UniquenessScoreLevel estimated_uniqueness_score = 24;</code>
     * @return int
     */
    public function getEstimatedUniquenessScore()
    {
        return $this->estimated_uniqueness_score;
    }

    /**
     * Approximate uniqueness of the column.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.UniquenessScoreLevel estimated_uniqueness_score = 24;</code>
     * @param int $var
     * @return $this
     */
    public function setEstimatedUniquenessScore($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Dlp\V2\UniquenessScoreLevel::class);
        $this->estimated_uniqueness_score = $var;

        return $this;
    }

    /**
     * The likelihood that this column contains free-form text.
     * A value close to 1 may indicate the column is likely to contain
     * free-form or natural language text.
     * Range in 0-1.
     *
     * Generated from protobuf field <code>double free_text_score = 13;</code>
     * @return float
     */
    public function getFreeTextScore()
    {
        return $this->free_text_score;
    }

    /**
     * The likelihood that this column contains free-form text.
     * A value close to 1 may indicate the column is likely to contain
     * free-form or natural language text.
     * Range in 0-1.
     *
     * Generated from protobuf field <code>double free_text_score = 13;</code>
     * @param float $var
     * @return $this
     */
    public function setFreeTextScore($var)
    {
        GPBUtil::checkDouble($var);
        $this->free_text_score = $var;

        return $this;
    }

    /**
     * The data type of a given column.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.ColumnDataProfile.ColumnDataType column_type = 14;</code>
     * @return int
     */
    public function getColumnType()
    {
        return $this->column_type;
    }

    /**
     * The data type of a given column.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.ColumnDataProfile.ColumnDataType column_type = 14;</code>
     * @param int $var
     * @return $this
     */
    public function setColumnType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Dlp\V2\ColumnDataProfile\ColumnDataType::class);
        $this->column_type = $var;

        return $this;
    }

    /**
     * Indicates if a policy tag has been applied to the column.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.ColumnDataProfile.ColumnPolicyState policy_state = 15;</code>
     * @return int
     */
    public function getPolicyState()
    {
        return $this->policy_state;
    }

    /**
     * Indicates if a policy tag has been applied to the column.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.ColumnDataProfile.ColumnPolicyState policy_state = 15;</code>
     * @param int $var
     * @return $this
     */
    public function setPolicyState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Dlp\V2\ColumnDataProfile\ColumnPolicyState::class);
        $this->policy_state = $var;

        return $this;
    }

}

