<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/privacy/dlp/v2/dlp.proto

namespace Google\Cloud\Dlp\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for CreateDiscoveryConfig.
 *
 * Generated from protobuf message <code>google.privacy.dlp.v2.CreateDiscoveryConfigRequest</code>
 */
class CreateDiscoveryConfigRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Parent resource name.
     * The format of this value varies depending on the scope of the request
     * (project or organization):
     * + Projects scope:
     *   `projects/{project_id}/locations/{location_id}`
     * + Organizations scope:
     *   `organizations/{org_id}/locations/{location_id}`
     * The following example `parent` string specifies a parent project with the
     * identifier `example-project`, and specifies the `europe-west3` location
     * for processing data:
     *     parent=projects/example-project/locations/europe-west3
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The DiscoveryConfig to create.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.DiscoveryConfig discovery_config = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $discovery_config = null;
    /**
     * The config ID can contain uppercase and lowercase letters,
     * numbers, and hyphens; that is, it must match the regular
     * expression: `[a-zA-Z\d-_]+`. The maximum length is 100
     * characters. Can be empty to allow the system to generate one.
     *
     * Generated from protobuf field <code>string config_id = 3;</code>
     */
    protected $config_id = '';

    /**
     * @param string                               $parent          Required. Parent resource name.
     *
     *                                                              The format of this value varies depending on the scope of the request
     *                                                              (project or organization):
     *
     *                                                              + Projects scope:
     *                                                              `projects/{project_id}/locations/{location_id}`
     *                                                              + Organizations scope:
     *                                                              `organizations/{org_id}/locations/{location_id}`
     *
     *                                                              The following example `parent` string specifies a parent project with the
     *                                                              identifier `example-project`, and specifies the `europe-west3` location
     *                                                              for processing data:
     *
     *                                                              parent=projects/example-project/locations/europe-west3
     *                                                              Please see {@see DlpServiceClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\Dlp\V2\DiscoveryConfig $discoveryConfig Required. The DiscoveryConfig to create.
     *
     * @return \Google\Cloud\Dlp\V2\CreateDiscoveryConfigRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\Dlp\V2\DiscoveryConfig $discoveryConfig): self
    {
        return (new self())
            ->setParent($parent)
            ->setDiscoveryConfig($discoveryConfig);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Parent resource name.
     *           The format of this value varies depending on the scope of the request
     *           (project or organization):
     *           + Projects scope:
     *             `projects/{project_id}/locations/{location_id}`
     *           + Organizations scope:
     *             `organizations/{org_id}/locations/{location_id}`
     *           The following example `parent` string specifies a parent project with the
     *           identifier `example-project`, and specifies the `europe-west3` location
     *           for processing data:
     *               parent=projects/example-project/locations/europe-west3
     *     @type \Google\Cloud\Dlp\V2\DiscoveryConfig $discovery_config
     *           Required. The DiscoveryConfig to create.
     *     @type string $config_id
     *           The config ID can contain uppercase and lowercase letters,
     *           numbers, and hyphens; that is, it must match the regular
     *           expression: `[a-zA-Z\d-_]+`. The maximum length is 100
     *           characters. Can be empty to allow the system to generate one.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Privacy\Dlp\V2\Dlp::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Parent resource name.
     * The format of this value varies depending on the scope of the request
     * (project or organization):
     * + Projects scope:
     *   `projects/{project_id}/locations/{location_id}`
     * + Organizations scope:
     *   `organizations/{org_id}/locations/{location_id}`
     * The following example `parent` string specifies a parent project with the
     * identifier `example-project`, and specifies the `europe-west3` location
     * for processing data:
     *     parent=projects/example-project/locations/europe-west3
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Parent resource name.
     * The format of this value varies depending on the scope of the request
     * (project or organization):
     * + Projects scope:
     *   `projects/{project_id}/locations/{location_id}`
     * + Organizations scope:
     *   `organizations/{org_id}/locations/{location_id}`
     * The following example `parent` string specifies a parent project with the
     * identifier `example-project`, and specifies the `europe-west3` location
     * for processing data:
     *     parent=projects/example-project/locations/europe-west3
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The DiscoveryConfig to create.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.DiscoveryConfig discovery_config = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\Dlp\V2\DiscoveryConfig|null
     */
    public function getDiscoveryConfig()
    {
        return $this->discovery_config;
    }

    public function hasDiscoveryConfig()
    {
        return isset($this->discovery_config);
    }

    public function clearDiscoveryConfig()
    {
        unset($this->discovery_config);
    }

    /**
     * Required. The DiscoveryConfig to create.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.DiscoveryConfig discovery_config = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\Dlp\V2\DiscoveryConfig $var
     * @return $this
     */
    public function setDiscoveryConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dlp\V2\DiscoveryConfig::class);
        $this->discovery_config = $var;

        return $this;
    }

    /**
     * The config ID can contain uppercase and lowercase letters,
     * numbers, and hyphens; that is, it must match the regular
     * expression: `[a-zA-Z\d-_]+`. The maximum length is 100
     * characters. Can be empty to allow the system to generate one.
     *
     * Generated from protobuf field <code>string config_id = 3;</code>
     * @return string
     */
    public function getConfigId()
    {
        return $this->config_id;
    }

    /**
     * The config ID can contain uppercase and lowercase letters,
     * numbers, and hyphens; that is, it must match the regular
     * expression: `[a-zA-Z\d-_]+`. The maximum length is 100
     * characters. Can be empty to allow the system to generate one.
     *
     * Generated from protobuf field <code>string config_id = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setConfigId($var)
    {
        GPBUtil::checkString($var, True);
        $this->config_id = $var;

        return $this;
    }

}

