<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/privacy/dlp/v2/dlp.proto

namespace Google\Cloud\Dlp\V2\DataProfileAction;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * If set, attaches the [tags]
 * (https://cloud.google.com/resource-manager/docs/tags/tags-overview)
 * provided to profiled resources. Tags support [access
 * control](https://cloud.google.com/iam/docs/tags-access-control). You can
 * conditionally grant or deny access to a resource based on whether the
 * resource has a specific tag.
 *
 * Generated from protobuf message <code>google.privacy.dlp.v2.DataProfileAction.TagResources</code>
 */
class TagResources extends \Google\Protobuf\Internal\Message
{
    /**
     * The tags to associate with different conditions.
     *
     * Generated from protobuf field <code>repeated .google.privacy.dlp.v2.DataProfileAction.TagResources.TagCondition tag_conditions = 1;</code>
     */
    private $tag_conditions;
    /**
     * The profile generations for which the tag should be attached to
     * resources. If you attach a tag to only new profiles, then if the
     * sensitivity score of a profile subsequently changes, its tag doesn't
     * change. By default, this field includes only new profiles. To include
     * both new and updated profiles for tagging, this field should explicitly
     * include both `PROFILE_GENERATION_NEW` and `PROFILE_GENERATION_UPDATE`.
     *
     * Generated from protobuf field <code>repeated .google.privacy.dlp.v2.ProfileGeneration profile_generations_to_tag = 2;</code>
     */
    private $profile_generations_to_tag;
    /**
     * Whether applying a tag to a resource should lower the risk of the profile
     * for that resource. For example, in conjunction with an [IAM deny
     * policy](https://cloud.google.com/iam/docs/deny-overview), you can deny
     * all principals a permission if a tag value is present, mitigating the
     * risk of the resource. This also lowers the data risk of resources at the
     * lower levels of the resource hierarchy. For example, reducing the data
     * risk of a table data profile also reduces the data risk of the
     * constituent column data profiles.
     *
     * Generated from protobuf field <code>bool lower_data_risk_to_low = 3;</code>
     */
    protected $lower_data_risk_to_low = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type array<\Google\Cloud\Dlp\V2\DataProfileAction\TagResources\TagCondition>|\Google\Protobuf\Internal\RepeatedField $tag_conditions
     *           The tags to associate with different conditions.
     *     @type array<int>|\Google\Protobuf\Internal\RepeatedField $profile_generations_to_tag
     *           The profile generations for which the tag should be attached to
     *           resources. If you attach a tag to only new profiles, then if the
     *           sensitivity score of a profile subsequently changes, its tag doesn't
     *           change. By default, this field includes only new profiles. To include
     *           both new and updated profiles for tagging, this field should explicitly
     *           include both `PROFILE_GENERATION_NEW` and `PROFILE_GENERATION_UPDATE`.
     *     @type bool $lower_data_risk_to_low
     *           Whether applying a tag to a resource should lower the risk of the profile
     *           for that resource. For example, in conjunction with an [IAM deny
     *           policy](https://cloud.google.com/iam/docs/deny-overview), you can deny
     *           all principals a permission if a tag value is present, mitigating the
     *           risk of the resource. This also lowers the data risk of resources at the
     *           lower levels of the resource hierarchy. For example, reducing the data
     *           risk of a table data profile also reduces the data risk of the
     *           constituent column data profiles.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Privacy\Dlp\V2\Dlp::initOnce();
        parent::__construct($data);
    }

    /**
     * The tags to associate with different conditions.
     *
     * Generated from protobuf field <code>repeated .google.privacy.dlp.v2.DataProfileAction.TagResources.TagCondition tag_conditions = 1;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getTagConditions()
    {
        return $this->tag_conditions;
    }

    /**
     * The tags to associate with different conditions.
     *
     * Generated from protobuf field <code>repeated .google.privacy.dlp.v2.DataProfileAction.TagResources.TagCondition tag_conditions = 1;</code>
     * @param array<\Google\Cloud\Dlp\V2\DataProfileAction\TagResources\TagCondition>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setTagConditions($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Dlp\V2\DataProfileAction\TagResources\TagCondition::class);
        $this->tag_conditions = $arr;

        return $this;
    }

    /**
     * The profile generations for which the tag should be attached to
     * resources. If you attach a tag to only new profiles, then if the
     * sensitivity score of a profile subsequently changes, its tag doesn't
     * change. By default, this field includes only new profiles. To include
     * both new and updated profiles for tagging, this field should explicitly
     * include both `PROFILE_GENERATION_NEW` and `PROFILE_GENERATION_UPDATE`.
     *
     * Generated from protobuf field <code>repeated .google.privacy.dlp.v2.ProfileGeneration profile_generations_to_tag = 2;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getProfileGenerationsToTag()
    {
        return $this->profile_generations_to_tag;
    }

    /**
     * The profile generations for which the tag should be attached to
     * resources. If you attach a tag to only new profiles, then if the
     * sensitivity score of a profile subsequently changes, its tag doesn't
     * change. By default, this field includes only new profiles. To include
     * both new and updated profiles for tagging, this field should explicitly
     * include both `PROFILE_GENERATION_NEW` and `PROFILE_GENERATION_UPDATE`.
     *
     * Generated from protobuf field <code>repeated .google.privacy.dlp.v2.ProfileGeneration profile_generations_to_tag = 2;</code>
     * @param array<int>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setProfileGenerationsToTag($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::ENUM, \Google\Cloud\Dlp\V2\ProfileGeneration::class);
        $this->profile_generations_to_tag = $arr;

        return $this;
    }

    /**
     * Whether applying a tag to a resource should lower the risk of the profile
     * for that resource. For example, in conjunction with an [IAM deny
     * policy](https://cloud.google.com/iam/docs/deny-overview), you can deny
     * all principals a permission if a tag value is present, mitigating the
     * risk of the resource. This also lowers the data risk of resources at the
     * lower levels of the resource hierarchy. For example, reducing the data
     * risk of a table data profile also reduces the data risk of the
     * constituent column data profiles.
     *
     * Generated from protobuf field <code>bool lower_data_risk_to_low = 3;</code>
     * @return bool
     */
    public function getLowerDataRiskToLow()
    {
        return $this->lower_data_risk_to_low;
    }

    /**
     * Whether applying a tag to a resource should lower the risk of the profile
     * for that resource. For example, in conjunction with an [IAM deny
     * policy](https://cloud.google.com/iam/docs/deny-overview), you can deny
     * all principals a permission if a tag value is present, mitigating the
     * risk of the resource. This also lowers the data risk of resources at the
     * lower levels of the resource hierarchy. For example, reducing the data
     * risk of a table data profile also reduces the data risk of the
     * constituent column data profiles.
     *
     * Generated from protobuf field <code>bool lower_data_risk_to_low = 3;</code>
     * @param bool $var
     * @return $this
     */
    public function setLowerDataRiskToLow($var)
    {
        GPBUtil::checkBool($var);
        $this->lower_data_risk_to_low = $var;

        return $this;
    }

}


