<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/privacy/dlp/v2/dlp.proto

namespace Google\Cloud\Dlp\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Determines what tables will have profiles generated within an organization
 * or project. Includes the ability to filter by regular expression patterns
 * on project ID, location, instance, database, and database resource name.
 *
 * Generated from protobuf message <code>google.privacy.dlp.v2.DiscoveryCloudSqlFilter</code>
 */
class DiscoveryCloudSqlFilter extends \Google\Protobuf\Internal\Message
{
    protected $filter;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\Dlp\V2\DatabaseResourceCollection $collection
     *           A specific set of database resources for this filter to apply to.
     *     @type \Google\Cloud\Dlp\V2\AllOtherDatabaseResources $others
     *           Catch-all. This should always be the last target in the list because
     *           anything above it will apply first. Should only appear once in a
     *           configuration. If none is specified, a default one will be added
     *           automatically.
     *     @type \Google\Cloud\Dlp\V2\DatabaseResourceReference $database_resource_reference
     *           The database resource to scan. Targets including this can only include
     *           one target (the target with this database resource reference).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Privacy\Dlp\V2\Dlp::initOnce();
        parent::__construct($data);
    }

    /**
     * A specific set of database resources for this filter to apply to.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.DatabaseResourceCollection collection = 1;</code>
     * @return \Google\Cloud\Dlp\V2\DatabaseResourceCollection|null
     */
    public function getCollection()
    {
        return $this->readOneof(1);
    }

    public function hasCollection()
    {
        return $this->hasOneof(1);
    }

    /**
     * A specific set of database resources for this filter to apply to.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.DatabaseResourceCollection collection = 1;</code>
     * @param \Google\Cloud\Dlp\V2\DatabaseResourceCollection $var
     * @return $this
     */
    public function setCollection($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dlp\V2\DatabaseResourceCollection::class);
        $this->writeOneof(1, $var);

        return $this;
    }

    /**
     * Catch-all. This should always be the last target in the list because
     * anything above it will apply first. Should only appear once in a
     * configuration. If none is specified, a default one will be added
     * automatically.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.AllOtherDatabaseResources others = 2;</code>
     * @return \Google\Cloud\Dlp\V2\AllOtherDatabaseResources|null
     */
    public function getOthers()
    {
        return $this->readOneof(2);
    }

    public function hasOthers()
    {
        return $this->hasOneof(2);
    }

    /**
     * Catch-all. This should always be the last target in the list because
     * anything above it will apply first. Should only appear once in a
     * configuration. If none is specified, a default one will be added
     * automatically.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.AllOtherDatabaseResources others = 2;</code>
     * @param \Google\Cloud\Dlp\V2\AllOtherDatabaseResources $var
     * @return $this
     */
    public function setOthers($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dlp\V2\AllOtherDatabaseResources::class);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     * The database resource to scan. Targets including this can only include
     * one target (the target with this database resource reference).
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.DatabaseResourceReference database_resource_reference = 3;</code>
     * @return \Google\Cloud\Dlp\V2\DatabaseResourceReference|null
     */
    public function getDatabaseResourceReference()
    {
        return $this->readOneof(3);
    }

    public function hasDatabaseResourceReference()
    {
        return $this->hasOneof(3);
    }

    /**
     * The database resource to scan. Targets including this can only include
     * one target (the target with this database resource reference).
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.DatabaseResourceReference database_resource_reference = 3;</code>
     * @param \Google\Cloud\Dlp\V2\DatabaseResourceReference $var
     * @return $this
     */
    public function setDatabaseResourceReference($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dlp\V2\DatabaseResourceReference::class);
        $this->writeOneof(3, $var);

        return $this;
    }

    /**
     * @return string
     */
    public function getFilter()
    {
        return $this->whichOneof("filter");
    }

}

