<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/privacy/dlp/v2/dlp.proto

namespace Google\Cloud\Dlp\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Requirements that must be true before a Cloud Storage bucket or object is
 * scanned in discovery for the first time. There is an AND relationship between
 * the top-level attributes.
 *
 * Generated from protobuf message <code>google.privacy.dlp.v2.DiscoveryCloudStorageConditions</code>
 */
class DiscoveryCloudStorageConditions extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Only objects with the specified attributes will be scanned. If an
     * object has one of the specified attributes but is inside an excluded
     * bucket, it will not be scanned. Defaults to [ALL_SUPPORTED_OBJECTS]. A
     * profile will be created even if no objects match the
     * included_object_attributes.
     *
     * Generated from protobuf field <code>repeated .google.privacy.dlp.v2.DiscoveryCloudStorageConditions.CloudStorageObjectAttribute included_object_attributes = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $included_object_attributes;
    /**
     * Required. Only objects with the specified attributes will be scanned.
     * Defaults to [ALL_SUPPORTED_BUCKETS] if unset.
     *
     * Generated from protobuf field <code>repeated .google.privacy.dlp.v2.DiscoveryCloudStorageConditions.CloudStorageBucketAttribute included_bucket_attributes = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $included_bucket_attributes;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type array<int>|\Google\Protobuf\Internal\RepeatedField $included_object_attributes
     *           Required. Only objects with the specified attributes will be scanned. If an
     *           object has one of the specified attributes but is inside an excluded
     *           bucket, it will not be scanned. Defaults to [ALL_SUPPORTED_OBJECTS]. A
     *           profile will be created even if no objects match the
     *           included_object_attributes.
     *     @type array<int>|\Google\Protobuf\Internal\RepeatedField $included_bucket_attributes
     *           Required. Only objects with the specified attributes will be scanned.
     *           Defaults to [ALL_SUPPORTED_BUCKETS] if unset.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Privacy\Dlp\V2\Dlp::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Only objects with the specified attributes will be scanned. If an
     * object has one of the specified attributes but is inside an excluded
     * bucket, it will not be scanned. Defaults to [ALL_SUPPORTED_OBJECTS]. A
     * profile will be created even if no objects match the
     * included_object_attributes.
     *
     * Generated from protobuf field <code>repeated .google.privacy.dlp.v2.DiscoveryCloudStorageConditions.CloudStorageObjectAttribute included_object_attributes = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getIncludedObjectAttributes()
    {
        return $this->included_object_attributes;
    }

    /**
     * Required. Only objects with the specified attributes will be scanned. If an
     * object has one of the specified attributes but is inside an excluded
     * bucket, it will not be scanned. Defaults to [ALL_SUPPORTED_OBJECTS]. A
     * profile will be created even if no objects match the
     * included_object_attributes.
     *
     * Generated from protobuf field <code>repeated .google.privacy.dlp.v2.DiscoveryCloudStorageConditions.CloudStorageObjectAttribute included_object_attributes = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param array<int>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setIncludedObjectAttributes($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::ENUM, \Google\Cloud\Dlp\V2\DiscoveryCloudStorageConditions\CloudStorageObjectAttribute::class);
        $this->included_object_attributes = $arr;

        return $this;
    }

    /**
     * Required. Only objects with the specified attributes will be scanned.
     * Defaults to [ALL_SUPPORTED_BUCKETS] if unset.
     *
     * Generated from protobuf field <code>repeated .google.privacy.dlp.v2.DiscoveryCloudStorageConditions.CloudStorageBucketAttribute included_bucket_attributes = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getIncludedBucketAttributes()
    {
        return $this->included_bucket_attributes;
    }

    /**
     * Required. Only objects with the specified attributes will be scanned.
     * Defaults to [ALL_SUPPORTED_BUCKETS] if unset.
     *
     * Generated from protobuf field <code>repeated .google.privacy.dlp.v2.DiscoveryCloudStorageConditions.CloudStorageBucketAttribute included_bucket_attributes = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param array<int>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setIncludedBucketAttributes($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::ENUM, \Google\Cloud\Dlp\V2\DiscoveryCloudStorageConditions\CloudStorageBucketAttribute::class);
        $this->included_bucket_attributes = $arr;

        return $this;
    }

}

