<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/privacy/dlp/v2/storage.proto

namespace Google\Cloud\Dlp\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Type of information detected by the API.
 *
 * Generated from protobuf message <code>google.privacy.dlp.v2.InfoType</code>
 */
class InfoType extends \Google\Protobuf\Internal\Message
{
    /**
     * Name of the information type. Either a name of your choosing when
     * creating a CustomInfoType, or one of the names listed
     * at
     * https://cloud.google.com/sensitive-data-protection/docs/infotypes-reference
     * when specifying a built-in type.  When sending Cloud DLP results to Data
     * Catalog, infoType names should conform to the pattern
     * `[A-Za-z0-9$_-]{1,64}`.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    protected $name = '';
    /**
     * Optional version name for this InfoType.
     *
     * Generated from protobuf field <code>string version = 2;</code>
     */
    protected $version = '';
    /**
     * Optional custom sensitivity for this InfoType.
     * This only applies to data profiling.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.SensitivityScore sensitivity_score = 3;</code>
     */
    protected $sensitivity_score = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Name of the information type. Either a name of your choosing when
     *           creating a CustomInfoType, or one of the names listed
     *           at
     *           https://cloud.google.com/sensitive-data-protection/docs/infotypes-reference
     *           when specifying a built-in type.  When sending Cloud DLP results to Data
     *           Catalog, infoType names should conform to the pattern
     *           `[A-Za-z0-9$_-]{1,64}`.
     *     @type string $version
     *           Optional version name for this InfoType.
     *     @type \Google\Cloud\Dlp\V2\SensitivityScore $sensitivity_score
     *           Optional custom sensitivity for this InfoType.
     *           This only applies to data profiling.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Privacy\Dlp\V2\Storage::initOnce();
        parent::__construct($data);
    }

    /**
     * Name of the information type. Either a name of your choosing when
     * creating a CustomInfoType, or one of the names listed
     * at
     * https://cloud.google.com/sensitive-data-protection/docs/infotypes-reference
     * when specifying a built-in type.  When sending Cloud DLP results to Data
     * Catalog, infoType names should conform to the pattern
     * `[A-Za-z0-9$_-]{1,64}`.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Name of the information type. Either a name of your choosing when
     * creating a CustomInfoType, or one of the names listed
     * at
     * https://cloud.google.com/sensitive-data-protection/docs/infotypes-reference
     * when specifying a built-in type.  When sending Cloud DLP results to Data
     * Catalog, infoType names should conform to the pattern
     * `[A-Za-z0-9$_-]{1,64}`.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Optional version name for this InfoType.
     *
     * Generated from protobuf field <code>string version = 2;</code>
     * @return string
     */
    public function getVersion()
    {
        return $this->version;
    }

    /**
     * Optional version name for this InfoType.
     *
     * Generated from protobuf field <code>string version = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->version = $var;

        return $this;
    }

    /**
     * Optional custom sensitivity for this InfoType.
     * This only applies to data profiling.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.SensitivityScore sensitivity_score = 3;</code>
     * @return \Google\Cloud\Dlp\V2\SensitivityScore|null
     */
    public function getSensitivityScore()
    {
        return $this->sensitivity_score;
    }

    public function hasSensitivityScore()
    {
        return isset($this->sensitivity_score);
    }

    public function clearSensitivityScore()
    {
        unset($this->sensitivity_score);
    }

    /**
     * Optional custom sensitivity for this InfoType.
     * This only applies to data profiling.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.SensitivityScore sensitivity_score = 3;</code>
     * @param \Google\Cloud\Dlp\V2\SensitivityScore $var
     * @return $this
     */
    public function setSensitivityScore($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dlp\V2\SensitivityScore::class);
        $this->sensitivity_score = $var;

        return $this;
    }

}

