<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/privacy/dlp/v2/dlp.proto

namespace Google\Cloud\Dlp\V2\InspectDataSourceDetails;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * All result fields mentioned below are updated while the job is processing.
 *
 * Generated from protobuf message <code>google.privacy.dlp.v2.InspectDataSourceDetails.Result</code>
 */
class Result extends \Google\Protobuf\Internal\Message
{
    /**
     * Total size in bytes that were processed.
     *
     * Generated from protobuf field <code>int64 processed_bytes = 1;</code>
     */
    protected $processed_bytes = 0;
    /**
     * Estimate of the number of bytes to process.
     *
     * Generated from protobuf field <code>int64 total_estimated_bytes = 2;</code>
     */
    protected $total_estimated_bytes = 0;
    /**
     * Statistics of how many instances of each info type were found during
     * inspect job.
     *
     * Generated from protobuf field <code>repeated .google.privacy.dlp.v2.InfoTypeStats info_type_stats = 3;</code>
     */
    private $info_type_stats;
    /**
     * Number of rows scanned after sampling and time filtering (applicable for
     * row based stores such as BigQuery).
     *
     * Generated from protobuf field <code>int64 num_rows_processed = 5;</code>
     */
    protected $num_rows_processed = 0;
    /**
     * Statistics related to the processing of hybrid inspect.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.HybridInspectStatistics hybrid_stats = 7;</code>
     */
    protected $hybrid_stats = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int|string $processed_bytes
     *           Total size in bytes that were processed.
     *     @type int|string $total_estimated_bytes
     *           Estimate of the number of bytes to process.
     *     @type array<\Google\Cloud\Dlp\V2\InfoTypeStats>|\Google\Protobuf\Internal\RepeatedField $info_type_stats
     *           Statistics of how many instances of each info type were found during
     *           inspect job.
     *     @type int|string $num_rows_processed
     *           Number of rows scanned after sampling and time filtering (applicable for
     *           row based stores such as BigQuery).
     *     @type \Google\Cloud\Dlp\V2\HybridInspectStatistics $hybrid_stats
     *           Statistics related to the processing of hybrid inspect.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Privacy\Dlp\V2\Dlp::initOnce();
        parent::__construct($data);
    }

    /**
     * Total size in bytes that were processed.
     *
     * Generated from protobuf field <code>int64 processed_bytes = 1;</code>
     * @return int|string
     */
    public function getProcessedBytes()
    {
        return $this->processed_bytes;
    }

    /**
     * Total size in bytes that were processed.
     *
     * Generated from protobuf field <code>int64 processed_bytes = 1;</code>
     * @param int|string $var
     * @return $this
     */
    public function setProcessedBytes($var)
    {
        GPBUtil::checkInt64($var);
        $this->processed_bytes = $var;

        return $this;
    }

    /**
     * Estimate of the number of bytes to process.
     *
     * Generated from protobuf field <code>int64 total_estimated_bytes = 2;</code>
     * @return int|string
     */
    public function getTotalEstimatedBytes()
    {
        return $this->total_estimated_bytes;
    }

    /**
     * Estimate of the number of bytes to process.
     *
     * Generated from protobuf field <code>int64 total_estimated_bytes = 2;</code>
     * @param int|string $var
     * @return $this
     */
    public function setTotalEstimatedBytes($var)
    {
        GPBUtil::checkInt64($var);
        $this->total_estimated_bytes = $var;

        return $this;
    }

    /**
     * Statistics of how many instances of each info type were found during
     * inspect job.
     *
     * Generated from protobuf field <code>repeated .google.privacy.dlp.v2.InfoTypeStats info_type_stats = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getInfoTypeStats()
    {
        return $this->info_type_stats;
    }

    /**
     * Statistics of how many instances of each info type were found during
     * inspect job.
     *
     * Generated from protobuf field <code>repeated .google.privacy.dlp.v2.InfoTypeStats info_type_stats = 3;</code>
     * @param array<\Google\Cloud\Dlp\V2\InfoTypeStats>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setInfoTypeStats($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Dlp\V2\InfoTypeStats::class);
        $this->info_type_stats = $arr;

        return $this;
    }

    /**
     * Number of rows scanned after sampling and time filtering (applicable for
     * row based stores such as BigQuery).
     *
     * Generated from protobuf field <code>int64 num_rows_processed = 5;</code>
     * @return int|string
     */
    public function getNumRowsProcessed()
    {
        return $this->num_rows_processed;
    }

    /**
     * Number of rows scanned after sampling and time filtering (applicable for
     * row based stores such as BigQuery).
     *
     * Generated from protobuf field <code>int64 num_rows_processed = 5;</code>
     * @param int|string $var
     * @return $this
     */
    public function setNumRowsProcessed($var)
    {
        GPBUtil::checkInt64($var);
        $this->num_rows_processed = $var;

        return $this;
    }

    /**
     * Statistics related to the processing of hybrid inspect.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.HybridInspectStatistics hybrid_stats = 7;</code>
     * @return \Google\Cloud\Dlp\V2\HybridInspectStatistics|null
     */
    public function getHybridStats()
    {
        return $this->hybrid_stats;
    }

    public function hasHybridStats()
    {
        return isset($this->hybrid_stats);
    }

    public function clearHybridStats()
    {
        unset($this->hybrid_stats);
    }

    /**
     * Statistics related to the processing of hybrid inspect.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.HybridInspectStatistics hybrid_stats = 7;</code>
     * @param \Google\Cloud\Dlp\V2\HybridInspectStatistics $var
     * @return $this
     */
    public function setHybridStats($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dlp\V2\HybridInspectStatistics::class);
        $this->hybrid_stats = $var;

        return $this;
    }

}


