<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/privacy/dlp/v2/dlp.proto

namespace Google\Cloud\Dlp\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An aggregated profile for this project, based on the resources profiled
 * within it.
 *
 * Generated from protobuf message <code>google.privacy.dlp.v2.ProjectDataProfile</code>
 */
class ProjectDataProfile extends \Google\Protobuf\Internal\Message
{
    /**
     * The resource name of the profile.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    protected $name = '';
    /**
     * Project ID or account that was profiled.
     *
     * Generated from protobuf field <code>string project_id = 2;</code>
     */
    protected $project_id = '';
    /**
     * The last time the profile was generated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp profile_last_generated = 3;</code>
     */
    protected $profile_last_generated = null;
    /**
     * The sensitivity score of this project.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.SensitivityScore sensitivity_score = 4;</code>
     */
    protected $sensitivity_score = null;
    /**
     * The data risk level of this project.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.DataRiskLevel data_risk_level = 5;</code>
     */
    protected $data_risk_level = null;
    /**
     * Success or error status of the last attempt to profile the project.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.ProfileStatus profile_status = 7;</code>
     */
    protected $profile_status = null;
    /**
     * The number of table data profiles generated for this project.
     *
     * Generated from protobuf field <code>int64 table_data_profile_count = 9;</code>
     */
    protected $table_data_profile_count = 0;
    /**
     * The number of file store data profiles generated for this project.
     *
     * Generated from protobuf field <code>int64 file_store_data_profile_count = 10;</code>
     */
    protected $file_store_data_profile_count = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           The resource name of the profile.
     *     @type string $project_id
     *           Project ID or account that was profiled.
     *     @type \Google\Protobuf\Timestamp $profile_last_generated
     *           The last time the profile was generated.
     *     @type \Google\Cloud\Dlp\V2\SensitivityScore $sensitivity_score
     *           The sensitivity score of this project.
     *     @type \Google\Cloud\Dlp\V2\DataRiskLevel $data_risk_level
     *           The data risk level of this project.
     *     @type \Google\Cloud\Dlp\V2\ProfileStatus $profile_status
     *           Success or error status of the last attempt to profile the project.
     *     @type int|string $table_data_profile_count
     *           The number of table data profiles generated for this project.
     *     @type int|string $file_store_data_profile_count
     *           The number of file store data profiles generated for this project.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Privacy\Dlp\V2\Dlp::initOnce();
        parent::__construct($data);
    }

    /**
     * The resource name of the profile.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * The resource name of the profile.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Project ID or account that was profiled.
     *
     * Generated from protobuf field <code>string project_id = 2;</code>
     * @return string
     */
    public function getProjectId()
    {
        return $this->project_id;
    }

    /**
     * Project ID or account that was profiled.
     *
     * Generated from protobuf field <code>string project_id = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setProjectId($var)
    {
        GPBUtil::checkString($var, True);
        $this->project_id = $var;

        return $this;
    }

    /**
     * The last time the profile was generated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp profile_last_generated = 3;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getProfileLastGenerated()
    {
        return $this->profile_last_generated;
    }

    public function hasProfileLastGenerated()
    {
        return isset($this->profile_last_generated);
    }

    public function clearProfileLastGenerated()
    {
        unset($this->profile_last_generated);
    }

    /**
     * The last time the profile was generated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp profile_last_generated = 3;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setProfileLastGenerated($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->profile_last_generated = $var;

        return $this;
    }

    /**
     * The sensitivity score of this project.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.SensitivityScore sensitivity_score = 4;</code>
     * @return \Google\Cloud\Dlp\V2\SensitivityScore|null
     */
    public function getSensitivityScore()
    {
        return $this->sensitivity_score;
    }

    public function hasSensitivityScore()
    {
        return isset($this->sensitivity_score);
    }

    public function clearSensitivityScore()
    {
        unset($this->sensitivity_score);
    }

    /**
     * The sensitivity score of this project.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.SensitivityScore sensitivity_score = 4;</code>
     * @param \Google\Cloud\Dlp\V2\SensitivityScore $var
     * @return $this
     */
    public function setSensitivityScore($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dlp\V2\SensitivityScore::class);
        $this->sensitivity_score = $var;

        return $this;
    }

    /**
     * The data risk level of this project.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.DataRiskLevel data_risk_level = 5;</code>
     * @return \Google\Cloud\Dlp\V2\DataRiskLevel|null
     */
    public function getDataRiskLevel()
    {
        return $this->data_risk_level;
    }

    public function hasDataRiskLevel()
    {
        return isset($this->data_risk_level);
    }

    public function clearDataRiskLevel()
    {
        unset($this->data_risk_level);
    }

    /**
     * The data risk level of this project.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.DataRiskLevel data_risk_level = 5;</code>
     * @param \Google\Cloud\Dlp\V2\DataRiskLevel $var
     * @return $this
     */
    public function setDataRiskLevel($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dlp\V2\DataRiskLevel::class);
        $this->data_risk_level = $var;

        return $this;
    }

    /**
     * Success or error status of the last attempt to profile the project.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.ProfileStatus profile_status = 7;</code>
     * @return \Google\Cloud\Dlp\V2\ProfileStatus|null
     */
    public function getProfileStatus()
    {
        return $this->profile_status;
    }

    public function hasProfileStatus()
    {
        return isset($this->profile_status);
    }

    public function clearProfileStatus()
    {
        unset($this->profile_status);
    }

    /**
     * Success or error status of the last attempt to profile the project.
     *
     * Generated from protobuf field <code>.google.privacy.dlp.v2.ProfileStatus profile_status = 7;</code>
     * @param \Google\Cloud\Dlp\V2\ProfileStatus $var
     * @return $this
     */
    public function setProfileStatus($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Dlp\V2\ProfileStatus::class);
        $this->profile_status = $var;

        return $this;
    }

    /**
     * The number of table data profiles generated for this project.
     *
     * Generated from protobuf field <code>int64 table_data_profile_count = 9;</code>
     * @return int|string
     */
    public function getTableDataProfileCount()
    {
        return $this->table_data_profile_count;
    }

    /**
     * The number of table data profiles generated for this project.
     *
     * Generated from protobuf field <code>int64 table_data_profile_count = 9;</code>
     * @param int|string $var
     * @return $this
     */
    public function setTableDataProfileCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->table_data_profile_count = $var;

        return $this;
    }

    /**
     * The number of file store data profiles generated for this project.
     *
     * Generated from protobuf field <code>int64 file_store_data_profile_count = 10;</code>
     * @return int|string
     */
    public function getFileStoreDataProfileCount()
    {
        return $this->file_store_data_profile_count;
    }

    /**
     * The number of file store data profiles generated for this project.
     *
     * Generated from protobuf field <code>int64 file_store_data_profile_count = 10;</code>
     * @param int|string $var
     * @return $this
     */
    public function setFileStoreDataProfileCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->file_store_data_profile_count = $var;

        return $this;
    }

}

