<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/clouddms/v1/conversionworkspace_resources.proto

namespace Google\Cloud\CloudDms\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Options to configure rule type ConditionalColumnSetValue.
 * The rule is used to transform the data which is being replicated/migrated.
 * The rule filter field can refer to one or more entities.
 * The rule scope can be one of: Column.
 *
 * Generated from protobuf message <code>google.cloud.clouddms.v1.ConditionalColumnSetValue</code>
 */
class ConditionalColumnSetValue extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Description of data transformation during migration.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.ValueTransformation value_transformation = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $value_transformation = null;
    /**
     * Optional. Custom engine specific features.
     *
     * Generated from protobuf field <code>.google.protobuf.Struct custom_features = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $custom_features = null;
    protected $source_filter;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\CloudDms\V1\SourceTextFilter $source_text_filter
     *           Optional. Optional filter on source column length. Used for text based
     *           data types like varchar.
     *     @type \Google\Cloud\CloudDms\V1\SourceNumericFilter $source_numeric_filter
     *           Optional. Optional filter on source column precision and scale. Used for
     *           fixed point numbers such as NUMERIC/NUMBER data types.
     *     @type \Google\Cloud\CloudDms\V1\ValueTransformation $value_transformation
     *           Required. Description of data transformation during migration.
     *     @type \Google\Protobuf\Struct $custom_features
     *           Optional. Custom engine specific features.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Clouddms\V1\ConversionworkspaceResources::initOnce();
        parent::__construct($data);
    }

    /**
     * Optional. Optional filter on source column length. Used for text based
     * data types like varchar.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.SourceTextFilter source_text_filter = 100 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\CloudDms\V1\SourceTextFilter|null
     */
    public function getSourceTextFilter()
    {
        return $this->readOneof(100);
    }

    public function hasSourceTextFilter()
    {
        return $this->hasOneof(100);
    }

    /**
     * Optional. Optional filter on source column length. Used for text based
     * data types like varchar.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.SourceTextFilter source_text_filter = 100 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\CloudDms\V1\SourceTextFilter $var
     * @return $this
     */
    public function setSourceTextFilter($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\CloudDms\V1\SourceTextFilter::class);
        $this->writeOneof(100, $var);

        return $this;
    }

    /**
     * Optional. Optional filter on source column precision and scale. Used for
     * fixed point numbers such as NUMERIC/NUMBER data types.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.SourceNumericFilter source_numeric_filter = 101 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\CloudDms\V1\SourceNumericFilter|null
     */
    public function getSourceNumericFilter()
    {
        return $this->readOneof(101);
    }

    public function hasSourceNumericFilter()
    {
        return $this->hasOneof(101);
    }

    /**
     * Optional. Optional filter on source column precision and scale. Used for
     * fixed point numbers such as NUMERIC/NUMBER data types.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.SourceNumericFilter source_numeric_filter = 101 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\CloudDms\V1\SourceNumericFilter $var
     * @return $this
     */
    public function setSourceNumericFilter($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\CloudDms\V1\SourceNumericFilter::class);
        $this->writeOneof(101, $var);

        return $this;
    }

    /**
     * Required. Description of data transformation during migration.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.ValueTransformation value_transformation = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\CloudDms\V1\ValueTransformation|null
     */
    public function getValueTransformation()
    {
        return $this->value_transformation;
    }

    public function hasValueTransformation()
    {
        return isset($this->value_transformation);
    }

    public function clearValueTransformation()
    {
        unset($this->value_transformation);
    }

    /**
     * Required. Description of data transformation during migration.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.ValueTransformation value_transformation = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\CloudDms\V1\ValueTransformation $var
     * @return $this
     */
    public function setValueTransformation($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\CloudDms\V1\ValueTransformation::class);
        $this->value_transformation = $var;

        return $this;
    }

    /**
     * Optional. Custom engine specific features.
     *
     * Generated from protobuf field <code>.google.protobuf.Struct custom_features = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Struct|null
     */
    public function getCustomFeatures()
    {
        return $this->custom_features;
    }

    public function hasCustomFeatures()
    {
        return isset($this->custom_features);
    }

    public function clearCustomFeatures()
    {
        unset($this->custom_features);
    }

    /**
     * Optional. Custom engine specific features.
     *
     * Generated from protobuf field <code>.google.protobuf.Struct custom_features = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Protobuf\Struct $var
     * @return $this
     */
    public function setCustomFeatures($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Struct::class);
        $this->custom_features = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getSourceFilter()
    {
        return $this->whichOneof("source_filter");
    }

}

