<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/clouddms/v1/clouddms.proto

namespace Google\Cloud\CloudDms\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for 'DescribeDatabaseEntities' request.
 *
 * Generated from protobuf message <code>google.cloud.clouddms.v1.DescribeDatabaseEntitiesRequest</code>
 */
class DescribeDatabaseEntitiesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Name of the conversion workspace resource whose database entities
     * are described. Must be in the form of:
     * projects/{project}/locations/{location}/conversionWorkspaces/{conversion_workspace}.
     *
     * Generated from protobuf field <code>string conversion_workspace = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $conversion_workspace = '';
    /**
     * Optional. The maximum number of entities to return. The service may return
     * fewer entities than the value specifies.
     *
     * Generated from protobuf field <code>int32 page_size = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. The nextPageToken value received in the previous call to
     * conversionWorkspace.describeDatabaseEntities, used in the subsequent
     * request to retrieve the next page of results. On first call this should be
     * left blank. When paginating, all other parameters provided to
     * conversionWorkspace.describeDatabaseEntities must match the call that
     * provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';
    /**
     * Required. The tree to fetch.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.DescribeDatabaseEntitiesRequest.DBTreeType tree = 6 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $tree = 0;
    /**
     * Optional. Whether to retrieve the latest committed version of the entities
     * or the latest version. This field is ignored if a specific commit_id is
     * specified.
     *
     * Generated from protobuf field <code>bool uncommitted = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $uncommitted = false;
    /**
     * Optional. Request a specific commit ID. If not specified, the entities from
     * the latest commit are returned.
     *
     * Generated from protobuf field <code>string commit_id = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $commit_id = '';
    /**
     * Optional. Filter the returned entities based on AIP-160 standard.
     *
     * Generated from protobuf field <code>string filter = 13 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $filter = '';
    /**
     * Optional. Results view based on AIP-157
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.DatabaseEntityView view = 14 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $view = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $conversion_workspace
     *           Required. Name of the conversion workspace resource whose database entities
     *           are described. Must be in the form of:
     *           projects/{project}/locations/{location}/conversionWorkspaces/{conversion_workspace}.
     *     @type int $page_size
     *           Optional. The maximum number of entities to return. The service may return
     *           fewer entities than the value specifies.
     *     @type string $page_token
     *           Optional. The nextPageToken value received in the previous call to
     *           conversionWorkspace.describeDatabaseEntities, used in the subsequent
     *           request to retrieve the next page of results. On first call this should be
     *           left blank. When paginating, all other parameters provided to
     *           conversionWorkspace.describeDatabaseEntities must match the call that
     *           provided the page token.
     *     @type int $tree
     *           Required. The tree to fetch.
     *     @type bool $uncommitted
     *           Optional. Whether to retrieve the latest committed version of the entities
     *           or the latest version. This field is ignored if a specific commit_id is
     *           specified.
     *     @type string $commit_id
     *           Optional. Request a specific commit ID. If not specified, the entities from
     *           the latest commit are returned.
     *     @type string $filter
     *           Optional. Filter the returned entities based on AIP-160 standard.
     *     @type int $view
     *           Optional. Results view based on AIP-157
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Clouddms\V1\Clouddms::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Name of the conversion workspace resource whose database entities
     * are described. Must be in the form of:
     * projects/{project}/locations/{location}/conversionWorkspaces/{conversion_workspace}.
     *
     * Generated from protobuf field <code>string conversion_workspace = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getConversionWorkspace()
    {
        return $this->conversion_workspace;
    }

    /**
     * Required. Name of the conversion workspace resource whose database entities
     * are described. Must be in the form of:
     * projects/{project}/locations/{location}/conversionWorkspaces/{conversion_workspace}.
     *
     * Generated from protobuf field <code>string conversion_workspace = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setConversionWorkspace($var)
    {
        GPBUtil::checkString($var, True);
        $this->conversion_workspace = $var;

        return $this;
    }

    /**
     * Optional. The maximum number of entities to return. The service may return
     * fewer entities than the value specifies.
     *
     * Generated from protobuf field <code>int32 page_size = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. The maximum number of entities to return. The service may return
     * fewer entities than the value specifies.
     *
     * Generated from protobuf field <code>int32 page_size = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. The nextPageToken value received in the previous call to
     * conversionWorkspace.describeDatabaseEntities, used in the subsequent
     * request to retrieve the next page of results. On first call this should be
     * left blank. When paginating, all other parameters provided to
     * conversionWorkspace.describeDatabaseEntities must match the call that
     * provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. The nextPageToken value received in the previous call to
     * conversionWorkspace.describeDatabaseEntities, used in the subsequent
     * request to retrieve the next page of results. On first call this should be
     * left blank. When paginating, all other parameters provided to
     * conversionWorkspace.describeDatabaseEntities must match the call that
     * provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Required. The tree to fetch.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.DescribeDatabaseEntitiesRequest.DBTreeType tree = 6 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return int
     */
    public function getTree()
    {
        return $this->tree;
    }

    /**
     * Required. The tree to fetch.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.DescribeDatabaseEntitiesRequest.DBTreeType tree = 6 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int $var
     * @return $this
     */
    public function setTree($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\CloudDms\V1\DescribeDatabaseEntitiesRequest\DBTreeType::class);
        $this->tree = $var;

        return $this;
    }

    /**
     * Optional. Whether to retrieve the latest committed version of the entities
     * or the latest version. This field is ignored if a specific commit_id is
     * specified.
     *
     * Generated from protobuf field <code>bool uncommitted = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getUncommitted()
    {
        return $this->uncommitted;
    }

    /**
     * Optional. Whether to retrieve the latest committed version of the entities
     * or the latest version. This field is ignored if a specific commit_id is
     * specified.
     *
     * Generated from protobuf field <code>bool uncommitted = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setUncommitted($var)
    {
        GPBUtil::checkBool($var);
        $this->uncommitted = $var;

        return $this;
    }

    /**
     * Optional. Request a specific commit ID. If not specified, the entities from
     * the latest commit are returned.
     *
     * Generated from protobuf field <code>string commit_id = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getCommitId()
    {
        return $this->commit_id;
    }

    /**
     * Optional. Request a specific commit ID. If not specified, the entities from
     * the latest commit are returned.
     *
     * Generated from protobuf field <code>string commit_id = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setCommitId($var)
    {
        GPBUtil::checkString($var, True);
        $this->commit_id = $var;

        return $this;
    }

    /**
     * Optional. Filter the returned entities based on AIP-160 standard.
     *
     * Generated from protobuf field <code>string filter = 13 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Optional. Filter the returned entities based on AIP-160 standard.
     *
     * Generated from protobuf field <code>string filter = 13 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * Optional. Results view based on AIP-157
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.DatabaseEntityView view = 14 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getView()
    {
        return $this->view;
    }

    /**
     * Optional. Results view based on AIP-157
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.DatabaseEntityView view = 14 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setView($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\CloudDms\V1\DatabaseEntityView::class);
        $this->view = $var;

        return $this;
    }

}

