<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/clouddms/v1/clouddms.proto

namespace Google\Cloud\CloudDms\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for 'GenerateTcpProxyScript' request.
 *
 * Generated from protobuf message <code>google.cloud.clouddms.v1.GenerateTcpProxyScriptRequest</code>
 */
class GenerateTcpProxyScriptRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Name of the migration job resource to generate the TCP Proxy script.
     *
     * Generated from protobuf field <code>string migration_job = 1 [(.google.api.resource_reference) = {</code>
     */
    protected $migration_job = '';
    /**
     * Required. The name of the Compute instance that will host the proxy.
     *
     * Generated from protobuf field <code>string vm_name = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $vm_name = '';
    /**
     * Required. The type of the Compute instance that will host the proxy.
     *
     * Generated from protobuf field <code>string vm_machine_type = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $vm_machine_type = '';
    /**
     * Optional. The Google Cloud Platform zone to create the VM in. The fully
     * qualified name of the zone must be specified, including the region name,
     * for example "us-central1-b". If not specified, uses the "-b" zone of the
     * destination Connection Profile's region.
     *
     * Generated from protobuf field <code>string vm_zone = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $vm_zone = '';
    /**
     * Required. The name of the subnet the Compute instance will use for private
     * connectivity. Must be supplied in the form of
     * projects/{project}/regions/{region}/subnetworks/{subnetwork}.
     * Note: the region for the subnet must match the Compute instance region.
     *
     * Generated from protobuf field <code>string vm_subnet = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $vm_subnet = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $migration_job
     *           Name of the migration job resource to generate the TCP Proxy script.
     *     @type string $vm_name
     *           Required. The name of the Compute instance that will host the proxy.
     *     @type string $vm_machine_type
     *           Required. The type of the Compute instance that will host the proxy.
     *     @type string $vm_zone
     *           Optional. The Google Cloud Platform zone to create the VM in. The fully
     *           qualified name of the zone must be specified, including the region name,
     *           for example "us-central1-b". If not specified, uses the "-b" zone of the
     *           destination Connection Profile's region.
     *     @type string $vm_subnet
     *           Required. The name of the subnet the Compute instance will use for private
     *           connectivity. Must be supplied in the form of
     *           projects/{project}/regions/{region}/subnetworks/{subnetwork}.
     *           Note: the region for the subnet must match the Compute instance region.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Clouddms\V1\Clouddms::initOnce();
        parent::__construct($data);
    }

    /**
     * Name of the migration job resource to generate the TCP Proxy script.
     *
     * Generated from protobuf field <code>string migration_job = 1 [(.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getMigrationJob()
    {
        return $this->migration_job;
    }

    /**
     * Name of the migration job resource to generate the TCP Proxy script.
     *
     * Generated from protobuf field <code>string migration_job = 1 [(.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setMigrationJob($var)
    {
        GPBUtil::checkString($var, True);
        $this->migration_job = $var;

        return $this;
    }

    /**
     * Required. The name of the Compute instance that will host the proxy.
     *
     * Generated from protobuf field <code>string vm_name = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getVmName()
    {
        return $this->vm_name;
    }

    /**
     * Required. The name of the Compute instance that will host the proxy.
     *
     * Generated from protobuf field <code>string vm_name = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setVmName($var)
    {
        GPBUtil::checkString($var, True);
        $this->vm_name = $var;

        return $this;
    }

    /**
     * Required. The type of the Compute instance that will host the proxy.
     *
     * Generated from protobuf field <code>string vm_machine_type = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getVmMachineType()
    {
        return $this->vm_machine_type;
    }

    /**
     * Required. The type of the Compute instance that will host the proxy.
     *
     * Generated from protobuf field <code>string vm_machine_type = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setVmMachineType($var)
    {
        GPBUtil::checkString($var, True);
        $this->vm_machine_type = $var;

        return $this;
    }

    /**
     * Optional. The Google Cloud Platform zone to create the VM in. The fully
     * qualified name of the zone must be specified, including the region name,
     * for example "us-central1-b". If not specified, uses the "-b" zone of the
     * destination Connection Profile's region.
     *
     * Generated from protobuf field <code>string vm_zone = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getVmZone()
    {
        return $this->vm_zone;
    }

    /**
     * Optional. The Google Cloud Platform zone to create the VM in. The fully
     * qualified name of the zone must be specified, including the region name,
     * for example "us-central1-b". If not specified, uses the "-b" zone of the
     * destination Connection Profile's region.
     *
     * Generated from protobuf field <code>string vm_zone = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setVmZone($var)
    {
        GPBUtil::checkString($var, True);
        $this->vm_zone = $var;

        return $this;
    }

    /**
     * Required. The name of the subnet the Compute instance will use for private
     * connectivity. Must be supplied in the form of
     * projects/{project}/regions/{region}/subnetworks/{subnetwork}.
     * Note: the region for the subnet must match the Compute instance region.
     *
     * Generated from protobuf field <code>string vm_subnet = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getVmSubnet()
    {
        return $this->vm_subnet;
    }

    /**
     * Required. The name of the subnet the Compute instance will use for private
     * connectivity. Must be supplied in the form of
     * projects/{project}/regions/{region}/subnetworks/{subnetwork}.
     * Note: the region for the subnet must match the Compute instance region.
     *
     * Generated from protobuf field <code>string vm_subnet = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setVmSubnet($var)
    {
        GPBUtil::checkString($var, True);
        $this->vm_subnet = $var;

        return $this;
    }

}

