<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/clouddms/v1/clouddms.proto

namespace Google\Cloud\CloudDms\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message to retrieve a list of private connections in a given project
 * and location.
 *
 * Generated from protobuf message <code>google.cloud.clouddms.v1.ListPrivateConnectionsRequest</code>
 */
class ListPrivateConnectionsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent that owns the collection of private connections.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Maximum number of private connections to return.
     * If unspecified, at most 50 private connections that are returned.
     * The maximum value is 1000; values above 1000 are coerced to 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     */
    protected $page_size = 0;
    /**
     * Page token received from a previous `ListPrivateConnections` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * `ListPrivateConnections` must match the call that provided the page
     * token.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     */
    protected $page_token = '';
    /**
     * A filter expression that filters private connections listed in the
     * response. The expression must specify the field name, a comparison
     * operator, and the value that you want to use for filtering. The value must
     * be a string, a number, or a boolean. The comparison operator must be either
     * =, !=, >, or <. For example, list private connections created this year by
     * specifying **createTime %gt; 2021-01-01T00:00:00.000000000Z**.
     *
     * Generated from protobuf field <code>string filter = 4;</code>
     */
    protected $filter = '';
    /**
     * Order by fields for the result.
     *
     * Generated from protobuf field <code>string order_by = 5;</code>
     */
    protected $order_by = '';

    /**
     * @param string $parent Required. The parent that owns the collection of private connections. Please see
     *                       {@see DataMigrationServiceClient::locationName()} for help formatting this field.
     *
     * @return \Google\Cloud\CloudDms\V1\ListPrivateConnectionsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent that owns the collection of private connections.
     *     @type int $page_size
     *           Maximum number of private connections to return.
     *           If unspecified, at most 50 private connections that are returned.
     *           The maximum value is 1000; values above 1000 are coerced to 1000.
     *     @type string $page_token
     *           Page token received from a previous `ListPrivateConnections` call.
     *           Provide this to retrieve the subsequent page.
     *           When paginating, all other parameters provided to
     *           `ListPrivateConnections` must match the call that provided the page
     *           token.
     *     @type string $filter
     *           A filter expression that filters private connections listed in the
     *           response. The expression must specify the field name, a comparison
     *           operator, and the value that you want to use for filtering. The value must
     *           be a string, a number, or a boolean. The comparison operator must be either
     *           =, !=, >, or <. For example, list private connections created this year by
     *           specifying **createTime %gt; 2021-01-01T00:00:00.000000000Z**.
     *     @type string $order_by
     *           Order by fields for the result.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Clouddms\V1\Clouddms::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent that owns the collection of private connections.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent that owns the collection of private connections.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Maximum number of private connections to return.
     * If unspecified, at most 50 private connections that are returned.
     * The maximum value is 1000; values above 1000 are coerced to 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Maximum number of private connections to return.
     * If unspecified, at most 50 private connections that are returned.
     * The maximum value is 1000; values above 1000 are coerced to 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Page token received from a previous `ListPrivateConnections` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * `ListPrivateConnections` must match the call that provided the page
     * token.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Page token received from a previous `ListPrivateConnections` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * `ListPrivateConnections` must match the call that provided the page
     * token.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * A filter expression that filters private connections listed in the
     * response. The expression must specify the field name, a comparison
     * operator, and the value that you want to use for filtering. The value must
     * be a string, a number, or a boolean. The comparison operator must be either
     * =, !=, >, or <. For example, list private connections created this year by
     * specifying **createTime %gt; 2021-01-01T00:00:00.000000000Z**.
     *
     * Generated from protobuf field <code>string filter = 4;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * A filter expression that filters private connections listed in the
     * response. The expression must specify the field name, a comparison
     * operator, and the value that you want to use for filtering. The value must
     * be a string, a number, or a boolean. The comparison operator must be either
     * =, !=, >, or <. For example, list private connections created this year by
     * specifying **createTime %gt; 2021-01-01T00:00:00.000000000Z**.
     *
     * Generated from protobuf field <code>string filter = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * Order by fields for the result.
     *
     * Generated from protobuf field <code>string order_by = 5;</code>
     * @return string
     */
    public function getOrderBy()
    {
        return $this->order_by;
    }

    /**
     * Order by fields for the result.
     *
     * Generated from protobuf field <code>string order_by = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setOrderBy($var)
    {
        GPBUtil::checkString($var, True);
        $this->order_by = $var;

        return $this;
    }

}

