<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/clouddms/v1/conversionworkspace_resources.proto

namespace Google\Cloud\CloudDms\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A filter defining the entities that a mapping rule should be applied to.
 * When more than one field is specified, the rule is applied only to
 * entities which match all the fields.
 *
 * Generated from protobuf message <code>google.cloud.clouddms.v1.MappingRuleFilter</code>
 */
class MappingRuleFilter extends \Google\Protobuf\Internal\Message
{
    /**
     * Optional. The rule should be applied to entities whose parent entity
     * (fully qualified name) matches the given value.
     * For example, if the rule applies to a table entity, the expected value
     * should be a schema (schema). If the rule applies to a column or index
     * entity, the expected value can be either a schema (schema) or a table
     * (schema.table)
     *
     * Generated from protobuf field <code>string parent_entity = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $parent_entity = '';
    /**
     * Optional. The rule should be applied to entities whose non-qualified name
     * starts with the given prefix.
     *
     * Generated from protobuf field <code>string entity_name_prefix = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $entity_name_prefix = '';
    /**
     * Optional. The rule should be applied to entities whose non-qualified name
     * ends with the given suffix.
     *
     * Generated from protobuf field <code>string entity_name_suffix = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $entity_name_suffix = '';
    /**
     * Optional. The rule should be applied to entities whose non-qualified name
     * contains the given string.
     *
     * Generated from protobuf field <code>string entity_name_contains = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $entity_name_contains = '';
    /**
     * Optional. The rule should be applied to specific entities defined by their
     * fully qualified names.
     *
     * Generated from protobuf field <code>repeated string entities = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $entities;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent_entity
     *           Optional. The rule should be applied to entities whose parent entity
     *           (fully qualified name) matches the given value.
     *           For example, if the rule applies to a table entity, the expected value
     *           should be a schema (schema). If the rule applies to a column or index
     *           entity, the expected value can be either a schema (schema) or a table
     *           (schema.table)
     *     @type string $entity_name_prefix
     *           Optional. The rule should be applied to entities whose non-qualified name
     *           starts with the given prefix.
     *     @type string $entity_name_suffix
     *           Optional. The rule should be applied to entities whose non-qualified name
     *           ends with the given suffix.
     *     @type string $entity_name_contains
     *           Optional. The rule should be applied to entities whose non-qualified name
     *           contains the given string.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $entities
     *           Optional. The rule should be applied to specific entities defined by their
     *           fully qualified names.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Clouddms\V1\ConversionworkspaceResources::initOnce();
        parent::__construct($data);
    }

    /**
     * Optional. The rule should be applied to entities whose parent entity
     * (fully qualified name) matches the given value.
     * For example, if the rule applies to a table entity, the expected value
     * should be a schema (schema). If the rule applies to a column or index
     * entity, the expected value can be either a schema (schema) or a table
     * (schema.table)
     *
     * Generated from protobuf field <code>string parent_entity = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getParentEntity()
    {
        return $this->parent_entity;
    }

    /**
     * Optional. The rule should be applied to entities whose parent entity
     * (fully qualified name) matches the given value.
     * For example, if the rule applies to a table entity, the expected value
     * should be a schema (schema). If the rule applies to a column or index
     * entity, the expected value can be either a schema (schema) or a table
     * (schema.table)
     *
     * Generated from protobuf field <code>string parent_entity = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setParentEntity($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent_entity = $var;

        return $this;
    }

    /**
     * Optional. The rule should be applied to entities whose non-qualified name
     * starts with the given prefix.
     *
     * Generated from protobuf field <code>string entity_name_prefix = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getEntityNamePrefix()
    {
        return $this->entity_name_prefix;
    }

    /**
     * Optional. The rule should be applied to entities whose non-qualified name
     * starts with the given prefix.
     *
     * Generated from protobuf field <code>string entity_name_prefix = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setEntityNamePrefix($var)
    {
        GPBUtil::checkString($var, True);
        $this->entity_name_prefix = $var;

        return $this;
    }

    /**
     * Optional. The rule should be applied to entities whose non-qualified name
     * ends with the given suffix.
     *
     * Generated from protobuf field <code>string entity_name_suffix = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getEntityNameSuffix()
    {
        return $this->entity_name_suffix;
    }

    /**
     * Optional. The rule should be applied to entities whose non-qualified name
     * ends with the given suffix.
     *
     * Generated from protobuf field <code>string entity_name_suffix = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setEntityNameSuffix($var)
    {
        GPBUtil::checkString($var, True);
        $this->entity_name_suffix = $var;

        return $this;
    }

    /**
     * Optional. The rule should be applied to entities whose non-qualified name
     * contains the given string.
     *
     * Generated from protobuf field <code>string entity_name_contains = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getEntityNameContains()
    {
        return $this->entity_name_contains;
    }

    /**
     * Optional. The rule should be applied to entities whose non-qualified name
     * contains the given string.
     *
     * Generated from protobuf field <code>string entity_name_contains = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setEntityNameContains($var)
    {
        GPBUtil::checkString($var, True);
        $this->entity_name_contains = $var;

        return $this;
    }

    /**
     * Optional. The rule should be applied to specific entities defined by their
     * fully qualified names.
     *
     * Generated from protobuf field <code>repeated string entities = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getEntities()
    {
        return $this->entities;
    }

    /**
     * Optional. The rule should be applied to specific entities defined by their
     * fully qualified names.
     *
     * Generated from protobuf field <code>repeated string entities = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setEntities($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->entities = $arr;

        return $this;
    }

}

