<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/clouddms/v1/conversionworkspace_resources.proto

namespace Google\Cloud\CloudDms\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Options to configure rule type MultiColumnDatatypeChange.
 * The rule is used to change the data type and associated properties of
 * multiple columns at once.
 * The rule filter field can refer to one or more entities.
 * The rule scope can be one of:Column.
 * This rule requires additional filters to be specified beyond the basic rule
 * filter field, which is the source data type, but the rule supports additional
 * filtering capabilities such as the minimum and maximum field length. All
 * additional filters which are specified are required to be met in order for
 * the rule to be applied (logical AND between the fields).
 *
 * Generated from protobuf message <code>google.cloud.clouddms.v1.MultiColumnDatatypeChange</code>
 */
class MultiColumnDatatypeChange extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Filter on source data type.
     *
     * Generated from protobuf field <code>string source_data_type_filter = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $source_data_type_filter = '';
    /**
     * Required. New data type.
     *
     * Generated from protobuf field <code>string new_data_type = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $new_data_type = '';
    /**
     * Optional. Column length - e.g. varchar (50) - if not specified and relevant
     * uses the source column length.
     *
     * Generated from protobuf field <code>int64 override_length = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $override_length = 0;
    /**
     * Optional. Column scale - when relevant - if not specified and relevant
     * uses the source column scale.
     *
     * Generated from protobuf field <code>int32 override_scale = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $override_scale = 0;
    /**
     * Optional. Column precision - when relevant - if not specified and relevant
     * uses the source column precision.
     *
     * Generated from protobuf field <code>int32 override_precision = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $override_precision = 0;
    /**
     * Optional. Column fractional seconds precision - used only for timestamp
     * based datatypes - if not specified and relevant uses the source column
     * fractional seconds precision.
     *
     * Generated from protobuf field <code>int32 override_fractional_seconds_precision = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $override_fractional_seconds_precision = 0;
    /**
     * Optional. Custom engine specific features.
     *
     * Generated from protobuf field <code>.google.protobuf.Struct custom_features = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $custom_features = null;
    protected $source_filter;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $source_data_type_filter
     *           Required. Filter on source data type.
     *     @type \Google\Cloud\CloudDms\V1\SourceTextFilter $source_text_filter
     *           Optional. Filter for text-based data types like varchar.
     *     @type \Google\Cloud\CloudDms\V1\SourceNumericFilter $source_numeric_filter
     *           Optional. Filter for fixed point number data types such as
     *           NUMERIC/NUMBER.
     *     @type string $new_data_type
     *           Required. New data type.
     *     @type int|string $override_length
     *           Optional. Column length - e.g. varchar (50) - if not specified and relevant
     *           uses the source column length.
     *     @type int $override_scale
     *           Optional. Column scale - when relevant - if not specified and relevant
     *           uses the source column scale.
     *     @type int $override_precision
     *           Optional. Column precision - when relevant - if not specified and relevant
     *           uses the source column precision.
     *     @type int $override_fractional_seconds_precision
     *           Optional. Column fractional seconds precision - used only for timestamp
     *           based datatypes - if not specified and relevant uses the source column
     *           fractional seconds precision.
     *     @type \Google\Protobuf\Struct $custom_features
     *           Optional. Custom engine specific features.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Clouddms\V1\ConversionworkspaceResources::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Filter on source data type.
     *
     * Generated from protobuf field <code>string source_data_type_filter = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getSourceDataTypeFilter()
    {
        return $this->source_data_type_filter;
    }

    /**
     * Required. Filter on source data type.
     *
     * Generated from protobuf field <code>string source_data_type_filter = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setSourceDataTypeFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->source_data_type_filter = $var;

        return $this;
    }

    /**
     * Optional. Filter for text-based data types like varchar.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.SourceTextFilter source_text_filter = 100 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\CloudDms\V1\SourceTextFilter|null
     */
    public function getSourceTextFilter()
    {
        return $this->readOneof(100);
    }

    public function hasSourceTextFilter()
    {
        return $this->hasOneof(100);
    }

    /**
     * Optional. Filter for text-based data types like varchar.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.SourceTextFilter source_text_filter = 100 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\CloudDms\V1\SourceTextFilter $var
     * @return $this
     */
    public function setSourceTextFilter($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\CloudDms\V1\SourceTextFilter::class);
        $this->writeOneof(100, $var);

        return $this;
    }

    /**
     * Optional. Filter for fixed point number data types such as
     * NUMERIC/NUMBER.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.SourceNumericFilter source_numeric_filter = 101 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\CloudDms\V1\SourceNumericFilter|null
     */
    public function getSourceNumericFilter()
    {
        return $this->readOneof(101);
    }

    public function hasSourceNumericFilter()
    {
        return $this->hasOneof(101);
    }

    /**
     * Optional. Filter for fixed point number data types such as
     * NUMERIC/NUMBER.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.SourceNumericFilter source_numeric_filter = 101 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\CloudDms\V1\SourceNumericFilter $var
     * @return $this
     */
    public function setSourceNumericFilter($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\CloudDms\V1\SourceNumericFilter::class);
        $this->writeOneof(101, $var);

        return $this;
    }

    /**
     * Required. New data type.
     *
     * Generated from protobuf field <code>string new_data_type = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getNewDataType()
    {
        return $this->new_data_type;
    }

    /**
     * Required. New data type.
     *
     * Generated from protobuf field <code>string new_data_type = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setNewDataType($var)
    {
        GPBUtil::checkString($var, True);
        $this->new_data_type = $var;

        return $this;
    }

    /**
     * Optional. Column length - e.g. varchar (50) - if not specified and relevant
     * uses the source column length.
     *
     * Generated from protobuf field <code>int64 override_length = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int|string
     */
    public function getOverrideLength()
    {
        return $this->override_length;
    }

    /**
     * Optional. Column length - e.g. varchar (50) - if not specified and relevant
     * uses the source column length.
     *
     * Generated from protobuf field <code>int64 override_length = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int|string $var
     * @return $this
     */
    public function setOverrideLength($var)
    {
        GPBUtil::checkInt64($var);
        $this->override_length = $var;

        return $this;
    }

    /**
     * Optional. Column scale - when relevant - if not specified and relevant
     * uses the source column scale.
     *
     * Generated from protobuf field <code>int32 override_scale = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getOverrideScale()
    {
        return $this->override_scale;
    }

    /**
     * Optional. Column scale - when relevant - if not specified and relevant
     * uses the source column scale.
     *
     * Generated from protobuf field <code>int32 override_scale = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setOverrideScale($var)
    {
        GPBUtil::checkInt32($var);
        $this->override_scale = $var;

        return $this;
    }

    /**
     * Optional. Column precision - when relevant - if not specified and relevant
     * uses the source column precision.
     *
     * Generated from protobuf field <code>int32 override_precision = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getOverridePrecision()
    {
        return $this->override_precision;
    }

    /**
     * Optional. Column precision - when relevant - if not specified and relevant
     * uses the source column precision.
     *
     * Generated from protobuf field <code>int32 override_precision = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setOverridePrecision($var)
    {
        GPBUtil::checkInt32($var);
        $this->override_precision = $var;

        return $this;
    }

    /**
     * Optional. Column fractional seconds precision - used only for timestamp
     * based datatypes - if not specified and relevant uses the source column
     * fractional seconds precision.
     *
     * Generated from protobuf field <code>int32 override_fractional_seconds_precision = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getOverrideFractionalSecondsPrecision()
    {
        return $this->override_fractional_seconds_precision;
    }

    /**
     * Optional. Column fractional seconds precision - used only for timestamp
     * based datatypes - if not specified and relevant uses the source column
     * fractional seconds precision.
     *
     * Generated from protobuf field <code>int32 override_fractional_seconds_precision = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setOverrideFractionalSecondsPrecision($var)
    {
        GPBUtil::checkInt32($var);
        $this->override_fractional_seconds_precision = $var;

        return $this;
    }

    /**
     * Optional. Custom engine specific features.
     *
     * Generated from protobuf field <code>.google.protobuf.Struct custom_features = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Struct|null
     */
    public function getCustomFeatures()
    {
        return $this->custom_features;
    }

    public function hasCustomFeatures()
    {
        return isset($this->custom_features);
    }

    public function clearCustomFeatures()
    {
        unset($this->custom_features);
    }

    /**
     * Optional. Custom engine specific features.
     *
     * Generated from protobuf field <code>.google.protobuf.Struct custom_features = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Protobuf\Struct $var
     * @return $this
     */
    public function setCustomFeatures($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Struct::class);
        $this->custom_features = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getSourceFilter()
    {
        return $this->whichOneof("source_filter");
    }

}

