<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/clouddms/v1/clouddms_resources.proto

namespace Google\Cloud\CloudDms\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Specifies connection parameters required specifically for PostgreSQL
 * databases.
 *
 * Generated from protobuf message <code>google.cloud.clouddms.v1.PostgreSqlConnectionProfile</code>
 */
class PostgreSqlConnectionProfile extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The IP or hostname of the source PostgreSQL database.
     *
     * Generated from protobuf field <code>string host = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $host = '';
    /**
     * Required. The network port of the source PostgreSQL database.
     *
     * Generated from protobuf field <code>int32 port = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $port = 0;
    /**
     * Required. The username that Database Migration Service will use to connect
     * to the database. The value is encrypted when stored in Database Migration
     * Service.
     *
     * Generated from protobuf field <code>string username = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $username = '';
    /**
     * Required. Input only. The password for the user that Database Migration
     * Service will be using to connect to the database. This field is not
     * returned on request, and the value is encrypted when stored in Database
     * Migration Service.
     *
     * Generated from protobuf field <code>string password = 4 [(.google.api.field_behavior) = INPUT_ONLY, (.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $password = '';
    /**
     * Output only. Indicates If this connection profile password is stored.
     *
     * Generated from protobuf field <code>bool password_set = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $password_set = false;
    /**
     * SSL configuration for the destination to connect to the source database.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.SslConfig ssl = 6;</code>
     */
    protected $ssl = null;
    /**
     * If the source is a Cloud SQL database, use this field to
     * provide the Cloud SQL instance ID of the source.
     *
     * Generated from protobuf field <code>string cloud_sql_id = 7;</code>
     */
    protected $cloud_sql_id = '';
    /**
     * Output only. If the source is a Cloud SQL database, this field indicates
     * the network architecture it's associated with.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.NetworkArchitecture network_architecture = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $network_architecture = 0;
    protected $connectivity;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $host
     *           Required. The IP or hostname of the source PostgreSQL database.
     *     @type int $port
     *           Required. The network port of the source PostgreSQL database.
     *     @type string $username
     *           Required. The username that Database Migration Service will use to connect
     *           to the database. The value is encrypted when stored in Database Migration
     *           Service.
     *     @type string $password
     *           Required. Input only. The password for the user that Database Migration
     *           Service will be using to connect to the database. This field is not
     *           returned on request, and the value is encrypted when stored in Database
     *           Migration Service.
     *     @type bool $password_set
     *           Output only. Indicates If this connection profile password is stored.
     *     @type \Google\Cloud\CloudDms\V1\SslConfig $ssl
     *           SSL configuration for the destination to connect to the source database.
     *     @type string $cloud_sql_id
     *           If the source is a Cloud SQL database, use this field to
     *           provide the Cloud SQL instance ID of the source.
     *     @type int $network_architecture
     *           Output only. If the source is a Cloud SQL database, this field indicates
     *           the network architecture it's associated with.
     *     @type \Google\Cloud\CloudDms\V1\StaticIpConnectivity $static_ip_connectivity
     *           Static ip connectivity data (default, no additional details needed).
     *     @type \Google\Cloud\CloudDms\V1\PrivateServiceConnectConnectivity $private_service_connect_connectivity
     *           Private service connect connectivity.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Clouddms\V1\ClouddmsResources::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The IP or hostname of the source PostgreSQL database.
     *
     * Generated from protobuf field <code>string host = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getHost()
    {
        return $this->host;
    }

    /**
     * Required. The IP or hostname of the source PostgreSQL database.
     *
     * Generated from protobuf field <code>string host = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setHost($var)
    {
        GPBUtil::checkString($var, True);
        $this->host = $var;

        return $this;
    }

    /**
     * Required. The network port of the source PostgreSQL database.
     *
     * Generated from protobuf field <code>int32 port = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return int
     */
    public function getPort()
    {
        return $this->port;
    }

    /**
     * Required. The network port of the source PostgreSQL database.
     *
     * Generated from protobuf field <code>int32 port = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int $var
     * @return $this
     */
    public function setPort($var)
    {
        GPBUtil::checkInt32($var);
        $this->port = $var;

        return $this;
    }

    /**
     * Required. The username that Database Migration Service will use to connect
     * to the database. The value is encrypted when stored in Database Migration
     * Service.
     *
     * Generated from protobuf field <code>string username = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getUsername()
    {
        return $this->username;
    }

    /**
     * Required. The username that Database Migration Service will use to connect
     * to the database. The value is encrypted when stored in Database Migration
     * Service.
     *
     * Generated from protobuf field <code>string username = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setUsername($var)
    {
        GPBUtil::checkString($var, True);
        $this->username = $var;

        return $this;
    }

    /**
     * Required. Input only. The password for the user that Database Migration
     * Service will be using to connect to the database. This field is not
     * returned on request, and the value is encrypted when stored in Database
     * Migration Service.
     *
     * Generated from protobuf field <code>string password = 4 [(.google.api.field_behavior) = INPUT_ONLY, (.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getPassword()
    {
        return $this->password;
    }

    /**
     * Required. Input only. The password for the user that Database Migration
     * Service will be using to connect to the database. This field is not
     * returned on request, and the value is encrypted when stored in Database
     * Migration Service.
     *
     * Generated from protobuf field <code>string password = 4 [(.google.api.field_behavior) = INPUT_ONLY, (.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setPassword($var)
    {
        GPBUtil::checkString($var, True);
        $this->password = $var;

        return $this;
    }

    /**
     * Output only. Indicates If this connection profile password is stored.
     *
     * Generated from protobuf field <code>bool password_set = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return bool
     */
    public function getPasswordSet()
    {
        return $this->password_set;
    }

    /**
     * Output only. Indicates If this connection profile password is stored.
     *
     * Generated from protobuf field <code>bool password_set = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param bool $var
     * @return $this
     */
    public function setPasswordSet($var)
    {
        GPBUtil::checkBool($var);
        $this->password_set = $var;

        return $this;
    }

    /**
     * SSL configuration for the destination to connect to the source database.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.SslConfig ssl = 6;</code>
     * @return \Google\Cloud\CloudDms\V1\SslConfig|null
     */
    public function getSsl()
    {
        return $this->ssl;
    }

    public function hasSsl()
    {
        return isset($this->ssl);
    }

    public function clearSsl()
    {
        unset($this->ssl);
    }

    /**
     * SSL configuration for the destination to connect to the source database.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.SslConfig ssl = 6;</code>
     * @param \Google\Cloud\CloudDms\V1\SslConfig $var
     * @return $this
     */
    public function setSsl($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\CloudDms\V1\SslConfig::class);
        $this->ssl = $var;

        return $this;
    }

    /**
     * If the source is a Cloud SQL database, use this field to
     * provide the Cloud SQL instance ID of the source.
     *
     * Generated from protobuf field <code>string cloud_sql_id = 7;</code>
     * @return string
     */
    public function getCloudSqlId()
    {
        return $this->cloud_sql_id;
    }

    /**
     * If the source is a Cloud SQL database, use this field to
     * provide the Cloud SQL instance ID of the source.
     *
     * Generated from protobuf field <code>string cloud_sql_id = 7;</code>
     * @param string $var
     * @return $this
     */
    public function setCloudSqlId($var)
    {
        GPBUtil::checkString($var, True);
        $this->cloud_sql_id = $var;

        return $this;
    }

    /**
     * Output only. If the source is a Cloud SQL database, this field indicates
     * the network architecture it's associated with.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.NetworkArchitecture network_architecture = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getNetworkArchitecture()
    {
        return $this->network_architecture;
    }

    /**
     * Output only. If the source is a Cloud SQL database, this field indicates
     * the network architecture it's associated with.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.NetworkArchitecture network_architecture = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setNetworkArchitecture($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\CloudDms\V1\NetworkArchitecture::class);
        $this->network_architecture = $var;

        return $this;
    }

    /**
     * Static ip connectivity data (default, no additional details needed).
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.StaticIpConnectivity static_ip_connectivity = 100;</code>
     * @return \Google\Cloud\CloudDms\V1\StaticIpConnectivity|null
     */
    public function getStaticIpConnectivity()
    {
        return $this->readOneof(100);
    }

    public function hasStaticIpConnectivity()
    {
        return $this->hasOneof(100);
    }

    /**
     * Static ip connectivity data (default, no additional details needed).
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.StaticIpConnectivity static_ip_connectivity = 100;</code>
     * @param \Google\Cloud\CloudDms\V1\StaticIpConnectivity $var
     * @return $this
     */
    public function setStaticIpConnectivity($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\CloudDms\V1\StaticIpConnectivity::class);
        $this->writeOneof(100, $var);

        return $this;
    }

    /**
     * Private service connect connectivity.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.PrivateServiceConnectConnectivity private_service_connect_connectivity = 101;</code>
     * @return \Google\Cloud\CloudDms\V1\PrivateServiceConnectConnectivity|null
     */
    public function getPrivateServiceConnectConnectivity()
    {
        return $this->readOneof(101);
    }

    public function hasPrivateServiceConnectConnectivity()
    {
        return $this->hasOneof(101);
    }

    /**
     * Private service connect connectivity.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.PrivateServiceConnectConnectivity private_service_connect_connectivity = 101;</code>
     * @param \Google\Cloud\CloudDms\V1\PrivateServiceConnectConnectivity $var
     * @return $this
     */
    public function setPrivateServiceConnectConnectivity($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\CloudDms\V1\PrivateServiceConnectConnectivity::class);
        $this->writeOneof(101, $var);

        return $this;
    }

    /**
     * @return string
     */
    public function getConnectivity()
    {
        return $this->whichOneof("connectivity");
    }

}

