<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/clouddms/v1/clouddms_resources.proto

namespace Google\Cloud\CloudDms\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The PrivateConnection resource is used to establish private connectivity
 * with the customer's network.
 *
 * Generated from protobuf message <code>google.cloud.clouddms.v1.PrivateConnection</code>
 */
class PrivateConnection extends \Google\Protobuf\Internal\Message
{
    /**
     * The name of the resource.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    protected $name = '';
    /**
     * Output only. The create time of the resource.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. The last update time of the resource.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * The resource labels for private connections to use to annotate any related
     * underlying resources such as Compute Engine VMs. An object containing a
     * list of "key": "value" pairs.
     * Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`.
     *
     * Generated from protobuf field <code>map<string, string> labels = 4;</code>
     */
    private $labels;
    /**
     * The private connection display name.
     *
     * Generated from protobuf field <code>string display_name = 5;</code>
     */
    protected $display_name = '';
    /**
     * Output only. The state of the private connection.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.PrivateConnection.State state = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;
    /**
     * Output only. The error details in case of state FAILED.
     *
     * Generated from protobuf field <code>.google.rpc.Status error = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $error = null;
    protected $connectivity;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           The name of the resource.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. The create time of the resource.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. The last update time of the resource.
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           The resource labels for private connections to use to annotate any related
     *           underlying resources such as Compute Engine VMs. An object containing a
     *           list of "key": "value" pairs.
     *           Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`.
     *     @type string $display_name
     *           The private connection display name.
     *     @type int $state
     *           Output only. The state of the private connection.
     *     @type \Google\Rpc\Status $error
     *           Output only. The error details in case of state FAILED.
     *     @type \Google\Cloud\CloudDms\V1\VpcPeeringConfig $vpc_peering_config
     *           VPC peering configuration.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Clouddms\V1\ClouddmsResources::initOnce();
        parent::__construct($data);
    }

    /**
     * The name of the resource.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * The name of the resource.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. The create time of the resource.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. The create time of the resource.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. The last update time of the resource.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. The last update time of the resource.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * The resource labels for private connections to use to annotate any related
     * underlying resources such as Compute Engine VMs. An object containing a
     * list of "key": "value" pairs.
     * Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`.
     *
     * Generated from protobuf field <code>map<string, string> labels = 4;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * The resource labels for private connections to use to annotate any related
     * underlying resources such as Compute Engine VMs. An object containing a
     * list of "key": "value" pairs.
     * Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`.
     *
     * Generated from protobuf field <code>map<string, string> labels = 4;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * The private connection display name.
     *
     * Generated from protobuf field <code>string display_name = 5;</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * The private connection display name.
     *
     * Generated from protobuf field <code>string display_name = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * Output only. The state of the private connection.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.PrivateConnection.State state = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. The state of the private connection.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.PrivateConnection.State state = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\CloudDms\V1\PrivateConnection\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Output only. The error details in case of state FAILED.
     *
     * Generated from protobuf field <code>.google.rpc.Status error = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Rpc\Status|null
     */
    public function getError()
    {
        return $this->error;
    }

    public function hasError()
    {
        return isset($this->error);
    }

    public function clearError()
    {
        unset($this->error);
    }

    /**
     * Output only. The error details in case of state FAILED.
     *
     * Generated from protobuf field <code>.google.rpc.Status error = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Rpc\Status $var
     * @return $this
     */
    public function setError($var)
    {
        GPBUtil::checkMessage($var, \Google\Rpc\Status::class);
        $this->error = $var;

        return $this;
    }

    /**
     * VPC peering configuration.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.VpcPeeringConfig vpc_peering_config = 100;</code>
     * @return \Google\Cloud\CloudDms\V1\VpcPeeringConfig|null
     */
    public function getVpcPeeringConfig()
    {
        return $this->readOneof(100);
    }

    public function hasVpcPeeringConfig()
    {
        return $this->hasOneof(100);
    }

    /**
     * VPC peering configuration.
     *
     * Generated from protobuf field <code>.google.cloud.clouddms.v1.VpcPeeringConfig vpc_peering_config = 100;</code>
     * @param \Google\Cloud\CloudDms\V1\VpcPeeringConfig $var
     * @return $this
     */
    public function setVpcPeeringConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\CloudDms\V1\VpcPeeringConfig::class);
        $this->writeOneof(100, $var);

        return $this;
    }

    /**
     * @return string
     */
    public function getConnectivity()
    {
        return $this->whichOneof("connectivity");
    }

}

