<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/clouddms/v1/conversionworkspace_resources.proto

namespace Google\Cloud\CloudDms\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Options to configure rule type SingleColumnChange.
 * The rule is used to change the properties of a column.
 * The rule filter field can refer to one entity.
 * The rule scope can be one of: Column.
 * When using this rule, if a field is not specified than the destination
 * column's configuration will be the same as the one in the source column..
 *
 * Generated from protobuf message <code>google.cloud.clouddms.v1.SingleColumnChange</code>
 */
class SingleColumnChange extends \Google\Protobuf\Internal\Message
{
    /**
     * Optional. Column data type name.
     *
     * Generated from protobuf field <code>string data_type = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $data_type = '';
    /**
     * Optional. Charset override - instead of table level charset.
     *
     * Generated from protobuf field <code>string charset = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $charset = '';
    /**
     * Optional. Collation override - instead of table level collation.
     *
     * Generated from protobuf field <code>string collation = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $collation = '';
    /**
     * Optional. Column length - e.g. 50 as in varchar (50) - when relevant.
     *
     * Generated from protobuf field <code>int64 length = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $length = 0;
    /**
     * Optional. Column precision - e.g. 8 as in double (8,2) - when relevant.
     *
     * Generated from protobuf field <code>int32 precision = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $precision = 0;
    /**
     * Optional. Column scale - e.g. 2 as in double (8,2) - when relevant.
     *
     * Generated from protobuf field <code>int32 scale = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $scale = 0;
    /**
     * Optional. Column fractional seconds precision - e.g. 2 as in timestamp (2)
     * - when relevant.
     *
     * Generated from protobuf field <code>int32 fractional_seconds_precision = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $fractional_seconds_precision = 0;
    /**
     * Optional. Is the column of array type.
     *
     * Generated from protobuf field <code>bool array = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $array = false;
    /**
     * Optional. The length of the array, only relevant if the column type is an
     * array.
     *
     * Generated from protobuf field <code>int32 array_length = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $array_length = 0;
    /**
     * Optional. Is the column nullable.
     *
     * Generated from protobuf field <code>bool nullable = 10 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $nullable = false;
    /**
     * Optional. Is the column auto-generated/identity.
     *
     * Generated from protobuf field <code>bool auto_generated = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $auto_generated = false;
    /**
     * Optional. Is the column a UDT (User-defined Type).
     *
     * Generated from protobuf field <code>bool udt = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $udt = false;
    /**
     * Optional. Custom engine specific features.
     *
     * Generated from protobuf field <code>.google.protobuf.Struct custom_features = 13 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $custom_features = null;
    /**
     * Optional. Specifies the list of values allowed in the column.
     *
     * Generated from protobuf field <code>repeated string set_values = 14 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $set_values;
    /**
     * Optional. Comment associated with the column.
     *
     * Generated from protobuf field <code>string comment = 15 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $comment = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $data_type
     *           Optional. Column data type name.
     *     @type string $charset
     *           Optional. Charset override - instead of table level charset.
     *     @type string $collation
     *           Optional. Collation override - instead of table level collation.
     *     @type int|string $length
     *           Optional. Column length - e.g. 50 as in varchar (50) - when relevant.
     *     @type int $precision
     *           Optional. Column precision - e.g. 8 as in double (8,2) - when relevant.
     *     @type int $scale
     *           Optional. Column scale - e.g. 2 as in double (8,2) - when relevant.
     *     @type int $fractional_seconds_precision
     *           Optional. Column fractional seconds precision - e.g. 2 as in timestamp (2)
     *           - when relevant.
     *     @type bool $array
     *           Optional. Is the column of array type.
     *     @type int $array_length
     *           Optional. The length of the array, only relevant if the column type is an
     *           array.
     *     @type bool $nullable
     *           Optional. Is the column nullable.
     *     @type bool $auto_generated
     *           Optional. Is the column auto-generated/identity.
     *     @type bool $udt
     *           Optional. Is the column a UDT (User-defined Type).
     *     @type \Google\Protobuf\Struct $custom_features
     *           Optional. Custom engine specific features.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $set_values
     *           Optional. Specifies the list of values allowed in the column.
     *     @type string $comment
     *           Optional. Comment associated with the column.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Clouddms\V1\ConversionworkspaceResources::initOnce();
        parent::__construct($data);
    }

    /**
     * Optional. Column data type name.
     *
     * Generated from protobuf field <code>string data_type = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDataType()
    {
        return $this->data_type;
    }

    /**
     * Optional. Column data type name.
     *
     * Generated from protobuf field <code>string data_type = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDataType($var)
    {
        GPBUtil::checkString($var, True);
        $this->data_type = $var;

        return $this;
    }

    /**
     * Optional. Charset override - instead of table level charset.
     *
     * Generated from protobuf field <code>string charset = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getCharset()
    {
        return $this->charset;
    }

    /**
     * Optional. Charset override - instead of table level charset.
     *
     * Generated from protobuf field <code>string charset = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setCharset($var)
    {
        GPBUtil::checkString($var, True);
        $this->charset = $var;

        return $this;
    }

    /**
     * Optional. Collation override - instead of table level collation.
     *
     * Generated from protobuf field <code>string collation = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getCollation()
    {
        return $this->collation;
    }

    /**
     * Optional. Collation override - instead of table level collation.
     *
     * Generated from protobuf field <code>string collation = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setCollation($var)
    {
        GPBUtil::checkString($var, True);
        $this->collation = $var;

        return $this;
    }

    /**
     * Optional. Column length - e.g. 50 as in varchar (50) - when relevant.
     *
     * Generated from protobuf field <code>int64 length = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int|string
     */
    public function getLength()
    {
        return $this->length;
    }

    /**
     * Optional. Column length - e.g. 50 as in varchar (50) - when relevant.
     *
     * Generated from protobuf field <code>int64 length = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int|string $var
     * @return $this
     */
    public function setLength($var)
    {
        GPBUtil::checkInt64($var);
        $this->length = $var;

        return $this;
    }

    /**
     * Optional. Column precision - e.g. 8 as in double (8,2) - when relevant.
     *
     * Generated from protobuf field <code>int32 precision = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPrecision()
    {
        return $this->precision;
    }

    /**
     * Optional. Column precision - e.g. 8 as in double (8,2) - when relevant.
     *
     * Generated from protobuf field <code>int32 precision = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPrecision($var)
    {
        GPBUtil::checkInt32($var);
        $this->precision = $var;

        return $this;
    }

    /**
     * Optional. Column scale - e.g. 2 as in double (8,2) - when relevant.
     *
     * Generated from protobuf field <code>int32 scale = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getScale()
    {
        return $this->scale;
    }

    /**
     * Optional. Column scale - e.g. 2 as in double (8,2) - when relevant.
     *
     * Generated from protobuf field <code>int32 scale = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setScale($var)
    {
        GPBUtil::checkInt32($var);
        $this->scale = $var;

        return $this;
    }

    /**
     * Optional. Column fractional seconds precision - e.g. 2 as in timestamp (2)
     * - when relevant.
     *
     * Generated from protobuf field <code>int32 fractional_seconds_precision = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getFractionalSecondsPrecision()
    {
        return $this->fractional_seconds_precision;
    }

    /**
     * Optional. Column fractional seconds precision - e.g. 2 as in timestamp (2)
     * - when relevant.
     *
     * Generated from protobuf field <code>int32 fractional_seconds_precision = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setFractionalSecondsPrecision($var)
    {
        GPBUtil::checkInt32($var);
        $this->fractional_seconds_precision = $var;

        return $this;
    }

    /**
     * Optional. Is the column of array type.
     *
     * Generated from protobuf field <code>bool array = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getArray()
    {
        return $this->array;
    }

    /**
     * Optional. Is the column of array type.
     *
     * Generated from protobuf field <code>bool array = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setArray($var)
    {
        GPBUtil::checkBool($var);
        $this->array = $var;

        return $this;
    }

    /**
     * Optional. The length of the array, only relevant if the column type is an
     * array.
     *
     * Generated from protobuf field <code>int32 array_length = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getArrayLength()
    {
        return $this->array_length;
    }

    /**
     * Optional. The length of the array, only relevant if the column type is an
     * array.
     *
     * Generated from protobuf field <code>int32 array_length = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setArrayLength($var)
    {
        GPBUtil::checkInt32($var);
        $this->array_length = $var;

        return $this;
    }

    /**
     * Optional. Is the column nullable.
     *
     * Generated from protobuf field <code>bool nullable = 10 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getNullable()
    {
        return $this->nullable;
    }

    /**
     * Optional. Is the column nullable.
     *
     * Generated from protobuf field <code>bool nullable = 10 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setNullable($var)
    {
        GPBUtil::checkBool($var);
        $this->nullable = $var;

        return $this;
    }

    /**
     * Optional. Is the column auto-generated/identity.
     *
     * Generated from protobuf field <code>bool auto_generated = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getAutoGenerated()
    {
        return $this->auto_generated;
    }

    /**
     * Optional. Is the column auto-generated/identity.
     *
     * Generated from protobuf field <code>bool auto_generated = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setAutoGenerated($var)
    {
        GPBUtil::checkBool($var);
        $this->auto_generated = $var;

        return $this;
    }

    /**
     * Optional. Is the column a UDT (User-defined Type).
     *
     * Generated from protobuf field <code>bool udt = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getUdt()
    {
        return $this->udt;
    }

    /**
     * Optional. Is the column a UDT (User-defined Type).
     *
     * Generated from protobuf field <code>bool udt = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setUdt($var)
    {
        GPBUtil::checkBool($var);
        $this->udt = $var;

        return $this;
    }

    /**
     * Optional. Custom engine specific features.
     *
     * Generated from protobuf field <code>.google.protobuf.Struct custom_features = 13 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Struct|null
     */
    public function getCustomFeatures()
    {
        return $this->custom_features;
    }

    public function hasCustomFeatures()
    {
        return isset($this->custom_features);
    }

    public function clearCustomFeatures()
    {
        unset($this->custom_features);
    }

    /**
     * Optional. Custom engine specific features.
     *
     * Generated from protobuf field <code>.google.protobuf.Struct custom_features = 13 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Protobuf\Struct $var
     * @return $this
     */
    public function setCustomFeatures($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Struct::class);
        $this->custom_features = $var;

        return $this;
    }

    /**
     * Optional. Specifies the list of values allowed in the column.
     *
     * Generated from protobuf field <code>repeated string set_values = 14 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSetValues()
    {
        return $this->set_values;
    }

    /**
     * Optional. Specifies the list of values allowed in the column.
     *
     * Generated from protobuf field <code>repeated string set_values = 14 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSetValues($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->set_values = $arr;

        return $this;
    }

    /**
     * Optional. Comment associated with the column.
     *
     * Generated from protobuf field <code>string comment = 15 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getComment()
    {
        return $this->comment;
    }

    /**
     * Optional. Comment associated with the column.
     *
     * Generated from protobuf field <code>string comment = 15 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setComment($var)
    {
        GPBUtil::checkString($var, True);
        $this->comment = $var;

        return $this;
    }

}

