<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/documentai/v1/document.proto

namespace Google\Cloud\DocumentAI\V1\Document\DocumentLayout;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents a block. A block could be one of the various types (text,
 * table, list) supported.
 *
 * Generated from protobuf message <code>google.cloud.documentai.v1.Document.DocumentLayout.DocumentLayoutBlock</code>
 */
class DocumentLayoutBlock extends \Google\Protobuf\Internal\Message
{
    /**
     * ID of the block.
     *
     * Generated from protobuf field <code>string block_id = 1;</code>
     */
    protected $block_id = '';
    /**
     * Page span of the block.
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.Document.DocumentLayout.DocumentLayoutBlock.LayoutPageSpan page_span = 5;</code>
     */
    protected $page_span = null;
    protected $block;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\DocumentAI\V1\Document\DocumentLayout\DocumentLayoutBlock\LayoutTextBlock $text_block
     *           Block consisting of text content.
     *     @type \Google\Cloud\DocumentAI\V1\Document\DocumentLayout\DocumentLayoutBlock\LayoutTableBlock $table_block
     *           Block consisting of table content/structure.
     *     @type \Google\Cloud\DocumentAI\V1\Document\DocumentLayout\DocumentLayoutBlock\LayoutListBlock $list_block
     *           Block consisting of list content/structure.
     *     @type string $block_id
     *           ID of the block.
     *     @type \Google\Cloud\DocumentAI\V1\Document\DocumentLayout\DocumentLayoutBlock\LayoutPageSpan $page_span
     *           Page span of the block.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Documentai\V1\Document::initOnce();
        parent::__construct($data);
    }

    /**
     * Block consisting of text content.
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.Document.DocumentLayout.DocumentLayoutBlock.LayoutTextBlock text_block = 2;</code>
     * @return \Google\Cloud\DocumentAI\V1\Document\DocumentLayout\DocumentLayoutBlock\LayoutTextBlock|null
     */
    public function getTextBlock()
    {
        return $this->readOneof(2);
    }

    public function hasTextBlock()
    {
        return $this->hasOneof(2);
    }

    /**
     * Block consisting of text content.
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.Document.DocumentLayout.DocumentLayoutBlock.LayoutTextBlock text_block = 2;</code>
     * @param \Google\Cloud\DocumentAI\V1\Document\DocumentLayout\DocumentLayoutBlock\LayoutTextBlock $var
     * @return $this
     */
    public function setTextBlock($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DocumentAI\V1\Document\DocumentLayout\DocumentLayoutBlock\LayoutTextBlock::class);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     * Block consisting of table content/structure.
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.Document.DocumentLayout.DocumentLayoutBlock.LayoutTableBlock table_block = 3;</code>
     * @return \Google\Cloud\DocumentAI\V1\Document\DocumentLayout\DocumentLayoutBlock\LayoutTableBlock|null
     */
    public function getTableBlock()
    {
        return $this->readOneof(3);
    }

    public function hasTableBlock()
    {
        return $this->hasOneof(3);
    }

    /**
     * Block consisting of table content/structure.
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.Document.DocumentLayout.DocumentLayoutBlock.LayoutTableBlock table_block = 3;</code>
     * @param \Google\Cloud\DocumentAI\V1\Document\DocumentLayout\DocumentLayoutBlock\LayoutTableBlock $var
     * @return $this
     */
    public function setTableBlock($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DocumentAI\V1\Document\DocumentLayout\DocumentLayoutBlock\LayoutTableBlock::class);
        $this->writeOneof(3, $var);

        return $this;
    }

    /**
     * Block consisting of list content/structure.
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.Document.DocumentLayout.DocumentLayoutBlock.LayoutListBlock list_block = 4;</code>
     * @return \Google\Cloud\DocumentAI\V1\Document\DocumentLayout\DocumentLayoutBlock\LayoutListBlock|null
     */
    public function getListBlock()
    {
        return $this->readOneof(4);
    }

    public function hasListBlock()
    {
        return $this->hasOneof(4);
    }

    /**
     * Block consisting of list content/structure.
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.Document.DocumentLayout.DocumentLayoutBlock.LayoutListBlock list_block = 4;</code>
     * @param \Google\Cloud\DocumentAI\V1\Document\DocumentLayout\DocumentLayoutBlock\LayoutListBlock $var
     * @return $this
     */
    public function setListBlock($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DocumentAI\V1\Document\DocumentLayout\DocumentLayoutBlock\LayoutListBlock::class);
        $this->writeOneof(4, $var);

        return $this;
    }

    /**
     * ID of the block.
     *
     * Generated from protobuf field <code>string block_id = 1;</code>
     * @return string
     */
    public function getBlockId()
    {
        return $this->block_id;
    }

    /**
     * ID of the block.
     *
     * Generated from protobuf field <code>string block_id = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setBlockId($var)
    {
        GPBUtil::checkString($var, True);
        $this->block_id = $var;

        return $this;
    }

    /**
     * Page span of the block.
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.Document.DocumentLayout.DocumentLayoutBlock.LayoutPageSpan page_span = 5;</code>
     * @return \Google\Cloud\DocumentAI\V1\Document\DocumentLayout\DocumentLayoutBlock\LayoutPageSpan|null
     */
    public function getPageSpan()
    {
        return $this->page_span;
    }

    public function hasPageSpan()
    {
        return isset($this->page_span);
    }

    public function clearPageSpan()
    {
        unset($this->page_span);
    }

    /**
     * Page span of the block.
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.Document.DocumentLayout.DocumentLayoutBlock.LayoutPageSpan page_span = 5;</code>
     * @param \Google\Cloud\DocumentAI\V1\Document\DocumentLayout\DocumentLayoutBlock\LayoutPageSpan $var
     * @return $this
     */
    public function setPageSpan($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DocumentAI\V1\Document\DocumentLayout\DocumentLayoutBlock\LayoutPageSpan::class);
        $this->page_span = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getBlock()
    {
        return $this->whichOneof("block");
    }

}


