<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/documentai/v1/document_processor_service.proto

namespace Google\Cloud\DocumentAI\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Retrieves a list of evaluations for a given
 * [ProcessorVersion][google.cloud.documentai.v1.ProcessorVersion].
 *
 * Generated from protobuf message <code>google.cloud.documentai.v1.ListEvaluationsRequest</code>
 */
class ListEvaluationsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the
     * [ProcessorVersion][google.cloud.documentai.v1.ProcessorVersion] to list
     * evaluations for.
     * `projects/{project}/locations/{location}/processors/{processor}/processorVersions/{processorVersion}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * The standard list page size.
     * If unspecified, at most `5` evaluations are returned.
     * The maximum value is `100`. Values above `100` are coerced to `100`.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     */
    protected $page_size = 0;
    /**
     * A page token, received from a previous `ListEvaluations` call.
     * Provide this to retrieve the subsequent page.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     */
    protected $page_token = '';

    /**
     * @param string $parent Required. The resource name of the
     *                       [ProcessorVersion][google.cloud.documentai.v1.ProcessorVersion] to list
     *                       evaluations for.
     *                       `projects/{project}/locations/{location}/processors/{processor}/processorVersions/{processorVersion}`
     *                       Please see {@see DocumentProcessorServiceClient::processorVersionName()} for help formatting this field.
     *
     * @return \Google\Cloud\DocumentAI\V1\ListEvaluationsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The resource name of the
     *           [ProcessorVersion][google.cloud.documentai.v1.ProcessorVersion] to list
     *           evaluations for.
     *           `projects/{project}/locations/{location}/processors/{processor}/processorVersions/{processorVersion}`
     *     @type int $page_size
     *           The standard list page size.
     *           If unspecified, at most `5` evaluations are returned.
     *           The maximum value is `100`. Values above `100` are coerced to `100`.
     *     @type string $page_token
     *           A page token, received from a previous `ListEvaluations` call.
     *           Provide this to retrieve the subsequent page.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Documentai\V1\DocumentProcessorService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the
     * [ProcessorVersion][google.cloud.documentai.v1.ProcessorVersion] to list
     * evaluations for.
     * `projects/{project}/locations/{location}/processors/{processor}/processorVersions/{processorVersion}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The resource name of the
     * [ProcessorVersion][google.cloud.documentai.v1.ProcessorVersion] to list
     * evaluations for.
     * `projects/{project}/locations/{location}/processors/{processor}/processorVersions/{processorVersion}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * The standard list page size.
     * If unspecified, at most `5` evaluations are returned.
     * The maximum value is `100`. Values above `100` are coerced to `100`.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The standard list page size.
     * If unspecified, at most `5` evaluations are returned.
     * The maximum value is `100`. Values above `100` are coerced to `100`.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * A page token, received from a previous `ListEvaluations` call.
     * Provide this to retrieve the subsequent page.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * A page token, received from a previous `ListEvaluations` call.
     * Provide this to retrieve the subsequent page.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

