<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/documentai/v1/document_processor_service.proto

namespace Google\Cloud\DocumentAI\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for the
 * [TrainProcessorVersion][google.cloud.documentai.v1.DocumentProcessorService.TrainProcessorVersion]
 * method.
 *
 * Generated from protobuf message <code>google.cloud.documentai.v1.TrainProcessorVersionRequest</code>
 */
class TrainProcessorVersionRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent (project, location and processor) to create the new
     * version for. Format:
     * `projects/{project}/locations/{location}/processors/{processor}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The processor version to be created.
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.ProcessorVersion processor_version = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $processor_version = null;
    /**
     * Optional. The schema the processor version will be trained with.
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.DocumentSchema document_schema = 10 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $document_schema = null;
    /**
     * Optional. The input data used to train the
     * [ProcessorVersion][google.cloud.documentai.v1.ProcessorVersion].
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.TrainProcessorVersionRequest.InputData input_data = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $input_data = null;
    /**
     * Optional. The processor version to use as a base for training. This
     * processor version must be a child of `parent`. Format:
     * `projects/{project}/locations/{location}/processors/{processor}/processorVersions/{processorVersion}`.
     *
     * Generated from protobuf field <code>string base_processor_version = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $base_processor_version = '';
    protected $processor_flags;

    /**
     * @param string                                       $parent           Required. The parent (project, location and processor) to create the new
     *                                                                       version for. Format:
     *                                                                       `projects/{project}/locations/{location}/processors/{processor}`. Please see
     *                                                                       {@see DocumentProcessorServiceClient::processorName()} for help formatting this field.
     * @param \Google\Cloud\DocumentAI\V1\ProcessorVersion $processorVersion Required. The processor version to be created.
     *
     * @return \Google\Cloud\DocumentAI\V1\TrainProcessorVersionRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\DocumentAI\V1\ProcessorVersion $processorVersion): self
    {
        return (new self())
            ->setParent($parent)
            ->setProcessorVersion($processorVersion);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\DocumentAI\V1\TrainProcessorVersionRequest\CustomDocumentExtractionOptions $custom_document_extraction_options
     *           Options to control Custom Document Extraction (CDE) Processor.
     *     @type \Google\Cloud\DocumentAI\V1\TrainProcessorVersionRequest\FoundationModelTuningOptions $foundation_model_tuning_options
     *           Options to control foundation model tuning of a processor.
     *     @type string $parent
     *           Required. The parent (project, location and processor) to create the new
     *           version for. Format:
     *           `projects/{project}/locations/{location}/processors/{processor}`.
     *     @type \Google\Cloud\DocumentAI\V1\ProcessorVersion $processor_version
     *           Required. The processor version to be created.
     *     @type \Google\Cloud\DocumentAI\V1\DocumentSchema $document_schema
     *           Optional. The schema the processor version will be trained with.
     *     @type \Google\Cloud\DocumentAI\V1\TrainProcessorVersionRequest\InputData $input_data
     *           Optional. The input data used to train the
     *           [ProcessorVersion][google.cloud.documentai.v1.ProcessorVersion].
     *     @type string $base_processor_version
     *           Optional. The processor version to use as a base for training. This
     *           processor version must be a child of `parent`. Format:
     *           `projects/{project}/locations/{location}/processors/{processor}/processorVersions/{processorVersion}`.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Documentai\V1\DocumentProcessorService::initOnce();
        parent::__construct($data);
    }

    /**
     * Options to control Custom Document Extraction (CDE) Processor.
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.TrainProcessorVersionRequest.CustomDocumentExtractionOptions custom_document_extraction_options = 5;</code>
     * @return \Google\Cloud\DocumentAI\V1\TrainProcessorVersionRequest\CustomDocumentExtractionOptions|null
     */
    public function getCustomDocumentExtractionOptions()
    {
        return $this->readOneof(5);
    }

    public function hasCustomDocumentExtractionOptions()
    {
        return $this->hasOneof(5);
    }

    /**
     * Options to control Custom Document Extraction (CDE) Processor.
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.TrainProcessorVersionRequest.CustomDocumentExtractionOptions custom_document_extraction_options = 5;</code>
     * @param \Google\Cloud\DocumentAI\V1\TrainProcessorVersionRequest\CustomDocumentExtractionOptions $var
     * @return $this
     */
    public function setCustomDocumentExtractionOptions($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DocumentAI\V1\TrainProcessorVersionRequest\CustomDocumentExtractionOptions::class);
        $this->writeOneof(5, $var);

        return $this;
    }

    /**
     * Options to control foundation model tuning of a processor.
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.TrainProcessorVersionRequest.FoundationModelTuningOptions foundation_model_tuning_options = 12;</code>
     * @return \Google\Cloud\DocumentAI\V1\TrainProcessorVersionRequest\FoundationModelTuningOptions|null
     */
    public function getFoundationModelTuningOptions()
    {
        return $this->readOneof(12);
    }

    public function hasFoundationModelTuningOptions()
    {
        return $this->hasOneof(12);
    }

    /**
     * Options to control foundation model tuning of a processor.
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.TrainProcessorVersionRequest.FoundationModelTuningOptions foundation_model_tuning_options = 12;</code>
     * @param \Google\Cloud\DocumentAI\V1\TrainProcessorVersionRequest\FoundationModelTuningOptions $var
     * @return $this
     */
    public function setFoundationModelTuningOptions($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DocumentAI\V1\TrainProcessorVersionRequest\FoundationModelTuningOptions::class);
        $this->writeOneof(12, $var);

        return $this;
    }

    /**
     * Required. The parent (project, location and processor) to create the new
     * version for. Format:
     * `projects/{project}/locations/{location}/processors/{processor}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent (project, location and processor) to create the new
     * version for. Format:
     * `projects/{project}/locations/{location}/processors/{processor}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The processor version to be created.
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.ProcessorVersion processor_version = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\DocumentAI\V1\ProcessorVersion|null
     */
    public function getProcessorVersion()
    {
        return $this->processor_version;
    }

    public function hasProcessorVersion()
    {
        return isset($this->processor_version);
    }

    public function clearProcessorVersion()
    {
        unset($this->processor_version);
    }

    /**
     * Required. The processor version to be created.
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.ProcessorVersion processor_version = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\DocumentAI\V1\ProcessorVersion $var
     * @return $this
     */
    public function setProcessorVersion($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DocumentAI\V1\ProcessorVersion::class);
        $this->processor_version = $var;

        return $this;
    }

    /**
     * Optional. The schema the processor version will be trained with.
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.DocumentSchema document_schema = 10 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\DocumentAI\V1\DocumentSchema|null
     */
    public function getDocumentSchema()
    {
        return $this->document_schema;
    }

    public function hasDocumentSchema()
    {
        return isset($this->document_schema);
    }

    public function clearDocumentSchema()
    {
        unset($this->document_schema);
    }

    /**
     * Optional. The schema the processor version will be trained with.
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.DocumentSchema document_schema = 10 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\DocumentAI\V1\DocumentSchema $var
     * @return $this
     */
    public function setDocumentSchema($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DocumentAI\V1\DocumentSchema::class);
        $this->document_schema = $var;

        return $this;
    }

    /**
     * Optional. The input data used to train the
     * [ProcessorVersion][google.cloud.documentai.v1.ProcessorVersion].
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.TrainProcessorVersionRequest.InputData input_data = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\DocumentAI\V1\TrainProcessorVersionRequest\InputData|null
     */
    public function getInputData()
    {
        return $this->input_data;
    }

    public function hasInputData()
    {
        return isset($this->input_data);
    }

    public function clearInputData()
    {
        unset($this->input_data);
    }

    /**
     * Optional. The input data used to train the
     * [ProcessorVersion][google.cloud.documentai.v1.ProcessorVersion].
     *
     * Generated from protobuf field <code>.google.cloud.documentai.v1.TrainProcessorVersionRequest.InputData input_data = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\DocumentAI\V1\TrainProcessorVersionRequest\InputData $var
     * @return $this
     */
    public function setInputData($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\DocumentAI\V1\TrainProcessorVersionRequest\InputData::class);
        $this->input_data = $var;

        return $this;
    }

    /**
     * Optional. The processor version to use as a base for training. This
     * processor version must be a child of `parent`. Format:
     * `projects/{project}/locations/{location}/processors/{processor}/processorVersions/{processorVersion}`.
     *
     * Generated from protobuf field <code>string base_processor_version = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getBaseProcessorVersion()
    {
        return $this->base_processor_version;
    }

    /**
     * Optional. The processor version to use as a base for training. This
     * processor version must be a child of `parent`. Format:
     * `projects/{project}/locations/{location}/processors/{processor}/processorVersions/{processorVersion}`.
     *
     * Generated from protobuf field <code>string base_processor_version = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setBaseProcessorVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->base_processor_version = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getProcessorFlags()
    {
        return $this->whichOneof("processor_flags");
    }

}

