<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/edgenetwork/v1/resources.proto

namespace Google\Cloud\EdgeNetwork\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message describing Interconnect object
 *
 * Generated from protobuf message <code>google.cloud.edgenetwork.v1.Interconnect</code>
 */
class Interconnect extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The canonical resource name of the interconnect.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $name = '';
    /**
     * Output only. The time when the subnet was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. The time when the subnet was last updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Labels associated with this resource.
     *
     * Generated from protobuf field <code>map<string, string> labels = 4;</code>
     */
    private $labels;
    /**
     * Optional. A free-text description of the resource. Max length 1024
     * characters.
     *
     * Generated from protobuf field <code>string description = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $description = '';
    /**
     * Optional. Type of interconnect, which takes only the value 'DEDICATED' for
     * now.
     *
     * Generated from protobuf field <code>.google.cloud.edgenetwork.v1.Interconnect.InterconnectType interconnect_type = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $interconnect_type = 0;
    /**
     * Output only. Unique identifier for the link.
     *
     * Generated from protobuf field <code>string uuid = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $uuid = '';
    /**
     * Output only. Cloud resource name of the switch device.
     *
     * Generated from protobuf field <code>string device_cloud_resource_name = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $device_cloud_resource_name = '';
    /**
     * Output only. Physical ports (e.g., TenGigE0/0/0/1) that form the
     * interconnect.
     *
     * Generated from protobuf field <code>repeated string physical_ports = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $physical_ports;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. The canonical resource name of the interconnect.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. The time when the subnet was created.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. The time when the subnet was last updated.
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Labels associated with this resource.
     *     @type string $description
     *           Optional. A free-text description of the resource. Max length 1024
     *           characters.
     *     @type int $interconnect_type
     *           Optional. Type of interconnect, which takes only the value 'DEDICATED' for
     *           now.
     *     @type string $uuid
     *           Output only. Unique identifier for the link.
     *     @type string $device_cloud_resource_name
     *           Output only. Cloud resource name of the switch device.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $physical_ports
     *           Output only. Physical ports (e.g., TenGigE0/0/0/1) that form the
     *           interconnect.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Edgenetwork\V1\Resources::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The canonical resource name of the interconnect.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. The canonical resource name of the interconnect.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. The time when the subnet was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. The time when the subnet was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. The time when the subnet was last updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. The time when the subnet was last updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Labels associated with this resource.
     *
     * Generated from protobuf field <code>map<string, string> labels = 4;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Labels associated with this resource.
     *
     * Generated from protobuf field <code>map<string, string> labels = 4;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * Optional. A free-text description of the resource. Max length 1024
     * characters.
     *
     * Generated from protobuf field <code>string description = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Optional. A free-text description of the resource. Max length 1024
     * characters.
     *
     * Generated from protobuf field <code>string description = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Optional. Type of interconnect, which takes only the value 'DEDICATED' for
     * now.
     *
     * Generated from protobuf field <code>.google.cloud.edgenetwork.v1.Interconnect.InterconnectType interconnect_type = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getInterconnectType()
    {
        return $this->interconnect_type;
    }

    /**
     * Optional. Type of interconnect, which takes only the value 'DEDICATED' for
     * now.
     *
     * Generated from protobuf field <code>.google.cloud.edgenetwork.v1.Interconnect.InterconnectType interconnect_type = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setInterconnectType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\EdgeNetwork\V1\Interconnect\InterconnectType::class);
        $this->interconnect_type = $var;

        return $this;
    }

    /**
     * Output only. Unique identifier for the link.
     *
     * Generated from protobuf field <code>string uuid = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getUuid()
    {
        return $this->uuid;
    }

    /**
     * Output only. Unique identifier for the link.
     *
     * Generated from protobuf field <code>string uuid = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setUuid($var)
    {
        GPBUtil::checkString($var, True);
        $this->uuid = $var;

        return $this;
    }

    /**
     * Output only. Cloud resource name of the switch device.
     *
     * Generated from protobuf field <code>string device_cloud_resource_name = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getDeviceCloudResourceName()
    {
        return $this->device_cloud_resource_name;
    }

    /**
     * Output only. Cloud resource name of the switch device.
     *
     * Generated from protobuf field <code>string device_cloud_resource_name = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setDeviceCloudResourceName($var)
    {
        GPBUtil::checkString($var, True);
        $this->device_cloud_resource_name = $var;

        return $this;
    }

    /**
     * Output only. Physical ports (e.g., TenGigE0/0/0/1) that form the
     * interconnect.
     *
     * Generated from protobuf field <code>repeated string physical_ports = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getPhysicalPorts()
    {
        return $this->physical_ports;
    }

    /**
     * Output only. Physical ports (e.g., TenGigE0/0/0/1) that form the
     * interconnect.
     *
     * Generated from protobuf field <code>repeated string physical_ports = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setPhysicalPorts($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->physical_ports = $arr;

        return $this;
    }

}

