<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/edgenetwork/v1/resources.proto

namespace Google\Cloud\EdgeNetwork\V1\Router;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * BGPPeer defines the peer side layer-3 information for building the BGP
 * session.
 *
 * Generated from protobuf message <code>google.cloud.edgenetwork.v1.Router.BgpPeer</code>
 */
class BgpPeer extends \Google\Protobuf\Internal\Message
{
    /**
     * Name of this BGP peer. Unique within the Zones resource.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    protected $name = '';
    /**
     * Name of the RouterInterface the BGP peer is associated with.
     *
     * Generated from protobuf field <code>string interface = 2;</code>
     */
    protected $interface = '';
    /**
     * IP range of the interface within Google.
     *
     * Generated from protobuf field <code>string interface_ipv4_cidr = 3;</code>
     */
    protected $interface_ipv4_cidr = '';
    /**
     * IPv6 range of the interface within Google.
     *
     * Generated from protobuf field <code>string interface_ipv6_cidr = 7;</code>
     */
    protected $interface_ipv6_cidr = '';
    /**
     * IP range of the BGP interface outside Google.
     *
     * Generated from protobuf field <code>string peer_ipv4_cidr = 4;</code>
     */
    protected $peer_ipv4_cidr = '';
    /**
     * IPv6 range of the BGP interface outside Google.
     *
     * Generated from protobuf field <code>string peer_ipv6_cidr = 6;</code>
     */
    protected $peer_ipv6_cidr = '';
    /**
     * Peer BGP Autonomous System Number (ASN). Each BGP interface may use
     * a different value.
     *
     * Generated from protobuf field <code>uint32 peer_asn = 5;</code>
     */
    protected $peer_asn = 0;
    /**
     * Output only. Local BGP Autonomous System Number (ASN).
     * This field is ST_NOT_REQUIRED because it stores private ASNs, which are
     * meaningless outside the zone in which they are being used.
     *
     * Generated from protobuf field <code>uint32 local_asn = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $local_asn = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Name of this BGP peer. Unique within the Zones resource.
     *     @type string $interface
     *           Name of the RouterInterface the BGP peer is associated with.
     *     @type string $interface_ipv4_cidr
     *           IP range of the interface within Google.
     *     @type string $interface_ipv6_cidr
     *           IPv6 range of the interface within Google.
     *     @type string $peer_ipv4_cidr
     *           IP range of the BGP interface outside Google.
     *     @type string $peer_ipv6_cidr
     *           IPv6 range of the BGP interface outside Google.
     *     @type int $peer_asn
     *           Peer BGP Autonomous System Number (ASN). Each BGP interface may use
     *           a different value.
     *     @type int $local_asn
     *           Output only. Local BGP Autonomous System Number (ASN).
     *           This field is ST_NOT_REQUIRED because it stores private ASNs, which are
     *           meaningless outside the zone in which they are being used.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Edgenetwork\V1\Resources::initOnce();
        parent::__construct($data);
    }

    /**
     * Name of this BGP peer. Unique within the Zones resource.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Name of this BGP peer. Unique within the Zones resource.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Name of the RouterInterface the BGP peer is associated with.
     *
     * Generated from protobuf field <code>string interface = 2;</code>
     * @return string
     */
    public function getInterface()
    {
        return $this->interface;
    }

    /**
     * Name of the RouterInterface the BGP peer is associated with.
     *
     * Generated from protobuf field <code>string interface = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setInterface($var)
    {
        GPBUtil::checkString($var, True);
        $this->interface = $var;

        return $this;
    }

    /**
     * IP range of the interface within Google.
     *
     * Generated from protobuf field <code>string interface_ipv4_cidr = 3;</code>
     * @return string
     */
    public function getInterfaceIpv4Cidr()
    {
        return $this->interface_ipv4_cidr;
    }

    /**
     * IP range of the interface within Google.
     *
     * Generated from protobuf field <code>string interface_ipv4_cidr = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setInterfaceIpv4Cidr($var)
    {
        GPBUtil::checkString($var, True);
        $this->interface_ipv4_cidr = $var;

        return $this;
    }

    /**
     * IPv6 range of the interface within Google.
     *
     * Generated from protobuf field <code>string interface_ipv6_cidr = 7;</code>
     * @return string
     */
    public function getInterfaceIpv6Cidr()
    {
        return $this->interface_ipv6_cidr;
    }

    /**
     * IPv6 range of the interface within Google.
     *
     * Generated from protobuf field <code>string interface_ipv6_cidr = 7;</code>
     * @param string $var
     * @return $this
     */
    public function setInterfaceIpv6Cidr($var)
    {
        GPBUtil::checkString($var, True);
        $this->interface_ipv6_cidr = $var;

        return $this;
    }

    /**
     * IP range of the BGP interface outside Google.
     *
     * Generated from protobuf field <code>string peer_ipv4_cidr = 4;</code>
     * @return string
     */
    public function getPeerIpv4Cidr()
    {
        return $this->peer_ipv4_cidr;
    }

    /**
     * IP range of the BGP interface outside Google.
     *
     * Generated from protobuf field <code>string peer_ipv4_cidr = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setPeerIpv4Cidr($var)
    {
        GPBUtil::checkString($var, True);
        $this->peer_ipv4_cidr = $var;

        return $this;
    }

    /**
     * IPv6 range of the BGP interface outside Google.
     *
     * Generated from protobuf field <code>string peer_ipv6_cidr = 6;</code>
     * @return string
     */
    public function getPeerIpv6Cidr()
    {
        return $this->peer_ipv6_cidr;
    }

    /**
     * IPv6 range of the BGP interface outside Google.
     *
     * Generated from protobuf field <code>string peer_ipv6_cidr = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setPeerIpv6Cidr($var)
    {
        GPBUtil::checkString($var, True);
        $this->peer_ipv6_cidr = $var;

        return $this;
    }

    /**
     * Peer BGP Autonomous System Number (ASN). Each BGP interface may use
     * a different value.
     *
     * Generated from protobuf field <code>uint32 peer_asn = 5;</code>
     * @return int
     */
    public function getPeerAsn()
    {
        return $this->peer_asn;
    }

    /**
     * Peer BGP Autonomous System Number (ASN). Each BGP interface may use
     * a different value.
     *
     * Generated from protobuf field <code>uint32 peer_asn = 5;</code>
     * @param int $var
     * @return $this
     */
    public function setPeerAsn($var)
    {
        GPBUtil::checkUint32($var);
        $this->peer_asn = $var;

        return $this;
    }

    /**
     * Output only. Local BGP Autonomous System Number (ASN).
     * This field is ST_NOT_REQUIRED because it stores private ASNs, which are
     * meaningless outside the zone in which they are being used.
     *
     * Generated from protobuf field <code>uint32 local_asn = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getLocalAsn()
    {
        return $this->local_asn;
    }

    /**
     * Output only. Local BGP Autonomous System Number (ASN).
     * This field is ST_NOT_REQUIRED because it stores private ASNs, which are
     * meaningless outside the zone in which they are being used.
     *
     * Generated from protobuf field <code>uint32 local_asn = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setLocalAsn($var)
    {
        GPBUtil::checkUint32($var);
        $this->local_asn = $var;

        return $this;
    }

}


