<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/edgenetwork/v1/resources.proto

namespace Google\Cloud\EdgeNetwork\V1\RouterStatus;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Status of a BGP peer.
 *
 * Generated from protobuf message <code>google.cloud.edgenetwork.v1.RouterStatus.BgpPeerStatus</code>
 */
class BgpPeerStatus extends \Google\Protobuf\Internal\Message
{
    /**
     * Name of this BGP peer. Unique within the Routers resource.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    protected $name = '';
    /**
     * IP address of the local BGP interface.
     *
     * Generated from protobuf field <code>string ip_address = 2;</code>
     */
    protected $ip_address = '';
    /**
     * IP address of the remote BGP interface.
     *
     * Generated from protobuf field <code>string peer_ip_address = 3;</code>
     */
    protected $peer_ip_address = '';
    /**
     * The current status of BGP.
     *
     * Generated from protobuf field <code>.google.cloud.edgenetwork.v1.RouterStatus.BgpPeerStatus.BgpStatus status = 4;</code>
     */
    protected $status = 0;
    /**
     * BGP state as specified in RFC1771.
     *
     * Generated from protobuf field <code>string state = 5;</code>
     */
    protected $state = '';
    /**
     * Time this session has been up.
     * Format:
     *  14 years, 51 weeks, 6 days, 23 hours, 59 minutes, 59 seconds
     *
     * Generated from protobuf field <code>string uptime = 6;</code>
     */
    protected $uptime = '';
    /**
     * Time this session has been up, in seconds.
     *
     * Generated from protobuf field <code>int64 uptime_seconds = 7;</code>
     */
    protected $uptime_seconds = 0;
    /**
     * A collection of counts for prefixes.
     *
     * Generated from protobuf field <code>.google.cloud.edgenetwork.v1.RouterStatus.PrefixCounter prefix_counter = 8;</code>
     */
    protected $prefix_counter = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Name of this BGP peer. Unique within the Routers resource.
     *     @type string $ip_address
     *           IP address of the local BGP interface.
     *     @type string $peer_ip_address
     *           IP address of the remote BGP interface.
     *     @type int $status
     *           The current status of BGP.
     *     @type string $state
     *           BGP state as specified in RFC1771.
     *     @type string $uptime
     *           Time this session has been up.
     *           Format:
     *            14 years, 51 weeks, 6 days, 23 hours, 59 minutes, 59 seconds
     *     @type int|string $uptime_seconds
     *           Time this session has been up, in seconds.
     *     @type \Google\Cloud\EdgeNetwork\V1\RouterStatus\PrefixCounter $prefix_counter
     *           A collection of counts for prefixes.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Edgenetwork\V1\Resources::initOnce();
        parent::__construct($data);
    }

    /**
     * Name of this BGP peer. Unique within the Routers resource.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Name of this BGP peer. Unique within the Routers resource.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * IP address of the local BGP interface.
     *
     * Generated from protobuf field <code>string ip_address = 2;</code>
     * @return string
     */
    public function getIpAddress()
    {
        return $this->ip_address;
    }

    /**
     * IP address of the local BGP interface.
     *
     * Generated from protobuf field <code>string ip_address = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setIpAddress($var)
    {
        GPBUtil::checkString($var, True);
        $this->ip_address = $var;

        return $this;
    }

    /**
     * IP address of the remote BGP interface.
     *
     * Generated from protobuf field <code>string peer_ip_address = 3;</code>
     * @return string
     */
    public function getPeerIpAddress()
    {
        return $this->peer_ip_address;
    }

    /**
     * IP address of the remote BGP interface.
     *
     * Generated from protobuf field <code>string peer_ip_address = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPeerIpAddress($var)
    {
        GPBUtil::checkString($var, True);
        $this->peer_ip_address = $var;

        return $this;
    }

    /**
     * The current status of BGP.
     *
     * Generated from protobuf field <code>.google.cloud.edgenetwork.v1.RouterStatus.BgpPeerStatus.BgpStatus status = 4;</code>
     * @return int
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * The current status of BGP.
     *
     * Generated from protobuf field <code>.google.cloud.edgenetwork.v1.RouterStatus.BgpPeerStatus.BgpStatus status = 4;</code>
     * @param int $var
     * @return $this
     */
    public function setStatus($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\EdgeNetwork\V1\RouterStatus\BgpPeerStatus\BgpStatus::class);
        $this->status = $var;

        return $this;
    }

    /**
     * BGP state as specified in RFC1771.
     *
     * Generated from protobuf field <code>string state = 5;</code>
     * @return string
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * BGP state as specified in RFC1771.
     *
     * Generated from protobuf field <code>string state = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkString($var, True);
        $this->state = $var;

        return $this;
    }

    /**
     * Time this session has been up.
     * Format:
     *  14 years, 51 weeks, 6 days, 23 hours, 59 minutes, 59 seconds
     *
     * Generated from protobuf field <code>string uptime = 6;</code>
     * @return string
     */
    public function getUptime()
    {
        return $this->uptime;
    }

    /**
     * Time this session has been up.
     * Format:
     *  14 years, 51 weeks, 6 days, 23 hours, 59 minutes, 59 seconds
     *
     * Generated from protobuf field <code>string uptime = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setUptime($var)
    {
        GPBUtil::checkString($var, True);
        $this->uptime = $var;

        return $this;
    }

    /**
     * Time this session has been up, in seconds.
     *
     * Generated from protobuf field <code>int64 uptime_seconds = 7;</code>
     * @return int|string
     */
    public function getUptimeSeconds()
    {
        return $this->uptime_seconds;
    }

    /**
     * Time this session has been up, in seconds.
     *
     * Generated from protobuf field <code>int64 uptime_seconds = 7;</code>
     * @param int|string $var
     * @return $this
     */
    public function setUptimeSeconds($var)
    {
        GPBUtil::checkInt64($var);
        $this->uptime_seconds = $var;

        return $this;
    }

    /**
     * A collection of counts for prefixes.
     *
     * Generated from protobuf field <code>.google.cloud.edgenetwork.v1.RouterStatus.PrefixCounter prefix_counter = 8;</code>
     * @return \Google\Cloud\EdgeNetwork\V1\RouterStatus\PrefixCounter|null
     */
    public function getPrefixCounter()
    {
        return $this->prefix_counter;
    }

    public function hasPrefixCounter()
    {
        return isset($this->prefix_counter);
    }

    public function clearPrefixCounter()
    {
        unset($this->prefix_counter);
    }

    /**
     * A collection of counts for prefixes.
     *
     * Generated from protobuf field <code>.google.cloud.edgenetwork.v1.RouterStatus.PrefixCounter prefix_counter = 8;</code>
     * @param \Google\Cloud\EdgeNetwork\V1\RouterStatus\PrefixCounter $var
     * @return $this
     */
    public function setPrefixCounter($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\EdgeNetwork\V1\RouterStatus\PrefixCounter::class);
        $this->prefix_counter = $var;

        return $this;
    }

}


