<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/eventarc/v1/discovery.proto

namespace Google\Cloud\Eventarc\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A representation of the event type resource.
 *
 * Generated from protobuf message <code>google.cloud.eventarc.v1.EventType</code>
 */
class EventType extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The full name of the event type (for example,
     * "google.cloud.storage.object.v1.finalized"). In the form of
     * {provider-specific-prefix}.{resource}.{version}.{verb}. Types MUST be
     * versioned and event schemas are guaranteed to remain backward compatible
     * within one version. Note that event type versions and API versions do not
     * need to match.
     *
     * Generated from protobuf field <code>string type = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $type = '';
    /**
     * Output only. Human friendly description of what the event type is about.
     * For example "Bucket created in Cloud Storage".
     *
     * Generated from protobuf field <code>string description = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $description = '';
    /**
     * Output only. Filtering attributes for the event type.
     *
     * Generated from protobuf field <code>repeated .google.cloud.eventarc.v1.FilteringAttribute filtering_attributes = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $filtering_attributes;
    /**
     * Output only. URI for the event schema.
     * For example
     * "https://github.com/googleapis/google-cloudevents/blob/master/proto/google/events/cloud/storage/v1/events.proto"
     *
     * Generated from protobuf field <code>string event_schema_uri = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $event_schema_uri = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $type
     *           Output only. The full name of the event type (for example,
     *           "google.cloud.storage.object.v1.finalized"). In the form of
     *           {provider-specific-prefix}.{resource}.{version}.{verb}. Types MUST be
     *           versioned and event schemas are guaranteed to remain backward compatible
     *           within one version. Note that event type versions and API versions do not
     *           need to match.
     *     @type string $description
     *           Output only. Human friendly description of what the event type is about.
     *           For example "Bucket created in Cloud Storage".
     *     @type array<\Google\Cloud\Eventarc\V1\FilteringAttribute>|\Google\Protobuf\Internal\RepeatedField $filtering_attributes
     *           Output only. Filtering attributes for the event type.
     *     @type string $event_schema_uri
     *           Output only. URI for the event schema.
     *           For example
     *           "https://github.com/googleapis/google-cloudevents/blob/master/proto/google/events/cloud/storage/v1/events.proto"
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Eventarc\V1\Discovery::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The full name of the event type (for example,
     * "google.cloud.storage.object.v1.finalized"). In the form of
     * {provider-specific-prefix}.{resource}.{version}.{verb}. Types MUST be
     * versioned and event schemas are guaranteed to remain backward compatible
     * within one version. Note that event type versions and API versions do not
     * need to match.
     *
     * Generated from protobuf field <code>string type = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * Output only. The full name of the event type (for example,
     * "google.cloud.storage.object.v1.finalized"). In the form of
     * {provider-specific-prefix}.{resource}.{version}.{verb}. Types MUST be
     * versioned and event schemas are guaranteed to remain backward compatible
     * within one version. Note that event type versions and API versions do not
     * need to match.
     *
     * Generated from protobuf field <code>string type = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setType($var)
    {
        GPBUtil::checkString($var, True);
        $this->type = $var;

        return $this;
    }

    /**
     * Output only. Human friendly description of what the event type is about.
     * For example "Bucket created in Cloud Storage".
     *
     * Generated from protobuf field <code>string description = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Output only. Human friendly description of what the event type is about.
     * For example "Bucket created in Cloud Storage".
     *
     * Generated from protobuf field <code>string description = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Output only. Filtering attributes for the event type.
     *
     * Generated from protobuf field <code>repeated .google.cloud.eventarc.v1.FilteringAttribute filtering_attributes = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getFilteringAttributes()
    {
        return $this->filtering_attributes;
    }

    /**
     * Output only. Filtering attributes for the event type.
     *
     * Generated from protobuf field <code>repeated .google.cloud.eventarc.v1.FilteringAttribute filtering_attributes = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param array<\Google\Cloud\Eventarc\V1\FilteringAttribute>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setFilteringAttributes($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Eventarc\V1\FilteringAttribute::class);
        $this->filtering_attributes = $arr;

        return $this;
    }

    /**
     * Output only. URI for the event schema.
     * For example
     * "https://github.com/googleapis/google-cloudevents/blob/master/proto/google/events/cloud/storage/v1/events.proto"
     *
     * Generated from protobuf field <code>string event_schema_uri = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getEventSchemaUri()
    {
        return $this->event_schema_uri;
    }

    /**
     * Output only. URI for the event schema.
     * For example
     * "https://github.com/googleapis/google-cloudevents/blob/master/proto/google/events/cloud/storage/v1/events.proto"
     *
     * Generated from protobuf field <code>string event_schema_uri = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setEventSchemaUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->event_schema_uri = $var;

        return $this;
    }

}

