<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/functions/v2/functions.proto

namespace Google\Cloud\Functions\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request of `GenerateSourceUploadUrl` method.
 *
 * Generated from protobuf message <code>google.cloud.functions.v2.GenerateUploadUrlRequest</code>
 */
class GenerateUploadUrlRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The project and location in which the Google Cloud Storage signed
     * URL should be generated, specified in the format `projects/&#42;&#47;locations/&#42;`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * [Preview] Resource name of a KMS crypto key (managed by the user) used to
     * encrypt/decrypt function source code objects in intermediate Cloud Storage
     * buckets. When you generate an upload url and upload your source code, it
     * gets copied to an intermediate Cloud Storage bucket. The source code is
     * then copied to a versioned directory in the sources bucket in the consumer
     * project during the function deployment.
     * It must match the pattern
     * `projects/{project}/locations/{location}/keyRings/{key_ring}/cryptoKeys/{crypto_key}`.
     * The Google Cloud Functions service account
     * (service-{project_number}&#64;gcf-admin-robot.iam.gserviceaccount.com) must be
     * granted the role 'Cloud KMS CryptoKey Encrypter/Decrypter
     * (roles/cloudkms.cryptoKeyEncrypterDecrypter)' on the
     * Key/KeyRing/Project/Organization (least access preferred).
     *
     * Generated from protobuf field <code>string kms_key_name = 2 [(.google.api.resource_reference) = {</code>
     */
    protected $kms_key_name = '';
    /**
     * The function environment the generated upload url will be used for.
     * The upload url for 2nd Gen functions can also be used for 1st gen
     * functions, but not vice versa. If not specified, 2nd generation-style
     * upload URLs are generated.
     *
     * Generated from protobuf field <code>.google.cloud.functions.v2.Environment environment = 3;</code>
     */
    protected $environment = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The project and location in which the Google Cloud Storage signed
     *           URL should be generated, specified in the format `projects/&#42;&#47;locations/&#42;`.
     *     @type string $kms_key_name
     *           [Preview] Resource name of a KMS crypto key (managed by the user) used to
     *           encrypt/decrypt function source code objects in intermediate Cloud Storage
     *           buckets. When you generate an upload url and upload your source code, it
     *           gets copied to an intermediate Cloud Storage bucket. The source code is
     *           then copied to a versioned directory in the sources bucket in the consumer
     *           project during the function deployment.
     *           It must match the pattern
     *           `projects/{project}/locations/{location}/keyRings/{key_ring}/cryptoKeys/{crypto_key}`.
     *           The Google Cloud Functions service account
     *           (service-{project_number}&#64;gcf-admin-robot.iam.gserviceaccount.com) must be
     *           granted the role 'Cloud KMS CryptoKey Encrypter/Decrypter
     *           (roles/cloudkms.cryptoKeyEncrypterDecrypter)' on the
     *           Key/KeyRing/Project/Organization (least access preferred).
     *     @type int $environment
     *           The function environment the generated upload url will be used for.
     *           The upload url for 2nd Gen functions can also be used for 1st gen
     *           functions, but not vice versa. If not specified, 2nd generation-style
     *           upload URLs are generated.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Functions\V2\Functions::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The project and location in which the Google Cloud Storage signed
     * URL should be generated, specified in the format `projects/&#42;&#47;locations/&#42;`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The project and location in which the Google Cloud Storage signed
     * URL should be generated, specified in the format `projects/&#42;&#47;locations/&#42;`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * [Preview] Resource name of a KMS crypto key (managed by the user) used to
     * encrypt/decrypt function source code objects in intermediate Cloud Storage
     * buckets. When you generate an upload url and upload your source code, it
     * gets copied to an intermediate Cloud Storage bucket. The source code is
     * then copied to a versioned directory in the sources bucket in the consumer
     * project during the function deployment.
     * It must match the pattern
     * `projects/{project}/locations/{location}/keyRings/{key_ring}/cryptoKeys/{crypto_key}`.
     * The Google Cloud Functions service account
     * (service-{project_number}&#64;gcf-admin-robot.iam.gserviceaccount.com) must be
     * granted the role 'Cloud KMS CryptoKey Encrypter/Decrypter
     * (roles/cloudkms.cryptoKeyEncrypterDecrypter)' on the
     * Key/KeyRing/Project/Organization (least access preferred).
     *
     * Generated from protobuf field <code>string kms_key_name = 2 [(.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getKmsKeyName()
    {
        return $this->kms_key_name;
    }

    /**
     * [Preview] Resource name of a KMS crypto key (managed by the user) used to
     * encrypt/decrypt function source code objects in intermediate Cloud Storage
     * buckets. When you generate an upload url and upload your source code, it
     * gets copied to an intermediate Cloud Storage bucket. The source code is
     * then copied to a versioned directory in the sources bucket in the consumer
     * project during the function deployment.
     * It must match the pattern
     * `projects/{project}/locations/{location}/keyRings/{key_ring}/cryptoKeys/{crypto_key}`.
     * The Google Cloud Functions service account
     * (service-{project_number}&#64;gcf-admin-robot.iam.gserviceaccount.com) must be
     * granted the role 'Cloud KMS CryptoKey Encrypter/Decrypter
     * (roles/cloudkms.cryptoKeyEncrypterDecrypter)' on the
     * Key/KeyRing/Project/Organization (least access preferred).
     *
     * Generated from protobuf field <code>string kms_key_name = 2 [(.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setKmsKeyName($var)
    {
        GPBUtil::checkString($var, True);
        $this->kms_key_name = $var;

        return $this;
    }

    /**
     * The function environment the generated upload url will be used for.
     * The upload url for 2nd Gen functions can also be used for 1st gen
     * functions, but not vice versa. If not specified, 2nd generation-style
     * upload URLs are generated.
     *
     * Generated from protobuf field <code>.google.cloud.functions.v2.Environment environment = 3;</code>
     * @return int
     */
    public function getEnvironment()
    {
        return $this->environment;
    }

    /**
     * The function environment the generated upload url will be used for.
     * The upload url for 2nd Gen functions can also be used for 1st gen
     * functions, but not vice versa. If not specified, 2nd generation-style
     * upload URLs are generated.
     *
     * Generated from protobuf field <code>.google.cloud.functions.v2.Environment environment = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setEnvironment($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Functions\V2\Environment::class);
        $this->environment = $var;

        return $this;
    }

}

