<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/functions/v2/functions.proto

namespace Google\Cloud\Functions\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request for the `ListFunctions` method.
 *
 * Generated from protobuf message <code>google.cloud.functions.v2.ListFunctionsRequest</code>
 */
class ListFunctionsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The project and location from which the function should be
     * listed, specified in the format `projects/&#42;&#47;locations/&#42;` If you want to
     * list functions in all locations, use "-" in place of a location. When
     * listing functions in all locations, if one or more location(s) are
     * unreachable, the response will contain functions from all reachable
     * locations along with the names of any unreachable locations.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Maximum number of functions to return per call. The largest allowed
     * page_size is 1,000, if the page_size is omitted or specified as greater
     * than 1,000 then it will be replaced as 1,000. The size of the list
     * response can be less than specified when used with filters.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     */
    protected $page_size = 0;
    /**
     * The value returned by the last
     * `ListFunctionsResponse`; indicates that
     * this is a continuation of a prior `ListFunctions` call, and that the
     * system should return the next page of data.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     */
    protected $page_token = '';
    /**
     * The filter for Functions that match the filter expression,
     * following the syntax outlined in https://google.aip.dev/160.
     *
     * Generated from protobuf field <code>string filter = 4;</code>
     */
    protected $filter = '';
    /**
     * The sorting order of the resources returned. Value should be a comma
     * separated list of fields. The default sorting oder is ascending.
     * See https://google.aip.dev/132#ordering.
     *
     * Generated from protobuf field <code>string order_by = 5;</code>
     */
    protected $order_by = '';

    /**
     * @param string $parent Required. The project and location from which the function should be
     *                       listed, specified in the format `projects/&#42;/locations/*` If you want to
     *                       list functions in all locations, use "-" in place of a location. When
     *                       listing functions in all locations, if one or more location(s) are
     *                       unreachable, the response will contain functions from all reachable
     *                       locations along with the names of any unreachable locations. Please see
     *                       {@see FunctionServiceClient::locationName()} for help formatting this field.
     *
     * @return \Google\Cloud\Functions\V2\ListFunctionsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The project and location from which the function should be
     *           listed, specified in the format `projects/&#42;&#47;locations/&#42;` If you want to
     *           list functions in all locations, use "-" in place of a location. When
     *           listing functions in all locations, if one or more location(s) are
     *           unreachable, the response will contain functions from all reachable
     *           locations along with the names of any unreachable locations.
     *     @type int $page_size
     *           Maximum number of functions to return per call. The largest allowed
     *           page_size is 1,000, if the page_size is omitted or specified as greater
     *           than 1,000 then it will be replaced as 1,000. The size of the list
     *           response can be less than specified when used with filters.
     *     @type string $page_token
     *           The value returned by the last
     *           `ListFunctionsResponse`; indicates that
     *           this is a continuation of a prior `ListFunctions` call, and that the
     *           system should return the next page of data.
     *     @type string $filter
     *           The filter for Functions that match the filter expression,
     *           following the syntax outlined in https://google.aip.dev/160.
     *     @type string $order_by
     *           The sorting order of the resources returned. Value should be a comma
     *           separated list of fields. The default sorting oder is ascending.
     *           See https://google.aip.dev/132#ordering.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Functions\V2\Functions::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The project and location from which the function should be
     * listed, specified in the format `projects/&#42;&#47;locations/&#42;` If you want to
     * list functions in all locations, use "-" in place of a location. When
     * listing functions in all locations, if one or more location(s) are
     * unreachable, the response will contain functions from all reachable
     * locations along with the names of any unreachable locations.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The project and location from which the function should be
     * listed, specified in the format `projects/&#42;&#47;locations/&#42;` If you want to
     * list functions in all locations, use "-" in place of a location. When
     * listing functions in all locations, if one or more location(s) are
     * unreachable, the response will contain functions from all reachable
     * locations along with the names of any unreachable locations.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Maximum number of functions to return per call. The largest allowed
     * page_size is 1,000, if the page_size is omitted or specified as greater
     * than 1,000 then it will be replaced as 1,000. The size of the list
     * response can be less than specified when used with filters.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Maximum number of functions to return per call. The largest allowed
     * page_size is 1,000, if the page_size is omitted or specified as greater
     * than 1,000 then it will be replaced as 1,000. The size of the list
     * response can be less than specified when used with filters.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * The value returned by the last
     * `ListFunctionsResponse`; indicates that
     * this is a continuation of a prior `ListFunctions` call, and that the
     * system should return the next page of data.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * The value returned by the last
     * `ListFunctionsResponse`; indicates that
     * this is a continuation of a prior `ListFunctions` call, and that the
     * system should return the next page of data.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * The filter for Functions that match the filter expression,
     * following the syntax outlined in https://google.aip.dev/160.
     *
     * Generated from protobuf field <code>string filter = 4;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * The filter for Functions that match the filter expression,
     * following the syntax outlined in https://google.aip.dev/160.
     *
     * Generated from protobuf field <code>string filter = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * The sorting order of the resources returned. Value should be a comma
     * separated list of fields. The default sorting oder is ascending.
     * See https://google.aip.dev/132#ordering.
     *
     * Generated from protobuf field <code>string order_by = 5;</code>
     * @return string
     */
    public function getOrderBy()
    {
        return $this->order_by;
    }

    /**
     * The sorting order of the resources returned. Value should be a comma
     * separated list of fields. The default sorting oder is ascending.
     * See https://google.aip.dev/132#ordering.
     *
     * Generated from protobuf field <code>string order_by = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setOrderBy($var)
    {
        GPBUtil::checkString($var, True);
        $this->order_by = $var;

        return $this;
    }

}

