<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/gkebackup/v1/backup_plan.proto

namespace Google\Cloud\GkeBackup\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Defines the configuration and scheduling for a "line" of Backups.
 *
 * Generated from protobuf message <code>google.cloud.gkebackup.v1.BackupPlan</code>
 */
class BackupPlan extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The full name of the BackupPlan resource.
     * Format: `projects/&#42;&#47;locations/&#42;&#47;backupPlans/&#42;`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $name = '';
    /**
     * Output only. Server generated global unique identifier of
     * [UUID](https://en.wikipedia.org/wiki/Universally_unique_identifier) format.
     *
     * Generated from protobuf field <code>string uid = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $uid = '';
    /**
     * Output only. The timestamp when this BackupPlan resource was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. The timestamp when this BackupPlan resource was last
     * updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Optional. User specified descriptive string for this BackupPlan.
     *
     * Generated from protobuf field <code>string description = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $description = '';
    /**
     * Required. Immutable. The source cluster from which Backups will be created
     * via this BackupPlan. Valid formats:
     * - `projects/&#42;&#47;locations/&#42;&#47;clusters/&#42;`
     * - `projects/&#42;&#47;zones/&#42;&#47;clusters/&#42;`
     *
     * Generated from protobuf field <code>string cluster = 6 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $cluster = '';
    /**
     * Optional. RetentionPolicy governs lifecycle of Backups created under this
     * plan.
     *
     * Generated from protobuf field <code>.google.cloud.gkebackup.v1.BackupPlan.RetentionPolicy retention_policy = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $retention_policy = null;
    /**
     * Optional. A set of custom labels supplied by user.
     *
     * Generated from protobuf field <code>map<string, string> labels = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $labels;
    /**
     * Optional. Defines a schedule for automatic Backup creation via this
     * BackupPlan.
     *
     * Generated from protobuf field <code>.google.cloud.gkebackup.v1.BackupPlan.Schedule backup_schedule = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $backup_schedule = null;
    /**
     * Output only. `etag` is used for optimistic concurrency control as a way to
     * help prevent simultaneous updates of a backup plan from overwriting each
     * other. It is strongly suggested that systems make use of the 'etag' in the
     * read-modify-write cycle to perform BackupPlan updates in order to avoid
     * race conditions: An `etag` is returned in the response to `GetBackupPlan`,
     * and systems are expected to put that etag in the request to
     * `UpdateBackupPlan` or `DeleteBackupPlan` to ensure that their change
     * will be applied to the same version of the resource.
     *
     * Generated from protobuf field <code>string etag = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $etag = '';
    /**
     * Optional. This flag indicates whether this BackupPlan has been deactivated.
     * Setting this field to True locks the BackupPlan such that no further
     * updates will be allowed (except deletes), including the deactivated field
     * itself. It also prevents any new Backups from being created via this
     * BackupPlan (including scheduled Backups).
     * Default: False
     *
     * Generated from protobuf field <code>bool deactivated = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $deactivated = false;
    /**
     * Optional. Defines the configuration of Backups created via this BackupPlan.
     *
     * Generated from protobuf field <code>.google.cloud.gkebackup.v1.BackupPlan.BackupConfig backup_config = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $backup_config = null;
    /**
     * Output only. The number of Kubernetes Pods backed up in the
     * last successful Backup created via this BackupPlan.
     *
     * Generated from protobuf field <code>int32 protected_pod_count = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $protected_pod_count = 0;
    /**
     * Output only. State of the BackupPlan. This State field reflects the
     * various stages a BackupPlan can be in
     * during the Create operation. It will be set to "DEACTIVATED"
     * if the BackupPlan is deactivated on an Update
     *
     * Generated from protobuf field <code>.google.cloud.gkebackup.v1.BackupPlan.State state = 14 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;
    /**
     * Output only. Human-readable description of why BackupPlan is in the current
     * `state`
     *
     * Generated from protobuf field <code>string state_reason = 15 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state_reason = '';
    /**
     * Output only. A number that represents the current risk level of this
     * BackupPlan from RPO perspective with 1 being no risk and 5 being highest
     * risk.
     *
     * Generated from protobuf field <code>int32 rpo_risk_level = 16 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $rpo_risk_level = 0;
    /**
     * Output only. Human-readable description of why the BackupPlan is in the
     * current rpo_risk_level and action items if any.
     *
     * Generated from protobuf field <code>string rpo_risk_reason = 17 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $rpo_risk_reason = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. The full name of the BackupPlan resource.
     *           Format: `projects/&#42;&#47;locations/&#42;&#47;backupPlans/&#42;`
     *     @type string $uid
     *           Output only. Server generated global unique identifier of
     *           [UUID](https://en.wikipedia.org/wiki/Universally_unique_identifier) format.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. The timestamp when this BackupPlan resource was created.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. The timestamp when this BackupPlan resource was last
     *           updated.
     *     @type string $description
     *           Optional. User specified descriptive string for this BackupPlan.
     *     @type string $cluster
     *           Required. Immutable. The source cluster from which Backups will be created
     *           via this BackupPlan. Valid formats:
     *           - `projects/&#42;&#47;locations/&#42;&#47;clusters/&#42;`
     *           - `projects/&#42;&#47;zones/&#42;&#47;clusters/&#42;`
     *     @type \Google\Cloud\GkeBackup\V1\BackupPlan\RetentionPolicy $retention_policy
     *           Optional. RetentionPolicy governs lifecycle of Backups created under this
     *           plan.
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Optional. A set of custom labels supplied by user.
     *     @type \Google\Cloud\GkeBackup\V1\BackupPlan\Schedule $backup_schedule
     *           Optional. Defines a schedule for automatic Backup creation via this
     *           BackupPlan.
     *     @type string $etag
     *           Output only. `etag` is used for optimistic concurrency control as a way to
     *           help prevent simultaneous updates of a backup plan from overwriting each
     *           other. It is strongly suggested that systems make use of the 'etag' in the
     *           read-modify-write cycle to perform BackupPlan updates in order to avoid
     *           race conditions: An `etag` is returned in the response to `GetBackupPlan`,
     *           and systems are expected to put that etag in the request to
     *           `UpdateBackupPlan` or `DeleteBackupPlan` to ensure that their change
     *           will be applied to the same version of the resource.
     *     @type bool $deactivated
     *           Optional. This flag indicates whether this BackupPlan has been deactivated.
     *           Setting this field to True locks the BackupPlan such that no further
     *           updates will be allowed (except deletes), including the deactivated field
     *           itself. It also prevents any new Backups from being created via this
     *           BackupPlan (including scheduled Backups).
     *           Default: False
     *     @type \Google\Cloud\GkeBackup\V1\BackupPlan\BackupConfig $backup_config
     *           Optional. Defines the configuration of Backups created via this BackupPlan.
     *     @type int $protected_pod_count
     *           Output only. The number of Kubernetes Pods backed up in the
     *           last successful Backup created via this BackupPlan.
     *     @type int $state
     *           Output only. State of the BackupPlan. This State field reflects the
     *           various stages a BackupPlan can be in
     *           during the Create operation. It will be set to "DEACTIVATED"
     *           if the BackupPlan is deactivated on an Update
     *     @type string $state_reason
     *           Output only. Human-readable description of why BackupPlan is in the current
     *           `state`
     *     @type int $rpo_risk_level
     *           Output only. A number that represents the current risk level of this
     *           BackupPlan from RPO perspective with 1 being no risk and 5 being highest
     *           risk.
     *     @type string $rpo_risk_reason
     *           Output only. Human-readable description of why the BackupPlan is in the
     *           current rpo_risk_level and action items if any.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Gkebackup\V1\BackupPlan::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The full name of the BackupPlan resource.
     * Format: `projects/&#42;&#47;locations/&#42;&#47;backupPlans/&#42;`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. The full name of the BackupPlan resource.
     * Format: `projects/&#42;&#47;locations/&#42;&#47;backupPlans/&#42;`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. Server generated global unique identifier of
     * [UUID](https://en.wikipedia.org/wiki/Universally_unique_identifier) format.
     *
     * Generated from protobuf field <code>string uid = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getUid()
    {
        return $this->uid;
    }

    /**
     * Output only. Server generated global unique identifier of
     * [UUID](https://en.wikipedia.org/wiki/Universally_unique_identifier) format.
     *
     * Generated from protobuf field <code>string uid = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setUid($var)
    {
        GPBUtil::checkString($var, True);
        $this->uid = $var;

        return $this;
    }

    /**
     * Output only. The timestamp when this BackupPlan resource was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. The timestamp when this BackupPlan resource was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. The timestamp when this BackupPlan resource was last
     * updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. The timestamp when this BackupPlan resource was last
     * updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Optional. User specified descriptive string for this BackupPlan.
     *
     * Generated from protobuf field <code>string description = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Optional. User specified descriptive string for this BackupPlan.
     *
     * Generated from protobuf field <code>string description = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Required. Immutable. The source cluster from which Backups will be created
     * via this BackupPlan. Valid formats:
     * - `projects/&#42;&#47;locations/&#42;&#47;clusters/&#42;`
     * - `projects/&#42;&#47;zones/&#42;&#47;clusters/&#42;`
     *
     * Generated from protobuf field <code>string cluster = 6 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getCluster()
    {
        return $this->cluster;
    }

    /**
     * Required. Immutable. The source cluster from which Backups will be created
     * via this BackupPlan. Valid formats:
     * - `projects/&#42;&#47;locations/&#42;&#47;clusters/&#42;`
     * - `projects/&#42;&#47;zones/&#42;&#47;clusters/&#42;`
     *
     * Generated from protobuf field <code>string cluster = 6 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setCluster($var)
    {
        GPBUtil::checkString($var, True);
        $this->cluster = $var;

        return $this;
    }

    /**
     * Optional. RetentionPolicy governs lifecycle of Backups created under this
     * plan.
     *
     * Generated from protobuf field <code>.google.cloud.gkebackup.v1.BackupPlan.RetentionPolicy retention_policy = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\GkeBackup\V1\BackupPlan\RetentionPolicy|null
     */
    public function getRetentionPolicy()
    {
        return $this->retention_policy;
    }

    public function hasRetentionPolicy()
    {
        return isset($this->retention_policy);
    }

    public function clearRetentionPolicy()
    {
        unset($this->retention_policy);
    }

    /**
     * Optional. RetentionPolicy governs lifecycle of Backups created under this
     * plan.
     *
     * Generated from protobuf field <code>.google.cloud.gkebackup.v1.BackupPlan.RetentionPolicy retention_policy = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\GkeBackup\V1\BackupPlan\RetentionPolicy $var
     * @return $this
     */
    public function setRetentionPolicy($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\GkeBackup\V1\BackupPlan\RetentionPolicy::class);
        $this->retention_policy = $var;

        return $this;
    }

    /**
     * Optional. A set of custom labels supplied by user.
     *
     * Generated from protobuf field <code>map<string, string> labels = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Optional. A set of custom labels supplied by user.
     *
     * Generated from protobuf field <code>map<string, string> labels = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * Optional. Defines a schedule for automatic Backup creation via this
     * BackupPlan.
     *
     * Generated from protobuf field <code>.google.cloud.gkebackup.v1.BackupPlan.Schedule backup_schedule = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\GkeBackup\V1\BackupPlan\Schedule|null
     */
    public function getBackupSchedule()
    {
        return $this->backup_schedule;
    }

    public function hasBackupSchedule()
    {
        return isset($this->backup_schedule);
    }

    public function clearBackupSchedule()
    {
        unset($this->backup_schedule);
    }

    /**
     * Optional. Defines a schedule for automatic Backup creation via this
     * BackupPlan.
     *
     * Generated from protobuf field <code>.google.cloud.gkebackup.v1.BackupPlan.Schedule backup_schedule = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\GkeBackup\V1\BackupPlan\Schedule $var
     * @return $this
     */
    public function setBackupSchedule($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\GkeBackup\V1\BackupPlan\Schedule::class);
        $this->backup_schedule = $var;

        return $this;
    }

    /**
     * Output only. `etag` is used for optimistic concurrency control as a way to
     * help prevent simultaneous updates of a backup plan from overwriting each
     * other. It is strongly suggested that systems make use of the 'etag' in the
     * read-modify-write cycle to perform BackupPlan updates in order to avoid
     * race conditions: An `etag` is returned in the response to `GetBackupPlan`,
     * and systems are expected to put that etag in the request to
     * `UpdateBackupPlan` or `DeleteBackupPlan` to ensure that their change
     * will be applied to the same version of the resource.
     *
     * Generated from protobuf field <code>string etag = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getEtag()
    {
        return $this->etag;
    }

    /**
     * Output only. `etag` is used for optimistic concurrency control as a way to
     * help prevent simultaneous updates of a backup plan from overwriting each
     * other. It is strongly suggested that systems make use of the 'etag' in the
     * read-modify-write cycle to perform BackupPlan updates in order to avoid
     * race conditions: An `etag` is returned in the response to `GetBackupPlan`,
     * and systems are expected to put that etag in the request to
     * `UpdateBackupPlan` or `DeleteBackupPlan` to ensure that their change
     * will be applied to the same version of the resource.
     *
     * Generated from protobuf field <code>string etag = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setEtag($var)
    {
        GPBUtil::checkString($var, True);
        $this->etag = $var;

        return $this;
    }

    /**
     * Optional. This flag indicates whether this BackupPlan has been deactivated.
     * Setting this field to True locks the BackupPlan such that no further
     * updates will be allowed (except deletes), including the deactivated field
     * itself. It also prevents any new Backups from being created via this
     * BackupPlan (including scheduled Backups).
     * Default: False
     *
     * Generated from protobuf field <code>bool deactivated = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getDeactivated()
    {
        return $this->deactivated;
    }

    /**
     * Optional. This flag indicates whether this BackupPlan has been deactivated.
     * Setting this field to True locks the BackupPlan such that no further
     * updates will be allowed (except deletes), including the deactivated field
     * itself. It also prevents any new Backups from being created via this
     * BackupPlan (including scheduled Backups).
     * Default: False
     *
     * Generated from protobuf field <code>bool deactivated = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setDeactivated($var)
    {
        GPBUtil::checkBool($var);
        $this->deactivated = $var;

        return $this;
    }

    /**
     * Optional. Defines the configuration of Backups created via this BackupPlan.
     *
     * Generated from protobuf field <code>.google.cloud.gkebackup.v1.BackupPlan.BackupConfig backup_config = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\GkeBackup\V1\BackupPlan\BackupConfig|null
     */
    public function getBackupConfig()
    {
        return $this->backup_config;
    }

    public function hasBackupConfig()
    {
        return isset($this->backup_config);
    }

    public function clearBackupConfig()
    {
        unset($this->backup_config);
    }

    /**
     * Optional. Defines the configuration of Backups created via this BackupPlan.
     *
     * Generated from protobuf field <code>.google.cloud.gkebackup.v1.BackupPlan.BackupConfig backup_config = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\GkeBackup\V1\BackupPlan\BackupConfig $var
     * @return $this
     */
    public function setBackupConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\GkeBackup\V1\BackupPlan\BackupConfig::class);
        $this->backup_config = $var;

        return $this;
    }

    /**
     * Output only. The number of Kubernetes Pods backed up in the
     * last successful Backup created via this BackupPlan.
     *
     * Generated from protobuf field <code>int32 protected_pod_count = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getProtectedPodCount()
    {
        return $this->protected_pod_count;
    }

    /**
     * Output only. The number of Kubernetes Pods backed up in the
     * last successful Backup created via this BackupPlan.
     *
     * Generated from protobuf field <code>int32 protected_pod_count = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setProtectedPodCount($var)
    {
        GPBUtil::checkInt32($var);
        $this->protected_pod_count = $var;

        return $this;
    }

    /**
     * Output only. State of the BackupPlan. This State field reflects the
     * various stages a BackupPlan can be in
     * during the Create operation. It will be set to "DEACTIVATED"
     * if the BackupPlan is deactivated on an Update
     *
     * Generated from protobuf field <code>.google.cloud.gkebackup.v1.BackupPlan.State state = 14 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. State of the BackupPlan. This State field reflects the
     * various stages a BackupPlan can be in
     * during the Create operation. It will be set to "DEACTIVATED"
     * if the BackupPlan is deactivated on an Update
     *
     * Generated from protobuf field <code>.google.cloud.gkebackup.v1.BackupPlan.State state = 14 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\GkeBackup\V1\BackupPlan\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Output only. Human-readable description of why BackupPlan is in the current
     * `state`
     *
     * Generated from protobuf field <code>string state_reason = 15 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getStateReason()
    {
        return $this->state_reason;
    }

    /**
     * Output only. Human-readable description of why BackupPlan is in the current
     * `state`
     *
     * Generated from protobuf field <code>string state_reason = 15 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setStateReason($var)
    {
        GPBUtil::checkString($var, True);
        $this->state_reason = $var;

        return $this;
    }

    /**
     * Output only. A number that represents the current risk level of this
     * BackupPlan from RPO perspective with 1 being no risk and 5 being highest
     * risk.
     *
     * Generated from protobuf field <code>int32 rpo_risk_level = 16 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getRpoRiskLevel()
    {
        return $this->rpo_risk_level;
    }

    /**
     * Output only. A number that represents the current risk level of this
     * BackupPlan from RPO perspective with 1 being no risk and 5 being highest
     * risk.
     *
     * Generated from protobuf field <code>int32 rpo_risk_level = 16 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setRpoRiskLevel($var)
    {
        GPBUtil::checkInt32($var);
        $this->rpo_risk_level = $var;

        return $this;
    }

    /**
     * Output only. Human-readable description of why the BackupPlan is in the
     * current rpo_risk_level and action items if any.
     *
     * Generated from protobuf field <code>string rpo_risk_reason = 17 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getRpoRiskReason()
    {
        return $this->rpo_risk_reason;
    }

    /**
     * Output only. Human-readable description of why the BackupPlan is in the
     * current rpo_risk_level and action items if any.
     *
     * Generated from protobuf field <code>string rpo_risk_reason = 17 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setRpoRiskReason($var)
    {
        GPBUtil::checkString($var, True);
        $this->rpo_risk_reason = $var;

        return $this;
    }

}

