<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/gkehub/v1/service.proto

namespace Google\Cloud\GkeHub\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for `GkeHub.ListMemberships` method.
 *
 * Generated from protobuf message <code>google.cloud.gkehub.v1.ListMembershipsRequest</code>
 */
class ListMembershipsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent (project and location) where the Memberships will be
     * listed. Specified in the format `projects/&#42;&#47;locations/&#42;`.
     * `projects/&#42;&#47;locations/-` list memberships in all the regions.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. When requesting a 'page' of resources, `page_size` specifies
     * number of resources to return. If unspecified or set to 0, all resources
     * will be returned.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. Token returned by previous call to `ListMemberships` which
     * specifies the position in the list from where to continue listing the
     * resources.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';
    /**
     * Optional. Lists Memberships that match the filter expression, following the
     * syntax outlined in https://google.aip.dev/160.
     * Examples:
     *   - Name is `bar` in project `foo-proj` and location `global`:
     *       name = "projects/foo-proj/locations/global/membership/bar"
     *   - Memberships that have a label called `foo`:
     *       labels.foo:*
     *   - Memberships that have a label called `foo` whose value is `bar`:
     *       labels.foo = bar
     *   - Memberships in the CREATING state:
     *       state = CREATING
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $filter = '';
    /**
     * Optional. One or more fields to compare and use to sort the output.
     * See https://google.aip.dev/132#ordering.
     *
     * Generated from protobuf field <code>string order_by = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $order_by = '';

    /**
     * @param string $parent Required. The parent (project and location) where the Memberships will be
     *                       listed. Specified in the format `projects/&#42;/locations/*`.
     *                       `projects/&#42;/locations/-` list memberships in all the regions. Please see
     *                       {@see GkeHubClient::locationName()} for help formatting this field.
     *
     * @return \Google\Cloud\GkeHub\V1\ListMembershipsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent (project and location) where the Memberships will be
     *           listed. Specified in the format `projects/&#42;&#47;locations/&#42;`.
     *           `projects/&#42;&#47;locations/-` list memberships in all the regions.
     *     @type int $page_size
     *           Optional. When requesting a 'page' of resources, `page_size` specifies
     *           number of resources to return. If unspecified or set to 0, all resources
     *           will be returned.
     *     @type string $page_token
     *           Optional. Token returned by previous call to `ListMemberships` which
     *           specifies the position in the list from where to continue listing the
     *           resources.
     *     @type string $filter
     *           Optional. Lists Memberships that match the filter expression, following the
     *           syntax outlined in https://google.aip.dev/160.
     *           Examples:
     *             - Name is `bar` in project `foo-proj` and location `global`:
     *                 name = "projects/foo-proj/locations/global/membership/bar"
     *             - Memberships that have a label called `foo`:
     *                 labels.foo:*
     *             - Memberships that have a label called `foo` whose value is `bar`:
     *                 labels.foo = bar
     *             - Memberships in the CREATING state:
     *                 state = CREATING
     *     @type string $order_by
     *           Optional. One or more fields to compare and use to sort the output.
     *           See https://google.aip.dev/132#ordering.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Gkehub\V1\Service::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent (project and location) where the Memberships will be
     * listed. Specified in the format `projects/&#42;&#47;locations/&#42;`.
     * `projects/&#42;&#47;locations/-` list memberships in all the regions.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent (project and location) where the Memberships will be
     * listed. Specified in the format `projects/&#42;&#47;locations/&#42;`.
     * `projects/&#42;&#47;locations/-` list memberships in all the regions.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. When requesting a 'page' of resources, `page_size` specifies
     * number of resources to return. If unspecified or set to 0, all resources
     * will be returned.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. When requesting a 'page' of resources, `page_size` specifies
     * number of resources to return. If unspecified or set to 0, all resources
     * will be returned.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. Token returned by previous call to `ListMemberships` which
     * specifies the position in the list from where to continue listing the
     * resources.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. Token returned by previous call to `ListMemberships` which
     * specifies the position in the list from where to continue listing the
     * resources.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. Lists Memberships that match the filter expression, following the
     * syntax outlined in https://google.aip.dev/160.
     * Examples:
     *   - Name is `bar` in project `foo-proj` and location `global`:
     *       name = "projects/foo-proj/locations/global/membership/bar"
     *   - Memberships that have a label called `foo`:
     *       labels.foo:*
     *   - Memberships that have a label called `foo` whose value is `bar`:
     *       labels.foo = bar
     *   - Memberships in the CREATING state:
     *       state = CREATING
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Optional. Lists Memberships that match the filter expression, following the
     * syntax outlined in https://google.aip.dev/160.
     * Examples:
     *   - Name is `bar` in project `foo-proj` and location `global`:
     *       name = "projects/foo-proj/locations/global/membership/bar"
     *   - Memberships that have a label called `foo`:
     *       labels.foo:*
     *   - Memberships that have a label called `foo` whose value is `bar`:
     *       labels.foo = bar
     *   - Memberships in the CREATING state:
     *       state = CREATING
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * Optional. One or more fields to compare and use to sort the output.
     * See https://google.aip.dev/132#ordering.
     *
     * Generated from protobuf field <code>string order_by = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getOrderBy()
    {
        return $this->order_by;
    }

    /**
     * Optional. One or more fields to compare and use to sort the output.
     * See https://google.aip.dev/132#ordering.
     *
     * Generated from protobuf field <code>string order_by = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setOrderBy($var)
    {
        GPBUtil::checkString($var, True);
        $this->order_by = $var;

        return $this;
    }

}

