<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/gkemulticloud/v1/aws_resources.proto

namespace Google\Cloud\GkeMultiCloud\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Details of a proxy config stored in AWS Secret Manager.
 *
 * Generated from protobuf message <code>google.cloud.gkemulticloud.v1.AwsProxyConfig</code>
 */
class AwsProxyConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * The ARN of the AWS Secret Manager secret that contains the HTTP(S) proxy
     * configuration.
     * The secret must be a JSON encoded proxy configuration
     * as described in
     * https://cloud.google.com/kubernetes-engine/multi-cloud/docs/aws/how-to/use-a-proxy#create_a_proxy_configuration_file
     *
     * Generated from protobuf field <code>string secret_arn = 1;</code>
     */
    protected $secret_arn = '';
    /**
     * The version string of the AWS Secret Manager secret that contains the
     * HTTP(S) proxy configuration.
     *
     * Generated from protobuf field <code>string secret_version = 2;</code>
     */
    protected $secret_version = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $secret_arn
     *           The ARN of the AWS Secret Manager secret that contains the HTTP(S) proxy
     *           configuration.
     *           The secret must be a JSON encoded proxy configuration
     *           as described in
     *           https://cloud.google.com/kubernetes-engine/multi-cloud/docs/aws/how-to/use-a-proxy#create_a_proxy_configuration_file
     *     @type string $secret_version
     *           The version string of the AWS Secret Manager secret that contains the
     *           HTTP(S) proxy configuration.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Gkemulticloud\V1\AwsResources::initOnce();
        parent::__construct($data);
    }

    /**
     * The ARN of the AWS Secret Manager secret that contains the HTTP(S) proxy
     * configuration.
     * The secret must be a JSON encoded proxy configuration
     * as described in
     * https://cloud.google.com/kubernetes-engine/multi-cloud/docs/aws/how-to/use-a-proxy#create_a_proxy_configuration_file
     *
     * Generated from protobuf field <code>string secret_arn = 1;</code>
     * @return string
     */
    public function getSecretArn()
    {
        return $this->secret_arn;
    }

    /**
     * The ARN of the AWS Secret Manager secret that contains the HTTP(S) proxy
     * configuration.
     * The secret must be a JSON encoded proxy configuration
     * as described in
     * https://cloud.google.com/kubernetes-engine/multi-cloud/docs/aws/how-to/use-a-proxy#create_a_proxy_configuration_file
     *
     * Generated from protobuf field <code>string secret_arn = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setSecretArn($var)
    {
        GPBUtil::checkString($var, True);
        $this->secret_arn = $var;

        return $this;
    }

    /**
     * The version string of the AWS Secret Manager secret that contains the
     * HTTP(S) proxy configuration.
     *
     * Generated from protobuf field <code>string secret_version = 2;</code>
     * @return string
     */
    public function getSecretVersion()
    {
        return $this->secret_version;
    }

    /**
     * The version string of the AWS Secret Manager secret that contains the
     * HTTP(S) proxy configuration.
     *
     * Generated from protobuf field <code>string secret_version = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setSecretVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->secret_version = $var;

        return $this;
    }

}

