<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/gkemulticloud/v1/azure_service.proto

namespace Google\Cloud\GkeMultiCloud\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for `AzureClusters.CreateAzureClient` method.
 *
 * Generated from protobuf message <code>google.cloud.gkemulticloud.v1.CreateAzureClientRequest</code>
 */
class CreateAzureClientRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent location where this
     * [AzureClient][google.cloud.gkemulticloud.v1.AzureClient] resource will be
     * created.
     * Location names are formatted as `projects/<project-id>/locations/<region>`.
     * See [Resource Names](https://cloud.google.com/apis/design/resource_names)
     * for more details on Google Cloud resource names.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The specification of the
     * [AzureClient][google.cloud.gkemulticloud.v1.AzureClient] to create.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.AzureClient azure_client = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $azure_client = null;
    /**
     * Required. A client provided ID the resource. Must be unique within the
     * parent resource.
     * The provided ID will be part of the
     * [AzureClient][google.cloud.gkemulticloud.v1.AzureClient] resource name
     * formatted as
     * `projects/<project-id>/locations/<region>/azureClients/<client-id>`.
     * Valid characters are `/[a-z][0-9]-/`. Cannot be longer than 63 characters.
     *
     * Generated from protobuf field <code>string azure_client_id = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $azure_client_id = '';
    /**
     * If set, only validate the request, but do not actually create the client.
     *
     * Generated from protobuf field <code>bool validate_only = 3;</code>
     */
    protected $validate_only = false;

    /**
     * @param string                                     $parent        Required. The parent location where this
     *                                                                  [AzureClient][google.cloud.gkemulticloud.v1.AzureClient] resource will be
     *                                                                  created.
     *
     *                                                                  Location names are formatted as `projects/<project-id>/locations/<region>`.
     *
     *                                                                  See [Resource Names](https://cloud.google.com/apis/design/resource_names)
     *                                                                  for more details on Google Cloud resource names. Please see
     *                                                                  {@see AzureClustersClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\GkeMultiCloud\V1\AzureClient $azureClient   Required. The specification of the
     *                                                                  [AzureClient][google.cloud.gkemulticloud.v1.AzureClient] to create.
     * @param string                                     $azureClientId Required. A client provided ID the resource. Must be unique within the
     *                                                                  parent resource.
     *
     *                                                                  The provided ID will be part of the
     *                                                                  [AzureClient][google.cloud.gkemulticloud.v1.AzureClient] resource name
     *                                                                  formatted as
     *                                                                  `projects/<project-id>/locations/<region>/azureClients/<client-id>`.
     *
     *                                                                  Valid characters are `/[a-z][0-9]-/`. Cannot be longer than 63 characters.
     *
     * @return \Google\Cloud\GkeMultiCloud\V1\CreateAzureClientRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\GkeMultiCloud\V1\AzureClient $azureClient, string $azureClientId): self
    {
        return (new self())
            ->setParent($parent)
            ->setAzureClient($azureClient)
            ->setAzureClientId($azureClientId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent location where this
     *           [AzureClient][google.cloud.gkemulticloud.v1.AzureClient] resource will be
     *           created.
     *           Location names are formatted as `projects/<project-id>/locations/<region>`.
     *           See [Resource Names](https://cloud.google.com/apis/design/resource_names)
     *           for more details on Google Cloud resource names.
     *     @type \Google\Cloud\GkeMultiCloud\V1\AzureClient $azure_client
     *           Required. The specification of the
     *           [AzureClient][google.cloud.gkemulticloud.v1.AzureClient] to create.
     *     @type string $azure_client_id
     *           Required. A client provided ID the resource. Must be unique within the
     *           parent resource.
     *           The provided ID will be part of the
     *           [AzureClient][google.cloud.gkemulticloud.v1.AzureClient] resource name
     *           formatted as
     *           `projects/<project-id>/locations/<region>/azureClients/<client-id>`.
     *           Valid characters are `/[a-z][0-9]-/`. Cannot be longer than 63 characters.
     *     @type bool $validate_only
     *           If set, only validate the request, but do not actually create the client.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Gkemulticloud\V1\AzureService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent location where this
     * [AzureClient][google.cloud.gkemulticloud.v1.AzureClient] resource will be
     * created.
     * Location names are formatted as `projects/<project-id>/locations/<region>`.
     * See [Resource Names](https://cloud.google.com/apis/design/resource_names)
     * for more details on Google Cloud resource names.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent location where this
     * [AzureClient][google.cloud.gkemulticloud.v1.AzureClient] resource will be
     * created.
     * Location names are formatted as `projects/<project-id>/locations/<region>`.
     * See [Resource Names](https://cloud.google.com/apis/design/resource_names)
     * for more details on Google Cloud resource names.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The specification of the
     * [AzureClient][google.cloud.gkemulticloud.v1.AzureClient] to create.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.AzureClient azure_client = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\GkeMultiCloud\V1\AzureClient|null
     */
    public function getAzureClient()
    {
        return $this->azure_client;
    }

    public function hasAzureClient()
    {
        return isset($this->azure_client);
    }

    public function clearAzureClient()
    {
        unset($this->azure_client);
    }

    /**
     * Required. The specification of the
     * [AzureClient][google.cloud.gkemulticloud.v1.AzureClient] to create.
     *
     * Generated from protobuf field <code>.google.cloud.gkemulticloud.v1.AzureClient azure_client = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\GkeMultiCloud\V1\AzureClient $var
     * @return $this
     */
    public function setAzureClient($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\GkeMultiCloud\V1\AzureClient::class);
        $this->azure_client = $var;

        return $this;
    }

    /**
     * Required. A client provided ID the resource. Must be unique within the
     * parent resource.
     * The provided ID will be part of the
     * [AzureClient][google.cloud.gkemulticloud.v1.AzureClient] resource name
     * formatted as
     * `projects/<project-id>/locations/<region>/azureClients/<client-id>`.
     * Valid characters are `/[a-z][0-9]-/`. Cannot be longer than 63 characters.
     *
     * Generated from protobuf field <code>string azure_client_id = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getAzureClientId()
    {
        return $this->azure_client_id;
    }

    /**
     * Required. A client provided ID the resource. Must be unique within the
     * parent resource.
     * The provided ID will be part of the
     * [AzureClient][google.cloud.gkemulticloud.v1.AzureClient] resource name
     * formatted as
     * `projects/<project-id>/locations/<region>/azureClients/<client-id>`.
     * Valid characters are `/[a-z][0-9]-/`. Cannot be longer than 63 characters.
     *
     * Generated from protobuf field <code>string azure_client_id = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setAzureClientId($var)
    {
        GPBUtil::checkString($var, True);
        $this->azure_client_id = $var;

        return $this;
    }

    /**
     * If set, only validate the request, but do not actually create the client.
     *
     * Generated from protobuf field <code>bool validate_only = 3;</code>
     * @return bool
     */
    public function getValidateOnly()
    {
        return $this->validate_only;
    }

    /**
     * If set, only validate the request, but do not actually create the client.
     *
     * Generated from protobuf field <code>bool validate_only = 3;</code>
     * @param bool $var
     * @return $this
     */
    public function setValidateOnly($var)
    {
        GPBUtil::checkBool($var);
        $this->validate_only = $var;

        return $this;
    }

}

