<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/gkemulticloud/v1/common_resources.proto

namespace Google\Cloud\GkeMultiCloud\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Fleet related configuration.
 * Fleets are a Google Cloud concept for logically organizing clusters,
 * letting you use and manage multi-cluster capabilities and apply
 * consistent policies across your systems.
 * See [Anthos
 * Fleets](https://cloud.google.com/anthos/multicluster-management/fleets) for
 * more details on Anthos multi-cluster capabilities using Fleets.
 *
 * Generated from protobuf message <code>google.cloud.gkemulticloud.v1.Fleet</code>
 */
class Fleet extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the Fleet host project where this cluster will be
     * registered.
     * Project names are formatted as
     * `projects/<project-number>`.
     *
     * Generated from protobuf field <code>string project = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $project = '';
    /**
     * Output only. The name of the managed Hub Membership resource associated to
     * this cluster.
     * Membership names are formatted as
     * `projects/<project-number>/locations/global/membership/<cluster-id>`.
     *
     * Generated from protobuf field <code>string membership = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $membership = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $project
     *           Required. The name of the Fleet host project where this cluster will be
     *           registered.
     *           Project names are formatted as
     *           `projects/<project-number>`.
     *     @type string $membership
     *           Output only. The name of the managed Hub Membership resource associated to
     *           this cluster.
     *           Membership names are formatted as
     *           `projects/<project-number>/locations/global/membership/<cluster-id>`.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Gkemulticloud\V1\CommonResources::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the Fleet host project where this cluster will be
     * registered.
     * Project names are formatted as
     * `projects/<project-number>`.
     *
     * Generated from protobuf field <code>string project = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getProject()
    {
        return $this->project;
    }

    /**
     * Required. The name of the Fleet host project where this cluster will be
     * registered.
     * Project names are formatted as
     * `projects/<project-number>`.
     *
     * Generated from protobuf field <code>string project = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setProject($var)
    {
        GPBUtil::checkString($var, True);
        $this->project = $var;

        return $this;
    }

    /**
     * Output only. The name of the managed Hub Membership resource associated to
     * this cluster.
     * Membership names are formatted as
     * `projects/<project-number>/locations/global/membership/<cluster-id>`.
     *
     * Generated from protobuf field <code>string membership = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getMembership()
    {
        return $this->membership;
    }

    /**
     * Output only. The name of the managed Hub Membership resource associated to
     * this cluster.
     * Membership names are formatted as
     * `projects/<project-number>/locations/global/membership/<cluster-id>`.
     *
     * Generated from protobuf field <code>string membership = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setMembership($var)
    {
        GPBUtil::checkString($var, True);
        $this->membership = $var;

        return $this;
    }

}

