<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: grafeas/v1/sbom.proto

namespace Grafeas\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The occurrence representing an SBOM reference as applied to a specific
 * resource. The occurrence follows the DSSE specification. See
 * https://github.com/secure-systems-lab/dsse/blob/master/envelope.md for more
 * details.
 *
 * Generated from protobuf message <code>grafeas.v1.SBOMReferenceOccurrence</code>
 */
class SBOMReferenceOccurrence extends \Google\Protobuf\Internal\Message
{
    /**
     * The actual payload that contains the SBOM reference data.
     *
     * Generated from protobuf field <code>.grafeas.v1.SbomReferenceIntotoPayload payload = 1;</code>
     */
    protected $payload = null;
    /**
     * The kind of payload that SbomReferenceIntotoPayload takes. Since it's in
     * the intoto format, this value is expected to be
     * 'application/vnd.in-toto+json'.
     *
     * Generated from protobuf field <code>string payload_type = 2;</code>
     */
    protected $payload_type = '';
    /**
     * The signatures over the payload.
     *
     * Generated from protobuf field <code>repeated .grafeas.v1.EnvelopeSignature signatures = 3;</code>
     */
    private $signatures;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Grafeas\V1\SbomReferenceIntotoPayload $payload
     *           The actual payload that contains the SBOM reference data.
     *     @type string $payload_type
     *           The kind of payload that SbomReferenceIntotoPayload takes. Since it's in
     *           the intoto format, this value is expected to be
     *           'application/vnd.in-toto+json'.
     *     @type array<\Grafeas\V1\EnvelopeSignature>|\Google\Protobuf\Internal\RepeatedField $signatures
     *           The signatures over the payload.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Grafeas\V1\Sbom::initOnce();
        parent::__construct($data);
    }

    /**
     * The actual payload that contains the SBOM reference data.
     *
     * Generated from protobuf field <code>.grafeas.v1.SbomReferenceIntotoPayload payload = 1;</code>
     * @return \Grafeas\V1\SbomReferenceIntotoPayload|null
     */
    public function getPayload()
    {
        return $this->payload;
    }

    public function hasPayload()
    {
        return isset($this->payload);
    }

    public function clearPayload()
    {
        unset($this->payload);
    }

    /**
     * The actual payload that contains the SBOM reference data.
     *
     * Generated from protobuf field <code>.grafeas.v1.SbomReferenceIntotoPayload payload = 1;</code>
     * @param \Grafeas\V1\SbomReferenceIntotoPayload $var
     * @return $this
     */
    public function setPayload($var)
    {
        GPBUtil::checkMessage($var, \Grafeas\V1\SbomReferenceIntotoPayload::class);
        $this->payload = $var;

        return $this;
    }

    /**
     * The kind of payload that SbomReferenceIntotoPayload takes. Since it's in
     * the intoto format, this value is expected to be
     * 'application/vnd.in-toto+json'.
     *
     * Generated from protobuf field <code>string payload_type = 2;</code>
     * @return string
     */
    public function getPayloadType()
    {
        return $this->payload_type;
    }

    /**
     * The kind of payload that SbomReferenceIntotoPayload takes. Since it's in
     * the intoto format, this value is expected to be
     * 'application/vnd.in-toto+json'.
     *
     * Generated from protobuf field <code>string payload_type = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setPayloadType($var)
    {
        GPBUtil::checkString($var, True);
        $this->payload_type = $var;

        return $this;
    }

    /**
     * The signatures over the payload.
     *
     * Generated from protobuf field <code>repeated .grafeas.v1.EnvelopeSignature signatures = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSignatures()
    {
        return $this->signatures;
    }

    /**
     * The signatures over the payload.
     *
     * Generated from protobuf field <code>repeated .grafeas.v1.EnvelopeSignature signatures = 3;</code>
     * @param array<\Grafeas\V1\EnvelopeSignature>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSignatures($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Grafeas\V1\EnvelopeSignature::class);
        $this->signatures = $arr;

        return $this;
    }

}

