<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/kms/v1/autokey_admin.proto

namespace Google\Cloud\Kms\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Cloud KMS Autokey configuration for a folder.
 *
 * Generated from protobuf message <code>google.cloud.kms.v1.AutokeyConfig</code>
 */
class AutokeyConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. Name of the [AutokeyConfig][google.cloud.kms.v1.AutokeyConfig]
     * resource, e.g. `folders/{FOLDER_NUMBER}/autokeyConfig`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Optional. Name of the key project, e.g. `projects/{PROJECT_ID}` or
     * `projects/{PROJECT_NUMBER}`, where Cloud KMS Autokey will provision a new
     * [CryptoKey][google.cloud.kms.v1.CryptoKey] when a
     * [KeyHandle][google.cloud.kms.v1.KeyHandle] is created. On
     * [UpdateAutokeyConfig][google.cloud.kms.v1.AutokeyAdmin.UpdateAutokeyConfig],
     * the caller will require `cloudkms.cryptoKeys.setIamPolicy` permission on
     * this key project. Once configured, for Cloud KMS Autokey to function
     * properly, this key project must have the Cloud KMS API activated and the
     * Cloud KMS Service Agent for this key project must be granted the
     * `cloudkms.admin` role (or pertinent permissions). A request with an empty
     * key project field will clear the configuration.
     *
     * Generated from protobuf field <code>string key_project = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $key_project = '';
    /**
     * Output only. The state for the AutokeyConfig.
     *
     * Generated from protobuf field <code>.google.cloud.kms.v1.AutokeyConfig.State state = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. Name of the [AutokeyConfig][google.cloud.kms.v1.AutokeyConfig]
     *           resource, e.g. `folders/{FOLDER_NUMBER}/autokeyConfig`.
     *     @type string $key_project
     *           Optional. Name of the key project, e.g. `projects/{PROJECT_ID}` or
     *           `projects/{PROJECT_NUMBER}`, where Cloud KMS Autokey will provision a new
     *           [CryptoKey][google.cloud.kms.v1.CryptoKey] when a
     *           [KeyHandle][google.cloud.kms.v1.KeyHandle] is created. On
     *           [UpdateAutokeyConfig][google.cloud.kms.v1.AutokeyAdmin.UpdateAutokeyConfig],
     *           the caller will require `cloudkms.cryptoKeys.setIamPolicy` permission on
     *           this key project. Once configured, for Cloud KMS Autokey to function
     *           properly, this key project must have the Cloud KMS API activated and the
     *           Cloud KMS Service Agent for this key project must be granted the
     *           `cloudkms.admin` role (or pertinent permissions). A request with an empty
     *           key project field will clear the configuration.
     *     @type int $state
     *           Output only. The state for the AutokeyConfig.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Kms\V1\AutokeyAdmin::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. Name of the [AutokeyConfig][google.cloud.kms.v1.AutokeyConfig]
     * resource, e.g. `folders/{FOLDER_NUMBER}/autokeyConfig`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. Name of the [AutokeyConfig][google.cloud.kms.v1.AutokeyConfig]
     * resource, e.g. `folders/{FOLDER_NUMBER}/autokeyConfig`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Optional. Name of the key project, e.g. `projects/{PROJECT_ID}` or
     * `projects/{PROJECT_NUMBER}`, where Cloud KMS Autokey will provision a new
     * [CryptoKey][google.cloud.kms.v1.CryptoKey] when a
     * [KeyHandle][google.cloud.kms.v1.KeyHandle] is created. On
     * [UpdateAutokeyConfig][google.cloud.kms.v1.AutokeyAdmin.UpdateAutokeyConfig],
     * the caller will require `cloudkms.cryptoKeys.setIamPolicy` permission on
     * this key project. Once configured, for Cloud KMS Autokey to function
     * properly, this key project must have the Cloud KMS API activated and the
     * Cloud KMS Service Agent for this key project must be granted the
     * `cloudkms.admin` role (or pertinent permissions). A request with an empty
     * key project field will clear the configuration.
     *
     * Generated from protobuf field <code>string key_project = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getKeyProject()
    {
        return $this->key_project;
    }

    /**
     * Optional. Name of the key project, e.g. `projects/{PROJECT_ID}` or
     * `projects/{PROJECT_NUMBER}`, where Cloud KMS Autokey will provision a new
     * [CryptoKey][google.cloud.kms.v1.CryptoKey] when a
     * [KeyHandle][google.cloud.kms.v1.KeyHandle] is created. On
     * [UpdateAutokeyConfig][google.cloud.kms.v1.AutokeyAdmin.UpdateAutokeyConfig],
     * the caller will require `cloudkms.cryptoKeys.setIamPolicy` permission on
     * this key project. Once configured, for Cloud KMS Autokey to function
     * properly, this key project must have the Cloud KMS API activated and the
     * Cloud KMS Service Agent for this key project must be granted the
     * `cloudkms.admin` role (or pertinent permissions). A request with an empty
     * key project field will clear the configuration.
     *
     * Generated from protobuf field <code>string key_project = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setKeyProject($var)
    {
        GPBUtil::checkString($var, True);
        $this->key_project = $var;

        return $this;
    }

    /**
     * Output only. The state for the AutokeyConfig.
     *
     * Generated from protobuf field <code>.google.cloud.kms.v1.AutokeyConfig.State state = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. The state for the AutokeyConfig.
     *
     * Generated from protobuf field <code>.google.cloud.kms.v1.AutokeyConfig.State state = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Kms\V1\AutokeyConfig\State::class);
        $this->state = $var;

        return $this;
    }

}

