<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/kms/v1/resources.proto

namespace Google\Cloud\Kms\V1\KeyOperationAttestation;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Certificate chains needed to verify the attestation.
 * Certificates in chains are PEM-encoded and are ordered based on
 * https://tools.ietf.org/html/rfc5246#section-7.4.2.
 *
 * Generated from protobuf message <code>google.cloud.kms.v1.KeyOperationAttestation.CertificateChains</code>
 */
class CertificateChains extends \Google\Protobuf\Internal\Message
{
    /**
     * Cavium certificate chain corresponding to the attestation.
     *
     * Generated from protobuf field <code>repeated string cavium_certs = 1;</code>
     */
    private $cavium_certs;
    /**
     * Google card certificate chain corresponding to the attestation.
     *
     * Generated from protobuf field <code>repeated string google_card_certs = 2;</code>
     */
    private $google_card_certs;
    /**
     * Google partition certificate chain corresponding to the attestation.
     *
     * Generated from protobuf field <code>repeated string google_partition_certs = 3;</code>
     */
    private $google_partition_certs;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $cavium_certs
     *           Cavium certificate chain corresponding to the attestation.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $google_card_certs
     *           Google card certificate chain corresponding to the attestation.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $google_partition_certs
     *           Google partition certificate chain corresponding to the attestation.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Kms\V1\Resources::initOnce();
        parent::__construct($data);
    }

    /**
     * Cavium certificate chain corresponding to the attestation.
     *
     * Generated from protobuf field <code>repeated string cavium_certs = 1;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getCaviumCerts()
    {
        return $this->cavium_certs;
    }

    /**
     * Cavium certificate chain corresponding to the attestation.
     *
     * Generated from protobuf field <code>repeated string cavium_certs = 1;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setCaviumCerts($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->cavium_certs = $arr;

        return $this;
    }

    /**
     * Google card certificate chain corresponding to the attestation.
     *
     * Generated from protobuf field <code>repeated string google_card_certs = 2;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getGoogleCardCerts()
    {
        return $this->google_card_certs;
    }

    /**
     * Google card certificate chain corresponding to the attestation.
     *
     * Generated from protobuf field <code>repeated string google_card_certs = 2;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setGoogleCardCerts($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->google_card_certs = $arr;

        return $this;
    }

    /**
     * Google partition certificate chain corresponding to the attestation.
     *
     * Generated from protobuf field <code>repeated string google_partition_certs = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getGooglePartitionCerts()
    {
        return $this->google_partition_certs;
    }

    /**
     * Google partition certificate chain corresponding to the attestation.
     *
     * Generated from protobuf field <code>repeated string google_partition_certs = 3;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setGooglePartitionCerts($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->google_partition_certs = $arr;

        return $this;
    }

}


