<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/kms/v1/service.proto

namespace Google\Cloud\Kms\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [KeyManagementService.MacVerify][google.cloud.kms.v1.KeyManagementService.MacVerify].
 *
 * Generated from protobuf message <code>google.cloud.kms.v1.MacVerifyRequest</code>
 */
class MacVerifyRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the
     * [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] to use for
     * verification.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';
    /**
     * Required. The data used previously as a
     * [MacSignRequest.data][google.cloud.kms.v1.MacSignRequest.data] to generate
     * the MAC tag.
     *
     * Generated from protobuf field <code>bytes data = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $data = '';
    /**
     * Optional. An optional CRC32C checksum of the
     * [MacVerifyRequest.data][google.cloud.kms.v1.MacVerifyRequest.data]. If
     * specified, [KeyManagementService][google.cloud.kms.v1.KeyManagementService]
     * will verify the integrity of the received
     * [MacVerifyRequest.data][google.cloud.kms.v1.MacVerifyRequest.data] using
     * this checksum.
     * [KeyManagementService][google.cloud.kms.v1.KeyManagementService] will
     * report an error if the checksum verification fails. If you receive a
     * checksum error, your client should verify that
     * CRC32C([MacVerifyRequest.data][google.cloud.kms.v1.MacVerifyRequest.data])
     * is equal to
     * [MacVerifyRequest.data_crc32c][google.cloud.kms.v1.MacVerifyRequest.data_crc32c],
     * and if so, perform a limited number of retries. A persistent mismatch may
     * indicate an issue in your computation of the CRC32C checksum. Note: This
     * field is defined as int64 for reasons of compatibility across different
     * languages. However, it is a non-negative integer, which will never exceed
     * 2^32-1, and can be safely downconverted to uint32 in languages that support
     * this type.
     *
     * Generated from protobuf field <code>.google.protobuf.Int64Value data_crc32c = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $data_crc32c = null;
    /**
     * Required. The signature to verify.
     *
     * Generated from protobuf field <code>bytes mac = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $mac = '';
    /**
     * Optional. An optional CRC32C checksum of the
     * [MacVerifyRequest.mac][google.cloud.kms.v1.MacVerifyRequest.mac]. If
     * specified, [KeyManagementService][google.cloud.kms.v1.KeyManagementService]
     * will verify the integrity of the received
     * [MacVerifyRequest.mac][google.cloud.kms.v1.MacVerifyRequest.mac] using this
     * checksum. [KeyManagementService][google.cloud.kms.v1.KeyManagementService]
     * will report an error if the checksum verification fails. If you receive a
     * checksum error, your client should verify that
     * CRC32C([MacVerifyRequest.tag][]) is equal to
     * [MacVerifyRequest.mac_crc32c][google.cloud.kms.v1.MacVerifyRequest.mac_crc32c],
     * and if so, perform a limited number of retries. A persistent mismatch may
     * indicate an issue in your computation of the CRC32C checksum. Note: This
     * field is defined as int64 for reasons of compatibility across different
     * languages. However, it is a non-negative integer, which will never exceed
     * 2^32-1, and can be safely downconverted to uint32 in languages that support
     * this type.
     *
     * Generated from protobuf field <code>.google.protobuf.Int64Value mac_crc32c = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $mac_crc32c = null;

    /**
     * @param string $name Required. The resource name of the
     *                     [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] to use for
     *                     verification. Please see
     *                     {@see KeyManagementServiceClient::cryptoKeyVersionName()} for help formatting this field.
     * @param string $data Required. The data used previously as a
     *                     [MacSignRequest.data][google.cloud.kms.v1.MacSignRequest.data] to generate
     *                     the MAC tag.
     * @param string $mac  Required. The signature to verify.
     *
     * @return \Google\Cloud\Kms\V1\MacVerifyRequest
     *
     * @experimental
     */
    public static function build(string $name, string $data, string $mac): self
    {
        return (new self())
            ->setName($name)
            ->setData($data)
            ->setMac($mac);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. The resource name of the
     *           [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] to use for
     *           verification.
     *     @type string $data
     *           Required. The data used previously as a
     *           [MacSignRequest.data][google.cloud.kms.v1.MacSignRequest.data] to generate
     *           the MAC tag.
     *     @type \Google\Protobuf\Int64Value $data_crc32c
     *           Optional. An optional CRC32C checksum of the
     *           [MacVerifyRequest.data][google.cloud.kms.v1.MacVerifyRequest.data]. If
     *           specified, [KeyManagementService][google.cloud.kms.v1.KeyManagementService]
     *           will verify the integrity of the received
     *           [MacVerifyRequest.data][google.cloud.kms.v1.MacVerifyRequest.data] using
     *           this checksum.
     *           [KeyManagementService][google.cloud.kms.v1.KeyManagementService] will
     *           report an error if the checksum verification fails. If you receive a
     *           checksum error, your client should verify that
     *           CRC32C([MacVerifyRequest.data][google.cloud.kms.v1.MacVerifyRequest.data])
     *           is equal to
     *           [MacVerifyRequest.data_crc32c][google.cloud.kms.v1.MacVerifyRequest.data_crc32c],
     *           and if so, perform a limited number of retries. A persistent mismatch may
     *           indicate an issue in your computation of the CRC32C checksum. Note: This
     *           field is defined as int64 for reasons of compatibility across different
     *           languages. However, it is a non-negative integer, which will never exceed
     *           2^32-1, and can be safely downconverted to uint32 in languages that support
     *           this type.
     *     @type string $mac
     *           Required. The signature to verify.
     *     @type \Google\Protobuf\Int64Value $mac_crc32c
     *           Optional. An optional CRC32C checksum of the
     *           [MacVerifyRequest.mac][google.cloud.kms.v1.MacVerifyRequest.mac]. If
     *           specified, [KeyManagementService][google.cloud.kms.v1.KeyManagementService]
     *           will verify the integrity of the received
     *           [MacVerifyRequest.mac][google.cloud.kms.v1.MacVerifyRequest.mac] using this
     *           checksum. [KeyManagementService][google.cloud.kms.v1.KeyManagementService]
     *           will report an error if the checksum verification fails. If you receive a
     *           checksum error, your client should verify that
     *           CRC32C([MacVerifyRequest.tag][]) is equal to
     *           [MacVerifyRequest.mac_crc32c][google.cloud.kms.v1.MacVerifyRequest.mac_crc32c],
     *           and if so, perform a limited number of retries. A persistent mismatch may
     *           indicate an issue in your computation of the CRC32C checksum. Note: This
     *           field is defined as int64 for reasons of compatibility across different
     *           languages. However, it is a non-negative integer, which will never exceed
     *           2^32-1, and can be safely downconverted to uint32 in languages that support
     *           this type.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Kms\V1\Service::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the
     * [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] to use for
     * verification.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. The resource name of the
     * [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] to use for
     * verification.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Required. The data used previously as a
     * [MacSignRequest.data][google.cloud.kms.v1.MacSignRequest.data] to generate
     * the MAC tag.
     *
     * Generated from protobuf field <code>bytes data = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getData()
    {
        return $this->data;
    }

    /**
     * Required. The data used previously as a
     * [MacSignRequest.data][google.cloud.kms.v1.MacSignRequest.data] to generate
     * the MAC tag.
     *
     * Generated from protobuf field <code>bytes data = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setData($var)
    {
        GPBUtil::checkString($var, False);
        $this->data = $var;

        return $this;
    }

    /**
     * Optional. An optional CRC32C checksum of the
     * [MacVerifyRequest.data][google.cloud.kms.v1.MacVerifyRequest.data]. If
     * specified, [KeyManagementService][google.cloud.kms.v1.KeyManagementService]
     * will verify the integrity of the received
     * [MacVerifyRequest.data][google.cloud.kms.v1.MacVerifyRequest.data] using
     * this checksum.
     * [KeyManagementService][google.cloud.kms.v1.KeyManagementService] will
     * report an error if the checksum verification fails. If you receive a
     * checksum error, your client should verify that
     * CRC32C([MacVerifyRequest.data][google.cloud.kms.v1.MacVerifyRequest.data])
     * is equal to
     * [MacVerifyRequest.data_crc32c][google.cloud.kms.v1.MacVerifyRequest.data_crc32c],
     * and if so, perform a limited number of retries. A persistent mismatch may
     * indicate an issue in your computation of the CRC32C checksum. Note: This
     * field is defined as int64 for reasons of compatibility across different
     * languages. However, it is a non-negative integer, which will never exceed
     * 2^32-1, and can be safely downconverted to uint32 in languages that support
     * this type.
     *
     * Generated from protobuf field <code>.google.protobuf.Int64Value data_crc32c = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Int64Value|null
     */
    public function getDataCrc32C()
    {
        return $this->data_crc32c;
    }

    public function hasDataCrc32C()
    {
        return isset($this->data_crc32c);
    }

    public function clearDataCrc32C()
    {
        unset($this->data_crc32c);
    }

    /**
     * Returns the unboxed value from <code>getDataCrc32C()</code>

     * Optional. An optional CRC32C checksum of the
     * [MacVerifyRequest.data][google.cloud.kms.v1.MacVerifyRequest.data]. If
     * specified, [KeyManagementService][google.cloud.kms.v1.KeyManagementService]
     * will verify the integrity of the received
     * [MacVerifyRequest.data][google.cloud.kms.v1.MacVerifyRequest.data] using
     * this checksum.
     * [KeyManagementService][google.cloud.kms.v1.KeyManagementService] will
     * report an error if the checksum verification fails. If you receive a
     * checksum error, your client should verify that
     * CRC32C([MacVerifyRequest.data][google.cloud.kms.v1.MacVerifyRequest.data])
     * is equal to
     * [MacVerifyRequest.data_crc32c][google.cloud.kms.v1.MacVerifyRequest.data_crc32c],
     * and if so, perform a limited number of retries. A persistent mismatch may
     * indicate an issue in your computation of the CRC32C checksum. Note: This
     * field is defined as int64 for reasons of compatibility across different
     * languages. However, it is a non-negative integer, which will never exceed
     * 2^32-1, and can be safely downconverted to uint32 in languages that support
     * this type.
     *
     * Generated from protobuf field <code>.google.protobuf.Int64Value data_crc32c = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int|string|null
     */
    public function getDataCrc32CUnwrapped()
    {
        return $this->readWrapperValue("data_crc32c");
    }

    /**
     * Optional. An optional CRC32C checksum of the
     * [MacVerifyRequest.data][google.cloud.kms.v1.MacVerifyRequest.data]. If
     * specified, [KeyManagementService][google.cloud.kms.v1.KeyManagementService]
     * will verify the integrity of the received
     * [MacVerifyRequest.data][google.cloud.kms.v1.MacVerifyRequest.data] using
     * this checksum.
     * [KeyManagementService][google.cloud.kms.v1.KeyManagementService] will
     * report an error if the checksum verification fails. If you receive a
     * checksum error, your client should verify that
     * CRC32C([MacVerifyRequest.data][google.cloud.kms.v1.MacVerifyRequest.data])
     * is equal to
     * [MacVerifyRequest.data_crc32c][google.cloud.kms.v1.MacVerifyRequest.data_crc32c],
     * and if so, perform a limited number of retries. A persistent mismatch may
     * indicate an issue in your computation of the CRC32C checksum. Note: This
     * field is defined as int64 for reasons of compatibility across different
     * languages. However, it is a non-negative integer, which will never exceed
     * 2^32-1, and can be safely downconverted to uint32 in languages that support
     * this type.
     *
     * Generated from protobuf field <code>.google.protobuf.Int64Value data_crc32c = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Protobuf\Int64Value $var
     * @return $this
     */
    public function setDataCrc32C($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Int64Value::class);
        $this->data_crc32c = $var;

        return $this;
    }

    /**
     * Sets the field by wrapping a primitive type in a Google\Protobuf\Int64Value object.

     * Optional. An optional CRC32C checksum of the
     * [MacVerifyRequest.data][google.cloud.kms.v1.MacVerifyRequest.data]. If
     * specified, [KeyManagementService][google.cloud.kms.v1.KeyManagementService]
     * will verify the integrity of the received
     * [MacVerifyRequest.data][google.cloud.kms.v1.MacVerifyRequest.data] using
     * this checksum.
     * [KeyManagementService][google.cloud.kms.v1.KeyManagementService] will
     * report an error if the checksum verification fails. If you receive a
     * checksum error, your client should verify that
     * CRC32C([MacVerifyRequest.data][google.cloud.kms.v1.MacVerifyRequest.data])
     * is equal to
     * [MacVerifyRequest.data_crc32c][google.cloud.kms.v1.MacVerifyRequest.data_crc32c],
     * and if so, perform a limited number of retries. A persistent mismatch may
     * indicate an issue in your computation of the CRC32C checksum. Note: This
     * field is defined as int64 for reasons of compatibility across different
     * languages. However, it is a non-negative integer, which will never exceed
     * 2^32-1, and can be safely downconverted to uint32 in languages that support
     * this type.
     *
     * Generated from protobuf field <code>.google.protobuf.Int64Value data_crc32c = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int|string|null $var
     * @return $this
     */
    public function setDataCrc32CUnwrapped($var)
    {
        $this->writeWrapperValue("data_crc32c", $var);
        return $this;}

    /**
     * Required. The signature to verify.
     *
     * Generated from protobuf field <code>bytes mac = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getMac()
    {
        return $this->mac;
    }

    /**
     * Required. The signature to verify.
     *
     * Generated from protobuf field <code>bytes mac = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setMac($var)
    {
        GPBUtil::checkString($var, False);
        $this->mac = $var;

        return $this;
    }

    /**
     * Optional. An optional CRC32C checksum of the
     * [MacVerifyRequest.mac][google.cloud.kms.v1.MacVerifyRequest.mac]. If
     * specified, [KeyManagementService][google.cloud.kms.v1.KeyManagementService]
     * will verify the integrity of the received
     * [MacVerifyRequest.mac][google.cloud.kms.v1.MacVerifyRequest.mac] using this
     * checksum. [KeyManagementService][google.cloud.kms.v1.KeyManagementService]
     * will report an error if the checksum verification fails. If you receive a
     * checksum error, your client should verify that
     * CRC32C([MacVerifyRequest.tag][]) is equal to
     * [MacVerifyRequest.mac_crc32c][google.cloud.kms.v1.MacVerifyRequest.mac_crc32c],
     * and if so, perform a limited number of retries. A persistent mismatch may
     * indicate an issue in your computation of the CRC32C checksum. Note: This
     * field is defined as int64 for reasons of compatibility across different
     * languages. However, it is a non-negative integer, which will never exceed
     * 2^32-1, and can be safely downconverted to uint32 in languages that support
     * this type.
     *
     * Generated from protobuf field <code>.google.protobuf.Int64Value mac_crc32c = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Int64Value|null
     */
    public function getMacCrc32C()
    {
        return $this->mac_crc32c;
    }

    public function hasMacCrc32C()
    {
        return isset($this->mac_crc32c);
    }

    public function clearMacCrc32C()
    {
        unset($this->mac_crc32c);
    }

    /**
     * Returns the unboxed value from <code>getMacCrc32C()</code>

     * Optional. An optional CRC32C checksum of the
     * [MacVerifyRequest.mac][google.cloud.kms.v1.MacVerifyRequest.mac]. If
     * specified, [KeyManagementService][google.cloud.kms.v1.KeyManagementService]
     * will verify the integrity of the received
     * [MacVerifyRequest.mac][google.cloud.kms.v1.MacVerifyRequest.mac] using this
     * checksum. [KeyManagementService][google.cloud.kms.v1.KeyManagementService]
     * will report an error if the checksum verification fails. If you receive a
     * checksum error, your client should verify that
     * CRC32C([MacVerifyRequest.tag][]) is equal to
     * [MacVerifyRequest.mac_crc32c][google.cloud.kms.v1.MacVerifyRequest.mac_crc32c],
     * and if so, perform a limited number of retries. A persistent mismatch may
     * indicate an issue in your computation of the CRC32C checksum. Note: This
     * field is defined as int64 for reasons of compatibility across different
     * languages. However, it is a non-negative integer, which will never exceed
     * 2^32-1, and can be safely downconverted to uint32 in languages that support
     * this type.
     *
     * Generated from protobuf field <code>.google.protobuf.Int64Value mac_crc32c = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int|string|null
     */
    public function getMacCrc32CUnwrapped()
    {
        return $this->readWrapperValue("mac_crc32c");
    }

    /**
     * Optional. An optional CRC32C checksum of the
     * [MacVerifyRequest.mac][google.cloud.kms.v1.MacVerifyRequest.mac]. If
     * specified, [KeyManagementService][google.cloud.kms.v1.KeyManagementService]
     * will verify the integrity of the received
     * [MacVerifyRequest.mac][google.cloud.kms.v1.MacVerifyRequest.mac] using this
     * checksum. [KeyManagementService][google.cloud.kms.v1.KeyManagementService]
     * will report an error if the checksum verification fails. If you receive a
     * checksum error, your client should verify that
     * CRC32C([MacVerifyRequest.tag][]) is equal to
     * [MacVerifyRequest.mac_crc32c][google.cloud.kms.v1.MacVerifyRequest.mac_crc32c],
     * and if so, perform a limited number of retries. A persistent mismatch may
     * indicate an issue in your computation of the CRC32C checksum. Note: This
     * field is defined as int64 for reasons of compatibility across different
     * languages. However, it is a non-negative integer, which will never exceed
     * 2^32-1, and can be safely downconverted to uint32 in languages that support
     * this type.
     *
     * Generated from protobuf field <code>.google.protobuf.Int64Value mac_crc32c = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Protobuf\Int64Value $var
     * @return $this
     */
    public function setMacCrc32C($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Int64Value::class);
        $this->mac_crc32c = $var;

        return $this;
    }

    /**
     * Sets the field by wrapping a primitive type in a Google\Protobuf\Int64Value object.

     * Optional. An optional CRC32C checksum of the
     * [MacVerifyRequest.mac][google.cloud.kms.v1.MacVerifyRequest.mac]. If
     * specified, [KeyManagementService][google.cloud.kms.v1.KeyManagementService]
     * will verify the integrity of the received
     * [MacVerifyRequest.mac][google.cloud.kms.v1.MacVerifyRequest.mac] using this
     * checksum. [KeyManagementService][google.cloud.kms.v1.KeyManagementService]
     * will report an error if the checksum verification fails. If you receive a
     * checksum error, your client should verify that
     * CRC32C([MacVerifyRequest.tag][]) is equal to
     * [MacVerifyRequest.mac_crc32c][google.cloud.kms.v1.MacVerifyRequest.mac_crc32c],
     * and if so, perform a limited number of retries. A persistent mismatch may
     * indicate an issue in your computation of the CRC32C checksum. Note: This
     * field is defined as int64 for reasons of compatibility across different
     * languages. However, it is a non-negative integer, which will never exceed
     * 2^32-1, and can be safely downconverted to uint32 in languages that support
     * this type.
     *
     * Generated from protobuf field <code>.google.protobuf.Int64Value mac_crc32c = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int|string|null $var
     * @return $this
     */
    public function setMacCrc32CUnwrapped($var)
    {
        $this->writeWrapperValue("mac_crc32c", $var);
        return $this;}

}

