<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/language/v2/language_service.proto

namespace Google\Cloud\Language\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The sentiment analysis response message.
 *
 * Generated from protobuf message <code>google.cloud.language.v2.AnalyzeSentimentResponse</code>
 */
class AnalyzeSentimentResponse extends \Google\Protobuf\Internal\Message
{
    /**
     * The overall sentiment of the input document.
     *
     * Generated from protobuf field <code>.google.cloud.language.v2.Sentiment document_sentiment = 1;</code>
     */
    private $document_sentiment = null;
    /**
     * The language of the text, which will be the same as the language specified
     * in the request or, if not specified, the automatically-detected language.
     * See [Document.language][] field for more details.
     *
     * Generated from protobuf field <code>string language_code = 2;</code>
     */
    private $language_code = '';
    /**
     * The sentiment for all the sentences in the document.
     *
     * Generated from protobuf field <code>repeated .google.cloud.language.v2.Sentence sentences = 3;</code>
     */
    private $sentences;
    /**
     * Whether the language is officially supported. The API may still return a
     * response when the language is not supported, but it is on a best effort
     * basis.
     *
     * Generated from protobuf field <code>bool language_supported = 4;</code>
     */
    private $language_supported = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\Language\V2\Sentiment $document_sentiment
     *           The overall sentiment of the input document.
     *     @type string $language_code
     *           The language of the text, which will be the same as the language specified
     *           in the request or, if not specified, the automatically-detected language.
     *           See [Document.language][] field for more details.
     *     @type array<\Google\Cloud\Language\V2\Sentence>|\Google\Protobuf\Internal\RepeatedField $sentences
     *           The sentiment for all the sentences in the document.
     *     @type bool $language_supported
     *           Whether the language is officially supported. The API may still return a
     *           response when the language is not supported, but it is on a best effort
     *           basis.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Language\V2\LanguageService::initOnce();
        parent::__construct($data);
    }

    /**
     * The overall sentiment of the input document.
     *
     * Generated from protobuf field <code>.google.cloud.language.v2.Sentiment document_sentiment = 1;</code>
     * @return \Google\Cloud\Language\V2\Sentiment|null
     */
    public function getDocumentSentiment()
    {
        return $this->document_sentiment;
    }

    public function hasDocumentSentiment()
    {
        return isset($this->document_sentiment);
    }

    public function clearDocumentSentiment()
    {
        unset($this->document_sentiment);
    }

    /**
     * The overall sentiment of the input document.
     *
     * Generated from protobuf field <code>.google.cloud.language.v2.Sentiment document_sentiment = 1;</code>
     * @param \Google\Cloud\Language\V2\Sentiment $var
     * @return $this
     */
    public function setDocumentSentiment($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Language\V2\Sentiment::class);
        $this->document_sentiment = $var;

        return $this;
    }

    /**
     * The language of the text, which will be the same as the language specified
     * in the request or, if not specified, the automatically-detected language.
     * See [Document.language][] field for more details.
     *
     * Generated from protobuf field <code>string language_code = 2;</code>
     * @return string
     */
    public function getLanguageCode()
    {
        return $this->language_code;
    }

    /**
     * The language of the text, which will be the same as the language specified
     * in the request or, if not specified, the automatically-detected language.
     * See [Document.language][] field for more details.
     *
     * Generated from protobuf field <code>string language_code = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setLanguageCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->language_code = $var;

        return $this;
    }

    /**
     * The sentiment for all the sentences in the document.
     *
     * Generated from protobuf field <code>repeated .google.cloud.language.v2.Sentence sentences = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSentences()
    {
        return $this->sentences;
    }

    /**
     * The sentiment for all the sentences in the document.
     *
     * Generated from protobuf field <code>repeated .google.cloud.language.v2.Sentence sentences = 3;</code>
     * @param array<\Google\Cloud\Language\V2\Sentence>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSentences($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Language\V2\Sentence::class);
        $this->sentences = $arr;

        return $this;
    }

    /**
     * Whether the language is officially supported. The API may still return a
     * response when the language is not supported, but it is on a best effort
     * basis.
     *
     * Generated from protobuf field <code>bool language_supported = 4;</code>
     * @return bool
     */
    public function getLanguageSupported()
    {
        return $this->language_supported;
    }

    /**
     * Whether the language is officially supported. The API may still return a
     * response when the language is not supported, but it is on a best effort
     * basis.
     *
     * Generated from protobuf field <code>bool language_supported = 4;</code>
     * @param bool $var
     * @return $this
     */
    public function setLanguageSupported($var)
    {
        GPBUtil::checkBool($var);
        $this->language_supported = $var;

        return $this;
    }

}

