<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/logging/v2/logging_config.proto

namespace Google\Cloud\Logging\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The parameters to
 * [GetSettings][google.logging.v2.ConfigServiceV2.GetSettings].
 * See [Enabling CMEK for Log
 * Router](https://cloud.google.com/logging/docs/routing/managed-encryption) for
 * more information.
 *
 * Generated from protobuf message <code>google.logging.v2.GetSettingsRequest</code>
 */
class GetSettingsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource for which to retrieve settings.
     *     "projects/[PROJECT_ID]/settings"
     *     "organizations/[ORGANIZATION_ID]/settings"
     *     "billingAccounts/[BILLING_ACCOUNT_ID]/settings"
     *     "folders/[FOLDER_ID]/settings"
     * For example:
     *   `"organizations/12345/settings"`
     * Note: Settings for the Log Router can be get for Google Cloud projects,
     * folders, organizations and billing accounts. Currently it can only be
     * configured for organizations. Once configured for an organization, it
     * applies to all projects and folders in the Google Cloud organization.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $name = '';

    /**
     * @param string $name Required. The resource for which to retrieve settings.
     *
     *                     "projects/[PROJECT_ID]/settings"
     *                     "organizations/[ORGANIZATION_ID]/settings"
     *                     "billingAccounts/[BILLING_ACCOUNT_ID]/settings"
     *                     "folders/[FOLDER_ID]/settings"
     *
     *                     For example:
     *
     *                     `"organizations/12345/settings"`
     *
     *                     Note: Settings for the Log Router can be get for Google Cloud projects,
     *                     folders, organizations and billing accounts. Currently it can only be
     *                     configured for organizations. Once configured for an organization, it
     *                     applies to all projects and folders in the Google Cloud organization. Please see
     *                     {@see ConfigServiceV2Client::settingsName()} for help formatting this field.
     *
     * @return \Google\Cloud\Logging\V2\GetSettingsRequest
     *
     * @experimental
     */
    public static function build(string $name): self
    {
        return (new self())
            ->setName($name);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. The resource for which to retrieve settings.
     *               "projects/[PROJECT_ID]/settings"
     *               "organizations/[ORGANIZATION_ID]/settings"
     *               "billingAccounts/[BILLING_ACCOUNT_ID]/settings"
     *               "folders/[FOLDER_ID]/settings"
     *           For example:
     *             `"organizations/12345/settings"`
     *           Note: Settings for the Log Router can be get for Google Cloud projects,
     *           folders, organizations and billing accounts. Currently it can only be
     *           configured for organizations. Once configured for an organization, it
     *           applies to all projects and folders in the Google Cloud organization.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Logging\V2\LoggingConfig::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource for which to retrieve settings.
     *     "projects/[PROJECT_ID]/settings"
     *     "organizations/[ORGANIZATION_ID]/settings"
     *     "billingAccounts/[BILLING_ACCOUNT_ID]/settings"
     *     "folders/[FOLDER_ID]/settings"
     * For example:
     *   `"organizations/12345/settings"`
     * Note: Settings for the Log Router can be get for Google Cloud projects,
     * folders, organizations and billing accounts. Currently it can only be
     * configured for organizations. Once configured for an organization, it
     * applies to all projects and folders in the Google Cloud organization.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. The resource for which to retrieve settings.
     *     "projects/[PROJECT_ID]/settings"
     *     "organizations/[ORGANIZATION_ID]/settings"
     *     "billingAccounts/[BILLING_ACCOUNT_ID]/settings"
     *     "folders/[FOLDER_ID]/settings"
     * For example:
     *   `"organizations/12345/settings"`
     * Note: Settings for the Log Router can be get for Google Cloud projects,
     * folders, organizations and billing accounts. Currently it can only be
     * configured for organizations. Once configured for an organization, it
     * applies to all projects and folders in the Google Cloud organization.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

}

