<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/managedkafka/v1/resources.proto

namespace Google\Cloud\ManagedKafka\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A Kafka consumer group in a given cluster.
 *
 * Generated from protobuf message <code>google.cloud.managedkafka.v1.ConsumerGroup</code>
 */
class ConsumerGroup extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. The name of the consumer group. The `consumer_group` segment is
     * used when connecting directly to the cluster. Structured like:
     * projects/{project}/locations/{location}/clusters/{cluster}/consumerGroups/{consumer_group}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Optional. Metadata for this consumer group for all topics it has metadata
     * for. The key of the map is a topic name, structured like:
     * projects/{project}/locations/{location}/clusters/{cluster}/topics/{topic}
     *
     * Generated from protobuf field <code>map<string, .google.cloud.managedkafka.v1.ConsumerTopicMetadata> topics = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $topics;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. The name of the consumer group. The `consumer_group` segment is
     *           used when connecting directly to the cluster. Structured like:
     *           projects/{project}/locations/{location}/clusters/{cluster}/consumerGroups/{consumer_group}
     *     @type array|\Google\Protobuf\Internal\MapField $topics
     *           Optional. Metadata for this consumer group for all topics it has metadata
     *           for. The key of the map is a topic name, structured like:
     *           projects/{project}/locations/{location}/clusters/{cluster}/topics/{topic}
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Managedkafka\V1\Resources::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. The name of the consumer group. The `consumer_group` segment is
     * used when connecting directly to the cluster. Structured like:
     * projects/{project}/locations/{location}/clusters/{cluster}/consumerGroups/{consumer_group}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. The name of the consumer group. The `consumer_group` segment is
     * used when connecting directly to the cluster. Structured like:
     * projects/{project}/locations/{location}/clusters/{cluster}/consumerGroups/{consumer_group}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Optional. Metadata for this consumer group for all topics it has metadata
     * for. The key of the map is a topic name, structured like:
     * projects/{project}/locations/{location}/clusters/{cluster}/topics/{topic}
     *
     * Generated from protobuf field <code>map<string, .google.cloud.managedkafka.v1.ConsumerTopicMetadata> topics = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getTopics()
    {
        return $this->topics;
    }

    /**
     * Optional. Metadata for this consumer group for all topics it has metadata
     * for. The key of the map is a topic name, structured like:
     * projects/{project}/locations/{location}/clusters/{cluster}/topics/{topic}
     *
     * Generated from protobuf field <code>map<string, .google.cloud.managedkafka.v1.ConsumerTopicMetadata> topics = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setTopics($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\ManagedKafka\V1\ConsumerTopicMetadata::class);
        $this->topics = $arr;

        return $this;
    }

}

