<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/managedkafka/v1/resources.proto

namespace Google\Cloud\ManagedKafka\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The configuration of a Virtual Private Cloud (VPC) network that can access
 * the Kafka cluster.
 *
 * Generated from protobuf message <code>google.cloud.managedkafka.v1.NetworkConfig</code>
 */
class NetworkConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Name of the VPC subnet in which to create Private Service Connect
     * (PSC) endpoints for the Kafka brokers and bootstrap address. Structured
     * like: projects/{project}/regions/{region}/subnetworks/{subnet_id}
     * The subnet must be located in the same region as the Kafka cluster. The
     * project may differ. Multiple subnets from the same parent network must not
     * be specified.
     * The CIDR range of the subnet must be within the IPv4 address ranges for
     * private networks, as specified in RFC 1918.
     *
     * Generated from protobuf field <code>string subnet = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $subnet = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $subnet
     *           Required. Name of the VPC subnet in which to create Private Service Connect
     *           (PSC) endpoints for the Kafka brokers and bootstrap address. Structured
     *           like: projects/{project}/regions/{region}/subnetworks/{subnet_id}
     *           The subnet must be located in the same region as the Kafka cluster. The
     *           project may differ. Multiple subnets from the same parent network must not
     *           be specified.
     *           The CIDR range of the subnet must be within the IPv4 address ranges for
     *           private networks, as specified in RFC 1918.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Managedkafka\V1\Resources::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Name of the VPC subnet in which to create Private Service Connect
     * (PSC) endpoints for the Kafka brokers and bootstrap address. Structured
     * like: projects/{project}/regions/{region}/subnetworks/{subnet_id}
     * The subnet must be located in the same region as the Kafka cluster. The
     * project may differ. Multiple subnets from the same parent network must not
     * be specified.
     * The CIDR range of the subnet must be within the IPv4 address ranges for
     * private networks, as specified in RFC 1918.
     *
     * Generated from protobuf field <code>string subnet = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getSubnet()
    {
        return $this->subnet;
    }

    /**
     * Required. Name of the VPC subnet in which to create Private Service Connect
     * (PSC) endpoints for the Kafka brokers and bootstrap address. Structured
     * like: projects/{project}/regions/{region}/subnetworks/{subnet_id}
     * The subnet must be located in the same region as the Kafka cluster. The
     * project may differ. Multiple subnets from the same parent network must not
     * be specified.
     * The CIDR range of the subnet must be within the IPv4 address ranges for
     * private networks, as specified in RFC 1918.
     *
     * Generated from protobuf field <code>string subnet = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setSubnet($var)
    {
        GPBUtil::checkString($var, True);
        $this->subnet = $var;

        return $this;
    }

}

