<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/maps/fleetengine/delivery/v1/delivery_api.proto

namespace Google\Maps\FleetEngine\Delivery\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The `CreateDeliveryVehicle` request message.
 *
 * Generated from protobuf message <code>maps.fleetengine.delivery.v1.CreateDeliveryVehicleRequest</code>
 */
class CreateDeliveryVehicleRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Optional. The standard Delivery API request header.
     *
     * Generated from protobuf field <code>.maps.fleetengine.delivery.v1.DeliveryRequestHeader header = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $header = null;
    /**
     * Required. Must be in the format `providers/{provider}`. The provider must
     * be the Google Cloud Project ID. For example, `sample-cloud-project`.
     *
     * Generated from protobuf field <code>string parent = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $parent = '';
    /**
     * Required. The Delivery Vehicle ID must be unique and subject to the
     * following restrictions:
     * * Must be a valid Unicode string.
     * * Limited to a maximum length of 64 characters.
     * * Normalized according to [Unicode Normalization Form C]
     * (http://www.unicode.org/reports/tr15/).
     * * May not contain any of the following ASCII characters: '/', ':', '?',
     * ',', or '#'.
     *
     * Generated from protobuf field <code>string delivery_vehicle_id = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $delivery_vehicle_id = '';
    /**
     * Required. The `DeliveryVehicle` entity to create. When creating a new
     * delivery vehicle, you may set the following optional fields:
     * * type
     * * last_location
     * * attributes
     * Note: The DeliveryVehicle's `name` field is ignored. All other
     * DeliveryVehicle fields must not be set; otherwise, an error is returned.
     *
     * Generated from protobuf field <code>.maps.fleetengine.delivery.v1.DeliveryVehicle delivery_vehicle = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $delivery_vehicle = null;

    /**
     * @param string                                               $parent            Required. Must be in the format `providers/{provider}`. The provider must
     *                                                                                be the Google Cloud Project ID. For example, `sample-cloud-project`.
     * @param \Google\Maps\FleetEngine\Delivery\V1\DeliveryVehicle $deliveryVehicle   Required. The `DeliveryVehicle` entity to create. When creating a new
     *                                                                                delivery vehicle, you may set the following optional fields:
     *
     *                                                                                * type
     *                                                                                * last_location
     *                                                                                * attributes
     *
     *                                                                                Note: The DeliveryVehicle's `name` field is ignored. All other
     *                                                                                DeliveryVehicle fields must not be set; otherwise, an error is returned.
     * @param string                                               $deliveryVehicleId Required. The Delivery Vehicle ID must be unique and subject to the
     *                                                                                following restrictions:
     *
     *                                                                                * Must be a valid Unicode string.
     *                                                                                * Limited to a maximum length of 64 characters.
     *                                                                                * Normalized according to [Unicode Normalization Form C]
     *                                                                                (http://www.unicode.org/reports/tr15/).
     *                                                                                * May not contain any of the following ASCII characters: '/', ':', '?',
     *                                                                                ',', or '#'.
     *
     * @return \Google\Maps\FleetEngine\Delivery\V1\CreateDeliveryVehicleRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Maps\FleetEngine\Delivery\V1\DeliveryVehicle $deliveryVehicle, string $deliveryVehicleId): self
    {
        return (new self())
            ->setParent($parent)
            ->setDeliveryVehicle($deliveryVehicle)
            ->setDeliveryVehicleId($deliveryVehicleId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Maps\FleetEngine\Delivery\V1\DeliveryRequestHeader $header
     *           Optional. The standard Delivery API request header.
     *     @type string $parent
     *           Required. Must be in the format `providers/{provider}`. The provider must
     *           be the Google Cloud Project ID. For example, `sample-cloud-project`.
     *     @type string $delivery_vehicle_id
     *           Required. The Delivery Vehicle ID must be unique and subject to the
     *           following restrictions:
     *           * Must be a valid Unicode string.
     *           * Limited to a maximum length of 64 characters.
     *           * Normalized according to [Unicode Normalization Form C]
     *           (http://www.unicode.org/reports/tr15/).
     *           * May not contain any of the following ASCII characters: '/', ':', '?',
     *           ',', or '#'.
     *     @type \Google\Maps\FleetEngine\Delivery\V1\DeliveryVehicle $delivery_vehicle
     *           Required. The `DeliveryVehicle` entity to create. When creating a new
     *           delivery vehicle, you may set the following optional fields:
     *           * type
     *           * last_location
     *           * attributes
     *           Note: The DeliveryVehicle's `name` field is ignored. All other
     *           DeliveryVehicle fields must not be set; otherwise, an error is returned.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Maps\Fleetengine\Delivery\V1\DeliveryApi::initOnce();
        parent::__construct($data);
    }

    /**
     * Optional. The standard Delivery API request header.
     *
     * Generated from protobuf field <code>.maps.fleetengine.delivery.v1.DeliveryRequestHeader header = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Maps\FleetEngine\Delivery\V1\DeliveryRequestHeader|null
     */
    public function getHeader()
    {
        return $this->header;
    }

    public function hasHeader()
    {
        return isset($this->header);
    }

    public function clearHeader()
    {
        unset($this->header);
    }

    /**
     * Optional. The standard Delivery API request header.
     *
     * Generated from protobuf field <code>.maps.fleetengine.delivery.v1.DeliveryRequestHeader header = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Maps\FleetEngine\Delivery\V1\DeliveryRequestHeader $var
     * @return $this
     */
    public function setHeader($var)
    {
        GPBUtil::checkMessage($var, \Google\Maps\FleetEngine\Delivery\V1\DeliveryRequestHeader::class);
        $this->header = $var;

        return $this;
    }

    /**
     * Required. Must be in the format `providers/{provider}`. The provider must
     * be the Google Cloud Project ID. For example, `sample-cloud-project`.
     *
     * Generated from protobuf field <code>string parent = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Must be in the format `providers/{provider}`. The provider must
     * be the Google Cloud Project ID. For example, `sample-cloud-project`.
     *
     * Generated from protobuf field <code>string parent = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The Delivery Vehicle ID must be unique and subject to the
     * following restrictions:
     * * Must be a valid Unicode string.
     * * Limited to a maximum length of 64 characters.
     * * Normalized according to [Unicode Normalization Form C]
     * (http://www.unicode.org/reports/tr15/).
     * * May not contain any of the following ASCII characters: '/', ':', '?',
     * ',', or '#'.
     *
     * Generated from protobuf field <code>string delivery_vehicle_id = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getDeliveryVehicleId()
    {
        return $this->delivery_vehicle_id;
    }

    /**
     * Required. The Delivery Vehicle ID must be unique and subject to the
     * following restrictions:
     * * Must be a valid Unicode string.
     * * Limited to a maximum length of 64 characters.
     * * Normalized according to [Unicode Normalization Form C]
     * (http://www.unicode.org/reports/tr15/).
     * * May not contain any of the following ASCII characters: '/', ':', '?',
     * ',', or '#'.
     *
     * Generated from protobuf field <code>string delivery_vehicle_id = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setDeliveryVehicleId($var)
    {
        GPBUtil::checkString($var, True);
        $this->delivery_vehicle_id = $var;

        return $this;
    }

    /**
     * Required. The `DeliveryVehicle` entity to create. When creating a new
     * delivery vehicle, you may set the following optional fields:
     * * type
     * * last_location
     * * attributes
     * Note: The DeliveryVehicle's `name` field is ignored. All other
     * DeliveryVehicle fields must not be set; otherwise, an error is returned.
     *
     * Generated from protobuf field <code>.maps.fleetengine.delivery.v1.DeliveryVehicle delivery_vehicle = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Maps\FleetEngine\Delivery\V1\DeliveryVehicle|null
     */
    public function getDeliveryVehicle()
    {
        return $this->delivery_vehicle;
    }

    public function hasDeliveryVehicle()
    {
        return isset($this->delivery_vehicle);
    }

    public function clearDeliveryVehicle()
    {
        unset($this->delivery_vehicle);
    }

    /**
     * Required. The `DeliveryVehicle` entity to create. When creating a new
     * delivery vehicle, you may set the following optional fields:
     * * type
     * * last_location
     * * attributes
     * Note: The DeliveryVehicle's `name` field is ignored. All other
     * DeliveryVehicle fields must not be set; otherwise, an error is returned.
     *
     * Generated from protobuf field <code>.maps.fleetengine.delivery.v1.DeliveryVehicle delivery_vehicle = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Maps\FleetEngine\Delivery\V1\DeliveryVehicle $var
     * @return $this
     */
    public function setDeliveryVehicle($var)
    {
        GPBUtil::checkMessage($var, \Google\Maps\FleetEngine\Delivery\V1\DeliveryVehicle::class);
        $this->delivery_vehicle = $var;

        return $this;
    }

}

