<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/maps/fleetengine/delivery/v1/delivery_api.proto

namespace Google\Maps\FleetEngine\Delivery\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The `ListDeliveryVehicles` request message.
 *
 * Generated from protobuf message <code>maps.fleetengine.delivery.v1.ListDeliveryVehiclesRequest</code>
 */
class ListDeliveryVehiclesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Optional. The standard Delivery API request header.
     *
     * Generated from protobuf field <code>.maps.fleetengine.delivery.v1.DeliveryRequestHeader header = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $header = null;
    /**
     * Required. Must be in the format `providers/{provider}`.
     * The `provider` must be the Google Cloud Project ID.
     * For example, `sample-cloud-project`.
     *
     * Generated from protobuf field <code>string parent = 3 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. The maximum number of vehicles to return. The service may return
     * fewer than this number. If you don't specify this number, then the server
     * determines the number of results to return.
     *
     * Generated from protobuf field <code>int32 page_size = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. A page token, received from a previous `ListDeliveryVehicles`
     * call. You must provide this in order to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListDeliveryVehicles`
     * must match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';
    /**
     * Optional. A filter query to apply when listing delivery vehicles. See
     * http://aip.dev/160 for examples of the filter syntax. If you don't specify
     * a value, or if you specify an empty string for the filter, then all
     * delivery vehicles are returned.
     * Note that the only queries supported for `ListDeliveryVehicles` are
     * on vehicle attributes (for example, `attributes.<key> = <value>` or
     * `attributes.<key1> = <value1> AND attributes.<key2> = <value2>`). Also, all
     * attributes are stored as strings, so the only supported comparisons against
     * attributes are string comparisons. In order to compare against number or
     * boolean values, the values must be explicitly quoted to be treated as
     * strings (for example, `attributes.<key> = "10"` or
     * `attributes.<key> = "true"`).
     * The maximum number of restrictions allowed in a filter query is 50. A
     * restriction is a part of the query of the form
     * `attribute.<KEY> <COMPARATOR> <VALUE>`, for example `attributes.foo = bar`
     * is 1 restriction.
     *
     * Generated from protobuf field <code>string filter = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $filter = '';
    /**
     * Optional. A filter that limits the vehicles returned to those whose last
     * known location was in the rectangular area defined by the viewport.
     *
     * Generated from protobuf field <code>.google.geo.type.Viewport viewport = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $viewport = null;

    /**
     * @param string $parent Required. Must be in the format `providers/{provider}`.
     *                       The `provider` must be the Google Cloud Project ID.
     *                       For example, `sample-cloud-project`. Please see
     *                       {@see DeliveryServiceClient::providerName()} for help formatting this field.
     *
     * @return \Google\Maps\FleetEngine\Delivery\V1\ListDeliveryVehiclesRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Maps\FleetEngine\Delivery\V1\DeliveryRequestHeader $header
     *           Optional. The standard Delivery API request header.
     *     @type string $parent
     *           Required. Must be in the format `providers/{provider}`.
     *           The `provider` must be the Google Cloud Project ID.
     *           For example, `sample-cloud-project`.
     *     @type int $page_size
     *           Optional. The maximum number of vehicles to return. The service may return
     *           fewer than this number. If you don't specify this number, then the server
     *           determines the number of results to return.
     *     @type string $page_token
     *           Optional. A page token, received from a previous `ListDeliveryVehicles`
     *           call. You must provide this in order to retrieve the subsequent page.
     *           When paginating, all other parameters provided to `ListDeliveryVehicles`
     *           must match the call that provided the page token.
     *     @type string $filter
     *           Optional. A filter query to apply when listing delivery vehicles. See
     *           http://aip.dev/160 for examples of the filter syntax. If you don't specify
     *           a value, or if you specify an empty string for the filter, then all
     *           delivery vehicles are returned.
     *           Note that the only queries supported for `ListDeliveryVehicles` are
     *           on vehicle attributes (for example, `attributes.<key> = <value>` or
     *           `attributes.<key1> = <value1> AND attributes.<key2> = <value2>`). Also, all
     *           attributes are stored as strings, so the only supported comparisons against
     *           attributes are string comparisons. In order to compare against number or
     *           boolean values, the values must be explicitly quoted to be treated as
     *           strings (for example, `attributes.<key> = "10"` or
     *           `attributes.<key> = "true"`).
     *           The maximum number of restrictions allowed in a filter query is 50. A
     *           restriction is a part of the query of the form
     *           `attribute.<KEY> <COMPARATOR> <VALUE>`, for example `attributes.foo = bar`
     *           is 1 restriction.
     *     @type \Google\Geo\Type\Viewport $viewport
     *           Optional. A filter that limits the vehicles returned to those whose last
     *           known location was in the rectangular area defined by the viewport.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Maps\Fleetengine\Delivery\V1\DeliveryApi::initOnce();
        parent::__construct($data);
    }

    /**
     * Optional. The standard Delivery API request header.
     *
     * Generated from protobuf field <code>.maps.fleetengine.delivery.v1.DeliveryRequestHeader header = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Maps\FleetEngine\Delivery\V1\DeliveryRequestHeader|null
     */
    public function getHeader()
    {
        return $this->header;
    }

    public function hasHeader()
    {
        return isset($this->header);
    }

    public function clearHeader()
    {
        unset($this->header);
    }

    /**
     * Optional. The standard Delivery API request header.
     *
     * Generated from protobuf field <code>.maps.fleetengine.delivery.v1.DeliveryRequestHeader header = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Maps\FleetEngine\Delivery\V1\DeliveryRequestHeader $var
     * @return $this
     */
    public function setHeader($var)
    {
        GPBUtil::checkMessage($var, \Google\Maps\FleetEngine\Delivery\V1\DeliveryRequestHeader::class);
        $this->header = $var;

        return $this;
    }

    /**
     * Required. Must be in the format `providers/{provider}`.
     * The `provider` must be the Google Cloud Project ID.
     * For example, `sample-cloud-project`.
     *
     * Generated from protobuf field <code>string parent = 3 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Must be in the format `providers/{provider}`.
     * The `provider` must be the Google Cloud Project ID.
     * For example, `sample-cloud-project`.
     *
     * Generated from protobuf field <code>string parent = 3 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. The maximum number of vehicles to return. The service may return
     * fewer than this number. If you don't specify this number, then the server
     * determines the number of results to return.
     *
     * Generated from protobuf field <code>int32 page_size = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. The maximum number of vehicles to return. The service may return
     * fewer than this number. If you don't specify this number, then the server
     * determines the number of results to return.
     *
     * Generated from protobuf field <code>int32 page_size = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. A page token, received from a previous `ListDeliveryVehicles`
     * call. You must provide this in order to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListDeliveryVehicles`
     * must match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. A page token, received from a previous `ListDeliveryVehicles`
     * call. You must provide this in order to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListDeliveryVehicles`
     * must match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. A filter query to apply when listing delivery vehicles. See
     * http://aip.dev/160 for examples of the filter syntax. If you don't specify
     * a value, or if you specify an empty string for the filter, then all
     * delivery vehicles are returned.
     * Note that the only queries supported for `ListDeliveryVehicles` are
     * on vehicle attributes (for example, `attributes.<key> = <value>` or
     * `attributes.<key1> = <value1> AND attributes.<key2> = <value2>`). Also, all
     * attributes are stored as strings, so the only supported comparisons against
     * attributes are string comparisons. In order to compare against number or
     * boolean values, the values must be explicitly quoted to be treated as
     * strings (for example, `attributes.<key> = "10"` or
     * `attributes.<key> = "true"`).
     * The maximum number of restrictions allowed in a filter query is 50. A
     * restriction is a part of the query of the form
     * `attribute.<KEY> <COMPARATOR> <VALUE>`, for example `attributes.foo = bar`
     * is 1 restriction.
     *
     * Generated from protobuf field <code>string filter = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Optional. A filter query to apply when listing delivery vehicles. See
     * http://aip.dev/160 for examples of the filter syntax. If you don't specify
     * a value, or if you specify an empty string for the filter, then all
     * delivery vehicles are returned.
     * Note that the only queries supported for `ListDeliveryVehicles` are
     * on vehicle attributes (for example, `attributes.<key> = <value>` or
     * `attributes.<key1> = <value1> AND attributes.<key2> = <value2>`). Also, all
     * attributes are stored as strings, so the only supported comparisons against
     * attributes are string comparisons. In order to compare against number or
     * boolean values, the values must be explicitly quoted to be treated as
     * strings (for example, `attributes.<key> = "10"` or
     * `attributes.<key> = "true"`).
     * The maximum number of restrictions allowed in a filter query is 50. A
     * restriction is a part of the query of the form
     * `attribute.<KEY> <COMPARATOR> <VALUE>`, for example `attributes.foo = bar`
     * is 1 restriction.
     *
     * Generated from protobuf field <code>string filter = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * Optional. A filter that limits the vehicles returned to those whose last
     * known location was in the rectangular area defined by the viewport.
     *
     * Generated from protobuf field <code>.google.geo.type.Viewport viewport = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Geo\Type\Viewport|null
     */
    public function getViewport()
    {
        return $this->viewport;
    }

    public function hasViewport()
    {
        return isset($this->viewport);
    }

    public function clearViewport()
    {
        unset($this->viewport);
    }

    /**
     * Optional. A filter that limits the vehicles returned to those whose last
     * known location was in the rectangular area defined by the viewport.
     *
     * Generated from protobuf field <code>.google.geo.type.Viewport viewport = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Geo\Type\Viewport $var
     * @return $this
     */
    public function setViewport($var)
    {
        GPBUtil::checkMessage($var, \Google\Geo\Type\Viewport::class);
        $this->viewport = $var;

        return $this;
    }

}

