<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/maps/fleetengine/delivery/v1/delivery_vehicles.proto

namespace Google\Maps\FleetEngine\Delivery\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents a Vehicle’s travel segment - from its previous stop to the
 * current stop. If it is the first active stop, then it is from the
 * Vehicle’s current location to this stop.
 *
 * Generated from protobuf message <code>maps.fleetengine.delivery.v1.VehicleJourneySegment</code>
 */
class VehicleJourneySegment extends \Google\Protobuf\Internal\Message
{
    /**
     * Specifies the stop location, along with the `Task`s associated with
     * the stop. Some fields of the VehicleStop might not be present if this
     * journey segment is part of `JourneySharingInfo`.
     *
     * Generated from protobuf field <code>.maps.fleetengine.delivery.v1.VehicleStop stop = 1;</code>
     */
    protected $stop = null;
    /**
     * Output only. The travel distance from the previous stop to this stop.
     * If the current stop is the first stop in the list of journey
     * segments, then the starting point is the vehicle's location recorded
     * at the time that this stop was added to the list. This field might not be
     * present if this journey segment is part of `JourneySharingInfo`.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value driving_distance_meters = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $driving_distance_meters = null;
    /**
     * Output only. The travel time from the previous stop to this stop.
     * If the current stop is the first stop in the list of journey
     * segments, then the starting point is the Vehicle's location recorded
     * at the time that this stop was added to the list.
     * If this field is defined in the path
     * `Task.remaining_vehicle_journey_segments[0].driving_duration` (gRPC) or
     * `Task.remainingVehicleJourneySegments[0].drivingDuration` (REST),
     * then it may be populated with the value from
     * `DeliveryVehicle.remaining_duration` (gRPC) or
     * `DeliveryVehicle.remainingDuration` (REST).
     * This provides the remaining driving duration from the driver app's latest
     * known location rather than the driving time from the previous stop.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration driving_duration = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $driving_duration = null;
    /**
     * Output only. The path from the previous stop to this stop. If the current
     * stop is the first stop in the list of journey segments, then this is the
     * path from the vehicle's current location to this stop at the time that the
     * stop was added to the list. This field might not be present if this journey
     * segment is part of `JourneySharingInfo`.
     * If this field is defined in the path
     * `Task.journey_sharing_info.remaining_vehicle_journey_segments[0].path`
     * (gRPC) or `Task.journeySharingInfo.remainingVehicleJourneySegments[0].path`
     * (REST), then it may be populated with the `LatLng`s decoded from
     * `DeliveryVehicle.current_route_segment` (gRPC) or
     * `DeliveryVehicle.currentRouteSegment` (REST). This provides the driving
     * path from the driver app's latest known location rather than the path from
     * the previous stop.
     *
     * Generated from protobuf field <code>repeated .google.type.LatLng path = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $path;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Maps\FleetEngine\Delivery\V1\VehicleStop $stop
     *           Specifies the stop location, along with the `Task`s associated with
     *           the stop. Some fields of the VehicleStop might not be present if this
     *           journey segment is part of `JourneySharingInfo`.
     *     @type \Google\Protobuf\Int32Value $driving_distance_meters
     *           Output only. The travel distance from the previous stop to this stop.
     *           If the current stop is the first stop in the list of journey
     *           segments, then the starting point is the vehicle's location recorded
     *           at the time that this stop was added to the list. This field might not be
     *           present if this journey segment is part of `JourneySharingInfo`.
     *     @type \Google\Protobuf\Duration $driving_duration
     *           Output only. The travel time from the previous stop to this stop.
     *           If the current stop is the first stop in the list of journey
     *           segments, then the starting point is the Vehicle's location recorded
     *           at the time that this stop was added to the list.
     *           If this field is defined in the path
     *           `Task.remaining_vehicle_journey_segments[0].driving_duration` (gRPC) or
     *           `Task.remainingVehicleJourneySegments[0].drivingDuration` (REST),
     *           then it may be populated with the value from
     *           `DeliveryVehicle.remaining_duration` (gRPC) or
     *           `DeliveryVehicle.remainingDuration` (REST).
     *           This provides the remaining driving duration from the driver app's latest
     *           known location rather than the driving time from the previous stop.
     *     @type array<\Google\Type\LatLng>|\Google\Protobuf\Internal\RepeatedField $path
     *           Output only. The path from the previous stop to this stop. If the current
     *           stop is the first stop in the list of journey segments, then this is the
     *           path from the vehicle's current location to this stop at the time that the
     *           stop was added to the list. This field might not be present if this journey
     *           segment is part of `JourneySharingInfo`.
     *           If this field is defined in the path
     *           `Task.journey_sharing_info.remaining_vehicle_journey_segments[0].path`
     *           (gRPC) or `Task.journeySharingInfo.remainingVehicleJourneySegments[0].path`
     *           (REST), then it may be populated with the `LatLng`s decoded from
     *           `DeliveryVehicle.current_route_segment` (gRPC) or
     *           `DeliveryVehicle.currentRouteSegment` (REST). This provides the driving
     *           path from the driver app's latest known location rather than the path from
     *           the previous stop.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Maps\Fleetengine\Delivery\V1\DeliveryVehicles::initOnce();
        parent::__construct($data);
    }

    /**
     * Specifies the stop location, along with the `Task`s associated with
     * the stop. Some fields of the VehicleStop might not be present if this
     * journey segment is part of `JourneySharingInfo`.
     *
     * Generated from protobuf field <code>.maps.fleetengine.delivery.v1.VehicleStop stop = 1;</code>
     * @return \Google\Maps\FleetEngine\Delivery\V1\VehicleStop|null
     */
    public function getStop()
    {
        return $this->stop;
    }

    public function hasStop()
    {
        return isset($this->stop);
    }

    public function clearStop()
    {
        unset($this->stop);
    }

    /**
     * Specifies the stop location, along with the `Task`s associated with
     * the stop. Some fields of the VehicleStop might not be present if this
     * journey segment is part of `JourneySharingInfo`.
     *
     * Generated from protobuf field <code>.maps.fleetengine.delivery.v1.VehicleStop stop = 1;</code>
     * @param \Google\Maps\FleetEngine\Delivery\V1\VehicleStop $var
     * @return $this
     */
    public function setStop($var)
    {
        GPBUtil::checkMessage($var, \Google\Maps\FleetEngine\Delivery\V1\VehicleStop::class);
        $this->stop = $var;

        return $this;
    }

    /**
     * Output only. The travel distance from the previous stop to this stop.
     * If the current stop is the first stop in the list of journey
     * segments, then the starting point is the vehicle's location recorded
     * at the time that this stop was added to the list. This field might not be
     * present if this journey segment is part of `JourneySharingInfo`.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value driving_distance_meters = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Int32Value|null
     */
    public function getDrivingDistanceMeters()
    {
        return $this->driving_distance_meters;
    }

    public function hasDrivingDistanceMeters()
    {
        return isset($this->driving_distance_meters);
    }

    public function clearDrivingDistanceMeters()
    {
        unset($this->driving_distance_meters);
    }

    /**
     * Returns the unboxed value from <code>getDrivingDistanceMeters()</code>

     * Output only. The travel distance from the previous stop to this stop.
     * If the current stop is the first stop in the list of journey
     * segments, then the starting point is the vehicle's location recorded
     * at the time that this stop was added to the list. This field might not be
     * present if this journey segment is part of `JourneySharingInfo`.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value driving_distance_meters = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int|null
     */
    public function getDrivingDistanceMetersUnwrapped()
    {
        return $this->readWrapperValue("driving_distance_meters");
    }

    /**
     * Output only. The travel distance from the previous stop to this stop.
     * If the current stop is the first stop in the list of journey
     * segments, then the starting point is the vehicle's location recorded
     * at the time that this stop was added to the list. This field might not be
     * present if this journey segment is part of `JourneySharingInfo`.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value driving_distance_meters = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Int32Value $var
     * @return $this
     */
    public function setDrivingDistanceMeters($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Int32Value::class);
        $this->driving_distance_meters = $var;

        return $this;
    }

    /**
     * Sets the field by wrapping a primitive type in a Google\Protobuf\Int32Value object.

     * Output only. The travel distance from the previous stop to this stop.
     * If the current stop is the first stop in the list of journey
     * segments, then the starting point is the vehicle's location recorded
     * at the time that this stop was added to the list. This field might not be
     * present if this journey segment is part of `JourneySharingInfo`.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value driving_distance_meters = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int|null $var
     * @return $this
     */
    public function setDrivingDistanceMetersUnwrapped($var)
    {
        $this->writeWrapperValue("driving_distance_meters", $var);
        return $this;}

    /**
     * Output only. The travel time from the previous stop to this stop.
     * If the current stop is the first stop in the list of journey
     * segments, then the starting point is the Vehicle's location recorded
     * at the time that this stop was added to the list.
     * If this field is defined in the path
     * `Task.remaining_vehicle_journey_segments[0].driving_duration` (gRPC) or
     * `Task.remainingVehicleJourneySegments[0].drivingDuration` (REST),
     * then it may be populated with the value from
     * `DeliveryVehicle.remaining_duration` (gRPC) or
     * `DeliveryVehicle.remainingDuration` (REST).
     * This provides the remaining driving duration from the driver app's latest
     * known location rather than the driving time from the previous stop.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration driving_duration = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Duration|null
     */
    public function getDrivingDuration()
    {
        return $this->driving_duration;
    }

    public function hasDrivingDuration()
    {
        return isset($this->driving_duration);
    }

    public function clearDrivingDuration()
    {
        unset($this->driving_duration);
    }

    /**
     * Output only. The travel time from the previous stop to this stop.
     * If the current stop is the first stop in the list of journey
     * segments, then the starting point is the Vehicle's location recorded
     * at the time that this stop was added to the list.
     * If this field is defined in the path
     * `Task.remaining_vehicle_journey_segments[0].driving_duration` (gRPC) or
     * `Task.remainingVehicleJourneySegments[0].drivingDuration` (REST),
     * then it may be populated with the value from
     * `DeliveryVehicle.remaining_duration` (gRPC) or
     * `DeliveryVehicle.remainingDuration` (REST).
     * This provides the remaining driving duration from the driver app's latest
     * known location rather than the driving time from the previous stop.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration driving_duration = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Duration $var
     * @return $this
     */
    public function setDrivingDuration($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Duration::class);
        $this->driving_duration = $var;

        return $this;
    }

    /**
     * Output only. The path from the previous stop to this stop. If the current
     * stop is the first stop in the list of journey segments, then this is the
     * path from the vehicle's current location to this stop at the time that the
     * stop was added to the list. This field might not be present if this journey
     * segment is part of `JourneySharingInfo`.
     * If this field is defined in the path
     * `Task.journey_sharing_info.remaining_vehicle_journey_segments[0].path`
     * (gRPC) or `Task.journeySharingInfo.remainingVehicleJourneySegments[0].path`
     * (REST), then it may be populated with the `LatLng`s decoded from
     * `DeliveryVehicle.current_route_segment` (gRPC) or
     * `DeliveryVehicle.currentRouteSegment` (REST). This provides the driving
     * path from the driver app's latest known location rather than the path from
     * the previous stop.
     *
     * Generated from protobuf field <code>repeated .google.type.LatLng path = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getPath()
    {
        return $this->path;
    }

    /**
     * Output only. The path from the previous stop to this stop. If the current
     * stop is the first stop in the list of journey segments, then this is the
     * path from the vehicle's current location to this stop at the time that the
     * stop was added to the list. This field might not be present if this journey
     * segment is part of `JourneySharingInfo`.
     * If this field is defined in the path
     * `Task.journey_sharing_info.remaining_vehicle_journey_segments[0].path`
     * (gRPC) or `Task.journeySharingInfo.remainingVehicleJourneySegments[0].path`
     * (REST), then it may be populated with the `LatLng`s decoded from
     * `DeliveryVehicle.current_route_segment` (gRPC) or
     * `DeliveryVehicle.currentRouteSegment` (REST). This provides the driving
     * path from the driver app's latest known location rather than the path from
     * the previous stop.
     *
     * Generated from protobuf field <code>repeated .google.type.LatLng path = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param array<\Google\Type\LatLng>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setPath($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Type\LatLng::class);
        $this->path = $arr;

        return $this;
    }

}

