<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/migrationcenter/v1/migrationcenter.proto

namespace Google\Cloud\MigrationCenter\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An asset represents a resource in your environment. Asset types include
 * virtual machines and databases.
 *
 * Generated from protobuf message <code>google.cloud.migrationcenter.v1.Asset</code>
 */
class Asset extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The full name of the asset.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $name = '';
    /**
     * Output only. The timestamp when the asset was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. The timestamp when the asset was last updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Labels as key value pairs.
     *
     * Generated from protobuf field <code>map<string, string> labels = 4;</code>
     */
    private $labels;
    /**
     * Generic asset attributes.
     *
     * Generated from protobuf field <code>map<string, string> attributes = 5;</code>
     */
    private $attributes;
    /**
     * Output only. The list of insights associated with the asset.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.InsightList insight_list = 20 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $insight_list = null;
    /**
     * Output only. Performance data for the asset.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.AssetPerformanceData performance_data = 21 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $performance_data = null;
    /**
     * Output only. The list of sources contributing to the asset.
     *
     * Generated from protobuf field <code>repeated string sources = 22 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     */
    private $sources;
    /**
     * Output only. The list of groups that the asset is assigned to.
     *
     * Generated from protobuf field <code>repeated string assigned_groups = 23 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     */
    private $assigned_groups;
    protected $AssetDetails;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. The full name of the asset.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. The timestamp when the asset was created.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. The timestamp when the asset was last updated.
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Labels as key value pairs.
     *     @type array|\Google\Protobuf\Internal\MapField $attributes
     *           Generic asset attributes.
     *     @type \Google\Cloud\MigrationCenter\V1\MachineDetails $machine_details
     *           Output only. Asset information specific for virtual and physical
     *           machines.
     *     @type \Google\Cloud\MigrationCenter\V1\InsightList $insight_list
     *           Output only. The list of insights associated with the asset.
     *     @type \Google\Cloud\MigrationCenter\V1\AssetPerformanceData $performance_data
     *           Output only. Performance data for the asset.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $sources
     *           Output only. The list of sources contributing to the asset.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $assigned_groups
     *           Output only. The list of groups that the asset is assigned to.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Migrationcenter\V1\Migrationcenter::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The full name of the asset.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. The full name of the asset.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. The timestamp when the asset was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. The timestamp when the asset was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. The timestamp when the asset was last updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. The timestamp when the asset was last updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Labels as key value pairs.
     *
     * Generated from protobuf field <code>map<string, string> labels = 4;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Labels as key value pairs.
     *
     * Generated from protobuf field <code>map<string, string> labels = 4;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * Generic asset attributes.
     *
     * Generated from protobuf field <code>map<string, string> attributes = 5;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getAttributes()
    {
        return $this->attributes;
    }

    /**
     * Generic asset attributes.
     *
     * Generated from protobuf field <code>map<string, string> attributes = 5;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setAttributes($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->attributes = $arr;

        return $this;
    }

    /**
     * Output only. Asset information specific for virtual and physical
     * machines.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.MachineDetails machine_details = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\MigrationCenter\V1\MachineDetails|null
     */
    public function getMachineDetails()
    {
        return $this->readOneof(6);
    }

    public function hasMachineDetails()
    {
        return $this->hasOneof(6);
    }

    /**
     * Output only. Asset information specific for virtual and physical
     * machines.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.MachineDetails machine_details = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\MigrationCenter\V1\MachineDetails $var
     * @return $this
     */
    public function setMachineDetails($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\MachineDetails::class);
        $this->writeOneof(6, $var);

        return $this;
    }

    /**
     * Output only. The list of insights associated with the asset.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.InsightList insight_list = 20 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\MigrationCenter\V1\InsightList|null
     */
    public function getInsightList()
    {
        return $this->insight_list;
    }

    public function hasInsightList()
    {
        return isset($this->insight_list);
    }

    public function clearInsightList()
    {
        unset($this->insight_list);
    }

    /**
     * Output only. The list of insights associated with the asset.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.InsightList insight_list = 20 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\MigrationCenter\V1\InsightList $var
     * @return $this
     */
    public function setInsightList($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\InsightList::class);
        $this->insight_list = $var;

        return $this;
    }

    /**
     * Output only. Performance data for the asset.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.AssetPerformanceData performance_data = 21 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\MigrationCenter\V1\AssetPerformanceData|null
     */
    public function getPerformanceData()
    {
        return $this->performance_data;
    }

    public function hasPerformanceData()
    {
        return isset($this->performance_data);
    }

    public function clearPerformanceData()
    {
        unset($this->performance_data);
    }

    /**
     * Output only. Performance data for the asset.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.AssetPerformanceData performance_data = 21 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\MigrationCenter\V1\AssetPerformanceData $var
     * @return $this
     */
    public function setPerformanceData($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\AssetPerformanceData::class);
        $this->performance_data = $var;

        return $this;
    }

    /**
     * Output only. The list of sources contributing to the asset.
     *
     * Generated from protobuf field <code>repeated string sources = 22 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSources()
    {
        return $this->sources;
    }

    /**
     * Output only. The list of sources contributing to the asset.
     *
     * Generated from protobuf field <code>repeated string sources = 22 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSources($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->sources = $arr;

        return $this;
    }

    /**
     * Output only. The list of groups that the asset is assigned to.
     *
     * Generated from protobuf field <code>repeated string assigned_groups = 23 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getAssignedGroups()
    {
        return $this->assigned_groups;
    }

    /**
     * Output only. The list of groups that the asset is assigned to.
     *
     * Generated from protobuf field <code>repeated string assigned_groups = 23 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setAssignedGroups($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->assigned_groups = $arr;

        return $this;
    }

    /**
     * @return string
     */
    public function getAssetDetails()
    {
        return $this->whichOneof("AssetDetails");
    }

}

