<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/migrationcenter/v1/migrationcenter.proto

namespace Google\Cloud\MigrationCenter\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A request to delete a list of  asset.
 *
 * Generated from protobuf message <code>google.cloud.migrationcenter.v1.BatchDeleteAssetsRequest</code>
 */
class BatchDeleteAssetsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Parent value for batch asset delete.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The IDs of the assets to delete.
     * A maximum of 1000 assets can be deleted in a batch.
     * Format: projects/{project}/locations/{location}/assets/{name}.
     *
     * Generated from protobuf field <code>repeated string names = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $names;
    /**
     * Optional. When this value is set to `true` the request is a no-op for
     * non-existing assets. See https://google.aip.dev/135#delete-if-existing for
     * additional details. Default value is `false`.
     *
     * Generated from protobuf field <code>bool allow_missing = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $allow_missing = false;

    /**
     * @param string   $parent Required. Parent value for batch asset delete. Please see
     *                         {@see MigrationCenterClient::locationName()} for help formatting this field.
     * @param string[] $names  Required. The IDs of the assets to delete.
     *                         A maximum of 1000 assets can be deleted in a batch.
     *                         Format: projects/{project}/locations/{location}/assets/{name}. Please see
     *                         {@see MigrationCenterClient::assetName()} for help formatting this field.
     *
     * @return \Google\Cloud\MigrationCenter\V1\BatchDeleteAssetsRequest
     *
     * @experimental
     */
    public static function build(string $parent, array $names): self
    {
        return (new self())
            ->setParent($parent)
            ->setNames($names);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Parent value for batch asset delete.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $names
     *           Required. The IDs of the assets to delete.
     *           A maximum of 1000 assets can be deleted in a batch.
     *           Format: projects/{project}/locations/{location}/assets/{name}.
     *     @type bool $allow_missing
     *           Optional. When this value is set to `true` the request is a no-op for
     *           non-existing assets. See https://google.aip.dev/135#delete-if-existing for
     *           additional details. Default value is `false`.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Migrationcenter\V1\Migrationcenter::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Parent value for batch asset delete.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Parent value for batch asset delete.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The IDs of the assets to delete.
     * A maximum of 1000 assets can be deleted in a batch.
     * Format: projects/{project}/locations/{location}/assets/{name}.
     *
     * Generated from protobuf field <code>repeated string names = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getNames()
    {
        return $this->names;
    }

    /**
     * Required. The IDs of the assets to delete.
     * A maximum of 1000 assets can be deleted in a batch.
     * Format: projects/{project}/locations/{location}/assets/{name}.
     *
     * Generated from protobuf field <code>repeated string names = 2 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setNames($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->names = $arr;

        return $this;
    }

    /**
     * Optional. When this value is set to `true` the request is a no-op for
     * non-existing assets. See https://google.aip.dev/135#delete-if-existing for
     * additional details. Default value is `false`.
     *
     * Generated from protobuf field <code>bool allow_missing = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getAllowMissing()
    {
        return $this->allow_missing;
    }

    /**
     * Optional. When this value is set to `true` the request is a no-op for
     * non-existing assets. See https://google.aip.dev/135#delete-if-existing for
     * additional details. Default value is `false`.
     *
     * Generated from protobuf field <code>bool allow_missing = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setAllowMissing($var)
    {
        GPBUtil::checkBool($var);
        $this->allow_missing = $var;

        return $this;
    }

}

