<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/migrationcenter/v1/migrationcenter.proto

namespace Google\Cloud\MigrationCenter\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A request to create an import job.
 *
 * Generated from protobuf message <code>google.cloud.migrationcenter.v1.CreateImportJobRequest</code>
 */
class CreateImportJobRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Value for parent.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. ID of the import job.
     *
     * Generated from protobuf field <code>string import_job_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $import_job_id = '';
    /**
     * Required. The resource being created.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ImportJob import_job = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $import_job = null;
    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and
     * the request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $request_id = '';

    /**
     * @param string                                     $parent      Required. Value for parent. Please see
     *                                                                {@see MigrationCenterClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\MigrationCenter\V1\ImportJob $importJob   Required. The resource being created.
     * @param string                                     $importJobId Required. ID of the import job.
     *
     * @return \Google\Cloud\MigrationCenter\V1\CreateImportJobRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\MigrationCenter\V1\ImportJob $importJob, string $importJobId): self
    {
        return (new self())
            ->setParent($parent)
            ->setImportJob($importJob)
            ->setImportJobId($importJobId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Value for parent.
     *     @type string $import_job_id
     *           Required. ID of the import job.
     *     @type \Google\Cloud\MigrationCenter\V1\ImportJob $import_job
     *           Required. The resource being created.
     *     @type string $request_id
     *           Optional. An optional request ID to identify requests. Specify a unique
     *           request ID so that if you must retry your request, the server will know to
     *           ignore the request if it has already been completed. The server will
     *           guarantee that for at least 60 minutes since the first request.
     *           For example, consider a situation where you make an initial request and
     *           the request times out. If you make the request again with the same request
     *           ID, the server can check if original operation with the same request ID
     *           was received, and if so, will ignore the second request. This prevents
     *           clients from accidentally creating duplicate commitments.
     *           The request ID must be a valid UUID with the exception that zero UUID is
     *           not supported (00000000-0000-0000-0000-000000000000).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Migrationcenter\V1\Migrationcenter::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Value for parent.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Value for parent.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. ID of the import job.
     *
     * Generated from protobuf field <code>string import_job_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getImportJobId()
    {
        return $this->import_job_id;
    }

    /**
     * Required. ID of the import job.
     *
     * Generated from protobuf field <code>string import_job_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setImportJobId($var)
    {
        GPBUtil::checkString($var, True);
        $this->import_job_id = $var;

        return $this;
    }

    /**
     * Required. The resource being created.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ImportJob import_job = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\MigrationCenter\V1\ImportJob|null
     */
    public function getImportJob()
    {
        return $this->import_job;
    }

    public function hasImportJob()
    {
        return isset($this->import_job);
    }

    public function clearImportJob()
    {
        unset($this->import_job);
    }

    /**
     * Required. The resource being created.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ImportJob import_job = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\MigrationCenter\V1\ImportJob $var
     * @return $this
     */
    public function setImportJob($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\ImportJob::class);
        $this->import_job = $var;

        return $this;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and
     * the request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getRequestId()
    {
        return $this->request_id;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and
     * the request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setRequestId($var)
    {
        GPBUtil::checkString($var, True);
        $this->request_id = $var;

        return $this;
    }

}

