<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/migrationcenter/v1/migrationcenter.proto

namespace Google\Cloud\MigrationCenter\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message for creating a Report.
 *
 * Generated from protobuf message <code>google.cloud.migrationcenter.v1.CreateReportRequest</code>
 */
class CreateReportRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Value for parent.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. User specified id for the report. It will become the last
     * component of the report name. The id must be unique within the project,
     * must conform with RFC-1034, is restricted to lower-cased letters, and has a
     * maximum length of 63 characters. The id must match the regular expression:
     * [a-z]([a-z0-9-]{0,61}[a-z0-9])?.
     *
     * Generated from protobuf field <code>string report_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $report_id = '';
    /**
     * Required. The report resource being created.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.Report report = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $report = null;
    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and
     * the request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $request_id = '';

    /**
     * @param string                                  $parent   Required. Value for parent. Please see
     *                                                          {@see MigrationCenterClient::reportConfigName()} for help formatting this field.
     * @param \Google\Cloud\MigrationCenter\V1\Report $report   Required. The report resource being created.
     * @param string                                  $reportId Required. User specified id for the report. It will become the last
     *                                                          component of the report name. The id must be unique within the project,
     *                                                          must conform with RFC-1034, is restricted to lower-cased letters, and has a
     *                                                          maximum length of 63 characters. The id must match the regular expression:
     *                                                          [a-z]([a-z0-9-]{0,61}[a-z0-9])?.
     *
     * @return \Google\Cloud\MigrationCenter\V1\CreateReportRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\MigrationCenter\V1\Report $report, string $reportId): self
    {
        return (new self())
            ->setParent($parent)
            ->setReport($report)
            ->setReportId($reportId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Value for parent.
     *     @type string $report_id
     *           Required. User specified id for the report. It will become the last
     *           component of the report name. The id must be unique within the project,
     *           must conform with RFC-1034, is restricted to lower-cased letters, and has a
     *           maximum length of 63 characters. The id must match the regular expression:
     *           [a-z]([a-z0-9-]{0,61}[a-z0-9])?.
     *     @type \Google\Cloud\MigrationCenter\V1\Report $report
     *           Required. The report resource being created.
     *     @type string $request_id
     *           Optional. An optional request ID to identify requests. Specify a unique
     *           request ID so that if you must retry your request, the server will know to
     *           ignore the request if it has already been completed. The server will
     *           guarantee that for at least 60 minutes since the first request.
     *           For example, consider a situation where you make an initial request and
     *           the request times out. If you make the request again with the same request
     *           ID, the server can check if original operation with the same request ID
     *           was received, and if so, will ignore the second request. This prevents
     *           clients from accidentally creating duplicate commitments.
     *           The request ID must be a valid UUID with the exception that zero UUID is
     *           not supported (00000000-0000-0000-0000-000000000000).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Migrationcenter\V1\Migrationcenter::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Value for parent.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Value for parent.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. User specified id for the report. It will become the last
     * component of the report name. The id must be unique within the project,
     * must conform with RFC-1034, is restricted to lower-cased letters, and has a
     * maximum length of 63 characters. The id must match the regular expression:
     * [a-z]([a-z0-9-]{0,61}[a-z0-9])?.
     *
     * Generated from protobuf field <code>string report_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getReportId()
    {
        return $this->report_id;
    }

    /**
     * Required. User specified id for the report. It will become the last
     * component of the report name. The id must be unique within the project,
     * must conform with RFC-1034, is restricted to lower-cased letters, and has a
     * maximum length of 63 characters. The id must match the regular expression:
     * [a-z]([a-z0-9-]{0,61}[a-z0-9])?.
     *
     * Generated from protobuf field <code>string report_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setReportId($var)
    {
        GPBUtil::checkString($var, True);
        $this->report_id = $var;

        return $this;
    }

    /**
     * Required. The report resource being created.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.Report report = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\MigrationCenter\V1\Report|null
     */
    public function getReport()
    {
        return $this->report;
    }

    public function hasReport()
    {
        return isset($this->report);
    }

    public function clearReport()
    {
        unset($this->report);
    }

    /**
     * Required. The report resource being created.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.Report report = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\MigrationCenter\V1\Report $var
     * @return $this
     */
    public function setReport($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\Report::class);
        $this->report = $var;

        return $this;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and
     * the request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getRequestId()
    {
        return $this->request_id;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and
     * the request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setRequestId($var)
    {
        GPBUtil::checkString($var, True);
        $this->request_id = $var;

        return $this;
    }

}

