<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/migrationcenter/v1/migrationcenter.proto

namespace Google\Cloud\MigrationCenter\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A resource that represents the background job that imports asset frames.
 *
 * Generated from protobuf message <code>google.cloud.migrationcenter.v1.ImportJob</code>
 */
class ImportJob extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The full name of the import job.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $name = '';
    /**
     * User-friendly display name. Maximum length is 63 characters.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     */
    protected $display_name = '';
    /**
     * Output only. The timestamp when the import job was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. The timestamp when the import job was last updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Output only. The timestamp when the import job was completed.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp complete_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $complete_time = null;
    /**
     * Output only. The state of the import job.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ImportJob.ImportJobState state = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;
    /**
     * Labels as key value pairs.
     *
     * Generated from protobuf field <code>map<string, string> labels = 7;</code>
     */
    private $labels;
    /**
     * Required. Reference to a source.
     *
     * Generated from protobuf field <code>string asset_source = 8 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $asset_source = '';
    protected $report;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. The full name of the import job.
     *     @type string $display_name
     *           User-friendly display name. Maximum length is 63 characters.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. The timestamp when the import job was created.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. The timestamp when the import job was last updated.
     *     @type \Google\Protobuf\Timestamp $complete_time
     *           Output only. The timestamp when the import job was completed.
     *     @type int $state
     *           Output only. The state of the import job.
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Labels as key value pairs.
     *     @type string $asset_source
     *           Required. Reference to a source.
     *     @type \Google\Cloud\MigrationCenter\V1\ValidationReport $validation_report
     *           Output only. The report with the validation results of the import job.
     *     @type \Google\Cloud\MigrationCenter\V1\ExecutionReport $execution_report
     *           Output only. The report with the results of running the import job.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Migrationcenter\V1\Migrationcenter::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The full name of the import job.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. The full name of the import job.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * User-friendly display name. Maximum length is 63 characters.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * User-friendly display name. Maximum length is 63 characters.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * Output only. The timestamp when the import job was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. The timestamp when the import job was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. The timestamp when the import job was last updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. The timestamp when the import job was last updated.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Output only. The timestamp when the import job was completed.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp complete_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCompleteTime()
    {
        return $this->complete_time;
    }

    public function hasCompleteTime()
    {
        return isset($this->complete_time);
    }

    public function clearCompleteTime()
    {
        unset($this->complete_time);
    }

    /**
     * Output only. The timestamp when the import job was completed.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp complete_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCompleteTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->complete_time = $var;

        return $this;
    }

    /**
     * Output only. The state of the import job.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ImportJob.ImportJobState state = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. The state of the import job.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ImportJob.ImportJobState state = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\MigrationCenter\V1\ImportJob\ImportJobState::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Labels as key value pairs.
     *
     * Generated from protobuf field <code>map<string, string> labels = 7;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Labels as key value pairs.
     *
     * Generated from protobuf field <code>map<string, string> labels = 7;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * Required. Reference to a source.
     *
     * Generated from protobuf field <code>string asset_source = 8 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getAssetSource()
    {
        return $this->asset_source;
    }

    /**
     * Required. Reference to a source.
     *
     * Generated from protobuf field <code>string asset_source = 8 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setAssetSource($var)
    {
        GPBUtil::checkString($var, True);
        $this->asset_source = $var;

        return $this;
    }

    /**
     * Output only. The report with the validation results of the import job.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ValidationReport validation_report = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\MigrationCenter\V1\ValidationReport|null
     */
    public function getValidationReport()
    {
        return $this->readOneof(10);
    }

    public function hasValidationReport()
    {
        return $this->hasOneof(10);
    }

    /**
     * Output only. The report with the validation results of the import job.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ValidationReport validation_report = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\MigrationCenter\V1\ValidationReport $var
     * @return $this
     */
    public function setValidationReport($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\ValidationReport::class);
        $this->writeOneof(10, $var);

        return $this;
    }

    /**
     * Output only. The report with the results of running the import job.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ExecutionReport execution_report = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\MigrationCenter\V1\ExecutionReport|null
     */
    public function getExecutionReport()
    {
        return $this->readOneof(11);
    }

    public function hasExecutionReport()
    {
        return $this->hasOneof(11);
    }

    /**
     * Output only. The report with the results of running the import job.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ExecutionReport execution_report = 11 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\MigrationCenter\V1\ExecutionReport $var
     * @return $this
     */
    public function setExecutionReport($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\ExecutionReport::class);
        $this->writeOneof(11, $var);

        return $this;
    }

    /**
     * @return string
     */
    public function getReport()
    {
        return $this->whichOneof("report");
    }

}

