<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/migrationcenter/v1/migrationcenter.proto

namespace Google\Cloud\MigrationCenter\V1\ReportSummary;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Aggregate statistics for a collection of assets.
 *
 * Generated from protobuf message <code>google.cloud.migrationcenter.v1.ReportSummary.AssetAggregateStats</code>
 */
class AssetAggregateStats extends \Google\Protobuf\Internal\Message
{
    /**
     * Sum of the memory in bytes of all the assets in this collection.
     *
     * Generated from protobuf field <code>int64 total_memory_bytes = 1;</code>
     */
    protected $total_memory_bytes = 0;
    /**
     * Sum of persistent storage in bytes of all the assets in this collection.
     *
     * Generated from protobuf field <code>int64 total_storage_bytes = 2;</code>
     */
    protected $total_storage_bytes = 0;
    /**
     * Sum of the CPU core count of all the assets in this collection.
     *
     * Generated from protobuf field <code>int64 total_cores = 3;</code>
     */
    protected $total_cores = 0;
    /**
     * Count of the number of unique assets in this collection.
     *
     * Generated from protobuf field <code>int64 total_assets = 4;</code>
     */
    protected $total_assets = 0;
    /**
     * Total memory split into Used/Free buckets.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.UtilizationChartData memory_utilization_chart = 5;</code>
     */
    protected $memory_utilization_chart = null;
    /**
     * Total memory split into Used/Free buckets.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.UtilizationChartData storage_utilization_chart = 6;</code>
     */
    protected $storage_utilization_chart = null;
    /**
     * Count of assets grouped by Operating System families.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.ChartData operating_system = 7;</code>
     */
    protected $operating_system = null;
    /**
     * Histogram showing a distribution of CPU core counts.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.HistogramChartData core_count_histogram = 8;</code>
     */
    protected $core_count_histogram = null;
    /**
     * Histogram showing a distribution of memory sizes.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.HistogramChartData memory_bytes_histogram = 9;</code>
     */
    protected $memory_bytes_histogram = null;
    /**
     * Histogram showing a distribution of memory sizes.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.HistogramChartData storage_bytes_histogram = 10;</code>
     */
    protected $storage_bytes_histogram = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int|string $total_memory_bytes
     *           Sum of the memory in bytes of all the assets in this collection.
     *     @type int|string $total_storage_bytes
     *           Sum of persistent storage in bytes of all the assets in this collection.
     *     @type int|string $total_cores
     *           Sum of the CPU core count of all the assets in this collection.
     *     @type int|string $total_assets
     *           Count of the number of unique assets in this collection.
     *     @type \Google\Cloud\MigrationCenter\V1\ReportSummary\UtilizationChartData $memory_utilization_chart
     *           Total memory split into Used/Free buckets.
     *     @type \Google\Cloud\MigrationCenter\V1\ReportSummary\UtilizationChartData $storage_utilization_chart
     *           Total memory split into Used/Free buckets.
     *     @type \Google\Cloud\MigrationCenter\V1\ReportSummary\ChartData $operating_system
     *           Count of assets grouped by Operating System families.
     *     @type \Google\Cloud\MigrationCenter\V1\ReportSummary\HistogramChartData $core_count_histogram
     *           Histogram showing a distribution of CPU core counts.
     *     @type \Google\Cloud\MigrationCenter\V1\ReportSummary\HistogramChartData $memory_bytes_histogram
     *           Histogram showing a distribution of memory sizes.
     *     @type \Google\Cloud\MigrationCenter\V1\ReportSummary\HistogramChartData $storage_bytes_histogram
     *           Histogram showing a distribution of memory sizes.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Migrationcenter\V1\Migrationcenter::initOnce();
        parent::__construct($data);
    }

    /**
     * Sum of the memory in bytes of all the assets in this collection.
     *
     * Generated from protobuf field <code>int64 total_memory_bytes = 1;</code>
     * @return int|string
     */
    public function getTotalMemoryBytes()
    {
        return $this->total_memory_bytes;
    }

    /**
     * Sum of the memory in bytes of all the assets in this collection.
     *
     * Generated from protobuf field <code>int64 total_memory_bytes = 1;</code>
     * @param int|string $var
     * @return $this
     */
    public function setTotalMemoryBytes($var)
    {
        GPBUtil::checkInt64($var);
        $this->total_memory_bytes = $var;

        return $this;
    }

    /**
     * Sum of persistent storage in bytes of all the assets in this collection.
     *
     * Generated from protobuf field <code>int64 total_storage_bytes = 2;</code>
     * @return int|string
     */
    public function getTotalStorageBytes()
    {
        return $this->total_storage_bytes;
    }

    /**
     * Sum of persistent storage in bytes of all the assets in this collection.
     *
     * Generated from protobuf field <code>int64 total_storage_bytes = 2;</code>
     * @param int|string $var
     * @return $this
     */
    public function setTotalStorageBytes($var)
    {
        GPBUtil::checkInt64($var);
        $this->total_storage_bytes = $var;

        return $this;
    }

    /**
     * Sum of the CPU core count of all the assets in this collection.
     *
     * Generated from protobuf field <code>int64 total_cores = 3;</code>
     * @return int|string
     */
    public function getTotalCores()
    {
        return $this->total_cores;
    }

    /**
     * Sum of the CPU core count of all the assets in this collection.
     *
     * Generated from protobuf field <code>int64 total_cores = 3;</code>
     * @param int|string $var
     * @return $this
     */
    public function setTotalCores($var)
    {
        GPBUtil::checkInt64($var);
        $this->total_cores = $var;

        return $this;
    }

    /**
     * Count of the number of unique assets in this collection.
     *
     * Generated from protobuf field <code>int64 total_assets = 4;</code>
     * @return int|string
     */
    public function getTotalAssets()
    {
        return $this->total_assets;
    }

    /**
     * Count of the number of unique assets in this collection.
     *
     * Generated from protobuf field <code>int64 total_assets = 4;</code>
     * @param int|string $var
     * @return $this
     */
    public function setTotalAssets($var)
    {
        GPBUtil::checkInt64($var);
        $this->total_assets = $var;

        return $this;
    }

    /**
     * Total memory split into Used/Free buckets.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.UtilizationChartData memory_utilization_chart = 5;</code>
     * @return \Google\Cloud\MigrationCenter\V1\ReportSummary\UtilizationChartData|null
     */
    public function getMemoryUtilizationChart()
    {
        return $this->memory_utilization_chart;
    }

    public function hasMemoryUtilizationChart()
    {
        return isset($this->memory_utilization_chart);
    }

    public function clearMemoryUtilizationChart()
    {
        unset($this->memory_utilization_chart);
    }

    /**
     * Total memory split into Used/Free buckets.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.UtilizationChartData memory_utilization_chart = 5;</code>
     * @param \Google\Cloud\MigrationCenter\V1\ReportSummary\UtilizationChartData $var
     * @return $this
     */
    public function setMemoryUtilizationChart($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\ReportSummary\UtilizationChartData::class);
        $this->memory_utilization_chart = $var;

        return $this;
    }

    /**
     * Total memory split into Used/Free buckets.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.UtilizationChartData storage_utilization_chart = 6;</code>
     * @return \Google\Cloud\MigrationCenter\V1\ReportSummary\UtilizationChartData|null
     */
    public function getStorageUtilizationChart()
    {
        return $this->storage_utilization_chart;
    }

    public function hasStorageUtilizationChart()
    {
        return isset($this->storage_utilization_chart);
    }

    public function clearStorageUtilizationChart()
    {
        unset($this->storage_utilization_chart);
    }

    /**
     * Total memory split into Used/Free buckets.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.UtilizationChartData storage_utilization_chart = 6;</code>
     * @param \Google\Cloud\MigrationCenter\V1\ReportSummary\UtilizationChartData $var
     * @return $this
     */
    public function setStorageUtilizationChart($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\ReportSummary\UtilizationChartData::class);
        $this->storage_utilization_chart = $var;

        return $this;
    }

    /**
     * Count of assets grouped by Operating System families.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.ChartData operating_system = 7;</code>
     * @return \Google\Cloud\MigrationCenter\V1\ReportSummary\ChartData|null
     */
    public function getOperatingSystem()
    {
        return $this->operating_system;
    }

    public function hasOperatingSystem()
    {
        return isset($this->operating_system);
    }

    public function clearOperatingSystem()
    {
        unset($this->operating_system);
    }

    /**
     * Count of assets grouped by Operating System families.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.ChartData operating_system = 7;</code>
     * @param \Google\Cloud\MigrationCenter\V1\ReportSummary\ChartData $var
     * @return $this
     */
    public function setOperatingSystem($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\ReportSummary\ChartData::class);
        $this->operating_system = $var;

        return $this;
    }

    /**
     * Histogram showing a distribution of CPU core counts.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.HistogramChartData core_count_histogram = 8;</code>
     * @return \Google\Cloud\MigrationCenter\V1\ReportSummary\HistogramChartData|null
     */
    public function getCoreCountHistogram()
    {
        return $this->core_count_histogram;
    }

    public function hasCoreCountHistogram()
    {
        return isset($this->core_count_histogram);
    }

    public function clearCoreCountHistogram()
    {
        unset($this->core_count_histogram);
    }

    /**
     * Histogram showing a distribution of CPU core counts.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.HistogramChartData core_count_histogram = 8;</code>
     * @param \Google\Cloud\MigrationCenter\V1\ReportSummary\HistogramChartData $var
     * @return $this
     */
    public function setCoreCountHistogram($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\ReportSummary\HistogramChartData::class);
        $this->core_count_histogram = $var;

        return $this;
    }

    /**
     * Histogram showing a distribution of memory sizes.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.HistogramChartData memory_bytes_histogram = 9;</code>
     * @return \Google\Cloud\MigrationCenter\V1\ReportSummary\HistogramChartData|null
     */
    public function getMemoryBytesHistogram()
    {
        return $this->memory_bytes_histogram;
    }

    public function hasMemoryBytesHistogram()
    {
        return isset($this->memory_bytes_histogram);
    }

    public function clearMemoryBytesHistogram()
    {
        unset($this->memory_bytes_histogram);
    }

    /**
     * Histogram showing a distribution of memory sizes.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.HistogramChartData memory_bytes_histogram = 9;</code>
     * @param \Google\Cloud\MigrationCenter\V1\ReportSummary\HistogramChartData $var
     * @return $this
     */
    public function setMemoryBytesHistogram($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\ReportSummary\HistogramChartData::class);
        $this->memory_bytes_histogram = $var;

        return $this;
    }

    /**
     * Histogram showing a distribution of memory sizes.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.HistogramChartData storage_bytes_histogram = 10;</code>
     * @return \Google\Cloud\MigrationCenter\V1\ReportSummary\HistogramChartData|null
     */
    public function getStorageBytesHistogram()
    {
        return $this->storage_bytes_histogram;
    }

    public function hasStorageBytesHistogram()
    {
        return isset($this->storage_bytes_histogram);
    }

    public function clearStorageBytesHistogram()
    {
        unset($this->storage_bytes_histogram);
    }

    /**
     * Histogram showing a distribution of memory sizes.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.HistogramChartData storage_bytes_histogram = 10;</code>
     * @param \Google\Cloud\MigrationCenter\V1\ReportSummary\HistogramChartData $var
     * @return $this
     */
    public function setStorageBytesHistogram($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\ReportSummary\HistogramChartData::class);
        $this->storage_bytes_histogram = $var;

        return $this;
    }

}


