<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/migrationcenter/v1/migrationcenter.proto

namespace Google\Cloud\MigrationCenter\V1\ReportSummary;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Summary Findings for a specific Group/PreferenceSet combination.
 *
 * Generated from protobuf message <code>google.cloud.migrationcenter.v1.ReportSummary.GroupPreferenceSetFinding</code>
 */
class GroupPreferenceSetFinding extends \Google\Protobuf\Internal\Message
{
    /**
     * Display Name of the Preference Set
     *
     * Generated from protobuf field <code>string display_name = 1;</code>
     */
    protected $display_name = '';
    /**
     * Description for the Preference Set.
     *
     * Generated from protobuf field <code>string description = 2;</code>
     */
    protected $description = '';
    /**
     * A set of preferences that applies to all machines in the context.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.VirtualMachinePreferences machine_preferences = 3;</code>
     */
    protected $machine_preferences = null;
    /**
     * Total monthly cost for this preference set.
     *
     * Generated from protobuf field <code>.google.type.Money monthly_cost_total = 4;</code>
     */
    protected $monthly_cost_total = null;
    /**
     * Compute monthly cost for this preference set.
     *
     * Generated from protobuf field <code>.google.type.Money monthly_cost_compute = 5;</code>
     */
    protected $monthly_cost_compute = null;
    /**
     * Licensing monthly cost for this preference set.
     *
     * Generated from protobuf field <code>.google.type.Money monthly_cost_os_license = 6;</code>
     */
    protected $monthly_cost_os_license = null;
    /**
     * Network Egress monthly cost for this preference set.
     *
     * Generated from protobuf field <code>.google.type.Money monthly_cost_network_egress = 7;</code>
     */
    protected $monthly_cost_network_egress = null;
    /**
     * Storage monthly cost for this preference set.
     *
     * Generated from protobuf field <code>.google.type.Money monthly_cost_storage = 8;</code>
     */
    protected $monthly_cost_storage = null;
    /**
     * Miscellaneous monthly cost for this preference set.
     *
     * Generated from protobuf field <code>.google.type.Money monthly_cost_other = 9;</code>
     */
    protected $monthly_cost_other = null;
    /**
     * A set of findings that applies to Compute Engine machines in the input.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.ComputeEngineFinding compute_engine_finding = 10;</code>
     */
    protected $compute_engine_finding = null;
    /**
     * A set of findings that applies to VMWare machines in the input.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.VmwareEngineFinding vmware_engine_finding = 11;</code>
     */
    protected $vmware_engine_finding = null;
    /**
     * A set of findings that applies to Sole-Tenant machines in the input.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.SoleTenantFinding sole_tenant_finding = 12;</code>
     */
    protected $sole_tenant_finding = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $display_name
     *           Display Name of the Preference Set
     *     @type string $description
     *           Description for the Preference Set.
     *     @type \Google\Cloud\MigrationCenter\V1\VirtualMachinePreferences $machine_preferences
     *           A set of preferences that applies to all machines in the context.
     *     @type \Google\Type\Money $monthly_cost_total
     *           Total monthly cost for this preference set.
     *     @type \Google\Type\Money $monthly_cost_compute
     *           Compute monthly cost for this preference set.
     *     @type \Google\Type\Money $monthly_cost_os_license
     *           Licensing monthly cost for this preference set.
     *     @type \Google\Type\Money $monthly_cost_network_egress
     *           Network Egress monthly cost for this preference set.
     *     @type \Google\Type\Money $monthly_cost_storage
     *           Storage monthly cost for this preference set.
     *     @type \Google\Type\Money $monthly_cost_other
     *           Miscellaneous monthly cost for this preference set.
     *     @type \Google\Cloud\MigrationCenter\V1\ReportSummary\ComputeEngineFinding $compute_engine_finding
     *           A set of findings that applies to Compute Engine machines in the input.
     *     @type \Google\Cloud\MigrationCenter\V1\ReportSummary\VmwareEngineFinding $vmware_engine_finding
     *           A set of findings that applies to VMWare machines in the input.
     *     @type \Google\Cloud\MigrationCenter\V1\ReportSummary\SoleTenantFinding $sole_tenant_finding
     *           A set of findings that applies to Sole-Tenant machines in the input.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Migrationcenter\V1\Migrationcenter::initOnce();
        parent::__construct($data);
    }

    /**
     * Display Name of the Preference Set
     *
     * Generated from protobuf field <code>string display_name = 1;</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * Display Name of the Preference Set
     *
     * Generated from protobuf field <code>string display_name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * Description for the Preference Set.
     *
     * Generated from protobuf field <code>string description = 2;</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Description for the Preference Set.
     *
     * Generated from protobuf field <code>string description = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * A set of preferences that applies to all machines in the context.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.VirtualMachinePreferences machine_preferences = 3;</code>
     * @return \Google\Cloud\MigrationCenter\V1\VirtualMachinePreferences|null
     */
    public function getMachinePreferences()
    {
        return $this->machine_preferences;
    }

    public function hasMachinePreferences()
    {
        return isset($this->machine_preferences);
    }

    public function clearMachinePreferences()
    {
        unset($this->machine_preferences);
    }

    /**
     * A set of preferences that applies to all machines in the context.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.VirtualMachinePreferences machine_preferences = 3;</code>
     * @param \Google\Cloud\MigrationCenter\V1\VirtualMachinePreferences $var
     * @return $this
     */
    public function setMachinePreferences($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\VirtualMachinePreferences::class);
        $this->machine_preferences = $var;

        return $this;
    }

    /**
     * Total monthly cost for this preference set.
     *
     * Generated from protobuf field <code>.google.type.Money monthly_cost_total = 4;</code>
     * @return \Google\Type\Money|null
     */
    public function getMonthlyCostTotal()
    {
        return $this->monthly_cost_total;
    }

    public function hasMonthlyCostTotal()
    {
        return isset($this->monthly_cost_total);
    }

    public function clearMonthlyCostTotal()
    {
        unset($this->monthly_cost_total);
    }

    /**
     * Total monthly cost for this preference set.
     *
     * Generated from protobuf field <code>.google.type.Money monthly_cost_total = 4;</code>
     * @param \Google\Type\Money $var
     * @return $this
     */
    public function setMonthlyCostTotal($var)
    {
        GPBUtil::checkMessage($var, \Google\Type\Money::class);
        $this->monthly_cost_total = $var;

        return $this;
    }

    /**
     * Compute monthly cost for this preference set.
     *
     * Generated from protobuf field <code>.google.type.Money monthly_cost_compute = 5;</code>
     * @return \Google\Type\Money|null
     */
    public function getMonthlyCostCompute()
    {
        return $this->monthly_cost_compute;
    }

    public function hasMonthlyCostCompute()
    {
        return isset($this->monthly_cost_compute);
    }

    public function clearMonthlyCostCompute()
    {
        unset($this->monthly_cost_compute);
    }

    /**
     * Compute monthly cost for this preference set.
     *
     * Generated from protobuf field <code>.google.type.Money monthly_cost_compute = 5;</code>
     * @param \Google\Type\Money $var
     * @return $this
     */
    public function setMonthlyCostCompute($var)
    {
        GPBUtil::checkMessage($var, \Google\Type\Money::class);
        $this->monthly_cost_compute = $var;

        return $this;
    }

    /**
     * Licensing monthly cost for this preference set.
     *
     * Generated from protobuf field <code>.google.type.Money monthly_cost_os_license = 6;</code>
     * @return \Google\Type\Money|null
     */
    public function getMonthlyCostOsLicense()
    {
        return $this->monthly_cost_os_license;
    }

    public function hasMonthlyCostOsLicense()
    {
        return isset($this->monthly_cost_os_license);
    }

    public function clearMonthlyCostOsLicense()
    {
        unset($this->monthly_cost_os_license);
    }

    /**
     * Licensing monthly cost for this preference set.
     *
     * Generated from protobuf field <code>.google.type.Money monthly_cost_os_license = 6;</code>
     * @param \Google\Type\Money $var
     * @return $this
     */
    public function setMonthlyCostOsLicense($var)
    {
        GPBUtil::checkMessage($var, \Google\Type\Money::class);
        $this->monthly_cost_os_license = $var;

        return $this;
    }

    /**
     * Network Egress monthly cost for this preference set.
     *
     * Generated from protobuf field <code>.google.type.Money monthly_cost_network_egress = 7;</code>
     * @return \Google\Type\Money|null
     */
    public function getMonthlyCostNetworkEgress()
    {
        return $this->monthly_cost_network_egress;
    }

    public function hasMonthlyCostNetworkEgress()
    {
        return isset($this->monthly_cost_network_egress);
    }

    public function clearMonthlyCostNetworkEgress()
    {
        unset($this->monthly_cost_network_egress);
    }

    /**
     * Network Egress monthly cost for this preference set.
     *
     * Generated from protobuf field <code>.google.type.Money monthly_cost_network_egress = 7;</code>
     * @param \Google\Type\Money $var
     * @return $this
     */
    public function setMonthlyCostNetworkEgress($var)
    {
        GPBUtil::checkMessage($var, \Google\Type\Money::class);
        $this->monthly_cost_network_egress = $var;

        return $this;
    }

    /**
     * Storage monthly cost for this preference set.
     *
     * Generated from protobuf field <code>.google.type.Money monthly_cost_storage = 8;</code>
     * @return \Google\Type\Money|null
     */
    public function getMonthlyCostStorage()
    {
        return $this->monthly_cost_storage;
    }

    public function hasMonthlyCostStorage()
    {
        return isset($this->monthly_cost_storage);
    }

    public function clearMonthlyCostStorage()
    {
        unset($this->monthly_cost_storage);
    }

    /**
     * Storage monthly cost for this preference set.
     *
     * Generated from protobuf field <code>.google.type.Money monthly_cost_storage = 8;</code>
     * @param \Google\Type\Money $var
     * @return $this
     */
    public function setMonthlyCostStorage($var)
    {
        GPBUtil::checkMessage($var, \Google\Type\Money::class);
        $this->monthly_cost_storage = $var;

        return $this;
    }

    /**
     * Miscellaneous monthly cost for this preference set.
     *
     * Generated from protobuf field <code>.google.type.Money monthly_cost_other = 9;</code>
     * @return \Google\Type\Money|null
     */
    public function getMonthlyCostOther()
    {
        return $this->monthly_cost_other;
    }

    public function hasMonthlyCostOther()
    {
        return isset($this->monthly_cost_other);
    }

    public function clearMonthlyCostOther()
    {
        unset($this->monthly_cost_other);
    }

    /**
     * Miscellaneous monthly cost for this preference set.
     *
     * Generated from protobuf field <code>.google.type.Money monthly_cost_other = 9;</code>
     * @param \Google\Type\Money $var
     * @return $this
     */
    public function setMonthlyCostOther($var)
    {
        GPBUtil::checkMessage($var, \Google\Type\Money::class);
        $this->monthly_cost_other = $var;

        return $this;
    }

    /**
     * A set of findings that applies to Compute Engine machines in the input.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.ComputeEngineFinding compute_engine_finding = 10;</code>
     * @return \Google\Cloud\MigrationCenter\V1\ReportSummary\ComputeEngineFinding|null
     */
    public function getComputeEngineFinding()
    {
        return $this->compute_engine_finding;
    }

    public function hasComputeEngineFinding()
    {
        return isset($this->compute_engine_finding);
    }

    public function clearComputeEngineFinding()
    {
        unset($this->compute_engine_finding);
    }

    /**
     * A set of findings that applies to Compute Engine machines in the input.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.ComputeEngineFinding compute_engine_finding = 10;</code>
     * @param \Google\Cloud\MigrationCenter\V1\ReportSummary\ComputeEngineFinding $var
     * @return $this
     */
    public function setComputeEngineFinding($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\ReportSummary\ComputeEngineFinding::class);
        $this->compute_engine_finding = $var;

        return $this;
    }

    /**
     * A set of findings that applies to VMWare machines in the input.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.VmwareEngineFinding vmware_engine_finding = 11;</code>
     * @return \Google\Cloud\MigrationCenter\V1\ReportSummary\VmwareEngineFinding|null
     */
    public function getVmwareEngineFinding()
    {
        return $this->vmware_engine_finding;
    }

    public function hasVmwareEngineFinding()
    {
        return isset($this->vmware_engine_finding);
    }

    public function clearVmwareEngineFinding()
    {
        unset($this->vmware_engine_finding);
    }

    /**
     * A set of findings that applies to VMWare machines in the input.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.VmwareEngineFinding vmware_engine_finding = 11;</code>
     * @param \Google\Cloud\MigrationCenter\V1\ReportSummary\VmwareEngineFinding $var
     * @return $this
     */
    public function setVmwareEngineFinding($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\ReportSummary\VmwareEngineFinding::class);
        $this->vmware_engine_finding = $var;

        return $this;
    }

    /**
     * A set of findings that applies to Sole-Tenant machines in the input.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.SoleTenantFinding sole_tenant_finding = 12;</code>
     * @return \Google\Cloud\MigrationCenter\V1\ReportSummary\SoleTenantFinding|null
     */
    public function getSoleTenantFinding()
    {
        return $this->sole_tenant_finding;
    }

    public function hasSoleTenantFinding()
    {
        return isset($this->sole_tenant_finding);
    }

    public function clearSoleTenantFinding()
    {
        unset($this->sole_tenant_finding);
    }

    /**
     * A set of findings that applies to Sole-Tenant machines in the input.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ReportSummary.SoleTenantFinding sole_tenant_finding = 12;</code>
     * @param \Google\Cloud\MigrationCenter\V1\ReportSummary\SoleTenantFinding $var
     * @return $this
     */
    public function setSoleTenantFinding($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\ReportSummary\SoleTenantFinding::class);
        $this->sole_tenant_finding = $var;

        return $this;
    }

}


