<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/migrationcenter/v1/migrationcenter.proto

namespace Google\Cloud\MigrationCenter\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * VirtualMachinePreferences enables you to create sets of assumptions, for
 * example, a geographical location and pricing track, for your migrated virtual
 * machines. The set of preferences influence recommendations for migrating
 * virtual machine assets.
 *
 * Generated from protobuf message <code>google.cloud.migrationcenter.v1.VirtualMachinePreferences</code>
 */
class VirtualMachinePreferences extends \Google\Protobuf\Internal\Message
{
    /**
     * Target product for assets using this preference set.
     * Specify either target product or business goal, but
     * not both.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ComputeMigrationTargetProduct target_product = 2;</code>
     */
    protected $target_product = 0;
    /**
     * Region preferences for assets using this preference set.
     * If you are unsure which value to set, the migration service API region is
     * often a good value to start with.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.RegionPreferences region_preferences = 3;</code>
     */
    protected $region_preferences = null;
    /**
     * Commitment plan to consider when calculating costs for virtual machine
     * insights and recommendations.
     * If you are unsure which value to set, a 3 year commitment plan is often a
     * good value to start with.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.CommitmentPlan commitment_plan = 4;</code>
     */
    protected $commitment_plan = 0;
    /**
     * Sizing optimization strategy specifies the preferred strategy used when
     * extrapolating usage data to calculate insights and recommendations for a
     * virtual machine.
     * If you are unsure which value to set, a moderate sizing optimization
     * strategy is often a good value to start with.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.SizingOptimizationStrategy sizing_optimization_strategy = 5;</code>
     */
    protected $sizing_optimization_strategy = 0;
    /**
     * Compute Engine preferences concern insights and recommendations for Compute
     * Engine target.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ComputeEnginePreferences compute_engine_preferences = 6;</code>
     */
    protected $compute_engine_preferences = null;
    /**
     * Preferences concerning insights and recommendations for
     * Google Cloud VMware Engine.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.VmwareEnginePreferences vmware_engine_preferences = 7;</code>
     */
    protected $vmware_engine_preferences = null;
    /**
     * Preferences concerning Sole Tenant nodes and virtual machines.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.SoleTenancyPreferences sole_tenancy_preferences = 8;</code>
     */
    protected $sole_tenancy_preferences = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int $target_product
     *           Target product for assets using this preference set.
     *           Specify either target product or business goal, but
     *           not both.
     *     @type \Google\Cloud\MigrationCenter\V1\RegionPreferences $region_preferences
     *           Region preferences for assets using this preference set.
     *           If you are unsure which value to set, the migration service API region is
     *           often a good value to start with.
     *     @type int $commitment_plan
     *           Commitment plan to consider when calculating costs for virtual machine
     *           insights and recommendations.
     *           If you are unsure which value to set, a 3 year commitment plan is often a
     *           good value to start with.
     *     @type int $sizing_optimization_strategy
     *           Sizing optimization strategy specifies the preferred strategy used when
     *           extrapolating usage data to calculate insights and recommendations for a
     *           virtual machine.
     *           If you are unsure which value to set, a moderate sizing optimization
     *           strategy is often a good value to start with.
     *     @type \Google\Cloud\MigrationCenter\V1\ComputeEnginePreferences $compute_engine_preferences
     *           Compute Engine preferences concern insights and recommendations for Compute
     *           Engine target.
     *     @type \Google\Cloud\MigrationCenter\V1\VmwareEnginePreferences $vmware_engine_preferences
     *           Preferences concerning insights and recommendations for
     *           Google Cloud VMware Engine.
     *     @type \Google\Cloud\MigrationCenter\V1\SoleTenancyPreferences $sole_tenancy_preferences
     *           Preferences concerning Sole Tenant nodes and virtual machines.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Migrationcenter\V1\Migrationcenter::initOnce();
        parent::__construct($data);
    }

    /**
     * Target product for assets using this preference set.
     * Specify either target product or business goal, but
     * not both.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ComputeMigrationTargetProduct target_product = 2;</code>
     * @return int
     */
    public function getTargetProduct()
    {
        return $this->target_product;
    }

    /**
     * Target product for assets using this preference set.
     * Specify either target product or business goal, but
     * not both.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ComputeMigrationTargetProduct target_product = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setTargetProduct($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\MigrationCenter\V1\ComputeMigrationTargetProduct::class);
        $this->target_product = $var;

        return $this;
    }

    /**
     * Region preferences for assets using this preference set.
     * If you are unsure which value to set, the migration service API region is
     * often a good value to start with.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.RegionPreferences region_preferences = 3;</code>
     * @return \Google\Cloud\MigrationCenter\V1\RegionPreferences|null
     */
    public function getRegionPreferences()
    {
        return $this->region_preferences;
    }

    public function hasRegionPreferences()
    {
        return isset($this->region_preferences);
    }

    public function clearRegionPreferences()
    {
        unset($this->region_preferences);
    }

    /**
     * Region preferences for assets using this preference set.
     * If you are unsure which value to set, the migration service API region is
     * often a good value to start with.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.RegionPreferences region_preferences = 3;</code>
     * @param \Google\Cloud\MigrationCenter\V1\RegionPreferences $var
     * @return $this
     */
    public function setRegionPreferences($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\RegionPreferences::class);
        $this->region_preferences = $var;

        return $this;
    }

    /**
     * Commitment plan to consider when calculating costs for virtual machine
     * insights and recommendations.
     * If you are unsure which value to set, a 3 year commitment plan is often a
     * good value to start with.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.CommitmentPlan commitment_plan = 4;</code>
     * @return int
     */
    public function getCommitmentPlan()
    {
        return $this->commitment_plan;
    }

    /**
     * Commitment plan to consider when calculating costs for virtual machine
     * insights and recommendations.
     * If you are unsure which value to set, a 3 year commitment plan is often a
     * good value to start with.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.CommitmentPlan commitment_plan = 4;</code>
     * @param int $var
     * @return $this
     */
    public function setCommitmentPlan($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\MigrationCenter\V1\CommitmentPlan::class);
        $this->commitment_plan = $var;

        return $this;
    }

    /**
     * Sizing optimization strategy specifies the preferred strategy used when
     * extrapolating usage data to calculate insights and recommendations for a
     * virtual machine.
     * If you are unsure which value to set, a moderate sizing optimization
     * strategy is often a good value to start with.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.SizingOptimizationStrategy sizing_optimization_strategy = 5;</code>
     * @return int
     */
    public function getSizingOptimizationStrategy()
    {
        return $this->sizing_optimization_strategy;
    }

    /**
     * Sizing optimization strategy specifies the preferred strategy used when
     * extrapolating usage data to calculate insights and recommendations for a
     * virtual machine.
     * If you are unsure which value to set, a moderate sizing optimization
     * strategy is often a good value to start with.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.SizingOptimizationStrategy sizing_optimization_strategy = 5;</code>
     * @param int $var
     * @return $this
     */
    public function setSizingOptimizationStrategy($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\MigrationCenter\V1\SizingOptimizationStrategy::class);
        $this->sizing_optimization_strategy = $var;

        return $this;
    }

    /**
     * Compute Engine preferences concern insights and recommendations for Compute
     * Engine target.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ComputeEnginePreferences compute_engine_preferences = 6;</code>
     * @return \Google\Cloud\MigrationCenter\V1\ComputeEnginePreferences|null
     */
    public function getComputeEnginePreferences()
    {
        return $this->compute_engine_preferences;
    }

    public function hasComputeEnginePreferences()
    {
        return isset($this->compute_engine_preferences);
    }

    public function clearComputeEnginePreferences()
    {
        unset($this->compute_engine_preferences);
    }

    /**
     * Compute Engine preferences concern insights and recommendations for Compute
     * Engine target.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.ComputeEnginePreferences compute_engine_preferences = 6;</code>
     * @param \Google\Cloud\MigrationCenter\V1\ComputeEnginePreferences $var
     * @return $this
     */
    public function setComputeEnginePreferences($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\ComputeEnginePreferences::class);
        $this->compute_engine_preferences = $var;

        return $this;
    }

    /**
     * Preferences concerning insights and recommendations for
     * Google Cloud VMware Engine.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.VmwareEnginePreferences vmware_engine_preferences = 7;</code>
     * @return \Google\Cloud\MigrationCenter\V1\VmwareEnginePreferences|null
     */
    public function getVmwareEnginePreferences()
    {
        return $this->vmware_engine_preferences;
    }

    public function hasVmwareEnginePreferences()
    {
        return isset($this->vmware_engine_preferences);
    }

    public function clearVmwareEnginePreferences()
    {
        unset($this->vmware_engine_preferences);
    }

    /**
     * Preferences concerning insights and recommendations for
     * Google Cloud VMware Engine.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.VmwareEnginePreferences vmware_engine_preferences = 7;</code>
     * @param \Google\Cloud\MigrationCenter\V1\VmwareEnginePreferences $var
     * @return $this
     */
    public function setVmwareEnginePreferences($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\VmwareEnginePreferences::class);
        $this->vmware_engine_preferences = $var;

        return $this;
    }

    /**
     * Preferences concerning Sole Tenant nodes and virtual machines.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.SoleTenancyPreferences sole_tenancy_preferences = 8;</code>
     * @return \Google\Cloud\MigrationCenter\V1\SoleTenancyPreferences|null
     */
    public function getSoleTenancyPreferences()
    {
        return $this->sole_tenancy_preferences;
    }

    public function hasSoleTenancyPreferences()
    {
        return isset($this->sole_tenancy_preferences);
    }

    public function clearSoleTenancyPreferences()
    {
        unset($this->sole_tenancy_preferences);
    }

    /**
     * Preferences concerning Sole Tenant nodes and virtual machines.
     *
     * Generated from protobuf field <code>.google.cloud.migrationcenter.v1.SoleTenancyPreferences sole_tenancy_preferences = 8;</code>
     * @param \Google\Cloud\MigrationCenter\V1\SoleTenancyPreferences $var
     * @return $this
     */
    public function setSoleTenancyPreferences($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\MigrationCenter\V1\SoleTenancyPreferences::class);
        $this->sole_tenancy_preferences = $var;

        return $this;
    }

}

