<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/monitoring/v3/service_service.proto

namespace Google\Cloud\Monitoring\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The `ListServices` request.
 *
 * Generated from protobuf message <code>google.monitoring.v3.ListServicesRequest</code>
 */
class ListServicesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Resource name of the parent containing the listed services,
     * either a [project](https://cloud.google.com/monitoring/api/v3#project_name)
     * or a Monitoring Metrics Scope. The formats are:
     *     projects/[PROJECT_ID_OR_NUMBER]
     *     workspaces/[HOST_PROJECT_ID_OR_NUMBER]
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * A filter specifying what `Service`s to return. The filter supports
     * filtering on a particular service-identifier type or one of its attributes.
     * To filter on a particular service-identifier type, the `identifier_case`
     * refers to which option in the `identifier` field is populated. For example,
     * the filter `identifier_case = "CUSTOM"` would match all services with a
     * value for the `custom` field. Valid options include "CUSTOM", "APP_ENGINE",
     * "MESH_ISTIO", and the other options listed at
     * https://cloud.google.com/monitoring/api/ref_v3/rest/v3/services#Service
     * To filter on an attribute of a service-identifier type, apply the filter
     * name by using the snake case of the service-identifier type and the
     * attribute of that service-identifier type, and join the two with a period.
     * For example, to filter by the `meshUid` field of the `MeshIstio`
     * service-identifier type, you must filter on `mesh_istio.mesh_uid =
     * "123"` to match all services with mesh UID "123". Service-identifier types
     * and their attributes are described at
     * https://cloud.google.com/monitoring/api/ref_v3/rest/v3/services#Service
     *
     * Generated from protobuf field <code>string filter = 2;</code>
     */
    private $filter = '';
    /**
     * A non-negative number that is the maximum number of results to return.
     * When 0, use default page size.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     */
    private $page_size = 0;
    /**
     * If this field is not empty then it must contain the `nextPageToken` value
     * returned by a previous call to this method.  Using this field causes the
     * method to return additional results from the previous method call.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     */
    private $page_token = '';

    /**
     * @param string $parent Required. Resource name of the parent containing the listed services,
     *                       either a [project](https://cloud.google.com/monitoring/api/v3#project_name)
     *                       or a Monitoring Metrics Scope. The formats are:
     *
     *                       projects/[PROJECT_ID_OR_NUMBER]
     *                       workspaces/[HOST_PROJECT_ID_OR_NUMBER]
     *
     * @return \Google\Cloud\Monitoring\V3\ListServicesRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Resource name of the parent containing the listed services,
     *           either a [project](https://cloud.google.com/monitoring/api/v3#project_name)
     *           or a Monitoring Metrics Scope. The formats are:
     *               projects/[PROJECT_ID_OR_NUMBER]
     *               workspaces/[HOST_PROJECT_ID_OR_NUMBER]
     *     @type string $filter
     *           A filter specifying what `Service`s to return. The filter supports
     *           filtering on a particular service-identifier type or one of its attributes.
     *           To filter on a particular service-identifier type, the `identifier_case`
     *           refers to which option in the `identifier` field is populated. For example,
     *           the filter `identifier_case = "CUSTOM"` would match all services with a
     *           value for the `custom` field. Valid options include "CUSTOM", "APP_ENGINE",
     *           "MESH_ISTIO", and the other options listed at
     *           https://cloud.google.com/monitoring/api/ref_v3/rest/v3/services#Service
     *           To filter on an attribute of a service-identifier type, apply the filter
     *           name by using the snake case of the service-identifier type and the
     *           attribute of that service-identifier type, and join the two with a period.
     *           For example, to filter by the `meshUid` field of the `MeshIstio`
     *           service-identifier type, you must filter on `mesh_istio.mesh_uid =
     *           "123"` to match all services with mesh UID "123". Service-identifier types
     *           and their attributes are described at
     *           https://cloud.google.com/monitoring/api/ref_v3/rest/v3/services#Service
     *     @type int $page_size
     *           A non-negative number that is the maximum number of results to return.
     *           When 0, use default page size.
     *     @type string $page_token
     *           If this field is not empty then it must contain the `nextPageToken` value
     *           returned by a previous call to this method.  Using this field causes the
     *           method to return additional results from the previous method call.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Monitoring\V3\ServiceService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Resource name of the parent containing the listed services,
     * either a [project](https://cloud.google.com/monitoring/api/v3#project_name)
     * or a Monitoring Metrics Scope. The formats are:
     *     projects/[PROJECT_ID_OR_NUMBER]
     *     workspaces/[HOST_PROJECT_ID_OR_NUMBER]
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Resource name of the parent containing the listed services,
     * either a [project](https://cloud.google.com/monitoring/api/v3#project_name)
     * or a Monitoring Metrics Scope. The formats are:
     *     projects/[PROJECT_ID_OR_NUMBER]
     *     workspaces/[HOST_PROJECT_ID_OR_NUMBER]
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * A filter specifying what `Service`s to return. The filter supports
     * filtering on a particular service-identifier type or one of its attributes.
     * To filter on a particular service-identifier type, the `identifier_case`
     * refers to which option in the `identifier` field is populated. For example,
     * the filter `identifier_case = "CUSTOM"` would match all services with a
     * value for the `custom` field. Valid options include "CUSTOM", "APP_ENGINE",
     * "MESH_ISTIO", and the other options listed at
     * https://cloud.google.com/monitoring/api/ref_v3/rest/v3/services#Service
     * To filter on an attribute of a service-identifier type, apply the filter
     * name by using the snake case of the service-identifier type and the
     * attribute of that service-identifier type, and join the two with a period.
     * For example, to filter by the `meshUid` field of the `MeshIstio`
     * service-identifier type, you must filter on `mesh_istio.mesh_uid =
     * "123"` to match all services with mesh UID "123". Service-identifier types
     * and their attributes are described at
     * https://cloud.google.com/monitoring/api/ref_v3/rest/v3/services#Service
     *
     * Generated from protobuf field <code>string filter = 2;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * A filter specifying what `Service`s to return. The filter supports
     * filtering on a particular service-identifier type or one of its attributes.
     * To filter on a particular service-identifier type, the `identifier_case`
     * refers to which option in the `identifier` field is populated. For example,
     * the filter `identifier_case = "CUSTOM"` would match all services with a
     * value for the `custom` field. Valid options include "CUSTOM", "APP_ENGINE",
     * "MESH_ISTIO", and the other options listed at
     * https://cloud.google.com/monitoring/api/ref_v3/rest/v3/services#Service
     * To filter on an attribute of a service-identifier type, apply the filter
     * name by using the snake case of the service-identifier type and the
     * attribute of that service-identifier type, and join the two with a period.
     * For example, to filter by the `meshUid` field of the `MeshIstio`
     * service-identifier type, you must filter on `mesh_istio.mesh_uid =
     * "123"` to match all services with mesh UID "123". Service-identifier types
     * and their attributes are described at
     * https://cloud.google.com/monitoring/api/ref_v3/rest/v3/services#Service
     *
     * Generated from protobuf field <code>string filter = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * A non-negative number that is the maximum number of results to return.
     * When 0, use default page size.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * A non-negative number that is the maximum number of results to return.
     * When 0, use default page size.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * If this field is not empty then it must contain the `nextPageToken` value
     * returned by a previous call to this method.  Using this field causes the
     * method to return additional results from the previous method call.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * If this field is not empty then it must contain the `nextPageToken` value
     * returned by a previous call to this method.  Using this field causes the
     * method to return additional results from the previous method call.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

