<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/netapp/v1/active_directory.proto

namespace Google\Cloud\NetApp\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * CreateActiveDirectoryRequest for creating an active directory.
 *
 * Generated from protobuf message <code>google.cloud.netapp.v1.CreateActiveDirectoryRequest</code>
 */
class CreateActiveDirectoryRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Value for parent.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. Fields of the to be created active directory.
     *
     * Generated from protobuf field <code>.google.cloud.netapp.v1.ActiveDirectory active_directory = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $active_directory = null;
    /**
     * Required. ID of the active directory to create. Must be unique within the
     * parent resource. Must contain only letters, numbers, underscore and hyphen,
     * with the first character a letter or underscore, the last a letter or
     * underscore or a number, and a 63 character maximum.
     *
     * Generated from protobuf field <code>string active_directory_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $active_directory_id = '';

    /**
     * @param string                                  $parent            Required. Value for parent. Please see
     *                                                                   {@see NetAppClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\NetApp\V1\ActiveDirectory $activeDirectory   Required. Fields of the to be created active directory.
     * @param string                                  $activeDirectoryId Required. ID of the active directory to create. Must be unique within the
     *                                                                   parent resource. Must contain only letters, numbers, underscore and hyphen,
     *                                                                   with the first character a letter or underscore, the last a letter or
     *                                                                   underscore or a number, and a 63 character maximum.
     *
     * @return \Google\Cloud\NetApp\V1\CreateActiveDirectoryRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\NetApp\V1\ActiveDirectory $activeDirectory, string $activeDirectoryId): self
    {
        return (new self())
            ->setParent($parent)
            ->setActiveDirectory($activeDirectory)
            ->setActiveDirectoryId($activeDirectoryId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Value for parent.
     *     @type \Google\Cloud\NetApp\V1\ActiveDirectory $active_directory
     *           Required. Fields of the to be created active directory.
     *     @type string $active_directory_id
     *           Required. ID of the active directory to create. Must be unique within the
     *           parent resource. Must contain only letters, numbers, underscore and hyphen,
     *           with the first character a letter or underscore, the last a letter or
     *           underscore or a number, and a 63 character maximum.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Netapp\V1\ActiveDirectory::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Value for parent.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Value for parent.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. Fields of the to be created active directory.
     *
     * Generated from protobuf field <code>.google.cloud.netapp.v1.ActiveDirectory active_directory = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\NetApp\V1\ActiveDirectory|null
     */
    public function getActiveDirectory()
    {
        return $this->active_directory;
    }

    public function hasActiveDirectory()
    {
        return isset($this->active_directory);
    }

    public function clearActiveDirectory()
    {
        unset($this->active_directory);
    }

    /**
     * Required. Fields of the to be created active directory.
     *
     * Generated from protobuf field <code>.google.cloud.netapp.v1.ActiveDirectory active_directory = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\NetApp\V1\ActiveDirectory $var
     * @return $this
     */
    public function setActiveDirectory($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\NetApp\V1\ActiveDirectory::class);
        $this->active_directory = $var;

        return $this;
    }

    /**
     * Required. ID of the active directory to create. Must be unique within the
     * parent resource. Must contain only letters, numbers, underscore and hyphen,
     * with the first character a letter or underscore, the last a letter or
     * underscore or a number, and a 63 character maximum.
     *
     * Generated from protobuf field <code>string active_directory_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getActiveDirectoryId()
    {
        return $this->active_directory_id;
    }

    /**
     * Required. ID of the active directory to create. Must be unique within the
     * parent resource. Must contain only letters, numbers, underscore and hyphen,
     * with the first character a letter or underscore, the last a letter or
     * underscore or a number, and a 63 character maximum.
     *
     * Generated from protobuf field <code>string active_directory_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setActiveDirectoryId($var)
    {
        GPBUtil::checkString($var, True);
        $this->active_directory_id = $var;

        return $this;
    }

}

