<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/netapp/v1/backup_vault.proto

namespace Google\Cloud\NetApp\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * CreateBackupVaultRequest creates a backup vault.
 *
 * Generated from protobuf message <code>google.cloud.netapp.v1.CreateBackupVaultRequest</code>
 */
class CreateBackupVaultRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The location to create the backup vaults, in the format
     * `projects/{project_id}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The ID to use for the backupVault.
     * The ID must be unique within the specified location.
     * Must contain only letters, numbers, underscore and hyphen, with the first
     * character a letter or underscore, the last a letter or underscore or a
     * number, and a 63 character maximum.
     *
     * Generated from protobuf field <code>string backup_vault_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $backup_vault_id = '';
    /**
     * Required. A backupVault resource
     *
     * Generated from protobuf field <code>.google.cloud.netapp.v1.BackupVault backup_vault = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $backup_vault = null;

    /**
     * @param string                              $parent        Required. The location to create the backup vaults, in the format
     *                                                           `projects/{project_id}/locations/{location}`
     *                                                           Please see {@see NetAppClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\NetApp\V1\BackupVault $backupVault   Required. A backupVault resource
     * @param string                              $backupVaultId Required. The ID to use for the backupVault.
     *                                                           The ID must be unique within the specified location.
     *                                                           Must contain only letters, numbers, underscore and hyphen, with the first
     *                                                           character a letter or underscore, the last a letter or underscore or a
     *                                                           number, and a 63 character maximum.
     *
     * @return \Google\Cloud\NetApp\V1\CreateBackupVaultRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\NetApp\V1\BackupVault $backupVault, string $backupVaultId): self
    {
        return (new self())
            ->setParent($parent)
            ->setBackupVault($backupVault)
            ->setBackupVaultId($backupVaultId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The location to create the backup vaults, in the format
     *           `projects/{project_id}/locations/{location}`
     *     @type string $backup_vault_id
     *           Required. The ID to use for the backupVault.
     *           The ID must be unique within the specified location.
     *           Must contain only letters, numbers, underscore and hyphen, with the first
     *           character a letter or underscore, the last a letter or underscore or a
     *           number, and a 63 character maximum.
     *     @type \Google\Cloud\NetApp\V1\BackupVault $backup_vault
     *           Required. A backupVault resource
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Netapp\V1\BackupVault::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The location to create the backup vaults, in the format
     * `projects/{project_id}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The location to create the backup vaults, in the format
     * `projects/{project_id}/locations/{location}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The ID to use for the backupVault.
     * The ID must be unique within the specified location.
     * Must contain only letters, numbers, underscore and hyphen, with the first
     * character a letter or underscore, the last a letter or underscore or a
     * number, and a 63 character maximum.
     *
     * Generated from protobuf field <code>string backup_vault_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getBackupVaultId()
    {
        return $this->backup_vault_id;
    }

    /**
     * Required. The ID to use for the backupVault.
     * The ID must be unique within the specified location.
     * Must contain only letters, numbers, underscore and hyphen, with the first
     * character a letter or underscore, the last a letter or underscore or a
     * number, and a 63 character maximum.
     *
     * Generated from protobuf field <code>string backup_vault_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setBackupVaultId($var)
    {
        GPBUtil::checkString($var, True);
        $this->backup_vault_id = $var;

        return $this;
    }

    /**
     * Required. A backupVault resource
     *
     * Generated from protobuf field <code>.google.cloud.netapp.v1.BackupVault backup_vault = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\NetApp\V1\BackupVault|null
     */
    public function getBackupVault()
    {
        return $this->backup_vault;
    }

    public function hasBackupVault()
    {
        return isset($this->backup_vault);
    }

    public function clearBackupVault()
    {
        unset($this->backup_vault);
    }

    /**
     * Required. A backupVault resource
     *
     * Generated from protobuf field <code>.google.cloud.netapp.v1.BackupVault backup_vault = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\NetApp\V1\BackupVault $var
     * @return $this
     */
    public function setBackupVault($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\NetApp\V1\BackupVault::class);
        $this->backup_vault = $var;

        return $this;
    }

}

