<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/netapp/v1/replication.proto

namespace Google\Cloud\NetApp\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * CreateReplicationRequest creates a replication.
 *
 * Generated from protobuf message <code>google.cloud.netapp.v1.CreateReplicationRequest</code>
 */
class CreateReplicationRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The NetApp volume to create the replications of, in the format
     * `projects/{project_id}/locations/{location}/volumes/{volume_id}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. A replication resource
     *
     * Generated from protobuf field <code>.google.cloud.netapp.v1.Replication replication = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $replication = null;
    /**
     * Required. ID of the replication to create. Must be unique within the parent
     * resource. Must contain only letters, numbers, underscore and hyphen, with
     * the first character a letter or underscore, the last a letter or underscore
     * or a number, and a 63 character maximum.
     *
     * Generated from protobuf field <code>string replication_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $replication_id = '';

    /**
     * @param string                              $parent        Required. The NetApp volume to create the replications of, in the format
     *                                                           `projects/{project_id}/locations/{location}/volumes/{volume_id}`
     *                                                           Please see {@see NetAppClient::volumeName()} for help formatting this field.
     * @param \Google\Cloud\NetApp\V1\Replication $replication   Required. A replication resource
     * @param string                              $replicationId Required. ID of the replication to create. Must be unique within the parent
     *                                                           resource. Must contain only letters, numbers, underscore and hyphen, with
     *                                                           the first character a letter or underscore, the last a letter or underscore
     *                                                           or a number, and a 63 character maximum.
     *
     * @return \Google\Cloud\NetApp\V1\CreateReplicationRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\NetApp\V1\Replication $replication, string $replicationId): self
    {
        return (new self())
            ->setParent($parent)
            ->setReplication($replication)
            ->setReplicationId($replicationId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The NetApp volume to create the replications of, in the format
     *           `projects/{project_id}/locations/{location}/volumes/{volume_id}`
     *     @type \Google\Cloud\NetApp\V1\Replication $replication
     *           Required. A replication resource
     *     @type string $replication_id
     *           Required. ID of the replication to create. Must be unique within the parent
     *           resource. Must contain only letters, numbers, underscore and hyphen, with
     *           the first character a letter or underscore, the last a letter or underscore
     *           or a number, and a 63 character maximum.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Netapp\V1\Replication::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The NetApp volume to create the replications of, in the format
     * `projects/{project_id}/locations/{location}/volumes/{volume_id}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The NetApp volume to create the replications of, in the format
     * `projects/{project_id}/locations/{location}/volumes/{volume_id}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. A replication resource
     *
     * Generated from protobuf field <code>.google.cloud.netapp.v1.Replication replication = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\NetApp\V1\Replication|null
     */
    public function getReplication()
    {
        return $this->replication;
    }

    public function hasReplication()
    {
        return isset($this->replication);
    }

    public function clearReplication()
    {
        unset($this->replication);
    }

    /**
     * Required. A replication resource
     *
     * Generated from protobuf field <code>.google.cloud.netapp.v1.Replication replication = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\NetApp\V1\Replication $var
     * @return $this
     */
    public function setReplication($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\NetApp\V1\Replication::class);
        $this->replication = $var;

        return $this;
    }

    /**
     * Required. ID of the replication to create. Must be unique within the parent
     * resource. Must contain only letters, numbers, underscore and hyphen, with
     * the first character a letter or underscore, the last a letter or underscore
     * or a number, and a 63 character maximum.
     *
     * Generated from protobuf field <code>string replication_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getReplicationId()
    {
        return $this->replication_id;
    }

    /**
     * Required. ID of the replication to create. Must be unique within the parent
     * resource. Must contain only letters, numbers, underscore and hyphen, with
     * the first character a letter or underscore, the last a letter or underscore
     * or a number, and a 63 character maximum.
     *
     * Generated from protobuf field <code>string replication_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setReplicationId($var)
    {
        GPBUtil::checkString($var, True);
        $this->replication_id = $var;

        return $this;
    }

}

