<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/netapp/v1/storage_pool.proto

namespace Google\Cloud\NetApp\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * StoragePool is a container for volumes with a service level and capacity.
 * Volumes can be created in a pool of sufficient available capacity.
 * StoragePool capacity is what you are billed for.
 *
 * Generated from protobuf message <code>google.cloud.netapp.v1.StoragePool</code>
 */
class StoragePool extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. Name of the storage pool
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Required. Service level of the storage pool
     *
     * Generated from protobuf field <code>.google.cloud.netapp.v1.ServiceLevel service_level = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $service_level = 0;
    /**
     * Required. Capacity in GIB of the pool
     *
     * Generated from protobuf field <code>int64 capacity_gib = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $capacity_gib = 0;
    /**
     * Output only. Allocated size of all volumes in GIB in the storage pool
     *
     * Generated from protobuf field <code>int64 volume_capacity_gib = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $volume_capacity_gib = 0;
    /**
     * Output only. Volume count of the storage pool
     *
     * Generated from protobuf field <code>int32 volume_count = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $volume_count = 0;
    /**
     * Output only. State of the storage pool
     *
     * Generated from protobuf field <code>.google.cloud.netapp.v1.StoragePool.State state = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;
    /**
     * Output only. State details of the storage pool
     *
     * Generated from protobuf field <code>string state_details = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state_details = '';
    /**
     * Output only. Create time of the storage pool
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Optional. Description of the storage pool
     *
     * Generated from protobuf field <code>string description = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $description = '';
    /**
     * Optional. Labels as key value pairs
     *
     * Generated from protobuf field <code>map<string, string> labels = 10 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $labels;
    /**
     * Required. VPC Network name.
     * Format: projects/{project}/global/networks/{network}
     *
     * Generated from protobuf field <code>string network = 11 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $network = '';
    /**
     * Optional. Specifies the Active Directory to be used for creating a SMB
     * volume.
     *
     * Generated from protobuf field <code>string active_directory = 12 [(.google.api.field_behavior) = OPTIONAL, (.google.api.resource_reference) = {</code>
     */
    protected $active_directory = '';
    /**
     * Optional. Specifies the KMS config to be used for volume encryption.
     *
     * Generated from protobuf field <code>string kms_config = 13 [(.google.api.field_behavior) = OPTIONAL, (.google.api.resource_reference) = {</code>
     */
    protected $kms_config = '';
    /**
     * Optional. Flag indicating if the pool is NFS LDAP enabled or not.
     *
     * Generated from protobuf field <code>bool ldap_enabled = 14 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $ldap_enabled = false;
    /**
     * Optional. This field is not implemented. The values provided in this field
     * are ignored.
     *
     * Generated from protobuf field <code>string psa_range = 15 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $psa_range = '';
    /**
     * Output only. Specifies the current pool encryption key source.
     *
     * Generated from protobuf field <code>.google.cloud.netapp.v1.EncryptionType encryption_type = 16 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $encryption_type = 0;
    /**
     * Deprecated. Used to allow SO pool to access AD or DNS server from other
     * regions.
     *
     * Generated from protobuf field <code>optional bool global_access_allowed = 17 [deprecated = true];</code>
     * @deprecated
     */
    protected $global_access_allowed = null;
    /**
     * Optional. True if the storage pool supports Auto Tiering enabled volumes.
     * Default is false. Auto-tiering can be enabled after storage pool creation
     * but it can't be disabled once enabled.
     *
     * Generated from protobuf field <code>bool allow_auto_tiering = 18 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $allow_auto_tiering = false;
    /**
     * Optional. Specifies the replica zone for regional storagePool.
     *
     * Generated from protobuf field <code>string replica_zone = 20 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $replica_zone = '';
    /**
     * Optional. Specifies the active zone for regional storagePool.
     *
     * Generated from protobuf field <code>string zone = 21 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $zone = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. Name of the storage pool
     *     @type int $service_level
     *           Required. Service level of the storage pool
     *     @type int|string $capacity_gib
     *           Required. Capacity in GIB of the pool
     *     @type int|string $volume_capacity_gib
     *           Output only. Allocated size of all volumes in GIB in the storage pool
     *     @type int $volume_count
     *           Output only. Volume count of the storage pool
     *     @type int $state
     *           Output only. State of the storage pool
     *     @type string $state_details
     *           Output only. State details of the storage pool
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. Create time of the storage pool
     *     @type string $description
     *           Optional. Description of the storage pool
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Optional. Labels as key value pairs
     *     @type string $network
     *           Required. VPC Network name.
     *           Format: projects/{project}/global/networks/{network}
     *     @type string $active_directory
     *           Optional. Specifies the Active Directory to be used for creating a SMB
     *           volume.
     *     @type string $kms_config
     *           Optional. Specifies the KMS config to be used for volume encryption.
     *     @type bool $ldap_enabled
     *           Optional. Flag indicating if the pool is NFS LDAP enabled or not.
     *     @type string $psa_range
     *           Optional. This field is not implemented. The values provided in this field
     *           are ignored.
     *     @type int $encryption_type
     *           Output only. Specifies the current pool encryption key source.
     *     @type bool $global_access_allowed
     *           Deprecated. Used to allow SO pool to access AD or DNS server from other
     *           regions.
     *     @type bool $allow_auto_tiering
     *           Optional. True if the storage pool supports Auto Tiering enabled volumes.
     *           Default is false. Auto-tiering can be enabled after storage pool creation
     *           but it can't be disabled once enabled.
     *     @type string $replica_zone
     *           Optional. Specifies the replica zone for regional storagePool.
     *     @type string $zone
     *           Optional. Specifies the active zone for regional storagePool.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Netapp\V1\StoragePool::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. Name of the storage pool
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. Name of the storage pool
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Required. Service level of the storage pool
     *
     * Generated from protobuf field <code>.google.cloud.netapp.v1.ServiceLevel service_level = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return int
     */
    public function getServiceLevel()
    {
        return $this->service_level;
    }

    /**
     * Required. Service level of the storage pool
     *
     * Generated from protobuf field <code>.google.cloud.netapp.v1.ServiceLevel service_level = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int $var
     * @return $this
     */
    public function setServiceLevel($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\NetApp\V1\ServiceLevel::class);
        $this->service_level = $var;

        return $this;
    }

    /**
     * Required. Capacity in GIB of the pool
     *
     * Generated from protobuf field <code>int64 capacity_gib = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return int|string
     */
    public function getCapacityGib()
    {
        return $this->capacity_gib;
    }

    /**
     * Required. Capacity in GIB of the pool
     *
     * Generated from protobuf field <code>int64 capacity_gib = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int|string $var
     * @return $this
     */
    public function setCapacityGib($var)
    {
        GPBUtil::checkInt64($var);
        $this->capacity_gib = $var;

        return $this;
    }

    /**
     * Output only. Allocated size of all volumes in GIB in the storage pool
     *
     * Generated from protobuf field <code>int64 volume_capacity_gib = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int|string
     */
    public function getVolumeCapacityGib()
    {
        return $this->volume_capacity_gib;
    }

    /**
     * Output only. Allocated size of all volumes in GIB in the storage pool
     *
     * Generated from protobuf field <code>int64 volume_capacity_gib = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int|string $var
     * @return $this
     */
    public function setVolumeCapacityGib($var)
    {
        GPBUtil::checkInt64($var);
        $this->volume_capacity_gib = $var;

        return $this;
    }

    /**
     * Output only. Volume count of the storage pool
     *
     * Generated from protobuf field <code>int32 volume_count = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getVolumeCount()
    {
        return $this->volume_count;
    }

    /**
     * Output only. Volume count of the storage pool
     *
     * Generated from protobuf field <code>int32 volume_count = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setVolumeCount($var)
    {
        GPBUtil::checkInt32($var);
        $this->volume_count = $var;

        return $this;
    }

    /**
     * Output only. State of the storage pool
     *
     * Generated from protobuf field <code>.google.cloud.netapp.v1.StoragePool.State state = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. State of the storage pool
     *
     * Generated from protobuf field <code>.google.cloud.netapp.v1.StoragePool.State state = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\NetApp\V1\StoragePool\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Output only. State details of the storage pool
     *
     * Generated from protobuf field <code>string state_details = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getStateDetails()
    {
        return $this->state_details;
    }

    /**
     * Output only. State details of the storage pool
     *
     * Generated from protobuf field <code>string state_details = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setStateDetails($var)
    {
        GPBUtil::checkString($var, True);
        $this->state_details = $var;

        return $this;
    }

    /**
     * Output only. Create time of the storage pool
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. Create time of the storage pool
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Optional. Description of the storage pool
     *
     * Generated from protobuf field <code>string description = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Optional. Description of the storage pool
     *
     * Generated from protobuf field <code>string description = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Optional. Labels as key value pairs
     *
     * Generated from protobuf field <code>map<string, string> labels = 10 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Optional. Labels as key value pairs
     *
     * Generated from protobuf field <code>map<string, string> labels = 10 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * Required. VPC Network name.
     * Format: projects/{project}/global/networks/{network}
     *
     * Generated from protobuf field <code>string network = 11 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getNetwork()
    {
        return $this->network;
    }

    /**
     * Required. VPC Network name.
     * Format: projects/{project}/global/networks/{network}
     *
     * Generated from protobuf field <code>string network = 11 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setNetwork($var)
    {
        GPBUtil::checkString($var, True);
        $this->network = $var;

        return $this;
    }

    /**
     * Optional. Specifies the Active Directory to be used for creating a SMB
     * volume.
     *
     * Generated from protobuf field <code>string active_directory = 12 [(.google.api.field_behavior) = OPTIONAL, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getActiveDirectory()
    {
        return $this->active_directory;
    }

    /**
     * Optional. Specifies the Active Directory to be used for creating a SMB
     * volume.
     *
     * Generated from protobuf field <code>string active_directory = 12 [(.google.api.field_behavior) = OPTIONAL, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setActiveDirectory($var)
    {
        GPBUtil::checkString($var, True);
        $this->active_directory = $var;

        return $this;
    }

    /**
     * Optional. Specifies the KMS config to be used for volume encryption.
     *
     * Generated from protobuf field <code>string kms_config = 13 [(.google.api.field_behavior) = OPTIONAL, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getKmsConfig()
    {
        return $this->kms_config;
    }

    /**
     * Optional. Specifies the KMS config to be used for volume encryption.
     *
     * Generated from protobuf field <code>string kms_config = 13 [(.google.api.field_behavior) = OPTIONAL, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setKmsConfig($var)
    {
        GPBUtil::checkString($var, True);
        $this->kms_config = $var;

        return $this;
    }

    /**
     * Optional. Flag indicating if the pool is NFS LDAP enabled or not.
     *
     * Generated from protobuf field <code>bool ldap_enabled = 14 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getLdapEnabled()
    {
        return $this->ldap_enabled;
    }

    /**
     * Optional. Flag indicating if the pool is NFS LDAP enabled or not.
     *
     * Generated from protobuf field <code>bool ldap_enabled = 14 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setLdapEnabled($var)
    {
        GPBUtil::checkBool($var);
        $this->ldap_enabled = $var;

        return $this;
    }

    /**
     * Optional. This field is not implemented. The values provided in this field
     * are ignored.
     *
     * Generated from protobuf field <code>string psa_range = 15 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPsaRange()
    {
        return $this->psa_range;
    }

    /**
     * Optional. This field is not implemented. The values provided in this field
     * are ignored.
     *
     * Generated from protobuf field <code>string psa_range = 15 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPsaRange($var)
    {
        GPBUtil::checkString($var, True);
        $this->psa_range = $var;

        return $this;
    }

    /**
     * Output only. Specifies the current pool encryption key source.
     *
     * Generated from protobuf field <code>.google.cloud.netapp.v1.EncryptionType encryption_type = 16 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getEncryptionType()
    {
        return $this->encryption_type;
    }

    /**
     * Output only. Specifies the current pool encryption key source.
     *
     * Generated from protobuf field <code>.google.cloud.netapp.v1.EncryptionType encryption_type = 16 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setEncryptionType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\NetApp\V1\EncryptionType::class);
        $this->encryption_type = $var;

        return $this;
    }

    /**
     * Deprecated. Used to allow SO pool to access AD or DNS server from other
     * regions.
     *
     * Generated from protobuf field <code>optional bool global_access_allowed = 17 [deprecated = true];</code>
     * @return bool
     * @deprecated
     */
    public function getGlobalAccessAllowed()
    {
        @trigger_error('global_access_allowed is deprecated.', E_USER_DEPRECATED);
        return isset($this->global_access_allowed) ? $this->global_access_allowed : false;
    }

    public function hasGlobalAccessAllowed()
    {
        @trigger_error('global_access_allowed is deprecated.', E_USER_DEPRECATED);
        return isset($this->global_access_allowed);
    }

    public function clearGlobalAccessAllowed()
    {
        @trigger_error('global_access_allowed is deprecated.', E_USER_DEPRECATED);
        unset($this->global_access_allowed);
    }

    /**
     * Deprecated. Used to allow SO pool to access AD or DNS server from other
     * regions.
     *
     * Generated from protobuf field <code>optional bool global_access_allowed = 17 [deprecated = true];</code>
     * @param bool $var
     * @return $this
     * @deprecated
     */
    public function setGlobalAccessAllowed($var)
    {
        @trigger_error('global_access_allowed is deprecated.', E_USER_DEPRECATED);
        GPBUtil::checkBool($var);
        $this->global_access_allowed = $var;

        return $this;
    }

    /**
     * Optional. True if the storage pool supports Auto Tiering enabled volumes.
     * Default is false. Auto-tiering can be enabled after storage pool creation
     * but it can't be disabled once enabled.
     *
     * Generated from protobuf field <code>bool allow_auto_tiering = 18 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getAllowAutoTiering()
    {
        return $this->allow_auto_tiering;
    }

    /**
     * Optional. True if the storage pool supports Auto Tiering enabled volumes.
     * Default is false. Auto-tiering can be enabled after storage pool creation
     * but it can't be disabled once enabled.
     *
     * Generated from protobuf field <code>bool allow_auto_tiering = 18 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setAllowAutoTiering($var)
    {
        GPBUtil::checkBool($var);
        $this->allow_auto_tiering = $var;

        return $this;
    }

    /**
     * Optional. Specifies the replica zone for regional storagePool.
     *
     * Generated from protobuf field <code>string replica_zone = 20 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getReplicaZone()
    {
        return $this->replica_zone;
    }

    /**
     * Optional. Specifies the replica zone for regional storagePool.
     *
     * Generated from protobuf field <code>string replica_zone = 20 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setReplicaZone($var)
    {
        GPBUtil::checkString($var, True);
        $this->replica_zone = $var;

        return $this;
    }

    /**
     * Optional. Specifies the active zone for regional storagePool.
     *
     * Generated from protobuf field <code>string zone = 21 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getZone()
    {
        return $this->zone;
    }

    /**
     * Optional. Specifies the active zone for regional storagePool.
     *
     * Generated from protobuf field <code>string zone = 21 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setZone($var)
    {
        GPBUtil::checkString($var, True);
        $this->zone = $var;

        return $this;
    }

}

