<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/networkconnectivity/v1/policy_based_routing.proto

namespace Google\Cloud\NetworkConnectivity\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request for [PolicyBasedRouting.CreatePolicyBasedRoute][] method.
 *
 * Generated from protobuf message <code>google.cloud.networkconnectivity.v1.CreatePolicyBasedRouteRequest</code>
 */
class CreatePolicyBasedRouteRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent resource's name of the PolicyBasedRoute.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. Unique id for the Policy Based Route to create.
     *
     * Generated from protobuf field <code>string policy_based_route_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $policy_based_route_id = '';
    /**
     * Required. Initial values for a new Policy Based Route.
     *
     * Generated from protobuf field <code>.google.cloud.networkconnectivity.v1.PolicyBasedRoute policy_based_route = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $policy_based_route = null;
    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and
     * the request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $request_id = '';

    /**
     * @param string                                                $parent             Required. The parent resource's name of the PolicyBasedRoute. Please see
     *                                                                                  {@see PolicyBasedRoutingServiceClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\NetworkConnectivity\V1\PolicyBasedRoute $policyBasedRoute   Required. Initial values for a new Policy Based Route.
     * @param string                                                $policyBasedRouteId Required. Unique id for the Policy Based Route to create.
     *
     * @return \Google\Cloud\NetworkConnectivity\V1\CreatePolicyBasedRouteRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\NetworkConnectivity\V1\PolicyBasedRoute $policyBasedRoute, string $policyBasedRouteId): self
    {
        return (new self())
            ->setParent($parent)
            ->setPolicyBasedRoute($policyBasedRoute)
            ->setPolicyBasedRouteId($policyBasedRouteId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent resource's name of the PolicyBasedRoute.
     *     @type string $policy_based_route_id
     *           Required. Unique id for the Policy Based Route to create.
     *     @type \Google\Cloud\NetworkConnectivity\V1\PolicyBasedRoute $policy_based_route
     *           Required. Initial values for a new Policy Based Route.
     *     @type string $request_id
     *           Optional. An optional request ID to identify requests. Specify a unique
     *           request ID so that if you must retry your request, the server will know to
     *           ignore the request if it has already been completed. The server will
     *           guarantee that for at least 60 minutes since the first request.
     *           For example, consider a situation where you make an initial request and
     *           the request times out. If you make the request again with the same request
     *           ID, the server can check if original operation with the same request ID
     *           was received, and if so, will ignore the second request. This prevents
     *           clients from accidentally creating duplicate commitments.
     *           The request ID must be a valid UUID with the exception that zero UUID is
     *           not supported (00000000-0000-0000-0000-000000000000).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Networkconnectivity\V1\PolicyBasedRouting::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent resource's name of the PolicyBasedRoute.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent resource's name of the PolicyBasedRoute.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. Unique id for the Policy Based Route to create.
     *
     * Generated from protobuf field <code>string policy_based_route_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getPolicyBasedRouteId()
    {
        return $this->policy_based_route_id;
    }

    /**
     * Required. Unique id for the Policy Based Route to create.
     *
     * Generated from protobuf field <code>string policy_based_route_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setPolicyBasedRouteId($var)
    {
        GPBUtil::checkString($var, True);
        $this->policy_based_route_id = $var;

        return $this;
    }

    /**
     * Required. Initial values for a new Policy Based Route.
     *
     * Generated from protobuf field <code>.google.cloud.networkconnectivity.v1.PolicyBasedRoute policy_based_route = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\NetworkConnectivity\V1\PolicyBasedRoute|null
     */
    public function getPolicyBasedRoute()
    {
        return $this->policy_based_route;
    }

    public function hasPolicyBasedRoute()
    {
        return isset($this->policy_based_route);
    }

    public function clearPolicyBasedRoute()
    {
        unset($this->policy_based_route);
    }

    /**
     * Required. Initial values for a new Policy Based Route.
     *
     * Generated from protobuf field <code>.google.cloud.networkconnectivity.v1.PolicyBasedRoute policy_based_route = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\NetworkConnectivity\V1\PolicyBasedRoute $var
     * @return $this
     */
    public function setPolicyBasedRoute($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\NetworkConnectivity\V1\PolicyBasedRoute::class);
        $this->policy_based_route = $var;

        return $this;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and
     * the request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getRequestId()
    {
        return $this->request_id;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and
     * the request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setRequestId($var)
    {
        GPBUtil::checkString($var, True);
        $this->request_id = $var;

        return $this;
    }

}

