<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/networkconnectivity/v1/hub.proto

namespace Google\Cloud\NetworkConnectivity\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A collection of router appliance instances. If you configure multiple router
 * appliance instances to receive data from the same set of sites outside of
 * Google Cloud, we recommend that you associate those instances with the same
 * spoke.
 *
 * Generated from protobuf message <code>google.cloud.networkconnectivity.v1.LinkedRouterApplianceInstances</code>
 */
class LinkedRouterApplianceInstances extends \Google\Protobuf\Internal\Message
{
    /**
     * The list of router appliance instances.
     *
     * Generated from protobuf field <code>repeated .google.cloud.networkconnectivity.v1.RouterApplianceInstance instances = 1;</code>
     */
    private $instances;
    /**
     * A value that controls whether site-to-site data transfer is enabled for
     * these resources. Data transfer is available only in [supported
     * locations](https://cloud.google.com/network-connectivity/docs/network-connectivity-center/concepts/locations).
     *
     * Generated from protobuf field <code>bool site_to_site_data_transfer = 2;</code>
     */
    protected $site_to_site_data_transfer = false;
    /**
     * Output only. The VPC network where these router appliance instances are
     * located.
     *
     * Generated from protobuf field <code>string vpc_network = 3 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     */
    protected $vpc_network = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type array<\Google\Cloud\NetworkConnectivity\V1\RouterApplianceInstance>|\Google\Protobuf\Internal\RepeatedField $instances
     *           The list of router appliance instances.
     *     @type bool $site_to_site_data_transfer
     *           A value that controls whether site-to-site data transfer is enabled for
     *           these resources. Data transfer is available only in [supported
     *           locations](https://cloud.google.com/network-connectivity/docs/network-connectivity-center/concepts/locations).
     *     @type string $vpc_network
     *           Output only. The VPC network where these router appliance instances are
     *           located.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Networkconnectivity\V1\Hub::initOnce();
        parent::__construct($data);
    }

    /**
     * The list of router appliance instances.
     *
     * Generated from protobuf field <code>repeated .google.cloud.networkconnectivity.v1.RouterApplianceInstance instances = 1;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getInstances()
    {
        return $this->instances;
    }

    /**
     * The list of router appliance instances.
     *
     * Generated from protobuf field <code>repeated .google.cloud.networkconnectivity.v1.RouterApplianceInstance instances = 1;</code>
     * @param array<\Google\Cloud\NetworkConnectivity\V1\RouterApplianceInstance>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setInstances($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\NetworkConnectivity\V1\RouterApplianceInstance::class);
        $this->instances = $arr;

        return $this;
    }

    /**
     * A value that controls whether site-to-site data transfer is enabled for
     * these resources. Data transfer is available only in [supported
     * locations](https://cloud.google.com/network-connectivity/docs/network-connectivity-center/concepts/locations).
     *
     * Generated from protobuf field <code>bool site_to_site_data_transfer = 2;</code>
     * @return bool
     */
    public function getSiteToSiteDataTransfer()
    {
        return $this->site_to_site_data_transfer;
    }

    /**
     * A value that controls whether site-to-site data transfer is enabled for
     * these resources. Data transfer is available only in [supported
     * locations](https://cloud.google.com/network-connectivity/docs/network-connectivity-center/concepts/locations).
     *
     * Generated from protobuf field <code>bool site_to_site_data_transfer = 2;</code>
     * @param bool $var
     * @return $this
     */
    public function setSiteToSiteDataTransfer($var)
    {
        GPBUtil::checkBool($var);
        $this->site_to_site_data_transfer = $var;

        return $this;
    }

    /**
     * Output only. The VPC network where these router appliance instances are
     * located.
     *
     * Generated from protobuf field <code>string vpc_network = 3 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getVpcNetwork()
    {
        return $this->vpc_network;
    }

    /**
     * Output only. The VPC network where these router appliance instances are
     * located.
     *
     * Generated from protobuf field <code>string vpc_network = 3 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setVpcNetwork($var)
    {
        GPBUtil::checkString($var, True);
        $this->vpc_network = $var;

        return $this;
    }

}

