<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/networkconnectivity/v1/hub.proto

namespace Google\Cloud\NetworkConnectivity\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request for
 * [HubService.ListHubSpokes][google.cloud.networkconnectivity.v1.HubService.ListHubSpokes].
 *
 * Generated from protobuf message <code>google.cloud.networkconnectivity.v1.ListHubSpokesRequest</code>
 */
class ListHubSpokesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the hub.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';
    /**
     * A list of locations.
     * Specify one of the following: `[global]`, a single region (for
     * example, `[us-central1]`), or a combination of
     * values (for example, `[global, us-central1, us-west1]`).
     * If the spoke_locations field is populated, the list of results
     * includes only spokes in the specified location.
     * If the spoke_locations field is not populated, the list of results
     * includes spokes in all locations.
     *
     * Generated from protobuf field <code>repeated string spoke_locations = 2;</code>
     */
    private $spoke_locations;
    /**
     * The maximum number of results to return per page.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     */
    protected $page_size = 0;
    /**
     * The page token.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     */
    protected $page_token = '';
    /**
     * An expression that filters the list of results.
     *
     * Generated from protobuf field <code>string filter = 5;</code>
     */
    protected $filter = '';
    /**
     * Sort the results by name or create_time.
     *
     * Generated from protobuf field <code>string order_by = 6;</code>
     */
    protected $order_by = '';
    /**
     * The view of the spoke to return.
     * The view that you use determines which spoke fields are included in the
     * response.
     *
     * Generated from protobuf field <code>.google.cloud.networkconnectivity.v1.ListHubSpokesRequest.SpokeView view = 7;</code>
     */
    protected $view = 0;

    /**
     * @param string $name Required. The name of the hub. Please see
     *                     {@see HubServiceClient::hubName()} for help formatting this field.
     *
     * @return \Google\Cloud\NetworkConnectivity\V1\ListHubSpokesRequest
     *
     * @experimental
     */
    public static function build(string $name): self
    {
        return (new self())
            ->setName($name);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. The name of the hub.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $spoke_locations
     *           A list of locations.
     *           Specify one of the following: `[global]`, a single region (for
     *           example, `[us-central1]`), or a combination of
     *           values (for example, `[global, us-central1, us-west1]`).
     *           If the spoke_locations field is populated, the list of results
     *           includes only spokes in the specified location.
     *           If the spoke_locations field is not populated, the list of results
     *           includes spokes in all locations.
     *     @type int $page_size
     *           The maximum number of results to return per page.
     *     @type string $page_token
     *           The page token.
     *     @type string $filter
     *           An expression that filters the list of results.
     *     @type string $order_by
     *           Sort the results by name or create_time.
     *     @type int $view
     *           The view of the spoke to return.
     *           The view that you use determines which spoke fields are included in the
     *           response.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Networkconnectivity\V1\Hub::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the hub.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. The name of the hub.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * A list of locations.
     * Specify one of the following: `[global]`, a single region (for
     * example, `[us-central1]`), or a combination of
     * values (for example, `[global, us-central1, us-west1]`).
     * If the spoke_locations field is populated, the list of results
     * includes only spokes in the specified location.
     * If the spoke_locations field is not populated, the list of results
     * includes spokes in all locations.
     *
     * Generated from protobuf field <code>repeated string spoke_locations = 2;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSpokeLocations()
    {
        return $this->spoke_locations;
    }

    /**
     * A list of locations.
     * Specify one of the following: `[global]`, a single region (for
     * example, `[us-central1]`), or a combination of
     * values (for example, `[global, us-central1, us-west1]`).
     * If the spoke_locations field is populated, the list of results
     * includes only spokes in the specified location.
     * If the spoke_locations field is not populated, the list of results
     * includes spokes in all locations.
     *
     * Generated from protobuf field <code>repeated string spoke_locations = 2;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSpokeLocations($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->spoke_locations = $arr;

        return $this;
    }

    /**
     * The maximum number of results to return per page.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The maximum number of results to return per page.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * The page token.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * The page token.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * An expression that filters the list of results.
     *
     * Generated from protobuf field <code>string filter = 5;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * An expression that filters the list of results.
     *
     * Generated from protobuf field <code>string filter = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * Sort the results by name or create_time.
     *
     * Generated from protobuf field <code>string order_by = 6;</code>
     * @return string
     */
    public function getOrderBy()
    {
        return $this->order_by;
    }

    /**
     * Sort the results by name or create_time.
     *
     * Generated from protobuf field <code>string order_by = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setOrderBy($var)
    {
        GPBUtil::checkString($var, True);
        $this->order_by = $var;

        return $this;
    }

    /**
     * The view of the spoke to return.
     * The view that you use determines which spoke fields are included in the
     * response.
     *
     * Generated from protobuf field <code>.google.cloud.networkconnectivity.v1.ListHubSpokesRequest.SpokeView view = 7;</code>
     * @return int
     */
    public function getView()
    {
        return $this->view;
    }

    /**
     * The view of the spoke to return.
     * The view that you use determines which spoke fields are included in the
     * response.
     *
     * Generated from protobuf field <code>.google.cloud.networkconnectivity.v1.ListHubSpokesRequest.SpokeView view = 7;</code>
     * @param int $var
     * @return $this
     */
    public function setView($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\NetworkConnectivity\V1\ListHubSpokesRequest\SpokeView::class);
        $this->view = $var;

        return $this;
    }

}

