<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/networkconnectivity/v1/hub.proto

namespace Google\Cloud\NetworkConnectivity\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Summarizes information about the spokes associated with a hub.
 * The summary includes a count of spokes according to type
 * and according to state. If any spokes are inactive,
 * the summary also lists the reasons they are inactive,
 * including a count for each reason.
 *
 * Generated from protobuf message <code>google.cloud.networkconnectivity.v1.SpokeSummary</code>
 */
class SpokeSummary extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. Counts the number of spokes of each type that are
     * associated with a specific hub.
     *
     * Generated from protobuf field <code>repeated .google.cloud.networkconnectivity.v1.SpokeSummary.SpokeTypeCount spoke_type_counts = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $spoke_type_counts;
    /**
     * Output only. Counts the number of spokes that are in each state
     * and associated with a given hub.
     *
     * Generated from protobuf field <code>repeated .google.cloud.networkconnectivity.v1.SpokeSummary.SpokeStateCount spoke_state_counts = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $spoke_state_counts;
    /**
     * Output only. Counts the number of spokes that are inactive for each
     * possible reason and associated with a given hub.
     *
     * Generated from protobuf field <code>repeated .google.cloud.networkconnectivity.v1.SpokeSummary.SpokeStateReasonCount spoke_state_reason_counts = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $spoke_state_reason_counts;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type array<\Google\Cloud\NetworkConnectivity\V1\SpokeSummary\SpokeTypeCount>|\Google\Protobuf\Internal\RepeatedField $spoke_type_counts
     *           Output only. Counts the number of spokes of each type that are
     *           associated with a specific hub.
     *     @type array<\Google\Cloud\NetworkConnectivity\V1\SpokeSummary\SpokeStateCount>|\Google\Protobuf\Internal\RepeatedField $spoke_state_counts
     *           Output only. Counts the number of spokes that are in each state
     *           and associated with a given hub.
     *     @type array<\Google\Cloud\NetworkConnectivity\V1\SpokeSummary\SpokeStateReasonCount>|\Google\Protobuf\Internal\RepeatedField $spoke_state_reason_counts
     *           Output only. Counts the number of spokes that are inactive for each
     *           possible reason and associated with a given hub.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Networkconnectivity\V1\Hub::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. Counts the number of spokes of each type that are
     * associated with a specific hub.
     *
     * Generated from protobuf field <code>repeated .google.cloud.networkconnectivity.v1.SpokeSummary.SpokeTypeCount spoke_type_counts = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSpokeTypeCounts()
    {
        return $this->spoke_type_counts;
    }

    /**
     * Output only. Counts the number of spokes of each type that are
     * associated with a specific hub.
     *
     * Generated from protobuf field <code>repeated .google.cloud.networkconnectivity.v1.SpokeSummary.SpokeTypeCount spoke_type_counts = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param array<\Google\Cloud\NetworkConnectivity\V1\SpokeSummary\SpokeTypeCount>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSpokeTypeCounts($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\NetworkConnectivity\V1\SpokeSummary\SpokeTypeCount::class);
        $this->spoke_type_counts = $arr;

        return $this;
    }

    /**
     * Output only. Counts the number of spokes that are in each state
     * and associated with a given hub.
     *
     * Generated from protobuf field <code>repeated .google.cloud.networkconnectivity.v1.SpokeSummary.SpokeStateCount spoke_state_counts = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSpokeStateCounts()
    {
        return $this->spoke_state_counts;
    }

    /**
     * Output only. Counts the number of spokes that are in each state
     * and associated with a given hub.
     *
     * Generated from protobuf field <code>repeated .google.cloud.networkconnectivity.v1.SpokeSummary.SpokeStateCount spoke_state_counts = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param array<\Google\Cloud\NetworkConnectivity\V1\SpokeSummary\SpokeStateCount>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSpokeStateCounts($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\NetworkConnectivity\V1\SpokeSummary\SpokeStateCount::class);
        $this->spoke_state_counts = $arr;

        return $this;
    }

    /**
     * Output only. Counts the number of spokes that are inactive for each
     * possible reason and associated with a given hub.
     *
     * Generated from protobuf field <code>repeated .google.cloud.networkconnectivity.v1.SpokeSummary.SpokeStateReasonCount spoke_state_reason_counts = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSpokeStateReasonCounts()
    {
        return $this->spoke_state_reason_counts;
    }

    /**
     * Output only. Counts the number of spokes that are inactive for each
     * possible reason and associated with a given hub.
     *
     * Generated from protobuf field <code>repeated .google.cloud.networkconnectivity.v1.SpokeSummary.SpokeStateReasonCount spoke_state_reason_counts = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param array<\Google\Cloud\NetworkConnectivity\V1\SpokeSummary\SpokeStateReasonCount>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSpokeStateReasonCounts($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\NetworkConnectivity\V1\SpokeSummary\SpokeStateReasonCount::class);
        $this->spoke_state_reason_counts = $arr;

        return $this;
    }

}

