<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/networkmanagement/v1/trace.proto

namespace Google\Cloud\NetworkManagement\V1\DropInfo;

use UnexpectedValueException;

/**
 * Drop cause types:
 *
 * Protobuf type <code>google.cloud.networkmanagement.v1.DropInfo.Cause</code>
 */
class Cause
{
    /**
     * Cause is unspecified.
     *
     * Generated from protobuf enum <code>CAUSE_UNSPECIFIED = 0;</code>
     */
    const CAUSE_UNSPECIFIED = 0;
    /**
     * Destination external address cannot be resolved to a known target. If
     * the address is used in a Google Cloud project, provide the project ID
     * as test input.
     *
     * Generated from protobuf enum <code>UNKNOWN_EXTERNAL_ADDRESS = 1;</code>
     */
    const UNKNOWN_EXTERNAL_ADDRESS = 1;
    /**
     * A Compute Engine instance can only send or receive a packet with a
     * foreign IP address if ip_forward is enabled.
     *
     * Generated from protobuf enum <code>FOREIGN_IP_DISALLOWED = 2;</code>
     */
    const FOREIGN_IP_DISALLOWED = 2;
    /**
     * Dropped due to a firewall rule, unless allowed due to connection
     * tracking.
     *
     * Generated from protobuf enum <code>FIREWALL_RULE = 3;</code>
     */
    const FIREWALL_RULE = 3;
    /**
     * Dropped due to no matching routes.
     *
     * Generated from protobuf enum <code>NO_ROUTE = 4;</code>
     */
    const NO_ROUTE = 4;
    /**
     * Dropped due to invalid route. Route's next hop is a blackhole.
     *
     * Generated from protobuf enum <code>ROUTE_BLACKHOLE = 5;</code>
     */
    const ROUTE_BLACKHOLE = 5;
    /**
     * Packet is sent to a wrong (unintended) network. Example: you trace a
     * packet from VM1:Network1 to VM2:Network2, however, the route configured
     * in Network1 sends the packet destined for VM2's IP address to Network3.
     *
     * Generated from protobuf enum <code>ROUTE_WRONG_NETWORK = 6;</code>
     */
    const ROUTE_WRONG_NETWORK = 6;
    /**
     * Route's next hop IP address cannot be resolved to a GCP resource.
     *
     * Generated from protobuf enum <code>ROUTE_NEXT_HOP_IP_ADDRESS_NOT_RESOLVED = 42;</code>
     */
    const ROUTE_NEXT_HOP_IP_ADDRESS_NOT_RESOLVED = 42;
    /**
     * Route's next hop resource is not found.
     *
     * Generated from protobuf enum <code>ROUTE_NEXT_HOP_RESOURCE_NOT_FOUND = 43;</code>
     */
    const ROUTE_NEXT_HOP_RESOURCE_NOT_FOUND = 43;
    /**
     * Route's next hop instance doesn't have a NIC in the route's network.
     *
     * Generated from protobuf enum <code>ROUTE_NEXT_HOP_INSTANCE_WRONG_NETWORK = 49;</code>
     */
    const ROUTE_NEXT_HOP_INSTANCE_WRONG_NETWORK = 49;
    /**
     * Route's next hop IP address is not a primary IP address of the next hop
     * instance.
     *
     * Generated from protobuf enum <code>ROUTE_NEXT_HOP_INSTANCE_NON_PRIMARY_IP = 50;</code>
     */
    const ROUTE_NEXT_HOP_INSTANCE_NON_PRIMARY_IP = 50;
    /**
     * Route's next hop forwarding rule doesn't match next hop IP address.
     *
     * Generated from protobuf enum <code>ROUTE_NEXT_HOP_FORWARDING_RULE_IP_MISMATCH = 51;</code>
     */
    const ROUTE_NEXT_HOP_FORWARDING_RULE_IP_MISMATCH = 51;
    /**
     * Route's next hop VPN tunnel is down (does not have valid IKE SAs).
     *
     * Generated from protobuf enum <code>ROUTE_NEXT_HOP_VPN_TUNNEL_NOT_ESTABLISHED = 52;</code>
     */
    const ROUTE_NEXT_HOP_VPN_TUNNEL_NOT_ESTABLISHED = 52;
    /**
     * Route's next hop forwarding rule type is invalid (it's not a forwarding
     * rule of the internal passthrough load balancer).
     *
     * Generated from protobuf enum <code>ROUTE_NEXT_HOP_FORWARDING_RULE_TYPE_INVALID = 53;</code>
     */
    const ROUTE_NEXT_HOP_FORWARDING_RULE_TYPE_INVALID = 53;
    /**
     * Packet is sent from the Internet to the private IPv6 address.
     *
     * Generated from protobuf enum <code>NO_ROUTE_FROM_INTERNET_TO_PRIVATE_IPV6_ADDRESS = 44;</code>
     */
    const NO_ROUTE_FROM_INTERNET_TO_PRIVATE_IPV6_ADDRESS = 44;
    /**
     * The packet does not match a policy-based VPN tunnel local selector.
     *
     * Generated from protobuf enum <code>VPN_TUNNEL_LOCAL_SELECTOR_MISMATCH = 45;</code>
     */
    const VPN_TUNNEL_LOCAL_SELECTOR_MISMATCH = 45;
    /**
     * The packet does not match a policy-based VPN tunnel remote selector.
     *
     * Generated from protobuf enum <code>VPN_TUNNEL_REMOTE_SELECTOR_MISMATCH = 46;</code>
     */
    const VPN_TUNNEL_REMOTE_SELECTOR_MISMATCH = 46;
    /**
     * Packet with internal destination address sent to the internet gateway.
     *
     * Generated from protobuf enum <code>PRIVATE_TRAFFIC_TO_INTERNET = 7;</code>
     */
    const PRIVATE_TRAFFIC_TO_INTERNET = 7;
    /**
     * Instance with only an internal IP address tries to access Google API and
     * services, but private Google access is not enabled in the subnet.
     *
     * Generated from protobuf enum <code>PRIVATE_GOOGLE_ACCESS_DISALLOWED = 8;</code>
     */
    const PRIVATE_GOOGLE_ACCESS_DISALLOWED = 8;
    /**
     * Source endpoint tries to access Google API and services through the VPN
     * tunnel to another network, but Private Google Access needs to be enabled
     * in the source endpoint network.
     *
     * Generated from protobuf enum <code>PRIVATE_GOOGLE_ACCESS_VIA_VPN_TUNNEL_UNSUPPORTED = 47;</code>
     */
    const PRIVATE_GOOGLE_ACCESS_VIA_VPN_TUNNEL_UNSUPPORTED = 47;
    /**
     * Instance with only an internal IP address tries to access external hosts,
     * but Cloud NAT is not enabled in the subnet, unless special configurations
     * on a VM allow this connection.
     *
     * Generated from protobuf enum <code>NO_EXTERNAL_ADDRESS = 9;</code>
     */
    const NO_EXTERNAL_ADDRESS = 9;
    /**
     * Destination internal address cannot be resolved to a known target. If
     * this is a shared VPC scenario, verify if the service project ID is
     * provided as test input. Otherwise, verify if the IP address is being
     * used in the project.
     *
     * Generated from protobuf enum <code>UNKNOWN_INTERNAL_ADDRESS = 10;</code>
     */
    const UNKNOWN_INTERNAL_ADDRESS = 10;
    /**
     * Forwarding rule's protocol and ports do not match the packet header.
     *
     * Generated from protobuf enum <code>FORWARDING_RULE_MISMATCH = 11;</code>
     */
    const FORWARDING_RULE_MISMATCH = 11;
    /**
     * Forwarding rule does not have backends configured.
     *
     * Generated from protobuf enum <code>FORWARDING_RULE_NO_INSTANCES = 12;</code>
     */
    const FORWARDING_RULE_NO_INSTANCES = 12;
    /**
     * Firewalls block the health check probes to the backends and cause
     * the backends to be unavailable for traffic from the load balancer.
     * For more details, see [Health check firewall
     * rules](https://cloud.google.com/load-balancing/docs/health-checks#firewall_rules).
     *
     * Generated from protobuf enum <code>FIREWALL_BLOCKING_LOAD_BALANCER_BACKEND_HEALTH_CHECK = 13;</code>
     */
    const FIREWALL_BLOCKING_LOAD_BALANCER_BACKEND_HEALTH_CHECK = 13;
    /**
     * Packet is sent from or to a Compute Engine instance that is not in a
     * running state.
     *
     * Generated from protobuf enum <code>INSTANCE_NOT_RUNNING = 14;</code>
     */
    const INSTANCE_NOT_RUNNING = 14;
    /**
     * Packet sent from or to a GKE cluster that is not in running state.
     *
     * Generated from protobuf enum <code>GKE_CLUSTER_NOT_RUNNING = 27;</code>
     */
    const GKE_CLUSTER_NOT_RUNNING = 27;
    /**
     * Packet sent from or to a Cloud SQL instance that is not in running state.
     *
     * Generated from protobuf enum <code>CLOUD_SQL_INSTANCE_NOT_RUNNING = 28;</code>
     */
    const CLOUD_SQL_INSTANCE_NOT_RUNNING = 28;
    /**
     * The type of traffic is blocked and the user cannot configure a firewall
     * rule to enable it. See [Always blocked
     * traffic](https://cloud.google.com/vpc/docs/firewalls#blockedtraffic) for
     * more details.
     *
     * Generated from protobuf enum <code>TRAFFIC_TYPE_BLOCKED = 15;</code>
     */
    const TRAFFIC_TYPE_BLOCKED = 15;
    /**
     * Access to Google Kubernetes Engine cluster master's endpoint is not
     * authorized. See [Access to the cluster
     * endpoints](https://cloud.google.com/kubernetes-engine/docs/how-to/private-clusters#access_to_the_cluster_endpoints)
     * for more details.
     *
     * Generated from protobuf enum <code>GKE_MASTER_UNAUTHORIZED_ACCESS = 16;</code>
     */
    const GKE_MASTER_UNAUTHORIZED_ACCESS = 16;
    /**
     * Access to the Cloud SQL instance endpoint is not authorized.
     * See [Authorizing with authorized
     * networks](https://cloud.google.com/sql/docs/mysql/authorize-networks) for
     * more details.
     *
     * Generated from protobuf enum <code>CLOUD_SQL_INSTANCE_UNAUTHORIZED_ACCESS = 17;</code>
     */
    const CLOUD_SQL_INSTANCE_UNAUTHORIZED_ACCESS = 17;
    /**
     * Packet was dropped inside Google Kubernetes Engine Service.
     *
     * Generated from protobuf enum <code>DROPPED_INSIDE_GKE_SERVICE = 18;</code>
     */
    const DROPPED_INSIDE_GKE_SERVICE = 18;
    /**
     * Packet was dropped inside Cloud SQL Service.
     *
     * Generated from protobuf enum <code>DROPPED_INSIDE_CLOUD_SQL_SERVICE = 19;</code>
     */
    const DROPPED_INSIDE_CLOUD_SQL_SERVICE = 19;
    /**
     * Packet was dropped because there is no peering between the originating
     * network and the Google Managed Services Network.
     *
     * Generated from protobuf enum <code>GOOGLE_MANAGED_SERVICE_NO_PEERING = 20;</code>
     */
    const GOOGLE_MANAGED_SERVICE_NO_PEERING = 20;
    /**
     * Packet was dropped because the Google-managed service uses Private
     * Service Connect (PSC), but the PSC endpoint is not found in the project.
     *
     * Generated from protobuf enum <code>GOOGLE_MANAGED_SERVICE_NO_PSC_ENDPOINT = 38;</code>
     */
    const GOOGLE_MANAGED_SERVICE_NO_PSC_ENDPOINT = 38;
    /**
     * Packet was dropped because the GKE cluster uses Private Service Connect
     * (PSC), but the PSC endpoint is not found in the project.
     *
     * Generated from protobuf enum <code>GKE_PSC_ENDPOINT_MISSING = 36;</code>
     */
    const GKE_PSC_ENDPOINT_MISSING = 36;
    /**
     * Packet was dropped because the Cloud SQL instance has neither a private
     * nor a public IP address.
     *
     * Generated from protobuf enum <code>CLOUD_SQL_INSTANCE_NO_IP_ADDRESS = 21;</code>
     */
    const CLOUD_SQL_INSTANCE_NO_IP_ADDRESS = 21;
    /**
     * Packet was dropped because a GKE cluster private endpoint is
     * unreachable from a region different from the cluster's region.
     *
     * Generated from protobuf enum <code>GKE_CONTROL_PLANE_REGION_MISMATCH = 30;</code>
     */
    const GKE_CONTROL_PLANE_REGION_MISMATCH = 30;
    /**
     * Packet sent from a public GKE cluster control plane to a private
     * IP address.
     *
     * Generated from protobuf enum <code>PUBLIC_GKE_CONTROL_PLANE_TO_PRIVATE_DESTINATION = 31;</code>
     */
    const PUBLIC_GKE_CONTROL_PLANE_TO_PRIVATE_DESTINATION = 31;
    /**
     * Packet was dropped because there is no route from a GKE cluster
     * control plane to a destination network.
     *
     * Generated from protobuf enum <code>GKE_CONTROL_PLANE_NO_ROUTE = 32;</code>
     */
    const GKE_CONTROL_PLANE_NO_ROUTE = 32;
    /**
     * Packet sent from a Cloud SQL instance to an external IP address is not
     * allowed. The Cloud SQL instance is not configured to send packets to
     * external IP addresses.
     *
     * Generated from protobuf enum <code>CLOUD_SQL_INSTANCE_NOT_CONFIGURED_FOR_EXTERNAL_TRAFFIC = 33;</code>
     */
    const CLOUD_SQL_INSTANCE_NOT_CONFIGURED_FOR_EXTERNAL_TRAFFIC = 33;
    /**
     * Packet sent from a Cloud SQL instance with only a public IP address to a
     * private IP address.
     *
     * Generated from protobuf enum <code>PUBLIC_CLOUD_SQL_INSTANCE_TO_PRIVATE_DESTINATION = 34;</code>
     */
    const PUBLIC_CLOUD_SQL_INSTANCE_TO_PRIVATE_DESTINATION = 34;
    /**
     * Packet was dropped because there is no route from a Cloud SQL
     * instance to a destination network.
     *
     * Generated from protobuf enum <code>CLOUD_SQL_INSTANCE_NO_ROUTE = 35;</code>
     */
    const CLOUD_SQL_INSTANCE_NO_ROUTE = 35;
    /**
     * Packet could be dropped because the Cloud Function is not in an active
     * status.
     *
     * Generated from protobuf enum <code>CLOUD_FUNCTION_NOT_ACTIVE = 22;</code>
     */
    const CLOUD_FUNCTION_NOT_ACTIVE = 22;
    /**
     * Packet could be dropped because no VPC connector is set.
     *
     * Generated from protobuf enum <code>VPC_CONNECTOR_NOT_SET = 23;</code>
     */
    const VPC_CONNECTOR_NOT_SET = 23;
    /**
     * Packet could be dropped because the VPC connector is not in a running
     * state.
     *
     * Generated from protobuf enum <code>VPC_CONNECTOR_NOT_RUNNING = 24;</code>
     */
    const VPC_CONNECTOR_NOT_RUNNING = 24;
    /**
     * Packet could be dropped because it was sent from a different region
     * to a regional forwarding without global access.
     *
     * Generated from protobuf enum <code>FORWARDING_RULE_REGION_MISMATCH = 25;</code>
     */
    const FORWARDING_RULE_REGION_MISMATCH = 25;
    /**
     * The Private Service Connect endpoint is in a project that is not approved
     * to connect to the service.
     *
     * Generated from protobuf enum <code>PSC_CONNECTION_NOT_ACCEPTED = 26;</code>
     */
    const PSC_CONNECTION_NOT_ACCEPTED = 26;
    /**
     * The packet is sent to the Private Service Connect endpoint over the
     * peering, but [it's not
     * supported](https://cloud.google.com/vpc/docs/configure-private-service-connect-services#on-premises).
     *
     * Generated from protobuf enum <code>PSC_ENDPOINT_ACCESSED_FROM_PEERED_NETWORK = 41;</code>
     */
    const PSC_ENDPOINT_ACCESSED_FROM_PEERED_NETWORK = 41;
    /**
     * The packet is sent to the Private Service Connect backend (network
     * endpoint group), but the producer PSC forwarding rule does not have
     * global access enabled.
     *
     * Generated from protobuf enum <code>PSC_NEG_PRODUCER_ENDPOINT_NO_GLOBAL_ACCESS = 48;</code>
     */
    const PSC_NEG_PRODUCER_ENDPOINT_NO_GLOBAL_ACCESS = 48;
    /**
     * The packet is sent to the Private Service Connect backend (network
     * endpoint group), but the producer PSC forwarding rule has multiple ports
     * specified.
     *
     * Generated from protobuf enum <code>PSC_NEG_PRODUCER_FORWARDING_RULE_MULTIPLE_PORTS = 54;</code>
     */
    const PSC_NEG_PRODUCER_FORWARDING_RULE_MULTIPLE_PORTS = 54;
    /**
     * The packet is sent to the Private Service Connect backend (network
     * endpoint group) targeting a Cloud SQL service attachment, but this
     * configuration is not supported.
     *
     * Generated from protobuf enum <code>CLOUD_SQL_PSC_NEG_UNSUPPORTED = 58;</code>
     */
    const CLOUD_SQL_PSC_NEG_UNSUPPORTED = 58;
    /**
     * No NAT subnets are defined for the PSC service attachment.
     *
     * Generated from protobuf enum <code>NO_NAT_SUBNETS_FOR_PSC_SERVICE_ATTACHMENT = 57;</code>
     */
    const NO_NAT_SUBNETS_FOR_PSC_SERVICE_ATTACHMENT = 57;
    /**
     * The packet sent from the hybrid NEG proxy matches a non-dynamic route,
     * but such a configuration is not supported.
     *
     * Generated from protobuf enum <code>HYBRID_NEG_NON_DYNAMIC_ROUTE_MATCHED = 55;</code>
     */
    const HYBRID_NEG_NON_DYNAMIC_ROUTE_MATCHED = 55;
    /**
     * The packet sent from the hybrid NEG proxy matches a dynamic route with a
     * next hop in a different region, but such a configuration is not
     * supported.
     *
     * Generated from protobuf enum <code>HYBRID_NEG_NON_LOCAL_DYNAMIC_ROUTE_MATCHED = 56;</code>
     */
    const HYBRID_NEG_NON_LOCAL_DYNAMIC_ROUTE_MATCHED = 56;
    /**
     * Packet sent from a Cloud Run revision that is not ready.
     *
     * Generated from protobuf enum <code>CLOUD_RUN_REVISION_NOT_READY = 29;</code>
     */
    const CLOUD_RUN_REVISION_NOT_READY = 29;
    /**
     * Packet was dropped inside Private Service Connect service producer.
     *
     * Generated from protobuf enum <code>DROPPED_INSIDE_PSC_SERVICE_PRODUCER = 37;</code>
     */
    const DROPPED_INSIDE_PSC_SERVICE_PRODUCER = 37;
    /**
     * Packet sent to a load balancer, which requires a proxy-only subnet and
     * the subnet is not found.
     *
     * Generated from protobuf enum <code>LOAD_BALANCER_HAS_NO_PROXY_SUBNET = 39;</code>
     */
    const LOAD_BALANCER_HAS_NO_PROXY_SUBNET = 39;
    /**
     * Packet sent to Cloud Nat without active NAT IPs.
     *
     * Generated from protobuf enum <code>CLOUD_NAT_NO_ADDRESSES = 40;</code>
     */
    const CLOUD_NAT_NO_ADDRESSES = 40;
    /**
     * Packet is stuck in a routing loop.
     *
     * Generated from protobuf enum <code>ROUTING_LOOP = 59;</code>
     */
    const ROUTING_LOOP = 59;

    private static $valueToName = [
        self::CAUSE_UNSPECIFIED => 'CAUSE_UNSPECIFIED',
        self::UNKNOWN_EXTERNAL_ADDRESS => 'UNKNOWN_EXTERNAL_ADDRESS',
        self::FOREIGN_IP_DISALLOWED => 'FOREIGN_IP_DISALLOWED',
        self::FIREWALL_RULE => 'FIREWALL_RULE',
        self::NO_ROUTE => 'NO_ROUTE',
        self::ROUTE_BLACKHOLE => 'ROUTE_BLACKHOLE',
        self::ROUTE_WRONG_NETWORK => 'ROUTE_WRONG_NETWORK',
        self::ROUTE_NEXT_HOP_IP_ADDRESS_NOT_RESOLVED => 'ROUTE_NEXT_HOP_IP_ADDRESS_NOT_RESOLVED',
        self::ROUTE_NEXT_HOP_RESOURCE_NOT_FOUND => 'ROUTE_NEXT_HOP_RESOURCE_NOT_FOUND',
        self::ROUTE_NEXT_HOP_INSTANCE_WRONG_NETWORK => 'ROUTE_NEXT_HOP_INSTANCE_WRONG_NETWORK',
        self::ROUTE_NEXT_HOP_INSTANCE_NON_PRIMARY_IP => 'ROUTE_NEXT_HOP_INSTANCE_NON_PRIMARY_IP',
        self::ROUTE_NEXT_HOP_FORWARDING_RULE_IP_MISMATCH => 'ROUTE_NEXT_HOP_FORWARDING_RULE_IP_MISMATCH',
        self::ROUTE_NEXT_HOP_VPN_TUNNEL_NOT_ESTABLISHED => 'ROUTE_NEXT_HOP_VPN_TUNNEL_NOT_ESTABLISHED',
        self::ROUTE_NEXT_HOP_FORWARDING_RULE_TYPE_INVALID => 'ROUTE_NEXT_HOP_FORWARDING_RULE_TYPE_INVALID',
        self::NO_ROUTE_FROM_INTERNET_TO_PRIVATE_IPV6_ADDRESS => 'NO_ROUTE_FROM_INTERNET_TO_PRIVATE_IPV6_ADDRESS',
        self::VPN_TUNNEL_LOCAL_SELECTOR_MISMATCH => 'VPN_TUNNEL_LOCAL_SELECTOR_MISMATCH',
        self::VPN_TUNNEL_REMOTE_SELECTOR_MISMATCH => 'VPN_TUNNEL_REMOTE_SELECTOR_MISMATCH',
        self::PRIVATE_TRAFFIC_TO_INTERNET => 'PRIVATE_TRAFFIC_TO_INTERNET',
        self::PRIVATE_GOOGLE_ACCESS_DISALLOWED => 'PRIVATE_GOOGLE_ACCESS_DISALLOWED',
        self::PRIVATE_GOOGLE_ACCESS_VIA_VPN_TUNNEL_UNSUPPORTED => 'PRIVATE_GOOGLE_ACCESS_VIA_VPN_TUNNEL_UNSUPPORTED',
        self::NO_EXTERNAL_ADDRESS => 'NO_EXTERNAL_ADDRESS',
        self::UNKNOWN_INTERNAL_ADDRESS => 'UNKNOWN_INTERNAL_ADDRESS',
        self::FORWARDING_RULE_MISMATCH => 'FORWARDING_RULE_MISMATCH',
        self::FORWARDING_RULE_NO_INSTANCES => 'FORWARDING_RULE_NO_INSTANCES',
        self::FIREWALL_BLOCKING_LOAD_BALANCER_BACKEND_HEALTH_CHECK => 'FIREWALL_BLOCKING_LOAD_BALANCER_BACKEND_HEALTH_CHECK',
        self::INSTANCE_NOT_RUNNING => 'INSTANCE_NOT_RUNNING',
        self::GKE_CLUSTER_NOT_RUNNING => 'GKE_CLUSTER_NOT_RUNNING',
        self::CLOUD_SQL_INSTANCE_NOT_RUNNING => 'CLOUD_SQL_INSTANCE_NOT_RUNNING',
        self::TRAFFIC_TYPE_BLOCKED => 'TRAFFIC_TYPE_BLOCKED',
        self::GKE_MASTER_UNAUTHORIZED_ACCESS => 'GKE_MASTER_UNAUTHORIZED_ACCESS',
        self::CLOUD_SQL_INSTANCE_UNAUTHORIZED_ACCESS => 'CLOUD_SQL_INSTANCE_UNAUTHORIZED_ACCESS',
        self::DROPPED_INSIDE_GKE_SERVICE => 'DROPPED_INSIDE_GKE_SERVICE',
        self::DROPPED_INSIDE_CLOUD_SQL_SERVICE => 'DROPPED_INSIDE_CLOUD_SQL_SERVICE',
        self::GOOGLE_MANAGED_SERVICE_NO_PEERING => 'GOOGLE_MANAGED_SERVICE_NO_PEERING',
        self::GOOGLE_MANAGED_SERVICE_NO_PSC_ENDPOINT => 'GOOGLE_MANAGED_SERVICE_NO_PSC_ENDPOINT',
        self::GKE_PSC_ENDPOINT_MISSING => 'GKE_PSC_ENDPOINT_MISSING',
        self::CLOUD_SQL_INSTANCE_NO_IP_ADDRESS => 'CLOUD_SQL_INSTANCE_NO_IP_ADDRESS',
        self::GKE_CONTROL_PLANE_REGION_MISMATCH => 'GKE_CONTROL_PLANE_REGION_MISMATCH',
        self::PUBLIC_GKE_CONTROL_PLANE_TO_PRIVATE_DESTINATION => 'PUBLIC_GKE_CONTROL_PLANE_TO_PRIVATE_DESTINATION',
        self::GKE_CONTROL_PLANE_NO_ROUTE => 'GKE_CONTROL_PLANE_NO_ROUTE',
        self::CLOUD_SQL_INSTANCE_NOT_CONFIGURED_FOR_EXTERNAL_TRAFFIC => 'CLOUD_SQL_INSTANCE_NOT_CONFIGURED_FOR_EXTERNAL_TRAFFIC',
        self::PUBLIC_CLOUD_SQL_INSTANCE_TO_PRIVATE_DESTINATION => 'PUBLIC_CLOUD_SQL_INSTANCE_TO_PRIVATE_DESTINATION',
        self::CLOUD_SQL_INSTANCE_NO_ROUTE => 'CLOUD_SQL_INSTANCE_NO_ROUTE',
        self::CLOUD_FUNCTION_NOT_ACTIVE => 'CLOUD_FUNCTION_NOT_ACTIVE',
        self::VPC_CONNECTOR_NOT_SET => 'VPC_CONNECTOR_NOT_SET',
        self::VPC_CONNECTOR_NOT_RUNNING => 'VPC_CONNECTOR_NOT_RUNNING',
        self::FORWARDING_RULE_REGION_MISMATCH => 'FORWARDING_RULE_REGION_MISMATCH',
        self::PSC_CONNECTION_NOT_ACCEPTED => 'PSC_CONNECTION_NOT_ACCEPTED',
        self::PSC_ENDPOINT_ACCESSED_FROM_PEERED_NETWORK => 'PSC_ENDPOINT_ACCESSED_FROM_PEERED_NETWORK',
        self::PSC_NEG_PRODUCER_ENDPOINT_NO_GLOBAL_ACCESS => 'PSC_NEG_PRODUCER_ENDPOINT_NO_GLOBAL_ACCESS',
        self::PSC_NEG_PRODUCER_FORWARDING_RULE_MULTIPLE_PORTS => 'PSC_NEG_PRODUCER_FORWARDING_RULE_MULTIPLE_PORTS',
        self::CLOUD_SQL_PSC_NEG_UNSUPPORTED => 'CLOUD_SQL_PSC_NEG_UNSUPPORTED',
        self::NO_NAT_SUBNETS_FOR_PSC_SERVICE_ATTACHMENT => 'NO_NAT_SUBNETS_FOR_PSC_SERVICE_ATTACHMENT',
        self::HYBRID_NEG_NON_DYNAMIC_ROUTE_MATCHED => 'HYBRID_NEG_NON_DYNAMIC_ROUTE_MATCHED',
        self::HYBRID_NEG_NON_LOCAL_DYNAMIC_ROUTE_MATCHED => 'HYBRID_NEG_NON_LOCAL_DYNAMIC_ROUTE_MATCHED',
        self::CLOUD_RUN_REVISION_NOT_READY => 'CLOUD_RUN_REVISION_NOT_READY',
        self::DROPPED_INSIDE_PSC_SERVICE_PRODUCER => 'DROPPED_INSIDE_PSC_SERVICE_PRODUCER',
        self::LOAD_BALANCER_HAS_NO_PROXY_SUBNET => 'LOAD_BALANCER_HAS_NO_PROXY_SUBNET',
        self::CLOUD_NAT_NO_ADDRESSES => 'CLOUD_NAT_NO_ADDRESSES',
        self::ROUTING_LOOP => 'ROUTING_LOOP',
    ];

    public static function name($value)
    {
        if (!isset(self::$valueToName[$value])) {
            throw new UnexpectedValueException(sprintf(
                    'Enum %s has no name defined for value %s', __CLASS__, $value));
        }
        return self::$valueToName[$value];
    }


    public static function value($name)
    {
        $const = __CLASS__ . '::' . strtoupper($name);
        if (!defined($const)) {
            throw new UnexpectedValueException(sprintf(
                    'Enum %s has no value defined for name %s', __CLASS__, $name));
        }
        return constant($const);
    }
}


