<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/networkmanagement/v1/trace.proto

namespace Google\Cloud\NetworkManagement\V1;

use UnexpectedValueException;

/**
 * Type of a load balancer. For more information, see [Summary of Google Cloud
 * load
 * balancers](https://cloud.google.com/load-balancing/docs/load-balancing-overview#summary-of-google-cloud-load-balancers).
 *
 * Protobuf type <code>google.cloud.networkmanagement.v1.LoadBalancerType</code>
 */
class LoadBalancerType
{
    /**
     * Forwarding rule points to a different target than a load balancer or a
     * load balancer type is unknown.
     *
     * Generated from protobuf enum <code>LOAD_BALANCER_TYPE_UNSPECIFIED = 0;</code>
     */
    const LOAD_BALANCER_TYPE_UNSPECIFIED = 0;
    /**
     * Global external HTTP(S) load balancer.
     *
     * Generated from protobuf enum <code>HTTPS_ADVANCED_LOAD_BALANCER = 1;</code>
     */
    const HTTPS_ADVANCED_LOAD_BALANCER = 1;
    /**
     * Global external HTTP(S) load balancer (classic)
     *
     * Generated from protobuf enum <code>HTTPS_LOAD_BALANCER = 2;</code>
     */
    const HTTPS_LOAD_BALANCER = 2;
    /**
     * Regional external HTTP(S) load balancer.
     *
     * Generated from protobuf enum <code>REGIONAL_HTTPS_LOAD_BALANCER = 3;</code>
     */
    const REGIONAL_HTTPS_LOAD_BALANCER = 3;
    /**
     * Internal HTTP(S) load balancer.
     *
     * Generated from protobuf enum <code>INTERNAL_HTTPS_LOAD_BALANCER = 4;</code>
     */
    const INTERNAL_HTTPS_LOAD_BALANCER = 4;
    /**
     * External SSL proxy load balancer.
     *
     * Generated from protobuf enum <code>SSL_PROXY_LOAD_BALANCER = 5;</code>
     */
    const SSL_PROXY_LOAD_BALANCER = 5;
    /**
     * External TCP proxy load balancer.
     *
     * Generated from protobuf enum <code>TCP_PROXY_LOAD_BALANCER = 6;</code>
     */
    const TCP_PROXY_LOAD_BALANCER = 6;
    /**
     * Internal regional TCP proxy load balancer.
     *
     * Generated from protobuf enum <code>INTERNAL_TCP_PROXY_LOAD_BALANCER = 7;</code>
     */
    const INTERNAL_TCP_PROXY_LOAD_BALANCER = 7;
    /**
     * External TCP/UDP Network load balancer.
     *
     * Generated from protobuf enum <code>NETWORK_LOAD_BALANCER = 8;</code>
     */
    const NETWORK_LOAD_BALANCER = 8;
    /**
     * Target-pool based external TCP/UDP Network load balancer.
     *
     * Generated from protobuf enum <code>LEGACY_NETWORK_LOAD_BALANCER = 9;</code>
     */
    const LEGACY_NETWORK_LOAD_BALANCER = 9;
    /**
     * Internal TCP/UDP load balancer.
     *
     * Generated from protobuf enum <code>TCP_UDP_INTERNAL_LOAD_BALANCER = 10;</code>
     */
    const TCP_UDP_INTERNAL_LOAD_BALANCER = 10;

    private static $valueToName = [
        self::LOAD_BALANCER_TYPE_UNSPECIFIED => 'LOAD_BALANCER_TYPE_UNSPECIFIED',
        self::HTTPS_ADVANCED_LOAD_BALANCER => 'HTTPS_ADVANCED_LOAD_BALANCER',
        self::HTTPS_LOAD_BALANCER => 'HTTPS_LOAD_BALANCER',
        self::REGIONAL_HTTPS_LOAD_BALANCER => 'REGIONAL_HTTPS_LOAD_BALANCER',
        self::INTERNAL_HTTPS_LOAD_BALANCER => 'INTERNAL_HTTPS_LOAD_BALANCER',
        self::SSL_PROXY_LOAD_BALANCER => 'SSL_PROXY_LOAD_BALANCER',
        self::TCP_PROXY_LOAD_BALANCER => 'TCP_PROXY_LOAD_BALANCER',
        self::INTERNAL_TCP_PROXY_LOAD_BALANCER => 'INTERNAL_TCP_PROXY_LOAD_BALANCER',
        self::NETWORK_LOAD_BALANCER => 'NETWORK_LOAD_BALANCER',
        self::LEGACY_NETWORK_LOAD_BALANCER => 'LEGACY_NETWORK_LOAD_BALANCER',
        self::TCP_UDP_INTERNAL_LOAD_BALANCER => 'TCP_UDP_INTERNAL_LOAD_BALANCER',
    ];

    public static function name($value)
    {
        if (!isset(self::$valueToName[$value])) {
            throw new UnexpectedValueException(sprintf(
                    'Enum %s has no name defined for value %s', __CLASS__, $value));
        }
        return self::$valueToName[$value];
    }


    public static function value($name)
    {
        $const = __CLASS__ . '::' . strtoupper($name);
        if (!defined($const)) {
            throw new UnexpectedValueException(sprintf(
                    'Enum %s has no value defined for name %s', __CLASS__, $name));
        }
        return constant($const);
    }
}

