<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/networksecurity/v1/client_tls_policy.proto

namespace Google\Cloud\NetworkSecurity\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request used by the CreateClientTlsPolicy method.
 *
 * Generated from protobuf message <code>google.cloud.networksecurity.v1.CreateClientTlsPolicyRequest</code>
 */
class CreateClientTlsPolicyRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent resource of the ClientTlsPolicy. Must be in
     * the format `projects/&#42;&#47;locations/{location}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. Short name of the ClientTlsPolicy resource to be created. This value should
     * be 1-63 characters long, containing only letters, numbers, hyphens, and
     * underscores, and should not start with a number. E.g. "client_mtls_policy".
     *
     * Generated from protobuf field <code>string client_tls_policy_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $client_tls_policy_id = '';
    /**
     * Required. ClientTlsPolicy resource to be created.
     *
     * Generated from protobuf field <code>.google.cloud.networksecurity.v1.ClientTlsPolicy client_tls_policy = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $client_tls_policy = null;

    /**
     * @param string                                           $parent            Required. The parent resource of the ClientTlsPolicy. Must be in
     *                                                                            the format `projects/&#42;/locations/{location}`. Please see
     *                                                                            {@see NetworkSecurityClient::locationName()} for help formatting this field.
     * @param \Google\Cloud\NetworkSecurity\V1\ClientTlsPolicy $clientTlsPolicy   Required. ClientTlsPolicy resource to be created.
     * @param string                                           $clientTlsPolicyId Required. Short name of the ClientTlsPolicy resource to be created. This value should
     *                                                                            be 1-63 characters long, containing only letters, numbers, hyphens, and
     *                                                                            underscores, and should not start with a number. E.g. "client_mtls_policy".
     *
     * @return \Google\Cloud\NetworkSecurity\V1\CreateClientTlsPolicyRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\NetworkSecurity\V1\ClientTlsPolicy $clientTlsPolicy, string $clientTlsPolicyId): self
    {
        return (new self())
            ->setParent($parent)
            ->setClientTlsPolicy($clientTlsPolicy)
            ->setClientTlsPolicyId($clientTlsPolicyId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent resource of the ClientTlsPolicy. Must be in
     *           the format `projects/&#42;&#47;locations/{location}`.
     *     @type string $client_tls_policy_id
     *           Required. Short name of the ClientTlsPolicy resource to be created. This value should
     *           be 1-63 characters long, containing only letters, numbers, hyphens, and
     *           underscores, and should not start with a number. E.g. "client_mtls_policy".
     *     @type \Google\Cloud\NetworkSecurity\V1\ClientTlsPolicy $client_tls_policy
     *           Required. ClientTlsPolicy resource to be created.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Networksecurity\V1\ClientTlsPolicy::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent resource of the ClientTlsPolicy. Must be in
     * the format `projects/&#42;&#47;locations/{location}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent resource of the ClientTlsPolicy. Must be in
     * the format `projects/&#42;&#47;locations/{location}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. Short name of the ClientTlsPolicy resource to be created. This value should
     * be 1-63 characters long, containing only letters, numbers, hyphens, and
     * underscores, and should not start with a number. E.g. "client_mtls_policy".
     *
     * Generated from protobuf field <code>string client_tls_policy_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getClientTlsPolicyId()
    {
        return $this->client_tls_policy_id;
    }

    /**
     * Required. Short name of the ClientTlsPolicy resource to be created. This value should
     * be 1-63 characters long, containing only letters, numbers, hyphens, and
     * underscores, and should not start with a number. E.g. "client_mtls_policy".
     *
     * Generated from protobuf field <code>string client_tls_policy_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setClientTlsPolicyId($var)
    {
        GPBUtil::checkString($var, True);
        $this->client_tls_policy_id = $var;

        return $this;
    }

    /**
     * Required. ClientTlsPolicy resource to be created.
     *
     * Generated from protobuf field <code>.google.cloud.networksecurity.v1.ClientTlsPolicy client_tls_policy = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\NetworkSecurity\V1\ClientTlsPolicy|null
     */
    public function getClientTlsPolicy()
    {
        return $this->client_tls_policy;
    }

    public function hasClientTlsPolicy()
    {
        return isset($this->client_tls_policy);
    }

    public function clearClientTlsPolicy()
    {
        unset($this->client_tls_policy);
    }

    /**
     * Required. ClientTlsPolicy resource to be created.
     *
     * Generated from protobuf field <code>.google.cloud.networksecurity.v1.ClientTlsPolicy client_tls_policy = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\NetworkSecurity\V1\ClientTlsPolicy $var
     * @return $this
     */
    public function setClientTlsPolicy($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\NetworkSecurity\V1\ClientTlsPolicy::class);
        $this->client_tls_policy = $var;

        return $this;
    }

}

