<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/networkservices/v1/common.proto

namespace Google\Cloud\NetworkServices\V1\EndpointMatcher;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The matcher that is based on node metadata presented by xDS clients.
 *
 * Generated from protobuf message <code>google.cloud.networkservices.v1.EndpointMatcher.MetadataLabelMatcher</code>
 */
class MetadataLabelMatcher extends \Google\Protobuf\Internal\Message
{
    /**
     * Specifies how matching should be done.
     * Supported values are:
     * MATCH_ANY: At least one of the Labels specified in the
     *   matcher should match the metadata presented by xDS client.
     * MATCH_ALL: The metadata presented by the xDS client should
     *   contain all of the labels specified here.
     * The selection is determined based on the best match. For
     * example, suppose there are three EndpointPolicy
     * resources P1, P2 and P3 and if P1 has a the matcher as
     * MATCH_ANY <A:1, B:1>, P2 has MATCH_ALL <A:1,B:1>, and P3 has
     * MATCH_ALL <A:1,B:1,C:1>.
     * If a client with label <A:1> connects, the config from P1
     * will be selected.
     * If a client with label <A:1,B:1> connects, the config from P2
     * will be selected.
     * If a client with label <A:1,B:1,C:1> connects, the config
     * from P3 will be selected.
     * If there is more than one best match, (for example, if a
     * config P4 with selector <A:1,D:1> exists and if a client with
     * label <A:1,B:1,D:1> connects), an error will be thrown.
     *
     * Generated from protobuf field <code>.google.cloud.networkservices.v1.EndpointMatcher.MetadataLabelMatcher.MetadataLabelMatchCriteria metadata_label_match_criteria = 1;</code>
     */
    protected $metadata_label_match_criteria = 0;
    /**
     * The list of label value pairs that must match labels in the
     * provided metadata based on filterMatchCriteria This list can
     * have at most 64 entries. The list can be empty if the match
     * criteria is MATCH_ANY, to specify a wildcard match (i.e this
     * matches any client).
     *
     * Generated from protobuf field <code>repeated .google.cloud.networkservices.v1.EndpointMatcher.MetadataLabelMatcher.MetadataLabels metadata_labels = 2;</code>
     */
    private $metadata_labels;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int $metadata_label_match_criteria
     *           Specifies how matching should be done.
     *           Supported values are:
     *           MATCH_ANY: At least one of the Labels specified in the
     *             matcher should match the metadata presented by xDS client.
     *           MATCH_ALL: The metadata presented by the xDS client should
     *             contain all of the labels specified here.
     *           The selection is determined based on the best match. For
     *           example, suppose there are three EndpointPolicy
     *           resources P1, P2 and P3 and if P1 has a the matcher as
     *           MATCH_ANY <A:1, B:1>, P2 has MATCH_ALL <A:1,B:1>, and P3 has
     *           MATCH_ALL <A:1,B:1,C:1>.
     *           If a client with label <A:1> connects, the config from P1
     *           will be selected.
     *           If a client with label <A:1,B:1> connects, the config from P2
     *           will be selected.
     *           If a client with label <A:1,B:1,C:1> connects, the config
     *           from P3 will be selected.
     *           If there is more than one best match, (for example, if a
     *           config P4 with selector <A:1,D:1> exists and if a client with
     *           label <A:1,B:1,D:1> connects), an error will be thrown.
     *     @type array<\Google\Cloud\NetworkServices\V1\EndpointMatcher\MetadataLabelMatcher\MetadataLabels>|\Google\Protobuf\Internal\RepeatedField $metadata_labels
     *           The list of label value pairs that must match labels in the
     *           provided metadata based on filterMatchCriteria This list can
     *           have at most 64 entries. The list can be empty if the match
     *           criteria is MATCH_ANY, to specify a wildcard match (i.e this
     *           matches any client).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Networkservices\V1\Common::initOnce();
        parent::__construct($data);
    }

    /**
     * Specifies how matching should be done.
     * Supported values are:
     * MATCH_ANY: At least one of the Labels specified in the
     *   matcher should match the metadata presented by xDS client.
     * MATCH_ALL: The metadata presented by the xDS client should
     *   contain all of the labels specified here.
     * The selection is determined based on the best match. For
     * example, suppose there are three EndpointPolicy
     * resources P1, P2 and P3 and if P1 has a the matcher as
     * MATCH_ANY <A:1, B:1>, P2 has MATCH_ALL <A:1,B:1>, and P3 has
     * MATCH_ALL <A:1,B:1,C:1>.
     * If a client with label <A:1> connects, the config from P1
     * will be selected.
     * If a client with label <A:1,B:1> connects, the config from P2
     * will be selected.
     * If a client with label <A:1,B:1,C:1> connects, the config
     * from P3 will be selected.
     * If there is more than one best match, (for example, if a
     * config P4 with selector <A:1,D:1> exists and if a client with
     * label <A:1,B:1,D:1> connects), an error will be thrown.
     *
     * Generated from protobuf field <code>.google.cloud.networkservices.v1.EndpointMatcher.MetadataLabelMatcher.MetadataLabelMatchCriteria metadata_label_match_criteria = 1;</code>
     * @return int
     */
    public function getMetadataLabelMatchCriteria()
    {
        return $this->metadata_label_match_criteria;
    }

    /**
     * Specifies how matching should be done.
     * Supported values are:
     * MATCH_ANY: At least one of the Labels specified in the
     *   matcher should match the metadata presented by xDS client.
     * MATCH_ALL: The metadata presented by the xDS client should
     *   contain all of the labels specified here.
     * The selection is determined based on the best match. For
     * example, suppose there are three EndpointPolicy
     * resources P1, P2 and P3 and if P1 has a the matcher as
     * MATCH_ANY <A:1, B:1>, P2 has MATCH_ALL <A:1,B:1>, and P3 has
     * MATCH_ALL <A:1,B:1,C:1>.
     * If a client with label <A:1> connects, the config from P1
     * will be selected.
     * If a client with label <A:1,B:1> connects, the config from P2
     * will be selected.
     * If a client with label <A:1,B:1,C:1> connects, the config
     * from P3 will be selected.
     * If there is more than one best match, (for example, if a
     * config P4 with selector <A:1,D:1> exists and if a client with
     * label <A:1,B:1,D:1> connects), an error will be thrown.
     *
     * Generated from protobuf field <code>.google.cloud.networkservices.v1.EndpointMatcher.MetadataLabelMatcher.MetadataLabelMatchCriteria metadata_label_match_criteria = 1;</code>
     * @param int $var
     * @return $this
     */
    public function setMetadataLabelMatchCriteria($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\NetworkServices\V1\EndpointMatcher\MetadataLabelMatcher\MetadataLabelMatchCriteria::class);
        $this->metadata_label_match_criteria = $var;

        return $this;
    }

    /**
     * The list of label value pairs that must match labels in the
     * provided metadata based on filterMatchCriteria This list can
     * have at most 64 entries. The list can be empty if the match
     * criteria is MATCH_ANY, to specify a wildcard match (i.e this
     * matches any client).
     *
     * Generated from protobuf field <code>repeated .google.cloud.networkservices.v1.EndpointMatcher.MetadataLabelMatcher.MetadataLabels metadata_labels = 2;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getMetadataLabels()
    {
        return $this->metadata_labels;
    }

    /**
     * The list of label value pairs that must match labels in the
     * provided metadata based on filterMatchCriteria This list can
     * have at most 64 entries. The list can be empty if the match
     * criteria is MATCH_ANY, to specify a wildcard match (i.e this
     * matches any client).
     *
     * Generated from protobuf field <code>repeated .google.cloud.networkservices.v1.EndpointMatcher.MetadataLabelMatcher.MetadataLabels metadata_labels = 2;</code>
     * @param array<\Google\Cloud\NetworkServices\V1\EndpointMatcher\MetadataLabelMatcher\MetadataLabels>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setMetadataLabels($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\NetworkServices\V1\EndpointMatcher\MetadataLabelMatcher\MetadataLabels::class);
        $this->metadata_labels = $arr;

        return $this;
    }

}


