<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/networkservices/v1/tls_route.proto

namespace Google\Cloud\NetworkServices\V1\TlsRoute;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * RouteMatch defines the predicate used to match requests to a given action.
 * Multiple match types are "AND"ed for evaluation.
 * If no routeMatch field is specified, this rule will unconditionally match
 * traffic.
 *
 * Generated from protobuf message <code>google.cloud.networkservices.v1.TlsRoute.RouteMatch</code>
 */
class RouteMatch extends \Google\Protobuf\Internal\Message
{
    /**
     * Optional. SNI (server name indicator) to match against.
     * SNI will be matched against all wildcard domains, i.e. `www.example.com`
     * will be first matched against `www.example.com`, then `*.example.com`,
     * then `*.com.`
     * Partial wildcards are not supported, and values like *w.example.com are
     * invalid.
     * At least one of sni_host and alpn is required.
     * Up to 5 sni hosts across all matches can be set.
     *
     * Generated from protobuf field <code>repeated string sni_host = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $sni_host;
    /**
     * Optional. ALPN (Application-Layer Protocol Negotiation) to match against.
     * Examples: "http/1.1", "h2".
     * At least one of sni_host and alpn is required.
     * Up to 5 alpns across all matches can be set.
     *
     * Generated from protobuf field <code>repeated string alpn = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $alpn;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $sni_host
     *           Optional. SNI (server name indicator) to match against.
     *           SNI will be matched against all wildcard domains, i.e. `www.example.com`
     *           will be first matched against `www.example.com`, then `*.example.com`,
     *           then `*.com.`
     *           Partial wildcards are not supported, and values like *w.example.com are
     *           invalid.
     *           At least one of sni_host and alpn is required.
     *           Up to 5 sni hosts across all matches can be set.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $alpn
     *           Optional. ALPN (Application-Layer Protocol Negotiation) to match against.
     *           Examples: "http/1.1", "h2".
     *           At least one of sni_host and alpn is required.
     *           Up to 5 alpns across all matches can be set.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Networkservices\V1\TlsRoute::initOnce();
        parent::__construct($data);
    }

    /**
     * Optional. SNI (server name indicator) to match against.
     * SNI will be matched against all wildcard domains, i.e. `www.example.com`
     * will be first matched against `www.example.com`, then `*.example.com`,
     * then `*.com.`
     * Partial wildcards are not supported, and values like *w.example.com are
     * invalid.
     * At least one of sni_host and alpn is required.
     * Up to 5 sni hosts across all matches can be set.
     *
     * Generated from protobuf field <code>repeated string sni_host = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSniHost()
    {
        return $this->sni_host;
    }

    /**
     * Optional. SNI (server name indicator) to match against.
     * SNI will be matched against all wildcard domains, i.e. `www.example.com`
     * will be first matched against `www.example.com`, then `*.example.com`,
     * then `*.com.`
     * Partial wildcards are not supported, and values like *w.example.com are
     * invalid.
     * At least one of sni_host and alpn is required.
     * Up to 5 sni hosts across all matches can be set.
     *
     * Generated from protobuf field <code>repeated string sni_host = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSniHost($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->sni_host = $arr;

        return $this;
    }

    /**
     * Optional. ALPN (Application-Layer Protocol Negotiation) to match against.
     * Examples: "http/1.1", "h2".
     * At least one of sni_host and alpn is required.
     * Up to 5 alpns across all matches can be set.
     *
     * Generated from protobuf field <code>repeated string alpn = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getAlpn()
    {
        return $this->alpn;
    }

    /**
     * Optional. ALPN (Application-Layer Protocol Negotiation) to match against.
     * Examples: "http/1.1", "h2".
     * At least one of sni_host and alpn is required.
     * Up to 5 alpns across all matches can be set.
     *
     * Generated from protobuf field <code>repeated string alpn = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setAlpn($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->alpn = $arr;

        return $this;
    }

}


