<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/notebooks/v1/execution.proto

namespace Google\Cloud\Notebooks\V1\ExecutionTemplate;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Parameters used in Vertex AI JobType executions.
 *
 * Generated from protobuf message <code>google.cloud.notebooks.v1.ExecutionTemplate.VertexAIParameters</code>
 */
class VertexAIParameters extends \Google\Protobuf\Internal\Message
{
    /**
     * The full name of the Compute Engine
     * [network](https://cloud.google.com/compute/docs/networks-and-firewalls#networks)
     * to which the Job should be peered. For example,
     * `projects/12345/global/networks/myVPC`.
     * [Format](https://cloud.google.com/compute/docs/reference/rest/v1/networks/insert)
     * is of the form `projects/{project}/global/networks/{network}`.
     * Where `{project}` is a project number, as in `12345`, and `{network}` is
     * a network name.
     * Private services access must already be configured for the network. If
     * left unspecified, the job is not peered with any network.
     *
     * Generated from protobuf field <code>string network = 1;</code>
     */
    protected $network = '';
    /**
     * Environment variables.
     * At most 100 environment variables can be specified and unique.
     * Example: `GCP_BUCKET=gs://my-bucket/samples/`
     *
     * Generated from protobuf field <code>map<string, string> env = 2;</code>
     */
    private $env;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $network
     *           The full name of the Compute Engine
     *           [network](https://cloud.google.com/compute/docs/networks-and-firewalls#networks)
     *           to which the Job should be peered. For example,
     *           `projects/12345/global/networks/myVPC`.
     *           [Format](https://cloud.google.com/compute/docs/reference/rest/v1/networks/insert)
     *           is of the form `projects/{project}/global/networks/{network}`.
     *           Where `{project}` is a project number, as in `12345`, and `{network}` is
     *           a network name.
     *           Private services access must already be configured for the network. If
     *           left unspecified, the job is not peered with any network.
     *     @type array|\Google\Protobuf\Internal\MapField $env
     *           Environment variables.
     *           At most 100 environment variables can be specified and unique.
     *           Example: `GCP_BUCKET=gs://my-bucket/samples/`
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Notebooks\V1\Execution::initOnce();
        parent::__construct($data);
    }

    /**
     * The full name of the Compute Engine
     * [network](https://cloud.google.com/compute/docs/networks-and-firewalls#networks)
     * to which the Job should be peered. For example,
     * `projects/12345/global/networks/myVPC`.
     * [Format](https://cloud.google.com/compute/docs/reference/rest/v1/networks/insert)
     * is of the form `projects/{project}/global/networks/{network}`.
     * Where `{project}` is a project number, as in `12345`, and `{network}` is
     * a network name.
     * Private services access must already be configured for the network. If
     * left unspecified, the job is not peered with any network.
     *
     * Generated from protobuf field <code>string network = 1;</code>
     * @return string
     */
    public function getNetwork()
    {
        return $this->network;
    }

    /**
     * The full name of the Compute Engine
     * [network](https://cloud.google.com/compute/docs/networks-and-firewalls#networks)
     * to which the Job should be peered. For example,
     * `projects/12345/global/networks/myVPC`.
     * [Format](https://cloud.google.com/compute/docs/reference/rest/v1/networks/insert)
     * is of the form `projects/{project}/global/networks/{network}`.
     * Where `{project}` is a project number, as in `12345`, and `{network}` is
     * a network name.
     * Private services access must already be configured for the network. If
     * left unspecified, the job is not peered with any network.
     *
     * Generated from protobuf field <code>string network = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setNetwork($var)
    {
        GPBUtil::checkString($var, True);
        $this->network = $var;

        return $this;
    }

    /**
     * Environment variables.
     * At most 100 environment variables can be specified and unique.
     * Example: `GCP_BUCKET=gs://my-bucket/samples/`
     *
     * Generated from protobuf field <code>map<string, string> env = 2;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getEnv()
    {
        return $this->env;
    }

    /**
     * Environment variables.
     * At most 100 environment variables can be specified and unique.
     * Example: `GCP_BUCKET=gs://my-bucket/samples/`
     *
     * Generated from protobuf field <code>map<string, string> env = 2;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setEnv($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->env = $arr;

        return $this;
    }

}


