<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/notebooks/v1/runtime.proto

namespace Google\Cloud\Notebooks\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Input only. Specifies the parameters for a new disk that will be created
 * alongside the new instance. Use initialization parameters to create boot
 * disks or local SSDs attached to the new runtime.
 * This property is mutually exclusive with the source property; you can only
 * define one or the other, but not both.
 *
 * Generated from protobuf message <code>google.cloud.notebooks.v1.LocalDiskInitializeParams</code>
 */
class LocalDiskInitializeParams extends \Google\Protobuf\Internal\Message
{
    /**
     * Optional. Provide this property when creating the disk.
     *
     * Generated from protobuf field <code>string description = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $description = '';
    /**
     * Optional. Specifies the disk name. If not specified, the default is to use the name
     * of the instance. If the disk with the instance name exists already in the
     * given zone/region, a new name will be automatically generated.
     *
     * Generated from protobuf field <code>string disk_name = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $disk_name = '';
    /**
     * Optional. Specifies the size of the disk in base-2 GB. If not specified, the disk
     * will be the same size as the image (usually 10GB). If specified, the size
     * must be equal to or larger than 10GB. Default 100 GB.
     *
     * Generated from protobuf field <code>int64 disk_size_gb = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $disk_size_gb = 0;
    /**
     * Input only. The type of the boot disk attached to this instance, defaults to
     * standard persistent disk (`PD_STANDARD`).
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.LocalDiskInitializeParams.DiskType disk_type = 4 [(.google.api.field_behavior) = INPUT_ONLY];</code>
     */
    protected $disk_type = 0;
    /**
     * Optional. Labels to apply to this disk. These can be later modified by the
     * disks.setLabels method. This field is only applicable for persistent disks.
     *
     * Generated from protobuf field <code>map<string, string> labels = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $labels;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $description
     *           Optional. Provide this property when creating the disk.
     *     @type string $disk_name
     *           Optional. Specifies the disk name. If not specified, the default is to use the name
     *           of the instance. If the disk with the instance name exists already in the
     *           given zone/region, a new name will be automatically generated.
     *     @type int|string $disk_size_gb
     *           Optional. Specifies the size of the disk in base-2 GB. If not specified, the disk
     *           will be the same size as the image (usually 10GB). If specified, the size
     *           must be equal to or larger than 10GB. Default 100 GB.
     *     @type int $disk_type
     *           Input only. The type of the boot disk attached to this instance, defaults to
     *           standard persistent disk (`PD_STANDARD`).
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Optional. Labels to apply to this disk. These can be later modified by the
     *           disks.setLabels method. This field is only applicable for persistent disks.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Notebooks\V1\Runtime::initOnce();
        parent::__construct($data);
    }

    /**
     * Optional. Provide this property when creating the disk.
     *
     * Generated from protobuf field <code>string description = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Optional. Provide this property when creating the disk.
     *
     * Generated from protobuf field <code>string description = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Optional. Specifies the disk name. If not specified, the default is to use the name
     * of the instance. If the disk with the instance name exists already in the
     * given zone/region, a new name will be automatically generated.
     *
     * Generated from protobuf field <code>string disk_name = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDiskName()
    {
        return $this->disk_name;
    }

    /**
     * Optional. Specifies the disk name. If not specified, the default is to use the name
     * of the instance. If the disk with the instance name exists already in the
     * given zone/region, a new name will be automatically generated.
     *
     * Generated from protobuf field <code>string disk_name = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDiskName($var)
    {
        GPBUtil::checkString($var, True);
        $this->disk_name = $var;

        return $this;
    }

    /**
     * Optional. Specifies the size of the disk in base-2 GB. If not specified, the disk
     * will be the same size as the image (usually 10GB). If specified, the size
     * must be equal to or larger than 10GB. Default 100 GB.
     *
     * Generated from protobuf field <code>int64 disk_size_gb = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int|string
     */
    public function getDiskSizeGb()
    {
        return $this->disk_size_gb;
    }

    /**
     * Optional. Specifies the size of the disk in base-2 GB. If not specified, the disk
     * will be the same size as the image (usually 10GB). If specified, the size
     * must be equal to or larger than 10GB. Default 100 GB.
     *
     * Generated from protobuf field <code>int64 disk_size_gb = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int|string $var
     * @return $this
     */
    public function setDiskSizeGb($var)
    {
        GPBUtil::checkInt64($var);
        $this->disk_size_gb = $var;

        return $this;
    }

    /**
     * Input only. The type of the boot disk attached to this instance, defaults to
     * standard persistent disk (`PD_STANDARD`).
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.LocalDiskInitializeParams.DiskType disk_type = 4 [(.google.api.field_behavior) = INPUT_ONLY];</code>
     * @return int
     */
    public function getDiskType()
    {
        return $this->disk_type;
    }

    /**
     * Input only. The type of the boot disk attached to this instance, defaults to
     * standard persistent disk (`PD_STANDARD`).
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.LocalDiskInitializeParams.DiskType disk_type = 4 [(.google.api.field_behavior) = INPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setDiskType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Notebooks\V1\LocalDiskInitializeParams\DiskType::class);
        $this->disk_type = $var;

        return $this;
    }

    /**
     * Optional. Labels to apply to this disk. These can be later modified by the
     * disks.setLabels method. This field is only applicable for persistent disks.
     *
     * Generated from protobuf field <code>map<string, string> labels = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Optional. Labels to apply to this disk. These can be later modified by the
     * disks.setLabels method. This field is only applicable for persistent disks.
     *
     * Generated from protobuf field <code>map<string, string> labels = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

}

