<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/notebooks/v1/runtime.proto

namespace Google\Cloud\Notebooks\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The definition of a Runtime for a managed notebook instance.
 *
 * Generated from protobuf message <code>google.cloud.notebooks.v1.Runtime</code>
 */
class Runtime extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The resource name of the runtime.
     * Format:
     * `projects/{project}/locations/{location}/runtimes/{runtimeId}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $name = '';
    /**
     * Output only. Runtime state.
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.Runtime.State state = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;
    /**
     * Output only. Runtime health_state.
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.Runtime.HealthState health_state = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $health_state = 0;
    /**
     * The config settings for accessing runtime.
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.RuntimeAccessConfig access_config = 5;</code>
     */
    protected $access_config = null;
    /**
     * The config settings for software inside the runtime.
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.RuntimeSoftwareConfig software_config = 6;</code>
     */
    protected $software_config = null;
    /**
     * Output only. Contains Runtime daemon metrics such as Service status and JupyterLab
     * stats.
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.RuntimeMetrics metrics = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $metrics = null;
    /**
     * Output only. Runtime creation time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 20 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. Runtime update time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 21 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    protected $runtime_type;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. The resource name of the runtime.
     *           Format:
     *           `projects/{project}/locations/{location}/runtimes/{runtimeId}`
     *     @type \Google\Cloud\Notebooks\V1\VirtualMachine $virtual_machine
     *           Use a Compute Engine VM image to start the managed notebook instance.
     *     @type int $state
     *           Output only. Runtime state.
     *     @type int $health_state
     *           Output only. Runtime health_state.
     *     @type \Google\Cloud\Notebooks\V1\RuntimeAccessConfig $access_config
     *           The config settings for accessing runtime.
     *     @type \Google\Cloud\Notebooks\V1\RuntimeSoftwareConfig $software_config
     *           The config settings for software inside the runtime.
     *     @type \Google\Cloud\Notebooks\V1\RuntimeMetrics $metrics
     *           Output only. Contains Runtime daemon metrics such as Service status and JupyterLab
     *           stats.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. Runtime creation time.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. Runtime update time.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Notebooks\V1\Runtime::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The resource name of the runtime.
     * Format:
     * `projects/{project}/locations/{location}/runtimes/{runtimeId}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. The resource name of the runtime.
     * Format:
     * `projects/{project}/locations/{location}/runtimes/{runtimeId}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Use a Compute Engine VM image to start the managed notebook instance.
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.VirtualMachine virtual_machine = 2;</code>
     * @return \Google\Cloud\Notebooks\V1\VirtualMachine|null
     */
    public function getVirtualMachine()
    {
        return $this->readOneof(2);
    }

    public function hasVirtualMachine()
    {
        return $this->hasOneof(2);
    }

    /**
     * Use a Compute Engine VM image to start the managed notebook instance.
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.VirtualMachine virtual_machine = 2;</code>
     * @param \Google\Cloud\Notebooks\V1\VirtualMachine $var
     * @return $this
     */
    public function setVirtualMachine($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Notebooks\V1\VirtualMachine::class);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     * Output only. Runtime state.
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.Runtime.State state = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. Runtime state.
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.Runtime.State state = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Notebooks\V1\Runtime\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Output only. Runtime health_state.
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.Runtime.HealthState health_state = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getHealthState()
    {
        return $this->health_state;
    }

    /**
     * Output only. Runtime health_state.
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.Runtime.HealthState health_state = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setHealthState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Notebooks\V1\Runtime\HealthState::class);
        $this->health_state = $var;

        return $this;
    }

    /**
     * The config settings for accessing runtime.
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.RuntimeAccessConfig access_config = 5;</code>
     * @return \Google\Cloud\Notebooks\V1\RuntimeAccessConfig|null
     */
    public function getAccessConfig()
    {
        return $this->access_config;
    }

    public function hasAccessConfig()
    {
        return isset($this->access_config);
    }

    public function clearAccessConfig()
    {
        unset($this->access_config);
    }

    /**
     * The config settings for accessing runtime.
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.RuntimeAccessConfig access_config = 5;</code>
     * @param \Google\Cloud\Notebooks\V1\RuntimeAccessConfig $var
     * @return $this
     */
    public function setAccessConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Notebooks\V1\RuntimeAccessConfig::class);
        $this->access_config = $var;

        return $this;
    }

    /**
     * The config settings for software inside the runtime.
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.RuntimeSoftwareConfig software_config = 6;</code>
     * @return \Google\Cloud\Notebooks\V1\RuntimeSoftwareConfig|null
     */
    public function getSoftwareConfig()
    {
        return $this->software_config;
    }

    public function hasSoftwareConfig()
    {
        return isset($this->software_config);
    }

    public function clearSoftwareConfig()
    {
        unset($this->software_config);
    }

    /**
     * The config settings for software inside the runtime.
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.RuntimeSoftwareConfig software_config = 6;</code>
     * @param \Google\Cloud\Notebooks\V1\RuntimeSoftwareConfig $var
     * @return $this
     */
    public function setSoftwareConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Notebooks\V1\RuntimeSoftwareConfig::class);
        $this->software_config = $var;

        return $this;
    }

    /**
     * Output only. Contains Runtime daemon metrics such as Service status and JupyterLab
     * stats.
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.RuntimeMetrics metrics = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\Notebooks\V1\RuntimeMetrics|null
     */
    public function getMetrics()
    {
        return $this->metrics;
    }

    public function hasMetrics()
    {
        return isset($this->metrics);
    }

    public function clearMetrics()
    {
        unset($this->metrics);
    }

    /**
     * Output only. Contains Runtime daemon metrics such as Service status and JupyterLab
     * stats.
     *
     * Generated from protobuf field <code>.google.cloud.notebooks.v1.RuntimeMetrics metrics = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\Notebooks\V1\RuntimeMetrics $var
     * @return $this
     */
    public function setMetrics($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Notebooks\V1\RuntimeMetrics::class);
        $this->metrics = $var;

        return $this;
    }

    /**
     * Output only. Runtime creation time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 20 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. Runtime creation time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 20 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. Runtime update time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 21 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. Runtime update time.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 21 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getRuntimeType()
    {
        return $this->whichOneof("runtime_type");
    }

}

