<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/oracledatabase/v1/autonomous_database.proto

namespace Google\Cloud\OracleDatabase\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The URLs for accessing Oracle Application Express (APEX) and SQL Developer
 * Web with a browser from a Compute instance.
 * https://docs.oracle.com/en-us/iaas/api/#/en/database/20160918/datatypes/AutonomousDatabaseConnectionUrls
 *
 * Generated from protobuf message <code>google.cloud.oracledatabase.v1.AutonomousDatabaseConnectionUrls</code>
 */
class AutonomousDatabaseConnectionUrls extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. Oracle Application Express (APEX) URL.
     *
     * Generated from protobuf field <code>string apex_uri = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $apex_uri = '';
    /**
     * Output only. The URL of the Database Transforms for the Autonomous
     * Database.
     *
     * Generated from protobuf field <code>string database_transforms_uri = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $database_transforms_uri = '';
    /**
     * Output only. The URL of the Graph Studio for the Autonomous Database.
     *
     * Generated from protobuf field <code>string graph_studio_uri = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $graph_studio_uri = '';
    /**
     * Output only. The URL of the Oracle Machine Learning (OML) Notebook for the
     * Autonomous Database.
     *
     * Generated from protobuf field <code>string machine_learning_notebook_uri = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $machine_learning_notebook_uri = '';
    /**
     * Output only. The URL of Machine Learning user management the Autonomous
     * Database.
     *
     * Generated from protobuf field <code>string machine_learning_user_management_uri = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $machine_learning_user_management_uri = '';
    /**
     * Output only. The URL of the MongoDB API for the Autonomous Database.
     *
     * Generated from protobuf field <code>string mongo_db_uri = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $mongo_db_uri = '';
    /**
     * Output only. The Oracle REST Data Services (ORDS) URL of the Web Access for
     * the Autonomous Database.
     *
     * Generated from protobuf field <code>string ords_uri = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $ords_uri = '';
    /**
     * Output only. The URL of the Oracle SQL Developer Web for the Autonomous
     * Database.
     *
     * Generated from protobuf field <code>string sql_dev_web_uri = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $sql_dev_web_uri = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $apex_uri
     *           Output only. Oracle Application Express (APEX) URL.
     *     @type string $database_transforms_uri
     *           Output only. The URL of the Database Transforms for the Autonomous
     *           Database.
     *     @type string $graph_studio_uri
     *           Output only. The URL of the Graph Studio for the Autonomous Database.
     *     @type string $machine_learning_notebook_uri
     *           Output only. The URL of the Oracle Machine Learning (OML) Notebook for the
     *           Autonomous Database.
     *     @type string $machine_learning_user_management_uri
     *           Output only. The URL of Machine Learning user management the Autonomous
     *           Database.
     *     @type string $mongo_db_uri
     *           Output only. The URL of the MongoDB API for the Autonomous Database.
     *     @type string $ords_uri
     *           Output only. The Oracle REST Data Services (ORDS) URL of the Web Access for
     *           the Autonomous Database.
     *     @type string $sql_dev_web_uri
     *           Output only. The URL of the Oracle SQL Developer Web for the Autonomous
     *           Database.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Oracledatabase\V1\AutonomousDatabase::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. Oracle Application Express (APEX) URL.
     *
     * Generated from protobuf field <code>string apex_uri = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getApexUri()
    {
        return $this->apex_uri;
    }

    /**
     * Output only. Oracle Application Express (APEX) URL.
     *
     * Generated from protobuf field <code>string apex_uri = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setApexUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->apex_uri = $var;

        return $this;
    }

    /**
     * Output only. The URL of the Database Transforms for the Autonomous
     * Database.
     *
     * Generated from protobuf field <code>string database_transforms_uri = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getDatabaseTransformsUri()
    {
        return $this->database_transforms_uri;
    }

    /**
     * Output only. The URL of the Database Transforms for the Autonomous
     * Database.
     *
     * Generated from protobuf field <code>string database_transforms_uri = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setDatabaseTransformsUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->database_transforms_uri = $var;

        return $this;
    }

    /**
     * Output only. The URL of the Graph Studio for the Autonomous Database.
     *
     * Generated from protobuf field <code>string graph_studio_uri = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getGraphStudioUri()
    {
        return $this->graph_studio_uri;
    }

    /**
     * Output only. The URL of the Graph Studio for the Autonomous Database.
     *
     * Generated from protobuf field <code>string graph_studio_uri = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setGraphStudioUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->graph_studio_uri = $var;

        return $this;
    }

    /**
     * Output only. The URL of the Oracle Machine Learning (OML) Notebook for the
     * Autonomous Database.
     *
     * Generated from protobuf field <code>string machine_learning_notebook_uri = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getMachineLearningNotebookUri()
    {
        return $this->machine_learning_notebook_uri;
    }

    /**
     * Output only. The URL of the Oracle Machine Learning (OML) Notebook for the
     * Autonomous Database.
     *
     * Generated from protobuf field <code>string machine_learning_notebook_uri = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setMachineLearningNotebookUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->machine_learning_notebook_uri = $var;

        return $this;
    }

    /**
     * Output only. The URL of Machine Learning user management the Autonomous
     * Database.
     *
     * Generated from protobuf field <code>string machine_learning_user_management_uri = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getMachineLearningUserManagementUri()
    {
        return $this->machine_learning_user_management_uri;
    }

    /**
     * Output only. The URL of Machine Learning user management the Autonomous
     * Database.
     *
     * Generated from protobuf field <code>string machine_learning_user_management_uri = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setMachineLearningUserManagementUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->machine_learning_user_management_uri = $var;

        return $this;
    }

    /**
     * Output only. The URL of the MongoDB API for the Autonomous Database.
     *
     * Generated from protobuf field <code>string mongo_db_uri = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getMongoDbUri()
    {
        return $this->mongo_db_uri;
    }

    /**
     * Output only. The URL of the MongoDB API for the Autonomous Database.
     *
     * Generated from protobuf field <code>string mongo_db_uri = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setMongoDbUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->mongo_db_uri = $var;

        return $this;
    }

    /**
     * Output only. The Oracle REST Data Services (ORDS) URL of the Web Access for
     * the Autonomous Database.
     *
     * Generated from protobuf field <code>string ords_uri = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getOrdsUri()
    {
        return $this->ords_uri;
    }

    /**
     * Output only. The Oracle REST Data Services (ORDS) URL of the Web Access for
     * the Autonomous Database.
     *
     * Generated from protobuf field <code>string ords_uri = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setOrdsUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->ords_uri = $var;

        return $this;
    }

    /**
     * Output only. The URL of the Oracle SQL Developer Web for the Autonomous
     * Database.
     *
     * Generated from protobuf field <code>string sql_dev_web_uri = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getSqlDevWebUri()
    {
        return $this->sql_dev_web_uri;
    }

    /**
     * Output only. The URL of the Oracle SQL Developer Web for the Autonomous
     * Database.
     *
     * Generated from protobuf field <code>string sql_dev_web_uri = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setSqlDevWebUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->sql_dev_web_uri = $var;

        return $this;
    }

}

