<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/oracledatabase/v1/autonomous_db_version.proto

namespace Google\Cloud\OracleDatabase\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Details of the Autonomous Database version.
 * https://docs.oracle.com/en-us/iaas/api/#/en/database/20160918/AutonomousDbVersionSummary/
 *
 * Generated from protobuf message <code>google.cloud.oracledatabase.v1.AutonomousDbVersion</code>
 */
class AutonomousDbVersion extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. The name of the Autonomous Database Version resource with the
     * format:
     * projects/{project}/locations/{region}/autonomousDbVersions/{autonomous_db_version}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Output only. An Oracle Database version for Autonomous Database.
     *
     * Generated from protobuf field <code>string version = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $version = '';
    /**
     * Output only. The Autonomous Database workload type.
     *
     * Generated from protobuf field <code>.google.cloud.oracledatabase.v1.DBWorkload db_workload = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $db_workload = 0;
    /**
     * Output only. A URL that points to a detailed description of the Autonomous
     * Database version.
     *
     * Generated from protobuf field <code>string workload_uri = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $workload_uri = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. The name of the Autonomous Database Version resource with the
     *           format:
     *           projects/{project}/locations/{region}/autonomousDbVersions/{autonomous_db_version}
     *     @type string $version
     *           Output only. An Oracle Database version for Autonomous Database.
     *     @type int $db_workload
     *           Output only. The Autonomous Database workload type.
     *     @type string $workload_uri
     *           Output only. A URL that points to a detailed description of the Autonomous
     *           Database version.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Oracledatabase\V1\AutonomousDbVersion::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. The name of the Autonomous Database Version resource with the
     * format:
     * projects/{project}/locations/{region}/autonomousDbVersions/{autonomous_db_version}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. The name of the Autonomous Database Version resource with the
     * format:
     * projects/{project}/locations/{region}/autonomousDbVersions/{autonomous_db_version}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. An Oracle Database version for Autonomous Database.
     *
     * Generated from protobuf field <code>string version = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getVersion()
    {
        return $this->version;
    }

    /**
     * Output only. An Oracle Database version for Autonomous Database.
     *
     * Generated from protobuf field <code>string version = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->version = $var;

        return $this;
    }

    /**
     * Output only. The Autonomous Database workload type.
     *
     * Generated from protobuf field <code>.google.cloud.oracledatabase.v1.DBWorkload db_workload = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getDbWorkload()
    {
        return $this->db_workload;
    }

    /**
     * Output only. The Autonomous Database workload type.
     *
     * Generated from protobuf field <code>.google.cloud.oracledatabase.v1.DBWorkload db_workload = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setDbWorkload($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\OracleDatabase\V1\DBWorkload::class);
        $this->db_workload = $var;

        return $this;
    }

    /**
     * Output only. A URL that points to a detailed description of the Autonomous
     * Database version.
     *
     * Generated from protobuf field <code>string workload_uri = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getWorkloadUri()
    {
        return $this->workload_uri;
    }

    /**
     * Output only. A URL that points to a detailed description of the Autonomous
     * Database version.
     *
     * Generated from protobuf field <code>string workload_uri = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setWorkloadUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->workload_uri = $var;

        return $this;
    }

}

