<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/oracledatabase/v1/exadata_infra.proto

namespace Google\Cloud\OracleDatabase\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents CloudExadataInfrastructure resource.
 * https://docs.oracle.com/en-us/iaas/api/#/en/database/20160918/CloudExadataInfrastructure/
 *
 * Generated from protobuf message <code>google.cloud.oracledatabase.v1.CloudExadataInfrastructure</code>
 */
class CloudExadataInfrastructure extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. The name of the Exadata Infrastructure resource with the
     * format:
     * projects/{project}/locations/{region}/cloudExadataInfrastructures/{cloud_exadata_infrastructure}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Optional. User friendly name for this resource.
     *
     * Generated from protobuf field <code>string display_name = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $display_name = '';
    /**
     * Optional. Google Cloud Platform location where Oracle Exadata is hosted.
     *
     * Generated from protobuf field <code>string gcp_oracle_zone = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $gcp_oracle_zone = '';
    /**
     * Output only. Entitlement ID of the private offer against which this
     * infrastructure resource is provisioned.
     *
     * Generated from protobuf field <code>string entitlement_id = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $entitlement_id = '';
    /**
     * Optional. Various properties of the infra.
     *
     * Generated from protobuf field <code>.google.cloud.oracledatabase.v1.CloudExadataInfrastructureProperties properties = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $properties = null;
    /**
     * Optional. Labels or tags associated with the resource.
     *
     * Generated from protobuf field <code>map<string, string> labels = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $labels;
    /**
     * Output only. The date and time that the Exadata Infrastructure was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. The name of the Exadata Infrastructure resource with the
     *           format:
     *           projects/{project}/locations/{region}/cloudExadataInfrastructures/{cloud_exadata_infrastructure}
     *     @type string $display_name
     *           Optional. User friendly name for this resource.
     *     @type string $gcp_oracle_zone
     *           Optional. Google Cloud Platform location where Oracle Exadata is hosted.
     *     @type string $entitlement_id
     *           Output only. Entitlement ID of the private offer against which this
     *           infrastructure resource is provisioned.
     *     @type \Google\Cloud\OracleDatabase\V1\CloudExadataInfrastructureProperties $properties
     *           Optional. Various properties of the infra.
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Optional. Labels or tags associated with the resource.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. The date and time that the Exadata Infrastructure was created.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Oracledatabase\V1\ExadataInfra::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. The name of the Exadata Infrastructure resource with the
     * format:
     * projects/{project}/locations/{region}/cloudExadataInfrastructures/{cloud_exadata_infrastructure}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. The name of the Exadata Infrastructure resource with the
     * format:
     * projects/{project}/locations/{region}/cloudExadataInfrastructures/{cloud_exadata_infrastructure}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Optional. User friendly name for this resource.
     *
     * Generated from protobuf field <code>string display_name = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * Optional. User friendly name for this resource.
     *
     * Generated from protobuf field <code>string display_name = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * Optional. Google Cloud Platform location where Oracle Exadata is hosted.
     *
     * Generated from protobuf field <code>string gcp_oracle_zone = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getGcpOracleZone()
    {
        return $this->gcp_oracle_zone;
    }

    /**
     * Optional. Google Cloud Platform location where Oracle Exadata is hosted.
     *
     * Generated from protobuf field <code>string gcp_oracle_zone = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setGcpOracleZone($var)
    {
        GPBUtil::checkString($var, True);
        $this->gcp_oracle_zone = $var;

        return $this;
    }

    /**
     * Output only. Entitlement ID of the private offer against which this
     * infrastructure resource is provisioned.
     *
     * Generated from protobuf field <code>string entitlement_id = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getEntitlementId()
    {
        return $this->entitlement_id;
    }

    /**
     * Output only. Entitlement ID of the private offer against which this
     * infrastructure resource is provisioned.
     *
     * Generated from protobuf field <code>string entitlement_id = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setEntitlementId($var)
    {
        GPBUtil::checkString($var, True);
        $this->entitlement_id = $var;

        return $this;
    }

    /**
     * Optional. Various properties of the infra.
     *
     * Generated from protobuf field <code>.google.cloud.oracledatabase.v1.CloudExadataInfrastructureProperties properties = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\OracleDatabase\V1\CloudExadataInfrastructureProperties|null
     */
    public function getProperties()
    {
        return $this->properties;
    }

    public function hasProperties()
    {
        return isset($this->properties);
    }

    public function clearProperties()
    {
        unset($this->properties);
    }

    /**
     * Optional. Various properties of the infra.
     *
     * Generated from protobuf field <code>.google.cloud.oracledatabase.v1.CloudExadataInfrastructureProperties properties = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\OracleDatabase\V1\CloudExadataInfrastructureProperties $var
     * @return $this
     */
    public function setProperties($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\OracleDatabase\V1\CloudExadataInfrastructureProperties::class);
        $this->properties = $var;

        return $this;
    }

    /**
     * Optional. Labels or tags associated with the resource.
     *
     * Generated from protobuf field <code>map<string, string> labels = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Optional. Labels or tags associated with the resource.
     *
     * Generated from protobuf field <code>map<string, string> labels = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * Output only. The date and time that the Exadata Infrastructure was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. The date and time that the Exadata Infrastructure was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

}

