<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/oracledatabase/v1/db_system_shape.proto

namespace Google\Cloud\OracleDatabase\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Details of the Database System Shapes resource.
 * https://docs.oracle.com/en-us/iaas/api/#/en/database/20160918/DbSystemShapeSummary/
 *
 * Generated from protobuf message <code>google.cloud.oracledatabase.v1.DbSystemShape</code>
 */
class DbSystemShape extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. The name of the Database System Shape resource with the format:
     * projects/{project}/locations/{region}/dbSystemShapes/{db_system_shape}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Optional. shape
     *
     * Generated from protobuf field <code>string shape = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $shape = '';
    /**
     * Optional. Minimum number of database servers.
     *
     * Generated from protobuf field <code>int32 min_node_count = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $min_node_count = 0;
    /**
     * Optional. Maximum number of database servers.
     *
     * Generated from protobuf field <code>int32 max_node_count = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $max_node_count = 0;
    /**
     * Optional. Minimum number of storage servers.
     *
     * Generated from protobuf field <code>int32 min_storage_count = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $min_storage_count = 0;
    /**
     * Optional. Maximum number of storage servers.
     *
     * Generated from protobuf field <code>int32 max_storage_count = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $max_storage_count = 0;
    /**
     * Optional. Number of cores per node.
     *
     * Generated from protobuf field <code>int32 available_core_count_per_node = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $available_core_count_per_node = 0;
    /**
     * Optional. Memory per database server node in gigabytes.
     *
     * Generated from protobuf field <code>int32 available_memory_per_node_gb = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $available_memory_per_node_gb = 0;
    /**
     * Optional. Storage per storage server in terabytes.
     *
     * Generated from protobuf field <code>int32 available_data_storage_tb = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $available_data_storage_tb = 0;
    /**
     * Optional. Minimum core count per node.
     *
     * Generated from protobuf field <code>int32 min_core_count_per_node = 10 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $min_core_count_per_node = 0;
    /**
     * Optional. Minimum memory per node in gigabytes.
     *
     * Generated from protobuf field <code>int32 min_memory_per_node_gb = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $min_memory_per_node_gb = 0;
    /**
     * Optional. Minimum node storage per database server in gigabytes.
     *
     * Generated from protobuf field <code>int32 min_db_node_storage_per_node_gb = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $min_db_node_storage_per_node_gb = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. The name of the Database System Shape resource with the format:
     *           projects/{project}/locations/{region}/dbSystemShapes/{db_system_shape}
     *     @type string $shape
     *           Optional. shape
     *     @type int $min_node_count
     *           Optional. Minimum number of database servers.
     *     @type int $max_node_count
     *           Optional. Maximum number of database servers.
     *     @type int $min_storage_count
     *           Optional. Minimum number of storage servers.
     *     @type int $max_storage_count
     *           Optional. Maximum number of storage servers.
     *     @type int $available_core_count_per_node
     *           Optional. Number of cores per node.
     *     @type int $available_memory_per_node_gb
     *           Optional. Memory per database server node in gigabytes.
     *     @type int $available_data_storage_tb
     *           Optional. Storage per storage server in terabytes.
     *     @type int $min_core_count_per_node
     *           Optional. Minimum core count per node.
     *     @type int $min_memory_per_node_gb
     *           Optional. Minimum memory per node in gigabytes.
     *     @type int $min_db_node_storage_per_node_gb
     *           Optional. Minimum node storage per database server in gigabytes.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Oracledatabase\V1\DbSystemShape::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. The name of the Database System Shape resource with the format:
     * projects/{project}/locations/{region}/dbSystemShapes/{db_system_shape}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. The name of the Database System Shape resource with the format:
     * projects/{project}/locations/{region}/dbSystemShapes/{db_system_shape}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Optional. shape
     *
     * Generated from protobuf field <code>string shape = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getShape()
    {
        return $this->shape;
    }

    /**
     * Optional. shape
     *
     * Generated from protobuf field <code>string shape = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setShape($var)
    {
        GPBUtil::checkString($var, True);
        $this->shape = $var;

        return $this;
    }

    /**
     * Optional. Minimum number of database servers.
     *
     * Generated from protobuf field <code>int32 min_node_count = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getMinNodeCount()
    {
        return $this->min_node_count;
    }

    /**
     * Optional. Minimum number of database servers.
     *
     * Generated from protobuf field <code>int32 min_node_count = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setMinNodeCount($var)
    {
        GPBUtil::checkInt32($var);
        $this->min_node_count = $var;

        return $this;
    }

    /**
     * Optional. Maximum number of database servers.
     *
     * Generated from protobuf field <code>int32 max_node_count = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getMaxNodeCount()
    {
        return $this->max_node_count;
    }

    /**
     * Optional. Maximum number of database servers.
     *
     * Generated from protobuf field <code>int32 max_node_count = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setMaxNodeCount($var)
    {
        GPBUtil::checkInt32($var);
        $this->max_node_count = $var;

        return $this;
    }

    /**
     * Optional. Minimum number of storage servers.
     *
     * Generated from protobuf field <code>int32 min_storage_count = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getMinStorageCount()
    {
        return $this->min_storage_count;
    }

    /**
     * Optional. Minimum number of storage servers.
     *
     * Generated from protobuf field <code>int32 min_storage_count = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setMinStorageCount($var)
    {
        GPBUtil::checkInt32($var);
        $this->min_storage_count = $var;

        return $this;
    }

    /**
     * Optional. Maximum number of storage servers.
     *
     * Generated from protobuf field <code>int32 max_storage_count = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getMaxStorageCount()
    {
        return $this->max_storage_count;
    }

    /**
     * Optional. Maximum number of storage servers.
     *
     * Generated from protobuf field <code>int32 max_storage_count = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setMaxStorageCount($var)
    {
        GPBUtil::checkInt32($var);
        $this->max_storage_count = $var;

        return $this;
    }

    /**
     * Optional. Number of cores per node.
     *
     * Generated from protobuf field <code>int32 available_core_count_per_node = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getAvailableCoreCountPerNode()
    {
        return $this->available_core_count_per_node;
    }

    /**
     * Optional. Number of cores per node.
     *
     * Generated from protobuf field <code>int32 available_core_count_per_node = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setAvailableCoreCountPerNode($var)
    {
        GPBUtil::checkInt32($var);
        $this->available_core_count_per_node = $var;

        return $this;
    }

    /**
     * Optional. Memory per database server node in gigabytes.
     *
     * Generated from protobuf field <code>int32 available_memory_per_node_gb = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getAvailableMemoryPerNodeGb()
    {
        return $this->available_memory_per_node_gb;
    }

    /**
     * Optional. Memory per database server node in gigabytes.
     *
     * Generated from protobuf field <code>int32 available_memory_per_node_gb = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setAvailableMemoryPerNodeGb($var)
    {
        GPBUtil::checkInt32($var);
        $this->available_memory_per_node_gb = $var;

        return $this;
    }

    /**
     * Optional. Storage per storage server in terabytes.
     *
     * Generated from protobuf field <code>int32 available_data_storage_tb = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getAvailableDataStorageTb()
    {
        return $this->available_data_storage_tb;
    }

    /**
     * Optional. Storage per storage server in terabytes.
     *
     * Generated from protobuf field <code>int32 available_data_storage_tb = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setAvailableDataStorageTb($var)
    {
        GPBUtil::checkInt32($var);
        $this->available_data_storage_tb = $var;

        return $this;
    }

    /**
     * Optional. Minimum core count per node.
     *
     * Generated from protobuf field <code>int32 min_core_count_per_node = 10 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getMinCoreCountPerNode()
    {
        return $this->min_core_count_per_node;
    }

    /**
     * Optional. Minimum core count per node.
     *
     * Generated from protobuf field <code>int32 min_core_count_per_node = 10 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setMinCoreCountPerNode($var)
    {
        GPBUtil::checkInt32($var);
        $this->min_core_count_per_node = $var;

        return $this;
    }

    /**
     * Optional. Minimum memory per node in gigabytes.
     *
     * Generated from protobuf field <code>int32 min_memory_per_node_gb = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getMinMemoryPerNodeGb()
    {
        return $this->min_memory_per_node_gb;
    }

    /**
     * Optional. Minimum memory per node in gigabytes.
     *
     * Generated from protobuf field <code>int32 min_memory_per_node_gb = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setMinMemoryPerNodeGb($var)
    {
        GPBUtil::checkInt32($var);
        $this->min_memory_per_node_gb = $var;

        return $this;
    }

    /**
     * Optional. Minimum node storage per database server in gigabytes.
     *
     * Generated from protobuf field <code>int32 min_db_node_storage_per_node_gb = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getMinDbNodeStoragePerNodeGb()
    {
        return $this->min_db_node_storage_per_node_gb;
    }

    /**
     * Optional. Minimum node storage per database server in gigabytes.
     *
     * Generated from protobuf field <code>int32 min_db_node_storage_per_node_gb = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setMinDbNodeStoragePerNodeGb($var)
    {
        GPBUtil::checkInt32($var);
        $this->min_db_node_storage_per_node_gb = $var;

        return $this;
    }

}

