<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/oracledatabase/v1/oracledatabase.proto

namespace Google\Cloud\OracleDatabase\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request for `AutonomousDatabaseCharacterSet.List`.
 *
 * Generated from protobuf message <code>google.cloud.oracledatabase.v1.ListAutonomousDatabaseCharacterSetsRequest</code>
 */
class ListAutonomousDatabaseCharacterSetsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent value for the Autonomous Database in the following
     * format: projects/{project}/locations/{location}.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. The maximum number of items to return.
     * If unspecified, at most 50 Autonomous DB Character Sets will be returned.
     * The maximum value is 1000; values above 1000 will be coerced to 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. A token identifying a page of results the server should return.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';
    /**
     * Optional. An expression for filtering the results of the request. Only the
     * **character_set_type** field is supported in the following format:
     * `character_set_type="{characterSetType}"`. Accepted values include
     * `DATABASE` and `NATIONAL`.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $filter = '';

    /**
     * @param string $parent Required. The parent value for the Autonomous Database in the following
     *                       format: projects/{project}/locations/{location}. Please see
     *                       {@see OracleDatabaseClient::locationName()} for help formatting this field.
     *
     * @return \Google\Cloud\OracleDatabase\V1\ListAutonomousDatabaseCharacterSetsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent value for the Autonomous Database in the following
     *           format: projects/{project}/locations/{location}.
     *     @type int $page_size
     *           Optional. The maximum number of items to return.
     *           If unspecified, at most 50 Autonomous DB Character Sets will be returned.
     *           The maximum value is 1000; values above 1000 will be coerced to 1000.
     *     @type string $page_token
     *           Optional. A token identifying a page of results the server should return.
     *     @type string $filter
     *           Optional. An expression for filtering the results of the request. Only the
     *           **character_set_type** field is supported in the following format:
     *           `character_set_type="{characterSetType}"`. Accepted values include
     *           `DATABASE` and `NATIONAL`.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Oracledatabase\V1\Oracledatabase::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent value for the Autonomous Database in the following
     * format: projects/{project}/locations/{location}.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent value for the Autonomous Database in the following
     * format: projects/{project}/locations/{location}.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. The maximum number of items to return.
     * If unspecified, at most 50 Autonomous DB Character Sets will be returned.
     * The maximum value is 1000; values above 1000 will be coerced to 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. The maximum number of items to return.
     * If unspecified, at most 50 Autonomous DB Character Sets will be returned.
     * The maximum value is 1000; values above 1000 will be coerced to 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. A token identifying a page of results the server should return.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. A token identifying a page of results the server should return.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. An expression for filtering the results of the request. Only the
     * **character_set_type** field is supported in the following format:
     * `character_set_type="{characterSetType}"`. Accepted values include
     * `DATABASE` and `NATIONAL`.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Optional. An expression for filtering the results of the request. Only the
     * **character_set_type** field is supported in the following format:
     * `character_set_type="{characterSetType}"`. Accepted values include
     * `DATABASE` and `NATIONAL`.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

}

