<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/osconfig/v1/os_policy_assignment_reports.proto

namespace Google\Cloud\OsConfig\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Get a report of the OS policy assignment for a VM instance.
 *
 * Generated from protobuf message <code>google.cloud.osconfig.v1.GetOSPolicyAssignmentReportRequest</code>
 */
class GetOSPolicyAssignmentReportRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. API resource name for OS policy assignment report.
     * Format:
     * `/projects/{project}/locations/{location}/instances/{instance}/osPolicyAssignments/{assignment}/report`
     * For `{project}`, either `project-number` or `project-id` can be provided.
     * For `{instance_id}`, either Compute Engine `instance-id` or `instance-name`
     * can be provided.
     * For `{assignment_id}`, the OSPolicyAssignment id must be provided.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';

    /**
     * @param string $name Required. API resource name for OS policy assignment report.
     *
     *                     Format:
     *                     `/projects/{project}/locations/{location}/instances/{instance}/osPolicyAssignments/{assignment}/report`
     *
     *                     For `{project}`, either `project-number` or `project-id` can be provided.
     *                     For `{instance_id}`, either Compute Engine `instance-id` or `instance-name`
     *                     can be provided.
     *                     For `{assignment_id}`, the OSPolicyAssignment id must be provided. Please see
     *                     {@see OsConfigZonalServiceClient::oSPolicyAssignmentReportName()} for help formatting this field.
     *
     * @return \Google\Cloud\OsConfig\V1\GetOSPolicyAssignmentReportRequest
     *
     * @experimental
     */
    public static function build(string $name): self
    {
        return (new self())
            ->setName($name);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. API resource name for OS policy assignment report.
     *           Format:
     *           `/projects/{project}/locations/{location}/instances/{instance}/osPolicyAssignments/{assignment}/report`
     *           For `{project}`, either `project-number` or `project-id` can be provided.
     *           For `{instance_id}`, either Compute Engine `instance-id` or `instance-name`
     *           can be provided.
     *           For `{assignment_id}`, the OSPolicyAssignment id must be provided.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Osconfig\V1\OsPolicyAssignmentReports::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. API resource name for OS policy assignment report.
     * Format:
     * `/projects/{project}/locations/{location}/instances/{instance}/osPolicyAssignments/{assignment}/report`
     * For `{project}`, either `project-number` or `project-id` can be provided.
     * For `{instance_id}`, either Compute Engine `instance-id` or `instance-name`
     * can be provided.
     * For `{assignment_id}`, the OSPolicyAssignment id must be provided.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. API resource name for OS policy assignment report.
     * Format:
     * `/projects/{project}/locations/{location}/instances/{instance}/osPolicyAssignments/{assignment}/report`
     * For `{project}`, either `project-number` or `project-id` can be provided.
     * For `{instance_id}`, either Compute Engine `instance-id` or `instance-name`
     * can be provided.
     * For `{assignment_id}`, the OSPolicyAssignment id must be provided.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

}

