<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/osconfig/v1/inventory.proto

namespace Google\Cloud\OsConfig\V1\Inventory;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Contains information about a Windows application that is retrieved from the
 * Windows Registry. For more information about these fields, see:
 * https://docs.microsoft.com/en-us/windows/win32/msi/uninstall-registry-key
 *
 * Generated from protobuf message <code>google.cloud.osconfig.v1.Inventory.WindowsApplication</code>
 */
class WindowsApplication extends \Google\Protobuf\Internal\Message
{
    /**
     * The name of the application or product.
     *
     * Generated from protobuf field <code>string display_name = 1;</code>
     */
    protected $display_name = '';
    /**
     * The version of the product or application in string format.
     *
     * Generated from protobuf field <code>string display_version = 2;</code>
     */
    protected $display_version = '';
    /**
     * The name of the manufacturer for the product or application.
     *
     * Generated from protobuf field <code>string publisher = 3;</code>
     */
    protected $publisher = '';
    /**
     * The last time this product received service. The value of this property
     * is replaced each time a patch is applied or removed from the product or
     * the command-line option is used to repair the product.
     *
     * Generated from protobuf field <code>.google.type.Date install_date = 4;</code>
     */
    protected $install_date = null;
    /**
     * The internet address for technical support.
     *
     * Generated from protobuf field <code>string help_link = 5;</code>
     */
    protected $help_link = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $display_name
     *           The name of the application or product.
     *     @type string $display_version
     *           The version of the product or application in string format.
     *     @type string $publisher
     *           The name of the manufacturer for the product or application.
     *     @type \Google\Type\Date $install_date
     *           The last time this product received service. The value of this property
     *           is replaced each time a patch is applied or removed from the product or
     *           the command-line option is used to repair the product.
     *     @type string $help_link
     *           The internet address for technical support.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Osconfig\V1\Inventory::initOnce();
        parent::__construct($data);
    }

    /**
     * The name of the application or product.
     *
     * Generated from protobuf field <code>string display_name = 1;</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * The name of the application or product.
     *
     * Generated from protobuf field <code>string display_name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * The version of the product or application in string format.
     *
     * Generated from protobuf field <code>string display_version = 2;</code>
     * @return string
     */
    public function getDisplayVersion()
    {
        return $this->display_version;
    }

    /**
     * The version of the product or application in string format.
     *
     * Generated from protobuf field <code>string display_version = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_version = $var;

        return $this;
    }

    /**
     * The name of the manufacturer for the product or application.
     *
     * Generated from protobuf field <code>string publisher = 3;</code>
     * @return string
     */
    public function getPublisher()
    {
        return $this->publisher;
    }

    /**
     * The name of the manufacturer for the product or application.
     *
     * Generated from protobuf field <code>string publisher = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPublisher($var)
    {
        GPBUtil::checkString($var, True);
        $this->publisher = $var;

        return $this;
    }

    /**
     * The last time this product received service. The value of this property
     * is replaced each time a patch is applied or removed from the product or
     * the command-line option is used to repair the product.
     *
     * Generated from protobuf field <code>.google.type.Date install_date = 4;</code>
     * @return \Google\Type\Date|null
     */
    public function getInstallDate()
    {
        return $this->install_date;
    }

    public function hasInstallDate()
    {
        return isset($this->install_date);
    }

    public function clearInstallDate()
    {
        unset($this->install_date);
    }

    /**
     * The last time this product received service. The value of this property
     * is replaced each time a patch is applied or removed from the product or
     * the command-line option is used to repair the product.
     *
     * Generated from protobuf field <code>.google.type.Date install_date = 4;</code>
     * @param \Google\Type\Date $var
     * @return $this
     */
    public function setInstallDate($var)
    {
        GPBUtil::checkMessage($var, \Google\Type\Date::class);
        $this->install_date = $var;

        return $this;
    }

    /**
     * The internet address for technical support.
     *
     * Generated from protobuf field <code>string help_link = 5;</code>
     * @return string
     */
    public function getHelpLink()
    {
        return $this->help_link;
    }

    /**
     * The internet address for technical support.
     *
     * Generated from protobuf field <code>string help_link = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setHelpLink($var)
    {
        GPBUtil::checkString($var, True);
        $this->help_link = $var;

        return $this;
    }

}


