<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/osconfig/v1/inventory.proto

namespace Google\Cloud\OsConfig\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A request message for listing inventory data for all VMs in the specified
 * location.
 *
 * Generated from protobuf message <code>google.cloud.osconfig.v1.ListInventoriesRequest</code>
 */
class ListInventoriesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent resource name.
     * Format: `projects/{project}/locations/{location}/instances/-`
     * For `{project}`, either `project-number` or `project-id` can be provided.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Inventory view indicating what information should be included in the
     * inventory resource. If unspecified, the default view is BASIC.
     *
     * Generated from protobuf field <code>.google.cloud.osconfig.v1.InventoryView view = 2;</code>
     */
    protected $view = 0;
    /**
     * The maximum number of results to return.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     */
    protected $page_size = 0;
    /**
     * A pagination token returned from a previous call to
     * `ListInventories` that indicates where this listing
     * should continue from.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     */
    protected $page_token = '';
    /**
     * If provided, this field specifies the criteria that must be met by a
     * `Inventory` API resource to be included in the response.
     *
     * Generated from protobuf field <code>string filter = 5;</code>
     */
    protected $filter = '';

    /**
     * @param string $parent Required. The parent resource name.
     *
     *                       Format: `projects/{project}/locations/{location}/instances/-`
     *
     *                       For `{project}`, either `project-number` or `project-id` can be provided. Please see
     *                       {@see OsConfigZonalServiceClient::instanceName()} for help formatting this field.
     *
     * @return \Google\Cloud\OsConfig\V1\ListInventoriesRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent resource name.
     *           Format: `projects/{project}/locations/{location}/instances/-`
     *           For `{project}`, either `project-number` or `project-id` can be provided.
     *     @type int $view
     *           Inventory view indicating what information should be included in the
     *           inventory resource. If unspecified, the default view is BASIC.
     *     @type int $page_size
     *           The maximum number of results to return.
     *     @type string $page_token
     *           A pagination token returned from a previous call to
     *           `ListInventories` that indicates where this listing
     *           should continue from.
     *     @type string $filter
     *           If provided, this field specifies the criteria that must be met by a
     *           `Inventory` API resource to be included in the response.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Osconfig\V1\Inventory::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent resource name.
     * Format: `projects/{project}/locations/{location}/instances/-`
     * For `{project}`, either `project-number` or `project-id` can be provided.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent resource name.
     * Format: `projects/{project}/locations/{location}/instances/-`
     * For `{project}`, either `project-number` or `project-id` can be provided.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Inventory view indicating what information should be included in the
     * inventory resource. If unspecified, the default view is BASIC.
     *
     * Generated from protobuf field <code>.google.cloud.osconfig.v1.InventoryView view = 2;</code>
     * @return int
     */
    public function getView()
    {
        return $this->view;
    }

    /**
     * Inventory view indicating what information should be included in the
     * inventory resource. If unspecified, the default view is BASIC.
     *
     * Generated from protobuf field <code>.google.cloud.osconfig.v1.InventoryView view = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setView($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\OsConfig\V1\InventoryView::class);
        $this->view = $var;

        return $this;
    }

    /**
     * The maximum number of results to return.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The maximum number of results to return.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * A pagination token returned from a previous call to
     * `ListInventories` that indicates where this listing
     * should continue from.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * A pagination token returned from a previous call to
     * `ListInventories` that indicates where this listing
     * should continue from.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * If provided, this field specifies the criteria that must be met by a
     * `Inventory` API resource to be included in the response.
     *
     * Generated from protobuf field <code>string filter = 5;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * If provided, this field specifies the criteria that must be met by a
     * `Inventory` API resource to be included in the response.
     *
     * Generated from protobuf field <code>string filter = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

}

