<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/policysimulator/v1/simulator.proto

namespace Google\Cloud\PolicySimulator\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A summary and comparison of the principal's access under the current
 * (baseline) policies and the proposed (simulated) policies for a single
 * access tuple.
 *
 * Generated from protobuf message <code>google.cloud.policysimulator.v1.AccessStateDiff</code>
 */
class AccessStateDiff extends \Google\Protobuf\Internal\Message
{
    /**
     * The results of evaluating the access tuple under the current (baseline)
     * policies.
     * If the [AccessState][google.cloud.policysimulator.v1.AccessState] couldn't
     * be fully evaluated, this field explains why.
     *
     * Generated from protobuf field <code>.google.cloud.policysimulator.v1.ExplainedAccess baseline = 1;</code>
     */
    protected $baseline = null;
    /**
     * The results of evaluating the access tuple under the proposed (simulated)
     * policies.
     * If the AccessState couldn't be fully evaluated, this field explains why.
     *
     * Generated from protobuf field <code>.google.cloud.policysimulator.v1.ExplainedAccess simulated = 2;</code>
     */
    protected $simulated = null;
    /**
     * How the principal's access, specified in the AccessState field, changed
     * between the current (baseline) policies and proposed (simulated) policies.
     *
     * Generated from protobuf field <code>.google.cloud.policysimulator.v1.AccessStateDiff.AccessChangeType access_change = 3;</code>
     */
    protected $access_change = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\PolicySimulator\V1\ExplainedAccess $baseline
     *           The results of evaluating the access tuple under the current (baseline)
     *           policies.
     *           If the [AccessState][google.cloud.policysimulator.v1.AccessState] couldn't
     *           be fully evaluated, this field explains why.
     *     @type \Google\Cloud\PolicySimulator\V1\ExplainedAccess $simulated
     *           The results of evaluating the access tuple under the proposed (simulated)
     *           policies.
     *           If the AccessState couldn't be fully evaluated, this field explains why.
     *     @type int $access_change
     *           How the principal's access, specified in the AccessState field, changed
     *           between the current (baseline) policies and proposed (simulated) policies.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Policysimulator\V1\Simulator::initOnce();
        parent::__construct($data);
    }

    /**
     * The results of evaluating the access tuple under the current (baseline)
     * policies.
     * If the [AccessState][google.cloud.policysimulator.v1.AccessState] couldn't
     * be fully evaluated, this field explains why.
     *
     * Generated from protobuf field <code>.google.cloud.policysimulator.v1.ExplainedAccess baseline = 1;</code>
     * @return \Google\Cloud\PolicySimulator\V1\ExplainedAccess|null
     */
    public function getBaseline()
    {
        return $this->baseline;
    }

    public function hasBaseline()
    {
        return isset($this->baseline);
    }

    public function clearBaseline()
    {
        unset($this->baseline);
    }

    /**
     * The results of evaluating the access tuple under the current (baseline)
     * policies.
     * If the [AccessState][google.cloud.policysimulator.v1.AccessState] couldn't
     * be fully evaluated, this field explains why.
     *
     * Generated from protobuf field <code>.google.cloud.policysimulator.v1.ExplainedAccess baseline = 1;</code>
     * @param \Google\Cloud\PolicySimulator\V1\ExplainedAccess $var
     * @return $this
     */
    public function setBaseline($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\PolicySimulator\V1\ExplainedAccess::class);
        $this->baseline = $var;

        return $this;
    }

    /**
     * The results of evaluating the access tuple under the proposed (simulated)
     * policies.
     * If the AccessState couldn't be fully evaluated, this field explains why.
     *
     * Generated from protobuf field <code>.google.cloud.policysimulator.v1.ExplainedAccess simulated = 2;</code>
     * @return \Google\Cloud\PolicySimulator\V1\ExplainedAccess|null
     */
    public function getSimulated()
    {
        return $this->simulated;
    }

    public function hasSimulated()
    {
        return isset($this->simulated);
    }

    public function clearSimulated()
    {
        unset($this->simulated);
    }

    /**
     * The results of evaluating the access tuple under the proposed (simulated)
     * policies.
     * If the AccessState couldn't be fully evaluated, this field explains why.
     *
     * Generated from protobuf field <code>.google.cloud.policysimulator.v1.ExplainedAccess simulated = 2;</code>
     * @param \Google\Cloud\PolicySimulator\V1\ExplainedAccess $var
     * @return $this
     */
    public function setSimulated($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\PolicySimulator\V1\ExplainedAccess::class);
        $this->simulated = $var;

        return $this;
    }

    /**
     * How the principal's access, specified in the AccessState field, changed
     * between the current (baseline) policies and proposed (simulated) policies.
     *
     * Generated from protobuf field <code>.google.cloud.policysimulator.v1.AccessStateDiff.AccessChangeType access_change = 3;</code>
     * @return int
     */
    public function getAccessChange()
    {
        return $this->access_change;
    }

    /**
     * How the principal's access, specified in the AccessState field, changed
     * between the current (baseline) policies and proposed (simulated) policies.
     *
     * Generated from protobuf field <code>.google.cloud.policysimulator.v1.AccessStateDiff.AccessChangeType access_change = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setAccessChange($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\PolicySimulator\V1\AccessStateDiff\AccessChangeType::class);
        $this->access_change = $var;

        return $this;
    }

}

