<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/policysimulator/v1/simulator.proto

namespace Google\Cloud\PolicySimulator\V1\AccessStateDiff;

use UnexpectedValueException;

/**
 * How the principal's access, specified in the AccessState field, changed
 * between the current (baseline) policies and proposed (simulated) policies.
 *
 * Protobuf type <code>google.cloud.policysimulator.v1.AccessStateDiff.AccessChangeType</code>
 */
class AccessChangeType
{
    /**
     * Default value. This value is unused.
     *
     * Generated from protobuf enum <code>ACCESS_CHANGE_TYPE_UNSPECIFIED = 0;</code>
     */
    const ACCESS_CHANGE_TYPE_UNSPECIFIED = 0;
    /**
     * The principal's access did not change.
     * This includes the case where both baseline and simulated are UNKNOWN,
     * but the unknown information is equivalent.
     *
     * Generated from protobuf enum <code>NO_CHANGE = 1;</code>
     */
    const NO_CHANGE = 1;
    /**
     * The principal's access under both the current policies and the proposed
     * policies is `UNKNOWN`, but the unknown information differs between them.
     *
     * Generated from protobuf enum <code>UNKNOWN_CHANGE = 2;</code>
     */
    const UNKNOWN_CHANGE = 2;
    /**
     * The principal had access under the current policies (`GRANTED`), but will
     * no longer have access after the proposed changes (`NOT_GRANTED`).
     *
     * Generated from protobuf enum <code>ACCESS_REVOKED = 3;</code>
     */
    const ACCESS_REVOKED = 3;
    /**
     * The principal did not have access under the current policies
     * (`NOT_GRANTED`), but will have access after the proposed changes
     * (`GRANTED`).
     *
     * Generated from protobuf enum <code>ACCESS_GAINED = 4;</code>
     */
    const ACCESS_GAINED = 4;
    /**
     * This result can occur for the following reasons:
     * * The principal had access under the current policies (`GRANTED`), but
     *   their access after the proposed changes is `UNKNOWN`.
     * * The principal's access under the current policies is `UNKNOWN`, but
     * they
     *   will not have access after the proposed changes (`NOT_GRANTED`).
     *
     * Generated from protobuf enum <code>ACCESS_MAYBE_REVOKED = 5;</code>
     */
    const ACCESS_MAYBE_REVOKED = 5;
    /**
     * This result can occur for the following reasons:
     * * The principal did not have access under the current policies
     *   (`NOT_GRANTED`), but their access after the proposed changes is
     *   `UNKNOWN`.
     * * The principal's access under the current policies is `UNKNOWN`, but
     * they will have access after the proposed changes (`GRANTED`).
     *
     * Generated from protobuf enum <code>ACCESS_MAYBE_GAINED = 6;</code>
     */
    const ACCESS_MAYBE_GAINED = 6;

    private static $valueToName = [
        self::ACCESS_CHANGE_TYPE_UNSPECIFIED => 'ACCESS_CHANGE_TYPE_UNSPECIFIED',
        self::NO_CHANGE => 'NO_CHANGE',
        self::UNKNOWN_CHANGE => 'UNKNOWN_CHANGE',
        self::ACCESS_REVOKED => 'ACCESS_REVOKED',
        self::ACCESS_GAINED => 'ACCESS_GAINED',
        self::ACCESS_MAYBE_REVOKED => 'ACCESS_MAYBE_REVOKED',
        self::ACCESS_MAYBE_GAINED => 'ACCESS_MAYBE_GAINED',
    ];

    public static function name($value)
    {
        if (!isset(self::$valueToName[$value])) {
            throw new UnexpectedValueException(sprintf(
                    'Enum %s has no name defined for value %s', __CLASS__, $value));
        }
        return self::$valueToName[$value];
    }


    public static function value($name)
    {
        $const = __CLASS__ . '::' . strtoupper($name);
        if (!defined($const)) {
            throw new UnexpectedValueException(sprintf(
                    'Enum %s has no value defined for name %s', __CLASS__, $name));
        }
        return constant($const);
    }
}


