<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/policysimulator/v1/simulator.proto

namespace Google\Cloud\PolicySimulator\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Details about how a set of policies, listed in
 * [ExplainedPolicy][google.cloud.policysimulator.v1.ExplainedPolicy], resulted
 * in a certain [AccessState][google.cloud.policysimulator.v1.AccessState] when
 * replaying an access tuple.
 *
 * Generated from protobuf message <code>google.cloud.policysimulator.v1.ExplainedAccess</code>
 */
class ExplainedAccess extends \Google\Protobuf\Internal\Message
{
    /**
     * Whether the principal in the access tuple has permission to access the
     * resource in the access tuple under the given policies.
     *
     * Generated from protobuf field <code>.google.cloud.policysimulator.v1.AccessState access_state = 1;</code>
     */
    protected $access_state = 0;
    /**
     * If the [AccessState][google.cloud.policysimulator.v1.AccessState] is
     * `UNKNOWN`, this field contains the policies that led to that result.
     * If the `AccessState` is `GRANTED` or `NOT_GRANTED`, this field is
     * omitted.
     *
     * Generated from protobuf field <code>repeated .google.cloud.policysimulator.v1.ExplainedPolicy policies = 2;</code>
     */
    private $policies;
    /**
     * If the [AccessState][google.cloud.policysimulator.v1.AccessState] is
     * `UNKNOWN`, this field contains a list of errors explaining why the result
     * is `UNKNOWN`.
     * If the `AccessState` is `GRANTED` or `NOT_GRANTED`, this field is
     * omitted.
     *
     * Generated from protobuf field <code>repeated .google.rpc.Status errors = 3;</code>
     */
    private $errors;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int $access_state
     *           Whether the principal in the access tuple has permission to access the
     *           resource in the access tuple under the given policies.
     *     @type array<\Google\Cloud\PolicySimulator\V1\ExplainedPolicy>|\Google\Protobuf\Internal\RepeatedField $policies
     *           If the [AccessState][google.cloud.policysimulator.v1.AccessState] is
     *           `UNKNOWN`, this field contains the policies that led to that result.
     *           If the `AccessState` is `GRANTED` or `NOT_GRANTED`, this field is
     *           omitted.
     *     @type array<\Google\Rpc\Status>|\Google\Protobuf\Internal\RepeatedField $errors
     *           If the [AccessState][google.cloud.policysimulator.v1.AccessState] is
     *           `UNKNOWN`, this field contains a list of errors explaining why the result
     *           is `UNKNOWN`.
     *           If the `AccessState` is `GRANTED` or `NOT_GRANTED`, this field is
     *           omitted.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Policysimulator\V1\Simulator::initOnce();
        parent::__construct($data);
    }

    /**
     * Whether the principal in the access tuple has permission to access the
     * resource in the access tuple under the given policies.
     *
     * Generated from protobuf field <code>.google.cloud.policysimulator.v1.AccessState access_state = 1;</code>
     * @return int
     */
    public function getAccessState()
    {
        return $this->access_state;
    }

    /**
     * Whether the principal in the access tuple has permission to access the
     * resource in the access tuple under the given policies.
     *
     * Generated from protobuf field <code>.google.cloud.policysimulator.v1.AccessState access_state = 1;</code>
     * @param int $var
     * @return $this
     */
    public function setAccessState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\PolicySimulator\V1\AccessState::class);
        $this->access_state = $var;

        return $this;
    }

    /**
     * If the [AccessState][google.cloud.policysimulator.v1.AccessState] is
     * `UNKNOWN`, this field contains the policies that led to that result.
     * If the `AccessState` is `GRANTED` or `NOT_GRANTED`, this field is
     * omitted.
     *
     * Generated from protobuf field <code>repeated .google.cloud.policysimulator.v1.ExplainedPolicy policies = 2;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getPolicies()
    {
        return $this->policies;
    }

    /**
     * If the [AccessState][google.cloud.policysimulator.v1.AccessState] is
     * `UNKNOWN`, this field contains the policies that led to that result.
     * If the `AccessState` is `GRANTED` or `NOT_GRANTED`, this field is
     * omitted.
     *
     * Generated from protobuf field <code>repeated .google.cloud.policysimulator.v1.ExplainedPolicy policies = 2;</code>
     * @param array<\Google\Cloud\PolicySimulator\V1\ExplainedPolicy>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setPolicies($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\PolicySimulator\V1\ExplainedPolicy::class);
        $this->policies = $arr;

        return $this;
    }

    /**
     * If the [AccessState][google.cloud.policysimulator.v1.AccessState] is
     * `UNKNOWN`, this field contains a list of errors explaining why the result
     * is `UNKNOWN`.
     * If the `AccessState` is `GRANTED` or `NOT_GRANTED`, this field is
     * omitted.
     *
     * Generated from protobuf field <code>repeated .google.rpc.Status errors = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getErrors()
    {
        return $this->errors;
    }

    /**
     * If the [AccessState][google.cloud.policysimulator.v1.AccessState] is
     * `UNKNOWN`, this field contains a list of errors explaining why the result
     * is `UNKNOWN`.
     * If the `AccessState` is `GRANTED` or `NOT_GRANTED`, this field is
     * omitted.
     *
     * Generated from protobuf field <code>repeated .google.rpc.Status errors = 3;</code>
     * @param array<\Google\Rpc\Status>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setErrors($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Rpc\Status::class);
        $this->errors = $arr;

        return $this;
    }

}

