<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/policytroubleshooter/iam/v3/troubleshooter.proto

namespace Google\Cloud\PolicyTroubleshooter\Iam\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Details about how the relevant IAM allow policies affect the final access
 * state.
 *
 * Generated from protobuf message <code>google.cloud.policytroubleshooter.iam.v3.AllowPolicyExplanation</code>
 */
class AllowPolicyExplanation extends \Google\Protobuf\Internal\Message
{
    /**
     * Indicates whether the principal has the specified permission for the
     * specified resource, based on evaluating all applicable IAM allow policies.
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.AllowAccessState allow_access_state = 1;</code>
     */
    protected $allow_access_state = 0;
    /**
     * List of IAM allow policies that were evaluated to check the principal's
     * permissions, with annotations to indicate how each policy contributed to
     * the final result.
     * The list of policies includes the policy for the resource itself, as well
     * as allow policies that are inherited from higher levels of the resource
     * hierarchy, including the organization, the folder, and the project.
     * To learn more about the resource hierarchy, see
     * https://cloud.google.com/iam/help/resource-hierarchy.
     *
     * Generated from protobuf field <code>repeated .google.cloud.policytroubleshooter.iam.v3.ExplainedAllowPolicy explained_policies = 2;</code>
     */
    private $explained_policies;
    /**
     * The relevance of the allow policy type to the overall access state.
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.HeuristicRelevance relevance = 3;</code>
     */
    protected $relevance = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int $allow_access_state
     *           Indicates whether the principal has the specified permission for the
     *           specified resource, based on evaluating all applicable IAM allow policies.
     *     @type array<\Google\Cloud\PolicyTroubleshooter\Iam\V3\ExplainedAllowPolicy>|\Google\Protobuf\Internal\RepeatedField $explained_policies
     *           List of IAM allow policies that were evaluated to check the principal's
     *           permissions, with annotations to indicate how each policy contributed to
     *           the final result.
     *           The list of policies includes the policy for the resource itself, as well
     *           as allow policies that are inherited from higher levels of the resource
     *           hierarchy, including the organization, the folder, and the project.
     *           To learn more about the resource hierarchy, see
     *           https://cloud.google.com/iam/help/resource-hierarchy.
     *     @type int $relevance
     *           The relevance of the allow policy type to the overall access state.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Policytroubleshooter\Iam\V3\Troubleshooter::initOnce();
        parent::__construct($data);
    }

    /**
     * Indicates whether the principal has the specified permission for the
     * specified resource, based on evaluating all applicable IAM allow policies.
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.AllowAccessState allow_access_state = 1;</code>
     * @return int
     */
    public function getAllowAccessState()
    {
        return $this->allow_access_state;
    }

    /**
     * Indicates whether the principal has the specified permission for the
     * specified resource, based on evaluating all applicable IAM allow policies.
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.AllowAccessState allow_access_state = 1;</code>
     * @param int $var
     * @return $this
     */
    public function setAllowAccessState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\PolicyTroubleshooter\Iam\V3\AllowAccessState::class);
        $this->allow_access_state = $var;

        return $this;
    }

    /**
     * List of IAM allow policies that were evaluated to check the principal's
     * permissions, with annotations to indicate how each policy contributed to
     * the final result.
     * The list of policies includes the policy for the resource itself, as well
     * as allow policies that are inherited from higher levels of the resource
     * hierarchy, including the organization, the folder, and the project.
     * To learn more about the resource hierarchy, see
     * https://cloud.google.com/iam/help/resource-hierarchy.
     *
     * Generated from protobuf field <code>repeated .google.cloud.policytroubleshooter.iam.v3.ExplainedAllowPolicy explained_policies = 2;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getExplainedPolicies()
    {
        return $this->explained_policies;
    }

    /**
     * List of IAM allow policies that were evaluated to check the principal's
     * permissions, with annotations to indicate how each policy contributed to
     * the final result.
     * The list of policies includes the policy for the resource itself, as well
     * as allow policies that are inherited from higher levels of the resource
     * hierarchy, including the organization, the folder, and the project.
     * To learn more about the resource hierarchy, see
     * https://cloud.google.com/iam/help/resource-hierarchy.
     *
     * Generated from protobuf field <code>repeated .google.cloud.policytroubleshooter.iam.v3.ExplainedAllowPolicy explained_policies = 2;</code>
     * @param array<\Google\Cloud\PolicyTroubleshooter\Iam\V3\ExplainedAllowPolicy>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setExplainedPolicies($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\PolicyTroubleshooter\Iam\V3\ExplainedAllowPolicy::class);
        $this->explained_policies = $arr;

        return $this;
    }

    /**
     * The relevance of the allow policy type to the overall access state.
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.HeuristicRelevance relevance = 3;</code>
     * @return int
     */
    public function getRelevance()
    {
        return $this->relevance;
    }

    /**
     * The relevance of the allow policy type to the overall access state.
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.HeuristicRelevance relevance = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setRelevance($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\PolicyTroubleshooter\Iam\V3\HeuristicRelevance::class);
        $this->relevance = $var;

        return $this;
    }

}

