<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/policytroubleshooter/iam/v3/troubleshooter.proto

namespace Google\Cloud\PolicyTroubleshooter\Iam\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Additional context for troubleshooting conditional role bindings and deny
 * rules.
 *
 * Generated from protobuf message <code>google.cloud.policytroubleshooter.iam.v3.ConditionContext</code>
 */
class ConditionContext extends \Google\Protobuf\Internal\Message
{
    /**
     * Represents a target resource that is involved with a network activity.
     * If multiple resources are involved with an activity, this must be the
     * primary one.
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.ConditionContext.Resource resource = 1;</code>
     */
    protected $resource = null;
    /**
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi-hop network activity, the destination represents the receiver of
     * the last hop.
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.ConditionContext.Peer destination = 2;</code>
     */
    protected $destination = null;
    /**
     * Represents a network request, such as an HTTP request.
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.ConditionContext.Request request = 3;</code>
     */
    protected $request = null;
    /**
     * Output only. The effective tags on the resource. The effective tags are
     * fetched during troubleshooting.
     *
     * Generated from protobuf field <code>repeated .google.cloud.policytroubleshooter.iam.v3.ConditionContext.EffectiveTag effective_tags = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $effective_tags;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\PolicyTroubleshooter\Iam\V3\ConditionContext\Resource $resource
     *           Represents a target resource that is involved with a network activity.
     *           If multiple resources are involved with an activity, this must be the
     *           primary one.
     *     @type \Google\Cloud\PolicyTroubleshooter\Iam\V3\ConditionContext\Peer $destination
     *           The destination of a network activity, such as accepting a TCP connection.
     *           In a multi-hop network activity, the destination represents the receiver of
     *           the last hop.
     *     @type \Google\Cloud\PolicyTroubleshooter\Iam\V3\ConditionContext\Request $request
     *           Represents a network request, such as an HTTP request.
     *     @type array<\Google\Cloud\PolicyTroubleshooter\Iam\V3\ConditionContext\EffectiveTag>|\Google\Protobuf\Internal\RepeatedField $effective_tags
     *           Output only. The effective tags on the resource. The effective tags are
     *           fetched during troubleshooting.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Policytroubleshooter\Iam\V3\Troubleshooter::initOnce();
        parent::__construct($data);
    }

    /**
     * Represents a target resource that is involved with a network activity.
     * If multiple resources are involved with an activity, this must be the
     * primary one.
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.ConditionContext.Resource resource = 1;</code>
     * @return \Google\Cloud\PolicyTroubleshooter\Iam\V3\ConditionContext\Resource|null
     */
    public function getResource()
    {
        return $this->resource;
    }

    public function hasResource()
    {
        return isset($this->resource);
    }

    public function clearResource()
    {
        unset($this->resource);
    }

    /**
     * Represents a target resource that is involved with a network activity.
     * If multiple resources are involved with an activity, this must be the
     * primary one.
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.ConditionContext.Resource resource = 1;</code>
     * @param \Google\Cloud\PolicyTroubleshooter\Iam\V3\ConditionContext\Resource $var
     * @return $this
     */
    public function setResource($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\PolicyTroubleshooter\Iam\V3\ConditionContext\Resource::class);
        $this->resource = $var;

        return $this;
    }

    /**
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi-hop network activity, the destination represents the receiver of
     * the last hop.
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.ConditionContext.Peer destination = 2;</code>
     * @return \Google\Cloud\PolicyTroubleshooter\Iam\V3\ConditionContext\Peer|null
     */
    public function getDestination()
    {
        return $this->destination;
    }

    public function hasDestination()
    {
        return isset($this->destination);
    }

    public function clearDestination()
    {
        unset($this->destination);
    }

    /**
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi-hop network activity, the destination represents the receiver of
     * the last hop.
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.ConditionContext.Peer destination = 2;</code>
     * @param \Google\Cloud\PolicyTroubleshooter\Iam\V3\ConditionContext\Peer $var
     * @return $this
     */
    public function setDestination($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\PolicyTroubleshooter\Iam\V3\ConditionContext\Peer::class);
        $this->destination = $var;

        return $this;
    }

    /**
     * Represents a network request, such as an HTTP request.
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.ConditionContext.Request request = 3;</code>
     * @return \Google\Cloud\PolicyTroubleshooter\Iam\V3\ConditionContext\Request|null
     */
    public function getRequest()
    {
        return $this->request;
    }

    public function hasRequest()
    {
        return isset($this->request);
    }

    public function clearRequest()
    {
        unset($this->request);
    }

    /**
     * Represents a network request, such as an HTTP request.
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.ConditionContext.Request request = 3;</code>
     * @param \Google\Cloud\PolicyTroubleshooter\Iam\V3\ConditionContext\Request $var
     * @return $this
     */
    public function setRequest($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\PolicyTroubleshooter\Iam\V3\ConditionContext\Request::class);
        $this->request = $var;

        return $this;
    }

    /**
     * Output only. The effective tags on the resource. The effective tags are
     * fetched during troubleshooting.
     *
     * Generated from protobuf field <code>repeated .google.cloud.policytroubleshooter.iam.v3.ConditionContext.EffectiveTag effective_tags = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getEffectiveTags()
    {
        return $this->effective_tags;
    }

    /**
     * Output only. The effective tags on the resource. The effective tags are
     * fetched during troubleshooting.
     *
     * Generated from protobuf field <code>repeated .google.cloud.policytroubleshooter.iam.v3.ConditionContext.EffectiveTag effective_tags = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param array<\Google\Cloud\PolicyTroubleshooter\Iam\V3\ConditionContext\EffectiveTag>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setEffectiveTags($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\PolicyTroubleshooter\Iam\V3\ConditionContext\EffectiveTag::class);
        $this->effective_tags = $arr;

        return $this;
    }

}

