<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/policytroubleshooter/iam/v3/troubleshooter.proto

namespace Google\Cloud\PolicyTroubleshooter\Iam\V3\ConditionContext;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A tag that applies to a resource during policy evaluation. Tags can be
 * either directly bound to a resource or inherited from its ancestor.
 * `EffectiveTag` contains the `name` and `namespaced_name` of the tag value
 * and tag key, with additional fields of `inherited` to indicate the
 * inheritance status of the effective tag.
 *
 * Generated from protobuf message <code>google.cloud.policytroubleshooter.iam.v3.ConditionContext.EffectiveTag</code>
 */
class EffectiveTag extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. Resource name for TagValue in the format `tagValues/456`.
     *
     * Generated from protobuf field <code>string tag_value = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $tag_value = '';
    /**
     * Output only. The namespaced name of the TagValue. Can be in the form
     * `{organization_id}/{tag_key_short_name}/{tag_value_short_name}` or
     * `{project_id}/{tag_key_short_name}/{tag_value_short_name}` or
     * `{project_number}/{tag_key_short_name}/{tag_value_short_name}`.
     *
     * Generated from protobuf field <code>string namespaced_tag_value = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $namespaced_tag_value = '';
    /**
     * Output only. The name of the TagKey, in the format `tagKeys/{id}`, such
     * as `tagKeys/123`.
     *
     * Generated from protobuf field <code>string tag_key = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $tag_key = '';
    /**
     * Output only. The namespaced name of the TagKey. Can be in the form
     * `{organization_id}/{tag_key_short_name}` or
     * `{project_id}/{tag_key_short_name}` or
     * `{project_number}/{tag_key_short_name}`.
     *
     * Generated from protobuf field <code>string namespaced_tag_key = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $namespaced_tag_key = '';
    /**
     * The parent name of the tag key.
     * Must be in the format `organizations/{organization_id}` or
     * `projects/{project_number}`
     *
     * Generated from protobuf field <code>string tag_key_parent_name = 6;</code>
     */
    protected $tag_key_parent_name = '';
    /**
     * Output only. Indicates the inheritance status of a tag value
     * attached to the given resource. If the tag value is inherited from one of
     * the resource's ancestors, inherited will be true. If false, then the tag
     * value is directly attached to the resource, inherited will be false.
     *
     * Generated from protobuf field <code>bool inherited = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $inherited = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $tag_value
     *           Output only. Resource name for TagValue in the format `tagValues/456`.
     *     @type string $namespaced_tag_value
     *           Output only. The namespaced name of the TagValue. Can be in the form
     *           `{organization_id}/{tag_key_short_name}/{tag_value_short_name}` or
     *           `{project_id}/{tag_key_short_name}/{tag_value_short_name}` or
     *           `{project_number}/{tag_key_short_name}/{tag_value_short_name}`.
     *     @type string $tag_key
     *           Output only. The name of the TagKey, in the format `tagKeys/{id}`, such
     *           as `tagKeys/123`.
     *     @type string $namespaced_tag_key
     *           Output only. The namespaced name of the TagKey. Can be in the form
     *           `{organization_id}/{tag_key_short_name}` or
     *           `{project_id}/{tag_key_short_name}` or
     *           `{project_number}/{tag_key_short_name}`.
     *     @type string $tag_key_parent_name
     *           The parent name of the tag key.
     *           Must be in the format `organizations/{organization_id}` or
     *           `projects/{project_number}`
     *     @type bool $inherited
     *           Output only. Indicates the inheritance status of a tag value
     *           attached to the given resource. If the tag value is inherited from one of
     *           the resource's ancestors, inherited will be true. If false, then the tag
     *           value is directly attached to the resource, inherited will be false.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Policytroubleshooter\Iam\V3\Troubleshooter::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. Resource name for TagValue in the format `tagValues/456`.
     *
     * Generated from protobuf field <code>string tag_value = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getTagValue()
    {
        return $this->tag_value;
    }

    /**
     * Output only. Resource name for TagValue in the format `tagValues/456`.
     *
     * Generated from protobuf field <code>string tag_value = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setTagValue($var)
    {
        GPBUtil::checkString($var, True);
        $this->tag_value = $var;

        return $this;
    }

    /**
     * Output only. The namespaced name of the TagValue. Can be in the form
     * `{organization_id}/{tag_key_short_name}/{tag_value_short_name}` or
     * `{project_id}/{tag_key_short_name}/{tag_value_short_name}` or
     * `{project_number}/{tag_key_short_name}/{tag_value_short_name}`.
     *
     * Generated from protobuf field <code>string namespaced_tag_value = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getNamespacedTagValue()
    {
        return $this->namespaced_tag_value;
    }

    /**
     * Output only. The namespaced name of the TagValue. Can be in the form
     * `{organization_id}/{tag_key_short_name}/{tag_value_short_name}` or
     * `{project_id}/{tag_key_short_name}/{tag_value_short_name}` or
     * `{project_number}/{tag_key_short_name}/{tag_value_short_name}`.
     *
     * Generated from protobuf field <code>string namespaced_tag_value = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setNamespacedTagValue($var)
    {
        GPBUtil::checkString($var, True);
        $this->namespaced_tag_value = $var;

        return $this;
    }

    /**
     * Output only. The name of the TagKey, in the format `tagKeys/{id}`, such
     * as `tagKeys/123`.
     *
     * Generated from protobuf field <code>string tag_key = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getTagKey()
    {
        return $this->tag_key;
    }

    /**
     * Output only. The name of the TagKey, in the format `tagKeys/{id}`, such
     * as `tagKeys/123`.
     *
     * Generated from protobuf field <code>string tag_key = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setTagKey($var)
    {
        GPBUtil::checkString($var, True);
        $this->tag_key = $var;

        return $this;
    }

    /**
     * Output only. The namespaced name of the TagKey. Can be in the form
     * `{organization_id}/{tag_key_short_name}` or
     * `{project_id}/{tag_key_short_name}` or
     * `{project_number}/{tag_key_short_name}`.
     *
     * Generated from protobuf field <code>string namespaced_tag_key = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getNamespacedTagKey()
    {
        return $this->namespaced_tag_key;
    }

    /**
     * Output only. The namespaced name of the TagKey. Can be in the form
     * `{organization_id}/{tag_key_short_name}` or
     * `{project_id}/{tag_key_short_name}` or
     * `{project_number}/{tag_key_short_name}`.
     *
     * Generated from protobuf field <code>string namespaced_tag_key = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setNamespacedTagKey($var)
    {
        GPBUtil::checkString($var, True);
        $this->namespaced_tag_key = $var;

        return $this;
    }

    /**
     * The parent name of the tag key.
     * Must be in the format `organizations/{organization_id}` or
     * `projects/{project_number}`
     *
     * Generated from protobuf field <code>string tag_key_parent_name = 6;</code>
     * @return string
     */
    public function getTagKeyParentName()
    {
        return $this->tag_key_parent_name;
    }

    /**
     * The parent name of the tag key.
     * Must be in the format `organizations/{organization_id}` or
     * `projects/{project_number}`
     *
     * Generated from protobuf field <code>string tag_key_parent_name = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setTagKeyParentName($var)
    {
        GPBUtil::checkString($var, True);
        $this->tag_key_parent_name = $var;

        return $this;
    }

    /**
     * Output only. Indicates the inheritance status of a tag value
     * attached to the given resource. If the tag value is inherited from one of
     * the resource's ancestors, inherited will be true. If false, then the tag
     * value is directly attached to the resource, inherited will be false.
     *
     * Generated from protobuf field <code>bool inherited = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return bool
     */
    public function getInherited()
    {
        return $this->inherited;
    }

    /**
     * Output only. Indicates the inheritance status of a tag value
     * attached to the given resource. If the tag value is inherited from one of
     * the resource's ancestors, inherited will be true. If false, then the tag
     * value is directly attached to the resource, inherited will be false.
     *
     * Generated from protobuf field <code>bool inherited = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param bool $var
     * @return $this
     */
    public function setInherited($var)
    {
        GPBUtil::checkBool($var);
        $this->inherited = $var;

        return $this;
    }

}


