<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/policytroubleshooter/iam/v3/troubleshooter.proto

namespace Google\Cloud\PolicyTroubleshooter\Iam\V3\ConditionExplanation;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Evaluated state of a condition expression.
 *
 * Generated from protobuf message <code>google.cloud.policytroubleshooter.iam.v3.ConditionExplanation.EvaluationState</code>
 */
class EvaluationState extends \Google\Protobuf\Internal\Message
{
    /**
     * Start position of an expression in the condition, by character.
     *
     * Generated from protobuf field <code>int32 start = 1;</code>
     */
    protected $start = 0;
    /**
     * End position of an expression in the condition, by character,
     * end included, for example: the end position of the first part of
     * `a==b || c==d` would be 4.
     *
     * Generated from protobuf field <code>int32 end = 2;</code>
     */
    protected $end = 0;
    /**
     * Value of this expression.
     *
     * Generated from protobuf field <code>.google.protobuf.Value value = 3;</code>
     */
    protected $value = null;
    /**
     * Any errors that prevented complete evaluation of the condition
     * expression.
     *
     * Generated from protobuf field <code>repeated .google.rpc.Status errors = 4;</code>
     */
    private $errors;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int $start
     *           Start position of an expression in the condition, by character.
     *     @type int $end
     *           End position of an expression in the condition, by character,
     *           end included, for example: the end position of the first part of
     *           `a==b || c==d` would be 4.
     *     @type \Google\Protobuf\Value $value
     *           Value of this expression.
     *     @type array<\Google\Rpc\Status>|\Google\Protobuf\Internal\RepeatedField $errors
     *           Any errors that prevented complete evaluation of the condition
     *           expression.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Policytroubleshooter\Iam\V3\Troubleshooter::initOnce();
        parent::__construct($data);
    }

    /**
     * Start position of an expression in the condition, by character.
     *
     * Generated from protobuf field <code>int32 start = 1;</code>
     * @return int
     */
    public function getStart()
    {
        return $this->start;
    }

    /**
     * Start position of an expression in the condition, by character.
     *
     * Generated from protobuf field <code>int32 start = 1;</code>
     * @param int $var
     * @return $this
     */
    public function setStart($var)
    {
        GPBUtil::checkInt32($var);
        $this->start = $var;

        return $this;
    }

    /**
     * End position of an expression in the condition, by character,
     * end included, for example: the end position of the first part of
     * `a==b || c==d` would be 4.
     *
     * Generated from protobuf field <code>int32 end = 2;</code>
     * @return int
     */
    public function getEnd()
    {
        return $this->end;
    }

    /**
     * End position of an expression in the condition, by character,
     * end included, for example: the end position of the first part of
     * `a==b || c==d` would be 4.
     *
     * Generated from protobuf field <code>int32 end = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setEnd($var)
    {
        GPBUtil::checkInt32($var);
        $this->end = $var;

        return $this;
    }

    /**
     * Value of this expression.
     *
     * Generated from protobuf field <code>.google.protobuf.Value value = 3;</code>
     * @return \Google\Protobuf\Value|null
     */
    public function getValue()
    {
        return $this->value;
    }

    public function hasValue()
    {
        return isset($this->value);
    }

    public function clearValue()
    {
        unset($this->value);
    }

    /**
     * Value of this expression.
     *
     * Generated from protobuf field <code>.google.protobuf.Value value = 3;</code>
     * @param \Google\Protobuf\Value $var
     * @return $this
     */
    public function setValue($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Value::class);
        $this->value = $var;

        return $this;
    }

    /**
     * Any errors that prevented complete evaluation of the condition
     * expression.
     *
     * Generated from protobuf field <code>repeated .google.rpc.Status errors = 4;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getErrors()
    {
        return $this->errors;
    }

    /**
     * Any errors that prevented complete evaluation of the condition
     * expression.
     *
     * Generated from protobuf field <code>repeated .google.rpc.Status errors = 4;</code>
     * @param array<\Google\Rpc\Status>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setErrors($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Rpc\Status::class);
        $this->errors = $arr;

        return $this;
    }

}


