<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/policytroubleshooter/iam/v3/troubleshooter.proto

namespace Google\Cloud\PolicyTroubleshooter\Iam\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Details about how a specific resource contributed to the deny policy
 * evaluation.
 *
 * Generated from protobuf message <code>google.cloud.policytroubleshooter.iam.v3.ExplainedDenyResource</code>
 */
class ExplainedDenyResource extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Indicates whether any policies attached to _this resource_ deny
     * the specific permission to the specified principal for the specified
     * resource.
     * This field does _not_ indicate whether the principal actually has the
     * permission for the resource. There might be another policy that overrides
     * this policy. To determine whether the principal actually has the
     * permission, use the `overall_access_state` field in the
     * [TroubleshootIamPolicyResponse][google.cloud.policytroubleshooter.iam.v3.TroubleshootIamPolicyResponse].
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.DenyAccessState deny_access_state = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $deny_access_state = 0;
    /**
     * The full resource name that identifies the resource. For example,
     * `//compute.googleapis.com/projects/my-project/zones/us-central1-a/instances/my-instance`.
     * If the sender of the request does not have access to the policy, this field
     * is omitted.
     * For examples of full resource names for Google Cloud services, see
     * https://cloud.google.com/iam/help/troubleshooter/full-resource-names.
     *
     * Generated from protobuf field <code>string full_resource_name = 2;</code>
     */
    protected $full_resource_name = '';
    /**
     * List of IAM deny policies that were evaluated to check the principal's
     * denied permissions, with annotations to indicate how each policy
     * contributed to the final result.
     *
     * Generated from protobuf field <code>repeated .google.cloud.policytroubleshooter.iam.v3.ExplainedDenyPolicy explained_policies = 3;</code>
     */
    private $explained_policies;
    /**
     * The relevance of this policy to the overall access state in the
     * [TroubleshootIamPolicyResponse][google.cloud.policytroubleshooter.iam.v3.TroubleshootIamPolicyResponse].
     * If the sender of the request does not have access to the policy, this field
     * is omitted.
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.HeuristicRelevance relevance = 4;</code>
     */
    protected $relevance = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int $deny_access_state
     *           Required. Indicates whether any policies attached to _this resource_ deny
     *           the specific permission to the specified principal for the specified
     *           resource.
     *           This field does _not_ indicate whether the principal actually has the
     *           permission for the resource. There might be another policy that overrides
     *           this policy. To determine whether the principal actually has the
     *           permission, use the `overall_access_state` field in the
     *           [TroubleshootIamPolicyResponse][google.cloud.policytroubleshooter.iam.v3.TroubleshootIamPolicyResponse].
     *     @type string $full_resource_name
     *           The full resource name that identifies the resource. For example,
     *           `//compute.googleapis.com/projects/my-project/zones/us-central1-a/instances/my-instance`.
     *           If the sender of the request does not have access to the policy, this field
     *           is omitted.
     *           For examples of full resource names for Google Cloud services, see
     *           https://cloud.google.com/iam/help/troubleshooter/full-resource-names.
     *     @type array<\Google\Cloud\PolicyTroubleshooter\Iam\V3\ExplainedDenyPolicy>|\Google\Protobuf\Internal\RepeatedField $explained_policies
     *           List of IAM deny policies that were evaluated to check the principal's
     *           denied permissions, with annotations to indicate how each policy
     *           contributed to the final result.
     *     @type int $relevance
     *           The relevance of this policy to the overall access state in the
     *           [TroubleshootIamPolicyResponse][google.cloud.policytroubleshooter.iam.v3.TroubleshootIamPolicyResponse].
     *           If the sender of the request does not have access to the policy, this field
     *           is omitted.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Policytroubleshooter\Iam\V3\Troubleshooter::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Indicates whether any policies attached to _this resource_ deny
     * the specific permission to the specified principal for the specified
     * resource.
     * This field does _not_ indicate whether the principal actually has the
     * permission for the resource. There might be another policy that overrides
     * this policy. To determine whether the principal actually has the
     * permission, use the `overall_access_state` field in the
     * [TroubleshootIamPolicyResponse][google.cloud.policytroubleshooter.iam.v3.TroubleshootIamPolicyResponse].
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.DenyAccessState deny_access_state = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return int
     */
    public function getDenyAccessState()
    {
        return $this->deny_access_state;
    }

    /**
     * Required. Indicates whether any policies attached to _this resource_ deny
     * the specific permission to the specified principal for the specified
     * resource.
     * This field does _not_ indicate whether the principal actually has the
     * permission for the resource. There might be another policy that overrides
     * this policy. To determine whether the principal actually has the
     * permission, use the `overall_access_state` field in the
     * [TroubleshootIamPolicyResponse][google.cloud.policytroubleshooter.iam.v3.TroubleshootIamPolicyResponse].
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.DenyAccessState deny_access_state = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int $var
     * @return $this
     */
    public function setDenyAccessState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\PolicyTroubleshooter\Iam\V3\DenyAccessState::class);
        $this->deny_access_state = $var;

        return $this;
    }

    /**
     * The full resource name that identifies the resource. For example,
     * `//compute.googleapis.com/projects/my-project/zones/us-central1-a/instances/my-instance`.
     * If the sender of the request does not have access to the policy, this field
     * is omitted.
     * For examples of full resource names for Google Cloud services, see
     * https://cloud.google.com/iam/help/troubleshooter/full-resource-names.
     *
     * Generated from protobuf field <code>string full_resource_name = 2;</code>
     * @return string
     */
    public function getFullResourceName()
    {
        return $this->full_resource_name;
    }

    /**
     * The full resource name that identifies the resource. For example,
     * `//compute.googleapis.com/projects/my-project/zones/us-central1-a/instances/my-instance`.
     * If the sender of the request does not have access to the policy, this field
     * is omitted.
     * For examples of full resource names for Google Cloud services, see
     * https://cloud.google.com/iam/help/troubleshooter/full-resource-names.
     *
     * Generated from protobuf field <code>string full_resource_name = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setFullResourceName($var)
    {
        GPBUtil::checkString($var, True);
        $this->full_resource_name = $var;

        return $this;
    }

    /**
     * List of IAM deny policies that were evaluated to check the principal's
     * denied permissions, with annotations to indicate how each policy
     * contributed to the final result.
     *
     * Generated from protobuf field <code>repeated .google.cloud.policytroubleshooter.iam.v3.ExplainedDenyPolicy explained_policies = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getExplainedPolicies()
    {
        return $this->explained_policies;
    }

    /**
     * List of IAM deny policies that were evaluated to check the principal's
     * denied permissions, with annotations to indicate how each policy
     * contributed to the final result.
     *
     * Generated from protobuf field <code>repeated .google.cloud.policytroubleshooter.iam.v3.ExplainedDenyPolicy explained_policies = 3;</code>
     * @param array<\Google\Cloud\PolicyTroubleshooter\Iam\V3\ExplainedDenyPolicy>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setExplainedPolicies($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\PolicyTroubleshooter\Iam\V3\ExplainedDenyPolicy::class);
        $this->explained_policies = $arr;

        return $this;
    }

    /**
     * The relevance of this policy to the overall access state in the
     * [TroubleshootIamPolicyResponse][google.cloud.policytroubleshooter.iam.v3.TroubleshootIamPolicyResponse].
     * If the sender of the request does not have access to the policy, this field
     * is omitted.
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.HeuristicRelevance relevance = 4;</code>
     * @return int
     */
    public function getRelevance()
    {
        return $this->relevance;
    }

    /**
     * The relevance of this policy to the overall access state in the
     * [TroubleshootIamPolicyResponse][google.cloud.policytroubleshooter.iam.v3.TroubleshootIamPolicyResponse].
     * If the sender of the request does not have access to the policy, this field
     * is omitted.
     *
     * Generated from protobuf field <code>.google.cloud.policytroubleshooter.iam.v3.HeuristicRelevance relevance = 4;</code>
     * @param int $var
     * @return $this
     */
    public function setRelevance($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\PolicyTroubleshooter\Iam\V3\HeuristicRelevance::class);
        $this->relevance = $var;

        return $this;
    }

}

