<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/privilegedaccessmanager/v1/privilegedaccessmanager.proto

namespace Google\Cloud\PrivilegedAccessManager\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * This is to ensure that the `Grants` and `ProducerGrants` proto are byte
 * compatible.
 * A grant represents a request from a user for obtaining the access specified
 * in an entitlement they are eligible for.
 *
 * Generated from protobuf message <code>google.cloud.privilegedaccessmanager.v1.Grant</code>
 */
class Grant extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. Name of this grant.
     * Possible formats:
     * * `organizations/{organization-number}/locations/{region}/entitlements/{entitlement-id}/grants/{grant-id}`
     * * `folders/{folder-number}/locations/{region}/entitlements/{entitlement-id}/grants/{grant-id}`
     * * `projects/{project-id|project-number}/locations/{region}/entitlements/{entitlement-id}/grants/{grant-id}`
     * The last segment of this name (`{grant-id}`) is autogenerated.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Output only. Create time stamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. Update time stamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Output only. Username of the user who created this grant.
     *
     * Generated from protobuf field <code>string requester = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $requester = '';
    /**
     * Required. The amount of time access is needed for. This value should be
     * less than the `max_request_duration` value of the entitlement.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration requested_duration = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $requested_duration = null;
    /**
     * Optional. Justification of why this access is needed.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Justification justification = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $justification = null;
    /**
     * Output only. Current state of this grant.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.State state = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;
    /**
     * Output only. Timeline of this grant.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline timeline = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $timeline = null;
    /**
     * Output only. The access that would be granted by this grant.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.PrivilegedAccess privileged_access = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $privileged_access = null;
    /**
     * Output only. Audit trail of access provided by this grant. If unspecified
     * then access was never granted.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.AuditTrail audit_trail = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $audit_trail = null;
    /**
     * Optional. Additional email addresses to notify for all the actions
     * performed on the grant.
     *
     * Generated from protobuf field <code>repeated string additional_email_recipients = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $additional_email_recipients;
    /**
     * Output only. Flag set by the PAM system to indicate that policy bindings
     * made by this grant have been modified from outside PAM.
     * After it is set, this flag remains set forever irrespective of the grant
     * state. A `true` value here indicates that PAM no longer has any certainty
     * on the access a user has because of this grant.
     *
     * Generated from protobuf field <code>bool externally_modified = 12 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $externally_modified = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. Name of this grant.
     *           Possible formats:
     *           * `organizations/{organization-number}/locations/{region}/entitlements/{entitlement-id}/grants/{grant-id}`
     *           * `folders/{folder-number}/locations/{region}/entitlements/{entitlement-id}/grants/{grant-id}`
     *           * `projects/{project-id|project-number}/locations/{region}/entitlements/{entitlement-id}/grants/{grant-id}`
     *           The last segment of this name (`{grant-id}`) is autogenerated.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. Create time stamp.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. Update time stamp.
     *     @type string $requester
     *           Output only. Username of the user who created this grant.
     *     @type \Google\Protobuf\Duration $requested_duration
     *           Required. The amount of time access is needed for. This value should be
     *           less than the `max_request_duration` value of the entitlement.
     *     @type \Google\Cloud\PrivilegedAccessManager\V1\Justification $justification
     *           Optional. Justification of why this access is needed.
     *     @type int $state
     *           Output only. Current state of this grant.
     *     @type \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline $timeline
     *           Output only. Timeline of this grant.
     *     @type \Google\Cloud\PrivilegedAccessManager\V1\PrivilegedAccess $privileged_access
     *           Output only. The access that would be granted by this grant.
     *     @type \Google\Cloud\PrivilegedAccessManager\V1\Grant\AuditTrail $audit_trail
     *           Output only. Audit trail of access provided by this grant. If unspecified
     *           then access was never granted.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $additional_email_recipients
     *           Optional. Additional email addresses to notify for all the actions
     *           performed on the grant.
     *     @type bool $externally_modified
     *           Output only. Flag set by the PAM system to indicate that policy bindings
     *           made by this grant have been modified from outside PAM.
     *           After it is set, this flag remains set forever irrespective of the grant
     *           state. A `true` value here indicates that PAM no longer has any certainty
     *           on the access a user has because of this grant.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Privilegedaccessmanager\V1\Privilegedaccessmanager::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. Name of this grant.
     * Possible formats:
     * * `organizations/{organization-number}/locations/{region}/entitlements/{entitlement-id}/grants/{grant-id}`
     * * `folders/{folder-number}/locations/{region}/entitlements/{entitlement-id}/grants/{grant-id}`
     * * `projects/{project-id|project-number}/locations/{region}/entitlements/{entitlement-id}/grants/{grant-id}`
     * The last segment of this name (`{grant-id}`) is autogenerated.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. Name of this grant.
     * Possible formats:
     * * `organizations/{organization-number}/locations/{region}/entitlements/{entitlement-id}/grants/{grant-id}`
     * * `folders/{folder-number}/locations/{region}/entitlements/{entitlement-id}/grants/{grant-id}`
     * * `projects/{project-id|project-number}/locations/{region}/entitlements/{entitlement-id}/grants/{grant-id}`
     * The last segment of this name (`{grant-id}`) is autogenerated.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. Create time stamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. Create time stamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. Update time stamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. Update time stamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Output only. Username of the user who created this grant.
     *
     * Generated from protobuf field <code>string requester = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getRequester()
    {
        return $this->requester;
    }

    /**
     * Output only. Username of the user who created this grant.
     *
     * Generated from protobuf field <code>string requester = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setRequester($var)
    {
        GPBUtil::checkString($var, True);
        $this->requester = $var;

        return $this;
    }

    /**
     * Required. The amount of time access is needed for. This value should be
     * less than the `max_request_duration` value of the entitlement.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration requested_duration = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Duration|null
     */
    public function getRequestedDuration()
    {
        return $this->requested_duration;
    }

    public function hasRequestedDuration()
    {
        return isset($this->requested_duration);
    }

    public function clearRequestedDuration()
    {
        unset($this->requested_duration);
    }

    /**
     * Required. The amount of time access is needed for. This value should be
     * less than the `max_request_duration` value of the entitlement.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration requested_duration = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Protobuf\Duration $var
     * @return $this
     */
    public function setRequestedDuration($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Duration::class);
        $this->requested_duration = $var;

        return $this;
    }

    /**
     * Optional. Justification of why this access is needed.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Justification justification = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\PrivilegedAccessManager\V1\Justification|null
     */
    public function getJustification()
    {
        return $this->justification;
    }

    public function hasJustification()
    {
        return isset($this->justification);
    }

    public function clearJustification()
    {
        unset($this->justification);
    }

    /**
     * Optional. Justification of why this access is needed.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Justification justification = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\PrivilegedAccessManager\V1\Justification $var
     * @return $this
     */
    public function setJustification($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\PrivilegedAccessManager\V1\Justification::class);
        $this->justification = $var;

        return $this;
    }

    /**
     * Output only. Current state of this grant.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.State state = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. Current state of this grant.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.State state = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\PrivilegedAccessManager\V1\Grant\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Output only. Timeline of this grant.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline timeline = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline|null
     */
    public function getTimeline()
    {
        return $this->timeline;
    }

    public function hasTimeline()
    {
        return isset($this->timeline);
    }

    public function clearTimeline()
    {
        unset($this->timeline);
    }

    /**
     * Output only. Timeline of this grant.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline timeline = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline $var
     * @return $this
     */
    public function setTimeline($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline::class);
        $this->timeline = $var;

        return $this;
    }

    /**
     * Output only. The access that would be granted by this grant.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.PrivilegedAccess privileged_access = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\PrivilegedAccessManager\V1\PrivilegedAccess|null
     */
    public function getPrivilegedAccess()
    {
        return $this->privileged_access;
    }

    public function hasPrivilegedAccess()
    {
        return isset($this->privileged_access);
    }

    public function clearPrivilegedAccess()
    {
        unset($this->privileged_access);
    }

    /**
     * Output only. The access that would be granted by this grant.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.PrivilegedAccess privileged_access = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\PrivilegedAccessManager\V1\PrivilegedAccess $var
     * @return $this
     */
    public function setPrivilegedAccess($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\PrivilegedAccessManager\V1\PrivilegedAccess::class);
        $this->privileged_access = $var;

        return $this;
    }

    /**
     * Output only. Audit trail of access provided by this grant. If unspecified
     * then access was never granted.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.AuditTrail audit_trail = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\PrivilegedAccessManager\V1\Grant\AuditTrail|null
     */
    public function getAuditTrail()
    {
        return $this->audit_trail;
    }

    public function hasAuditTrail()
    {
        return isset($this->audit_trail);
    }

    public function clearAuditTrail()
    {
        unset($this->audit_trail);
    }

    /**
     * Output only. Audit trail of access provided by this grant. If unspecified
     * then access was never granted.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.AuditTrail audit_trail = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\PrivilegedAccessManager\V1\Grant\AuditTrail $var
     * @return $this
     */
    public function setAuditTrail($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\PrivilegedAccessManager\V1\Grant\AuditTrail::class);
        $this->audit_trail = $var;

        return $this;
    }

    /**
     * Optional. Additional email addresses to notify for all the actions
     * performed on the grant.
     *
     * Generated from protobuf field <code>repeated string additional_email_recipients = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getAdditionalEmailRecipients()
    {
        return $this->additional_email_recipients;
    }

    /**
     * Optional. Additional email addresses to notify for all the actions
     * performed on the grant.
     *
     * Generated from protobuf field <code>repeated string additional_email_recipients = 11 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setAdditionalEmailRecipients($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->additional_email_recipients = $arr;

        return $this;
    }

    /**
     * Output only. Flag set by the PAM system to indicate that policy bindings
     * made by this grant have been modified from outside PAM.
     * After it is set, this flag remains set forever irrespective of the grant
     * state. A `true` value here indicates that PAM no longer has any certainty
     * on the access a user has because of this grant.
     *
     * Generated from protobuf field <code>bool externally_modified = 12 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return bool
     */
    public function getExternallyModified()
    {
        return $this->externally_modified;
    }

    /**
     * Output only. Flag set by the PAM system to indicate that policy bindings
     * made by this grant have been modified from outside PAM.
     * After it is set, this flag remains set forever irrespective of the grant
     * state. A `true` value here indicates that PAM no longer has any certainty
     * on the access a user has because of this grant.
     *
     * Generated from protobuf field <code>bool externally_modified = 12 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param bool $var
     * @return $this
     */
    public function setExternallyModified($var)
    {
        GPBUtil::checkBool($var);
        $this->externally_modified = $var;

        return $this;
    }

}

