<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/privilegedaccessmanager/v1/privilegedaccessmanager.proto

namespace Google\Cloud\PrivilegedAccessManager\V1\Grant;

use UnexpectedValueException;

/**
 * Different states a grant can be in.
 *
 * Protobuf type <code>google.cloud.privilegedaccessmanager.v1.Grant.State</code>
 */
class State
{
    /**
     * Unspecified state. This value is never returned by the server.
     *
     * Generated from protobuf enum <code>STATE_UNSPECIFIED = 0;</code>
     */
    const STATE_UNSPECIFIED = 0;
    /**
     * The entitlement had an approval workflow configured and this grant is
     * waiting for the workflow to complete.
     *
     * Generated from protobuf enum <code>APPROVAL_AWAITED = 1;</code>
     */
    const APPROVAL_AWAITED = 1;
    /**
     * The approval workflow completed with a denied result. No access is
     * granted for this grant. This is a terminal state.
     *
     * Generated from protobuf enum <code>DENIED = 3;</code>
     */
    const DENIED = 3;
    /**
     * The approval workflow completed successfully with an approved result or
     * none was configured. Access is provided at an appropriate time.
     *
     * Generated from protobuf enum <code>SCHEDULED = 4;</code>
     */
    const SCHEDULED = 4;
    /**
     * Access is being given.
     *
     * Generated from protobuf enum <code>ACTIVATING = 5;</code>
     */
    const ACTIVATING = 5;
    /**
     * Access was successfully given and is currently active.
     *
     * Generated from protobuf enum <code>ACTIVE = 6;</code>
     */
    const ACTIVE = 6;
    /**
     * The system could not give access due to a non-retriable error. This is a
     * terminal state.
     *
     * Generated from protobuf enum <code>ACTIVATION_FAILED = 7;</code>
     */
    const ACTIVATION_FAILED = 7;
    /**
     * Expired after waiting for the approval workflow to complete. This is a
     * terminal state.
     *
     * Generated from protobuf enum <code>EXPIRED = 8;</code>
     */
    const EXPIRED = 8;
    /**
     * Access is being revoked.
     *
     * Generated from protobuf enum <code>REVOKING = 9;</code>
     */
    const REVOKING = 9;
    /**
     * Access was revoked by a user. This is a terminal state.
     *
     * Generated from protobuf enum <code>REVOKED = 10;</code>
     */
    const REVOKED = 10;
    /**
     * System took back access as the requested duration was over. This is a
     * terminal state.
     *
     * Generated from protobuf enum <code>ENDED = 11;</code>
     */
    const ENDED = 11;

    private static $valueToName = [
        self::STATE_UNSPECIFIED => 'STATE_UNSPECIFIED',
        self::APPROVAL_AWAITED => 'APPROVAL_AWAITED',
        self::DENIED => 'DENIED',
        self::SCHEDULED => 'SCHEDULED',
        self::ACTIVATING => 'ACTIVATING',
        self::ACTIVE => 'ACTIVE',
        self::ACTIVATION_FAILED => 'ACTIVATION_FAILED',
        self::EXPIRED => 'EXPIRED',
        self::REVOKING => 'REVOKING',
        self::REVOKED => 'REVOKED',
        self::ENDED => 'ENDED',
    ];

    public static function name($value)
    {
        if (!isset(self::$valueToName[$value])) {
            throw new UnexpectedValueException(sprintf(
                    'Enum %s has no name defined for value %s', __CLASS__, $value));
        }
        return self::$valueToName[$value];
    }


    public static function value($name)
    {
        $const = __CLASS__ . '::' . strtoupper($name);
        if (!defined($const)) {
            throw new UnexpectedValueException(sprintf(
                    'Enum %s has no value defined for name %s', __CLASS__, $name));
        }
        return constant($const);
    }
}


