<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/privilegedaccessmanager/v1/privilegedaccessmanager.proto

namespace Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A single operation on the grant.
 *
 * Generated from protobuf message <code>google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event</code>
 */
class Event extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The time (as recorded at server) when this event occurred.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp event_time = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $event_time = null;
    protected $event;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Requested $requested
     *           The grant was requested.
     *     @type \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Approved $approved
     *           The grant was approved.
     *     @type \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Denied $denied
     *           The grant was denied.
     *     @type \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Revoked $revoked
     *           The grant was revoked.
     *     @type \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Scheduled $scheduled
     *           The grant has been scheduled to give access.
     *     @type \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Activated $activated
     *           The grant was successfully activated to give access.
     *     @type \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\ActivationFailed $activation_failed
     *           There was a non-retriable error while trying to give access.
     *     @type \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Expired $expired
     *           The approval workflow did not complete in the necessary duration,
     *           and so the grant is expired.
     *     @type \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Ended $ended
     *           Access given by the grant ended automatically as the approved
     *           duration was over.
     *     @type \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\ExternallyModified $externally_modified
     *           The policy bindings made by grant have been modified outside of PAM.
     *     @type \Google\Protobuf\Timestamp $event_time
     *           Output only. The time (as recorded at server) when this event occurred.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Privilegedaccessmanager\V1\Privilegedaccessmanager::initOnce();
        parent::__construct($data);
    }

    /**
     * The grant was requested.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.Requested requested = 2;</code>
     * @return \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Requested|null
     */
    public function getRequested()
    {
        return $this->readOneof(2);
    }

    public function hasRequested()
    {
        return $this->hasOneof(2);
    }

    /**
     * The grant was requested.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.Requested requested = 2;</code>
     * @param \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Requested $var
     * @return $this
     */
    public function setRequested($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Requested::class);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     * The grant was approved.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.Approved approved = 3;</code>
     * @return \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Approved|null
     */
    public function getApproved()
    {
        return $this->readOneof(3);
    }

    public function hasApproved()
    {
        return $this->hasOneof(3);
    }

    /**
     * The grant was approved.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.Approved approved = 3;</code>
     * @param \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Approved $var
     * @return $this
     */
    public function setApproved($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Approved::class);
        $this->writeOneof(3, $var);

        return $this;
    }

    /**
     * The grant was denied.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.Denied denied = 4;</code>
     * @return \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Denied|null
     */
    public function getDenied()
    {
        return $this->readOneof(4);
    }

    public function hasDenied()
    {
        return $this->hasOneof(4);
    }

    /**
     * The grant was denied.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.Denied denied = 4;</code>
     * @param \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Denied $var
     * @return $this
     */
    public function setDenied($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Denied::class);
        $this->writeOneof(4, $var);

        return $this;
    }

    /**
     * The grant was revoked.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.Revoked revoked = 5;</code>
     * @return \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Revoked|null
     */
    public function getRevoked()
    {
        return $this->readOneof(5);
    }

    public function hasRevoked()
    {
        return $this->hasOneof(5);
    }

    /**
     * The grant was revoked.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.Revoked revoked = 5;</code>
     * @param \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Revoked $var
     * @return $this
     */
    public function setRevoked($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Revoked::class);
        $this->writeOneof(5, $var);

        return $this;
    }

    /**
     * The grant has been scheduled to give access.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.Scheduled scheduled = 6;</code>
     * @return \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Scheduled|null
     */
    public function getScheduled()
    {
        return $this->readOneof(6);
    }

    public function hasScheduled()
    {
        return $this->hasOneof(6);
    }

    /**
     * The grant has been scheduled to give access.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.Scheduled scheduled = 6;</code>
     * @param \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Scheduled $var
     * @return $this
     */
    public function setScheduled($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Scheduled::class);
        $this->writeOneof(6, $var);

        return $this;
    }

    /**
     * The grant was successfully activated to give access.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.Activated activated = 7;</code>
     * @return \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Activated|null
     */
    public function getActivated()
    {
        return $this->readOneof(7);
    }

    public function hasActivated()
    {
        return $this->hasOneof(7);
    }

    /**
     * The grant was successfully activated to give access.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.Activated activated = 7;</code>
     * @param \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Activated $var
     * @return $this
     */
    public function setActivated($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Activated::class);
        $this->writeOneof(7, $var);

        return $this;
    }

    /**
     * There was a non-retriable error while trying to give access.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.ActivationFailed activation_failed = 8;</code>
     * @return \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\ActivationFailed|null
     */
    public function getActivationFailed()
    {
        return $this->readOneof(8);
    }

    public function hasActivationFailed()
    {
        return $this->hasOneof(8);
    }

    /**
     * There was a non-retriable error while trying to give access.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.ActivationFailed activation_failed = 8;</code>
     * @param \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\ActivationFailed $var
     * @return $this
     */
    public function setActivationFailed($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\ActivationFailed::class);
        $this->writeOneof(8, $var);

        return $this;
    }

    /**
     * The approval workflow did not complete in the necessary duration,
     * and so the grant is expired.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.Expired expired = 10;</code>
     * @return \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Expired|null
     */
    public function getExpired()
    {
        return $this->readOneof(10);
    }

    public function hasExpired()
    {
        return $this->hasOneof(10);
    }

    /**
     * The approval workflow did not complete in the necessary duration,
     * and so the grant is expired.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.Expired expired = 10;</code>
     * @param \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Expired $var
     * @return $this
     */
    public function setExpired($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Expired::class);
        $this->writeOneof(10, $var);

        return $this;
    }

    /**
     * Access given by the grant ended automatically as the approved
     * duration was over.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.Ended ended = 11;</code>
     * @return \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Ended|null
     */
    public function getEnded()
    {
        return $this->readOneof(11);
    }

    public function hasEnded()
    {
        return $this->hasOneof(11);
    }

    /**
     * Access given by the grant ended automatically as the approved
     * duration was over.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.Ended ended = 11;</code>
     * @param \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Ended $var
     * @return $this
     */
    public function setEnded($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\Ended::class);
        $this->writeOneof(11, $var);

        return $this;
    }

    /**
     * The policy bindings made by grant have been modified outside of PAM.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.ExternallyModified externally_modified = 12;</code>
     * @return \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\ExternallyModified|null
     */
    public function getExternallyModified()
    {
        return $this->readOneof(12);
    }

    public function hasExternallyModified()
    {
        return $this->hasOneof(12);
    }

    /**
     * The policy bindings made by grant have been modified outside of PAM.
     *
     * Generated from protobuf field <code>.google.cloud.privilegedaccessmanager.v1.Grant.Timeline.Event.ExternallyModified externally_modified = 12;</code>
     * @param \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\ExternallyModified $var
     * @return $this
     */
    public function setExternallyModified($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\PrivilegedAccessManager\V1\Grant\Timeline\Event\ExternallyModified::class);
        $this->writeOneof(12, $var);

        return $this;
    }

    /**
     * Output only. The time (as recorded at server) when this event occurred.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp event_time = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getEventTime()
    {
        return $this->event_time;
    }

    public function hasEventTime()
    {
        return isset($this->event_time);
    }

    public function clearEventTime()
    {
        unset($this->event_time);
    }

    /**
     * Output only. The time (as recorded at server) when this event occurred.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp event_time = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setEventTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->event_time = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getEvent()
    {
        return $this->whichOneof("event");
    }

}


