<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/pubsub/v1/pubsub.proto

namespace Google\Cloud\PubSub\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request for the `ListTopics` method.
 *
 * Generated from protobuf message <code>google.pubsub.v1.ListTopicsRequest</code>
 */
class ListTopicsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the project in which to list topics.
     * Format is `projects/{project-id}`.
     *
     * Generated from protobuf field <code>string project = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $project = '';
    /**
     * Optional. Maximum number of topics to return.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $page_size = 0;
    /**
     * Optional. The value returned by the last `ListTopicsResponse`; indicates
     * that this is a continuation of a prior `ListTopics` call, and that the
     * system should return the next page of data.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $page_token = '';

    /**
     * @param string $project Required. The name of the project in which to list topics.
     *                        Format is `projects/{project-id}`. Please see
     *                        {@see PublisherClient::projectName()} for help formatting this field.
     *
     * @return \Google\Cloud\PubSub\V1\ListTopicsRequest
     *
     * @experimental
     */
    public static function build(string $project): self
    {
        return (new self())
            ->setProject($project);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $project
     *           Required. The name of the project in which to list topics.
     *           Format is `projects/{project-id}`.
     *     @type int $page_size
     *           Optional. Maximum number of topics to return.
     *     @type string $page_token
     *           Optional. The value returned by the last `ListTopicsResponse`; indicates
     *           that this is a continuation of a prior `ListTopics` call, and that the
     *           system should return the next page of data.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Pubsub\V1\Pubsub::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the project in which to list topics.
     * Format is `projects/{project-id}`.
     *
     * Generated from protobuf field <code>string project = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getProject()
    {
        return $this->project;
    }

    /**
     * Required. The name of the project in which to list topics.
     * Format is `projects/{project-id}`.
     *
     * Generated from protobuf field <code>string project = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setProject($var)
    {
        GPBUtil::checkString($var, True);
        $this->project = $var;

        return $this;
    }

    /**
     * Optional. Maximum number of topics to return.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. Maximum number of topics to return.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. The value returned by the last `ListTopicsResponse`; indicates
     * that this is a continuation of a prior `ListTopics` call, and that the
     * system should return the next page of data.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. The value returned by the last `ListTopicsResponse`; indicates
     * that this is a continuation of a prior `ListTopics` call, and that the
     * system should return the next page of data.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

