<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/pubsub/v1/pubsub.proto

namespace Google\Cloud\PubSub\V1\PushConfig;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Contains information needed for generating an
 * [OpenID Connect
 * token](https://developers.google.com/identity/protocols/OpenIDConnect).
 *
 * Generated from protobuf message <code>google.pubsub.v1.PushConfig.OidcToken</code>
 */
class OidcToken extends \Google\Protobuf\Internal\Message
{
    /**
     * Optional. [Service account
     * email](https://cloud.google.com/iam/docs/service-accounts)
     * used for generating the OIDC token. For more information
     * on setting up authentication, see
     * [Push subscriptions](https://cloud.google.com/pubsub/docs/push).
     *
     * Generated from protobuf field <code>string service_account_email = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $service_account_email = '';
    /**
     * Optional. Audience to be used when generating OIDC token. The audience
     * claim identifies the recipients that the JWT is intended for. The
     * audience value is a single case-sensitive string. Having multiple values
     * (array) for the audience field is not supported. More info about the OIDC
     * JWT token audience here:
     * https://tools.ietf.org/html/rfc7519#section-4.1.3 Note: if not specified,
     * the Push endpoint URL will be used.
     *
     * Generated from protobuf field <code>string audience = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $audience = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $service_account_email
     *           Optional. [Service account
     *           email](https://cloud.google.com/iam/docs/service-accounts)
     *           used for generating the OIDC token. For more information
     *           on setting up authentication, see
     *           [Push subscriptions](https://cloud.google.com/pubsub/docs/push).
     *     @type string $audience
     *           Optional. Audience to be used when generating OIDC token. The audience
     *           claim identifies the recipients that the JWT is intended for. The
     *           audience value is a single case-sensitive string. Having multiple values
     *           (array) for the audience field is not supported. More info about the OIDC
     *           JWT token audience here:
     *           https://tools.ietf.org/html/rfc7519#section-4.1.3 Note: if not specified,
     *           the Push endpoint URL will be used.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Pubsub\V1\Pubsub::initOnce();
        parent::__construct($data);
    }

    /**
     * Optional. [Service account
     * email](https://cloud.google.com/iam/docs/service-accounts)
     * used for generating the OIDC token. For more information
     * on setting up authentication, see
     * [Push subscriptions](https://cloud.google.com/pubsub/docs/push).
     *
     * Generated from protobuf field <code>string service_account_email = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getServiceAccountEmail()
    {
        return $this->service_account_email;
    }

    /**
     * Optional. [Service account
     * email](https://cloud.google.com/iam/docs/service-accounts)
     * used for generating the OIDC token. For more information
     * on setting up authentication, see
     * [Push subscriptions](https://cloud.google.com/pubsub/docs/push).
     *
     * Generated from protobuf field <code>string service_account_email = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setServiceAccountEmail($var)
    {
        GPBUtil::checkString($var, True);
        $this->service_account_email = $var;

        return $this;
    }

    /**
     * Optional. Audience to be used when generating OIDC token. The audience
     * claim identifies the recipients that the JWT is intended for. The
     * audience value is a single case-sensitive string. Having multiple values
     * (array) for the audience field is not supported. More info about the OIDC
     * JWT token audience here:
     * https://tools.ietf.org/html/rfc7519#section-4.1.3 Note: if not specified,
     * the Push endpoint URL will be used.
     *
     * Generated from protobuf field <code>string audience = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getAudience()
    {
        return $this->audience;
    }

    /**
     * Optional. Audience to be used when generating OIDC token. The audience
     * claim identifies the recipients that the JWT is intended for. The
     * audience value is a single case-sensitive string. Having multiple values
     * (array) for the audience field is not supported. More info about the OIDC
     * JWT token audience here:
     * https://tools.ietf.org/html/rfc7519#section-4.1.3 Note: if not specified,
     * the Push endpoint URL will be used.
     *
     * Generated from protobuf field <code>string audience = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setAudience($var)
    {
        GPBUtil::checkString($var, True);
        $this->audience = $var;

        return $this;
    }

}


