<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/api/cloudquotas/v1/resources.proto

namespace Google\Cloud\CloudQuotas\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The detailed quota information such as effective quota value for a
 * combination of dimensions.
 *
 * Generated from protobuf message <code>google.api.cloudquotas.v1.DimensionsInfo</code>
 */
class DimensionsInfo extends \Google\Protobuf\Internal\Message
{
    /**
     * The map of dimensions for this dimensions info. The key of a map entry
     * is "region", "zone" or the name of a service specific dimension, and the
     * value of a map entry is the value of the dimension.  If a dimension does
     * not appear in the map of dimensions, the dimensions info applies to all
     * the dimension values except for those that have another DimenisonInfo
     * instance configured for the specific value.
     * Example: {"provider" : "Foo Inc"} where "provider" is a service specific
     * dimension of a quota.
     *
     * Generated from protobuf field <code>map<string, string> dimensions = 1;</code>
     */
    private $dimensions;
    /**
     * Quota details for the specified dimensions.
     *
     * Generated from protobuf field <code>.google.api.cloudquotas.v1.QuotaDetails details = 2;</code>
     */
    protected $details = null;
    /**
     * The applicable regions or zones of this dimensions info. The field will be
     * set to ['global'] for quotas that are not per region or per zone.
     * Otherwise, it will be set to the list of locations this dimension info is
     * applicable to.
     *
     * Generated from protobuf field <code>repeated string applicable_locations = 3;</code>
     */
    private $applicable_locations;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type array|\Google\Protobuf\Internal\MapField $dimensions
     *           The map of dimensions for this dimensions info. The key of a map entry
     *           is "region", "zone" or the name of a service specific dimension, and the
     *           value of a map entry is the value of the dimension.  If a dimension does
     *           not appear in the map of dimensions, the dimensions info applies to all
     *           the dimension values except for those that have another DimenisonInfo
     *           instance configured for the specific value.
     *           Example: {"provider" : "Foo Inc"} where "provider" is a service specific
     *           dimension of a quota.
     *     @type \Google\Cloud\CloudQuotas\V1\QuotaDetails $details
     *           Quota details for the specified dimensions.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $applicable_locations
     *           The applicable regions or zones of this dimensions info. The field will be
     *           set to ['global'] for quotas that are not per region or per zone.
     *           Otherwise, it will be set to the list of locations this dimension info is
     *           applicable to.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Api\Cloudquotas\V1\Resources::initOnce();
        parent::__construct($data);
    }

    /**
     * The map of dimensions for this dimensions info. The key of a map entry
     * is "region", "zone" or the name of a service specific dimension, and the
     * value of a map entry is the value of the dimension.  If a dimension does
     * not appear in the map of dimensions, the dimensions info applies to all
     * the dimension values except for those that have another DimenisonInfo
     * instance configured for the specific value.
     * Example: {"provider" : "Foo Inc"} where "provider" is a service specific
     * dimension of a quota.
     *
     * Generated from protobuf field <code>map<string, string> dimensions = 1;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getDimensions()
    {
        return $this->dimensions;
    }

    /**
     * The map of dimensions for this dimensions info. The key of a map entry
     * is "region", "zone" or the name of a service specific dimension, and the
     * value of a map entry is the value of the dimension.  If a dimension does
     * not appear in the map of dimensions, the dimensions info applies to all
     * the dimension values except for those that have another DimenisonInfo
     * instance configured for the specific value.
     * Example: {"provider" : "Foo Inc"} where "provider" is a service specific
     * dimension of a quota.
     *
     * Generated from protobuf field <code>map<string, string> dimensions = 1;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setDimensions($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->dimensions = $arr;

        return $this;
    }

    /**
     * Quota details for the specified dimensions.
     *
     * Generated from protobuf field <code>.google.api.cloudquotas.v1.QuotaDetails details = 2;</code>
     * @return \Google\Cloud\CloudQuotas\V1\QuotaDetails|null
     */
    public function getDetails()
    {
        return $this->details;
    }

    public function hasDetails()
    {
        return isset($this->details);
    }

    public function clearDetails()
    {
        unset($this->details);
    }

    /**
     * Quota details for the specified dimensions.
     *
     * Generated from protobuf field <code>.google.api.cloudquotas.v1.QuotaDetails details = 2;</code>
     * @param \Google\Cloud\CloudQuotas\V1\QuotaDetails $var
     * @return $this
     */
    public function setDetails($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\CloudQuotas\V1\QuotaDetails::class);
        $this->details = $var;

        return $this;
    }

    /**
     * The applicable regions or zones of this dimensions info. The field will be
     * set to ['global'] for quotas that are not per region or per zone.
     * Otherwise, it will be set to the list of locations this dimension info is
     * applicable to.
     *
     * Generated from protobuf field <code>repeated string applicable_locations = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getApplicableLocations()
    {
        return $this->applicable_locations;
    }

    /**
     * The applicable regions or zones of this dimensions info. The field will be
     * set to ['global'] for quotas that are not per region or per zone.
     * Otherwise, it will be set to the list of locations this dimension info is
     * applicable to.
     *
     * Generated from protobuf field <code>repeated string applicable_locations = 3;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setApplicableLocations($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->applicable_locations = $arr;

        return $this;
    }

}

