<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/api/cloudquotas/v1/cloudquotas.proto

namespace Google\Cloud\CloudQuotas\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message for requesting list of QuotaInfos
 *
 * Generated from protobuf message <code>google.api.cloudquotas.v1.ListQuotaInfosRequest</code>
 */
class ListQuotaInfosRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Parent value of QuotaInfo resources.
     * Listing across different resource containers (such as 'projects/-') is not
     * allowed.
     * Example names:
     * `projects/123/locations/global/services/compute.googleapis.com`
     * `folders/234/locations/global/services/compute.googleapis.com`
     * `organizations/345/locations/global/services/compute.googleapis.com`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. Requested page size. Server may return fewer items than
     * requested. If unspecified, server will pick an appropriate default.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. A token identifying a page of results the server should return.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';

    /**
     * @param string $parent Required. Parent value of QuotaInfo resources.
     *                       Listing across different resource containers (such as 'projects/-') is not
     *                       allowed.
     *
     *                       Example names:
     *                       `projects/123/locations/global/services/compute.googleapis.com`
     *                       `folders/234/locations/global/services/compute.googleapis.com`
     *                       `organizations/345/locations/global/services/compute.googleapis.com`
     *                       Please see {@see CloudQuotasClient::serviceName()} for help formatting this field.
     *
     * @return \Google\Cloud\CloudQuotas\V1\ListQuotaInfosRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Parent value of QuotaInfo resources.
     *           Listing across different resource containers (such as 'projects/-') is not
     *           allowed.
     *           Example names:
     *           `projects/123/locations/global/services/compute.googleapis.com`
     *           `folders/234/locations/global/services/compute.googleapis.com`
     *           `organizations/345/locations/global/services/compute.googleapis.com`
     *     @type int $page_size
     *           Optional. Requested page size. Server may return fewer items than
     *           requested. If unspecified, server will pick an appropriate default.
     *     @type string $page_token
     *           Optional. A token identifying a page of results the server should return.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Api\Cloudquotas\V1\Cloudquotas::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Parent value of QuotaInfo resources.
     * Listing across different resource containers (such as 'projects/-') is not
     * allowed.
     * Example names:
     * `projects/123/locations/global/services/compute.googleapis.com`
     * `folders/234/locations/global/services/compute.googleapis.com`
     * `organizations/345/locations/global/services/compute.googleapis.com`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Parent value of QuotaInfo resources.
     * Listing across different resource containers (such as 'projects/-') is not
     * allowed.
     * Example names:
     * `projects/123/locations/global/services/compute.googleapis.com`
     * `folders/234/locations/global/services/compute.googleapis.com`
     * `organizations/345/locations/global/services/compute.googleapis.com`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. Requested page size. Server may return fewer items than
     * requested. If unspecified, server will pick an appropriate default.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. Requested page size. Server may return fewer items than
     * requested. If unspecified, server will pick an appropriate default.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. A token identifying a page of results the server should return.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. A token identifying a page of results the server should return.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

