<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/api/cloudquotas/v1/cloudquotas.proto

namespace Google\Cloud\CloudQuotas\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message for requesting list of QuotaPreferences
 *
 * Generated from protobuf message <code>google.api.cloudquotas.v1.ListQuotaPreferencesRequest</code>
 */
class ListQuotaPreferencesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Parent value of QuotaPreference resources.
     * Listing across different resource containers (such as 'projects/-') is not
     * allowed.
     * When the value starts with 'folders' or 'organizations', it lists the
     * QuotaPreferences for org quotas in the container. It does not list the
     * QuotaPreferences in the descendant projects of the container.
     * Example parents:
     * `projects/123/locations/global`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. Requested page size. Server may return fewer items than
     * requested. If unspecified, server will pick an appropriate default.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. A token identifying a page of results the server should return.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';
    /**
     * Optional. Filter result QuotaPreferences by their state, type,
     * create/update time range.
     * Example filters:
     * `reconciling=true AND request_type=CLOUD_CONSOLE`,
     * `reconciling=true OR creation_time>2022-12-03T10:30:00`
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $filter = '';
    /**
     * Optional. How to order of the results. By default, the results are ordered
     * by create time.
     * Example orders:
     * `quota_id`,
     * `service, create_time`
     *
     * Generated from protobuf field <code>string order_by = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $order_by = '';

    /**
     * @param string $parent Required. Parent value of QuotaPreference resources.
     *                       Listing across different resource containers (such as 'projects/-') is not
     *                       allowed.
     *
     *                       When the value starts with 'folders' or 'organizations', it lists the
     *                       QuotaPreferences for org quotas in the container. It does not list the
     *                       QuotaPreferences in the descendant projects of the container.
     *
     *                       Example parents:
     *                       `projects/123/locations/global`
     *                       Please see {@see CloudQuotasClient::locationName()} for help formatting this field.
     *
     * @return \Google\Cloud\CloudQuotas\V1\ListQuotaPreferencesRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Parent value of QuotaPreference resources.
     *           Listing across different resource containers (such as 'projects/-') is not
     *           allowed.
     *           When the value starts with 'folders' or 'organizations', it lists the
     *           QuotaPreferences for org quotas in the container. It does not list the
     *           QuotaPreferences in the descendant projects of the container.
     *           Example parents:
     *           `projects/123/locations/global`
     *     @type int $page_size
     *           Optional. Requested page size. Server may return fewer items than
     *           requested. If unspecified, server will pick an appropriate default.
     *     @type string $page_token
     *           Optional. A token identifying a page of results the server should return.
     *     @type string $filter
     *           Optional. Filter result QuotaPreferences by their state, type,
     *           create/update time range.
     *           Example filters:
     *           `reconciling=true AND request_type=CLOUD_CONSOLE`,
     *           `reconciling=true OR creation_time>2022-12-03T10:30:00`
     *     @type string $order_by
     *           Optional. How to order of the results. By default, the results are ordered
     *           by create time.
     *           Example orders:
     *           `quota_id`,
     *           `service, create_time`
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Api\Cloudquotas\V1\Cloudquotas::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Parent value of QuotaPreference resources.
     * Listing across different resource containers (such as 'projects/-') is not
     * allowed.
     * When the value starts with 'folders' or 'organizations', it lists the
     * QuotaPreferences for org quotas in the container. It does not list the
     * QuotaPreferences in the descendant projects of the container.
     * Example parents:
     * `projects/123/locations/global`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Parent value of QuotaPreference resources.
     * Listing across different resource containers (such as 'projects/-') is not
     * allowed.
     * When the value starts with 'folders' or 'organizations', it lists the
     * QuotaPreferences for org quotas in the container. It does not list the
     * QuotaPreferences in the descendant projects of the container.
     * Example parents:
     * `projects/123/locations/global`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. Requested page size. Server may return fewer items than
     * requested. If unspecified, server will pick an appropriate default.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. Requested page size. Server may return fewer items than
     * requested. If unspecified, server will pick an appropriate default.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. A token identifying a page of results the server should return.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. A token identifying a page of results the server should return.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. Filter result QuotaPreferences by their state, type,
     * create/update time range.
     * Example filters:
     * `reconciling=true AND request_type=CLOUD_CONSOLE`,
     * `reconciling=true OR creation_time>2022-12-03T10:30:00`
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Optional. Filter result QuotaPreferences by their state, type,
     * create/update time range.
     * Example filters:
     * `reconciling=true AND request_type=CLOUD_CONSOLE`,
     * `reconciling=true OR creation_time>2022-12-03T10:30:00`
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * Optional. How to order of the results. By default, the results are ordered
     * by create time.
     * Example orders:
     * `quota_id`,
     * `service, create_time`
     *
     * Generated from protobuf field <code>string order_by = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getOrderBy()
    {
        return $this->order_by;
    }

    /**
     * Optional. How to order of the results. By default, the results are ordered
     * by create time.
     * Example orders:
     * `quota_id`,
     * `service, create_time`
     *
     * Generated from protobuf field <code>string order_by = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setOrderBy($var)
    {
        GPBUtil::checkString($var, True);
        $this->order_by = $var;

        return $this;
    }

}

