<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/api/cloudquotas/v1/cloudquotas.proto

namespace Google\Cloud\CloudQuotas\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message for updating a QuotaPreference
 *
 * Generated from protobuf message <code>google.api.cloudquotas.v1.UpdateQuotaPreferenceRequest</code>
 */
class UpdateQuotaPreferenceRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Optional. Field mask is used to specify the fields to be overwritten in the
     * QuotaPreference resource by the update.
     * The fields specified in the update_mask are relative to the resource, not
     * the full request. A field will be overwritten if it is in the mask. If the
     * user does not provide a mask then all fields will be overwritten.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $update_mask = null;
    /**
     * Required. The resource being updated
     *
     * Generated from protobuf field <code>.google.api.cloudquotas.v1.QuotaPreference quota_preference = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $quota_preference = null;
    /**
     * Optional. If set to true, and the quota preference is not found, a new one
     * will be created. In this situation, `update_mask` is ignored.
     *
     * Generated from protobuf field <code>bool allow_missing = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $allow_missing = false;
    /**
     * Optional. If set to true, validate the request, but do not actually update.
     * Note that a request being valid does not mean that the request is
     * guaranteed to be fulfilled.
     *
     * Generated from protobuf field <code>bool validate_only = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $validate_only = false;
    /**
     * The list of quota safety checks to be ignored.
     *
     * Generated from protobuf field <code>repeated .google.api.cloudquotas.v1.QuotaSafetyCheck ignore_safety_checks = 5;</code>
     */
    private $ignore_safety_checks;

    /**
     * @param \Google\Cloud\CloudQuotas\V1\QuotaPreference $quotaPreference Required. The resource being updated
     * @param \Google\Protobuf\FieldMask                   $updateMask      Optional. Field mask is used to specify the fields to be overwritten in the
     *                                                                      QuotaPreference resource by the update.
     *                                                                      The fields specified in the update_mask are relative to the resource, not
     *                                                                      the full request. A field will be overwritten if it is in the mask. If the
     *                                                                      user does not provide a mask then all fields will be overwritten.
     *
     * @return \Google\Cloud\CloudQuotas\V1\UpdateQuotaPreferenceRequest
     *
     * @experimental
     */
    public static function build(\Google\Cloud\CloudQuotas\V1\QuotaPreference $quotaPreference, \Google\Protobuf\FieldMask $updateMask): self
    {
        return (new self())
            ->setQuotaPreference($quotaPreference)
            ->setUpdateMask($updateMask);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Protobuf\FieldMask $update_mask
     *           Optional. Field mask is used to specify the fields to be overwritten in the
     *           QuotaPreference resource by the update.
     *           The fields specified in the update_mask are relative to the resource, not
     *           the full request. A field will be overwritten if it is in the mask. If the
     *           user does not provide a mask then all fields will be overwritten.
     *     @type \Google\Cloud\CloudQuotas\V1\QuotaPreference $quota_preference
     *           Required. The resource being updated
     *     @type bool $allow_missing
     *           Optional. If set to true, and the quota preference is not found, a new one
     *           will be created. In this situation, `update_mask` is ignored.
     *     @type bool $validate_only
     *           Optional. If set to true, validate the request, but do not actually update.
     *           Note that a request being valid does not mean that the request is
     *           guaranteed to be fulfilled.
     *     @type array<int>|\Google\Protobuf\Internal\RepeatedField $ignore_safety_checks
     *           The list of quota safety checks to be ignored.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Api\Cloudquotas\V1\Cloudquotas::initOnce();
        parent::__construct($data);
    }

    /**
     * Optional. Field mask is used to specify the fields to be overwritten in the
     * QuotaPreference resource by the update.
     * The fields specified in the update_mask are relative to the resource, not
     * the full request. A field will be overwritten if it is in the mask. If the
     * user does not provide a mask then all fields will be overwritten.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\FieldMask|null
     */
    public function getUpdateMask()
    {
        return $this->update_mask;
    }

    public function hasUpdateMask()
    {
        return isset($this->update_mask);
    }

    public function clearUpdateMask()
    {
        unset($this->update_mask);
    }

    /**
     * Optional. Field mask is used to specify the fields to be overwritten in the
     * QuotaPreference resource by the update.
     * The fields specified in the update_mask are relative to the resource, not
     * the full request. A field will be overwritten if it is in the mask. If the
     * user does not provide a mask then all fields will be overwritten.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask update_mask = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Protobuf\FieldMask $var
     * @return $this
     */
    public function setUpdateMask($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\FieldMask::class);
        $this->update_mask = $var;

        return $this;
    }

    /**
     * Required. The resource being updated
     *
     * Generated from protobuf field <code>.google.api.cloudquotas.v1.QuotaPreference quota_preference = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\CloudQuotas\V1\QuotaPreference|null
     */
    public function getQuotaPreference()
    {
        return $this->quota_preference;
    }

    public function hasQuotaPreference()
    {
        return isset($this->quota_preference);
    }

    public function clearQuotaPreference()
    {
        unset($this->quota_preference);
    }

    /**
     * Required. The resource being updated
     *
     * Generated from protobuf field <code>.google.api.cloudquotas.v1.QuotaPreference quota_preference = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\CloudQuotas\V1\QuotaPreference $var
     * @return $this
     */
    public function setQuotaPreference($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\CloudQuotas\V1\QuotaPreference::class);
        $this->quota_preference = $var;

        return $this;
    }

    /**
     * Optional. If set to true, and the quota preference is not found, a new one
     * will be created. In this situation, `update_mask` is ignored.
     *
     * Generated from protobuf field <code>bool allow_missing = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getAllowMissing()
    {
        return $this->allow_missing;
    }

    /**
     * Optional. If set to true, and the quota preference is not found, a new one
     * will be created. In this situation, `update_mask` is ignored.
     *
     * Generated from protobuf field <code>bool allow_missing = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setAllowMissing($var)
    {
        GPBUtil::checkBool($var);
        $this->allow_missing = $var;

        return $this;
    }

    /**
     * Optional. If set to true, validate the request, but do not actually update.
     * Note that a request being valid does not mean that the request is
     * guaranteed to be fulfilled.
     *
     * Generated from protobuf field <code>bool validate_only = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getValidateOnly()
    {
        return $this->validate_only;
    }

    /**
     * Optional. If set to true, validate the request, but do not actually update.
     * Note that a request being valid does not mean that the request is
     * guaranteed to be fulfilled.
     *
     * Generated from protobuf field <code>bool validate_only = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setValidateOnly($var)
    {
        GPBUtil::checkBool($var);
        $this->validate_only = $var;

        return $this;
    }

    /**
     * The list of quota safety checks to be ignored.
     *
     * Generated from protobuf field <code>repeated .google.api.cloudquotas.v1.QuotaSafetyCheck ignore_safety_checks = 5;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getIgnoreSafetyChecks()
    {
        return $this->ignore_safety_checks;
    }

    /**
     * The list of quota safety checks to be ignored.
     *
     * Generated from protobuf field <code>repeated .google.api.cloudquotas.v1.QuotaSafetyCheck ignore_safety_checks = 5;</code>
     * @param array<int>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setIgnoreSafetyChecks($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::ENUM, \Google\Cloud\CloudQuotas\V1\QuotaSafetyCheck::class);
        $this->ignore_safety_checks = $arr;

        return $this;
    }

}

