<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/recaptchaenterprise/v1/recaptchaenterprise.proto

namespace Google\Cloud\RecaptchaEnterprise\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Assessment for Fraud Prevention.
 *
 * Generated from protobuf message <code>google.cloud.recaptchaenterprise.v1.FraudPreventionAssessment</code>
 */
class FraudPreventionAssessment extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. Probability of this transaction being fraudulent. Summarizes
     * the combined risk of attack vectors below. Values are from 0.0 (lowest)
     * to 1.0 (highest).
     *
     * Generated from protobuf field <code>float transaction_risk = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $transaction_risk = 0.0;
    /**
     * Output only. Assessment of this transaction for risk of a stolen
     * instrument.
     *
     * Generated from protobuf field <code>.google.cloud.recaptchaenterprise.v1.FraudPreventionAssessment.StolenInstrumentVerdict stolen_instrument_verdict = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $stolen_instrument_verdict = null;
    /**
     * Output only. Assessment of this transaction for risk of being part of a
     * card testing attack.
     *
     * Generated from protobuf field <code>.google.cloud.recaptchaenterprise.v1.FraudPreventionAssessment.CardTestingVerdict card_testing_verdict = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $card_testing_verdict = null;
    /**
     * Output only. Assessment of this transaction for behavioral trust.
     *
     * Generated from protobuf field <code>.google.cloud.recaptchaenterprise.v1.FraudPreventionAssessment.BehavioralTrustVerdict behavioral_trust_verdict = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $behavioral_trust_verdict = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type float $transaction_risk
     *           Output only. Probability of this transaction being fraudulent. Summarizes
     *           the combined risk of attack vectors below. Values are from 0.0 (lowest)
     *           to 1.0 (highest).
     *     @type \Google\Cloud\RecaptchaEnterprise\V1\FraudPreventionAssessment\StolenInstrumentVerdict $stolen_instrument_verdict
     *           Output only. Assessment of this transaction for risk of a stolen
     *           instrument.
     *     @type \Google\Cloud\RecaptchaEnterprise\V1\FraudPreventionAssessment\CardTestingVerdict $card_testing_verdict
     *           Output only. Assessment of this transaction for risk of being part of a
     *           card testing attack.
     *     @type \Google\Cloud\RecaptchaEnterprise\V1\FraudPreventionAssessment\BehavioralTrustVerdict $behavioral_trust_verdict
     *           Output only. Assessment of this transaction for behavioral trust.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Recaptchaenterprise\V1\Recaptchaenterprise::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. Probability of this transaction being fraudulent. Summarizes
     * the combined risk of attack vectors below. Values are from 0.0 (lowest)
     * to 1.0 (highest).
     *
     * Generated from protobuf field <code>float transaction_risk = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return float
     */
    public function getTransactionRisk()
    {
        return $this->transaction_risk;
    }

    /**
     * Output only. Probability of this transaction being fraudulent. Summarizes
     * the combined risk of attack vectors below. Values are from 0.0 (lowest)
     * to 1.0 (highest).
     *
     * Generated from protobuf field <code>float transaction_risk = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param float $var
     * @return $this
     */
    public function setTransactionRisk($var)
    {
        GPBUtil::checkFloat($var);
        $this->transaction_risk = $var;

        return $this;
    }

    /**
     * Output only. Assessment of this transaction for risk of a stolen
     * instrument.
     *
     * Generated from protobuf field <code>.google.cloud.recaptchaenterprise.v1.FraudPreventionAssessment.StolenInstrumentVerdict stolen_instrument_verdict = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\RecaptchaEnterprise\V1\FraudPreventionAssessment\StolenInstrumentVerdict|null
     */
    public function getStolenInstrumentVerdict()
    {
        return $this->stolen_instrument_verdict;
    }

    public function hasStolenInstrumentVerdict()
    {
        return isset($this->stolen_instrument_verdict);
    }

    public function clearStolenInstrumentVerdict()
    {
        unset($this->stolen_instrument_verdict);
    }

    /**
     * Output only. Assessment of this transaction for risk of a stolen
     * instrument.
     *
     * Generated from protobuf field <code>.google.cloud.recaptchaenterprise.v1.FraudPreventionAssessment.StolenInstrumentVerdict stolen_instrument_verdict = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\RecaptchaEnterprise\V1\FraudPreventionAssessment\StolenInstrumentVerdict $var
     * @return $this
     */
    public function setStolenInstrumentVerdict($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\RecaptchaEnterprise\V1\FraudPreventionAssessment\StolenInstrumentVerdict::class);
        $this->stolen_instrument_verdict = $var;

        return $this;
    }

    /**
     * Output only. Assessment of this transaction for risk of being part of a
     * card testing attack.
     *
     * Generated from protobuf field <code>.google.cloud.recaptchaenterprise.v1.FraudPreventionAssessment.CardTestingVerdict card_testing_verdict = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\RecaptchaEnterprise\V1\FraudPreventionAssessment\CardTestingVerdict|null
     */
    public function getCardTestingVerdict()
    {
        return $this->card_testing_verdict;
    }

    public function hasCardTestingVerdict()
    {
        return isset($this->card_testing_verdict);
    }

    public function clearCardTestingVerdict()
    {
        unset($this->card_testing_verdict);
    }

    /**
     * Output only. Assessment of this transaction for risk of being part of a
     * card testing attack.
     *
     * Generated from protobuf field <code>.google.cloud.recaptchaenterprise.v1.FraudPreventionAssessment.CardTestingVerdict card_testing_verdict = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\RecaptchaEnterprise\V1\FraudPreventionAssessment\CardTestingVerdict $var
     * @return $this
     */
    public function setCardTestingVerdict($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\RecaptchaEnterprise\V1\FraudPreventionAssessment\CardTestingVerdict::class);
        $this->card_testing_verdict = $var;

        return $this;
    }

    /**
     * Output only. Assessment of this transaction for behavioral trust.
     *
     * Generated from protobuf field <code>.google.cloud.recaptchaenterprise.v1.FraudPreventionAssessment.BehavioralTrustVerdict behavioral_trust_verdict = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\RecaptchaEnterprise\V1\FraudPreventionAssessment\BehavioralTrustVerdict|null
     */
    public function getBehavioralTrustVerdict()
    {
        return $this->behavioral_trust_verdict;
    }

    public function hasBehavioralTrustVerdict()
    {
        return isset($this->behavioral_trust_verdict);
    }

    public function clearBehavioralTrustVerdict()
    {
        unset($this->behavioral_trust_verdict);
    }

    /**
     * Output only. Assessment of this transaction for behavioral trust.
     *
     * Generated from protobuf field <code>.google.cloud.recaptchaenterprise.v1.FraudPreventionAssessment.BehavioralTrustVerdict behavioral_trust_verdict = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\RecaptchaEnterprise\V1\FraudPreventionAssessment\BehavioralTrustVerdict $var
     * @return $this
     */
    public function setBehavioralTrustVerdict($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\RecaptchaEnterprise\V1\FraudPreventionAssessment\BehavioralTrustVerdict::class);
        $this->behavioral_trust_verdict = $var;

        return $this;
    }

}

