<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/redis/v1/cloud_redis.proto

namespace Google\Cloud\Redis\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request for [Failover][google.cloud.redis.v1.CloudRedis.FailoverInstance].
 *
 * Generated from protobuf message <code>google.cloud.redis.v1.FailoverInstanceRequest</code>
 */
class FailoverInstanceRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Redis instance resource name using the form:
     *     `projects/{project_id}/locations/{location_id}/instances/{instance_id}`
     * where `location_id` refers to a GCP region.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';
    /**
     * Optional. Available data protection modes that the user can choose. If it's
     * unspecified, data protection mode will be LIMITED_DATA_LOSS by default.
     *
     * Generated from protobuf field <code>.google.cloud.redis.v1.FailoverInstanceRequest.DataProtectionMode data_protection_mode = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $data_protection_mode = 0;

    /**
     * @param string $name               Required. Redis instance resource name using the form:
     *                                   `projects/{project_id}/locations/{location_id}/instances/{instance_id}`
     *                                   where `location_id` refers to a GCP region. Please see
     *                                   {@see CloudRedisClient::instanceName()} for help formatting this field.
     * @param int    $dataProtectionMode Optional. Available data protection modes that the user can choose. If it's
     *                                   unspecified, data protection mode will be LIMITED_DATA_LOSS by default.
     *                                   For allowed values, use constants defined on {@see \Google\Cloud\Redis\V1\FailoverInstanceRequest\DataProtectionMode}
     *
     * @return \Google\Cloud\Redis\V1\FailoverInstanceRequest
     *
     * @experimental
     */
    public static function build(string $name, int $dataProtectionMode): self
    {
        return (new self())
            ->setName($name)
            ->setDataProtectionMode($dataProtectionMode);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. Redis instance resource name using the form:
     *               `projects/{project_id}/locations/{location_id}/instances/{instance_id}`
     *           where `location_id` refers to a GCP region.
     *     @type int $data_protection_mode
     *           Optional. Available data protection modes that the user can choose. If it's
     *           unspecified, data protection mode will be LIMITED_DATA_LOSS by default.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Redis\V1\CloudRedis::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Redis instance resource name using the form:
     *     `projects/{project_id}/locations/{location_id}/instances/{instance_id}`
     * where `location_id` refers to a GCP region.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. Redis instance resource name using the form:
     *     `projects/{project_id}/locations/{location_id}/instances/{instance_id}`
     * where `location_id` refers to a GCP region.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Optional. Available data protection modes that the user can choose. If it's
     * unspecified, data protection mode will be LIMITED_DATA_LOSS by default.
     *
     * Generated from protobuf field <code>.google.cloud.redis.v1.FailoverInstanceRequest.DataProtectionMode data_protection_mode = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getDataProtectionMode()
    {
        return $this->data_protection_mode;
    }

    /**
     * Optional. Available data protection modes that the user can choose. If it's
     * unspecified, data protection mode will be LIMITED_DATA_LOSS by default.
     *
     * Generated from protobuf field <code>.google.cloud.redis.v1.FailoverInstanceRequest.DataProtectionMode data_protection_mode = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setDataProtectionMode($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Redis\V1\FailoverInstanceRequest\DataProtectionMode::class);
        $this->data_protection_mode = $var;

        return $this;
    }

}

