<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/redis/v1/cloud_redis.proto

namespace Google\Cloud\Redis\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request for
 * [RescheduleMaintenance][google.cloud.redis.v1.CloudRedis.RescheduleMaintenance].
 *
 * Generated from protobuf message <code>google.cloud.redis.v1.RescheduleMaintenanceRequest</code>
 */
class RescheduleMaintenanceRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Redis instance resource name using the form:
     *     `projects/{project_id}/locations/{location_id}/instances/{instance_id}`
     * where `location_id` refers to a GCP region.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';
    /**
     * Required. If reschedule type is SPECIFIC_TIME, must set up schedule_time as
     * well.
     *
     * Generated from protobuf field <code>.google.cloud.redis.v1.RescheduleMaintenanceRequest.RescheduleType reschedule_type = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $reschedule_type = 0;
    /**
     * Optional. Timestamp when the maintenance shall be rescheduled to if
     * reschedule_type=SPECIFIC_TIME, in RFC 3339 format, for
     * example `2012-11-15T16:19:00.094Z`.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp schedule_time = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $schedule_time = null;

    /**
     * @param string                     $name           Required. Redis instance resource name using the form:
     *                                                   `projects/{project_id}/locations/{location_id}/instances/{instance_id}`
     *                                                   where `location_id` refers to a GCP region. Please see
     *                                                   {@see CloudRedisClient::instanceName()} for help formatting this field.
     * @param int                        $rescheduleType Required. If reschedule type is SPECIFIC_TIME, must set up schedule_time as
     *                                                   well.
     *                                                   For allowed values, use constants defined on {@see \Google\Cloud\Redis\V1\RescheduleMaintenanceRequest\RescheduleType}
     * @param \Google\Protobuf\Timestamp $scheduleTime   Optional. Timestamp when the maintenance shall be rescheduled to if
     *                                                   reschedule_type=SPECIFIC_TIME, in RFC 3339 format, for
     *                                                   example `2012-11-15T16:19:00.094Z`.
     *
     * @return \Google\Cloud\Redis\V1\RescheduleMaintenanceRequest
     *
     * @experimental
     */
    public static function build(string $name, int $rescheduleType, \Google\Protobuf\Timestamp $scheduleTime): self
    {
        return (new self())
            ->setName($name)
            ->setRescheduleType($rescheduleType)
            ->setScheduleTime($scheduleTime);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. Redis instance resource name using the form:
     *               `projects/{project_id}/locations/{location_id}/instances/{instance_id}`
     *           where `location_id` refers to a GCP region.
     *     @type int $reschedule_type
     *           Required. If reschedule type is SPECIFIC_TIME, must set up schedule_time as
     *           well.
     *     @type \Google\Protobuf\Timestamp $schedule_time
     *           Optional. Timestamp when the maintenance shall be rescheduled to if
     *           reschedule_type=SPECIFIC_TIME, in RFC 3339 format, for
     *           example `2012-11-15T16:19:00.094Z`.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Redis\V1\CloudRedis::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Redis instance resource name using the form:
     *     `projects/{project_id}/locations/{location_id}/instances/{instance_id}`
     * where `location_id` refers to a GCP region.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. Redis instance resource name using the form:
     *     `projects/{project_id}/locations/{location_id}/instances/{instance_id}`
     * where `location_id` refers to a GCP region.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Required. If reschedule type is SPECIFIC_TIME, must set up schedule_time as
     * well.
     *
     * Generated from protobuf field <code>.google.cloud.redis.v1.RescheduleMaintenanceRequest.RescheduleType reschedule_type = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return int
     */
    public function getRescheduleType()
    {
        return $this->reschedule_type;
    }

    /**
     * Required. If reschedule type is SPECIFIC_TIME, must set up schedule_time as
     * well.
     *
     * Generated from protobuf field <code>.google.cloud.redis.v1.RescheduleMaintenanceRequest.RescheduleType reschedule_type = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int $var
     * @return $this
     */
    public function setRescheduleType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Redis\V1\RescheduleMaintenanceRequest\RescheduleType::class);
        $this->reschedule_type = $var;

        return $this;
    }

    /**
     * Optional. Timestamp when the maintenance shall be rescheduled to if
     * reschedule_type=SPECIFIC_TIME, in RFC 3339 format, for
     * example `2012-11-15T16:19:00.094Z`.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp schedule_time = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getScheduleTime()
    {
        return $this->schedule_time;
    }

    public function hasScheduleTime()
    {
        return isset($this->schedule_time);
    }

    public function clearScheduleTime()
    {
        unset($this->schedule_time);
    }

    /**
     * Optional. Timestamp when the maintenance shall be rescheduled to if
     * reschedule_type=SPECIFIC_TIME, in RFC 3339 format, for
     * example `2012-11-15T16:19:00.094Z`.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp schedule_time = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setScheduleTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->schedule_time = $var;

        return $this;
    }

}

