<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/redis/cluster/v1/cloud_redis_cluster.proto

namespace Google\Cloud\Redis\Cluster\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Details of consumer resources in a PSC connection.
 *
 * Generated from protobuf message <code>google.cloud.redis.cluster.v1.PscConnection</code>
 */
class PscConnection extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The PSC connection id of the forwarding rule connected to the
     * service attachment.
     *
     * Generated from protobuf field <code>string psc_connection_id = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $psc_connection_id = '';
    /**
     * Output only. The IP allocated on the consumer network for the PSC
     * forwarding rule.
     *
     * Generated from protobuf field <code>string address = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $address = '';
    /**
     * Output only. The URI of the consumer side forwarding rule.
     * Example:
     * projects/{projectNumOrId}/regions/us-east1/forwardingRules/{resourceId}.
     *
     * Generated from protobuf field <code>string forwarding_rule = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $forwarding_rule = '';
    /**
     * Output only. The consumer project_id where the forwarding rule is created
     * from.
     *
     * Generated from protobuf field <code>string project_id = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $project_id = '';
    /**
     * The consumer network where the IP address resides, in the form of
     * projects/{project_id}/global/networks/{network_id}.
     *
     * Generated from protobuf field <code>string network = 5;</code>
     */
    protected $network = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $psc_connection_id
     *           Output only. The PSC connection id of the forwarding rule connected to the
     *           service attachment.
     *     @type string $address
     *           Output only. The IP allocated on the consumer network for the PSC
     *           forwarding rule.
     *     @type string $forwarding_rule
     *           Output only. The URI of the consumer side forwarding rule.
     *           Example:
     *           projects/{projectNumOrId}/regions/us-east1/forwardingRules/{resourceId}.
     *     @type string $project_id
     *           Output only. The consumer project_id where the forwarding rule is created
     *           from.
     *     @type string $network
     *           The consumer network where the IP address resides, in the form of
     *           projects/{project_id}/global/networks/{network_id}.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Redis\Cluster\V1\CloudRedisCluster::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The PSC connection id of the forwarding rule connected to the
     * service attachment.
     *
     * Generated from protobuf field <code>string psc_connection_id = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getPscConnectionId()
    {
        return $this->psc_connection_id;
    }

    /**
     * Output only. The PSC connection id of the forwarding rule connected to the
     * service attachment.
     *
     * Generated from protobuf field <code>string psc_connection_id = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setPscConnectionId($var)
    {
        GPBUtil::checkString($var, True);
        $this->psc_connection_id = $var;

        return $this;
    }

    /**
     * Output only. The IP allocated on the consumer network for the PSC
     * forwarding rule.
     *
     * Generated from protobuf field <code>string address = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getAddress()
    {
        return $this->address;
    }

    /**
     * Output only. The IP allocated on the consumer network for the PSC
     * forwarding rule.
     *
     * Generated from protobuf field <code>string address = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setAddress($var)
    {
        GPBUtil::checkString($var, True);
        $this->address = $var;

        return $this;
    }

    /**
     * Output only. The URI of the consumer side forwarding rule.
     * Example:
     * projects/{projectNumOrId}/regions/us-east1/forwardingRules/{resourceId}.
     *
     * Generated from protobuf field <code>string forwarding_rule = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getForwardingRule()
    {
        return $this->forwarding_rule;
    }

    /**
     * Output only. The URI of the consumer side forwarding rule.
     * Example:
     * projects/{projectNumOrId}/regions/us-east1/forwardingRules/{resourceId}.
     *
     * Generated from protobuf field <code>string forwarding_rule = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setForwardingRule($var)
    {
        GPBUtil::checkString($var, True);
        $this->forwarding_rule = $var;

        return $this;
    }

    /**
     * Output only. The consumer project_id where the forwarding rule is created
     * from.
     *
     * Generated from protobuf field <code>string project_id = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getProjectId()
    {
        return $this->project_id;
    }

    /**
     * Output only. The consumer project_id where the forwarding rule is created
     * from.
     *
     * Generated from protobuf field <code>string project_id = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setProjectId($var)
    {
        GPBUtil::checkString($var, True);
        $this->project_id = $var;

        return $this;
    }

    /**
     * The consumer network where the IP address resides, in the form of
     * projects/{project_id}/global/networks/{network_id}.
     *
     * Generated from protobuf field <code>string network = 5;</code>
     * @return string
     */
    public function getNetwork()
    {
        return $this->network;
    }

    /**
     * The consumer network where the IP address resides, in the form of
     * projects/{project_id}/global/networks/{network_id}.
     *
     * Generated from protobuf field <code>string network = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setNetwork($var)
    {
        GPBUtil::checkString($var, True);
        $this->network = $var;

        return $this;
    }

}

