<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/resourcemanager/v3/tag_bindings.proto

namespace Google\Cloud\ResourceManager\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message to list all TagBindings for a parent.
 *
 * Generated from protobuf message <code>google.cloud.resourcemanager.v3.ListTagBindingsRequest</code>
 */
class ListTagBindingsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The full resource name of a resource for which you want to list
     * existing TagBindings. E.g.
     * "//cloudresourcemanager.googleapis.com/projects/123"
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. The maximum number of TagBindings to return in the response. The
     * server allows a maximum of 300 TagBindings to return. If unspecified, the
     * server will use 100 as the default.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. A pagination token returned from a previous call to
     * `ListTagBindings` that indicates where this listing should continue from.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';

    /**
     * @param string $parent Required. The full resource name of a resource for which you want to list
     *                       existing TagBindings. E.g.
     *                       "//cloudresourcemanager.googleapis.com/projects/123"
     *
     * @return \Google\Cloud\ResourceManager\V3\ListTagBindingsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The full resource name of a resource for which you want to list
     *           existing TagBindings. E.g.
     *           "//cloudresourcemanager.googleapis.com/projects/123"
     *     @type int $page_size
     *           Optional. The maximum number of TagBindings to return in the response. The
     *           server allows a maximum of 300 TagBindings to return. If unspecified, the
     *           server will use 100 as the default.
     *     @type string $page_token
     *           Optional. A pagination token returned from a previous call to
     *           `ListTagBindings` that indicates where this listing should continue from.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Resourcemanager\V3\TagBindings::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The full resource name of a resource for which you want to list
     * existing TagBindings. E.g.
     * "//cloudresourcemanager.googleapis.com/projects/123"
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The full resource name of a resource for which you want to list
     * existing TagBindings. E.g.
     * "//cloudresourcemanager.googleapis.com/projects/123"
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. The maximum number of TagBindings to return in the response. The
     * server allows a maximum of 300 TagBindings to return. If unspecified, the
     * server will use 100 as the default.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. The maximum number of TagBindings to return in the response. The
     * server allows a maximum of 300 TagBindings to return. If unspecified, the
     * server will use 100 as the default.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. A pagination token returned from a previous call to
     * `ListTagBindings` that indicates where this listing should continue from.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. A pagination token returned from a previous call to
     * `ListTagBindings` that indicates where this listing should continue from.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

