<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/retail/v2/product_service.proto

namespace Google\Cloud\Retail\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [ProductService.DeleteProduct][google.cloud.retail.v2.ProductService.DeleteProduct]
 * method.
 *
 * Generated from protobuf message <code>google.cloud.retail.v2.DeleteProductRequest</code>
 */
class DeleteProductRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Full resource name of [Product][google.cloud.retail.v2.Product],
     * such as
     * `projects/&#42;&#47;locations/global/catalogs/default_catalog/branches/default_branch/products/some_product_id`.
     * If the caller does not have permission to delete the
     * [Product][google.cloud.retail.v2.Product], regardless of whether or not it
     * exists, a PERMISSION_DENIED error is returned.
     * If the [Product][google.cloud.retail.v2.Product] to delete does not exist,
     * a NOT_FOUND error is returned.
     * The [Product][google.cloud.retail.v2.Product] to delete can neither be a
     * [Product.Type.COLLECTION][google.cloud.retail.v2.Product.Type.COLLECTION]
     * [Product][google.cloud.retail.v2.Product] member nor a
     * [Product.Type.PRIMARY][google.cloud.retail.v2.Product.Type.PRIMARY]
     * [Product][google.cloud.retail.v2.Product] with more than one
     * [variants][google.cloud.retail.v2.Product.Type.VARIANT]. Otherwise, an
     * INVALID_ARGUMENT error is returned.
     * All inventory information for the named
     * [Product][google.cloud.retail.v2.Product] will be deleted.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';

    /**
     * @param string $name Required. Full resource name of [Product][google.cloud.retail.v2.Product],
     *                     such as
     *                     `projects/&#42;/locations/global/catalogs/default_catalog/branches/default_branch/products/some_product_id`.
     *
     *                     If the caller does not have permission to delete the
     *                     [Product][google.cloud.retail.v2.Product], regardless of whether or not it
     *                     exists, a PERMISSION_DENIED error is returned.
     *
     *                     If the [Product][google.cloud.retail.v2.Product] to delete does not exist,
     *                     a NOT_FOUND error is returned.
     *
     *                     The [Product][google.cloud.retail.v2.Product] to delete can neither be a
     *                     [Product.Type.COLLECTION][google.cloud.retail.v2.Product.Type.COLLECTION]
     *                     [Product][google.cloud.retail.v2.Product] member nor a
     *                     [Product.Type.PRIMARY][google.cloud.retail.v2.Product.Type.PRIMARY]
     *                     [Product][google.cloud.retail.v2.Product] with more than one
     *                     [variants][google.cloud.retail.v2.Product.Type.VARIANT]. Otherwise, an
     *                     INVALID_ARGUMENT error is returned.
     *
     *                     All inventory information for the named
     *                     [Product][google.cloud.retail.v2.Product] will be deleted. Please see
     *                     {@see ProductServiceClient::productName()} for help formatting this field.
     *
     * @return \Google\Cloud\Retail\V2\DeleteProductRequest
     *
     * @experimental
     */
    public static function build(string $name): self
    {
        return (new self())
            ->setName($name);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. Full resource name of [Product][google.cloud.retail.v2.Product],
     *           such as
     *           `projects/&#42;&#47;locations/global/catalogs/default_catalog/branches/default_branch/products/some_product_id`.
     *           If the caller does not have permission to delete the
     *           [Product][google.cloud.retail.v2.Product], regardless of whether or not it
     *           exists, a PERMISSION_DENIED error is returned.
     *           If the [Product][google.cloud.retail.v2.Product] to delete does not exist,
     *           a NOT_FOUND error is returned.
     *           The [Product][google.cloud.retail.v2.Product] to delete can neither be a
     *           [Product.Type.COLLECTION][google.cloud.retail.v2.Product.Type.COLLECTION]
     *           [Product][google.cloud.retail.v2.Product] member nor a
     *           [Product.Type.PRIMARY][google.cloud.retail.v2.Product.Type.PRIMARY]
     *           [Product][google.cloud.retail.v2.Product] with more than one
     *           [variants][google.cloud.retail.v2.Product.Type.VARIANT]. Otherwise, an
     *           INVALID_ARGUMENT error is returned.
     *           All inventory information for the named
     *           [Product][google.cloud.retail.v2.Product] will be deleted.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Retail\V2\ProductService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Full resource name of [Product][google.cloud.retail.v2.Product],
     * such as
     * `projects/&#42;&#47;locations/global/catalogs/default_catalog/branches/default_branch/products/some_product_id`.
     * If the caller does not have permission to delete the
     * [Product][google.cloud.retail.v2.Product], regardless of whether or not it
     * exists, a PERMISSION_DENIED error is returned.
     * If the [Product][google.cloud.retail.v2.Product] to delete does not exist,
     * a NOT_FOUND error is returned.
     * The [Product][google.cloud.retail.v2.Product] to delete can neither be a
     * [Product.Type.COLLECTION][google.cloud.retail.v2.Product.Type.COLLECTION]
     * [Product][google.cloud.retail.v2.Product] member nor a
     * [Product.Type.PRIMARY][google.cloud.retail.v2.Product.Type.PRIMARY]
     * [Product][google.cloud.retail.v2.Product] with more than one
     * [variants][google.cloud.retail.v2.Product.Type.VARIANT]. Otherwise, an
     * INVALID_ARGUMENT error is returned.
     * All inventory information for the named
     * [Product][google.cloud.retail.v2.Product] will be deleted.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. Full resource name of [Product][google.cloud.retail.v2.Product],
     * such as
     * `projects/&#42;&#47;locations/global/catalogs/default_catalog/branches/default_branch/products/some_product_id`.
     * If the caller does not have permission to delete the
     * [Product][google.cloud.retail.v2.Product], regardless of whether or not it
     * exists, a PERMISSION_DENIED error is returned.
     * If the [Product][google.cloud.retail.v2.Product] to delete does not exist,
     * a NOT_FOUND error is returned.
     * The [Product][google.cloud.retail.v2.Product] to delete can neither be a
     * [Product.Type.COLLECTION][google.cloud.retail.v2.Product.Type.COLLECTION]
     * [Product][google.cloud.retail.v2.Product] member nor a
     * [Product.Type.PRIMARY][google.cloud.retail.v2.Product.Type.PRIMARY]
     * [Product][google.cloud.retail.v2.Product] with more than one
     * [variants][google.cloud.retail.v2.Product.Type.VARIANT]. Otherwise, an
     * INVALID_ARGUMENT error is returned.
     * All inventory information for the named
     * [Product][google.cloud.retail.v2.Product] will be deleted.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

}

