<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/retail/v2/export_config.proto

namespace Google\Cloud\Retail\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for the `ExportAnalyticsMetrics` method.
 *
 * Generated from protobuf message <code>google.cloud.retail.v2.ExportAnalyticsMetricsRequest</code>
 */
class ExportAnalyticsMetricsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Full resource name of the parent catalog.
     * Expected format: `projects/&#42;&#47;locations/&#42;&#47;catalogs/&#42;`
     *
     * Generated from protobuf field <code>string catalog = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $catalog = '';
    /**
     * Required. The output location of the data.
     *
     * Generated from protobuf field <code>.google.cloud.retail.v2.OutputConfig output_config = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $output_config = null;
    /**
     * A filtering expression to specify restrictions on returned metrics.
     * The expression is a sequence of terms. Each term applies a restriction to
     * the returned metrics. Use this expression to restrict results to a
     * specific time range.
     *   Currently we expect only one types of fields:
     *    * `timestamp`: This can be specified twice, once with a
     *      less than operator and once with a greater than operator. The
     *      `timestamp` restriction should result in one, contiguous, valid,
     *      `timestamp` range.
     *   Some examples of valid filters expressions:
     *   * Example 1: `timestamp > "2012-04-23T18:25:43.511Z"
     *             timestamp < "2012-04-23T18:30:43.511Z"`
     *   * Example 2: `timestamp > "2012-04-23T18:25:43.511Z"`
     *
     * Generated from protobuf field <code>string filter = 3;</code>
     */
    protected $filter = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $catalog
     *           Required. Full resource name of the parent catalog.
     *           Expected format: `projects/&#42;&#47;locations/&#42;&#47;catalogs/&#42;`
     *     @type \Google\Cloud\Retail\V2\OutputConfig $output_config
     *           Required. The output location of the data.
     *     @type string $filter
     *           A filtering expression to specify restrictions on returned metrics.
     *           The expression is a sequence of terms. Each term applies a restriction to
     *           the returned metrics. Use this expression to restrict results to a
     *           specific time range.
     *             Currently we expect only one types of fields:
     *              * `timestamp`: This can be specified twice, once with a
     *                less than operator and once with a greater than operator. The
     *                `timestamp` restriction should result in one, contiguous, valid,
     *                `timestamp` range.
     *             Some examples of valid filters expressions:
     *             * Example 1: `timestamp > "2012-04-23T18:25:43.511Z"
     *                       timestamp < "2012-04-23T18:30:43.511Z"`
     *             * Example 2: `timestamp > "2012-04-23T18:25:43.511Z"`
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Retail\V2\ExportConfig::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Full resource name of the parent catalog.
     * Expected format: `projects/&#42;&#47;locations/&#42;&#47;catalogs/&#42;`
     *
     * Generated from protobuf field <code>string catalog = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getCatalog()
    {
        return $this->catalog;
    }

    /**
     * Required. Full resource name of the parent catalog.
     * Expected format: `projects/&#42;&#47;locations/&#42;&#47;catalogs/&#42;`
     *
     * Generated from protobuf field <code>string catalog = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setCatalog($var)
    {
        GPBUtil::checkString($var, True);
        $this->catalog = $var;

        return $this;
    }

    /**
     * Required. The output location of the data.
     *
     * Generated from protobuf field <code>.google.cloud.retail.v2.OutputConfig output_config = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\Retail\V2\OutputConfig|null
     */
    public function getOutputConfig()
    {
        return $this->output_config;
    }

    public function hasOutputConfig()
    {
        return isset($this->output_config);
    }

    public function clearOutputConfig()
    {
        unset($this->output_config);
    }

    /**
     * Required. The output location of the data.
     *
     * Generated from protobuf field <code>.google.cloud.retail.v2.OutputConfig output_config = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\Retail\V2\OutputConfig $var
     * @return $this
     */
    public function setOutputConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Retail\V2\OutputConfig::class);
        $this->output_config = $var;

        return $this;
    }

    /**
     * A filtering expression to specify restrictions on returned metrics.
     * The expression is a sequence of terms. Each term applies a restriction to
     * the returned metrics. Use this expression to restrict results to a
     * specific time range.
     *   Currently we expect only one types of fields:
     *    * `timestamp`: This can be specified twice, once with a
     *      less than operator and once with a greater than operator. The
     *      `timestamp` restriction should result in one, contiguous, valid,
     *      `timestamp` range.
     *   Some examples of valid filters expressions:
     *   * Example 1: `timestamp > "2012-04-23T18:25:43.511Z"
     *             timestamp < "2012-04-23T18:30:43.511Z"`
     *   * Example 2: `timestamp > "2012-04-23T18:25:43.511Z"`
     *
     * Generated from protobuf field <code>string filter = 3;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * A filtering expression to specify restrictions on returned metrics.
     * The expression is a sequence of terms. Each term applies a restriction to
     * the returned metrics. Use this expression to restrict results to a
     * specific time range.
     *   Currently we expect only one types of fields:
     *    * `timestamp`: This can be specified twice, once with a
     *      less than operator and once with a greater than operator. The
     *      `timestamp` restriction should result in one, contiguous, valid,
     *      `timestamp` range.
     *   Some examples of valid filters expressions:
     *   * Example 1: `timestamp > "2012-04-23T18:25:43.511Z"
     *             timestamp < "2012-04-23T18:30:43.511Z"`
     *   * Example 2: `timestamp > "2012-04-23T18:25:43.511Z"`
     *
     * Generated from protobuf field <code>string filter = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

}

