<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/retail/v2/generative_question.proto

namespace Google\Cloud\Retail\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Configuration for a single generated question.
 *
 * Generated from protobuf message <code>google.cloud.retail.v2.GenerativeQuestionConfig</code>
 */
class GenerativeQuestionConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Resource name of the catalog.
     * Format: projects/{project}/locations/{location}/catalogs/{catalog}
     *
     * Generated from protobuf field <code>string catalog = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $catalog = '';
    /**
     * Required. The facet to which the question is associated.
     *
     * Generated from protobuf field <code>string facet = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $facet = '';
    /**
     * Output only. The LLM generated question.
     *
     * Generated from protobuf field <code>string generated_question = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $generated_question = '';
    /**
     * Optional. The question that will be used at serving time.
     * Question can have a max length of 300 bytes.
     * When not populated, generated_question should be used.
     *
     * Generated from protobuf field <code>string final_question = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $final_question = '';
    /**
     * Output only. Values that can be used to answer the question.
     *
     * Generated from protobuf field <code>repeated string example_values = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $example_values;
    /**
     * Output only. The ratio of how often a question was asked.
     *
     * Generated from protobuf field <code>float frequency = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $frequency = 0.0;
    /**
     * Optional. Whether the question is asked at serving time.
     *
     * Generated from protobuf field <code>bool allowed_in_conversation = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $allowed_in_conversation = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $catalog
     *           Required. Resource name of the catalog.
     *           Format: projects/{project}/locations/{location}/catalogs/{catalog}
     *     @type string $facet
     *           Required. The facet to which the question is associated.
     *     @type string $generated_question
     *           Output only. The LLM generated question.
     *     @type string $final_question
     *           Optional. The question that will be used at serving time.
     *           Question can have a max length of 300 bytes.
     *           When not populated, generated_question should be used.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $example_values
     *           Output only. Values that can be used to answer the question.
     *     @type float $frequency
     *           Output only. The ratio of how often a question was asked.
     *     @type bool $allowed_in_conversation
     *           Optional. Whether the question is asked at serving time.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Retail\V2\GenerativeQuestion::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Resource name of the catalog.
     * Format: projects/{project}/locations/{location}/catalogs/{catalog}
     *
     * Generated from protobuf field <code>string catalog = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getCatalog()
    {
        return $this->catalog;
    }

    /**
     * Required. Resource name of the catalog.
     * Format: projects/{project}/locations/{location}/catalogs/{catalog}
     *
     * Generated from protobuf field <code>string catalog = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setCatalog($var)
    {
        GPBUtil::checkString($var, True);
        $this->catalog = $var;

        return $this;
    }

    /**
     * Required. The facet to which the question is associated.
     *
     * Generated from protobuf field <code>string facet = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getFacet()
    {
        return $this->facet;
    }

    /**
     * Required. The facet to which the question is associated.
     *
     * Generated from protobuf field <code>string facet = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setFacet($var)
    {
        GPBUtil::checkString($var, True);
        $this->facet = $var;

        return $this;
    }

    /**
     * Output only. The LLM generated question.
     *
     * Generated from protobuf field <code>string generated_question = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getGeneratedQuestion()
    {
        return $this->generated_question;
    }

    /**
     * Output only. The LLM generated question.
     *
     * Generated from protobuf field <code>string generated_question = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setGeneratedQuestion($var)
    {
        GPBUtil::checkString($var, True);
        $this->generated_question = $var;

        return $this;
    }

    /**
     * Optional. The question that will be used at serving time.
     * Question can have a max length of 300 bytes.
     * When not populated, generated_question should be used.
     *
     * Generated from protobuf field <code>string final_question = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFinalQuestion()
    {
        return $this->final_question;
    }

    /**
     * Optional. The question that will be used at serving time.
     * Question can have a max length of 300 bytes.
     * When not populated, generated_question should be used.
     *
     * Generated from protobuf field <code>string final_question = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFinalQuestion($var)
    {
        GPBUtil::checkString($var, True);
        $this->final_question = $var;

        return $this;
    }

    /**
     * Output only. Values that can be used to answer the question.
     *
     * Generated from protobuf field <code>repeated string example_values = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getExampleValues()
    {
        return $this->example_values;
    }

    /**
     * Output only. Values that can be used to answer the question.
     *
     * Generated from protobuf field <code>repeated string example_values = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setExampleValues($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->example_values = $arr;

        return $this;
    }

    /**
     * Output only. The ratio of how often a question was asked.
     *
     * Generated from protobuf field <code>float frequency = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return float
     */
    public function getFrequency()
    {
        return $this->frequency;
    }

    /**
     * Output only. The ratio of how often a question was asked.
     *
     * Generated from protobuf field <code>float frequency = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param float $var
     * @return $this
     */
    public function setFrequency($var)
    {
        GPBUtil::checkFloat($var);
        $this->frequency = $var;

        return $this;
    }

    /**
     * Optional. Whether the question is asked at serving time.
     *
     * Generated from protobuf field <code>bool allowed_in_conversation = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getAllowedInConversation()
    {
        return $this->allowed_in_conversation;
    }

    /**
     * Optional. Whether the question is asked at serving time.
     *
     * Generated from protobuf field <code>bool allowed_in_conversation = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setAllowedInConversation($var)
    {
        GPBUtil::checkBool($var);
        $this->allowed_in_conversation = $var;

        return $this;
    }

}

