<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/retail/v2/product_service.proto

namespace Google\Cloud\Retail\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [ProductService.ListProducts][google.cloud.retail.v2.ProductService.ListProducts]
 * method.
 *
 * Generated from protobuf message <code>google.cloud.retail.v2.ListProductsRequest</code>
 */
class ListProductsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent branch resource name, such as
     * `projects/&#42;&#47;locations/global/catalogs/default_catalog/branches/0`. Use
     * `default_branch` as the branch ID, to list products under the default
     * branch.
     * If the caller does not have permission to list
     * [Product][google.cloud.retail.v2.Product]s under this branch, regardless of
     * whether or not this branch exists, a PERMISSION_DENIED error is returned.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Maximum number of [Product][google.cloud.retail.v2.Product]s to return. If
     * unspecified, defaults to 100. The maximum allowed value is 1000. Values
     * above 1000 will be coerced to 1000.
     * If this field is negative, an INVALID_ARGUMENT error is returned.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     */
    protected $page_size = 0;
    /**
     * A page token
     * [ListProductsResponse.next_page_token][google.cloud.retail.v2.ListProductsResponse.next_page_token],
     * received from a previous
     * [ProductService.ListProducts][google.cloud.retail.v2.ProductService.ListProducts]
     * call. Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * [ProductService.ListProducts][google.cloud.retail.v2.ProductService.ListProducts]
     * must match the call that provided the page token. Otherwise, an
     * INVALID_ARGUMENT error is returned.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     */
    protected $page_token = '';
    /**
     * A filter to apply on the list results. Supported features:
     * * List all the products under the parent branch if
     * [filter][google.cloud.retail.v2.ListProductsRequest.filter] is unset.
     * * List [Product.Type.VARIANT][google.cloud.retail.v2.Product.Type.VARIANT]
     * [Product][google.cloud.retail.v2.Product]s sharing the same
     *   [Product.Type.PRIMARY][google.cloud.retail.v2.Product.Type.PRIMARY]
     *   [Product][google.cloud.retail.v2.Product]. For example:
     *     `primary_product_id = "some_product_id"`
     * * List [Product][google.cloud.retail.v2.Product]s bundled in a
     * [Product.Type.COLLECTION][google.cloud.retail.v2.Product.Type.COLLECTION]
     * [Product][google.cloud.retail.v2.Product].
     *   For example:
     *     `collection_product_id = "some_product_id"`
     * * List [Product][google.cloud.retail.v2.Product]s with a partibular type.
     * For example:
     *     `type = "PRIMARY"`
     *     `type = "VARIANT"`
     *     `type = "COLLECTION"`
     * If the field is unrecognizable, an INVALID_ARGUMENT error is returned.
     * If the specified
     * [Product.Type.PRIMARY][google.cloud.retail.v2.Product.Type.PRIMARY]
     * [Product][google.cloud.retail.v2.Product] or
     * [Product.Type.COLLECTION][google.cloud.retail.v2.Product.Type.COLLECTION]
     * [Product][google.cloud.retail.v2.Product] does not exist, a NOT_FOUND error
     * is returned.
     *
     * Generated from protobuf field <code>string filter = 4;</code>
     */
    protected $filter = '';
    /**
     * The fields of [Product][google.cloud.retail.v2.Product] to return in the
     * responses. If not set or empty, the following fields are returned:
     * * [Product.name][google.cloud.retail.v2.Product.name]
     * * [Product.id][google.cloud.retail.v2.Product.id]
     * * [Product.title][google.cloud.retail.v2.Product.title]
     * * [Product.uri][google.cloud.retail.v2.Product.uri]
     * * [Product.images][google.cloud.retail.v2.Product.images]
     * * [Product.price_info][google.cloud.retail.v2.Product.price_info]
     * * [Product.brands][google.cloud.retail.v2.Product.brands]
     * If "*" is provided, all fields are returned.
     * [Product.name][google.cloud.retail.v2.Product.name] is always returned no
     * matter what mask is set.
     * If an unsupported or unknown field is provided, an INVALID_ARGUMENT error
     * is returned.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask read_mask = 5;</code>
     */
    protected $read_mask = null;

    /**
     * @param string $parent Required. The parent branch resource name, such as
     *                       `projects/&#42;/locations/global/catalogs/default_catalog/branches/0`. Use
     *                       `default_branch` as the branch ID, to list products under the default
     *                       branch.
     *
     *                       If the caller does not have permission to list
     *                       [Product][google.cloud.retail.v2.Product]s under this branch, regardless of
     *                       whether or not this branch exists, a PERMISSION_DENIED error is returned. Please see
     *                       {@see ProductServiceClient::branchName()} for help formatting this field.
     *
     * @return \Google\Cloud\Retail\V2\ListProductsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent branch resource name, such as
     *           `projects/&#42;&#47;locations/global/catalogs/default_catalog/branches/0`. Use
     *           `default_branch` as the branch ID, to list products under the default
     *           branch.
     *           If the caller does not have permission to list
     *           [Product][google.cloud.retail.v2.Product]s under this branch, regardless of
     *           whether or not this branch exists, a PERMISSION_DENIED error is returned.
     *     @type int $page_size
     *           Maximum number of [Product][google.cloud.retail.v2.Product]s to return. If
     *           unspecified, defaults to 100. The maximum allowed value is 1000. Values
     *           above 1000 will be coerced to 1000.
     *           If this field is negative, an INVALID_ARGUMENT error is returned.
     *     @type string $page_token
     *           A page token
     *           [ListProductsResponse.next_page_token][google.cloud.retail.v2.ListProductsResponse.next_page_token],
     *           received from a previous
     *           [ProductService.ListProducts][google.cloud.retail.v2.ProductService.ListProducts]
     *           call. Provide this to retrieve the subsequent page.
     *           When paginating, all other parameters provided to
     *           [ProductService.ListProducts][google.cloud.retail.v2.ProductService.ListProducts]
     *           must match the call that provided the page token. Otherwise, an
     *           INVALID_ARGUMENT error is returned.
     *     @type string $filter
     *           A filter to apply on the list results. Supported features:
     *           * List all the products under the parent branch if
     *           [filter][google.cloud.retail.v2.ListProductsRequest.filter] is unset.
     *           * List [Product.Type.VARIANT][google.cloud.retail.v2.Product.Type.VARIANT]
     *           [Product][google.cloud.retail.v2.Product]s sharing the same
     *             [Product.Type.PRIMARY][google.cloud.retail.v2.Product.Type.PRIMARY]
     *             [Product][google.cloud.retail.v2.Product]. For example:
     *               `primary_product_id = "some_product_id"`
     *           * List [Product][google.cloud.retail.v2.Product]s bundled in a
     *           [Product.Type.COLLECTION][google.cloud.retail.v2.Product.Type.COLLECTION]
     *           [Product][google.cloud.retail.v2.Product].
     *             For example:
     *               `collection_product_id = "some_product_id"`
     *           * List [Product][google.cloud.retail.v2.Product]s with a partibular type.
     *           For example:
     *               `type = "PRIMARY"`
     *               `type = "VARIANT"`
     *               `type = "COLLECTION"`
     *           If the field is unrecognizable, an INVALID_ARGUMENT error is returned.
     *           If the specified
     *           [Product.Type.PRIMARY][google.cloud.retail.v2.Product.Type.PRIMARY]
     *           [Product][google.cloud.retail.v2.Product] or
     *           [Product.Type.COLLECTION][google.cloud.retail.v2.Product.Type.COLLECTION]
     *           [Product][google.cloud.retail.v2.Product] does not exist, a NOT_FOUND error
     *           is returned.
     *     @type \Google\Protobuf\FieldMask $read_mask
     *           The fields of [Product][google.cloud.retail.v2.Product] to return in the
     *           responses. If not set or empty, the following fields are returned:
     *           * [Product.name][google.cloud.retail.v2.Product.name]
     *           * [Product.id][google.cloud.retail.v2.Product.id]
     *           * [Product.title][google.cloud.retail.v2.Product.title]
     *           * [Product.uri][google.cloud.retail.v2.Product.uri]
     *           * [Product.images][google.cloud.retail.v2.Product.images]
     *           * [Product.price_info][google.cloud.retail.v2.Product.price_info]
     *           * [Product.brands][google.cloud.retail.v2.Product.brands]
     *           If "*" is provided, all fields are returned.
     *           [Product.name][google.cloud.retail.v2.Product.name] is always returned no
     *           matter what mask is set.
     *           If an unsupported or unknown field is provided, an INVALID_ARGUMENT error
     *           is returned.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Retail\V2\ProductService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent branch resource name, such as
     * `projects/&#42;&#47;locations/global/catalogs/default_catalog/branches/0`. Use
     * `default_branch` as the branch ID, to list products under the default
     * branch.
     * If the caller does not have permission to list
     * [Product][google.cloud.retail.v2.Product]s under this branch, regardless of
     * whether or not this branch exists, a PERMISSION_DENIED error is returned.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent branch resource name, such as
     * `projects/&#42;&#47;locations/global/catalogs/default_catalog/branches/0`. Use
     * `default_branch` as the branch ID, to list products under the default
     * branch.
     * If the caller does not have permission to list
     * [Product][google.cloud.retail.v2.Product]s under this branch, regardless of
     * whether or not this branch exists, a PERMISSION_DENIED error is returned.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Maximum number of [Product][google.cloud.retail.v2.Product]s to return. If
     * unspecified, defaults to 100. The maximum allowed value is 1000. Values
     * above 1000 will be coerced to 1000.
     * If this field is negative, an INVALID_ARGUMENT error is returned.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Maximum number of [Product][google.cloud.retail.v2.Product]s to return. If
     * unspecified, defaults to 100. The maximum allowed value is 1000. Values
     * above 1000 will be coerced to 1000.
     * If this field is negative, an INVALID_ARGUMENT error is returned.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * A page token
     * [ListProductsResponse.next_page_token][google.cloud.retail.v2.ListProductsResponse.next_page_token],
     * received from a previous
     * [ProductService.ListProducts][google.cloud.retail.v2.ProductService.ListProducts]
     * call. Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * [ProductService.ListProducts][google.cloud.retail.v2.ProductService.ListProducts]
     * must match the call that provided the page token. Otherwise, an
     * INVALID_ARGUMENT error is returned.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * A page token
     * [ListProductsResponse.next_page_token][google.cloud.retail.v2.ListProductsResponse.next_page_token],
     * received from a previous
     * [ProductService.ListProducts][google.cloud.retail.v2.ProductService.ListProducts]
     * call. Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * [ProductService.ListProducts][google.cloud.retail.v2.ProductService.ListProducts]
     * must match the call that provided the page token. Otherwise, an
     * INVALID_ARGUMENT error is returned.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * A filter to apply on the list results. Supported features:
     * * List all the products under the parent branch if
     * [filter][google.cloud.retail.v2.ListProductsRequest.filter] is unset.
     * * List [Product.Type.VARIANT][google.cloud.retail.v2.Product.Type.VARIANT]
     * [Product][google.cloud.retail.v2.Product]s sharing the same
     *   [Product.Type.PRIMARY][google.cloud.retail.v2.Product.Type.PRIMARY]
     *   [Product][google.cloud.retail.v2.Product]. For example:
     *     `primary_product_id = "some_product_id"`
     * * List [Product][google.cloud.retail.v2.Product]s bundled in a
     * [Product.Type.COLLECTION][google.cloud.retail.v2.Product.Type.COLLECTION]
     * [Product][google.cloud.retail.v2.Product].
     *   For example:
     *     `collection_product_id = "some_product_id"`
     * * List [Product][google.cloud.retail.v2.Product]s with a partibular type.
     * For example:
     *     `type = "PRIMARY"`
     *     `type = "VARIANT"`
     *     `type = "COLLECTION"`
     * If the field is unrecognizable, an INVALID_ARGUMENT error is returned.
     * If the specified
     * [Product.Type.PRIMARY][google.cloud.retail.v2.Product.Type.PRIMARY]
     * [Product][google.cloud.retail.v2.Product] or
     * [Product.Type.COLLECTION][google.cloud.retail.v2.Product.Type.COLLECTION]
     * [Product][google.cloud.retail.v2.Product] does not exist, a NOT_FOUND error
     * is returned.
     *
     * Generated from protobuf field <code>string filter = 4;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * A filter to apply on the list results. Supported features:
     * * List all the products under the parent branch if
     * [filter][google.cloud.retail.v2.ListProductsRequest.filter] is unset.
     * * List [Product.Type.VARIANT][google.cloud.retail.v2.Product.Type.VARIANT]
     * [Product][google.cloud.retail.v2.Product]s sharing the same
     *   [Product.Type.PRIMARY][google.cloud.retail.v2.Product.Type.PRIMARY]
     *   [Product][google.cloud.retail.v2.Product]. For example:
     *     `primary_product_id = "some_product_id"`
     * * List [Product][google.cloud.retail.v2.Product]s bundled in a
     * [Product.Type.COLLECTION][google.cloud.retail.v2.Product.Type.COLLECTION]
     * [Product][google.cloud.retail.v2.Product].
     *   For example:
     *     `collection_product_id = "some_product_id"`
     * * List [Product][google.cloud.retail.v2.Product]s with a partibular type.
     * For example:
     *     `type = "PRIMARY"`
     *     `type = "VARIANT"`
     *     `type = "COLLECTION"`
     * If the field is unrecognizable, an INVALID_ARGUMENT error is returned.
     * If the specified
     * [Product.Type.PRIMARY][google.cloud.retail.v2.Product.Type.PRIMARY]
     * [Product][google.cloud.retail.v2.Product] or
     * [Product.Type.COLLECTION][google.cloud.retail.v2.Product.Type.COLLECTION]
     * [Product][google.cloud.retail.v2.Product] does not exist, a NOT_FOUND error
     * is returned.
     *
     * Generated from protobuf field <code>string filter = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * The fields of [Product][google.cloud.retail.v2.Product] to return in the
     * responses. If not set or empty, the following fields are returned:
     * * [Product.name][google.cloud.retail.v2.Product.name]
     * * [Product.id][google.cloud.retail.v2.Product.id]
     * * [Product.title][google.cloud.retail.v2.Product.title]
     * * [Product.uri][google.cloud.retail.v2.Product.uri]
     * * [Product.images][google.cloud.retail.v2.Product.images]
     * * [Product.price_info][google.cloud.retail.v2.Product.price_info]
     * * [Product.brands][google.cloud.retail.v2.Product.brands]
     * If "*" is provided, all fields are returned.
     * [Product.name][google.cloud.retail.v2.Product.name] is always returned no
     * matter what mask is set.
     * If an unsupported or unknown field is provided, an INVALID_ARGUMENT error
     * is returned.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask read_mask = 5;</code>
     * @return \Google\Protobuf\FieldMask|null
     */
    public function getReadMask()
    {
        return $this->read_mask;
    }

    public function hasReadMask()
    {
        return isset($this->read_mask);
    }

    public function clearReadMask()
    {
        unset($this->read_mask);
    }

    /**
     * The fields of [Product][google.cloud.retail.v2.Product] to return in the
     * responses. If not set or empty, the following fields are returned:
     * * [Product.name][google.cloud.retail.v2.Product.name]
     * * [Product.id][google.cloud.retail.v2.Product.id]
     * * [Product.title][google.cloud.retail.v2.Product.title]
     * * [Product.uri][google.cloud.retail.v2.Product.uri]
     * * [Product.images][google.cloud.retail.v2.Product.images]
     * * [Product.price_info][google.cloud.retail.v2.Product.price_info]
     * * [Product.brands][google.cloud.retail.v2.Product.brands]
     * If "*" is provided, all fields are returned.
     * [Product.name][google.cloud.retail.v2.Product.name] is always returned no
     * matter what mask is set.
     * If an unsupported or unknown field is provided, an INVALID_ARGUMENT error
     * is returned.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask read_mask = 5;</code>
     * @param \Google\Protobuf\FieldMask $var
     * @return $this
     */
    public function setReadMask($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\FieldMask::class);
        $this->read_mask = $var;

        return $this;
    }

}

