<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/retail/v2/common.proto

namespace Google\Cloud\Retail\V2\Rule;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Force returns an attribute/facet in the request around a certain position
 * or above.
 * * Rule Condition:
 *   Must specify non-empty
 *   [Condition.query_terms][google.cloud.retail.v2.Condition.query_terms]
 *   (for search only) or
 *   [Condition.page_categories][google.cloud.retail.v2.Condition.page_categories]
 *   (for browse only), but can't specify both.
 * * Action Inputs: attribute name, position
 * * Action Result: Will force return a facet key around a certain position
 * or above if the condition is satisfied.
 * Example: Suppose the query is "shoes", the
 * [Condition.query_terms][google.cloud.retail.v2.Condition.query_terms] is
 * "shoes", the
 * [ForceReturnFacetAction.FacetPositionAdjustment.attribute_name][google.cloud.retail.v2.Rule.ForceReturnFacetAction.FacetPositionAdjustment.attribute_name]
 * is "size" and the
 * [ForceReturnFacetAction.FacetPositionAdjustment.position][google.cloud.retail.v2.Rule.ForceReturnFacetAction.FacetPositionAdjustment.position]
 * is 8.
 * Two cases: a) The facet key "size" is not already in the top 8 slots, then
 * the facet "size" will appear at a position close to 8. b) The facet key
 * "size" in among the top 8 positions in the request, then it will stay at
 * its current rank.
 *
 * Generated from protobuf message <code>google.cloud.retail.v2.Rule.ForceReturnFacetAction</code>
 */
class ForceReturnFacetAction extends \Google\Protobuf\Internal\Message
{
    /**
     * Each instance corresponds to a force return attribute for the given
     * condition. There can't be more 15 instances here.
     *
     * Generated from protobuf field <code>repeated .google.cloud.retail.v2.Rule.ForceReturnFacetAction.FacetPositionAdjustment facet_position_adjustments = 1;</code>
     */
    private $facet_position_adjustments;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type array<\Google\Cloud\Retail\V2\Rule\ForceReturnFacetAction\FacetPositionAdjustment>|\Google\Protobuf\Internal\RepeatedField $facet_position_adjustments
     *           Each instance corresponds to a force return attribute for the given
     *           condition. There can't be more 15 instances here.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Retail\V2\Common::initOnce();
        parent::__construct($data);
    }

    /**
     * Each instance corresponds to a force return attribute for the given
     * condition. There can't be more 15 instances here.
     *
     * Generated from protobuf field <code>repeated .google.cloud.retail.v2.Rule.ForceReturnFacetAction.FacetPositionAdjustment facet_position_adjustments = 1;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getFacetPositionAdjustments()
    {
        return $this->facet_position_adjustments;
    }

    /**
     * Each instance corresponds to a force return attribute for the given
     * condition. There can't be more 15 instances here.
     *
     * Generated from protobuf field <code>repeated .google.cloud.retail.v2.Rule.ForceReturnFacetAction.FacetPositionAdjustment facet_position_adjustments = 1;</code>
     * @param array<\Google\Cloud\Retail\V2\Rule\ForceReturnFacetAction\FacetPositionAdjustment>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setFacetPositionAdjustments($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Retail\V2\Rule\ForceReturnFacetAction\FacetPositionAdjustment::class);
        $this->facet_position_adjustments = $arr;

        return $this;
    }

}


