<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/run/v2/job.proto

namespace Google\Cloud\Run\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message to create a new Execution of a Job.
 *
 * Generated from protobuf message <code>google.cloud.run.v2.RunJobRequest</code>
 */
class RunJobRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The full name of the Job.
     * Format: projects/{project}/locations/{location}/jobs/{job}, where {project}
     * can be project id or number.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';
    /**
     * Indicates that the request should be validated without actually
     * deleting any resources.
     *
     * Generated from protobuf field <code>bool validate_only = 2;</code>
     */
    protected $validate_only = false;
    /**
     * A system-generated fingerprint for this version of the
     * resource. May be used to detect modification conflict during updates.
     *
     * Generated from protobuf field <code>string etag = 3;</code>
     */
    protected $etag = '';
    /**
     * Overrides specification for a given execution of a job. If provided,
     * overrides will be applied to update the execution or task spec.
     *
     * Generated from protobuf field <code>.google.cloud.run.v2.RunJobRequest.Overrides overrides = 4;</code>
     */
    protected $overrides = null;

    /**
     * @param string $name Required. The full name of the Job.
     *                     Format: projects/{project}/locations/{location}/jobs/{job}, where {project}
     *                     can be project id or number. Please see
     *                     {@see JobsClient::jobName()} for help formatting this field.
     *
     * @return \Google\Cloud\Run\V2\RunJobRequest
     *
     * @experimental
     */
    public static function build(string $name): self
    {
        return (new self())
            ->setName($name);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. The full name of the Job.
     *           Format: projects/{project}/locations/{location}/jobs/{job}, where {project}
     *           can be project id or number.
     *     @type bool $validate_only
     *           Indicates that the request should be validated without actually
     *           deleting any resources.
     *     @type string $etag
     *           A system-generated fingerprint for this version of the
     *           resource. May be used to detect modification conflict during updates.
     *     @type \Google\Cloud\Run\V2\RunJobRequest\Overrides $overrides
     *           Overrides specification for a given execution of a job. If provided,
     *           overrides will be applied to update the execution or task spec.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Run\V2\Job::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The full name of the Job.
     * Format: projects/{project}/locations/{location}/jobs/{job}, where {project}
     * can be project id or number.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. The full name of the Job.
     * Format: projects/{project}/locations/{location}/jobs/{job}, where {project}
     * can be project id or number.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Indicates that the request should be validated without actually
     * deleting any resources.
     *
     * Generated from protobuf field <code>bool validate_only = 2;</code>
     * @return bool
     */
    public function getValidateOnly()
    {
        return $this->validate_only;
    }

    /**
     * Indicates that the request should be validated without actually
     * deleting any resources.
     *
     * Generated from protobuf field <code>bool validate_only = 2;</code>
     * @param bool $var
     * @return $this
     */
    public function setValidateOnly($var)
    {
        GPBUtil::checkBool($var);
        $this->validate_only = $var;

        return $this;
    }

    /**
     * A system-generated fingerprint for this version of the
     * resource. May be used to detect modification conflict during updates.
     *
     * Generated from protobuf field <code>string etag = 3;</code>
     * @return string
     */
    public function getEtag()
    {
        return $this->etag;
    }

    /**
     * A system-generated fingerprint for this version of the
     * resource. May be used to detect modification conflict during updates.
     *
     * Generated from protobuf field <code>string etag = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setEtag($var)
    {
        GPBUtil::checkString($var, True);
        $this->etag = $var;

        return $this;
    }

    /**
     * Overrides specification for a given execution of a job. If provided,
     * overrides will be applied to update the execution or task spec.
     *
     * Generated from protobuf field <code>.google.cloud.run.v2.RunJobRequest.Overrides overrides = 4;</code>
     * @return \Google\Cloud\Run\V2\RunJobRequest\Overrides|null
     */
    public function getOverrides()
    {
        return $this->overrides;
    }

    public function hasOverrides()
    {
        return isset($this->overrides);
    }

    public function clearOverrides()
    {
        unset($this->overrides);
    }

    /**
     * Overrides specification for a given execution of a job. If provided,
     * overrides will be applied to update the execution or task spec.
     *
     * Generated from protobuf field <code>.google.cloud.run.v2.RunJobRequest.Overrides overrides = 4;</code>
     * @param \Google\Cloud\Run\V2\RunJobRequest\Overrides $var
     * @return $this
     */
    public function setOverrides($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Run\V2\RunJobRequest\Overrides::class);
        $this->overrides = $var;

        return $this;
    }

}

