<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/run/v2/vendor_settings.proto

namespace Google\Cloud\Run\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * VPC Access settings. For more information on sending traffic to a VPC
 * network, visit https://cloud.google.com/run/docs/configuring/connecting-vpc.
 *
 * Generated from protobuf message <code>google.cloud.run.v2.VpcAccess</code>
 */
class VpcAccess extends \Google\Protobuf\Internal\Message
{
    /**
     * VPC Access connector name.
     * Format: `projects/{project}/locations/{location}/connectors/{connector}`,
     * where `{project}` can be project id or number.
     * For more information on sending traffic to a VPC network via a connector,
     * visit https://cloud.google.com/run/docs/configuring/vpc-connectors.
     *
     * Generated from protobuf field <code>string connector = 1 [(.google.api.resource_reference) = {</code>
     */
    protected $connector = '';
    /**
     * Optional. Traffic VPC egress settings. If not provided, it defaults to
     * PRIVATE_RANGES_ONLY.
     *
     * Generated from protobuf field <code>.google.cloud.run.v2.VpcAccess.VpcEgress egress = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $egress = 0;
    /**
     * Optional. Direct VPC egress settings. Currently only single network
     * interface is supported.
     *
     * Generated from protobuf field <code>repeated .google.cloud.run.v2.VpcAccess.NetworkInterface network_interfaces = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $network_interfaces;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $connector
     *           VPC Access connector name.
     *           Format: `projects/{project}/locations/{location}/connectors/{connector}`,
     *           where `{project}` can be project id or number.
     *           For more information on sending traffic to a VPC network via a connector,
     *           visit https://cloud.google.com/run/docs/configuring/vpc-connectors.
     *     @type int $egress
     *           Optional. Traffic VPC egress settings. If not provided, it defaults to
     *           PRIVATE_RANGES_ONLY.
     *     @type array<\Google\Cloud\Run\V2\VpcAccess\NetworkInterface>|\Google\Protobuf\Internal\RepeatedField $network_interfaces
     *           Optional. Direct VPC egress settings. Currently only single network
     *           interface is supported.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Run\V2\VendorSettings::initOnce();
        parent::__construct($data);
    }

    /**
     * VPC Access connector name.
     * Format: `projects/{project}/locations/{location}/connectors/{connector}`,
     * where `{project}` can be project id or number.
     * For more information on sending traffic to a VPC network via a connector,
     * visit https://cloud.google.com/run/docs/configuring/vpc-connectors.
     *
     * Generated from protobuf field <code>string connector = 1 [(.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getConnector()
    {
        return $this->connector;
    }

    /**
     * VPC Access connector name.
     * Format: `projects/{project}/locations/{location}/connectors/{connector}`,
     * where `{project}` can be project id or number.
     * For more information on sending traffic to a VPC network via a connector,
     * visit https://cloud.google.com/run/docs/configuring/vpc-connectors.
     *
     * Generated from protobuf field <code>string connector = 1 [(.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setConnector($var)
    {
        GPBUtil::checkString($var, True);
        $this->connector = $var;

        return $this;
    }

    /**
     * Optional. Traffic VPC egress settings. If not provided, it defaults to
     * PRIVATE_RANGES_ONLY.
     *
     * Generated from protobuf field <code>.google.cloud.run.v2.VpcAccess.VpcEgress egress = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getEgress()
    {
        return $this->egress;
    }

    /**
     * Optional. Traffic VPC egress settings. If not provided, it defaults to
     * PRIVATE_RANGES_ONLY.
     *
     * Generated from protobuf field <code>.google.cloud.run.v2.VpcAccess.VpcEgress egress = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setEgress($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Run\V2\VpcAccess\VpcEgress::class);
        $this->egress = $var;

        return $this;
    }

    /**
     * Optional. Direct VPC egress settings. Currently only single network
     * interface is supported.
     *
     * Generated from protobuf field <code>repeated .google.cloud.run.v2.VpcAccess.NetworkInterface network_interfaces = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getNetworkInterfaces()
    {
        return $this->network_interfaces;
    }

    /**
     * Optional. Direct VPC egress settings. Currently only single network
     * interface is supported.
     *
     * Generated from protobuf field <code>repeated .google.cloud.run.v2.VpcAccess.NetworkInterface network_interfaces = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<\Google\Cloud\Run\V2\VpcAccess\NetworkInterface>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setNetworkInterfaces($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Run\V2\VpcAccess\NetworkInterface::class);
        $this->network_interfaces = $arr;

        return $this;
    }

}

