<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/securesourcemanager/v1/secure_source_manager.proto

namespace Google\Cloud\SecureSourceManager\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Metadata of a Secure Source Manager repository.
 *
 * Generated from protobuf message <code>google.cloud.securesourcemanager.v1.Repository</code>
 */
class Repository extends \Google\Protobuf\Internal\Message
{
    /**
     * Optional. A unique identifier for a repository. The name should be of the
     * format:
     * `projects/{project}/locations/{location_id}/repositories/{repository_id}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $name = '';
    /**
     * Optional. Description of the repository, which cannot exceed 500
     * characters.
     *
     * Generated from protobuf field <code>string description = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $description = '';
    /**
     * Optional. The name of the instance in which the repository is hosted,
     * formatted as
     * `projects/{project_number}/locations/{location_id}/instances/{instance_id}`
     * For data plane CreateRepository requests, this field is output only.
     * For control plane CreateRepository requests, this field is used as input.
     *
     * Generated from protobuf field <code>string instance = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $instance = '';
    /**
     * Output only. Unique identifier of the repository.
     *
     * Generated from protobuf field <code>string uid = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $uid = '';
    /**
     * Output only. Create timestamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. Update timestamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Optional. This checksum is computed by the server based on the value of
     * other fields, and may be sent on update and delete requests to ensure the
     * client has an up-to-date value before proceeding.
     *
     * Generated from protobuf field <code>string etag = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $etag = '';
    /**
     * Output only. URIs for the repository.
     *
     * Generated from protobuf field <code>.google.cloud.securesourcemanager.v1.Repository.URIs uris = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $uris = null;
    /**
     * Input only. Initial configurations for the repository.
     *
     * Generated from protobuf field <code>.google.cloud.securesourcemanager.v1.Repository.InitialConfig initial_config = 10 [(.google.api.field_behavior) = INPUT_ONLY];</code>
     */
    protected $initial_config = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Optional. A unique identifier for a repository. The name should be of the
     *           format:
     *           `projects/{project}/locations/{location_id}/repositories/{repository_id}`
     *     @type string $description
     *           Optional. Description of the repository, which cannot exceed 500
     *           characters.
     *     @type string $instance
     *           Optional. The name of the instance in which the repository is hosted,
     *           formatted as
     *           `projects/{project_number}/locations/{location_id}/instances/{instance_id}`
     *           For data plane CreateRepository requests, this field is output only.
     *           For control plane CreateRepository requests, this field is used as input.
     *     @type string $uid
     *           Output only. Unique identifier of the repository.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. Create timestamp.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. Update timestamp.
     *     @type string $etag
     *           Optional. This checksum is computed by the server based on the value of
     *           other fields, and may be sent on update and delete requests to ensure the
     *           client has an up-to-date value before proceeding.
     *     @type \Google\Cloud\SecureSourceManager\V1\Repository\URIs $uris
     *           Output only. URIs for the repository.
     *     @type \Google\Cloud\SecureSourceManager\V1\Repository\InitialConfig $initial_config
     *           Input only. Initial configurations for the repository.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Securesourcemanager\V1\SecureSourceManager::initOnce();
        parent::__construct($data);
    }

    /**
     * Optional. A unique identifier for a repository. The name should be of the
     * format:
     * `projects/{project}/locations/{location_id}/repositories/{repository_id}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Optional. A unique identifier for a repository. The name should be of the
     * format:
     * `projects/{project}/locations/{location_id}/repositories/{repository_id}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Optional. Description of the repository, which cannot exceed 500
     * characters.
     *
     * Generated from protobuf field <code>string description = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Optional. Description of the repository, which cannot exceed 500
     * characters.
     *
     * Generated from protobuf field <code>string description = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Optional. The name of the instance in which the repository is hosted,
     * formatted as
     * `projects/{project_number}/locations/{location_id}/instances/{instance_id}`
     * For data plane CreateRepository requests, this field is output only.
     * For control plane CreateRepository requests, this field is used as input.
     *
     * Generated from protobuf field <code>string instance = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getInstance()
    {
        return $this->instance;
    }

    /**
     * Optional. The name of the instance in which the repository is hosted,
     * formatted as
     * `projects/{project_number}/locations/{location_id}/instances/{instance_id}`
     * For data plane CreateRepository requests, this field is output only.
     * For control plane CreateRepository requests, this field is used as input.
     *
     * Generated from protobuf field <code>string instance = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setInstance($var)
    {
        GPBUtil::checkString($var, True);
        $this->instance = $var;

        return $this;
    }

    /**
     * Output only. Unique identifier of the repository.
     *
     * Generated from protobuf field <code>string uid = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getUid()
    {
        return $this->uid;
    }

    /**
     * Output only. Unique identifier of the repository.
     *
     * Generated from protobuf field <code>string uid = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setUid($var)
    {
        GPBUtil::checkString($var, True);
        $this->uid = $var;

        return $this;
    }

    /**
     * Output only. Create timestamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. Create timestamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. Update timestamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. Update timestamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Optional. This checksum is computed by the server based on the value of
     * other fields, and may be sent on update and delete requests to ensure the
     * client has an up-to-date value before proceeding.
     *
     * Generated from protobuf field <code>string etag = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getEtag()
    {
        return $this->etag;
    }

    /**
     * Optional. This checksum is computed by the server based on the value of
     * other fields, and may be sent on update and delete requests to ensure the
     * client has an up-to-date value before proceeding.
     *
     * Generated from protobuf field <code>string etag = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setEtag($var)
    {
        GPBUtil::checkString($var, True);
        $this->etag = $var;

        return $this;
    }

    /**
     * Output only. URIs for the repository.
     *
     * Generated from protobuf field <code>.google.cloud.securesourcemanager.v1.Repository.URIs uris = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\SecureSourceManager\V1\Repository\URIs|null
     */
    public function getUris()
    {
        return $this->uris;
    }

    public function hasUris()
    {
        return isset($this->uris);
    }

    public function clearUris()
    {
        unset($this->uris);
    }

    /**
     * Output only. URIs for the repository.
     *
     * Generated from protobuf field <code>.google.cloud.securesourcemanager.v1.Repository.URIs uris = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\SecureSourceManager\V1\Repository\URIs $var
     * @return $this
     */
    public function setUris($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\SecureSourceManager\V1\Repository\URIs::class);
        $this->uris = $var;

        return $this;
    }

    /**
     * Input only. Initial configurations for the repository.
     *
     * Generated from protobuf field <code>.google.cloud.securesourcemanager.v1.Repository.InitialConfig initial_config = 10 [(.google.api.field_behavior) = INPUT_ONLY];</code>
     * @return \Google\Cloud\SecureSourceManager\V1\Repository\InitialConfig|null
     */
    public function getInitialConfig()
    {
        return $this->initial_config;
    }

    public function hasInitialConfig()
    {
        return isset($this->initial_config);
    }

    public function clearInitialConfig()
    {
        unset($this->initial_config);
    }

    /**
     * Input only. Initial configurations for the repository.
     *
     * Generated from protobuf field <code>.google.cloud.securesourcemanager.v1.Repository.InitialConfig initial_config = 10 [(.google.api.field_behavior) = INPUT_ONLY];</code>
     * @param \Google\Cloud\SecureSourceManager\V1\Repository\InitialConfig $var
     * @return $this
     */
    public function setInitialConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\SecureSourceManager\V1\Repository\InitialConfig::class);
        $this->initial_config = $var;

        return $this;
    }

}

