<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/securitycenter/v1/container.proto

namespace Google\Cloud\SecurityCenter\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Container associated with the finding.
 *
 * Generated from protobuf message <code>google.cloud.securitycenter.v1.Container</code>
 */
class Container extends \Google\Protobuf\Internal\Message
{
    /**
     * Name of the container.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    protected $name = '';
    /**
     * Container image URI provided when configuring a pod or container. This
     * string can identify a container image version using mutable tags.
     *
     * Generated from protobuf field <code>string uri = 2;</code>
     */
    protected $uri = '';
    /**
     * Optional container image ID, if provided by the container runtime. Uniquely
     * identifies the container image launched using a container image digest.
     *
     * Generated from protobuf field <code>string image_id = 3;</code>
     */
    protected $image_id = '';
    /**
     * Container labels, as provided by the container runtime.
     *
     * Generated from protobuf field <code>repeated .google.cloud.securitycenter.v1.Label labels = 4;</code>
     */
    private $labels;
    /**
     * The time that the container was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5;</code>
     */
    protected $create_time = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Name of the container.
     *     @type string $uri
     *           Container image URI provided when configuring a pod or container. This
     *           string can identify a container image version using mutable tags.
     *     @type string $image_id
     *           Optional container image ID, if provided by the container runtime. Uniquely
     *           identifies the container image launched using a container image digest.
     *     @type array<\Google\Cloud\SecurityCenter\V1\Label>|\Google\Protobuf\Internal\RepeatedField $labels
     *           Container labels, as provided by the container runtime.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           The time that the container was created.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Securitycenter\V1\Container::initOnce();
        parent::__construct($data);
    }

    /**
     * Name of the container.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Name of the container.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Container image URI provided when configuring a pod or container. This
     * string can identify a container image version using mutable tags.
     *
     * Generated from protobuf field <code>string uri = 2;</code>
     * @return string
     */
    public function getUri()
    {
        return $this->uri;
    }

    /**
     * Container image URI provided when configuring a pod or container. This
     * string can identify a container image version using mutable tags.
     *
     * Generated from protobuf field <code>string uri = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->uri = $var;

        return $this;
    }

    /**
     * Optional container image ID, if provided by the container runtime. Uniquely
     * identifies the container image launched using a container image digest.
     *
     * Generated from protobuf field <code>string image_id = 3;</code>
     * @return string
     */
    public function getImageId()
    {
        return $this->image_id;
    }

    /**
     * Optional container image ID, if provided by the container runtime. Uniquely
     * identifies the container image launched using a container image digest.
     *
     * Generated from protobuf field <code>string image_id = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setImageId($var)
    {
        GPBUtil::checkString($var, True);
        $this->image_id = $var;

        return $this;
    }

    /**
     * Container labels, as provided by the container runtime.
     *
     * Generated from protobuf field <code>repeated .google.cloud.securitycenter.v1.Label labels = 4;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Container labels, as provided by the container runtime.
     *
     * Generated from protobuf field <code>repeated .google.cloud.securitycenter.v1.Label labels = 4;</code>
     * @param array<\Google\Cloud\SecurityCenter\V1\Label>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\SecurityCenter\V1\Label::class);
        $this->labels = $arr;

        return $this;
    }

    /**
     * The time that the container was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * The time that the container was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 5;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

}

