<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/securitycenter/v1/securitycenter_service.proto

namespace Google\Cloud\SecurityCenter\V1\ListFindingsResponse\ListFindingsResult;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Information related to the Google Cloud resource that is
 * associated with this finding.
 *
 * Generated from protobuf message <code>google.cloud.securitycenter.v1.ListFindingsResponse.ListFindingsResult.Resource</code>
 */
class Resource extends \Google\Protobuf\Internal\Message
{
    /**
     * The full resource name of the resource. See:
     * https://cloud.google.com/apis/design/resource_names#full_resource_name
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    protected $name = '';
    /**
     * The human readable name of the resource.
     *
     * Generated from protobuf field <code>string display_name = 8;</code>
     */
    protected $display_name = '';
    /**
     * The full resource type of the resource.
     *
     * Generated from protobuf field <code>string type = 6;</code>
     */
    protected $type = '';
    /**
     * The full resource name of project that the resource belongs to.
     *
     * Generated from protobuf field <code>string project_name = 2;</code>
     */
    protected $project_name = '';
    /**
     * The project ID that the resource belongs to.
     *
     * Generated from protobuf field <code>string project_display_name = 3;</code>
     */
    protected $project_display_name = '';
    /**
     * The full resource name of resource's parent.
     *
     * Generated from protobuf field <code>string parent_name = 4;</code>
     */
    protected $parent_name = '';
    /**
     * The human readable name of resource's parent.
     *
     * Generated from protobuf field <code>string parent_display_name = 5;</code>
     */
    protected $parent_display_name = '';
    /**
     * Contains a Folder message for each folder in the assets ancestry.
     * The first folder is the deepest nested folder, and the last folder is
     * the folder directly under the Organization.
     *
     * Generated from protobuf field <code>repeated .google.cloud.securitycenter.v1.Folder folders = 7;</code>
     */
    private $folders;
    /**
     * Indicates which cloud provider the finding is from.
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v1.CloudProvider cloud_provider = 9;</code>
     */
    protected $cloud_provider = 0;
    /**
     * Indicates which organization / tenant the finding is for.
     *
     * Generated from protobuf field <code>string organization = 10;</code>
     */
    protected $organization = '';
    /**
     * The service or resource provider associated with the resource.
     *
     * Generated from protobuf field <code>string service = 11;</code>
     */
    protected $service = '';
    /**
     * The region or location of the service (if applicable).
     *
     * Generated from protobuf field <code>string location = 12;</code>
     */
    protected $location = '';
    /**
     * Provides the path to the resource within the resource hierarchy.
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v1.ResourcePath resource_path = 18;</code>
     */
    protected $resource_path = null;
    /**
     * A string representation of the resource path.
     * For Google Cloud, it has the format of
     * `org/{organization_id}/folder/{folder_id}/folder/{folder_id}/project/{project_id}`
     * where there can be any number of folders.
     * For AWS, it has the format of
     * `org/{organization_id}/ou/{organizational_unit_id}/ou/{organizational_unit_id}/account/{account_id}`
     * where there can be any number of organizational units.
     * For Azure, it has the format of
     * `mg/{management_group_id}/mg/{management_group_id}/subscription/{subscription_id}/rg/{resource_group_name}`
     * where there can be any number of management groups.
     *
     * Generated from protobuf field <code>string resource_path_string = 19;</code>
     */
    protected $resource_path_string = '';
    protected $cloud_provider_metadata;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           The full resource name of the resource. See:
     *           https://cloud.google.com/apis/design/resource_names#full_resource_name
     *     @type string $display_name
     *           The human readable name of the resource.
     *     @type string $type
     *           The full resource type of the resource.
     *     @type string $project_name
     *           The full resource name of project that the resource belongs to.
     *     @type string $project_display_name
     *           The project ID that the resource belongs to.
     *     @type string $parent_name
     *           The full resource name of resource's parent.
     *     @type string $parent_display_name
     *           The human readable name of resource's parent.
     *     @type array<\Google\Cloud\SecurityCenter\V1\Folder>|\Google\Protobuf\Internal\RepeatedField $folders
     *           Contains a Folder message for each folder in the assets ancestry.
     *           The first folder is the deepest nested folder, and the last folder is
     *           the folder directly under the Organization.
     *     @type int $cloud_provider
     *           Indicates which cloud provider the finding is from.
     *     @type string $organization
     *           Indicates which organization / tenant the finding is for.
     *     @type string $service
     *           The service or resource provider associated with the resource.
     *     @type string $location
     *           The region or location of the service (if applicable).
     *     @type \Google\Cloud\SecurityCenter\V1\AwsMetadata $aws_metadata
     *           The AWS metadata associated with the finding.
     *     @type \Google\Cloud\SecurityCenter\V1\AzureMetadata $azure_metadata
     *           The Azure metadata associated with the finding.
     *     @type \Google\Cloud\SecurityCenter\V1\ResourcePath $resource_path
     *           Provides the path to the resource within the resource hierarchy.
     *     @type string $resource_path_string
     *           A string representation of the resource path.
     *           For Google Cloud, it has the format of
     *           `org/{organization_id}/folder/{folder_id}/folder/{folder_id}/project/{project_id}`
     *           where there can be any number of folders.
     *           For AWS, it has the format of
     *           `org/{organization_id}/ou/{organizational_unit_id}/ou/{organizational_unit_id}/account/{account_id}`
     *           where there can be any number of organizational units.
     *           For Azure, it has the format of
     *           `mg/{management_group_id}/mg/{management_group_id}/subscription/{subscription_id}/rg/{resource_group_name}`
     *           where there can be any number of management groups.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Securitycenter\V1\SecuritycenterService::initOnce();
        parent::__construct($data);
    }

    /**
     * The full resource name of the resource. See:
     * https://cloud.google.com/apis/design/resource_names#full_resource_name
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * The full resource name of the resource. See:
     * https://cloud.google.com/apis/design/resource_names#full_resource_name
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The human readable name of the resource.
     *
     * Generated from protobuf field <code>string display_name = 8;</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * The human readable name of the resource.
     *
     * Generated from protobuf field <code>string display_name = 8;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * The full resource type of the resource.
     *
     * Generated from protobuf field <code>string type = 6;</code>
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * The full resource type of the resource.
     *
     * Generated from protobuf field <code>string type = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setType($var)
    {
        GPBUtil::checkString($var, True);
        $this->type = $var;

        return $this;
    }

    /**
     * The full resource name of project that the resource belongs to.
     *
     * Generated from protobuf field <code>string project_name = 2;</code>
     * @return string
     */
    public function getProjectName()
    {
        return $this->project_name;
    }

    /**
     * The full resource name of project that the resource belongs to.
     *
     * Generated from protobuf field <code>string project_name = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setProjectName($var)
    {
        GPBUtil::checkString($var, True);
        $this->project_name = $var;

        return $this;
    }

    /**
     * The project ID that the resource belongs to.
     *
     * Generated from protobuf field <code>string project_display_name = 3;</code>
     * @return string
     */
    public function getProjectDisplayName()
    {
        return $this->project_display_name;
    }

    /**
     * The project ID that the resource belongs to.
     *
     * Generated from protobuf field <code>string project_display_name = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setProjectDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->project_display_name = $var;

        return $this;
    }

    /**
     * The full resource name of resource's parent.
     *
     * Generated from protobuf field <code>string parent_name = 4;</code>
     * @return string
     */
    public function getParentName()
    {
        return $this->parent_name;
    }

    /**
     * The full resource name of resource's parent.
     *
     * Generated from protobuf field <code>string parent_name = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setParentName($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent_name = $var;

        return $this;
    }

    /**
     * The human readable name of resource's parent.
     *
     * Generated from protobuf field <code>string parent_display_name = 5;</code>
     * @return string
     */
    public function getParentDisplayName()
    {
        return $this->parent_display_name;
    }

    /**
     * The human readable name of resource's parent.
     *
     * Generated from protobuf field <code>string parent_display_name = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setParentDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent_display_name = $var;

        return $this;
    }

    /**
     * Contains a Folder message for each folder in the assets ancestry.
     * The first folder is the deepest nested folder, and the last folder is
     * the folder directly under the Organization.
     *
     * Generated from protobuf field <code>repeated .google.cloud.securitycenter.v1.Folder folders = 7;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getFolders()
    {
        return $this->folders;
    }

    /**
     * Contains a Folder message for each folder in the assets ancestry.
     * The first folder is the deepest nested folder, and the last folder is
     * the folder directly under the Organization.
     *
     * Generated from protobuf field <code>repeated .google.cloud.securitycenter.v1.Folder folders = 7;</code>
     * @param array<\Google\Cloud\SecurityCenter\V1\Folder>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setFolders($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\SecurityCenter\V1\Folder::class);
        $this->folders = $arr;

        return $this;
    }

    /**
     * Indicates which cloud provider the finding is from.
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v1.CloudProvider cloud_provider = 9;</code>
     * @return int
     */
    public function getCloudProvider()
    {
        return $this->cloud_provider;
    }

    /**
     * Indicates which cloud provider the finding is from.
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v1.CloudProvider cloud_provider = 9;</code>
     * @param int $var
     * @return $this
     */
    public function setCloudProvider($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\SecurityCenter\V1\CloudProvider::class);
        $this->cloud_provider = $var;

        return $this;
    }

    /**
     * Indicates which organization / tenant the finding is for.
     *
     * Generated from protobuf field <code>string organization = 10;</code>
     * @return string
     */
    public function getOrganization()
    {
        return $this->organization;
    }

    /**
     * Indicates which organization / tenant the finding is for.
     *
     * Generated from protobuf field <code>string organization = 10;</code>
     * @param string $var
     * @return $this
     */
    public function setOrganization($var)
    {
        GPBUtil::checkString($var, True);
        $this->organization = $var;

        return $this;
    }

    /**
     * The service or resource provider associated with the resource.
     *
     * Generated from protobuf field <code>string service = 11;</code>
     * @return string
     */
    public function getService()
    {
        return $this->service;
    }

    /**
     * The service or resource provider associated with the resource.
     *
     * Generated from protobuf field <code>string service = 11;</code>
     * @param string $var
     * @return $this
     */
    public function setService($var)
    {
        GPBUtil::checkString($var, True);
        $this->service = $var;

        return $this;
    }

    /**
     * The region or location of the service (if applicable).
     *
     * Generated from protobuf field <code>string location = 12;</code>
     * @return string
     */
    public function getLocation()
    {
        return $this->location;
    }

    /**
     * The region or location of the service (if applicable).
     *
     * Generated from protobuf field <code>string location = 12;</code>
     * @param string $var
     * @return $this
     */
    public function setLocation($var)
    {
        GPBUtil::checkString($var, True);
        $this->location = $var;

        return $this;
    }

    /**
     * The AWS metadata associated with the finding.
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v1.AwsMetadata aws_metadata = 16;</code>
     * @return \Google\Cloud\SecurityCenter\V1\AwsMetadata|null
     */
    public function getAwsMetadata()
    {
        return $this->readOneof(16);
    }

    public function hasAwsMetadata()
    {
        return $this->hasOneof(16);
    }

    /**
     * The AWS metadata associated with the finding.
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v1.AwsMetadata aws_metadata = 16;</code>
     * @param \Google\Cloud\SecurityCenter\V1\AwsMetadata $var
     * @return $this
     */
    public function setAwsMetadata($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\SecurityCenter\V1\AwsMetadata::class);
        $this->writeOneof(16, $var);

        return $this;
    }

    /**
     * The Azure metadata associated with the finding.
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v1.AzureMetadata azure_metadata = 17;</code>
     * @return \Google\Cloud\SecurityCenter\V1\AzureMetadata|null
     */
    public function getAzureMetadata()
    {
        return $this->readOneof(17);
    }

    public function hasAzureMetadata()
    {
        return $this->hasOneof(17);
    }

    /**
     * The Azure metadata associated with the finding.
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v1.AzureMetadata azure_metadata = 17;</code>
     * @param \Google\Cloud\SecurityCenter\V1\AzureMetadata $var
     * @return $this
     */
    public function setAzureMetadata($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\SecurityCenter\V1\AzureMetadata::class);
        $this->writeOneof(17, $var);

        return $this;
    }

    /**
     * Provides the path to the resource within the resource hierarchy.
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v1.ResourcePath resource_path = 18;</code>
     * @return \Google\Cloud\SecurityCenter\V1\ResourcePath|null
     */
    public function getResourcePath()
    {
        return $this->resource_path;
    }

    public function hasResourcePath()
    {
        return isset($this->resource_path);
    }

    public function clearResourcePath()
    {
        unset($this->resource_path);
    }

    /**
     * Provides the path to the resource within the resource hierarchy.
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v1.ResourcePath resource_path = 18;</code>
     * @param \Google\Cloud\SecurityCenter\V1\ResourcePath $var
     * @return $this
     */
    public function setResourcePath($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\SecurityCenter\V1\ResourcePath::class);
        $this->resource_path = $var;

        return $this;
    }

    /**
     * A string representation of the resource path.
     * For Google Cloud, it has the format of
     * `org/{organization_id}/folder/{folder_id}/folder/{folder_id}/project/{project_id}`
     * where there can be any number of folders.
     * For AWS, it has the format of
     * `org/{organization_id}/ou/{organizational_unit_id}/ou/{organizational_unit_id}/account/{account_id}`
     * where there can be any number of organizational units.
     * For Azure, it has the format of
     * `mg/{management_group_id}/mg/{management_group_id}/subscription/{subscription_id}/rg/{resource_group_name}`
     * where there can be any number of management groups.
     *
     * Generated from protobuf field <code>string resource_path_string = 19;</code>
     * @return string
     */
    public function getResourcePathString()
    {
        return $this->resource_path_string;
    }

    /**
     * A string representation of the resource path.
     * For Google Cloud, it has the format of
     * `org/{organization_id}/folder/{folder_id}/folder/{folder_id}/project/{project_id}`
     * where there can be any number of folders.
     * For AWS, it has the format of
     * `org/{organization_id}/ou/{organizational_unit_id}/ou/{organizational_unit_id}/account/{account_id}`
     * where there can be any number of organizational units.
     * For Azure, it has the format of
     * `mg/{management_group_id}/mg/{management_group_id}/subscription/{subscription_id}/rg/{resource_group_name}`
     * where there can be any number of management groups.
     *
     * Generated from protobuf field <code>string resource_path_string = 19;</code>
     * @param string $var
     * @return $this
     */
    public function setResourcePathString($var)
    {
        GPBUtil::checkString($var, True);
        $this->resource_path_string = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getCloudProviderMetadata()
    {
        return $this->whichOneof("cloud_provider_metadata");
    }

}


