<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/securitycenter/v2/cloud_armor.proto

namespace Google\Cloud\SecurityCenter\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Fields related to Google Cloud Armor findings.
 *
 * Generated from protobuf message <code>google.cloud.securitycenter.v2.CloudArmor</code>
 */
class CloudArmor extends \Google\Protobuf\Internal\Message
{
    /**
     * Information about the [Google Cloud Armor security
     * policy](https://cloud.google.com/armor/docs/security-policy-overview)
     * relevant to the finding.
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v2.SecurityPolicy security_policy = 1;</code>
     */
    protected $security_policy = null;
    /**
     * Information about incoming requests evaluated by [Google Cloud Armor
     * security
     * policies](https://cloud.google.com/armor/docs/security-policy-overview).
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v2.Requests requests = 2;</code>
     */
    protected $requests = null;
    /**
     * Information about potential Layer 7 DDoS attacks identified by [Google
     * Cloud Armor Adaptive
     * Protection](https://cloud.google.com/armor/docs/adaptive-protection-overview).
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v2.AdaptiveProtection adaptive_protection = 3;</code>
     */
    protected $adaptive_protection = null;
    /**
     * Information about DDoS attack volume and classification.
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v2.Attack attack = 4;</code>
     */
    protected $attack = null;
    /**
     * Distinguish between volumetric & protocol DDoS attack and
     * application layer attacks. For example, "L3_4" for Layer 3 and Layer 4 DDoS
     * attacks, or "L_7" for Layer 7 DDoS attacks.
     *
     * Generated from protobuf field <code>string threat_vector = 5;</code>
     */
    protected $threat_vector = '';
    /**
     * Duration of attack from the start until the current moment (updated every 5
     * minutes).
     *
     * Generated from protobuf field <code>.google.protobuf.Duration duration = 6;</code>
     */
    protected $duration = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\SecurityCenter\V2\SecurityPolicy $security_policy
     *           Information about the [Google Cloud Armor security
     *           policy](https://cloud.google.com/armor/docs/security-policy-overview)
     *           relevant to the finding.
     *     @type \Google\Cloud\SecurityCenter\V2\Requests $requests
     *           Information about incoming requests evaluated by [Google Cloud Armor
     *           security
     *           policies](https://cloud.google.com/armor/docs/security-policy-overview).
     *     @type \Google\Cloud\SecurityCenter\V2\AdaptiveProtection $adaptive_protection
     *           Information about potential Layer 7 DDoS attacks identified by [Google
     *           Cloud Armor Adaptive
     *           Protection](https://cloud.google.com/armor/docs/adaptive-protection-overview).
     *     @type \Google\Cloud\SecurityCenter\V2\Attack $attack
     *           Information about DDoS attack volume and classification.
     *     @type string $threat_vector
     *           Distinguish between volumetric & protocol DDoS attack and
     *           application layer attacks. For example, "L3_4" for Layer 3 and Layer 4 DDoS
     *           attacks, or "L_7" for Layer 7 DDoS attacks.
     *     @type \Google\Protobuf\Duration $duration
     *           Duration of attack from the start until the current moment (updated every 5
     *           minutes).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Securitycenter\V2\CloudArmor::initOnce();
        parent::__construct($data);
    }

    /**
     * Information about the [Google Cloud Armor security
     * policy](https://cloud.google.com/armor/docs/security-policy-overview)
     * relevant to the finding.
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v2.SecurityPolicy security_policy = 1;</code>
     * @return \Google\Cloud\SecurityCenter\V2\SecurityPolicy|null
     */
    public function getSecurityPolicy()
    {
        return $this->security_policy;
    }

    public function hasSecurityPolicy()
    {
        return isset($this->security_policy);
    }

    public function clearSecurityPolicy()
    {
        unset($this->security_policy);
    }

    /**
     * Information about the [Google Cloud Armor security
     * policy](https://cloud.google.com/armor/docs/security-policy-overview)
     * relevant to the finding.
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v2.SecurityPolicy security_policy = 1;</code>
     * @param \Google\Cloud\SecurityCenter\V2\SecurityPolicy $var
     * @return $this
     */
    public function setSecurityPolicy($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\SecurityCenter\V2\SecurityPolicy::class);
        $this->security_policy = $var;

        return $this;
    }

    /**
     * Information about incoming requests evaluated by [Google Cloud Armor
     * security
     * policies](https://cloud.google.com/armor/docs/security-policy-overview).
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v2.Requests requests = 2;</code>
     * @return \Google\Cloud\SecurityCenter\V2\Requests|null
     */
    public function getRequests()
    {
        return $this->requests;
    }

    public function hasRequests()
    {
        return isset($this->requests);
    }

    public function clearRequests()
    {
        unset($this->requests);
    }

    /**
     * Information about incoming requests evaluated by [Google Cloud Armor
     * security
     * policies](https://cloud.google.com/armor/docs/security-policy-overview).
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v2.Requests requests = 2;</code>
     * @param \Google\Cloud\SecurityCenter\V2\Requests $var
     * @return $this
     */
    public function setRequests($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\SecurityCenter\V2\Requests::class);
        $this->requests = $var;

        return $this;
    }

    /**
     * Information about potential Layer 7 DDoS attacks identified by [Google
     * Cloud Armor Adaptive
     * Protection](https://cloud.google.com/armor/docs/adaptive-protection-overview).
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v2.AdaptiveProtection adaptive_protection = 3;</code>
     * @return \Google\Cloud\SecurityCenter\V2\AdaptiveProtection|null
     */
    public function getAdaptiveProtection()
    {
        return $this->adaptive_protection;
    }

    public function hasAdaptiveProtection()
    {
        return isset($this->adaptive_protection);
    }

    public function clearAdaptiveProtection()
    {
        unset($this->adaptive_protection);
    }

    /**
     * Information about potential Layer 7 DDoS attacks identified by [Google
     * Cloud Armor Adaptive
     * Protection](https://cloud.google.com/armor/docs/adaptive-protection-overview).
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v2.AdaptiveProtection adaptive_protection = 3;</code>
     * @param \Google\Cloud\SecurityCenter\V2\AdaptiveProtection $var
     * @return $this
     */
    public function setAdaptiveProtection($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\SecurityCenter\V2\AdaptiveProtection::class);
        $this->adaptive_protection = $var;

        return $this;
    }

    /**
     * Information about DDoS attack volume and classification.
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v2.Attack attack = 4;</code>
     * @return \Google\Cloud\SecurityCenter\V2\Attack|null
     */
    public function getAttack()
    {
        return $this->attack;
    }

    public function hasAttack()
    {
        return isset($this->attack);
    }

    public function clearAttack()
    {
        unset($this->attack);
    }

    /**
     * Information about DDoS attack volume and classification.
     *
     * Generated from protobuf field <code>.google.cloud.securitycenter.v2.Attack attack = 4;</code>
     * @param \Google\Cloud\SecurityCenter\V2\Attack $var
     * @return $this
     */
    public function setAttack($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\SecurityCenter\V2\Attack::class);
        $this->attack = $var;

        return $this;
    }

    /**
     * Distinguish between volumetric & protocol DDoS attack and
     * application layer attacks. For example, "L3_4" for Layer 3 and Layer 4 DDoS
     * attacks, or "L_7" for Layer 7 DDoS attacks.
     *
     * Generated from protobuf field <code>string threat_vector = 5;</code>
     * @return string
     */
    public function getThreatVector()
    {
        return $this->threat_vector;
    }

    /**
     * Distinguish between volumetric & protocol DDoS attack and
     * application layer attacks. For example, "L3_4" for Layer 3 and Layer 4 DDoS
     * attacks, or "L_7" for Layer 7 DDoS attacks.
     *
     * Generated from protobuf field <code>string threat_vector = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setThreatVector($var)
    {
        GPBUtil::checkString($var, True);
        $this->threat_vector = $var;

        return $this;
    }

    /**
     * Duration of attack from the start until the current moment (updated every 5
     * minutes).
     *
     * Generated from protobuf field <code>.google.protobuf.Duration duration = 6;</code>
     * @return \Google\Protobuf\Duration|null
     */
    public function getDuration()
    {
        return $this->duration;
    }

    public function hasDuration()
    {
        return isset($this->duration);
    }

    public function clearDuration()
    {
        unset($this->duration);
    }

    /**
     * Duration of attack from the start until the current moment (updated every 5
     * minutes).
     *
     * Generated from protobuf field <code>.google.protobuf.Duration duration = 6;</code>
     * @param \Google\Protobuf\Duration $var
     * @return $this
     */
    public function setDuration($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Duration::class);
        $this->duration = $var;

        return $this;
    }

}

