<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/securitycenter/v2/securitycenter_service.proto

namespace Google\Cloud\SecurityCenter\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message to list resource value configs of a parent
 *
 * Generated from protobuf message <code>google.cloud.securitycenter.v2.ListResourceValueConfigsRequest</code>
 */
class ListResourceValueConfigsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent, which owns the collection of resource value configs.
     * Its format is
     * `organizations/[organization_id]`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * The maximum number of configs to return. The service may return fewer than
     * this value.
     * If unspecified, at most 10 configs will be returned.
     * The maximum value is 1000; values above 1000 will be coerced to 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     */
    protected $page_size = 0;
    /**
     * A page token, received from a previous `ListResourceValueConfigs` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * `ListResourceValueConfigs` must match the call that provided the
     * page token.
     * page_size can be specified, and the new page_size will be used.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     */
    protected $page_token = '';

    /**
     * @param string $parent Required. The parent, which owns the collection of resource value configs.
     *                       Its format is
     *                       `organizations/[organization_id]`
     *                       Please see {@see SecurityCenterClient::organizationLocationName()} for help formatting this field.
     *
     * @return \Google\Cloud\SecurityCenter\V2\ListResourceValueConfigsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent, which owns the collection of resource value configs.
     *           Its format is
     *           `organizations/[organization_id]`
     *     @type int $page_size
     *           The maximum number of configs to return. The service may return fewer than
     *           this value.
     *           If unspecified, at most 10 configs will be returned.
     *           The maximum value is 1000; values above 1000 will be coerced to 1000.
     *     @type string $page_token
     *           A page token, received from a previous `ListResourceValueConfigs` call.
     *           Provide this to retrieve the subsequent page.
     *           When paginating, all other parameters provided to
     *           `ListResourceValueConfigs` must match the call that provided the
     *           page token.
     *           page_size can be specified, and the new page_size will be used.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Securitycenter\V2\SecuritycenterService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent, which owns the collection of resource value configs.
     * Its format is
     * `organizations/[organization_id]`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent, which owns the collection of resource value configs.
     * Its format is
     * `organizations/[organization_id]`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * The maximum number of configs to return. The service may return fewer than
     * this value.
     * If unspecified, at most 10 configs will be returned.
     * The maximum value is 1000; values above 1000 will be coerced to 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The maximum number of configs to return. The service may return fewer than
     * this value.
     * If unspecified, at most 10 configs will be returned.
     * The maximum value is 1000; values above 1000 will be coerced to 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * A page token, received from a previous `ListResourceValueConfigs` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * `ListResourceValueConfigs` must match the call that provided the
     * page token.
     * page_size can be specified, and the new page_size will be used.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * A page token, received from a previous `ListResourceValueConfigs` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * `ListResourceValueConfigs` must match the call that provided the
     * page token.
     * page_size can be specified, and the new page_size will be used.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

