<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/servicedirectory/v1/endpoint.proto

namespace Google\Cloud\ServiceDirectory\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An individual endpoint that provides a
 * [service][google.cloud.servicedirectory.v1.Service]. The service must
 * already exist to create an endpoint.
 *
 * Generated from protobuf message <code>google.cloud.servicedirectory.v1.Endpoint</code>
 */
class Endpoint extends \Google\Protobuf\Internal\Message
{
    /**
     * Immutable. The resource name for the endpoint in the format
     * `projects/&#42;&#47;locations/&#42;&#47;namespaces/&#42;&#47;services/&#42;&#47;endpoints/&#42;`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IMMUTABLE];</code>
     */
    protected $name = '';
    /**
     * Optional. An IPv4 or IPv6 address. Service Directory rejects bad addresses
     * like:
     * *   `8.8.8`
     * *   `8.8.8.8:53`
     * *   `test:bad:address`
     * *   `[::1]`
     * *   `[::1]:8080`
     * Limited to 45 characters.
     *
     * Generated from protobuf field <code>string address = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $address = '';
    /**
     * Optional. Service Directory rejects values outside of `[0, 65535]`.
     *
     * Generated from protobuf field <code>int32 port = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $port = 0;
    /**
     * Optional. Annotations for the endpoint. This data can be consumed by
     * service clients.
     * Restrictions:
     * *   The entire annotations dictionary may contain up to 512 characters,
     *     spread accoss all key-value pairs. Annotations that go beyond this
     *     limit are rejected
     * *   Valid annotation keys have two segments: an optional prefix and name,
     *     separated by a slash (/). The name segment is required and must be 63
     *     characters or less, beginning and ending with an alphanumeric character
     *     ([a-z0-9A-Z]) with dashes (-), underscores (_), dots (.), and
     *     alphanumerics between. The prefix is optional. If specified, the prefix
     *     must be a DNS subdomain: a series of DNS labels separated by dots (.),
     *     not longer than 253 characters in total, followed by a slash (/)
     *     Annotations that fails to meet these requirements are rejected.
     * Note: This field is equivalent to the `metadata` field in the v1beta1 API.
     * They have the same syntax and read/write to the same location in Service
     * Directory.
     *
     * Generated from protobuf field <code>map<string, string> annotations = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $annotations;
    /**
     * Immutable. The Google Compute Engine network (VPC) of the endpoint in the
     * format `projects/<project number>/locations/global/networks/&#42;`.
     * The project must be specified by project number (project id is rejected).
     * Incorrectly formatted networks are rejected, we also check to make sure
     * that you have the servicedirectory.networks.attach permission on the
     * project specified.
     *
     * Generated from protobuf field <code>string network = 8 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.resource_reference) = {</code>
     */
    protected $network = '';
    /**
     * Output only. The globally unique identifier of the endpoint in the UUID4
     * format.
     *
     * Generated from protobuf field <code>string uid = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $uid = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Immutable. The resource name for the endpoint in the format
     *           `projects/&#42;&#47;locations/&#42;&#47;namespaces/&#42;&#47;services/&#42;&#47;endpoints/&#42;`.
     *     @type string $address
     *           Optional. An IPv4 or IPv6 address. Service Directory rejects bad addresses
     *           like:
     *           *   `8.8.8`
     *           *   `8.8.8.8:53`
     *           *   `test:bad:address`
     *           *   `[::1]`
     *           *   `[::1]:8080`
     *           Limited to 45 characters.
     *     @type int $port
     *           Optional. Service Directory rejects values outside of `[0, 65535]`.
     *     @type array|\Google\Protobuf\Internal\MapField $annotations
     *           Optional. Annotations for the endpoint. This data can be consumed by
     *           service clients.
     *           Restrictions:
     *           *   The entire annotations dictionary may contain up to 512 characters,
     *               spread accoss all key-value pairs. Annotations that go beyond this
     *               limit are rejected
     *           *   Valid annotation keys have two segments: an optional prefix and name,
     *               separated by a slash (/). The name segment is required and must be 63
     *               characters or less, beginning and ending with an alphanumeric character
     *               ([a-z0-9A-Z]) with dashes (-), underscores (_), dots (.), and
     *               alphanumerics between. The prefix is optional. If specified, the prefix
     *               must be a DNS subdomain: a series of DNS labels separated by dots (.),
     *               not longer than 253 characters in total, followed by a slash (/)
     *               Annotations that fails to meet these requirements are rejected.
     *           Note: This field is equivalent to the `metadata` field in the v1beta1 API.
     *           They have the same syntax and read/write to the same location in Service
     *           Directory.
     *     @type string $network
     *           Immutable. The Google Compute Engine network (VPC) of the endpoint in the
     *           format `projects/<project number>/locations/global/networks/&#42;`.
     *           The project must be specified by project number (project id is rejected).
     *           Incorrectly formatted networks are rejected, we also check to make sure
     *           that you have the servicedirectory.networks.attach permission on the
     *           project specified.
     *     @type string $uid
     *           Output only. The globally unique identifier of the endpoint in the UUID4
     *           format.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Servicedirectory\V1\Endpoint::initOnce();
        parent::__construct($data);
    }

    /**
     * Immutable. The resource name for the endpoint in the format
     * `projects/&#42;&#47;locations/&#42;&#47;namespaces/&#42;&#47;services/&#42;&#47;endpoints/&#42;`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Immutable. The resource name for the endpoint in the format
     * `projects/&#42;&#47;locations/&#42;&#47;namespaces/&#42;&#47;services/&#42;&#47;endpoints/&#42;`.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Optional. An IPv4 or IPv6 address. Service Directory rejects bad addresses
     * like:
     * *   `8.8.8`
     * *   `8.8.8.8:53`
     * *   `test:bad:address`
     * *   `[::1]`
     * *   `[::1]:8080`
     * Limited to 45 characters.
     *
     * Generated from protobuf field <code>string address = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getAddress()
    {
        return $this->address;
    }

    /**
     * Optional. An IPv4 or IPv6 address. Service Directory rejects bad addresses
     * like:
     * *   `8.8.8`
     * *   `8.8.8.8:53`
     * *   `test:bad:address`
     * *   `[::1]`
     * *   `[::1]:8080`
     * Limited to 45 characters.
     *
     * Generated from protobuf field <code>string address = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setAddress($var)
    {
        GPBUtil::checkString($var, True);
        $this->address = $var;

        return $this;
    }

    /**
     * Optional. Service Directory rejects values outside of `[0, 65535]`.
     *
     * Generated from protobuf field <code>int32 port = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPort()
    {
        return $this->port;
    }

    /**
     * Optional. Service Directory rejects values outside of `[0, 65535]`.
     *
     * Generated from protobuf field <code>int32 port = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPort($var)
    {
        GPBUtil::checkInt32($var);
        $this->port = $var;

        return $this;
    }

    /**
     * Optional. Annotations for the endpoint. This data can be consumed by
     * service clients.
     * Restrictions:
     * *   The entire annotations dictionary may contain up to 512 characters,
     *     spread accoss all key-value pairs. Annotations that go beyond this
     *     limit are rejected
     * *   Valid annotation keys have two segments: an optional prefix and name,
     *     separated by a slash (/). The name segment is required and must be 63
     *     characters or less, beginning and ending with an alphanumeric character
     *     ([a-z0-9A-Z]) with dashes (-), underscores (_), dots (.), and
     *     alphanumerics between. The prefix is optional. If specified, the prefix
     *     must be a DNS subdomain: a series of DNS labels separated by dots (.),
     *     not longer than 253 characters in total, followed by a slash (/)
     *     Annotations that fails to meet these requirements are rejected.
     * Note: This field is equivalent to the `metadata` field in the v1beta1 API.
     * They have the same syntax and read/write to the same location in Service
     * Directory.
     *
     * Generated from protobuf field <code>map<string, string> annotations = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getAnnotations()
    {
        return $this->annotations;
    }

    /**
     * Optional. Annotations for the endpoint. This data can be consumed by
     * service clients.
     * Restrictions:
     * *   The entire annotations dictionary may contain up to 512 characters,
     *     spread accoss all key-value pairs. Annotations that go beyond this
     *     limit are rejected
     * *   Valid annotation keys have two segments: an optional prefix and name,
     *     separated by a slash (/). The name segment is required and must be 63
     *     characters or less, beginning and ending with an alphanumeric character
     *     ([a-z0-9A-Z]) with dashes (-), underscores (_), dots (.), and
     *     alphanumerics between. The prefix is optional. If specified, the prefix
     *     must be a DNS subdomain: a series of DNS labels separated by dots (.),
     *     not longer than 253 characters in total, followed by a slash (/)
     *     Annotations that fails to meet these requirements are rejected.
     * Note: This field is equivalent to the `metadata` field in the v1beta1 API.
     * They have the same syntax and read/write to the same location in Service
     * Directory.
     *
     * Generated from protobuf field <code>map<string, string> annotations = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setAnnotations($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->annotations = $arr;

        return $this;
    }

    /**
     * Immutable. The Google Compute Engine network (VPC) of the endpoint in the
     * format `projects/<project number>/locations/global/networks/&#42;`.
     * The project must be specified by project number (project id is rejected).
     * Incorrectly formatted networks are rejected, we also check to make sure
     * that you have the servicedirectory.networks.attach permission on the
     * project specified.
     *
     * Generated from protobuf field <code>string network = 8 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getNetwork()
    {
        return $this->network;
    }

    /**
     * Immutable. The Google Compute Engine network (VPC) of the endpoint in the
     * format `projects/<project number>/locations/global/networks/&#42;`.
     * The project must be specified by project number (project id is rejected).
     * Incorrectly formatted networks are rejected, we also check to make sure
     * that you have the servicedirectory.networks.attach permission on the
     * project specified.
     *
     * Generated from protobuf field <code>string network = 8 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setNetwork($var)
    {
        GPBUtil::checkString($var, True);
        $this->network = $var;

        return $this;
    }

    /**
     * Output only. The globally unique identifier of the endpoint in the UUID4
     * format.
     *
     * Generated from protobuf field <code>string uid = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getUid()
    {
        return $this->uid;
    }

    /**
     * Output only. The globally unique identifier of the endpoint in the UUID4
     * format.
     *
     * Generated from protobuf field <code>string uid = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setUid($var)
    {
        GPBUtil::checkString($var, True);
        $this->uid = $var;

        return $this;
    }

}

