<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/servicehealth/v1/event_resources.proto

namespace Google\Cloud\ServiceHealth\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Message for requesting list of OrganizationImpacts
 *
 * Generated from protobuf message <code>google.cloud.servicehealth.v1.ListOrganizationImpactsRequest</code>
 */
class ListOrganizationImpactsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Parent value using the form
     * `organizations/{organization_id}/locations/{location}/organizationImpacts`.
     * `organization_id` - ID (number) of the project that contains the event. To
     * get your `organization_id`, see
     * [Getting your organization resource
     * ID](https://cloud.google.com/resource-manager/docs/creating-managing-organization#retrieving_your_organization_id).
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. The maximum number of events that should be returned. Acceptable
     * values are `1` to `100`, inclusive. The default value is `10`.
     *  If more results are available, the service returns a
     * `next_page_token` that can be used to get the next page of results in
     * subsequent list requests. The service may return fewer
     * [impacts](/service-health/docs/reference/rest/v1beta/organizations.locations.organizationImpacts#OrganizationImpact)
     * than the requested `page_size`.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. A token identifying a page of results the server should return.
     * Provide `page_token` returned by a previous `ListOrganizationImpacts` call
     * to retrieve the next page of results.
     * When paginating, all other parameters provided to `ListOrganizationImpacts`
     * must match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';
    /**
     * Optional. A filter expression that filters resources listed in the
     * response. The expression is in the form of `field:value` for checking if a
     * repeated field contains a value.
     * Example:
     * `events:organizations%2F{organization_id}%2Flocations%2Fglobal%2ForganizationEvents%2Fevent-id`
     * To get your `{organization_id}`, see
     * [Getting your organization resource
     * ID](https://cloud.google.com/resource-manager/docs/creating-managing-organization#retrieving_your_organization_id).
     * Multiple filter queries are separated by spaces.
     * By default, each expression is an AND expression. However, you can include
     * AND and OR expressions explicitly.
     * Filter is supported for the following fields: `events`.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $filter = '';

    /**
     * @param string $parent Required. Parent value using the form
     *                       `organizations/{organization_id}/locations/{location}/organizationImpacts`.
     *
     *                       `organization_id` - ID (number) of the project that contains the event. To
     *                       get your `organization_id`, see
     *                       [Getting your organization resource
     *                       ID](https://cloud.google.com/resource-manager/docs/creating-managing-organization#retrieving_your_organization_id). Please see
     *                       {@see ServiceHealthClient::organizationLocationName()} for help formatting this field.
     *
     * @return \Google\Cloud\ServiceHealth\V1\ListOrganizationImpactsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Parent value using the form
     *           `organizations/{organization_id}/locations/{location}/organizationImpacts`.
     *           `organization_id` - ID (number) of the project that contains the event. To
     *           get your `organization_id`, see
     *           [Getting your organization resource
     *           ID](https://cloud.google.com/resource-manager/docs/creating-managing-organization#retrieving_your_organization_id).
     *     @type int $page_size
     *           Optional. The maximum number of events that should be returned. Acceptable
     *           values are `1` to `100`, inclusive. The default value is `10`.
     *            If more results are available, the service returns a
     *           `next_page_token` that can be used to get the next page of results in
     *           subsequent list requests. The service may return fewer
     *           [impacts](/service-health/docs/reference/rest/v1beta/organizations.locations.organizationImpacts#OrganizationImpact)
     *           than the requested `page_size`.
     *     @type string $page_token
     *           Optional. A token identifying a page of results the server should return.
     *           Provide `page_token` returned by a previous `ListOrganizationImpacts` call
     *           to retrieve the next page of results.
     *           When paginating, all other parameters provided to `ListOrganizationImpacts`
     *           must match the call that provided the page token.
     *     @type string $filter
     *           Optional. A filter expression that filters resources listed in the
     *           response. The expression is in the form of `field:value` for checking if a
     *           repeated field contains a value.
     *           Example:
     *           `events:organizations%2F{organization_id}%2Flocations%2Fglobal%2ForganizationEvents%2Fevent-id`
     *           To get your `{organization_id}`, see
     *           [Getting your organization resource
     *           ID](https://cloud.google.com/resource-manager/docs/creating-managing-organization#retrieving_your_organization_id).
     *           Multiple filter queries are separated by spaces.
     *           By default, each expression is an AND expression. However, you can include
     *           AND and OR expressions explicitly.
     *           Filter is supported for the following fields: `events`.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Servicehealth\V1\EventResources::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Parent value using the form
     * `organizations/{organization_id}/locations/{location}/organizationImpacts`.
     * `organization_id` - ID (number) of the project that contains the event. To
     * get your `organization_id`, see
     * [Getting your organization resource
     * ID](https://cloud.google.com/resource-manager/docs/creating-managing-organization#retrieving_your_organization_id).
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Parent value using the form
     * `organizations/{organization_id}/locations/{location}/organizationImpacts`.
     * `organization_id` - ID (number) of the project that contains the event. To
     * get your `organization_id`, see
     * [Getting your organization resource
     * ID](https://cloud.google.com/resource-manager/docs/creating-managing-organization#retrieving_your_organization_id).
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. The maximum number of events that should be returned. Acceptable
     * values are `1` to `100`, inclusive. The default value is `10`.
     *  If more results are available, the service returns a
     * `next_page_token` that can be used to get the next page of results in
     * subsequent list requests. The service may return fewer
     * [impacts](/service-health/docs/reference/rest/v1beta/organizations.locations.organizationImpacts#OrganizationImpact)
     * than the requested `page_size`.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. The maximum number of events that should be returned. Acceptable
     * values are `1` to `100`, inclusive. The default value is `10`.
     *  If more results are available, the service returns a
     * `next_page_token` that can be used to get the next page of results in
     * subsequent list requests. The service may return fewer
     * [impacts](/service-health/docs/reference/rest/v1beta/organizations.locations.organizationImpacts#OrganizationImpact)
     * than the requested `page_size`.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. A token identifying a page of results the server should return.
     * Provide `page_token` returned by a previous `ListOrganizationImpacts` call
     * to retrieve the next page of results.
     * When paginating, all other parameters provided to `ListOrganizationImpacts`
     * must match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. A token identifying a page of results the server should return.
     * Provide `page_token` returned by a previous `ListOrganizationImpacts` call
     * to retrieve the next page of results.
     * When paginating, all other parameters provided to `ListOrganizationImpacts`
     * must match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. A filter expression that filters resources listed in the
     * response. The expression is in the form of `field:value` for checking if a
     * repeated field contains a value.
     * Example:
     * `events:organizations%2F{organization_id}%2Flocations%2Fglobal%2ForganizationEvents%2Fevent-id`
     * To get your `{organization_id}`, see
     * [Getting your organization resource
     * ID](https://cloud.google.com/resource-manager/docs/creating-managing-organization#retrieving_your_organization_id).
     * Multiple filter queries are separated by spaces.
     * By default, each expression is an AND expression. However, you can include
     * AND and OR expressions explicitly.
     * Filter is supported for the following fields: `events`.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Optional. A filter expression that filters resources listed in the
     * response. The expression is in the form of `field:value` for checking if a
     * repeated field contains a value.
     * Example:
     * `events:organizations%2F{organization_id}%2Flocations%2Fglobal%2ForganizationEvents%2Fevent-id`
     * To get your `{organization_id}`, see
     * [Getting your organization resource
     * ID](https://cloud.google.com/resource-manager/docs/creating-managing-organization#retrieving_your_organization_id).
     * Multiple filter queries are separated by spaces.
     * By default, each expression is an AND expression. However, you can include
     * AND and OR expressions explicitly.
     * Filter is supported for the following fields: `events`.
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

}

