<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/servicehealth/v1/event_resources.proto

namespace Google\Cloud\ServiceHealth\V1\OrganizationEvent;

use UnexpectedValueException;

/**
 * The detailed state of the incident. This enum lists all possible detailed
 * states of an incident.
 *
 * Protobuf type <code>google.cloud.servicehealth.v1.OrganizationEvent.DetailedState</code>
 */
class DetailedState
{
    /**
     * Unspecified detail state.
     *
     * Generated from protobuf enum <code>DETAILED_STATE_UNSPECIFIED = 0;</code>
     */
    const DETAILED_STATE_UNSPECIFIED = 0;
    /**
     * Google engineers are actively investigating the incident to determine the
     * impact.
     *
     * Generated from protobuf enum <code>EMERGING = 1;</code>
     */
    const EMERGING = 1;
    /**
     * The incident is confirmed and impacting at least one Google Cloud
     * product. Ongoing status updates will be provided until it is resolved.
     *
     * Generated from protobuf enum <code>CONFIRMED = 2;</code>
     */
    const CONFIRMED = 2;
    /**
     * The incident is no longer affecting any Google Cloud product, and there
     * will be no further updates.
     *
     * Generated from protobuf enum <code>RESOLVED = 3;</code>
     */
    const RESOLVED = 3;
    /**
     * The incident was merged into a parent event. All further updates will be
     * published to the parent only. The `parent_event` contains the name of the
     * parent.
     *
     * Generated from protobuf enum <code>MERGED = 4;</code>
     */
    const MERGED = 4;
    /**
     * The incident was automatically closed because of the following reasons:
     *  * The impact of the incident could not be confirmed.
     *  * The incident was intermittent or resolved itself.
     *  The incident does not have a resolution because no action or
     *  investigation happened. If it is intermittent, the incident may reopen.
     *
     * Generated from protobuf enum <code>AUTO_CLOSED = 9;</code>
     */
    const AUTO_CLOSED = 9;
    /**
     * Upon investigation, Google engineers concluded that the incident is not
     * affecting a Google Cloud product. This state can change if the incident
     * is reviewed again.
     *
     * Generated from protobuf enum <code>FALSE_POSITIVE = 10;</code>
     */
    const FALSE_POSITIVE = 10;

    private static $valueToName = [
        self::DETAILED_STATE_UNSPECIFIED => 'DETAILED_STATE_UNSPECIFIED',
        self::EMERGING => 'EMERGING',
        self::CONFIRMED => 'CONFIRMED',
        self::RESOLVED => 'RESOLVED',
        self::MERGED => 'MERGED',
        self::AUTO_CLOSED => 'AUTO_CLOSED',
        self::FALSE_POSITIVE => 'FALSE_POSITIVE',
    ];

    public static function name($value)
    {
        if (!isset(self::$valueToName[$value])) {
            throw new UnexpectedValueException(sprintf(
                    'Enum %s has no name defined for value %s', __CLASS__, $value));
        }
        return self::$valueToName[$value];
    }


    public static function value($name)
    {
        $const = __CLASS__ . '::' . strtoupper($name);
        if (!defined($const)) {
            throw new UnexpectedValueException(sprintf(
                    'Enum %s has no value defined for name %s', __CLASS__, $name));
        }
        return constant($const);
    }
}


