<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/api/servicemanagement/v1/servicemanager.proto

namespace Google\Cloud\ServiceManagement\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for SubmitConfigSource method.
 *
 * Generated from protobuf message <code>google.api.servicemanagement.v1.SubmitConfigSourceRequest</code>
 */
class SubmitConfigSourceRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the service.  See the
     * [overview](https://cloud.google.com/service-management/overview) for naming
     * requirements.  For example: `example.googleapis.com`.
     *
     * Generated from protobuf field <code>string service_name = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $service_name = '';
    /**
     * Required. The source configuration for the service.
     *
     * Generated from protobuf field <code>.google.api.servicemanagement.v1.ConfigSource config_source = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $config_source = null;
    /**
     * Optional. If set, this will result in the generation of a
     * `google.api.Service` configuration based on the `ConfigSource` provided,
     * but the generated config and the sources will NOT be persisted.
     *
     * Generated from protobuf field <code>bool validate_only = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $validate_only = false;

    /**
     * @param string                                          $serviceName  Required. The name of the service.  See the
     *                                                                      [overview](https://cloud.google.com/service-management/overview) for naming
     *                                                                      requirements.  For example: `example.googleapis.com`.
     * @param \Google\Cloud\ServiceManagement\V1\ConfigSource $configSource Required. The source configuration for the service.
     * @param bool                                            $validateOnly Optional. If set, this will result in the generation of a
     *                                                                      `google.api.Service` configuration based on the `ConfigSource` provided,
     *                                                                      but the generated config and the sources will NOT be persisted.
     *
     * @return \Google\Cloud\ServiceManagement\V1\SubmitConfigSourceRequest
     *
     * @experimental
     */
    public static function build(string $serviceName, \Google\Cloud\ServiceManagement\V1\ConfigSource $configSource, bool $validateOnly): self
    {
        return (new self())
            ->setServiceName($serviceName)
            ->setConfigSource($configSource)
            ->setValidateOnly($validateOnly);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $service_name
     *           Required. The name of the service.  See the
     *           [overview](https://cloud.google.com/service-management/overview) for naming
     *           requirements.  For example: `example.googleapis.com`.
     *     @type \Google\Cloud\ServiceManagement\V1\ConfigSource $config_source
     *           Required. The source configuration for the service.
     *     @type bool $validate_only
     *           Optional. If set, this will result in the generation of a
     *           `google.api.Service` configuration based on the `ConfigSource` provided,
     *           but the generated config and the sources will NOT be persisted.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Api\Servicemanagement\V1\Servicemanager::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the service.  See the
     * [overview](https://cloud.google.com/service-management/overview) for naming
     * requirements.  For example: `example.googleapis.com`.
     *
     * Generated from protobuf field <code>string service_name = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getServiceName()
    {
        return $this->service_name;
    }

    /**
     * Required. The name of the service.  See the
     * [overview](https://cloud.google.com/service-management/overview) for naming
     * requirements.  For example: `example.googleapis.com`.
     *
     * Generated from protobuf field <code>string service_name = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setServiceName($var)
    {
        GPBUtil::checkString($var, True);
        $this->service_name = $var;

        return $this;
    }

    /**
     * Required. The source configuration for the service.
     *
     * Generated from protobuf field <code>.google.api.servicemanagement.v1.ConfigSource config_source = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\ServiceManagement\V1\ConfigSource|null
     */
    public function getConfigSource()
    {
        return $this->config_source;
    }

    public function hasConfigSource()
    {
        return isset($this->config_source);
    }

    public function clearConfigSource()
    {
        unset($this->config_source);
    }

    /**
     * Required. The source configuration for the service.
     *
     * Generated from protobuf field <code>.google.api.servicemanagement.v1.ConfigSource config_source = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\ServiceManagement\V1\ConfigSource $var
     * @return $this
     */
    public function setConfigSource($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\ServiceManagement\V1\ConfigSource::class);
        $this->config_source = $var;

        return $this;
    }

    /**
     * Optional. If set, this will result in the generation of a
     * `google.api.Service` configuration based on the `ConfigSource` provided,
     * but the generated config and the sources will NOT be persisted.
     *
     * Generated from protobuf field <code>bool validate_only = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getValidateOnly()
    {
        return $this->validate_only;
    }

    /**
     * Optional. If set, this will result in the generation of a
     * `google.api.Service` configuration based on the `ConfigSource` provided,
     * but the generated config and the sources will NOT be persisted.
     *
     * Generated from protobuf field <code>bool validate_only = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setValidateOnly($var)
    {
        GPBUtil::checkBool($var);
        $this->validate_only = $var;

        return $this;
    }

}

