<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/css/v1/accounts_labels.proto

namespace Google\Shopping\Css\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Label assigned by CSS domain or CSS group to one of its sub-accounts.
 *
 * Generated from protobuf message <code>google.shopping.css.v1.AccountLabel</code>
 */
class AccountLabel extends \Google\Protobuf\Internal\Message
{
    /**
     * The resource name of the label.
     * Format: accounts/{account}/labels/{label}
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    protected $name = '';
    /**
     * Output only. The ID of the label.
     *
     * Generated from protobuf field <code>int64 label_id = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $label_id = 0;
    /**
     * Output only. The ID of account this label belongs to.
     *
     * Generated from protobuf field <code>int64 account_id = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $account_id = 0;
    /**
     * The display name of this label.
     *
     * Generated from protobuf field <code>optional string display_name = 4;</code>
     */
    protected $display_name = null;
    /**
     * The description of this label.
     *
     * Generated from protobuf field <code>optional string description = 5;</code>
     */
    protected $description = null;
    /**
     * Output only. The type of this label.
     *
     * Generated from protobuf field <code>.google.shopping.css.v1.AccountLabel.LabelType label_type = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $label_type = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           The resource name of the label.
     *           Format: accounts/{account}/labels/{label}
     *     @type int|string $label_id
     *           Output only. The ID of the label.
     *     @type int|string $account_id
     *           Output only. The ID of account this label belongs to.
     *     @type string $display_name
     *           The display name of this label.
     *     @type string $description
     *           The description of this label.
     *     @type int $label_type
     *           Output only. The type of this label.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Css\V1\AccountsLabels::initOnce();
        parent::__construct($data);
    }

    /**
     * The resource name of the label.
     * Format: accounts/{account}/labels/{label}
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * The resource name of the label.
     * Format: accounts/{account}/labels/{label}
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. The ID of the label.
     *
     * Generated from protobuf field <code>int64 label_id = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int|string
     */
    public function getLabelId()
    {
        return $this->label_id;
    }

    /**
     * Output only. The ID of the label.
     *
     * Generated from protobuf field <code>int64 label_id = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int|string $var
     * @return $this
     */
    public function setLabelId($var)
    {
        GPBUtil::checkInt64($var);
        $this->label_id = $var;

        return $this;
    }

    /**
     * Output only. The ID of account this label belongs to.
     *
     * Generated from protobuf field <code>int64 account_id = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int|string
     */
    public function getAccountId()
    {
        return $this->account_id;
    }

    /**
     * Output only. The ID of account this label belongs to.
     *
     * Generated from protobuf field <code>int64 account_id = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int|string $var
     * @return $this
     */
    public function setAccountId($var)
    {
        GPBUtil::checkInt64($var);
        $this->account_id = $var;

        return $this;
    }

    /**
     * The display name of this label.
     *
     * Generated from protobuf field <code>optional string display_name = 4;</code>
     * @return string
     */
    public function getDisplayName()
    {
        return isset($this->display_name) ? $this->display_name : '';
    }

    public function hasDisplayName()
    {
        return isset($this->display_name);
    }

    public function clearDisplayName()
    {
        unset($this->display_name);
    }

    /**
     * The display name of this label.
     *
     * Generated from protobuf field <code>optional string display_name = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * The description of this label.
     *
     * Generated from protobuf field <code>optional string description = 5;</code>
     * @return string
     */
    public function getDescription()
    {
        return isset($this->description) ? $this->description : '';
    }

    public function hasDescription()
    {
        return isset($this->description);
    }

    public function clearDescription()
    {
        unset($this->description);
    }

    /**
     * The description of this label.
     *
     * Generated from protobuf field <code>optional string description = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Output only. The type of this label.
     *
     * Generated from protobuf field <code>.google.shopping.css.v1.AccountLabel.LabelType label_type = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getLabelType()
    {
        return $this->label_type;
    }

    /**
     * Output only. The type of this label.
     *
     * Generated from protobuf field <code>.google.shopping.css.v1.AccountLabel.LabelType label_type = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setLabelType($var)
    {
        GPBUtil::checkEnum($var, \Google\Shopping\Css\V1\AccountLabel\LabelType::class);
        $this->label_type = $var;

        return $this;
    }

}

