<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/css/v1/accounts.proto

namespace Google\Shopping\Css\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request message for the `ListChildAccounts` method.
 *
 * Generated from protobuf message <code>google.shopping.css.v1.ListChildAccountsRequest</code>
 */
class ListChildAccountsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent account. Must be a CSS group or domain.
     * Format: accounts/{account}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * If set, only the MC accounts with the given label ID will be returned.
     *
     * Generated from protobuf field <code>optional int64 label_id = 2;</code>
     */
    protected $label_id = null;
    /**
     * If set, only the MC accounts with the given name (case sensitive) will be
     * returned.
     *
     * Generated from protobuf field <code>optional string full_name = 3;</code>
     */
    protected $full_name = null;
    /**
     * Optional. The maximum number of accounts to return. The service may return
     * fewer than this value. If unspecified, at most 50 accounts will be
     * returned. The maximum value is 1000; values above 1000 will be coerced to
     * 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. A page token, received from a previous `ListChildAccounts` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListChildAccounts` must
     * match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';

    /**
     * @param string $parent Required. The parent account. Must be a CSS group or domain.
     *                       Format: accounts/{account}
     *                       Please see {@see AccountsServiceClient::accountName()} for help formatting this field.
     *
     * @return \Google\Shopping\Css\V1\ListChildAccountsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent account. Must be a CSS group or domain.
     *           Format: accounts/{account}
     *     @type int|string $label_id
     *           If set, only the MC accounts with the given label ID will be returned.
     *     @type string $full_name
     *           If set, only the MC accounts with the given name (case sensitive) will be
     *           returned.
     *     @type int $page_size
     *           Optional. The maximum number of accounts to return. The service may return
     *           fewer than this value. If unspecified, at most 50 accounts will be
     *           returned. The maximum value is 1000; values above 1000 will be coerced to
     *           1000.
     *     @type string $page_token
     *           Optional. A page token, received from a previous `ListChildAccounts` call.
     *           Provide this to retrieve the subsequent page.
     *           When paginating, all other parameters provided to `ListChildAccounts` must
     *           match the call that provided the page token.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Css\V1\Accounts::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent account. Must be a CSS group or domain.
     * Format: accounts/{account}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent account. Must be a CSS group or domain.
     * Format: accounts/{account}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * If set, only the MC accounts with the given label ID will be returned.
     *
     * Generated from protobuf field <code>optional int64 label_id = 2;</code>
     * @return int|string
     */
    public function getLabelId()
    {
        return isset($this->label_id) ? $this->label_id : 0;
    }

    public function hasLabelId()
    {
        return isset($this->label_id);
    }

    public function clearLabelId()
    {
        unset($this->label_id);
    }

    /**
     * If set, only the MC accounts with the given label ID will be returned.
     *
     * Generated from protobuf field <code>optional int64 label_id = 2;</code>
     * @param int|string $var
     * @return $this
     */
    public function setLabelId($var)
    {
        GPBUtil::checkInt64($var);
        $this->label_id = $var;

        return $this;
    }

    /**
     * If set, only the MC accounts with the given name (case sensitive) will be
     * returned.
     *
     * Generated from protobuf field <code>optional string full_name = 3;</code>
     * @return string
     */
    public function getFullName()
    {
        return isset($this->full_name) ? $this->full_name : '';
    }

    public function hasFullName()
    {
        return isset($this->full_name);
    }

    public function clearFullName()
    {
        unset($this->full_name);
    }

    /**
     * If set, only the MC accounts with the given name (case sensitive) will be
     * returned.
     *
     * Generated from protobuf field <code>optional string full_name = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setFullName($var)
    {
        GPBUtil::checkString($var, True);
        $this->full_name = $var;

        return $this;
    }

    /**
     * Optional. The maximum number of accounts to return. The service may return
     * fewer than this value. If unspecified, at most 50 accounts will be
     * returned. The maximum value is 1000; values above 1000 will be coerced to
     * 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. The maximum number of accounts to return. The service may return
     * fewer than this value. If unspecified, at most 50 accounts will be
     * returned. The maximum value is 1000; values above 1000 will be coerced to
     * 1000.
     *
     * Generated from protobuf field <code>int32 page_size = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. A page token, received from a previous `ListChildAccounts` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListChildAccounts` must
     * match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. A page token, received from a previous `ListChildAccounts` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListChildAccounts` must
     * match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

