<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/accounts/v1beta/accountissue.proto

namespace Google\Shopping\Merchant\Accounts\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An
 * [`AccountIssue`](https://support.google.com/merchants/answer/12153802?sjid=17798438912526418908-EU#account).
 *
 * Generated from protobuf message <code>google.shopping.merchant.accounts.v1beta.AccountIssue</code>
 */
class AccountIssue extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. The resource name of the account issue.
     * Format: `accounts/{account}/issues/{id}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * The localized title of the issue.
     *
     * Generated from protobuf field <code>string title = 2;</code>
     */
    protected $title = '';
    /**
     * The overall severity of the issue.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.AccountIssue.Severity severity = 3;</code>
     */
    protected $severity = 0;
    /**
     * The impact this issue has on various destinations.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.AccountIssue.ImpactedDestination impacted_destinations = 4;</code>
     */
    private $impacted_destinations;
    /**
     * Further localized details about the issue.
     *
     * Generated from protobuf field <code>string detail = 5;</code>
     */
    protected $detail = '';
    /**
     * Link to Merchant Center Help Center providing further information about the
     * issue and how to fix it.
     *
     * Generated from protobuf field <code>string documentation_uri = 6;</code>
     */
    protected $documentation_uri = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. The resource name of the account issue.
     *           Format: `accounts/{account}/issues/{id}`
     *     @type string $title
     *           The localized title of the issue.
     *     @type int $severity
     *           The overall severity of the issue.
     *     @type array<\Google\Shopping\Merchant\Accounts\V1beta\AccountIssue\ImpactedDestination>|\Google\Protobuf\Internal\RepeatedField $impacted_destinations
     *           The impact this issue has on various destinations.
     *     @type string $detail
     *           Further localized details about the issue.
     *     @type string $documentation_uri
     *           Link to Merchant Center Help Center providing further information about the
     *           issue and how to fix it.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Accounts\V1Beta\Accountissue::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. The resource name of the account issue.
     * Format: `accounts/{account}/issues/{id}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. The resource name of the account issue.
     * Format: `accounts/{account}/issues/{id}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The localized title of the issue.
     *
     * Generated from protobuf field <code>string title = 2;</code>
     * @return string
     */
    public function getTitle()
    {
        return $this->title;
    }

    /**
     * The localized title of the issue.
     *
     * Generated from protobuf field <code>string title = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setTitle($var)
    {
        GPBUtil::checkString($var, True);
        $this->title = $var;

        return $this;
    }

    /**
     * The overall severity of the issue.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.AccountIssue.Severity severity = 3;</code>
     * @return int
     */
    public function getSeverity()
    {
        return $this->severity;
    }

    /**
     * The overall severity of the issue.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.AccountIssue.Severity severity = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setSeverity($var)
    {
        GPBUtil::checkEnum($var, \Google\Shopping\Merchant\Accounts\V1beta\AccountIssue\Severity::class);
        $this->severity = $var;

        return $this;
    }

    /**
     * The impact this issue has on various destinations.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.AccountIssue.ImpactedDestination impacted_destinations = 4;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getImpactedDestinations()
    {
        return $this->impacted_destinations;
    }

    /**
     * The impact this issue has on various destinations.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.AccountIssue.ImpactedDestination impacted_destinations = 4;</code>
     * @param array<\Google\Shopping\Merchant\Accounts\V1beta\AccountIssue\ImpactedDestination>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setImpactedDestinations($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Shopping\Merchant\Accounts\V1beta\AccountIssue\ImpactedDestination::class);
        $this->impacted_destinations = $arr;

        return $this;
    }

    /**
     * Further localized details about the issue.
     *
     * Generated from protobuf field <code>string detail = 5;</code>
     * @return string
     */
    public function getDetail()
    {
        return $this->detail;
    }

    /**
     * Further localized details about the issue.
     *
     * Generated from protobuf field <code>string detail = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setDetail($var)
    {
        GPBUtil::checkString($var, True);
        $this->detail = $var;

        return $this;
    }

    /**
     * Link to Merchant Center Help Center providing further information about the
     * issue and how to fix it.
     *
     * Generated from protobuf field <code>string documentation_uri = 6;</code>
     * @return string
     */
    public function getDocumentationUri()
    {
        return $this->documentation_uri;
    }

    /**
     * Link to Merchant Center Help Center providing further information about the
     * issue and how to fix it.
     *
     * Generated from protobuf field <code>string documentation_uri = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setDocumentationUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->documentation_uri = $var;

        return $this;
    }

}

