<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/accounts/v1beta/businessidentity.proto

namespace Google\Shopping\Merchant\Accounts\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Collection of information related to the [identity of a
 * business](https://support.google.com/merchants/answer/12564247).
 *
 * Generated from protobuf message <code>google.shopping.merchant.accounts.v1beta.BusinessIdentity</code>
 */
class BusinessIdentity extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. The resource name of the business identity.
     * Format: `accounts/{account}/businessIdentity`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Optional. Whether the identity attributes may be used for promotions.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.BusinessIdentity.PromotionsConsent promotions_consent = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $promotions_consent = 0;
    /**
     * Optional. Specifies whether the business identifies itself as being
     * black-owned. This optional field will only be available for merchants with
     * a business country set to `US`. It is also not applicable for marketplaces
     * or marketplace sellers.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.BusinessIdentity.IdentityAttribute black_owned = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $black_owned = null;
    /**
     * Optional. Specifies whether the business identifies itself as being
     * women-owned. This optional field will only be available for merchants with
     * a business country set to `US`. It is also not applicable for marketplaces
     * or marketplace sellers.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.BusinessIdentity.IdentityAttribute women_owned = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $women_owned = null;
    /**
     * Optional. Specifies whether the business identifies itself as being
     * veteran-owned. This optional field will only be available for merchants
     * with a business country set to `US`. It is also not applicable for
     * marketplaces or marketplace sellers.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.BusinessIdentity.IdentityAttribute veteran_owned = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $veteran_owned = null;
    /**
     * Optional. Specifies whether the business identifies itself as being
     * latino-owned. This optional field will only be available for merchants with
     * a business country set to `US`. It is also not applicable for marketplaces
     * or marketplace sellers.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.BusinessIdentity.IdentityAttribute latino_owned = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $latino_owned = null;
    /**
     * Optional. Specifies whether the business identifies itself as a small
     * business. This optional field will only be available for merchants with a
     * business country set to `US`. It is also not applicable for marketplaces.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.BusinessIdentity.IdentityAttribute small_business = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $small_business = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. The resource name of the business identity.
     *           Format: `accounts/{account}/businessIdentity`
     *     @type int $promotions_consent
     *           Optional. Whether the identity attributes may be used for promotions.
     *     @type \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute $black_owned
     *           Optional. Specifies whether the business identifies itself as being
     *           black-owned. This optional field will only be available for merchants with
     *           a business country set to `US`. It is also not applicable for marketplaces
     *           or marketplace sellers.
     *     @type \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute $women_owned
     *           Optional. Specifies whether the business identifies itself as being
     *           women-owned. This optional field will only be available for merchants with
     *           a business country set to `US`. It is also not applicable for marketplaces
     *           or marketplace sellers.
     *     @type \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute $veteran_owned
     *           Optional. Specifies whether the business identifies itself as being
     *           veteran-owned. This optional field will only be available for merchants
     *           with a business country set to `US`. It is also not applicable for
     *           marketplaces or marketplace sellers.
     *     @type \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute $latino_owned
     *           Optional. Specifies whether the business identifies itself as being
     *           latino-owned. This optional field will only be available for merchants with
     *           a business country set to `US`. It is also not applicable for marketplaces
     *           or marketplace sellers.
     *     @type \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute $small_business
     *           Optional. Specifies whether the business identifies itself as a small
     *           business. This optional field will only be available for merchants with a
     *           business country set to `US`. It is also not applicable for marketplaces.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Accounts\V1Beta\Businessidentity::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. The resource name of the business identity.
     * Format: `accounts/{account}/businessIdentity`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. The resource name of the business identity.
     * Format: `accounts/{account}/businessIdentity`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Optional. Whether the identity attributes may be used for promotions.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.BusinessIdentity.PromotionsConsent promotions_consent = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPromotionsConsent()
    {
        return $this->promotions_consent;
    }

    /**
     * Optional. Whether the identity attributes may be used for promotions.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.BusinessIdentity.PromotionsConsent promotions_consent = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPromotionsConsent($var)
    {
        GPBUtil::checkEnum($var, \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\PromotionsConsent::class);
        $this->promotions_consent = $var;

        return $this;
    }

    /**
     * Optional. Specifies whether the business identifies itself as being
     * black-owned. This optional field will only be available for merchants with
     * a business country set to `US`. It is also not applicable for marketplaces
     * or marketplace sellers.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.BusinessIdentity.IdentityAttribute black_owned = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute|null
     */
    public function getBlackOwned()
    {
        return $this->black_owned;
    }

    public function hasBlackOwned()
    {
        return isset($this->black_owned);
    }

    public function clearBlackOwned()
    {
        unset($this->black_owned);
    }

    /**
     * Optional. Specifies whether the business identifies itself as being
     * black-owned. This optional field will only be available for merchants with
     * a business country set to `US`. It is also not applicable for marketplaces
     * or marketplace sellers.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.BusinessIdentity.IdentityAttribute black_owned = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute $var
     * @return $this
     */
    public function setBlackOwned($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute::class);
        $this->black_owned = $var;

        return $this;
    }

    /**
     * Optional. Specifies whether the business identifies itself as being
     * women-owned. This optional field will only be available for merchants with
     * a business country set to `US`. It is also not applicable for marketplaces
     * or marketplace sellers.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.BusinessIdentity.IdentityAttribute women_owned = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute|null
     */
    public function getWomenOwned()
    {
        return $this->women_owned;
    }

    public function hasWomenOwned()
    {
        return isset($this->women_owned);
    }

    public function clearWomenOwned()
    {
        unset($this->women_owned);
    }

    /**
     * Optional. Specifies whether the business identifies itself as being
     * women-owned. This optional field will only be available for merchants with
     * a business country set to `US`. It is also not applicable for marketplaces
     * or marketplace sellers.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.BusinessIdentity.IdentityAttribute women_owned = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute $var
     * @return $this
     */
    public function setWomenOwned($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute::class);
        $this->women_owned = $var;

        return $this;
    }

    /**
     * Optional. Specifies whether the business identifies itself as being
     * veteran-owned. This optional field will only be available for merchants
     * with a business country set to `US`. It is also not applicable for
     * marketplaces or marketplace sellers.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.BusinessIdentity.IdentityAttribute veteran_owned = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute|null
     */
    public function getVeteranOwned()
    {
        return $this->veteran_owned;
    }

    public function hasVeteranOwned()
    {
        return isset($this->veteran_owned);
    }

    public function clearVeteranOwned()
    {
        unset($this->veteran_owned);
    }

    /**
     * Optional. Specifies whether the business identifies itself as being
     * veteran-owned. This optional field will only be available for merchants
     * with a business country set to `US`. It is also not applicable for
     * marketplaces or marketplace sellers.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.BusinessIdentity.IdentityAttribute veteran_owned = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute $var
     * @return $this
     */
    public function setVeteranOwned($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute::class);
        $this->veteran_owned = $var;

        return $this;
    }

    /**
     * Optional. Specifies whether the business identifies itself as being
     * latino-owned. This optional field will only be available for merchants with
     * a business country set to `US`. It is also not applicable for marketplaces
     * or marketplace sellers.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.BusinessIdentity.IdentityAttribute latino_owned = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute|null
     */
    public function getLatinoOwned()
    {
        return $this->latino_owned;
    }

    public function hasLatinoOwned()
    {
        return isset($this->latino_owned);
    }

    public function clearLatinoOwned()
    {
        unset($this->latino_owned);
    }

    /**
     * Optional. Specifies whether the business identifies itself as being
     * latino-owned. This optional field will only be available for merchants with
     * a business country set to `US`. It is also not applicable for marketplaces
     * or marketplace sellers.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.BusinessIdentity.IdentityAttribute latino_owned = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute $var
     * @return $this
     */
    public function setLatinoOwned($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute::class);
        $this->latino_owned = $var;

        return $this;
    }

    /**
     * Optional. Specifies whether the business identifies itself as a small
     * business. This optional field will only be available for merchants with a
     * business country set to `US`. It is also not applicable for marketplaces.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.BusinessIdentity.IdentityAttribute small_business = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute|null
     */
    public function getSmallBusiness()
    {
        return $this->small_business;
    }

    public function hasSmallBusiness()
    {
        return isset($this->small_business);
    }

    public function clearSmallBusiness()
    {
        unset($this->small_business);
    }

    /**
     * Optional. Specifies whether the business identifies itself as a small
     * business. This optional field will only be available for merchants with a
     * business country set to `US`. It is also not applicable for marketplaces.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.accounts.v1beta.BusinessIdentity.IdentityAttribute small_business = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute $var
     * @return $this
     */
    public function setSmallBusiness($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Merchant\Accounts\V1beta\BusinessIdentity\IdentityAttribute::class);
        $this->small_business = $var;

        return $this;
    }

}

