<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/accounts/v1beta/shippingsettings.proto

namespace Google\Shopping\Merchant\Accounts\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Time spent in various aspects from order to the delivery of the product.
 *
 * Generated from protobuf message <code>google.shopping.merchant.accounts.v1beta.DeliveryTime</code>
 */
class DeliveryTime extends \Google\Protobuf\Internal\Message
{
    /**
     * Minimum number of business days that is spent in transit. 0 means same
     * day delivery, 1 means next day delivery.
     * Either `min_transit_days`, `max_transit_days` or
     * `transit_time_table` must be set, but not both.
     *
     * Generated from protobuf field <code>optional int32 min_transit_days = 1;</code>
     */
    protected $min_transit_days = null;
    /**
     * Maximum number of business days that is spent in transit. 0 means same
     * day delivery, 1 means next day delivery. Must be greater than or equal
     * to `min_transit_days`.
     *
     * Generated from protobuf field <code>optional int32 max_transit_days = 2;</code>
     */
    protected $max_transit_days = null;
    /**
     * Business days cutoff time definition.
     * If not configured the cutoff time will be defaulted to 8AM PST.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.CutoffTime cutoff_time = 3;</code>
     */
    protected $cutoff_time = null;
    /**
     * Minimum number of business days spent before an order is shipped.
     * 0 means same day shipped, 1 means next day shipped.
     * 'min_handling_days' and 'max_handling_days' should be either set or not set
     * at the same time.
     *
     * Generated from protobuf field <code>optional int32 min_handling_days = 4;</code>
     */
    protected $min_handling_days = null;
    /**
     * Maximum number of business days spent before an order is shipped.
     * 0 means same day shipped, 1 means next day shipped.
     * Must be greater than or equal to `min_handling_days`.
     * 'min_handling_days' and 'max_handling_days' should be either set or not set
     * at the same time.
     *
     * Generated from protobuf field <code>optional int32 max_handling_days = 5;</code>
     */
    protected $max_handling_days = null;
    /**
     * Transit time table, number of business days spent in transit based on row
     * and column dimensions. Either `min_transit_days`, `max_transit_days` or
     * `transit_time_table` can be set, but not both.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.TransitTable transit_time_table = 6;</code>
     */
    protected $transit_time_table = null;
    /**
     * The business days during which orders can be handled.
     * If not provided, Monday to Friday business days will be assumed.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.BusinessDayConfig handling_business_day_config = 7;</code>
     */
    protected $handling_business_day_config = null;
    /**
     * The business days during which orders can be in-transit.
     * If not provided, Monday to Friday business days will be assumed.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.BusinessDayConfig transit_business_day_config = 8;</code>
     */
    protected $transit_business_day_config = null;
    /**
     * Optional. Indicates that the delivery time should be calculated per
     * warehouse (shipping origin location) based on the settings of the selected
     * carrier. When set, no other transit time related field in [delivery
     * time][[google.shopping.content.bundles.ShippingSetting.DeliveryTime] should
     * be set.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.WarehouseBasedDeliveryTime warehouse_based_delivery_times = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $warehouse_based_delivery_times;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int $min_transit_days
     *           Minimum number of business days that is spent in transit. 0 means same
     *           day delivery, 1 means next day delivery.
     *           Either `min_transit_days`, `max_transit_days` or
     *           `transit_time_table` must be set, but not both.
     *     @type int $max_transit_days
     *           Maximum number of business days that is spent in transit. 0 means same
     *           day delivery, 1 means next day delivery. Must be greater than or equal
     *           to `min_transit_days`.
     *     @type \Google\Shopping\Merchant\Accounts\V1beta\CutoffTime $cutoff_time
     *           Business days cutoff time definition.
     *           If not configured the cutoff time will be defaulted to 8AM PST.
     *     @type int $min_handling_days
     *           Minimum number of business days spent before an order is shipped.
     *           0 means same day shipped, 1 means next day shipped.
     *           'min_handling_days' and 'max_handling_days' should be either set or not set
     *           at the same time.
     *     @type int $max_handling_days
     *           Maximum number of business days spent before an order is shipped.
     *           0 means same day shipped, 1 means next day shipped.
     *           Must be greater than or equal to `min_handling_days`.
     *           'min_handling_days' and 'max_handling_days' should be either set or not set
     *           at the same time.
     *     @type \Google\Shopping\Merchant\Accounts\V1beta\TransitTable $transit_time_table
     *           Transit time table, number of business days spent in transit based on row
     *           and column dimensions. Either `min_transit_days`, `max_transit_days` or
     *           `transit_time_table` can be set, but not both.
     *     @type \Google\Shopping\Merchant\Accounts\V1beta\BusinessDayConfig $handling_business_day_config
     *           The business days during which orders can be handled.
     *           If not provided, Monday to Friday business days will be assumed.
     *     @type \Google\Shopping\Merchant\Accounts\V1beta\BusinessDayConfig $transit_business_day_config
     *           The business days during which orders can be in-transit.
     *           If not provided, Monday to Friday business days will be assumed.
     *     @type array<\Google\Shopping\Merchant\Accounts\V1beta\WarehouseBasedDeliveryTime>|\Google\Protobuf\Internal\RepeatedField $warehouse_based_delivery_times
     *           Optional. Indicates that the delivery time should be calculated per
     *           warehouse (shipping origin location) based on the settings of the selected
     *           carrier. When set, no other transit time related field in [delivery
     *           time][[google.shopping.content.bundles.ShippingSetting.DeliveryTime] should
     *           be set.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Accounts\V1Beta\Shippingsettings::initOnce();
        parent::__construct($data);
    }

    /**
     * Minimum number of business days that is spent in transit. 0 means same
     * day delivery, 1 means next day delivery.
     * Either `min_transit_days`, `max_transit_days` or
     * `transit_time_table` must be set, but not both.
     *
     * Generated from protobuf field <code>optional int32 min_transit_days = 1;</code>
     * @return int
     */
    public function getMinTransitDays()
    {
        return isset($this->min_transit_days) ? $this->min_transit_days : 0;
    }

    public function hasMinTransitDays()
    {
        return isset($this->min_transit_days);
    }

    public function clearMinTransitDays()
    {
        unset($this->min_transit_days);
    }

    /**
     * Minimum number of business days that is spent in transit. 0 means same
     * day delivery, 1 means next day delivery.
     * Either `min_transit_days`, `max_transit_days` or
     * `transit_time_table` must be set, but not both.
     *
     * Generated from protobuf field <code>optional int32 min_transit_days = 1;</code>
     * @param int $var
     * @return $this
     */
    public function setMinTransitDays($var)
    {
        GPBUtil::checkInt32($var);
        $this->min_transit_days = $var;

        return $this;
    }

    /**
     * Maximum number of business days that is spent in transit. 0 means same
     * day delivery, 1 means next day delivery. Must be greater than or equal
     * to `min_transit_days`.
     *
     * Generated from protobuf field <code>optional int32 max_transit_days = 2;</code>
     * @return int
     */
    public function getMaxTransitDays()
    {
        return isset($this->max_transit_days) ? $this->max_transit_days : 0;
    }

    public function hasMaxTransitDays()
    {
        return isset($this->max_transit_days);
    }

    public function clearMaxTransitDays()
    {
        unset($this->max_transit_days);
    }

    /**
     * Maximum number of business days that is spent in transit. 0 means same
     * day delivery, 1 means next day delivery. Must be greater than or equal
     * to `min_transit_days`.
     *
     * Generated from protobuf field <code>optional int32 max_transit_days = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setMaxTransitDays($var)
    {
        GPBUtil::checkInt32($var);
        $this->max_transit_days = $var;

        return $this;
    }

    /**
     * Business days cutoff time definition.
     * If not configured the cutoff time will be defaulted to 8AM PST.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.CutoffTime cutoff_time = 3;</code>
     * @return \Google\Shopping\Merchant\Accounts\V1beta\CutoffTime|null
     */
    public function getCutoffTime()
    {
        return $this->cutoff_time;
    }

    public function hasCutoffTime()
    {
        return isset($this->cutoff_time);
    }

    public function clearCutoffTime()
    {
        unset($this->cutoff_time);
    }

    /**
     * Business days cutoff time definition.
     * If not configured the cutoff time will be defaulted to 8AM PST.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.CutoffTime cutoff_time = 3;</code>
     * @param \Google\Shopping\Merchant\Accounts\V1beta\CutoffTime $var
     * @return $this
     */
    public function setCutoffTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Merchant\Accounts\V1beta\CutoffTime::class);
        $this->cutoff_time = $var;

        return $this;
    }

    /**
     * Minimum number of business days spent before an order is shipped.
     * 0 means same day shipped, 1 means next day shipped.
     * 'min_handling_days' and 'max_handling_days' should be either set or not set
     * at the same time.
     *
     * Generated from protobuf field <code>optional int32 min_handling_days = 4;</code>
     * @return int
     */
    public function getMinHandlingDays()
    {
        return isset($this->min_handling_days) ? $this->min_handling_days : 0;
    }

    public function hasMinHandlingDays()
    {
        return isset($this->min_handling_days);
    }

    public function clearMinHandlingDays()
    {
        unset($this->min_handling_days);
    }

    /**
     * Minimum number of business days spent before an order is shipped.
     * 0 means same day shipped, 1 means next day shipped.
     * 'min_handling_days' and 'max_handling_days' should be either set or not set
     * at the same time.
     *
     * Generated from protobuf field <code>optional int32 min_handling_days = 4;</code>
     * @param int $var
     * @return $this
     */
    public function setMinHandlingDays($var)
    {
        GPBUtil::checkInt32($var);
        $this->min_handling_days = $var;

        return $this;
    }

    /**
     * Maximum number of business days spent before an order is shipped.
     * 0 means same day shipped, 1 means next day shipped.
     * Must be greater than or equal to `min_handling_days`.
     * 'min_handling_days' and 'max_handling_days' should be either set or not set
     * at the same time.
     *
     * Generated from protobuf field <code>optional int32 max_handling_days = 5;</code>
     * @return int
     */
    public function getMaxHandlingDays()
    {
        return isset($this->max_handling_days) ? $this->max_handling_days : 0;
    }

    public function hasMaxHandlingDays()
    {
        return isset($this->max_handling_days);
    }

    public function clearMaxHandlingDays()
    {
        unset($this->max_handling_days);
    }

    /**
     * Maximum number of business days spent before an order is shipped.
     * 0 means same day shipped, 1 means next day shipped.
     * Must be greater than or equal to `min_handling_days`.
     * 'min_handling_days' and 'max_handling_days' should be either set or not set
     * at the same time.
     *
     * Generated from protobuf field <code>optional int32 max_handling_days = 5;</code>
     * @param int $var
     * @return $this
     */
    public function setMaxHandlingDays($var)
    {
        GPBUtil::checkInt32($var);
        $this->max_handling_days = $var;

        return $this;
    }

    /**
     * Transit time table, number of business days spent in transit based on row
     * and column dimensions. Either `min_transit_days`, `max_transit_days` or
     * `transit_time_table` can be set, but not both.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.TransitTable transit_time_table = 6;</code>
     * @return \Google\Shopping\Merchant\Accounts\V1beta\TransitTable|null
     */
    public function getTransitTimeTable()
    {
        return $this->transit_time_table;
    }

    public function hasTransitTimeTable()
    {
        return isset($this->transit_time_table);
    }

    public function clearTransitTimeTable()
    {
        unset($this->transit_time_table);
    }

    /**
     * Transit time table, number of business days spent in transit based on row
     * and column dimensions. Either `min_transit_days`, `max_transit_days` or
     * `transit_time_table` can be set, but not both.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.TransitTable transit_time_table = 6;</code>
     * @param \Google\Shopping\Merchant\Accounts\V1beta\TransitTable $var
     * @return $this
     */
    public function setTransitTimeTable($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Merchant\Accounts\V1beta\TransitTable::class);
        $this->transit_time_table = $var;

        return $this;
    }

    /**
     * The business days during which orders can be handled.
     * If not provided, Monday to Friday business days will be assumed.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.BusinessDayConfig handling_business_day_config = 7;</code>
     * @return \Google\Shopping\Merchant\Accounts\V1beta\BusinessDayConfig|null
     */
    public function getHandlingBusinessDayConfig()
    {
        return $this->handling_business_day_config;
    }

    public function hasHandlingBusinessDayConfig()
    {
        return isset($this->handling_business_day_config);
    }

    public function clearHandlingBusinessDayConfig()
    {
        unset($this->handling_business_day_config);
    }

    /**
     * The business days during which orders can be handled.
     * If not provided, Monday to Friday business days will be assumed.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.BusinessDayConfig handling_business_day_config = 7;</code>
     * @param \Google\Shopping\Merchant\Accounts\V1beta\BusinessDayConfig $var
     * @return $this
     */
    public function setHandlingBusinessDayConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Merchant\Accounts\V1beta\BusinessDayConfig::class);
        $this->handling_business_day_config = $var;

        return $this;
    }

    /**
     * The business days during which orders can be in-transit.
     * If not provided, Monday to Friday business days will be assumed.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.BusinessDayConfig transit_business_day_config = 8;</code>
     * @return \Google\Shopping\Merchant\Accounts\V1beta\BusinessDayConfig|null
     */
    public function getTransitBusinessDayConfig()
    {
        return $this->transit_business_day_config;
    }

    public function hasTransitBusinessDayConfig()
    {
        return isset($this->transit_business_day_config);
    }

    public function clearTransitBusinessDayConfig()
    {
        unset($this->transit_business_day_config);
    }

    /**
     * The business days during which orders can be in-transit.
     * If not provided, Monday to Friday business days will be assumed.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.BusinessDayConfig transit_business_day_config = 8;</code>
     * @param \Google\Shopping\Merchant\Accounts\V1beta\BusinessDayConfig $var
     * @return $this
     */
    public function setTransitBusinessDayConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Merchant\Accounts\V1beta\BusinessDayConfig::class);
        $this->transit_business_day_config = $var;

        return $this;
    }

    /**
     * Optional. Indicates that the delivery time should be calculated per
     * warehouse (shipping origin location) based on the settings of the selected
     * carrier. When set, no other transit time related field in [delivery
     * time][[google.shopping.content.bundles.ShippingSetting.DeliveryTime] should
     * be set.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.WarehouseBasedDeliveryTime warehouse_based_delivery_times = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getWarehouseBasedDeliveryTimes()
    {
        return $this->warehouse_based_delivery_times;
    }

    /**
     * Optional. Indicates that the delivery time should be calculated per
     * warehouse (shipping origin location) based on the settings of the selected
     * carrier. When set, no other transit time related field in [delivery
     * time][[google.shopping.content.bundles.ShippingSetting.DeliveryTime] should
     * be set.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.WarehouseBasedDeliveryTime warehouse_based_delivery_times = 9 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<\Google\Shopping\Merchant\Accounts\V1beta\WarehouseBasedDeliveryTime>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setWarehouseBasedDeliveryTimes($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Shopping\Merchant\Accounts\V1beta\WarehouseBasedDeliveryTime::class);
        $this->warehouse_based_delivery_times = $arr;

        return $this;
    }

}

