<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/accounts/v1beta/shippingsettings.proto

namespace Google\Shopping\Merchant\Accounts\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A non-empty list of row or column headers for a table.
 * Exactly one of `prices`, `weights`,
 * `num_items`, `postal_code_group_names`, or
 * `location` must be set.
 *
 * Generated from protobuf message <code>google.shopping.merchant.accounts.v1beta.Headers</code>
 */
class Headers extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. A list of inclusive order price upper bounds. The last price's
     * value can be infinity by setting price amount_micros = -1. For example
     * `[{"amount_micros": 10000000, "currency_code": "USD"},
     * {"amount_micros": 500000000, "currency_code": "USD"},
     * {"amount_micros": -1, "currency_code": "USD"}]` represents the headers
     * "<= $10", "<= $500", and "> $500". All prices within a service must have
     * the same currency. Must be non-empty. Must be positive except -1. Can only
     * be set if all other fields are not set.
     *
     * Generated from protobuf field <code>repeated .google.shopping.type.Price prices = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $prices;
    /**
     * Required. A list of inclusive order weight upper bounds. The last weight's
     * value can be infinity by setting price amount_micros = -1. For example
     * `[{"amount_micros": 10000000, "unit": "kg"}, {"amount_micros": 50000000,
     * "unit": "kg"},
     * {"amount_micros": -1, "unit": "kg"}]` represents the headers
     * "<= 10kg", "<= 50kg", and "> 50kg". All weights within a service must have
     * the same unit. Must be non-empty. Must be positive except -1. Can only be
     * set if all other fields are not set.
     *
     * Generated from protobuf field <code>repeated .google.shopping.type.Weight weights = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $weights;
    /**
     * Required. A list of inclusive number of items upper bounds. The last value
     * can be
     * `"infinity"`. For example
     * `["10", "50", "infinity"]` represents the headers
     * "<= 10 items", "<= 50 items", and "> 50 items". Must be non-empty. Can
     * only be set if all other fields are not set.
     *
     * Generated from protobuf field <code>repeated string number_of_items = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $number_of_items;
    /**
     * Required. A list of postal group names. The last value can be
     * `"all other locations"`. Example:
     * `["zone 1", "zone 2", "all other locations"]`. The referred
     * postal code groups must match the delivery country of the service. Must
     * be non-empty. Can only be set if all other fields are not set.
     *
     * Generated from protobuf field <code>repeated string postal_code_group_names = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $postal_code_group_names;
    /**
     * Required. A list of location ID sets. Must be non-empty. Can only be set if
     * all other fields are not set.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.LocationIdSet locations = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $locations;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type array<\Google\Shopping\Type\Price>|\Google\Protobuf\Internal\RepeatedField $prices
     *           Required. A list of inclusive order price upper bounds. The last price's
     *           value can be infinity by setting price amount_micros = -1. For example
     *           `[{"amount_micros": 10000000, "currency_code": "USD"},
     *           {"amount_micros": 500000000, "currency_code": "USD"},
     *           {"amount_micros": -1, "currency_code": "USD"}]` represents the headers
     *           "<= $10", "<= $500", and "> $500". All prices within a service must have
     *           the same currency. Must be non-empty. Must be positive except -1. Can only
     *           be set if all other fields are not set.
     *     @type array<\Google\Shopping\Type\Weight>|\Google\Protobuf\Internal\RepeatedField $weights
     *           Required. A list of inclusive order weight upper bounds. The last weight's
     *           value can be infinity by setting price amount_micros = -1. For example
     *           `[{"amount_micros": 10000000, "unit": "kg"}, {"amount_micros": 50000000,
     *           "unit": "kg"},
     *           {"amount_micros": -1, "unit": "kg"}]` represents the headers
     *           "<= 10kg", "<= 50kg", and "> 50kg". All weights within a service must have
     *           the same unit. Must be non-empty. Must be positive except -1. Can only be
     *           set if all other fields are not set.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $number_of_items
     *           Required. A list of inclusive number of items upper bounds. The last value
     *           can be
     *           `"infinity"`. For example
     *           `["10", "50", "infinity"]` represents the headers
     *           "<= 10 items", "<= 50 items", and "> 50 items". Must be non-empty. Can
     *           only be set if all other fields are not set.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $postal_code_group_names
     *           Required. A list of postal group names. The last value can be
     *           `"all other locations"`. Example:
     *           `["zone 1", "zone 2", "all other locations"]`. The referred
     *           postal code groups must match the delivery country of the service. Must
     *           be non-empty. Can only be set if all other fields are not set.
     *     @type array<\Google\Shopping\Merchant\Accounts\V1beta\LocationIdSet>|\Google\Protobuf\Internal\RepeatedField $locations
     *           Required. A list of location ID sets. Must be non-empty. Can only be set if
     *           all other fields are not set.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Accounts\V1Beta\Shippingsettings::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. A list of inclusive order price upper bounds. The last price's
     * value can be infinity by setting price amount_micros = -1. For example
     * `[{"amount_micros": 10000000, "currency_code": "USD"},
     * {"amount_micros": 500000000, "currency_code": "USD"},
     * {"amount_micros": -1, "currency_code": "USD"}]` represents the headers
     * "<= $10", "<= $500", and "> $500". All prices within a service must have
     * the same currency. Must be non-empty. Must be positive except -1. Can only
     * be set if all other fields are not set.
     *
     * Generated from protobuf field <code>repeated .google.shopping.type.Price prices = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getPrices()
    {
        return $this->prices;
    }

    /**
     * Required. A list of inclusive order price upper bounds. The last price's
     * value can be infinity by setting price amount_micros = -1. For example
     * `[{"amount_micros": 10000000, "currency_code": "USD"},
     * {"amount_micros": 500000000, "currency_code": "USD"},
     * {"amount_micros": -1, "currency_code": "USD"}]` represents the headers
     * "<= $10", "<= $500", and "> $500". All prices within a service must have
     * the same currency. Must be non-empty. Must be positive except -1. Can only
     * be set if all other fields are not set.
     *
     * Generated from protobuf field <code>repeated .google.shopping.type.Price prices = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param array<\Google\Shopping\Type\Price>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setPrices($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Shopping\Type\Price::class);
        $this->prices = $arr;

        return $this;
    }

    /**
     * Required. A list of inclusive order weight upper bounds. The last weight's
     * value can be infinity by setting price amount_micros = -1. For example
     * `[{"amount_micros": 10000000, "unit": "kg"}, {"amount_micros": 50000000,
     * "unit": "kg"},
     * {"amount_micros": -1, "unit": "kg"}]` represents the headers
     * "<= 10kg", "<= 50kg", and "> 50kg". All weights within a service must have
     * the same unit. Must be non-empty. Must be positive except -1. Can only be
     * set if all other fields are not set.
     *
     * Generated from protobuf field <code>repeated .google.shopping.type.Weight weights = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getWeights()
    {
        return $this->weights;
    }

    /**
     * Required. A list of inclusive order weight upper bounds. The last weight's
     * value can be infinity by setting price amount_micros = -1. For example
     * `[{"amount_micros": 10000000, "unit": "kg"}, {"amount_micros": 50000000,
     * "unit": "kg"},
     * {"amount_micros": -1, "unit": "kg"}]` represents the headers
     * "<= 10kg", "<= 50kg", and "> 50kg". All weights within a service must have
     * the same unit. Must be non-empty. Must be positive except -1. Can only be
     * set if all other fields are not set.
     *
     * Generated from protobuf field <code>repeated .google.shopping.type.Weight weights = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param array<\Google\Shopping\Type\Weight>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setWeights($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Shopping\Type\Weight::class);
        $this->weights = $arr;

        return $this;
    }

    /**
     * Required. A list of inclusive number of items upper bounds. The last value
     * can be
     * `"infinity"`. For example
     * `["10", "50", "infinity"]` represents the headers
     * "<= 10 items", "<= 50 items", and "> 50 items". Must be non-empty. Can
     * only be set if all other fields are not set.
     *
     * Generated from protobuf field <code>repeated string number_of_items = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getNumberOfItems()
    {
        return $this->number_of_items;
    }

    /**
     * Required. A list of inclusive number of items upper bounds. The last value
     * can be
     * `"infinity"`. For example
     * `["10", "50", "infinity"]` represents the headers
     * "<= 10 items", "<= 50 items", and "> 50 items". Must be non-empty. Can
     * only be set if all other fields are not set.
     *
     * Generated from protobuf field <code>repeated string number_of_items = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setNumberOfItems($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->number_of_items = $arr;

        return $this;
    }

    /**
     * Required. A list of postal group names. The last value can be
     * `"all other locations"`. Example:
     * `["zone 1", "zone 2", "all other locations"]`. The referred
     * postal code groups must match the delivery country of the service. Must
     * be non-empty. Can only be set if all other fields are not set.
     *
     * Generated from protobuf field <code>repeated string postal_code_group_names = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getPostalCodeGroupNames()
    {
        return $this->postal_code_group_names;
    }

    /**
     * Required. A list of postal group names. The last value can be
     * `"all other locations"`. Example:
     * `["zone 1", "zone 2", "all other locations"]`. The referred
     * postal code groups must match the delivery country of the service. Must
     * be non-empty. Can only be set if all other fields are not set.
     *
     * Generated from protobuf field <code>repeated string postal_code_group_names = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setPostalCodeGroupNames($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->postal_code_group_names = $arr;

        return $this;
    }

    /**
     * Required. A list of location ID sets. Must be non-empty. Can only be set if
     * all other fields are not set.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.LocationIdSet locations = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getLocations()
    {
        return $this->locations;
    }

    /**
     * Required. A list of location ID sets. Must be non-empty. Can only be set if
     * all other fields are not set.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.LocationIdSet locations = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param array<\Google\Shopping\Merchant\Accounts\V1beta\LocationIdSet>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setLocations($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Shopping\Merchant\Accounts\V1beta\LocationIdSet::class);
        $this->locations = $arr;

        return $this;
    }

}

