<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/accounts/v1beta/accountissue.proto

namespace Google\Shopping\Merchant\Accounts\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for the `ListAccountIssues` method.
 *
 * Generated from protobuf message <code>google.shopping.merchant.accounts.v1beta.ListAccountIssuesRequest</code>
 */
class ListAccountIssuesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent, which owns this collection of issues.
     * Format: `accounts/{account}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. The maximum number of issues to return. The service may return
     * fewer than this value. If unspecified, at most 50 users will be returned.
     * The maximum value is 100; values above 100 will be coerced to 100
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. A page token, received from a previous `ListAccountIssues` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListAccountIssues` must
     * match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';
    /**
     * Optional. The issues in the response will have human-readable fields in the
     * given language. The format is [BCP-47](https://tools.ietf.org/html/bcp47),
     * such as `en-US` or `sr-Latn`. If not value is provided, `en-US` will be
     * used.
     *
     * Generated from protobuf field <code>string language_code = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $language_code = '';
    /**
     * Optional. The [IANA](https://www.iana.org/time-zones) timezone used to
     * localize times in human-readable fields. For example 'America/Los_Angeles'.
     * If not set, 'America/Los_Angeles' will be used.
     *
     * Generated from protobuf field <code>string time_zone = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $time_zone = '';

    /**
     * @param string $parent Required. The parent, which owns this collection of issues.
     *                       Format: `accounts/{account}`
     *                       Please see {@see AccountIssueServiceClient::accountName()} for help formatting this field.
     *
     * @return \Google\Shopping\Merchant\Accounts\V1beta\ListAccountIssuesRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent, which owns this collection of issues.
     *           Format: `accounts/{account}`
     *     @type int $page_size
     *           Optional. The maximum number of issues to return. The service may return
     *           fewer than this value. If unspecified, at most 50 users will be returned.
     *           The maximum value is 100; values above 100 will be coerced to 100
     *     @type string $page_token
     *           Optional. A page token, received from a previous `ListAccountIssues` call.
     *           Provide this to retrieve the subsequent page.
     *           When paginating, all other parameters provided to `ListAccountIssues` must
     *           match the call that provided the page token.
     *     @type string $language_code
     *           Optional. The issues in the response will have human-readable fields in the
     *           given language. The format is [BCP-47](https://tools.ietf.org/html/bcp47),
     *           such as `en-US` or `sr-Latn`. If not value is provided, `en-US` will be
     *           used.
     *     @type string $time_zone
     *           Optional. The [IANA](https://www.iana.org/time-zones) timezone used to
     *           localize times in human-readable fields. For example 'America/Los_Angeles'.
     *           If not set, 'America/Los_Angeles' will be used.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Accounts\V1Beta\Accountissue::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent, which owns this collection of issues.
     * Format: `accounts/{account}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent, which owns this collection of issues.
     * Format: `accounts/{account}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. The maximum number of issues to return. The service may return
     * fewer than this value. If unspecified, at most 50 users will be returned.
     * The maximum value is 100; values above 100 will be coerced to 100
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. The maximum number of issues to return. The service may return
     * fewer than this value. If unspecified, at most 50 users will be returned.
     * The maximum value is 100; values above 100 will be coerced to 100
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. A page token, received from a previous `ListAccountIssues` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListAccountIssues` must
     * match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. A page token, received from a previous `ListAccountIssues` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListAccountIssues` must
     * match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. The issues in the response will have human-readable fields in the
     * given language. The format is [BCP-47](https://tools.ietf.org/html/bcp47),
     * such as `en-US` or `sr-Latn`. If not value is provided, `en-US` will be
     * used.
     *
     * Generated from protobuf field <code>string language_code = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getLanguageCode()
    {
        return $this->language_code;
    }

    /**
     * Optional. The issues in the response will have human-readable fields in the
     * given language. The format is [BCP-47](https://tools.ietf.org/html/bcp47),
     * such as `en-US` or `sr-Latn`. If not value is provided, `en-US` will be
     * used.
     *
     * Generated from protobuf field <code>string language_code = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setLanguageCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->language_code = $var;

        return $this;
    }

    /**
     * Optional. The [IANA](https://www.iana.org/time-zones) timezone used to
     * localize times in human-readable fields. For example 'America/Los_Angeles'.
     * If not set, 'America/Los_Angeles' will be used.
     *
     * Generated from protobuf field <code>string time_zone = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getTimeZone()
    {
        return $this->time_zone;
    }

    /**
     * Optional. The [IANA](https://www.iana.org/time-zones) timezone used to
     * localize times in human-readable fields. For example 'America/Los_Angeles'.
     * If not set, 'America/Los_Angeles' will be used.
     *
     * Generated from protobuf field <code>string time_zone = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setTimeZone($var)
    {
        GPBUtil::checkString($var, True);
        $this->time_zone = $var;

        return $this;
    }

}

