<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/accounts/v1beta/online_return_policy.proto

namespace Google\Shopping\Merchant\Accounts\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for the `ListOnlineReturnPolicies` method.
 *
 * Generated from protobuf message <code>google.shopping.merchant.accounts.v1beta.ListOnlineReturnPoliciesRequest</code>
 */
class ListOnlineReturnPoliciesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The merchant account for which to list return policies.
     * Format: `accounts/{account}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. The maximum number of `OnlineReturnPolicy` resources to return.
     * The service returns fewer than this value if the number of return policies
     * for the given merchant is less that than the `pageSize`. The default value
     * is 10. The maximum value is 100; If a value higher than the maximum is
     * specified, then the `pageSize` will default to the maximum
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. A page token, received from a previous `ListOnlineReturnPolicies`
     * call. Provide the page token to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * `ListOnlineReturnPolicies` must match the call that provided the page
     * token. The token returned as
     * [nextPageToken][google.shopping.merchant.accounts.v1beta.ListOnlineReturnPoliciesResponse.next_page_token]
     * in the response to the previous request.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';

    /**
     * @param string $parent Required. The merchant account for which to list return policies.
     *                       Format: `accounts/{account}`
     *                       Please see {@see OnlineReturnPolicyServiceClient::accountName()} for help formatting this field.
     *
     * @return \Google\Shopping\Merchant\Accounts\V1beta\ListOnlineReturnPoliciesRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The merchant account for which to list return policies.
     *           Format: `accounts/{account}`
     *     @type int $page_size
     *           Optional. The maximum number of `OnlineReturnPolicy` resources to return.
     *           The service returns fewer than this value if the number of return policies
     *           for the given merchant is less that than the `pageSize`. The default value
     *           is 10. The maximum value is 100; If a value higher than the maximum is
     *           specified, then the `pageSize` will default to the maximum
     *     @type string $page_token
     *           Optional. A page token, received from a previous `ListOnlineReturnPolicies`
     *           call. Provide the page token to retrieve the subsequent page.
     *           When paginating, all other parameters provided to
     *           `ListOnlineReturnPolicies` must match the call that provided the page
     *           token. The token returned as
     *           [nextPageToken][google.shopping.merchant.accounts.v1beta.ListOnlineReturnPoliciesResponse.next_page_token]
     *           in the response to the previous request.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Accounts\V1Beta\OnlineReturnPolicy::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The merchant account for which to list return policies.
     * Format: `accounts/{account}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The merchant account for which to list return policies.
     * Format: `accounts/{account}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. The maximum number of `OnlineReturnPolicy` resources to return.
     * The service returns fewer than this value if the number of return policies
     * for the given merchant is less that than the `pageSize`. The default value
     * is 10. The maximum value is 100; If a value higher than the maximum is
     * specified, then the `pageSize` will default to the maximum
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. The maximum number of `OnlineReturnPolicy` resources to return.
     * The service returns fewer than this value if the number of return policies
     * for the given merchant is less that than the `pageSize`. The default value
     * is 10. The maximum value is 100; If a value higher than the maximum is
     * specified, then the `pageSize` will default to the maximum
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. A page token, received from a previous `ListOnlineReturnPolicies`
     * call. Provide the page token to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * `ListOnlineReturnPolicies` must match the call that provided the page
     * token. The token returned as
     * [nextPageToken][google.shopping.merchant.accounts.v1beta.ListOnlineReturnPoliciesResponse.next_page_token]
     * in the response to the previous request.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. A page token, received from a previous `ListOnlineReturnPolicies`
     * call. Provide the page token to retrieve the subsequent page.
     * When paginating, all other parameters provided to
     * `ListOnlineReturnPolicies` must match the call that provided the page
     * token. The token returned as
     * [nextPageToken][google.shopping.merchant.accounts.v1beta.ListOnlineReturnPoliciesResponse.next_page_token]
     * in the response to the previous request.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

