<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/accounts/v1beta/accounts.proto

namespace Google\Shopping\Merchant\Accounts\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for the `ListSubAccounts` method.
 *
 * Generated from protobuf message <code>google.shopping.merchant.accounts.v1beta.ListSubAccountsRequest</code>
 */
class ListSubAccountsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent account.
     * Format: `accounts/{account}`
     *
     * Generated from protobuf field <code>string provider = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $provider = '';
    /**
     * Optional. The maximum number of accounts to return. The service may return
     * fewer than this value.  If unspecified, at most 250 accounts are returned.
     * The maximum value is 500; values above 500 are coerced to 500.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. A page token, received from a previous `ListAccounts` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListAccounts` must match
     * the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';

    /**
     * @param string $provider Required. The parent account.
     *                         Format: `accounts/{account}`
     *                         Please see {@see AccountsServiceClient::accountName()} for help formatting this field.
     *
     * @return \Google\Shopping\Merchant\Accounts\V1beta\ListSubAccountsRequest
     *
     * @experimental
     */
    public static function build(string $provider): self
    {
        return (new self())
            ->setProvider($provider);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $provider
     *           Required. The parent account.
     *           Format: `accounts/{account}`
     *     @type int $page_size
     *           Optional. The maximum number of accounts to return. The service may return
     *           fewer than this value.  If unspecified, at most 250 accounts are returned.
     *           The maximum value is 500; values above 500 are coerced to 500.
     *     @type string $page_token
     *           Optional. A page token, received from a previous `ListAccounts` call.
     *           Provide this to retrieve the subsequent page.
     *           When paginating, all other parameters provided to `ListAccounts` must match
     *           the call that provided the page token.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Accounts\V1Beta\Accounts::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent account.
     * Format: `accounts/{account}`
     *
     * Generated from protobuf field <code>string provider = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getProvider()
    {
        return $this->provider;
    }

    /**
     * Required. The parent account.
     * Format: `accounts/{account}`
     *
     * Generated from protobuf field <code>string provider = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setProvider($var)
    {
        GPBUtil::checkString($var, True);
        $this->provider = $var;

        return $this;
    }

    /**
     * Optional. The maximum number of accounts to return. The service may return
     * fewer than this value.  If unspecified, at most 250 accounts are returned.
     * The maximum value is 500; values above 500 are coerced to 500.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. The maximum number of accounts to return. The service may return
     * fewer than this value.  If unspecified, at most 250 accounts are returned.
     * The maximum value is 500; values above 500 are coerced to 500.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. A page token, received from a previous `ListAccounts` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListAccounts` must match
     * the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. A page token, received from a previous `ListAccounts` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListAccounts` must match
     * the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

