<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/accounts/v1beta/shippingsettings.proto

namespace Google\Shopping\Merchant\Accounts\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Shipping rate group definitions. Only the last one is allowed to have an
 * empty `applicable_shipping_labels`, which means
 * "everything else". The other `applicable_shipping_labels` must
 * not overlap.
 *
 * Generated from protobuf message <code>google.shopping.merchant.accounts.v1beta.RateGroup</code>
 */
class RateGroup extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. A list of [shipping
     * labels](https://support.google.com/merchants/answer/6324504) defining the
     * products to which this rate group applies to. This is a disjunction: only
     * one of the labels has to match for the rate group to apply. May only be
     * empty for the last rate group of a service.
     *
     * Generated from protobuf field <code>repeated string applicable_shipping_labels = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $applicable_shipping_labels;
    /**
     * The value of the rate group (For example flat rate $10). Can only be set
     * if `main_table` and `subtables` are not set.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.Value single_value = 2;</code>
     */
    protected $single_value = null;
    /**
     * A table defining the rate group, when `single_value` is not
     * expressive enough. Can only be set if `single_value` is not
     * set.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.Table main_table = 3;</code>
     */
    protected $main_table = null;
    /**
     * Optional. A list of subtables referred to by `main_table`. Can only
     * be set if `main_table` is set.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.Table subtables = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $subtables;
    /**
     * Optional. A list of carrier rates that can be referred to by
     * `main_table` or `single_value`.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.CarrierRate carrier_rates = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $carrier_rates;
    /**
     * Optional. Name of the rate group.
     * If set has to be unique within shipping service.
     *
     * Generated from protobuf field <code>optional string name = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $name = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $applicable_shipping_labels
     *           Required. A list of [shipping
     *           labels](https://support.google.com/merchants/answer/6324504) defining the
     *           products to which this rate group applies to. This is a disjunction: only
     *           one of the labels has to match for the rate group to apply. May only be
     *           empty for the last rate group of a service.
     *     @type \Google\Shopping\Merchant\Accounts\V1beta\Value $single_value
     *           The value of the rate group (For example flat rate $10). Can only be set
     *           if `main_table` and `subtables` are not set.
     *     @type \Google\Shopping\Merchant\Accounts\V1beta\Table $main_table
     *           A table defining the rate group, when `single_value` is not
     *           expressive enough. Can only be set if `single_value` is not
     *           set.
     *     @type array<\Google\Shopping\Merchant\Accounts\V1beta\Table>|\Google\Protobuf\Internal\RepeatedField $subtables
     *           Optional. A list of subtables referred to by `main_table`. Can only
     *           be set if `main_table` is set.
     *     @type array<\Google\Shopping\Merchant\Accounts\V1beta\CarrierRate>|\Google\Protobuf\Internal\RepeatedField $carrier_rates
     *           Optional. A list of carrier rates that can be referred to by
     *           `main_table` or `single_value`.
     *     @type string $name
     *           Optional. Name of the rate group.
     *           If set has to be unique within shipping service.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Accounts\V1Beta\Shippingsettings::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. A list of [shipping
     * labels](https://support.google.com/merchants/answer/6324504) defining the
     * products to which this rate group applies to. This is a disjunction: only
     * one of the labels has to match for the rate group to apply. May only be
     * empty for the last rate group of a service.
     *
     * Generated from protobuf field <code>repeated string applicable_shipping_labels = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getApplicableShippingLabels()
    {
        return $this->applicable_shipping_labels;
    }

    /**
     * Required. A list of [shipping
     * labels](https://support.google.com/merchants/answer/6324504) defining the
     * products to which this rate group applies to. This is a disjunction: only
     * one of the labels has to match for the rate group to apply. May only be
     * empty for the last rate group of a service.
     *
     * Generated from protobuf field <code>repeated string applicable_shipping_labels = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setApplicableShippingLabels($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->applicable_shipping_labels = $arr;

        return $this;
    }

    /**
     * The value of the rate group (For example flat rate $10). Can only be set
     * if `main_table` and `subtables` are not set.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.Value single_value = 2;</code>
     * @return \Google\Shopping\Merchant\Accounts\V1beta\Value|null
     */
    public function getSingleValue()
    {
        return $this->single_value;
    }

    public function hasSingleValue()
    {
        return isset($this->single_value);
    }

    public function clearSingleValue()
    {
        unset($this->single_value);
    }

    /**
     * The value of the rate group (For example flat rate $10). Can only be set
     * if `main_table` and `subtables` are not set.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.Value single_value = 2;</code>
     * @param \Google\Shopping\Merchant\Accounts\V1beta\Value $var
     * @return $this
     */
    public function setSingleValue($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Merchant\Accounts\V1beta\Value::class);
        $this->single_value = $var;

        return $this;
    }

    /**
     * A table defining the rate group, when `single_value` is not
     * expressive enough. Can only be set if `single_value` is not
     * set.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.Table main_table = 3;</code>
     * @return \Google\Shopping\Merchant\Accounts\V1beta\Table|null
     */
    public function getMainTable()
    {
        return $this->main_table;
    }

    public function hasMainTable()
    {
        return isset($this->main_table);
    }

    public function clearMainTable()
    {
        unset($this->main_table);
    }

    /**
     * A table defining the rate group, when `single_value` is not
     * expressive enough. Can only be set if `single_value` is not
     * set.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.Table main_table = 3;</code>
     * @param \Google\Shopping\Merchant\Accounts\V1beta\Table $var
     * @return $this
     */
    public function setMainTable($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Merchant\Accounts\V1beta\Table::class);
        $this->main_table = $var;

        return $this;
    }

    /**
     * Optional. A list of subtables referred to by `main_table`. Can only
     * be set if `main_table` is set.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.Table subtables = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSubtables()
    {
        return $this->subtables;
    }

    /**
     * Optional. A list of subtables referred to by `main_table`. Can only
     * be set if `main_table` is set.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.Table subtables = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<\Google\Shopping\Merchant\Accounts\V1beta\Table>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSubtables($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Shopping\Merchant\Accounts\V1beta\Table::class);
        $this->subtables = $arr;

        return $this;
    }

    /**
     * Optional. A list of carrier rates that can be referred to by
     * `main_table` or `single_value`.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.CarrierRate carrier_rates = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getCarrierRates()
    {
        return $this->carrier_rates;
    }

    /**
     * Optional. A list of carrier rates that can be referred to by
     * `main_table` or `single_value`.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.CarrierRate carrier_rates = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<\Google\Shopping\Merchant\Accounts\V1beta\CarrierRate>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setCarrierRates($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Shopping\Merchant\Accounts\V1beta\CarrierRate::class);
        $this->carrier_rates = $arr;

        return $this;
    }

    /**
     * Optional. Name of the rate group.
     * If set has to be unique within shipping service.
     *
     * Generated from protobuf field <code>optional string name = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getName()
    {
        return isset($this->name) ? $this->name : '';
    }

    public function hasName()
    {
        return isset($this->name);
    }

    public function clearName()
    {
        unset($this->name);
    }

    /**
     * Optional. Name of the rate group.
     * If set has to be unique within shipping service.
     *
     * Generated from protobuf field <code>optional string name = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

}

