<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/accounts/v1beta/shippingsettings.proto

namespace Google\Shopping\Merchant\Accounts\V1beta\Service\StoreConfig;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Configs related to local delivery ends for the day.
 *
 * Generated from protobuf message <code>google.shopping.merchant.accounts.v1beta.Service.StoreConfig.CutoffConfig</code>
 */
class CutoffConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * Time that local delivery ends for the day.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.Service.StoreConfig.CutoffConfig.LocalCutoffTime local_cutoff_time = 1;</code>
     */
    protected $local_cutoff_time = null;
    /**
     * Only valid with local delivery fulfillment. Represents cutoff time
     * as the number of hours before store closing. Mutually exclusive
     * with `local_cutoff_time`.
     *
     * Generated from protobuf field <code>optional int64 store_close_offset_hours = 2;</code>
     */
    protected $store_close_offset_hours = null;
    /**
     * Merchants can opt-out of showing n+1 day local delivery when they have
     * a shipping service configured to n day local delivery. For example, if
     * the shipping service defines same-day delivery, and it's past the
     * cut-off, setting this field to `true` results in the calculated
     * shipping service rate returning `NO_DELIVERY_POST_CUTOFF`. In the
     * same example, setting this field to `false` results in the calculated
     * shipping time being one day. This is only for local delivery.
     *
     * Generated from protobuf field <code>optional bool no_delivery_post_cutoff = 3;</code>
     */
    protected $no_delivery_post_cutoff = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Shopping\Merchant\Accounts\V1beta\Service\StoreConfig\CutoffConfig\LocalCutoffTime $local_cutoff_time
     *           Time that local delivery ends for the day.
     *     @type int|string $store_close_offset_hours
     *           Only valid with local delivery fulfillment. Represents cutoff time
     *           as the number of hours before store closing. Mutually exclusive
     *           with `local_cutoff_time`.
     *     @type bool $no_delivery_post_cutoff
     *           Merchants can opt-out of showing n+1 day local delivery when they have
     *           a shipping service configured to n day local delivery. For example, if
     *           the shipping service defines same-day delivery, and it's past the
     *           cut-off, setting this field to `true` results in the calculated
     *           shipping service rate returning `NO_DELIVERY_POST_CUTOFF`. In the
     *           same example, setting this field to `false` results in the calculated
     *           shipping time being one day. This is only for local delivery.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Accounts\V1Beta\Shippingsettings::initOnce();
        parent::__construct($data);
    }

    /**
     * Time that local delivery ends for the day.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.Service.StoreConfig.CutoffConfig.LocalCutoffTime local_cutoff_time = 1;</code>
     * @return \Google\Shopping\Merchant\Accounts\V1beta\Service\StoreConfig\CutoffConfig\LocalCutoffTime|null
     */
    public function getLocalCutoffTime()
    {
        return $this->local_cutoff_time;
    }

    public function hasLocalCutoffTime()
    {
        return isset($this->local_cutoff_time);
    }

    public function clearLocalCutoffTime()
    {
        unset($this->local_cutoff_time);
    }

    /**
     * Time that local delivery ends for the day.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.Service.StoreConfig.CutoffConfig.LocalCutoffTime local_cutoff_time = 1;</code>
     * @param \Google\Shopping\Merchant\Accounts\V1beta\Service\StoreConfig\CutoffConfig\LocalCutoffTime $var
     * @return $this
     */
    public function setLocalCutoffTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Merchant\Accounts\V1beta\Service\StoreConfig\CutoffConfig\LocalCutoffTime::class);
        $this->local_cutoff_time = $var;

        return $this;
    }

    /**
     * Only valid with local delivery fulfillment. Represents cutoff time
     * as the number of hours before store closing. Mutually exclusive
     * with `local_cutoff_time`.
     *
     * Generated from protobuf field <code>optional int64 store_close_offset_hours = 2;</code>
     * @return int|string
     */
    public function getStoreCloseOffsetHours()
    {
        return isset($this->store_close_offset_hours) ? $this->store_close_offset_hours : 0;
    }

    public function hasStoreCloseOffsetHours()
    {
        return isset($this->store_close_offset_hours);
    }

    public function clearStoreCloseOffsetHours()
    {
        unset($this->store_close_offset_hours);
    }

    /**
     * Only valid with local delivery fulfillment. Represents cutoff time
     * as the number of hours before store closing. Mutually exclusive
     * with `local_cutoff_time`.
     *
     * Generated from protobuf field <code>optional int64 store_close_offset_hours = 2;</code>
     * @param int|string $var
     * @return $this
     */
    public function setStoreCloseOffsetHours($var)
    {
        GPBUtil::checkInt64($var);
        $this->store_close_offset_hours = $var;

        return $this;
    }

    /**
     * Merchants can opt-out of showing n+1 day local delivery when they have
     * a shipping service configured to n day local delivery. For example, if
     * the shipping service defines same-day delivery, and it's past the
     * cut-off, setting this field to `true` results in the calculated
     * shipping service rate returning `NO_DELIVERY_POST_CUTOFF`. In the
     * same example, setting this field to `false` results in the calculated
     * shipping time being one day. This is only for local delivery.
     *
     * Generated from protobuf field <code>optional bool no_delivery_post_cutoff = 3;</code>
     * @return bool
     */
    public function getNoDeliveryPostCutoff()
    {
        return isset($this->no_delivery_post_cutoff) ? $this->no_delivery_post_cutoff : false;
    }

    public function hasNoDeliveryPostCutoff()
    {
        return isset($this->no_delivery_post_cutoff);
    }

    public function clearNoDeliveryPostCutoff()
    {
        unset($this->no_delivery_post_cutoff);
    }

    /**
     * Merchants can opt-out of showing n+1 day local delivery when they have
     * a shipping service configured to n day local delivery. For example, if
     * the shipping service defines same-day delivery, and it's past the
     * cut-off, setting this field to `true` results in the calculated
     * shipping service rate returning `NO_DELIVERY_POST_CUTOFF`. In the
     * same example, setting this field to `false` results in the calculated
     * shipping time being one day. This is only for local delivery.
     *
     * Generated from protobuf field <code>optional bool no_delivery_post_cutoff = 3;</code>
     * @param bool $var
     * @return $this
     */
    public function setNoDeliveryPostCutoff($var)
    {
        GPBUtil::checkBool($var);
        $this->no_delivery_post_cutoff = $var;

        return $this;
    }

}


