<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/accounts/v1beta/shippingsettings.proto

namespace Google\Shopping\Merchant\Accounts\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The merchant account's [shipping
 * setting](https://support.google.com/merchants/answer/6069284).
 *
 * Generated from protobuf message <code>google.shopping.merchant.accounts.v1beta.ShippingSettings</code>
 */
class ShippingSettings extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. The resource name of the shipping setting.
     * Format: `accounts/{account}/shippingSetting`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Optional. The target account's list of services.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.Service services = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $services;
    /**
     * Optional. A list of warehouses which can be referred to in `services`.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.Warehouse warehouses = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $warehouses;
    /**
     * Required. This field is used for avoid async issue. Make sure shipping
     * setting data
     *  didn't change between get call and insert call. The user should do
     *  following steps：
     * 1. Set etag field as empty string for initial shipping setting creation.
     * 2. After initial creation, call get method to obtain an etag and current
     * shipping setting data before call insert.
     * 3. Modify to wanted shipping setting information.
     * 4. Call insert method with the wanted shipping setting information with
     * the etag obtained from step 2.
     * 5. If shipping setting data changed between step 2 and step 4. Insert
     * request will fail because the etag changes every time the shipping setting
     * data changes. User should repeate step 2-4 with the new etag.
     *
     * Generated from protobuf field <code>string etag = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $etag = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. The resource name of the shipping setting.
     *           Format: `accounts/{account}/shippingSetting`
     *     @type array<\Google\Shopping\Merchant\Accounts\V1beta\Service>|\Google\Protobuf\Internal\RepeatedField $services
     *           Optional. The target account's list of services.
     *     @type array<\Google\Shopping\Merchant\Accounts\V1beta\Warehouse>|\Google\Protobuf\Internal\RepeatedField $warehouses
     *           Optional. A list of warehouses which can be referred to in `services`.
     *     @type string $etag
     *           Required. This field is used for avoid async issue. Make sure shipping
     *           setting data
     *            didn't change between get call and insert call. The user should do
     *            following steps：
     *           1. Set etag field as empty string for initial shipping setting creation.
     *           2. After initial creation, call get method to obtain an etag and current
     *           shipping setting data before call insert.
     *           3. Modify to wanted shipping setting information.
     *           4. Call insert method with the wanted shipping setting information with
     *           the etag obtained from step 2.
     *           5. If shipping setting data changed between step 2 and step 4. Insert
     *           request will fail because the etag changes every time the shipping setting
     *           data changes. User should repeate step 2-4 with the new etag.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Accounts\V1Beta\Shippingsettings::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. The resource name of the shipping setting.
     * Format: `accounts/{account}/shippingSetting`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. The resource name of the shipping setting.
     * Format: `accounts/{account}/shippingSetting`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Optional. The target account's list of services.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.Service services = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getServices()
    {
        return $this->services;
    }

    /**
     * Optional. The target account's list of services.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.Service services = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<\Google\Shopping\Merchant\Accounts\V1beta\Service>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setServices($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Shopping\Merchant\Accounts\V1beta\Service::class);
        $this->services = $arr;

        return $this;
    }

    /**
     * Optional. A list of warehouses which can be referred to in `services`.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.Warehouse warehouses = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getWarehouses()
    {
        return $this->warehouses;
    }

    /**
     * Optional. A list of warehouses which can be referred to in `services`.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.Warehouse warehouses = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<\Google\Shopping\Merchant\Accounts\V1beta\Warehouse>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setWarehouses($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Shopping\Merchant\Accounts\V1beta\Warehouse::class);
        $this->warehouses = $arr;

        return $this;
    }

    /**
     * Required. This field is used for avoid async issue. Make sure shipping
     * setting data
     *  didn't change between get call and insert call. The user should do
     *  following steps：
     * 1. Set etag field as empty string for initial shipping setting creation.
     * 2. After initial creation, call get method to obtain an etag and current
     * shipping setting data before call insert.
     * 3. Modify to wanted shipping setting information.
     * 4. Call insert method with the wanted shipping setting information with
     * the etag obtained from step 2.
     * 5. If shipping setting data changed between step 2 and step 4. Insert
     * request will fail because the etag changes every time the shipping setting
     * data changes. User should repeate step 2-4 with the new etag.
     *
     * Generated from protobuf field <code>string etag = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getEtag()
    {
        return $this->etag;
    }

    /**
     * Required. This field is used for avoid async issue. Make sure shipping
     * setting data
     *  didn't change between get call and insert call. The user should do
     *  following steps：
     * 1. Set etag field as empty string for initial shipping setting creation.
     * 2. After initial creation, call get method to obtain an etag and current
     * shipping setting data before call insert.
     * 3. Modify to wanted shipping setting information.
     * 4. Call insert method with the wanted shipping setting information with
     * the etag obtained from step 2.
     * 5. If shipping setting data changed between step 2 and step 4. Insert
     * request will fail because the etag changes every time the shipping setting
     * data changes. User should repeate step 2-4 with the new etag.
     *
     * Generated from protobuf field <code>string etag = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setEtag($var)
    {
        GPBUtil::checkString($var, True);
        $this->etag = $var;

        return $this;
    }

}

