<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/accounts/v1beta/shippingsettings.proto

namespace Google\Shopping\Merchant\Accounts\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Transit time table, number of business days spent in transit based on row
 * and column dimensions. Either `min_transit_days`, `max_transit_days` or
 * `transit_time_table` can be set, but not both.
 *
 * Generated from protobuf message <code>google.shopping.merchant.accounts.v1beta.TransitTable</code>
 */
class TransitTable extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. A list of region names
     * [Region.name][google.shopping.merchant.accounts.v1beta.Region.name] . The
     * last value can be
     * `"all other locations"`. Example:
     * `["zone 1", "zone 2", "all other locations"]`. The referred
     * postal code groups must match the delivery country of the service.
     *
     * Generated from protobuf field <code>repeated string postal_code_group_names = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $postal_code_group_names;
    /**
     * Required. A list of transit time labels. The last value can be
     * `"all other labels"`. Example:
     * `["food", "electronics", "all other labels"]`.
     *
     * Generated from protobuf field <code>repeated string transit_time_labels = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $transit_time_labels;
    /**
     * Required. If there's only one dimension set of `postal_code_group_names` or
     * `transit_time_labels`, there are multiple rows each with one value
     * for that dimension. If there are two dimensions, each row corresponds to a
     * `postal_code_group_names`, and columns (values) to a
     * `transit_time_labels`.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.TransitTable.TransitTimeRow rows = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $rows;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $postal_code_group_names
     *           Required. A list of region names
     *           [Region.name][google.shopping.merchant.accounts.v1beta.Region.name] . The
     *           last value can be
     *           `"all other locations"`. Example:
     *           `["zone 1", "zone 2", "all other locations"]`. The referred
     *           postal code groups must match the delivery country of the service.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $transit_time_labels
     *           Required. A list of transit time labels. The last value can be
     *           `"all other labels"`. Example:
     *           `["food", "electronics", "all other labels"]`.
     *     @type array<\Google\Shopping\Merchant\Accounts\V1beta\TransitTable\TransitTimeRow>|\Google\Protobuf\Internal\RepeatedField $rows
     *           Required. If there's only one dimension set of `postal_code_group_names` or
     *           `transit_time_labels`, there are multiple rows each with one value
     *           for that dimension. If there are two dimensions, each row corresponds to a
     *           `postal_code_group_names`, and columns (values) to a
     *           `transit_time_labels`.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Accounts\V1Beta\Shippingsettings::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. A list of region names
     * [Region.name][google.shopping.merchant.accounts.v1beta.Region.name] . The
     * last value can be
     * `"all other locations"`. Example:
     * `["zone 1", "zone 2", "all other locations"]`. The referred
     * postal code groups must match the delivery country of the service.
     *
     * Generated from protobuf field <code>repeated string postal_code_group_names = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getPostalCodeGroupNames()
    {
        return $this->postal_code_group_names;
    }

    /**
     * Required. A list of region names
     * [Region.name][google.shopping.merchant.accounts.v1beta.Region.name] . The
     * last value can be
     * `"all other locations"`. Example:
     * `["zone 1", "zone 2", "all other locations"]`. The referred
     * postal code groups must match the delivery country of the service.
     *
     * Generated from protobuf field <code>repeated string postal_code_group_names = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setPostalCodeGroupNames($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->postal_code_group_names = $arr;

        return $this;
    }

    /**
     * Required. A list of transit time labels. The last value can be
     * `"all other labels"`. Example:
     * `["food", "electronics", "all other labels"]`.
     *
     * Generated from protobuf field <code>repeated string transit_time_labels = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getTransitTimeLabels()
    {
        return $this->transit_time_labels;
    }

    /**
     * Required. A list of transit time labels. The last value can be
     * `"all other labels"`. Example:
     * `["food", "electronics", "all other labels"]`.
     *
     * Generated from protobuf field <code>repeated string transit_time_labels = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setTransitTimeLabels($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->transit_time_labels = $arr;

        return $this;
    }

    /**
     * Required. If there's only one dimension set of `postal_code_group_names` or
     * `transit_time_labels`, there are multiple rows each with one value
     * for that dimension. If there are two dimensions, each row corresponds to a
     * `postal_code_group_names`, and columns (values) to a
     * `transit_time_labels`.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.TransitTable.TransitTimeRow rows = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getRows()
    {
        return $this->rows;
    }

    /**
     * Required. If there's only one dimension set of `postal_code_group_names` or
     * `transit_time_labels`, there are multiple rows each with one value
     * for that dimension. If there are two dimensions, each row corresponds to a
     * `postal_code_group_names`, and columns (values) to a
     * `transit_time_labels`.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.accounts.v1beta.TransitTable.TransitTimeRow rows = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param array<\Google\Shopping\Merchant\Accounts\V1beta\TransitTable\TransitTimeRow>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setRows($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Shopping\Merchant\Accounts\V1beta\TransitTable\TransitTimeRow::class);
        $this->rows = $arr;

        return $this;
    }

}

