<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/accounts/v1beta/shippingsettings.proto

namespace Google\Shopping\Merchant\Accounts\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The single value of a rate group or the value of a rate group table's cell.
 * Exactly one of `no_shipping`, `flat_rate`,
 * `price_percentage`, `carrier_rateName`,
 * `subtable_name` must be set.
 *
 * Generated from protobuf message <code>google.shopping.merchant.accounts.v1beta.Value</code>
 */
class Value extends \Google\Protobuf\Internal\Message
{
    /**
     * If true, then the product can't be shipped. Must be true when set, can only
     * be set if all other fields are not set.
     *
     * Generated from protobuf field <code>optional bool no_shipping = 1;</code>
     */
    protected $no_shipping = null;
    /**
     * A flat rate. Can only be set if all other fields are not set.
     *
     * Generated from protobuf field <code>optional .google.shopping.type.Price flat_rate = 2;</code>
     */
    protected $flat_rate = null;
    /**
     * A percentage of the price represented as a number in decimal notation
     * (For example, `"5.4"`). Can only be set if all other fields are not
     * set.
     *
     * Generated from protobuf field <code>optional string price_percentage = 3;</code>
     */
    protected $price_percentage = null;
    /**
     * The name of a carrier rate referring to a carrier rate defined in the
     * same rate group. Can only be set if all other fields are not set.
     *
     * Generated from protobuf field <code>optional string carrier_rate = 4;</code>
     */
    protected $carrier_rate = null;
    /**
     * The name of a subtable. Can only be set in table cells (For example, not
     * for single values), and only if all other fields are not set.
     *
     * Generated from protobuf field <code>optional string subtable = 5;</code>
     */
    protected $subtable = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type bool $no_shipping
     *           If true, then the product can't be shipped. Must be true when set, can only
     *           be set if all other fields are not set.
     *     @type \Google\Shopping\Type\Price $flat_rate
     *           A flat rate. Can only be set if all other fields are not set.
     *     @type string $price_percentage
     *           A percentage of the price represented as a number in decimal notation
     *           (For example, `"5.4"`). Can only be set if all other fields are not
     *           set.
     *     @type string $carrier_rate
     *           The name of a carrier rate referring to a carrier rate defined in the
     *           same rate group. Can only be set if all other fields are not set.
     *     @type string $subtable
     *           The name of a subtable. Can only be set in table cells (For example, not
     *           for single values), and only if all other fields are not set.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Accounts\V1Beta\Shippingsettings::initOnce();
        parent::__construct($data);
    }

    /**
     * If true, then the product can't be shipped. Must be true when set, can only
     * be set if all other fields are not set.
     *
     * Generated from protobuf field <code>optional bool no_shipping = 1;</code>
     * @return bool
     */
    public function getNoShipping()
    {
        return isset($this->no_shipping) ? $this->no_shipping : false;
    }

    public function hasNoShipping()
    {
        return isset($this->no_shipping);
    }

    public function clearNoShipping()
    {
        unset($this->no_shipping);
    }

    /**
     * If true, then the product can't be shipped. Must be true when set, can only
     * be set if all other fields are not set.
     *
     * Generated from protobuf field <code>optional bool no_shipping = 1;</code>
     * @param bool $var
     * @return $this
     */
    public function setNoShipping($var)
    {
        GPBUtil::checkBool($var);
        $this->no_shipping = $var;

        return $this;
    }

    /**
     * A flat rate. Can only be set if all other fields are not set.
     *
     * Generated from protobuf field <code>optional .google.shopping.type.Price flat_rate = 2;</code>
     * @return \Google\Shopping\Type\Price|null
     */
    public function getFlatRate()
    {
        return $this->flat_rate;
    }

    public function hasFlatRate()
    {
        return isset($this->flat_rate);
    }

    public function clearFlatRate()
    {
        unset($this->flat_rate);
    }

    /**
     * A flat rate. Can only be set if all other fields are not set.
     *
     * Generated from protobuf field <code>optional .google.shopping.type.Price flat_rate = 2;</code>
     * @param \Google\Shopping\Type\Price $var
     * @return $this
     */
    public function setFlatRate($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Type\Price::class);
        $this->flat_rate = $var;

        return $this;
    }

    /**
     * A percentage of the price represented as a number in decimal notation
     * (For example, `"5.4"`). Can only be set if all other fields are not
     * set.
     *
     * Generated from protobuf field <code>optional string price_percentage = 3;</code>
     * @return string
     */
    public function getPricePercentage()
    {
        return isset($this->price_percentage) ? $this->price_percentage : '';
    }

    public function hasPricePercentage()
    {
        return isset($this->price_percentage);
    }

    public function clearPricePercentage()
    {
        unset($this->price_percentage);
    }

    /**
     * A percentage of the price represented as a number in decimal notation
     * (For example, `"5.4"`). Can only be set if all other fields are not
     * set.
     *
     * Generated from protobuf field <code>optional string price_percentage = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPricePercentage($var)
    {
        GPBUtil::checkString($var, True);
        $this->price_percentage = $var;

        return $this;
    }

    /**
     * The name of a carrier rate referring to a carrier rate defined in the
     * same rate group. Can only be set if all other fields are not set.
     *
     * Generated from protobuf field <code>optional string carrier_rate = 4;</code>
     * @return string
     */
    public function getCarrierRate()
    {
        return isset($this->carrier_rate) ? $this->carrier_rate : '';
    }

    public function hasCarrierRate()
    {
        return isset($this->carrier_rate);
    }

    public function clearCarrierRate()
    {
        unset($this->carrier_rate);
    }

    /**
     * The name of a carrier rate referring to a carrier rate defined in the
     * same rate group. Can only be set if all other fields are not set.
     *
     * Generated from protobuf field <code>optional string carrier_rate = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setCarrierRate($var)
    {
        GPBUtil::checkString($var, True);
        $this->carrier_rate = $var;

        return $this;
    }

    /**
     * The name of a subtable. Can only be set in table cells (For example, not
     * for single values), and only if all other fields are not set.
     *
     * Generated from protobuf field <code>optional string subtable = 5;</code>
     * @return string
     */
    public function getSubtable()
    {
        return isset($this->subtable) ? $this->subtable : '';
    }

    public function hasSubtable()
    {
        return isset($this->subtable);
    }

    public function clearSubtable()
    {
        unset($this->subtable);
    }

    /**
     * The name of a subtable. Can only be set in table cells (For example, not
     * for single values), and only if all other fields are not set.
     *
     * Generated from protobuf field <code>optional string subtable = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setSubtable($var)
    {
        GPBUtil::checkString($var, True);
        $this->subtable = $var;

        return $this;
    }

}

