<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/accounts/v1beta/shippingsettings.proto

namespace Google\Shopping\Merchant\Accounts\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A fulfillment warehouse, which stores and handles inventory.
 * Next tag: 7
 *
 * Generated from protobuf message <code>google.shopping.merchant.accounts.v1beta.Warehouse</code>
 */
class Warehouse extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the warehouse. Must be unique within account.
     *
     * Generated from protobuf field <code>optional string name = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $name = null;
    /**
     * Required. Shipping address of the warehouse.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.Address shipping_address = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $shipping_address = null;
    /**
     * Required. The latest time of day that an order can be accepted and begin
     * processing. Later orders will be processed in the next day. The time is
     * based on the warehouse postal code.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.WarehouseCutoffTime cutoff_time = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $cutoff_time = null;
    /**
     * Required. The number of days it takes for this warehouse to pack up and
     * ship an item. This is on the warehouse level, but can be overridden on the
     * offer level based on the attributes of an item.
     *
     * Generated from protobuf field <code>optional int64 handling_days = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $handling_days = null;
    /**
     * Business days of the warehouse.
     * If not set, will be Monday to Friday by default.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.BusinessDayConfig business_day_config = 5;</code>
     */
    protected $business_day_config = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. The name of the warehouse. Must be unique within account.
     *     @type \Google\Shopping\Merchant\Accounts\V1beta\Address $shipping_address
     *           Required. Shipping address of the warehouse.
     *     @type \Google\Shopping\Merchant\Accounts\V1beta\WarehouseCutoffTime $cutoff_time
     *           Required. The latest time of day that an order can be accepted and begin
     *           processing. Later orders will be processed in the next day. The time is
     *           based on the warehouse postal code.
     *     @type int|string $handling_days
     *           Required. The number of days it takes for this warehouse to pack up and
     *           ship an item. This is on the warehouse level, but can be overridden on the
     *           offer level based on the attributes of an item.
     *     @type \Google\Shopping\Merchant\Accounts\V1beta\BusinessDayConfig $business_day_config
     *           Business days of the warehouse.
     *           If not set, will be Monday to Friday by default.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Accounts\V1Beta\Shippingsettings::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the warehouse. Must be unique within account.
     *
     * Generated from protobuf field <code>optional string name = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getName()
    {
        return isset($this->name) ? $this->name : '';
    }

    public function hasName()
    {
        return isset($this->name);
    }

    public function clearName()
    {
        unset($this->name);
    }

    /**
     * Required. The name of the warehouse. Must be unique within account.
     *
     * Generated from protobuf field <code>optional string name = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Required. Shipping address of the warehouse.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.Address shipping_address = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Shopping\Merchant\Accounts\V1beta\Address|null
     */
    public function getShippingAddress()
    {
        return $this->shipping_address;
    }

    public function hasShippingAddress()
    {
        return isset($this->shipping_address);
    }

    public function clearShippingAddress()
    {
        unset($this->shipping_address);
    }

    /**
     * Required. Shipping address of the warehouse.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.Address shipping_address = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Shopping\Merchant\Accounts\V1beta\Address $var
     * @return $this
     */
    public function setShippingAddress($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Merchant\Accounts\V1beta\Address::class);
        $this->shipping_address = $var;

        return $this;
    }

    /**
     * Required. The latest time of day that an order can be accepted and begin
     * processing. Later orders will be processed in the next day. The time is
     * based on the warehouse postal code.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.WarehouseCutoffTime cutoff_time = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Shopping\Merchant\Accounts\V1beta\WarehouseCutoffTime|null
     */
    public function getCutoffTime()
    {
        return $this->cutoff_time;
    }

    public function hasCutoffTime()
    {
        return isset($this->cutoff_time);
    }

    public function clearCutoffTime()
    {
        unset($this->cutoff_time);
    }

    /**
     * Required. The latest time of day that an order can be accepted and begin
     * processing. Later orders will be processed in the next day. The time is
     * based on the warehouse postal code.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.WarehouseCutoffTime cutoff_time = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Shopping\Merchant\Accounts\V1beta\WarehouseCutoffTime $var
     * @return $this
     */
    public function setCutoffTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Merchant\Accounts\V1beta\WarehouseCutoffTime::class);
        $this->cutoff_time = $var;

        return $this;
    }

    /**
     * Required. The number of days it takes for this warehouse to pack up and
     * ship an item. This is on the warehouse level, but can be overridden on the
     * offer level based on the attributes of an item.
     *
     * Generated from protobuf field <code>optional int64 handling_days = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return int|string
     */
    public function getHandlingDays()
    {
        return isset($this->handling_days) ? $this->handling_days : 0;
    }

    public function hasHandlingDays()
    {
        return isset($this->handling_days);
    }

    public function clearHandlingDays()
    {
        unset($this->handling_days);
    }

    /**
     * Required. The number of days it takes for this warehouse to pack up and
     * ship an item. This is on the warehouse level, but can be overridden on the
     * offer level based on the attributes of an item.
     *
     * Generated from protobuf field <code>optional int64 handling_days = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int|string $var
     * @return $this
     */
    public function setHandlingDays($var)
    {
        GPBUtil::checkInt64($var);
        $this->handling_days = $var;

        return $this;
    }

    /**
     * Business days of the warehouse.
     * If not set, will be Monday to Friday by default.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.BusinessDayConfig business_day_config = 5;</code>
     * @return \Google\Shopping\Merchant\Accounts\V1beta\BusinessDayConfig|null
     */
    public function getBusinessDayConfig()
    {
        return $this->business_day_config;
    }

    public function hasBusinessDayConfig()
    {
        return isset($this->business_day_config);
    }

    public function clearBusinessDayConfig()
    {
        unset($this->business_day_config);
    }

    /**
     * Business days of the warehouse.
     * If not set, will be Monday to Friday by default.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.accounts.v1beta.BusinessDayConfig business_day_config = 5;</code>
     * @param \Google\Shopping\Merchant\Accounts\V1beta\BusinessDayConfig $var
     * @return $this
     */
    public function setBusinessDayConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Merchant\Accounts\V1beta\BusinessDayConfig::class);
        $this->business_day_config = $var;

        return $this;
    }

}

