<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/conversions/v1beta/conversionsources.proto

namespace Google\Shopping\Merchant\Conversions\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for the ListConversionSources method.
 *
 * Generated from protobuf message <code>google.shopping.merchant.conversions.v1beta.ListConversionSourcesRequest</code>
 */
class ListConversionSourcesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The merchant account who owns the collection of conversion
     * sources. Format: accounts/{account}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. The maximum number of conversion sources to return in a page.
     * If no `page_size` is specified, `100` is used as the default value. The
     * maximum value is `200`. Values above `200` will be coerced to `200`.
     * Regardless of pagination, at most `200` conversion sources are returned
     * in total.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. Page token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';
    /**
     * Optional. Show deleted (archived) option.
     *
     * Generated from protobuf field <code>bool show_deleted = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $show_deleted = false;

    /**
     * @param string $parent Required. The merchant account who owns the collection of conversion
     *                       sources. Format: accounts/{account}
     *                       Please see {@see ConversionSourcesServiceClient::accountName()} for help formatting this field.
     *
     * @return \Google\Shopping\Merchant\Conversions\V1beta\ListConversionSourcesRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The merchant account who owns the collection of conversion
     *           sources. Format: accounts/{account}
     *     @type int $page_size
     *           Optional. The maximum number of conversion sources to return in a page.
     *           If no `page_size` is specified, `100` is used as the default value. The
     *           maximum value is `200`. Values above `200` will be coerced to `200`.
     *           Regardless of pagination, at most `200` conversion sources are returned
     *           in total.
     *     @type string $page_token
     *           Optional. Page token.
     *     @type bool $show_deleted
     *           Optional. Show deleted (archived) option.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Conversions\V1Beta\Conversionsources::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The merchant account who owns the collection of conversion
     * sources. Format: accounts/{account}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The merchant account who owns the collection of conversion
     * sources. Format: accounts/{account}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. The maximum number of conversion sources to return in a page.
     * If no `page_size` is specified, `100` is used as the default value. The
     * maximum value is `200`. Values above `200` will be coerced to `200`.
     * Regardless of pagination, at most `200` conversion sources are returned
     * in total.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. The maximum number of conversion sources to return in a page.
     * If no `page_size` is specified, `100` is used as the default value. The
     * maximum value is `200`. Values above `200` will be coerced to `200`.
     * Regardless of pagination, at most `200` conversion sources are returned
     * in total.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. Page token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. Page token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. Show deleted (archived) option.
     *
     * Generated from protobuf field <code>bool show_deleted = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getShowDeleted()
    {
        return $this->show_deleted;
    }

    /**
     * Optional. Show deleted (archived) option.
     *
     * Generated from protobuf field <code>bool show_deleted = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setShowDeleted($var)
    {
        GPBUtil::checkBool($var);
        $this->show_deleted = $var;

        return $this;
    }

}

