<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/conversions/v1beta/conversionsources.proto

namespace Google\Shopping\Merchant\Conversions\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * "Merchant Center Destination" sources can be used to send conversion events
 * from an online store using a Google tag directly to a Merchant Center account
 * where the source is created.
 *
 * Generated from protobuf message <code>google.shopping.merchant.conversions.v1beta.MerchantCenterDestination</code>
 */
class MerchantCenterDestination extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. Merchant Center Destination ID.
     *
     * Generated from protobuf field <code>string destination = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $destination = '';
    /**
     * Required. Attribution settings being used for the Merchant Center
     * Destination.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.conversions.v1beta.AttributionSettings attribution_settings = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $attribution_settings = null;
    /**
     * Required. Merchant-specified display name for the destination. This is the
     * name that identifies the conversion source within the Merchant Center UI.
     * Limited to 64 characters.
     *
     * Generated from protobuf field <code>string display_name = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $display_name = '';
    /**
     * Required. Three-letter currency code (ISO 4217). The currency code defines
     * in which currency the conversions sent to this destination will be reported
     * in Merchant Center.
     *
     * Generated from protobuf field <code>string currency_code = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $currency_code = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $destination
     *           Output only. Merchant Center Destination ID.
     *     @type \Google\Shopping\Merchant\Conversions\V1beta\AttributionSettings $attribution_settings
     *           Required. Attribution settings being used for the Merchant Center
     *           Destination.
     *     @type string $display_name
     *           Required. Merchant-specified display name for the destination. This is the
     *           name that identifies the conversion source within the Merchant Center UI.
     *           Limited to 64 characters.
     *     @type string $currency_code
     *           Required. Three-letter currency code (ISO 4217). The currency code defines
     *           in which currency the conversions sent to this destination will be reported
     *           in Merchant Center.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Conversions\V1Beta\Conversionsources::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. Merchant Center Destination ID.
     *
     * Generated from protobuf field <code>string destination = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getDestination()
    {
        return $this->destination;
    }

    /**
     * Output only. Merchant Center Destination ID.
     *
     * Generated from protobuf field <code>string destination = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setDestination($var)
    {
        GPBUtil::checkString($var, True);
        $this->destination = $var;

        return $this;
    }

    /**
     * Required. Attribution settings being used for the Merchant Center
     * Destination.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.conversions.v1beta.AttributionSettings attribution_settings = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Shopping\Merchant\Conversions\V1beta\AttributionSettings|null
     */
    public function getAttributionSettings()
    {
        return $this->attribution_settings;
    }

    public function hasAttributionSettings()
    {
        return isset($this->attribution_settings);
    }

    public function clearAttributionSettings()
    {
        unset($this->attribution_settings);
    }

    /**
     * Required. Attribution settings being used for the Merchant Center
     * Destination.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.conversions.v1beta.AttributionSettings attribution_settings = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Shopping\Merchant\Conversions\V1beta\AttributionSettings $var
     * @return $this
     */
    public function setAttributionSettings($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Merchant\Conversions\V1beta\AttributionSettings::class);
        $this->attribution_settings = $var;

        return $this;
    }

    /**
     * Required. Merchant-specified display name for the destination. This is the
     * name that identifies the conversion source within the Merchant Center UI.
     * Limited to 64 characters.
     *
     * Generated from protobuf field <code>string display_name = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * Required. Merchant-specified display name for the destination. This is the
     * name that identifies the conversion source within the Merchant Center UI.
     * Limited to 64 characters.
     *
     * Generated from protobuf field <code>string display_name = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * Required. Three-letter currency code (ISO 4217). The currency code defines
     * in which currency the conversions sent to this destination will be reported
     * in Merchant Center.
     *
     * Generated from protobuf field <code>string currency_code = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getCurrencyCode()
    {
        return $this->currency_code;
    }

    /**
     * Required. Three-letter currency code (ISO 4217). The currency code defines
     * in which currency the conversions sent to this destination will be reported
     * in Merchant Center.
     *
     * Generated from protobuf field <code>string currency_code = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setCurrencyCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->currency_code = $var;

        return $this;
    }

}

