<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/lfp/v1beta/lfpsale.proto

namespace Google\Shopping\Merchant\Lfp\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A sale for the merchant.
 *
 * Generated from protobuf message <code>google.shopping.merchant.lfp.v1beta.LfpSale</code>
 */
class LfpSale extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. Identifier. The name of the `LfpSale` resource.
     * Format:
     * `accounts/{account}/lfpSales/{sale}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Required. The Merchant Center ID of the merchant to submit the sale for.
     *
     * Generated from protobuf field <code>int64 target_account = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $target_account = 0;
    /**
     * Required. The identifier of the merchant's store. Either a `storeCode`
     * inserted through the API or the code of the store in the Business Profile.
     *
     * Generated from protobuf field <code>string store_code = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $store_code = '';
    /**
     * Required. A unique identifier for the product. If both inventories and
     * sales are submitted for a merchant, this id should match for the same
     * product.
     * **Note**: if the merchant sells the same product new and used, they should
     * have different IDs.
     *
     * Generated from protobuf field <code>string offer_id = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $offer_id = '';
    /**
     * Required. The [CLDR territory
     * code](https://github.com/unicode-org/cldr/blob/latest/common/main/en.xml)
     * for the country where the product is sold.
     *
     * Generated from protobuf field <code>string region_code = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $region_code = '';
    /**
     * Required. The two-letter ISO 639-1 language code for the item.
     *
     * Generated from protobuf field <code>string content_language = 6 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $content_language = '';
    /**
     * Required. The Global Trade Item Number of the sold product.
     *
     * Generated from protobuf field <code>string gtin = 7 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $gtin = '';
    /**
     * Required. The unit price of the product.
     *
     * Generated from protobuf field <code>.google.shopping.type.Price price = 8 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $price = null;
    /**
     * Required. The relative change of the available quantity. Negative for items
     * returned.
     *
     * Generated from protobuf field <code>int64 quantity = 9 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $quantity = 0;
    /**
     * Required. The timestamp for the sale.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp sale_time = 10 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $sale_time = null;
    /**
     * Output only. System generated globally unique ID for the `LfpSale`.
     *
     * Generated from protobuf field <code>optional string uid = 11 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_info) = {</code>
     */
    protected $uid = null;
    /**
     * Optional. The [feed
     * label](https://developers.google.com/shopping-content/guides/products/feed-labels)
     * for the product. If this is not set, it will default to `regionCode`.
     *
     * Generated from protobuf field <code>optional string feed_label = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $feed_label = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. Identifier. The name of the `LfpSale` resource.
     *           Format:
     *           `accounts/{account}/lfpSales/{sale}`
     *     @type int|string $target_account
     *           Required. The Merchant Center ID of the merchant to submit the sale for.
     *     @type string $store_code
     *           Required. The identifier of the merchant's store. Either a `storeCode`
     *           inserted through the API or the code of the store in the Business Profile.
     *     @type string $offer_id
     *           Required. A unique identifier for the product. If both inventories and
     *           sales are submitted for a merchant, this id should match for the same
     *           product.
     *           **Note**: if the merchant sells the same product new and used, they should
     *           have different IDs.
     *     @type string $region_code
     *           Required. The [CLDR territory
     *           code](https://github.com/unicode-org/cldr/blob/latest/common/main/en.xml)
     *           for the country where the product is sold.
     *     @type string $content_language
     *           Required. The two-letter ISO 639-1 language code for the item.
     *     @type string $gtin
     *           Required. The Global Trade Item Number of the sold product.
     *     @type \Google\Shopping\Type\Price $price
     *           Required. The unit price of the product.
     *     @type int|string $quantity
     *           Required. The relative change of the available quantity. Negative for items
     *           returned.
     *     @type \Google\Protobuf\Timestamp $sale_time
     *           Required. The timestamp for the sale.
     *     @type string $uid
     *           Output only. System generated globally unique ID for the `LfpSale`.
     *     @type string $feed_label
     *           Optional. The [feed
     *           label](https://developers.google.com/shopping-content/guides/products/feed-labels)
     *           for the product. If this is not set, it will default to `regionCode`.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Lfp\V1Beta\Lfpsale::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. Identifier. The name of the `LfpSale` resource.
     * Format:
     * `accounts/{account}/lfpSales/{sale}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. Identifier. The name of the `LfpSale` resource.
     * Format:
     * `accounts/{account}/lfpSales/{sale}`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Required. The Merchant Center ID of the merchant to submit the sale for.
     *
     * Generated from protobuf field <code>int64 target_account = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return int|string
     */
    public function getTargetAccount()
    {
        return $this->target_account;
    }

    /**
     * Required. The Merchant Center ID of the merchant to submit the sale for.
     *
     * Generated from protobuf field <code>int64 target_account = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int|string $var
     * @return $this
     */
    public function setTargetAccount($var)
    {
        GPBUtil::checkInt64($var);
        $this->target_account = $var;

        return $this;
    }

    /**
     * Required. The identifier of the merchant's store. Either a `storeCode`
     * inserted through the API or the code of the store in the Business Profile.
     *
     * Generated from protobuf field <code>string store_code = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getStoreCode()
    {
        return $this->store_code;
    }

    /**
     * Required. The identifier of the merchant's store. Either a `storeCode`
     * inserted through the API or the code of the store in the Business Profile.
     *
     * Generated from protobuf field <code>string store_code = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setStoreCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->store_code = $var;

        return $this;
    }

    /**
     * Required. A unique identifier for the product. If both inventories and
     * sales are submitted for a merchant, this id should match for the same
     * product.
     * **Note**: if the merchant sells the same product new and used, they should
     * have different IDs.
     *
     * Generated from protobuf field <code>string offer_id = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getOfferId()
    {
        return $this->offer_id;
    }

    /**
     * Required. A unique identifier for the product. If both inventories and
     * sales are submitted for a merchant, this id should match for the same
     * product.
     * **Note**: if the merchant sells the same product new and used, they should
     * have different IDs.
     *
     * Generated from protobuf field <code>string offer_id = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setOfferId($var)
    {
        GPBUtil::checkString($var, True);
        $this->offer_id = $var;

        return $this;
    }

    /**
     * Required. The [CLDR territory
     * code](https://github.com/unicode-org/cldr/blob/latest/common/main/en.xml)
     * for the country where the product is sold.
     *
     * Generated from protobuf field <code>string region_code = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getRegionCode()
    {
        return $this->region_code;
    }

    /**
     * Required. The [CLDR territory
     * code](https://github.com/unicode-org/cldr/blob/latest/common/main/en.xml)
     * for the country where the product is sold.
     *
     * Generated from protobuf field <code>string region_code = 5 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setRegionCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->region_code = $var;

        return $this;
    }

    /**
     * Required. The two-letter ISO 639-1 language code for the item.
     *
     * Generated from protobuf field <code>string content_language = 6 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getContentLanguage()
    {
        return $this->content_language;
    }

    /**
     * Required. The two-letter ISO 639-1 language code for the item.
     *
     * Generated from protobuf field <code>string content_language = 6 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setContentLanguage($var)
    {
        GPBUtil::checkString($var, True);
        $this->content_language = $var;

        return $this;
    }

    /**
     * Required. The Global Trade Item Number of the sold product.
     *
     * Generated from protobuf field <code>string gtin = 7 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getGtin()
    {
        return $this->gtin;
    }

    /**
     * Required. The Global Trade Item Number of the sold product.
     *
     * Generated from protobuf field <code>string gtin = 7 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setGtin($var)
    {
        GPBUtil::checkString($var, True);
        $this->gtin = $var;

        return $this;
    }

    /**
     * Required. The unit price of the product.
     *
     * Generated from protobuf field <code>.google.shopping.type.Price price = 8 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Shopping\Type\Price|null
     */
    public function getPrice()
    {
        return $this->price;
    }

    public function hasPrice()
    {
        return isset($this->price);
    }

    public function clearPrice()
    {
        unset($this->price);
    }

    /**
     * Required. The unit price of the product.
     *
     * Generated from protobuf field <code>.google.shopping.type.Price price = 8 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Shopping\Type\Price $var
     * @return $this
     */
    public function setPrice($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Type\Price::class);
        $this->price = $var;

        return $this;
    }

    /**
     * Required. The relative change of the available quantity. Negative for items
     * returned.
     *
     * Generated from protobuf field <code>int64 quantity = 9 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return int|string
     */
    public function getQuantity()
    {
        return $this->quantity;
    }

    /**
     * Required. The relative change of the available quantity. Negative for items
     * returned.
     *
     * Generated from protobuf field <code>int64 quantity = 9 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int|string $var
     * @return $this
     */
    public function setQuantity($var)
    {
        GPBUtil::checkInt64($var);
        $this->quantity = $var;

        return $this;
    }

    /**
     * Required. The timestamp for the sale.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp sale_time = 10 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getSaleTime()
    {
        return $this->sale_time;
    }

    public function hasSaleTime()
    {
        return isset($this->sale_time);
    }

    public function clearSaleTime()
    {
        unset($this->sale_time);
    }

    /**
     * Required. The timestamp for the sale.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp sale_time = 10 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setSaleTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->sale_time = $var;

        return $this;
    }

    /**
     * Output only. System generated globally unique ID for the `LfpSale`.
     *
     * Generated from protobuf field <code>optional string uid = 11 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_info) = {</code>
     * @return string
     */
    public function getUid()
    {
        return isset($this->uid) ? $this->uid : '';
    }

    public function hasUid()
    {
        return isset($this->uid);
    }

    public function clearUid()
    {
        unset($this->uid);
    }

    /**
     * Output only. System generated globally unique ID for the `LfpSale`.
     *
     * Generated from protobuf field <code>optional string uid = 11 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_info) = {</code>
     * @param string $var
     * @return $this
     */
    public function setUid($var)
    {
        GPBUtil::checkString($var, True);
        $this->uid = $var;

        return $this;
    }

    /**
     * Optional. The [feed
     * label](https://developers.google.com/shopping-content/guides/products/feed-labels)
     * for the product. If this is not set, it will default to `regionCode`.
     *
     * Generated from protobuf field <code>optional string feed_label = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFeedLabel()
    {
        return isset($this->feed_label) ? $this->feed_label : '';
    }

    public function hasFeedLabel()
    {
        return isset($this->feed_label);
    }

    public function clearFeedLabel()
    {
        unset($this->feed_label);
    }

    /**
     * Optional. The [feed
     * label](https://developers.google.com/shopping-content/guides/products/feed-labels)
     * for the product. If this is not set, it will default to `regionCode`.
     *
     * Generated from protobuf field <code>optional string feed_label = 12 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFeedLabel($var)
    {
        GPBUtil::checkString($var, True);
        $this->feed_label = $var;

        return $this;
    }

}

