<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/lfp/v1beta/lfpstore.proto

namespace Google\Shopping\Merchant\Lfp\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for the ListLfpStores method.
 *
 * Generated from protobuf message <code>google.shopping.merchant.lfp.v1beta.ListLfpStoresRequest</code>
 */
class ListLfpStoresRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The LFP partner.
     * Format: `accounts/{account}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The Merchant Center id of the merchant to list stores for.
     *
     * Generated from protobuf field <code>int64 target_account = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $target_account = 0;
    /**
     * Optional. The maximum number of `LfpStore` resources for the given account
     * to return. The service returns fewer than this value if the number of
     * stores for the given account is less than the `pageSize`. The default value
     * is 250. The maximum value is 1000; If a value higher than the maximum is
     * specified, then the `pageSize` will default to the maximum.
     *
     * Generated from protobuf field <code>int32 page_size = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. A page token, received from a previous `ListLfpStoresRequest`
     * call. Provide the page token to retrieve the subsequent page. When
     * paginating, all other parameters provided to `ListLfpStoresRequest` must
     * match the call that provided the page token. The token returned as
     * [nextPageToken][google.shopping.merchant.lfp.v1beta.ListLfpStoresResponse.next_page_token]
     * in the response to the previous request.
     *
     * Generated from protobuf field <code>string page_token = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';

    /**
     * @param string $parent Required. The LFP partner.
     *                       Format: `accounts/{account}`
     *                       Please see {@see LfpStoreServiceClient::accountName()} for help formatting this field.
     *
     * @return \Google\Shopping\Merchant\Lfp\V1beta\ListLfpStoresRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The LFP partner.
     *           Format: `accounts/{account}`
     *     @type int|string $target_account
     *           Required. The Merchant Center id of the merchant to list stores for.
     *     @type int $page_size
     *           Optional. The maximum number of `LfpStore` resources for the given account
     *           to return. The service returns fewer than this value if the number of
     *           stores for the given account is less than the `pageSize`. The default value
     *           is 250. The maximum value is 1000; If a value higher than the maximum is
     *           specified, then the `pageSize` will default to the maximum.
     *     @type string $page_token
     *           Optional. A page token, received from a previous `ListLfpStoresRequest`
     *           call. Provide the page token to retrieve the subsequent page. When
     *           paginating, all other parameters provided to `ListLfpStoresRequest` must
     *           match the call that provided the page token. The token returned as
     *           [nextPageToken][google.shopping.merchant.lfp.v1beta.ListLfpStoresResponse.next_page_token]
     *           in the response to the previous request.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Lfp\V1Beta\Lfpstore::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The LFP partner.
     * Format: `accounts/{account}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The LFP partner.
     * Format: `accounts/{account}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The Merchant Center id of the merchant to list stores for.
     *
     * Generated from protobuf field <code>int64 target_account = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return int|string
     */
    public function getTargetAccount()
    {
        return $this->target_account;
    }

    /**
     * Required. The Merchant Center id of the merchant to list stores for.
     *
     * Generated from protobuf field <code>int64 target_account = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int|string $var
     * @return $this
     */
    public function setTargetAccount($var)
    {
        GPBUtil::checkInt64($var);
        $this->target_account = $var;

        return $this;
    }

    /**
     * Optional. The maximum number of `LfpStore` resources for the given account
     * to return. The service returns fewer than this value if the number of
     * stores for the given account is less than the `pageSize`. The default value
     * is 250. The maximum value is 1000; If a value higher than the maximum is
     * specified, then the `pageSize` will default to the maximum.
     *
     * Generated from protobuf field <code>int32 page_size = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. The maximum number of `LfpStore` resources for the given account
     * to return. The service returns fewer than this value if the number of
     * stores for the given account is less than the `pageSize`. The default value
     * is 250. The maximum value is 1000; If a value higher than the maximum is
     * specified, then the `pageSize` will default to the maximum.
     *
     * Generated from protobuf field <code>int32 page_size = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. A page token, received from a previous `ListLfpStoresRequest`
     * call. Provide the page token to retrieve the subsequent page. When
     * paginating, all other parameters provided to `ListLfpStoresRequest` must
     * match the call that provided the page token. The token returned as
     * [nextPageToken][google.shopping.merchant.lfp.v1beta.ListLfpStoresResponse.next_page_token]
     * in the response to the previous request.
     *
     * Generated from protobuf field <code>string page_token = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. A page token, received from a previous `ListLfpStoresRequest`
     * call. Provide the page token to retrieve the subsequent page. When
     * paginating, all other parameters provided to `ListLfpStoresRequest` must
     * match the call that provided the page token. The token returned as
     * [nextPageToken][google.shopping.merchant.lfp.v1beta.ListLfpStoresResponse.next_page_token]
     * in the response to the previous request.
     *
     * Generated from protobuf field <code>string page_token = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

