<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/promotions/v1beta/promotions.proto

namespace Google\Shopping\Merchant\Promotions\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for the `ListPromotions` method.
 *
 * Generated from protobuf message <code>google.shopping.merchant.promotions.v1beta.ListPromotionsRequest</code>
 */
class ListPromotionsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The account to list processed promotions for.
     * Format: `accounts/{account}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $parent = '';
    /**
     * Output only. The maximum number of promotions to return. The service may
     * return fewer than this value. The maximum value is 1000; values above 1000
     * will be coerced to 1000. If unspecified, the maximum number of promotions
     * will be returned.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $page_size = 0;
    /**
     * Output only. A page token, received from a previous `ListPromotions` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListPromotions` must
     * match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $page_token = '';

    /**
     * @param string $parent Required. The account to list processed promotions for.
     *                       Format: `accounts/{account}`
     *
     * @return \Google\Shopping\Merchant\Promotions\V1beta\ListPromotionsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The account to list processed promotions for.
     *           Format: `accounts/{account}`
     *     @type int $page_size
     *           Output only. The maximum number of promotions to return. The service may
     *           return fewer than this value. The maximum value is 1000; values above 1000
     *           will be coerced to 1000. If unspecified, the maximum number of promotions
     *           will be returned.
     *     @type string $page_token
     *           Output only. A page token, received from a previous `ListPromotions` call.
     *           Provide this to retrieve the subsequent page.
     *           When paginating, all other parameters provided to `ListPromotions` must
     *           match the call that provided the page token.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Promotions\V1Beta\Promotions::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The account to list processed promotions for.
     * Format: `accounts/{account}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The account to list processed promotions for.
     * Format: `accounts/{account}`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Output only. The maximum number of promotions to return. The service may
     * return fewer than this value. The maximum value is 1000; values above 1000
     * will be coerced to 1000. If unspecified, the maximum number of promotions
     * will be returned.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Output only. The maximum number of promotions to return. The service may
     * return fewer than this value. The maximum value is 1000; values above 1000
     * will be coerced to 1000. If unspecified, the maximum number of promotions
     * will be returned.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Output only. A page token, received from a previous `ListPromotions` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListPromotions` must
     * match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Output only. A page token, received from a previous `ListPromotions` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListPromotions` must
     * match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

