<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/quota/v1beta/quota.proto

namespace Google\Shopping\Merchant\Quota\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The group information for methods in the Merchant API. The quota is shared
 * between all methods in the group. Even if none of the methods within the
 * group have usage the information for the group is returned.
 *
 * Generated from protobuf message <code>google.shopping.merchant.quota.v1beta.QuotaGroup</code>
 */
class QuotaGroup extends \Google\Protobuf\Internal\Message
{
    /**
     * Identifier. The resource name of the quota group.
     * Format: accounts/{account}/quotas/{group}
     * Note: There is no guarantee on the format of {group}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     */
    protected $name = '';
    /**
     * Output only. The current quota usage, meaning the number of calls already
     * made on a given day to the methods in the group. The daily quota limits
     * reset at at 12:00 PM midday UTC.
     *
     * Generated from protobuf field <code>int64 quota_usage = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $quota_usage = 0;
    /**
     * Output only. The maximum number of calls allowed per day for the group.
     *
     * Generated from protobuf field <code>int64 quota_limit = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $quota_limit = 0;
    /**
     * Output only. The maximum number of calls allowed per minute for the group.
     *
     * Generated from protobuf field <code>int64 quota_minute_limit = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $quota_minute_limit = 0;
    /**
     * Output only. List of all methods group quota applies to.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.quota.v1beta.MethodDetails method_details = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $method_details;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Identifier. The resource name of the quota group.
     *           Format: accounts/{account}/quotas/{group}
     *           Note: There is no guarantee on the format of {group}
     *     @type int|string $quota_usage
     *           Output only. The current quota usage, meaning the number of calls already
     *           made on a given day to the methods in the group. The daily quota limits
     *           reset at at 12:00 PM midday UTC.
     *     @type int|string $quota_limit
     *           Output only. The maximum number of calls allowed per day for the group.
     *     @type int|string $quota_minute_limit
     *           Output only. The maximum number of calls allowed per minute for the group.
     *     @type array<\Google\Shopping\Merchant\Quota\V1beta\MethodDetails>|\Google\Protobuf\Internal\RepeatedField $method_details
     *           Output only. List of all methods group quota applies to.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Quota\V1Beta\Quota::initOnce();
        parent::__construct($data);
    }

    /**
     * Identifier. The resource name of the quota group.
     * Format: accounts/{account}/quotas/{group}
     * Note: There is no guarantee on the format of {group}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier. The resource name of the quota group.
     * Format: accounts/{account}/quotas/{group}
     * Note: There is no guarantee on the format of {group}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IDENTIFIER];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. The current quota usage, meaning the number of calls already
     * made on a given day to the methods in the group. The daily quota limits
     * reset at at 12:00 PM midday UTC.
     *
     * Generated from protobuf field <code>int64 quota_usage = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int|string
     */
    public function getQuotaUsage()
    {
        return $this->quota_usage;
    }

    /**
     * Output only. The current quota usage, meaning the number of calls already
     * made on a given day to the methods in the group. The daily quota limits
     * reset at at 12:00 PM midday UTC.
     *
     * Generated from protobuf field <code>int64 quota_usage = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int|string $var
     * @return $this
     */
    public function setQuotaUsage($var)
    {
        GPBUtil::checkInt64($var);
        $this->quota_usage = $var;

        return $this;
    }

    /**
     * Output only. The maximum number of calls allowed per day for the group.
     *
     * Generated from protobuf field <code>int64 quota_limit = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int|string
     */
    public function getQuotaLimit()
    {
        return $this->quota_limit;
    }

    /**
     * Output only. The maximum number of calls allowed per day for the group.
     *
     * Generated from protobuf field <code>int64 quota_limit = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int|string $var
     * @return $this
     */
    public function setQuotaLimit($var)
    {
        GPBUtil::checkInt64($var);
        $this->quota_limit = $var;

        return $this;
    }

    /**
     * Output only. The maximum number of calls allowed per minute for the group.
     *
     * Generated from protobuf field <code>int64 quota_minute_limit = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int|string
     */
    public function getQuotaMinuteLimit()
    {
        return $this->quota_minute_limit;
    }

    /**
     * Output only. The maximum number of calls allowed per minute for the group.
     *
     * Generated from protobuf field <code>int64 quota_minute_limit = 5 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int|string $var
     * @return $this
     */
    public function setQuotaMinuteLimit($var)
    {
        GPBUtil::checkInt64($var);
        $this->quota_minute_limit = $var;

        return $this;
    }

    /**
     * Output only. List of all methods group quota applies to.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.quota.v1beta.MethodDetails method_details = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getMethodDetails()
    {
        return $this->method_details;
    }

    /**
     * Output only. List of all methods group quota applies to.
     *
     * Generated from protobuf field <code>repeated .google.shopping.merchant.quota.v1beta.MethodDetails method_details = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param array<\Google\Shopping\Merchant\Quota\V1beta\MethodDetails>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setMethodDetails($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Shopping\Merchant\Quota\V1beta\MethodDetails::class);
        $this->method_details = $arr;

        return $this;
    }

}

