<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/reports/v1beta/reports.proto

namespace Google\Shopping\Merchant\Reports\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Fields available for query in `best_sellers_brand_view` table.
 * [Best sellers](https://support.google.com/merchants/answer/9488679) report
 * with top brands.
 * Values are only set for fields requested explicitly in the request's search
 * query.
 *
 * Generated from protobuf message <code>google.shopping.merchant.reports.v1beta.BestSellersBrandView</code>
 */
class BestSellersBrandView extends \Google\Protobuf\Internal\Message
{
    /**
     * Report date. The value of this field can only be one of the following:
     * *   The first day of the week (Monday) for weekly reports,
     * *   The first day of the month for monthly reports.
     * Required in the `SELECT` clause. If a `WHERE` condition on `report_date` is
     * not specified in the query, the latest available weekly or monthly report
     * is returned.
     *
     * Generated from protobuf field <code>.google.type.Date report_date = 1;</code>
     */
    protected $report_date = null;
    /**
     * Granularity of the report. The ranking can be done over a week or a month
     * timeframe.
     * Required in the `SELECT` clause. Condition on `report_granularity` is
     * required in the `WHERE` clause.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.reports.v1beta.ReportGranularity.ReportGranularityEnum report_granularity = 2;</code>
     */
    protected $report_granularity = null;
    /**
     * Country where the ranking is calculated. Represented in the ISO 3166
     * format.
     * Required in the `SELECT` clause. Condition on `report_country_code` is
     * required in the `WHERE` clause.
     *
     * Generated from protobuf field <code>optional string report_country_code = 3;</code>
     */
    protected $report_country_code = null;
    /**
     * Google product category ID to calculate the ranking for, represented in
     * [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     * Required in the `SELECT` clause. If a `WHERE` condition on
     * `report_category_id` is not specified in the query, rankings for all
     * top-level categories are returned.
     *
     * Generated from protobuf field <code>optional int64 report_category_id = 4;</code>
     */
    protected $report_category_id = null;
    /**
     * Name of the brand.
     *
     * Generated from protobuf field <code>optional string brand = 6;</code>
     */
    protected $brand = null;
    /**
     * Popularity of the brand on Ads and organic surfaces, in the selected
     * category and country, based on the estimated number of units sold.
     *
     * Generated from protobuf field <code>optional int64 rank = 7;</code>
     */
    protected $rank = null;
    /**
     * Popularity rank in the previous week or month.
     *
     * Generated from protobuf field <code>optional int64 previous_rank = 8;</code>
     */
    protected $previous_rank = null;
    /**
     * Estimated demand in relation to the brand with the highest popularity rank
     * in the same category and country.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.reports.v1beta.RelativeDemand.RelativeDemandEnum relative_demand = 9;</code>
     */
    protected $relative_demand = null;
    /**
     * Estimated demand in relation to the brand with the highest popularity rank
     * in the same category and country in the previous week or month.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.reports.v1beta.RelativeDemand.RelativeDemandEnum previous_relative_demand = 10;</code>
     */
    protected $previous_relative_demand = null;
    /**
     * Change in the estimated demand. Whether it rose, sank or remained flat.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.reports.v1beta.RelativeDemandChangeType.RelativeDemandChangeTypeEnum relative_demand_change = 11;</code>
     */
    protected $relative_demand_change = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Type\Date $report_date
     *           Report date. The value of this field can only be one of the following:
     *           *   The first day of the week (Monday) for weekly reports,
     *           *   The first day of the month for monthly reports.
     *           Required in the `SELECT` clause. If a `WHERE` condition on `report_date` is
     *           not specified in the query, the latest available weekly or monthly report
     *           is returned.
     *     @type int $report_granularity
     *           Granularity of the report. The ranking can be done over a week or a month
     *           timeframe.
     *           Required in the `SELECT` clause. Condition on `report_granularity` is
     *           required in the `WHERE` clause.
     *     @type string $report_country_code
     *           Country where the ranking is calculated. Represented in the ISO 3166
     *           format.
     *           Required in the `SELECT` clause. Condition on `report_country_code` is
     *           required in the `WHERE` clause.
     *     @type int|string $report_category_id
     *           Google product category ID to calculate the ranking for, represented in
     *           [Google's product
     *           taxonomy](https://support.google.com/merchants/answer/6324436).
     *           Required in the `SELECT` clause. If a `WHERE` condition on
     *           `report_category_id` is not specified in the query, rankings for all
     *           top-level categories are returned.
     *     @type string $brand
     *           Name of the brand.
     *     @type int|string $rank
     *           Popularity of the brand on Ads and organic surfaces, in the selected
     *           category and country, based on the estimated number of units sold.
     *     @type int|string $previous_rank
     *           Popularity rank in the previous week or month.
     *     @type int $relative_demand
     *           Estimated demand in relation to the brand with the highest popularity rank
     *           in the same category and country.
     *     @type int $previous_relative_demand
     *           Estimated demand in relation to the brand with the highest popularity rank
     *           in the same category and country in the previous week or month.
     *     @type int $relative_demand_change
     *           Change in the estimated demand. Whether it rose, sank or remained flat.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Reports\V1Beta\Reports::initOnce();
        parent::__construct($data);
    }

    /**
     * Report date. The value of this field can only be one of the following:
     * *   The first day of the week (Monday) for weekly reports,
     * *   The first day of the month for monthly reports.
     * Required in the `SELECT` clause. If a `WHERE` condition on `report_date` is
     * not specified in the query, the latest available weekly or monthly report
     * is returned.
     *
     * Generated from protobuf field <code>.google.type.Date report_date = 1;</code>
     * @return \Google\Type\Date|null
     */
    public function getReportDate()
    {
        return $this->report_date;
    }

    public function hasReportDate()
    {
        return isset($this->report_date);
    }

    public function clearReportDate()
    {
        unset($this->report_date);
    }

    /**
     * Report date. The value of this field can only be one of the following:
     * *   The first day of the week (Monday) for weekly reports,
     * *   The first day of the month for monthly reports.
     * Required in the `SELECT` clause. If a `WHERE` condition on `report_date` is
     * not specified in the query, the latest available weekly or monthly report
     * is returned.
     *
     * Generated from protobuf field <code>.google.type.Date report_date = 1;</code>
     * @param \Google\Type\Date $var
     * @return $this
     */
    public function setReportDate($var)
    {
        GPBUtil::checkMessage($var, \Google\Type\Date::class);
        $this->report_date = $var;

        return $this;
    }

    /**
     * Granularity of the report. The ranking can be done over a week or a month
     * timeframe.
     * Required in the `SELECT` clause. Condition on `report_granularity` is
     * required in the `WHERE` clause.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.reports.v1beta.ReportGranularity.ReportGranularityEnum report_granularity = 2;</code>
     * @return int
     */
    public function getReportGranularity()
    {
        return isset($this->report_granularity) ? $this->report_granularity : 0;
    }

    public function hasReportGranularity()
    {
        return isset($this->report_granularity);
    }

    public function clearReportGranularity()
    {
        unset($this->report_granularity);
    }

    /**
     * Granularity of the report. The ranking can be done over a week or a month
     * timeframe.
     * Required in the `SELECT` clause. Condition on `report_granularity` is
     * required in the `WHERE` clause.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.reports.v1beta.ReportGranularity.ReportGranularityEnum report_granularity = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setReportGranularity($var)
    {
        GPBUtil::checkEnum($var, \Google\Shopping\Merchant\Reports\V1beta\ReportGranularity\ReportGranularityEnum::class);
        $this->report_granularity = $var;

        return $this;
    }

    /**
     * Country where the ranking is calculated. Represented in the ISO 3166
     * format.
     * Required in the `SELECT` clause. Condition on `report_country_code` is
     * required in the `WHERE` clause.
     *
     * Generated from protobuf field <code>optional string report_country_code = 3;</code>
     * @return string
     */
    public function getReportCountryCode()
    {
        return isset($this->report_country_code) ? $this->report_country_code : '';
    }

    public function hasReportCountryCode()
    {
        return isset($this->report_country_code);
    }

    public function clearReportCountryCode()
    {
        unset($this->report_country_code);
    }

    /**
     * Country where the ranking is calculated. Represented in the ISO 3166
     * format.
     * Required in the `SELECT` clause. Condition on `report_country_code` is
     * required in the `WHERE` clause.
     *
     * Generated from protobuf field <code>optional string report_country_code = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setReportCountryCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->report_country_code = $var;

        return $this;
    }

    /**
     * Google product category ID to calculate the ranking for, represented in
     * [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     * Required in the `SELECT` clause. If a `WHERE` condition on
     * `report_category_id` is not specified in the query, rankings for all
     * top-level categories are returned.
     *
     * Generated from protobuf field <code>optional int64 report_category_id = 4;</code>
     * @return int|string
     */
    public function getReportCategoryId()
    {
        return isset($this->report_category_id) ? $this->report_category_id : 0;
    }

    public function hasReportCategoryId()
    {
        return isset($this->report_category_id);
    }

    public function clearReportCategoryId()
    {
        unset($this->report_category_id);
    }

    /**
     * Google product category ID to calculate the ranking for, represented in
     * [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     * Required in the `SELECT` clause. If a `WHERE` condition on
     * `report_category_id` is not specified in the query, rankings for all
     * top-level categories are returned.
     *
     * Generated from protobuf field <code>optional int64 report_category_id = 4;</code>
     * @param int|string $var
     * @return $this
     */
    public function setReportCategoryId($var)
    {
        GPBUtil::checkInt64($var);
        $this->report_category_id = $var;

        return $this;
    }

    /**
     * Name of the brand.
     *
     * Generated from protobuf field <code>optional string brand = 6;</code>
     * @return string
     */
    public function getBrand()
    {
        return isset($this->brand) ? $this->brand : '';
    }

    public function hasBrand()
    {
        return isset($this->brand);
    }

    public function clearBrand()
    {
        unset($this->brand);
    }

    /**
     * Name of the brand.
     *
     * Generated from protobuf field <code>optional string brand = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setBrand($var)
    {
        GPBUtil::checkString($var, True);
        $this->brand = $var;

        return $this;
    }

    /**
     * Popularity of the brand on Ads and organic surfaces, in the selected
     * category and country, based on the estimated number of units sold.
     *
     * Generated from protobuf field <code>optional int64 rank = 7;</code>
     * @return int|string
     */
    public function getRank()
    {
        return isset($this->rank) ? $this->rank : 0;
    }

    public function hasRank()
    {
        return isset($this->rank);
    }

    public function clearRank()
    {
        unset($this->rank);
    }

    /**
     * Popularity of the brand on Ads and organic surfaces, in the selected
     * category and country, based on the estimated number of units sold.
     *
     * Generated from protobuf field <code>optional int64 rank = 7;</code>
     * @param int|string $var
     * @return $this
     */
    public function setRank($var)
    {
        GPBUtil::checkInt64($var);
        $this->rank = $var;

        return $this;
    }

    /**
     * Popularity rank in the previous week or month.
     *
     * Generated from protobuf field <code>optional int64 previous_rank = 8;</code>
     * @return int|string
     */
    public function getPreviousRank()
    {
        return isset($this->previous_rank) ? $this->previous_rank : 0;
    }

    public function hasPreviousRank()
    {
        return isset($this->previous_rank);
    }

    public function clearPreviousRank()
    {
        unset($this->previous_rank);
    }

    /**
     * Popularity rank in the previous week or month.
     *
     * Generated from protobuf field <code>optional int64 previous_rank = 8;</code>
     * @param int|string $var
     * @return $this
     */
    public function setPreviousRank($var)
    {
        GPBUtil::checkInt64($var);
        $this->previous_rank = $var;

        return $this;
    }

    /**
     * Estimated demand in relation to the brand with the highest popularity rank
     * in the same category and country.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.reports.v1beta.RelativeDemand.RelativeDemandEnum relative_demand = 9;</code>
     * @return int
     */
    public function getRelativeDemand()
    {
        return isset($this->relative_demand) ? $this->relative_demand : 0;
    }

    public function hasRelativeDemand()
    {
        return isset($this->relative_demand);
    }

    public function clearRelativeDemand()
    {
        unset($this->relative_demand);
    }

    /**
     * Estimated demand in relation to the brand with the highest popularity rank
     * in the same category and country.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.reports.v1beta.RelativeDemand.RelativeDemandEnum relative_demand = 9;</code>
     * @param int $var
     * @return $this
     */
    public function setRelativeDemand($var)
    {
        GPBUtil::checkEnum($var, \Google\Shopping\Merchant\Reports\V1beta\RelativeDemand\RelativeDemandEnum::class);
        $this->relative_demand = $var;

        return $this;
    }

    /**
     * Estimated demand in relation to the brand with the highest popularity rank
     * in the same category and country in the previous week or month.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.reports.v1beta.RelativeDemand.RelativeDemandEnum previous_relative_demand = 10;</code>
     * @return int
     */
    public function getPreviousRelativeDemand()
    {
        return isset($this->previous_relative_demand) ? $this->previous_relative_demand : 0;
    }

    public function hasPreviousRelativeDemand()
    {
        return isset($this->previous_relative_demand);
    }

    public function clearPreviousRelativeDemand()
    {
        unset($this->previous_relative_demand);
    }

    /**
     * Estimated demand in relation to the brand with the highest popularity rank
     * in the same category and country in the previous week or month.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.reports.v1beta.RelativeDemand.RelativeDemandEnum previous_relative_demand = 10;</code>
     * @param int $var
     * @return $this
     */
    public function setPreviousRelativeDemand($var)
    {
        GPBUtil::checkEnum($var, \Google\Shopping\Merchant\Reports\V1beta\RelativeDemand\RelativeDemandEnum::class);
        $this->previous_relative_demand = $var;

        return $this;
    }

    /**
     * Change in the estimated demand. Whether it rose, sank or remained flat.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.reports.v1beta.RelativeDemandChangeType.RelativeDemandChangeTypeEnum relative_demand_change = 11;</code>
     * @return int
     */
    public function getRelativeDemandChange()
    {
        return isset($this->relative_demand_change) ? $this->relative_demand_change : 0;
    }

    public function hasRelativeDemandChange()
    {
        return isset($this->relative_demand_change);
    }

    public function clearRelativeDemandChange()
    {
        unset($this->relative_demand_change);
    }

    /**
     * Change in the estimated demand. Whether it rose, sank or remained flat.
     *
     * Generated from protobuf field <code>optional .google.shopping.merchant.reports.v1beta.RelativeDemandChangeType.RelativeDemandChangeTypeEnum relative_demand_change = 11;</code>
     * @param int $var
     * @return $this
     */
    public function setRelativeDemandChange($var)
    {
        GPBUtil::checkEnum($var, \Google\Shopping\Merchant\Reports\V1beta\RelativeDemandChangeType\RelativeDemandChangeTypeEnum::class);
        $this->relative_demand_change = $var;

        return $this;
    }

}

