<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/reports/v1beta/reports.proto

namespace Google\Shopping\Merchant\Reports\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Fields available for query in `price_competitiveness_product_view` table.
 * [Price competitiveness](https://support.google.com/merchants/answer/9626903)
 * report.
 * Values are only set for fields requested explicitly in the request's search
 * query.
 *
 * Generated from protobuf message <code>google.shopping.merchant.reports.v1beta.PriceCompetitivenessProductView</code>
 */
class PriceCompetitivenessProductView extends \Google\Protobuf\Internal\Message
{
    /**
     * Country of the price benchmark. Represented in the ISO 3166 format.
     * Required in the `SELECT` clause.
     *
     * Generated from protobuf field <code>optional string report_country_code = 1;</code>
     */
    protected $report_country_code = null;
    /**
     * REST ID of the product, in the form of
     * `channel~languageCode~feedLabel~offerId`. Can be used to join data with the
     * `product_view` table.
     * Required in the `SELECT` clause.
     *
     * Generated from protobuf field <code>optional string id = 2;</code>
     */
    protected $id = null;
    /**
     * Merchant-provided id of the product.
     *
     * Generated from protobuf field <code>optional string offer_id = 3;</code>
     */
    protected $offer_id = null;
    /**
     * Title of the product.
     *
     * Generated from protobuf field <code>optional string title = 4;</code>
     */
    protected $title = null;
    /**
     * Brand of the product.
     *
     * Generated from protobuf field <code>optional string brand = 5;</code>
     */
    protected $brand = null;
    /**
     * Product category (1st level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l1 = 6;</code>
     */
    protected $category_l1 = null;
    /**
     * Product category (2nd level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l2 = 7;</code>
     */
    protected $category_l2 = null;
    /**
     * Product category (3rd level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l3 = 8;</code>
     */
    protected $category_l3 = null;
    /**
     * Product category (4th level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l4 = 9;</code>
     */
    protected $category_l4 = null;
    /**
     * Product category (5th level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l5 = 10;</code>
     */
    protected $category_l5 = null;
    /**
     * Product type (1st level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l1 = 11;</code>
     */
    protected $product_type_l1 = null;
    /**
     * Product type (2nd level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l2 = 12;</code>
     */
    protected $product_type_l2 = null;
    /**
     * Product type (3rd level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l3 = 13;</code>
     */
    protected $product_type_l3 = null;
    /**
     * Product type (4th level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l4 = 14;</code>
     */
    protected $product_type_l4 = null;
    /**
     * Product type (5th level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l5 = 15;</code>
     */
    protected $product_type_l5 = null;
    /**
     * Current price of the product.
     *
     * Generated from protobuf field <code>.google.shopping.type.Price price = 16;</code>
     */
    protected $price = null;
    /**
     * Latest available price benchmark for the product's catalog in the benchmark
     * country.
     *
     * Generated from protobuf field <code>.google.shopping.type.Price benchmark_price = 17;</code>
     */
    protected $benchmark_price = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $report_country_code
     *           Country of the price benchmark. Represented in the ISO 3166 format.
     *           Required in the `SELECT` clause.
     *     @type string $id
     *           REST ID of the product, in the form of
     *           `channel~languageCode~feedLabel~offerId`. Can be used to join data with the
     *           `product_view` table.
     *           Required in the `SELECT` clause.
     *     @type string $offer_id
     *           Merchant-provided id of the product.
     *     @type string $title
     *           Title of the product.
     *     @type string $brand
     *           Brand of the product.
     *     @type string $category_l1
     *           Product category (1st level) in [Google's product
     *           taxonomy](https://support.google.com/merchants/answer/6324436).
     *     @type string $category_l2
     *           Product category (2nd level) in [Google's product
     *           taxonomy](https://support.google.com/merchants/answer/6324436).
     *     @type string $category_l3
     *           Product category (3rd level) in [Google's product
     *           taxonomy](https://support.google.com/merchants/answer/6324436).
     *     @type string $category_l4
     *           Product category (4th level) in [Google's product
     *           taxonomy](https://support.google.com/merchants/answer/6324436).
     *     @type string $category_l5
     *           Product category (5th level) in [Google's product
     *           taxonomy](https://support.google.com/merchants/answer/6324436).
     *     @type string $product_type_l1
     *           Product type (1st level) in merchant's own [product
     *           taxonomy](https://support.google.com/merchants/answer/6324406).
     *     @type string $product_type_l2
     *           Product type (2nd level) in merchant's own [product
     *           taxonomy](https://support.google.com/merchants/answer/6324406).
     *     @type string $product_type_l3
     *           Product type (3rd level) in merchant's own [product
     *           taxonomy](https://support.google.com/merchants/answer/6324406).
     *     @type string $product_type_l4
     *           Product type (4th level) in merchant's own [product
     *           taxonomy](https://support.google.com/merchants/answer/6324406).
     *     @type string $product_type_l5
     *           Product type (5th level) in merchant's own [product
     *           taxonomy](https://support.google.com/merchants/answer/6324406).
     *     @type \Google\Shopping\Type\Price $price
     *           Current price of the product.
     *     @type \Google\Shopping\Type\Price $benchmark_price
     *           Latest available price benchmark for the product's catalog in the benchmark
     *           country.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Reports\V1Beta\Reports::initOnce();
        parent::__construct($data);
    }

    /**
     * Country of the price benchmark. Represented in the ISO 3166 format.
     * Required in the `SELECT` clause.
     *
     * Generated from protobuf field <code>optional string report_country_code = 1;</code>
     * @return string
     */
    public function getReportCountryCode()
    {
        return isset($this->report_country_code) ? $this->report_country_code : '';
    }

    public function hasReportCountryCode()
    {
        return isset($this->report_country_code);
    }

    public function clearReportCountryCode()
    {
        unset($this->report_country_code);
    }

    /**
     * Country of the price benchmark. Represented in the ISO 3166 format.
     * Required in the `SELECT` clause.
     *
     * Generated from protobuf field <code>optional string report_country_code = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setReportCountryCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->report_country_code = $var;

        return $this;
    }

    /**
     * REST ID of the product, in the form of
     * `channel~languageCode~feedLabel~offerId`. Can be used to join data with the
     * `product_view` table.
     * Required in the `SELECT` clause.
     *
     * Generated from protobuf field <code>optional string id = 2;</code>
     * @return string
     */
    public function getId()
    {
        return isset($this->id) ? $this->id : '';
    }

    public function hasId()
    {
        return isset($this->id);
    }

    public function clearId()
    {
        unset($this->id);
    }

    /**
     * REST ID of the product, in the form of
     * `channel~languageCode~feedLabel~offerId`. Can be used to join data with the
     * `product_view` table.
     * Required in the `SELECT` clause.
     *
     * Generated from protobuf field <code>optional string id = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setId($var)
    {
        GPBUtil::checkString($var, True);
        $this->id = $var;

        return $this;
    }

    /**
     * Merchant-provided id of the product.
     *
     * Generated from protobuf field <code>optional string offer_id = 3;</code>
     * @return string
     */
    public function getOfferId()
    {
        return isset($this->offer_id) ? $this->offer_id : '';
    }

    public function hasOfferId()
    {
        return isset($this->offer_id);
    }

    public function clearOfferId()
    {
        unset($this->offer_id);
    }

    /**
     * Merchant-provided id of the product.
     *
     * Generated from protobuf field <code>optional string offer_id = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setOfferId($var)
    {
        GPBUtil::checkString($var, True);
        $this->offer_id = $var;

        return $this;
    }

    /**
     * Title of the product.
     *
     * Generated from protobuf field <code>optional string title = 4;</code>
     * @return string
     */
    public function getTitle()
    {
        return isset($this->title) ? $this->title : '';
    }

    public function hasTitle()
    {
        return isset($this->title);
    }

    public function clearTitle()
    {
        unset($this->title);
    }

    /**
     * Title of the product.
     *
     * Generated from protobuf field <code>optional string title = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setTitle($var)
    {
        GPBUtil::checkString($var, True);
        $this->title = $var;

        return $this;
    }

    /**
     * Brand of the product.
     *
     * Generated from protobuf field <code>optional string brand = 5;</code>
     * @return string
     */
    public function getBrand()
    {
        return isset($this->brand) ? $this->brand : '';
    }

    public function hasBrand()
    {
        return isset($this->brand);
    }

    public function clearBrand()
    {
        unset($this->brand);
    }

    /**
     * Brand of the product.
     *
     * Generated from protobuf field <code>optional string brand = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setBrand($var)
    {
        GPBUtil::checkString($var, True);
        $this->brand = $var;

        return $this;
    }

    /**
     * Product category (1st level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l1 = 6;</code>
     * @return string
     */
    public function getCategoryL1()
    {
        return isset($this->category_l1) ? $this->category_l1 : '';
    }

    public function hasCategoryL1()
    {
        return isset($this->category_l1);
    }

    public function clearCategoryL1()
    {
        unset($this->category_l1);
    }

    /**
     * Product category (1st level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l1 = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setCategoryL1($var)
    {
        GPBUtil::checkString($var, True);
        $this->category_l1 = $var;

        return $this;
    }

    /**
     * Product category (2nd level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l2 = 7;</code>
     * @return string
     */
    public function getCategoryL2()
    {
        return isset($this->category_l2) ? $this->category_l2 : '';
    }

    public function hasCategoryL2()
    {
        return isset($this->category_l2);
    }

    public function clearCategoryL2()
    {
        unset($this->category_l2);
    }

    /**
     * Product category (2nd level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l2 = 7;</code>
     * @param string $var
     * @return $this
     */
    public function setCategoryL2($var)
    {
        GPBUtil::checkString($var, True);
        $this->category_l2 = $var;

        return $this;
    }

    /**
     * Product category (3rd level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l3 = 8;</code>
     * @return string
     */
    public function getCategoryL3()
    {
        return isset($this->category_l3) ? $this->category_l3 : '';
    }

    public function hasCategoryL3()
    {
        return isset($this->category_l3);
    }

    public function clearCategoryL3()
    {
        unset($this->category_l3);
    }

    /**
     * Product category (3rd level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l3 = 8;</code>
     * @param string $var
     * @return $this
     */
    public function setCategoryL3($var)
    {
        GPBUtil::checkString($var, True);
        $this->category_l3 = $var;

        return $this;
    }

    /**
     * Product category (4th level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l4 = 9;</code>
     * @return string
     */
    public function getCategoryL4()
    {
        return isset($this->category_l4) ? $this->category_l4 : '';
    }

    public function hasCategoryL4()
    {
        return isset($this->category_l4);
    }

    public function clearCategoryL4()
    {
        unset($this->category_l4);
    }

    /**
     * Product category (4th level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l4 = 9;</code>
     * @param string $var
     * @return $this
     */
    public function setCategoryL4($var)
    {
        GPBUtil::checkString($var, True);
        $this->category_l4 = $var;

        return $this;
    }

    /**
     * Product category (5th level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l5 = 10;</code>
     * @return string
     */
    public function getCategoryL5()
    {
        return isset($this->category_l5) ? $this->category_l5 : '';
    }

    public function hasCategoryL5()
    {
        return isset($this->category_l5);
    }

    public function clearCategoryL5()
    {
        unset($this->category_l5);
    }

    /**
     * Product category (5th level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l5 = 10;</code>
     * @param string $var
     * @return $this
     */
    public function setCategoryL5($var)
    {
        GPBUtil::checkString($var, True);
        $this->category_l5 = $var;

        return $this;
    }

    /**
     * Product type (1st level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l1 = 11;</code>
     * @return string
     */
    public function getProductTypeL1()
    {
        return isset($this->product_type_l1) ? $this->product_type_l1 : '';
    }

    public function hasProductTypeL1()
    {
        return isset($this->product_type_l1);
    }

    public function clearProductTypeL1()
    {
        unset($this->product_type_l1);
    }

    /**
     * Product type (1st level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l1 = 11;</code>
     * @param string $var
     * @return $this
     */
    public function setProductTypeL1($var)
    {
        GPBUtil::checkString($var, True);
        $this->product_type_l1 = $var;

        return $this;
    }

    /**
     * Product type (2nd level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l2 = 12;</code>
     * @return string
     */
    public function getProductTypeL2()
    {
        return isset($this->product_type_l2) ? $this->product_type_l2 : '';
    }

    public function hasProductTypeL2()
    {
        return isset($this->product_type_l2);
    }

    public function clearProductTypeL2()
    {
        unset($this->product_type_l2);
    }

    /**
     * Product type (2nd level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l2 = 12;</code>
     * @param string $var
     * @return $this
     */
    public function setProductTypeL2($var)
    {
        GPBUtil::checkString($var, True);
        $this->product_type_l2 = $var;

        return $this;
    }

    /**
     * Product type (3rd level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l3 = 13;</code>
     * @return string
     */
    public function getProductTypeL3()
    {
        return isset($this->product_type_l3) ? $this->product_type_l3 : '';
    }

    public function hasProductTypeL3()
    {
        return isset($this->product_type_l3);
    }

    public function clearProductTypeL3()
    {
        unset($this->product_type_l3);
    }

    /**
     * Product type (3rd level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l3 = 13;</code>
     * @param string $var
     * @return $this
     */
    public function setProductTypeL3($var)
    {
        GPBUtil::checkString($var, True);
        $this->product_type_l3 = $var;

        return $this;
    }

    /**
     * Product type (4th level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l4 = 14;</code>
     * @return string
     */
    public function getProductTypeL4()
    {
        return isset($this->product_type_l4) ? $this->product_type_l4 : '';
    }

    public function hasProductTypeL4()
    {
        return isset($this->product_type_l4);
    }

    public function clearProductTypeL4()
    {
        unset($this->product_type_l4);
    }

    /**
     * Product type (4th level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l4 = 14;</code>
     * @param string $var
     * @return $this
     */
    public function setProductTypeL4($var)
    {
        GPBUtil::checkString($var, True);
        $this->product_type_l4 = $var;

        return $this;
    }

    /**
     * Product type (5th level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l5 = 15;</code>
     * @return string
     */
    public function getProductTypeL5()
    {
        return isset($this->product_type_l5) ? $this->product_type_l5 : '';
    }

    public function hasProductTypeL5()
    {
        return isset($this->product_type_l5);
    }

    public function clearProductTypeL5()
    {
        unset($this->product_type_l5);
    }

    /**
     * Product type (5th level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l5 = 15;</code>
     * @param string $var
     * @return $this
     */
    public function setProductTypeL5($var)
    {
        GPBUtil::checkString($var, True);
        $this->product_type_l5 = $var;

        return $this;
    }

    /**
     * Current price of the product.
     *
     * Generated from protobuf field <code>.google.shopping.type.Price price = 16;</code>
     * @return \Google\Shopping\Type\Price|null
     */
    public function getPrice()
    {
        return $this->price;
    }

    public function hasPrice()
    {
        return isset($this->price);
    }

    public function clearPrice()
    {
        unset($this->price);
    }

    /**
     * Current price of the product.
     *
     * Generated from protobuf field <code>.google.shopping.type.Price price = 16;</code>
     * @param \Google\Shopping\Type\Price $var
     * @return $this
     */
    public function setPrice($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Type\Price::class);
        $this->price = $var;

        return $this;
    }

    /**
     * Latest available price benchmark for the product's catalog in the benchmark
     * country.
     *
     * Generated from protobuf field <code>.google.shopping.type.Price benchmark_price = 17;</code>
     * @return \Google\Shopping\Type\Price|null
     */
    public function getBenchmarkPrice()
    {
        return $this->benchmark_price;
    }

    public function hasBenchmarkPrice()
    {
        return isset($this->benchmark_price);
    }

    public function clearBenchmarkPrice()
    {
        unset($this->benchmark_price);
    }

    /**
     * Latest available price benchmark for the product's catalog in the benchmark
     * country.
     *
     * Generated from protobuf field <code>.google.shopping.type.Price benchmark_price = 17;</code>
     * @param \Google\Shopping\Type\Price $var
     * @return $this
     */
    public function setBenchmarkPrice($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Type\Price::class);
        $this->benchmark_price = $var;

        return $this;
    }

}

