<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/shopping/merchant/reports/v1beta/reports.proto

namespace Google\Shopping\Merchant\Reports\V1beta;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Fields available for query in `price_insights_product_view` table.
 * [Price insights](https://support.google.com/merchants/answer/11916926)
 * report.
 * Values are only set for fields requested explicitly in the request's search
 * query.
 *
 * Generated from protobuf message <code>google.shopping.merchant.reports.v1beta.PriceInsightsProductView</code>
 */
class PriceInsightsProductView extends \Google\Protobuf\Internal\Message
{
    /**
     * REST ID of the product, in the form of
     * `channel~languageCode~feedLabel~offerId`. Can be used to join data with the
     * `product_view` table.
     * Required in the `SELECT` clause.
     *
     * Generated from protobuf field <code>optional string id = 1;</code>
     */
    protected $id = null;
    /**
     * Merchant-provided id of the product.
     *
     * Generated from protobuf field <code>optional string offer_id = 2;</code>
     */
    protected $offer_id = null;
    /**
     * Title of the product.
     *
     * Generated from protobuf field <code>optional string title = 3;</code>
     */
    protected $title = null;
    /**
     * Brand of the product.
     *
     * Generated from protobuf field <code>optional string brand = 4;</code>
     */
    protected $brand = null;
    /**
     * Product category (1st level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l1 = 5;</code>
     */
    protected $category_l1 = null;
    /**
     * Product category (2nd level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l2 = 6;</code>
     */
    protected $category_l2 = null;
    /**
     * Product category (3rd level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l3 = 7;</code>
     */
    protected $category_l3 = null;
    /**
     * Product category (4th level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l4 = 8;</code>
     */
    protected $category_l4 = null;
    /**
     * Product category (5th level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l5 = 9;</code>
     */
    protected $category_l5 = null;
    /**
     * Product type (1st level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l1 = 10;</code>
     */
    protected $product_type_l1 = null;
    /**
     * Product type (2nd level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l2 = 11;</code>
     */
    protected $product_type_l2 = null;
    /**
     * Product type (3rd level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l3 = 12;</code>
     */
    protected $product_type_l3 = null;
    /**
     * Product type (4th level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l4 = 13;</code>
     */
    protected $product_type_l4 = null;
    /**
     * Product type (5th level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l5 = 14;</code>
     */
    protected $product_type_l5 = null;
    /**
     * Current price of the product.
     *
     * Generated from protobuf field <code>.google.shopping.type.Price price = 15;</code>
     */
    protected $price = null;
    /**
     * Latest suggested price for the product.
     *
     * Generated from protobuf field <code>.google.shopping.type.Price suggested_price = 16;</code>
     */
    protected $suggested_price = null;
    /**
     * Predicted change in impressions as a fraction after introducing the
     * suggested price compared to current active price. For example, 0.05 is a 5%
     * predicted increase in impressions.
     *
     * Generated from protobuf field <code>optional double predicted_impressions_change_fraction = 17;</code>
     */
    protected $predicted_impressions_change_fraction = null;
    /**
     * Predicted change in clicks as a fraction after introducing the
     * suggested price compared to current active price. For example, 0.05 is a 5%
     * predicted increase in clicks.
     *
     * Generated from protobuf field <code>optional double predicted_clicks_change_fraction = 18;</code>
     */
    protected $predicted_clicks_change_fraction = null;
    /**
     * Predicted change in conversions as a fraction after introducing the
     * suggested price compared to current active price. For example, 0.05 is a 5%
     * predicted increase in conversions).
     *
     * Generated from protobuf field <code>optional double predicted_conversions_change_fraction = 19;</code>
     */
    protected $predicted_conversions_change_fraction = null;
    /**
     * The predicted effectiveness of applying the price suggestion, bucketed.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.reports.v1beta.PriceInsightsProductView.Effectiveness effectiveness = 22;</code>
     */
    protected $effectiveness = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $id
     *           REST ID of the product, in the form of
     *           `channel~languageCode~feedLabel~offerId`. Can be used to join data with the
     *           `product_view` table.
     *           Required in the `SELECT` clause.
     *     @type string $offer_id
     *           Merchant-provided id of the product.
     *     @type string $title
     *           Title of the product.
     *     @type string $brand
     *           Brand of the product.
     *     @type string $category_l1
     *           Product category (1st level) in [Google's product
     *           taxonomy](https://support.google.com/merchants/answer/6324436).
     *     @type string $category_l2
     *           Product category (2nd level) in [Google's product
     *           taxonomy](https://support.google.com/merchants/answer/6324436).
     *     @type string $category_l3
     *           Product category (3rd level) in [Google's product
     *           taxonomy](https://support.google.com/merchants/answer/6324436).
     *     @type string $category_l4
     *           Product category (4th level) in [Google's product
     *           taxonomy](https://support.google.com/merchants/answer/6324436).
     *     @type string $category_l5
     *           Product category (5th level) in [Google's product
     *           taxonomy](https://support.google.com/merchants/answer/6324436).
     *     @type string $product_type_l1
     *           Product type (1st level) in merchant's own [product
     *           taxonomy](https://support.google.com/merchants/answer/6324406).
     *     @type string $product_type_l2
     *           Product type (2nd level) in merchant's own [product
     *           taxonomy](https://support.google.com/merchants/answer/6324406).
     *     @type string $product_type_l3
     *           Product type (3rd level) in merchant's own [product
     *           taxonomy](https://support.google.com/merchants/answer/6324406).
     *     @type string $product_type_l4
     *           Product type (4th level) in merchant's own [product
     *           taxonomy](https://support.google.com/merchants/answer/6324406).
     *     @type string $product_type_l5
     *           Product type (5th level) in merchant's own [product
     *           taxonomy](https://support.google.com/merchants/answer/6324406).
     *     @type \Google\Shopping\Type\Price $price
     *           Current price of the product.
     *     @type \Google\Shopping\Type\Price $suggested_price
     *           Latest suggested price for the product.
     *     @type float $predicted_impressions_change_fraction
     *           Predicted change in impressions as a fraction after introducing the
     *           suggested price compared to current active price. For example, 0.05 is a 5%
     *           predicted increase in impressions.
     *     @type float $predicted_clicks_change_fraction
     *           Predicted change in clicks as a fraction after introducing the
     *           suggested price compared to current active price. For example, 0.05 is a 5%
     *           predicted increase in clicks.
     *     @type float $predicted_conversions_change_fraction
     *           Predicted change in conversions as a fraction after introducing the
     *           suggested price compared to current active price. For example, 0.05 is a 5%
     *           predicted increase in conversions).
     *     @type int $effectiveness
     *           The predicted effectiveness of applying the price suggestion, bucketed.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Shopping\Merchant\Reports\V1Beta\Reports::initOnce();
        parent::__construct($data);
    }

    /**
     * REST ID of the product, in the form of
     * `channel~languageCode~feedLabel~offerId`. Can be used to join data with the
     * `product_view` table.
     * Required in the `SELECT` clause.
     *
     * Generated from protobuf field <code>optional string id = 1;</code>
     * @return string
     */
    public function getId()
    {
        return isset($this->id) ? $this->id : '';
    }

    public function hasId()
    {
        return isset($this->id);
    }

    public function clearId()
    {
        unset($this->id);
    }

    /**
     * REST ID of the product, in the form of
     * `channel~languageCode~feedLabel~offerId`. Can be used to join data with the
     * `product_view` table.
     * Required in the `SELECT` clause.
     *
     * Generated from protobuf field <code>optional string id = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setId($var)
    {
        GPBUtil::checkString($var, True);
        $this->id = $var;

        return $this;
    }

    /**
     * Merchant-provided id of the product.
     *
     * Generated from protobuf field <code>optional string offer_id = 2;</code>
     * @return string
     */
    public function getOfferId()
    {
        return isset($this->offer_id) ? $this->offer_id : '';
    }

    public function hasOfferId()
    {
        return isset($this->offer_id);
    }

    public function clearOfferId()
    {
        unset($this->offer_id);
    }

    /**
     * Merchant-provided id of the product.
     *
     * Generated from protobuf field <code>optional string offer_id = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setOfferId($var)
    {
        GPBUtil::checkString($var, True);
        $this->offer_id = $var;

        return $this;
    }

    /**
     * Title of the product.
     *
     * Generated from protobuf field <code>optional string title = 3;</code>
     * @return string
     */
    public function getTitle()
    {
        return isset($this->title) ? $this->title : '';
    }

    public function hasTitle()
    {
        return isset($this->title);
    }

    public function clearTitle()
    {
        unset($this->title);
    }

    /**
     * Title of the product.
     *
     * Generated from protobuf field <code>optional string title = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setTitle($var)
    {
        GPBUtil::checkString($var, True);
        $this->title = $var;

        return $this;
    }

    /**
     * Brand of the product.
     *
     * Generated from protobuf field <code>optional string brand = 4;</code>
     * @return string
     */
    public function getBrand()
    {
        return isset($this->brand) ? $this->brand : '';
    }

    public function hasBrand()
    {
        return isset($this->brand);
    }

    public function clearBrand()
    {
        unset($this->brand);
    }

    /**
     * Brand of the product.
     *
     * Generated from protobuf field <code>optional string brand = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setBrand($var)
    {
        GPBUtil::checkString($var, True);
        $this->brand = $var;

        return $this;
    }

    /**
     * Product category (1st level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l1 = 5;</code>
     * @return string
     */
    public function getCategoryL1()
    {
        return isset($this->category_l1) ? $this->category_l1 : '';
    }

    public function hasCategoryL1()
    {
        return isset($this->category_l1);
    }

    public function clearCategoryL1()
    {
        unset($this->category_l1);
    }

    /**
     * Product category (1st level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l1 = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setCategoryL1($var)
    {
        GPBUtil::checkString($var, True);
        $this->category_l1 = $var;

        return $this;
    }

    /**
     * Product category (2nd level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l2 = 6;</code>
     * @return string
     */
    public function getCategoryL2()
    {
        return isset($this->category_l2) ? $this->category_l2 : '';
    }

    public function hasCategoryL2()
    {
        return isset($this->category_l2);
    }

    public function clearCategoryL2()
    {
        unset($this->category_l2);
    }

    /**
     * Product category (2nd level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l2 = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setCategoryL2($var)
    {
        GPBUtil::checkString($var, True);
        $this->category_l2 = $var;

        return $this;
    }

    /**
     * Product category (3rd level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l3 = 7;</code>
     * @return string
     */
    public function getCategoryL3()
    {
        return isset($this->category_l3) ? $this->category_l3 : '';
    }

    public function hasCategoryL3()
    {
        return isset($this->category_l3);
    }

    public function clearCategoryL3()
    {
        unset($this->category_l3);
    }

    /**
     * Product category (3rd level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l3 = 7;</code>
     * @param string $var
     * @return $this
     */
    public function setCategoryL3($var)
    {
        GPBUtil::checkString($var, True);
        $this->category_l3 = $var;

        return $this;
    }

    /**
     * Product category (4th level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l4 = 8;</code>
     * @return string
     */
    public function getCategoryL4()
    {
        return isset($this->category_l4) ? $this->category_l4 : '';
    }

    public function hasCategoryL4()
    {
        return isset($this->category_l4);
    }

    public function clearCategoryL4()
    {
        unset($this->category_l4);
    }

    /**
     * Product category (4th level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l4 = 8;</code>
     * @param string $var
     * @return $this
     */
    public function setCategoryL4($var)
    {
        GPBUtil::checkString($var, True);
        $this->category_l4 = $var;

        return $this;
    }

    /**
     * Product category (5th level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l5 = 9;</code>
     * @return string
     */
    public function getCategoryL5()
    {
        return isset($this->category_l5) ? $this->category_l5 : '';
    }

    public function hasCategoryL5()
    {
        return isset($this->category_l5);
    }

    public function clearCategoryL5()
    {
        unset($this->category_l5);
    }

    /**
     * Product category (5th level) in [Google's product
     * taxonomy](https://support.google.com/merchants/answer/6324436).
     *
     * Generated from protobuf field <code>optional string category_l5 = 9;</code>
     * @param string $var
     * @return $this
     */
    public function setCategoryL5($var)
    {
        GPBUtil::checkString($var, True);
        $this->category_l5 = $var;

        return $this;
    }

    /**
     * Product type (1st level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l1 = 10;</code>
     * @return string
     */
    public function getProductTypeL1()
    {
        return isset($this->product_type_l1) ? $this->product_type_l1 : '';
    }

    public function hasProductTypeL1()
    {
        return isset($this->product_type_l1);
    }

    public function clearProductTypeL1()
    {
        unset($this->product_type_l1);
    }

    /**
     * Product type (1st level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l1 = 10;</code>
     * @param string $var
     * @return $this
     */
    public function setProductTypeL1($var)
    {
        GPBUtil::checkString($var, True);
        $this->product_type_l1 = $var;

        return $this;
    }

    /**
     * Product type (2nd level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l2 = 11;</code>
     * @return string
     */
    public function getProductTypeL2()
    {
        return isset($this->product_type_l2) ? $this->product_type_l2 : '';
    }

    public function hasProductTypeL2()
    {
        return isset($this->product_type_l2);
    }

    public function clearProductTypeL2()
    {
        unset($this->product_type_l2);
    }

    /**
     * Product type (2nd level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l2 = 11;</code>
     * @param string $var
     * @return $this
     */
    public function setProductTypeL2($var)
    {
        GPBUtil::checkString($var, True);
        $this->product_type_l2 = $var;

        return $this;
    }

    /**
     * Product type (3rd level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l3 = 12;</code>
     * @return string
     */
    public function getProductTypeL3()
    {
        return isset($this->product_type_l3) ? $this->product_type_l3 : '';
    }

    public function hasProductTypeL3()
    {
        return isset($this->product_type_l3);
    }

    public function clearProductTypeL3()
    {
        unset($this->product_type_l3);
    }

    /**
     * Product type (3rd level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l3 = 12;</code>
     * @param string $var
     * @return $this
     */
    public function setProductTypeL3($var)
    {
        GPBUtil::checkString($var, True);
        $this->product_type_l3 = $var;

        return $this;
    }

    /**
     * Product type (4th level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l4 = 13;</code>
     * @return string
     */
    public function getProductTypeL4()
    {
        return isset($this->product_type_l4) ? $this->product_type_l4 : '';
    }

    public function hasProductTypeL4()
    {
        return isset($this->product_type_l4);
    }

    public function clearProductTypeL4()
    {
        unset($this->product_type_l4);
    }

    /**
     * Product type (4th level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l4 = 13;</code>
     * @param string $var
     * @return $this
     */
    public function setProductTypeL4($var)
    {
        GPBUtil::checkString($var, True);
        $this->product_type_l4 = $var;

        return $this;
    }

    /**
     * Product type (5th level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l5 = 14;</code>
     * @return string
     */
    public function getProductTypeL5()
    {
        return isset($this->product_type_l5) ? $this->product_type_l5 : '';
    }

    public function hasProductTypeL5()
    {
        return isset($this->product_type_l5);
    }

    public function clearProductTypeL5()
    {
        unset($this->product_type_l5);
    }

    /**
     * Product type (5th level) in merchant's own [product
     * taxonomy](https://support.google.com/merchants/answer/6324406).
     *
     * Generated from protobuf field <code>optional string product_type_l5 = 14;</code>
     * @param string $var
     * @return $this
     */
    public function setProductTypeL5($var)
    {
        GPBUtil::checkString($var, True);
        $this->product_type_l5 = $var;

        return $this;
    }

    /**
     * Current price of the product.
     *
     * Generated from protobuf field <code>.google.shopping.type.Price price = 15;</code>
     * @return \Google\Shopping\Type\Price|null
     */
    public function getPrice()
    {
        return $this->price;
    }

    public function hasPrice()
    {
        return isset($this->price);
    }

    public function clearPrice()
    {
        unset($this->price);
    }

    /**
     * Current price of the product.
     *
     * Generated from protobuf field <code>.google.shopping.type.Price price = 15;</code>
     * @param \Google\Shopping\Type\Price $var
     * @return $this
     */
    public function setPrice($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Type\Price::class);
        $this->price = $var;

        return $this;
    }

    /**
     * Latest suggested price for the product.
     *
     * Generated from protobuf field <code>.google.shopping.type.Price suggested_price = 16;</code>
     * @return \Google\Shopping\Type\Price|null
     */
    public function getSuggestedPrice()
    {
        return $this->suggested_price;
    }

    public function hasSuggestedPrice()
    {
        return isset($this->suggested_price);
    }

    public function clearSuggestedPrice()
    {
        unset($this->suggested_price);
    }

    /**
     * Latest suggested price for the product.
     *
     * Generated from protobuf field <code>.google.shopping.type.Price suggested_price = 16;</code>
     * @param \Google\Shopping\Type\Price $var
     * @return $this
     */
    public function setSuggestedPrice($var)
    {
        GPBUtil::checkMessage($var, \Google\Shopping\Type\Price::class);
        $this->suggested_price = $var;

        return $this;
    }

    /**
     * Predicted change in impressions as a fraction after introducing the
     * suggested price compared to current active price. For example, 0.05 is a 5%
     * predicted increase in impressions.
     *
     * Generated from protobuf field <code>optional double predicted_impressions_change_fraction = 17;</code>
     * @return float
     */
    public function getPredictedImpressionsChangeFraction()
    {
        return isset($this->predicted_impressions_change_fraction) ? $this->predicted_impressions_change_fraction : 0.0;
    }

    public function hasPredictedImpressionsChangeFraction()
    {
        return isset($this->predicted_impressions_change_fraction);
    }

    public function clearPredictedImpressionsChangeFraction()
    {
        unset($this->predicted_impressions_change_fraction);
    }

    /**
     * Predicted change in impressions as a fraction after introducing the
     * suggested price compared to current active price. For example, 0.05 is a 5%
     * predicted increase in impressions.
     *
     * Generated from protobuf field <code>optional double predicted_impressions_change_fraction = 17;</code>
     * @param float $var
     * @return $this
     */
    public function setPredictedImpressionsChangeFraction($var)
    {
        GPBUtil::checkDouble($var);
        $this->predicted_impressions_change_fraction = $var;

        return $this;
    }

    /**
     * Predicted change in clicks as a fraction after introducing the
     * suggested price compared to current active price. For example, 0.05 is a 5%
     * predicted increase in clicks.
     *
     * Generated from protobuf field <code>optional double predicted_clicks_change_fraction = 18;</code>
     * @return float
     */
    public function getPredictedClicksChangeFraction()
    {
        return isset($this->predicted_clicks_change_fraction) ? $this->predicted_clicks_change_fraction : 0.0;
    }

    public function hasPredictedClicksChangeFraction()
    {
        return isset($this->predicted_clicks_change_fraction);
    }

    public function clearPredictedClicksChangeFraction()
    {
        unset($this->predicted_clicks_change_fraction);
    }

    /**
     * Predicted change in clicks as a fraction after introducing the
     * suggested price compared to current active price. For example, 0.05 is a 5%
     * predicted increase in clicks.
     *
     * Generated from protobuf field <code>optional double predicted_clicks_change_fraction = 18;</code>
     * @param float $var
     * @return $this
     */
    public function setPredictedClicksChangeFraction($var)
    {
        GPBUtil::checkDouble($var);
        $this->predicted_clicks_change_fraction = $var;

        return $this;
    }

    /**
     * Predicted change in conversions as a fraction after introducing the
     * suggested price compared to current active price. For example, 0.05 is a 5%
     * predicted increase in conversions).
     *
     * Generated from protobuf field <code>optional double predicted_conversions_change_fraction = 19;</code>
     * @return float
     */
    public function getPredictedConversionsChangeFraction()
    {
        return isset($this->predicted_conversions_change_fraction) ? $this->predicted_conversions_change_fraction : 0.0;
    }

    public function hasPredictedConversionsChangeFraction()
    {
        return isset($this->predicted_conversions_change_fraction);
    }

    public function clearPredictedConversionsChangeFraction()
    {
        unset($this->predicted_conversions_change_fraction);
    }

    /**
     * Predicted change in conversions as a fraction after introducing the
     * suggested price compared to current active price. For example, 0.05 is a 5%
     * predicted increase in conversions).
     *
     * Generated from protobuf field <code>optional double predicted_conversions_change_fraction = 19;</code>
     * @param float $var
     * @return $this
     */
    public function setPredictedConversionsChangeFraction($var)
    {
        GPBUtil::checkDouble($var);
        $this->predicted_conversions_change_fraction = $var;

        return $this;
    }

    /**
     * The predicted effectiveness of applying the price suggestion, bucketed.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.reports.v1beta.PriceInsightsProductView.Effectiveness effectiveness = 22;</code>
     * @return int
     */
    public function getEffectiveness()
    {
        return $this->effectiveness;
    }

    /**
     * The predicted effectiveness of applying the price suggestion, bucketed.
     *
     * Generated from protobuf field <code>.google.shopping.merchant.reports.v1beta.PriceInsightsProductView.Effectiveness effectiveness = 22;</code>
     * @param int $var
     * @return $this
     */
    public function setEffectiveness($var)
    {
        GPBUtil::checkEnum($var, \Google\Shopping\Merchant\Reports\V1beta\PriceInsightsProductView\Effectiveness::class);
        $this->effectiveness = $var;

        return $this;
    }

}

