<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/spanner/admin/database/v1/backup_schedule.proto

namespace Google\Cloud\Spanner\Admin\Database\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request for
 * [CreateBackupSchedule][google.spanner.admin.database.v1.DatabaseAdmin.CreateBackupSchedule].
 *
 * Generated from protobuf message <code>google.spanner.admin.database.v1.CreateBackupScheduleRequest</code>
 */
class CreateBackupScheduleRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the database that this backup schedule applies to.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * Required. The Id to use for the backup schedule. The `backup_schedule_id`
     * appended to `parent` forms the full backup schedule name of the form
     * `projects/<project>/instances/<instance>/databases/<database>/backupSchedules/<backup_schedule_id>`.
     *
     * Generated from protobuf field <code>string backup_schedule_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $backup_schedule_id = '';
    /**
     * Required. The backup schedule to create.
     *
     * Generated from protobuf field <code>.google.spanner.admin.database.v1.BackupSchedule backup_schedule = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $backup_schedule = null;

    /**
     * @param string                                                 $parent           Required. The name of the database that this backup schedule applies to. Please see
     *                                                                                 {@see DatabaseAdminClient::databaseName()} for help formatting this field.
     * @param \Google\Cloud\Spanner\Admin\Database\V1\BackupSchedule $backupSchedule   Required. The backup schedule to create.
     * @param string                                                 $backupScheduleId Required. The Id to use for the backup schedule. The `backup_schedule_id`
     *                                                                                 appended to `parent` forms the full backup schedule name of the form
     *                                                                                 `projects/<project>/instances/<instance>/databases/<database>/backupSchedules/<backup_schedule_id>`.
     *
     * @return \Google\Cloud\Spanner\Admin\Database\V1\CreateBackupScheduleRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\Spanner\Admin\Database\V1\BackupSchedule $backupSchedule, string $backupScheduleId): self
    {
        return (new self())
            ->setParent($parent)
            ->setBackupSchedule($backupSchedule)
            ->setBackupScheduleId($backupScheduleId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The name of the database that this backup schedule applies to.
     *     @type string $backup_schedule_id
     *           Required. The Id to use for the backup schedule. The `backup_schedule_id`
     *           appended to `parent` forms the full backup schedule name of the form
     *           `projects/<project>/instances/<instance>/databases/<database>/backupSchedules/<backup_schedule_id>`.
     *     @type \Google\Cloud\Spanner\Admin\Database\V1\BackupSchedule $backup_schedule
     *           Required. The backup schedule to create.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Spanner\Admin\Database\V1\BackupSchedule::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the database that this backup schedule applies to.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The name of the database that this backup schedule applies to.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The Id to use for the backup schedule. The `backup_schedule_id`
     * appended to `parent` forms the full backup schedule name of the form
     * `projects/<project>/instances/<instance>/databases/<database>/backupSchedules/<backup_schedule_id>`.
     *
     * Generated from protobuf field <code>string backup_schedule_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getBackupScheduleId()
    {
        return $this->backup_schedule_id;
    }

    /**
     * Required. The Id to use for the backup schedule. The `backup_schedule_id`
     * appended to `parent` forms the full backup schedule name of the form
     * `projects/<project>/instances/<instance>/databases/<database>/backupSchedules/<backup_schedule_id>`.
     *
     * Generated from protobuf field <code>string backup_schedule_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setBackupScheduleId($var)
    {
        GPBUtil::checkString($var, True);
        $this->backup_schedule_id = $var;

        return $this;
    }

    /**
     * Required. The backup schedule to create.
     *
     * Generated from protobuf field <code>.google.spanner.admin.database.v1.BackupSchedule backup_schedule = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\Spanner\Admin\Database\V1\BackupSchedule|null
     */
    public function getBackupSchedule()
    {
        return $this->backup_schedule;
    }

    public function hasBackupSchedule()
    {
        return isset($this->backup_schedule);
    }

    public function clearBackupSchedule()
    {
        unset($this->backup_schedule);
    }

    /**
     * Required. The backup schedule to create.
     *
     * Generated from protobuf field <code>.google.spanner.admin.database.v1.BackupSchedule backup_schedule = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\Spanner\Admin\Database\V1\BackupSchedule $var
     * @return $this
     */
    public function setBackupSchedule($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Spanner\Admin\Database\V1\BackupSchedule::class);
        $this->backup_schedule = $var;

        return $this;
    }

}

