<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/spanner/admin/instance/v1/spanner_instance_admin.proto

namespace Google\Cloud\Spanner\Admin\Instance\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request for
 * [ListInstancePartitionOperations][google.spanner.admin.instance.v1.InstanceAdmin.ListInstancePartitionOperations].
 *
 * Generated from protobuf message <code>google.spanner.admin.instance.v1.ListInstancePartitionOperationsRequest</code>
 */
class ListInstancePartitionOperationsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent instance of the instance partition operations.
     * Values are of the form `projects/<project>/instances/<instance>`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * Optional. An expression that filters the list of returned operations.
     * A filter expression consists of a field name, a
     * comparison operator, and a value for filtering.
     * The value must be a string, a number, or a boolean. The comparison operator
     * must be one of: `<`, `>`, `<=`, `>=`, `!=`, `=`, or `:`.
     * Colon `:` is the contains operator. Filter rules are not case sensitive.
     * The following fields in the [Operation][google.longrunning.Operation]
     * are eligible for filtering:
     *   * `name` - The name of the long-running operation
     *   * `done` - False if the operation is in progress, else true.
     *   * `metadata.&#64;type` - the type of metadata. For example, the type string
     *      for
     *      [CreateInstancePartitionMetadata][google.spanner.admin.instance.v1.CreateInstancePartitionMetadata]
     *      is
     *      `type.googleapis.com/google.spanner.admin.instance.v1.CreateInstancePartitionMetadata`.
     *   * `metadata.<field_name>` - any field in metadata.value.
     *      `metadata.&#64;type` must be specified first, if filtering on metadata
     *      fields.
     *   * `error` - Error associated with the long-running operation.
     *   * `response.&#64;type` - the type of response.
     *   * `response.<field_name>` - any field in response.value.
     * You can combine multiple expressions by enclosing each expression in
     * parentheses. By default, expressions are combined with AND logic. However,
     * you can specify AND, OR, and NOT logic explicitly.
     * Here are a few examples:
     *   * `done:true` - The operation is complete.
     *   * `(metadata.&#64;type=` \
     *     `type.googleapis.com/google.spanner.admin.instance.v1.CreateInstancePartitionMetadata)
     *     AND` \
     *     `(metadata.instance_partition.name:custom-instance-partition) AND` \
     *     `(metadata.start_time < \"2021-03-28T14:50:00Z\") AND` \
     *     `(error:*)` - Return operations where:
     *     * The operation's metadata type is
     *     [CreateInstancePartitionMetadata][google.spanner.admin.instance.v1.CreateInstancePartitionMetadata].
     *     * The instance partition name contains "custom-instance-partition".
     *     * The operation started before 2021-03-28T14:50:00Z.
     *     * The operation resulted in an error.
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $filter = '';
    /**
     * Optional. Number of operations to be returned in the response. If 0 or
     * less, defaults to the server's maximum allowed page size.
     *
     * Generated from protobuf field <code>int32 page_size = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $page_size = 0;
    /**
     * Optional. If non-empty, `page_token` should contain a
     * [next_page_token][google.spanner.admin.instance.v1.ListInstancePartitionOperationsResponse.next_page_token]
     * from a previous
     * [ListInstancePartitionOperationsResponse][google.spanner.admin.instance.v1.ListInstancePartitionOperationsResponse]
     * to the same `parent` and with the same `filter`.
     *
     * Generated from protobuf field <code>string page_token = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $page_token = '';
    /**
     * Optional. Deadline used while retrieving metadata for instance partition
     * operations. Instance partitions whose operation metadata cannot be
     * retrieved within this deadline will be added to
     * [unreachable][ListInstancePartitionOperationsResponse.unreachable] in
     * [ListInstancePartitionOperationsResponse][google.spanner.admin.instance.v1.ListInstancePartitionOperationsResponse].
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp instance_partition_deadline = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $instance_partition_deadline = null;

    /**
     * @param string $parent Required. The parent instance of the instance partition operations.
     *                       Values are of the form `projects/<project>/instances/<instance>`. Please see
     *                       {@see InstanceAdminClient::instanceName()} for help formatting this field.
     *
     * @return \Google\Cloud\Spanner\Admin\Instance\V1\ListInstancePartitionOperationsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent instance of the instance partition operations.
     *           Values are of the form `projects/<project>/instances/<instance>`.
     *     @type string $filter
     *           Optional. An expression that filters the list of returned operations.
     *           A filter expression consists of a field name, a
     *           comparison operator, and a value for filtering.
     *           The value must be a string, a number, or a boolean. The comparison operator
     *           must be one of: `<`, `>`, `<=`, `>=`, `!=`, `=`, or `:`.
     *           Colon `:` is the contains operator. Filter rules are not case sensitive.
     *           The following fields in the [Operation][google.longrunning.Operation]
     *           are eligible for filtering:
     *             * `name` - The name of the long-running operation
     *             * `done` - False if the operation is in progress, else true.
     *             * `metadata.&#64;type` - the type of metadata. For example, the type string
     *                for
     *                [CreateInstancePartitionMetadata][google.spanner.admin.instance.v1.CreateInstancePartitionMetadata]
     *                is
     *                `type.googleapis.com/google.spanner.admin.instance.v1.CreateInstancePartitionMetadata`.
     *             * `metadata.<field_name>` - any field in metadata.value.
     *                `metadata.&#64;type` must be specified first, if filtering on metadata
     *                fields.
     *             * `error` - Error associated with the long-running operation.
     *             * `response.&#64;type` - the type of response.
     *             * `response.<field_name>` - any field in response.value.
     *           You can combine multiple expressions by enclosing each expression in
     *           parentheses. By default, expressions are combined with AND logic. However,
     *           you can specify AND, OR, and NOT logic explicitly.
     *           Here are a few examples:
     *             * `done:true` - The operation is complete.
     *             * `(metadata.&#64;type=` \
     *               `type.googleapis.com/google.spanner.admin.instance.v1.CreateInstancePartitionMetadata)
     *               AND` \
     *               `(metadata.instance_partition.name:custom-instance-partition) AND` \
     *               `(metadata.start_time < \"2021-03-28T14:50:00Z\") AND` \
     *               `(error:*)` - Return operations where:
     *               * The operation's metadata type is
     *               [CreateInstancePartitionMetadata][google.spanner.admin.instance.v1.CreateInstancePartitionMetadata].
     *               * The instance partition name contains "custom-instance-partition".
     *               * The operation started before 2021-03-28T14:50:00Z.
     *               * The operation resulted in an error.
     *     @type int $page_size
     *           Optional. Number of operations to be returned in the response. If 0 or
     *           less, defaults to the server's maximum allowed page size.
     *     @type string $page_token
     *           Optional. If non-empty, `page_token` should contain a
     *           [next_page_token][google.spanner.admin.instance.v1.ListInstancePartitionOperationsResponse.next_page_token]
     *           from a previous
     *           [ListInstancePartitionOperationsResponse][google.spanner.admin.instance.v1.ListInstancePartitionOperationsResponse]
     *           to the same `parent` and with the same `filter`.
     *     @type \Google\Protobuf\Timestamp $instance_partition_deadline
     *           Optional. Deadline used while retrieving metadata for instance partition
     *           operations. Instance partitions whose operation metadata cannot be
     *           retrieved within this deadline will be added to
     *           [unreachable][ListInstancePartitionOperationsResponse.unreachable] in
     *           [ListInstancePartitionOperationsResponse][google.spanner.admin.instance.v1.ListInstancePartitionOperationsResponse].
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Spanner\Admin\Instance\V1\SpannerInstanceAdmin::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent instance of the instance partition operations.
     * Values are of the form `projects/<project>/instances/<instance>`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent instance of the instance partition operations.
     * Values are of the form `projects/<project>/instances/<instance>`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. An expression that filters the list of returned operations.
     * A filter expression consists of a field name, a
     * comparison operator, and a value for filtering.
     * The value must be a string, a number, or a boolean. The comparison operator
     * must be one of: `<`, `>`, `<=`, `>=`, `!=`, `=`, or `:`.
     * Colon `:` is the contains operator. Filter rules are not case sensitive.
     * The following fields in the [Operation][google.longrunning.Operation]
     * are eligible for filtering:
     *   * `name` - The name of the long-running operation
     *   * `done` - False if the operation is in progress, else true.
     *   * `metadata.&#64;type` - the type of metadata. For example, the type string
     *      for
     *      [CreateInstancePartitionMetadata][google.spanner.admin.instance.v1.CreateInstancePartitionMetadata]
     *      is
     *      `type.googleapis.com/google.spanner.admin.instance.v1.CreateInstancePartitionMetadata`.
     *   * `metadata.<field_name>` - any field in metadata.value.
     *      `metadata.&#64;type` must be specified first, if filtering on metadata
     *      fields.
     *   * `error` - Error associated with the long-running operation.
     *   * `response.&#64;type` - the type of response.
     *   * `response.<field_name>` - any field in response.value.
     * You can combine multiple expressions by enclosing each expression in
     * parentheses. By default, expressions are combined with AND logic. However,
     * you can specify AND, OR, and NOT logic explicitly.
     * Here are a few examples:
     *   * `done:true` - The operation is complete.
     *   * `(metadata.&#64;type=` \
     *     `type.googleapis.com/google.spanner.admin.instance.v1.CreateInstancePartitionMetadata)
     *     AND` \
     *     `(metadata.instance_partition.name:custom-instance-partition) AND` \
     *     `(metadata.start_time < \"2021-03-28T14:50:00Z\") AND` \
     *     `(error:*)` - Return operations where:
     *     * The operation's metadata type is
     *     [CreateInstancePartitionMetadata][google.spanner.admin.instance.v1.CreateInstancePartitionMetadata].
     *     * The instance partition name contains "custom-instance-partition".
     *     * The operation started before 2021-03-28T14:50:00Z.
     *     * The operation resulted in an error.
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Optional. An expression that filters the list of returned operations.
     * A filter expression consists of a field name, a
     * comparison operator, and a value for filtering.
     * The value must be a string, a number, or a boolean. The comparison operator
     * must be one of: `<`, `>`, `<=`, `>=`, `!=`, `=`, or `:`.
     * Colon `:` is the contains operator. Filter rules are not case sensitive.
     * The following fields in the [Operation][google.longrunning.Operation]
     * are eligible for filtering:
     *   * `name` - The name of the long-running operation
     *   * `done` - False if the operation is in progress, else true.
     *   * `metadata.&#64;type` - the type of metadata. For example, the type string
     *      for
     *      [CreateInstancePartitionMetadata][google.spanner.admin.instance.v1.CreateInstancePartitionMetadata]
     *      is
     *      `type.googleapis.com/google.spanner.admin.instance.v1.CreateInstancePartitionMetadata`.
     *   * `metadata.<field_name>` - any field in metadata.value.
     *      `metadata.&#64;type` must be specified first, if filtering on metadata
     *      fields.
     *   * `error` - Error associated with the long-running operation.
     *   * `response.&#64;type` - the type of response.
     *   * `response.<field_name>` - any field in response.value.
     * You can combine multiple expressions by enclosing each expression in
     * parentheses. By default, expressions are combined with AND logic. However,
     * you can specify AND, OR, and NOT logic explicitly.
     * Here are a few examples:
     *   * `done:true` - The operation is complete.
     *   * `(metadata.&#64;type=` \
     *     `type.googleapis.com/google.spanner.admin.instance.v1.CreateInstancePartitionMetadata)
     *     AND` \
     *     `(metadata.instance_partition.name:custom-instance-partition) AND` \
     *     `(metadata.start_time < \"2021-03-28T14:50:00Z\") AND` \
     *     `(error:*)` - Return operations where:
     *     * The operation's metadata type is
     *     [CreateInstancePartitionMetadata][google.spanner.admin.instance.v1.CreateInstancePartitionMetadata].
     *     * The instance partition name contains "custom-instance-partition".
     *     * The operation started before 2021-03-28T14:50:00Z.
     *     * The operation resulted in an error.
     *
     * Generated from protobuf field <code>string filter = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * Optional. Number of operations to be returned in the response. If 0 or
     * less, defaults to the server's maximum allowed page size.
     *
     * Generated from protobuf field <code>int32 page_size = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. Number of operations to be returned in the response. If 0 or
     * less, defaults to the server's maximum allowed page size.
     *
     * Generated from protobuf field <code>int32 page_size = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. If non-empty, `page_token` should contain a
     * [next_page_token][google.spanner.admin.instance.v1.ListInstancePartitionOperationsResponse.next_page_token]
     * from a previous
     * [ListInstancePartitionOperationsResponse][google.spanner.admin.instance.v1.ListInstancePartitionOperationsResponse]
     * to the same `parent` and with the same `filter`.
     *
     * Generated from protobuf field <code>string page_token = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. If non-empty, `page_token` should contain a
     * [next_page_token][google.spanner.admin.instance.v1.ListInstancePartitionOperationsResponse.next_page_token]
     * from a previous
     * [ListInstancePartitionOperationsResponse][google.spanner.admin.instance.v1.ListInstancePartitionOperationsResponse]
     * to the same `parent` and with the same `filter`.
     *
     * Generated from protobuf field <code>string page_token = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. Deadline used while retrieving metadata for instance partition
     * operations. Instance partitions whose operation metadata cannot be
     * retrieved within this deadline will be added to
     * [unreachable][ListInstancePartitionOperationsResponse.unreachable] in
     * [ListInstancePartitionOperationsResponse][google.spanner.admin.instance.v1.ListInstancePartitionOperationsResponse].
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp instance_partition_deadline = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getInstancePartitionDeadline()
    {
        return $this->instance_partition_deadline;
    }

    public function hasInstancePartitionDeadline()
    {
        return isset($this->instance_partition_deadline);
    }

    public function clearInstancePartitionDeadline()
    {
        unset($this->instance_partition_deadline);
    }

    /**
     * Optional. Deadline used while retrieving metadata for instance partition
     * operations. Instance partitions whose operation metadata cannot be
     * retrieved within this deadline will be added to
     * [unreachable][ListInstancePartitionOperationsResponse.unreachable] in
     * [ListInstancePartitionOperationsResponse][google.spanner.admin.instance.v1.ListInstancePartitionOperationsResponse].
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp instance_partition_deadline = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setInstancePartitionDeadline($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->instance_partition_deadline = $var;

        return $this;
    }

}

