<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/spanner/admin/instance/v1/spanner_instance_admin.proto

namespace Google\Cloud\Spanner\Admin\Instance\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The response for
 * [ListInstancePartitionOperations][google.spanner.admin.instance.v1.InstanceAdmin.ListInstancePartitionOperations].
 *
 * Generated from protobuf message <code>google.spanner.admin.instance.v1.ListInstancePartitionOperationsResponse</code>
 */
class ListInstancePartitionOperationsResponse extends \Google\Protobuf\Internal\Message
{
    /**
     * The list of matching instance partition [long-running
     * operations][google.longrunning.Operation]. Each operation's name will be
     * prefixed by the instance partition's name. The operation's
     * [metadata][google.longrunning.Operation.metadata] field type
     * `metadata.type_url` describes the type of the metadata.
     *
     * Generated from protobuf field <code>repeated .google.longrunning.Operation operations = 1;</code>
     */
    private $operations;
    /**
     * `next_page_token` can be sent in a subsequent
     * [ListInstancePartitionOperations][google.spanner.admin.instance.v1.InstanceAdmin.ListInstancePartitionOperations]
     * call to fetch more of the matching metadata.
     *
     * Generated from protobuf field <code>string next_page_token = 2;</code>
     */
    private $next_page_token = '';
    /**
     * The list of unreachable instance partitions.
     * It includes the names of instance partitions whose operation metadata could
     * not be retrieved within
     * [instance_partition_deadline][google.spanner.admin.instance.v1.ListInstancePartitionOperationsRequest.instance_partition_deadline].
     *
     * Generated from protobuf field <code>repeated string unreachable_instance_partitions = 3;</code>
     */
    private $unreachable_instance_partitions;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type array<\Google\LongRunning\Operation>|\Google\Protobuf\Internal\RepeatedField $operations
     *           The list of matching instance partition [long-running
     *           operations][google.longrunning.Operation]. Each operation's name will be
     *           prefixed by the instance partition's name. The operation's
     *           [metadata][google.longrunning.Operation.metadata] field type
     *           `metadata.type_url` describes the type of the metadata.
     *     @type string $next_page_token
     *           `next_page_token` can be sent in a subsequent
     *           [ListInstancePartitionOperations][google.spanner.admin.instance.v1.InstanceAdmin.ListInstancePartitionOperations]
     *           call to fetch more of the matching metadata.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $unreachable_instance_partitions
     *           The list of unreachable instance partitions.
     *           It includes the names of instance partitions whose operation metadata could
     *           not be retrieved within
     *           [instance_partition_deadline][google.spanner.admin.instance.v1.ListInstancePartitionOperationsRequest.instance_partition_deadline].
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Spanner\Admin\Instance\V1\SpannerInstanceAdmin::initOnce();
        parent::__construct($data);
    }

    /**
     * The list of matching instance partition [long-running
     * operations][google.longrunning.Operation]. Each operation's name will be
     * prefixed by the instance partition's name. The operation's
     * [metadata][google.longrunning.Operation.metadata] field type
     * `metadata.type_url` describes the type of the metadata.
     *
     * Generated from protobuf field <code>repeated .google.longrunning.Operation operations = 1;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getOperations()
    {
        return $this->operations;
    }

    /**
     * The list of matching instance partition [long-running
     * operations][google.longrunning.Operation]. Each operation's name will be
     * prefixed by the instance partition's name. The operation's
     * [metadata][google.longrunning.Operation.metadata] field type
     * `metadata.type_url` describes the type of the metadata.
     *
     * Generated from protobuf field <code>repeated .google.longrunning.Operation operations = 1;</code>
     * @param array<\Google\LongRunning\Operation>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setOperations($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\LongRunning\Operation::class);
        $this->operations = $arr;

        return $this;
    }

    /**
     * `next_page_token` can be sent in a subsequent
     * [ListInstancePartitionOperations][google.spanner.admin.instance.v1.InstanceAdmin.ListInstancePartitionOperations]
     * call to fetch more of the matching metadata.
     *
     * Generated from protobuf field <code>string next_page_token = 2;</code>
     * @return string
     */
    public function getNextPageToken()
    {
        return $this->next_page_token;
    }

    /**
     * `next_page_token` can be sent in a subsequent
     * [ListInstancePartitionOperations][google.spanner.admin.instance.v1.InstanceAdmin.ListInstancePartitionOperations]
     * call to fetch more of the matching metadata.
     *
     * Generated from protobuf field <code>string next_page_token = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setNextPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->next_page_token = $var;

        return $this;
    }

    /**
     * The list of unreachable instance partitions.
     * It includes the names of instance partitions whose operation metadata could
     * not be retrieved within
     * [instance_partition_deadline][google.spanner.admin.instance.v1.ListInstancePartitionOperationsRequest.instance_partition_deadline].
     *
     * Generated from protobuf field <code>repeated string unreachable_instance_partitions = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getUnreachableInstancePartitions()
    {
        return $this->unreachable_instance_partitions;
    }

    /**
     * The list of unreachable instance partitions.
     * It includes the names of instance partitions whose operation metadata could
     * not be retrieved within
     * [instance_partition_deadline][google.spanner.admin.instance.v1.ListInstancePartitionOperationsRequest.instance_partition_deadline].
     *
     * Generated from protobuf field <code>repeated string unreachable_instance_partitions = 3;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setUnreachableInstancePartitions($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->unreachable_instance_partitions = $arr;

        return $this;
    }

}

