<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/spanner/admin/instance/v1/spanner_instance_admin.proto

namespace Google\Cloud\Spanner\Admin\Instance\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request for
 * [ListInstancePartitions][google.spanner.admin.instance.v1.InstanceAdmin.ListInstancePartitions].
 *
 * Generated from protobuf message <code>google.spanner.admin.instance.v1.ListInstancePartitionsRequest</code>
 */
class ListInstancePartitionsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The instance whose instance partitions should be listed. Values
     * are of the form `projects/<project>/instances/<instance>`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * Number of instance partitions to be returned in the response. If 0 or less,
     * defaults to the server's maximum allowed page size.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     */
    private $page_size = 0;
    /**
     * If non-empty, `page_token` should contain a
     * [next_page_token][google.spanner.admin.instance.v1.ListInstancePartitionsResponse.next_page_token]
     * from a previous
     * [ListInstancePartitionsResponse][google.spanner.admin.instance.v1.ListInstancePartitionsResponse].
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     */
    private $page_token = '';
    /**
     * Optional. Deadline used while retrieving metadata for instance partitions.
     * Instance partitions whose metadata cannot be retrieved within this deadline
     * will be added to
     * [unreachable][google.spanner.admin.instance.v1.ListInstancePartitionsResponse.unreachable]
     * in
     * [ListInstancePartitionsResponse][google.spanner.admin.instance.v1.ListInstancePartitionsResponse].
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp instance_partition_deadline = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $instance_partition_deadline = null;

    /**
     * @param string $parent Required. The instance whose instance partitions should be listed. Values
     *                       are of the form `projects/<project>/instances/<instance>`. Please see
     *                       {@see InstanceAdminClient::instanceName()} for help formatting this field.
     *
     * @return \Google\Cloud\Spanner\Admin\Instance\V1\ListInstancePartitionsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The instance whose instance partitions should be listed. Values
     *           are of the form `projects/<project>/instances/<instance>`.
     *     @type int $page_size
     *           Number of instance partitions to be returned in the response. If 0 or less,
     *           defaults to the server's maximum allowed page size.
     *     @type string $page_token
     *           If non-empty, `page_token` should contain a
     *           [next_page_token][google.spanner.admin.instance.v1.ListInstancePartitionsResponse.next_page_token]
     *           from a previous
     *           [ListInstancePartitionsResponse][google.spanner.admin.instance.v1.ListInstancePartitionsResponse].
     *     @type \Google\Protobuf\Timestamp $instance_partition_deadline
     *           Optional. Deadline used while retrieving metadata for instance partitions.
     *           Instance partitions whose metadata cannot be retrieved within this deadline
     *           will be added to
     *           [unreachable][google.spanner.admin.instance.v1.ListInstancePartitionsResponse.unreachable]
     *           in
     *           [ListInstancePartitionsResponse][google.spanner.admin.instance.v1.ListInstancePartitionsResponse].
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Spanner\Admin\Instance\V1\SpannerInstanceAdmin::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The instance whose instance partitions should be listed. Values
     * are of the form `projects/<project>/instances/<instance>`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The instance whose instance partitions should be listed. Values
     * are of the form `projects/<project>/instances/<instance>`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Number of instance partitions to be returned in the response. If 0 or less,
     * defaults to the server's maximum allowed page size.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Number of instance partitions to be returned in the response. If 0 or less,
     * defaults to the server's maximum allowed page size.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * If non-empty, `page_token` should contain a
     * [next_page_token][google.spanner.admin.instance.v1.ListInstancePartitionsResponse.next_page_token]
     * from a previous
     * [ListInstancePartitionsResponse][google.spanner.admin.instance.v1.ListInstancePartitionsResponse].
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * If non-empty, `page_token` should contain a
     * [next_page_token][google.spanner.admin.instance.v1.ListInstancePartitionsResponse.next_page_token]
     * from a previous
     * [ListInstancePartitionsResponse][google.spanner.admin.instance.v1.ListInstancePartitionsResponse].
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Optional. Deadline used while retrieving metadata for instance partitions.
     * Instance partitions whose metadata cannot be retrieved within this deadline
     * will be added to
     * [unreachable][google.spanner.admin.instance.v1.ListInstancePartitionsResponse.unreachable]
     * in
     * [ListInstancePartitionsResponse][google.spanner.admin.instance.v1.ListInstancePartitionsResponse].
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp instance_partition_deadline = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getInstancePartitionDeadline()
    {
        return $this->instance_partition_deadline;
    }

    public function hasInstancePartitionDeadline()
    {
        return isset($this->instance_partition_deadline);
    }

    public function clearInstancePartitionDeadline()
    {
        unset($this->instance_partition_deadline);
    }

    /**
     * Optional. Deadline used while retrieving metadata for instance partitions.
     * Instance partitions whose metadata cannot be retrieved within this deadline
     * will be added to
     * [unreachable][google.spanner.admin.instance.v1.ListInstancePartitionsResponse.unreachable]
     * in
     * [ListInstancePartitionsResponse][google.spanner.admin.instance.v1.ListInstancePartitionsResponse].
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp instance_partition_deadline = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setInstancePartitionDeadline($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->instance_partition_deadline = $var;

        return $this;
    }

}

