<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/spanner/v1/spanner.proto

namespace Google\Cloud\Spanner\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The request for [BatchWrite][google.spanner.v1.Spanner.BatchWrite].
 *
 * Generated from protobuf message <code>google.spanner.v1.BatchWriteRequest</code>
 */
class BatchWriteRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The session in which the batch request is to be run.
     *
     * Generated from protobuf field <code>string session = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $session = '';
    /**
     * Common options for this request.
     *
     * Generated from protobuf field <code>.google.spanner.v1.RequestOptions request_options = 3;</code>
     */
    private $request_options = null;
    /**
     * Required. The groups of mutations to be applied.
     *
     * Generated from protobuf field <code>repeated .google.spanner.v1.BatchWriteRequest.MutationGroup mutation_groups = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $mutation_groups;
    /**
     * Optional. When `exclude_txn_from_change_streams` is set to `true`:
     *  * Mutations from all transactions in this batch write operation will not
     *  be recorded in change streams with DDL option `allow_txn_exclusion=true`
     *  that are tracking columns modified by these transactions.
     *  * Mutations from all transactions in this batch write operation will be
     *  recorded in change streams with DDL option `allow_txn_exclusion=false or
     *  not set` that are tracking columns modified by these transactions.
     * When `exclude_txn_from_change_streams` is set to `false` or not set,
     * mutations from all transactions in this batch write operation will be
     * recorded in all change streams that are tracking columns modified by these
     * transactions.
     *
     * Generated from protobuf field <code>bool exclude_txn_from_change_streams = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $exclude_txn_from_change_streams = false;

    /**
     * @param string                                                     $session        Required. The session in which the batch request is to be run. Please see
     *                                                                                   {@see SpannerClient::sessionName()} for help formatting this field.
     * @param \Google\Cloud\Spanner\V1\BatchWriteRequest\MutationGroup[] $mutationGroups Required. The groups of mutations to be applied.
     *
     * @return \Google\Cloud\Spanner\V1\BatchWriteRequest
     *
     * @experimental
     */
    public static function build(string $session, array $mutationGroups): self
    {
        return (new self())
            ->setSession($session)
            ->setMutationGroups($mutationGroups);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $session
     *           Required. The session in which the batch request is to be run.
     *     @type \Google\Cloud\Spanner\V1\RequestOptions $request_options
     *           Common options for this request.
     *     @type array<\Google\Cloud\Spanner\V1\BatchWriteRequest\MutationGroup>|\Google\Protobuf\Internal\RepeatedField $mutation_groups
     *           Required. The groups of mutations to be applied.
     *     @type bool $exclude_txn_from_change_streams
     *           Optional. When `exclude_txn_from_change_streams` is set to `true`:
     *            * Mutations from all transactions in this batch write operation will not
     *            be recorded in change streams with DDL option `allow_txn_exclusion=true`
     *            that are tracking columns modified by these transactions.
     *            * Mutations from all transactions in this batch write operation will be
     *            recorded in change streams with DDL option `allow_txn_exclusion=false or
     *            not set` that are tracking columns modified by these transactions.
     *           When `exclude_txn_from_change_streams` is set to `false` or not set,
     *           mutations from all transactions in this batch write operation will be
     *           recorded in all change streams that are tracking columns modified by these
     *           transactions.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Spanner\V1\Spanner::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The session in which the batch request is to be run.
     *
     * Generated from protobuf field <code>string session = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getSession()
    {
        return $this->session;
    }

    /**
     * Required. The session in which the batch request is to be run.
     *
     * Generated from protobuf field <code>string session = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setSession($var)
    {
        GPBUtil::checkString($var, True);
        $this->session = $var;

        return $this;
    }

    /**
     * Common options for this request.
     *
     * Generated from protobuf field <code>.google.spanner.v1.RequestOptions request_options = 3;</code>
     * @return \Google\Cloud\Spanner\V1\RequestOptions|null
     */
    public function getRequestOptions()
    {
        return $this->request_options;
    }

    public function hasRequestOptions()
    {
        return isset($this->request_options);
    }

    public function clearRequestOptions()
    {
        unset($this->request_options);
    }

    /**
     * Common options for this request.
     *
     * Generated from protobuf field <code>.google.spanner.v1.RequestOptions request_options = 3;</code>
     * @param \Google\Cloud\Spanner\V1\RequestOptions $var
     * @return $this
     */
    public function setRequestOptions($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Spanner\V1\RequestOptions::class);
        $this->request_options = $var;

        return $this;
    }

    /**
     * Required. The groups of mutations to be applied.
     *
     * Generated from protobuf field <code>repeated .google.spanner.v1.BatchWriteRequest.MutationGroup mutation_groups = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getMutationGroups()
    {
        return $this->mutation_groups;
    }

    /**
     * Required. The groups of mutations to be applied.
     *
     * Generated from protobuf field <code>repeated .google.spanner.v1.BatchWriteRequest.MutationGroup mutation_groups = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param array<\Google\Cloud\Spanner\V1\BatchWriteRequest\MutationGroup>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setMutationGroups($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Spanner\V1\BatchWriteRequest\MutationGroup::class);
        $this->mutation_groups = $arr;

        return $this;
    }

    /**
     * Optional. When `exclude_txn_from_change_streams` is set to `true`:
     *  * Mutations from all transactions in this batch write operation will not
     *  be recorded in change streams with DDL option `allow_txn_exclusion=true`
     *  that are tracking columns modified by these transactions.
     *  * Mutations from all transactions in this batch write operation will be
     *  recorded in change streams with DDL option `allow_txn_exclusion=false or
     *  not set` that are tracking columns modified by these transactions.
     * When `exclude_txn_from_change_streams` is set to `false` or not set,
     * mutations from all transactions in this batch write operation will be
     * recorded in all change streams that are tracking columns modified by these
     * transactions.
     *
     * Generated from protobuf field <code>bool exclude_txn_from_change_streams = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getExcludeTxnFromChangeStreams()
    {
        return $this->exclude_txn_from_change_streams;
    }

    /**
     * Optional. When `exclude_txn_from_change_streams` is set to `true`:
     *  * Mutations from all transactions in this batch write operation will not
     *  be recorded in change streams with DDL option `allow_txn_exclusion=true`
     *  that are tracking columns modified by these transactions.
     *  * Mutations from all transactions in this batch write operation will be
     *  recorded in change streams with DDL option `allow_txn_exclusion=false or
     *  not set` that are tracking columns modified by these transactions.
     * When `exclude_txn_from_change_streams` is set to `false` or not set,
     * mutations from all transactions in this batch write operation will be
     * recorded in all change streams that are tracking columns modified by these
     * transactions.
     *
     * Generated from protobuf field <code>bool exclude_txn_from_change_streams = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setExcludeTxnFromChangeStreams($var)
    {
        GPBUtil::checkBool($var);
        $this->exclude_txn_from_change_streams = $var;

        return $this;
    }

}

