<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/sql/v1/cloud_sql_resources.proto

namespace Google\Cloud\Sql\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Maintenance window. This specifies when a Cloud SQL instance is
 * restarted for system maintenance purposes.
 *
 * Generated from protobuf message <code>google.cloud.sql.v1.MaintenanceWindow</code>
 */
class MaintenanceWindow extends \Google\Protobuf\Internal\Message
{
    /**
     * Hour of day - 0 to 23. Specify in the UTC time zone.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value hour = 1;</code>
     */
    protected $hour = null;
    /**
     * Day of week - `MONDAY`, `TUESDAY`, `WEDNESDAY`, `THURSDAY`, `FRIDAY`,
     * `SATURDAY`, or `SUNDAY`. Specify in the UTC time zone.
     * Returned in output as an integer, 1 to 7, where `1` equals Monday.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value day = 2;</code>
     */
    protected $day = null;
    /**
     * Maintenance timing settings: `canary`, `stable`, or `week5`.
     * For more information, see [About maintenance on Cloud SQL
     * instances](https://cloud.google.com/sql/docs/mysql/maintenance).
     *
     * Generated from protobuf field <code>.google.cloud.sql.v1.SqlUpdateTrack update_track = 3;</code>
     */
    protected $update_track = 0;
    /**
     * This is always `sql#maintenanceWindow`.
     *
     * Generated from protobuf field <code>string kind = 4;</code>
     */
    protected $kind = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Protobuf\Int32Value $hour
     *           Hour of day - 0 to 23. Specify in the UTC time zone.
     *     @type \Google\Protobuf\Int32Value $day
     *           Day of week - `MONDAY`, `TUESDAY`, `WEDNESDAY`, `THURSDAY`, `FRIDAY`,
     *           `SATURDAY`, or `SUNDAY`. Specify in the UTC time zone.
     *           Returned in output as an integer, 1 to 7, where `1` equals Monday.
     *     @type int $update_track
     *           Maintenance timing settings: `canary`, `stable`, or `week5`.
     *           For more information, see [About maintenance on Cloud SQL
     *           instances](https://cloud.google.com/sql/docs/mysql/maintenance).
     *     @type string $kind
     *           This is always `sql#maintenanceWindow`.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Sql\V1\CloudSqlResources::initOnce();
        parent::__construct($data);
    }

    /**
     * Hour of day - 0 to 23. Specify in the UTC time zone.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value hour = 1;</code>
     * @return \Google\Protobuf\Int32Value|null
     */
    public function getHour()
    {
        return $this->hour;
    }

    public function hasHour()
    {
        return isset($this->hour);
    }

    public function clearHour()
    {
        unset($this->hour);
    }

    /**
     * Returns the unboxed value from <code>getHour()</code>

     * Hour of day - 0 to 23. Specify in the UTC time zone.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value hour = 1;</code>
     * @return int|null
     */
    public function getHourUnwrapped()
    {
        return $this->readWrapperValue("hour");
    }

    /**
     * Hour of day - 0 to 23. Specify in the UTC time zone.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value hour = 1;</code>
     * @param \Google\Protobuf\Int32Value $var
     * @return $this
     */
    public function setHour($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Int32Value::class);
        $this->hour = $var;

        return $this;
    }

    /**
     * Sets the field by wrapping a primitive type in a Google\Protobuf\Int32Value object.

     * Hour of day - 0 to 23. Specify in the UTC time zone.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value hour = 1;</code>
     * @param int|null $var
     * @return $this
     */
    public function setHourUnwrapped($var)
    {
        $this->writeWrapperValue("hour", $var);
        return $this;}

    /**
     * Day of week - `MONDAY`, `TUESDAY`, `WEDNESDAY`, `THURSDAY`, `FRIDAY`,
     * `SATURDAY`, or `SUNDAY`. Specify in the UTC time zone.
     * Returned in output as an integer, 1 to 7, where `1` equals Monday.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value day = 2;</code>
     * @return \Google\Protobuf\Int32Value|null
     */
    public function getDay()
    {
        return $this->day;
    }

    public function hasDay()
    {
        return isset($this->day);
    }

    public function clearDay()
    {
        unset($this->day);
    }

    /**
     * Returns the unboxed value from <code>getDay()</code>

     * Day of week - `MONDAY`, `TUESDAY`, `WEDNESDAY`, `THURSDAY`, `FRIDAY`,
     * `SATURDAY`, or `SUNDAY`. Specify in the UTC time zone.
     * Returned in output as an integer, 1 to 7, where `1` equals Monday.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value day = 2;</code>
     * @return int|null
     */
    public function getDayUnwrapped()
    {
        return $this->readWrapperValue("day");
    }

    /**
     * Day of week - `MONDAY`, `TUESDAY`, `WEDNESDAY`, `THURSDAY`, `FRIDAY`,
     * `SATURDAY`, or `SUNDAY`. Specify in the UTC time zone.
     * Returned in output as an integer, 1 to 7, where `1` equals Monday.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value day = 2;</code>
     * @param \Google\Protobuf\Int32Value $var
     * @return $this
     */
    public function setDay($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Int32Value::class);
        $this->day = $var;

        return $this;
    }

    /**
     * Sets the field by wrapping a primitive type in a Google\Protobuf\Int32Value object.

     * Day of week - `MONDAY`, `TUESDAY`, `WEDNESDAY`, `THURSDAY`, `FRIDAY`,
     * `SATURDAY`, or `SUNDAY`. Specify in the UTC time zone.
     * Returned in output as an integer, 1 to 7, where `1` equals Monday.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value day = 2;</code>
     * @param int|null $var
     * @return $this
     */
    public function setDayUnwrapped($var)
    {
        $this->writeWrapperValue("day", $var);
        return $this;}

    /**
     * Maintenance timing settings: `canary`, `stable`, or `week5`.
     * For more information, see [About maintenance on Cloud SQL
     * instances](https://cloud.google.com/sql/docs/mysql/maintenance).
     *
     * Generated from protobuf field <code>.google.cloud.sql.v1.SqlUpdateTrack update_track = 3;</code>
     * @return int
     */
    public function getUpdateTrack()
    {
        return $this->update_track;
    }

    /**
     * Maintenance timing settings: `canary`, `stable`, or `week5`.
     * For more information, see [About maintenance on Cloud SQL
     * instances](https://cloud.google.com/sql/docs/mysql/maintenance).
     *
     * Generated from protobuf field <code>.google.cloud.sql.v1.SqlUpdateTrack update_track = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setUpdateTrack($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Sql\V1\SqlUpdateTrack::class);
        $this->update_track = $var;

        return $this;
    }

    /**
     * This is always `sql#maintenanceWindow`.
     *
     * Generated from protobuf field <code>string kind = 4;</code>
     * @return string
     */
    public function getKind()
    {
        return $this->kind;
    }

    /**
     * This is always `sql#maintenanceWindow`.
     *
     * Generated from protobuf field <code>string kind = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setKind($var)
    {
        GPBUtil::checkString($var, True);
        $this->kind = $var;

        return $this;
    }

}

