<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/sql/v1/cloud_sql_instances.proto

namespace Google\Cloud\Sql\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Instance verify external sync settings request.
 *
 * Generated from protobuf message <code>google.cloud.sql.v1.SqlInstancesVerifyExternalSyncSettingsRequest</code>
 */
class SqlInstancesVerifyExternalSyncSettingsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Cloud SQL instance ID. This does not include the project ID.
     *
     * Generated from protobuf field <code>string instance = 1;</code>
     */
    protected $instance = '';
    /**
     * Project ID of the project that contains the instance.
     *
     * Generated from protobuf field <code>string project = 2;</code>
     */
    protected $project = '';
    /**
     * Flag to enable verifying connection only
     *
     * Generated from protobuf field <code>bool verify_connection_only = 3;</code>
     */
    protected $verify_connection_only = false;
    /**
     * External sync mode
     *
     * Generated from protobuf field <code>.google.cloud.sql.v1.SqlInstancesVerifyExternalSyncSettingsRequest.ExternalSyncMode sync_mode = 4;</code>
     */
    protected $sync_mode = 0;
    /**
     * Optional. Flag to verify settings required by replication setup only
     *
     * Generated from protobuf field <code>bool verify_replication_only = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $verify_replication_only = false;
    /**
     * Optional. MigrationType configures the migration to use physical files or
     * logical dump files. If not set, then the logical dump file configuration is
     * used. Valid values are `LOGICAL` or `PHYSICAL`. Only applicable to MySQL.
     *
     * Generated from protobuf field <code>.google.cloud.sql.v1.SqlInstancesVerifyExternalSyncSettingsRequest.MigrationType migration_type = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $migration_type = 0;
    /**
     * Optional. Parallel level for initial data sync. Only applicable for
     * PostgreSQL.
     *
     * Generated from protobuf field <code>.google.cloud.sql.v1.ExternalSyncParallelLevel sync_parallel_level = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $sync_parallel_level = 0;
    protected $sync_config;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $instance
     *           Cloud SQL instance ID. This does not include the project ID.
     *     @type string $project
     *           Project ID of the project that contains the instance.
     *     @type bool $verify_connection_only
     *           Flag to enable verifying connection only
     *     @type int $sync_mode
     *           External sync mode
     *     @type bool $verify_replication_only
     *           Optional. Flag to verify settings required by replication setup only
     *     @type \Google\Cloud\Sql\V1\MySqlSyncConfig $mysql_sync_config
     *           Optional. MySQL-specific settings for start external sync.
     *     @type int $migration_type
     *           Optional. MigrationType configures the migration to use physical files or
     *           logical dump files. If not set, then the logical dump file configuration is
     *           used. Valid values are `LOGICAL` or `PHYSICAL`. Only applicable to MySQL.
     *     @type int $sync_parallel_level
     *           Optional. Parallel level for initial data sync. Only applicable for
     *           PostgreSQL.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Sql\V1\CloudSqlInstances::initOnce();
        parent::__construct($data);
    }

    /**
     * Cloud SQL instance ID. This does not include the project ID.
     *
     * Generated from protobuf field <code>string instance = 1;</code>
     * @return string
     */
    public function getInstance()
    {
        return $this->instance;
    }

    /**
     * Cloud SQL instance ID. This does not include the project ID.
     *
     * Generated from protobuf field <code>string instance = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setInstance($var)
    {
        GPBUtil::checkString($var, True);
        $this->instance = $var;

        return $this;
    }

    /**
     * Project ID of the project that contains the instance.
     *
     * Generated from protobuf field <code>string project = 2;</code>
     * @return string
     */
    public function getProject()
    {
        return $this->project;
    }

    /**
     * Project ID of the project that contains the instance.
     *
     * Generated from protobuf field <code>string project = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setProject($var)
    {
        GPBUtil::checkString($var, True);
        $this->project = $var;

        return $this;
    }

    /**
     * Flag to enable verifying connection only
     *
     * Generated from protobuf field <code>bool verify_connection_only = 3;</code>
     * @return bool
     */
    public function getVerifyConnectionOnly()
    {
        return $this->verify_connection_only;
    }

    /**
     * Flag to enable verifying connection only
     *
     * Generated from protobuf field <code>bool verify_connection_only = 3;</code>
     * @param bool $var
     * @return $this
     */
    public function setVerifyConnectionOnly($var)
    {
        GPBUtil::checkBool($var);
        $this->verify_connection_only = $var;

        return $this;
    }

    /**
     * External sync mode
     *
     * Generated from protobuf field <code>.google.cloud.sql.v1.SqlInstancesVerifyExternalSyncSettingsRequest.ExternalSyncMode sync_mode = 4;</code>
     * @return int
     */
    public function getSyncMode()
    {
        return $this->sync_mode;
    }

    /**
     * External sync mode
     *
     * Generated from protobuf field <code>.google.cloud.sql.v1.SqlInstancesVerifyExternalSyncSettingsRequest.ExternalSyncMode sync_mode = 4;</code>
     * @param int $var
     * @return $this
     */
    public function setSyncMode($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Sql\V1\SqlInstancesVerifyExternalSyncSettingsRequest\ExternalSyncMode::class);
        $this->sync_mode = $var;

        return $this;
    }

    /**
     * Optional. Flag to verify settings required by replication setup only
     *
     * Generated from protobuf field <code>bool verify_replication_only = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return bool
     */
    public function getVerifyReplicationOnly()
    {
        return $this->verify_replication_only;
    }

    /**
     * Optional. Flag to verify settings required by replication setup only
     *
     * Generated from protobuf field <code>bool verify_replication_only = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param bool $var
     * @return $this
     */
    public function setVerifyReplicationOnly($var)
    {
        GPBUtil::checkBool($var);
        $this->verify_replication_only = $var;

        return $this;
    }

    /**
     * Optional. MySQL-specific settings for start external sync.
     *
     * Generated from protobuf field <code>.google.cloud.sql.v1.MySqlSyncConfig mysql_sync_config = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Cloud\Sql\V1\MySqlSyncConfig|null
     */
    public function getMysqlSyncConfig()
    {
        return $this->readOneof(6);
    }

    public function hasMysqlSyncConfig()
    {
        return $this->hasOneof(6);
    }

    /**
     * Optional. MySQL-specific settings for start external sync.
     *
     * Generated from protobuf field <code>.google.cloud.sql.v1.MySqlSyncConfig mysql_sync_config = 6 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param \Google\Cloud\Sql\V1\MySqlSyncConfig $var
     * @return $this
     */
    public function setMysqlSyncConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Sql\V1\MySqlSyncConfig::class);
        $this->writeOneof(6, $var);

        return $this;
    }

    /**
     * Optional. MigrationType configures the migration to use physical files or
     * logical dump files. If not set, then the logical dump file configuration is
     * used. Valid values are `LOGICAL` or `PHYSICAL`. Only applicable to MySQL.
     *
     * Generated from protobuf field <code>.google.cloud.sql.v1.SqlInstancesVerifyExternalSyncSettingsRequest.MigrationType migration_type = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getMigrationType()
    {
        return $this->migration_type;
    }

    /**
     * Optional. MigrationType configures the migration to use physical files or
     * logical dump files. If not set, then the logical dump file configuration is
     * used. Valid values are `LOGICAL` or `PHYSICAL`. Only applicable to MySQL.
     *
     * Generated from protobuf field <code>.google.cloud.sql.v1.SqlInstancesVerifyExternalSyncSettingsRequest.MigrationType migration_type = 7 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setMigrationType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Sql\V1\SqlInstancesVerifyExternalSyncSettingsRequest\MigrationType::class);
        $this->migration_type = $var;

        return $this;
    }

    /**
     * Optional. Parallel level for initial data sync. Only applicable for
     * PostgreSQL.
     *
     * Generated from protobuf field <code>.google.cloud.sql.v1.ExternalSyncParallelLevel sync_parallel_level = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getSyncParallelLevel()
    {
        return $this->sync_parallel_level;
    }

    /**
     * Optional. Parallel level for initial data sync. Only applicable for
     * PostgreSQL.
     *
     * Generated from protobuf field <code>.google.cloud.sql.v1.ExternalSyncParallelLevel sync_parallel_level = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setSyncParallelLevel($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Sql\V1\ExternalSyncParallelLevel::class);
        $this->sync_parallel_level = $var;

        return $this;
    }

    /**
     * @return string
     */
    public function getSyncConfig()
    {
        return $this->whichOneof("sync_config");
    }

}

