<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/storagetransfer/v1/transfer.proto

namespace Google\Cloud\StorageTransfer\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * `projectId`, `jobNames`, and `jobStatuses` are query parameters that can
 * be specified when listing transfer jobs.
 *
 * Generated from protobuf message <code>google.storagetransfer.v1.ListTransferJobsRequest</code>
 */
class ListTransferJobsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. A list of query parameters specified as JSON text in the form of:
     * `{"projectId":"my_project_id",
     *  "jobNames":["jobid1","jobid2",...],
     *  "jobStatuses":["status1","status2",...]}`
     * Since `jobNames` and `jobStatuses` support multiple values, their values
     * must be specified with array notation. `projectId` is required.
     * `jobNames` and `jobStatuses` are optional.  The valid values for
     * `jobStatuses` are case-insensitive:
     * [ENABLED][google.storagetransfer.v1.TransferJob.Status.ENABLED],
     * [DISABLED][google.storagetransfer.v1.TransferJob.Status.DISABLED], and
     * [DELETED][google.storagetransfer.v1.TransferJob.Status.DELETED].
     *
     * Generated from protobuf field <code>string filter = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $filter = '';
    /**
     * The list page size. The max allowed value is 256.
     *
     * Generated from protobuf field <code>int32 page_size = 4;</code>
     */
    protected $page_size = 0;
    /**
     * The list page token.
     *
     * Generated from protobuf field <code>string page_token = 5;</code>
     */
    protected $page_token = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $filter
     *           Required. A list of query parameters specified as JSON text in the form of:
     *           `{"projectId":"my_project_id",
     *            "jobNames":["jobid1","jobid2",...],
     *            "jobStatuses":["status1","status2",...]}`
     *           Since `jobNames` and `jobStatuses` support multiple values, their values
     *           must be specified with array notation. `projectId` is required.
     *           `jobNames` and `jobStatuses` are optional.  The valid values for
     *           `jobStatuses` are case-insensitive:
     *           [ENABLED][google.storagetransfer.v1.TransferJob.Status.ENABLED],
     *           [DISABLED][google.storagetransfer.v1.TransferJob.Status.DISABLED], and
     *           [DELETED][google.storagetransfer.v1.TransferJob.Status.DELETED].
     *     @type int $page_size
     *           The list page size. The max allowed value is 256.
     *     @type string $page_token
     *           The list page token.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Storagetransfer\V1\Transfer::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. A list of query parameters specified as JSON text in the form of:
     * `{"projectId":"my_project_id",
     *  "jobNames":["jobid1","jobid2",...],
     *  "jobStatuses":["status1","status2",...]}`
     * Since `jobNames` and `jobStatuses` support multiple values, their values
     * must be specified with array notation. `projectId` is required.
     * `jobNames` and `jobStatuses` are optional.  The valid values for
     * `jobStatuses` are case-insensitive:
     * [ENABLED][google.storagetransfer.v1.TransferJob.Status.ENABLED],
     * [DISABLED][google.storagetransfer.v1.TransferJob.Status.DISABLED], and
     * [DELETED][google.storagetransfer.v1.TransferJob.Status.DELETED].
     *
     * Generated from protobuf field <code>string filter = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Required. A list of query parameters specified as JSON text in the form of:
     * `{"projectId":"my_project_id",
     *  "jobNames":["jobid1","jobid2",...],
     *  "jobStatuses":["status1","status2",...]}`
     * Since `jobNames` and `jobStatuses` support multiple values, their values
     * must be specified with array notation. `projectId` is required.
     * `jobNames` and `jobStatuses` are optional.  The valid values for
     * `jobStatuses` are case-insensitive:
     * [ENABLED][google.storagetransfer.v1.TransferJob.Status.ENABLED],
     * [DISABLED][google.storagetransfer.v1.TransferJob.Status.DISABLED], and
     * [DELETED][google.storagetransfer.v1.TransferJob.Status.DELETED].
     *
     * Generated from protobuf field <code>string filter = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * The list page size. The max allowed value is 256.
     *
     * Generated from protobuf field <code>int32 page_size = 4;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The list page size. The max allowed value is 256.
     *
     * Generated from protobuf field <code>int32 page_size = 4;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * The list page token.
     *
     * Generated from protobuf field <code>string page_token = 5;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * The list page token.
     *
     * Generated from protobuf field <code>string page_token = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

