<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/telcoautomation/v1/telcoautomation.proto

namespace Google\Cloud\TelcoAutomation\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * EdgeSlm represents an SLM instance which manages the lifecycle of edge
 * components installed on Workload clusters managed by an Orchestration
 * Cluster.
 *
 * Generated from protobuf message <code>google.cloud.telcoautomation.v1.EdgeSlm</code>
 */
class EdgeSlm extends \Google\Protobuf\Internal\Message
{
    /**
     * Name of the EdgeSlm resource.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    protected $name = '';
    /**
     * Immutable. Reference to the orchestration cluster on which templates for
     * this resources will be applied. This should be of format
     * projects/{project}/locations/{location}/orchestrationClusters/{orchestration_cluster}.
     *
     * Generated from protobuf field <code>string orchestration_cluster = 5 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.resource_reference) = {</code>
     */
    protected $orchestration_cluster = '';
    /**
     * Output only. [Output only] Create time stamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. [Output only] Update time stamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Optional. Labels as key value pairs. The key and value should contain
     * characters which are UTF-8 compliant and less than 50 characters.
     *
     * Generated from protobuf field <code>map<string, string> labels = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $labels;
    /**
     * Output only. Provides the active TNA version for this resource.
     *
     * Generated from protobuf field <code>string tna_version = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $tna_version = '';
    /**
     * Output only. State of the EdgeSlm resource.
     *
     * Generated from protobuf field <code>.google.cloud.telcoautomation.v1.EdgeSlm.State state = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;
    /**
     * Optional. Type of workload cluster for which an EdgeSLM resource is
     * created.
     *
     * Generated from protobuf field <code>.google.cloud.telcoautomation.v1.EdgeSlm.WorkloadClusterType workload_cluster_type = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $workload_cluster_type = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Name of the EdgeSlm resource.
     *     @type string $orchestration_cluster
     *           Immutable. Reference to the orchestration cluster on which templates for
     *           this resources will be applied. This should be of format
     *           projects/{project}/locations/{location}/orchestrationClusters/{orchestration_cluster}.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. [Output only] Create time stamp.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. [Output only] Update time stamp.
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Optional. Labels as key value pairs. The key and value should contain
     *           characters which are UTF-8 compliant and less than 50 characters.
     *     @type string $tna_version
     *           Output only. Provides the active TNA version for this resource.
     *     @type int $state
     *           Output only. State of the EdgeSlm resource.
     *     @type int $workload_cluster_type
     *           Optional. Type of workload cluster for which an EdgeSLM resource is
     *           created.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Telcoautomation\V1\Telcoautomation::initOnce();
        parent::__construct($data);
    }

    /**
     * Name of the EdgeSlm resource.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Name of the EdgeSlm resource.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Immutable. Reference to the orchestration cluster on which templates for
     * this resources will be applied. This should be of format
     * projects/{project}/locations/{location}/orchestrationClusters/{orchestration_cluster}.
     *
     * Generated from protobuf field <code>string orchestration_cluster = 5 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getOrchestrationCluster()
    {
        return $this->orchestration_cluster;
    }

    /**
     * Immutable. Reference to the orchestration cluster on which templates for
     * this resources will be applied. This should be of format
     * projects/{project}/locations/{location}/orchestrationClusters/{orchestration_cluster}.
     *
     * Generated from protobuf field <code>string orchestration_cluster = 5 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setOrchestrationCluster($var)
    {
        GPBUtil::checkString($var, True);
        $this->orchestration_cluster = $var;

        return $this;
    }

    /**
     * Output only. [Output only] Create time stamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. [Output only] Create time stamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. [Output only] Update time stamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. [Output only] Update time stamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Optional. Labels as key value pairs. The key and value should contain
     * characters which are UTF-8 compliant and less than 50 characters.
     *
     * Generated from protobuf field <code>map<string, string> labels = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Optional. Labels as key value pairs. The key and value should contain
     * characters which are UTF-8 compliant and less than 50 characters.
     *
     * Generated from protobuf field <code>map<string, string> labels = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * Output only. Provides the active TNA version for this resource.
     *
     * Generated from protobuf field <code>string tna_version = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getTnaVersion()
    {
        return $this->tna_version;
    }

    /**
     * Output only. Provides the active TNA version for this resource.
     *
     * Generated from protobuf field <code>string tna_version = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setTnaVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->tna_version = $var;

        return $this;
    }

    /**
     * Output only. State of the EdgeSlm resource.
     *
     * Generated from protobuf field <code>.google.cloud.telcoautomation.v1.EdgeSlm.State state = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. State of the EdgeSlm resource.
     *
     * Generated from protobuf field <code>.google.cloud.telcoautomation.v1.EdgeSlm.State state = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\TelcoAutomation\V1\EdgeSlm\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Optional. Type of workload cluster for which an EdgeSLM resource is
     * created.
     *
     * Generated from protobuf field <code>.google.cloud.telcoautomation.v1.EdgeSlm.WorkloadClusterType workload_cluster_type = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getWorkloadClusterType()
    {
        return $this->workload_cluster_type;
    }

    /**
     * Optional. Type of workload cluster for which an EdgeSLM resource is
     * created.
     *
     * Generated from protobuf field <code>.google.cloud.telcoautomation.v1.EdgeSlm.WorkloadClusterType workload_cluster_type = 8 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setWorkloadClusterType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\TelcoAutomation\V1\EdgeSlm\WorkloadClusterType::class);
        $this->workload_cluster_type = $var;

        return $this;
    }

}

