<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/telcoautomation/v1/telcoautomation.proto

namespace Google\Cloud\TelcoAutomation\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A collection of kubernetes yaml files which are deployed on a Workload
 * Cluster. Hydrated Deployments are created by TNA intent based automation.
 *
 * Generated from protobuf message <code>google.cloud.telcoautomation.v1.HydratedDeployment</code>
 */
class HydratedDeployment extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The name of the hydrated deployment.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $name = '';
    /**
     * Output only. State of the hydrated deployment (DRAFT, APPLIED).
     *
     * Generated from protobuf field <code>.google.cloud.telcoautomation.v1.HydratedDeployment.State state = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;
    /**
     * Optional. File contents of a hydrated deployment.
     * When invoking UpdateHydratedBlueprint API, only the modified files should
     * be included in this. Files that are not included in the update of a
     * hydrated deployment will not be changed.
     *
     * Generated from protobuf field <code>repeated .google.cloud.telcoautomation.v1.File files = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $files;
    /**
     * Output only. WorkloadCluster identifies which workload cluster will the
     * hydrated deployment will be deployed on.
     *
     * Generated from protobuf field <code>string workload_cluster = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $workload_cluster = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. The name of the hydrated deployment.
     *     @type int $state
     *           Output only. State of the hydrated deployment (DRAFT, APPLIED).
     *     @type array<\Google\Cloud\TelcoAutomation\V1\File>|\Google\Protobuf\Internal\RepeatedField $files
     *           Optional. File contents of a hydrated deployment.
     *           When invoking UpdateHydratedBlueprint API, only the modified files should
     *           be included in this. Files that are not included in the update of a
     *           hydrated deployment will not be changed.
     *     @type string $workload_cluster
     *           Output only. WorkloadCluster identifies which workload cluster will the
     *           hydrated deployment will be deployed on.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Telcoautomation\V1\Telcoautomation::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The name of the hydrated deployment.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. The name of the hydrated deployment.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. State of the hydrated deployment (DRAFT, APPLIED).
     *
     * Generated from protobuf field <code>.google.cloud.telcoautomation.v1.HydratedDeployment.State state = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. State of the hydrated deployment (DRAFT, APPLIED).
     *
     * Generated from protobuf field <code>.google.cloud.telcoautomation.v1.HydratedDeployment.State state = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\TelcoAutomation\V1\HydratedDeployment\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Optional. File contents of a hydrated deployment.
     * When invoking UpdateHydratedBlueprint API, only the modified files should
     * be included in this. Files that are not included in the update of a
     * hydrated deployment will not be changed.
     *
     * Generated from protobuf field <code>repeated .google.cloud.telcoautomation.v1.File files = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getFiles()
    {
        return $this->files;
    }

    /**
     * Optional. File contents of a hydrated deployment.
     * When invoking UpdateHydratedBlueprint API, only the modified files should
     * be included in this. Files that are not included in the update of a
     * hydrated deployment will not be changed.
     *
     * Generated from protobuf field <code>repeated .google.cloud.telcoautomation.v1.File files = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array<\Google\Cloud\TelcoAutomation\V1\File>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setFiles($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\TelcoAutomation\V1\File::class);
        $this->files = $arr;

        return $this;
    }

    /**
     * Output only. WorkloadCluster identifies which workload cluster will the
     * hydrated deployment will be deployed on.
     *
     * Generated from protobuf field <code>string workload_cluster = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getWorkloadCluster()
    {
        return $this->workload_cluster;
    }

    /**
     * Output only. WorkloadCluster identifies which workload cluster will the
     * hydrated deployment will be deployed on.
     *
     * Generated from protobuf field <code>string workload_cluster = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setWorkloadCluster($var)
    {
        GPBUtil::checkString($var, True);
        $this->workload_cluster = $var;

        return $this;
    }

}

