<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/telcoautomation/v1/telcoautomation.proto

namespace Google\Cloud\TelcoAutomation\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request object for `ListBlueprints`.
 *
 * Generated from protobuf message <code>google.cloud.telcoautomation.v1.ListBlueprintsRequest</code>
 */
class ListBlueprintsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of parent orchestration cluster resource.
     * Format should be -
     * "projects/{project_id}/locations/{location_name}/orchestrationClusters/{orchestration_cluster}".
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Optional. Filtering only supports equality on blueprint state.
     * It should be in the form: "state = DRAFT". `OR` operator can be used to
     * get response for multiple states. e.g. "state = DRAFT OR state = PROPOSED".
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $filter = '';
    /**
     * Optional. The maximum number of blueprints to return per page.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_size = 0;
    /**
     * Optional. The page token, received from a previous ListBlueprints call.
     * It can be provided to retrieve the subsequent page.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $page_token = '';

    /**
     * @param string $parent Required. The name of parent orchestration cluster resource.
     *                       Format should be -
     *                       "projects/{project_id}/locations/{location_name}/orchestrationClusters/{orchestration_cluster}". Please see
     *                       {@see TelcoAutomationClient::orchestrationClusterName()} for help formatting this field.
     *
     * @return \Google\Cloud\TelcoAutomation\V1\ListBlueprintsRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The name of parent orchestration cluster resource.
     *           Format should be -
     *           "projects/{project_id}/locations/{location_name}/orchestrationClusters/{orchestration_cluster}".
     *     @type string $filter
     *           Optional. Filtering only supports equality on blueprint state.
     *           It should be in the form: "state = DRAFT". `OR` operator can be used to
     *           get response for multiple states. e.g. "state = DRAFT OR state = PROPOSED".
     *     @type int $page_size
     *           Optional. The maximum number of blueprints to return per page.
     *     @type string $page_token
     *           Optional. The page token, received from a previous ListBlueprints call.
     *           It can be provided to retrieve the subsequent page.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Telcoautomation\V1\Telcoautomation::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of parent orchestration cluster resource.
     * Format should be -
     * "projects/{project_id}/locations/{location_name}/orchestrationClusters/{orchestration_cluster}".
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The name of parent orchestration cluster resource.
     * Format should be -
     * "projects/{project_id}/locations/{location_name}/orchestrationClusters/{orchestration_cluster}".
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Optional. Filtering only supports equality on blueprint state.
     * It should be in the form: "state = DRAFT". `OR` operator can be used to
     * get response for multiple states. e.g. "state = DRAFT OR state = PROPOSED".
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * Optional. Filtering only supports equality on blueprint state.
     * It should be in the form: "state = DRAFT". `OR` operator can be used to
     * get response for multiple states. e.g. "state = DRAFT OR state = PROPOSED".
     *
     * Generated from protobuf field <code>string filter = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * Optional. The maximum number of blueprints to return per page.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Optional. The maximum number of blueprints to return per page.
     *
     * Generated from protobuf field <code>int32 page_size = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Optional. The page token, received from a previous ListBlueprints call.
     * It can be provided to retrieve the subsequent page.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Optional. The page token, received from a previous ListBlueprints call.
     * It can be provided to retrieve the subsequent page.
     *
     * Generated from protobuf field <code>string page_token = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

