<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/telcoautomation/v1/telcoautomation.proto

namespace Google\Cloud\TelcoAutomation\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Orchestration cluster represents a GKE cluster with config controller and
 * TNA specific components installed on it.
 *
 * Generated from protobuf message <code>google.cloud.telcoautomation.v1.OrchestrationCluster</code>
 */
class OrchestrationCluster extends \Google\Protobuf\Internal\Message
{
    /**
     * Name of the orchestration cluster. The name of orchestration cluster cannot
     * be more than 24 characters.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     */
    protected $name = '';
    /**
     * Management configuration of the underlying GKE cluster.
     *
     * Generated from protobuf field <code>.google.cloud.telcoautomation.v1.ManagementConfig management_config = 5;</code>
     */
    protected $management_config = null;
    /**
     * Output only. [Output only] Create time stamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $create_time = null;
    /**
     * Output only. [Output only] Update time stamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $update_time = null;
    /**
     * Labels as key value pairs.
     *
     * Generated from protobuf field <code>map<string, string> labels = 4;</code>
     */
    private $labels;
    /**
     * Output only. Provides the TNA version installed on the cluster.
     *
     * Generated from protobuf field <code>string tna_version = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $tna_version = '';
    /**
     * Output only. State of the Orchestration Cluster.
     *
     * Generated from protobuf field <code>.google.cloud.telcoautomation.v1.OrchestrationCluster.State state = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $state = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Name of the orchestration cluster. The name of orchestration cluster cannot
     *           be more than 24 characters.
     *     @type \Google\Cloud\TelcoAutomation\V1\ManagementConfig $management_config
     *           Management configuration of the underlying GKE cluster.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. [Output only] Create time stamp.
     *     @type \Google\Protobuf\Timestamp $update_time
     *           Output only. [Output only] Update time stamp.
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Labels as key value pairs.
     *     @type string $tna_version
     *           Output only. Provides the TNA version installed on the cluster.
     *     @type int $state
     *           Output only. State of the Orchestration Cluster.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Telcoautomation\V1\Telcoautomation::initOnce();
        parent::__construct($data);
    }

    /**
     * Name of the orchestration cluster. The name of orchestration cluster cannot
     * be more than 24 characters.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Name of the orchestration cluster. The name of orchestration cluster cannot
     * be more than 24 characters.
     *
     * Generated from protobuf field <code>string name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Management configuration of the underlying GKE cluster.
     *
     * Generated from protobuf field <code>.google.cloud.telcoautomation.v1.ManagementConfig management_config = 5;</code>
     * @return \Google\Cloud\TelcoAutomation\V1\ManagementConfig|null
     */
    public function getManagementConfig()
    {
        return $this->management_config;
    }

    public function hasManagementConfig()
    {
        return isset($this->management_config);
    }

    public function clearManagementConfig()
    {
        unset($this->management_config);
    }

    /**
     * Management configuration of the underlying GKE cluster.
     *
     * Generated from protobuf field <code>.google.cloud.telcoautomation.v1.ManagementConfig management_config = 5;</code>
     * @param \Google\Cloud\TelcoAutomation\V1\ManagementConfig $var
     * @return $this
     */
    public function setManagementConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\TelcoAutomation\V1\ManagementConfig::class);
        $this->management_config = $var;

        return $this;
    }

    /**
     * Output only. [Output only] Create time stamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. [Output only] Create time stamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * Output only. [Output only] Update time stamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getUpdateTime()
    {
        return $this->update_time;
    }

    public function hasUpdateTime()
    {
        return isset($this->update_time);
    }

    public function clearUpdateTime()
    {
        unset($this->update_time);
    }

    /**
     * Output only. [Output only] Update time stamp.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp update_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setUpdateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->update_time = $var;

        return $this;
    }

    /**
     * Labels as key value pairs.
     *
     * Generated from protobuf field <code>map<string, string> labels = 4;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Labels as key value pairs.
     *
     * Generated from protobuf field <code>map<string, string> labels = 4;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * Output only. Provides the TNA version installed on the cluster.
     *
     * Generated from protobuf field <code>string tna_version = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getTnaVersion()
    {
        return $this->tna_version;
    }

    /**
     * Output only. Provides the TNA version installed on the cluster.
     *
     * Generated from protobuf field <code>string tna_version = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setTnaVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->tna_version = $var;

        return $this;
    }

    /**
     * Output only. State of the Orchestration Cluster.
     *
     * Generated from protobuf field <code>.google.cloud.telcoautomation.v1.OrchestrationCluster.State state = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. State of the Orchestration Cluster.
     *
     * Generated from protobuf field <code>.google.cloud.telcoautomation.v1.OrchestrationCluster.State state = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\TelcoAutomation\V1\OrchestrationCluster\State::class);
        $this->state = $var;

        return $this;
    }

}

