<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/tpu/v2/cloud_tpu.proto

namespace Google\Cloud\Tpu\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A TPU instance.
 *
 * Generated from protobuf message <code>google.cloud.tpu.v2.Node</code>
 */
class Node extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. Immutable. The name of the TPU.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     */
    private $name = '';
    /**
     * The user-supplied description of the TPU. Maximum of 512 characters.
     *
     * Generated from protobuf field <code>string description = 3;</code>
     */
    private $description = '';
    /**
     * Optional. The type of hardware accelerators associated with this node.
     *
     * Generated from protobuf field <code>string accelerator_type = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $accelerator_type = '';
    /**
     * Output only. The current state for the TPU Node.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.Node.State state = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $state = 0;
    /**
     * Output only. If this field is populated, it contains a description of why
     * the TPU Node is unhealthy.
     *
     * Generated from protobuf field <code>string health_description = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $health_description = '';
    /**
     * Required. The runtime version running in the Node.
     *
     * Generated from protobuf field <code>string runtime_version = 11 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $runtime_version = '';
    /**
     * Network configurations for the TPU node.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.NetworkConfig network_config = 36;</code>
     */
    private $network_config = null;
    /**
     * The CIDR block that the TPU node will use when selecting an IP address.
     * This CIDR block must be a /29 block; the Compute Engine networks API
     * forbids a smaller block, and using a larger block would be wasteful (a
     * node can only consume one IP address). Errors will occur if the CIDR block
     * has already been used for a currently existing TPU node, the CIDR block
     * conflicts with any subnetworks in the user's provided network, or the
     * provided network is peered with another network that is using that CIDR
     * block.
     *
     * Generated from protobuf field <code>string cidr_block = 13;</code>
     */
    private $cidr_block = '';
    /**
     * The Google Cloud Platform Service Account to be used by the TPU node VMs.
     * If None is specified, the default compute service account will be used.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.ServiceAccount service_account = 37;</code>
     */
    private $service_account = null;
    /**
     * Output only. The time when the node was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 16 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $create_time = null;
    /**
     * The scheduling options for this node.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.SchedulingConfig scheduling_config = 17;</code>
     */
    private $scheduling_config = null;
    /**
     * Output only. The network endpoints where TPU workers can be accessed and
     * sent work. It is recommended that runtime clients of the node reach out
     * to the 0th entry in this map first.
     *
     * Generated from protobuf field <code>repeated .google.cloud.tpu.v2.NetworkEndpoint network_endpoints = 21 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $network_endpoints;
    /**
     * The health status of the TPU node.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.Node.Health health = 22;</code>
     */
    private $health = 0;
    /**
     * Resource labels to represent user-provided metadata.
     *
     * Generated from protobuf field <code>map<string, string> labels = 24;</code>
     */
    private $labels;
    /**
     * Custom metadata to apply to the TPU Node.
     * Can set startup-script and shutdown-script
     *
     * Generated from protobuf field <code>map<string, string> metadata = 34;</code>
     */
    private $metadata;
    /**
     * Tags to apply to the TPU Node. Tags are used to identify valid sources or
     * targets for network firewalls.
     *
     * Generated from protobuf field <code>repeated string tags = 40;</code>
     */
    private $tags;
    /**
     * Output only. The unique identifier for the TPU Node.
     *
     * Generated from protobuf field <code>int64 id = 33 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $id = 0;
    /**
     * The additional data disks for the Node.
     *
     * Generated from protobuf field <code>repeated .google.cloud.tpu.v2.AttachedDisk data_disks = 41;</code>
     */
    private $data_disks;
    /**
     * Output only. The API version that created this Node.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.Node.ApiVersion api_version = 38 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $api_version = 0;
    /**
     * Output only. The Symptoms that have occurred to the TPU Node.
     *
     * Generated from protobuf field <code>repeated .google.cloud.tpu.v2.Symptom symptoms = 39 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $symptoms;
    /**
     * Shielded Instance options.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.ShieldedInstanceConfig shielded_instance_config = 45;</code>
     */
    private $shielded_instance_config = null;
    /**
     * The AccleratorConfig for the TPU Node.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.AcceleratorConfig accelerator_config = 46;</code>
     */
    private $accelerator_config = null;
    /**
     * Output only. The qualified name of the QueuedResource that requested this
     * Node.
     *
     * Generated from protobuf field <code>string queued_resource = 47 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $queued_resource = '';
    /**
     * Output only. Whether the Node belongs to a Multislice group.
     *
     * Generated from protobuf field <code>bool multislice_node = 48 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $multislice_node = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. Immutable. The name of the TPU.
     *     @type string $description
     *           The user-supplied description of the TPU. Maximum of 512 characters.
     *     @type string $accelerator_type
     *           Optional. The type of hardware accelerators associated with this node.
     *     @type int $state
     *           Output only. The current state for the TPU Node.
     *     @type string $health_description
     *           Output only. If this field is populated, it contains a description of why
     *           the TPU Node is unhealthy.
     *     @type string $runtime_version
     *           Required. The runtime version running in the Node.
     *     @type \Google\Cloud\Tpu\V2\NetworkConfig $network_config
     *           Network configurations for the TPU node.
     *     @type string $cidr_block
     *           The CIDR block that the TPU node will use when selecting an IP address.
     *           This CIDR block must be a /29 block; the Compute Engine networks API
     *           forbids a smaller block, and using a larger block would be wasteful (a
     *           node can only consume one IP address). Errors will occur if the CIDR block
     *           has already been used for a currently existing TPU node, the CIDR block
     *           conflicts with any subnetworks in the user's provided network, or the
     *           provided network is peered with another network that is using that CIDR
     *           block.
     *     @type \Google\Cloud\Tpu\V2\ServiceAccount $service_account
     *           The Google Cloud Platform Service Account to be used by the TPU node VMs.
     *           If None is specified, the default compute service account will be used.
     *     @type \Google\Protobuf\Timestamp $create_time
     *           Output only. The time when the node was created.
     *     @type \Google\Cloud\Tpu\V2\SchedulingConfig $scheduling_config
     *           The scheduling options for this node.
     *     @type array<\Google\Cloud\Tpu\V2\NetworkEndpoint>|\Google\Protobuf\Internal\RepeatedField $network_endpoints
     *           Output only. The network endpoints where TPU workers can be accessed and
     *           sent work. It is recommended that runtime clients of the node reach out
     *           to the 0th entry in this map first.
     *     @type int $health
     *           The health status of the TPU node.
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Resource labels to represent user-provided metadata.
     *     @type array|\Google\Protobuf\Internal\MapField $metadata
     *           Custom metadata to apply to the TPU Node.
     *           Can set startup-script and shutdown-script
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $tags
     *           Tags to apply to the TPU Node. Tags are used to identify valid sources or
     *           targets for network firewalls.
     *     @type int|string $id
     *           Output only. The unique identifier for the TPU Node.
     *     @type array<\Google\Cloud\Tpu\V2\AttachedDisk>|\Google\Protobuf\Internal\RepeatedField $data_disks
     *           The additional data disks for the Node.
     *     @type int $api_version
     *           Output only. The API version that created this Node.
     *     @type array<\Google\Cloud\Tpu\V2\Symptom>|\Google\Protobuf\Internal\RepeatedField $symptoms
     *           Output only. The Symptoms that have occurred to the TPU Node.
     *     @type \Google\Cloud\Tpu\V2\ShieldedInstanceConfig $shielded_instance_config
     *           Shielded Instance options.
     *     @type \Google\Cloud\Tpu\V2\AcceleratorConfig $accelerator_config
     *           The AccleratorConfig for the TPU Node.
     *     @type string $queued_resource
     *           Output only. The qualified name of the QueuedResource that requested this
     *           Node.
     *     @type bool $multislice_node
     *           Output only. Whether the Node belongs to a Multislice group.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Tpu\V2\CloudTpu::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. Immutable. The name of the TPU.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. Immutable. The name of the TPU.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The user-supplied description of the TPU. Maximum of 512 characters.
     *
     * Generated from protobuf field <code>string description = 3;</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * The user-supplied description of the TPU. Maximum of 512 characters.
     *
     * Generated from protobuf field <code>string description = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Optional. The type of hardware accelerators associated with this node.
     *
     * Generated from protobuf field <code>string accelerator_type = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getAcceleratorType()
    {
        return $this->accelerator_type;
    }

    /**
     * Optional. The type of hardware accelerators associated with this node.
     *
     * Generated from protobuf field <code>string accelerator_type = 5 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setAcceleratorType($var)
    {
        GPBUtil::checkString($var, True);
        $this->accelerator_type = $var;

        return $this;
    }

    /**
     * Output only. The current state for the TPU Node.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.Node.State state = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. The current state for the TPU Node.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.Node.State state = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Tpu\V2\Node\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Output only. If this field is populated, it contains a description of why
     * the TPU Node is unhealthy.
     *
     * Generated from protobuf field <code>string health_description = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getHealthDescription()
    {
        return $this->health_description;
    }

    /**
     * Output only. If this field is populated, it contains a description of why
     * the TPU Node is unhealthy.
     *
     * Generated from protobuf field <code>string health_description = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setHealthDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->health_description = $var;

        return $this;
    }

    /**
     * Required. The runtime version running in the Node.
     *
     * Generated from protobuf field <code>string runtime_version = 11 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getRuntimeVersion()
    {
        return $this->runtime_version;
    }

    /**
     * Required. The runtime version running in the Node.
     *
     * Generated from protobuf field <code>string runtime_version = 11 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setRuntimeVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->runtime_version = $var;

        return $this;
    }

    /**
     * Network configurations for the TPU node.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.NetworkConfig network_config = 36;</code>
     * @return \Google\Cloud\Tpu\V2\NetworkConfig|null
     */
    public function getNetworkConfig()
    {
        return $this->network_config;
    }

    public function hasNetworkConfig()
    {
        return isset($this->network_config);
    }

    public function clearNetworkConfig()
    {
        unset($this->network_config);
    }

    /**
     * Network configurations for the TPU node.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.NetworkConfig network_config = 36;</code>
     * @param \Google\Cloud\Tpu\V2\NetworkConfig $var
     * @return $this
     */
    public function setNetworkConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Tpu\V2\NetworkConfig::class);
        $this->network_config = $var;

        return $this;
    }

    /**
     * The CIDR block that the TPU node will use when selecting an IP address.
     * This CIDR block must be a /29 block; the Compute Engine networks API
     * forbids a smaller block, and using a larger block would be wasteful (a
     * node can only consume one IP address). Errors will occur if the CIDR block
     * has already been used for a currently existing TPU node, the CIDR block
     * conflicts with any subnetworks in the user's provided network, or the
     * provided network is peered with another network that is using that CIDR
     * block.
     *
     * Generated from protobuf field <code>string cidr_block = 13;</code>
     * @return string
     */
    public function getCidrBlock()
    {
        return $this->cidr_block;
    }

    /**
     * The CIDR block that the TPU node will use when selecting an IP address.
     * This CIDR block must be a /29 block; the Compute Engine networks API
     * forbids a smaller block, and using a larger block would be wasteful (a
     * node can only consume one IP address). Errors will occur if the CIDR block
     * has already been used for a currently existing TPU node, the CIDR block
     * conflicts with any subnetworks in the user's provided network, or the
     * provided network is peered with another network that is using that CIDR
     * block.
     *
     * Generated from protobuf field <code>string cidr_block = 13;</code>
     * @param string $var
     * @return $this
     */
    public function setCidrBlock($var)
    {
        GPBUtil::checkString($var, True);
        $this->cidr_block = $var;

        return $this;
    }

    /**
     * The Google Cloud Platform Service Account to be used by the TPU node VMs.
     * If None is specified, the default compute service account will be used.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.ServiceAccount service_account = 37;</code>
     * @return \Google\Cloud\Tpu\V2\ServiceAccount|null
     */
    public function getServiceAccount()
    {
        return $this->service_account;
    }

    public function hasServiceAccount()
    {
        return isset($this->service_account);
    }

    public function clearServiceAccount()
    {
        unset($this->service_account);
    }

    /**
     * The Google Cloud Platform Service Account to be used by the TPU node VMs.
     * If None is specified, the default compute service account will be used.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.ServiceAccount service_account = 37;</code>
     * @param \Google\Cloud\Tpu\V2\ServiceAccount $var
     * @return $this
     */
    public function setServiceAccount($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Tpu\V2\ServiceAccount::class);
        $this->service_account = $var;

        return $this;
    }

    /**
     * Output only. The time when the node was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 16 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getCreateTime()
    {
        return $this->create_time;
    }

    public function hasCreateTime()
    {
        return isset($this->create_time);
    }

    public function clearCreateTime()
    {
        unset($this->create_time);
    }

    /**
     * Output only. The time when the node was created.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp create_time = 16 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->create_time = $var;

        return $this;
    }

    /**
     * The scheduling options for this node.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.SchedulingConfig scheduling_config = 17;</code>
     * @return \Google\Cloud\Tpu\V2\SchedulingConfig|null
     */
    public function getSchedulingConfig()
    {
        return $this->scheduling_config;
    }

    public function hasSchedulingConfig()
    {
        return isset($this->scheduling_config);
    }

    public function clearSchedulingConfig()
    {
        unset($this->scheduling_config);
    }

    /**
     * The scheduling options for this node.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.SchedulingConfig scheduling_config = 17;</code>
     * @param \Google\Cloud\Tpu\V2\SchedulingConfig $var
     * @return $this
     */
    public function setSchedulingConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Tpu\V2\SchedulingConfig::class);
        $this->scheduling_config = $var;

        return $this;
    }

    /**
     * Output only. The network endpoints where TPU workers can be accessed and
     * sent work. It is recommended that runtime clients of the node reach out
     * to the 0th entry in this map first.
     *
     * Generated from protobuf field <code>repeated .google.cloud.tpu.v2.NetworkEndpoint network_endpoints = 21 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getNetworkEndpoints()
    {
        return $this->network_endpoints;
    }

    /**
     * Output only. The network endpoints where TPU workers can be accessed and
     * sent work. It is recommended that runtime clients of the node reach out
     * to the 0th entry in this map first.
     *
     * Generated from protobuf field <code>repeated .google.cloud.tpu.v2.NetworkEndpoint network_endpoints = 21 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param array<\Google\Cloud\Tpu\V2\NetworkEndpoint>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setNetworkEndpoints($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Tpu\V2\NetworkEndpoint::class);
        $this->network_endpoints = $arr;

        return $this;
    }

    /**
     * The health status of the TPU node.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.Node.Health health = 22;</code>
     * @return int
     */
    public function getHealth()
    {
        return $this->health;
    }

    /**
     * The health status of the TPU node.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.Node.Health health = 22;</code>
     * @param int $var
     * @return $this
     */
    public function setHealth($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Tpu\V2\Node\Health::class);
        $this->health = $var;

        return $this;
    }

    /**
     * Resource labels to represent user-provided metadata.
     *
     * Generated from protobuf field <code>map<string, string> labels = 24;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Resource labels to represent user-provided metadata.
     *
     * Generated from protobuf field <code>map<string, string> labels = 24;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * Custom metadata to apply to the TPU Node.
     * Can set startup-script and shutdown-script
     *
     * Generated from protobuf field <code>map<string, string> metadata = 34;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getMetadata()
    {
        return $this->metadata;
    }

    /**
     * Custom metadata to apply to the TPU Node.
     * Can set startup-script and shutdown-script
     *
     * Generated from protobuf field <code>map<string, string> metadata = 34;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setMetadata($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->metadata = $arr;

        return $this;
    }

    /**
     * Tags to apply to the TPU Node. Tags are used to identify valid sources or
     * targets for network firewalls.
     *
     * Generated from protobuf field <code>repeated string tags = 40;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getTags()
    {
        return $this->tags;
    }

    /**
     * Tags to apply to the TPU Node. Tags are used to identify valid sources or
     * targets for network firewalls.
     *
     * Generated from protobuf field <code>repeated string tags = 40;</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setTags($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->tags = $arr;

        return $this;
    }

    /**
     * Output only. The unique identifier for the TPU Node.
     *
     * Generated from protobuf field <code>int64 id = 33 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int|string
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Output only. The unique identifier for the TPU Node.
     *
     * Generated from protobuf field <code>int64 id = 33 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int|string $var
     * @return $this
     */
    public function setId($var)
    {
        GPBUtil::checkInt64($var);
        $this->id = $var;

        return $this;
    }

    /**
     * The additional data disks for the Node.
     *
     * Generated from protobuf field <code>repeated .google.cloud.tpu.v2.AttachedDisk data_disks = 41;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getDataDisks()
    {
        return $this->data_disks;
    }

    /**
     * The additional data disks for the Node.
     *
     * Generated from protobuf field <code>repeated .google.cloud.tpu.v2.AttachedDisk data_disks = 41;</code>
     * @param array<\Google\Cloud\Tpu\V2\AttachedDisk>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setDataDisks($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Tpu\V2\AttachedDisk::class);
        $this->data_disks = $arr;

        return $this;
    }

    /**
     * Output only. The API version that created this Node.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.Node.ApiVersion api_version = 38 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getApiVersion()
    {
        return $this->api_version;
    }

    /**
     * Output only. The API version that created this Node.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.Node.ApiVersion api_version = 38 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setApiVersion($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Tpu\V2\Node\ApiVersion::class);
        $this->api_version = $var;

        return $this;
    }

    /**
     * Output only. The Symptoms that have occurred to the TPU Node.
     *
     * Generated from protobuf field <code>repeated .google.cloud.tpu.v2.Symptom symptoms = 39 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSymptoms()
    {
        return $this->symptoms;
    }

    /**
     * Output only. The Symptoms that have occurred to the TPU Node.
     *
     * Generated from protobuf field <code>repeated .google.cloud.tpu.v2.Symptom symptoms = 39 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param array<\Google\Cloud\Tpu\V2\Symptom>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSymptoms($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Tpu\V2\Symptom::class);
        $this->symptoms = $arr;

        return $this;
    }

    /**
     * Shielded Instance options.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.ShieldedInstanceConfig shielded_instance_config = 45;</code>
     * @return \Google\Cloud\Tpu\V2\ShieldedInstanceConfig|null
     */
    public function getShieldedInstanceConfig()
    {
        return $this->shielded_instance_config;
    }

    public function hasShieldedInstanceConfig()
    {
        return isset($this->shielded_instance_config);
    }

    public function clearShieldedInstanceConfig()
    {
        unset($this->shielded_instance_config);
    }

    /**
     * Shielded Instance options.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.ShieldedInstanceConfig shielded_instance_config = 45;</code>
     * @param \Google\Cloud\Tpu\V2\ShieldedInstanceConfig $var
     * @return $this
     */
    public function setShieldedInstanceConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Tpu\V2\ShieldedInstanceConfig::class);
        $this->shielded_instance_config = $var;

        return $this;
    }

    /**
     * The AccleratorConfig for the TPU Node.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.AcceleratorConfig accelerator_config = 46;</code>
     * @return \Google\Cloud\Tpu\V2\AcceleratorConfig|null
     */
    public function getAcceleratorConfig()
    {
        return $this->accelerator_config;
    }

    public function hasAcceleratorConfig()
    {
        return isset($this->accelerator_config);
    }

    public function clearAcceleratorConfig()
    {
        unset($this->accelerator_config);
    }

    /**
     * The AccleratorConfig for the TPU Node.
     *
     * Generated from protobuf field <code>.google.cloud.tpu.v2.AcceleratorConfig accelerator_config = 46;</code>
     * @param \Google\Cloud\Tpu\V2\AcceleratorConfig $var
     * @return $this
     */
    public function setAcceleratorConfig($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Tpu\V2\AcceleratorConfig::class);
        $this->accelerator_config = $var;

        return $this;
    }

    /**
     * Output only. The qualified name of the QueuedResource that requested this
     * Node.
     *
     * Generated from protobuf field <code>string queued_resource = 47 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getQueuedResource()
    {
        return $this->queued_resource;
    }

    /**
     * Output only. The qualified name of the QueuedResource that requested this
     * Node.
     *
     * Generated from protobuf field <code>string queued_resource = 47 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setQueuedResource($var)
    {
        GPBUtil::checkString($var, True);
        $this->queued_resource = $var;

        return $this;
    }

    /**
     * Output only. Whether the Node belongs to a Multislice group.
     *
     * Generated from protobuf field <code>bool multislice_node = 48 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return bool
     */
    public function getMultisliceNode()
    {
        return $this->multislice_node;
    }

    /**
     * Output only. Whether the Node belongs to a Multislice group.
     *
     * Generated from protobuf field <code>bool multislice_node = 48 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param bool $var
     * @return $this
     */
    public function setMultisliceNode($var)
    {
        GPBUtil::checkBool($var);
        $this->multislice_node = $var;

        return $this;
    }

}

