<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/video/livestream/v1/service.proto

namespace Google\Cloud\Video\LiveStream\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for "LivestreamService.CreateClip".
 *
 * Generated from protobuf message <code>google.cloud.video.livestream.v1.CreateClipRequest</code>
 */
class CreateClipRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent resource name, in the following form:
     * `projects/{project}/locations/{location}/channels/{channel}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. Id of the requesting object in the following form:
     * 1. 1 character minimum, 63 characters maximum
     * 2. Only contains letters, digits, underscores, and hyphens
     *
     * Generated from protobuf field <code>string clip_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $clip_id = '';
    /**
     * Required. The resource being created
     *
     * Generated from protobuf field <code>.google.cloud.video.livestream.v1.Clip clip = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $clip = null;
    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and
     * the request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $request_id = '';

    /**
     * @param string                                 $parent Required. The parent resource name, in the following form:
     *                                                       `projects/{project}/locations/{location}/channels/{channel}`. Please see
     *                                                       {@see LivestreamServiceClient::channelName()} for help formatting this field.
     * @param \Google\Cloud\Video\LiveStream\V1\Clip $clip   Required. The resource being created
     * @param string                                 $clipId Required. Id of the requesting object in the following form:
     *
     *                                                       1. 1 character minimum, 63 characters maximum
     *                                                       2. Only contains letters, digits, underscores, and hyphens
     *
     * @return \Google\Cloud\Video\LiveStream\V1\CreateClipRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\Video\LiveStream\V1\Clip $clip, string $clipId): self
    {
        return (new self())
            ->setParent($parent)
            ->setClip($clip)
            ->setClipId($clipId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent resource name, in the following form:
     *           `projects/{project}/locations/{location}/channels/{channel}`.
     *     @type string $clip_id
     *           Required. Id of the requesting object in the following form:
     *           1. 1 character minimum, 63 characters maximum
     *           2. Only contains letters, digits, underscores, and hyphens
     *     @type \Google\Cloud\Video\LiveStream\V1\Clip $clip
     *           Required. The resource being created
     *     @type string $request_id
     *           Optional. An optional request ID to identify requests. Specify a unique
     *           request ID so that if you must retry your request, the server will know to
     *           ignore the request if it has already been completed. The server will
     *           guarantee that for at least 60 minutes since the first request.
     *           For example, consider a situation where you make an initial request and
     *           the request times out. If you make the request again with the same request
     *           ID, the server can check if original operation with the same request ID
     *           was received, and if so, will ignore the second request. This prevents
     *           clients from accidentally creating duplicate commitments.
     *           The request ID must be a valid UUID with the exception that zero UUID is
     *           not supported (00000000-0000-0000-0000-000000000000).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Video\Livestream\V1\Service::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent resource name, in the following form:
     * `projects/{project}/locations/{location}/channels/{channel}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent resource name, in the following form:
     * `projects/{project}/locations/{location}/channels/{channel}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. Id of the requesting object in the following form:
     * 1. 1 character minimum, 63 characters maximum
     * 2. Only contains letters, digits, underscores, and hyphens
     *
     * Generated from protobuf field <code>string clip_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getClipId()
    {
        return $this->clip_id;
    }

    /**
     * Required. Id of the requesting object in the following form:
     * 1. 1 character minimum, 63 characters maximum
     * 2. Only contains letters, digits, underscores, and hyphens
     *
     * Generated from protobuf field <code>string clip_id = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setClipId($var)
    {
        GPBUtil::checkString($var, True);
        $this->clip_id = $var;

        return $this;
    }

    /**
     * Required. The resource being created
     *
     * Generated from protobuf field <code>.google.cloud.video.livestream.v1.Clip clip = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\Video\LiveStream\V1\Clip|null
     */
    public function getClip()
    {
        return $this->clip;
    }

    public function hasClip()
    {
        return isset($this->clip);
    }

    public function clearClip()
    {
        unset($this->clip);
    }

    /**
     * Required. The resource being created
     *
     * Generated from protobuf field <code>.google.cloud.video.livestream.v1.Clip clip = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\Video\LiveStream\V1\Clip $var
     * @return $this
     */
    public function setClip($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Video\LiveStream\V1\Clip::class);
        $this->clip = $var;

        return $this;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and
     * the request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getRequestId()
    {
        return $this->request_id;
    }

    /**
     * Optional. An optional request ID to identify requests. Specify a unique
     * request ID so that if you must retry your request, the server will know to
     * ignore the request if it has already been completed. The server will
     * guarantee that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and
     * the request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 4 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setRequestId($var)
    {
        GPBUtil::checkString($var, True);
        $this->request_id = $var;

        return $this;
    }

}

