<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/video/livestream/v1/service.proto

namespace Google\Cloud\Video\LiveStream\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for "LivestreamService.CreateEvent".
 *
 * Generated from protobuf message <code>google.cloud.video.livestream.v1.CreateEventRequest</code>
 */
class CreateEventRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The parent channel for the resource, in the form of:
     * `projects/{project}/locations/{location}/channels/{channelId}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * Required. The event resource to be created.
     *
     * Generated from protobuf field <code>.google.cloud.video.livestream.v1.Event event = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $event = null;
    /**
     * Required. The ID of the event resource to be created.
     * This value must be 1-63 characters, begin and end with `[a-z0-9]`,
     * could contain dashes (-) in between.
     *
     * Generated from protobuf field <code>string event_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $event_id = '';
    /**
     * A request ID to identify requests. Specify a unique request ID
     * so that if you must retry your request, the server will know to ignore
     * the request if it has already been completed. The server will guarantee
     * that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request ID,
     * the server can check if original operation with the same request ID was
     * received, and if so, will ignore the second request. This prevents clients
     * from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported `(00000000-0000-0000-0000-000000000000)`.
     *
     * Generated from protobuf field <code>string request_id = 4;</code>
     */
    protected $request_id = '';

    /**
     * @param string                                  $parent  Required. The parent channel for the resource, in the form of:
     *                                                         `projects/{project}/locations/{location}/channels/{channelId}`. Please see
     *                                                         {@see LivestreamServiceClient::channelName()} for help formatting this field.
     * @param \Google\Cloud\Video\LiveStream\V1\Event $event   Required. The event resource to be created.
     * @param string                                  $eventId Required. The ID of the event resource to be created.
     *                                                         This value must be 1-63 characters, begin and end with `[a-z0-9]`,
     *                                                         could contain dashes (-) in between.
     *
     * @return \Google\Cloud\Video\LiveStream\V1\CreateEventRequest
     *
     * @experimental
     */
    public static function build(string $parent, \Google\Cloud\Video\LiveStream\V1\Event $event, string $eventId): self
    {
        return (new self())
            ->setParent($parent)
            ->setEvent($event)
            ->setEventId($eventId);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The parent channel for the resource, in the form of:
     *           `projects/{project}/locations/{location}/channels/{channelId}`.
     *     @type \Google\Cloud\Video\LiveStream\V1\Event $event
     *           Required. The event resource to be created.
     *     @type string $event_id
     *           Required. The ID of the event resource to be created.
     *           This value must be 1-63 characters, begin and end with `[a-z0-9]`,
     *           could contain dashes (-) in between.
     *     @type string $request_id
     *           A request ID to identify requests. Specify a unique request ID
     *           so that if you must retry your request, the server will know to ignore
     *           the request if it has already been completed. The server will guarantee
     *           that for at least 60 minutes since the first request.
     *           For example, consider a situation where you make an initial request and the
     *           request times out. If you make the request again with the same request ID,
     *           the server can check if original operation with the same request ID was
     *           received, and if so, will ignore the second request. This prevents clients
     *           from accidentally creating duplicate commitments.
     *           The request ID must be a valid UUID with the exception that zero UUID is
     *           not supported `(00000000-0000-0000-0000-000000000000)`.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Video\Livestream\V1\Service::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The parent channel for the resource, in the form of:
     * `projects/{project}/locations/{location}/channels/{channelId}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The parent channel for the resource, in the form of:
     * `projects/{project}/locations/{location}/channels/{channelId}`.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The event resource to be created.
     *
     * Generated from protobuf field <code>.google.cloud.video.livestream.v1.Event event = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\Video\LiveStream\V1\Event|null
     */
    public function getEvent()
    {
        return $this->event;
    }

    public function hasEvent()
    {
        return isset($this->event);
    }

    public function clearEvent()
    {
        unset($this->event);
    }

    /**
     * Required. The event resource to be created.
     *
     * Generated from protobuf field <code>.google.cloud.video.livestream.v1.Event event = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\Video\LiveStream\V1\Event $var
     * @return $this
     */
    public function setEvent($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Video\LiveStream\V1\Event::class);
        $this->event = $var;

        return $this;
    }

    /**
     * Required. The ID of the event resource to be created.
     * This value must be 1-63 characters, begin and end with `[a-z0-9]`,
     * could contain dashes (-) in between.
     *
     * Generated from protobuf field <code>string event_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getEventId()
    {
        return $this->event_id;
    }

    /**
     * Required. The ID of the event resource to be created.
     * This value must be 1-63 characters, begin and end with `[a-z0-9]`,
     * could contain dashes (-) in between.
     *
     * Generated from protobuf field <code>string event_id = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setEventId($var)
    {
        GPBUtil::checkString($var, True);
        $this->event_id = $var;

        return $this;
    }

    /**
     * A request ID to identify requests. Specify a unique request ID
     * so that if you must retry your request, the server will know to ignore
     * the request if it has already been completed. The server will guarantee
     * that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request ID,
     * the server can check if original operation with the same request ID was
     * received, and if so, will ignore the second request. This prevents clients
     * from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported `(00000000-0000-0000-0000-000000000000)`.
     *
     * Generated from protobuf field <code>string request_id = 4;</code>
     * @return string
     */
    public function getRequestId()
    {
        return $this->request_id;
    }

    /**
     * A request ID to identify requests. Specify a unique request ID
     * so that if you must retry your request, the server will know to ignore
     * the request if it has already been completed. The server will guarantee
     * that for at least 60 minutes since the first request.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request ID,
     * the server can check if original operation with the same request ID was
     * received, and if so, will ignore the second request. This prevents clients
     * from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported `(00000000-0000-0000-0000-000000000000)`.
     *
     * Generated from protobuf field <code>string request_id = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setRequestId($var)
    {
        GPBUtil::checkString($var, True);
        $this->request_id = $var;

        return $this;
    }

}

