<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/vmwareengine/v1/vmwareengine_resources.proto

namespace Google\Cloud\VmwareEngine\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * DnsBindPermission resource that contains the accounts having the consumer DNS
 * bind permission on the corresponding intranet VPC of the consumer project.
 *
 * Generated from protobuf message <code>google.cloud.vmwareengine.v1.DnsBindPermission</code>
 */
class DnsBindPermission extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Output only. The name of the resource which stores the
     * users/service accounts having the permission to bind to the corresponding
     * intranet VPC of the consumer project. DnsBindPermission is a global
     * resource and location can only be global. Resource names are schemeless
     * URIs that follow the conventions in
     * https://cloud.google.com/apis/design/resource_names. For example:
     * `projects/my-project/locations/global/dnsBindPermission`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $name = '';
    /**
     * Output only. Users/Service accounts which have access for binding on the
     * intranet VPC project corresponding to the consumer project.
     *
     * Generated from protobuf field <code>repeated .google.cloud.vmwareengine.v1.Principal principals = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $principals;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. Output only. The name of the resource which stores the
     *           users/service accounts having the permission to bind to the corresponding
     *           intranet VPC of the consumer project. DnsBindPermission is a global
     *           resource and location can only be global. Resource names are schemeless
     *           URIs that follow the conventions in
     *           https://cloud.google.com/apis/design/resource_names. For example:
     *           `projects/my-project/locations/global/dnsBindPermission`
     *     @type array<\Google\Cloud\VmwareEngine\V1\Principal>|\Google\Protobuf\Internal\RepeatedField $principals
     *           Output only. Users/Service accounts which have access for binding on the
     *           intranet VPC project corresponding to the consumer project.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Vmwareengine\V1\VmwareengineResources::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Output only. The name of the resource which stores the
     * users/service accounts having the permission to bind to the corresponding
     * intranet VPC of the consumer project. DnsBindPermission is a global
     * resource and location can only be global. Resource names are schemeless
     * URIs that follow the conventions in
     * https://cloud.google.com/apis/design/resource_names. For example:
     * `projects/my-project/locations/global/dnsBindPermission`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. Output only. The name of the resource which stores the
     * users/service accounts having the permission to bind to the corresponding
     * intranet VPC of the consumer project. DnsBindPermission is a global
     * resource and location can only be global. Resource names are schemeless
     * URIs that follow the conventions in
     * https://cloud.google.com/apis/design/resource_names. For example:
     * `projects/my-project/locations/global/dnsBindPermission`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. Users/Service accounts which have access for binding on the
     * intranet VPC project corresponding to the consumer project.
     *
     * Generated from protobuf field <code>repeated .google.cloud.vmwareengine.v1.Principal principals = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getPrincipals()
    {
        return $this->principals;
    }

    /**
     * Output only. Users/Service accounts which have access for binding on the
     * intranet VPC project corresponding to the consumer project.
     *
     * Generated from protobuf field <code>repeated .google.cloud.vmwareengine.v1.Principal principals = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param array<\Google\Cloud\VmwareEngine\V1\Principal>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setPrincipals($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\VmwareEngine\V1\Principal::class);
        $this->principals = $arr;

        return $this;
    }

}

