<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/vmwareengine/v1/vmwareengine_resources.proto

namespace Google\Cloud\VmwareEngine\V1\ExternalAccessRule;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An IP range provided in any one of the supported formats.
 *
 * Generated from protobuf message <code>google.cloud.vmwareengine.v1.ExternalAccessRule.IpRange</code>
 */
class IpRange extends \Google\Protobuf\Internal\Message
{
    protected $ip_range;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $ip_address
     *           A single IP address. For example: `10.0.0.5`.
     *     @type string $ip_address_range
     *           An IP address range in the CIDR format. For example: `10.0.0.0/24`.
     *     @type string $external_address
     *           The name of an `ExternalAddress` resource. The external address must
     *           have been reserved in the scope of this external access rule's parent
     *           network policy.  Provide the external address name in the form of
     *           `projects/{project}/locations/{location}/privateClouds/{private_cloud}/externalAddresses/{external_address}`.
     *           For example:
     *           `projects/my-project/locations/us-central1-a/privateClouds/my-cloud/externalAddresses/my-address`.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Vmwareengine\V1\VmwareengineResources::initOnce();
        parent::__construct($data);
    }

    /**
     * A single IP address. For example: `10.0.0.5`.
     *
     * Generated from protobuf field <code>string ip_address = 1;</code>
     * @return string
     */
    public function getIpAddress()
    {
        return $this->readOneof(1);
    }

    public function hasIpAddress()
    {
        return $this->hasOneof(1);
    }

    /**
     * A single IP address. For example: `10.0.0.5`.
     *
     * Generated from protobuf field <code>string ip_address = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setIpAddress($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(1, $var);

        return $this;
    }

    /**
     * An IP address range in the CIDR format. For example: `10.0.0.0/24`.
     *
     * Generated from protobuf field <code>string ip_address_range = 2;</code>
     * @return string
     */
    public function getIpAddressRange()
    {
        return $this->readOneof(2);
    }

    public function hasIpAddressRange()
    {
        return $this->hasOneof(2);
    }

    /**
     * An IP address range in the CIDR format. For example: `10.0.0.0/24`.
     *
     * Generated from protobuf field <code>string ip_address_range = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setIpAddressRange($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     * The name of an `ExternalAddress` resource. The external address must
     * have been reserved in the scope of this external access rule's parent
     * network policy.  Provide the external address name in the form of
     * `projects/{project}/locations/{location}/privateClouds/{private_cloud}/externalAddresses/{external_address}`.
     * For example:
     * `projects/my-project/locations/us-central1-a/privateClouds/my-cloud/externalAddresses/my-address`.
     *
     * Generated from protobuf field <code>string external_address = 3 [(.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getExternalAddress()
    {
        return $this->readOneof(3);
    }

    public function hasExternalAddress()
    {
        return $this->hasOneof(3);
    }

    /**
     * The name of an `ExternalAddress` resource. The external address must
     * have been reserved in the scope of this external access rule's parent
     * network policy.  Provide the external address name in the form of
     * `projects/{project}/locations/{location}/privateClouds/{private_cloud}/externalAddresses/{external_address}`.
     * For example:
     * `projects/my-project/locations/us-central1-a/privateClouds/my-cloud/externalAddresses/my-address`.
     *
     * Generated from protobuf field <code>string external_address = 3 [(.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setExternalAddress($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(3, $var);

        return $this;
    }

    /**
     * @return string
     */
    public function getIpRange()
    {
        return $this->whichOneof("ip_range");
    }

}


