<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/vmwareengine/v1/vmwareengine.proto

namespace Google\Cloud\VmwareEngine\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [VmwareEngine.FetchNetworkPolicyExternalAddresses][google.cloud.vmwareengine.v1.VmwareEngine.FetchNetworkPolicyExternalAddresses]
 *
 * Generated from protobuf message <code>google.cloud.vmwareengine.v1.FetchNetworkPolicyExternalAddressesRequest</code>
 */
class FetchNetworkPolicyExternalAddressesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the network policy to query for assigned
     * external IP addresses. Resource names are schemeless URIs that follow the
     * conventions in https://cloud.google.com/apis/design/resource_names. For
     * example:
     * `projects/my-project/locations/us-central1/networkPolicies/my-policy`
     *
     * Generated from protobuf field <code>string network_policy = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $network_policy = '';
    /**
     * The maximum number of external IP addresses to return in one page.
     * The service may return fewer than this value.
     * The maximum value is coerced to 1000.
     * The default value of this field is 500.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     */
    protected $page_size = 0;
    /**
     * A page token, received from a previous
     * `FetchNetworkPolicyExternalAddresses` call. Provide this to retrieve the
     * subsequent page.
     * When paginating, all parameters provided to
     * `FetchNetworkPolicyExternalAddresses`, except for `page_size` and
     * `page_token`, must match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     */
    protected $page_token = '';

    /**
     * @param string $networkPolicy Required. The resource name of the network policy to query for assigned
     *                              external IP addresses. Resource names are schemeless URIs that follow the
     *                              conventions in https://cloud.google.com/apis/design/resource_names. For
     *                              example:
     *                              `projects/my-project/locations/us-central1/networkPolicies/my-policy`
     *                              Please see {@see VmwareEngineClient::networkPolicyName()} for help formatting this field.
     *
     * @return \Google\Cloud\VmwareEngine\V1\FetchNetworkPolicyExternalAddressesRequest
     *
     * @experimental
     */
    public static function build(string $networkPolicy): self
    {
        return (new self())
            ->setNetworkPolicy($networkPolicy);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $network_policy
     *           Required. The resource name of the network policy to query for assigned
     *           external IP addresses. Resource names are schemeless URIs that follow the
     *           conventions in https://cloud.google.com/apis/design/resource_names. For
     *           example:
     *           `projects/my-project/locations/us-central1/networkPolicies/my-policy`
     *     @type int $page_size
     *           The maximum number of external IP addresses to return in one page.
     *           The service may return fewer than this value.
     *           The maximum value is coerced to 1000.
     *           The default value of this field is 500.
     *     @type string $page_token
     *           A page token, received from a previous
     *           `FetchNetworkPolicyExternalAddresses` call. Provide this to retrieve the
     *           subsequent page.
     *           When paginating, all parameters provided to
     *           `FetchNetworkPolicyExternalAddresses`, except for `page_size` and
     *           `page_token`, must match the call that provided the page token.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Vmwareengine\V1\Vmwareengine::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the network policy to query for assigned
     * external IP addresses. Resource names are schemeless URIs that follow the
     * conventions in https://cloud.google.com/apis/design/resource_names. For
     * example:
     * `projects/my-project/locations/us-central1/networkPolicies/my-policy`
     *
     * Generated from protobuf field <code>string network_policy = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getNetworkPolicy()
    {
        return $this->network_policy;
    }

    /**
     * Required. The resource name of the network policy to query for assigned
     * external IP addresses. Resource names are schemeless URIs that follow the
     * conventions in https://cloud.google.com/apis/design/resource_names. For
     * example:
     * `projects/my-project/locations/us-central1/networkPolicies/my-policy`
     *
     * Generated from protobuf field <code>string network_policy = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setNetworkPolicy($var)
    {
        GPBUtil::checkString($var, True);
        $this->network_policy = $var;

        return $this;
    }

    /**
     * The maximum number of external IP addresses to return in one page.
     * The service may return fewer than this value.
     * The maximum value is coerced to 1000.
     * The default value of this field is 500.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The maximum number of external IP addresses to return in one page.
     * The service may return fewer than this value.
     * The maximum value is coerced to 1000.
     * The default value of this field is 500.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * A page token, received from a previous
     * `FetchNetworkPolicyExternalAddresses` call. Provide this to retrieve the
     * subsequent page.
     * When paginating, all parameters provided to
     * `FetchNetworkPolicyExternalAddresses`, except for `page_size` and
     * `page_token`, must match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * A page token, received from a previous
     * `FetchNetworkPolicyExternalAddresses` call. Provide this to retrieve the
     * subsequent page.
     * When paginating, all parameters provided to
     * `FetchNetworkPolicyExternalAddresses`, except for `page_size` and
     * `page_token`, must match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

