<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/vmwareengine/v1/vmwareengine.proto

namespace Google\Cloud\VmwareEngine\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [VmwareEngine.ListPeeringRoutes][google.cloud.vmwareengine.v1.VmwareEngine.ListPeeringRoutes]
 *
 * Generated from protobuf message <code>google.cloud.vmwareengine.v1.ListPeeringRoutesRequest</code>
 */
class ListPeeringRoutesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the network peering to retrieve peering
     * routes from. Resource names are schemeless URIs that follow the conventions
     * in https://cloud.google.com/apis/design/resource_names. For example:
     * `projects/my-project/locations/global/networkPeerings/my-peering`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $parent = '';
    /**
     * The maximum number of peering routes to return in one page.
     * The service may return fewer than this value.
     * The maximum value is coerced to 1000.
     * The default value of this field is 500.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     */
    protected $page_size = 0;
    /**
     * A page token, received from a previous `ListPeeringRoutes` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListPeeringRoutes` must
     * match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     */
    protected $page_token = '';
    /**
     * A filter expression that matches resources returned in the response.
     * Currently, only filtering on the `direction` field is supported. To return
     * routes imported from the peer network, provide "direction=INCOMING". To
     * return routes exported from the VMware Engine network, provide
     * "direction=OUTGOING". Other filter expressions return an error.
     *
     * Generated from protobuf field <code>string filter = 6;</code>
     */
    protected $filter = '';

    /**
     * @param string $parent Required. The resource name of the network peering to retrieve peering
     *                       routes from. Resource names are schemeless URIs that follow the conventions
     *                       in https://cloud.google.com/apis/design/resource_names. For example:
     *                       `projects/my-project/locations/global/networkPeerings/my-peering`
     *                       Please see {@see VmwareEngineClient::networkPeeringName()} for help formatting this field.
     *
     * @return \Google\Cloud\VmwareEngine\V1\ListPeeringRoutesRequest
     *
     * @experimental
     */
    public static function build(string $parent): self
    {
        return (new self())
            ->setParent($parent);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The resource name of the network peering to retrieve peering
     *           routes from. Resource names are schemeless URIs that follow the conventions
     *           in https://cloud.google.com/apis/design/resource_names. For example:
     *           `projects/my-project/locations/global/networkPeerings/my-peering`
     *     @type int $page_size
     *           The maximum number of peering routes to return in one page.
     *           The service may return fewer than this value.
     *           The maximum value is coerced to 1000.
     *           The default value of this field is 500.
     *     @type string $page_token
     *           A page token, received from a previous `ListPeeringRoutes` call.
     *           Provide this to retrieve the subsequent page.
     *           When paginating, all other parameters provided to `ListPeeringRoutes` must
     *           match the call that provided the page token.
     *     @type string $filter
     *           A filter expression that matches resources returned in the response.
     *           Currently, only filtering on the `direction` field is supported. To return
     *           routes imported from the peer network, provide "direction=INCOMING". To
     *           return routes exported from the VMware Engine network, provide
     *           "direction=OUTGOING". Other filter expressions return an error.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Vmwareengine\V1\Vmwareengine::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the network peering to retrieve peering
     * routes from. Resource names are schemeless URIs that follow the conventions
     * in https://cloud.google.com/apis/design/resource_names. For example:
     * `projects/my-project/locations/global/networkPeerings/my-peering`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The resource name of the network peering to retrieve peering
     * routes from. Resource names are schemeless URIs that follow the conventions
     * in https://cloud.google.com/apis/design/resource_names. For example:
     * `projects/my-project/locations/global/networkPeerings/my-peering`
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * The maximum number of peering routes to return in one page.
     * The service may return fewer than this value.
     * The maximum value is coerced to 1000.
     * The default value of this field is 500.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The maximum number of peering routes to return in one page.
     * The service may return fewer than this value.
     * The maximum value is coerced to 1000.
     * The default value of this field is 500.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * A page token, received from a previous `ListPeeringRoutes` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListPeeringRoutes` must
     * match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * A page token, received from a previous `ListPeeringRoutes` call.
     * Provide this to retrieve the subsequent page.
     * When paginating, all other parameters provided to `ListPeeringRoutes` must
     * match the call that provided the page token.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * A filter expression that matches resources returned in the response.
     * Currently, only filtering on the `direction` field is supported. To return
     * routes imported from the peer network, provide "direction=INCOMING". To
     * return routes exported from the VMware Engine network, provide
     * "direction=OUTGOING". Other filter expressions return an error.
     *
     * Generated from protobuf field <code>string filter = 6;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * A filter expression that matches resources returned in the response.
     * Currently, only filtering on the `direction` field is supported. To return
     * routes imported from the peer network, provide "direction=INCOMING". To
     * return routes exported from the VMware Engine network, provide
     * "direction=OUTGOING". Other filter expressions return an error.
     *
     * Generated from protobuf field <code>string filter = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

}

