<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/vmwareengine/v1/vmwareengine_resources.proto

namespace Google\Cloud\VmwareEngine\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Network configuration in the consumer project
 * with which the peering has to be done.
 *
 * Generated from protobuf message <code>google.cloud.vmwareengine.v1.NetworkConfig</code>
 */
class NetworkConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Management CIDR used by VMware management appliances.
     *
     * Generated from protobuf field <code>string management_cidr = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $management_cidr = '';
    /**
     * Optional. The relative resource name of the VMware Engine network attached
     * to the private cloud. Specify the name in the following form:
     * `projects/{project}/locations/{location}/vmwareEngineNetworks/{vmware_engine_network_id}`
     * where `{project}` can either be a project number or a project ID.
     *
     * Generated from protobuf field <code>string vmware_engine_network = 5 [(.google.api.field_behavior) = OPTIONAL, (.google.api.resource_reference) = {</code>
     */
    protected $vmware_engine_network = '';
    /**
     * Output only. The canonical name of the VMware Engine network in the form:
     * `projects/{project_number}/locations/{location}/vmwareEngineNetworks/{vmware_engine_network_id}`
     *
     * Generated from protobuf field <code>string vmware_engine_network_canonical = 6 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     */
    protected $vmware_engine_network_canonical = '';
    /**
     * Output only. The IP address layout version of the management IP address
     * range. Possible versions include:
     * * `managementIpAddressLayoutVersion=1`: Indicates the legacy IP address
     * layout used by some existing private clouds. This is no longer supported
     * for new private clouds as it does not support all features.
     * * `managementIpAddressLayoutVersion=2`: Indicates the latest IP address
     * layout used by all newly created private clouds. This version supports all
     * current features.
     *
     * Generated from protobuf field <code>int32 management_ip_address_layout_version = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $management_ip_address_layout_version = 0;
    /**
     * Output only. DNS Server IP of the Private Cloud.
     * All DNS queries can be forwarded to this address for name resolution of
     * Private Cloud's management entities like vCenter, NSX-T Manager and
     * ESXi hosts.
     *
     * Generated from protobuf field <code>string dns_server_ip = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $dns_server_ip = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $management_cidr
     *           Required. Management CIDR used by VMware management appliances.
     *     @type string $vmware_engine_network
     *           Optional. The relative resource name of the VMware Engine network attached
     *           to the private cloud. Specify the name in the following form:
     *           `projects/{project}/locations/{location}/vmwareEngineNetworks/{vmware_engine_network_id}`
     *           where `{project}` can either be a project number or a project ID.
     *     @type string $vmware_engine_network_canonical
     *           Output only. The canonical name of the VMware Engine network in the form:
     *           `projects/{project_number}/locations/{location}/vmwareEngineNetworks/{vmware_engine_network_id}`
     *     @type int $management_ip_address_layout_version
     *           Output only. The IP address layout version of the management IP address
     *           range. Possible versions include:
     *           * `managementIpAddressLayoutVersion=1`: Indicates the legacy IP address
     *           layout used by some existing private clouds. This is no longer supported
     *           for new private clouds as it does not support all features.
     *           * `managementIpAddressLayoutVersion=2`: Indicates the latest IP address
     *           layout used by all newly created private clouds. This version supports all
     *           current features.
     *     @type string $dns_server_ip
     *           Output only. DNS Server IP of the Private Cloud.
     *           All DNS queries can be forwarded to this address for name resolution of
     *           Private Cloud's management entities like vCenter, NSX-T Manager and
     *           ESXi hosts.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Vmwareengine\V1\VmwareengineResources::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Management CIDR used by VMware management appliances.
     *
     * Generated from protobuf field <code>string management_cidr = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getManagementCidr()
    {
        return $this->management_cidr;
    }

    /**
     * Required. Management CIDR used by VMware management appliances.
     *
     * Generated from protobuf field <code>string management_cidr = 4 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setManagementCidr($var)
    {
        GPBUtil::checkString($var, True);
        $this->management_cidr = $var;

        return $this;
    }

    /**
     * Optional. The relative resource name of the VMware Engine network attached
     * to the private cloud. Specify the name in the following form:
     * `projects/{project}/locations/{location}/vmwareEngineNetworks/{vmware_engine_network_id}`
     * where `{project}` can either be a project number or a project ID.
     *
     * Generated from protobuf field <code>string vmware_engine_network = 5 [(.google.api.field_behavior) = OPTIONAL, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getVmwareEngineNetwork()
    {
        return $this->vmware_engine_network;
    }

    /**
     * Optional. The relative resource name of the VMware Engine network attached
     * to the private cloud. Specify the name in the following form:
     * `projects/{project}/locations/{location}/vmwareEngineNetworks/{vmware_engine_network_id}`
     * where `{project}` can either be a project number or a project ID.
     *
     * Generated from protobuf field <code>string vmware_engine_network = 5 [(.google.api.field_behavior) = OPTIONAL, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setVmwareEngineNetwork($var)
    {
        GPBUtil::checkString($var, True);
        $this->vmware_engine_network = $var;

        return $this;
    }

    /**
     * Output only. The canonical name of the VMware Engine network in the form:
     * `projects/{project_number}/locations/{location}/vmwareEngineNetworks/{vmware_engine_network_id}`
     *
     * Generated from protobuf field <code>string vmware_engine_network_canonical = 6 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getVmwareEngineNetworkCanonical()
    {
        return $this->vmware_engine_network_canonical;
    }

    /**
     * Output only. The canonical name of the VMware Engine network in the form:
     * `projects/{project_number}/locations/{location}/vmwareEngineNetworks/{vmware_engine_network_id}`
     *
     * Generated from protobuf field <code>string vmware_engine_network_canonical = 6 [(.google.api.field_behavior) = OUTPUT_ONLY, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setVmwareEngineNetworkCanonical($var)
    {
        GPBUtil::checkString($var, True);
        $this->vmware_engine_network_canonical = $var;

        return $this;
    }

    /**
     * Output only. The IP address layout version of the management IP address
     * range. Possible versions include:
     * * `managementIpAddressLayoutVersion=1`: Indicates the legacy IP address
     * layout used by some existing private clouds. This is no longer supported
     * for new private clouds as it does not support all features.
     * * `managementIpAddressLayoutVersion=2`: Indicates the latest IP address
     * layout used by all newly created private clouds. This version supports all
     * current features.
     *
     * Generated from protobuf field <code>int32 management_ip_address_layout_version = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getManagementIpAddressLayoutVersion()
    {
        return $this->management_ip_address_layout_version;
    }

    /**
     * Output only. The IP address layout version of the management IP address
     * range. Possible versions include:
     * * `managementIpAddressLayoutVersion=1`: Indicates the legacy IP address
     * layout used by some existing private clouds. This is no longer supported
     * for new private clouds as it does not support all features.
     * * `managementIpAddressLayoutVersion=2`: Indicates the latest IP address
     * layout used by all newly created private clouds. This version supports all
     * current features.
     *
     * Generated from protobuf field <code>int32 management_ip_address_layout_version = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setManagementIpAddressLayoutVersion($var)
    {
        GPBUtil::checkInt32($var);
        $this->management_ip_address_layout_version = $var;

        return $this;
    }

    /**
     * Output only. DNS Server IP of the Private Cloud.
     * All DNS queries can be forwarded to this address for name resolution of
     * Private Cloud's management entities like vCenter, NSX-T Manager and
     * ESXi hosts.
     *
     * Generated from protobuf field <code>string dns_server_ip = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getDnsServerIp()
    {
        return $this->dns_server_ip;
    }

    /**
     * Output only. DNS Server IP of the Private Cloud.
     * All DNS queries can be forwarded to this address for name resolution of
     * Private Cloud's management entities like vCenter, NSX-T Manager and
     * ESXi hosts.
     *
     * Generated from protobuf field <code>string dns_server_ip = 9 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setDnsServerIp($var)
    {
        GPBUtil::checkString($var, True);
        $this->dns_server_ip = $var;

        return $this;
    }

}

