<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/vmwareengine/v1/vmwareengine.proto

namespace Google\Cloud\VmwareEngine\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [VmwareEngine.RevokeDnsBindPermission][google.cloud.vmwareengine.v1.VmwareEngine.RevokeDnsBindPermission]
 *
 * Generated from protobuf message <code>google.cloud.vmwareengine.v1.RevokeDnsBindPermissionRequest</code>
 */
class RevokeDnsBindPermissionRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the resource which stores the users/service accounts
     * having the permission to bind to the corresponding intranet VPC of the
     * consumer project. DnsBindPermission is a global resource. Resource names
     * are schemeless URIs that follow the conventions in
     * https://cloud.google.com/apis/design/resource_names. For example:
     * `projects/my-project/locations/global/dnsBindPermission`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    protected $name = '';
    /**
     * Required. The consumer provided user/service account which needs to be
     * granted permission to bind with the intranet VPC corresponding to the
     * consumer project.
     *
     * Generated from protobuf field <code>.google.cloud.vmwareengine.v1.Principal principal = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $principal = null;
    /**
     * Optional. A request ID to identify requests. Specify a unique request ID
     * so that if you must retry your request, the server will know to ignore
     * the request if it has already been completed. The server guarantees that a
     * request doesn't result in creation of duplicate commitments for at least 60
     * minutes.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    protected $request_id = '';

    /**
     * @param string                                  $name      Required. The name of the resource which stores the users/service accounts
     *                                                           having the permission to bind to the corresponding intranet VPC of the
     *                                                           consumer project. DnsBindPermission is a global resource. Resource names
     *                                                           are schemeless URIs that follow the conventions in
     *                                                           https://cloud.google.com/apis/design/resource_names. For example:
     *                                                           `projects/my-project/locations/global/dnsBindPermission`
     *                                                           Please see {@see VmwareEngineClient::dnsBindPermissionName()} for help formatting this field.
     * @param \Google\Cloud\VmwareEngine\V1\Principal $principal Required. The consumer provided user/service account which needs to be
     *                                                           granted permission to bind with the intranet VPC corresponding to the
     *                                                           consumer project.
     *
     * @return \Google\Cloud\VmwareEngine\V1\RevokeDnsBindPermissionRequest
     *
     * @experimental
     */
    public static function build(string $name, \Google\Cloud\VmwareEngine\V1\Principal $principal): self
    {
        return (new self())
            ->setName($name)
            ->setPrincipal($principal);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. The name of the resource which stores the users/service accounts
     *           having the permission to bind to the corresponding intranet VPC of the
     *           consumer project. DnsBindPermission is a global resource. Resource names
     *           are schemeless URIs that follow the conventions in
     *           https://cloud.google.com/apis/design/resource_names. For example:
     *           `projects/my-project/locations/global/dnsBindPermission`
     *     @type \Google\Cloud\VmwareEngine\V1\Principal $principal
     *           Required. The consumer provided user/service account which needs to be
     *           granted permission to bind with the intranet VPC corresponding to the
     *           consumer project.
     *     @type string $request_id
     *           Optional. A request ID to identify requests. Specify a unique request ID
     *           so that if you must retry your request, the server will know to ignore
     *           the request if it has already been completed. The server guarantees that a
     *           request doesn't result in creation of duplicate commitments for at least 60
     *           minutes.
     *           For example, consider a situation where you make an initial request and the
     *           request times out. If you make the request again with the same request
     *           ID, the server can check if original operation with the same request ID
     *           was received, and if so, will ignore the second request. This prevents
     *           clients from accidentally creating duplicate commitments.
     *           The request ID must be a valid UUID with the exception that zero UUID is
     *           not supported (00000000-0000-0000-0000-000000000000).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Vmwareengine\V1\Vmwareengine::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the resource which stores the users/service accounts
     * having the permission to bind to the corresponding intranet VPC of the
     * consumer project. DnsBindPermission is a global resource. Resource names
     * are schemeless URIs that follow the conventions in
     * https://cloud.google.com/apis/design/resource_names. For example:
     * `projects/my-project/locations/global/dnsBindPermission`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. The name of the resource which stores the users/service accounts
     * having the permission to bind to the corresponding intranet VPC of the
     * consumer project. DnsBindPermission is a global resource. Resource names
     * are schemeless URIs that follow the conventions in
     * https://cloud.google.com/apis/design/resource_names. For example:
     * `projects/my-project/locations/global/dnsBindPermission`
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Required. The consumer provided user/service account which needs to be
     * granted permission to bind with the intranet VPC corresponding to the
     * consumer project.
     *
     * Generated from protobuf field <code>.google.cloud.vmwareengine.v1.Principal principal = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Cloud\VmwareEngine\V1\Principal|null
     */
    public function getPrincipal()
    {
        return $this->principal;
    }

    public function hasPrincipal()
    {
        return isset($this->principal);
    }

    public function clearPrincipal()
    {
        unset($this->principal);
    }

    /**
     * Required. The consumer provided user/service account which needs to be
     * granted permission to bind with the intranet VPC corresponding to the
     * consumer project.
     *
     * Generated from protobuf field <code>.google.cloud.vmwareengine.v1.Principal principal = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param \Google\Cloud\VmwareEngine\V1\Principal $var
     * @return $this
     */
    public function setPrincipal($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\VmwareEngine\V1\Principal::class);
        $this->principal = $var;

        return $this;
    }

    /**
     * Optional. A request ID to identify requests. Specify a unique request ID
     * so that if you must retry your request, the server will know to ignore
     * the request if it has already been completed. The server guarantees that a
     * request doesn't result in creation of duplicate commitments for at least 60
     * minutes.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getRequestId()
    {
        return $this->request_id;
    }

    /**
     * Optional. A request ID to identify requests. Specify a unique request ID
     * so that if you must retry your request, the server will know to ignore
     * the request if it has already been completed. The server guarantees that a
     * request doesn't result in creation of duplicate commitments for at least 60
     * minutes.
     * For example, consider a situation where you make an initial request and the
     * request times out. If you make the request again with the same request
     * ID, the server can check if original operation with the same request ID
     * was received, and if so, will ignore the second request. This prevents
     * clients from accidentally creating duplicate commitments.
     * The request ID must be a valid UUID with the exception that zero UUID is
     * not supported (00000000-0000-0000-0000-000000000000).
     *
     * Generated from protobuf field <code>string request_id = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setRequestId($var)
    {
        GPBUtil::checkString($var, True);
        $this->request_id = $var;

        return $this;
    }

}

