<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/websecurityscanner/v1/scan_run_log.proto

namespace Google\Cloud\WebSecurityScanner\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A ScanRunLog is an output-only proto used for Stackdriver customer logging.
 * It is used for logs covering the start and end of scan pipelines.
 * Other than an added summary, this is a subset of the ScanRun.
 * Representation in logs is either a proto Struct, or converted to JSON.
 * Next id: 9
 *
 * Generated from protobuf message <code>google.cloud.websecurityscanner.v1.ScanRunLog</code>
 */
class ScanRunLog extends \Google\Protobuf\Internal\Message
{
    /**
     * Human friendly message about the event.
     *
     * Generated from protobuf field <code>string summary = 1;</code>
     */
    protected $summary = '';
    /**
     * The resource name of the ScanRun being logged.
     *
     * Generated from protobuf field <code>string name = 2;</code>
     */
    protected $name = '';
    /**
     * The execution state of the ScanRun.
     *
     * Generated from protobuf field <code>.google.cloud.websecurityscanner.v1.ScanRun.ExecutionState execution_state = 3;</code>
     */
    protected $execution_state = 0;
    /**
     * The result state of the ScanRun.
     *
     * Generated from protobuf field <code>.google.cloud.websecurityscanner.v1.ScanRun.ResultState result_state = 4;</code>
     */
    protected $result_state = 0;
    /**
     * Generated from protobuf field <code>int64 urls_crawled_count = 5;</code>
     */
    protected $urls_crawled_count = 0;
    /**
     * Generated from protobuf field <code>int64 urls_tested_count = 6;</code>
     */
    protected $urls_tested_count = 0;
    /**
     * Generated from protobuf field <code>bool has_findings = 7;</code>
     */
    protected $has_findings = false;
    /**
     * Generated from protobuf field <code>.google.cloud.websecurityscanner.v1.ScanRunErrorTrace error_trace = 8;</code>
     */
    protected $error_trace = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $summary
     *           Human friendly message about the event.
     *     @type string $name
     *           The resource name of the ScanRun being logged.
     *     @type int $execution_state
     *           The execution state of the ScanRun.
     *     @type int $result_state
     *           The result state of the ScanRun.
     *     @type int|string $urls_crawled_count
     *     @type int|string $urls_tested_count
     *     @type bool $has_findings
     *     @type \Google\Cloud\WebSecurityScanner\V1\ScanRunErrorTrace $error_trace
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Websecurityscanner\V1\ScanRunLog::initOnce();
        parent::__construct($data);
    }

    /**
     * Human friendly message about the event.
     *
     * Generated from protobuf field <code>string summary = 1;</code>
     * @return string
     */
    public function getSummary()
    {
        return $this->summary;
    }

    /**
     * Human friendly message about the event.
     *
     * Generated from protobuf field <code>string summary = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setSummary($var)
    {
        GPBUtil::checkString($var, True);
        $this->summary = $var;

        return $this;
    }

    /**
     * The resource name of the ScanRun being logged.
     *
     * Generated from protobuf field <code>string name = 2;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * The resource name of the ScanRun being logged.
     *
     * Generated from protobuf field <code>string name = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The execution state of the ScanRun.
     *
     * Generated from protobuf field <code>.google.cloud.websecurityscanner.v1.ScanRun.ExecutionState execution_state = 3;</code>
     * @return int
     */
    public function getExecutionState()
    {
        return $this->execution_state;
    }

    /**
     * The execution state of the ScanRun.
     *
     * Generated from protobuf field <code>.google.cloud.websecurityscanner.v1.ScanRun.ExecutionState execution_state = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setExecutionState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\WebSecurityScanner\V1\ScanRun\ExecutionState::class);
        $this->execution_state = $var;

        return $this;
    }

    /**
     * The result state of the ScanRun.
     *
     * Generated from protobuf field <code>.google.cloud.websecurityscanner.v1.ScanRun.ResultState result_state = 4;</code>
     * @return int
     */
    public function getResultState()
    {
        return $this->result_state;
    }

    /**
     * The result state of the ScanRun.
     *
     * Generated from protobuf field <code>.google.cloud.websecurityscanner.v1.ScanRun.ResultState result_state = 4;</code>
     * @param int $var
     * @return $this
     */
    public function setResultState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\WebSecurityScanner\V1\ScanRun\ResultState::class);
        $this->result_state = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>int64 urls_crawled_count = 5;</code>
     * @return int|string
     */
    public function getUrlsCrawledCount()
    {
        return $this->urls_crawled_count;
    }

    /**
     * Generated from protobuf field <code>int64 urls_crawled_count = 5;</code>
     * @param int|string $var
     * @return $this
     */
    public function setUrlsCrawledCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->urls_crawled_count = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>int64 urls_tested_count = 6;</code>
     * @return int|string
     */
    public function getUrlsTestedCount()
    {
        return $this->urls_tested_count;
    }

    /**
     * Generated from protobuf field <code>int64 urls_tested_count = 6;</code>
     * @param int|string $var
     * @return $this
     */
    public function setUrlsTestedCount($var)
    {
        GPBUtil::checkInt64($var);
        $this->urls_tested_count = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>bool has_findings = 7;</code>
     * @return bool
     */
    public function getHasFindings()
    {
        return $this->has_findings;
    }

    /**
     * Generated from protobuf field <code>bool has_findings = 7;</code>
     * @param bool $var
     * @return $this
     */
    public function setHasFindings($var)
    {
        GPBUtil::checkBool($var);
        $this->has_findings = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>.google.cloud.websecurityscanner.v1.ScanRunErrorTrace error_trace = 8;</code>
     * @return \Google\Cloud\WebSecurityScanner\V1\ScanRunErrorTrace|null
     */
    public function getErrorTrace()
    {
        return $this->error_trace;
    }

    public function hasErrorTrace()
    {
        return isset($this->error_trace);
    }

    public function clearErrorTrace()
    {
        unset($this->error_trace);
    }

    /**
     * Generated from protobuf field <code>.google.cloud.websecurityscanner.v1.ScanRunErrorTrace error_trace = 8;</code>
     * @param \Google\Cloud\WebSecurityScanner\V1\ScanRunErrorTrace $var
     * @return $this
     */
    public function setErrorTrace($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\WebSecurityScanner\V1\ScanRunErrorTrace::class);
        $this->error_trace = $var;

        return $this;
    }

}

