<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/workflows/executions/v1/executions.proto

namespace Google\Cloud\Workflows\Executions\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A running instance of a
 * [Workflow](https://cloud.google.com/workflows/docs/reference/rest/v1/projects.locations.workflows).
 *
 * Generated from protobuf message <code>google.cloud.workflows.executions.v1.Execution</code>
 */
class Execution extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The resource name of the execution.
     * Format:
     * projects/{project}/locations/{location}/workflows/{workflow}/executions/{execution}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $name = '';
    /**
     * Output only. Marks the beginning of execution.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $start_time = null;
    /**
     * Output only. Marks the end of execution, successful or not.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $end_time = null;
    /**
     * Output only. Measures the duration of the execution.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration duration = 12 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $duration = null;
    /**
     * Output only. Current state of the execution.
     *
     * Generated from protobuf field <code>.google.cloud.workflows.executions.v1.Execution.State state = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $state = 0;
    /**
     * Input parameters of the execution represented as a JSON string.
     * The size limit is 32KB.
     * *Note*: If you are using the REST API directly to run your workflow, you
     * must escape any JSON string value of `argument`. Example:
     * `'{"argument":"{\"firstName\":\"FIRST\",\"lastName\":\"LAST\"}"}'`
     *
     * Generated from protobuf field <code>string argument = 5;</code>
     */
    private $argument = '';
    /**
     * Output only. Output of the execution represented as a JSON string. The
     * value can only be present if the execution's state is `SUCCEEDED`.
     *
     * Generated from protobuf field <code>string result = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $result = '';
    /**
     * Output only. The error which caused the execution to finish prematurely.
     * The value is only present if the execution's state is `FAILED`
     * or `CANCELLED`.
     *
     * Generated from protobuf field <code>.google.cloud.workflows.executions.v1.Execution.Error error = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $error = null;
    /**
     * Output only. Revision of the workflow this execution is using.
     *
     * Generated from protobuf field <code>string workflow_revision_id = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $workflow_revision_id = '';
    /**
     * The call logging level associated to this execution.
     *
     * Generated from protobuf field <code>.google.cloud.workflows.executions.v1.Execution.CallLogLevel call_log_level = 9;</code>
     */
    private $call_log_level = 0;
    /**
     * Output only. Status tracks the current steps and progress data of this
     * execution.
     *
     * Generated from protobuf field <code>.google.cloud.workflows.executions.v1.Execution.Status status = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $status = null;
    /**
     * Labels associated with this execution.
     * Labels can contain at most 64 entries. Keys and values can be no longer
     * than 63 characters and can only contain lowercase letters, numeric
     * characters, underscores, and dashes. Label keys must start with a letter.
     * International characters are allowed.
     * By default, labels are inherited from the workflow but are overridden by
     * any labels associated with the execution.
     *
     * Generated from protobuf field <code>map<string, string> labels = 11;</code>
     */
    private $labels;
    /**
     * Output only. Error regarding the state of the Execution resource. For
     * example, this field will have error details if the execution data is
     * unavailable due to revoked KMS key permissions.
     *
     * Generated from protobuf field <code>.google.cloud.workflows.executions.v1.Execution.StateError state_error = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $state_error = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. The resource name of the execution.
     *           Format:
     *           projects/{project}/locations/{location}/workflows/{workflow}/executions/{execution}
     *     @type \Google\Protobuf\Timestamp $start_time
     *           Output only. Marks the beginning of execution.
     *     @type \Google\Protobuf\Timestamp $end_time
     *           Output only. Marks the end of execution, successful or not.
     *     @type \Google\Protobuf\Duration $duration
     *           Output only. Measures the duration of the execution.
     *     @type int $state
     *           Output only. Current state of the execution.
     *     @type string $argument
     *           Input parameters of the execution represented as a JSON string.
     *           The size limit is 32KB.
     *           *Note*: If you are using the REST API directly to run your workflow, you
     *           must escape any JSON string value of `argument`. Example:
     *           `'{"argument":"{\"firstName\":\"FIRST\",\"lastName\":\"LAST\"}"}'`
     *     @type string $result
     *           Output only. Output of the execution represented as a JSON string. The
     *           value can only be present if the execution's state is `SUCCEEDED`.
     *     @type \Google\Cloud\Workflows\Executions\V1\Execution\Error $error
     *           Output only. The error which caused the execution to finish prematurely.
     *           The value is only present if the execution's state is `FAILED`
     *           or `CANCELLED`.
     *     @type string $workflow_revision_id
     *           Output only. Revision of the workflow this execution is using.
     *     @type int $call_log_level
     *           The call logging level associated to this execution.
     *     @type \Google\Cloud\Workflows\Executions\V1\Execution\Status $status
     *           Output only. Status tracks the current steps and progress data of this
     *           execution.
     *     @type array|\Google\Protobuf\Internal\MapField $labels
     *           Labels associated with this execution.
     *           Labels can contain at most 64 entries. Keys and values can be no longer
     *           than 63 characters and can only contain lowercase letters, numeric
     *           characters, underscores, and dashes. Label keys must start with a letter.
     *           International characters are allowed.
     *           By default, labels are inherited from the workflow but are overridden by
     *           any labels associated with the execution.
     *     @type \Google\Cloud\Workflows\Executions\V1\Execution\StateError $state_error
     *           Output only. Error regarding the state of the Execution resource. For
     *           example, this field will have error details if the execution data is
     *           unavailable due to revoked KMS key permissions.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Workflows\Executions\V1\Executions::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The resource name of the execution.
     * Format:
     * projects/{project}/locations/{location}/workflows/{workflow}/executions/{execution}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. The resource name of the execution.
     * Format:
     * projects/{project}/locations/{location}/workflows/{workflow}/executions/{execution}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Output only. Marks the beginning of execution.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getStartTime()
    {
        return $this->start_time;
    }

    public function hasStartTime()
    {
        return isset($this->start_time);
    }

    public function clearStartTime()
    {
        unset($this->start_time);
    }

    /**
     * Output only. Marks the beginning of execution.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_time = 2 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setStartTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->start_time = $var;

        return $this;
    }

    /**
     * Output only. Marks the end of execution, successful or not.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getEndTime()
    {
        return $this->end_time;
    }

    public function hasEndTime()
    {
        return isset($this->end_time);
    }

    public function clearEndTime()
    {
        unset($this->end_time);
    }

    /**
     * Output only. Marks the end of execution, successful or not.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_time = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setEndTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->end_time = $var;

        return $this;
    }

    /**
     * Output only. Measures the duration of the execution.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration duration = 12 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Duration|null
     */
    public function getDuration()
    {
        return $this->duration;
    }

    public function hasDuration()
    {
        return isset($this->duration);
    }

    public function clearDuration()
    {
        unset($this->duration);
    }

    /**
     * Output only. Measures the duration of the execution.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration duration = 12 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Duration $var
     * @return $this
     */
    public function setDuration($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Duration::class);
        $this->duration = $var;

        return $this;
    }

    /**
     * Output only. Current state of the execution.
     *
     * Generated from protobuf field <code>.google.cloud.workflows.executions.v1.Execution.State state = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * Output only. Current state of the execution.
     *
     * Generated from protobuf field <code>.google.cloud.workflows.executions.v1.Execution.State state = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Workflows\Executions\V1\Execution\State::class);
        $this->state = $var;

        return $this;
    }

    /**
     * Input parameters of the execution represented as a JSON string.
     * The size limit is 32KB.
     * *Note*: If you are using the REST API directly to run your workflow, you
     * must escape any JSON string value of `argument`. Example:
     * `'{"argument":"{\"firstName\":\"FIRST\",\"lastName\":\"LAST\"}"}'`
     *
     * Generated from protobuf field <code>string argument = 5;</code>
     * @return string
     */
    public function getArgument()
    {
        return $this->argument;
    }

    /**
     * Input parameters of the execution represented as a JSON string.
     * The size limit is 32KB.
     * *Note*: If you are using the REST API directly to run your workflow, you
     * must escape any JSON string value of `argument`. Example:
     * `'{"argument":"{\"firstName\":\"FIRST\",\"lastName\":\"LAST\"}"}'`
     *
     * Generated from protobuf field <code>string argument = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setArgument($var)
    {
        GPBUtil::checkString($var, True);
        $this->argument = $var;

        return $this;
    }

    /**
     * Output only. Output of the execution represented as a JSON string. The
     * value can only be present if the execution's state is `SUCCEEDED`.
     *
     * Generated from protobuf field <code>string result = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getResult()
    {
        return $this->result;
    }

    /**
     * Output only. Output of the execution represented as a JSON string. The
     * value can only be present if the execution's state is `SUCCEEDED`.
     *
     * Generated from protobuf field <code>string result = 6 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setResult($var)
    {
        GPBUtil::checkString($var, True);
        $this->result = $var;

        return $this;
    }

    /**
     * Output only. The error which caused the execution to finish prematurely.
     * The value is only present if the execution's state is `FAILED`
     * or `CANCELLED`.
     *
     * Generated from protobuf field <code>.google.cloud.workflows.executions.v1.Execution.Error error = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\Workflows\Executions\V1\Execution\Error|null
     */
    public function getError()
    {
        return $this->error;
    }

    public function hasError()
    {
        return isset($this->error);
    }

    public function clearError()
    {
        unset($this->error);
    }

    /**
     * Output only. The error which caused the execution to finish prematurely.
     * The value is only present if the execution's state is `FAILED`
     * or `CANCELLED`.
     *
     * Generated from protobuf field <code>.google.cloud.workflows.executions.v1.Execution.Error error = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\Workflows\Executions\V1\Execution\Error $var
     * @return $this
     */
    public function setError($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Workflows\Executions\V1\Execution\Error::class);
        $this->error = $var;

        return $this;
    }

    /**
     * Output only. Revision of the workflow this execution is using.
     *
     * Generated from protobuf field <code>string workflow_revision_id = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getWorkflowRevisionId()
    {
        return $this->workflow_revision_id;
    }

    /**
     * Output only. Revision of the workflow this execution is using.
     *
     * Generated from protobuf field <code>string workflow_revision_id = 8 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setWorkflowRevisionId($var)
    {
        GPBUtil::checkString($var, True);
        $this->workflow_revision_id = $var;

        return $this;
    }

    /**
     * The call logging level associated to this execution.
     *
     * Generated from protobuf field <code>.google.cloud.workflows.executions.v1.Execution.CallLogLevel call_log_level = 9;</code>
     * @return int
     */
    public function getCallLogLevel()
    {
        return $this->call_log_level;
    }

    /**
     * The call logging level associated to this execution.
     *
     * Generated from protobuf field <code>.google.cloud.workflows.executions.v1.Execution.CallLogLevel call_log_level = 9;</code>
     * @param int $var
     * @return $this
     */
    public function setCallLogLevel($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Workflows\Executions\V1\Execution\CallLogLevel::class);
        $this->call_log_level = $var;

        return $this;
    }

    /**
     * Output only. Status tracks the current steps and progress data of this
     * execution.
     *
     * Generated from protobuf field <code>.google.cloud.workflows.executions.v1.Execution.Status status = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\Workflows\Executions\V1\Execution\Status|null
     */
    public function getStatus()
    {
        return $this->status;
    }

    public function hasStatus()
    {
        return isset($this->status);
    }

    public function clearStatus()
    {
        unset($this->status);
    }

    /**
     * Output only. Status tracks the current steps and progress data of this
     * execution.
     *
     * Generated from protobuf field <code>.google.cloud.workflows.executions.v1.Execution.Status status = 10 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\Workflows\Executions\V1\Execution\Status $var
     * @return $this
     */
    public function setStatus($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Workflows\Executions\V1\Execution\Status::class);
        $this->status = $var;

        return $this;
    }

    /**
     * Labels associated with this execution.
     * Labels can contain at most 64 entries. Keys and values can be no longer
     * than 63 characters and can only contain lowercase letters, numeric
     * characters, underscores, and dashes. Label keys must start with a letter.
     * International characters are allowed.
     * By default, labels are inherited from the workflow but are overridden by
     * any labels associated with the execution.
     *
     * Generated from protobuf field <code>map<string, string> labels = 11;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getLabels()
    {
        return $this->labels;
    }

    /**
     * Labels associated with this execution.
     * Labels can contain at most 64 entries. Keys and values can be no longer
     * than 63 characters and can only contain lowercase letters, numeric
     * characters, underscores, and dashes. Label keys must start with a letter.
     * International characters are allowed.
     * By default, labels are inherited from the workflow but are overridden by
     * any labels associated with the execution.
     *
     * Generated from protobuf field <code>map<string, string> labels = 11;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setLabels($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->labels = $arr;

        return $this;
    }

    /**
     * Output only. Error regarding the state of the Execution resource. For
     * example, this field will have error details if the execution data is
     * unavailable due to revoked KMS key permissions.
     *
     * Generated from protobuf field <code>.google.cloud.workflows.executions.v1.Execution.StateError state_error = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Cloud\Workflows\Executions\V1\Execution\StateError|null
     */
    public function getStateError()
    {
        return $this->state_error;
    }

    public function hasStateError()
    {
        return isset($this->state_error);
    }

    public function clearStateError()
    {
        unset($this->state_error);
    }

    /**
     * Output only. Error regarding the state of the Execution resource. For
     * example, this field will have error details if the execution data is
     * unavailable due to revoked KMS key permissions.
     *
     * Generated from protobuf field <code>.google.cloud.workflows.executions.v1.Execution.StateError state_error = 13 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\Workflows\Executions\V1\Execution\StateError $var
     * @return $this
     */
    public function setStateError($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Workflows\Executions\V1\Execution\StateError::class);
        $this->state_error = $var;

        return $this;
    }

}

