<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/workflows/v1/workflows.proto

namespace Google\Cloud\Workflows\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request for the
 * [GetWorkflow][google.cloud.workflows.v1.Workflows.GetWorkflow] method.
 *
 * Generated from protobuf message <code>google.cloud.workflows.v1.GetWorkflowRequest</code>
 */
class GetWorkflowRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Name of the workflow for which information should be retrieved.
     * Format: projects/{project}/locations/{location}/workflows/{workflow}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $name = '';
    /**
     * Optional. The revision of the workflow to retrieve. If the revision_id is
     * empty, the latest revision is retrieved.
     * The format is "000001-a4d", where the first six characters define
     * the zero-padded decimal revision number. They are followed by a hyphen and
     * three hexadecimal characters.
     *
     * Generated from protobuf field <code>string revision_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $revision_id = '';

    /**
     * @param string $name Required. Name of the workflow for which information should be retrieved.
     *                     Format: projects/{project}/locations/{location}/workflows/{workflow}
     *                     Please see {@see WorkflowsClient::workflowName()} for help formatting this field.
     *
     * @return \Google\Cloud\Workflows\V1\GetWorkflowRequest
     *
     * @experimental
     */
    public static function build(string $name): self
    {
        return (new self())
            ->setName($name);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Required. Name of the workflow for which information should be retrieved.
     *           Format: projects/{project}/locations/{location}/workflows/{workflow}
     *     @type string $revision_id
     *           Optional. The revision of the workflow to retrieve. If the revision_id is
     *           empty, the latest revision is retrieved.
     *           The format is "000001-a4d", where the first six characters define
     *           the zero-padded decimal revision number. They are followed by a hyphen and
     *           three hexadecimal characters.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Workflows\V1\Workflows::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Name of the workflow for which information should be retrieved.
     * Format: projects/{project}/locations/{location}/workflows/{workflow}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. Name of the workflow for which information should be retrieved.
     * Format: projects/{project}/locations/{location}/workflows/{workflow}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Optional. The revision of the workflow to retrieve. If the revision_id is
     * empty, the latest revision is retrieved.
     * The format is "000001-a4d", where the first six characters define
     * the zero-padded decimal revision number. They are followed by a hyphen and
     * three hexadecimal characters.
     *
     * Generated from protobuf field <code>string revision_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getRevisionId()
    {
        return $this->revision_id;
    }

    /**
     * Optional. The revision of the workflow to retrieve. If the revision_id is
     * empty, the latest revision is retrieved.
     * The format is "000001-a4d", where the first six characters define
     * the zero-padded decimal revision number. They are followed by a hyphen and
     * three hexadecimal characters.
     *
     * Generated from protobuf field <code>string revision_id = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setRevisionId($var)
    {
        GPBUtil::checkString($var, True);
        $this->revision_id = $var;

        return $this;
    }

}

